<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array('tpl_root' => "browse_list_edit_js.inc.html"));
$img_line= "img/$THEME/tree_vertline.gif";
$img_split_ex = "img/$THEME/tree_split_ex.gif";
$img_split_co = "img/$THEME/tree_split_co.gif";
$img_split = "img/$THEME/tree_split.gif";
$img_end_ex= "img/$THEME/tree_end_ex.gif";
$img_end_co= "img/$THEME/tree_end_co.gif";
$img_end= "img/$THEME/tree_end.gif";

$ex_link="index.php?site=$site&action=$action&oid=$oid&mode=$mode&sort=$sort";
$ac_link="index.php?site=$site&mode=cat";
$t->assign('EX_LINK',$ex_link);


$eroots=array();
if (is_object($root_obj_s) && (($Addr->havePermsProfilAcl(4) || $Addr->getPerms(4)) || (!$copy && is_object($AObj) && $AObj->getAcl(4)))) {
	if ($dis_root_g) $eroot_id=$root_obj_s->getID();
	$eroots[]=$root_obj_s->getID();
}
if ($Addr->getPerms(1)) {
	if ($dis_root_p) $eroot_id=$root_obj_u->getID();
	$eroots[]=$root_obj_u->getID();
}

if (!$eroot_id) {
	if (is_object($AObj)) {
		$ANodes=array();
		if ($AObj->getMeta('Trash')) {
			$temp=explode(',',$AObj->getMeta('TrashIDs'));

			foreach ($temp as $val) {
				$ANodes[$val]=$Addr->getObj($val);
			}
		} else {
			$ANodes=$Addr->getAddrNodes($aid);
		}
		if (is_object(reset($ANodes))) {
			$tmp=reset($ANodes);
			$eroot_id=$tmp->getMeta('RootID');
			if (!$copy) {
				if ($root_obj[$eroot_id]->getMeta('System')=='u') {
					$pNodeID=array_keys($ANodes);
				} else {
					$gNodeID=array_keys($ANodes);
				}
			}
		}
	} elseif ($rootObj->getMeta('System')=='u') {
		$eroot_id=$rootObj->getID();
	}
}
if (!in_array($eroot_id,$eroots)) {
	$eroot_id=reset($eroots);
}

if ($root_obj[$eroot_id]->getMeta('System')=='u') {
	$t->assign('DIS_ROOT_P_ON','on');
	$t->assign('DIS_ROOT_G_ON','off');
	$gNodeID=array();
	$selIds=$Addr->getTreeIDs($pNodeID);
} else {
	$t->assign('DIS_ROOT_P_ON','off');
	$t->assign('DIS_ROOT_G_ON','on');
	$pNodeID=array();
	$selIds=$Addr->getTreeIDs($gNodeID);
}


$t->assign('HID_EROOT_ID',$eroot_id);
if (!is_array($pNodeID)) $pNodeID=array();
if (!is_array($gNodeID)) $gNodeID=array();
if ($sopen && is_array($sopen)) {
	$open=key($sopen);
}


$tree_apps=array('fol');
$tree=$Addr->ListAllTree($eroots,-1,'Title_'.$session_lang,'ASC',$tree_apps);
$up_tree=false;
if ($open==1) {
	$open_tree=','.implode(',',array_keys($tree)).',';
	$up_tree=true;
} elseif ($open==-1) {
	$open_tree=',';
	$up_tree=true;
} else {
	$open_tree=$frm->getTree($Addr->getModul(),$eroot_id);
	if (isset($x)) {
		$frm->updateTree($open_tree,$x);
		$up_tree=true;
	}
}

$expand=array_flip(explode(',',$open_tree));
foreach ($eroots as $kroot) {
	$expand[$kroot]=1;
}


if (is_array($selIds)) {
	foreach ($selIds as $val) {
		if (!$expand[$val]) {
			$expand[$val]=1;
		}
	}
}

if ($up_tree) {
	$frm->setTree($Addr->getModul(),$eroot_id,$open_tree);
}


$chkpNodeID=new CheckBox ("pNodeID",'onclick="unsetRad(\'gNodeID[]\',\'\');"',"",0,1);
$chkgNodeID=new CheckBox ("gNodeID",'onclick="unsetRad(\'pNodeID[]\',\'\');"',"",0,1);


require_once('lib/class_ObjTree.php');
$ObjTree=new ObjTree();
$ObjTree->setSplitImages('tree_split.gif','tree_split_ex.gif','tree_split_co.gif');
$ObjTree->setEndImages('tree_end.gif','tree_end_ex.gif','tree_end_co.gif');
$ObjTree->setLineImages('tree_vertline.gif');
$ObjTree->setExpand($expand);
$ObjTree->setExLink('exp[{ID}]','f');
$ObjTree->setAcLink(0);
$ObjTree->setImgPath("img/$THEME");
$ObjTree->setColors($bgcolor,$fg10color);
$ObjTree->setModul($Addr->getModul());
$ObjTree->setTree($tree);

foreach ($eroots as $kroot) {
	$ObjTree->setRootID($kroot);
	if ($eroot_id==$kroot) $t->assign('DIS_ROOT',''); else $t->assign('DIS_ROOT','none');
	if ($root_obj[$kroot]->getMeta('System')=='u') {
		$ObjTree->setSelectedID($pNodeID);
		$ObjTree->setCheckBox($chkpNodeID,1);
		$t->assign('DIS_BOX','p');
		$t->assign('EROOT_P',$kroot);
		if (in_array($kroot,$pNodeID)) {
			$class='it_s';
		} else {
			$class='it_n';
		}
		$t->assign('ROOT_CHK',$chkpNodeID->f($kroot));
		$t->parse('ROW','dis_root_p');
	}
	if ($root_obj[$kroot]->getMeta('System')=='s') {
		$ObjTree->setSelectedID($gNodeID);
		$ObjTree->setCheckBox($chkgNodeID,1);
		$t->assign('DIS_BOX','g');
		$t->assign('EROOT_G',$kroot);
		if (in_array($kroot,$gNodeID)) {
			$class='it_s';
		} else {
			$class='it_n';
		}
		$t->assign('ROOT_CHK','');
		$t->parse('ROW','dis_root_g');
	}
	$t->assign('ROOT_CLASS',$class);
	$t->assign('ROOT_NAME',FrameWork::entities($root_obj[$kroot]->getName($session_lang)));
	$t->assign('ROOT_IMG',$root_obj[$kroot]->getImage(isset($tree[$kroot])));
	$t->assign('NAV_TREE',$ObjTree->parseTree($kroot));
 	$t->parse("ROW",".dis_root");
}

$t->parse("TPL_ROOT","tpl_root");
?>
