<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array('tpl_root' => "browse_list_js.inc.html"));
$img_line= "img/$THEME/tree_vertline.gif";
$img_split_ex = "img/$THEME/tree_split_ex.gif";
$img_split_co = "img/$THEME/tree_split_co.gif";
$img_split = "img/$THEME/tree_split.gif";
$img_end_ex= "img/$THEME/tree_end_ex.gif";
$img_end_co= "img/$THEME/tree_end_co.gif";
$img_end= "img/$THEME/tree_end.gif";

$ex_link="index.php?site=$site&action=$action&oid=$oid&mode=$mode&sort=$sort";
$ac_link="index.php?site=$site&mode=cat";
$t->assign('EX_LINK',$ex_link);

if ($rootObj->getMeta('System')=='d') {
	require_once('lib/class_ApplicationListGui.php');
	$avFav=array(
		'fav'=>$T->lang('[[Favoriten]]'),
		'used'=>$T->lang('[[Meist gebrauchte Adressen]]'),
		'last'=>$T->lang('[[Zuletzt geoeffnete Adressen]]'),
		'new'=>$T->lang('[[Neuzugaenge]]'),
	);
	$favGui=new ApplicationListGui();

	foreach ($avFav as $key=>$val) {
		$favGui->addRow($mode==$key?2:0);
		$favGui->addCol('IMG','','month_all.gif');
		$favGui->addCol('Name',$val,'',"index.php?site=$site&mode=$key",'',0,'2000');
	}

	$t->assign('TPL_FAV',$favGui->process());

	$slist=$Addr->listAddrSearch();
	$i=0;
	$tabGui=new ApplicationListGui();
	foreach ($slist as $key=>$val) {
		if ($key) {
			$tabGui->addRow(($mode=='src' && $vsrid==$key)?2:0,'');
			if ($val['FKUserID']==$frm->getUser()) {
				$tabGui->addCol('IMG','','month_mine.gif');
			} else {
				$tabGui->addCol('IMG','','month_all.gif');
			}
			$tabGui->addCol('Name',$val['Title'],'',"index.php?site=$site&mode=src&vsrid=$key&load=1",'',0,'2000');
			if ($val['FKUserID']==$frm->getUser() || $Addr->isRuleUser()) {
				$tabGui->addCol('IMG_DEL','','loeschen.gif',"index.php?site=$site&action=$action&oid=$oid&mode=$mode&sort=$sort&b=$b&o=$o&a=$a&vsrid=$vsrid&del_srid=$key");
			} else {
				$tabGui->addCol('IMG_DEL','','tras.gif');
			}
			if ($mode=='src' && Framework::getParam('vsrid')==$key) {

				
				if ($searchEditForm=$searchEditGui->processEditGui()) {
					$tabGui->addRow(0);
					$tabGui->addCol('IMG','','');
					$tabGui->addCol('Name',$searchEditForm,'','','',0,'','2');
				}
			}

			$i++;
		}
	}
	if ($i) {
		$t->assign('TPL_SEARCH',$tabGui->process());
		$t->parse('ROW','mode_search');
	}
	$t->parse('ROW','mode_tree');
} else {

	$tree_apps=array('fol','trash');
	$tree=$Addr->ListAllTree($root_id,-1,'Title_'.$session_lang,'ASC',$tree_apps);
	$up_tree=false;
	if ($open==1) {
		$open_tree=','.implode(',',array_keys($tree)).',';
		$up_tree=true;
	} elseif ($open==-1) {
		$open_tree=',';
		$up_tree=true;
	} else {
		$open_tree=$frm->getTree($Addr->getModul(),$root_id);
		if (isset($x)) {
			$frm->updateTree($open_tree,$x);
			$up_tree=true;

		}
	}

	$expand=array_flip(explode(',',$open_tree));
	$expand[$root_id]=1;
	if ($tree[$oid] && !$expand[$oid]) {
		$expand[$oid]=1;
		$frm->updateTree($open_tree,$oid);
		$up_tree=true;
	}
	if (is_array($obj_tree)) {
		foreach (array_keys($obj_tree) as $val) {
			if (!$expand[$val]) {
				$expand[$val]=1;
				$frm->updateTree($open_tree,$val);
				$up_tree=true;
			}
		}
	}

	if ($up_tree) {
		$frm->setTree($Addr->getModul(),$root_id,$open_tree);
	}





	require_once('lib/class_ObjTree.php');
	$ObjTree=new ObjTree();
	$ObjTree->setSplitImages('tree_split.gif','tree_split_ex.gif','tree_split_co.gif');
	$ObjTree->setEndImages('tree_end.gif','tree_end_ex.gif','tree_end_co.gif');
	$ObjTree->setLineImages('tree_vertline.gif');
	$ObjTree->setExpand($expand);
	$ObjTree->setTree($tree);
	$ObjTree->setExLink($ex_link."&x={OID}");
	$ObjTree->setAcLink($ac_link."&action={ACTION}&oid={OID}");
	$ObjTree->setImgPath("img/$THEME");
	$ObjTree->setColors($bgcolor,$fg10color);
	$ObjTree->setSelectedID($obj->getID());
 	$ObjTree->setRootID($root_id);
	$ObjTree->setModul($Addr->getModul());

	if ($rootObj->getID()==reset($ObjTree->getSelectedID())) {
		$class='it_s';
	} else {
		$class='it_n';
	}

	$t->assign('ROOT_CLASS',$class);
	$t->assign('ROOT_L',"$ac_link&oid=$root_id");
	$t->assign('ROOT_NAME',FrameWork::entities($rootObj->getName($session_lang)));
	$t->assign('ROOT_IMG',$rootObj->getImage(isset($tree[$root_id])));



	$t->assign('NAV_TREE',$ObjTree->parseTree($root_id));

	$t->parse('ROW','folder_tree');
}
$t->parse("TPL_ROOT","tpl_root");
?>
