<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array('tpl_root' => "browse_list_org_js.inc.html"));
$img_line= "img/$THEME/tree_vertline.gif";
$img_split_ex = "img/$THEME/tree_split_ex.gif";
$img_split_co = "img/$THEME/tree_split_co.gif";
$img_split = "img/$THEME/tree_split.gif";
$img_end_ex= "img/$THEME/tree_end_ex.gif";
$img_end_co= "img/$THEME/tree_end_co.gif";
$img_end= "img/$THEME/tree_end.gif";
$eroots=array();
if ($Addr->isClipboard('addr_s')) {
	$eroots[]=$root_obj_s->getID();
}
if ($Addr->getPerms(1) && $Addr->isClipboard('addr_u')) {
	$eroots[]=$root_obj_u->getID();
}
if (empty($eroots)) {
	if ($H_REFERER[0]) {
		header('Location:'.$H_REFERER[0]);
	} else {
		header("Location:index.php?site=$site");
	}
	page_close();
	exit;
}
if (!$eroot_id) {
	if ($aid) {
		$ANodes=$Addr->getAddrNodes($aid);
		if (is_object(reset($ANodes))) {
			$tmp=reset($ANodes);
			$eroot_id=$tmp->getMeta('RootID');
			$sNodeID=array_keys($ANodes);
		}
	}
}

if (!in_array($eroot_id,$eroots)) $eroot_id=reset($eroots);

if (is_array($sNodeID)) {
	$selIds=$Addr->getTreeIDs($sNodeID);
}

$t->assign('HID_EROOT_ID',$eroot_id);
if (!is_array($sNodeID)) $sNodeID=array();
if ($sopen && is_array($sopen)) {
	$open=key($sopen);
}


$tree_apps=array('fol');
$tree=$Addr->ListAllTree($eroot_id,-1,'Title_'.$session_lang,'ASC',$tree_apps);
$up_tree=false;
if ($open==1) {
	$open_tree=','.implode(',',array_keys($tree)).',';
	$up_tree=true;
} elseif ($open==-1) {
	$open_tree=',';
	$up_tree=true;
} else {
	$open_tree=$frm->getTree($Addr->getModul(),$eroot_id);
	if (isset($x)) {
		$frm->updateTree($open_tree,$x);
		$up_tree=true;
	}
}

if (is_array($selIds)) {
	foreach ($selIds as $val) {
		if (!$expand[$val]) {
			$expand[$val]=1;
		}
	}
} else {
	$expand=array_flip(explode(',',$open_tree));
}
$expand[$eroot_id]=1;

if ($up_tree) {
	$frm->setTree($Addr->getModul(),$eroot_id,$open_tree);
}


$chksNodeID=new CheckBox ("sNodeID",'',"",0,1);

require_once('lib/class_ObjTree.php');
$ObjTree=new ObjTree();
$ObjTree->setSplitImages('tree_split.gif','tree_split_ex.gif','tree_split_co.gif');
$ObjTree->setEndImages('tree_end.gif','tree_end_ex.gif','tree_end_co.gif');
$ObjTree->setLineImages('tree_vertline.gif');
$ObjTree->setExpand($expand);
$ObjTree->setExLink('exp[{ID}]','f');
$ObjTree->setAcLink(0);
$ObjTree->setImgPath("img/$THEME");
$ObjTree->setColors($bgcolor,$fg10color);
$ObjTree->setModul($Addr->getModul());
$ObjTree->setTree($tree);
$ObjTree->setRootID($eroot_id);
$ObjTree->setSelectedID($sNodeID);
$ObjTree->setCheckBox($chksNodeID,1);
$t->assign('EROOT',$eroot_id);
if (in_array($eroot_id,$sNodeID)) {
	$class='it_s';
} else {
	$class='it_n';
}
if ($root_obj[$eroot_id]->getMeta('System')=='u') {
	$t->assign('ROOT_CHK',$chksNodeID->f($eroot_id));
} else {
	$t->assign('ROOT_CHK','');
}
$t->assign('ROOT_CLASS',$class);
$t->assign('ROOT_NAME',FrameWork::entities($root_obj[$eroot_id]->getName($session_lang)));
$t->assign('ROOT_IMG',$rootObj->getImage(isset($tree[$eroot_id])));
$t->assign('NAV_TREE',$ObjTree->parseTree($eroot_id));
$t->parse("TPL_ROOT","tpl_root");
?>
