<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if (!$obj || (!$obj->getAcl(1) && !$obj->getAcl(2))) {
	header("Location:index.php?site=$site");
	exit;
}
$t->define (array('tpl_table' => "browse_addr_table.inc.html"));
$ID=$obj->getID();
$order=array();
$l_this="index.php?site=$site&action=$action&oid=$oid";
$form_action=$l_this;
$t->assign('FORM_ACTION',$form_action);
$t->assign('L_THIS',$form_action);
$H_REFERER[0]=$form_action;

foreach ($Addr->getlistFields() as $fid) {
	if ($Addr->getFieldData($fid,'Title')) {
		$t->assign("N_HEAD",Framework::entities($Addr->getFieldData($fid,'Title')));
	} elseif ($Addr->getFieldData($fid,'Name',1)) {
		$t->assign("N_HEAD",Framework::entities($T->lang($Addr->getFieldData($fid,'Name',1))));
	}
	$t->parse('ROW','.addr_head');
}
$t->assign('COL_SPAN',count($Addr->getlistFields())+3);
$av_modes=array('fav','used','last','new');
foreach ($av_modes as $mode) {
	$order=array();
	$use_limit=false;
	$searchAddr=array();
	$searchNode=array();
	$searchProject=array();
	$searchHot=array();
	switch ($mode) {
		case 'fav':
			$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
			$searchHot[]=array('Field'=>'Favorite','Typ'=>'=','Values'=>1);
			$searchHot[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$user_id);
			$Addr->setLimit(0);
		break;
		case 'used':
			$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
			$searchHot[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$user_id);
			$searchHot[]=array('Field'=>'Counter','Typ'=>'!=','Values'=>0);
			$order['AddrHotList.Counter']=-1;
			$Addr->setLimit(5);
		break;
		case 'last':
			$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
			$searchHot[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$user_id);
			$searchHot[]=array('Field'=>'TimeLast','Typ'=>'!=','Values'=>0);
			$order['AddrHotList.TimeLast']=-1;
			$Addr->setLimit(5);
		break;
		case 'new':
			$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
			$order['AddrMeta.TimeCreate']=-1;
			$Addr->setLimit(5);
		break;
	}

	$Fo='Name';
	$Fa=1;
	$order['AddrMeta.'.$Fo]=$Fa;
	$ftree=$Addr->searchAddr($b,$order,$searchAddr,$searchNode,$searchHot,$searchProject,$use_limit);
	$num_entrys=count($ftree);
	if ($Addr->getRows()) {
		$j=$i=1;
		$ac_link="index.php?site=$site&oid=$oid";
		foreach ($ftree as $key=>$val) {
			$lid=$val->getID();
			$link=$ac_link."&action=".$val->getAction(0)."&aid=".$lid."&back=0";
			$link_attribs='';
			if ($val->getACL(4)) {
				$link_attribs.=' onclick="return goToView(this);" ondblclick="return goToEdit(this,\'action='.$val->getAction(0).'\',\'action='.$val->getAction(1).'\');"';
			}
			$t->assign("L_LIST_ATTRIBS",$link_attribs);
			$t->assign('LIST_OBJ_ID',$mode.$lid);
			$t->assign("LIST_IMG",$val->getImage(0));
			$t->assign("L_LIST_ITEM",$link);
			$t->assign("LIST_ITEM",FrameWork::entities($val->getName()));
			foreach ($Addr->getlistFields() as $fid) {
				$values=$Addr->AddrExplode($val->getMeta($fid));
				$nowrap=1;
				$Addr->entry2Value($fid,$values,$nowrap);
				foreach ($values as $tkey=>$tval) {
					$col_link='';
					$col_add='';
					$target='';
					if ($tval) {
						switch ($Addr->getFieldData($fid,'Action')) {
							case 'mail':
								if ($app['email']) {
									$col_link=$H_REFERER[0]."&aid=$lid&addr_action_x=1&addr_action_val=s_mail&addr_action_num=$tkey";
								} else {
									$col_link="mailto:".htmlspecialchars($Addr->formatMail($val,$tval));
								}
							break;
							case 'fax':
								if ($app['fax']) {
									$col_link="index.php?site=fax.php&action=&show=compose&m_t=new&Addr=".urlencode($Addr->formatFax($val,$tval));
								}
							break;
							case 'sms':
								$col_link=htmlspecialchars($Addr->formatCallto($val,$tval));
								if ($frm->getMyApps('sms')) {
									$col_add='';
									$msgParams=array(
										'invReset'=>1,
										'tab'=>'sms',
									);
									$msgParams['smsToAdd']=$frm->getStaticModul('sms')->formatNumber($tval,$val->getName(1));
									$smsLink='javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));';
									if ($col_link) {
										$col_add='<a href="'.$smsLink.'"><img style="vertical-align:text-top" src="img/ge/js_send.gif" /></a>';
									} else {
										$col_link=$smsLink;
									}
								}
							break;
							case 'skype':
								$col_link=htmlspecialchars($Addr->formatCallto($val,$tval));
							break;
							case 'web':
								$col_link=htmlspecialchars($Addr->formatWeb($val,$tval));
								$target='target="_blank"';
							break;
						}
					}
					if ($col_link) {
						$values[$tkey]=$col_add.'<a href="'.$col_link.'" '.$target.'>'.FrameWork::entities($tval).'</a>';
					} else {
						$values[$tkey]=FrameWork::entities($tval);
					}
				}
				if ($nowrap) {
					$t->assign('LIST_WRAP',"wrap");
				} else {
					$t->assign('LIST_WRAP',"nowrap");
				}
				$t->assign("LIST_COL",implode('<br>',$values));
				$t->parse('ROW','.addr_col');
			}

			if ($i%2) $t->assign("ROW_COLOR",$bgcolor); else  $t->assign("ROW_COLOR","#f2f2f2");
			$t->parse('ROW','.addr_row');
			$t->clear_dynamic('addr_col');
			$i++;
		}
		$t->parse('ROW','title_'.$mode);

		$t->parse('TPL_TABLE','tpl_table');
		$t->parse('ROW','.table_row');
		$t->clear_dynamic('title_'.$mode);
		$t->clear_dynamic('addr_row');
		$t->unsetkey('tpl_table');
	} else {


	}



}
$t->assign("TPL_LAYERS","");
?>
