<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                                  |
	|	  39100 Bozen/Bolzano                                                     |
	|	  ITALIEN/ITALIA                                                          |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
    | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array('tpl_fields' => "edit_content_fields.inc.html"));
$k_array=array();$k_select=array();

if ($SESS_MDATA[$site]['REFERER']) {
	$H_REFERER[0]=$SESS_MDATA[$site]['REFERER'];
	unset($SESS_MDATA[$site]['REFERER']);
}
if ($SESS_MDATA[$site]['VCARD']) {
	$vcard_x=1;
	$f_vCard=$SESS_MDATA[$site]['VCARD'];
	unset($SESS_MDATA[$site]['VCARD']);
}

if (is_object($AObj)) {
	if ($copy) {
		$aid=0;
		if (!$AObj->getAcl(1) && !$AObj->getAcl(2)) {
			page_close();
			header("Location:index.php?site=$site&action=".$AObj->getAction(0)."&oid=$oid&aid=".$AObj->getID()."&back=0");
			exit;
		}
	} else {
		if (!$AObj->getAcl(4)) {
			page_close();
			header("Location:index.php?site=$site&action=".$AObj->getAction(0)."&oid=$oid&aid=".$AObj->getID()."&back=0");
			exit;
		}
		$AObj->setParentMeta('NodeIDs',$Addr->getAddrNodesIDs($AObj->getID()));
	}
} else {
	$AObj=new AObj_addr(0);
	if (Framework::issetParam('f_vCard','F')) {
		$f_vCard=Framework::getParam('f_vCard[tmp_name]','','F');
	}
	if (isset($vcard_x) && $f_vCard) {
		if (!file_exists($f_vCard)) {
			$ActionError['vcard']=true;
		} else {
			require_once ('lib/addr/Contact_Vcard_Parse.php');
			require_once ("lib/addr/ClassVcard.php");
			$vcard = new vCard($Addr->getVcardFields());
			$vcard->ParseFile($f_vCard);
			//$vcard->debug();
			if ($CardData=$vcard->fetchAddress(0)) {
				foreach ($CardData as $key=>$val) {
					$AObj->setMeta($key,$Addr->AddrImplode($val));
				}
				unset($AMeta,$form,$FieldTyp,$FieldMeta,$disp_n);
			} else {
				$ActionError['vcard']=true;
			}
		}
	}
}
if ($Addr->getPerms(4)) {
	$ProfilAcl=array('0'=>'-') + $Addr->listPermsProfilAcl(4);
} else {
	$ProfilAcl=$Addr->listPermsProfilAcl(4);
}

require_once('lib/class_FormGui.php');
require_once('lib/class_FunctionButtons.php');
$formGui=new FormGui();
$formGui->setLabelClass('no','no_error');
$key='StammID';
$formGui->addField($key,'ttip',$Addr->getFieldData($key,'Title'),$AObj->getMeta('StammID')?'a_'.$AObj->getMeta('StammID'):'','field_stamm');
$formGui->setParams($key,array('mode'=>'a','app'=>'','params'=>base64_encode(serialize(array('MaxEntries'=>1,'simpleSearch'=>1)))));

if ($P) {
	$lb_params=array('Values'=>array());
	$lb_params['Values'][]=array(
		'Label'=>$T->lang('[[Projektzugehoerigkeit]]'),
		'LabelSep'=>'',
		'mode'=>'o',
		'app'=>'',
		'params'=>'',
		'FieldVal'=>'_PROJECTS',
	);
	$key='fProject';
	$lb_Project=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
	$defInvit=array();
	if ($AObj->getID()) {
		$addrProjects=$Addr->getAddrProjects($AObj);
	} else {
		$addrProjects=array();
		if (Framework::getParam('_setPrjID','G')) $addrProjects[]=Framework::getParam('_setPrjID','G');
	}
	foreach ($addrProjects as $val) {
		$defInvit[]='o_'.$val;
	}
	$formGui->addField($key,'ttip',$lb_Project,implode('|',$defInvit),'field_proj');
	$formGui->setParams($key,array('mode'=>'o','app'=>'','params'=>''));
}


if ($save_x) {
	if (!count($pNodeID) && !count($gNodeID)) {
		$ActionError['no_cat']=true;
	}
	if ($Addr->getFieldData('Geschlecht')) {
		if (!intval($AMeta['Geschlecht'])) {
			$ActionError['fields']['Geschlecht']=true;
		} else {
			switch(intval($AMeta['Geschlecht'])) {
				case 1:
				case 2:
					if (!trim($AMeta['Nachname']) && !trim($AMeta['Vorname'])) {
						$ActionError['fields']['Nachname']=true;
						$ActionError['fields']['Vorname']=true;
					}
				break;
				case 3:
				case 4:
					if (!trim($AMeta['Firma'])) {
						$ActionError['fields']['Firma']=true;
					}
				break;

			}

		}
	}
	foreach ($Addr->getFields() as $FieldID=>$Field) {
		if ($Field['F_Unique']) {
			switch ($Field['Typ']) {
				case 'num':
					$temp=preg_replace('/[^0-9'.constDECIMAL.']/','',$AMeta[$FieldID]);
					$temp=str_replace(constDECIMAL,'.',$temp);
				break;
				default:
					$temp=$AMeta[$FieldID];
				break;
			}
			if ($temp && $Addr->isUsedFieldID($FieldID,$temp,$AObj->getID())) {
				$ActionError['fields'][$FieldID]=true;
			}
		}
		if ($Field['F_Required']) {
			$temp='';
			switch ($Field['Typ']) {
				case 'date':
					$temp=sprintf('%04d',$AMeta[$FieldID]['Y']).'-'.sprintf('%02d',$AMeta[$FieldID]['M']).'-'.sprintf('%02d',$AMeta[$FieldID]['D']);
					if ($temp=='0000-00-00') $temp='';
				break;
				case 'num':
					$temp=preg_replace('/[^0-9'.constDECIMAL.']/','',$AMeta[$FieldID]);
					$temp=str_replace(constDECIMAL,'.',$temp);
				break;
				case 'fk_user':
					$temp=FrameWork::getParam('hid_AMeta['.$FieldID.']','');
				break;
				default:
					if (is_array($AMeta[$FieldID])) {
						$temp=trim(implode('',$AMeta[$FieldID]));
					} else {
						$temp=trim($AMeta[$FieldID]);
					}
				break;
			}
			if (!$temp) {
				$ActionError['fields'][$FieldID]=true;
			}
		}
	}

	//debug($ActionError);
	if (!$ActionError) {
		if (is_array($FieldTyp)) {
			foreach($FieldTyp as $key=>$val) {
				if (trim($FieldMeta[$key])) $AMeta[$val][]=trim($FieldMeta[$key]);
			}
		}
		foreach ($Addr->getKFields() as $FieldID) {
			if (!isset($AMeta[$FieldID])) $AMeta[$FieldID]='';
		}

		$update=false;
		foreach ($Addr->getFields() as $FieldID=>$Field) {
			if (!($Field['Perms']&4)) continue;
			switch ($Field['Typ']) {
				case 'perm':
					if (count($pNodeID)) $AMeta[$FieldID]=0;
					if (((count($ProfilAcl)>1 || !isset($ProfilAcl[0])) && isset($ProfilAcl[$AMeta[$FieldID]])) || count($pNodeID))  {
						if ($AObj->getMeta($FieldID)!=$AMeta[$FieldID]) {
							$AObj->setMeta($FieldID,''.$AMeta[$FieldID]);
							$update=true;
						}
					}
				break;
				case 'date':
					$temp=sprintf('%04d',$AMeta[$FieldID]['Y']).'-'.sprintf('%02d',$AMeta[$FieldID]['M']).'-'.sprintf('%02d',$AMeta[$FieldID]['D']);
					if ($AObj->getMeta($FieldID)!=$temp) {
						$AObj->setMeta($FieldID,''.$temp);
						$update=true;
					}
				break;
				case 'num':
					$temp=preg_replace('/[^0-9'.constDECIMAL.']/','',$AMeta[$FieldID]);
					$temp=str_replace(constDECIMAL,'.',$temp);
					//debug($temp);
					//debug((string)$AObj->getMeta($FieldID));
					if ((string)$AObj->getMeta($FieldID)!==$temp) {
						$AObj->setMeta($FieldID,$temp);
						//debug('hh'.$temp);
						$update=true;
					}
				break;
				case 'stamm':
					$temp=0;
					if (trim($formGui->getFieldVal($FieldID))) {
						$tmp1=explode('|',$formGui->getFieldVal($FieldID));
						foreach ($tmp1 as $val) {
							$tmp2=explode('_',$val);
							if ($tmp2[0]=='a') $temp=$tmp2[1];
						}
					}
					if ($AObj->getMeta($FieldID)!=$temp) {
						$AObj->setMeta($FieldID,$temp);
						$update=true;
					}
				break;
				case 'fk_user':
					$temp=array();
					if (FrameWork::getParam('hid_AMeta['.$FieldID.']','')) {
						foreach(explode('|',FrameWork::getParam('hid_AMeta['.$FieldID.']','')) as $val) {
							$temp[]=substr($val,2);
						}
					}
					if ($AObj->getMeta($FieldID)!=trim($Addr->AddrImplode($temp))) {
						$AObj->setMeta($FieldID,trim(''.$Addr->AddrImplode($temp)));
						$update=true;
					}
				break;
				
				case 'password':
					if ($AMeta[$FieldID]!='**********') {
						if ($AMeta[$FieldID]) {
							$AObj->setMeta($FieldID,md5($AMeta[$FieldID]));
						} else {
							$AObj->setMeta($FieldID,'');
						}
						$update=true;
					}
				break;
				default:
					if (is_array($AMeta[$FieldID])) {
						if ($AObj->getMeta($FieldID)!=trim($Addr->AddrImplode($AMeta[$FieldID]))) {
							$AObj->setMeta($FieldID,trim(''.$Addr->AddrImplode($AMeta[$FieldID])));
							$update=true;
						}
					} else {
						if ($AObj->getMeta($FieldID)!=trim($AMeta[$FieldID])) {
							$AObj->setMeta($FieldID,trim(''.$AMeta[$FieldID]));
							$update=true;
						}
					}

			}

		}
		if ($AObj->getMeta('Trash')) {
			$AObj->setMeta('Trash',0);
			$AObj->setMeta('TrashIDs','');
			$update=true;
		}

		if (count($pNodeID)) {
			sort($pNodeID,SORT_NUMERIC);
			if ($pNodeID!=$AObj->getParentMeta('NodeIDs')) {
				$AObj->setParentMeta('NodeIDs',$pNodeID);
				$AObj->setMeta('UserID',$user_id);
				$update=true;
			}
		} else {
			sort($gNodeID,SORT_NUMERIC);
			if ($gNodeID!=$AObj->getParentMeta('NodeIDs')) {
				$AObj->setParentMeta('NodeIDs',$gNodeID);
				$AObj->setMeta('UserID',0);
				$update=true;
			}
		}
		if ($update) {
			$AObj->setMeta('UserModify',$user_id);
			$AObj->setMeta('TimeModify',time());
			$AObj->setMeta('Name',$AObj->getName());

			//debug($AObj);

			if ($AObj->getID()) {
				$Addr->updateAddrMeta($AObj);
			} else {
				$AObj->setMeta('UserCreate',$user_id);
				$AObj->setMeta('TimeCreate',time());
				$Addr->insertAddrMeta($AObj);
			}

		}
		if ($P && $formGui) {
			$addrPrj=array();
			if (trim($formGui->getFieldVal('fProject'))) {
				$temp=explode('|',$formGui->getFieldVal('fProject'));
				foreach ($temp as $val) {
					$tmp=explode('_',$val);
					if ($tmp[0]=='o') $addrPrj[]=$tmp[1];
				}
			}
			sort($addrProjects,SORT_NUMERIC);
			sort($addrPrj,SORT_NUMERIC);
			if ($addrPrj!=$addrProjects) {
				$Addr->setAddrProjects($AObj,$addrPrj);
			}
		}
		page_close();
		header("Location:index.php?site=$site&action=".$AObj->getAction(0)."&oid=$oid&aid=".$AObj->getID()."&back=0");
		exit;
	}
}
if ($P && $formGui) {
	$t->assign('C_FELD',$formGui->process('','field_proj'));
	$t->parse('ROW','card_row_proj');
}
foreach ($Addr->getKFields() as $FieldID) {
	$k_array[$FieldID]=$Addr->getFieldData($FieldID,'Title');
	if (!isset($form)) {
		$values=$Addr->AddrExplode($AObj->getMeta($FieldID));
		foreach ($values as $val) {
			if (trim($val)!=='') {
				$k_select[]=$FieldID;
				$FieldMeta[]=$val;
			}
		}
	}
}
if (!isset($form)) {
	foreach ($Addr->getKFields() as $FieldID) {
		if (!in_array($FieldID,$k_select)) $k_select[]=$FieldID;
	}
}
$maxKon=3;
if (isset($FieldMeta) && is_array($FieldMeta)) {
	foreach($FieldMeta as $v) {
		if (trim($v)) $maxKon++;
	}
}
if ($maxKon<10) $maxKon=10;
for ($kont=0;$kont<$maxKon;$kont++) {
	if (!isset($k_select[$kont])) $k_select[$kont]=reset(array_reverse($Addr->getKFields()));
	$select_obj=new SelectField('FieldTyp['.$kont.']','class="sel" style="width:100px;"',$k_array,$k_select[$kont]);
	$input_obj=new TextField('FieldMeta['.$kont.']','class="sel" style="width:195px;"');
	$t->assign('F_FELD_1',$select_obj->f());
	$t->assign('F_FELD_2',$input_obj->f());
	$t->parse('C_FELD','field_kont');
	$t->assign('C_FELD',$t->getParsed());
	$t->parse('ROW','.card_row_k');
}

foreach ($Addr->getFields() as $FieldID=>$Field) {
	if (!($Field['Perms']&4)) continue;
	$t->assign('ID_FELD',$FieldID);
	$t->assign('CLASS_FELD',$ActionError['fields'][$FieldID]?'error':'');
	switch ($Field['Typ']) {
		case 'perm':
			if ((count($ProfilAcl)>1 || !isset($ProfilAcl[0]))) {
				$select_array=$ProfilAcl;
				$input_obj=new SelectField('AMeta['.$FieldID.']','class="sel" style="width:300px;"',$select_array,$AObj->getMeta($FieldID));
				$t->assign('N_FELD',Framework::entities($Field['Title']));
				$t->assign('F_FELD',$input_obj->f());
				if (!is_object($root_obj[$eroot_id]) || $root_obj[$eroot_id]->getMeta('System')=='u') {
					$t->assign('DIS_PERM','none');
				} else {
					$t->assign('DIS_PERM','');
				}
				$t->parse('C_FELD','field_perm');
				$t->assign('C_FELD',$t->getParsed());
			} else {
				$Field['Card']='';
			}
			break;
		case 'stamm':
			$t->assign('C_FELD',$formGui->process('','field_stamm'));
			break;
		case 'text':
			if (!isset($AMeta[$FieldID])) {
				$AMeta[$FieldID]=$AObj->getMeta($FieldID);
			}
			$input_obj=new TextField('AMeta['.$FieldID.']','class="sel" style="width:300px;"','0','%',$AObj->getID()?$AObj->getMeta($FieldID):$Field['F_Default']);
			/*if ($Field['F_Unique'] && (!$AMeta[$FieldID] || $ActionError['fields'][$FieldID])) {
				$Field['Title'].=' ('.$Addr->getNextFreeFieldID($FieldID).')';
			}*/
			$t->assign('N_FELD',Framework::entities($Field['Title']));
			$t->assign('F_FELD',$input_obj->f());
			$t->parse('C_FELD','field_text');
			$t->assign('C_FELD',$t->getParsed());
			//debug($Field);
			break;
		case 'area':
			$input_obj=new TextArea('AMeta['.$FieldID.']','class="sel" rows="5" style="width:300px;"','0','%',$AObj->getID()?$AObj->getMeta($FieldID):$Field['F_Default']);
			$t->assign('N_FELD',Framework::entities($Field['Title']));
			$t->assign('F_FELD',$input_obj->f());
			$t->parse('C_FELD','field_text');
			$t->assign('C_FELD',$t->getParsed());
			break;
		case 'fk_user':
			if ($ActionError['fields'][$FieldID]) {
				$E->setError('fields','AMeta['.$FieldID.']');
			}
			$crmFormGui=new FormGui();
			$Params=array();
			$tmpParams=array(
				'MaxEntries'=>$Field['F_Mode']?0:1,
				'useAll'=>0,
			);
			$Params['mode']='u';
			$Params['limit']=10;
			$Params['params']=base64_encode(serialize($tmpParams));

			$Default=array();
			$temp=$AObj->getID()?$AObj->getMeta($FieldID):$Field['F_Default'];
			if ($temp) {
				foreach($Addr->AddrExplode($temp) as $fval) {
					$Default[]='u_'.$fval;
				}
			}

			$lb_params=array('Values'=>array());
			$lb_params['Values'][]=array(
				'Label'=>$Field['Title'],
				'LabelSep'=>'',
				'mode'=>$Params['mode'],
				'app'=>'cal',
				'params'=>$Params['params'],
				'FieldVal'=>'_USERS',
			);
			$crmLabel=new FunctionButtons('AMeta['.$FieldID.']','ajaxttiplabel',$lb_params);
			$crmFormGui->addField('AMeta['.$FieldID.']','ttip',$crmLabel,implode('|',$Default));
			$crmFormGui->setParams('AMeta['.$FieldID.']',$Params);
			
			$t->assign('C_FELD',$crmFormGui->process());
		break;
		case 'select':
			if ($Field['F_Mode']) {
				$t->clear_dynamic('field_select_chk_row');
				$input_obj=new RadioButton('AMeta['.$FieldID.']',"",$AObj->getID()?$AObj->getMeta($FieldID):$Field['F_Default']);
				$fValues=$Addr->listAddrSelect($FieldID);
				foreach ($fValues as $fkey=>$fval) {
					$t->assign('V_FELD',Framework::entities($fval));
					$t->assign('F_FELD',$input_obj->f($fkey));
					$t->parse('ROW','.field_select_chk_row');
				}
				$t->assign('N_FELD',Framework::entities($Field['Title']));
				$t->parse('C_FELD','field_select_chk');
				$t->assign('C_FELD',$t->getParsed());
			} else {
				$select_array=array('0'=>'-') + $Addr->listAddrSelect($FieldID);
				$input_obj=new SelectField('AMeta['.$FieldID.']','class="sel" style="width:300px;"',$select_array,$AObj->getID()?$AObj->getMeta($FieldID):$Field['F_Default']);
				$t->assign('N_FELD',Framework::entities($Field['Title']));
				$t->assign('F_FELD',$input_obj->f());
				$t->parse('C_FELD','field_select');
				$t->assign('C_FELD',$t->getParsed());
			}
			break;
		case 'mselect':
			if ($Field['F_Mode']) {
				$t->clear_dynamic('field_mselect_chk_row');
				$input_obj=new CheckBox ('AMeta['.$FieldID.']',"",0,$Addr->AddrExplode($AObj->getID()?$AObj->getMeta($FieldID):$Field['F_Default']),1);
				$fValues=$Addr->listAddrSelect($FieldID);
				foreach ($fValues as $fkey=>$fval) {
					$t->assign('V_FELD',Framework::entities($fval));
					$t->assign('F_FELD',$input_obj->f($fkey));
					$t->parse('ROW','.field_mselect_chk_row');
				}
				$t->assign('N_FELD',Framework::entities($Field['Title']));
				$t->parse('C_FELD','field_mselect_chk');
				$t->assign('C_FELD',$t->getParsed());
			} else {
				$input_obj=new SelectField('AMeta['.$FieldID.']','class="sel" id="'.$FieldID.'" size="5" style="width:300px;"',$Addr->listAddrSelect($FieldID),$Addr->AddrExplode($AObj->getID()?$AObj->getMeta($FieldID):$Field['F_Default']),1);
				$t->assign('N_FELD',Framework::entities($Field['Title']));
				$t->assign('F_FELD',$input_obj->f());
				$t->parse('C_FELD','field_mselect');
				$t->assign('C_FELD',$t->getParsed());
			}
			break;
		case 'chk':
			if (!isset($AMeta[$FieldID])) {
				$AMeta[$FieldID]=$AObj->getID()?$AObj->getMeta($FieldID):$Field['F_Default'];
			}
			$input_obj=new RadioButton('AMeta['.$FieldID.']','',0);
			$t->assign('N_FELD',Framework::entities($Field['Title']));
			$t->assign('F_FELD_J',$input_obj->f(1));
			$t->assign('F_FELD_N',$input_obj->f(-1));
			$t->assign('F_FELD_I',$input_obj->f(0));
			$t->parse('C_FELD','field_chk');
			$t->assign('C_FELD',$t->getParsed());
			break;
		case 'title':
			$t->assign('N_FELD',Framework::entities($Field['Title']));
			$t->parse('C_FELD','field_title');
			$t->assign('C_FELD',$t->getParsed());
			break;
		case 'num':
			//debug(localeconv());
			if (!isset($AMeta[$FieldID])) {
				$AMeta[$FieldID]=$AObj->getID()?(''.str_replace('.',constDECIMAL,$AObj->getMeta($FieldID))):$Field['F_Default'];
			}
			$input_obj=new TextField('AMeta['.$FieldID.']','class="sel" style="width:300px;"');

			if ($Field['F_Unique'] && (!$AMeta[$FieldID] || $ActionError['fields'][$FieldID])) {
				$Field['Title'].=' ('.$Addr->getNextFreeFieldID($FieldID,$Field['F_Unique']).')';
			}
			$t->assign('N_FELD',Framework::entities($Field['Title']));
			$t->assign('F_FELD',$input_obj->f());
			$t->parse('C_FELD','field_text');
			$t->assign('C_FELD',$t->getParsed());
			//debug($Field);
			break;
		case 'date':
			if (!isset($AMeta[$FieldID])) {
				if ($AObj->getID()) {
					$temp=preg_split('/[^0-9]/',$AObj->getMeta($FieldID));
					$AMeta[$FieldID]['Y']=$temp[0];
					$AMeta[$FieldID]['M']=$temp[1];
					$AMeta[$FieldID]['D']=$temp[2];
				} else {
					switch($Field['F_Default']) {
						case 'now':
							$AMeta[$FieldID]['Y']=date('Y');
							$AMeta[$FieldID]['M']=date('m');
							$AMeta[$FieldID]['D']=date('d');
						break;
					}
				}
			}
			if (!intval($AMeta[$FieldID]['Y'])) $AMeta[$FieldID]['Y']='----';
			if (!intval($AMeta[$FieldID]['M'])) $AMeta[$FieldID]['M']='--';
			if (!intval($AMeta[$FieldID]['D'])) $AMeta[$FieldID]['D']='--';
			$input_obj1=new TextField('AMeta['.$FieldID.'][Y]','class="sel" maxlenght="4" style="width:60px;"');
			$input_obj2=new TextField('AMeta['.$FieldID.'][M]','class="sel" maxlenght="2" style="width:30px;"');
			$input_obj3=new TextField('AMeta['.$FieldID.'][D]','class="sel" maxlenght="2" style="width:30px;"');

			$t->assign('N_FELD',Framework::entities($Field['Title']));
			$t->assign('F_FELD_1',$input_obj1->f());
			$t->assign('F_FELD_2',$input_obj2->f());
			$t->assign('F_FELD_3',$input_obj3->f());
			$t->parse('C_FELD','field_date');
			$t->assign('C_FELD',$t->getParsed());
			//debug($Field);
			break;
		case 'password':
			if (!isset($AMeta[$FieldID])) {
				$AMeta[$FieldID]=$AObj->getMeta($FieldID)?'**********':'';
			}
			$input_obj=new PasswordField('AMeta['.$FieldID.']','class="sel" style="width:300px;"','0','%');
			$t->assign('N_FELD',Framework::entities($Field['Title']));
			$t->assign('F_FELD',$input_obj->f());
			$t->parse('C_FELD','field_text');
			$t->assign('C_FELD',$t->getParsed());
			//debug($Field);
			break;

		default:
			$Field['Card']='';
			continue;


	}
	//$Ftyp=array('chk','select','mselect','text','area','date','num','title');
	if ( $Field['Multi'] && $AObj->getMeta($FieldID)) $mvalues[$Field['Multi']]+=1;
	if ($Field['Card'] && $t->issetkey('card_row_'.$Field['Card'])) {
		$t->parse('ROW','.card_row_'.$Field['Card']);
		$parseCards[$Field['Card']]=true;
	}
}
foreach (array_keys($parseCards) as $val) {
	if ($t->issetkey('card_'.$val)) {
		$t->parse('ROW','card_'.$val);
	}
}
if (!$disp) {
	if ($mvalues[2]>$mvalues[1]) $disp='pk'; else $disp='gk';
}
if ($display_pk) $disp='pk';
if ($display_gk) $disp='gk';
if ($display_crm) $disp='crm';

if ($display_n_n) $disp_n='n';
if ($display_n_v) $disp_n='v';

$t->assign('DISP_GK_ON','off');
$t->assign('DISP_PK_ON','off');
$t->assign('DISP_CRM_ON','off');

$t->assign('DISP_GK','none');
$t->assign('DISP_PK','none');
$t->assign('DISP_CRM','none');

$t->assign('C_DISP_N_N','disp_off');
$t->assign('C_DISP_N_V','disp_off');
$t->assign('DISP_N_N','none');
$t->assign('DISP_N_V','none');


switch($disp) {
	case 'pk':
		$t->assign('DISP_PK','normal');
		$t->assign('DISP_PK_ON','on');
		break;
	case 'crm':
		if ($Addr->getFieldsACL(4)) {
			$t->assign('DISP_CRM','normal');
			$t->assign('DISP_CRM_ON','on');
			break;
		}
	default:
		$t->assign('DISP_GK','normal');
		$t->assign('DISP_GK_ON','on');
		break;
}
switch($disp_n) {
	case 'v':
		$t->assign('DISP_N_V','normal');
		$t->assign('C_DISP_N_V','disp_on');
		break;
	default:
		$t->assign('DISP_N_N','normal');
		$t->assign('C_DISP_N_N','disp_on');
		break;
}
if ($Addr->getFieldsACL(4)) {
	$t->parse('ROW','display_crm');
}
if ($parseCards['ga'] || $parseCards['gf']) {
	$t->parse('ROW','display_gk');
}
if ($parseCards['pa'] || $parseCards['pf']) {
	$t->parse('ROW','display_pk');
}
$t->assign('HID_DISP',$disp);
$t->assign('HID_DISP_N',$disp_n);

$t->assign('FORM_ACTION',"index.php?site=$site&action=$action&oid=$oid&aid=$aid&back=$back&form=1");
if ($H_REFERER[intval($back)]) {
	$t->assign('L_BREAK',$H_REFERER[intval($back)]);
} else {
	$t->assign('L_BREAK',"index.php?site=$site");
}

?>