<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array('tpl_addr' => 'print_address.inc.html'));
if (!is_object($AObj) || !$AObj->getACL(2)) {
	exit;
}

$t->assign('ADDR_NAME',FrameWork::entities($AObj->getName()));
$AObj->setParentMeta('NodeIDs',$Addr->getAddrNodesIDs($AObj->getID()));

parseAddress($AObj,$disp,0);

$view_crm=0;
if (count($Addr->getUserFields())) {
	$t->define (array('tpl_fields' => "view_content_fields.inc.html"));
	$crmFields=array();$crmGroup=0;
	foreach ($Addr->getUserFields() as $FieldID) {
		switch ($Addr->getFieldData($FieldID,'Typ')) {
			case 'title':
				$crmGroup=$FieldID;
			break;
			case 'text':
			case 'area':
			case 'select':
			case 'mselect':
			case 'chk':
			case 'num':
			case 'fk_user':
				if ($AObj->getMeta($FieldID)) {
					$crmFields[$crmGroup][]=$FieldID;
				}
			break;
			case 'date':
				if ($AObj->getMeta($FieldID) && $AObj->getMeta($FieldID) != '0000-00-00') {
					$crmFields[$crmGroup][]=$FieldID;
				}
			break;
		}

	}
	if (!empty($crmFields)) {
		foreach ($crmFields as $crmGroup=>$field_list) {
			$Field=$Addr->getFieldData($crmGroup);
			if ($Field) {
				$t->assign('N_FELD',Framework::entities($Field['Title']));
				$t->parse('C_FELD','field_title');
				$t->assign('C_FELD',$t->getParsed());
				if ($Field['Card'] && $t->issetkey('card_row_'.$Field['Card'])) {
					$t->parse('ROW','.card_row_'.$Field['Card']);
				}
			}
			foreach ($field_list as $FieldID) {
				$Field=$Addr->getFieldData($FieldID);
				//debug($FieldID);
				switch ($Field['Typ']) {
					case 'text':
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',Framework::entities($AObj->getMeta($FieldID)));
						$t->parse('C_FELD','field_text');
						$t->assign('C_FELD',$t->getParsed());
						break;
					case 'area':
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',nl2br(Framework::entities($AObj->getMeta($FieldID))));
						$t->parse('C_FELD','field_text');
						$t->assign('C_FELD',$t->getParsed());
						break;
					case 'select':
						$select_array=array('0'=>'-') + $Addr->listAddrSelect($FieldID);
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',Framework::entities($select_array[$AObj->getMeta($FieldID)]));
						$t->parse('C_FELD','field_select');
						$t->assign('C_FELD',$t->getParsed());
						break;
					case 'mselect':
						$select_array=array('0'=>'-') + $Addr->listAddrSelect($FieldID);
						$temp=$Addr->AddrExplode($AObj->getMeta($FieldID));
						$temp_val=array();
						foreach ($temp as $val) {
							$temp_val[]=$select_array[$val];
						}
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',implode('<br />',Framework::entities($temp_val)));
						$t->parse('C_FELD','field_select');
						$t->assign('C_FELD',$t->getParsed());
						break;
					case 'fk_user':
						$temp_val=$frm->getCachedUserName($Addr->AddrExplode($AObj->getMeta($FieldID)));
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',implode('<br />',Framework::entities($temp_val)));
						$t->parse('C_FELD','field_select');
						$t->assign('C_FELD',$t->getParsed());
						break;
						
					case 'chk':
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						if ($AObj->getMeta($FieldID)==1) {
							$t->parse('ROW','field_chk_y');
						}
						if ($AObj->getMeta($FieldID)==-1) {
							$t->parse('ROW','field_chk_n');
						}
						$t->parse('C_FELD','field_chk');
						$t->assign('C_FELD',$t->getParsed());
						$t->clear_dynamic('field_chk_y');
						$t->clear_dynamic('field_chk_n');
						break;
					case 'num':
						$temp=''.str_replace('.',constDECIMAL,floatval($AObj->getMeta($FieldID)));
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',Framework::entities($temp));
						$t->parse('C_FELD','field_text');
						$t->assign('C_FELD',$t->getParsed());
						break;
					case 'date':
						$temp=preg_split('/[^0-9]/',$AObj->getMeta($FieldID));
						if (!intval($temp[0])) $temp[0]='----';
						if (!intval($temp[1])) $temp[1]='--';
						if (!intval($temp[2])) $temp[2]='--';
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD_1',$temp[0]);
						$t->assign('F_FELD_2',$temp[1]);
						$t->assign('F_FELD_3',$temp[2]);
						$t->parse('C_FELD','field_date');
						$t->assign('C_FELD',$t->getParsed());
						break;
				}
				if ($Field['Card'] && $t->issetkey('card_row_'.$Field['Card'])) {
					$t->parse('ROW','.card_row_'.$Field['Card']);
				}
			}
		}
		$t->parse('ROW','view_crm');
	}
}

if ($disp=='p') {
	$t->assign('DISP_P_ON','on');
	$t->assign('DISP_G_ON','off');
} else {
	$t->assign('DISP_P_ON','off');
	$t->assign('DISP_G_ON','on');
}

$t->parse('TPL_ADDR','tpl_addr');
clearAddress();




if ($AObj->getMeta('StammID')) {
	$tmpObj=$Addr->getAddrObj($AObj->getMeta('StammID'));
	if ($tmpObj->getAcl(1) || $tmpObj->getAcl(2)) {
		parseAddress($tmpObj,$disp,$seed,1);
		$t->parse('TPL_STAMM','tpl_addr');
		//$t->parse('ROW','txt_stamm');
		$t->parse('ROW','.tpl_stamm');
		clearAddress();
	}
	$StammID=$AObj->getMeta('StammID');
} else {
	$StammID=$AObj->getID();
}
/*
$st_list=$Addr->getStammAddr($StammID,$AObj->getID());
foreach ($st_list as $key=>$val) {
	$tmpObj=$Addr->getAddrObj($val);
	if ($tmpObj->getAcl(1) || $tmpObj->getAcl(2)) {
		parseAddress($tmpObj,$disp,$seed);
		$t->parse('TPL_STAMM','tpl_addr');
		if ($vst==$seed) {
			$t->assign('DISP_STAMM','');
			$t->assign('ST_ON','on');
		} else {
			$t->assign('DISP_STAMM','none');
			$t->assign('ST_ON','off');
		}
		$t->assign('ST_URL',"index.php?site=$site&action=$action&oid=$oid&aid=$aid&disp=$disp&vst=$seed");
		if ($tmpObj->getMeta('Firma')==$stFirma) {
			if ($tmpObj->getMeta('Nachname') || $tmpObj->getMeta('Vorname')) $tmpObj->setMeta('Firma','');
		}
		if ($tmpObj->getMeta('Nachname') && $tmpObj->getMeta('Vorname')) {
			$tmpObj->setMeta('Vorname',substr($tmpObj->getMeta('Vorname'),0,1).'.');
		}
		$t->assign('ST_NAME',Framework::entities($tmpObj->getName()));
		$t->parse('ROW','.view_stamm_h');
		$t->parse('ROW','.tpl_stamm');
		clearAddress();
		$seed++;
	}
}
if ($seed>1) {
	$t->parse('ROW','view_stamm');
}
*/


$i=1;
$log_list=$Addr->listLog($AObj->getID(),'log','');
foreach ($log_list as $key=>$val) {
	$t->assign('LOG_TEXT',nl2br(Framework::entities($val['Text'])));
	$t->assign('LOG_DATE',date('d.m.Y - H:i',$val['Date']));
	if (!$all_users[$val['User']]) {
		$temp=$frm->getFullName($val['User'],0,1);
		$all_users[$val['User']]=$temp[$val['User']];
	}
	$t->assign('LOG_USER',$all_users[$val['User']]);
	$t->parse('ROW','.log_row');
	$i++;
}
if ($i>1) {
	$t->parse('ROW','log_book');
}
$i=1;
$kmng_list=$Addr->listKmng($AObj->getID());
foreach ($kmng_list as $key=>$val) {
	$tmpObj=$Addr->getAddrObj($key);
	if (is_object($tmpObj) && $tmpObj->getAcl(2)) {
		$t->assign('KMNG_LINK',"index.php?site=$site&action=$action&oid=$oid&aid=$key&back=0");
		$t->assign('KMNG_NAME',Framework::entities($tmpObj->getName()));
		$t->assign('KMNG_TEXT',nl2br(Framework::entities($val['Text'])));
		$t->parse('ROW','.kmng_row');
		$i++;
	}
}
if ($i>1) {
	$t->parse('ROW','kontakt_mng');
}

$t->parse('TPL_CARD','tpl_card');
$PrintID=$frm->insertPrint($Addr->getModul(),'html',$t->getparsed('TPL_CARD'));
page_close();
header("Location:print.php?PrintID=$PrintID");
exit;

function parseAddress(&$AObj,&$disp,$seed,$Stamm=0) {
	global $t,$Addr,$app,$root_obj,$P;
	$t->assign('SEED',$seed);
	$parse_card=array();
	foreach ($Addr->getFields() as $FieldID=>$Field) {
		if ($Field['FieldTyp']!='u') {
			if ($FieldID=='Geschlecht') $Field['Card']='ex';
			$parseCards[$Field['Card']]=true;
			//echo $FieldID.'<br>';
			$values=$Addr->AddrExplode($AObj->getMeta($FieldID));
			$parse=0;
			foreach ($values as $tkey=>$tval) {
				$col_link='';
				$target='';
				if ($tval) {
					switch ($Field['Action']) {
						case 'mail':
							if ($app['email']) {
								$col_link="index.php?site=mail.php&action=&show=compose&m_t=new&Addr=".urlencode($Addr->formatMail($AObj,$tval));
							} else {
								$col_link="mailto:".htmlspecialchars($Addr->formatMail($AObj,$tval));
							}
						break;
						case 'fax':
							if ($app['fax']) {
								$col_link="index.php?site=fax.php&action=&show=compose&m_t=new&Addr=".urlencode($Addr->formatFax($AObj,$tval));
							}
						break;
						case 'web':
							$col_link=htmlspecialchars($Addr->formatWeb($AObj,$tval));
							$target='target="_blank"';
						break;
					}
					$parse=1;
				}
				if ($col_link) {
					$values[$tkey]='<a href="'.$col_link.'" '.$target.'>'.nl2br(FrameWork::entities($tval)).'</a>';
				} else {
					$values[$tkey]=nl2br(FrameWork::entities($tval));
				}
			}

			switch ($Field['Typ']) {
				case 'area':
				case 'text':
				case 'kont':
					if ($parse && $t->issetkey("$FieldID")) {
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',implode('<br>',$values));
						$t->parse('ROW',"$FieldID");
						$parse_card[$Field['Card']]=1;
						if ($Field['Multi']) $mvalues[$Field['Multi']]+=1;
					}
					break;
				case 'select':
					if ($parse && $t->issetkey("$FieldID")) {
						foreach ($values as $key=>$val) {
							$tmp=$Addr->readAddrSelect($FieldID,$val,array($Addr->getLang()));
							$values[$key]=$tmp['Name_'.$Addr->getLang()];
						}
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',implode('<br>',$values));
						$t->parse('ROW',"$FieldID");
						$parse_card[$Field['Card']]=1;
						if ($Field['Multi']) $mvalues[$Field['Multi']]+=1;
					}
					break;
				case 'date':
					if ($parse && $t->issetkey("$FieldID") && $values[0]!= '0000-00-00') {
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',Framework::dateSql('d.m.Y',$values[0]));
						$t->parse('ROW',"$FieldID");
						$parse_card[$Field['Card']]=1;
						if ($Field['Multi']) $mvalues[$Field['Multi']]+=1;
					}
					break;
				default:
					continue;
			}

		}
	}
	if (!$disp) {
		if ($mvalues[2]>$mvalues[1]) $disp='p'; else $disp='g';
	}
	if ($disp=='p') {
		$t->assign('DISP_GA','none');
		$t->assign('DISP_GK','none');
		$t->assign('DISP_PA','');
		$t->assign('DISP_PK','');
	} else {
		$t->assign('DISP_GA','');
		$t->assign('DISP_GK','');
		$t->assign('DISP_PA','none');
		$t->assign('DISP_PK','none');
	}

	if ($Stamm) {
		$t->parse('ROW','StammAddr');
	}
	foreach ($parse_card as $key=>$val) {
		if ($t->issetkey('card_row_'.$key)) {
			$t->parse('ROW','card_row_'.$key);
		}
	}
	$colspan=2;
	if (($parseCards['ga'] || $parseCards['gf']) && ($parseCards['pa'] || $parseCards['pf'])) {
		$colspan=1;
	}
	$t->assign('COLSPAN',$colspan);


	if ($parseCards['ga'] || $parseCards['gf']) {
		$t->parse('ROW','card_ga');
		$t->parse('ROW','card_gf');
		$t->parse('ROW','view_g');
	}
	if ($parseCards['pa'] || $parseCards['pf']) {
		$t->parse('ROW','card_pa');
		$t->parse('ROW','card_pf');
		$t->parse('ROW','view_p');
	}

	if (is_array($AObj->getParentMeta('NodeIDs'))) {
		$i=0;
		foreach ($AObj->getParentMeta('NodeIDs') as $nid) {
			$obj_tree=$Addr->getObjTree($nid);
			$tmp_tree=array();
			if (is_array($obj_tree) && !empty($obj_tree)) {
				foreach ($obj_tree as $key=>$val) {
					if (!isset($root_obj[$nid]) && isset($root_obj[$key])) break;
					$tmp_tree[]=FrameWork::entities($val);
				}
			}
			$t->assign('CAT_TREE',implode(' / ',array_reverse($tmp_tree)));
			$t->parse('ROW','.cat_row');
			$i++;
		}
		if ($i) $t->parse('ROW','categorys');
	}
	$addrProjects=$Addr->getAddrProjects($AObj);
	if (!empty($addrProjects) && $P) {
		foreach ($addrProjects as $val) {
			$t->assign('PROJ_NAME',Framework::entities($P->getCachedProjectName($val)));
			$t->parse('ROW','.proj_row');
		}
		$t->parse('ROW','view_project');
	}

}
function clearAddress() {
	global $t,$Addr;
	foreach ($Addr->getFields() as $FieldID=>$Field) {
		$t->clear_dynamic($FieldID);
		$t->clear_dynamic($Field['Card']);
		$t->clear_dynamic('card_row_'.$Field['Card']);
	}
	$t->clear_dynamic('card_ga');
	$t->clear_dynamic('card_gf');
	$t->clear_dynamic('view_g');
	$t->clear_dynamic('card_pa');
	$t->clear_dynamic('card_pf');
	$t->clear_dynamic('view_p');
	$t->clear_dynamic('StammAddr');
	$t->clear_dynamic('cat_row');
	$t->clear_dynamic('categorys');
	$t->clear_dynamic('proj_row');
	$t->clear_dynamic('view_project');
	$t->clear_dynamic('view_crm');

}
?>