<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if ($delete_x) {
	$del_app=$frm->getApplication();
	foreach ($delUsers as $userID) {
		$userData=$frm->read_user($userID,true);

		if ($userData['uidGroup-e']==$auth->auth["uid"]) {
			$ActionError['medel'][$userID]=1;
			continue;
		}
		$urules=$frm->getUserRules($userData['uidGroup-e']);
		if (is_array($urules)) {
			foreach(array_keys($urules) as $rval) {
				$rusers=$frm->getRuleUsers($rval);
				if (is_array($rusers[$rval]) && in_array($userData['uidGroup-e'],$rusers[$rval]) && count($rusers[$rval])==1) {
					$ActionError['udel'][$userID]=1;
					break;
				}
			}
		}
		if (!$ActionError['udel'][$userID] && !$ActionError['medel'][$userID] && $userData['uidGroup-e'] && $userData['uidGroup-e']!=$CFG['SUPERADMIN']) {
			if ($del_app["cal"]) {
				$cal=& $frm->getStaticModul('cal');
				$cal->deleteUser($userData['uidGroup-e']);
			}
			if ($del_app["addr"]) {
				$Addr=& $frm->getStaticModul('addr');
				$Addr->deleteUser($userData['uidGroup-e']);
			}
			if ($del_app["task"]) {
				$Task=& $frm->getStaticModul('task');
				$Task->deleteUser($userData['uidGroup-e']);
			}
			if ($del_app["forum"]) {
				require_once ("lib/forum/header.php");
				$forum->deleteUser($userData['uidGroup-e']);

			}
			if ($del_app["msg"]) {
				$c_msg=& $frm->getStaticModul('msg');
				$c_msg->deleteUser($userData['uidGroup-e']);
			}
			if ($del_app["fax"]) {
				require_once('lib/fax/class_Db_Fax.php');
				$db_fax=new DB_Fax($db);
				$db_fax->deleteUser($userData['uidGroup-e']);
			}
			if ($del_app["email"]) {
				$Mail=& $frm->getStaticModul('mail');
				$Mail->setUser($userData['uidGroup-e']);
				$Mail->setUserName($userData['username']);
				$Mail->deleteUser($userData['uidGroup-e']);
				if ($Mail->getCfg('cfg/sieve/user') || $Mail->getCfg('cfg/filter/user')) {
					require_once('lib/mail/classSieve.php');
					$sieve=new SieveDB($db);
					$sieve->deleteUser($userData['uidGroup-e']);
					if ($Mail->getCfg('cfg/sieve/user')) {
						require_once('lib/mail/classSieveLib.php');
						$sieve_lib=new Sieve($Mail->getCfg('cfg/Server'), $Mail->getCfg('cfg/sieve/port'),$Mail->getUserName(),$Mail->getCfg('cfg/admin'),$Mail->getAdminPwd());
						if ($sieve_lib->sieve_login()) $sieve_lib->sieve_deletescript($Mail->getUserName());
					}
				}
				if ($frm->getFrmCfg('cfg/delall')) {
					$CyrAdm=& $frm->getStaticModul('mail_adm');
					$Mail->setCfg($GLOBALS['frm']->getCfg($Mail->getModul(),0,$Mail->getCfg('cfg/alias').'/%'));
					if ($Mail->getCfg('cfg/alias') && file_exists("lib/mail/classAlias_".$Mail->getCfg('cfg/alias').".php")) {
						require_once("lib/mail/classAlias_".$Mail->getCfg('cfg/alias').".php");
					} else {
						require_once("lib/mail/classAlias_mysql.php");
					}
					$Ali=new Aliases($Mail);
					if ($CyrAdm->imap_login()) {
						$user_alias=$Ali->get_alias_list_user($userData['username']);
						if (is_array($user_alias)) {
							foreach($user_alias as $var){
								$Ali->alias_delete($var['alias'], $userData['username']);
							}
						}
						$CyrAdm->deletemb("user".$CyrAdm->getCfg('cfg/delim').$userData['username']);
					}
				}
			}
			$frm->delete_user($userData['uidGroup-e']);
			$frm->deleteUserGroups($userID,0,true,false);
			$frm->deleteGroupieUser($userID);
		}
	}
	if (!$ActionError) {
		if ($groupID && $groupID!=$frm->getGroupAllLdapID()) {
			/*
			$groupdata=$frm->getAdminGroups($groupID);
			if ($groupdata['gidGroup-e']) {
				$frm->deleteGroup($groupdata['gidGroup-e']);
			}
			$frm->deleteGroupieGroup($groupID);*/
			header("Location:index.php?site=$site&ac=acc_group");
			page_close();
			exit;
		} else {
			header("Location:index.php?site=$site&ac=acc_user");
			page_close();
			exit;
		}
	}
} else {
	if ($groupID) {
		$delUsers=$frm->getGroupUsers($groupID,true);
	} else {
		$delUsers=array($userID);
	}

}
?>
