<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array("form_tpl"=>"admin_acc_group_form.inc.html"));
$parse=false;
$obj_action=$frm->getObjAction('admin','acc_group');
foreach ($obj_action as $key=>$val) {
	if ($val['Hidden']) continue;
	if (in_array('ID',$val['Extra']) && (!$groupID || $groupID==$CFG['GROUP_ALL'])) continue;
	if (in_array('rule',$val['Extra']) && (!$my_rule['sysadmin'])) continue;
	$t->assign('SEL_VAL',$key);
	$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
	$t->parse('ROW','.obj_action_val');
	$parse=true;
}
if ($parse) $t->parse('ROW','obj_action');

if ($mode=='edit') {

	if ($ActionError['fields']['group_name']) $t->assign('C_NAME','error'); else  $t->assign('C_NAME','');
	$f_name=new TextField("group_name","class=sel  style=\"width:300px\" size=15");
	$t->assign("F_NAME",$f_name->f());
	$t->assign('FOCUS_FIELD','group_name');
	$f_restrict=new TextField("restrict_ip",'lass="sel" size=15 style="width:300px"',"","",$def_restrict_ip);
	$t->assign("F_RESTRICT_IP",$f_restrict->f());

	if ($groupID) {
		$chk_group_app=new CheckBox ("group_app","","","",1);
		$apps=$frm->getApplication(0,-1);
		foreach ($apps as $key=>$val) {
			$t->assign("APP_RIGHTS_F",$chk_group_app->f($val['id']));
			if (in_array($val['id'],$group_app)) {
				$t->assign("APP_E_RIGHTS_F","<img src=img/$THEME/checked.gif width=17 height=17 border=0>");
			} else {
				$t->assign("APP_E_RIGHTS_F","<img src=img/$THEME/unchecked.gif width=17 height=17 border=0>");
			}
			$t->assign("APP_NAME_LIST",Framework::entities($val['title']));
			$t->parse("ROW",".app_row");
		}
		$t->parse("ROW",'app_edit');
		if ($groupID!=$CFG['GROUP_ALL']) {
			$temp=$frm->getGroupUsers($groupID);
			if (!empty($temp)){
				$g_users=$frm->getFullName($temp,0,array('','system'));
			} else $g_users=array('');
			unset($temp);
			$o_users=$frm->getFullName(0,0,array('','system'));
			if (is_array($o_users)) {
				foreach($o_users as $key=>$val) {
					if ($g_users[$key]) unset($o_users[$key]);
				}
			}
			if (!is_array($o_users)) $o_users=array('');
			$select1=new SelectField ('group_users','class=sel size=20 style=width:200px',$g_users,'',1);
			$select2=new SelectField ('other_users','class=sel size=20 style=width:200px',$o_users,'',1);
			$t->assign('GROUP_USERS',$select1->f());
			$t->assign('OTHER_USERS',$select2->f());
			$t->parse("ROW",'user_edit');
		}
		$t->assign('GROUP_NAME',Framework::entities($groupdata[$groupID]));
		$t->parse('ROW','title_edit');
	} else {
		$t->parse('ROW','title_new');
	}
	$t->assign('L_BREAK',"index.php?site=$site&ac=$ac");
	$t->parse('ROW','break');
	$t->parse('ROW','update');
	$t->parse('ROW','meta_content');

} else {
	$all_groups=$frm->getAllGroups();
	$i=0;
	foreach ($all_groups as $key=>$val) {
		$t->assign('LIST_LINK',"index.php?site=$site&ac=$ac&groupID=$key&mode=edit");
		$t->assign('LIST_NAME',Framework::entities($val));
		if ($key==$groupID) {
			$t->assign('ROW_COLOR',$fg10color);
		} elseif ($i%2) {
			$t->assign('ROW_COLOR','#f2f2f2');
		} else {
			$t->assign('ROW_COLOR',$bgcolor);
		}
		$t->parse('ROW','.list_row');
		$i++;
	}
	$t->parse('ROW','list_content');
}


$AdminGui->setFormAction("index.php?site=$site&ac=$ac&groupID=$groupID&mode=$mode");
if($my_rule['sysadmin']) {
	$t->parse('ROW','app_rules');
	if (!$CFG['NoUserEdit']) $t->parse('ROW','app_import');
	if (defined('GE_SUPER_GROUPS_ENABLED') && GE_SUPER_GROUPS_ENABLED) {
		$t->parse('ROW','app_sgroups');
	}
}
?>