<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if ($obj_action_x && $obj_action_val) {
	if ($obj_action_val=='new') {
		header("Location:index.php?site=$site&ac=$ac&mode=edit");
		page_close();
		exit;
	}
	if ($obj_action_val=='delete') {
		if ($groupID!=$frm->getGroupAllLdapID()) {
			$groupdata=$frm->getAdminGroups($groupID);
			if ($groupdata['gidGroup-e']) {
				$frm->deleteGroup($groupdata['gidGroup-e']);
			}
			$frm->deleteGroupieGroup($groupID);
			page_close();
			header("Location:index.php?site=$site&ac=$ac");
			exit;
		}

	}
	if ($obj_action_val=='del_users') {
		header("Location:index.php?site=$site&ac=acc_delete&groupID=".$groupID);
		page_close();
		exit;
	}
}
if ($save_x) {
	if (trim($group_name) && GE_groupDomainSuffix && !strpos($group_name,'_'.GE_groupDomainSuffix)) {
		$group_name.='_'.GE_groupDomainSuffix;
	}
	if (!trim($group_name) || $frm->check_group($group_name,$groupID)) $ActionError['fields']['group_name']=1;
	if (!$ActionError) {
		if ($groupID) {
			$groupdata=$frm->getAdminGroups($groupID);
			if ($frm->getGroupAllLdapID()==$groupID) $group_aktiv=1;
		} else {
			$groupdata=array();
			if ($sadmin && $DEBUG==2) {
				if ($_POST['gidNumber']) {
					$groupdata['gidnumber']=$_POST['gidNumber'];
				}
			}
		}
		$groupdata['cn']=$group_name;
		$groupdata['activGroup-e']=intval($group_aktiv);
		if ($groupID) {
			if (!$frm->update_group($groupID,$groupdata,true)) {
				$ActionError['ldap']=$frm->getError();
			};
		} else {
			if (!($groupID=$frm->insert_group($groupdata))) {
				$ActionError['ldap']=$frm->getError();
			} else {
				$tmpUser=$frm->read_user($auth->auth['uid']);

				//LSCHEN TODO
				if (!$tmpUser['uidnumber']) $tmpUser['uidnumber']=$auth->auth['uid'];

				if (!$tmpUser['uidnumber'] || !$frm->insertGroupUsers($groupID,array($tmpUser['uidnumber']))) {
					$frm->deleteGroupieGroup($groupID);
					unset($groupID);
					$ActionError['ldap']=$frm->getError();
				}
			}
			$unload=0;
		}
		if (!$ActionError) {
			$groupdata=$frm->getAdminGroups($groupID);
			if ($groupdata['gidGroup-e']) {
				$frm->deleteGroupApps($groupdata['gidGroup-e']);
				if (is_array($group_app)) {
					$frm->insertGroupApps($groupdata['gidGroup-e'],$group_app);
				}
				if ($_POST['restrict_ip']) {
					$frm->insertModulData('global','g',$groupdata['gidGroup-e'],'restrict_ip',$_POST['restrict_ip']);
				} else {
					$frm->deleteModulData('global','g',$groupdata['gidGroup-e'],'restrict_ip');
				}
			}
			if ($unload) {
				unset($groupID,$mode);
			} else {
				unset($save_x);
			}
		}
	}
}
if ($mode=="edit") {
	if ($groupID) {
		$groupdata=$frm->getAdminGroups($groupID);
		//debug($groupdata);
		if (!$save_x) {
			$group_name=$groupdata['cn'];
			$group_aktiv=$groupdata['activGroup-e'];
			$group_app=$frm->getGroupsApplication($groupdata['gidGroup-e']);
			$def_restrict_ip=$frm->getModulData('global','g',$groupdata['gidGroup-e'],'restrict_ip');;
		}
	} else {
		if (!$save_x) {
			$group_aktiv=1;
			$group_app=array();
			$def_restrict_ip='';
		}
	}
}
if ($add_x) {
	if ($other_users[0]) {
		$frm->insertGroupUsers($groupID,$other_users);
		unset($other_users);
	}
}
if ($del_x) {
	if (is_array($group_users)) {
		foreach ($group_users as $val) {
			$frm->deleteUserGroups($val,$groupID);
		}
		unset($group_users);
	}
}
if ($move_x) {
	if (is_array($group_users) && $move_groups) {
		$frm->insertGroupUsers($move_groups,$group_users);
		foreach ($group_users as $val) {
			$frm->deleteUserGroups($val,$groupID);
		}
		unset($group_users);
	}
}
if ($copy_x) {
	if (is_array($group_users) && $move_groups) {
		$frm->insertGroupUsers($move_groups,$group_users);
	}
}
?>