<?php
if (Framework::getParam('_csv',0)) {
	$csvData=unserialize($frm->getUserData('admin','userImport'));
	if (is_array($csvData)) {
		$frm->deleteUserData('admin','userImport');
		$frm->exportCsv($csvData,';',false,'User.csv');
	}
	exit;
}

$TMP_DIR=Framework::getTempPath();
$max_num=0;
$numData=0;
$impData=array();
$allowed_fields=array(
	'g',
	'm',
	's',
	'p',
);
if ($frm->getFrmCfg('ldap/squid')) $allowed_fields[]='i';

if($av_apps['email']){
	$Mail=$frm->getStaticModul('mail');
	$CyrAdm=$frm->getStaticModul('mail_adm');
	if (!$CyrAdm->imap_login()) {
		$ActionError['server']=$CyrAdm->getError();
	} else {
		$Mail->setCfg($GLOBALS['frm']->getCfg($Mail->getModul(),0,$Mail->getCfg('cfg/alias').'/%'));
		require_once("lib/mail/classAlias_".$Mail->getCfg('cfg/alias').".php");
		$Ali=new Aliases($Mail);
	}
}
$ListID=Framework::getParam('ListID',array(),'P');

if ($fname && !file_exists("$TMP_DIR/".basename($fname))) {
	unset($fname);
}
$groups=$frm->getAdminGroups(0,false);
if ($z_sep=='t') $sep="\t";
else $sep=$z_sep;
if ($upload_x) {
	if (file_exists($_FILES['csv_file']['tmp_name']) && is_uploaded_file($_FILES['csv_file']['tmp_name'])) {
		$impData=$frm->importCsv ($_FILES['csv_file']['tmp_name'],$z_sep,true);
		if ($impData[0]['firstname'] && $impData[0]['lastname']) {
			if (!$fname) $fname=basename(tempnam($TMP_DIR,'csv'));
			copy ($_FILES['csv_file']['tmp_name'],"$TMP_DIR/".$fname);
			$numData=count($impData);
			$ListID=array_keys($impData);
		} else $ActionError['csv']=1;
	} else $ActionError['csv']=1;
} elseif ($fname && file_exists("$TMP_DIR/".basename($fname))) {
	$impData=$frm->importCsv ("$TMP_DIR/".$fname,$z_sep,true);
	if (is_array($impData)) {
		$numData=count($impData);
	}
	if ($numData && isset($import_x)) {
		if (!is_array($user_groups) || !count($user_groups)) {
			$ActionError['fields']['group']=1;
		}

		if (!$gidNumber || !$frm->getAdminGroups($gidNumber)) {
			$ActionError['fields']['gidNumber']=1;
		}
		unset($UserError);
		foreach ($impData as $key=>$impUser) {
			if (!in_array($key,$ListID)) continue;
			if ($autUname[$key]) {
				$impData[$key]['username']=$impUser['username']=$autUname[$key];
			}
			if ($autPwd[$key]) {
				$impData[$key]['password']=$impUser['password']=$autPwd[$key];
			}
			if  (strlen($impUser['password'])<$CFG['MinPassLenght']) {
				$UserError[$key]['password']=1;
				$ActionError['i_password'][]=$impUser['username'];
			}
			if (!trim($impUser['firstname'])) {
				$UserError[$key]['firstname']=1;
				$ActionError['i_fields'][]=$impUser['username'];
			}
			if (!trim($impUser['lastname'])) {
				$UserError[$key]['lastname']=1;
				$ActionError['i_fields'][]=$impUser['username'];
			}
			$username=strtolower(trim($impUser['username']));
			if (strlen($username) < $CFG['MinUserLenght']) {
				$ActionError['i_userlen'][]=$impUser['username'];
				$UserError[$key]['username']=1;
			} elseif (preg_match('/[^a-z0-9-_]/i',$username)) {
				$UserError[$key]['username']=1;
				$ActionError['i_fields'][]=$impUser['username'];
			} else {
				if (GE_userDomainSuffix) {
					$username=preg_replace('/'.preg_quote('_'.GE_userDomainSuffix,'/').'$/i','',$username).'_'.GE_userDomainSuffix;
				}
				if ($frm->check_user($username,0)) {
					$ActionError['i_username'][]=$impUser['username'];
					$UserError[$key]['username']=1;
				} else {
					$impData[$key]['username']=$username;
				}
			}
			if (!trim($impUser['email']) && $av_apps['email']) {
				$domain=$Mail->getCfg('cfg/domain');
				if ($domain && strpos($domain,'@')===false) {
					$domain='@'.$domain;
				}
				$impData[$key]['email']=$impUser['email']=$impUser['username'].$domain;
			}
			if (!$frm->is_email($impUser['email'])) {
				$UserError[$key]['email']=1;
				$ActionError['i_fields'][]=$impUser['username'];
			}
		}

		if (!$ActionError) {
			$cnt=0;
			foreach ($impData as $key=>$impUser) {
				if (!in_array($key,$ListID)) continue;
				$field=array();
				if (in_array('g',$allowed_fields)) $field["groupe"]=intval($impUser['allow_groupe']);
				if (in_array('s',$allowed_fields)) $field["samba"]=intval($impUser['allow_samba']);
				if (in_array('p',$allowed_fields)) $field["posix"]=intval($impUser['allow_posix']);
				if (in_array('i',$allowed_fields)) $field["internet"]=intval($impUser['allow_internet']);
				if (intval($impUser['old_group-e_id'])) $field['uidGroup-e']=$impUser['old_group-e_id'];
				$field["firstname"]=trim($impUser['firstname']);
				$field["lastname"]=trim($impUser['lastname']);
				$field["email"]=trim($impUser['email']);
				$field["username"]=strtolower(trim($impUser['username']));
				$field["password"]=$impUser['password'];
				$field['perms']=0;
				$field['gidnumber']=$gidNumber;
				if (!($userID=$frm->insert_user($field))) {
					$ActionError['server'][]=$impUser['username'].':'.$frm->getError();
				} else {
					$cnt++;
					$userdata=$frm->read_user($userID,true);
					if ($userdata['groupe']) {
						$user_groups[]=$frm->getGroupAllLdapID();
					}
					if (is_array($user_groups)) {
						$user_groups=array_unique($user_groups);
						$frm->insertUserGroups($userID,$user_groups);
					}
					if($impUser['allow_mail'] && $av_apps['email']){
						$result=$CyrAdm->GetUsers($field["username"]);
						if ($result!==false) {
							if (!is_array($result) || !in_array($field["username"],$result)) {
								if ($CyrAdm->createmb("user".$CyrAdm->getCfg('cfg/delim').$field["username"])) {
									$CyrAdm->setmbquota("user".$CyrAdm->getCfg('cfg/delim').$field["username"],($impUser['quota']?$impUser['quota']:20)*1000);
									if (GE_userDomainSuffix) {
										$simple_username=preg_replace('/'.preg_quote('_'.GE_userDomainSuffix,'/').'$/','',$field["username"]);
									} else {
										$simple_username=$field["username"];
									}
									$aliasar=array();
									$aliasar[0]=Framework::replaceAccents(strtolower($field["firstname"].".".$field["lastname"]));
									if (GE_DOMAIN) $aliasar[0].='@'.GE_DOMAIN;
									$aliasar[1]=$simple_username;
									if (GE_DOMAIN) $aliasar[1].='@'.GE_DOMAIN;
									$aliasar=array_unique($aliasar);

									foreach($aliasar as $avar){
										if (!$Ali->alias_add($avar,$field["username"],$field)) {
											$ActionError['server'][]=$impUser['username'].':'.$Ali->getError();
										}
									}

									$tpre['email']=$frm->getPrefs('email','',$userdata['uidGroup-e']);
									$pref_update=false;
									if (!$tpre['email']['email1']) {
										if (GE_DOMAIN) {
											$tpre['email']['email1']=$aliasar[0];
										} else {
											$domain=$Mail->getCfg('cfg/domain');
											if ($domain && strpos($domain,'@')===false) {
												$domain='@'.$domain;
											}
											$tpre['email']['email1']=$aliasar[0].$domain;
										}
										$pref_update=true;
									}
									if (!$tpre['email']['fullname1']) {
										$tpre['email']['fullname1']=$field["firstname"]." ".$field["lastname"];
										$pref_update=true;
									}
									if ($pref_update) {
										$frm->insertPrefs('email',$tpre['email'],$userdata['uidGroup-e']);
									}


								} else {
									$ActionError['i_mail'][]=$impUser['username'];
								}
							} else {
								$ActionError['i_mail'][]=$impUser['username'];
							}
						} else {
							$ActionError['i_mail'][]=$impUser['username'];
						}
					}
				}
			}
			if ($cnt) $ActionError['import']=$cnt;
		}

	}
} else {

}
