<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$no_mail=false;
$allowed_fields=$frm->getUserFields();
if ($obj_action_x && $obj_action_val) {
	if ($obj_action_val=='new' && !$CFG['NoUserEdit']) {
		header("Location:index.php?site=$site&ac=$ac&mode=edit&b=$b&info=".urlencode($info));
		page_close();
		exit;
	}
	if ($obj_action_val=='delete' && !$CFG['NoUserEdit']) {
		header("Location:index.php?site=$site&ac=acc_delete&userID=".$userID);
		page_close();
		exit;
	}
}

if (isset($save_x)) {
	if (!$CFG['NoPassword']) {
		$npassword=trim($npassword);
		if ($npassword!=$npassword_b || ($npassword && strlen($npassword)<$CFG['MinPassLenght']) || (!$npassword && !$userID)) {
			if  (strlen($npassword)<$CFG['MinPassLenght']) {
				$ActionError['passwlen']=$CFG['MinPassLenght'];
			} else {
				$ActionError['fields']['passwort']=1;
				$ActionError['fields']['passwort2']=1;
			}
		}
	} else {
		$npassword='';
	}
	if (!trim($firstname)) $ActionError['fields']['vorname']=1;
	if (!trim($lastname)) $ActionError['fields']['nachname']=1;
	if (!$CFG['NoUserEdit']) {
		$username=strtolower(trim($username));
		if (strlen($username) < $CFG['MinUserLenght']) {
			$ActionError['userlen']=$CFG['MinUserLenght'];
		} elseif (preg_match('/[^a-z0-9-_]/i',$username)) {
			$ActionError['fields']['username']=1;
		} else {
			if (GE_userDomainSuffix) {
				$username=preg_replace('/'.preg_quote('_'.GE_userDomainSuffix,'/').'$/i','',$username).'_'.GE_userDomainSuffix;
			}
			if ($frm->check_user($username,$userID)) {
				$ActionError['username']=$username;
			}
			if ($GLOBALS['CFG']['USER_CLASS']=='ldap_full' && (!$gidNumber || !$frm->getAdminGroups($gidNumber))) {
				$ActionError['fields']['gidNumber']=1;
			}
		}
	}
	if (!$frm->is_email($email)) $ActionError['fields']['email']=1;
	if (!$ActionError) {
		if ($userID) {
			$userdata=$frm->read_user($userID,true);
			$uidGroupe=$userdata['uidGroup-e']?$userdata['uidGroup-e']:$userID;
			if ($CFG['NoUserEdit'] && $uidGroupe==$CFG['SUPERADMIN']) {
				$allowed_fields=array();
				$CFG['NoPassword']=true;
			}
		} else {
			$uidGroupe=0;
			$userdata=array();
		}

		if (in_array('g',$allowed_fields)) {
			$userdata["groupe"]=intval($groupe);
			if ($my_rule['sysadmin']) {
				if ($perms) $userdata['perms']=1; else $userdata['perms']=0;
			} elseif (!isset($userdata['perms'])) $userdata['perms']=0;
		}
		if (in_array('s',$allowed_fields)) {
			$userdata["samba"]=intval($samba);
			$userdata["smbServer"]=$sambaServer;
			if ($samba) $user_groups[]=513;
		}
		if (in_array('p',$allowed_fields)) $userdata["posix"]=intval($posix);
		if (in_array('i',$allowed_fields)) $userdata["internet"]=intval($internet);

		$userdata["firstname"]=trim($firstname);
    	$userdata["lastname"]=trim($lastname);
    	$userdata["email"]=trim($email);
      	$userdata["mobil"]=Framework::formatPhone($mobil);
      	$userdata["tel"]=Framework::formatPhone($tel);
      	$userdata["fax"]=Framework::formatPhone($fax);

       	$userdata["company"]=trim($company);
     	$userdata["adress"]=trim($adress);
     	$userdata["zip"]=trim($zip);
      	$userdata["place"]=trim($place);
  	
    	if (!$CFG['NoUserEdit']) {
			$userdata["username"]=$username;
		}
		if (!$CFG['NoPassword'] && $npassword) {
			$userdata["password"]=$npassword;
		} else unset($userdata["password"]);
		if ($CFG['USER_CLASS']=='ldap_full') {
			$userdata["title"]=trim($title);
			if (isset($password_time)) $userdata["shadowMax"]=$password_time;
			if ($frm->getFrmCfg('ldap/mailRouting')) {
				$userdata["maillocaladdress"]=trim($maillocaladdress);
				$userdata["mailhost"]=trim($mailhost);
				$userdata["mailroutingaddress"]=trim($mailroutingaddress);
			}
		}

		if ($CFG['USER_CLASS']!='ldap_full') {
			$userdata["startdate"]=$frm->parseDate($startdate);
			if (!$userdata["startdate"]) {
				$userdata["startdate"]=-1;
				$startdate='--/--/----';
			}
			$userdata["enddate"]=$frm->parseDate($enddate,23,59);
			if (!$userdata["enddate"]) {
				$userdata["enddate"]=-1;
				$enddate='--/--/----';
			}
			$userdata["update_time"]=time();
			if (!$userID) $userdata["create_time"]=$userdata["update_time"];
		} else {
			$userdata['gidnumber']=$gidNumber;
		}

		if ($userID) {
			//debug($userdata);
			if (!$frm->update_user($userID,$userdata,true)) {
				$ActionError['server']=$frm->getError();
			};
		} else {
			if ($sadmin && $DEBUG==2) {
				if ($_POST['uidNumber']) {
					$userdata['uidnumber']=$_POST['uidNumber'];
				}
			}
			if (!($userID=$frm->insert_user($userdata))) {
				$ActionError['server']=$frm->getError();
			}
		}
		if (!$ActionError) {
			$userdata=$frm->read_user($userID,true);
			$frm->deleteUserGroups($userID);
			$frm->deleteUserApps($userdata['uidGroup-e']?$userdata['uidGroup-e']:$userID,true);
			if (!$userdata['perms'] && $userdata['groupe']) {
				if ($CFG['USER_CLASS']=='ldap_full') {
					$user_groups[]=$frm->getGroupAllLdapID();
				} else {
					$user_groups[]=$CFG['GROUP_ALL'];
				}
			}
			if (is_array($user_groups)) {
				$user_groups=array_unique($user_groups);
				//debug($user_groups);
				$frm->insertUserGroups($userID,$user_groups);
			}
			if (is_array($user_app)) {
				$frm->insertUserApps($userdata['uidGroup-e'],$user_app);
			}
			if (in_array('g',$allowed_fields)) {
				if ($_POST['restrict_ip']) {
					$frm->insertModulData('global','u',$userdata['uidGroup-e'],'restrict_ip',$_POST['restrict_ip']);
				} else {
					$frm->deleteModulData('global','u',$userdata['uidGroup-e'],'restrict_ip');
				}
			}

			if($mail && $av_apps['email']){
				$Mail=& $frm->getStaticModul('mail');
				$CyrAdm=& $frm->getStaticModul('mail_adm');
				if ($CyrAdm->imap_login()) {
					if (GE_userDomainSuffix) {
						$simple_username=preg_replace('/'.preg_quote('_'.GE_userDomainSuffix,'/').'$/i','',$userdata['username']);
					} else {
						$simple_username=$userdata['username'];
					}

					if (GE_DOMAIN && $GLOBALS['CFG']['USER_CLASS']!='ldap_full') {
						$m_username=$userdata['username'].'_'.str_replace('.','_',GE_DOMAIN);
					} elseif (GE_mailUserSuffix) {
						$m_username=$simple_username.GE_mailUserSuffix;
					} else {
						$m_username=$userdata['username'];
					}
					$result=$CyrAdm->GetUsers($m_username);
					if ($result!==false) {
						if (!is_array($result) || !in_array($m_username,$result)) {
							if ($CyrAdm->createmb("user".$CyrAdm->getCfg('cfg/delim').$m_username)) {
								$CyrAdm->setmbquota("user".$CyrAdm->getCfg('cfg/delim').$m_username, $selquota*1000);
								$Mail->setCfg($GLOBALS['frm']->getCfg($Mail->getModul(),0,$Mail->getCfg('cfg/alias').'/%'));
								require_once("lib/mail/classAlias_".$Mail->getCfg('cfg/alias').".php");
								$Ali=new Aliases($Mail);
								$aliasar=array();
								$aliasar[0]=Framework::replaceAccents(strtolower($userdata["firstname"].".".$userdata["lastname"]));
								if (GE_DOMAIN) $aliasar[0].='@'.GE_DOMAIN;
								$aliasar[1]=$simple_username;
								if (GE_DOMAIN) $aliasar[1].='@'.GE_DOMAIN;
								$aliasar=array_unique($aliasar);
								foreach($aliasar as $key=>$var){
									if (!$Ali->alias_add($var,$userdata["username"],$field)) {
										$ActionError['server'].=$Ali->getError()."\n";
									}
								}
								$tpre['email']=$frm->getPrefs('email','',$userdata['uidGroup-e']);
								$pref_update=false;
								if (!$tpre['email']['email1']) {
									if (GE_DOMAIN) {
										$tpre['email']['email1']=$aliasar[0];
									} else {
										$domain=$Mail->getCfg('cfg/domain');
										if ($domain && strpos($domain,'@')===false) {
											$domain='@'.$domain;
										}
										$tpre['email']['email1']=$aliasar[0].$domain;
									}
									$pref_update=true;
								}
								if (!$tpre['email']['fullname1']) {
									$tpre['email']['fullname1']=$userdata['firstname']." ".$userdata['lastname'];
									$pref_update=true;
								}
								if ($pref_update) {
									$frm->insertPrefs('email',$tpre['email'],$userdata['uidGroup-e']);
								}
							} else {
								$ActionError['server']=$CyrAdm->getError();
							}
						} else {
							$mailacc="yes";
						}
					} else {
						$ActionError['server']=$CyrAdm->getError();
						$no_mail=true;
					}
				} else {
					$ActionError['server']=$CyrAdm->getError();
					$no_mail=true;
				}
			}
			if($av_apps['zef'] && $userdata['uidGroup-e']){
				$zError=array();
				$zef=$frm->getStaticModul('zef');
				$bhour=FrameWork::getParam('bhour',array(),'P');
				$bmin=FrameWork::getParam('bmin',array(),'P');
				$ehour=FrameWork::getParam('ehour',array(),'P');
				$emin=FrameWork::getParam('emin',array(),'P');
				for ($i=1;$i<8;$i++) {
					if ($bhour[$i][1]<0 || $bhour[$i][1]>23) $bhour[$i][1]=0;
					if ($bhour[$i][2]<0 || $bhour[$i][2]>23) $bhour[$i][2]=0;
					if ($ehour[$i][1]<0 || $ehour[$i][1]>23) $ehour[$i][1]=0;
					if ($ehour[$i][2]<0 || $ehour[$i][2]>23) $ehour[$i][2]=0;

					if ($bmin[$i][1]<0 || $bmin[$i][1]>59) $bmin[$i][1]=0;
					if ($bmin[$i][2]<0 || $bmin[$i][2]>59) $bmin[$i][2]=0;
					if ($emin[$i][1]<0 || $emin[$i][1]>59) $emin[$i][1]=0;
					if ($emin[$i][2]<0 || $emin[$i][2]>59) $emin[$i][2]=0;
				}
				$zef->saveUserTime($bhour,$bmin,$ehour,$emin,$userdata['uidGroup-e']);
			}
		}
		if (!$ActionError) {
			$mode="";
			$userID="";
		}
	}
}
?>
