<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$T->loadModul('addr');
$t->define(array("form_tpl"=>"admin_addr_crm_form.inc.html"));
$t->assign('P_ON','off');
$t->assign('C_ON','on');
$t->assign('R_ON','off');
$parse=false;
$obj_action=$frm->getObjAction('admin','addr_crm');
foreach ($obj_action as $key=>$val) {
	if ($val['Hidden']) continue;
	if (in_array('ID',$val['Extra']) && (!$FieldID || $mode!='edit')) continue;
	$t->assign('SEL_VAL',$key);
	$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
	$t->parse('ROW','.obj_action_val');
	$parse=true;
}
if ($parse) $t->parse('ROW','obj_action');

if ($mode=='edit') {
	$L_THIS="index.php?site=$site&ac=$ac&mode=$mode&FieldID=".$FieldID."&SelID=".$SelID;
	if ($FieldID) {
		$t->assign('FIELD_NAME',Framework::entities($Field['Title_'.$session_lang]));
		$t->parse('ROW','title_edit');
	} else {
		$Ftyp=array('chk','select','mselect','text','area','date','num','fk_user','title','password');
		if (!$save_x) $ObjAktiv=1;
		$t->parse('ROW','title_new');
	}

	$tmp_name=$Field['Title_'.$session_lang];
	if (!isset($save_x)) $ObjLang=1;
	$lang_array=$CFG['MA_LANG'];
	foreach ($lang_array as $val) {
		if ($val==$session_lang) {
			$txt_title=new TextField("ObjTitle_$val",'size="30" class="sel" style="width:300px"','0','%',$Field['Title_'.$val]);
			$t->assign('OBJ_TITLE',$txt_title->f());
			$t->assign('OBJ_TITLE_LANG',strtoupper($val));
			if ($ActionError['fields']["ObjTitle_$val"]) {
				$t->assign('C_TITLE','error');
			} else {
				$t->assign('C_TITLE','');
			}
			$t->assign('FOCUS_FIELD',"ObjTitle_$val");
		} else {
			$txt_title=new TextField("ObjTitle_$val",'size="30" class="sel" style="width:300px" onChange="document.daten.ObjLang.checked=0;" onKeyDown="document.daten.ObjLang.checked=0;"','0','%',$Field['Title_'.$val]);
			if ($_POST["ObjTitle_$val"] && $_POST["ObjTitle_$val"]!=$tmp_name) $ObjLang=0;
			if ($Field['Title_'.$val] && $Field['Title_'.$val]!=$tmp_name) $ObjLang=0;
			$t->assign('OBJ_TITLE_A',$txt_title->f());
			$t->assign('OBJ_TITLE_LANG_A',strtoupper($val));
			if ($ActionError['fields']["ObjTitle_$val"]) {
				$t->assign('C_TITLE_A','error');
			} else {
				$t->assign('C_TITLE_A','');
			}
			$t->parse('ROW','.obj_lang');
		}
	}
	$txt_id=new TextField("ObjRefID",'size="30" class="sel" style="width:300px"','0','%',$Field['RefID']);
	$t->assign('OBJ_REFID',$txt_id->f());
	if ($ActionError['fields']["RefID"]) {
		$t->assign('C_REFID','error');
	} else {
		$t->assign('C_REFID','');
	}
	
	if (count($lang_array)>1) {
		$chk_lang=new CheckBox('ObjLang','',1);
		$t->assign('CHK_OBJ_LANG',$chk_lang->f());
		$t->parse('ROW','obj_lang_one');
	}
	$chk_aktiv=new CheckBox('ObjAktiv','',1,$Field['Aktiv']);
	$t->assign('CHK_OBJ_AKTIV',$chk_aktiv->f());
	$chk_required=new CheckBox('ObjF_Required','',1,$Field['F_Required']);
	$t->assign('CHK_OBJ_REQUIRED',$chk_required->f());

	if (is_array($Ftyp)) {
		foreach ($Ftyp as $val) {
			if ($FieldTyp==$val) $t->assign(strtoupper($val).'_SEL','selcted="selected"'); else $t->assign(strtoupper($val).'_SEL','');
			$t->parse('ROW','ftyp_'.$val);
		}
		if ($ActionError['fields']['FieldTyp']){
			$t->assign('C_FIELD_TYP','error');
		} else {
			$t->assign('C_FIELD_TYP','');
		}
		$t->parse('ROW','ftyp');
	}
	if ($FieldID) {
		if ($Field['Typ']=='mselect') {
			$rad_mode=new RadioButton('ObjF_Mode','',$Field['F_Mode']);
			$t->assign('RAD_OBJ_MODE_0',$rad_mode->f(0));
			$t->assign('RAD_OBJ_MODE_1',$rad_mode->f(1));
			$t->parse('ROW','obj_multi_mode');
		}
		if ($Field['Typ']=='fk_user') {
			$rad_mode=new RadioButton('ObjF_Mode','',$Field['F_Mode']);
			$t->assign('RAD_USER_MODE_0',$rad_mode->f(0));
			$t->assign('RAD_USER_MODE_1',$rad_mode->f(1));
			$t->parse('ROW','obj_user_mode');
		}
		$f_default=false;
		switch($Field['Typ']) {
			case 'chk':
				$def_array=array(0=>'-',1=>$T->lang('[[Ja]]'),-1=>$T->lang('[[Nein]]'));
				$f_default=new SelectField("ObjF_Default",'class="sel" style="width:300px;"',$def_array,$Field['F_Default']);
			break;
			case 'select':
				$def_array=array(0=>'-') + $Addr->listAddrSelect($FieldID);
				$f_default=new SelectField("ObjF_Default",'class="sel" style="width:300px;"',$def_array,$Field['F_Default']);
			break;
			case 'mselect':
				$def_array=$Addr->listAddrSelect($FieldID);
				$f_default=new SelectField("ObjF_Default",'class="sel" style="width:300px;"',$def_array,$Field['F_Default']?$Addr->AddrExplode($Field['F_Default']):array(),1);
			break;
			case 'text':
				$f_default=new TextField("ObjF_Default",'size="30" class="sel" style="width:300px"','0','%',$Field['F_Default']);
			break;
			case 'area':
				$f_default=new TextArea("ObjF_Default",'size="30" class="sel" style="width:300px"','0','%',$Field['F_Default']);
			break;
			case 'date':
				$def_array=array(0=>'-','now'=>$T->lang('[[Aktuelles Datum]]'));
				$f_default=new SelectField("ObjF_Default",'class="sel" style="width:300px;"',$def_array,$Field['F_Default']);
			break;
			case 'num':
				$f_default=new TextField("ObjF_Default",'size="30" class="sel" style="width:300px"','0','%',$Field['F_Default']);
			break;
			case 'fk_user':
				if ($Field['F_Mode']) {
					$def_array=$frm->getFullName(array_keys($frm->getApplicationUsers('addr')));
					$f_default=new SelectField("ObjF_Default",'class="sel" style="width:300px;"',$def_array,$Field['F_Default']?$Addr->AddrExplode($Field['F_Default']):array(),1);
				} else {
					$def_array=array(0=>'-') + $frm->getFullName(array_keys($frm->getApplicationUsers('addr')));
					$f_default=new SelectField("ObjF_Default",'class="sel" style="width:300px;"',$def_array,$Field['F_Default']);
				}
			break;
		}
		if ($f_default) {
			$t->assign('F_DEFAULT',$f_default->f());
			$t->parse('ROW','obj_default');
			
		}



		

		

		$av_perms=array(
			'l'=>2,
			's'=>6,
			'k'=>0,
		);
		$img_signed='X';
		$users_array=$frm->getFullName(array_keys($frm->getApplicationUsers('addr')));
		$all_users=$users_array;
		$groups_array=array(0=>'-') + $frm->getAllGroups();
		$convert_perms=array();
		foreach ($av_perms as $key=>$val) {
			$t->parse('COL','sign_tit_'.$key);
			$t->parse('COL','gsign_tit_'.$key);
		}
		$Users=explode('|',$Field['Users']);
		$i=0;
		foreach ($Users as $val) {
			if (empty($val)) continue;
			$puser=explode(',',$val);
			if ($puser[0]==$CFG['SUPERADMIN'] && $auth->auth['uid']!=$CFG['SUPERADMIN']) continue;
			if ($puser[0]==$eu) {
				$obj_perms=$puser[1];
				$sel_user=array($puser[0]);
			}
			foreach ($av_perms as $perm=>$num) {
				if ($puser[1]==$num || (isset($convert_perms[$puser[1]]) && $convert_perms[$puser[1]]==$num)) {
					$t->assign('IMG_SIGN',$img_signed);
				} else {
					$t->assign('IMG_SIGN','&nbsp;');
				}
				$t->parse('ROW',"sign_$perm");
			}
			if (!$all_users[$puser[0]]) {
				$tmp=$frm->getFullName($puser[0],0,1);
				$all_users[$puser[0]]=$tmp[$puser[0]];
			}
			$t->assign('P_USER',$all_users[$puser[0]]);
			$t->assign('P_DHREF',$L_THIS."&du=".$puser[0]);
			$t->assign('P_EHREF',$L_THIS."&eu=".$puser[0]);
			$t->parse("ROW",".uperms");
			$i++;
		}
		$t->parse("ROW","user_perms");

		$Groups=explode('|',$Field['Groups']);
		$i=0;
		foreach ($Groups as $val) {
			if (empty($val)) continue;
			$pgroup=explode(',',$val);
			if ($pgroup[0]==$eg) {
					$obj_perms=$pgroup[1];
					$sel_group=$pgroup[0];
			}
			foreach ($av_perms as $perm=>$num) {
				if ($pgroup[1]==$num || (isset($convert_perms[$pgroup[1]]) && $convert_perms[$pgroup[1]]==$num)) {
					$t->assign('IMG_SIGN',$img_signed);
				} else {
					$t->assign('IMG_SIGN','&nbsp;');
				}
						$t->parse('ROW',"gsign_$perm");
			}
			$t->assign('P_USER',$frm->getCachedGroupName($pgroup[0]));
			$t->assign('P_DHREF',$L_THIS."&dg=".$pgroup[0]);
			$t->assign('P_EHREF',$L_THIS."&eg=".$pgroup[0]);
			$t->parse("ROW",".gperms");
			$i++;
		}
		$t->parse("ROW","group_perms");

		$rad_perms=new RadioButton('obj_perms','class=sel',1);
		foreach ($av_perms as $key=>$val) {
			$t->assign("PERMS_F",$rad_perms->f($val));
			$t->parse('ROW','.av_perms_'.$key);
		}
		$sel_sel_group=new SelectField("sel_group",'class="sel" style="width:250px;"',$groups_array);
		$t->assign("GROUPS_F",$sel_sel_group->f());

		$sel_sel_user=new SelectField("sel_user",'class="sel" size="5" id="sel_user" style="width:250px;"',$users_array,"",1);
		$t->assign("USERS_F",$sel_sel_user->f());
		if ($CFG['USER_LIST']) {
			$link="js_user.php?modul=addr&form=daten&field=sel_user&mult=1";
			$t->assign('JS_USER_U',"NewWindow('$link','User',".$CFG['userwidth'].','.$CFG['userheight'].",0)");
		} else $t->assign('JS_USER_U','');


		$rule_users=$frm->getRuleUsers('addr');
		if (is_array($rule_users)) {
			foreach($rule_users as $key=>$val) {
				foreach ($val as $num=>$id) {
					if (!$all_users[$id]) {
						$tmp=$frm->getFullName($id);
						$all_users[$id]=$tmp[$id];
					}
					$t->assign('OWNER_NAME',$all_users[$id]);
					$t->assign('OWNER_NUM',$num+1);
					$t->parse('ROW','.rule_row_'.$key);
				}
				$t->parse('ROW','rule_'.$key);
			}
		}
		$t->parse('ROW','perms_content');
	}
	$t->parse('ROW','update');
	$t->assign('L_BREAK',"index.php?site=$site&ac=$ac");
	$t->parse('ROW','break');
	$t->parse('ROW','meta_content');
	if ($FieldID && ($Field['Typ']=='select' || $Field['Typ']=='mselect')) {
		if ($SelID) {
			$t->assign('FIELD_NAME',Framework::entities($Select['Name_'.$session_lang]));
			$t->parse('ROW','title_edit_s');
			$t->assign('L_BREAK_S',"index.php?site=$site&ac=$ac&mode=$mode&FieldID=".$FieldID);
			$t->parse('ROW','break_s');
		} else {
			$t->parse('ROW','title_new_s');
		}

		$tmp_name=$Select['Name_'.$session_lang];
		if (!isset($save_s_x)) $ObjLang_s=1;
		$lang_array=$CFG['MA_LANG'];
		foreach ($lang_array as $val) {
			if ($val==$session_lang) {
				$txt_title=new TextField("ObjTitle_s_$val",'size="30" class="sel" style="width:300px"','0','%',$Select['Name_'.$val]);
				$t->assign('OBJ_TITLE_S',$txt_title->f());
				$t->assign('OBJ_TITLE_LANG_S',strtoupper($val));
				if ($ActionError['fields']["ObjTitle_s_$val"]) {
					$t->assign('C_TITLE_S','error');
				} else {
					$t->assign('C_TITLE_S','');
				}
				$t->assign('FOCUS_FIELD',"ObjTitle_s_$val");
			} else {
				$txt_title=new TextField("ObjTitle_s_$val",'size="30" class="sel" style="width:300px" onChange="document.daten.ObjLang_s.checked=0;" onKeyDown="document.daten.ObjLang_s.checked=0;"','0','%',$Select['Name_'.$val]);
				if ($_POST["ObjTitle_s_$val"] && $_POST["ObjTitle_s_$val"]!=$tmp_name) $ObjLang_s=0;
				if ($Select['Name_'.$val] && $Select['Name_'.$val]!=$tmp_name) $ObjLang_s=0;
				$t->assign('OBJ_TITLE_A_S',$txt_title->f());
				$t->assign('OBJ_TITLE_LANG_A_S',strtoupper($val));
				if ($ActionError['fields']["ObjTitle_s_$val"]) {
					$t->assign('C_TITLE_A_S','error');
				} else {
					$t->assign('C_TITLE_A_S','');
				}
				$t->parse('ROW','.obj_lang_s');
			}
		}
		if (count($lang_array)>1) {
			$chk_lang=new CheckBox('ObjLang_s','',1);
			$t->assign('CHK_OBJ_LANG_S',$chk_lang->f());
			$t->parse('ROW','obj_lang_one_s');
		}

		$t->parse('ROW','update_s');

		$img_up="<img src=\"img/$THEME/rs_up.gif\" width=\"11\" height=\"11\" hspace=\"0\" border=\"0\" />";
		$img_down="<img src=\"img/$THEME/rs_down.gif\" width=\"11\" height=\"11\" hspace=\"3\" border=\"0\" />";
		$img_top="<img src=\"img/$THEME/rs_top.gif\" width=\"11\" height=\"11\" hspace=\"3\" border=\"0\" />";
		$all_selects=$Addr->listAddrSelect($FieldID);
		if (is_array($all_selects)) {
			$i=0;
			$num_entrys=count($all_selects);
			foreach ($all_selects as $key=>$val) {
				$t->assign('LIST_LINK',"index.php?site=$site&ac=$ac&mode=$mode&FieldID=".$FieldID."&SelID=".urlencode($key));
				$t->assign('LIST_DELETE',"$L_THIS&DSelID=".urlencode($key));
				$t->assign('LIST_NAME',Framework::entities($val));
				if ($i>0) {
					$t->assign('IMG_UP',"<a href=\"$L_THIS&ue=".$key."\">$img_up</a>");
					$t->assign('IMG_TOP',"<a href=\"$L_THIS&fe=".$key."\">$img_top</a>");
				} else {
					$t->assign('IMG_UP',$img_up);
					$t->assign('IMG_TOP',$img_top);
				}
				if ($i<$num_entrys) {
					$t->assign('IMG_DOWN',"<a href=\"$L_THIS&de=".$key."\">$img_down</a>");
				} else {
					$t->assign('IMG_DOWN',$img_down);
				}
				if ($key==$SelID) {
					$t->assign('ROW_COLOR',$fg10color);
				} elseif ($i%2) {
					$t->assign('ROW_COLOR','#f2f2f2');
				} else {
					$t->assign('ROW_COLOR',$bgcolor);
				}
				$t->parse('ROW','.list_row_s');
				$i++;
			}
		}
		$t->parse('ROW','select_content');
	}

} else {
	$img_up="<img src=\"img/$THEME/rs_up.gif\" width=\"11\" height=\"11\" hspace=\"0\" border=\"0\" />";
	$img_down="<img src=\"img/$THEME/rs_down.gif\" width=\"11\" height=\"11\" hspace=\"3\" border=\"0\" />";
	$img_top="<img src=\"img/$THEME/rs_top.gif\" width=\"11\" height=\"11\" hspace=\"3\" border=\"0\" />";
	$L_THIS="index.php?site=$site&ac=$ac&mode=$mode";
	$all_fields=$Addr->listAddrUserFields();
	if (is_array($all_fields)) {
		$i=0;
		$num_entrys=count($all_fields);
		foreach ($all_fields as $key=>$val) {
			$t->assign('LIST_LINK',"index.php?site=$site&ac=$ac&mode=edit&FieldID=".urlencode($key));
			$t->assign('LIST_NAME',Framework::entities($val['Title']));
			$t->assign('LIST_REFID',Framework::entities($val['RefID']));
			if ($i>0) {
				$t->assign('IMG_UP',"<a href=\"$L_THIS&ue=".$key."\">$img_up</a>");
				$t->assign('IMG_TOP',"<a href=\"$L_THIS&fe=".$key."\">$img_top</a>");
			} else {
				$t->assign('IMG_UP',$img_up);
				$t->assign('IMG_TOP',$img_top);
			}
			if ($i<$num_entrys) {
				$t->assign('IMG_DOWN',"<a href=\"$L_THIS&de=".$key."\">$img_down</a>");
			} else {
				$t->assign('IMG_DOWN',$img_down);
			}
			if ($val['Typ']=='title') {
				$t->assign('ROW_CLASS','list_s');
			} elseif ($i%2) {
				$t->assign('ROW_CLASS','list_h');
			} else {
				$t->assign('ROW_CLASS','list_l');
			}
			if ($val['Aktiv']) {
				$t->assign('LIST_AKTIV','X');
			} else {
				$t->assign('LIST_AKTIV','');
			}
			if ($val['F_Required']) {
				$t->assign('LIST_REQUIRED','X');
			} else {
				$t->assign('LIST_REQUIRED','');
			}
			$t->parse('ROW','ltyp_'.$val['Typ']);
			$t->parse('ROW','.list_row');
			$t->clear_dynamic('ltyp_'.$val['Typ']);
			$i++;
		}
	}
	$t->parse('ROW','list_content');
}

$AdminGui->setFormAction($L_THIS);
?>