<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->unload('tpl_error');
$t->define (array('tpl_error' => "admin_error.inc.html"));
if (isset($ActionError['fields'])) {
	$t->parse('ROW','error_fields');
	$E->setErrorMsg('fields',$t->getParsed());
	$E->setError('fields');
}
if (isset($ActionError['medel'])) {
	$t->parse('ROW','error_medel');
	$E->setErrorMsg('medel',$t->getParsed());
	$E->setError('medel');
}
if (isset($ActionError['udel'])) {
	$t->parse('ROW','error_udel');
	$E->setErrorMsg('udel',$t->getParsed());
	$E->setError('udel');
}
if (isset($ActionError['userlen'])) {
	$t->assign('ERROR_MSG',Framework::entities($ActionError['userlen']));
	$t->parse('ROW','error_userlen');
	$E->setErrorMsg('userlen',$t->getParsed());
	$E->setError('userlen');
}
if (isset($ActionError['passwlen'])) {
	$t->assign('ERROR_MSG',$ActionError['passwlen']);
	$t->parse('ROW','error_passwd');
	$E->setErrorMsg('passwlen',$t->getParsed());
	$E->setError('passwlen');
}
if (isset($ActionError['username'])) {
	$t->assign('ERROR_MSG',$ActionError['username']);
	$t->parse('ROW','error_username');
	$E->setErrorMsg('username',$t->getParsed());
	$E->setError('username');
}
if (isset($ActionError['mailuser'])) {
	$t->assign('ERROR_MSG',$ActionError['mailuser']);
	$t->parse('ROW','error_mailuser');
	$E->setErrorMsg('mailuser',$t->getParsed());
	$E->setError('mailuser');
}
if (isset($ActionError['acl'])) {
	$t->assign('ERROR_MSG',$ActionError['acl']);
	$t->parse('ROW','error_acl');
	$E->setErrorMsg('acl',$t->getParsed());
	$E->setError('acl');
}
if (isset($ActionError['size'])) {
	$t->assign('ERROR_MSG',$ActionError['size']);
	$t->parse('ROW','error_size');
	$E->setErrorMsg('size',$t->getParsed());
	$E->setError('size');
}
if (isset($ActionError['i_password'])) {
	$t->assign('ERROR_MSG',Framework::entities(implode(',',array_unique($ActionError['i_password']))));
	$t->parse('ROW','error_ipassword');
	$E->setErrorMsg('i_password',$t->getParsed());
	$E->setError('i_password');
}
if (isset($ActionError['i_username'])) {
	$t->assign('ERROR_MSG',Framework::entities(implode(',',array_unique($ActionError['i_username']))));
	$t->parse('ROW','error_iusername');
	$E->setErrorMsg('i_username',$t->getParsed());
	$E->setError('i_username');
}
if (isset($ActionError['i_fields'])) {
	$t->assign('ERROR_MSG',Framework::entities(implode(',',array_unique($ActionError['i_fields']))));
	$t->parse('ROW','error_ifields');
	$E->setErrorMsg('i_fields',$t->getParsed());
	$E->setError('i_fields');
}
if (isset($ActionError['i_userlen'])) {
	$t->assign('ERROR_MSG',Framework::entities(implode(',',array_unique($ActionError['i_userlen']))));
	$t->parse('ROW','error_iuserlen');
	$E->setErrorMsg('i_userlen',$t->getParsed());
	$E->setError('i_userlen');
}
if (isset($ActionError['i_mail'])) {
	$t->assign('ERROR_MSG',Framework::entities(implode(',',array_unique($ActionError['i_mail']))));
	$t->parse('ROW','error_imail');
	$E->setErrorMsg('i_mail',$t->getParsed());
	$E->setError('i_mail');
}
if (isset($ActionError['import'])) {
	$t->assign('ERROR_MSG',$ActionError['import']);
	$t->parse('ROW','error_import');
	$E->setErrorMsg('import',$t->getParsed());
	$E->setError('import');
}
if (isset($ActionError['csv'])) {
	$t->parse('ROW','error_csv');
	$E->setErrorMsg('csv',$t->getParsed());
	$E->setError('csv');
}
if (isset($ActionError['del_done'])) {
	$t->assign('ERROR_MSG',$ActionError['del_done']);
	$t->parse('ROW','error_del_done');
	$E->setErrorMsg('del_done',$t->getParsed());
	$E->setError('del_done');
}
if (isset($ActionError['server'])) {
	if (is_array($ActionError['server'])) {
		$t->assign('ERROR_MSG',nl2br(implode("\n\n",Framework::entities($ActionError['server']))));
	} else {
		$t->assign('ERROR_MSG',nl2br(Framework::entities($ActionError['server'])));
	}
	$t->parse('ROW','error_server');
	$E->setErrorMsg('server',$t->getParsed());
	$E->setError('server');
}
?>