<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
//phpinfo();
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
function setAjaxData($ajax_type,$ajax_id,$ajax_data) {
	global $t;
	$t->assign('AJAX_TYPE',$ajax_type);
	$t->assign('AJAX_ID',$ajax_id);
	$t->clear_dynamic('ajax_entries_data');
	$lenght=3000;
	$i=0;
	$data_len=mb_strlen($ajax_data,GE_CHARSET);
	while ($i<$data_len) {
		$t->assign('AJAX_DATA',mb_substr($ajax_data,$i,$lenght,GE_CHARSET));
		$t->parse('ROW','.ajax_entries_data');
		$i+=$lenght;
	}
	$t->parse('ROW','.ajax_entries');
}
$t->setRoot("tpl/$THEME");
$t->define (array('content' => "core/ajax.inc.html"));
$t->assign('CHARSET',GE_CHARSET);
$user_id=$auth->auth['uid'];
if ($frm->getUserStatus()!=1) {
	$frm->insertUserMsg(0,'',0,time());
}
$T->loadModul('core');
if ($frm->appExists('proj')) {
	$T->loadModul('proj');
	$T->loadModulSql('proj_rule');
}
function toIso($value) {
	if (is_array($value)) {
		foreach ($value as $key=>$val) {
			$value[$key]=toIso($val);
		}
	} else {
		if (Framework::isUtf8($value)) {
			$value=Framework::convertCharset($value,'UTF-8',GE_CHARSET);
		}
	}
	return $value;
}
if (GE_CHARSET!='UTF-8') {
	$_GET=toIso($_GET);
	$_POST=toIso($_POST);
}

switch (FrameWork::getParam('ajax_modul','')) {
	case 'admin_user_search':
		require("lib/class_form.inc.php");
		require_once('lib/classAdminGUI.php');
		$AdminGUI=new AdminGUI();
		setAjaxData('html',$obj_id,$AdminGUI->show('list',true));
	break;
	case 'mail_hlist':
		require('mail/ajax_ttip_mail.php');
	break;
	case 'cronJobs':
		$open_win=false;
		require('lib/class_CronJobs.php');
		$cronJob=new CronJobs();
		$jobs=$cronJob->getJobs();
		foreach ($jobs as $job) {
			if ($job['cronApp'] && !$app[$job['cronApp']]) continue;
			switch ($job['cronName']) {
				case 'newMail':
					if ($frm->getPrefs('email','msg')) {
						require('mail/ajax_new_mail.php');
					}
				break;
				case 'newMsg':
					if ($frm->getPrefs('global','mse')) {
						require('msg/ajax_new_notes.php');
					}
				break;
				case 'cronCalendar':
					require('lib/cal/cron_alarm.php');
				break;
				case 'sendInfoEsc':
					if ($cronJob->isToExecute($job,0)) {
						$Imng=& $frm->getStaticModul('imng');
						$search=array(
							'MaxEscalationEnd'=>mktime(0,0,0),
							'EscalationSend'=>-1,
						);
						$rows=0;
						$entrys=$Imng->searchEscalationObj($rows,$search);
						if ($rows) {
							$sendUser=array();
							$rUsers=$frm->getRuleUsers('imng');
							if (is_array($rUsers['imng'])) {
								$sendUser=array();
								foreach($rUsers['imng'] as $ukey) {
									$uLang=$frm->getPrefs('global','lang',$ukey);
									if (!$uLang) $uLang='en';
									$sendUser[$uLang][]=$ukey;
								}
								foreach($sendUser as $lang=>$send_to)  {
									$T->setLang($lang);
									$T->loadModul('imng');
									$subject=$T->lang('[[Bestaetigungszeit abgelaufen]]');
									$body=$T->lang('[[Bei folgendem Dokument ist die Bestatigungszeit abgelaufen]]');
									foreach ($entrys as $dVal) {
										$link="?site=imng.php&action=esc_v&oid=".$dVal->getID();
										$link_title=$dVal->getMeta('Title_'.$lang);
										foreach ($send_to as $ukey) {
											$frm->sendmessage(array($ukey),$ukey,$subject,$body,$link,$link_title,'msg_3.gif');
										}
									}
								}
								foreach ($entrys as $dVal) {
									$dVal->setMeta('EscalationSend',time());
									$Imng->updateMeta($dVal);
								}
								$T->setLang($frm->getLang());
							}
						}
						//debug('DDD');
						$cronJob->insertExecute($job,0);
					}
				break;
				case 'cleanMails':
					$monthArray=array(1=>"Jan",2=>"Feb",3=>"Mar",4=>"Apr",5=>"May",6=>"Jun",7=>"Jul",8=>"Aug",9=>"Sep",10=>"Oct",11=>"Nov",12=>"Dec");
					if ($cronJob->isToExecute($job,$frm->getUser())) {
						$jobOK=false;
						$Mail=& $frm->getStaticModul('mail');
						$Mail->init($auth->auth['uid']);
						if($Mail->isOpen()) {
							$days=$frm->getPrefs('email','cron/trash');
							if ($days) {
								$box_obj=$Mail->getObj($Mail->getTrashID(),false);
								if (is_object($box_obj)) {
									$date=mktime(0,0,0,date('m'),date('d')-$days,date('Y'));
									$criteria='BEFORE '.date('j',$date).'-'.$monthArray[date('n',$date)].'-'.date('Y',$date);
									//debug($criteria);
									$delUids=$Mail->searchMails($box_obj->getBox(),$criteria);
									if (is_array($delUids) && !empty($delUids)) {
										$Mail->deleteMail($box_obj->getBox(),implode(',',$delUids));
										$Mail->expungeBox($box_obj->getBox());
									}
								}
								$jobOK=true;
							}
							$days=$frm->getPrefs('email','cron/sent');
							if ($days) {
								$box_obj=$Mail->getObj($Mail->getSentID(),false);
								if (is_object($box_obj)) {
									$date=mktime(0,0,0,date('m'),date('d')-$days,date('Y'));
									$criteria='BEFORE '.date('j',$date).'-'.$monthArray[date('n',$date)].'-'.date('Y',$date);
									//debug($criteria);
									$delUids=$Mail->searchMails($box_obj->getBox(),$criteria);
									if (is_array($delUids) && !empty($delUids)) {
										$Mail->deleteMail($box_obj->getBox(),implode(',',$delUids));
										$Mail->expungeBox($box_obj->getBox());
									}
								}
								$jobOK=true;
							}
							$days=$frm->getPrefs('email','cron/spam');
							if ($days && $Mail->getCfg('cfg/spam/enable')) {
								$box_obj=$Mail->getObj($Mail->getSpamID(),false);
								if (is_object($box_obj)) {
									$date=mktime(0,0,0,date('m'),date('d')-$days,date('Y'));
									$criteria='BEFORE '.date('j',$date).'-'.$monthArray[date('n',$date)].'-'.date('Y',$date);
									//debug($criteria);
									$delUids=$Mail->searchMails($box_obj->getBox(),$criteria);
									if (is_array($delUids) && !empty($delUids)) {
										$Mail->deleteMail($box_obj->getBox(),implode(',',$delUids));
										$Mail->expungeBox($box_obj->getBox());
									}
								}
								$jobOK=true;
							}
							$days=$Mail->getCfg('cfg/user/readonly_del');
							if ($days && $Mail->getReadOnlyID()) {
								$box_obj=$Mail->getObj($Mail->getReadOnlyID(),false);
								if (is_object($box_obj)) {
									$date=mktime(0,0,0,date('m'),date('d')-$days,date('Y'));
									$delUids=$Mail->searchMails($box_obj->getBox(),$criteria);
									if (is_array($delUids) && !empty($delUids)) {
										$CyrAdm=& $frm->getStaticModul('mail_adm');
										if ($CyrAdm->imap_login()) {
											$aclBox=str_replace('INBOX','user'.$Mail->getCfg('cfg/delim').$Mail->getUserName(),$box_obj->getBox());
											$CyrAdm->setacl($aclBox,$Mail->getUserName(),'lrswipcd');
											$Mail->close();
											$Mail->open();
											$Mail->deleteMail($box_obj->getBox(),implode(',',$delUids));
											//debug($Mail->getError());
											$Mail->expungeBox($box_obj->getBox());
											$CyrAdm->setacl($aclBox,$Mail->getUserName(),'lrsip');
										}
									}
								}
								$jobOK=true;
							}

						}
						if ($jobOK) $cronJob->insertExecute($job,$frm->getUser());
					}
			}
		}
		if ($open_win) {
			setAjaxData('window','new_mail','mail_notify.php');
		}
	break;
	case 'showMail':
		require('mail/ajax_show_mail.php');
	break;
	case 'cal_users':
		require_once('lib/classUserGUI.php');
		$rows=0;
		$data=array();
		$av_userIds=array_keys($frm->getApplicationUsers('cal'));
		$app_users=$frm->searchUser($rows,$fieldVal,$av_userIds,0,0,4,false,true);
		if (is_array($app_users)) {
			foreach ($app_users as $key=>$val) {
				$data[$key]=$val['lastname'].' '.$val['firstname'];
			}
		}
		setAjaxData('html_tip',$layID,UserGUI::showTtipList($fieldID,$data));
	break;
	case 'ajaxTip':
		require('lib/class_FormGui.php');
		$Gui=new FormGui();
		$search=Framework::getParam('fieldVal');
		//setAjaxData('alert','ajax_ttip_'.Framework::getParam('fieldID'),Framework::getParam('tipMode').'-'.Framework::getParam('fieldVal').'-'.base64_decode(Framework::getParam('tipParams')));
		setAjaxData('html_tip','ajax_ttip_'.Framework::getParam('fieldID'),$Gui->parseTipList(Framework::getParam('fieldID'),$search,Framework::getParam('tipMode'),Framework::getParam('tipApp'),Framework::getParam('tipParams'),Framework::getParam('tipLimit'),Framework::getParam('jsSetFunction')));
	break;
	case 'ajaxTipSet':
		require('lib/class_FormGui.php');
		$Gui=new FormGui();
		$tipVal=Framework::getParam('tipVal','');
		$params=array(
			'mode'=>Framework::getParam('tipMode'),
			'params'=>Framework::getParam('tipParams'),
		);
		$tipParams=unserialize(base64_decode(Framework::getParam('tipParams')));
		if ($tipParams['IgnoreUid']) $ignore='u_'.$tipParams['IgnoreUid']; else $ignore='';
		if (trim($tipVal)) $tipArray=explode('|',$tipVal); else $tipArray=array();

		if (Framework::getParam('addKey')) {
			if (!in_array(Framework::getParam('addKey'),$tipArray) && Framework::getParam('addKey')!=$ignore) {
				if ($tipParams['MaxEntries'] && count($tipArray)>=$tipParams['MaxEntries']) {
					array_shift($tipArray);
				}
				$tipArray[]=Framework::getParam('addKey');
				$tipVal=implode('|',$tipArray);
			}
		}
		if (Framework::getParam('delKey')) {
			if (Framework::getParam('delKey')=='ALL') {
				$tipVal='';
			} else {
				//debug($tipArray);
				if (in_array(Framework::getParam('delKey'),$tipArray)) {
					$key=array_search(Framework::getParam('delKey'),$tipArray);
					unset($tipArray[$key]);
					$tipVal=implode('|',$tipArray);
				}
			}
		}
		//setAjaxData('alert','ajax_list_'.Framework::getParam('fieldID'),Framework::getParam('tipParams'));
		setAjaxData('html','ajax_list_'.Framework::getParam('fieldID'),$Gui->parseAjaxList(Framework::getParam('fieldID'),$tipVal,$params,true));
		setAjaxData('setVal','hid_'.Framework::getParam('fieldID'),$tipVal);
		setAjaxData('setVal',Framework::getParam('fieldID'),'');
		if ($tipParams['onChange']) {
			setAjaxData('eval',Framework::getParam('fieldID'),$tipParams['onChange']);
		}


	break;
	case 'UserGUI':
		require_once('lib/classUserGUI.php');
		switch ($show) {
			case 'showUserList':
				if (trim(${'value_'.$ID})) {
					$akt_users=explode(',',trim(${'value_'.$ID}));
				} else {
					$akt_users=array();
				}
				if ($addUser) {
					$data=UserGUI::showUserList($ID,$akt_users,'add',array($addUser));
				} elseif ($delUser) {
					$data=UserGUI::showUserList($ID,$akt_users,'del',array($delUser));
				} else {
					$data=UserGUI::showUserList($ID,$akt_users,'list');
				}
				setAjaxData('setVal','value_'.$ID,implode(',',$akt_users));
				setAjaxData('html','list_'.$ID,$data);
			break;
		}
	break;
	case 'mail_sign':
		if (Framework::getParam('use_m_wysiwyg')) {
			if ($frm->getPrefs('email',"use".Framework::getParam('fieldVal'))) {
				$signatur=$frm->getPrefs('email',"signatur_html".Framework::getParam('fieldVal'));
				if (!strlen($signatur)) {
					$signatur=nl2br($frm->getPrefs('email',"signatur".Framework::getParam('fieldVal')).$CFG['NL_MAIL']);
				} else {
					$relImgPath=Framework::getSelfDir().'/fetch_mail_img.php?img=htmlImg/';
					$signatur=preg_replace('/(src="?)[^ ]+\/htmlImg\/(.+\.(jpg|gif|jpeg|png))/i','\\1'.$relImgPath.'\\2',$signatur);
				}
				//ajaxLog($signatur);
				setAjaxData('setVal',Framework::getParam('fieldID'),$signatur);
				setAjaxData('eval',Framework::getParam('fieldID'),'setNewSign()');
			} else {
				setAjaxData('setVal',Framework::getParam('fieldID'),'');
				setAjaxData('eval',Framework::getParam('fieldID'),'setNewSign()');
			}
		} else {
			$mailData=array();
			parse_str(Framework::getParam('mailFormData'),$mailData);
			if (GE_CHARSET!='UTF-8') {
				$mailData=toIso($mailData);
			}
			if ($frm->getPrefs('email',"use".$mailData['oldSign'])) {
				$old_signatur=$frm->getPrefs('email',"signatur".$mailData['oldSign']);
			} else {
				$old_signatur='';
			}
			if ($frm->getPrefs('email',"use".$mailData['identity'])) {
				$new_signatur=$frm->getPrefs('email',"signatur".$mailData['identity']);
			} else {
				$new_signatur='';
			}
			Framework::convertLineEndings($old_signatur,"\n");
			Framework::convertLineEndings($new_signatur,"\n");
			Framework::convertLineEndings($mailData[Framework::getParam('fieldID')],"\n");

			//debug($mailData[Framework::getParam('fieldID')]);
			//debug($old_signatur);
			//debug($new_signatur);

			if (!trim($old_signatur)) {
				$newBody.=$mailData[Framework::getParam('fieldID')]."\n\n".$new_signatur;
			} else {
				$newBody=preg_replace ('/'.preg_quote($old_signatur,'/').'/',$new_signatur,$mailData[Framework::getParam('fieldID')],1);
			}
			//debug($newBody);
			setAjaxData('setVal','mail_body',$newBody);
			setAjaxData('setVal','spellChecker01',$newBody);
			setAjaxData('setVal','oldSign',$mailData['identity']);
		}
	break;
	case 'portal_sort':
		if ($sortID) {
			$sotNum=substr($sortID,2,1);
			if (is_array($_POST[$sortID])) {
				$frm->insertPrefs('portal',array('frame_'.$sotNum=>implode(',',$_POST[$sortID])));
				//setAjaxData('alert',$sortID,"SET frame_$sotNum TO ".implode(',',$_POST[$sortID]));
			} else {
				$frm->insertPrefs('portal',array('frame_'.$sotNum=>''));
				//setAjaxData('alert',$sortID,"SET frame_$sotNum TO ''");
			}
		}

	break;
	case 'portal_toggle':
		if ($_POST['WinID']) {
			$old_val=$frm->getPrefs('portal',$_POST['WinID']);
			$new_val=($old_val=='none'?'':'none');
			$frm->insertPrefs('portal',array($_POST['WinID']=>$new_val));
		}
	break;
	case 'portal_swidth':
		if (is_array($_POST['tdWidth'])) {
			$frm->insertPrefs('portal',array('tdWidth'=>implode(',',$_POST['tdWidth'])));
			//setAjaxData('alert','portal',"SET tdWidth TO ".implode(',',$_POST[tdWidth]));
		}
	break;
	case 'changeBox':
		if ($tabID && $boxID){
			$tmp=explode('|',$boxID);
			$frm->insertPrefs($tmp[0],array($tmp[1]=>$tabID));
		}
	break;
	case 'setPrefs':
		if (Framework::getParam('prefModul') && Framework::getParam('prefKey')){
			$frm->insertPrefs(Framework::getParam('prefModul'),array(Framework::getParam('prefKey')=>Framework::getParam('prefVal')));
		}
	break;
	case 'zef_prjsearch':
		require_once('lib/zef/class_zefProjectGui.php');
		$link=parse_url(Framework::getParam('Link'));
		if ($link['query']) {
			$query=array();
			parse_str($link['query'],$query);
			$L->setParam($query);
		}
		$L->setParam('b',0);
		$L->setParam('zef_prjsearch',Framework::getParam('zef_prjsearch'));
		$zefGui=new zefProjectGui();
		$resGui=$zefGui->showProjectList(array('info'=>Framework::getParam('zef_prjsearch')));
		setAjaxData('html',Framework::getParam('fieldID'),$resGui->process());
	break;
	case 'zef_menu':
		require_once('lib/zef/class_zefMenuGui.php');
		$zefMenu=new zefMenuGui();
		setAjaxData('html',Framework::getParam('fieldID'),$zefMenu->process());
	break;
	case 'proj_search':
		require_once('lib/proj/class_ProjectAdminGui.php');
		$link=parse_url(Framework::getParam('Link'));
		if ($link['query']) {
			$query=array();
			parse_str($link['query'],$query);
			$L->setParam($query);
		}
		$L->setParam('b',0);
		$Gui=new ProjectAdminGui();
		$search=array('info'=>Framework::getParam('proj_search'));
		if ($query['trash']) {
			$search['trash']=1;
		}
		$resGui=$Gui->showProjectList($search);
		setAjaxData('html',Framework::getParam('fieldID'),$resGui->process());
		//setAjaxData('html',Framework::getParam('fieldID'),print_r($query,true));
	break;
	case 'proj_my_search':
		require_once('lib/proj/class_ProjectGui.php');
		$link=parse_url(Framework::getParam('Link'));
		if ($link['query']) {
			$query=array();
			parse_str($link['query'],$query);
			$L->setParam($query);
		}
		$L->setParam('b',0);
		$Gui=new ProjectGui();
		$search=array('Info'=>Framework::getParam('proj_my_search'));
		$resGui=$Gui->processProjectContentAjax($search);
		setAjaxData('setVal','daten',$L->getTempLink());
		setAjaxData('html',Framework::getParam('fieldID'),$resGui->process());
		//setAjaxData('html',Framework::getParam('fieldID'),print_r($query,true));
	break;
	case 'calEdit':
		require_once('lib/cal/class_EventEditGui.php');
		$contGui=new EventEditGui();
		$contGui->handleEditRequest();
		$show_tab=explode(',',Framework::getParam('show'));
		if (in_array('evt_meta',$show_tab)) {
			$Cont=$contGui->getEventMetaGui();
			if (is_object($Cont)) {
				setAjaxData('html','evt_meta',$Cont->process());
			} else {
				setAjaxData('html','evt_meta','&nbsp;');
			}
		}
		if (in_array('evt_invit',$show_tab)) {
			$Cont=$contGui->getEventInvitGui();
			if (is_object($Cont)) {
				setAjaxData('html','evt_invit',$Cont->process());
			} else {
				setAjaxData('html','evt_invit','&nbsp;');
			}
		}
		if (in_array('evt_grant',$show_tab)) {
			$Cont=$contGui->getEventGrantGui();
			if (is_object($Cont)) {
				setAjaxData('html','evt_grant',$Cont->process());
			} else {
				setAjaxData('html','evt_grant','&nbsp;');
			}
		}
		if (in_array('evt_fmng',$show_tab)) {
			$Cont=$contGui->getEventFmngGui();
			if (is_object($Cont)) {
				setAjaxData('html','evt_fmng',$Cont->process());
			} else {
				setAjaxData('html','evt_fmng','&nbsp;');
			}
		}
	break;
	case 'taskEdit':
		require_once('lib/task/class_TaskEditGui.php');
		$contGui=new TaskEditGui();
		$contGui->handleEditRequest();
		$show_tab=explode(',',Framework::getParam('show'));
		if (in_array('task_meta',$show_tab)) {
			$Cont=$contGui->getMetaGui();
			if (is_object($Cont)) {
				setAjaxData('html','task_meta',$Cont->process());
			} else {
				setAjaxData('html','task_meta','&nbsp;');
			}
		}
		if (in_array('task_invit',$show_tab)) {
			$Cont=$contGui->getInvitGui();
			if (is_object($Cont)) {
				setAjaxData('html','task_invit',$Cont->process());
			} else {
				setAjaxData('html','task_invit','&nbsp;');
			}
		}
	break;
	case 'setMailColor':
		$ModClass=& $frm->getStaticModul('mail');
		$ModClass->init($MACC_ID);
		if($ModClass->isOpen() && Framework::getParam('MailID')) {
			$temp=explode('||',Framework::getParam('MailID'));
			$Mobj=$ModClass->getMailObj($temp[0],$temp[1]);
			if (is_object($Mobj)) {
				if (!Framework::getParam('MailColor')) {
					$ModClass->deleteMailColor($Mobj->getMeta('Md5Id'));
					$ModClass->clearFlag($temp[0],$Mobj->getID(),"\\Flagged");
				} else {
					$ModClass->setMailColor($Mobj->getMeta('Md5Id'),Framework::getParam('MailColor'));
					$ModClass->setFlag($temp[0],$Mobj->getID(),"\\Flagged");
				}
			}
		}
	break;
	case 'setObjColor':
		if (Framework::getParam('modul') && Framework::getParam('id')) {
			switch(Framework::getParam('modul')) {
				case 'cal':
					if (!$CAL_USER || $CAL_USER=='info') {
						$uid=$frm->getUser();
					} else {
						$uid=$CAL_USER;
					}
				break;
				default:
					$uid=$frm->getUser();
				break;
			}
			if (!Framework::getParam('color') || Framework::getParam('color')=='transparent') {
				$frm->deleteObjColor(Framework::getParam('modul'),Framework::getParam('id'),$uid);
			} else {
				$frm->insertObjColor(Framework::getParam('modul'),Framework::getParam('id'),$uid,Framework::getParam('color'));
			}
		}
	break;
	case 'mail_img_upload':
		if (!empty($_FILES)) {
			$Mail=& $frm->getStaticModul('mail');
			$imgPath=$Mail->getAttachPath();
			if (!file_exists($imgPath)) {
				mkdir($imgPath,0700);
			}
			$relPath=Framework::getSelfDir().'/fetch_mail_img.php?img=';
			if ($_GET['isSign']) {
				$imgPath.='/htmlImg';
				if (!file_exists($imgPath)) {
					mkdir($imgPath,0700);
				}
				$relPath.='htmlImg/';
			}
			$file=Framework::getParam('upload','','F');
			if ($file['tmp_name'] && file_exists($file['tmp_name']) &&  $info=getimagesize($file['tmp_name'])) {
				$file['name']=preg_replace('/[^a-z0-9._-]/i','_',$file['name']);
				move_uploaded_file($file['tmp_name'],$imgPath.'/'.$file['name']);
				$url=$relPath.urlencode($file['name']);
				$msg='';
			} else {
				$url='';
				$msg=$T->Lang('[[ERROR_FILE]]');
			}
		}
		switch ($_GET['htmleditor']) {
			case 'tiny_mce':
				$output='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">';
				$output.='<html>';
				$output.='<head>';
				$output.='<meta http-equiv="Content-Type" content="text/html; charset="'.GE_CHARSET.'">';
				$output.='<title>Upload</title>';
				$output.='</head>';
				$output.='<body style="margin:0;padding:0;font-size:11px;font-family:Verdana,Arial,Helvetica,sans-serif;">';
				$output.='<form enctype="multipart/form-data" method="post">';
				$output.='<input type="file" id="upload" name="upload" style="width:300px;" value="" onchange="document.forms[0]-submit();" /> ';
				//$output.='<input type="submit" id="insert" name="insert" value="UPLOAD" />';
				$output.='</form>';
				if (!empty($_FILES)) {
					if ($msg) {
						$output.="<script>alert('$msg')</script>";
					} else {
						$output.="<script>setTimeout(\"window.parent.document.getElementById('src').value='".$url."'\", 200);</script>";
						$output.="<script>setTimeout(\"window.parent.ImageDialog.showPreviewImage('".$url."')\", 400)</script>";
					}
				}
				$output.='</body>';
				$output.='</html>';
			break;
			default:
				$output = '<html><body><script type="text/javascript">window.parent.CKEDITOR.tools.callFunction('.$_GET['CKEditorFuncNum'].', "'.$url.'","'.$msg.'");</script></body></html>';
			break;
		}
		echo $output;
		exit;
	break;
	case 'mail_save':
		if (Framework::getParam('mailFormData')) {
			$ModClass=& $frm->getStaticModul('mail');
			$mailData=array();
			parse_str(Framework::getParam('mailFormData'),$mailData);
			if (GE_CHARSET!='UTF-8') {
				$mailData=toIso($mailData);
			}
			$ModClass->saveEmail(array(
					'TO'=>$mailData['send_to'],
					'CC'=>$mailData['send_to_cc'],
					'BCC'=>$mailData['send_to_bcc'],
					'Subject'=>$mailData['subject'],
					'Body'=>$mailData['ajax_body']?$mailData['ajax_body']:$mailData['body'],
					'identity'=>$mailData['identity'],
					'copyto'=>trim($mailData['hid_FcopyTo'])?substr($mailData['hid_FcopyTo'],2):0,
					'read_confirm'=>$mailData['read_confirm'],
				)
			);
		}
	break;
	case 'mail_att_del':
		$ModClass=& $frm->getStaticModul('mail');
		$ModClass->init($MACC_ID);
		$delAtt=array();
		if (Framework::getParam('fileID') && ($Attachment=$ModClass->readEmailAttachment(Framework::getParam('fileID')))) {
			$delAtt[]=$Attachment;
		} elseif(Framework::getParam('fileName')) {
			$actAttachments=$ModClass->getEmailAttachments();
			foreach ($actAttachments as $key=>$Attachment) {
				if ($Attachment['Name']==Framework::getParam('fileName')) {
					$delAtt[]=$Attachment;
				}
			}
		}
		foreach($delAtt as $Attachment) {
			$ModClass->deleteEmailAttachments($Attachment['ID']);
			if (file_exists($ModClass->getAttachPath().'/'.$Attachment['Name'])) {
				@unlink($ModClass->getAttachPath().'/'.$Attachment['Name']);
			}
			if (file_exists($ModClass->getAttachPath().'/'.$Attachment['Name'].'.b64')) {
				@unlink($ModClass->getAttachPath().'/'.$Attachment['Name'].'.b64');
			}
			setAjaxData('eval','mail_att_del','deleteMailAttachmentSuccess('.$Attachment['ID'].',\''.Framework::escapeJs($Attachment['Name']).'\')');
		}
	break;
	case 'mail_att_upload':
		$status=array(
			'error'=>0,
			'files'=>array(),
		);
		if (!empty($_FILES)) {
			$ModClass=& $frm->getStaticModul('mail');
			$ModClass->init($MACC_ID);

			if (is_array($_FILES['userfile']['name'])) {
				for($i=0;$i<count($_FILES['userfile']['name']);++$i){
					$F_name=str_replace('/','_',$_FILES['userfile']['name'][$i]);
					if (!$frm->scanFile($_FILES['userfile']['tmp_name'][$i]) && move_uploaded_file($_FILES['userfile']['tmp_name'][$i], $ModClass->getAttachPath()."/".$F_name)) {
						$F_name=$_FILES['userfile']['name'][$i];
						$F_type=preg_replace('/;.*$/','',$_FILES['userfile']['type'][$i]);
						$F_size=$_FILES['userfile']['size'][$i];
						$res=$ModClass->addEmailAttachments(array('Name'=>$F_name,'Size'=>$F_size,'Type'=>$F_type));
						$status['files'][$_FILES['userfile']['name'][$i]]=array(
							'error'=>0,
							'id'=>$res['ID'],
							'name'=>$F_name,
							'type'=>$F_type,
							'size'=>$F_size,
						);
					} else {
						$status['files'][$_FILES['userfile']['name'][$i]]=array(
							'error'=>1,
							'errormessage'=>$_FILES['userfile']['error'][$i],
						);
					}
				}
			} else {
				if (!$frm->scanFile($_FILES['userfile']['tmp_name']) && move_uploaded_file($_FILES['userfile']['tmp_name'], $ModClass->getAttachPath()."/".$_FILES['userfile']['name'])) {
					$F_name=$_FILES['userfile']['name'];
					$F_type=preg_replace('/;.*$/','',$_FILES['userfile']['type']);
					$F_size=$_FILES['userfile']['size'];
					$ModClass->addEmailAttachments(array('Name'=>$F_name,'Size'=>$F_size,'Type'=>$F_type));
					$status['files'][$_FILES['userfile']['name']]=array(
						'error'=>0,
						'id'=>$res['ID'],
						'name'=>$F_name,
						'type'=>$F_type,
						'size'=>$F_size,
					);
				} else {
					$status['files'][$_FILES['userfile']['name']]=array(
						'error'=>1,
						'errormessage'=>$_FILES['userfile']['error'],
					);
				}
			}
			header('Content-Type: application/json');
			echo json_encode($status);
		}
		exit;
	break;	
	case 'mail_read_notify':
		$ModClass=& $frm->getStaticModul('mail');
		$ModClass->init($MACC_ID);
		if($ModClass->isOpen() && Framework::getParam('mid') && Framework::getParam('mbox')) {
			$Mobj=$ModClass->getMailObj(Framework::getParam('mbox'),Framework::getParam('mid'));
			if (is_object($Mobj)) {
				$FullHeader=$ModClass->parseFullHeader(Framework::getParam('mbox'),$Mobj->getID(),1);
				if ($FullHeader['disposition-notification-to']) {
					$T->loadModul('mail');
					$ModClass->setPrefs($frm->getPrefs('email'));
					$identity=Framework::getParam('identity');
					$personal=$ModClass->getPrefs("fullname".$identity);
					$mailbox=substr($ModClass->getPrefs("email".$identity),0,strpos($ModClass->getPrefs("email".$identity),'@'));
					$host=substr($ModClass->getPrefs("email".$identity),strpos($ModClass->getPrefs("email".$identity),'@')+1);

					$tras_array=array(
						'{ORIG_TO}'=>imap_rfc822_write_address($mailbox,$host,''),
						'{TO}'=>$FullHeader['disposition-notification-to'],
						'{SUBJECT}'=>$ModClass->mail_enc($Mobj->getName()),
						'{MAIL_DATE}'=>strftime("%A, %d.%m.%Y %H:%M",$Mobj->getMeta('Date')),
						'{ACTUAL_DATE}'=>strftime("%A, %d.%m.%Y %H:%M"),
						"\r"=>"\n",
					);
					$subject=strtr($T->lang('[[notify_subject]]'),$tras_array);
					$body=strtr($T->lang('[[notify_body]]'),$tras_array);
					$result_alert=strtr($T->lang('[[notify_alert]]'),$tras_array);

					require_once('lib/mail/mimePart.php');
					require_once('lib/mail/mime.php');
					$personal=$ModClass->getPrefs("fullname".$identity);
					$mailbox=substr($ModClass->getPrefs("email".$identity),0,strpos($ModClass->getPrefs("email".$identity),'@'));
					$host=substr($ModClass->getPrefs("email".$identity),strpos($ModClass->getPrefs("email".$identity),'@')+1);
					$smail=new Mail_mime($CFG['NL_MAIL']);
					$params=array(
						'text_encoding'=>'8bit',
						'html_charset'=>GE_CHARSET,
						'text_charset'=>GE_CHARSET,
						'head_charset'=>GE_CHARSET,
					);
					$headers=array(
						'From'=>imap_rfc822_write_address($mailbox,$host,$personal),
						'Subject'=>$subject?$subject:'no subject',
						'Cc'=>'',
						'Bcc'=>'',
						'Reply-To'=>'',
						'To'=>$FullHeader['disposition-notification-to'],
						'X-Priority'=>'3 (Normal)',
					);
					//debug($headers);
					$smail->setTXTBody($body);
					$snd_body = $smail->get($params);
					$snd_hdrs = $smail->headers($headers);
					$subject=$snd_hdrs['Subject'];
					unset($snd_hdrs['Subject']);
					$to=$snd_hdrs['To'];
					unset($snd_hdrs['To']);
					if (mail($to,$subject,$snd_body,$ModClass->headersToTxt($snd_hdrs,$CFG['NL_MAIL']),'-f'.imap_rfc822_write_address($mailbox,$host,''))) {
						$sent_obj=$ModClass->getObj($ModClass->getSentID(),false);
						if (is_object($sent_obj)) {
							$snd_hdrs["Date"]=date('r');
							$snd_hdrs["Subject"]=$subject;
							$snd_hdrs["To"]=$to;
							$mail_headers=$ModClass->headersToTxt($snd_hdrs,$CFG['NL_MAIL']);
							Framework::convertLineEndings($mail_headers,"\r\n");
							Framework::convertLineEndings($snd_body,"\r\n");
							$ModClass->appendMail($sent_obj->getBox(),$mail_headers."\r\n"."\r\n".$snd_body."\r\n","\\Seen");
						}
						setAjaxData('alert',FrameWork::getParam('ajax_modul',''),$result_alert);
					}
				}
			}
		}
	break;
	case 'mail_move':
		$ModClass=& $frm->getStaticModul('mail');
		$ModClass->init($MACC_ID);
		if($ModClass->isOpen() && Framework::getParam('mid') && Framework::getParam('mbox')) {
			$Mobj=$ModClass->getMailObj(Framework::getParam('mbox'),Framework::getParam('mid'));
			if (is_object($Mobj)) {
				$ActionError=$ModClass->moveMail(Framework::getParam('mbox'),Framework::getParam('mid'),Framework::getParam('mboxTo'));
				if (!$ActionError) {
					$ModClass->expungeBox(Framework::getParam('mbox'));
					setAjaxData('eval','mail_move',"mailMoved('".Framework::getParam('mbox').'||'.Framework::getParam('mid')."')");
				} else {
				}
			}
		}
		//setAjaxData('alert','mail_move',Framework::getParam('mid').'-'.Framework::getParam('mbox').'-'.Framework::getParam('mboxTo'));
	break;
	case 'mail_action':
		//ajaxLog($_POST);
		$ActionError=array();
		$ModClass=& $frm->getStaticModul('mail');
		$T->loadModul('mail');
		$ModClass->init($MACC_ID);
		if($ModClass->isOpen() && Framework::getParam('ListID')) {
			//ajaxLog('mailOpen:OK');
			$expunge=array();
			$okIds=array();$badIds=array();
			$jsResult=array('header'=>'','body'=>'','footer'=>'');
			switch(Framework::getParam('action')) {
				case 'delete':
					$move_obj=$ModClass->getObj($ModClass->getTrashID(),true);
					foreach (Framework::getParam('ListID',array()) as $key=>$val) {
						$temp=explode('||',$val);
						if (is_object($move_obj) && $temp[0]!=$move_obj->getBox()) {
							$tmp_error=$ModClass->moveMail($temp[0],$temp[1],$move_obj->getBox());
						} else {
							$tmp_error=$ModClass->deleteMail($temp[0],$temp[1]);
						}
						if (!$tmp_error) {
							$expunge[$temp[0]]=1;
							$okIds[]=$val;
						} else {
							$ActionError['server'][$tmp_error['server']]=$tmp_error['server'];
							$badIds[]=$val;
						}
					}
				break;
				case 'archiv':
					$deleteIds=array();
					$move_obj=$ModClass->getObj($ModClass->getTrashID(),true);
					if ($ModClass->getCfg('cfg/archiv/enable')) {
						foreach (Framework::getParam('ListID',array()) as $key=>$val) {
							$temp=explode('||',$val);
							$tmp_error=$ModClass->archivMail($temp[0],$temp[1]);
							if (!$tmp_error) {
								if (is_object($move_obj) && $temp[0]!=$move_obj->getBox()) {
									$tmp_error=$ModClass->moveMail($temp[0],$temp[1],$move_obj->getBox());
								} else {
									$tmp_error=$ModClass->deleteMail($temp[0],$temp[1]);
								}
								if (!$tmp_error) {
									$okIds[]=$val;
									$expunge[$temp[0]]=1;
								} else {
									$badIds[]=$val;
								}
							} else {
								$ActionError['server'][$tmp_error['server']]=$tmp_error['server'];
							}
						}
					}
				break;
				case 'move':
					$move_obj=$ModClass->getObj(Framework::getParam('mboxTo'),true);
					//debug(Framework::getParam('mboxTo'));
					foreach (Framework::getParam('ListID',array()) as $key=>$val) {
						$temp=explode('||',$val);
						if (is_object($move_obj) && $temp[0]!=$move_obj->getBox()) {
							$tmp_error=$ModClass->moveMail($temp[0],$temp[1],$move_obj->getBox());
							if (!$tmp_error) {
								$expunge[$temp[0]]=1;
								$okIds[]=$val;
							} else {
								$ActionError['server'][$tmp_error['server']]=$tmp_error['server'];
								$badIds[]=$val;
							}
						}
					}
				break;
				case 'copy':
					$move_obj=$ModClass->getObj(Framework::getParam('mboxTo'),true);
					foreach (Framework::getParam('ListID',array()) as $key=>$val) {
						$temp=explode('||',$val);
						if (is_object($move_obj) && $temp[0]!=$move_obj->getBox()) {
							$tmp_error=$ModClass->copyMail($temp[0],$temp[1],$move_obj->getBox());
							if (!$tmp_error) {
								$okIds[]=$val;
							} else {
								$ActionError['server'][$tmp_error['server']]=$tmp_error['server'];
							}						}
						if ($tmp_error) ajaxLog('Error:'.print_r($tmp_error,true));
					}
				break;
				case 'forward':
					$all_mail_users=array();
					$CyrAdm=& $frm->getStaticModul('mail_adm');
					if ($CyrAdm->imap_login()) {
						if (GE_mailUserSuffix) {
							$all_mail_users=$CyrAdm->GetUsers('%'.GE_mailUserSuffix);
						} else {
							$all_mail_users=$CyrAdm->GetUsers('%');
						}
					}
					$actUser=array();
					$userTo=Framework::getParam('userTo')?explode('|',Framework::getParam('userTo')):array();
					foreach ($userTo as $uval) {
						if ($uval[0]=='u') {
							$actUser[]=substr($uval,2);
						}
						if ($uval[0]=='g') {
							$groupUsers=$frm->getGroupUsers(substr($uval,2));
							if (is_array($groupUsers)) {
								$actUser=array_merge($actUser,$groupUsers);
							}
						}
					}
					$actUser=array_unique($actUser);
					$deleteIds=array();
					$MailLog=array();
					foreach ($actUser as $uval) {
						if ($uval==$user_id) continue;
						$userData=$frm->read_user($uval);
						$userOK=true;
						$errorTxt=array();
						if ($userData["username"] && in_array($userData["username"],$all_mail_users)) {
							$boxTo='user'.$ModClass->getCfg('cfg/delim').$userData["username"];

							$boxAcl=$CyrAdm->getacl($boxTo);
							if (isset($boxAcl[$ModClass->getUserName()])) {
								$oldAcl=$boxAcl[$ModClass->getUserName()];
							} else {
								$oldAcl='';
							}
							$CyrAdm->setacl($boxTo,$ModClass->getUserName(),'li');

							$boxToObj=$ModClass->getObj($boxTo,true,false);

							foreach (Framework::getParam('ListID',array()) as $key=>$val) {
								$temp=explode('||',$val);
								if (is_object($boxToObj)) {
									$tmp_error=$ModClass->copyMail($temp[0],$temp[1],$boxToObj->getBox());
									if (!$tmp_error) {
										if (Framework::getParam('mailMove') && !isset($deleteIds[$val])) {
											$deleteIds[$val]=1;
										}
										if (!isset($MailLog[$val])) {
											$Mobj=$ModClass->getMailObj($temp[0],$temp[1]);
											$MailLog[$val]=array(
												'Subject'=>$ModClass->mail_enc($Mobj->getName()),
												'From'=>is_array($Mobj->getMail('From'))?implode(',',$ModClass->formatMail($Mobj->getMail('From'),0,1)):'',
												'FromBox'=>$temp[0],
												'ToUserID'=>array(),
											);
										}
										$MailLog[$val]['ToUserID'][]=$uval;
										$okIds[]=$val;
									} else {
										$deleteIds[$val]=0;
										$userOK=false;
										$errorTxt[$tmp_error['server']]=1;
									}
								} else {
									$errorTxt['Mailbox not found']=1;
									$userOK=false;
								}
								if ($tmp_error) ajaxLog('Error:'.print_r($tmp_error,true));
							}

							if ($oldAcl) {
								$CyrAdm->setacl($boxTo,$ModClass->getUserName(),$oldAcl);
							} else {
								$CyrAdm->deleteacl($boxTo,$ModClass->getUserName());
							}
						} else {
							$userOK=false;
							$errorTxt['Mailbox not found']=1;
						}
						if ($userOK) {

						} else {
							$jsResult['body'].='<div><span class="error">'.$userData["lastname"].' '.$userData["firstname"].'</span>';
							if (!empty($errorTxt)) $jsResult['body'].=' ('.implode(',',array_keys($errorTxt)).')';
							$jsResult['body'].='</div>';
						}
					}
					if (!empty($MailLog)) {
						$Log=& $frm->getStaticModul('core_log');
						$LogID=$Log->insertLog('mail',0,$user_id,'forward');
						foreach ($MailLog as $key=>$val) {
							$Log->insertLogValues($LogID,$key,'',serialize($val));
						}
					}

					if (!empty($deleteIds)) {
						$move_obj=$ModClass->getObj($ModClass->getTrashID(),true);
						foreach ($deleteIds as $val=>$key) {
							if ($key) {
								$temp=explode('||',$val);
								if (is_object($move_obj) && $temp[0]!=$move_obj->getBox()) {
									$tmp_error=$ModClass->moveMail($temp[0],$temp[1],$move_obj->getBox());
								} else {
									$tmp_error=$ModClass->deleteMail($temp[0],$temp[1]);
								}
								if (!$tmp_error) {
									$expunge[$temp[0]]=1;
								} else {
									$badIds[]=$val;
								}
							}

						}
					}
					if (!$jsResult['body']) {
						$jsResult['body']=$T->lang('[[E-Mails wurden erfolgreich weitergeleitet]]');
					} else {
						$jsResult['body']='<strong>'.$T->lang('[[error_desc]]').'</strong>'.$jsResult['body'];
					}
				break;

			}
			if (!empty($badIds)) {
				setAjaxData('eval','removeMailRow','removeMailRow('.Framework::array2json($badIds).',1)');
			}
			if ($ActionError['server']) {
				$jsResult['body']='';
				foreach ($ActionError['server'] as $error) {
					if (preg_match('/Permission denied/i',$error)) {
						$jsResult['body'].='<div style="width:300px"><strong>'.$T->lang('[[error_permissions]]').'</strong></div>';
					} else {
						$jsResult['body'].='<div style="width:300px"><strong>'.$tmp_error['server'].'</strong></div>';
					}
				}
			}
			if ($jsResult['body']) {
				if (!$jsResult['header']) $jsResult['header']=$T->lang('[[Meldung]]');
				setAjaxData('eval','resultPanel','showResultDialog('.Framework::array2json($jsResult).')');
			}

			if (Framework::getParam('rlBox') && is_object($move_obj)) {
				$move_obj->setParentMeta(0,$ModClass->getStatus($move_obj->getBox()));
				setAjaxData('html',Framework::getParam('rlBox').$move_obj->getBox(),Mail::formatName($move_obj,false,''));
				if ($move_obj->getBox()=='INBOX') setAjaxData('html','r'.Framework::getParam('rlBox').$move_obj->getBox(),Mail::formatName($move_obj,false,''));
			}
			foreach ($expunge as $val=>$key) {
				if ($key) {
					$ModClass->expungeBox($val);
					if (Framework::getParam('rlBox')) {
						$bObj=$ModClass->getObj($val,true);
						if (is_object($bObj)) {
							setAjaxData('html',Framework::getParam('rlBox').$bObj->getBox(),Mail::formatName($bObj,false,''));
							if ($bObj->getBox()=='INBOX') setAjaxData('html','r'.Framework::getParam('rlBox').$bObj->getBox(),Mail::formatName($bObj,false,''));
						}
					}
				}
			}
		}
		//setAjaxData('alert','mail_move',Framework::getParam('mid').'-'.Framework::getParam('mbox').'-'.Framework::getParam('mboxTo'));
	break;
	case 'calEvtMove':
		$cal=& $frm->getStaticModul('cal');
		$PERMS=$cal->getPerms($frm->getUser(),$frm->getMyGroups());
		$PERMS[$frm->getUser()]=7;
		$PERMS['info']=7;
		if (!isset($CAL_USER)) {
			$sess->register('CAL_USER');
			$CAL_USER=0;
		}
		if (!($PERMS[$CAL_USER]&1)) {
			if ($frm->getPrefs('cal','inf')) $CAL_USER='info';
			else $CAL_USER=$frm->getUser();
		}
		$CAL_PERMS=$PERMS[$CAL_USER];
		if ($CAL_USER=='info') $user_id=$frm->getUser();
		else $user_id=$CAL_USER;
		$cal->setUser($user_id);
		$cal->setCalPerms($CAL_PERMS);
		$cal->setAllCalPerms($PERMS);
		if ($cal->getUser()==$frm->getUser()) {
			$cal->setGroup($frm->getMyGroups());
		} else {
			$cal->setGroup($frm->getUserGroups($cal->getUser()));
		}
		require_once('lib/cal/class_EventMoveGui.php');
		$contGui=new EventMoveGui();
		//debug($_POST);
		if (Framework::getParam('conflictTested',0)) {
			$contGui->setCheckConflict(0);
			$frm->loadPostData($cal->getModul(),'post_conflict_ajax');
		}

		//debug($_POST);
		//
		$nData=array();
		if (Framework::getParam('delEvt')) {

		} else {
			if (Framework::getParam('newStart')) {
				$nData['StartDate']=Framework::parseSqlDate(Framework::getParam('newStart'));
				$nData['EndDate']=Framework::parseSqlDate(Framework::getParam('newEnd'));
			} else {
				$nData['StartDate']=Framework::parseDate(Framework::getParam('newStartD'),Framework::getParam('newStartH'),Framework::getParam('newStartM'),0);
				$nData['EndDate']=Framework::parseDate(Framework::getParam('newEndD'),Framework::getParam('newEndH'),Framework::getParam('newEndM'),0);
			}
		}
		$nData['moveOne']=Framework::getParam('moveOne');
		if (Framework::issetParam('newUnsecure')) $nData['Unsecure']=Framework::getParam('newUnsecure');
		$contGui->setStart(Framework::getParam('aktCalStart'));
		$contGui->setEnd(Framework::getParam('aktCalEnd'));
		$contGui->setView(Framework::getParam('aktCalView'));
		$contGui->setDate(Framework::getParam('aktCalDate'));

		//debug($nData);
		if ((Framework::getParam('delEvt') || ($nData['StartDate'] && $nData['EndDate'] && $nData['EndDate']>=$nData['StartDate'])) && Framework::getParam('evtID')) {
			if (Framework::getParam('delEvt')) {
				$newID=$contGui->delEvent(Framework::getParam('evtID'),$nData,Framework::getParam('evtDate'));
			} elseif (Framework::getParam('copyEvt')) {
				$newID=$contGui->copyEvent(Framework::getParam('evtID'),$nData);
			} else {
				$newID=$contGui->moveEvent(Framework::getParam('evtID'),$nData,Framework::getParam('evtDate'));
			}
			if ($newID) {
				foreach ($contGui->getModifiedDays() as $key=>$val) {
					setAjaxData('html',$key,$val);
				}
				setAjaxData('eval','eval','Groupe.calMove.setCfgDragCal('.$contGui->getJsDraggable().');');
				if (Framework::getParam('aktCalView')=='day') {
					setAjaxData('eval','eval','Groupe.calMove.setCfgDropCal('.$contGui->getJsDroppable().');');
					setAjaxData('eval','eval',$frm->getOnLoad());
				}

				/*$tmpData2=$contGui->getDraggable();
				foreach ($tmpData2 as $key=>$val) {
					setAjaxData('eval','eval'.$key,$val);
				}*/
				//debug($tmpData2);
			} elseif (($conflict=$contGui->getConflict())) {
				$confGui=$contGui->getConflictGui(true);
				$frm->savePostData($cal->getModul(),'post_conflict_ajax',array());
				setAjaxData('eval','eval',"Groupe.calMove.showConflict('".Framework::escapeJs($confGui->process())."',".intval($conflict['overwrite']).");");
			} else {
				setAjaxData('alert','alert',$T->lang('[[error_unknown]]'));
			}
		}
	break;
	case 'loadCompSchluessel':
		require("lib/zef/class_zefGui.php");
		$zefGui=new zefGui();
		$hidCompData='';
		setAjaxData('html',Framework::getParam('fPrep','P','').'compSchluessel',$zefGui->loadCompSchluessel($hidCompData));
		setAjaxData('setVal',Framework::getParam('fPrep','P','').'customCompCalc',$hidCompData);

	break;
	case 'loadLastZef':
		$zef=& $frm->getStaticModul('zef');
		if (isset($ZEF_USER)) {
			$zef->setUser($ZEF_USER);
			if ($ZEF_USER!=$auth->auth['uid']) {
				$zef->setGroup($frm->getUserGroups($ZEF_USER));
			}
			require("lib/zef/class_zefGui.php");
			$zefGui=new zefGui();
			$lastGui=& $zefGui->_getLastEntries(Framework::getParam('zefDate'),'loadEntry_I',1);
			setAjaxData('html','lastZefCont',$lastGui->process());
		}

	break;
	case 'loadZefCat':
		$zef=& $frm->getStaticModul('zef');
		if (!isset($ZEF_USER)) {
			$sess->register('ZEF_USER');
			$ZEF_USER=$auth->auth['uid'];
		}
		$zef->setUser($ZEF_USER);
		if ($ZEF_USER!=$auth->auth['uid']) {
			$zef->setGroup($frm->getUserGroups($ZEF_USER));
		}
		if (Framework::getParam('FKzefPrjID')) {
			$prjCat=$zef->listPrjCat(Framework::getParam('FKzefPrjID'));
			$zef_cat=$zef->listAllCatNames();
			$avCat=array();
			if (!empty($prjCat)) {
				foreach ($zef_cat as $key=>$val) {
					if (isset($prjCat[$key])) {
						$avCat[$key]=$val;
					}
				}
			} else {
				$avCat=$zef_cat;
			}


			$defCat=Framework::getParam('FKcatID',0);
			require("lib/class_FormFieldsCore.php");
			$sel=new SelectFieldBtn(Framework::getParam('CatFieldID'),$defCat,array('class'=>'ipt','id'=>Framework::getParam('CatFieldID')));
			if ($defCat && isset($avCat[$defCat])) {
				$sel->setValues($avCat);
			} else {
				$sel->setValues(array('0'=>'-')+$avCat);
			}
			setAjaxData('html','ipt_'.Framework::getParam('CatFieldID'),$sel->process());
		}
	break;
	case 'archivProject':
		require_once('lib/proj/class_ProjectAdminGui.php');
		$prjGui=new ProjectAdminGui();
		$prjGui->_ArchivProject();
	break;
	case 'archivProjectStatus':
		require_once('lib/proj/class_ProjectAdminGui.php');
		$prjGui=new ProjectAdminGui();
		$prjGui->_AjaxArchivProjectStatus();
	break;
	case 'toggleAjax':
		//debug($_GET);
		switch (Framework::getParam('modul')) {
			case 'proj_prf':
				$ModClass=& $frm->getStaticModul('proj_profiles');
				require_once('lib/class_ObjAjaxTreeGui.php');
				$objID=Framework::getParam('objID');
				$obj=$ModClass->getObj($objID);
				if (is_object($obj)) {
					$root_id=$obj->getMeta('RootID');
					$open_tree=$frm->getTree(Framework::getParam('modul'),$root_id);
					$frm->updateTree($open_tree,$objID);
					$frm->setTree(Framework::getParam('modul'),$root_id,$open_tree);
					if (Framework::getParam('getMode')!=-1) {
						$expand=array_flip(explode(',',$open_tree));
						$ObjAjaxTreeGui=new ObjAjaxTreeGui();
						$ObjAjaxTreeGui->setCallback(array(&$ModClass,'listSubTree'));
						$ObjAjaxTreeGui->setCallbackLen(array(&$ModClass,'isSubTreeLen'));
						$ObjAjaxTreeGui->setExpand($expand);
						$ObjAjaxTreeGui->setExLink(Framework::getParam('exLink'));
						$ObjAjaxTreeGui->setAcLink(Framework::getParam('acLink'));
						$ObjAjaxTreeGui->setImgPath("img/$THEME");
						$ObjAjaxTreeGui->setColors($bgcolor,$fg10color);
						$ObjAjaxTreeGui->setRootID($root_id);
						$ObjAjaxTreeGui->setModul(Framework::getParam('modul'));
						$ObjAjaxTreeGui->setSelectedID(Framework::getParam('objSelected'));
						setAjaxData('html','nav'.$objID,$ObjAjaxTreeGui->processSub($objID,Framework::getParam('objDepth') + 1));
						if ($expand[$objID] && !$ObjAjaxTreeGui->getLen($objID)) {
							setAjaxData('eval','img'.$objID,"toggleAjaxDisp($objID,'e',1)");
						} else {
							setAjaxData('eval','img'.$objID,"toggleAjaxDisp($objID,'t',1)");
						}
					} else {
						setAjaxData('eval','img'.$objID,"toggleAjaxDisp($objID,'t',1)");
					}
				}
			break;
			case 'smb':
			case 'fmng':
			case 'imng':
				$ModClass=& $frm->getStaticModul(Framework::getParam('modul'));
				if (Framework::getParam('modul')=='imng') {
					$ModClass->setLangID($BL);
					$ModClass->setPublic(1);
					$Imng=$ModClass;
				}
				require_once('lib/class_ObjAjaxTreeGui.php');
				$objID=Framework::getParam('objID');
				$obj=$ModClass->getObj(base64_decode($objID));
				if (is_object($obj)) {
					$root_id=Framework::getParam('objRootID');
					$open_tree=$frm->getTree(Framework::getParam('modul'),$root_id);
					$frm->updateTree($open_tree,$objID,'|');
					$frm->setTree(Framework::getParam('modul'),$root_id,$open_tree);
					if (Framework::getParam('getMode')!=-1) {
						$expand=array_flip(array_map('base64_decode',explode('|',$open_tree)));
						$ObjAjaxTreeGui=new ObjAjaxTreeGui();
						$ObjAjaxTreeGui->setEncodeID(true);
						$ObjAjaxTreeGui->setCallback(array(&$ModClass,'listSubTree'));
						$ObjAjaxTreeGui->setCallbackLen(array(&$ModClass,'isSubTreeLen'));
						$ObjAjaxTreeGui->setExpand($expand);
						$ObjAjaxTreeGui->setExLink(Framework::getParam('exLink'));
						$ObjAjaxTreeGui->setAcLink(Framework::getParam('acLink'));
						$ObjAjaxTreeGui->setImgPath("img/$THEME");
						$ObjAjaxTreeGui->setColors($bgcolor,$fg10color);
						$ObjAjaxTreeGui->setRootID($root_id);
						$ObjAjaxTreeGui->setModul(Framework::getParam('modul'));
						$ObjAjaxTreeGui->setSelectedID(Framework::getParam('objSelected'));
						setAjaxData('html','nav'.$objID,$ObjAjaxTreeGui->processSub($obj->getID(),Framework::getParam('objDepth') + 1));
						if ($expand[$obj->getID()] && !$ObjAjaxTreeGui->getLen($obj->getID())) {
							setAjaxData('eval','img'.$objID,"toggleAjaxDisp('$objID','e',1)");
						} else {
							setAjaxData('eval','img'.$objID,"toggleAjaxDisp('$objID','t',1)");
						}
					} else {
						setAjaxData('eval','img'.$objID,"toggleAjaxDisp('$objID','t',1)");
					}
				}
			break;
			case 'mail':
				$ModClass=& $frm->getStaticModul('mail');
				$ModClass->init($MACC_ID);
				require_once('lib/class_ObjAjaxTreeGui.php');
				$objID=Framework::getParam('objID');
				if ($objID) {
					$root_id=Framework::getParam('objRootID');
					$open_tree=$frm->getTree(Framework::getParam('modul'),$root_id);
					$frm->updateTree($open_tree,$objID);
					$frm->setTree(Framework::getParam('modul'),$root_id,$open_tree);
					if (Framework::getParam('getMode')!=-1) {
						$expand=array_flip(explode(',',$open_tree));
						$ObjAjaxTreeGui=new ObjAjaxTreeGui();
						$ObjAjaxTreeGui->setClass('it_n','it_l');
						$ObjAjaxTreeGui->setCallback(array(&$ModClass,'listSubTree'),array('all'=>Framework::getParam('folderAll'),'vst'=>Framework::getParam('folderVst'),'quick'=>false));
						$ObjAjaxTreeGui->setExpand($expand);
						$ObjAjaxTreeGui->setExLink(Framework::getParam('exLink'));
						$ObjAjaxTreeGui->setAcLink(Framework::getParam('acLink'));
						$ObjAjaxTreeGui->setImgPath("img/$THEME");
						$ObjAjaxTreeGui->setColors($bgcolor,$fg10color);
						$ObjAjaxTreeGui->setRootID($root_id);
						$ObjAjaxTreeGui->setModul(Framework::getParam('modul'));
						$ObjAjaxTreeGui->setSelectedID(Framework::getParam('objSelected'));
						$ObjAjaxTreeGui->setMaxLen(0);
						$ObjAjaxTreeGui->setLinkAttribs(array('onmouseover'=>"showNewMail(event,1,'{OID}')",'onmouseout'=>"showNewMail(event,0,'{OID}')"));
						if (Framework::getParam('folderVst')) {
							$ObjAjaxTreeGui->setEntityFunc('');
							$ObjAjaxTreeGui->setNameFunc(array('Mail','formatName'));
						}

						setAjaxData('html','nav'.$objID,$ObjAjaxTreeGui->processSub($objID,Framework::getParam('objDepth') + 1));
						//setAjaxData('html','nav'.$objID,'lopo');
						if ($expand[$objID] && !$ObjAjaxTreeGui->getLen($objID)) {
							setAjaxData('eval','img'.$objID,"toggleAjaxDisp('$objID','e',1)");
						} else {
							setAjaxData('eval','img'.$objID,"toggleAjaxDisp('$objID','t',1)");
						}
						$dropIds=$ObjAjaxTreeGui->getJsIds();
						if (is_array($dropIds) && !empty($dropIds)) {
							setAjaxData('eval','eval',"Groupe.mailMove.addDrop(".'["'.implode('","',$dropIds).'"]'.");");
						}
					} else {
						setAjaxData('eval','img'.$objID,"toggleAjaxDisp('$objID','t',1)");
					}
				}
			break;
			case 'addr':
				$ModClass=& $frm->getStaticModul('addr');
				$root_id=Framework::getParam('objRootID');
				$extraParams=Framework::getParam('extraParams')?unserialize(base64_decode(Framework::getParam('extraParams'))):array();

				$ModClass->setAktServer($root_id);
				require_once('lib/class_ObjAjaxTreeGui.php');
				$objID=Framework::getParam('objID');
				$obj=$ModClass->getObjByDn(base64_decode($objID));
				if (is_object($obj)) {
					$open_tree=$frm->getTree(Framework::getParam('modul'),$root_id);
					$frm->updateTree($open_tree,$objID,'|');
					$frm->setTree(Framework::getParam('modul'),$root_id,$open_tree);
					if (Framework::getParam('getMode')!=-1) {
						$expand=array_flip(array_map('base64_decode',explode('|',$open_tree)));
						$ObjAjaxTreeGui=new ObjAjaxTreeGui();
						$ObjAjaxTreeGui->setEncodeID(true);
						$ObjAjaxTreeGui->setObjID('_DN');
						$ObjAjaxTreeGui->setCallback(array(&$ModClass,'listSubTree'),array('sid'=>$root_id));
						$ObjAjaxTreeGui->setExpand($expand);
						$ObjAjaxTreeGui->setExLink(Framework::getParam('exLink'));
						$ObjAjaxTreeGui->setAcLink(Framework::getParam('acLink'));
						$ObjAjaxTreeGui->setImgPath("img/$THEME");
						$ObjAjaxTreeGui->setColors($bgcolor,$fg10color);
						$ObjAjaxTreeGui->setRootID($root_id);
						$ObjAjaxTreeGui->setModul(Framework::getParam('modul'));
						$ObjAjaxTreeGui->setSelectedID(Framework::getParam('objSelected'));
						if ($extraParams['btnCheck']) {
							require_once('lib/class_FormFieldsCore.php');
							$btnCheck=new CheckBoxBtn ($extraParams['btnCheck'],'');
							$ObjAjaxTreeGui->setRowObject($btnCheck);
						}
						setAjaxData('html','nav'.$objID,$ObjAjaxTreeGui->processSub($obj->getMeta('_DN'),Framework::getParam('objDepth') + 1));
						if ($expand[$obj->getMeta('_DN')] && !$ObjAjaxTreeGui->getLen($obj->getMeta('_DN'))) {
							setAjaxData('eval','img'.$objID,"toggleAjaxDisp('$objID','e',1)");
						} else {
							setAjaxData('eval','img'.$objID,"toggleAjaxDisp('$objID','t',1)");
						}
					} else {
						setAjaxData('eval','img'.$objID,"toggleAjaxDisp('$objID','t',1)");
					}
				}
			break;
		}
	break;
	case 'loadClass':
		if (Framework::getParam('modul') && Framework::getParam('guiClass')) {
			$GuiObj=& $frm->getStaticGuiModul(Framework::getParam('modul'),Framework::getParam('guiClass'));
			if (is_object($GuiObj) &&  method_exists ($GuiObj,'processAjax')) {
				call_user_func(array(&$GuiObj, 'processAjax'),Framework::getParam('reqData'));
			}
		}
	break;
	case 'addrHot':
		if (Framework::getParam('AddrID')) {
			$ModClass=& $frm->getStaticModul('addr');
			$AObj=$ModClass->getAddrObj(Framework::getParam('AddrID'));
			if (is_object($AObj)) {
				$ModClass->updateAddrMetaVisited($AObj->getID());
			}
		}
	break;
	case 'asxCall':
		if ($frm->getMyApps('asx') && FrameWork::getParam('number','')) {
			$Asx=$frm->getStaticModul('asx');
			$Addr=$frm->getStaticModul('addr');
			$asxPhone=$Asx->getPhoneFromIP();
			if (is_object($asxPhone)) {
				$Base=$Asx->getStaticModul('server');
				try {
					if ($Base->login()) {
						$call_name='';
						if (FrameWork::getParam('AddrID','') && ($AObj=$Addr->getAddrObj(Framework::getParam('AddrID')))) {
							$call_name=$AObj->getName();
						}
						$res=$Base->geCall($asxPhone,FrameWork::getParam('number',''),$call_name);
					}
				} catch(Exception $E) {
					return false;
				}
			}
		}
	break;
	case 'asxRedirect':
		if ($frm->getMyApps('asx') && FrameWork::getParam('exten','') && FrameWork::getParam('channel','')) {
			$Asx=$frm->getStaticModul('asx');
			$asxPhone=$Asx->getPhoneFromIP();
			if (is_object($asxPhone)) {
				$Base=$Asx->getStaticModul('server');
				try {
					if ($Base->login()) {
						$res=$Base->geRedirect($asxPhone,FrameWork::getParam('channel',''),FrameWork::getParam('exten',''),FrameWork::getParam('status',''));
					}
				} catch(Exception $E) {
					return false;
				}
			}
		}
	break;
	case 'asxHangup':
		if ($frm->getMyApps('asx') && FrameWork::getParam('channel','')) {
			$Asx=$frm->getStaticModul('asx');
			$asxPhone=$Asx->getPhoneFromIP();
			if (is_object($asxPhone)) {
				$Base=$Asx->getStaticModul('server');
				try {
					if ($Base->login()) {
						$res=$Base->geHangup($asxPhone,FrameWork::getParam('channel',''));
					}
				} catch(Exception $E) {
					return false;
				}
			}
		}
	break;
	case 'protSetAjaxAddress':
		if (Framework::getParam('addKey')) {
			$Addr=$frm->getStaticModul('addr');
			if ($AObj=$Addr->getAddrObj(substr(Framework::getParam('addKey'),2))) {
				$address=array();
				if ($AObj->getMeta('Firma')) {
					$address[]=$AObj->getMeta('Firma');
				}
				if ($AObj->getMeta('Nachname') || $AObj->getMeta('Vorname')) {
					$address[]=trim($AObj->getMeta('Nachname').' '.$AObj->getMeta('Vorname'));
				}
				$parsed_addr=false;
				if ($AObj->getMeta('AStrasse')) {
					$address[]=$AObj->getMeta('AStrasse');
					$parsed_addr=true;
				}
				if ($AObj->getMeta('AOrt')) {
					$address[]=trim($AObj->getMeta('APlz').' '.$AObj->getMeta('AOrt'));
					$parsed_addr=true;
				}
				if (!$parsed_addr) {
					if ($AObj->getMeta('PStrasse')) {
						$address[]=$AObj->getMeta('PStrasse');
					}
					if ($AObj->getMeta('POrt')) {
						$address[]=trim($AObj->getMeta('PPlz').' '.$AObj->getMeta('POrt'));
					}
				}
				setAjaxData('setVal',substr(Framework::getParam('fieldID'),1),implode("\n",$address));
			}
		}
		setAjaxData('setVal',Framework::getParam('fieldID'),'');
	break;
}
page_close();
$t->parse("CONTENT","content");
header('Content-Type: text/xml');
$t->FastPrint('','');

function ajaxLog($val) {
	global $frm;
	if (defined('AJAX_LOG') && AJAX_LOG) {
		$fp=fopen(AJAX_LOG,'a+');
		if (!is_string($val)) $val=print_r($val,true);
		fwrite($fp,"\n".date('d.m.y H:i:s ').$frm->getUser()."\n".$val);
		fclose($fp);
	}
}
?>
