<?php
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
$Asx = $frm->getStaticModul('asx');
page_close();
//
try {
	$poller = $Asx->getStaticModul('poller');

	$result=array(
		'type'   => 'success',
		'events' => $poller->getEvents(),
	);
	$result['cookie']=$poller->getCookie();
	echo json_encode($result);
} catch( Exception $e ) {
	echo json_encode(
		array(
			'type'	  => 'error',
			'message' => $e->getMessage(),
		)
	);
	return;
}

/*
{"variables":{
	"event":"Newchannel",
	"privilege":"call,all",
	"channel":"SIP\/32-082fa848",
	"state":"Down",
	"calleridnum":"<unknown>",
	"calleridname":"<unknown>",
	"uniqueid":"asterisk-1298277673.623"
}},

{"variables":{
	"event":"Newcallerid",
	"privilege":"call,all",
	"channel":"SIP\/32-082fa848",
	"callerid":"31",
	"calleridname":"<Unknown>",
	"uniqueid":"asterisk-1298277673.623",
	"cid-callingpres":"0 (Presentation Allowed, Not Screened)"}
},
{"variables":
	{"event":"WaitEventComplete"}
}*/
?>
