<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

$t->assign('MOD_TITLE',$frm->getAppName('bmng'));
if (!$app["imng"]) {
       	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
} else {
	require_once('lib/imng/header.php');
	require('lib/bmng/header.php');
	$t->setRoot("tpl/$THEME/bmng/$session_lang");
	$t->define (array('application' => "header.inc.html"));
	$user_id=$auth->auth['uid'];
	unset($obj);
	unset($ActionError);
	$root_id=0;
	$root_obj=$Bmng->ListRoots();
	$trash_obj=$Bmng->getTrashObj();
	if (is_object($trash_obj)) {
		$root_obj[$trash_obj->getID()]=$trash_obj;
	}
	if ($oid) {
		$obj=$Bmng->getObj($oid);
		if (is_object($obj)) {
			$root_id=$obj->getParentMeta('RootID');
		}
	}
	if (!$root_id) {
		$obj=$Bmng->getSystemFolderObj();
		if (is_object($obj)) {
			$oid=$obj->getID();
			$root_id=$obj->getParentMeta('RootID');
		} else {
			$oid=$root_id=key($root_obj);
			$obj=$root_obj[$oid];
		}
	}
	if (!is_object($obj) || !$obj->getAcl(1) || !$Imng->getPerms(2)) {
		$t->assign('TPL_ERROR','');
	       	$t->define (array('tpl_card' => "no_perms.inc.html"));
		$t->parse('TPL_CARD','tpl_card');
	} else {
		if ($pre["global"]['js']) $t->parse("ROW","conf_delete");
		if (!isset($action)) $action=$obj->getAction(0);
		$L_THIS="index.php?site=$site&action=$action&oid=$oid";
		$Bmng->setClipboard('bobj',$frm->getClipboard('bobj'));
		if ($_POST['img_upload_x'] && $obj->getAcl(2)) {
			require ('lib/bmng/inc_UploadImage.php');
		}
		if ($_POST['meta_save_x'] && $obj->getAcl(2)) {
			require ('lib/bmng/inc_UpdateObject.php');
		}
		if ($obj_action_x && $obj_action_val) {
			require ('lib/bmng/func_Action.php');
			require ('lib/bmng/inc_ActionObject.php');
		}
		if ($list_action_x && $list_action_val) {
			require ('lib/bmng/func_Action.php');
			require ('lib/bmng/inc_ActionList.php');
		}
		$t->assign('OBJ_NAME',FrameWork::entities($obj->getName()));
		foreach ($root_obj as $key=>$val) {
			$t->assign('M_NAME',FrameWork::entities($val->getName()));
			$t->assign('M_IMG',$val->getImage(0));
			if ($val->getMeta('DocType')=='trash') {
				$t->assign('M_URL',"index.php?site=$site&oid=$key");
			} else {
				$t->assign('M_URL',"index.php?site=$site");
			}
			if ($root_id==$key) {
				$t->assign('M_ON','on');
			} else {
				$t->assign('M_ON','off');
			}
			$t->parse('ROW','.roots_header');

		}
		if ($action=="b") {
			$t->define (array('tpl_card' => "browse_content.inc.html"));
			require("lib/class_form.inc.php");
			require("bmng/browse_list_js.php");
			require("bmng/browse_content.php");
			$t->parse('TPL_CARD','tpl_card');
		}
		if ($action=="bt") {
			$t->define (array('tpl_card' => "browse_content.inc.html"));
			require("lib/class_form.inc.php");
			require("bmng/browse_list_js.php");
			require("bmng/browse_content.php");
			$t->parse('TPL_CARD','tpl_card');
		}

		if ($action=="vo") {
			$t->define (array('tpl_card' => "view_content.inc.html"));
			require("lib/class_form.inc.php");
			require("bmng/browse_list_js.php");
			require("bmng/view_content.php");
			$t->parse('TPL_CARD','tpl_card');
		}
		if ($action=="p") {
			$t->define (array('tpl_card' => "perms_content.inc.html"));
			require("lib/class_form.inc.php");
			require("bmng/browse_list_js.php");
			require("bmng/perms_content.php");
			$t->parse('TPL_CARD','tpl_card');
		}
		if ($ActionError) {
			require('bmng/view_error.php');
		}
	}
}
?>
