<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

$img_parent= "tree_expand.gif";
$img_up="<img src=\"img/$THEME/rs_up.gif\" width=\"11\" height=\"11\" hspace=\"0\" border=\"0\" />";
$img_down="<img src=\"img/$THEME/rs_down.gif\" width=\"11\" height=\"11\" hspace=\"3\" border=\"0\" />";
$img_top="<img src=\"img/$THEME/rs_top.gif\" width=\"11\" height=\"11\" hspace=\"3\" border=\"0\" />";

if (!$obj || !$obj->getAcl(1)) {
	header("Location:index.php?site=$site");
	exit;
}
$ID=$obj->getID();

$l_this="index.php?site=$site&action=$action&oid=$oid";
if ($pre['global']['lay']) {
    $t->define (array('tpl_layer' => "layers.inc.html"));
}

$t->parse('ROW','title_'.$obj->getMeta('DocType'));

$t->assign('FORM_ACTION',$l_this);
$t->assign('L_THIS',$l_this);

// todo wenn gesperrt ???
$p_update=false;
if (!$obj->getMeta('Trash') && $obj->getAcl(2) && ($Bmng->isSuperAdmin() || $obj->getParentMeta('RootID')!=$obj->getID())) {
	$txt_menutitle=new TextField('ObjTitle','size="30" class="sel" style="width:300px"','0','%',$obj->getMeta('Title'));
	$t->assign('OBJ_TITLE',$txt_menutitle->f());
	$t->assign('FOCUS_FIELD','ObjTitle');
	$p_update=true;
} else {
	$t->assign('OBJ_TITLE','<div class="disable" style="width:300px">'.FrameWork::entities($obj->getMeta('Title')).'</div>');
}

if ($p_update) {
	$t->parse('ROW','update');
}
if (!$obj->getMeta('Trash') && $obj->getAcl(2) && $obj->getParentMeta('RootID')!=$obj->getID()) {
	$txt_imgtitle=new TextField('ImgTitle','size="30" class="sel" style="width:220px"');
	$t->assign('F_IMG_TITLE',$txt_imgtitle->f());
	$t->parse('ROW','upload_box');
}


$obj_action=$frm->getObjAction($Bmng->getModul(),$obj->getActionMode(0));
foreach ($obj_action as $key=>$val) {
	if (!$val['Hidden'] && $Bmng->isAllowedAction($obj,$val)) {
		$t->assign('SEL_VAL',$key);
		$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
		$t->parse('ROW','.obj_action_val');
	}
}

$list_action=$frm->getObjAction($Bmng->getModul(),$obj->getActionMode(1));
foreach ($list_action as $key=>$val) {
	if (!$val['Hidden'] && $Bmng->isAllowedAction($obj,$val)) {
		$t->assign('SEL_VAL',$key);
		$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
		$t->parse('ROW','.list_action_val');
	}
}

$img_list=$Bmng->ListSubEntrys($obj->getID(),'img');
if (!empty($img_list)) {
	$img_num=$Bmng->listNumUsed($obj->getID());
	$i=1;$k=0;

	$num_entrys=count($img_list);
	$chk_list=new CheckBox("ListID",'id="ListID"',"","",1);
	if (is_array($ListID) && count($ListID) == $num_entrys) {
		$sel_all=true;
	}
	if ($sel_all) {
		$ListID=array_keys($img_list);
		$t->assign('DISPLAY_ALL','none');
		$t->assign('DISPLAY_NONE','normal');
	} else {
		if ($sel_none) {
			$ListID=array();
		}
		$t->assign('DISPLAY_ALL','normal');
		$t->assign('DISPLAY_NONE','none');
	}

	foreach ($img_list as $img_obj) {
		$path=$img_obj->getMeta('Content');
		if ($path && file_exists($Bmng->getCfg('ThumbPath').'/'.$path)) {
			$t->assign("THUMB_IMG",'fetch_image.php?mode=thumb&file='.$path);
		} else {
			$t->assign("THUMB_IMG","img/$THEME/tras.gif");
		}
		$t->assign('IMG_DIMENSION',$img_obj->getMeta('Width').'x'.$img_obj->getMeta('Height'));
		$t->assign('IMG_SIZE',$frm->formatSize($img_obj->getMeta('Size')));
		if ($img_obj->getMeta('Version') > 1) {
			$t->assign("IMG_NAME",$img_obj->getName().'['.$img_obj->getMeta('Version').']');
		} else {
			$t->assign("IMG_NAME",$img_obj->getName());
		}
		$t->assign("IMG_COUNT",intval($img_num[$img_obj->getID()]));
		/*if (!$img_num[$img_obj->getID()]) {
			$t->assign("ROW_COLOR",$fg10color);
		} else*/
		if ($k%2) {
			$t->assign("ROW_COLOR","#f2f2f2");
		} else {
			$t->assign("ROW_COLOR","$bgcolor");
		}
		$t->assign('CHK_IMG',$chk_list->f($img_obj->getID()));
		$t->assign('L_IMG_VIEW',"index.php?site=$site&oid=".$img_obj->getID());
		$t->parse('ROW',".img_row".$i);
		$k++;
		$i++;
		if ($i>3) $i=1;

	}
	$t->assign('NUM_IMAGES',($k));
	$t->parse('ROW','list_content');
}

if ($pre['global']['lay']) $t->parse("TPL_LAYERS","tpl_layer"); else $t->assign("TPL_LAYERS","");
?>
