<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$ID=$obj->getID();
$this_action=$frm->getObjAction ($Bmng->getModul(),$obj->getActionMode(0),'perms');
if (!$Bmng->isAllowedAction($obj,reset($this_action))) {
	header("Location:index.php?site=$site&oid=".$ID);
	exit;
}
$l_this="index.php?site=$site&action=$action&oid=$oid";
$t->assign('FORM_ACTION',$l_this);
$t->parse('ROW','title_'.$obj->getMeta('DocType'));

$img_signed='X';
$users_array=$frm->getFullName();
$all_users=$users_array;
$groups_array=array(0=>'-') + $frm->getAllGroups();

$av_perms=array(
	'l'=>1,
	's'=>3,
	'k'=>0,
);
if ($obj->getMeta('DocType')=='wcat') {
	$av_perms['p']=19;
}

if (!$obj->getMeta('Groups')) $obj->setMeta('Groups','|');
if (!$obj->getMeta('Users')) $obj->setMeta('Users','|');

$update_perms=false;
if (isset($new_x)) {
        $temp=0;
        if ($sel_group && $obj_perms) {
            	if (preg_match("/\|$sel_group,[^|]+\|/",$obj->getMeta('Groups'))) {
			$obj->setMeta('Groups',preg_replace("/\|$sel_group,[^|]+\|/",'|'.$sel_group.','.$obj_perms.'|',$obj->getMeta('Groups')));
		} else {
			$obj->setMeta('Groups',$obj->getMeta('Groups').$sel_group.",".$obj_perms."|");
		}
		$update_perms=true;
            	unset($sel_group);
        }
        if (is_array($sel_user) && isset($obj_perms)) {
                foreach ($sel_user as $val) {
                    	if (empty($val)) continue;
                    	if (preg_match("/\|$val,[^|]+\|/",$obj->getMeta('Users'))) {
				$obj->setMeta('Users',preg_replace("/\|$val,[^|]+\|/",'|'.$val.','.$obj_perms.'|',$obj->getMeta('Users')));
			} else {
				$obj->setMeta('Users',$obj->getMeta('Users').$val.",".$obj_perms."|");
			}

                 }
                 $update_perms=true;
		 if ($CFG[USER_LIST]) {
			$frm->updateHotlist($sel_user,'web');
		 }
                 unset($sel_user);
        }
         $obj_perms=1;
}

if (isset($du)) {
        $obj->setMeta('Users',preg_replace("/\|$du,[^|]+\|/",'|',$obj->getMeta('Users')));
        $update_perms=true;
}
if (isset($dg)) {
	$obj->setMeta('Groups',preg_replace("/\|$dg,[^|]+\|/",'|',$obj->getMeta('Groups')));
	$update_perms=true;
}
if ($update_perms) {
	$Bmng->updateMeta($obj);
	$sub_entrys=$Bmng->ListSubEntrys($ID);
	foreach ($sub_entrys as $sub_obj) {
		if (!$sub_obj->isFolder()) {
			$sub_obj->setMeta('Users',$obj->getMeta('Users'));
			$sub_obj->setMeta('Groups',$obj->getMeta('Groups'));
			$Bmng->updateMeta($sub_obj);
		}
	}

}

foreach ($av_perms as $key=>$val) {
        $t->parse('COL','sign_tit_'.$key);
        $t->parse('COL','gsign_tit_'.$key);
}
$Users=explode('|',$obj->getMeta('Users'));
$i=0;
foreach ($Users as $val) {
        if (empty($val)) continue;
        $puser=explode(',',$val);
        if ($puser[0]==$CFG[SUPERADMIN] && $auth->auth[uid]!=$CFG[SUPERADMIN]) continue;
        if ($puser[0]==$eu) {
            	$obj_perms=$puser[1];
            	$sel_user=array($puser[0]);
        }
	foreach ($av_perms as $perm=>$num) {
             	if ($puser[1]==$num) {
			$t->assign('IMG_SIGN',$img_signed);
		} else {
			$t->assign('IMG_SIGN','&nbsp;');
		}
            	$t->parse('ROW',"sign_$perm");
        }

        if (!$all_users[$puser[0]]) {
		$tmp=$frm->getFullName($puser[0],0,1);
		$all_users[$puser[0]]=$tmp[$puser[0]];
	}
	$t->assign('P_USER',$all_users[$puser[0]]);
        $t->assign('P_DHREF',$l_this."&du=".$puser[0]);
        $t->assign('P_EHREF',$l_this."&eu=".$puser[0]);
        $t->parse("ROW",".uperms");
        $i++;
}
if ($i) {
	$t->parse("ROW","user_perms");
}

$Groups=explode('|',$obj->getMeta('Groups'));
$i=0;
foreach ($Groups as $val) {
        if (empty($val)) continue;
        $pgroup=explode(',',$val);
        if ($pgroup[0]==$eg) {
            	$obj_perms=$pgroup[1];
            	$sel_group=$pgroup[0];
        }
	foreach ($av_perms as $perm=>$num) {
             	if ($pgroup[1]==$num) {
			$t->assign('IMG_SIGN',$img_signed);
		} else {
			$t->assign('IMG_SIGN','&nbsp;');
		}
            	$t->parse('ROW',"gsign_$perm");
        }
        $t->assign('P_USER',$frm->getCachedGroupName($pgroup[0]));
        $t->assign('P_DHREF',$l_this."&dg=".$pgroup[0]);
        $t->assign('P_EHREF',$l_this."&eg=".$pgroup[0]);
        $t->parse("ROW",".gperms");
        $i++;
}
if ($i) {
	$t->parse("ROW","group_perms");
}
$rad_perms=new RadioButton('obj_perms','class=sel',1);
foreach ($av_perms as $key=>$val) {
        $t->assign("PERMS_F",$rad_perms->f($val));
        $t->parse('ROW','.av_perms_'.$key);
}
$sel_sel_group=new SelectField("sel_group",'class="sel" style="width:250px;"',$groups_array);
$t->assign("GROUPS_F",$sel_sel_group->f());

$sel_sel_user=new SelectField("sel_user",'class="sel" size="5" id="sel_user" style="width:250px;"',$users_array,"",1);
$t->assign("USERS_F",$sel_sel_user->f());
if ($CFG[USER_LIST]) {
	$link="js_user.php?modul=web&form=daten&field=sel_user&mult=1";
	$t->assign('JS_USER_U',"NewWindow('$link','User',".$CFG[userwidth].','.$CFG[userheight].",0)");
}else $t->assign('JS_USER_U','');





$rule_users=$frm->getRuleUsers('web');
/*
// Besitzer
if (!$all_users[$obj->getMeta('UserCreate')]) {
	$tmp=$frm->getFullName($obj->getMeta('UserCreate'),0,1);
	if ($tmp) $all_users[$obj->getMeta('UserCreate')]=$tmp[$obj->getMeta('UserCreate')];
}
if ($all_users[$obj->getMeta('UserCreate')]) $rule_users['owner'][0]=$obj->getMeta('UserCreate');
*/

if (is_array($rule_users)) {
        foreach($rule_users as $key=>$val) {
            	foreach ($val as $num=>$id) {
			if (!$all_users[$id]) {
				$tmp=$frm->getFullName($id);
				$all_users[$id]=$tmp[$id];
			}
                	$t->assign('OWNER_NAME',$all_users[$id]);
                	$t->assign('OWNER_NUM',$num+1);
                	$t->parse('ROW','.rule_row_'.$key);
            	}
            	$t->parse('ROW','rule_'.$key);
        }
}

$t->assign('L_BREAK',"index.php?site=$site&oid=".$ID);
$t->parse('ROW','break');
?>
