<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$IMG_PAGE_WIDTH=750;
if (!$obj || !$obj->getAcl(1)) {
	header("Location:index.php?site=$site");
	exit;
}
$ID=$obj->getID();

$l_this="index.php?site=$site&action=$action&oid=$oid";
if ($pre['global']['lay']) {
    $t->define (array('tpl_layer' => "layers.inc.html"));
}

$t->parse('ROW','title_'.$obj->getMeta('DocType'));


$t->assign('L_THIS',$l_this);
$width=$obj->getMeta('Width');
$height=$obj->getMeta('Height');

$t->assign('OBJ_VERSION',$obj->getMeta('Version'));
$t->assign('IMG_DIMENSION',$width.'x'.$height);
$t->assign('IMG_DIM',$width.'x'.$height);
$t->assign('IMG_SIZE',$frm->formatSize($obj->getMeta('Size')));

$usedObj=$Bmng->getUsedObjectIDs($ID);
if (is_array($usedObj['redi'])) {
	$usedObj['redi']=array_unique($usedObj['redi']);
	require_once("lib/redi/header.php");
	foreach ($usedObj['redi'] as $uobjID) {
		$uobj=$Web->getObj($uobjID);
		if (is_object($uobj)) {
			$t->assign('UOBJ_L',"index.php?site=".$uobj->getSite(0)."&action=".$uobj->getAction(0)."&oid=".$uobj->getID());
			$t->assign('UOBJ_IMG',$uobj->getImage());
			$t->assign('UOBJ_NAME',Framework::entities($uobj->getName()));
			$t->parse('ROW','.uobj_row');
		}
	}
	$t->parse('ROW','uobj');
}


if ($width>$IMG_PAGE_WIDTH) {
	$proz=$IMG_PAGE_WIDTH/($width);
	$t->assign('ORIG_WIDTH',intval($width*$proz));
	$t->assign('ORIG_PROZ',intval($proz*100));
	$t->assign("L_FULL_ORIG_B",'<a href="fetch_image.php?file='.urlencode($obj->getMeta('Content')).'" target="_blank">');
	$t->assign("L_FULL_ORIG_E",'</a>');
} else {
	$t->assign("L_FULL_ORIG_B","");
	$t->assign("L_FULL_ORIG_E","");
	$t->assign('ORIG_WIDTH',$width);
	$t->assign('ORIG_PROZ','100');
}
$t->assign('ORIG_IMG','fetch_image.php?file='.urlencode($obj->getMeta('Content')));



// todo wenn gesperrt ???
$p_update=false;
if (!$obj->getMeta('Trash') && $obj->getAcl(2) && ($Bmng->isSuperAdmin() || $obj->getParentMeta('RootID')!=$obj->getID())) {
	$txt_title=new TextField('ObjTitle','size="25" class="sel" style="width:250px"','0','%',$obj->getMeta('Title'));
	$t->assign('F_OBJ_TITLE',$txt_title->f());
	$t->assign('FOCUS_FIELD','ObjTitle');
	$txt_version=new TextField('ObjVersion','size="5" class="sel" style="width:50px"','0','%',$obj->getMeta('Version'));
	$t->assign('F_OBJ_VERSION',$txt_version->f());
	$p_update=true;
} else {
	$t->assign('F_OBJ_TITLE','<div class="disable" style="width:250px">'.FrameWork::entities($obj->getMeta('Title')).'</div>');
	$t->assign('F_OBJ_VERSION','<div class="disable" style="width:50px">'.FrameWork::entities($obj->getMeta('Version')).'</div>');
}



$t->assign('L_BREAK',"index.php?site=$site&oid=".$obj->getParentMeta('ParentID'));
$t->parse('ROW','break');

if (!$obj->getMeta('Trash') && $obj->getAcl(2) && $obj->getParentMeta('RootID')!=$obj->getID()) {
	$p_update=true;
	if ($filter_x) {
		$filter['resize']=intval($filter['resize']);
		if ($filter['resize']<1) $filter['resize']=$width;
		if ( $filter['resize']>$Bmng->getCfg('OrigSize')) $filter['resize']=$Bmng->getCfg('OrigSize');
		$tmp_x=$filter['resize']/$width;
		$n_width=$filter['resize'];
		$n_height=round($tmp_x*$height);

		$filter['crop']['l']=intval($filter['crop']['l']);
		$filter['crop']['r']=intval($filter['crop']['r']);
		$filter['crop']['t']=intval($filter['crop']['t']);
		$filter['crop']['b']=intval($filter['crop']['b']);

		if (($filter['crop']['l']+$filter['crop']['r'])>=$n_width) {
			$filter['crop']['l']=0;
			$filter['crop']['r']=0;
		}
		if (($filter['crop']['t']+$filter['crop']['b'])>=$n_height) {
			$filter['crop']['t']=0;
			$filter['crop']['b']=0;
		}
		$n_width=$n_width-$filter['crop']['r']-$filter['crop']['l'];
		$n_height=$n_height-$filter['crop']['t']-$filter['crop']['b'];

		$filter['raise']=intval($filter['raise']);
		if ($filter['raise']>($n_width/2)) $filter['raise']=floor($n_width/2);
		if ($filter['raise']>($n_height/2)) $filter['raise']=floor($n_height/2);
		if ($filter['raise']<0) $filter['raise']=0;

		$dest=$Bmng->filterImage($Bmng->getCfg('OrigPath').'/'.$obj->getMeta('Content'),$filter);

		$old_dest=Framework::getTempPath().'/'.basename($old_dest);
		if ($old_dest && file_exists($old_dest) && is_file($old_dest)) {
			unlink($old_dest);
		}

		if ($dest) {
			$t->assign('FILTER_IMG','fetch_image.php?file='.urlencode(basename($dest)));
			$t->assign('FILTER_IMG_SIZE',$frm->formatSize(filesize($dest)));
			$t->assign('FILTER_IMG_DIM',$n_width.'x'.$n_height);
			if (($width+$n_width)>$IMG_PAGE_WIDTH) {
				$proz=$IMG_PAGE_WIDTH/($width+$n_width);
				$t->assign('ORIG_WIDTH',intval($width*$proz));
				$t->assign('FILTER_WIDTH',intval($n_width*$proz));
				$t->assign('ORIG_PROZ',intval($proz*100));
				$t->assign('FILTER_PROZ',intval($proz*100));
				$t->assign("L_FULL_FILTER_B",'<a href="fetch_image.php?file='.urlencode(basename($dest)).'" target="_blank">');
				$t->assign("L_FULL_FILTER_E",'</a>');
				$t->assign("L_FULL_ORIG_B",'<a href="fetch_image.php?file='.urlencode($obj->getMeta('Content')).'" target="_blank">');
				$t->assign("L_FULL_ORIG_E",'</a>');
			} else {
				$t->assign("L_FULL_FILTER_B","");
				$t->assign("L_FULL_FILTER_E","");
				$t->assign('ORIG_WIDTH',$width);
				$t->assign('ORIG_PROZ','100');
				$t->assign('FILTER_WIDTH',$n_width);
				$t->assign('FILTER_PROZ','100');

			}
			$t->parse('ROW','tit_preview');
			$t->parse('ROW','filter_img');
			$t->parse('ROW','conf_update');
			$l_this.="&filter_x=$filter_x&old_dest=".urlencode(basename($dest));
		}
	} else {
		unset($filter);
	}






	$t->assign('NORMALIZE',$filter['normalize']);
	if (!isset($filter['gamma'])) $filter['gamma']=0;
	$gamma_array=array(-50=>-10,-45=>-9,-40=>-8,-35=>-7,-30=>-6,-25=>-5,-20=>-4,-15=>-3,-10=>-2,-5=>-1,0=>0,5=>1,10=>2,15=>3,20=>4,25=>5,30=>6,35=>7,40=>8,45=>9,50=>10);
	foreach ($gamma_array as $key=>$val) {
		$t->assign('SEL_KEY',$key);
		$t->assign('SEL_VAL',$val);
		if ($filter['gamma']==$key) {
			$t->assign('SEL_CHK','selected');
		} else {
			$t->assign('SEL_CHK','');
		}
		$t->parse('ROW','.sel_gamma');
	}
	if (!isset($filter['modulate']['s'])) $filter['modulate']['s']=0;
	$modulate_s_array=array(-50=>-10,-45=>-9,-40=>-8,-35=>-7,-30=>-6,-25=>-5,-20=>-4,15=>-3,-10=>-2,-5=>-1,0=>0,5=>1,10=>2,15=>3,20=>4,25=>5,30=>6,35=>7,40=>8,45=>9,50=>10);
	foreach ($modulate_s_array as $key=>$val) {
		$t->assign('SEL_KEY',$key);
		$t->assign('SEL_VAL',$val);
		if ($filter['modulate']['s']==$key) {
			$t->assign('SEL_CHK','selected');
		} else {
			$t->assign('SEL_CHK','');
		}
		$t->parse('ROW','.sel_modulate_s');
	}
	if (!isset($filter['sharpen'])) $filter['sharpen']=0;
	$sharpen_array=array(-5=>-5,-4=>-4,-3=>-3,-2=>-2,-1=>-1,0=>0,1=>1,2=>2,3=>3,4=>4,5=>5);
	foreach ($sharpen_array as $key=>$val) {
		$t->assign('SEL_KEY',$key);
		$t->assign('SEL_VAL',$val);
		if ($filter['sharpen']==$key) {
			$t->assign('SEL_CHK','selected');
		} else {
			$t->assign('SEL_CHK','');
		}
		$t->parse('ROW','.sel_sharpen');
	}

	if (!$filter['resize']) $filter['resize']=$width;
	$t->assign('RESIZE',intval($filter['resize']));

	$t->assign('CROP_L',intval($filter['crop']['l']));
	$t->assign('CROP_R',intval($filter['crop']['r']));
	$t->assign('CROP_T',intval($filter['crop']['t']));
	$t->assign('CROP_B',intval($filter['crop']['b']));

	$t->assign('RAISE',intval($filter['raise']));

	$t->parse('ROW','img_box');
}

if ($p_update) {
	$t->parse('ROW','update');
}

$obj_action=$frm->getObjAction($Bmng->getModul(),$obj->getActionMode(0));
foreach ($obj_action as $key=>$val) {
	if ($Bmng->isAllowedAction($obj,$val)) {
		$t->assign('SEL_VAL',$key);
		$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
		$t->parse('ROW','.obj_action_val');
	}
}

$t->assign('FORM_ACTION',$l_this);

?>
