<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->unload('tpl_error');
$t->define (array('tpl_error' => "error.inc.html"));
if (is_array($ActionError['no_del_perms'])) {
	$object_error='';
	foreach ($ActionError['no_del_perms'] as $tmp_id) {
		$tmp_obj=$Bmng->getObj($tmp_id);
		if (is_object($tmp_obj)) {
			$object_error[]=FrameWork::entities($tmp_obj->getName());
		}
	}
	if (is_array($object_error)) {
		$t->assign('OBJECT_ERROR',implode('<br>',$object_error));
		$t->parse('ROW','error_del_perms');
	}
}
if (is_array($ActionError['no_sub_del_perms'])) {
	$t->parse('ROW','error_sub_del_perms');
}
if (is_array($ActionError['no_cut_perms'])) {
	$object_error='';
	foreach ($ActionError['no_cut_perms'] as $tmp_id) {
		$tmp_obj=$Bmng->getObj($tmp_id);
		if (is_object($tmp_obj)) {
			$object_error[]=FrameWork::entities($tmp_obj->getName());
		}
	}
	if (is_array($object_error)) {
		$t->assign('OBJECT_ERROR',implode('<br>',$object_error));
		$t->parse('ROW','error_cut_perms');
	}
}
if (is_array($ActionError['no_copy_perms'])) {
	$object_error='';
	foreach ($ActionError['no_copy_perms'] as $tmp_id) {
		$tmp_obj=$Bmng->getObj($tmp_id);
		if (is_object($tmp_obj)) {
			$object_error[]="".FrameWork::entities($tmp_obj->getName()).'';
		}
	}
	if (is_array($object_error)) {
		$t->assign('OBJECT_ERROR',implode('<br>',$object_error));
		$t->parse('ROW','error_copy_perms');
	}
}
if (is_array($ActionError['to_self'])) {
	$object_error='';
	foreach ($ActionError['to_self'] as $tmp_id) {
		$tmp_obj=$Bmng->getObj($tmp_id);
		if (is_object($tmp_obj)) {
			$object_error[]=FrameWork::entities($tmp_obj->getName());
		}
	}
	if (is_array($object_error)) {
		$t->assign('OBJECT_ERROR',implode('<br>',$object_error));
		$t->parse('ROW','error_self');
	}
}
if (isset($ActionError['no_valid_file'])) {
	$t->parse('ROW','error_no_file');
}
if (is_array($ActionError['no_img_file'])) {
	foreach ($ActionError['no_img_file'] as $tmp_name) {
		$object_error[]=FrameWork::entities($tmp_name);
	}
	if (is_array($object_error)) {
		$t->assign('OBJECT_ERROR',implode('<br>',$object_error));
		$t->parse('ROW','error_img_file');
	}
}
if (isset($ActionError['Title'])) {
	$t->parse('ROW','error_no_title');
}
if (isset($ActionError['Version'])) {
	$tmp_obj=$Bmng->getObj($ActionError['Version']);
	if (is_object($tmp_obj)) {
		$t->assign('OBJECT_ERROR',FrameWork::entities($tmp_obj->getName().'['.$tmp_obj->getMeta('Version').']'));
	} else {
		$t->assign('OBJECT_ERROR','');
	}
	$t->parse('ROW','error_version');
}
if (isset($ActionError['ImageSave'])) {
	$t->parse('ROW','error_img_save');
}
$t->parse('TPL_ERROR','.tpl_error');
?>
