<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
//debug($obj);
if (FrameWork::getParam('go_b',0)) {
	$CAL_REFERER[0]=$_SERVER['HTTP_REFERER'];
}
if (!$obj) {
	page_close();
	header("location:".$CAL_REFERER[0]);
	exit;
}
if (Framework::getParam('loadPost',0)) {
	$frm->loadPostData($cal->getModul(),'post_conflict');
}

$tplShow='show_view';
if (Framework::getParam('print',0)) {
	require_once('lib/cal/class_CalPrintGui.php');
	$printGui=new CalPrintGui(array(
		'TplID'=>intval(Framework::getParam('printTpl','','G'))?Framework::getParam('printTpl','','G'):'view_e',
		'TimeStart'=>$obj['StartDate'],
		'TimeEnd'=>$obj['EndDate'],
		'CalUserID'=>$cal->getUser(),
		'CalUserName'=>$frm->getCachedUserName($cal->getUser(),0,1),
	));
	$printGui->setEntries($obj,0);
	$printGui->printObject();
} else {
	$frm->addOnload('e7gMsgIntitObj('.json_encode(array(
		'typ'=>'cal',
		'id'=>$obj['EventID'],
		'name'=>$obj['Title'],
		'link'=>"index.php?site=cal.php&action=view&view=event&event_id=".$obj['EventID']."&edate=".$edate."&go_b=1"
	)).');');



	$t->assign("L_PRINT","javascript:showPrintDialog('list_e');");
	require_once('lib/class_PrintDialogGui.php');
	$printDialogGui=new PrintDialogGui('cal');
	$printDialogGui->process('view_e');
	
	require_once('lib/class_ColorPickerGui.php');
	$cGui=new ColorPickerGui();
	$cGui->setCallback('setObjColor');
	$cGui->setColors(explode(',','transparent,'.$cal->getCfg('cfg/colors')));
	$frm->addScript($cGui);

	require_once('lib/class_FormFieldsCore.php');

	$btnColor=new ColorFieldBtn ('evtcolor_'.$event_id,$default='',array('style'=>'float:left;width:12px;height:12px;margin-right:5px;margin-left:5px;'));
	$btnColor->setParams(array('data'=>array('modul'=>'cal','id'=>$event_id)));
	$t->assign('JS_COLOR_PICKER',$btnColor->process());
	
	$link="js_cal.php?date=".time()."&field=n_date";
	$t->assign('JS_CAL',"NewWindow('$link','Calendar',".$CFG['calwidth'].','.$CFG['calheight'].",0);");
	$category=$frm->getStaticModul('cal_cat')->getCachedObj($obj['FKCatID']);

	if (!$obj['_Privat'] && ($cal->getUser()==$obj['OwnerID'] || $cal->getAllCalPerms($obj['OwnerID'],2))) {
		$editPerms=true;
	} else {
		$editPerms=false;
	}

	$InvitGroups=explode(',',$obj['InvitGroups']);
	$InvitUsers=explode(',',$obj['InvitUsers']);
	$tpmGusers=$frm->getGroupUsers($InvitGroups);

	if (is_array($tpmGusers) && !empty($tpmGusers)) $tpmGusers=array_keys($frm->getApplicationUsers('cal',$tpmGusers));
	if (!is_array($tpmGusers)) $tpmGusers=array();
	$i_users=array_filter(array_unique(array_merge($tpmGusers,$InvitUsers,array($obj['OwnerID']))),'intval');
	//debug($i_users);
	$iv_users=$frm->getFullName($i_users);
	if (trim($obj['InvitAddr'])) {
		$Addr=& $frm->getStaticModul('addr');
		$InvitAddr=explode(',',$obj['InvitAddr']);
		$Fields=array('firstname','lastname','company');
		foreach ($InvitAddr as $val) {
			if ($address=$Addr->getAddrObj($val)) {
				$iv_users[]=$address->getName(1);
			}
		}
	}
	if (!is_array($iv_users)) $iv_users=array();
	$owner=$frm->getFullName($obj['OwnerID'],0,1);
	$log_tras=array(
		'{EDATE}'=>$cal->formatDate($obj['StartDate'],$obj['EndDate'],$obj['TimeMode']),
		'{ETITLE}'=>trim($obj['Title']),
		'{EPLACE}'=>trim($obj['Place']),
		'{ETEXT}'=>trim($obj['Text']),
		'{TEXT}'=>trim($comment),
		'{CUSER}'=>$CAL_USER_N,
		'{OUSER}'=>$owner['lastname'].' '.$owner['firstname'],
		'{EUSER}'=>implode(', ',$iv_users),
	);
	$CAL_REFERER[1]="index.php?site=$site&action=$action&view=$view&event_id=$event_id&edate=$edate";

	if ($editPerms) {
		$m_typ=Framework::getParam('m_typ','','P');
		$n_num=Framework::getParam('n_num','','P');
		$n_typ=Framework::getParam('n_typ','','P');
		$n_date=Framework::getParam('n_date','','P');
		$n_date_h=Framework::getParam('n_date_h','','P');
		$n_date_i=Framework::getParam('n_date_i','','P');

		if ((Framework::getParam('save_x','','P') && !Framework::getParam('break_x','','P')) && (($m_typ==1 && $n_num) || ($m_typ==2 && $frm->parseDate($n_date)))) {
			if ($m_typ==2) {
				$tmp=$frm->parseDate($n_date);
				$n_date_d=date('d',$tmp);
				$n_date_m=date('m',$tmp);
				$n_date_y=date('Y',$tmp);
				if (!($n_date_h)) $n_date_h=date('H',$obj['StartDate']);
				if (!($n_date_i)) $n_date_i=date('i',$obj['StartDate']);
				//debug(date('H',$obj['StartDate']));
			} else {
				$n_date_d=date('d',$obj['StartDate']);
				$n_date_m=date('m',$obj['StartDate']);
				$n_date_y=date('Y',$obj['StartDate']);
				$n_date_h=date('H',$obj['StartDate']);
				$n_date_i=date('i',$obj['StartDate']);
				switch ($n_typ) {
					case 'hour':
						$n_date_h+=$n_num;
						break;
					case 'day':
						$n_date_d+=$n_num;
						break;
					case 'week':
						$n_date_d+=$n_num*7;
						break;
					case 'month':
						$n_date_m+=$n_num;
						break;
				}
			}
			$next_start=mktime((int)$n_date_h,(int)$n_date_i,0,$n_date_m,$n_date_d,$n_date_y);
			//debug(date('d.m.Y H:i',$next_start));
			if ($next_start && $next_start!=$obj['StartDate']) {
				$diff=$next_start-$obj['StartDate']+=$cal->date_dist_cmp($next_start,$obj['StartDate']);
				$next_end=$obj['EndDate']+$diff;
				$next_end+=$cal->date_dist_cmp($next_end,$obj['EndDate']);

				require_once('lib/cal/class_EventMoveGui.php');
				$contGui=new EventMoveGui();

				if (Framework::getParam('conflictTested',0)) {
					$contGui->setCheckConflict(0);
				}
				$nData=array();
				$nData['StartDate']=$next_start;
				$nData['EndDate']=$next_end;
				$nData['moveOne']=Framework::getParam('move_one','');


				$newID=$contGui->moveEvent(Framework::getParam('event_id'),$nData,Framework::getParam('edate',mktime(0,0,0)));
				if ($newID) {
					page_close();
					header("location:index.php?site=$site&action=view&view=event&edate=$edate&event_id=$newID");
					exit;
				} elseif (($conflict=$contGui->getConflict())) {
					$confGui=$contGui->getConflictGui(false);
					$frm->savePostData($cal->getModul(),'post_conflict',array());
					require_once('lib/class_TemplateGui.php');

					$TopGui=new TemplateGui('core/common_form.inc.html');
					$TopGui->addContent('cont1',$confGui,'CONTENT');
					$TopGui->addContent('faction',$L->getTempLink(null,array('move_one'=>Framework::getParam('move_one',''))),'FORM_ACTION');
					$t->assign('show_conflict',$TopGui->process());
					$tplShow='show_conflict';
				}

			}
		}
		if ($del_user && $del_user!=$obj['OwnerID']) {
			//$cal->deleteEventDone($event_id,'u',$del_user);
		}

	}
	if (($deny_x || $accept_x || ($unsec_x && $user_id==$obj['OwnerID'])) && ($CAL_PERMS&2)) {

		if ($deny_x) {
			$done=2;
		} elseif ($unsec_x) {
			$done=1;
		} else {
			$done=1;
		}
		$cal->insertEventDone($event_id,'u',$user_id,$done);
		if ($done==2) {
			$logTyp='deny';
			$cal->insertLog($event_id,$cal->getUser(),strtr($T->lang('[[action_'.$logTyp.'_text]]'),$log_tras),'deny');
		} else {
			$logTyp='accept';
			$cal->insertLog($event_id,$cal->getUser(),strtr($T->lang('[[action_'.$logTyp.'_text]]'),$log_tras),'accept');
			if ($unsec_x) {
				$cal->delUnsecure($event_id);
				$obj['Unsecure']=0;
				$obj['TimeModify']=time();
				$obj['UserModify']=$user_id;
			}
			$cal->updateEventModify($event_id);
		}
		if ($obj['Message'] && $cal->getUser() != $obj['OwnerID']) {
			$frm->sendmessage(array($obj['OwnerID']),
				$cal->getUser(),
				strtr($T->lang('[[action_'.$logTyp.'_title]]'),$log_tras),
				strtr($T->lang('[[action_'.$logTyp.'_text]]'),$log_tras),
				"?site=$site&action=view&view=event&edate=$edate&event_id=$event_id",
				$obj['Title'],
				$cal->getCfg('cfg/img_notes'));
		}
		if ($done==2) {
			page_close();
			header("location:".$CAL_REFERER[0]);
			exit;
		}
	}
	if (isset($send_x) && ($CAL_PERMS&2)) {
		$logTyp='log';
		$cal->insertLog($event_id,$cal->getAuthUser(),strtr($T->lang('[[action_'.$logTyp.'_text]]'),$log_tras),'log');
		if ($obj['Message'] || $send_owner || $send_all) {
			unset($send_user);
			if ($obj['OwnerID']!=$auth->auth['uid']) $send_user[]=$obj['OwnerID'];
			if ($send_all) {
				$user_done=$cal->readEventDone($event_id,'u');

				foreach ($user_done as $key=>$val) {
					if ($key!=$auth->auth['uid'] && ($val==1 || $val==3)) {
						$send_user[]=$key;
					}
				}
			}
			if ($send_user) {
				$frm->sendmessage($send_user,
					$auth->auth['uid'],
					strtr($T->lang('[[action_'.$logTyp.'_title]]'),$log_tras),
					strtr($T->lang('[[action_'.$logTyp.'_text]]'),$log_tras),
					"?site=$site&action=view&view=event&edate=$edate&event_id=$event_id",
					$obj['Title'],
					$cal->getCfg('cfg/img_notes'));
			}
		}
	}

	if ($tplShow=='show_view') {
		$form_action="index.php?site=$site&action=view&view=event&event_id=$event_id&edate=$edate";
		$t->assign("FORM_ACTION",$form_action);
		$t->assign("EVENT_TITLE",Framework::entities($obj['Title']));
		$t->assign("EVENT_CAT",is_object($category)?Framework::entities($category->getName()):'-');
		$t->assign("EVENT_ID",$event_id);
		$t->assign("EVENT_DATE",$edate);


		if ($obj['RecType']) {
			if ($obj['RecInt']>1) $t->assign('REC_INT',' '.$obj['RecInt']);
			else $t->assign('REC_INT','');
			$t->parse('ROW',"recur_".$obj['RecType']);
			if ($obj['RecEnd']!=-1) {
				$t->assign('REC_END',date('d.m.Y',$obj['RecEnd']));
				$t->parse('ROW','rec_end');
			}
			if ($obj['Exception']) {
				$tmp_ex=explode(',',$obj['Exception']);
				sort($tmp_ex);
				foreach ($tmp_ex as $key=>$val) {
					$tmp_ex[$key]=date('d.m.Y',$val);
				}
				$t->assign('REC_EX',implode(', ',$tmp_ex));
				$t->parse('ROW','rec_ex');
			}
			$t->parse('ROW','recurence');
		}



		$t->assign("EVENT_START",$cal->formatDate($obj['StartDate'],$obj['EndDate'],$obj['TimeMode'],"%A, %d.%m.%Y"));
		$t->assign("EVENT_DESC",nl2br(Framework::entities($obj['Text'])));
		if ($obj['FKProjID'] && $P) {
			$pName=$P->getCachedProjectName($obj['FKProjID']);
			if ($pName) {
				$t->assign("EVENT_PROJECT",Framework::entities($pName));
				$t->assign('L_PROJ','index.php?site=proj.php&oid='.$obj['FKProjID']);
				$t->parse('ROW','event_project');
			}
		}
		if ($obj['Place']) {
			$t->assign("EVENT_PLACE",Framework::entities($obj['Place']));
			$t->parse('ROW','event_place');
		}


		if ($obj['AlarmTime']) {
			if ($obj['TimeMode']==1 && ($obj['AlarmTime']+3600*12)%(3600*24)==0) {
				$obj['AlarmTime']+=3600*12;
			}
			if ($obj['AlarmTime']%(3600*24)==0) {
				$AlarmTyp='d';
				$AlarmTime=$obj['AlarmTime']/(3600*24);
			} elseif ($obj['AlarmTime']%(3600)==0) {
				$AlarmTyp='h';
				$AlarmTime=$obj['AlarmTime']/(3600);
			} else {
				$AlarmTyp='m';
				$AlarmTime=floor($obj['AlarmTime']/(60));
			}
			$t->assign('EVENT_ALARM',$AlarmTime);
			$t->parse('ROW','y_alarm_'.$AlarmTyp);
			$t->parse('ROW','y_alarm');
		} else {
			$t->parse('ROW','n_alarm');
		}
		if ($obj['PrevTime']) {
			if ($obj['PrevTime']%(3600*24)==0) {
				$PrevTyp='d';
				$PrevTime=$obj['PrevTime']/(3600*24);
			} elseif ($nobj['PrevTime']%(3600)==0) {
				$PrevTyp='h';
				$PrevTime=$obj['PrevTime']/(3600);
			} else {
				$PrevTyp='m';
				$PrevTime=floor($obj['PrevTime']/(60));
			}
			$t->assign('EVENT_PREV',$PrevTime);
			$t->parse('ROW','y_prev_'.$PrevTyp);
			$t->parse('ROW','y_prev');
		} else {
			$t->parse('ROW','n_prev');
		}


		$t->assign("EVENT_USER",$owner[$obj['OwnerID']]);
		$event_invit=$owner[$obj['OwnerID']];
		$tmp_invit=0;
		$log_book=0;

		$InvitGroups=explode(',',$obj['InvitGroups']);
		$InvitUsers=explode(',',$obj['InvitUsers']);
		if ($obj['InvitAddr']) $InvitAddr=explode(',',$obj['InvitAddr']);
		else $InvitAddr='';
		$tpmGusers=$frm->getGroupUsers($InvitGroups);
		if (!is_array($tpmGusers)) $tpmGusers=array();
		if (is_array($tpmGusers)) $tpmGusers=array_keys($frm->getApplicationUsers('cal',$tpmGusers));
		$i_users=array_filter(array_unique(array_merge($tpmGusers,$InvitUsers,array($obj['OwnerID']))),'intval');
		$user_done=$cal->readEventDone($event_id,'u');
		if (($CAL_PERMS&2) && in_array($user_id,$i_users)) {
			if ($obj['Unsecure'] && $user_id==$obj['OwnerID'] && $editPerms) {
				$t->parse("ROW","unsecure");
			} elseif (!isset($user_done[$user_id]) && !$obj['NoInvit']) {
				$t->parse("ROW","invitation");
			} else {
				$log_book=1;
			}
		}

		if ($obj['InvitResources']) {
			$calRes=& $frm->getStaticModul('cal_res');
			$InvitResources=explode(',',$obj['InvitResources']);
			foreach ($InvitResources as $val) {
				if (strpos($val,'@')) {
					$tmp=explode('@',$val);
					$rid=$tmp[0];
					$needed=$tmp[1];
				} else {
					$rid=$val;
					$needed=1;
				}
				$rObj=$calRes->getCachedObj($rid);
				if ($rObj) {
					$t->assign('RESOURCES',($needed>1?$needed.' x ':'').FrameWork::entities($rObj->getName()));
					if ($rObj->getMeta('calResText')) {
						$t->assign('RESOURCES_TEXT',FrameWork::entities($rObj->getMeta('calResText'),1));
						$t->parse("ROW","resources_row_text");
					}
					$t->parse("ROW",".resources_row");
					$t->clear_dynamic("resources_row_text");
				}
			}
			$t->parse("ROW","resources");
		}


		/*if (!$log_book && $cal->getAllCalPerms($obj['OwnerID'],2)) {
			$log_book=1;
		}*/
		if ($log_book) {
			if ($CAL_PERMS&2) {
				if ($auth->auth['uid']!=$obj['OwnerID']) {
					if ($obj['Message']) {
						$t->assign('CHK_SEND_OWNER','checked="true"');
						$t->assign('DIS_SEND_OWNER','disabled="true"');
					} else {
						$t->assign('DIS_SEND_OWNER','');
						$t->assign('CHK_SEND_OWNER','');
					}
					$t->parse('ROW','send_owner');
				}
				if (count($i_users)>1) {
					$t->assign('CHK_SEND_ALL','');
					$t->parse('ROW','send_all');
				}
				$t->parse('ROW','logbook');
			}
		}
		if ($obj['EvtPrivat']) {
			$t->parse('ROW','owner_privat');
		}


		$t->assign('EVENT_OWNER',reset($frm->getFullName($obj['OwnerID'],0,1)));

		if ($obj['NoInvit']) {
			if ($user_done[$obj['OwnerID']]==3) {
				$t->parse('ROW','owner_unsec');
			} else {
				$log_list=$cal->listLog($event_id,array('accept'),$obj['OwnerID']);
				if ($logval=reset($log_list)) {
					if ($logval['Text']) $t->assign('LOG_TEXT',nl2br("\n".htmlspecialchars($logval['Text'])));
					if ($logval['Date']) $t->assign('LOG_DATE',date('d.m.Y',$logval['Date']));
					$t->parse('ROW','owner_accept');
				}
			}

			$parse=0;
			if ($obj['InvitUsers']) {
				$tmp=$frm->getFullName(explode(',',$obj['InvitUsers']),0,1);
				if (is_array($tmp)) {
					foreach ($tmp as $val) {
						$t->assign("LIST_USERS",$val);
						$t->parse('ROW','.invit_user');
					}
					$parse=1;
				}
			}
			if ($obj['InvitGroups']) {
				$tmp=$frm->getAllGroups(explode(',',$obj['InvitGroups']),-1);
				if (is_array($tmp)) {
					foreach ($tmp as $val) {
						$t->assign("LIST_GROUPS",$val);
						$t->parse('ROW','.invit_group');
					}
					$parse=1;
				}
			}
			if ($parse)  $t->parse('ROW','no_invit');


		} else {
			$all_users=$frm->getFullName($i_users,0,1);
			$parse_invit=false;
			foreach ($i_users as $key) {
				if (!$key) continue;
				$t->clear_dynamic('user_wait');
				$t->clear_dynamic('user_deny');
				$t->clear_dynamic('user_accept');
				$t->clear_dynamic('user_unsec');
				$t->clear_dynamic('del_user');
				$t->clear_dynamic('user_msg');
				$t->assign('EVENT_USER',$all_users[$key]);
				if ($app['msg'] || $app['sms']) {
					$msgParams=array(
						'invReset'=>1,
						'invTab'=>'msg',
					);
					if ($app['msg']) {
						$msgParams['msgToAdd']='u_'.$key;
						$msgParams['msgLink']=json_encode(array(array('U'=>"index.php?site=$site&action=$action&view=$view&edate=$edate&event_id=".$event_id,'N'=>$obj['Title'])));
					}
					if ($app['sms'] && $frm->getCachedUser($key,'mobil')) {
						$msgParams['smsToAdd']=$frm->getStaticModul('sms')->formatNumber($frm->getCachedUser($key,'mobil'),$frm->getCachedUserName($key));
						$msgParams['smsMessage']=$cal->formatDate($obj['StartDate'],$obj['EndDate'],$obj['TimeMode'],"%d.%m.%Y").' - '.$obj['Title'];
					}
					$t->assign('L_MSG','javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));');
					if ($key==$obj['OwnerID'] && $obj['OwnerID']!=$frm->getUser()) {
						$t->parse('ROW','owner_msg');
					}
					$t->parse('ROW','user_msg');
				}
				$t->assign('LOG_TEXT','');
				$t->assign('LOG_DATE','');
				if ($key==$obj['OwnerID']) {
					$t->assign('ROW_COLOR',$bgcolor);
					if ($user_done[$key]==3) {
						$t->parse('ROW','owner_unsec');
						$t->parse('ROW','user_unsec');
					} else {
						$log_list=$cal->listLog($event_id,array('accept'),$key);
						if ($logval=reset($log_list)) {
							if ($logval['Text']) $t->assign('LOG_TEXT',nl2br("\n".htmlspecialchars($logval['Text'])));
							if ($logval['Date']) $t->assign('LOG_DATE',date('d.m.Y',$logval['Date']));
							$t->parse('ROW','owner_accept');
						}
						$t->parse('ROW','user_accept');
						
					}
				} elseif (!$user_done[$key]) {
					$t->assign('ROW_COLOR','#efefef');
					$t->parse('ROW','user_wait');
					$parse_invit=true;
				} elseif ($user_done[$key]==2) {
					$t->assign('ROW_COLOR',$fg10color);
					$log_list=$cal->listLog($event_id,array('deny'),$key);
					$logval=reset($log_list);
					if ($logval['Text']) $t->assign('LOG_TEXT',nl2br("\n".htmlspecialchars($logval['Text'])));
					if ($logval['Date']) $t->assign('LOG_DATE',date('d.m.Y',$logval['Date']));

					/*if ($user_id==$obj['OwnerID'] || $cal->getAllCalPerms($obj['OwnerID'],2)) {
						$t->assign("DEL_USER_LINK",$form_action."&del_user=$key");
						$t->parse('ROW','del_user');
					}*/

					$t->parse('ROW','user_deny');
					$parse_invit=true;
				} else {
					$t->assign('ROW_COLOR',$bgcolor);
					$log_list=$cal->listLog($event_id,array('accept'),$key);
					$logval=reset($log_list);
					if ($logval['Text']) $t->assign('LOG_TEXT',nl2br("\n".htmlspecialchars($logval['Text'])));
					if ($logval['Date']) $t->assign('LOG_DATE',date('d.m.Y',$logval['Date']));
					$t->parse('ROW','user_accept');
					$parse_invit=true;
				}
				$t->parse('ROW','.user_row');
			}
			if ($parse_invit) $t->parse('ROW','view_invit');
		}

		
		$smsTo=$msgTo=array();
		foreach ($i_users as $key) {
			if ($app['sms']) {
				if ($key!=$frm->getUser() && $frm->getCachedUser($key,'mobil')) {
					$smsTo[]=$frm->getStaticModul('sms')->formatNumber($frm->getCachedUser($key,'mobil'),$frm->getCachedUserName($key));
				}
			}
			if ($app['msg']) {
				if ($key!=$frm->getUser()) {
					$msgTo[]='u_'.$key;
				}
			}
		}


		if (!empty($InvitAddr) && is_array($InvitAddr)) {
			$smsAddrTo=array();
			$t->define(array('tpl_view_addr'=>'view_addr.inc.html'));
			$t->assign('ROW_COLOR',$bgcolor);
			$parse_cont=0;
			$Addr=& $frm->getStaticModul('addr');
			$Addr->getPerms();
			$mail_to_all=array();
			$address_array=$Addr->getAddrObj($InvitAddr);
			foreach ($address_array as $address) {
				$t->clear_dynamic('user_mail');
				$temp=$Addr->addrExplode($address->getMeta('Email'));
				foreach ($temp as $tval) {
					if ($tval) {
						if ($app['email']) {
							$mail_to_all[]=$Addr->formatMail($address,$tval);
							$link=$form_action."&obj_action_val=s_mail&obj_action_x=1&mail_to=".urlencode($Addr->formatMail($address,$tval));
						} else {
							$link="mailto:".htmlspecialchars($Addr->formatMail($address,$tval));
						}
						$t->assign('L_MAIL',$link);
						$t->parse('ROW','user_mail');
						break;
					}
				}
				$temp=$Addr->addrExplode($address->getMeta('ATel'));
				foreach ($temp as $tval) {
					if ($tval) {
						$t->assign('ADDR_TEL',$tval);
						$t->parse('ROW','addr_tel');
						break;
					}
				}
				$temp=$Addr->addrExplode($address->getMeta('Mobil'));
				foreach ($temp as $tval) {
					if ($tval) {
						$t->assign('ADDR_MOBIL',$tval);
						$t->parse('ROW','addr_mobil');
						if ($app['sms']) {
							$smsNumber=$frm->getStaticModul('sms')->formatNumber($tval,$address->getName(1));
							$msgParams=array(
								'invReset'=>1,
								'invTab'=>'sms',
								'smsMessage'=>$cal->formatDate($obj['StartDate'],$obj['EndDate'],$obj['TimeMode'],"%d.%m.%Y").' - '.$obj['Title'],
								'smsToAdd'=>$smsNumber,
							);
							$t->assign('L_MSG','javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));');
							$t->parse('ROW','user_sms');
							$smsTo[]=$smsNumber;
							$smsAddrTo[]=$smsNumber;
						}
						break;
					}
				}
				if ($address->getACL(2)) {
					$t->assign('ADDR_NAME','<a href="'.$form_action.'&_goToAddr='.$address->getId().'">'.Framework::entities($address->getName())."</a>");
				} else {
					$t->assign('ADDR_NAME',Framework::entities($address->getName()));
				}
				$t->parse('ROW','.addr_view_row');
				$t->clear_dynamic('addr_tel');
				$t->clear_dynamic('user_mail');
				$t->clear_dynamic('user_sms');
				$t->clear_dynamic('addr_mobil');
				$parse_cont=1;
			}
			if ($parse_cont) {
				if (!empty($mail_to_all)) {
					$t->assign('L_MAIL_ALL',$form_action."&obj_action_val=s_mail&obj_action_x=1&mail_to=".urlencode(implode(',',$mail_to_all)));
					$t->parse('ROW','user_mail_all');
				}
				if (!empty($smsAddrTo)) {
					$msgParams=array(
						'reset'=>1,
						'tab'=>'sms',
						'smsMessage'=>$cal->formatDate($obj['StartDate'],$obj['EndDate'],$obj['TimeMode'],"%d.%m.%Y").' - '.$obj['Title'],
						'smsTo'=>implode(',',$smsAddrTo),
					);
					$t->assign('L_MSG_ALL','javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));');
					$t->parse('ROW','user_sms_all');
				}				
				$t->parse('TPL_VIEW_ADDR','tpl_view_addr');
			} else $t->assign('TPL_VIEW_ADDR','');
		} else $t->assign('TPL_VIEW_ADDR','');



		$i=1;
		$log_list=$cal->listLog($event_id,'log','');
		foreach ($log_list as $key=>$val) {
				$t->assign('LOG_TEXT',nl2br(Framework::entities($val['Text'])));
				if ($val['User']==$obj['OwnerID'] && $obj['_Privat']) {
					$t->assign('LOG_TEXT',$T->lang('[[PRIVAT]]'));
				}
				$t->assign('LOG_DATE',date('d.m.Y - H:i',$val['Date']));
				if (!$all_users[$val['User']]) {
					$temp=$frm->getFullName($val['User'],0,1);
					$all_users[$val['User']]=$temp[$val['User']];
				}
				$t->assign('LOG_USER',$all_users[$val['User']]);
				if ($obj['OwnerID']==$auth->auth['uid']) {
					if ($dlog && $dlog==$key) {
						$cal->deleteLog($dlog);
						continue;
					}
					$t->assign('DEL_LOG',$form_action.'&dlog='.$key);
					$t->parse('ROW','del_log');
				} else {
					$t->clear_dynamic('ROW','del_log');
				}
				if ($app['msg'] || $app['sms'] || $app['rem']) {
					$msgParams=array(
						'reset'=>1,
						'tab'=>'msg',
						'smsMessage'=>$cal->formatDate($obj['StartDate'],$obj['EndDate'],$obj['TimeMode'],"%d.%m.%Y").' - '.$obj['Title']."\n".$val['Text'],
						'msgSubject'=>$cal->formatDate($obj['StartDate'],$obj['EndDate'],$obj['TimeMode'],"%d.%m.%Y").' - '.$obj['Title'],
						'msgMessage'=>$val['Text'],
						'remMessage'=>$val['Text'],
						'remObjName'=>$obj['Title'],
						'remObjTyp'=>'cal',
						'remObjId'=>$event_id,
						'smsTo'=>implode(',',$smsTo),
						'msgTo'=>implode(',',$msgTo),
					);
					$msgParams['msgLink']=json_encode(array(
						array('U'=>"index.php?site=$site&action=$action&view=$view&edate=$edate&event_id=".$event_id,'N'=>$obj['Title']),
					));
					if (!empty($smsTo)) {
						$msgParams['tab']='sms';
					}
					//debug($msgTo);
					$t->assign('L_MSG','javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));');
					$t->parse('ROW','sms_log');
				}	else {
					$t->clear_dynamic('ROW','sms_log');
				}
				
				if ($i%2) $t->assign('ROW_COLOR','#efefef'); else $t->assign('ROW_COLOR',$bgcolor);
				$t->parse('ROW','.log_row');
				$i++;
		}
		if ($i>1) $t->parse('ROW','view_logbook');

		if ($frm->appExists('fmng')) {
			$hl=0;$parse_fmng=0;
			$fmng_list=$cal->listEventFmng($event_id);
			if (!empty($fmng_list)) {
				$Fmng=& $frm->getStaticModul('fmng');
				require_once('lib/class_ApplicationListGui.php');
				$fmgListGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
				foreach ($fmng_list as $val) {
					$fObj=$Fmng->getObj($val,'',false);
					if (is_object($fObj) && !$fObj->getMeta('Trash')) {
						$temp=$Fmng->getObjTree($fObj->getID());
						$fmgListGui->addRow($hl=$hl?0:1,'top');
						$fmgListGui->addCol('Img','',$fObj->getImage(),'','',1,'');
						$fmgListGui->addCol('Title',implode('/',array_reverse($temp)).'/'.$fObj->getName(),'',$fObj->getAcl(1)?('index.php?site=fmng.php&action=fu&oid='.$fObj->getID()):'','',0,'2000');
						$parse_fmng=1;
						//debug($fObj);
					}
				}
				if ($parse_fmng) {
					$t->assign('EVT_FMG',$fmgListGui->process());
					$t->parse('ROW','view_evtfmng');
				}
			}
		}



		$grant=0;
		if ($obj['GrantUsers']) {
			$grant_user=$frm->getFullName(explode(',',$obj['GrantUsers']),0,1);
			if (is_array($grant_user)) {
				foreach ($grant_user as $val) {
					$t->assign("GRANT_USERS",$val);
					$t->parse('ROW','.grant_user');
				}
				$grant=1;
			}
		}
		if ($obj['GrantGroups']) {
			$grant_groups=$frm->getAllGroups(explode(',',$obj['GrantGroups']),-1);
			if (is_array($grant_groups)) {
				foreach ($grant_groups as $val) {
					$t->assign("GRANT_GROUPS",$val);
					$t->parse('ROW','.grant_group');
				}
				$grant=1;
			}
		}
		if ($grant)  $t->parse('ROW','grant');

		if ($obj['Message']) {
			$t->parse('ROW','y_message');
		} else {
			$t->parse('ROW','n_message');
		}



		if ($editPerms) {
			if ($CAL_PERMS&2) {
				if (!$n_date) $n_date=date('d/m/Y',$obj['StartDate']);
				$t->assign('N_DATE',$n_date);
				if (!$obj['TimeMode']) {
					if (!$n_date_h) $n_date_h=date('H',$obj['StartDate']);
					if (!$n_date_i) $n_date_i=date('i',$obj['StartDate']);
					$t->assign('N_DATE_H',$n_date_h);
					$t->assign('N_DATE_I',$n_date_i);
					$t->parse('ROW','move_time');
					$t->parse('ROW','option_time');
				}
				if ($obj['RecType']) {
					if ($move_one || !isset($move_one)) $t->assign('CHK_MONE','checked="true"'); else $t->assign('CHK_MONE','');
					$t->parse("ROW","move_one");
				}
				if (!$m_typ) $m_typ=1;
				if ($m_typ==1) $t->assign('CHK_MTYP_1','checked="true"'); else $t->assign('CHK_MTYP_1','');
				if ($m_typ==2) $t->assign('CHK_MTYP_2','checked="true"'); else $t->assign('CHK_MTYP_2','');
				$t->parse("ROW","move_event");
			}

		}
		if ($frm->getMyApps('zef') && in_array($frm->getUser(),$i_users)) {
			$t->parse("ROW","insert_zef");
		}
		$parse=0;
		$obj_action=$frm->getObjAction($cal->getModul(),'evt');
		//debug($obj_action);
		foreach ($obj_action as $key=>$val) {
			if (!$val['Hidden'] && $cal->isAllowedAction($obj,$val)) {
				$t->assign('SEL_VAL',$key);
				$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
				$t->parse('ROW','.obj_action_val');
				$parse=1;
			}
		}
		if ($parse) $t->parse('ROW','obj_action');


		$t->assign("L_BREAK",$CAL_REFERER[0]);
		$t->parse('ROW','break');
	}
	$t->parse('ROW',$tplShow);
}
?>
