<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$T->loadModul('config');
require("lib/class_form.inc.php");
$t->assign('MOD_TITLE','Configuration');
$t->setRoot("tpl/$THEME/config/$session_lang");
$t->define (array('content' => "header.inc.html"));
$t->assign('CFG_ON','off');
$t->assign('DEF_ON','off');
$t->assign('DB_ON','off');
$t->assign('CHK_ON','off');
require_once('update/version.php');
$DomainUse='';
if ($USE_DOMAIN) {
	if (!$sess->is_registered("DB_use")) {
		$sess->register("DB_use");
	}
	if ($set_db_use) {
		$DB_use=$set_db_use;
	}
	$query="SHOW DATABASES LIKE '".(defined('GE_DB_PREPEND')?GE_DB_PREPEND:'group-e_')."%'";
	$db->query($query);
	while ($db->next_record()) {
		$DB_groupe[$db->f('Database ('.(defined('GE_DB_PREPEND')?GE_DB_PREPEND:'group-e_').'%)')]=$db->f('Database ('.(defined('GE_DB_PREPEND')?GE_DB_PREPEND:'group-e_').'%)');
	}
	if (!isset($DB_groupe[$DB_use])) {
		$DB_use=GE_DB;
	}
	if (defined('GE_DB_PREPEND')) {
		$DomainUse=preg_replace('/^'.preg_quote(GE_DB_PREPEND,'/').'/','',$DB_use);
	} else {
		$DomainUse=$DB_use;
	}
	if (file_exists(GE_DYN_PATH.'/domain_config') && is_dir(GE_DYN_PATH.'/domain_config')) {
		$dh=opendir(GE_DYN_PATH.'/domain_config');
		while (($file=readdir($dh))!==false) {
			if (is_file(GE_DYN_PATH.'/domain_config/'.$file)) {
				$tmpDomainIni=parse_ini_file(GE_DYN_PATH.'/domain_config/'.$file);
				if (str_replace('.','_',$tmpDomainIni['myDomain'])==$DomainUse) {
					$myDomainIni=$tmpDomainIni;
					break;
				}
			}
		}
	}
	if (!$myDomainIni['userDomainSuffix']) $myDomainIni['userDomainSuffix']=$DomainUse;
	if (!$myDomainIni['groupDomainSuffix']) $myDomainIni['groupDomainSuffix']=$DomainUse;
	if (!$myDomainIni['mailUserSuffix']) $myDomainIni['mailUserSuffix']=$myDomainIni['userDomainSuffix']?'_'.$myDomainIni['userDomainSuffix']:'';



	foreach ($DB_groupe as $val) {
		if ($val==$DB_use) {
			$t->assign('DB_CHK','selected="selected"');
		} else {
			$t->assign('DB_CHK','');
		}
		$t->assign('DB_KEY',htmlspecialchars($val));
		$t->assign('DB_VAL',htmlspecialchars($val));
		$t->parse('ROW','.groupe_db');
	}
	$t->assign('EXT_DB',$DB_use);
	$t->parse('ROW','ext_groupe');
	$t->assign('I_ACTION',"index.php?site=$site&mode=$mode&action=$action&modul=$modul");
	$t->parse('ROW','set_groupe_db');
	$db->Link_ID=0;
	$db->Database=$DB_use;
	if ($GLOBALS['CFG']['USER_CLASS']!='ldap_full') {
		//DB-Objekt von Framework mit globalem DB Objekt verknüpfen sonst geht das multidomain nicht 
		$frm->db=&$db;
	}
	if ($CFG['USER_CLASS']=='ldap_full') {
		$frm->setDomain(str_replace('_',GE_LDAP_DOMAIN_SEP,$DomainUse));
	}
	$frm->setFrmCfg($frm->getCfg('global',0,array('cfg/%','ldap/%')));
} else {
	$myDomainIni=array(
		'userDomainSuffix'=>'',
		'groupDomainSuffix'=>'',
		'mailUserSuffix'=>'',
	);
}
$av_apps=$frm->getApplication();
$DB_version=$frm->getVersion('group-e');
if ($VERSION!=$DB_version['Version'] && $mode!='chk') {
	$mode='db';
}
if (defined('GE_DYN_PATH_OK') && !GE_DYN_PATH_OK) {
	$ActionError['dynPath']="For security reason dyn path has changed<br />";
	$ActionError['dynPath'].="Please move folder: '".realpath('dyn')."'<br>to: '".realpath('..').'/dyn'."'<br /><br />";
	$ActionError['dynPath'].="execute as root<br />";
	$ActionError['dynPath'].='mv "'.realpath('dyn').'" "'.realpath('..').'/dyn"';

}

switch ($mode) {
	case 'cfg':
		$t->assign('CFG_ON','on');
		require('config/config.php');
	break;
	case 'def':
		$t->assign('DEF_ON','on');
		require('config/defaults.php');
	break;
	case 'db':
		$t->assign('DB_ON','on');
		require('config/update.php');
	break;
	default:
		$t->assign('CHK_ON','on');
		require_once('config/check_install.php');
}
if ($ActionError) {
	require('config/view_error.php');
}

if (!$t->isparsed('TPL_ERROR')) {
	$t->assign('TPL_ERROR','');
}
$t->parse("TPL_APPLICATION","application");
$t->parse("CONTENT","content");
$t->FastPrint();
$sess->that->db->Link_ID=0;
?>
