<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$l_this="index.php?site=$site&action=$action&mode=$mode&modul=$modul";
$CfgKeys=$frm->getCfgKeys($modul,'def/%');
if (isset($config_save_x) || isset($config_save_all_x)) {
	foreach ($CfgKeys as $key=>$val) {
		if (!isset($CfgVal[$key])) $CfgVal[$key]=0;
		if ($val['FieldTyp']='msel' && is_array($CfgVal[$key])) $CfgVal[$key]=implode('|',$CfgVal[$key]);
	}
	if ($USE_DOMAIN) {
		if ($config_save_all_x) {
			$update_dbs=$DB_groupe;
		} else {
			$update_dbs=array($DB_use);
		}
	} else {
		$update_dbs=array($db->Database);
	}
	foreach($update_dbs as $val) {
		$db->Link_ID=0;
		$db->Database=$val;
		$frm->setCfg($modul,0,$CfgVal,'def/%');
	}
	$db->Link_ID=0;
	$db->Database=GE_DB;
	page_close();
	header("Location:$l_this");
	exit;
} else {
	$CfgVal=$frm->getCfg($modul,0,'def/%');
}
if (is_array($CfgKeys)) {
	foreach ($CfgKeys as $key=>$val) {
		switch ($val['FieldTyp']) {
			case 'text':
				$t->assign('CFG_KEY_NAME',FrameWork::entities($val['Name']));
				$field_size=explode('|',$val['Size']);
				if (!isset($CfgVal[$key]) && $val['CfgVal']) $CfgVal[$key]=$val['CfgVal'];
				if ($field_size[0]==1) {
					$tpl_field=new TextField("CfgVal[$key]",'class="sel" size="'.$field_size[1].'"');
				} else {
					$tpl_field=new TextArea("CfgVal[$key]",'class="sel" rows="'.$field_size[0].'" cols="'.$field_size[1].'"');
				}
				$t->assign('CFG_KEY_FIELD',$tpl_field->f());

				break;
			case 'chk':
				$t->assign('CFG_KEY_NAME',FrameWork::entities($val['Name']));
				if (!isset($CfgVal[$key]) && $val['CfgVal']) $CfgVal[$key]=$val['CfgVal'];
				$tpl_field=new CheckBox("CfgVal[$key]");
				$t->assign('CFG_KEY_FIELD',$tpl_field->f($val['Size']));
				break;
			case 'sel':
				$field_array=array();
				if (strpos($val['Size'],'FUNC:')===0) {
					$func=substr($val['Size'],5);
					$field_array=$func();
				} else {
					$temp=explode(',',$val['Size']);
					foreach ($temp as $tval) {
						if (strpos($tval,'=>')) {
							$temp2=explode('=>',$tval);
							$field_array[$temp2[0]]=$temp2[1];
						} else {
							$field_array[$tval]=$tval;
						}
					}
				}
				$t->assign('CFG_KEY_NAME',FrameWork::entities($val['Name']));
				if (!isset($CfgVal[$key]) && $val['CfgVal']) $CfgVal[$key]=$val['CfgVal'];
				$tpl_field=new SelectField("CfgVal[$key]",'class="sel"',$field_array);
				$t->assign('CFG_KEY_FIELD',$tpl_field->f());
				break;
			case 'msel':
				$field_array=array();
				if (strpos($val['Size'],'FUNC:')===0) {
					$func=substr($val['Size'],5);
					$field_array=$func();
				} else {
					$temp=explode(',',$val['Size']);
					foreach ($temp as $tval) $field_array[$tval]=$tval;
				}
				$size=count($field_array)+1;
				if ($size<3) $size=3;
				$t->assign('CFG_KEY_NAME',FrameWork::entities($val['Name']));
				if (!isset($CfgVal[$key]) && $val['CfgVal']) $CfgVal[$key]=$val['CfgVal'];
				$CfgVal[$key]=explode('|',$CfgVal[$key]);
				$tpl_field=new SelectField("CfgVal[$key]",'class="sel" size="'.$size.'"',$field_array,"",1,"");
				$t->assign('CFG_KEY_FIELD',$tpl_field->f());
				break;
			case 'info':
				$t->assign('CFG_KEY_NAME','<strong>'.FrameWork::entities($val['Name']).'</strong>');
				$t->assign('CFG_KEY_FIELD','');
				break;

		}
		$t->parse('ROW','.cfg_row');
	}
}
$t->assign('FORM_ACTION',$l_this);
$t->assign('L_BREAK',"index.php?site=$site");
$t->parse('ROW','break');
if ($USE_DOMAIN) {
	$t->parse('ROW','update_all');
}
$t->parse('ROW','update');

function getMaLang() {
	return $GLOBALS['frm']->getMaLang();
}
function getGroups() {
	return $GLOBALS['frm']->getAllGroups();
}
function getFGColors() {
	global $THEME;
	require("cfg/$THEME/global/colors_managment.inc.php");
	return array_flip($colorfg);
}
function getCalView() {
	$result=array(
		"year"=>"year",
		"month"=>"month",
		"week"=>"week",
		"day"=>"day",
	);
	return $result;

}
function getCalMode() {
	$result=array(
		"0"=>"Privat",
		"1"=>"Team",
	);
	return $result;

}
function getHolidays() {
	return $GLOBALS['frm']->getSelectData('cou');
}
function getCalCats() {
	return Framework::extractObjName($GLOBALS['frm']->getStaticModul('cal_cat')->listObj());
}
function getAddrFields() {
	global $db,$session_lang;
	$db->query("SELECT * FROM AddrFields WHERE Aktiv=1 ORDER BY Sequence");
	while ($db->next_record()) {
		if ( $db->f("Typ")!='perm' && $db->f("Typ")!='stamm' && $db->f("Card")!='n') {
			$title=$db->f("Title_$session_lang");
			if ($db->f("Multi")==1) $title.=" (WORK)";
			if ($db->f("Multi")==2) $title.=" (HOME)";
			$result[$db->f("FieldID")]=$title;
		}
	}
	return $result;
}
?>
