<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                                  |
	|	  39100 Bozen/Bolzano                                                     |
	|	  ITALIEN/ITALIA                                                          |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
    | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
// 
$l_this="index.php?site=$site&action=$action&mode=$mode";
require_once('update/version.php');
$DB_version=$frm->getVersion('group-e');
$mysql_version=explode('.',mysql_get_server_info());
$AddrLdapUpdate=false;
$GoupeUpdate=false;
$UpdateCustom=false;
if ($VERSION!=$DB_version['Version']) {
	$GoupeUpdate=true;
}
if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
	$DB_version_addr_ldap=$frm->getVersion('addr_ldap');
	if ($DB_version_addr_ldap['Version']!=$VERSION_ADDR_LDAP) {
		$AddrLdapUpdate=true;
	}
}
if (defined('GE_CUSTOM_APP') && GE_CUSTOM_APP && file_exists('update/'.GE_CUSTOM_APP.'/version.php')) {
	require_once('update/'.GE_CUSTOM_APP.'/version.php');
	$DB_version_custom=$frm->getVersion('cus_'.GE_CUSTOM_APP);
	if ($DB_version_custom['Version']!=$VERSION_CUSTOM[GE_CUSTOM_APP]) {
		$UpdateCustom=true;
	}
}

if (isset($_POST['update_x']) || isset($_POST['update_all_x']) || isset($_POST['new_db_x'])) {
	if (!@mysql_connect($db->Host,$_POST['db_uname'],$_POST['db_pwd'])) {
		$ActionError['server']= 'Access denied';
	} else {
		$db->Link_ID=0;
		$db->User=$_POST['db_uname'];
		$db->Password=$_POST['db_pwd'];
		if (isset($_POST['new_db_x']) && file_exists('cfg/new_group-e.sql')) {
			if (!file_exists(GE_DYN_PATH.'/domain_config')) {
				if (is_writable(GE_DYN_PATH)) {
					mkdir(GE_DYN_PATH.'/domain_config',0755);
				}
			}
			if (!file_exists(GE_DYN_PATH.'/domain_config') && !is_writable(GE_DYN_PATH.'/domain_config')) {
				$ActionError['server']='PATH: '.GE_DYN_PATH.'/domain_config is not writable';
			} elseif (!trim($_POST['db_domain'])) {
				$ActionError['server']='NO DOMAIN GIVEN';
			} elseif (!trim($_POST['db_domain_url'])) {
				$ActionError['server']='NO URL GIVEN';
			} else {
				$new_domain=(defined('GE_DB_PREPEND')?GE_DB_PREPEND:'group-e_').str_replace('.','_',trim($_POST['db_domain']));
				if (isset($DB_groupe[$new_domain])) {
					$ActionError['server']='DATABASE EXISTS';
				}
			}

			if (!$ActionError) {
				require_once('update/update.php');
				$result=createDB($new_domain,'cfg/new_group-e.sql');
				if (is_array($result)) {
					$ActionError['server']=implode("\n",$result);
				} else {
					$fp=fopen(GE_DYN_PATH.'/domain_config/'.str_replace('/','_',trim($_POST['db_domain_url'])),'w');
					fwrite($fp,'[Global]'."\n");
					fwrite($fp,'myUrl="'.trim($_POST['db_domain_url']).'"'."\n");
					fwrite($fp,'myDomain="'.trim($_POST['db_domain']).'"'."\n");
					fclose($fp);
					if ($CFG['USER_CLASS']=='ldap_full') {
						if ($frm->newDomain($_POST['db_domain'])) {
							$frm->setDomain($_POST['db_domain']);
							$adminUser=$frm->read_user($CFG['SUPERADMIN']);
							$adminGroup=$frm->getAdminGroups($CFG['GROUP_ALL'],true,false);
							if (empty($adminGroup)) {
								$groupdata=array();
								$groupdata['gidGroup-e']=$GLOBALS['CFG']['GROUP_ALL'];
								$groupdata['cn']='All_'.str_replace('.','_',$_POST['db_domain']);
								$groupdata['activGroup-e']=1;
								//debug($groupdata);
								if ($groupID=$frm->insert_group($groupdata)) {
									$adminGroup=$frm->getAdminGroups($CFG['GROUP_ALL'],true,false);
								} else {
									$ActionError['server']=$frm->getError();
								}
							}
							if (empty($adminUser) && !empty($adminGroup)) {
								$userdata=array();
								$userdata["groupe"]=1;
								$userdata["firstname"]='Sysadmin';
								$userdata["lastname"]='Group-e';
								$userdata["username"]='sysadmin_'.str_replace('.','_',$_POST['db_domain']);
								$userdata["password"]='sysadmin';
								$userdata['perms']=0;
								$userdata['uidGroup-e']=$CFG['SUPERADMIN'];
								$userdata['gidnumber']=$adminGroup['gidnumber'];
								//debug($userdata);
								if ($userID=$frm->insert_user($userdata)) {
									$adminUser=$frm->read_user($CFG['SUPERADMIN']);
									$frm->insertGroupUsers($adminGroup['gidnumber'],array($adminUser['uidnumber']));
								} else {
									$ActionError['server']=$frm->getError();
								}
							}
						} else {
							$ActionError['server']=$frm->getError();
						}
					}


					$_POST['update_x']=1;
					$DB_use=$new_domain;
					$db->Link_ID=0;
					$db->Database=$DB_use;
					$DB_version=$frm->getVersion('group-e');
					if ($VERSION!=$DB_version['Version']) {
						$GoupeUpdate=true;
					}
					if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
						$DB_version_addr_ldap=$frm->getVersion('addr_ldap');
						if ($DB_version_addr_ldap['Version']!=$VERSION_ADDR_LDAP) {
							$AddrLdapUpdate=true;
						}
					}
					if (defined('GE_CUSTOM_APP') && GE_CUSTOM_APP && file_exists('update/'.GE_CUSTOM_APP.'/version.php')) {
						require_once('update/'.GE_CUSTOM_APP.'/version.php');
						$DB_version_custom=$frm->getVersion('cus_'.GE_CUSTOM_APP);
						if ($DB_version_custom['Version']!=$VERSION_CUSTOM[GE_CUSTOM_APP]) {
							$UpdateCustom=true;
						}
					}

				}
			}
		}
		if (isset($_POST['update_x']) || isset($_POST['update_all_x'])) {
			if ($GoupeUpdate) require_once('update/update.php');
			if ($AddrLdapUpdate) require_once('update/update_addr_ldap.php');
			if ($UpdateCustom) {
				require_once('update/'.GE_CUSTOM_APP.'/update_custom.php');
			}

			
			if ($USE_DOMAIN) {
				if ($_POST['update_all_x']) {
					$update_dbs=$DB_groupe;
					/*
					$update_domain_ini=array();
					if (file_exists(GE_DYN_PATH.'/domain_config') && is_dir(GE_DYN_PATH.'/domain_config')) {
						$dh=opendir(GE_DYN_PATH.'/domain_config');
						while (($file=readdir($dh))!==false) {
							if (is_file(GE_DYN_PATH.'/domain_config/'.$file)) {
								$tmpDomainIni=parse_ini_file(GE_DYN_PATH.'/domain_config/'.$file);
								$update_domain_ini[str_replace('.','_',$tmpDomainIni['myDomain'])]=$tmpDomainIni;
							}
						}
					}*/
				} else {
					$update_dbs=array($DB_use);
				}
			} else {
				$update_dbs=array($db->Database);
			}
			foreach($update_dbs as $key=>$val) {
				$db->Link_ID=0;
				$db->Database=$val;
				$db->query("SET NAMES 'utf8'");

				if ($USE_DOMAIN) {
					$frm->setFrmCfg($frm->getCfg('global',0,array('cfg/%','ldap/%')));
					if ($CFG['USER_CLASS']=='ldap_full') {
						if (defined('GE_DB_PREPEND')) {
							$frm->setDomain(str_replace('_',GE_LDAP_DOMAIN_SEP,preg_replace('/^'.preg_quote(GE_DB_PREPEND,'/').'/','',$key)));
						} else {
							$frm->setDomain(str_replace('_',GE_LDAP_DOMAIN_SEP,$key));
						}
					}
					/*$myDomainIni=$update_domain_ini[$tmpDomainUse];
					if (!$myDomainIni['userDomainSuffix']) $myDomainIni['userDomainSuffix']=$tmpDomainUse;
					if (!$myDomainIni['groupDomainSuffix']) $myDomainIni['groupDomainSuffix']=$tmpDomainUse;
					if (!$myDomainIni['mailUserSuffix']) $myDomainIni['mailUserSuffix']=$myDomainIni['userDomainSuffix']?'_'.$myDomainIni['userDomainSuffix']:'';
					*/
				}
			
				
				if ($GoupeUpdate) {
					$DB_version=$frm->getVersion('group-e');
					if ($VERSION!=$DB_version['Version']) {
						updateGroupe($DB_version['Version']);
					}
				}
				if ($AddrLdapUpdate) {
					$DB_version_addr_ldap=$frm->getVersion('addr_ldap');

					if ($DB_version_addr_ldap['Version']!=$VERSION_ADDR_LDAP) {
						updateAddrLdap($DB_version_addr_ldap['Version']);
					}
				}
				if ($UpdateCustom) {
					$DB_version_custom=$frm->getVersion('cus_'.GE_CUSTOM_APP);
					if ($DB_version_custom['Version']!=$VERSION_CUSTOM[GE_CUSTOM_APP]) {
						updateCustom($DB_version_custom['Version']);
					}
				}
			}
			$db->Link_ID=0;
			$db->Database=GE_DB;
			page_close();
			header("Location:$l_this");
			exit;
		}
	}
}
if ($action=='new') {
	$t->assign('DB_DOMAIN_URL',htmlspecialchars($_POST['db_domain_url']));
	$t->assign('DB_DOMAIN',htmlspecialchars($_POST['db_domain']));
	$t->assign('DB_UNAME',htmlspecialchars($_POST['db_uname']));
	$t->parse('ROW','new_db');
} else {
	$t->assign('GRP_VERSION',$VERSION);
	$t->assign('DB_VERSION',$DB_version['Version']);
	if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
		$t->assign('ADDR_VERSION',$VERSION_ADDR_LDAP);
		$t->assign('ADDR_DB_VERSION',floatval($DB_version_addr_ldap['Version']));
		$t->parse('ROW','update_addr_ldap');
	}
	$upd_user=false;
	if ($GoupeUpdate || $AddrLdapUpdate || $UpdateCustom) {
		$upd_user=true;
		if ($USE_DOMAIN) {
			$t->parse('ROW','update_all');
		}
		$t->parse('ROW','update');
	}
	if ($upd_user) {
		$t->assign('DB_UNAME',htmlspecialchars($_POST['db_uname']));
		$t->parse('ROW','update_user');
	}
	$t->parse('ROW','update_db');
}
$t->assign('FORM_ACTION',$l_this);
$t->assign('L_BREAK',"index.php?site=$site");
$t->parse('ROW','break');


?>
