<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

$t->assign('MOD_TITLE',$frm->getAppName('fmng'));
if (!$app["fmng"]) {
	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
} else {
	//$auth->auth['uid']=84;
	$user_id=$auth->auth['uid'];
	require_once('lib/fmng/header.php');

	$t->setRoot("tpl/$THEME/fmng/$session_lang");
	$t->define (array('application' => "header.inc.html"));
	unset($obj);
	unset($ActionError);
	$root_id=0;

	if ($Fmng->getPerms(1) || $Fmng->getPerms(2)) {
		$root_obj_d=$Fmng->getSystemObj('d',$session_lang,0,true);
		if (is_object($root_obj_d)) {
			$root_obj[$root_obj_d->getID()]=$root_obj_d;
			unset($root_obj_d);
		}
		if ($Fmng->getPerms(1)) {
			$root_obj_u=$Fmng->getSystemObj('u',$session_lang,$user_id,true);
			if (is_object($root_obj_u)) {
				$root_obj[$root_obj_u->getID()]=$root_obj_u;
				unset($root_obj_u);
			} else {
				$root_obj_u=$Fmng->getSystemObj('u',$CFG['AV_LANG'],0,false);
				if (is_object($root_obj_u)) {
					$Fmng->insertMeta($root_obj_u);
					$root_obj_u->setParentMeta('UserID',$user_id);
					$root_obj_u->setParentMeta('RootID',$root_obj_u->getID());
					$Fmng->insertParentMeta($root_obj_u);
					$root_obj[$root_obj_u->getID()]=$root_obj_u;
					unset($root_obj_u);
				}
			}
		}
		if ($Fmng->getPerms(2)) {
			$root_obj_s=$Fmng->getSystemObj('s',$session_lang,0,true);
			if (is_object($root_obj_s)) {
				$root_obj[$root_obj_s->getID()]=$root_obj_s;
				unset($root_obj_s);
			}
		}
		$trash_obj=$Fmng->getSystemObj('t',$session_lang,0,true);
		if (is_object($trash_obj)) {
			$root_obj[$trash_obj->getID()]=$trash_obj;
		}

		if ($oid) {
			$obj=$Fmng->getObj($oid,$CFG['MA_LANG'],false);
			if (is_object($obj)) {
				if ($obj->getMeta('Trash') && $trash_obj) {
					$root_id=$trash_obj->getID();
				} else {
					$root_id=$obj->getParentMeta('RootID');
				}
			}
		}

		if (!$root_id || !isset($root_obj[$root_id])) {
			$oid=$root_id=key($root_obj);
			$obj=$Fmng->getObj($oid,$CFG['MA_LANG']);
		}
		$rootObj=$root_obj[$root_id];
	} else {
		unset($rootObj);
	}
	if (!is_object($rootObj) || !is_object($obj) || !$obj->getAcl(1)) {
		$t->assign('TPL_ERROR','');
		$t->define (array('tpl_card' => "no_perms.inc.html"));
		$t->parse('TPL_CARD','tpl_card');
	} else {


		//if (!$mode) $mode='fav';
		if ($action=='s') $mode='all';
		$Fmng->setMode($mode);
		$Fmng->setRootObj($rootObj);
		if ($pre["global"]['js']) $t->parse("ROW","conf_delete");

		if (!$action)  $action=$obj->getAction(0);
		$L_THIS="index.php?site=$site&action=$action&oid=$oid";
		$Fmng->setClipboard('fobj',$frm->getClipboard('fobj'));
		if (($_POST['download_x'] || $action=='fu') && $obj->getMeta('DocType')=='ext') {
			require ('lib/fmng/inc_DownloadFile.php');
		}
		if (($meta_save_x || $ext_upload_x) && $obj->getAcl(2)) {
			if ($new) {
				require ('lib/fmng/inc_NewObject.php');
			} else {
				require ('lib/fmng/inc_UpdateObject.php');
			}
		}
		if ($obj_action_x && $obj_action_val) {
			require ('lib/fmng/func_Action.php');
			require ('lib/fmng/inc_ActionObject.php');
		}
		if ($list_action_x && $list_action_val) {
			require ('lib/fmng/func_Action.php');
			require ('lib/fmng/inc_ActionList.php');
		}
		$obj_tree=$Fmng->getObjTree($oid);
		$tmp_tree='';
		if (is_array($obj_tree)) {
			foreach ($obj_tree as $key=>$val) {
				$tmp_tree="<a href=\"index.php?site=$site&oid=$key\">".FrameWork::entities($val).'</a>/'.$tmp_tree;
			}
		}
		$t->assign('OBJ_TREE',$tmp_tree);
		$t->assign('OBJ_NAME',FrameWork::entities($obj->getName()));
		foreach ($root_obj as $val) {
			$t->assign('M_IMG',$val->getImage(0));
			$t->assign('M_NAME',FrameWork::entities($val->getName()));
			$t->assign('M_URL',"index.php?site=$site&oid=".$val->getID());
			if ($root_id==$val->getID()) {
				$t->assign('M_ON','on');
			} else {
				$t->assign('M_ON','off');
			}
			$t->parse('ROW','.root_header_'.$val->getMeta('System'));
		}
		$t->assign('CFG_ON','off');
		if ($action=="b") {
			require("lib/class_form.inc.php");
			require("fmng/browse_list_js.php");
			if (!$mode && $rootObj->getMeta('System')=='d') {
				$t->define (array('tpl_card' => "browse_overview.inc.html"));
				require("fmng/browse_overview.php");
			} else {
				$t->define (array('tpl_card' => "browse_content.inc.html"));
				require("fmng/browse_content.php");
			}
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=="bt") {
			$t->define (array('tpl_card' => "browse_content.inc.html"));
			require("lib/class_form.inc.php");
			require("fmng/browse_list_js.php");
			require("fmng/browse_content.php");
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=="vo") {
			$t->define (array('tpl_card' => "view_content.inc.html"));
			require("lib/class_form.inc.php");
			require("fmng/browse_list_js.php");
			require("fmng/view_content.php");
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=="p") {
			$t->define (array('tpl_card' => "perms_content.inc.html"));
			require("lib/class_form.inc.php");
			require("fmng/browse_list_js.php");
			require("fmng/perms_content.php");
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=="s") {
			$t->define (array('tpl_card' => "search.inc.html"));
			require("fmng/search.php");
			$t->parse('TPL_CARD','tpl_card');
		} else {
			$t->define (array('tpl_card' => "no_perms.inc.html"));
			$t->parse('TPL_CARD','tpl_card');
		}

		$t->assign('T_S_ACTION',"index.php?site=$site&action=s");

		if ($ActionError) {
			require('fmng/view_error.php');
		}

	}
}
?>
