<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if (!$obj || !$obj->getAcl(1)) {
	header("Location:index.php?site=$site");
	exit;
}
if ($pre["global"]['lay']) $t->define (array('tpl_layer' => "layers.inc.html"));
$ID=$obj->getID();
$l_this="index.php?site=$site&action=$action&oid=$oid&new=$new&edit=$edit";
$t->assign('FORM_ACTION',$l_this);

if ($new) {
	$t->parse('ROW','title_new');
	$new_obj=new FObj_ext();
	$new_obj->setMeta('DocType','ext');
	$new_obj->setParentMeta('ParentID',$obj->getID());
	$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
	$new_obj->setAcl(-1);
	$edit=1;
} else {
	$new_obj=$obj;
	if ($edit) {
		$t->parse('ROW','title_edit');
	} else {
		$t->parse('ROW','title_view');
	}
	
	$frm->addOnload('e7gMsgIntitObj('.json_encode(array(
		'typ'=>'fmng',
		'id'=>$obj->getID(),
		'name'=>$obj->getName(),
		'link'=>"index.php?site=".$obj->getSite()."&action=".$obj->getAction(0)."&oid=".$obj->getID(),"&go_b=1"
	)).');');
}

$meta_action=$frm->getObjAction($Fmng->getModul(),'e_'.$new_obj->getActionMode(0));
$p_update=false;

if ($edit && $Fmng->isAllowedAction($new_obj,$meta_action['e|title'])) {
	$txt_title=new TextField("ObjTitle_$session_lang",'size="30" class="sel" style="width:300px"','0','%',$new_obj->getMeta('Title_'.$session_lang));
	$t->assign('OBJ_TITLE',$txt_title->f());
	$t->assign('OBJ_TITLE_LANG',strtoupper($session_lang));
	if ($ActionError['fields']["ObjTitle_$session_lang"]) {
		$t->assign('C_TITLE','error');
	} else {
		$t->assign('C_TITLE','');
	}
	$t->assign('FOCUS_FIELD',"ObjTitle_$session_lang");
	$p_update=true;
} else {
	$t->assign('OBJ_TITLE','<div class="disable" style="width:300px">'.FrameWork::entities($new_obj->getName($session_lang)).'&nbsp;</div>');
	$t->assign('OBJ_TITLE_LANG',strtoupper($session_lang));
}

if ($edit && $Fmng->isAllowedAction($new_obj,$meta_action['e|text'])) {
	$txt_desc=new TextArea('ObjText','rows="7" cols="36" class="sel" style="width:300px;"','0','%',$new_obj->getMeta('Text'));
	$t->assign('OBJ_DESC',$txt_desc->f());
	$p_update=true;
} else {
	$t->assign('OBJ_DESC','<div class="disable" style="width:300px;min-height:70px;">'.FrameWork::entities($new_obj->getMeta('Text')).'</div>');
}




require_once('lib/class_FastTemplateGui.php');
$pubBoxGui=new FastTemplateGui('fmng/'.$frm->getLang().'/view_content_pubbox.inc.html');

if ($edit && $Fmng->isAllowedAction($new_obj,$meta_action['e|upload'])) {
	if ($obj->getMeta('UserModify')!=$user_id && $obj->getFileMeta('TimeDl') && $obj->getFileMeta('TimeDl')<$obj->getMeta('TimeModify')) {
		$pubBoxGui->assign('FILE_USER_MODIFY',FrameWork::entities($frm->getCachedUserName($obj->getMeta('UserModify'))));
		$pubBoxGui->assign('FILE_TIME_MODIFY',date('d.m.Y H:i',$obj->getMeta('TimeModify')));
		$pubBoxGui->parse('ROW','upload_msg');
	}
	$pubBoxGui->parse('ROW','upload_box');
}



if ($new_obj->getMeta('TimeModify')) {
	$pubBoxGui->assign('OBJ_TIME_MODIFY',date('d.m.Y H:i',$new_obj->getMeta('TimeModify')));
} else {
	$pubBoxGui->assign('OBJ_TIME_MODIFY','-');
}
if ($new_obj->getMeta('UserModify')) {
	if (!isset($all_user[$new_obj->getMeta('UserModify')])) {
		$temp=$frm->getFullName($new_obj->getMeta('UserModify'),1,1);
		$all_user[$new_obj->getMeta('UserModify')]=$temp[$new_obj->getMeta('UserModify')];
	}
	$pubBoxGui->assign('OBJ_USER_MODIFY',FrameWork::entities($all_user[$new_obj->getMeta('UserModify')]));
} else {
	$pubBoxGui->assign('OBJ_USER_MODIFY','-');
}
$pubBoxGui->parse('ROW','last_modify');


if (!$new && !$new_obj->isFolder() && $new_obj->getMeta('Content')!=$new_obj->getID()) {
	$orig_obj=$Fmng->getObj($new_obj->getMeta('Content'));
	if (is_object($orig_obj)) {
		$pubBoxGui->assign('ORIG_OBJ_TITLE',Framework::entities($orig_obj->getName()));
		$pubBoxGui->assign("ORIG_OBJ_IMG",$orig_obj->getImage(0));
		$pubBoxGui->assign("L_ORIG_OBJ_IMG","index.php?site=".$orig_obj->getSite()."&oid=".$orig_obj->getID()."&action=".$orig_obj->getAction(1));
		$pubBoxGui->assign("L_ORIG_OBJ_ITEM","index.php?site=".$orig_obj->getSite()."&oid=".$orig_obj->getID()."&action=".$orig_obj->getAction(1));
		if ($pre['global']['lay']) {
			$obj_tree=$Fmng->getObjTree($orig_obj->getID());
			if (is_array($obj_tree)) {
				$t->assign("DIV_TREE",implode(' / ',array_reverse(FrameWork::entities($obj_tree))));
				$t->parse("ROW","div_tree");
				$t->assign("DIV_ID","fk_$key");
				$t->parse("ROW",".div_row");
				$pubBoxGui->assign('LAY_LINK'," onMouseOver=\"show(event, 'fk_$key'); return true;\" onMouseOut=\"hide('fk_$key'); return true;\"");
			} else {
				$pubBoxGui->assign('LAY_LINK','');
			}
		} else {
			$pubBoxGui->assign('LAY_LINK','');
		}
		$pubBoxGui->parse('ROW','orig_obj');
	}
}
if (!$new && !$new_obj->isFolder()) {
	$linked_objs=$Fmng->getLinkedObj($new_obj->getID());
	if (!empty($linked_objs)) {
		foreach ($linked_objs as $linked_obj) {
			$pubBoxGui->assign('LINK_OBJ_TITLE',Framework::entities($linked_obj->getName()));
			$pubBoxGui->assign("LINK_OBJ_IMG",$linked_obj->getImage(0));
			$pubBoxGui->assign("L_LINK_OBJ_IMG","index.php?site=".$linked_obj->getSite()."&oid=".$linked_obj->getID()."&action=".$linked_obj->getAction(1));
			$pubBoxGui->assign("L_LINK_OBJ_ITEM","index.php?site=".$linked_obj->getSite()."&oid=".$linked_obj->getID()."&action=".$linked_obj->getAction(1));
			if ($pre['global']['lay']) {
				$obj_tree=$Fmng->getObjTree($linked_obj->getID());
				if (is_array($obj_tree)) {
					$t->assign("DIV_TREE",implode(' / ',array_reverse(FrameWork::entities($obj_tree))));
					$t->parse("ROW","div_tree");
					$t->assign("DIV_ID","fk_$key");
					$t->parse("ROW",".div_row");
					$pubBoxGui->assign('LAY_LINK'," onMouseOver=\"show(event, 'fk_$key'); return true;\" onMouseOut=\"hide('fk_$key'); return true;\"");
				} else {
					$pubBoxGui->assign('LAY_LINK','');
				}
			} else {
				$pubBoxGui->assign('LAY_LINK','');
			}
			$pubBoxGui->parse('ROW','.linked_obj_row');
		}
		$pubBoxGui->parse('ROW','linked_obj');
	}

	if ($Fmng->getCfg('cfg/versioning/active') && $new_obj->getMeta('Content')==$new_obj->getID()) {
		require_once 'lib/fmng/class_FmngGui.php';
		$Gui=new FmngGui();
		$Gui->setObj($new_obj);
		$listGui=$Gui->processVersionContent();
		if ($listGui) {
			$t->assign('VERSION_CONTENT',$listGui->process());
			$t->parse("ROW","version_content");
		}
	}
}

if (!$new && $new_obj->getACL(1)) {
	$pubBoxGui->assign('L_DOWNLOAD',"index.php?site=$site&oid=".$new_obj->getID()."&action=".$new_obj->getAction(1));
	$pubBoxGui->assign('FILE_SIZE',FrameWork::formatsize(intval($obj->getFileMeta('FileSize'))));
	$pubBoxGui->parse('ROW','file_download');
}

//debug($incdata);

if ($p_update) {
	$t->parse('ROW','update');
}



$t->assign('L_BREAK',"index.php?site=$site&oid=".$new_obj->getParentMeta('ParentID'));
$t->parse('ROW','break');

$T->loadModul($Fmng->getModul());
if (!$new) {
	$obj_action=$frm->getObjAction($Fmng->getModul(),$obj->getActionMode(0));
	foreach ($obj_action as $key=>$val) {
		if (!$val['Hidden'] && $Fmng->isAllowedAction($obj,$val)) {
			$t->assign('SEL_VAL',$key);
			$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
			$t->parse('ROW','.obj_action_val');
			$parse=true;
		}
	}
	if ($parse) $t->parse('ROW','obj_action');
	require_once('lib/class_BoxGui.php');
	$boxGui=new BoxGui($Fmng->getModul().'|showtab_view_obj');
	$boxGui->setJsCallback('noAction','');
	$boxGui->addTab('file',$T->lang('[[Datei]]'),'#',true);
	$boxGui->setTabContent('file',$pubBoxGui);

	require_once('lib/fmng/class_FmngLogGui.php');
	$fmngLog=new FmngLogGui();
	$logCont=$fmngLog->getFmngLogGui($obj);
	if (is_object($logCont)) {
		$boxGui->addTab('log',$T->lang('[[Aenderungen]]'),'#',true);
		$boxGui->setTabContent('log',$fmngLog->getFmngLogGui($obj));
	}






	$boxGui->setTabOn('file');
	$t->assign('TPL_BOX',$boxGui->process());

	//$t->parse('ROW','public_box');
} else {
	$t->assign('TPL_BOX','');
}
if ($pre['global']['lay']) $t->parse("TPL_LAYERS","tpl_layer"); else
$t->assign("TPL_LAYERS","");
?>
