<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$f_root_id=0;
$root_obj_s=$Fmng->getSystemObj('s',$session_lang,0,true);
if (is_object($root_obj_s)) {
	$f_root_obj[$root_obj_s->getID()]=$root_obj_s;
	unset($root_obj_s);
}
if (!$f_oid && $dl_id) {
	$tmp_obj=$Fmng->getObj($dl_id,$CFG['MA_LANG']);
	if (is_object($tmp_obj)) {
		$f_oid=$tmp_obj->getParentMeta('ParentID');
	}

}

if ($f_oid) {
	$f_obj=$Fmng->getObj($f_oid,$CFG['MA_LANG']);
	if (is_object($f_obj)) {
		$f_root_id=$f_obj->getParentMeta('RootID');
	}
}
if (!$f_root_id || !isset($f_root_obj[$f_root_id])) {
	$f_oid=$f_root_id=key($f_root_obj);
	$f_obj=$Fmng->getObj($f_oid,$CFG['MA_LANG']);
}
$f_rootObj=$f_root_obj[$f_root_id];

if (is_object($f_obj)) {
	$t->define (array('tpl_root' => "wdoc_edit_download_froot.inc.html"));
	if (!$f_mode) $f_mode='fav';
	$Fmng->setMode($f_mode);
	$Fmng->setRootObj($f_rootObj);

	$f_tree_apps=array('fol');
	$f_tree=$Fmng->ListAllTree($f_root_id,-1,'DocType DESC,Title_'.$session_lang,'ASC',$f_tree_apps);
	$up_tree=false;
	if ($open==1) {
		$f_open_tree=','.implode(',',array_keys($f_tree)).',';
		$up_tree=true;
	} elseif ($open==-1) {
		$f_open_tree=',';
		$up_tree=true;
	} else {
		$f_open_tree=$frm->getTree($Fmng->getModul(),$f_root_id);
		if (isset($x)) {
			$frm->updateTree($f_open_tree,$x);
			$up_tree=true;

		}
	}

	$f_expand=array_flip(explode(',',$f_open_tree));
	$f_expand[$f_root_id]=1;
	if ($f_tree[$f_oid] && !$f_expand[$f_oid]) {
		$f_expand[$f_oid]=1;
		$frm->updateTree($f_open_tree,$f_oid);
		$up_tree=true;
	}
	if (is_array($f_obj_tree)) {
		foreach (array_keys($f_obj_tree) as $val) {
			if (!$f_expand[$val]) {
				$f_expand[$val]=1;
				$frm->updateTree($f_open_tree,$val);
				$up_tree=true;
			}
		}
	}

	if ($up_tree) {
		$frm->setTree($Fmng->getModul(),$f_root_id,$f_open_tree);
	}

	$ac_link=$form_action;
	$form_action.="&f_oid=$f_oid";
	$ex_link=$form_action;
	$t->assign('EX_LINK',$ex_link);

	require_once('lib/class_ObjTree.php');
	$ObjTree=new ObjTree();
	$ObjTree->setSplitImages('tree_split.gif','tree_split_ex.gif','tree_split_co.gif');
	$ObjTree->setEndImages('tree_end.gif','tree_end_ex.gif','tree_end_co.gif');
	$ObjTree->setLineImages('tree_vertline.gif');
	$ObjTree->setExpand($f_expand);
	$ObjTree->setTree($f_tree);
	$ObjTree->setExLink($ex_link."&f_x={OID}");
	$ObjTree->setAcLink($ac_link."&f_oid={OID}");
	$ObjTree->setImgPath("img/$THEME");
	$ObjTree->setColors($bgcolor,$fg10color);
	if ($f_tree_apps && !in_array($f_obj->getMeta('DocType'),$f_tree_apps)) {
		$ObjTree->setSelectedID($f_obj->getParentMeta('ParentID'));
	} else {
		$ObjTree->setSelectedID($f_obj->getID());
	}
	$ObjTree->setRootID($f_root_id);
	$ObjTree->setModul($Fmng->getModul());

	if ($f_rootObj->getID()==$ObjTree->getSelectedID()) {
		$class='it_s';
	} else {
		$class='it_n';
	}

	$t->assign('ROOT_CLASS',$class);
	$t->assign('ROOT_L',"$ac_link&f_oid=$f_root_id");
	$t->assign('ROOT_NAME',FrameWork::entities($f_rootObj->getName($session_lang)));
	$t->assign('ROOT_IMG',$f_rootObj->getImage(isset($f_tree[$f_root_id])));

	$t->assign('NAV_TREE',$ObjTree->parseTree($f_root_id));
	$t->parse('ROW','folder_tree');
	$t->parse("TPL_ROOT","tpl_root");

	$t->define (array('tpl_dl_cont' => "wdoc_edit_download_fcont.inc.html"));
	$meta_action=$frm->getObjAction($Fmng->getModul(),'e_'.$f_obj->getActionMode(0));

	$p_update=false;
	$t->assign('OBJ_TITLE','<div class="disable" style="width:300px">'.FrameWork::entities($f_obj->getName($session_lang)).'&nbsp;</div>');
	$t->assign('OBJ_TITLE_LANG',strtoupper($session_lang));

	if ($Fmng->isAllowedAction($f_obj,$meta_action['e|upload'])) {

		if ($ext_upload_x && $_FILES['ext_file']['tmp_name'] && file_exists($_FILES['ext_file']['tmp_name'])) {
			$new_obj=new FObj_ext();
			foreach ($CFG['AV_LANG'] as $val) {
				if (trim($_POST['FObjTitle'])) {
					$new_obj->setMeta('Title_'.$val,trim($_POST['FObjTitle']));
				} else {
					$new_obj->setMeta('Title_'.$val,$_FILES['ext_file']['name']);
				}
			}
			if (isset($_POST['FObjText'])) {
				$new_obj->setMeta('Text',trim($_POST['FObjText']));
			}
			$new_obj->setMeta('MenuImage','other.gif');
			$new_obj->setMeta('Version',1);
			$new_obj->setMeta('TimeCreate',time());
			$new_obj->setMeta('TimeModify',time());
			$new_obj->setMeta('UserCreate',$user_id);
			$new_obj->setMeta('UserModify',$user_id);
			$new_obj->setMeta('DocType','ext');
			$new_obj->setMeta('Users',$f_obj->getMeta('Users'));
			$new_obj->setMeta('Groups',$f_obj->getMeta('Groups'));
			$new_obj->setParentMeta('ParentID',$f_obj->getID());
			$new_obj->setParentMeta('RootID',$f_obj->getParentMeta('RootID'));
			$new_obj->setParentMeta('UserID',$f_obj->getParentMeta('UserID'));
			if ($Fmng->insertMeta($new_obj)) {
				$Fmng->insertParentMeta($new_obj);
				$error=$Fmng->replaceFile($new_obj,$Fmng->getModul(),$new_obj->getID(),$_FILES['ext_file']);
				if ($error===false){
					if ($FavInsert) {
						$new_obj->setFileMeta('Favorite',1);
						$Fmng->setFavorite($new_obj);
					}
					page_close();
					header("Location:$dl_action&dl_id=".$new_obj->getID());
					exit;
				} else {
					$ActionError[$error]=true;
					$Fmng->deleteParentMeta($new_obj);
					$Fmng->deleteMeta($new_obj);
				}
			}
			//debug($ActionError);
		}


		$txt_title=new TextField("FObjTitle",'size="30" class="sel" style="width:300px"','0','%',$FObjTitle);
		$t->assign('F_OBJ_TITLE',$txt_title->f());
		$txt_text=new TextArea("FObjText",'cols="30" rows="5" class="sel" style="width:300px"','0','%',$FObjText);
		$t->assign('F_OBJ_TEXT',$txt_text->f());
		$chk_fav=new CheckBox ('FavInsert','',1);
		$t->assign('CHK_FAV',$chk_fav->f(1));
		$t->parse('ROW','upload_box');
	}
	/*
	if ($f_obj->getMeta('TimeModify')) {
		$t->assign('OBJ_TIME_MODIFY',date('d.m.Y H:i',$f_obj->getMeta('TimeModify')));
	} else {
		$t->assign('OBJ_TIME_MODIFY','-');
	}

	if ($f_obj->getMeta('UserModify')) {
		if (!isset($all_user[$f_obj->getMeta('UserModify')])) {
			$temp=$frm->getFullName($f_obj->getMeta('UserModify'),1,1);
			$all_user[$f_obj->getMeta('UserModify')]=$temp[$f_obj->getMeta('UserModify')];
		}
		$t->assign('OBJ_USER_MODIFY',FrameWork::entities($all_user[$f_obj->getMeta('UserModify')]));
	} else {
		$t->assign('OBJ_USER_MODIFY','-');
	}
	$t->parse('ROW','last_modify');
	$t->parse('ROW','public_box');
	*/

	$search_sql="ParentID=".$db->escape($f_obj->getID());
	$limit=0;
	$order='Title_'.$session_lang.' asc';
	$rows=0;
	$ftree=$Fmng->searchObj($rows,0,0,$search_sql,$order,$use_limit);
	$num_entrys=count($ftree);
	if ($num_entrys) {
		$j=$i=1;
		foreach ($ftree as $val) {
			$lid=$val->getID();


			$t->assign('LIST_OBJ_ID',$lid);
			$t->assign("LIST_IMG",$val->getImage(0));
			$t->assign("LIST_ITEM",FrameWork::entities($val->getName($session_lang)));
	//debug($val);
			if (!isset($all_user[$val->getMeta('UserModify')])) {
				$temp=$frm->getFullName($val->getMeta('UserModify'),1,1);
				$all_user[$val->getMeta('UserModify')]=$temp[$val->getMeta('UserModify')];
			}
			$t->assign('LIST_USER_MODIFY',FrameWork::entities($all_user[$val->getMeta('UserModify')]));

			if ($val->getMeta('TimeModify')) {
				$t->assign('LIST_TIME_MODIFY',date('d.m.Y',$val->getMeta('TimeModify')));
			} else {
				$t->assign('LIST_TIME_MODIFY','-');
			}
			/*
			if ($pre["global"]['lay']) {
				$div_row=0;
				if ($val->getMeta('Text')) {
					$t->assign("DIV_DESC",Framework::entities($val->getMeta('Text')));
					$t->parse("ROW","div_desc");
					$div_row=1;
				} else {
					$t->clear_dynamic('div_desc');
				}
				if ($div_row) {
					$t->assign('LAY_LINK'," onMouseOver=\"show(event, 'fk_$key'); return true;\" onMouseOut=\"hide('fk_$key'); return true;\"");
					$t->assign("DIV_ID","fk_$key");
					$t->parse("ROW",".div_row");
				} else {
					$t->assign('LAY_LINK','');
				}
			} else {
				$t->assign('LAY_LINK','');
			}*/

			if ($val->isFolder()) {
				$link=$ac_link."&f_oid=".$lid;
				$t->assign("L_LIST_ITEM",$link);
				if ($j%2) $t->assign("ROW_COLOR",$bgcolor); else  $t->assign("ROW_COLOR","#f2f2f2");
				$t->parse("ROW",".folder_row");
				$j++;

			} else {
				$link=$dl_action."&dl_id=".$lid;
				$t->assign("L_LIST_ITEM",$link);
				if ($i%2) $t->assign("ROW_COLOR",$bgcolor); else  $t->assign("ROW_COLOR","#f2f2f2");
				$t->assign('LIST_SIZE',FrameWork::formatsize($val->getFileMeta('FileSize')));
				$t->parse("ROW",".file_row");
				$i++;
			}

		}
	}

	$t->parse("ROW","list_content");





	$t->parse("TPL_DL_CONT","tpl_dl_cont");


} else {
	$t->assign('TPL_ROOT','');
}

?>
