<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$b_root_id=0;
$b_root_obj=$Bmng->ListRoots();
if (!$b_oid && $img_id && $img_id!=-1) {
	$tmp_obj=$Bmng->getObj($img_id);
	if (is_object($tmp_obj)) {
		$b_oid=$tmp_obj->getParentMeta('ParentID');
	}

}
if ($b_oid) {
	$b_obj=$Bmng->getObj($b_oid);
	if (is_object($b_obj)) {
		$b_root_id=$b_obj->getParentMeta('RootID');
	}
}
if (!$b_root_id) {
	$b_obj=$Bmng->getSystemFolderObj();
	if (is_object($b_obj)) {
		$b_oid=$b_obj->getID();
		$b_root_id=$b_obj->getParentMeta('RootID');
	} else {
		$b_oid=$b_root_id=key($b_root_obj);
		$b_obj=$b_root_obj[$b_oid];
	}
}
if (is_object($b_obj)) {
	$t->define (array('tpl_root' => "wdoc_edit_image_broot.inc.html"));
	$b_tree=$Bmng->ListAllTree($b_root_id,'Title','asc','pfol');
	$up_tree=false;
	if ($open==1) {
		$b_open_tree=','.implode(',',array_keys($b_tree)).',';
		$up_tree=true;
	} elseif ($open==-1) {
		$b_open_tree=',';
		$up_tree=true;
	} else {
		$b_open_tree=$frm->getTree($Bmng->getModul(),$b_root_id);
		if (isset($b_x)) {
			$frm->updateTree($b_open_tree,$b_x);
			$up_tree=true;
		}
	}
	$b_expand=array_flip(explode(',',$b_open_tree));
	$b_expand[$b_root_id]=1;
	if ($b_tree[$b_oid] && !$b_expand[$b_oid]) {
		$b_expand[$b_oid]=1;
		$frm->updateTree($b_open_tree,$b_oid);
		$up_tree=true;
	}
	if ($up_tree) {
		$frm->setTree($Bmng->getModul(),$b_root_id,$b_open_tree);
	}
	$ac_link=$form_action;
	$form_action.="&b_oid=$b_oid";
	$ex_link=$form_action;

	$t->assign('EX_LINK',$ex_link);
	if ($b_root_id==$b_oid) {
		$class='it_s';
	} else {
		$class='it_n';
	}
	$t->assign('ROOT_CLASS',$class);
	$t->assign('ROOT_ITEM',FrameWork::entities($b_root_obj[$b_root_id]->getName()));
	$t->assign('ROOT_IMG',$b_root_obj[$b_root_id]->getImage(isset($b_tree[$b_root_id])));

	require_once('lib/class_ObjTree.php');
	$ObjTree=new ObjTree;
	$ObjTree->setSplitImages('tree_split.gif','tree_split_ex.gif','tree_split_co.gif');
	$ObjTree->setEndImages('tree_end.gif','tree_end_ex.gif','tree_end_co.gif');
	$ObjTree->setLineImages('tree_vertline.gif');
	$ObjTree->setExpand($b_expand);
	$ObjTree->setTree($b_tree);
	$ObjTree->setExLink($ex_link."&b_x={OID}");
	$ObjTree->setAcLink($ac_link."&b_oid={OID}");
	$ObjTree->setImgPath("img/$THEME");
	$ObjTree->setColors($bgcolor,$fg10color);
	$ObjTree->setSelectedID($b_oid);
	$ObjTree->setRootID($b_root_id);
	$ObjTree->setModul($Bmng->getModul());
	$t->assign('NAV_TREE',$ObjTree->parseTree($b_root_id));
	$t->parse("TPL_ROOT","tpl_root");



	$t->define (array('tpl_img_cont' => "wdoc_edit_image_bcont.inc.html"));

	if (!$b_obj->getMeta('Trash') && $b_obj->getAcl(2) && $b_obj->getParentMeta('RootID')!=$b_obj->getID()) {
		if ($_POST['img_upload_x']) {
			$images=$Bmng->UplaodImage($b_obj,$_FILES['img_file'],$_POST['ImgTitle'],$ActionError);
			if (!$ActionError) {
				$_POST['ImgTitle']='';
				unset($ImgTitle);
				if (count($images)==1) {
					page_close();
					header("Location:$img_action&img_id=".$images[0]->getID());
					exit;
				}
			}
		}
		$txt_imgtitle=new TextField('ImgTitle','size="30" class="sel" style="width:220px"');
		$t->assign('F_IMG_TITLE',$txt_imgtitle->f());
		$t->parse('ROW','upload_box');
	}
	$t->assign('BOBJ_NAME',FrameWork::entities($b_obj->getName()));
	$t->assign('SPACE_IMG',$Bmng->getCfg('ImgPath').'/space_edit.gif');
	$t->assign('L_SPACE_IMG',"$img_action&img_id=-1");
	$img_list=$Bmng->ListSubEntrys($b_obj->getID(),'img');
	if (!empty($img_list)) {
		$i=1;$k=0;
		foreach ($img_list as $img_obj) {
			$path=$img_obj->getMeta('Content');
			if ($path && file_exists($Bmng->getCfg('ThumbPath').'/'.$path)) {
				$t->assign("THUMB_IMG",'fetch_image.php?mode=thumb&file='.$path);
			} else {
				$t->assign("THUMB_IMG","img/$THEME/tras.gif");
			}
			$t->assign('IMG_DIMENSION',$img_obj->getMeta('Width').'x'.$img_obj->getMeta('Height'));
			$t->assign('IMG_SIZE',$frm->formatSize($img_obj->getMeta('Size')));
			if ($img_obj->getMeta('Version') > 1) {
				$t->assign("IMG_NAME",$img_obj->getName().'['.$img_obj->getMeta('Version').']');
			} else {
				$t->assign("IMG_NAME",$img_obj->getName());
			}
			if ($k%2) {
				$t->assign("ROW_COLOR","#f2f2f2");
			} else {
				$t->assign("ROW_COLOR","$bgcolor");
			}
			if ($cont_mode=='new_over') {
				$t->assign('L_IMG_VIEW',"$img_action&over_id=".$img_obj->getID());
			} else {
				$t->assign('L_IMG_VIEW',"$img_action&img_id=".$img_obj->getID());
			}
			$t->parse('ROW',".img_row".$i);
			$k++;
			$i++;
			if ($i>3) $i=1;

		}
		$t->assign('NUM_IMAGES',($k));
		$t->parse('ROW','list_content');
	}
	$t->parse("TPL_IMG_CONT","tpl_img_cont");


} else {
	$t->assign('TPL_ROOT','');
}

?>
