<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require_once('lib/class_ObjSelect.php');
$t->define (array('tpl_img_cont' => "wdoc_edit_image_cont.inc.html"));
if ($cont_pos) {
	$parent_id=substr($cont_pos,0,strpos($cont_pos,','));
}

if ($img_id!=-1) {
	$img_obj=$Bmng->getObj($img_id);
} else {
	$img_obj=new BObj_img($ID=-1,array('Content'=>'space_edit.gif','Width'=>$xmlFastText->getValue('image|max'),'Height'=>3),0,-1);
}
$attr['base']=$img_obj->getMeta('Content');
$t->assign('ATTR_BASE',htmlspecialchars($attr['base']));

$attr['over']='';
if ($over_id) {
	$over_obj=$Bmng->getObj($over_id);
	if (is_object($over_obj)) {
		$attr['over']=$over_obj->getMeta('Content');
	}
}
$t->assign('ATTR_OVER',htmlspecialchars($attr['over']));

$view_cont_action=false;
$cont_action=$frm->getObjAction($Imng->getModul(),'cont_img');
foreach ($cont_action as $key=>$val) {
	if (in_array('over',$val['Extra']) && !$attr['over']) continue;
	if (in_array('!over',$val['Extra']) && $attr['over']) continue;
	if (in_array('!content',$val['Extra']) && $cont_id) continue;
	if (in_array('content',$val['Extra']) && !$cont_id) continue;
	$t->assign('SEL_VAL',$key);
	$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
	$t->parse('ROW','.cont_action_val');
	$view_cont_action=true;
}
if ($view_cont_action) {
	$t->parse('ROW','cont_action');
}


if ($img_obj->getID()!=-1 || $xmlFastText->getMode()=='tpl') {
	$t->assign('ATTR_TITLE',htmlspecialchars($attr['title']));
	$t->assign('ATTR_OVER',htmlspecialchars($attr['over']));
	if ($attr['align']=='none' || !$attr['align']) $t->assign('ATTR_ALIGN_NONE','checked'); else $t->assign('ATTR_ALIGN_NONE','');
	if ($attr['align']=='left') $t->assign('ATTR_ALIGN_LEFT','checked'); else $t->assign('ATTR_ALIGN_LEFT','');
	if ($attr['align']=='center') $t->assign('ATTR_ALIGN_CENTER','checked'); else $t->assign('ATTR_ALIGN_CENTER','');
	if ($attr['align']=='right') $t->assign('ATTR_ALIGN_RIGHT','checked'); else $t->assign('ATTR_ALIGN_RIGHT','');
	if ($attr['border']=='1') $t->assign('ATTR_BORDER','checked'); else $t->assign('ATTR_BORDER','');

	if ($l_type=='int') $t->assign('ATTR_TYPE_INT','checked'); else $t->assign('ATTR_TYPE_INT','');
	if ($l_type=='ext') $t->assign('ATTR_TYPE_EXT','checked'); else $t->assign('ATTR_TYPE_EXT','');
	if ($l_type=='self') $t->assign('ATTR_TYPE_SELF','checked'); else $t->assign('ATTR_TYPE_SELF','');
	if ($l_type=='none' || !$l_type) $t->assign('ATTR_TYPE_NONE','checked'); else $t->assign('ATTR_TYPE_NONE','');

	if (!$url_ext) $url_ext="http://";
	$t->assign('NODE_DATA',htmlspecialchars($node_data));
	$t->assign('URL_EXT',htmlspecialchars($url_ext));
	$t->assign('LINK_SEARCH',htmlspecialchars($link_search));

	if ($link_mode) {
	//$tree_root=$Imng->ListSubEntrys($Imng->getSite(),array('wcat'));
	//$tree=$Imng->ListAllTree(array_keys($tree_root),-1,'Sequence','ASC',$CFG['REDI']['Apps'],0);
	} else {
		$tree=$Imng->ListAllTree($Imng->getLangID(),$root_id,-1);
	}
	$sel_int=new ObjSelect();
	$sel_int->setTree($tree);
	$sel_int->setObjClass('wcat','poption');
	$sel_int->setObjClass('wfol','foption');
	$sel_int->setClass('noption');
	if ($l_type=='int') {
		$sel_int->setSelectedID($url_int);
	}
	$sel_int->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');
	if ($link_mode) {
		$t->assign('TREE_OPTION',$sel_int->parseSelect($Imng->getSite()));
	} else {
		$t->assign('TREE_OPTION',$sel_int->parseSelect($root_id));
	}
	if ($link_search) {
	$rows=0;
		$sql_search=$db->formatSearch($link_search,array('Title_'.$Imng->getLangID(),'Text'));
		if ($link_mode) {
			$sql_search.=' AND RootID IN ('.implode(',',array_keys($tree_root)).')';
		} else {
			$sql_search.=' AND RootID='.intval($root_id);
		}
		$search_array=$Imng->searchObj ($rows,0,10,$sql_search,'Title_'.$Imng->getLangID());
		foreach ($search_array as $search_obj) {
			$t->assign('S_KEY',$search_obj->getID());
			$t->assign('S_IMG',$search_obj->getImage(0));
			$t->assign('S_TITLE',Framework::entities($search_obj->getName()));
			$t->parse('ROW','.l_search_row');
		}
	}

	if ($img_obj->getMeta('Width')>=$xmlFastText->getValue('image|galerie') || $xmlFastText->getMode()=='tpl') {
		$t->assign('GALERIE_SIZE',intval($xmlFastText->getValue('image|galerie')));
		$t->parse('ROW','l_gallery');
	}
	if ($xmlFastText->getMode()=='tpl') {
		$tattr=$xml->get_attribs($cont_id);
		if ($tattr['edit']=='1') $t->assign('TATTR_EDIT','checked'); else $t->assign('TATTR_EDIT','');
		if ($tattr['edit_link']=='1') {
			$t->assign('TATTR_LINK','checked');
		} else {
			$t->assign('TATTR_LINK','');
		}
		if ($Imng->isSuperAdmin()) {
			$t->assign('TATTR_CID',htmlspecialchars($tattr['cid']));
			$t->assign('TATTR_FIELDS',',cid');
			$t->parse('ROW','tattr_cid');
		} else {
			$t->assign('TATTR_FIELDS','');
		}
		$t->assign('TATTR_TITLE',htmlspecialchars($tattr['title']));
		$t->parse('ROW','edit_tpl');
	}
	$t->parse('ROW','img_format');
}


$max_width=$xmlFastText->getValue('image|max');
$width_array=explode(',',$xmlFastText->getValue('image|width'));
if ($img_obj->getMeta('Width')>$max_width) {
	$img_width=$max_width;
} else {
	$img_width=$img_obj->getMeta('Width');
}
if ($attr['width']) {
	$tmp_width=round(substr($attr['width'],0,-1)*($max_width/100));
	if ($tmp_width<$img_width) {
		//echo $tmp_width;
		if (!in_array($tmp_width,$width_array)) {
			foreach($width_array as $key=>$val) {
				if ($val>$tmp_width) {
					//echo $tmp_width;
					array_splice ($width_array,$key,0,$tmp_width);
					break;
				}
			}
		}
		$attr['width']=round($tmp_width/($max_width/100),2).'%';
	} elseif ($attr['width']!='100%') {
		$custom_width=$tmp_width;
		//$attr['width']='100%';
	}
} else {
	$attr['width']='100%';
}

$t->assign('CUSTOM_WIDTH',intval($custom_width));
$t->assign('IMG_BASE_WIDTH',$img_width);
$break_after=false;
$prev_width=0;
foreach ($width_array as $key=>$val) {
	if ($val>=$img_obj->getMeta('Width')) {
		$val=$img_obj->getMeta('Width');
		$val_perc='100%';
		$break_after=true;
	} else {
		$val_perc=round($val/($max_width/100),2).'%';
		//echo $val_perc.'<br>';
	}
	$t->assign('V_ATTR_WIDTH',$val_perc);
	if ($attr['width']==$val_perc && !$custom_width) {
		$t->assign('C_ATTR_WIDTH','checked');
	} else {
		$t->assign('C_ATTR_WIDTH','');
	}
	if ($key==0) {
		$t->assign('TOP_ATTR_WIDTH',$val-$prev_width+8);
	} else {
		$t->assign('TOP_ATTR_WIDTH',$val-$prev_width);
	}
	$t->assign('BOTTOM_ATTR_WIDTH',$val-$prev_width-1);
 	$t->assign('ATTR_WIDTH',$val);
	$t->parse('ROW','.width_top');
	$t->parse('ROW','.width_bottom');
	$prev_width=$val;
	if ($break_after) break;
}
if ($img_obj->getID()!=-1) {
	$orig_img=$Bmng->getCfg('OrigPath').'/'.$img_obj->getMeta('Content');
	$final_img=$Bmng->getCfg('ImgPath').'/'.$img_width.'_'.$img_obj->getMeta('Content');
	if (file_exists($orig_img)) {
		if (!file_exists($final_img)) {
			$not_exists=true;
		} else {
			$not_exists=false;
		}
		if ($not_exists || filemtime($orig_img) > filemtime($final_img)) {
			$Bmng->_resize($orig_img,$final_img,'',$img_width);
			if ($not_exists) {
				$Bmng->insertImgTemp($img_obj->getMeta('Content'),$xmlFastText->getModul(),$img_width,$Bmng->getCfg('ImgPath'));
			}
		}
	}
	$img_obj_tree=$Bmng->getObjTree($img_obj->getID());
	$img_obj_name=$img_obj->getName();
	if ($img_obj->getMeta('Version')>1) {
		$img_obj_name.='['.$img_obj->getMeta('Version').']';
	}
	$t->assign('IMG_BASE_PATH',FrameWork::entities(implode('/',array_reverse($img_obj_tree)).'/'));
	$t->assign('IMG_BASE_NAME',FrameWork::entities($img_obj_name));
	$t->assign('IMG_BASE_SIZE','('.$img_obj->getMeta('Width').'x'.$img_obj->getMeta('Height').')');
	if (is_object($over_obj)) {
		if ($over_obj->getMeta('Width')>$max_width) {
			$over_width=$max_width;
		} else {
			$over_width=$over_obj->getMeta('Width');
		}
		$orig_over=$Bmng->getCfg('OrigPath').'/'.$over_obj->getMeta('Content');
		$final_over=$Bmng->getCfg('ImgPath').'/'.$over_width.'_'.$over_obj->getMeta('Content');
		if (file_exists($orig_over)) {
			if (!file_exists($final_over)) {
				$not_exists=true;
			} else {
				$not_exists=false;
			}
			if ($not_exists || filemtime($orig_over) > filemtime($final_over)) {
				$Bmng->_resize($orig_over,$final_over,'',$over_width);
				if ($not_exists) {
					$Bmng->insertImgTemp($over_obj->getMeta('Content'),$xmlFastText->getModul(),$over_width,$Bmng->getCfg('ImgPath'));
				}
			}
		}
		$over_obj_tree=$Bmng->getObjTree($over_obj->getID());
		$over_obj_name=$over_obj->getName();
		if ($over_obj->getMeta('Version')>1) {
			$over_obj_name.='['.$over_obj->getMeta('Version').']';
		}
		$t->assign('IMG_OVER_WIDTH',$over_width);
		$t->assign('IMG_OVER_PATH',FrameWork::entities(implode('/',array_reverse($over_obj_tree)).'/'));
		$t->assign('IMG_OVER_NAME',FrameWork::entities($over_obj_name));
		$t->assign('IMG_OVER_SIZE','('.$over_obj->getMeta('Width').'x'.$over_obj->getMeta('Height').')');
		$t->assign('IMG_OVER','fetch_image.php?mode=final&file='.basename($final_over));
		$t->assign('L_IMG_OVER',$form_action."&cont_action_x=1&cont_action_val=e_over&cont_pos=$cont_pos");
		$t->parse('ROW','img_over');
	}
} else {
	$final_img=$Bmng->getCfg('ImgPath').'/'.$img_obj->getMeta('Content');
	$t->assign('IMG_BASE_PATH','');
	$t->assign('IMG_BASE_NAME','');
	$t->assign('IMG_BASE_SIZE','');
}

$t->assign('IMG_BASE','fetch_image.php?mode=final&file='.basename($final_img));
$t->assign('L_IMG_BASE',$form_action."&cont_action_x=1&cont_action_val=e_img&cont_pos=$cont_pos");


$t->parse('ROW','update');

$t->parse("TPL_IMG_CONT","tpl_img_cont");

require ('imng/wdoc_edit_position.php');
?>
