<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array('tpl_root' => "wdoc_edit_position.inc.html"));
$img_line= "tree_vertline.gif";
$img_split_ex = "tree_split_ex.gif";
$img_split_co = "tree_split_co.gif";
$img_split = "tree_split.gif";
$img_end_ex= "tree_end_ex.gif";
$img_end_co= "tree_end_co.gif";
$img_end= "tree_end.gif";
$img_spc = "tree_space.gif";

$title_len=25;
$follow_tags=array(
	'paragraph',
	'obj:table',
	'table',
	'row',
	'col',
);
$ex_all=false;
$rad_pos=new RadioButton('cont_pos');
$ex_link=$form_action;


if (is_array($x)) {
	$x=key($x);
	$ex_node=$xml->get_node($x);
	if (is_object($ex_node)) {
		if ($ex_node->get_name()=='table') {
			$ex_node=$ex_node->get_parent();
		}
		if ($ex_node->get_attribs('ex')=='1') {
			$xml->set_attribs($ex_node->get_id(),array('ex'=>'0'));
		} else {
			$xml->set_attribs($ex_node->get_id(),array('ex'=>'1'));
		}
		$modify=true;
	}

}
if ($none_x || $all_x) {
	$modify=true;
}

$parent_tree=array();
if ($parent_id) {

	$ex_node=$xml->get_node($parent_id);
	while (is_object($ex_node)) {
  		$parent_tree[]=$ex_node->get_id();
		$ex_node=$ex_node->get_parent();
	}
}



$t->assign('NAV_TREE',parseTree($xml->get_node(0)));

$t->clear_dynamic('item_row');
$t->clear_dynamic('item_col');
$t->clear_dynamic('item_absatz');
$t->parse("TPL_ROOT","tpl_root");

function parseTree(&$parent,$no_rad=false) {
	global $Imng,$xml,$t,$THEME,$site,$title_len,$follow_tags,$expand,$all_x,$none_x,$parent_tree,$rad_pos,$cont_id,$cont_pos,$mode,$Fmng;
	global $img_end,$img_end_ex,$img_end_co,$img_split,$img_split_co,$img_split_ex,$img_spc,$img_line,$fg10color;
	static $depth=0,$j=0;
        $i=1;
        $len=$parent->children_len();
	$parent_Name=$parent->get_name();
	$prev=$parent->get_id();
	if ($depth<2 || in_array($parent->get_id(),$parent_tree) || $parent->get_attribs('ex')) {
		$style='style="clear:both;"';
	} else {
		$style='style="display:none;clear:both;"';
	}
	$nav="<table width=\"100%\" bgcolor=\"$bgcolor\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" id=\"nav".$prev."\" $style>\n";

        foreach ($parent->get_children() as $node_pos=>$node) {
		$ID=$node->get_id();
		//$node=&$xml->get_node($ID);
  		//echo 'ID:'.$ID.'<br>';
		$Name=$node->get_name();
		if ($node->children_len() && in_array($Name,$follow_tags)) {
			if ($none_x) {
				$node->set_attrib('ex','0');
				$xml->set_attribs ($ID,array('ex'=>'0'));
			}
			if ($all_x) {
				$node->set_attrib('ex','1');
				$xml->set_attribs ($ID,array('ex'=>'1'));
			}
			if ($depth==0 || in_array($ID,$parent_tree)) {
				$ex=1;
			} else {
				$ex=$node->get_attribs('ex');
			}
			//echo $ID."-$Name-".$ex.'<br>';
			if ($ex) {
				$sub_nodes=true;
				if ($len==$i) {
					$img=$img_end_co;
					if ($depth==0 && !$cont_pos) $cont_pos=$ID.','.$node->children_len();
				} else {
					$img=$img_split_co;
				}
			} else {
				if ($len==$i) {
					$img=$img_end_ex;
				} else {
					$img=$img_split_ex;
				}
				$sub_nodes=false;
			}
		} else {
			$sub_nodes=false;
			if ($len==$i) {
				if ($depth==0 && !$cont_pos) $cont_pos=$ID.',0';
				$img=$img_end;
			} else {
				$img=$img_split;
			}
		}
		$cont_rad='';
		$Title='';
		$follow=false;
		$t->assign("CONT_POS",$node_pos+1);

		switch ($Name) {
			case 'obj:fasttext':
				$cont_img="rs_exttext.gif";
				$Title=$xml->get_recur_data($ID,$title_len);
				$this_pos=$prev.','.($node_pos+1);
				if ( ($mode!='paragraph'  || ($parent_Name=='paragraph' && (!$cont_id || $len==$i)))) $cont_rad=$rad_pos->f($this_pos);
				break;
			case 'obj:text':
				$cont_img="rs_text.gif";
				$Title=$xml->get_recur_data($ID,$title_len);
				$this_pos=$prev.','.($node_pos+1);
				//echo $parent_Name.'<br>';
				if ( ($mode!='paragraph'  || ($parent_Name=='paragraph' && (!$cont_id || $len==$i)))) $cont_rad=$rad_pos->f($this_pos);
				break;
			case 'obj:title':
				$sub_node=$node->get_children(0);
				if (is_object($sub_node)) {
					if ($sub_node->get_attribs('style')=='h1') {
						$cont_img="rs_main.gif";
					} elseif ($sub_node->get_attribs('style')=='h2') {
						$cont_img="rs_sub.gif";
					} elseif ($sub_node->get_attribs('style')=='h3') {
						$cont_img="rs_section.gif";
					}
				} else {
					$cont_img="rs_main.gif";
				}
				$Title=$xml->get_recur_data($ID,$title_len);
				$this_pos=$prev.','.($node_pos+1);
				if (($mode!='paragraph'  || ($parent_Name=='paragraph' && (!$cont_id || $len==$i)))) $cont_rad=$rad_pos->f($this_pos);
				break;
			case 'obj:link':
				$cont_img="rs_link.gif";
				$Title=$xml->get_recur_data($ID,$title_len);
				$this_pos=$prev.','.($node_pos+1);
				if (($mode!='paragraph'  || ($parent_Name=='paragraph' && (!$cont_id || $len==$i)))) $cont_rad=$rad_pos->f($this_pos);
				break;
			case 'obj:download':
				$cont_img="rs_download.gif";
				$sub_node=$node->get_children(0);
				if (is_object($sub_node)) {
					require_once('lib/fmng/header.php');
					//echo $sub_node->get_attribs('url');
					$tmp_obj=$Fmng->getObj($sub_node->get_attribs('url'),$Imng->getLangID());
					if (is_object($tmp_obj)) {
						$Title=$tmp_obj->getName();
					} else {
						$Title='????';
					}
				}
				$this_pos=$prev.','.($node_pos+1);
				if ( ($mode!='paragraph'  || ($parent_Name=='paragraph' && (!$cont_id || $len==$i)))) $cont_rad=$rad_pos->f($this_pos);
				break;
			case 'obj:mmedia':
				$cont_img="rs_mmedia.gif";
				$sub_node=$node->get_children(0);
				if (is_object($sub_node)) {
					$Title=$sub_node->get_attribs('name');
				}
				$this_pos=$prev.','.($node_pos+1);
				if ( ($mode!='paragraph'  || ($parent_Name=='paragraph' && (!$cont_id || $len==$i)))) $cont_rad=$rad_pos->f($this_pos);
				break;
			case 'obj:list':
				$cont_img="rs_list.gif";
				$Title=$xml->get_recur_data($ID,$title_len);
				$this_pos=$prev.','.($node_pos+1);
				if ( ($mode!='paragraph'  || ($parent_Name=='paragraph' && (!$cont_id || $len==$i)))) $cont_rad=$rad_pos->f($this_pos);
				break;
			case 'table':
				/*
				if ($sub_nodes) {
					$cont_img="rs_table_collapse.gif";
				} else {
					$cont_img="rs_table_expand.gif";
				}
				$Title=$xml->get_recur_data($ID,$title_len);
				$this_pos=$prev.','.($node_pos+1);
				if ($parent_Name!='col' && ($mode!='paragraph'  || ($parent_Name=='paragraph' && (!$cont_id || $len==$i)))) $cont_rad=$rad_pos->f($this_pos);
				$follow=true;
				*/
				$follow=true;
				break;
			case 'obj:table':
				if ($sub_nodes) {
					$cont_img="rs_table_collapse.gif";
				} else {
					$cont_img="rs_table_expand.gif";
				}
				$Title=$xml->get_recur_data($ID,$title_len);
				$this_pos=$prev.','.($node_pos+1);
				if ( ($mode!='paragraph'  || ($parent_Name=='paragraph' && (!$cont_id || $len==$i)))) $cont_rad=$rad_pos->f($this_pos);
				$follow=true;
				break;
			case 'row':
				$Title='Row';
				if ($sub_nodes) {
					$cont_img="rs_row_collapse.gif";
				} else {
					$cont_img="rs_row_expand.gif";
				}
				$t->parse('TEMP','item_row');
				$Title=$t->getParsed();
				$follow=true;
				break;
			case 'col':
				if ($sub_nodes) {
					$cont_img="rs_col_collapse.gif";
				} else {
					$cont_img="rs_col_expand.gif";
				}
				$t->parse('TEMP','item_col');
				$Title=$t->getParsed();
				$this_pos=$ID.',0';
				if ($mode!='paragraph' ) $cont_rad=$rad_pos->f($this_pos);
				$follow=true;
				break;
			case 'obj:image':
				$cont_img="rs_picture.gif";
				$sub_node=$node->get_children(0);
				if (is_object($sub_node)) {
					//$Title=$sub_node->get_attribs('base');
					$Title=$sub_node->get_attribs('title');
					if (!$Title) $Title=$sub_node->get_attribs('base');
					$Title=substr($Title,0,$title_len);
				}
				$view='image';
				$this_pos=$prev.','.($node_pos+1);
				if ( ($mode!='paragraph'  || ($parent_Name=='paragraph' && (!$cont_id || $len==$i)))) $cont_rad=$rad_pos->f($this_pos);
				break;
			case 'paragraph':
				if ($sub_nodes) {
					$cont_img="rs_absatz_collapse.gif";
				} else {
					$cont_img="rs_absatz_expand.gif";
				}
				$view='paragraph';
				$t->parse('TEMP','item_absatz');
				$Title=$t->getParsed();
				if ($mode=='paragraph' && $cont_id ) {
					$this_pos=$ID.',0';
					if (!$node->children_len()) $cont_rad=$rad_pos->f($this_pos);
				} else {
					$this_pos=$ID.',0';
					$cont_rad=$rad_pos->f($this_pos);
				}
				$follow=true;
				break;
			default:
				continue;
		}
		if ($ID==$cont_id) {
			$style='style="background-color:'.$fg10color.'"';
			if ($mode!='paragraph' || $i!=1) $cont_rad='&nbsp;';
		} else {
			$style='';
		}
		if ($no_rad) {
			$sub_rad=$no_rad;
			$cont_rad='&nbsp;';
		}
		if ($Name=='obj:table')  {
			if ($ID==$cont_id) {
				$sub_rad=true;
			}
			$first_child=$node->get_children(0);
			unset($node);
			$node=$xml->get_node($first_child->get_id());
			unset($first_child);
			$ID=$node->get_id();
			$node->set_attrib('ex',$ex);
			$xml->set_attribs ($ID,array('ex'=>$ex));
		}
		$nav.="<tr>\n";
		if ($node->children_len()) {
			if ($depth!=0) {
				$nav.="<td width=\"14\" valign=\"top\"";
				if ($len==$i) {
					$nav.=">";
				} else {
					$nav.=" background=\"img/$THEME/".$img_line."\">";
				}
				$nav.="<input type=\"image\"  id=\"i1_$ID\" name=\"x[".$ID."]\" src=\"img/$THEME/$img\" class=\"tree_img\"  onDblClick=\"return false;\" onClick=\"return false;\" onMouseUp=\"return toggle('$ID',false,false,event);\"></td>\n";
			}
			$nav.="<td nowrap=\"nowrap\"><div class=\"wdoc_elist_l\" $style><img src=\"img/$THEME/$cont_img\" class=\"list_img\" id=\"i2_$ID\">".FrameWork::entities($Title)."</div>";
		} else {
			if ($depth!=0) {
				$nav.="<td width=\"14\" valign=\"top\"";
				$nav.="><img src=\"img/$THEME/$img\"></td>\n";
			}
			$nav.="<td nowrap=\"nowrap\"><div class=\"wdoc_elist_l\" $style><img src=\"img/$THEME/$cont_img\" class=\"list_img\">".FrameWork::entities($Title)."</div>";
		}
		$nav.="<div class=\"wdoc_elist_r\" $style>$cont_rad</div>\n";
		if ($follow && $node->children_len()) {
			$depth++;
			$nav.=parseTree($node,$sub_rad);
			$depth--;
		}
		$nav.="</td>\n";
		$nav.="</tr>\n";


		$i++;
        }
	$nav.="</table>\n";
	return $nav;
}
?>
