<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

if (isset($addcol)) {
	foreach ($node->get_children() as $row_num=>$row_node) {
		$col_node=$row_node->get_children(0);
		$xml->new_child ($row_node->get_id(),'col',array('align'=>'left','valign'=>$col_node->get_attribs('valign')), '',intval($addcol));
	}
	$modify=true;
}
if (isset($delcol)) {
	foreach ($node->get_children() as $row_num=>$row_node) {
		$col_node=$row_node->get_children($delcol);
		if (is_object($col_node)) {
			$xml->delete_node($col_node->get_id());
		}
	}
	$modify=true;
}
if (isset($aligncol)) {
	switch ($align) {
		case 'r':
			$align='right';
			break;
		case 'c':
			$align='center';
			break;
		case 'j':
			$align='justify';
			break;
		default:
			$align='left';
	}
	foreach ($node->get_children() as $row_num=>$row_node) {
		$col_node=$row_node->get_children($aligncol);
		if (is_object($col_node)) {
			$xml->set_attribs ($col_node->get_id(),array('align'=>$align));
		}
	}
	$modify=true;
}
if (isset($addrow)) {
	$new_row_id=$xml->new_child ($node->get_id(),'row','', '',intval($addrow));
	$first_row=$node->get_children(0);
	foreach ($first_row->get_children() as $col_num=>$col_node) {
		$xml->new_child ($new_row_id,'col',array('align'=>$col_node->get_attribs('align'),'valign'=>'center'), '');
	}
	$node=$xml->get_node($node->get_id());
	$modify=true;
}
if (isset($delrow)) {
	$row_node=$node->get_children($delrow);
	if (is_object($row_node)) {
		$xml->delete_node($row_node->get_id());
	}
	$node=$xml->get_node($node->get_id());
	$modify=true;
}
if (isset($alignrow)) {
	switch ($align) {
		case 't':
			$align='top';
			break;
		case 'b':
			$align='bottom';
			break;
		default:
			$align='center';
	}
	$row_node=$node->get_children($alignrow);
	if (is_object($row_node)) {
		foreach ($row_node->get_children() as $col_num=>$col_node) {
			$xml->set_attribs ($col_node->get_id(),array('valign'=>$align));
		}
	}
	$modify=true;
}


$t->assign('TAB_WIDTH',$xmlFastText->getValue('page|width')+60);

$first_row=$node->get_children(0);
$edit_link=$this_link."&mode=$mode&cont_id=$cont_id&p_mode=$p_mode&p_cont_id=$p_cont_id";
foreach ($first_row->get_children() as $col_num=>$col_node) {
	$col_array[$col_num]=chr(65+$col_num);
	$t->assign("HEAD",$col_array[$col_num]);
	$t->assign("DELCOL",$edit_link."&delcol=".$col_num);
	$t->assign("ADDCOL",$edit_link."&addcol=".$col_num);
	$t->assign("ALIGNCOL_L",$edit_link."&aligncol=".$col_num."&align=l");
	$t->assign("ALIGNCOL_M",$edit_link."&aligncol=".$col_num."&align=c");
	$t->assign("ALIGNCOL_R",$edit_link."&aligncol=".$col_num."&align=r");
	$t->assign("ALIGNCOL_J",$edit_link."&aligncol=".$col_num."&align=j");
	$t->assign("ALIGN_L",'off');
	$t->assign("ALIGN_M",'off');
	$t->assign("ALIGN_R",'off');
	$t->assign("ALIGN_J",'off');
	switch ($col_node->get_attribs('align')) {
		case 'right':
			$t->assign("ALIGN_R",'on');
		break;
		case 'center':
			$t->assign("ALIGN_M",'on');
		break;
		case 'justify':
			$t->assign("ALIGN_J",'on');
		break;
		default:
			$t->assign("ALIGN_L",'on');
	}
	$t->parse('COL','.tablehead');
}
$sub_style['col']=array(
	'rowspan'=>'2',
);
$sub_style['row']=array(
	'rowcolor'=>$node->get_attribs('rowcolor'),
	'headrow'=>$node->get_attribs('headrow'),
	'border'=>$node->get_attribs('border'),
);
$old_mode=$xmlFastText->getMode();
$xmlFastText->init('edit');
$xmlFastText->setLink($this_link."&p_mode=$mode&p_cont_id=$cont_id");
// Tabelleninhalt ausgeben
foreach ($node->get_children() as $row_num=>$row_node) {
	$t->clear_dynamic('tablecol');
	$row_array[$row_num]=$row_num+1;
	$t->assign("HEAD2",$row_num+1);
	$t->assign("DELROW",$edit_link."&delrow=".$row_num);
	$t->assign("ADDROW",$edit_link."&addrow=".$row_num);
	$t->assign("ALIGNROW_T",$edit_link."&alignrow=".$row_num."&align=t");
	$t->assign("ALIGNROW_C",$edit_link."&alignrow=".$row_num."&align=c");
	$t->assign("ALIGNROW_B",$edit_link."&alignrow=".$row_num."&align=b");
	if ($sub_style['row']['headrow']=='1' && $row_num==0) {
		$sub_style['col']['headrow']='1';
	} else {
		$sub_style['col']['headrow']='0';
	}
	if ($sub_style['row']['rowcolor']=='alternate' && !($row_num%2)) {
		$sub_style['col']['rowcolor']='color';
	} else {
		$sub_style['col']['rowcolor']='none';
	}
	if ($sub_style['row']['border']=='border') {
		$sub_style['col']['border']='border';
	} else {
		$sub_style['col']['border']='none';
	}
	if ($row_node->get_attribs('repeat')) {
		$rtattr['repeat']=1;
		$rtattr['row_num']=$row_num;
		$rtattr['rtitle']=$row_node->get_attribs('rtitle');
	}

	foreach ($row_node->get_children() as $col_num=>$col_node) {
		if ($col_num==0) {
			$t->assign("ALIGN_T",'off');
			$t->assign("ALIGN_C",'off');
			$t->assign("ALIGN_B",'off');
			switch ($col_node->get_attribs('valign')) {
				case 'top':
					$t->assign("ALIGN_T",'on');
				break;
				case 'bottom':
					$t->assign("ALIGN_B",'on');
				break;
				default:
					$t->assign("ALIGN_C",'on');
			}

		}


		//$t->assign('ENTRY','a');
		$t->assign('ENTRY',$xmlFastText->getHtml($col_node,1," ","\n",$col_num,$sub_style));
		$t->parse('ROW','.tablecol');
	}
	$t->parse('ROW','.tablerow');
}
$xmlFastText->init($old_mode);

$t->assign("N_ADDROW",$edit_link."&addrow=".($row_num+1));
$t->assign("N_ADDCOL",$edit_link."&addcol=".($col_num+1));

$t->assign('NUM_ROWS',$row_num+1);
$t->assign('NUM_ROWS2',($row_num+1)*2);
$t->assign('NUM_COLS',$col_num+1);

$sel_row=new SelectField('tab_action_row','class="sel"',$row_array);
$sel_col=new SelectField('tab_action_col','class="sel"',$col_array);
$t->assign('SEL_ROW',$sel_row->f());
$t->assign('SEL_COL',$sel_col->f());
$sel_row=new SelectField('tab_del_row','class="sel"',$row_array);
$sel_col=new SelectField('tab_del_col','class="sel"',$col_array);
$t->assign('SEL_ROW_DEL',$sel_row->f());
$t->assign('SEL_COL_DEL',$sel_col->f());

if ($xmlFastText->getMode()=='tpl') {
	$tattr=$xml->get_attribs($cont_id);
	if ($tattr['repeat']=='1') {
		$t->assign('TATTR_REPEAT','checked');
	}
	if ($rtattr['repeat']=='1') {
		$t->assign('RTATTR_REPEAT','checked');
	}
	$sel_row=new SelectField('rtattr[row_num]','class="sel"',$row_array);
	$t->assign('SEL_RTATTR_ROW_NUM',$sel_row->f());
	$t->assign('TATTR_RTITLE',htmlspecialchars($tattr['rtitle']));
	$t->assign('RTATTR_RTITLE',htmlspecialchars($rtattr['rtitle']));
	$t->parse('ROW','edit_tpl');
}

$tab_action=$frm->getObjAction($Imng->getModul(),'doc_view');
foreach ($tab_action as $key=>$val) {
	if (in_array('content',$val['Extra']) && !$Imng->isClipboard('wcont')) continue;
	$t->assign('SEL_VAL',$key);
	$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
	$t->parse('ROW','.tab_action_val');
}



$t->define (array('tpl_table_js_menu' => "wdoc_edit_table_js_menu.inc.html"));
$t->assign('JUMP_URL',$this_link."&p_mode=$mode&p_cont_id=$cont_id");
$t->assign('JUMP_URL_INSERT',$edit_link.'&cont_action_x=1&cont_action_val=insert');
if ($Imng->isClipboard('wcont')) {
	$t->parse('ROW','cont_insert');
}
$t->Parse('TPL_TABLE_JS_MENU','tpl_table_js_menu');
?>
