<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array('tpl_root' => "wdoc_list.inc.html"));
$img_line= "<img src=\"img/$THEME/tree_vertline.gif\" align=\"left\" border=1>";
$img_split_ex = "<img src=\"img/$THEME/tree_split_ex.gif\" align=\"left\" border=1>";
$img_split_co = "<img src=\"img/$THEME/tree_split_co.gif\" align=\"left\"e border=1>";
$img_split = "<img src=\"img/$THEME/tree_split.gif\" align=\"left\" border=1>";
$img_end_ex= "<img src=\"img/$THEME/tree_end_ex.gif\" align=\"left\"e border=1>";
$img_end_co= "<img src=\"img/$THEME/tree_end_co.gif\" align=\"left\"e border=1>";
$img_end= "<img src=\"img/$THEME/tree_end.gif\" align=\"left\" border=1>";
$img_spc = "<img src=\"img/$THEME/tree_space.gif\" align=\"left\" border=1>";
$img_up="<img src=\"img/$THEME/rs_up.gif\" width=11 height=11 hspace=0 border=1>";
$img_down="<img src=\"img/$THEME/rs_down.gif\" width=11 height=11 hspace=3 border=1>";
$img_top="<img src=\"img/$THEME/rs_top.gif\" width=11 height=11 hspace=3 border=1>";
$img_tras="<img src=\"img/$THEME/tras.gif\" width=11 height=11 hspace=1 border=1>";

$title_len=30;


function plist($prev,$prev_prev=-1,$prev_pos=-1) {
	global $Imng,$xml,$t,$THEME,$site,$this_link,$title_len,$Fmng;
	global $img_end,$img_end_ex,$img_end_co,$img_split,$img_split_co,$img_split_ex,$img_spc,$img_line;
	static $depth=0,$j=0;
        $i=1;
        $len=$xml->children_len($prev);
	//echo $prev.':'.$len.'<br>';
	//echo '<pre>';

        foreach ($xml->get_children($prev) as $node_pos=>$node) {
		if ($depth==0) {
			$t->clear_dynamic("container_list");
		}
		$ID=$node->get_id();
		//echo 'ID:'.$ID.'<br>';
		$Name=$node->get_name();
		if ($node->children_len()) {
			if (isset($expand[$ID])) {
				if ($len==$i) $img[$depth]=$img_end_co; else $img[$depth]=$img_split_co;
			} else {
				if ($len==$i) $img[$depth]=$img_end_ex; else $img[$depth]=$img_split_ex;
			}
			$img[$depth]="<a href=\"$ex_link&x=$ID\">".$img[$depth]."</a>";
		} else {
			if ($len==$i) {
				$img[$depth]=$img_end;
			} else {
				$img[$depth]=$img_split;
			}
		}

		if ($depth==0) {
			if ($len==$i) $img[$depth]=$img_spc; else $img[$depth]=$img_line;
			$depth++;
			plist($ID,$prev,$node_pos);
			$img[$depth]="";
			$depth--;
		}
		$Title='';
		//echo $node->get_name().'<br>';
		$m_function='viewBackground';
		switch ($node->get_name()) {
			case 'obj:fasttext':
				$cont_img="rs_exttext.gif";
				$Title=$xml->get_recur_data($ID,$title_len);
				$view='fasttext';
				break;
			case 'obj:text':
				$cont_img="rs_text.gif";
				$Title=$xml->get_recur_data($ID,$title_len);
				$view='text';
				break;
			case 'obj:title':
				$sub_node=$node->get_children(0);
				if (is_object($sub_node)) {
					if ($sub_node->get_attribs('style')=='h1') {
						$cont_img="rs_main.gif";
					} elseif ($sub_node->get_attribs('style')=='h2') {
						$cont_img="rs_sub.gif";
					} elseif ($sub_node->get_attribs('style')=='h3') {
						$cont_img="rs_section.gif";
					}
				} else {
					$cont_img="rs_main.gif";
				}
				$Title=$xml->get_recur_data($ID,$title_len);
				$view='title';
				break;
			case 'obj:link':
				$cont_img="rs_link.gif";
				$Title=$xml->get_recur_data($ID,$title_len);
				$view='link';
				break;
			case 'obj:download':
				$cont_img="rs_download.gif";
				$sub_node=$node->get_children(0);
				if (is_object($sub_node)) {
					require_once('lib/fmng/header.php');
					//echo $sub_node->get_attribs('url');
					$tmp_obj=$Fmng->getObj($sub_node->get_attribs('url'),$Imng->getLangID());
					if (is_object($tmp_obj)) {
						$Title=$tmp_obj->getName($Imng->getLangID());
					} else {
						$Title='????';
					}
				}

				$view='download';
				break;
			case 'obj:address':
				$cont_img="rs_address.gif";
				$sub_node=$node->get_children(0);
				if (is_object($sub_node)) {
					$Addr=& $frm->getStaticModul('addr');
					//echo $sub_node->get_attribs('url');
					$tmp_obj=$Addr->getAddrObj($sub_node->get_attribs('url'));
					if (is_object($tmp_obj)) {
						$Title=$tmp_obj->getName($Imng->getLangID());
					} else {
						$Title='????';
					}
				}

				$view='address';
				break;
			case 'obj:list':
				$cont_img="rs_list.gif";
				$Title=$xml->get_recur_data($ID,$title_len);
				$view='list';
				break;
			case 'obj:table':
				$m_function='';
				$cont_img="rs_table.gif";
				$Title=$xml->get_recur_data($ID,$title_len);
				$view='table';
				break;
			case 'obj:image':
				$m_function='';
				$cont_img="rs_picture.gif";
				$sub_node=$node->get_children(0);
				if (is_object($sub_node)) {
					$Title=$sub_node->get_attribs('base');
					$Title.=' - '.$sub_node->get_attribs('title');
				}
				$view='image';
				break;
			case 'obj:mmedia':
				$cont_img="rs_mmedia.gif";
				$sub_node=$node->get_children(0);
				if (is_object($sub_node)) {
					$Title.=$sub_node->get_attribs('name');
				}
				$view='mmedia';

				break;
			case 'paragraph':
				$cont_img="rs_absatz.gif";
				$view='paragraph';
				break;
		}
		if ($i>1) {
			$l_up=$this_link."&move=$ID,$prev,".($node_pos-1);
		} else {

			$tmp=$xml->get_child($prev_prev,$prev_pos-1);
			if ($tmp) {
				$l_up=$this_link."&move=$ID,".$tmp->get_id().",-1";
			} else {
				$l_up="#";
			}
		}
		if ($i <$len) {
			$l_down=$this_link."&move=$ID,$prev,".($node_pos+1);
		} else {
			$tmp=$xml->get_child($prev_prev,$prev_pos+1);
			if ($tmp) {
				$l_down=$this_link."&move=$ID,".$tmp->get_id().",0";
			} else {
				$l_down="#";
			}
		}
		$l_delete=$this_link."&delete=$ID";
		$l_content=$this_link."&mode=$view&cont_id=$ID";
		$t->assign('L_UP',$l_up);
		$t->assign('L_DOWN',$l_down);
		$t->assign('L_DELETE',$l_delete);
    		$t->assign("CONT_IMG",$cont_img);
		$t->assign('CONT_TITLE',FrameWork::entities($Title));
		$t->assign("CONT_NUM",$i);
		if ($m_function) {
			$t->assign("MOUSE_OVER",$m_function."($ID,true)");
			$t->assign("MOUSE_OUT",$m_function."($ID,false)");
		} else {
			$t->assign("MOUSE_OVER",'');
			$t->assign("MOUSE_OUT",'');
		}
		$t->assign("CONT_ID",$ID);
		$t->assign("L_CONTENT",$l_content);
		if ($depth==0) {
			$t->parse("ROW",".paragraph_list");
		} else {
			$t->parse("ROW",".container_list");
		}
                $i++;
        }
}
plist(0);

$t->parse("TPL_ROOT","tpl_root");
?>
