<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

$t->assign('MOD_TITLE',$frm->getAppName('imng'));
if (!$app["imng"]) {
	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
} else {
	$user_id=$auth->auth['uid'];
	require_once('lib/imng/header.php');
	require_once('lib/bmng/header.php');
	require_once('lib/fmng/header.php');
	$t->setRoot("tpl/$THEME/imng/$session_lang");
	$t->define (array('application' => "header.inc.html"));
	$obj=false;
	$ActionError=false;
	$root_id=0;
	$root_obj=array();
	$root_ids=array();

	$root_obj_d=$Imng->getSystemObj('d','00',true);
	if (is_object($root_obj_d)) {
		$root_obj[$root_obj_d->getID()]=$root_obj_d;
		$root_ids[]=$root_obj_d->getID();
	}

	$root_obj_s=$Imng->getSystemObj('s','00',true);
	if (is_object($root_obj_s)) {
		$root_obj[$root_obj_s->getID()]=$root_obj_s;
		$root_ids[]=$root_obj_s->getID();
	}

	$trash_obj=$Imng->getSystemObj('t','00',true);
	if (is_object($trash_obj)) {
		$root_obj[$trash_obj->getID()]=$trash_obj;
		$root_ids[]=$trash_obj->getID();
	}

	$oid=Framework::getParam('oid');
	if ($oid) {
		$obj=$Imng->getObj($oid);
		if (is_object($obj)) {
			$root_id=$obj->getParentMeta('RootID');
		}
	}

	if (!$root_id || !in_array($root_id,$root_ids)) {
		$oid=$root_id=key($root_obj);
		$obj=$Imng->getObj($oid);
	}
	if (!isset($BL)) $sess->register('BL');
	if ($obj->getParentMeta('LangID')!='00') {
		$BL=$obj->getParentMeta('LangID');
	}
	if ($LangID) $BL=$LangID;
	if (!in_array($BL,$Imng->getAvLang())) {
		$BL=$session_lang;
	}
	if (!$BL) $BL=$session_lang;

	$Imng->setLangID($BL);
	$rootObj=$root_obj[$root_id];

	if (!is_object($rootObj) || !is_object($obj) || !$obj->getAcl(1) || !$Imng->getPerms(2)) {
		$t->assign('TPL_ERROR','');
		$t->define (array('tpl_card' => "no_perms.inc.html"));
		$t->parse('TPL_CARD','tpl_card');
	} else {
		if ($CloseObj && $CloseMod) {
			$frm->deleteOpenObjects($CloseMod,$CloseObj);
			$Imng->deleteContentTemp($CloseObj);
		}
		foreach ($Imng->getAvLang() as $val) {
			if (is_object($root_obj_s)) {
				$t->assign('LANG_URL',"index.php?site=$site&oid=".$root_obj_s->getID()."&LangID=".$val);
				if ($BL==$val) {
					$t->assign('LANG_NAME','<strong>'.strtoupper($val).'</strong>');
				} else {
					$t->assign('LANG_NAME',strtoupper($val));
				}
				$t->parse('ROW','.root_lang');
			}
		}
		$t->parse('ROW','root_vimng');

		//if (!$mode) $mode='mod';
		$Imng->setMode($mode);
		$Imng->setRootObj($rootObj);
		$xmlFastText->setStyle($Imng->getBlackStyles(0),0);
		$xmlFastText->setImgClass($Bmng);
		$frm->setStyleSheet('0_style.css');
		if ($pre["global"]['js']) $t->parse("ROW","conf_delete");

		if (!$action)  $action=$obj->getAction(0);
		$L_THIS="index.php?site=$site&action=$action&oid=$oid";
		$Imng->setClipboard('iobj',$frm->getClipboard('iobj'));

		/*if (($meta_save_x || $ext_upload_x) && $obj->getAcl(2)) {
			if ($new) {
				require ('lib/imng/inc_NewObject.php');
			} else {
				require ('lib/imng/inc_UpdateObject.php');
			}
		} else*/
		if ($obj_action_x && $obj_action_val) {
			require ('lib/imng/func_Action.php');
			require ('lib/imng/inc_ActionObject.php');
		} elseif ($list_action_x && $list_action_val) {
			require ('lib/imng/func_Action.php');
			require ('lib/imng/inc_ActionList.php');
		}

		foreach ($root_obj as $val) {
			$t->assign('M_IMG',$val->getImage(0));
			$t->assign('M_NAME',FrameWork::entities($val->getName()));
			$t->assign('M_URL',"index.php?site=$site&oid=".$val->getID());
			if ($root_id==$val->getID()) {
				$t->assign('M_ON','on');
			} else {
				$t->assign('M_ON','off');
			}
			$t->parse('ROW','.root_header_'.$val->getMeta('System'));
		}

		$obj_tree=$Imng->getObjTree($oid);
		$tmp_tree='';
		if (is_array($obj_tree)) {
			foreach ($obj_tree as $key=>$val) {
				$tmp_tree="<a href=\"index.php?site=$site&oid=$key\">".FrameWork::entities($val).'</a>/'.$tmp_tree;
			}
		}
		$t->assign('OBJ_TREE',$tmp_tree);
		$t->assign('OBJ_NAME',FrameWork::entities($obj->getName()));

		if ($action=="b") {
			require("lib/class_form.inc.php");
			require("imng/browse_list_js.php");
			if (!$mode && $rootObj->getMeta('System')=='d') {
				$t->define (array('tpl_card' => "browse_overview.inc.html"));
				require("imng/browse_overview.php");
			} else {
				$t->define (array('tpl_card' => "browse_content.inc.html"));
				require("imng/browse_content.php");
			}
			$t->parse('TPL_CARD','tpl_card');
		}
		if ($action=="bt") {
			$t->define (array('tpl_card' => "browse_content.inc.html"));
			require("lib/class_form.inc.php");
			require("imng/browse_list_js.php");
			require("imng/browse_content.php");
			$t->parse('TPL_CARD','tpl_card');
		}

		if ($action=="vo") {
			$t->define (array('tpl_card' => "view_content.inc.html"));
			require("lib/class_form.inc.php");
			require("imng/browse_list_js.php");
			require("imng/view_content.php");
			$t->parse('TPL_CARD','tpl_card');
		}
		if ($action=="p") {
			$t->define (array('tpl_card' => "perms_content.inc.html"));
			require("lib/class_form.inc.php");
			require("imng/browse_list_js.php");
			require("imng/perms_content.php");
			$t->parse('TPL_CARD','tpl_card');
		}
		if ($Imng->isSuperAdmin()) {

			$t->assign('CFG_URL',"index.php?site=$site&action=scfg&oid=".$root_id);
			if ($action=='scfg') {
				$t->assign('CFG_ON','on');
				$t->define (array('tpl_card' => "config.inc.html"));
				require("lib/class_form.inc.php");
				require("imng/browse_list_js.php");
				require("imng/config.php");
				$t->parse('TPL_CARD','tpl_card');
			} else {
				$t->assign('CFG_ON','off');
			}
			$t->parse('ROW','w_config');
		}
		if ($action=="wd") {
			if ($obj->getMeta('TemplateID')) {
				require("imng/wdoc_tpl.php");
			} else {
				require("imng/wdoc.php");
			}
		}
		if ($action=="wt") {
			require("imng/wdoc.php");
		}
		if ($action=="btpl") {
			if (!$toid) $toid=$Imng->getCfg('wcat/en_tpl');
			$tobj=$Imng->getObj($toid);
			if (!$tobj->isFolder()) {
				if ($obj->isFolder() && $tobj->getMeta('Content')) {
					$obj_action_val='n_tpl_wdoc';
					require ('lib/imng/func_Action.php');
					require('lib/imng/inc_ActionObject.php');
				}
				$toid=$tobj->getParentMeta('ParentID');
				$tobj=$Imng->getObj($toid);
			}
			$troot_id=$tobj->getParentMeta('RootID');
			$troot_obj=$Imng->getObj($Imng->getCfg('wcat/en_tpl'));
			$t->define (array('tpl_card' => "browse_sel_tpl_content.inc.html"));
			require("imng/browse_tpl_list_js.php");
			require("imng/browse_tpl_content.php");
			$t->parse('TPL_CARD','tpl_card');
		}

		if ($action=="s") {
			$t->define (array('tpl_card' => "search.inc.html"));
			require("lib/class_form.inc.php");
			require("imng/search.php");
			$t->parse('TPL_CARD','tpl_card');
		}
		if ($action=="imp") {
			require("lib/class_form.inc.php");
			require("imng/browse_list_js.php");
			$t->define (array('tpl_card' => "import_content.inc.html"));
			require("imng/import_content.php");
			$t->parse('TPL_CARD','tpl_card');
		}

		$t->assign('T_S_ACTION',"index.php?site=$site&action=s");

		if ($E->isError()) {
			$t->unload('tpl_error');
			$t->assign('TPL_ERROR',$E->process());
		} elseif ($ActionError) {
			require('imng/view_error.php');
		}
	}
}
?>
