gprError=true;
asxPoller = function() {
	var me = this;
	var _channels = {};
	var _que_events = {};
	var _stopPoll = false;
	var _cookie = '';

	this.poll = function() {
		if( _stopPoll ) {
			return;
		}
		try {
			jQuery.ajax({
				'url': 'ajax_asx.php?randomId=' + Math.random() + '&asx_cookie=' + encodeURIComponent( _cookie),
				'dataType': 'json',
				'success': function(data, textStatus, XMLHttpRequest) {
					gprError=true;
					_cookie=data.cookie;
					_process(data);
					//alert('poll');
					me.poll();
				},
				'error': function(jqXHR, textStatus, errorThrown) {
					gprError=true;
				},
				'beforeSend':function(jqXHR, settings){
					gprError=false;
				}
			});
		} catch(e) {
			alert('errr');
			gprError=true;
		}
	};
	this.showActivDialogs = function() {
		if (grpWin && grpWin.jQuery) {
			for (id in _channels) {
				if (!_isDialogOpen(id)) {
					_showDialog(id);
				}
			}
		}
	};
	
	_isDialogOpen = function(id) {
		if( typeof _channels[id] != 'undefined') {
			var callDialog=grpWin.jQuery("#call_" + id);
			if (callDialog.length && callDialog.dialog( "isOpen" )) {
				return true;
			}
		}
		return false;
	};

	_showDialog = function(id) {
		if( typeof _channels[id] != 'undefined' && _channels[id].enable) {
			if (!_channels[id].dialog.html) {
				var html='<div class="call">';
				html+='<h1>' + _channels[id].event.calldisp + '</h1>';
				html+='<br />';
				//html+='<br/>';
				//html+='<div class="ext">' + event.callchannel + '</div>';
				if (jQuery.isPlainObject(_channels[id].event.callredirect) && !jQuery.isEmptyObject(_channels[id].event.callredirect)) {
					html+='<div class="redirect" style="display:none;">';
					html+='<strong>' + geTranslation.asx_transfer + '</strong><br />';
					html+='<select style="width:270px;" id="asx_redirect" onchange="hiddenWin.geAsxPoller.asxRedirect(\'' + id + '\',jQuery(this).val())">';
					html+='<option value="">-</option>';
					jQuery.each(_channels[id].event.callredirect,function(i,val) {
						html+='<option value="' + i + '">' + val + '</option>';
					});
					html+='</select>';
					html+='</div>';
				}
				html+='<br />';
				html+='</div>';
				_channels[id].dialog.html=html;
			}
			if (!_channels[id].dialog.options) {
				_channels[id].dialog.options={
					title:geTranslation.asx_newcall,
					position:[10,10],
					draggable: true,
					beforeClose: function(event, ui) {
						if( typeof _channels[grpWin.jQuery(this).data('channel_id')] != 'undefined') {
							delete _channels[grpWin.jQuery(this).data('channel_id')];
						}
					}
				};
			}
			_channels[id].dialog.options.buttons=[];
			if (_channels[id].event.bt_respond) {
				_channels[id].dialog.options.buttons.push({
					text: geTranslation.asx_answer,
					click: function() {
						geAsxPoller.asxRedirect(id,_channels[id].event.bt_respond);
					}
				});
			}
			if (_channels[id].event.bt_close)  {
				_channels[id].dialog.options.buttons.push({
						text: geTranslation.asx_hangup,
						click: function() {
							geAsxPoller.terminateCall(id);
						}
					});
			}
			var callDialog=grpWin.jQuery("#call_" + id);
			if (!callDialog.length) {
				callDialog=grpWin.jQuery("<div id=\"call_" + id + "\"></div>");
				grpWin.jQuery(grpWin.document.body).append(callDialog);
			}
			callDialog.data('channel_id', id);
			callDialog.html(_channels[id].dialog.html);
			if (_channels[id].event.bt_redirect) {
				callDialog.find('.redirect').css('display','block');
			} else {
				callDialog.find('.redirect').css('display','none');
			}
			
			callDialog.dialog(_channels[id].dialog.options);
		}
		return grpWin.jQuery("#call_" + id);
	};
	_disableDialog = function(id) {
		grpWin.jQuery("#call_" + id).dialog('disable');
	};
	_enableDialog = function(id) {
		grpWin.jQuery("#call_" + id).dialog('enable');
	};

	_process = function( events ) {
		if( events.type != 'success' ) {
			//alert("Unable to communicate with the remote asterisk");
			_stopPoll = true;
		}
		if (jQuery.isArray(events.events)) {
			//console.log(events.events);
			jQuery.each(events.events,function(i,event) {
				try {
					_processCall(event);
				} catch(e) {
					gprError=true;
				}
			})
		}
	};

	_processCall = function( event ) {
		switch(event.event) {
			case 'dial':
				//console.log('Dial:' + event.callid);
				if( typeof _channels[event.callid] == 'undefined') {
					_channels[event.callid] = {
						'event':{},
						'dialog':{},
						'enable':true
					}
				} else {
					//Call Gibt es schon, heisst der Up kam vor dem Dial;
					
				}
				jQuery.extend(_channels[event.callid].event,event);
				_showDialog(event.callid);
				if ( typeof _que_events[event.callid] != 'undefined') {
					//Falls que diese jetzt abarbeiten
					_processCall(_que_events[event.callid]);
					delete _que_events[event.callid];
				}
			break;
			case 'down':
				//console.log('Hangup:' + event.callid);
				if( typeof _channels[event.callid] != 'undefined') {
					delete _channels[event.callid];
				}
				var callDialog=grpWin.jQuery("#call_" + event.callid);
				if (callDialog.length) {
					callDialog.dialog("close");
				}
			break;
			case 'up':
				if( typeof _channels[event.callid] == 'undefined') {
					//In que da noch kein Diale Event da;
					_que_events[event.callid]=event;
				} else {
					jQuery.extend(_channels[event.callid].event,event);
					_showDialog(event.callid);
				}
				//console.log(_channels[event.callid]);
			break;
			case 'hold':
				if ( typeof _channels[event.callid] != 'undefined') {
					_disableDialog(event.callid);
				}
			break;
			case 'retrieve':
				if ( typeof _channels[event.callid] != 'undefined') {
					_enableDialog(event.callid);
				}
			break;

		}
	};

	this.terminateCall = function( id ) {
		if (id && typeof _channels[id] != 'undefined') {
			jQuery.ajax({
				'url': 'ajax.php?randomId=' + Math.random() + '&ajax_modul=asxHangup&channel=' + encodeURIComponent(_channels[id].event.callchannel),
				'dataType': 'json',
				'success': function(data, textStatus, XMLHttpRequest) {

				},
				'error': function(jqXHR, textStatus, errorThrown) {

				},
				'beforeSend':function(jqXHR, settings){

				}
			});
		}
	}
	this.asxRedirect = function( id, to ) {
		//alert(exten);
		if (to) {
			jQuery.ajax({
				'url': 'ajax.php?randomId=' + Math.random() + '&ajax_modul=asxRedirect&channel=' + encodeURIComponent(_channels[id].event.callchannel) + '&exten=' + encodeURIComponent(to) + '&status=' + encodeURIComponent(_channels[id].event.event),
				'dataType': 'json',
				'success': function(data, textStatus, XMLHttpRequest) {

				},
				'error': function(jqXHR, textStatus, errorThrown) {

				},
				'beforeSend':function(jqXHR, settings){

				}
			});
		}
	}
	
};
var geAsxPoller = new asxPoller();
jQuery(document).ready(function() {
	window.setTimeout( "geAsxPoller.poll();", 100 );
});
