gprError=true;
asxPoller = function() {
	var me = this;
	var _channels = {};
	var _que_events = {};
	var _stopPoll = false;
	var _cookie = '';

	this.poll = function() {
		if( _stopPoll ) {
			return;
		}
		try {
			jQuery.ajax({
				'url': 'ajax_asx.php?randomId=' + Math.random() + '&asx_cookie=' + encodeURIComponent( _cookie),
				'dataType': 'json',
				'success': function(data, textStatus, XMLHttpRequest) {
					gprError=true;
					_cookie=data.cookie;
					_process(data);
					//alert('poll');
					me.poll();
				},
				'error': function(jqXHR, textStatus, errorThrown) {
					gprError=true;
				},
				'beforeSend':function(jqXHR, settings){
					gprError=false;
				}
			});
		} catch(e) {
			alert('errr');
			gprError=true;
		}
	};
	this.showActivDialogs = function() {
		if (grpWin && grpWin.jQuery) {
			for (id in _channels) {
				if (!_isDialogOpen(id)) {
					_showDialog(id);
				}
			}
		}
	};
	
	_isDialogOpen = function(id) {
		if( typeof _channels[id] != 'undefined') {
			var callDialog=grpWin.jQuery("#call_" + id);
			if (callDialog.length && callDialog.dialog( "isOpen" )) {
				return true;
			}
		}
		return false;
	};

	_showDialog = function(id) {
		if( typeof _channels[id] != 'undefined' && _channels[id].enable) {
			if (!_channels[id].dialog.html) {
				var html='<div class="call">';
				html+='<h1>' + _channels[id].event._calldisp + '</h1>';
				html+='<br />';
				//html+='<br/>';
				//html+='<div class="ext">' + event._callchannel + '</div>';
				if (jQuery.isPlainObject(_channels[id].event._callredirect) && !jQuery.isEmptyObject(_channels[id].event._callredirect)) {
					html+='<div>';
					html+='<strong>' + geTranslation.asx_transfer + '</strong><br />';
					html+='<select style="width:270px;" id="asx_redirect" onchange="hiddenWin.asxRedirect(\'' + _channels[id].event._callchannel + '\',jQuery(this).val(),\'' + _channels[id].status + '\')">';
					html+='<option value="">-</option>';
					jQuery.each(_channels[id].event._callredirect,function(i,val) {
						html+='<option value="' + i + '">' + val + '</option>';
					});
					html+='</select>';
					html+='</div>';
				}
				html+='<br />';
				html+='</div>';
				_channels[id].dialog.html=html;
			}
			if (!_channels[id].dialog.options) {
				_channels[id].dialog.options={
					title:geTranslation.asx_newcall,
					position:[10,10],
					draggable: true,
					beforeClose: function(event, ui) {
						if( typeof _channels[grpWin.jQuery(this).data('channel_id')] != 'undefined') {
							delete _channels[grpWin.jQuery(this).data('channel_id')];
						}
					}
				};
			}
			if (_channels[id].status=='up') {
				_channels[id].dialog.options.buttons=[{
						text: geTranslation.asx_hangup,
						click: function() {
							_terminateCall(id);
						}
					}
				];
			} else if (_channels[id].event._autoresponder) {
				_channels[id].dialog.options.buttons=[{
					text: geTranslation.asx_answer,
					click: function() {
						asxRedirect(_channels[id].event._callchannel,_channels[id].event._autoresponder,_channels[id].status);
					}
				}];
			}
			var callDialog=grpWin.jQuery("#call_" + id);
			if (!callDialog.length) {
				callDialog=grpWin.jQuery("<div id=\"call_" + id + "\"></div>");
				grpWin.jQuery(grpWin.document.body).append(callDialog);
			}
			callDialog.data('channel_id', id);
			callDialog.html(_channels[id].dialog.html);
			callDialog.dialog(_channels[id].dialog.options);
		}
		return grpWin.jQuery("#call_" + id);
	};

	_process = function( events ) {
		if( events.type != 'success' ) {
			//alert("Unable to communicate with the remote asterisk");
			_stopPoll = true;
		}
		if (jQuery.isArray(events.events)) {
			//console.log(events.events);
			jQuery.each(events.events,function(i,event) {
				try {
					_processCall(event);
				} catch(e) {
					gprError=true;
				}
			})
		}
	};

	_processCall = function( event ) {
		switch(event.event) {
			case 'Dial':
				//console.log('Dial:' + event._callid);
				if( typeof _channels[event._callid] == 'undefined') {
					_channels[event._callid] = {
						'event':{},
						'dialog':{},
						'status':'dial',
						'enable':true
					}
				}
				_channels[event._callid].event=event;
				_showDialog(event._callid);
			break;
			case 'Hangup':
				//console.log('Hangup:' + event._callid);
				if( typeof _channels[event._callid] != 'undefined') {
					delete _channels[event._callid];
				}
				var callDialog=grpWin.jQuery("#call_" + event._callid);
				if (callDialog.length) {
					callDialog.dialog("close");
				}
			break;
			case 'Newstate':
				//console.log('Newstate:' + event._callid);
				if (event.state=='Up') {
					if( typeof _channels[event._callid] == 'undefined') {
						_channels[event._callid] = {
							'event':event,
							'dialog':{},
							'status':'up',
							'enable':false
						};
					} else {
						_channels[event._callid].status='up';
						_channels[event._callid].enable=true;
						_showDialog(event._callid);
					}
				}
			break;

		}
	};

	_terminateCall = function( id ) {
		if (id && typeof _channels[id] != 'undefined') {
			jQuery.ajax({
				'url': 'ajax.php?randomId=' + Math.random() + '&ajax_modul=asxHangup&channel=' + encodeURIComponent(_channels[id].event._callchannel),
				'dataType': 'json',
				'success': function(data, textStatus, XMLHttpRequest) {

				},
				'error': function(jqXHR, textStatus, errorThrown) {

				},
				'beforeSend':function(jqXHR, settings){

				}
			});
		}
	}
};
function asxRedirect(channel,exten,status) {
	//alert(exten);
	if (exten) {
		jQuery.ajax({
			'url': 'ajax.php?randomId=' + Math.random() + '&ajax_modul=asxRedirect&channel=' + encodeURIComponent(channel) + '&exten=' + encodeURIComponent(exten) + '&status=' + encodeURIComponent(status),
			'dataType': 'json',
			'success': function(data, textStatus, XMLHttpRequest) {

			},
			'error': function(jqXHR, textStatus, errorThrown) {

			},
			'beforeSend':function(jqXHR, settings){

			}
		});
	}
}

var poller = new asxPoller();
jQuery(document).ready(function() {
	window.setTimeout( "poller.poll();", 100 );
});
