Ext.ns('ge.core.view');
ge.core.view.log = Ext.extend(Ext.Window, {
	options: {},
	layout: 'fit',
	title: $T('[[Logbuch]]'),
	height: 400,
	width: 850,
	closeAction: 'hide',
	stateful:false,
	initComponent: function() {
		this.stateData = ge.getFormStateData(this.id) || {};
		var config={
			border:false,
			items: [
				{
					xtype: 'form',
					id: this.id + 'Form',
					layout: 'fit',
					border:false,
					bodyStyle:'padding:10px',
					labelAlign  : 'left',
					labelWidth:150,
					items: [
						{
							xtype: 'fieldset',
							layout: 'form',
							title: $T('[[Neuer Eintrag]]'),
							items: [
								{
									xtype: 'textarea',
									name: 'message',
									id: this.id + 'Message',
									fieldLabel: $T('[[Nachricht_sin]]'),
									allowBlank: false,
									height: 250,
									width: 600
								}
							]
						}
					]
				}
			],
			buttons: [{
				text     : $T('[[Speichern]]'),
				handler : function () {
					var obj=this.findParentByType(ge.core.view.log);
					//console.log(this.getComponent('msgSendmsgForm').getForm().getValues());
					if (obj.getComponent(obj.id + 'Form').getForm().isValid()) {

						var saveData = obj.getComponent(obj.id + 'Form').getForm().getValues();
						obj.fireEvent('geLogSave',saveData);
						
						/*saveData.extAction="geMsgCtrlAjax";
						saveData.extMethod="sendMsgMessage";
						Ext.Ajax.request({
							waitMsg: $T('[[Bitte warten]]'),
							url: 'router.php',
							params: saveData,
							success: function(response){
								handleResult(response);
							},
							failure: function(response){
								handleResult(response);
							}
						});*/
					}
					return false;
				}
			},{
				text     : $T('[[Abbrechen]]'),
				handler : function () {
					this.findParentByType(ge.core.view.log).hide();
				}
			}]
		};
		this.geLogShow = function(msgParams) {
			if (!this.isVisible()) {
				this.show();
				this.findById(this.id + 'Message').focus(true,true);
			}
		};
		this.geLogHide = function(msgParams) {
			if (this.isVisible()) {
				this.hide();
			}
		};
		this.geLogReset = function(msgParams) {
			this.getComponent(this.id + 'Form').getForm().reset();
		};

		Ext.applyIf(this, config);
		ge.core.view.log.superclass.initComponent.call(this);
	}
});
