<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
$user_id=$auth->auth['uid'];
if ($user_id==$CFG['SUPERADMIN']) {
	$sadmin=1;
} else {
	$sadmin=0;
}
$Mail=& $frm->getStaticModul('mail');
$Fmng=& $frm->getStaticModul('fmng');
if ($type=='mail') {
	$uaccess_ids=$Mail->listUserAccess($auth->auth['uid']);
	if ($uaccess_ids && $MACC_ID && $MACC_ID!=$auth->auth['uid'] && in_array($MACC_ID,$uaccess_ids)) {
		$tmp=$frm->read_user($MACC_ID);
		$username=$tmp['username'];
		$password=$tmp['password'];
		$muser_id=$MACC_ID;
	} else {
		$username=$auth->auth['uname'];
		$password=$auth->auth['password'];
		$muser_id=$auth->auth['uid'];
	}
	$Mail->setUser($muser_id);
	$Mail->setUserName($username);
	$Mail->setPassword($password);
	$Mail->open();
	if ($Mail->isOpen()) {
		$mobj=$Mail->getObj($moid);
		if (is_object($mobj)) {
			$Mobj=$Mail->getMailObj($mobj->getBox(),$mid);
		}
	}
}
if (!$app["fmng"] || !is_object($Mobj) || (!$Fmng->getPerms(1) && !$Fmng->getPerms(2))) {
	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
	$t->assign('MOD_TITLE','');
} else {
	$t->setRoot("tpl/$THEME/fmng/$session_lang");
	$root_id=0;
	if ($Fmng->getPerms(1)) {
		$root_obj_u=$Fmng->getSystemObj('u',$session_lang,$user_id,true);
		if (is_object($root_obj_u)) {
			$root_obj[$root_obj_u->getID()]=$root_obj_u;
			unset($root_obj_u);
		} else {
			$root_obj_u=$Fmng->getSystemObj('u',$CFG['AV_LANG'],0,false);
			if (is_object($root_obj_u)) {
				$Fmng->insertMeta($root_obj_u);
				$root_obj_u->setParentMeta('UserID',$user_id);
				$root_obj_u->setParentMeta('RootID',$root_obj_u->getID());
				$Fmng->insertParentMeta($root_obj_u);
				$root_obj[$root_obj_u->getID()]=$root_obj_u;
				unset($root_obj_u);
			}
		}
	}
	if ($Fmng->getPerms(2)) {
		$root_obj_s=$Fmng->getSystemObj('s',$session_lang,0,true);
		if (is_object($root_obj_s)) {
			$root_obj[$root_obj_s->getID()]=$root_obj_s;
			unset($root_obj_s);
		}
	}
	if (!$root_id || !isset($root_obj[$root_id])) {
		$oid=$root_id=key($root_obj);
		$obj=$Fmng->getObj($oid,$CFG['MA_LANG']);
	}
	$close=false;
	$rootObj=$root_obj[$root_id];
	if ($type=='mail') {
		require("lib/mail/classMailDecode.php");
		$MDec=new MailDecode($Mail);
		$bodyar=$MDec->getBody($mobj->getBox(),$Mobj);
		$File['name']=$Mail->mail_enc($bodyar['att'][$DL_PART]['name']);
		$File['type']=$bodyar['att'][$DL_PART]['type'];
		$File['enc']=$bodyar['att'][$DL_PART]['enc'];
	}
	if ($meta_save_x) {
		$obj=$Fmng->getObj($_POST['ObjFolder']);
		if (!is_object($obj) || !$obj->getAcl(2)) {
			$ActionError['WriteError']=$obj->getID();
		}
		if (!$ActionError) {
			$new_obj=new FObj_ext();
			foreach ($CFG['AV_LANG'] as $val) {
				if (trim($_POST['ObjTitle'])) {
					$new_obj->setMeta('Title_'.$val,trim($_POST['ObjTitle']));
				} else {
					$new_obj->setMeta('Title_'.$val,$File['name']);
				}
			}
			$new_obj->setMeta('Text',$_POST['ObjText']);
			$new_obj->setMeta('MenuImage','other.gif');
			$new_obj->setMeta('Version',1);
			$new_obj->setMeta('TimeCreate',time());
			$new_obj->setMeta('TimeModify',time());
			$new_obj->setMeta('UserCreate',$user_id);
			$new_obj->setMeta('UserModify',$user_id);
			$new_obj->setMeta('DocType','ext');
			$new_obj->setMeta('Users',$obj->getMeta('Users'));
			$new_obj->setMeta('Groups',$obj->getMeta('Groups'));
			$new_obj->setParentMeta('ParentID',$obj->getID());
			$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
			$new_obj->setParentMeta('UserID',$obj->getParentMeta('UserID'));
			if ($Fmng->insertMeta($new_obj)) {
				$Fmng->insertParentMeta($new_obj);
				if ($type=='mail') {
					$File['tmp_name']=tempnam(Framework::getTempPath(),'ml');
					$fp=fopen($File['tmp_name'],'w');
					fwrite($fp,$Mail->getAttachment($mobj->getBox(), $Mobj->getID(),$DL_PART,$File['enc']));
					fclose($fp);
				}
				$error=$Fmng->replaceFile($new_obj,$Fmng->getModul(),$new_obj->getID(),$File,$new_obj);
				if ($error===false){
					$Fmng->updateMeta($new_obj);
					if ($FavInsert) {
						$new_obj->setFileMeta('Favorite',1);
						$Fmng->setFavorite($new_obj);
					}
					$frm->setUserData($Fmng->getModul(),'sfolder',$obj->getID());
					$close=true;
				} else {
					$ActionError[$error]=true;
					$Fmng->deleteParentMeta($new_obj);
					$Fmng->deleteMeta($new_obj);
				}
				@unlink($File['tmp_name']);
			}

		}

	} else {

	}
	$t->define(array('application'=>'js_add_file.inc.html'));
	if (!$close) {
		require("lib/class_form.inc.php");
		require_once('lib/class_ObjSelect.php');
		$txt_title=new TextField("ObjTitle",'size="30" class="sel" style="width:400px"','0','%',$File['name']);
		$t->assign('OBJ_TITLE',$txt_title->f());
		$t->assign('C_TITLE','');
		$ObjFolder=Framework::getParam('ObjFolder',0);
		if (!$ObjFolder) $ObjFolder=$frm->getUserData($Fmng->getModul(),'sfolder');
		$sel_int=new ObjSelect();
		$sel_int->setClass('noption');
		$sel_int->setSelectedID($ObjFolder);
		$sel_int->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');


		$tree_apps=array('fol');
		$option_tree='';
		foreach ($root_obj as $key=>$val) {
			$sel_int->setTree($Fmng->ListAllTree($key,-1,'Title_'.$session_lang,'ASC',$tree_apps));
			$option_tree.=$sel_int->parseSelect($val->getParentMeta('ParentID'));
		}
		$t->assign('TREE_FOLDER',$option_tree);
		unset($option_tree);
		if ($ActionError['WriteError']) {
			$t->assign('C_FOLDER','error');
		} else {
			$t->assign('C_FOLDER','');
		}

		$txt_desc=new TextArea('ObjText','rows="7" cols="36" class="sel" style="width:400px;"');
		$t->assign('OBJ_DESC',$txt_desc->f());

		$chk_fav=new CheckBox ('FavInsert','',1);
		$t->assign('CHK_FAV',$chk_fav->f(1));

		$t->parse('ROW','update');
		$t->assign('L_BREAK','javascript:window.close();');
		$t->parse('ROW','break');
		if ($type=='mail') {
			$t->assign('FORM_ACTION',"js_addFile.php?type=mail&moid=".urlencode($mobj->getBox())."&mid=$mid&DL_PART=$DL_PART");
		}
		if ($ActionError) {
			require('fmng/view_error.php');
		} else $t->assign('TPL_ERROR','');
		$t->parse('ROW','win_view');
	} else {
		$t->parse('ROW','win_close');
	}
}
$t->parse('CONTENT','application');
$t->fastprint();
page_close();
?>
