<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
$wd=& $frm->getStaticModul('workday');

$t->setRoot("tpl/$THEME/$session_lang");
$t->define(array('application'=>'js_cal.inc.html'));

$daydate=date("j",$date);
$month=date("n",$date);
$year=date("Y",$date);
$listbeginn=mktime (0,0,0,$month,1,$year);
$days=date("t",$listbeginn);
$prev_days=date("t",$listbeginn - 10);
$listend=mktime (23,59,59,$month,$days,$year);
$startday=date("w",$listbeginn)-1;
if ($startday<0) $startday=6;

if ($month==1) {
        $pmonth=12;
        $pyear=$year-1;
} else {
        $pmonth=$month-1;
        $pyear=$year;
}
if ($month==12) {
        $nmonth=1;
        $nyear=$year+1;
} else {
        $nmonth=$month+1;
        $nyear=$year;
}
$t->assign("JS_FIELD",$field);
$link="js_cal.php?field=eingabe.event_start&date=";
for($i=1;$i<13;$i+=2) {
	$sel_m_date=mktime(0,0,0,$i,1,$year);
	$sel_m_l="<a href=\"javascript:opener.NewWindow('js_cal.php?field=$field&date=".$sel_m_date."','Calendar',".$CFG[calwidth].','.$CFG[calheight].",0)\">".strftime("%b",mktime(0,0,0,$i,1,$year))."</a>";
 	$t->assign("MON0",$sel_m_l);
	$sel_m_date=mktime(0,0,0,$i+1,1,$year);
	$sel_m_l="<a href=\"javascript:opener.NewWindow('js_cal.php?field=$field&date=".$sel_m_date."','Calendar',".$CFG[calwidth].','.$CFG[calheight].",0)\">".strftime("%b",$sel_m_date)."</a>";
 	$t->assign("MON1",$sel_m_l);
 	$t->parse("COL",".sel_month_row");
}
$t->assign("PREV_LINK","javascript:opener.NewWindow('js_cal.php?field=$field&date=".mktime(0,0,0,$pmonth,1,$pyear)."','Calendar',".$CFG[calwidth].','.$CFG[calheight].",0)");
$t->assign("NEXT_LINK","javascript:opener.NewWindow('js_cal.php?field=$field&date=".mktime(0,0,0,$nmonth,1,$nyear)."','Calendar',".$CFG[calwidth].','.$CFG[calheight].",0)");
$t->assign("SEL_MONTH",strftime("%b, %Y",$listbeginn));
$t->assign("CAL_COL_COLOR","");
for($i=1;$i<8;$i++) {
              $t->assign("CAL_DAY_NUM",strtoupper(substr(strftime("%a",mktime(0,0,0,1,$i,2001)),0,1)));
              $t->parse("COL",".month_col");
}
$t->parse("ROW",".month_row");
if (($startday+$days)>35) $cells=42; else $cells=35;
$a="";$cell=1;
for($cell;$cell<=$startday;$cell++) {
              $t->assign("CAL_DAY_NUM","<a href=\"javascript:setDatum(".($prev_days-$startday+$cell).",$pmonth,$pyear)\"><font color=#888888>".($prev_days-$startday+$cell)."</font></a>");
              $t->parse("COL",$a."month_col");
              $a=".";
}
for($cell;$cell<=($days+$startday);$cell++){
         $day=$cell-$startday;
         $celldate=mktime(0,0,0,$month,$day,$year);
         if ($day==date("j") && $month==date("n") && $year==date("Y"))  $t->assign("CAL_COL_COLOR","bgcolor=$fg10color"); else  $t->assign("CAL_COL_COLOR","");
         if ($wd->is_workday($celldate)) {
               $t->assign("CAL_DAY_NUM","<a href=\"javascript:setDatum($day,$month,$year)\">$day</a>");
         } else {
               $t->assign("CAL_DAY_NUM","<a href=\"javascript:setDatum($day,$month,$year)\"><font color=red>$day</font></a>");
         }
         $t->parse("COL",$a."month_col");
         $a=".";
          if ($cell%7==0) {
                $t->parse("ROW",".month_row");
                $a="";
         }
}
$t->assign("CAL_COL_COLOR","");
$i=1;
for($cell;$cell<=$cells;$cell++) {
              $t->assign("CAL_DAY_NUM","<a href=\"javascript:setDatum($i,$nmonth,$nyear)\"><font color=#888888>".$i."</font></a>");
              $t->parse("COL",$a."month_col");
              $a=".";$i++;
}

if ($a==".") {
        $t->parse("ROW",".month_row");
}
$time=mktime(15,0,0,date('m'),date('d'),date('Y'));

$tmp=$time+3600*24;
$t->assign('L_1DAY',"javascript:setDatum(".date('d',$tmp).",".date('m',$tmp).",".date('Y',$tmp).")");

$tmp=$time+3600*24*2;
$t->assign('L_2DAY',"javascript:setDatum(".date('d',$tmp).",".date('m',$tmp).",".date('Y',$tmp).")");

$tmp=$time+3600*24*3;
$t->assign('L_3DAY',"javascript:setDatum(".date('d',$tmp).",".date('m',$tmp).",".date('Y',$tmp).")");

$tmp=$time+3600*24*7;
$t->assign('L_7DAY',"javascript:setDatum(".date('d',$tmp).",".date('m',$tmp).",".date('Y',$tmp).")");

$tmp=mktime(15,0,0,date('m')+1,date('d'),date('Y'));
$t->assign('L_1MONTH',"javascript:setDatum(".date('d',$tmp).",".date('m',$tmp).",".date('Y',$tmp).")");

$tmp=mktime(15,0,0,date('m'),date('d'),date('Y')+1);
$t->assign('L_1YEAR',"javascript:setDatum(".date('d',$tmp).",".date('m',$tmp).",".date('Y',$tmp).")");




$t->parse('CONTENT','application');
$t->fastprint();
page_close();
?>
