<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require("cfg/global.inc.php");
if (($l_typ!='mail' &&  $l_typ!='fax') || !$js_field || !$sel_list) {
	die('ERROR');
}
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
$t->setRoot("tpl/$THEME/$l_typ/$session_lang");
$t->define(array('application'=>'js_list.inc.html'));
$Addr=& $frm->getStaticModul('addr');
if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
	require_once("lib/addr/func_SearchListLdap.php");
	$result=getSearchList($Addr,$sel_list,$l_typ);
} else {
	require_once("lib/addr/func_SearchList.php");
	$uperms=false;
	if ($l_typ=='mail') {
		$temp=$frm->getCfg('mail',0,'cfg/all/addr_list');
		if ($temp['cfg/all/addr_list']) $uperms=true;
	}
	$result=getSearchList($Addr,$db,$sel_list,$l_typ,$uperms);
}
$i=1;
foreach ($result as $key=>$val) {
	$t->assign('NAME',Framework::entities($val['name']));
	$t->assign('VALUE',Framework::entities($val['data_val']));
	$t->assign('CHK_KEY',$i);
	$t->assign('CHK_VAL',htmlspecialchars($val['data']));
	if ($i%2) {
		$t->assign('ROW_COLOR','bgcolor="#f2f2f2"');
	} else {
		$t->assign('ROW_COLOR','');
	}
	$t->parse('ROW','.list_row');
	$i++;
}
$t->assign('ITEMS',$i-1);
$t->assign('JS_FIELD',$js_field);
$t->parse('CONTENT','application');
$t->fastprint();
page_close();
?>
