<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
$T->loadModul('core');
$L->init('js_prot.php');

if ($frm->getMyApps("prot")) {
	$t->assign('MOD_TITLE',$frm->getAppName('prot'));

	require("lib/prot/class_ProtokollObjectGui.php");
	$Gui=new ProtokollObjectGui();
	$infGui=$Gui->processInsert();
	if ($Gui->getStatus()=='no_slots') {
		$t->setRoot("tpl/$THEME/$session_lang");
		$t->define (array('application' => "no_app.inc.html"));
	} else {
		require_once('lib/class_ApplicationGui.php');
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_TemplateGui.php');
		$AppGui=new ApplicationGui();
		$AppGui->setName($frm->getAppName('prot'));
		$AppGui->setImage('appl_prot.gif');

		if ($Gui->getStatus()=='insert_ok') {
			$Obj=$Gui->getObj();
			$tplGui=$Gui->processView('popup');
			$tplGui->setName($T->lang('[[Protokoll]]'));
			//$tplGui->setName($Obj->getMeta('protNumber'));

			require_once('lib/class_FormGui.php');
			$formGui=new FormGui();
			$formGui->setLabelClass('no','error');

			$key='submit';
			$formGui->addField($key,'submit','','','field_s');
			$submitValues=array('close_x'=>' '.$T->lang('[[Schliessen]]').' ');
			$formGui->setValuesAttribs($key,'close_x',array('onclick'=>'window.close();return false;'));
			$formGui->setValues($key,$submitValues);


			require_once('lib/class_TemplateGui.php');
			$ContGui=new TemplateGui('core/common_simple_content.inc.html');
			$ContGui->addContent('content1',$tplGui,'CONTENT');

			$ContGui->addContent('content2',$formGui,'CONTENT');

		} else {
			$tplGui=new TemplateGui('core/common_template_intern.inc.html');
			$tplGui->addContent('box',$infGui,'CONTENT');

			$ContGui=new ContentGui();
			$ContGui->setName($T->lang('[[Protokoll]]'));
			$ContGui->setWidth('650');
			$ContGui->addContent($tplGui);
		}
		$frm->addOnload('windowResize(690,80);');

		$AppGui->addContent($ContGui);
		$AppGui->setFormAction($L->getTempLink());

		$AppGui->processApplication('application',false);
	}
	require("lib/content.inc.php");
}
page_close();

?>
