<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
if ($auth->auth['uid']==$CFG['SUPERADMIN']) $sadmin=1;
require_once("lib/class_form.inc.php");
$t->setRoot("tpl/$THEME/squid/$session_lang");
$t->define (array('application' => "js_squid.inc.html"));
$t->assign('MOD_TITLE',$frm->getAppName('squid'));
if ($CFG['USER_CLASS']=='ldap_full' && $frm->getFrmCfg('ldap/squid') && $app["squid"]) {
	if (isset($_POST['allow_x']) || isset($_POST['deny_x'])) {
		if (!$groupID || $groupID==$frm->getGroupAllLdapID()) {
			$error['groupID']=1;
		}
		if (!$error) {
			$app_users=$frm->getGroupUsers($groupID,true);
			if (is_array($app_users)) {
				foreach ($app_users as $key=>$val) {
					$update=0;
					$userdata=$frm->read_user($key,true);
					if ($_POST['allow_x'] && !$userdata["internet"]) {
						$userdata["internet"]=1;
						$update=1;
					}
					if ($_POST['deny_x'] && $userdata["internet"]) {
						$userdata["internet"]=0;
						$update=1;
					}
					if ($update) {
						$frm->update_user($key,$userdata,true);
					}

				}

			}
			$close=true;
		}
	}
	if (!$close) {
		$group_array=$frm->getAdminGroups(0);
		foreach ($group_array as $key=>$val) {
			if ($val['activGroup-e'] && $key!=$frm->getGroupAllLdapID()) {
				$t->assign('S_KEY',$key);
				$t->assign('S_N',htmlspecialchars($val['cn']));
				$t->parse('ROW','.group_row');
			}
		}
		if ($error['groupID']) {
			$t->assign('C_GROUPS','error');
		} else {
			$t->assign('C_GROUPS','');
		}
		$t->parse('ROW','view');
	} else {
		$t->parse('ROW','close');
	}
} else {
	$t->parse('ROW','close');
}
$t->parse('CONTENT','application');
$t->fastprint();
page_close();
?>
