<?php
class AddrCatGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;

	function __construct() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=$frm->getStaticModul('addr');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('zef');
	}
	function setObj($Obj) {
		$this->_Obj=$Obj;
	}
	function getCatEditGui() {
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$tabs=array();
		$tabs[]='meta';
		if ($this->_Obj->getID() && !$this->_Obj->getMeta('UserID') && $this->_Base->isRuleUser()) {
			$tabs[]='perms';
		}
		$box=new BoxGui($this->_Base->getModul().'|editCatGui');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('editCatGui'));
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getCatMetaGui());
		}
		if (in_array('perms',$tabs)) {
			$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
			$box->setTabContent('perms',$this->getCatPermsGui());
		}

		$show_tap=$this->getPrefs('editCatGui');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		return $box;
	}
	function &getCatMetaGui() {//Title_
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		$defOneLang=1;
		if ($this->_Obj->getID()) {
			foreach ($this->_frm->getMaLang() as $val) {
				if ($this->_Obj->getMeta('Title_'.$val)!=$this->_Obj->getMeta('Title_'.$this->_frm->getLang())) {
					$defOneLang=0;
					break;
				}
			}
		}
		foreach ($this->_frm->getMaLang()  as $val) {
			$key='Title_'.$val;
			$formGui->addField($key,'text',$this->_T->lang('[[Bezeichnung]]').' '.$val,$this->_Obj?$this->_Obj->getMeta($key):'','form_fields1');
			if ($val!=$this->_frm->getLang()) {
				if ((!(Framework::getParam('meta_save_x','0','P')) && $defOneLang) || Framework::getParam('oneLang',0,'P')) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					//debug('Ss');
					$formGui->setAttribs($key,$attribs);
				} else {
					$formGui->setRequired($key);
				}
			} else {
				$formGui->setRequired($key);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'form_fields1');
				$formGui->setNoMeta($key);
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $val2) {
					if ($val2!=$val) $attribs['onchange'].="disableEnable('Title_".$val2."',this,this.checked?0:1);";
				}
				$formGui->setAttribs($key,$attribs);
			}
		}

		$key='meta_save_x';
		$formGui->addField($key,'submit','',$this->_T->lang('[[Speichern]]'),'form_submit');

		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {

				$formGui->addMetaToObj($this->_Obj);
				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$this->_Obj->setMeta('Title_'.$val,$this->_Obj->getMeta('Title_'.$this->_frm->getLang()));
					}
				}
				if ($this->_Obj->getID()) {
					$this->_Obj->setMeta('TimeModify',time());
					$this->_Obj->setMeta('UserModify',$this->_frm->getUser());

					$this->_Base->updateMeta($this->_Obj);
					/*$this->_L->setParam('action','b');
					$this->_L->unsetParam('oid');
					$this->_L->goToLink();*/
				} else {
					$this->_Obj->setMeta('TimeModify',time());
					$this->_Obj->setMeta('UserModify',$this->_frm->getUser());
					$this->_Obj->setMeta('TimeCreate',time());
					$this->_Obj->setMeta('UserCreate',$this->_frm->getUser());
					$this->_Base->insertMeta($this->_Obj);
				}
				//debug($this->_Obj);
				$this->_L->unsetParam(array('new','edit'));
				$this->_L->setParam('oid',$this->_Obj->getID());
				$this->_L->goToLink();
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}
	function &getCatPermsGui() {
		require_once('lib/class_PermsGui.php');
		$permsGui=new PermsGui();
		$guiCfg=array(
			'avPerms'=>array(1=>$this->_T->Lang('[[Lesen]]')),
			'onlyApp'=>'addr',
			'useSuperGroups'=>1,
			'useGroups'=>0,
			'useUsers'=>0,
			'useRules'=>0,
		);
		$permsGui->setGuiCfg($guiCfg);
		$permsGui->setAktPerms('SuperGroups',$this->_Obj->getMeta('SuperGroups'));
		if ($permsGui->handleRequest()) {
			$this->_Obj->setMeta('SuperGroups',$permsGui->getAktPerms('SuperGroups'));
			$this->_Base->updateMeta($this->_Obj);
			$this->_L->goToLink();
		}
		return $permsGui->getPermsGui();

	}



	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result) $result=$default;
		return $result;
	}

}
?>