<?php
class AddrGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $sMd5='';
	function AddrGui() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('addr');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_T->loadModul('addr');
	}
	function &getSMd5() {
		return $this->sMd5;
	}
	function &getAddrExportGui($search,$fixOrder=null) {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');

		$Gui=new ContentGui();;
		$Gui->setName($this->_T->lang('[[Adressen exportieren]]'));

		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('showExp'))));
		$Gui->addFunction($btBreak);

		$formGui=new FormGui();
		$exportTyp=array(
			'all'=>$this->_T->lang('[[Komplette Liste]]'),
			'spr'=>$this->_T->lang('[[Serienbrief (Privatadressse)]]'),
			'sge'=>$this->_T->lang('[[Serienbrief (Firmenadressse)]]'),
		);
		$exportTypDesc=array(
			'spr'=>$this->_T->lang('[[Gruppiert nach Nachname,Adresse,Ort]]'),
			'sge'=>$this->_T->lang('[[Gruppiert nach Firma,Adresse,Ort]]'),
		);
		$exportMode=array(
			'csv'=>$this->_T->lang('[[CSV - Datei]]'),
			'xls'=>$this->_T->lang('[[XLS - Datei]]'),
			/*'vcard'=>$this->_T->lang('[[Vcard]]'),*/
		);
		$exportChar=array(
			'UTF-8'=>$this->_T->lang('[[Unicode (UTF-8)]]'),
			'ISO-8859-1'=>$this->_T->lang('[[Europaeisch (iso)]]'),
			/*'vcard'=>$this->_T->lang('[[Vcard]]'),*/
		);

		$key="expTyp";
		$formGui->addField($key,'radiolist_v',$this->_T->lang('[[Exportieren als]]'),'all','fields1');
		$formGui->setValues($key,$exportTyp);
		$formGui->setValuesDesc($key,$exportTypDesc);

		$key="expMode";
		$formGui->addField($key,'select',$this->_T->lang('[[Dateiformat]]'),$this->getPrefs('exmod'),'fields2');
		$formGui->setValues($key,$exportMode);

		$key="expChar";
		$default=$this->getPrefs('exchar');
		if (!$default) {
			$default=$formGui->getFieldVal("expMode",true)=='xls'?'ISO-8859-1':GE_CHARSET;
		}
		$formGui->addField($key,'select',$this->_T->lang('[[Zeichen Kodierung]]'),$default,'fields2');
		$formGui->setValues($key,$exportChar);

		$formGui->addField('export_x','submit','',$this->_T->lang('[[Exportieren]]'),'fields3');

		if (Framework::getParam('export_x',0,'P')) {
			$expConfig=array();
			$formGui->addMetaToArray($expConfig);
			$this->exportAddrList($expConfig,$search,$fixOrder);
		}
		$tplGui=new TemplateGui('core/form_3columns.inc.html');
		$tplGui->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplGui->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplGui->addContent('form3',$formGui,'FORM3',array('','fields3'));

		$contGui=new TemplateGui('core/common_template_intern.inc.html');
		$contGui->addContent('cont1',$tplGui,'CONTENT');
		$Gui->addContent($contGui);
		return $Gui;
	}
	function exportAddrList($expConfig,$search,$fixOrder) {
		if ($fixOrder && !empty($fixOrder)){
			$sqlOrder=$fixOrder;
		} else {
			$search['orderF']=$this->getPrefs('AddrOrderF','Name');
			$search['orderD']=$this->getPrefs('AddrOrderD',1);
			$sqlOrder=array($search['orderF']=>$search['orderD']);
			if ($search['orderF']!='Name') $sqlOrder['Name']=1;
		}
		$search['b']=0;
		if (!isset($search['use_limit'])) $search['use_limit']=true;
		if (!isset($search['use_perms'])) $search['use_perms']=true;
		if (!isset($search['use_archiv'])) $search['use_archiv']=0;
		if (isset($search['limit'])) $this->_Base->setLimit($search['limit']);
		if ($search['use_limit']) $this->_Base->setLimit(0);


		$list_fields=array();
		$export_fields=array();
		$card_fields=array();
		foreach ($this->_Base->getFields() as $key=>$val) {
			switch ($val['Typ']) {
				case 'stamm':
					break;
				case 'perm':
					break;
				default:
					$card_fields[$val['Card']][]=$key;
			}
		}
		switch ($expConfig['expTyp']) {
			case 'spr':
				$sqlOrder=array('Nachname'=>1,'Vorname'=>1,'Firma'=>1);
				foreach ($card_fields as $card=>$tmp_val) {
					switch ($card) {
						case 'pa':
							foreach ($tmp_val as $val) {
								$list_fields[]=$val;
								$export_fields[]=$val;
								$copyFields[0][]=$val;
							}
						break;
						case 'ga':
							foreach ($tmp_val as $val) {
								$list_fields[]=$val;
								$copyFields[1][]=$val;
							}
						break;
						case 'n':
							foreach ($tmp_val as $val) {
								//if ($val=='Firma') continue;
								$list_fields[]=$val;
								$export_fields[]=$val;
							}
						break;
						case 'k':
						case 'pf':
						case 'ex':
							foreach ($tmp_val as $val) {
								$list_fields[]=$val;
								$export_fields[]=$val;
							}
						break;
					}
				}
				$extraFields=array('GroupNum'=>$this->_T->lang('[[addrGroupNum]]'));
				$noMulti=true;
			break;
			case 'sge':
				$sqlOrder=array('Firma'=>1);
				foreach ($card_fields as $card=>$tmp_val) {
					switch ($card) {
						case 'ga':
							foreach ($tmp_val as $val) {
								$list_fields[]=$val;
								$export_fields[]=$val;
								$copyFields[0][]=$val;
							}
						break;
						case 'pa':
							foreach ($tmp_val as $val) {
								$copyFields[1][]=$val;
								$list_fields[]=$val;
							}
						break;
						case 'n':
							foreach ($tmp_val as $val) {
								if ($val=='Nachname') continue;
								if ($val=='Vorname') continue;
								if ($val=='Titel') continue;
								if ($val=='MaidenName') continue;

								$list_fields[]=$val;
								$export_fields[]=$val;
							}
						break;
						case 'k':
						case 'gf':
						case 'ex':
							foreach ($tmp_val as $val) {
								$list_fields[]=$val;
								$export_fields[]=$val;
							}
						break;
					}
				}
				$extraFields=array('GroupNum'=>$this->_T->lang('[[addrGroupNum]]'));
				$noMulti=true;
			break;
			default:
				foreach ($card_fields as $tmp_val) {
					foreach ($tmp_val as $val) {
						$list_fields[]=$val;
						$export_fields[]=$val;
					}
				}
				$extraFields=array();
				$copyFields=array();
				$noMulti=false;
			break;
		}
		//debug($list_fields);
		$this->_Base->setListFields($list_fields);
		if ($search['search']) {
			$entries=$this->_Base->searchAddrAdv($search['b'],$sqlOrder,$search['search'],$search['use_limit'],$search['use_perms'],$search['use_archiv']);
		} else {
			$entries=$this->_Base->searchAddr($search['b'],$sqlOrder,$search['searchAddr'],$search['searchNode'],$search['searchHot'],$search['searchProject'],$search['use_limit'],$search['use_perms']);
		}
		$this->cleanEntries($entries,$expConfig['expTyp'],$copyFields);
		//exit;
		switch ($expConfig['expMode']) {
			case  'xls':
				$this->exportXls($entries,$expConfig['expChar'],$export_fields,$extraFields,$noMulti);
			break;
			default:
				$this->exportCsv($entries,$expConfig['expChar'],$export_fields,$extraFields,$noMulti);
			break;
		}
	}
	function cleanEntries(&$entries,$expTyp='all',$copyFields=null) {
		switch ($expTyp) {
			case 'spr':
				$nameField=array('Nachname');
				$nameField2=array('Firma');
				$gFields1=array('PStrasse','POrt');
				$gFields2=array('AStrasse','AOrt');
				$groupFields=array('Vorname');
			break;
			case 'sge':
				$nameField=array('Firma');
				$gFields1=array('AStrasse','AOrt');
				$gFields2=array('PStrasse','POrt');
				$groupFields=array();
			break;
			default:
				return true;
			break;
		}
		$parsed=array();
		foreach ($entries as $key=>$val) {
			$usedGField=1;
			$useGroupFields=true;
			//debug($val->getName());
			$testTxt='';
			foreach ($gFields1 as $gval) {
				if (!trim($val->getMeta($gval))) {
					$testTxt='';
					break;
				}
				$testTxt.=preg_replace('/[^a-z0-9]/','',strtolower($val->getMeta($gval)));
			}
			//debug('1'.$testTxt);
			if (!trim($testTxt)) {
				$usedGField=2;
				foreach ($gFields2 as $gval) {
					if (!trim($val->getMeta($gval))) {
						$testTxt='';
						break;
					}
					$testTxt.=preg_replace('/[^a-z0-9]/','',strtolower($val->getMeta($gval)));
				}
				if (trim($testTxt) && is_array($copyFields[0]) && is_array($copyFields[1])) {
					foreach ($copyFields[0] as $ckey=>$cval) {
						$entries[$key]->setMeta($cval,$entries[$key]->getMeta($copyFields[1][$ckey]));
					}
				}
			}
			//debug('2'.$testTxt);
			//debug($val);
			if (trim($testTxt)) {
				foreach ($nameField as $nval) {
					if (!trim($val->getMeta($nval))) {
						if ($usedGField==2 && !empty($nameField2)) {
							foreach ($nameField2 as $nval2) {
								if (!trim($val->getMeta($nval2))) {
									$testTxt='';
								}
							}
							$useGroupFields=false;
						} else {
							$testTxt='';
						}
					}
					if (!$testTxt) break;
					$testTxt=preg_replace('/[^a-z0-9]/','',strtolower($val->getMeta($nval))).$testTxt;
				}
			}


			if (!trim($testTxt)) {
				//debug('UNSET:'.$entries[$key]->getName());
				unset($entries[$key]);
			} else {
				//debug('3'.$testTxt);
				if ($usedGField==1 && !empty($nameField2)) {
					foreach ($nameField2 as $nval2) {
						$entries[$key]->setMeta($nval2,'');
					}
				}
				if (isset($parsed[$testTxt])) {
					$entries[$parsed[$testTxt]]->setMeta('GroupNum',$entries[$parsed[$testTxt]]->getMeta('GroupNum')+1);
					if ($useGroupFields) {
						foreach ($groupFields as $gval) {
							//debug($gval);
							if (trim($entries[$key]->getMeta($gval))) {
								$addValues=$this->_Base->AddrExplode($entries[$key]->getMeta($gval));

								if (trim($entries[$parsed[$testTxt]]->getMeta($gval))) {
									$origValues=$this->_Base->AddrExplode($entries[$parsed[$testTxt]]->getMeta($gval));
									$newValues=array_merge($origValues,$addValues);
								} else {
									$newValues=$addValues;
								}

								$entries[$parsed[$testTxt]]->setMeta($gval,$this->_Base->AddrImplode(array_unique($newValues)));
							}
						}
					}
					unset($entries[$key]);
				} else {
					$parsed[$testTxt]=$key;
					$entries[$key]->setMeta('GroupNum',1);
				}
			}

		}
	}
	function exportCsv(&$entries,$expChar=GE_CHARSET,$fields=null,$extraFields=null,$noMulti=false) {
		if (!is_array($extraFields)) $extraFields=array();
		if (!is_array($fields)) $fields=$this->_Base->getlistFields();
		$row=array();
		$i=0;
		foreach ($fields as $fid) {
			switch ($this->_Base->getFieldData($fid,'Typ')) {
				case 'select':
				case 'mselect':
					$addrSelect[$fid]=$this->_Base->listAddrSelect($fid);
				break;
			}
			if ($this->_Base->getFieldData($fid,'Multi') && !$noMulti) {
				$row[$i][]=Framework::convertCharset($this->_Base->getFieldData($fid,'Multi').'. '.$this->_Base->getFieldData($fid,'Title'),GE_CHARSET,$expChar);
			} else {
				$row[$i][]=Framework::convertCharset($this->_Base->getFieldData($fid,'Title'),GE_CHARSET,$expChar);
			}
		}
		foreach ($extraFields as $key=>$val) {
			$row[$i][]=Framework::convertCharset($val,GE_CHARSET,$expChar);
		}
		$i++;
		foreach ($entries as $AddID=>$val) {
			foreach ($fields as $fid) {
				switch ($this->_Base->getFieldData($fid,'Typ')) {
					case 'select':
					case 'mselect':
						$values=array();
						$tmp=explode('||',$val->getMeta($fid));

						foreach ($tmp as $tmpval) {
							if ($addrSelect[$fid][$tmpval]) {
								$values[]=$addrSelect[$fid][$tmpval];
							}
						}
						$row[$i][]=Framework::convertCharset(implode(';',$values),GE_CHARSET,$expChar);
					break;
					case 'fk_user':
						$values=$this->_frm->getCachedUserName(Addr::AddrExplode($val->getMeta($fid)));
						$row[$i][]=Framework::convertCharset(implode(';',$values),GE_CHARSET,$expChar);
					break;
					case 'password':
						$row[$i][]=$val->getMeta($fid)?'**********':'';
					break;

					default:
						$values=$this->_Base->AddrExplode($val->getMeta($fid));
						$row[$i][]=Framework::convertCharset(implode(', ',$values),GE_CHARSET,$expChar);
					break;
				}
			}
			foreach ($extraFields as $ekey=>$eval) {
				$row[$i][]=Framework::convertCharset($val->getMeta($ekey),GE_CHARSET,$expChar);
			}

			$i++;
		}
		$this->_frm->exportCsv($row,';',false,'adresses.csv');
		exit;
	}
	function exportXls(&$entries,$expChar=GE_CHARSET,$fields=null,$extraFields=null,$noMulti=false) {
		$title='addresses';
		if (!is_array($extraFields)) $extraFields=array();
		if (!is_array($fields)) $fields=$this->_Base->getlistFields();
		foreach ($fields as $key=>$fid) {
			if ($this->_Base->getFieldData($fid,'Typ')=='title') unset($fields[$key]);
		}

		require_once("lib/class_WriteExcel.inc.php");
		$tmp_file=tempnam(Framework::getTempPath(),'xls');
		$Excel =& new writeexcel_workbook($tmp_file);

		$format=array();
		$format['date']=& $Excel->addformat(array('num_format' => 'dd.mm.YYYY'));
		$format['bold']=& $Excel->addFormat(array('bold' => 1));
		$format['curr']=& $Excel->addFormat(array('num_format' => '##,#0.00'));
		$format['normal']=& $Excel->addFormat(array('bold' => 0));

		$worksheet=& $Excel->addworksheet(Framework::convertCharset($title,GE_CHARSET,$expChar));

		$rowNum=0;$colNum=0;
		foreach ($fields as $fid) {
			switch ($this->_Base->getFieldData($fid,'Typ')) {
				case 'select':
				case 'mselect':
					$addrSelect[$fid]=$this->_Base->listAddrSelect($fid);
				break;

			}
			if ($this->_Base->getFieldData($fid,'Multi') && !$noMulti) {
				$worksheet->write($rowNum,$colNum,Framework::convertCharset($this->_Base->getFieldData($fid,'Multi').'. '.$this->_Base->getFieldData($fid,'Title'),GE_CHARSET,$expChar),$format['bold']);
			} else {
				$worksheet->write($rowNum,$colNum,Framework::convertCharset($this->_Base->getFieldData($fid,'Title'),GE_CHARSET,$expChar),$format['bold']);
			}
			$colNum++;
		}
		foreach ($extraFields as $key=>$val) {
			$worksheet->write($rowNum,$colNum,Framework::convertCharset($val,GE_CHARSET,$expChar),$format['bold']);
			$colNum++;
		}
		$rowNum++;

		foreach ($entries as $AddID=>$val) {
			$colNum=0;
			foreach ($fields as $fid) {
				switch ($this->_Base->getFieldData($fid,'Typ')) {
					case 'select':
					case 'mselect':
						$values=array();
						$tmp=Addr::AddrExplode($val->getMeta($fid));
						foreach ($tmp as $tmpval) {
							if ($addrSelect[$fid][$tmpval]) {
								$values[]=$addrSelect[$fid][$tmpval];
							}
						}
						$worksheet->write($rowNum,$colNum,Framework::convertCharset(implode(";",$values),GE_CHARSET,$expChar),$format['normal']);
					break;
					case 'fk_user':
						$values=$this->_frm->getCachedUserName(Addr::AddrExplode($val->getMeta($fid)));
						$worksheet->write($rowNum,$colNum,Framework::convertCharset(implode(";",$values),GE_CHARSET,$expChar),$format['normal']);
					break;
					case 'password':
						$worksheet->write($rowNum,$colNum,$val->getMeta($fid)?'**********':'',$format['normal']);
					break;
					case 'num':
						if ((string)$val->getMeta($fid)!=='') {
							$worksheet->write($rowNum,$colNum,(float)$val->getMeta($fid),$format['normal']);
						}
					break;
					case 'chk':
						$worksheet->write($rowNum,$colNum,(float)$val->getMeta($fid),$format['normal']);
					break;
					case 'date':
						if ($val->getMeta($fid)!='0000-00-00') {
							$xlsDate=$Excel->xl_date_list(Framework::dateSql('Y',$val->getMeta($fid)), Framework::dateSql('m',$val->getMeta($fid)),Framework::dateSql('d',$val->getMeta($fid)));
							$worksheet->write($rowNum,$colNum,$xlsDate,$format['date']);
						}
					break;
					default:
						//debug($this->_Base->getFieldData($fid,'Typ'));
						$values=$this->_Base->AddrExplode($val->getMeta($fid));
						//debug($values);
						$worksheet->write($rowNum,$colNum,Framework::convertCharset(implode(", ",$values),GE_CHARSET,$expChar),$format['normal']);
					break;
				}
				$colNum++;
			}
			foreach ($extraFields as $ekey=>$eval) {
				$worksheet->write($rowNum,$colNum,Framework::convertCharset($val->getMeta($ekey),GE_CHARSET,$expChar),$format['normal']);
				$colNum++;
			}
			$rowNum++;
		}
		$Excel->close();
		Framework::dumpFile($tmp_file,$title.'.xls','application/x-msexcel',true);
		exit;
	}
	function &getAddrListGui($search,$headers,&$navLink,$lmode='m_src',$fixOrder=null,$useMd5=false) {

		$this->_parsedKeys=array();

		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_FunctionButtons.php');

		$Gui=new ApplicationListGui();
		if ($lmode) {
			$funcAction=new FunctionObjActionGui('list_action',1);
			$funcAction->setName($this->_T->lang('[[Ausgewaehlte Adressen]]'));
			$list_action=$this->_frm->getObjAction($this->_Base->getModul(),$lmode);
			$rootObj=$this->_Base->getRootObj();
			foreach ($list_action as $key=>$val) {
				if (!$val['Hidden'] && $this->_Base->isAllowedAction($rootObj,$val)) {
					$funcAction->addValue($key,$val['Name']);
				}
			}
			$Gui->addFunction($funcAction);
		}

		if ($fixOrder && !empty($fixOrder)){
			$sqlOrder=$fixOrder;
			$search['orderF']='';
			$search['orderD']=0;
		} else {
			if (Framework::getParam('_OrderF',0,'G')) {
				$this->setPrefs('AddrOrderF',Framework::getParam('_OrderF',0,'G'));
				$this->setPrefs('AddrOrderD',Framework::getParam('_OrderD',0,'G'));
			}
			$search['orderF']=$this->getPrefs('AddrOrderF','Name');
			$search['orderD']=$this->getPrefs('AddrOrderD',1);
			$sqlOrder=array($search['orderF']=>$search['orderD']);
			if ($search['orderF']!='Name') $sqlOrder['Name']=1;
		}
		$rows=0;
		if (!isset($search['b'])) $search['b']=intval(Framework::getParam('b',0,'G'));
		if (isset($search['limit'])) $this->_Base->setLimit($search['limit']);
		if (!isset($search['use_limit'])) $search['use_limit']=true;
		if (!isset($search['use_perms'])) $search['use_perms']=true;
		if (!isset($search['use_archiv'])) $search['use_archiv']=0;

		$search['sqlOrder']=$sqlOrder;

		if ($useMd5) {
			$Data=$search;
			unset($Data['b'],$Data['limit'],$Data['use_limit']);
			$Data['sqlOrder']=$sqlOrder;
			$Data=serialize($Data);
			$this->sMd5=md5($Data);
			$this->_frm->setUserData('md5_src',$this->sMd5,$Data);
		}

		$header_links=array(
			'Name'=>$this->_L->getTempLink(null,array('sMd5'=>$this->sMd5,'aid'=>'__AID__','action'=>'__ACTION__','pos'=>'__POS__')),
		);
		if ($search['search']) {
			$entries=$this->_Base->searchAddrAdv($search['b'],$sqlOrder,$search['search'],$search['use_limit'],$search['use_perms'],$search['use_archiv']);
		} else {
			$entries=$this->_Base->searchAddr($search['b'],$sqlOrder,$search['searchAddr'],$search['searchNode'],$search['searchHot'],$search['searchProject'],$search['use_limit'],$search['use_perms']);
		}
		if (!empty($_POST) && $this->_Base->getRows()==1) {
			$AObj=reset($entries);
			if (is_object($AObj)) {
				$GLOBALS['SESS_MDATA']['addr.php']['L_BACK']=$GLOBALS['H_REFERER'];
				page_close();
				header("Location:index.php?site=addr.php&oid=".Framework::getParam('oid')."&action=".$AObj->getAction(0)."&aid=".$AObj->getID());
				exit;
			}
		}
		$this->fillAddrListRows($Gui,$entries,$search,$headers,$header_links);
		$this->fillAddrListHeaders($Gui,$navLink,$search,$headers,$header_links);
		return $Gui;
	}
	function fillAddrListHeaders(&$Gui,&$navLink,$search,$headers,$header_links) {
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionButtons.php');
		if ($search['orderF']) {
			$Gui->setActOrder($search['orderF'],$search['orderD']);
			$Gui->setOrderLink($navLink);
		}
		$Gui->setNavLink($navLink);
		$Gui->setAutoBg(APP_FG10COLOR);
		$Gui->setID('addrTab');
		$this->_frm->addOnLoad("disableSelection(document.getElementById('addrTab'));");
		$Gui->setRowClass(array('list_l','list_b','list_h','list_hb','list_s','list'));
		$Gui->setLimit($this->_Base->getLimit()?$this->_Base->getLimit():$this->_Base->getRows());
		$Gui->setSumRows($this->_Base->getRows());
		$Gui->setBegin($search['b']);

		$hspan=2;
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		if ($headers['ListID']) {
			$funcSelAll=new FunctionButtons('addr_list','selectall',array('ListID'=>'ListID[]','ListOn'=>false));
			$Gui->addHeaderCol('ListID',$funcSelAll->process(),'','','',1,'1%',0,'',$noEnc);
			$Gui->setTrOver('trBOC({ROW},this);');
			$Gui->setTrDown('trBOI({ROW},this,1);');
		}

		$key='Name';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Name]]'),'','','',1,'',$hspan);
		$Gui->setHeaderOrder($key,$key,1);

		foreach ($this->_Base->getlistFields() as $key) {
			if ($this->_Base->getFieldData($key,'Title')) {
				$Gui->addHeaderCol($key,$this->_Base->getFieldData($key,'Title'),'','','',1,'');
				$Gui->setHeaderOrder($key,$key,1);
			} elseif ($this->_Base->getFieldData($key,'Name',1)) {
				$Gui->addHeaderCol($key,$this->_T->lang($this->_Base->getFieldData($key,'Name',1)),'','','',1,'');
				$Gui->setHeaderOrder($key,$key,1);
			}
			
		}
	}

	function fillAddrListRows(&$Gui,&$entries,$search,$headers,$header_links) {
		require_once('lib/class_FormFieldsCore.php');
		$rspan=4;
		if ($headers['ListID']) $rspan+=1;

		if ($headers['ListID']) {
			$attribs=array(
				'onclick'=>'return false;',
			);
			$btnList=new CheckBoxBtn ('ListID[]','');
			$btnList->setAttribs($attribs);
		}
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		$hl=0;
		if ($this->_Base->getRows()) {
			$aB=$search['b'];
			foreach ($entries as $mkey=>$val) {
				$tras_array=array(
					'__AID__'=>urlencode($val->getID()),
					'__ACTION__'=>$val->getAction(0),
					'__POS__'=>$aB,
				);
				$hl=($hl?$hl=0:$hl=1);
				$Gui->addRow($hl?2:0,'top','');
				if ($headers['ListID']) {
					$Gui->addCol('ListID',$btnList->process($val->getID()),'','','',1,'1%',0,'',$noEnc);
				}
				$key='img';
				$colAttribs=array();
				
				$Gui->addCol($key,'',$val->getImage(0),'','',0,'1%',0,'',$colAttribs);

				$key='Name';
				$colAttribs=array(
					'ID'=>$val->getID(),
				);

				if ($val->getACL(4)) {
					$colAttribs['LinkAttribs']=array(
						'onclick'=>'return goToView(this);',
						'ondblclick'=>$header_links[$key.'_dbl']?'return goToEdit(this,\''.$header_links[$key.'_dbl'][0].'\',\''.$header_links[$key.'_dbl'][1].'\');':'return goToEdit(this,\'action='.$val->getAction(0).'\',\'action='.$val->getAction(1).'\');',
					);
				}
				$Gui->addCol('Name',$val->getName(),'',$header_links[$key]?strtr($header_links[$key],$tras_array):'','',0,'',0,'',$colAttribs);
				foreach ($this->_Base->getlistFields() as $fid) {
					$values=$this->_Base->AddrExplode($val->getMeta($fid));
					foreach ($values as $tkey=>$tval) {
						$col_link='';
						$col_add='';
						$target='';
						if ($tval) {
							switch ($this->_Base->getFieldData($fid,'Action')) {
								case 'mail':
									if ($this->_frm->getMyApps('email')) {
										if ($GLOBALS['SESS_MDATA']['addr.php']['MAIL_REFERER']) {
											$col_link=$GLOBALS['H_REFERER'][0]."&aid=".$val->getID()."&addr_action_x=1&addr_action_val=s_mail&addr_action_num=$tkey";
										} else {
											$col_link="index.php?site=mail.php&action=n&add_to=".urlencode($this->_Base->formatMail($val,$tval));
										}
									} else {
										$col_link="mailto:".htmlspecialchars($this->_Base->formatMail($val,$tval));
									}
								break;
								case 'fax':
									if ($this->_frm->getMyApps('fax')) {
										$col_link="index.php?site=fax.php&action=&show=compose&m_t=new&Addr=".urlencode($this->_Base->formatFax($val,$tval));
									}
								break;
								case 'sms':
									$col_link=htmlspecialchars($this->_Base->formatCallto($val,$tval));
									if ($this->_frm->getMyApps('sms')) {
										$col_add='';
										$msgParams=array(
											'invReset'=>1,
											'tab'=>'sms',
										);
										$msgParams['smsToAdd']=$this->_frm->getStaticModul('sms')->formatNumber($tval,$val->getName(1));
										$smsLink='javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));';
										if ($col_link) {
											$col_add='<a href="'.$smsLink.'"><img style="vertical-align:text-top" src="img/ge/js_send.gif" /></a>';
										} else {
											$col_link=$smsLink;
										}
									}
								break;
								case 'skype':
									$col_link=htmlspecialchars($this->_Base->formatCallto($val,$tval));
								break;
								case 'web':
									$col_link=htmlspecialchars($this->_Base->formatWeb($val,$tval));
									$target='target="_blank"';
								break;
							}
						}
						if ($col_link) {
							$onClick="return sndReq('addrHot','ajax.php','ajax_modul=addrHot&AddrID=".$val->getID()."');";
							$values[$tkey]=$col_add.'<a href="'.$col_link.'" '.$target.' onclick="'.$onClick.'">'.FrameWork::entities($tval).'</a>';
						} else {
							$values[$tkey]=FrameWork::entities($tval);
						}
					}
					$nowrap=1;
					$this->_Base->entry2Value($fid,$values,$nowrap);
					$Gui->addCol($fid,implode('<br>',$values),'','','',$nowrap,'',0,'',$noEnc);
				}
				//debugtime('E');

				$aB++;
			}
		}

	}

	function setPrefs($key,$val) {
		$this->_frm->insertPrefs('addr',array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs('addr',$key);
		if ($key=='AddrOrderF' && !$this->_Base->getFieldData($result,'Typ',1)) {
			$this->setPrefs('AddrOrderF',$default);
			$result=$default;
		}
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
}
?>