<?php
class AddrMultiEditGui {
	var $_Base;
	var $_Obj;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	function AddrMultiEditGui() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('addr');
		$this->_T=&$T;
		$this->_T->loadModul('addr');
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		if (is_object($P)) $this->_P=&$P;
	}
	function _handleRequest() {

	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
	function process() {
		//debug($_POST);
		require_once('lib/class_TemplateGui.php');
		$TopGui=new TemplateGui('core/common_form.inc.html');
		$contGui=& $this->getGui();
		$TopGui->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
		$TopGui->addContent('cont1',$contGui,'CONTENT');
		return $TopGui->process();
	}
	function &getConfigGui(&$formValues) {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		$ContGui=new TemplateGui('core/common_content_border.inc.html');

		$avFieldArray=array(0=>array(0=>'-'));
		$cardTitle=array();
		foreach ($this->_Base->getFields() as $key=>$val) {
			if ($val['Typ']=='perm' && $this->_P) {
				$cardTitle['proj']=$this->_T->lang('[[Projekte]]');
				$avFieldArray[$cardTitle['proj']]['FKProjID']=$this->_T->lang('[[Projektzugehoerigkeit]]');
			}
			if ($val['Typ']=='perm' && !$this->_Base->isRuleUser()) continue;
			if (!$cardTitle[$val['Card']]) {
				$cardTitle[$val['Card']]=$this->_T->lang('[[AddrCard_'.$val['Card'].']]');
			}
			switch ($val['Typ']) {
				case 'title':
					$cardTitle[$val['Card']]=$val['Title'];
				break;
				default:
					$avFieldArray[$cardTitle[$val['Card']]][$key]=$val['Title'];
				break;
			}
		}
		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key='fieldID';
		$formGui->addField($key,'select_grp',$this->_T->lang('[[Feld auswaehlen]]'),'','fields1');
		$formGui->setValues($key,$avFieldArray);
		$formGui->setAttribs($key,array('onchange'=>'document.daten.submit()'));


		$parseEdit=false;
		$isMulti=false;
		$aktField=$formGui->getFieldVal('fieldID',true);
		if ($aktField) {
			$key='fieldData';
			$fTitle=$this->_T->lang('[[Neuer Wert]]');
			if ($aktField=='FKProjID') {
				$Params=array(
					'mode'=>'o',
					'params'=>'',

				);
				$lb_params=array('Values'=>array());
				$lb_params['Values'][]=array(
					'Label'=>$fTitle,
					'LabelSep'=>'',
					'mode'=>$Params['mode'],
					'app'=>'',
					'params'=>$Params['params'],
					'FieldVal'=>'_PROJECTS',
				);
				$crmLabel=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
				$formGui->addField($key,'ttip',$crmLabel,'');
				$formGui->setParams($key,$Params);

				$parseEdit=true;
				$isMulti=true;
			} else {
				switch ($this->_Base->getFieldData($aktField,'Typ')) {
					case 'perm':
						$select_array=array('0'=>'-') + $this->_Base->listPermsProfilAcl(4);
						$formGui->addField($key,'select',$fTitle,'','fields1');
						$formGui->setValues($key,$select_array);
						$parseEdit=true;
					break;
					case 'stamm':
						$formGui->addField($key,'ttip',$fTitle,'','fields1');
						$formGui->setParams($key,array('mode'=>'a','limit'=>20,'width'=>200,'app'=>'','params'=>base64_encode(serialize(array('MaxEntries'=>1,'simpleSearch'=>1)))));
						$parseEdit=true;
					break;
					case 'text':
					case 'date':
						$formGui->addField($key,$this->_Base->getFieldData($aktField,'Typ'),$fTitle,'','fields1');
						$parseEdit=true;
					break;
					case 'password':
						$formGui->addField($key,'pwd',$fTitle,'','fields1');
						$parseEdit=true;
					break;
					case 'area':
						$formGui->addField($key,$this->_Base->getFieldData($aktField,'Typ'),$fTitle,'','fields1');
						$formGui->setAttribs($key,array('rows'=>5));
						$parseEdit=true;
					break;
					case 'select':
						$select_array=array('0'=>'-') + $this->_Base->listAddrSelect($aktField);
						$formGui->addField($key,'select',$fTitle,'','fields1');
						$formGui->setValues($key,$select_array);
						$parseEdit=true;
					break;
					case 'mselect':
						$select_array=$this->_Base->listAddrSelect($aktField);
						if ($this->_Base->getFieldData($aktField,'F_Mode')) {
							$formGui->addField($key,'checklist_v',$fTitle,'','fields1');
						} else {
							$formGui->addField($key,'mselect',$fTitle,'','fields1');
						}
						$formGui->setValues($key,$select_array);
						$parseEdit=true;
						$isMulti=true;
					break;
					case 'fk_user':
						$Params=array();
						$tmpParams=array(
							'MaxEntries'=>$this->_Base->getFieldData($aktField,'F_Mode')?0:1,
							'useAll'=>0,
						);
						$Params['mode']='u';
						$Params['limit']=10;
						$Params['params']=base64_encode(serialize($tmpParams));


						$lb_params=array('Values'=>array());
						$lb_params['Values'][]=array(
							'Label'=>$fTitle,
							'LabelSep'=>'',
							'mode'=>$Params['mode'],
							'app'=>'cal',
							'params'=>$Params['params'],
							'FieldVal'=>'_USERS',
						);
						$crmLabel=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
						$formGui->addField($key,'ttip',$crmLabel,'');
						$formGui->setParams($key,$Params);

						$parseEdit=true;
						$isMulti=true;
					break;
					case 'chk':
					case 'check':
						$formGui->addField($key,'radiolist_h',$fTitle,0,'fields1');
						$select_array=array(1=>$this->_T->Lang('[[Ja]]'),-1=>$this->_T->Lang('[[Nein]]'),0=>$this->_T->Lang('[[Ignorieren]]'));
						$formGui->setValues($key,$select_array);
						$parseEdit=true;
					break;
					case 'num':
						$formGui->addField($key,'int',$fTitle,0,'fields1');
						$parseEdit=true;
					break;
					case 'kont':
						$formGui->addField($key,'text',$fTitle,'','fields1');
						$parseEdit=true;
						$isMulti=true;
					break;
					default:
					break;
				}
			}
		}
		if ($parseEdit) {
			$key='fieldMode';
			$formGui->addField($key,'radiolist_v',$this->_T->lang('[[Aktion]]'),'r','fields1');
			$select_array=array();
			$select_array['r']=$this->_T->Lang('[[Wert ersetzen]]');
			if ($isMulti) $select_array['a']=$this->_T->Lang('[[Wert hinzufuegen]]');
			$select_array['d']=$this->_T->Lang('[[Wert entfernen]]');
			$formGui->setValues($key,$select_array);

			$formGui->addField('save','submit','',$this->_T->lang('[[Ausgewaehlten Adresse zuweisen]]'),'fields1');
		}
		$formGui->addMetaToArray($formValues,'',true);

		if (Framework::getParam('save','','P')) {
			$ListID=Framework::getParam('ListID','','P');
			$numMod=0;
			if (is_array($ListID)) {
				foreach($ListID as $val) {
					$AObj=$this->_Base->getAddrObj($val);
					if (is_object($AObj) && $AObj->getAcl(4)) {
						if ($formValues['fieldID']=='FKProjID') {
							if ($formValues['fieldData']) {
								$tmpVal=array();
								foreach(explode('|',$formValues['fieldData']) as $val) {
									$tmpVal[]=substr($val,2);
								}
							} else {
								$tmpVal=array();
							}
							$oldVal=$this->_Base->getAddrProjects($AObj);
							switch ($formValues['fieldMode']) {
								case 'a':
									if (!empty($tmpVal)) {
										$this->_Base->setAddrProjects($AObj,$tmpVal,0);
										$numMod++;
									}
								break;
								case 'd':
									if (!empty($oldVal) && !empty($tmpVal)) {
										$this->_Base->deleteAddrProjects($AObj,$tmpVal);
										$numMod++;
									}
								break;
								default:
									$this->_Base->setAddrProjects($AObj,$tmpVal,1);
								break;
							}
						} else {
							switch ($this->_Base->getFieldData($formValues['fieldID'],'Typ')) {
								case 'stamm':
									if ($formValues['fieldData']) {
										$newVal=substr($formValues['fieldData'],2);
									} else {
										$newVal=0;
									}
								break;
								case 'perm':
									if ($this->_Base->isRuleUser()) {
										if ($AObj->getMeta('UserID')) {
											$newVal=0;
										} else {
											$newVal=$formValues['fieldData'];
										}
									} else {
										$newVal=$AObj->getMeta($formValues['fieldID']);
									}
								break;
								case 'mselect':
									if (is_array($formValues['fieldData'])) {
										$newVal=$this->_Base->AddrImplode($formValues['fieldData']);
									} else {
										$newVal=$formValues['fieldData'];
									}
								break;
								case 'fk_user':
									if ($formValues['fieldData']) {
										$temp=array();
										foreach(explode('|',$formValues['fieldData']) as $val) {
											$temp[]=substr($val,2);
										}
										$newVal=$this->_Base->AddrImplode($temp);
									} else {
										$newVal='';
									}
								break;
								case 'password':
									if ($formValues['fieldData']) {
										$newVal=md5($formValues['fieldData']);
									} else {
										$newVal='';
									}
								break;
								default:
									$newVal=$formValues['fieldData'];
								break;
							}
							$tmpVal=$this->_Base->AddrExplode($newVal);
							$oldVal=$this->_Base->AddrExplode($AObj->getMeta($formValues['fieldID']));
							switch ($formValues['fieldMode']) {
								case 'a':
									foreach ($tmpVal as $aVal) {
										if (!in_array($aVal,$oldVal)) {
											$oldVal[]=$aVal;
										}
									}
									$newVal=$this->_Base->AddrImplode($oldVal);
								break;
								case 'd':
									foreach ($oldVal as $aKey=>$aVal) {
										if (in_array($aVal,$tmpVal)) {
											unset($oldVal[$aKey]);
										}
									}
									$newVal=$this->_Base->AddrImplode($oldVal);
								break;
								default:
									$newVal=$this->_Base->AddrImplode($tmpVal);
								break;
							}
							if ($AObj->getMeta($formValues['fieldID'])!=$newVal) {
								$AObj->setMeta($formValues['fieldID'],$newVal);
								$this->_Base->updateAddrMeta($AObj);
								$numMod++;
							}
						}
					}
				}

			}
		}
		$ContGui->addContent('formConfig',$formGui,'CONTENT');
		return $ContGui;
	}
	function &getListGui($configValues) {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FormFieldsCore.php');
		$Gui=new ApplicationListGui();
		$Gui->setName($this->_T->lang('[[Adressen bearbeiten]]'));
		$Gui->setAutoBg(APP_FG10COLOR);
		$Gui->setID('addrEditTab');
		$Gui->setRowClass(array('list_l','list_b','list_h','list_hb','list_s','list'));
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);

		$tmp=$this->_frm->getClipboard('addr_s');
		$addrIDs=array(0);
		if (is_array($tmp)) {
			foreach($tmp as $val) {
				$addrIDs[]=$val['Content'];
			}
		}
		$searchAddr=array();
		$searchAddr[]=array('Field'=>'AddressID','Typ'=>'=','Values'=>$addrIDs);



		$listFields=array();
		if ($configValues['fieldID'] && $configValues['fieldID']!='FKProjID') {
			$listFields[]=$configValues['fieldID'];
		}

		if (Framework::getParam('_OrderF',0,'G')) {
			$this->setPrefs('AddrOrderF',Framework::getParam('_OrderF',0,'G'));
			$this->setPrefs('AddrOrderD',Framework::getParam('_OrderD',0,'G'));
		}
		$search['orderF']=$this->getPrefs('AddrOrderF','Name');
		$search['orderD']=$this->getPrefs('AddrOrderD',1);
		$sqlOrder=array($search['orderF']=>$search['orderD']);
		if ($search['orderF']!='Name') $sqlOrder['Name']=1;

		$rows=0;
		$search=array(
			'b'=>0,
			'limit'=>0,
			'use_limit'=>true,
			'use_perms'=>true,
			'addFields'=>$listFields,
		);
		$entries=$this->_Base->searchAddr($search['b'],$sqlOrder,$searchAddr,NULL,NULL,NULL,$search['use_limit'],$search['use_perms'],$search['addFields']);

		$Gui->setLimit($this->_Base->getLimit()?$this->_Base->getLimit():$this->_Base->getRows());
		$Gui->setSumRows($this->_Base->getRows());
		$Gui->setBegin($search['b']);

		$funcSelAll=new FunctionButtons('addr_list','selectall',array('ListID'=>'ListID[]','ListOn'=>true));
		$Gui->addHeaderCol('ListID',$funcSelAll->process(),'','','',1,'1%',0,'',$noEnc);
		$Gui->setTrOver('trBOC({ROW},this);');
		$Gui->setTrDown('trBOI({ROW},this,1);');

		$key='Name';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Name]]'),'','','',1,'',2);
		$Gui->setHeaderOrder($key,$key,1);
		foreach ($listFields as $key) {
			$Gui->addHeaderCol($key,$this->_Base->getFieldData($key,'Title'),'','','',1,'');
			$Gui->setHeaderOrder($key,$key,1);
		}
		if ($configValues['fieldID'] && $configValues['fieldID']=='FKProjID') {
			$Gui->addHeaderCol($configValues['fieldID'],$this->_T->lang('[[Projektzugehoerigkeit]]'),'','','',1,'');
		}

		$hl=0;
		if ($this->_Base->getRows()) {
			$attribs=array(
				'onclick'=>'return false;',
			);
			$btnList=new CheckBoxBtn ('ListID[]','');
			$btnList->setAttribs($attribs);
			foreach ($entries as $key=>$val) {
				if ($val->getAcl(4)) {
					$hl=($hl?$hl=0:$hl=1);
					$Gui->addRow($hl?2:0,'top','');
					$Gui->addCol('ListID',$btnList->process($val->getID()),'','','',1,'1%',0,'',$noEnc);
					$key='img';
					$Gui->addCol($key,'',$val->getImage(0),'','',0,'1%',0,'');
					$key='Name';
					$Gui->addCol('Name',$val->getName(),'','','',0,'',0,'');
					foreach ($listFields as $fid) {
						$nowrap=1;
						$values=$this->_Base->AddrExplode($val->getMeta($fid));
						$this->_Base->entry2Value($fid,$values,$nowrap);
						$Gui->addCol($fid,implode('<br>',$values),'','','',$nowrap,'',0,'',$noEnc);
					}
					if ($configValues['fieldID'] && $configValues['fieldID']=='FKProjID') {
						$values=array();
						$tmpPrjID=$this->_Base->getAddrProjects($val);
						if (!empty($tmpPrjID)) {
							$values=$this->_P->getCachedProjectName($tmpPrjID);
						}
						$Gui->addCol($configValues['fieldID'],implode('<br>',$values),'','','',$nowrap,'',0,'',$noEnc);
					}
					
				}
			}
		}
		return $Gui;
	}
	function &getGui() {
		require_once('lib/class_ApplicationTreeGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_TemplateGui.php');

		$ContGui=new ApplicationTreeGui();
		$configValues=array();
		$configGui=$this->getConfigGui($configValues);
		$ContGui->addTreeContent($configGui);


		$listGui=$this->getListGui($configValues);

		if ($GLOBALS['H_REFERER'][0]) {
			$lBreak=$GLOBALS['H_REFERER'][0];
		} else {
			$lBreak="index.php?site=addr.php";
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$lBreak));
		$listGui->addFunction($btBreak,1);

		$ContGui->addContent($listGui);
		return $ContGui;

	}

}
?>