<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if ($rootObj->getMeta('System')=='d') {
	$this_action=$frm->getObjAction ($Addr->getModul(),'m_'.$Addr->getMode(),$list_action_val);
} else {
	$this_action=$frm->getObjAction ($Addr->getModul(),$obj->getActionMode(1),$list_action_val);
}

if ($Addr->isAllowedAction($obj,reset($this_action)) && is_array($ListID)) {
	$location='';
	switch ($list_action_val) {
		case 'org':
			$frm->deleteClipboard('addr_u');
			$frm->deleteClipboard('addr_s');
			$Addr->updateAddrMetaVisited($ListID);
			foreach ($ListID as $key=>$val) {
				$new_obj=$Addr->getAddrObj($val);
				if (is_object($new_obj)) {
					if ($new_obj->getAcl(4)) {
						if ($new_obj->getMeta('UserID')) {
							$frm->insertClipboard('addr_u',$val,'org');
						} else {
							$frm->insertClipboard('addr_s',$val,'org');
						}
					} else {
						$ActionError['no_addr_perms'][]=$new_obj->getID();
					}
				}

			}
			$Addr->setClipboard('addr_u',$frm->getClipboard('addr_u'));
			$Addr->setClipboard('addr_s',$frm->getClipboard('addr_s'));
			if ($Addr->isClipboard('addr_s') || $Addr->isClipboard('addr_u')) {
				$action="org";
			}
		break;
		case 'operm':
			$frm->deleteClipboard('addr_s');
			$Addr->updateAddrMetaVisited($ListID);
			foreach ($ListID as $key=>$val) {
				$new_obj=$Addr->getAddrObj($val);
				if (is_object($new_obj)) {
					if (!$new_obj->getMeta('UserID')) {
						if ($new_obj->getAcl(4)) {
							$frm->insertClipboard('addr_s',$val,'perm');
						} else {
							$ActionError['no_addr_perms'][]=$new_obj->getID();
						}
					}
				}

			}
			$Addr->setClipboard('addr_s',$frm->getClipboard('addr_s'));
			if ($Addr->isClipboard('addr_s')) {
				$action="operm";
			}
		break;
		case 'medit':
			$frm->deleteClipboard('addr_s');
			$Addr->updateAddrMetaVisited($ListID);
			foreach ($ListID as $key=>$val) {
				$new_obj=$Addr->getAddrObj($val);
				if (is_object($new_obj)) {
					if ($new_obj->getAcl(4)) {
						$frm->insertClipboard('addr_s',$val,'edit');
					} else {
						$ActionError['no_addr_perms'][]=$new_obj->getID();
					}
				}

			}
			$L->setParam('action','medit');
			$action="medit";
		break;
		case 'f_delete':
			foreach ($ListID as $key=>$val) {
				$new_obj=$Addr->getAddrObj($val);
				if (is_object($new_obj)) {
					$tmp_error=DeleteAddrObject($new_obj);
					if ($tmp_error) {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
			}
			break;
		case 'undelete':
			foreach ($ListID as $key=>$val) {
				$new_obj=$Addr->getAddrObj($val);
				if (is_object($new_obj) && $new_obj->getMeta('Trash') && $new_obj->getMeta('TrashIDs')) {

					$new_obj->setParentMeta('NodeIDs',explode(',',$new_obj->getMeta('TrashIDs')));
					$new_obj->setMeta('Trash',0);
					$new_obj->setMeta('TrashIDs','');

					$new_obj->setMeta('UserModify',$frm->getUser());
					$new_obj->setMeta('TimeModify',time());

					$Addr->updateAddrMeta($new_obj);
				}
			}
			break;
/*

			
*/
		case 'i_fav':
			$Addr->updateAddrMetaVisited($ListID);
			foreach ($ListID as $key=>$val) {
				$new_obj=$Addr->getAddrObj($val);
				if (is_object($new_obj)) {
					if (!$new_obj->getHotMeta('Favorite')) {
						$new_obj->setHotMeta('Favorite',1);
						$Addr->insertHotMeta($new_obj);
					}
					unset($ListID[$key]);
				}
			}
			break;
		case 'd_fav':
			$Addr->updateAddrMetaVisited($ListID);
			foreach ($ListID as $key=>$val) {
				$new_obj=$Addr->getAddrObj($val);
				if (is_object($new_obj)) {
					if ($new_obj->getHotMeta('Favorite')) {
						$new_obj->setHotMeta('Favorite',0);
						$Addr->insertHotMeta($new_obj);
					}
					unset($ListID[$key]);
				}
			}
			break;
		case 'proj_add':
			$Addr->updateAddrMetaVisited($ListID);
			foreach ($ListID as $key=>$val) {
				$new_obj=$Addr->getAddrObj($val);
				if (is_object($new_obj)) {
					if ($new_obj->getAcl(4)) {
						if ($P && $frm->getPrefs('proj','actualProject')) {
							$Addr->setAddrProjects($new_obj,array($frm->getPrefs('proj','actualProject')),false);
						}
						unset($ListID[$key]);
					} else {
						$ActionError['addr_perms'][]=$new_obj->getID();
					}
				}
			}
		break;
		case 'proj_del':
			$Addr->updateAddrMetaVisited($ListID);
			foreach ($ListID as $key=>$val) {
				$new_obj=$Addr->getAddrObj($val);
				if (is_object($new_obj)) {
					if ($new_obj->getAcl(4)) {
						if ($P && $frm->getPrefs('proj','actualProject')) {
							$Addr->deleteAddrProjects($new_obj,$frm->getPrefs('proj','actualProject'));
						}
						unset($ListID[$key]);
					} else {
						$ActionError['addr_perms'][]=$new_obj->getID();
					}
				}
			}
		break;
		case 'l_mail':
			$Addr->updateAddrMetaVisited($ListID);
			$loc_val='';
			$mfield=$mto=array();
			foreach ($Addr->getFields() as $key=>$val) {
				if ($val['Action']=='mail') {
					$mfield[]=$key;
				}
			}
			foreach ($ListID as $key=>$val) {
				$new_obj=$Addr->getAddrObj($val);
				foreach ($mfield as $FieldID) {
					if ($new_obj->getMeta($FieldID)) {
				   		$values=$Addr->AddrExplode($new_obj->getMeta($FieldID));
						if ($values[0]) {
							$mto[]=$Addr->formatMail($new_obj,$values[0]);
							break;
						}

					}
				}
				unset($ListID[$key]);
			}
			if (!empty($mto)) {
				$frm->setUserData('mail',1,implode(',',$mto));
				if ($SESS_MDATA[$site]['MAIL_REFERER']) {
					$location=$SESS_MDATA[$site]['MAIL_REFERER'];
					unset($SESS_MDATA[$site]);
				} else {
					$location="index.php?site=mail.php&action=n&getUserBCC=1";
				}
			}
			break;
		case 'l_sms':
			$Addr->updateAddrMetaVisited($ListID);
			$sms=$frm->getStaticModul('sms');
			$loc_val='';
			$field=$to=array();
			foreach ($Addr->getFields() as $key=>$val) {
				if ($val['Action']=='sms') {
					$field[]=$key;
				}
			}
			foreach ($ListID as $key=>$val) {
				$new_obj=$Addr->getAddrObj($val);
				foreach ($field as $FieldID) {
					if ($new_obj->getMeta($FieldID)) {
				   		$values=$Addr->AddrExplode($new_obj->getMeta($FieldID));
						if ($values[0]) {
							$to[]=$sms->formatNumber($values[0],$new_obj->getName(1));
							unset($ListID[$key]);
							break;
						}
					}
				}
			}
			if (!empty($to)) {
				FrameWork::importParam(array('ListID'=>$ListID));
				$msgParams=array(
					'reset'=>1,
					'tab'=>'sms',
					'smsTo'=>implode(',',$to),
				);
				$frm->addOnload('ge.registry.coreViewMessage.geMsgShow('.(json_encode($msgParams)).');');
			}
		break;
	}
	if ($location) {
		page_close();
		header('Location:'.$location);
		exit;
	}
}
?>
