<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$obj_action=$frm->getObjAction($Addr->getModul(),$AObj->getActionMode(0));
if ($Addr->isAllowedAddrAction($AObj,$obj_action[$addr_action_val])) {
	$location='';
	if ($obj_action[$addr_action_val]['Custom']) {
		$appCustom=& $frm->getStaticModul('custom');
		$appCustom->executeAction($obj_action[$addr_action_val]['Custom'],$AObj,$Addr->getModul());
	}
	switch ($addr_action_val) {
		case 'delete':
			if (is_object($trash_obj)) {
				$tmp_error=TrashAddrObject($trash_obj,$AObj);
				//debug($tmp_error);
				if (!$tmp_error) {
					if ($H_REFERER[0]) {
						$location=$H_REFERER[0];
					} else {
						$location="index.php?site=$site";
					}
				} else {
					$ActionError[$tmp_error[0]][]=$tmp_error[1];
				}
			}
			break;
		case 'f_delete':
			$tmp_error=DeleteAddrObject($AObj);
			if (!$tmp_error) {
				if ($H_REFERER[0]) {
					$location=$H_REFERER[0];
				} else {
					$location="index.php?site=$site";
				}
			} else {
				$ActionError[$tmp_error[0]][]=$tmp_error[1];
			}
			break;
		case 'modify':
			$location="index.php?site=$site&action=".$AObj->getAction(1)."&oid=$oid&aid=".$AObj->getID()."&back=1";
			break;
		case 'copy':
			$location="index.php?site=$site&action=".$AObj->getAction(1)."&oid=$oid&aid=".$AObj->getID()."&copy=1&back=1";
			break;
		case 'undelete':
			$location="index.php?site=$site&action=".$AObj->getAction(1)."&oid=$oid&aid=".$AObj->getID()."&undelete=1&back=1";
			break;
		case 'vcard':
			getVcard($AObj,1);
			break;
		case 'v_mail':
			$vcard=getVcard($AObj);
			if ($vcard) {
				$Fname=preg_replace('/[^A-za-z0-9]/','_',$AObj->getName()).'.vcf';
				$f_url=tempnam(Framework::getTempPath(),'vcf');
				$fp=fopen($f_url,'w');
				fwrite($fp,$vcard);
				fclose($fp);
				if ($SESS_MDATA[$site]['MAIL_REFERER']) {
					$location="index.php?site=mail.php&action=n&load=1&f_name=".urlencode($Fname)."&f_url=".urlencode($f_url);
					unset($SESS_MDATA[$site]);
				} else {
					$location="index.php?site=mail.php&action=n&f_name=".urlencode($Fname)."&f_url=".urlencode($f_url);
				}
			}
			//debug($vcard);
			break;
		case 's_mail':
			$loc_val='';
			$mfield=$mto=array();
			$addr_action_num=intval($addr_action_num);
			foreach ($Addr->getFields() as $key=>$val) {
				if ($val['Action']=='mail') {
					$mfield[]=$key;
				}
			}
			foreach ($mfield as $FieldID) {
				if ($AObj->getMeta($FieldID)) {
					$values=$Addr->AddrExplode($AObj->getMeta($FieldID));
					if ($values[$addr_action_num]) {
						$mto[]=$Addr->formatMail($AObj,$values[$addr_action_num]);
						break;
					} elseif ($values[0]) {
						$mto[]=$Addr->formatMail($AObj,$values[0]);
						break;
					}
				}
			}
			if (!empty($mto)) {
				$frm->setUserData('mail',1,implode(',',$mto));
				if ($SESS_MDATA[$site]['MAIL_REFERER']) {
					$location=$SESS_MDATA[$site]['MAIL_REFERER'];
					unset($SESS_MDATA[$site]);
				} else {
					$location="index.php?site=mail.php&action=n&getUserTO=1";
				}
			}
			break;
		case 'i_fav':
			if (!$AObj->getHotMeta('Favorite')) {
				$AObj->setHotMeta('Favorite',1);
				$Addr->insertHotMeta($AObj);
			}
			break;
		case 'd_fav':
			if ($AObj->getHotMeta('Favorite')) {
				$AObj->setHotMeta('Favorite',0);
				$Addr->insertHotMeta($AObj);
			}
			break;
		case 'proj_add':
			if ($P && $frm->getPrefs('proj','actualProject')) {
				 $Addr->setAddrProjects($AObj,array($frm->getPrefs('proj','actualProject')),false);
			}
		break;
		case 'proj_del':
			if ($P && $frm->getPrefs('proj','actualProject')) {
				 $Addr->deleteAddrProjects($AObj,$frm->getPrefs('proj','actualProject'));
			}
		break;
		case 'perms':
			$action='p';
			$back=1;
			break;

	}
	if ($location) {
		page_close();
		header('Location:'.$location);
		exit;
	}
}
?>
