<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$this_action=$frm->getObjAction ($Addr->getModul(),'l_org',$org_action_val);
$ListID=array();
if ($root_obj[$eroot_id]->getMeta('System')=='u') {
	$ListID=$frm->getClipboard('addr_u');
	$lmode='addr_u';
}
if ($root_obj[$eroot_id]->getMeta('System')=='s') {
	$ListID=$frm->getClipboard('addr_s');
	$lmode='addr_s';
}
if ($Addr->isAllowedAction($obj,reset($this_action))) {
	$location='';
	switch ($org_action_val) {
		case 'delete':
			if (is_object($trash_obj)) {
				foreach ($ListID as $key=>$val) {
					$new_obj=$Addr->getAddrObj($val['Content']);
					if (is_object($new_obj)) {
						$tmp_error=TrashAddrObject($trash_obj,$new_obj);
						//debug($tmp_error);
						if (!$tmp_error) {
							unset($ListID[$key]);
							$frm->deleteClipboard($lmode,$val['Content']);
						} else {
							$ActionError[$tmp_error[0]][]=$tmp_error[1];
						}
					}
				}
			}
			break;
		case 'a_cat':
			if (is_array($sNodeID) && count($sNodeID)) {
				foreach ($ListID as $key=>$val) {
					$newNodes=$sNodeID;
					$new_obj=$Addr->getAddrObj($val['Content']);
					if (is_object($new_obj)) {
						$oldNodes=$Addr->getAddrNodesIDs($new_obj->getID());
						foreach ($oldNodes as $nval) {
							if (!in_array($nval,$newNodes)) {
								$newNodes[]=$nval;
							}
						}
						//debug($newNodes);
						$new_obj->setParentMeta('NodeIDs',$newNodes);
						$Addr->updateAddrMeta($new_obj);
					}
				}
				unset($sNodeID);
			} else {
				$ActionError['no_cat']=true;
			}
			break;
		case 'n_cat':
			if (is_array($sNodeID) && count($sNodeID)) {
				foreach ($ListID as $key=>$val) {
					$new_obj=$Addr->getAddrObj($val['Content']);
					if (is_object($new_obj)) {
						$new_obj->setParentMeta('NodeIDs',$sNodeID);
						//debug($sNodeID);
						$Addr->updateAddrMeta($new_obj);
					}
				}
				unset($sNodeID);
			} else {
				$ActionError['no_cat']=true;
			}
			break;
		case 'd_cat':
			if (is_array($sNodeID) && count($sNodeID)) {
				foreach ($ListID as $key=>$val) {
					$new_obj=$Addr->getAddrObj($val['Content']);
					if (is_object($new_obj)) {
						$oldNodes=$Addr->getAddrNodesIDs($new_obj->getID());
						$newNodes=array();
						foreach ($oldNodes as $nval) {
							if (!in_array($nval,$sNodeID)) {
								$newNodes[]=$nval;
							}
						}
						if (!empty($newNodes)) {
							$new_obj->setParentMeta('NodeIDs',$newNodes);
							$Addr->updateAddrMeta($new_obj);
						} else {
							$ActionError['d_cat'][]=$new_obj->getID();
						}
					}
				}
				if (!$ActionError) unset($sNodeID);
			} else {
				$ActionError['no_cat']=true;
			}
			break;
	}
	if ($location) {
		page_close();
		header('Location:'.$location);
		exit;
	}
}
?>
