<?php
class AsxEventAjam extends Shift8_Event {

}
class AsxServerAjam extends Shift8 {
	protected $_Asx;
	protected $_frm;
	protected $_features=array(
		'context'=>true,
		'phonelist'=>true,
	);
	public function __construct() {
		global $frm;
		$this->_frm=& $frm;
		$this->_Asx=$this->_frm->getStaticModul('asx');
		parent::__construct($this->_Asx->getCfg('ajam/url'),$this->_Asx->getCfg('ajam/user'),$this->_Asx->getCfg('ajam/pwd'));
	}
	public function getFeatures($k,$def=false) {
		return isset($this->_features[$k])?$this->_features[$k]:$def;
	}
	public function login() {
		return parent::login();
	}
	public function geSetDND($asxPhone,$val) {
		//debug(strstr($asxPhone->getID(),'/'));
		$peer=$this->getSipPeer($asxPhone->getName());
		if ($peer) {
			if ($val) {
				if (!$this->DBPut('SIP/DND',$asxPhone->getID(),1)) {
					//debug($Shift8->getLastError());
				}
			} else {
				$this->DBDel('SIP/DND',$asxPhone->getID());
			}
			return 1;
		}
		return 0;
	}
	public function geCall($asxPhone,$call_number,$call_name='') {
		//debug(strstr($asxPhone->getID(),'/'));
		$peer=$this->getSipPeer($asxPhone->getName());
		//debug($Shift8->ListCommands('ListCommands'));
		//debug($peer);
		if ($peer) {
			$number=$this->_Asx->cleanNumber($call_number);
			if ($this->_Asx->getCfg('cfg/phone/prefix') && strpos($number,$this->_Asx->getCfg('cfg/phone/prefix'))===0) {
				$number=substr($number,strlen($this->_Asx->getCfg('cfg/phone/prefix')));
			}
			$call_name.=trim(' <'.$number.'>');

			if ($asxPhone->getMeta('CallContext')) {
				$context=$asxPhone->getMeta('CallContext');
			} else {
				$context=$peer->get('context');
			}

			/*debug($context);
			debug(FrameWork::getParam('number',''));*/
			//$res=$Shift8->originate($peer->get('channeltype').'/'.$peer->get('objectname'),$context,$number,'1',false,false,30000,$callerid);
			//$context='intern';
			if ($this->_Asx->getCfg('ajam/self_redirect')) {
				$res=$this->originate('Local/'.$peer->get('objectname').'@'.$this->_Asx->getCfg('ajam/self_redirect'),$context,$number,'1',false,false,30000,$call_name);
			} else {
				$res=$this->originate($peer->get('channeltype').'/'.$peer->get('objectname'),$context,$number,'1',false,false,30000,$call_name);
			}
			return $res;
		}
	}
	public function geRedirect($asxPhone,$channel,$exten) {
		$peer=$this->getSipPeer($asxPhone->getName());
		//debug($peer);
		if ($peer) {
			if ($this->_Asx->getCfg('ajam/self_redirect') && $exten==$asxPhone->getName()) {
				$context=$this->_Asx->getCfg('ajam/self_redirect');
			} elseif ($asxPhone->getMeta('CallContext')) {
				$context=$asxPhone->getMeta('CallContext');
			} else {
				$context=$peer->get('context');
			}
			$res=$this->transfer($channel,'',$exten,$context,'1');

			/*
			if ($Asx->getCfg('ajam/self_redirect') && FrameWork::getParam('exten','')==$asxPhone->getName()) {
				//$Shift8->setChannelVariable('GERL', $asxPhone->getName(), FrameWork::getParam('channel',''));
				//debug(FrameWork::getParam('channel',''));
				$res=$Shift8->transfer(FrameWork::getParam('channel',''),'',FrameWork::getParam('exten',''),$Asx->getCfg('ajam/self_redirect'),'1');
			} else {
				if ($asxVerison>=1.61) {
					$res=$Shift8->attendedTransfer(FrameWork::getParam('channel',''),FrameWork::getParam('exten',''),$context,'1');
				}

			}
			*/
			/*debug(FrameWork::getParam('channel',''));
			debug(FrameWork::getParam('extrachannel',''));
			debug(FrameWork::getParam('exten',''));*/
			//debug($res);
			//debug($peer);
		}
	}
	public function geHangup($asxPhone,$channel) {
		$this->hangup($channel);
	}
	public function geGetAllPhones() {
		$result=array();
		$rows=0;
		$entries=$this->_Asx->listPhones($rows,array());
		$peers=$this->getSipPeers();
		foreach ($peers as $peer) {
			if ($peer->get('ipaddress') && $this->_frm->isAllowedIpMask($this->_Asx->getCfg('cfg/phone/ip_mask'),$peer->get('ipaddress'))) {
				$obj=new AsxEventAjam();
				$obj->id=$peer->get('channeltype').'/'.$peer->get('objectname');
				$obj->phoneAddress=$peer->get('ipaddress');
				$obj->phoneStatus=$peer->get('status');
				if (isset($entries[$obj->id])) {
					$obj->pcAddress=$entries[$obj->id]->getMeta('PcAddress');
					$obj->pcUser=$entries[$obj->id]->getMeta('FKUserID');
					$obj->pcContext=$entries[$obj->id]->getMeta('CallContext');
				}
				$result[]=$obj;
			}
		}
		return $result;
	}
}
