<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$obj_action=$frm->getObjAction ($Bmng->getModul(),$obj->getActionMode(0));
if ($Bmng->isAllowedAction($obj,$obj_action[$obj_action_val])) {
	$location='';
	switch ($obj_action_val) {
		case 'n_pfol':
			if ($obj->isFolder()) {
				$new_obj=new BObj_pfol();
				$DocType='pfol';
				$new_obj->setMeta('Title','No Name');
				$new_obj->setMeta('MenuImage','tree.gif');
				$new_obj->setMeta('Version',1);
				$new_obj->setMeta('TimeCreate',time());
				$new_obj->setMeta('TimeModify',time());
				$new_obj->setMeta('UserCreate',$user_id);
				$new_obj->setMeta('UserModify',$user_id);
				$new_obj->setMeta('DocType',$DocType);
				$new_obj->setMeta('Users',$obj->getMeta('Users'));
				$new_obj->setMeta('Groups',$obj->getMeta('Groups'));
				if ($Bmng->insertMeta($new_obj)) {
					$new_obj->setParentMeta('ParentID',$obj->getID());
					$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
					$Bmng->insertParentMeta($new_obj);
				}
				$location="index.php?site=$site&action=".$new_obj->getAction(0)."&oid=".$new_obj->getID();
			}
		break;
		case 'cut':
			if ($Bmng->isClipboard('bobj')) {
				$frm->deleteClipboard('bobj');
				$Bmng->setClipboard('bobj',false);
			}
			$Bmng->setClipboard('bobj',$frm->insertClipboard('bobj',$obj->getID(),'cut'));
			break;
		case 'copy':
			if ($Bmng->isClipboard('bobj')) {
				$frm->deleteClipboard('bobj');
				$Bmng->setClipboard('bobj',false);
			}
			$Bmng->setClipboard('bobj',$frm->insertClipboard('bobj',$obj->getID(),'copy'));
			break;
		case 'insert':
			if ($Bmng->isClipboard('bobj')) {
				foreach ($Bmng->getClipboard('bobj') as $val) {
					$new_obj=$Bmng->getObj($val['Content']);
					$tmp_error=CutCopyObject($obj,$new_obj,$val['Mode']);
					if (!$tmp_error) {
						$frm->deleteClipboard('bobj',$val['Content']);
					} else {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
				$Bmng->setClipboard('bobj',$frm->getClipboard('bobj'));
			}
			break;
		case 'delete':
			$oldParentID=$obj->getParentMeta('ParentID');
			if (is_object($trash_obj)) {
				$tmp_error=TrashObject($trash_obj,$obj);
				if (!$tmp_error) {
					$location="index.php?site=$site&oid=".$oldParentID;
				} else {
					$ActionError[$tmp_error[0]][]=$tmp_error[1];
				}
			}
			break;
		case 'f_delete':
			$oldParentID=$obj->getParentMeta('ParentID');
			$tmp_error=DeleteObject($obj);
			if (!$tmp_error) {
				$location="index.php?site=$site&oid=".$oldParentID;
			} else {
				$ActionError[$tmp_error[0]][]=$tmp_error[1];
			}
			break;
		case 'tr_delete':
			if (is_object($trash_obj)) {
				$sub_entrys=$Bmng->ListSubEntrys($trash_obj->getID(),'');
				foreach ($sub_entrys as $new_obj) {
					$tmp_error=DeleteObject($new_obj);
					if ($tmp_error) {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
			}
			break;
		case 'n_version':
			$parent_obj=$Bmng->getObj($obj->getParentMeta('ParentID'));
			if (basename($old_dest) && file_exists(Framework::getTempPath().'/'.basename($old_dest))) {
				$file=Framework::getTempPath().'/'.basename($old_dest);
			} else {
				$file=$Bmng->getCfg('OrigPath').'/'.$obj->getMeta('Content');
			}
			$new_obj=$Bmng->saveImage($parent_obj,$file,$obj->getMeta('Title'));
			if ($new_obj) {
				$location="index.php?site=$site&oid=".$new_obj->getID();
			} else {
				$ActionError['ImageSave']=1;
			}
		break;
		case 'perms':
			$action='p';
			//$location="index.php?site=$site&action=".$obj->getAction(1)."&oid=".$obj->getID();
			break;
		case 'config':
			$action='cfg';
			//$location="index.php?site=$site&action=".$obj->getAction(1)."&oid=".$obj->getID();
			break;
	}
	if ($location) {
		page_close();
		header('Location:'.$location);
		exit;
	}
}
?>
