<?php
class CalAdminGui {
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_avTools=array();
	function CalAdminGui() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=$frm->getStaticModul('cal');
		$this->_BaseCat=$frm->getStaticModul('cal_cat');
		$this->_BaseRes=$frm->getStaticModul('cal_res');
		$this->_BaseTime=$frm->getStaticModul('cal_time');
		$this->_Wd=$frm->getStaticModul('workday');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('cal');
	}
	function _handleRequest() {
		$this->_mode=Framework::getParam('mode','cal_sec','G');
		switch ($this->_mode) {
			case 'cal_cat':
				$this->_oid=Framework::getParam('oid',0,'G');
				if ($this->_oid) {
					$this->_Obj=$this->_BaseCat->getObj($this->_oid,true);
				}

				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('oid');
							$this->_L->goToLink();
						break;
						case 'delete':
							if ($this->_oid && $this->_Obj) {
								if ($this->_BaseCat->deleteObj($this->_Obj)) {
									$this->_L->unsetParam(array('oid','action'));
									$this->_L->goToLink();
								}
							}
						break;
						default:
							//debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
				$this->_ObjActionGui=$this->getObjActionGui('cal_cat');
			break;
			case 'cal_res':
				$this->_action=Framework::getParam('action','b','G');
				$this->_oid=Framework::getParam('oid',0,'G');
				if ($this->_oid) {
					$this->_Obj=$this->_BaseRes->getObj($this->_oid,true);
				}
				if (Framework::getParam('_clTab',0,'G')) {
					$this->setPrefs('calResTab',Framework::getParam('_clTab',0,'G'));
				}

				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('oid');
							$this->_L->goToLink();
						break;
						case 'delete':
							if ($this->_oid && $this->_Obj) {
								if ($this->_BaseRes->deleteObj($this->_Obj)) {
									$this->_L->unsetParam(array('oid','action'));
									$this->_L->goToLink();
								}
							}
						break;
						default:
							//debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
				$this->_ObjActionGui=$this->getObjActionGui('cal_res');
			break;
			case 'cal_res_crm':
				$this->_action=Framework::getParam('action','b','G');
				//$this->_frm->addJsScript('tpl/'.APP_THEME.'/cjs/applicationPrj.js');
				$this->_UserFormFieldsGui=& $this->_frm->getStaticGuiModul('uform','UserFormFieldsGui');
				$GuiCfg=array(
					'showUseSearch'=>0,
					'showUseList'=>0,
					'showUseQuick'=>0,
					'usePerms'=>0,
					'useMaxLen'=>1,
					'showUseMultiple'=>0,
					'showVisibility'=>0,
					'allowedFields'=>array(
						'int',
						'check',
						'select',
						'mselect',
					),
					'requiredFields'=>array(
						'none',
					),
				);
				$this->_UserFormFieldsGui->setGuiCfg($GuiCfg);
				$this->_UserFormFieldsGui->loadSystemObj('cal_res');
			break;
			
			case 'cal_sec':

			break;
			case 'cal_admin':

			break;
			case 'cal_holy':
				$this->_countries=$this->_frm->getSelectData('cou');
				$this->_oid=Framework::getParam('oid',0,'G');
				$this->_cid=Framework::getParam('cid',0,'G');
				$this->_action=Framework::getParam('action','b','G');
				if ($this->_oid) {
					$this->_Obj=$this->_Wd->getObj($this->_oid,true);
					$this->_cid=$this->_Obj->getMeta('FKCountryID');
				}
				if ($this->_action=='b' && (!$this->_cid || !isset($this->_countries[$this->_cid]))) {
					$this->_cid=key($this->_countries);
				}
				if ($this->_cid) {
					$this->_cObj=$this->_frm->readSelectData($this->_cid);
				}
				if ($this->_cObj) {
					$this->_wdEntries=$this->_Wd->getDays($this->_cid);
				}

				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('cid');
							$this->_L->goToLink();
						break;
						case 'edit':
							$this->_L->setParam('action','n');
							$this->_L->goToLink();
						break;
						case 'delete':
							if ($this->_cid && empty($this->_wdEntries)) {
								if ($this->_frm->deleteSelectData($this->_cid)) {
									$this->_L->unsetParam(array('cid','action'));
									$this->_L->goToLink();
								}
							}
						break;
						default:
							//debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
				$this->_ObjActionGui=$this->getObjActionGui('cal_holy');
			break;
			case 'cal_print':
				if (Framework::getParam('_getCalPrintTpl','','G')) {
					require_once('lib/cal/class_CalPrintGui.php');
					$calPrintGui=new CalPrintGui();
					$tpl=$calPrintGui->getPrintTemplate(Framework::getParam('_getCalPrintTpl','','G'));
					//debug($tpl);
					Framework::dumpFile($tpl,$this->_T->lang('[[Vorlage]]').'.html','application/save');
					exit;
				}
				$this->_PrintTemplatesGui=& $this->_frm->getStaticGuiModul('core','PrintTemplatesGui');
				$guiCfg=array(
					'defAction'=>'b',
					'defMode'=>'print_tpl',
					'showTree'=>false,
					'defOid'=>0,
					'avTyps'=>array(
						'list_w'=>$this->_T->lang('[[Wochenansicht]]').' - '.$this->_T->lang('[[KompaktView]]'),
						'list_g'=>$this->_T->lang('[[Wochenansicht]]').' - '.$this->_T->lang('[[ErweitertView]]'),
						'list_m'=>$this->_T->lang('[[Monatsansicht]]'),
						'list_d'=>$this->_T->lang('[[Tagesansicht]]'),
						'list_f'=>$this->_T->lang('[[Uebersicht-cal]]'),
						'list_s'=>$this->_T->lang('[[Suche]]'),
						'view_e'=>$this->_T->lang('[[Detailansicht]]'),
					),
					'systemTpls'=>array(
						'list_w'=>array(array('Name'=>$this->_T->lang('[[Standard]]'),'Link'=>$this->_L->getTempLink(null,array('_getCalPrintTpl'=>'list_w')))),
						'list_g'=>array(array('Name'=>$this->_T->lang('[[Standard]]'),'Link'=>$this->_L->getTempLink(null,array('_getCalPrintTpl'=>'list_g')))),
						'list_m'=>array(array('Name'=>$this->_T->lang('[[Standard]]'),'Link'=>$this->_L->getTempLink(null,array('_getCalPrintTpl'=>'list_m')))),
						'list_d'=>array(array('Name'=>$this->_T->lang('[[Standard]]'),'Link'=>$this->_L->getTempLink(null,array('_getCalPrintTpl'=>'list_d')))),
						'list_f'=>array(array('Name'=>$this->_T->lang('[[Standard]]'),'Link'=>$this->_L->getTempLink(null,array('_getCalPrintTpl'=>'list_f')))),
						'list_s'=>array(array('Name'=>$this->_T->lang('[[Standard]]'),'Link'=>$this->_L->getTempLink(null,array('_getCalPrintTpl'=>'list_s')))),
						'view_e'=>array(array('Name'=>$this->_T->lang('[[Standard]]'),'Link'=>$this->_L->getTempLink(null,array('_getCalPrintTpl'=>'list_e')))),
					),
					'usePerms'=>array('list_w','list_g','list_m','list_d','list_f','list_s','view_e'),
					'usePermsRules'=>array(),
				);
				$this->_PrintTemplatesGui->setGuiCfg($guiCfg);
				$this->_PrintTemplatesGui->setModul('cal');
				$this->_PrintTemplatesGui->handleRequest();
				$this->_ObjActionGui=$this->_PrintTemplatesGui->getObjActionGui();
			break;
			case 'cal_time':
				$this->_oid=Framework::getParam('oid',0,'G');
				if ($this->_oid) {
					$this->_Obj=$this->_BaseTime->getObj($this->_oid,true);
				}

				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('oid');
							$this->_L->goToLink();
						break;
						case 'delete':
							if ($this->_oid && $this->_Obj) {
								if ($this->_BaseTime->deleteObj($this->_Obj)) {
									$this->_L->unsetParam(array('oid','action'));
									$this->_L->goToLink();
								}
							}
						break;
						default:
							//debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
				$this->_ObjActionGui=$this->getObjActionGui('cal_time');
			break;
			case 'cal_import':


			break;
		}
	}
	function &getAdminHeader() {
		require_once("lib/class_ContentGui.php");
		$hGui=new ContentGui();
		$hGui->setName($this->_frm->getAppName('cal'));
		$hGui->addTab('cal_sec',$this->_T->lang('[[Rechte]]'),"index.php?site=admin.php&ac=cal&mode=cal_sec");
		$hGui->addTab('cal_res',$this->_T->lang('[[Resourcen]]'),"index.php?site=admin.php&ac=cal&mode=cal_res");
		$hGui->addTab('cal_res_crm',$this->_T->lang('[[Resourcen Attribute]]'),"index.php?site=admin.php&ac=cal&mode=cal_res_crm");
		$hGui->addTab('cal_cat',$this->_T->lang('[[Terminarten]]'),"index.php?site=admin.php&ac=cal&mode=cal_cat");
		$hGui->addTab('cal_holy',$this->_T->lang('[[Feiertage]]'),"index.php?site=admin.php&ac=cal&mode=cal_holy");
		$hGui->addTab('cal_time',$this->_T->lang('[[Zeitvorlagen]]'),"index.php?site=admin.php&ac=cal&mode=cal_time");
		$hGui->addTab('cal_print',$this->_T->lang('[[Druckvorlagen]]'),"index.php?site=admin.php&ac=cal&mode=cal_print");
		$hGui->addTabSpacer();
		$hGui->addTab('cal_import',$this->_T->lang('[[Import]]'),"index.php?site=admin.php&ac=cal&mode=cal_import");
		$hGui->addTab('cal_admin',$this->_T->lang('[[Datenpflege]]'),"index.php?site=admin.php&ac=cal&mode=cal_admin");
		$hGui->setTabOn($this->_mode);
		if ($this->_ObjActionGui) {
			$hGui->addFunction($this->_ObjActionGui);
		}
		return $hGui;
	}
	function process(&$AppGui) {
		$this->_handleRequest();
		$AppGui->addContent($this->getAdminHeader());

		switch ($this->_mode) {
			case 'cal_sec':
				switch ($this->_action) {
					default:
						$AppGui->addContent($this->showPerms());
					break;
				}

			break;
			case 'cal_cat':
				require_once('lib/class_ApplicationTreeGui.php');
				$Cont=new ApplicationTreeGui();
				$Cont->addTreeContent($this->listCategoryTree());
				switch ($this->_action) {
					default:
						$Cont->addContent($this->newCategoryEntry());
					break;
				}
				$AppGui->addContent($Cont);

			break;
			case 'cal_res':
				require_once('lib/class_ApplicationTreeGui.php');
				$Cont=new ApplicationTreeGui();
				switch ($this->_action) {
					case 'n':
						$AppGui->addContent($this->newResourcesEntry());
					break;
					default:
						$AppGui->addContent($this->listResources());
					breaK;
				}

			break;
			case 'cal_res_crm':
				$Cont=$this->_UserFormFieldsGui->process();
				$AppGui->addContent($Cont);
			break;
			case 'cal_holy':
				require_once('lib/class_ApplicationTreeGui.php');
				$Cont=new ApplicationTreeGui();
				$Cont->addTreeContent($this->listCountries());
				switch ($this->_action) {
					case 'n':
						$Cont->addContent($this->newCountry());
					break;
					case 'b':
						$Cont->addContent($this->newCountryEntry());
						$Cont->addContent($this->showCountry());
					break;
					default:
						$Cont->addContent($this->newCountry());
					break;
				}
				$AppGui->addContent($Cont);

			break;
			case 'cal_print':
				$Gui=$this->_PrintTemplatesGui->process(false);
				$AppGui->addContent($Gui);
			break;
			case 'cal_admin':
				switch ($this->_action) {
					default:
						$AppGui->addContent($this->showAdmin());
					break;
				}

			break;
			case 'cal_time':
				require_once('lib/class_ApplicationTreeGui.php');
				$Cont=new ApplicationTreeGui();
				$Cont->addTreeContent($this->listTimeTree());
				switch ($this->_action) {
					default:
						$Cont->addContent($this->newTimeEntry());
					break;
				}
				$AppGui->addContent($Cont);

			break;
			case 'cal_import':
				require_once('lib/cal/class_CalImportGui.php');
				$Cont=new CalImportGui();
				$Gui=$Cont->process();
				if ($Gui) {
					$AppGui->addContent($Gui);
				}
			break;
		}
		$AppGui->setFormAction($this->_L->getLink());
	}
	function getObjActionGui($action) {
		require_once('lib/class_FunctionObjActionGui.php');
		$objActionGui=new FunctionObjActionGui();
		$obj_action=$this->_frm->getObjAction('admin',$action);
		$parse=false;
		foreach ($obj_action as $key=>$val) {
			if ($val['Hidden']) continue;
			if($action=='cal_holy') {
				if (in_array('ID',$val['Extra']) && !$this->_cid) continue;
				if (in_array('empty',$val['Extra']) && !empty($this->_wdEntries)) continue;
			}
			if($action=='cal_res') {
				if (in_array('ID',$val['Extra']) && !$this->_oid) continue;
			}
			//print_r($val);
			$parse=true;
			$objActionGui->addValue($key,$val['Name']);
		}
		if ($parse) {
			return $objActionGui;
		}
	}

	function &listCountries() {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		$tabGui->addHeaderCol('Name',$this->_T->lang('[[Laender]]'),'','','','','',2);
		foreach ($this->_countries as $key=>$val) {
			if ($key==$this->_cid) {
				$hl=2;
			} else {
				$hl=0;
			}
			$tabGui->addRow($hl);
			$tabGui->addCol('IMG','','obj_img/ex_tree.gif');
			$tabGui->addCol('Name',$val,'',$this->_L->getTempLink(null,array('cid'=>$key,'action'=>'b')),'',0,'2000');
		}
		return $tabGui;
	}
	function &showCountry() {
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_ApplicationListGui.php');

		$Gui=new ApplicationListGui();
		$Gui->addHeaderCol('Name',$this->_T->lang('[[Bezeichnung]]'),'','','',1);
		$Gui->addHeaderCol('Date',$this->_T->lang('[[Datum]]'),'','','',0,2000);
		$Gui->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','',1);
		$Gui->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);

		foreach ($this->_wdEntries as $key=>$val) {
			if ($key==$this->_oid) {
				$hl=2;
			} else {
				$hl?$hl=0:$hl=1;
			}
			$Gui->addRow($hl,'top');
			$Gui->addCol('Name',$val->getName(),'',$this->_L->getTempLink(null,array('oid'=>$key,'action'=>'b')),'','1');
			if ($val->getMeta('wdMonth') && $val->getMeta('wdDay')) {
				$Gui->addCol('Date',$val->getMeta('wdDay').". ".strftime("%B",mktime(0,0,0,$val->getMeta('wdMonth'),1,2000)),'','','','');
			} else {
				$Gui->addCol('Date',intval($val->getMeta('wdEaster')).' '.$this->_T->lang('[[Tage nach Ostern]]'),'','','','');
			}

			$Gui->addCol('TimeModify',$val->getMeta('TimeModify')?date('d.m.Y',$val->getMeta('TimeModify')):'','','','','1');
			$Gui->addCol('UserModify',$val->getMeta('UserModify')?$this->_frm->getCachedUserName($val->getMeta('UserModify')):'','','','',1);
		}

		return $Gui;


	}
	function &newCountry() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_cid) {
			$Gui->setName($this->_T->lang('[[Neues Land einfuegen]]'));
		} else {
			$Gui->setName($this->_T->lang('[[Land bearbeiten]]'));
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'calAdminNull');
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getCountryMetaGui());
		}
		$box->setTabOn('meta');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getCountryMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		$defOneLang=1;
		if ($this->_cid) {
			foreach ($this->_frm->getMaLang() as $val) {
				if ($this->_cObj['Name_'.$val]!=$this->_cObj['Name_'.$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
			}
		}
		foreach ($this->_frm->getMaLang() as $val) {
			$key='Name_'.$val;
			$formGui->addField($key,'text',$this->_T->lang('[[Bezeichnung]]').' '.$val,$this->_cObj?$this->_cObj[$key]:'','form_fields1');
			if ($val!=$this->_frm->getLang()) {
				if ((empty($_POST) && $defOneLang) || Framework::getParam('oneLang',0,'P')) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key,$attribs);
				} else {
					$formGui->setRequired($key);
				}
			} else {
				$formGui->setRequired($key);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'form_fields1');
				$formGui->setNoMeta($key);
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $val2) {
					if ($val2!=$val) $attribs['onchange'].="disableEnable('Name_".$val2."',this,this.checked?0:1);";
				}
				$formGui->setAttribs($key,$attribs);
			}
		}

		$key='submit';
		$formGui->addField($key,'submit','','','fields1');
		$submit_array=array(
			'meta_save_x'=>' '.$this->_T->lang('[[Speichern]]').' ',
		);
		$formGui->setValues($key,$submit_array);

		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if (!is_array($this->_cObj)) {
					$this->_cObj=array();
				}
				$formGui->addMetaToArray($this->_cObj);

				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$this->_cObj['Name_'.$val]=$this->_cObj['Name_'.$this->_frm->getLang()];
					}
				}
				if ($this->_cid) {
					$this->_frm->updateSelectData ($this->_cid,$this->_cObj);
				} else {
					$this->_cid=$this->_frm->insertSelectData('cou',$this->_cObj);
				}
				$this->_L->setParam('action','b');
				$this->_L->setParam('cid',$this->_cid);
				$this->_L->goToLink();
			}
		}
		return $formGui;

	}
	function &newCountryEntry() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_oid) {
			$Gui->setName($this->_T->lang('[[Neuer Eintrag]]'));
		} else {
			$Gui->setName($this->_T->lang('[[Eintrag bearbeiten]]'));
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'|calAdminNull');
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getHolyMetaGui());
		}
		$box->setTabOn('meta');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getHolyMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		$defTrans=array();
		if (Framework::getParam('isset_oneLang',0,'P')) {
			$defOneLang=Framework::getParam('oneLang',0,'P');
		} elseif ($this->_Obj) {
			$defOneLang=1;
			$defTrans=$this->_Obj->getTrans('wdName');
			foreach ($this->_frm->getMaLang() as $lang) {
				if ($defTrans[$lang]!=$defTrans[$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
			}

		} else {
			$defOneLang=1;
		}
		foreach ($this->_frm->getMaLang() as $lang) {
			$key='Trans['.$lang.']';
			$formGui->addField($key,'text',$this->_T->lang('[[Name]]').' '.strtoupper($lang),$defTrans[$lang],'form_fields1');
			$formGui->setNoMeta($key);
			if ($lang!=$this->_frm->getLang()) {
				if ($defOneLang) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key,$attribs);
				} else {
					$formGui->setRequired($key);
				}
			} else {
				$formGui->setRequired($key);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'form_fields1');
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $lang2) {
					if ($lang2!=$lang) $attribs['onchange'].="disableEnable('Trans[".$lang2."]',this,this.checked?0:1);";
				}
				//debug($attribs);
				$formGui->setAttribs($key,$attribs);
			}
		}
		for ($i=1;$i<32;$i++) {
			$selct['wdDay'][$i]=sprintf('%02d',$i);
		}
		$selct['wdMonth'][0]='-';
		for ($i=1;$i<13;$i++) {
			$selct['wdMonth'][$i]=strftime('%B',mktime(0,0,0,$i,1,2000));
		}

		$key="lb1";
		$formGui->addField($key,'label',$this->_T->lang('[[Absolutes Datum]]'),'','form_fields2');

		$key="wdDay";
		$formGui->addField($key,'select','',$this->_Obj?$this->_Obj->getMeta($key):1,'form_fields2');
		$formGui->setValues($key,$selct[$key]);
		$formGui->setAttribs($key,array('style'=>'width:50px;'));
		$formGui->setIptAttribs($key,array('style'=>'float:left;clear:none;width:60px;'));
		$key="wdMonth";
		$formGui->addField($key,'select','',$this->_Obj?$this->_Obj->getMeta($key):0,'form_fields2');
		$formGui->setValues($key,$selct[$key]);
		$formGui->setAttribs($key,array('style'=>'width:100px;'));
		$formGui->setIptAttribs($key,array('style'=>'float:left;clear:none;width:110px;'));


		$key="wdEaster";
		$formGui->addField($key,'int',$this->_T->lang('[[Tage nach Ostern]]'),$this->_Obj?$this->_Obj->getMeta($key):0,'form_fields2');
		$formGui->setAttribs($key,array('style'=>'width:50px;'));
		$formGui->setIptAttribs($key,array('style'=>'clear:both;'));


		$key='submit';
		$submitVals=array(
			'meta_save_x'=>$this->_T->lang('[[Speichern]]')
		);
		if ($this->_oid) {
			$submitVals['meta_delete_x']=$this->_T->lang('[[Loeschen]]');
			$formGui->setValuesAttribs($key,'meta_delete_x',array('onclick'=>'return lo_form();'));
		}
		$formGui->addField($key,'submit','','','form_submit');
		$formGui->setValues($key,$submitVals);

		if (Framework::getParam('meta_delete_x','0','P')) {
			$this->_Wd->deleteObj($this->_Obj);
			$this->_L->unsetParam('oid');
			$this->_L->setParam('action','b');
			$this->_L->goToLink();
		}
		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if (!is_object($this->_Obj)) {
					$this->_Obj=new ObjCoreWorkday();
					$this->_Obj->setMeta('FKCountryID',$this->_cid);
				}
				$formGui->addMetaToObj($this->_Obj);

				if ($this->_Obj->getMeta('wdMonth')) {
					if (!checkdate($this->_Obj->getMeta('wdMonth'),$this->_Obj->getMeta('wdDay'),2000)) {
						$this->_E->setError('fields','lb1');
					}
					$this->_Obj->setMeta('wdEaster',0);
				} else {
					$this->_Obj->setMeta('wdMonth',0);
					$this->_Obj->setMeta('wdMonth',0);
				}

				if (!$this->_E->isError()) {
					$ObjTrans=array();
					if ($formGui->getFieldVal('oneLang')) {
						foreach ($this->_frm->getMaLang() as $val) {
							$ObjTrans[$val]=$formGui->getFieldVal('Trans['.$this->_frm->getLang().']');
						}
					} else {
						foreach ($this->_frm->getMaLang() as $val) {
							$ObjTrans[$val]=$formGui->getFieldVal('Trans['.$val.']');
						}
					}
					$this->_Obj->setTrans('wdName',$ObjTrans);

					if ($this->_oid) {
						$this->_Wd->updateObj($this->_Obj);
						$this->_L->unsetParam('oid');
						$this->_L->goToLink();
					} else {
						$this->_Wd->insertObj($this->_Obj);
						$this->_L->goToLink();
					}
				}
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}


	function &listCategoryTree() {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		//$tabGui->setName($this->_T->lang('[[Rechte Profil]]'));
		$tabGui->addHeaderCol('Name',$this->_T->lang('[[Terminarten]]'),'','','','','',2);
		$categorys=$this->_BaseCat->listObj();
		foreach ($categorys as $key=>$val) {
			if ($key==$this->_oid) {
				$hl=2;
			} else {
				$hl=0;
			}
			$tabGui->addRow($hl);
			$tabGui->addCol('IMG','','obj_img/ex_tree.gif');
			$tabGui->addCol('Name',$val->getName(),'',$this->_L->getTempLink(null,array('oid'=>$key,'action'=>'n')),'',0,'2000');
		}
		return $tabGui;
	}
	function &newCategoryEntry() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_oid) {
			$Gui->setName($this->_T->lang('[[Neuer Eintrag]]'));
		} else {
			$Gui->setName($this->_T->lang('[[Eintrag bearbeiten]]'));
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'|calAdminNull');
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getCategoryMetaGui());
		}
		$box->setTabOn('meta');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getCategoryMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		$defTrans=array();
		if (Framework::getParam('isset_oneLang',0,'P')) {
			$defOneLang=Framework::getParam('oneLang',0,'P');
		} elseif ($this->_Obj) {
			$defOneLang=1;
			$defTrans=$this->_Obj->getTrans('calCatName');
			foreach ($this->_frm->getMaLang() as $lang) {
				if ($defTrans[$lang]!=$defTrans[$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
			}

		} else {
			$defOneLang=1;
		}
		foreach ($this->_frm->getMaLang() as $lang) {
			$key='Trans['.$lang.']';
			$formGui->addField($key,'text',$this->_T->lang('[[Name]]').' '.strtoupper($lang),$defTrans[$lang],'form_fields1');
			$formGui->setNoMeta($key);
			if ($lang!=$this->_frm->getLang()) {
				if ($defOneLang) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key,$attribs);
				} else {
					$formGui->setRequired($key);
				}
			} else {
				$formGui->setRequired($key);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'form_fields1');
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $lang2) {
					if ($lang2!=$lang) $attribs['onchange'].="disableEnable('Trans[".$lang2."]',this,this.checked?0:1);";
				}
				//debug($attribs);
				$formGui->setAttribs($key,$attribs);
			}
		}

		if ($this->_Obj) {
			if ($this->_Obj->getMeta('calCatTest')) $defSettings[]='calCatTest';
			if ($this->_Obj->getMeta('calCatNoConflict')) $defSettings[]='calCatNoConflict';
			if ($this->_Obj->getMeta('calCatView')&1) $defSettings[]='b_1';
			if ($this->_Obj->getMeta('calCatView')&2) $defSettings[]='b_2';
			if ($this->_Obj->getMeta('calCatView')&4) $defSettings[]='b_4';
			if ($this->_Obj->getMeta('calCatView')&8) $defSettings[]='b_8';
			if ($this->_Obj->getMeta('calCatView')&16) $defSettings[]='b_16';
			if ($this->_Obj->getMeta('calCatView')&32) $defSettings[]='b_32';
			if ($this->_Obj->getMeta('calCatView')&64) $defSettings[]='b_64';
			if ($this->_Obj->getMeta('calCatView')&128) $defSettings[]='b_128';
			if ($this->_Obj->getMeta('calCatView')&256) $defSettings[]='b_256';
			if ($this->_Obj->getMeta('calCatView')&512) $defSettings[]='b_512';
			if ($this->_Obj->getMeta('calCatView')&1024) $defSettings[]='b_1024';
			if ($this->_Obj->getMeta('calCatView')&2048) $defSettings[]='b_2048';
			if ($this->_Obj->getMeta('calCatView')&4096) $defSettings[]='b_4096';
			if ($this->_Obj->getMeta('calCatView')&8192) $defSettings[]='b_8192';
		}
		$key="cat_settings_1";
		$formGui->addField($key,'checklist_v',$this->_T->lang('[[uform_Einstellungen]]'),$defSettings,'form_fields1');
		$formGui->setValues($key,array(
			'calCatTest'=>$this->_T->lang('[[Auf Konflikte testen]]'),
			'calCatNoConflict'=>$this->_T->lang('[[Keine Konflikte zulassen]]'),
			'b_256'=>$this->_T->lang('[[Terminart in der Zeitfenstersuche beruecksichtigen]]'),
			'b_32'=>$this->_T->lang('[[Terminart ohne Uhrzeitangabe]]'),
		));
		$formGui->setNoMeta($key);

		$key="cat_settings_tmp";
		$formGui->addField($key,'checklist_v',$this->_T->lang('[[Fixe Eingabefelder]]'),array('a','b','c','d'),'form_fields2');
		$formGui->setValues($key,array(
			'a'=>$this->_T->lang('[[Titel]]'),
			'b'=>$this->_T->lang('[[Ort]]'),
			'c'=>$this->_T->lang('[[Beschreibung]]'),
			'd'=>$this->_T->lang('[[Startdatum]]'),
		));
		$formGui->setAttribs($key,array('disabled'=>'disabled'));
		$formGui->setNoMeta($key);

		$key="cat_settings_2";
		$formGui->addField($key,'checklist_v',$this->_T->lang('[[Variable Eingabefelder]]'),$defSettings,'form_fields2');
		$fValues=array();
		$fValues['b_1']=$this->_T->lang('[[Enddatum]]');
		$fValues['b_64']=$this->_T->lang('[[Termin f&uuml;r den ganzen Tag]]');
		$fValues['b_128']=$this->_T->lang('[[Provisorischer Termin]]');
		$fValues['b_16']=$this->_T->lang('[[Vorwarnung]]');
		$fValues['b_2']=$this->_T->lang('[[Wiederholung]]');
		$fValues['b_8']=$this->_T->lang('[[Sichtbarkeit]]');
		$fValues['b_4']=$this->_T->lang('[[Einladung]]');
		$fValues['b_8192']=$this->_T->lang('[[Einladung ohne Bestaetigung]]');

		if ($this->_frm->appExists('addr')) {
			$fValues['b_1024']=$this->_T->lang('[[Einladung Externe Personen]]');
		}
		$fValues['b_4096']=$this->_T->lang('[[Resourcen]]');
		$fValues['b_512']=$this->_T->lang('[[Benachrichtigungsservice]]');
		if ($this->_frm->appExists('fmng')) {
			$fValues['b_2048']=$this->_T->lang('[[Dateien]]');
		}
		$formGui->setValues($key,$fValues);
		$formGui->setNoMeta($key);

		$key='submit';
		$submitVals=array(
			'meta_save_x'=>$this->_T->lang('[[Speichern]]')
		);
		/*if ($this->_oid) {
			$submitVals['meta_delete_x']=$this->_T->lang('[[Loeschen]]');
			$formGui->setValuesAttribs($key,'meta_delete_x',array('onclick'=>'return lo_form();'));
		}*/
		$formGui->addField($key,'submit','','','form_submit');
		$formGui->setValues($key,$submitVals);

		if (Framework::getParam('meta_delete_x','0','P')) {
			$this->_BaseCat->deleteObj($this->_Obj);
			$this->_L->unsetParam('oid');
			$this->_L->setParam('action','b');
			$this->_L->goToLink();
		}
		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {

				$ObjTrans=array();
				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans[$val]=$formGui->getFieldVal('Trans['.$this->_frm->getLang().']');
					}
				} else {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans[$val]=$formGui->getFieldVal('Trans['.$val.']');
					}
				}
				if (!is_object($this->_Obj)) {
					$this->_Obj=new ObjCalCategory();
				}
				$this->_Obj->setMeta('calCatTest',0);
				$this->_Obj->setMeta('calCatNoConflict',0);
				$formGui->addMetaToObj($this->_Obj);
				if ($this->_Obj->getMeta('calCatNoConflict')) {
					$this->_Obj->setMeta('calCatTest',1);
				}
				$this->_Obj->setTrans('calCatName',$ObjTrans);

				$settings=array();
				if ($formGui->getFieldVal('cat_settings_1')) {
					$settings=array_merge($settings,$formGui->getFieldVal('cat_settings_1'));
				}
				if ($formGui->getFieldVal('cat_settings_2')) {
					$settings=array_merge($settings,$formGui->getFieldVal('cat_settings_2'));
				}
				$catView=0;
				foreach ($settings as $val) {
					if ($val[0]=='b') {
						$catView+=intval(substr($val,2));
					} else {
						$this->_Obj->setMeta($val,1);
					}
				}
				$this->_Obj->setMeta('calCatView',$catView);
				if ($this->_oid) {
					$this->_BaseCat->updateObj($this->_Obj);
					$this->_L->unsetParam('oid');
					$this->_L->goToLink();
				} else {
					$this->_oid=$this->_BaseCat->insertObj($this->_Obj);
					$this->_L->setParam('action','n');
					$this->_L->goToLink();
				}
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}

	function &listResources() {

		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		require_once('lib/class_ApplicationListGui.php');
		$entries=$this->_BaseRes->listObj();
		$Gui=new ApplicationListGui();
		$Gui->setName($this->_T->lang('[[Resourcen]]'));
		$Gui->addHeaderCol('calResName',$this->_T->lang('[[Titel]]'),'','','',0,2000);
		$Gui->addHeaderCol('calResAmount',$this->_T->lang('[[Anzahl]]'),'','','',1);
		$Gui->addHeaderCol('calResCheck',$this->_T->lang('[[Auf Konflikte testen]]'),'','','',1);
		$Gui->addHeaderCol('calResNoConflict',$this->_T->lang('[[Keine Konflikte zulassen]]'),'','','',1);
		$Gui->addHeaderCol('calResUseCal',$this->_T->lang('[[In Kalender verwenden]]'),'','','',1);
		$Gui->addHeaderCol('calResUseZef',$this->_T->lang('[[In Zeiterfassung verwenden]]'),'','','',1);
	
		foreach ($entries as $key=>$val) {
			$Gui->addRow(($hl?$hl=0:$hl=1),'top');
			$Gui->addCol('calResName',$val->getMeta('calResName'),'',$this->_L->getTempLink(null,array('oid'=>$key,'action'=>'n')),'','0',2000);
			/*$tmp_groups=array();
			foreach ($val['zefUsers'] as $uid) {
				$tmp_groups[]=$this->_frm->getCachedUserName($uid);
			}
			foreach ($val['zefGroups'] as $gid) {
				$tmp_groups[]=$this->_frm->getCachedGroupName($gid);
			}
			$Gui->addCol('Perms',implode(', ',$tmp_groups),'','','','0',2000);*/
			$Gui->addCol('calResAmount',$val->getMeta('calResAmount')?$val->getMeta('calResAmount'):1,'','','','1');
			$Gui->addCol('calResCheck',$val->getMeta('calResCheck')?'X':'','','','center','1');
			$Gui->addCol('calResNoConflict',$val->getMeta('calResNoConflict')?'X':'','','','center','1');
			$Gui->addCol('calResUseCal',$val->getMeta('calResUseCal')?'X':'','','','center','1');
			$Gui->addCol('calResUseZef',$val->getMeta('calResUseZef')?'X':'','','','center','1');
		}
		return $Gui;
		
	}
	
	function &newResourcesEntry() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_oid) {
			$Gui->setName($this->_T->lang('[[Neuer Eintrag]]'));
		} else {
			$Gui->setName($this->_T->lang('[[Eintrag bearbeiten]]'));
			$tabs[]='perms';
			$tabs[]='crm';
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'|calResTab');
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getResourcesMetaGui());
		}

		if (in_array('crm',$tabs) && ($content=$this->getResourcesCrmGui())) {
			$box->addTab('crm',$this->_T->lang('[[Attribute]]'),'#',true);
			$box->setTabContent('crm',$content);
		}
		if (in_array('perms',$tabs)) {
			$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
			$box->setTabContent('perms',$this->getResourcesPermsGui());
		}


		
		$show_tap=$this->getPrefs('calResTab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));

		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getResourcesCrmGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/uform/class_UserFormShowGui.php');

		$UserFormShowGui=new UserFormShowGui();
		$UserFormShowGui->loadSystemObj('cal_res');
		if ($this->_Obj) {
			$UserFormShowGui->loadDefault($this->_Obj->getID());
		}
		if ($UserFormShowGui->hasSimpleGroups()) {
			$tplContent=new TemplateGui('core/common_simple_content.inc.html');
			$formGui=new FormGui();
			$formGui->addField('uform_save_x','submit','',$this->_T->lang('[[Speichern]]'),'fields3');
			//$this->_UserFormFieldsGui->loadSystemObj('cal_res');
			$tplContent->addContent('form_1',$UserFormShowGui,'CONTENT',array());
			$tplContent->addContent('form_2',$formGui,'CONTENT',array());

			if (Framework::getParam('uform_save_x',0)) {
				//$fGui->checkFields();
				if (!$this->_E->isError()) {
					$Values=$UserFormShowGui->getDbValues('uf_cal_res_'.$this->_Obj->getID());
					//debug($Values);
					$Values['FKModul']='cal';
					$UserFormShowGui->updateData($this->_Obj->getID(),$Values);
				}
			}
		} else {
			$tplContent=false;
		}
		return $tplContent;
	}
	function &getResourcesMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		$defTrans=array();
		if (Framework::getParam('isset_oneLang',0,'P')) {
			$defOneLang=Framework::getParam('oneLang',0,'P');
		} elseif ($this->_Obj) {
			$defOneLang=1;
			$defTrans['calResName']=$this->_Obj->getTrans('calResName');
			$defTrans['calResText']=$this->_Obj->getTrans('calResText');
			foreach ($this->_frm->getMaLang() as $lang) {
				if ($defTrans['calResName'][$lang]!=$defTrans['calResName'][$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
				if ($defTrans['calResText'][$lang]!=$defTrans['calResText'][$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
			}

		} else {
			$defOneLang=1;
		}
		foreach ($this->_frm->getMaLang() as $lang) {
			$key1='Trans[calResName]['.$lang.']';
			$formGui->addField($key1,'text',$this->_T->lang('[[Name]]').' '.strtoupper($lang),$defTrans['calResName'][$lang],'form_fields1');
			$formGui->setNoMeta($key1);
			$key2='Trans[calResText]['.$lang.']';
			$formGui->addField($key2,'area',$this->_T->lang('[[Beschreibung]]').' '.strtoupper($lang),$defTrans['calResText'][$lang],'form_fields1');
			$formGui->setAttribs($key2,array('rows'=>3));
			$formGui->setNoMeta($key2);

			if ($lang!=$this->_frm->getLang()) {
				if ($defOneLang) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key1,$attribs);
					$formGui->setAttribs($key2,$attribs);
				} else {
					$formGui->setRequired($key1);
				}
			} else {
				$formGui->setRequired($key1);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'form_fields1');
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $lang2) {
					if ($lang2!=$lang) {
						$attribs['onchange'].="disableEnable('Trans[calResName][".$lang2."]',this,this.checked?0:1);";
						$attribs['onchange'].="disableEnable('Trans[calResText][".$lang2."]',this,this.checked?0:1);";
					}
				}
				//debug($attribs);
				$formGui->setAttribs($key,$attribs);
			}
		}
		$key='lb1';
		$formGui->addField($key,'label',$this->_T->lang('[[Optionen]]'),'','form_fields2');

		$key='calResCheck';
		$formGui->addField($key,'check',$this->_T->lang('[[Auf Konflikte testen]]'),$this->_Obj?$this->_Obj->getMeta($key):1,'form_fields2');

		$key='calResNoConflict';
		$formGui->addField($key,'check',$this->_T->lang('[[Keine Konflikte zulassen]]'),$this->_Obj?$this->_Obj->getMeta($key):0,'form_fields2');

		$key='calResUseCal';
		$formGui->addField($key,'check',$this->_T->lang('[[In Kalender verwenden]]'),$this->_Obj?$this->_Obj->getMeta($key):0,'form_fields2');
		$key='calResUseZef';
		$formGui->addField($key,'check',$this->_T->lang('[[In Zeiterfassung verwenden]]'),$this->_Obj?$this->_Obj->getMeta($key):0,'form_fields2');

		$key='calResAmount';
		$formGui->addField($key,'int',$this->_T->lang('[[Anzahl]]'),($this->_Obj && $this->_Obj->getMeta($key))?$this->_Obj->getMeta($key):1,'form_fields2');


/*
		$key="calResNotify";
		$default=($this->_Obj && $this->_Obj->getMeta($key))?('u_'.implode('|u_',explode(',',$this->_Obj->getMeta($key)))):'';
		$mode='u';
		$params=base64_encode(serialize(array()));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Benachrichtigungsservice]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_InvitU=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_InvitU,$default,'form_fields2');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));
		$formGui->setNoMeta($key);
*/

		
		
		$key='submit';
		$submitVals=array(
			'meta_save_x'=>$this->_T->lang('[[Speichern]]')
		);

		$formGui->addField($key,'submit','','','form_submit');
		$formGui->setValues($key,$submitVals);

		if (Framework::getParam('meta_delete_x','0','P')) {
			$this->_BaseRes->deleteObj($this->_Obj);
			$this->_L->unsetParam('oid');
			$this->_L->setParam('action','b');
			$this->_L->goToLink();
		}
		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {

				$ObjTrans=array();
				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans['calResName'][$val]=$formGui->getFieldVal('Trans[calResName]['.$this->_frm->getLang().']');
						$ObjTrans['calResText'][$val]=$formGui->getFieldVal('Trans[calResText]['.$this->_frm->getLang().']');
					}
				} else {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans['calResName'][$val]=$formGui->getFieldVal('Trans[calResName]['.$val.']');
						$ObjTrans['calResText'][$val]=$formGui->getFieldVal('Trans[calResText]['.$val.']');
					}
				}
				if (!is_object($this->_Obj)) {
					$this->_Obj=new ObjCalResource();
				}
				$formGui->addMetaToObj($this->_Obj);
				if ($this->_Obj->getMeta('calResNoConflict')) {
					$this->_Obj->setMeta('calResCheck',1);
				}
				
				if ($formGui->fieldExists('calResNotify') && $formGui->getFieldVal('calResNotify',1)) {
					$notifyUsers=array();
					$tmp=explode('|',$formGui->getFieldVal('calResNotify',1));
					foreach ($tmp as $val) {
						$notifyUsers[]=substr($val,2);
					}
					$this->_Obj->setMeta('calResNotify',implode(',',$notifyUsers));
				} else {
					$this->_Obj->setMeta('calResNotify','');
				}

				$this->_Obj->setTrans('calResName',$ObjTrans['calResName']);
				$this->_Obj->setTrans('calResText',$ObjTrans['calResText']);

				if ($this->_oid) {
					$this->_BaseRes->updateObj($this->_Obj);
					$this->_L->unsetParam('oid');
					$this->_L->setParam('action','b');
					$this->_L->goToLink();
				} else {
					$this->_oid=$this->_BaseRes->insertObj($this->_Obj);
					$this->_L->setParam('action','n');
					$this->_L->setParam('oid',$this->_oid);
					$this->_L->setParam('_clTab','perms');
					$this->_L->goToLink();
				}
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}
	function &getResourcesPermsGui() {
		require_once('lib/class_PermsGui.php');
		$permsGui=new PermsGui();
		$guiCfg=array(
			'avPerms'=>array(2=>$this->_T->Lang('[[Schreiben]]')),
			'onlyApp'=>'cal',
		);
		$permsGui->setGuiCfg($guiCfg);
		$permsGui->setAktPerms('Groups',$this->_Obj->getMeta('calResPermsGroup'));
		$permsGui->setAktPerms('Users',$this->_Obj->getMeta('calResPermsUser'));
		if ($permsGui->handleRequest()) {
			$this->_Obj->setMeta('calResPermsGroup',$permsGui->getAktPerms('Groups'));
			$this->_Obj->setMeta('calResPermsUser',$permsGui->getAktPerms('Users'));
			$this->_BaseRes->updateObj($this->_Obj);
			$this->_L->goToLink();
		}
		return $permsGui->getPermsGui();
	}



	function showAdmin() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');

		$Gui->setName($this->_T->lang('[[Datenpflege]]'));

		$formGui=new FormGui();
		$formGui->addField('mLabel','label',$this->_T->lang('[[Eintraege loeschen, die aelter sind als]]'),'','field_l');
		$formGui->setIptAttribs('mLabel',array('style'=>'text-align:right;display:block;width:300px;'));

		$formGui->addField('numMonth','int',$this->_T->lang('[[Monate]]'),6,'field_r');
		$formGui->setAttribs('numMonth',array('style'=>'width:50px;'));
		$formGui->setRequired('numMonth');

		$formGui->addField('meta_delete_x','submit','',$this->_T->lang('[[Loeschen]]'),'field_c');
		$formGui->setAttribs('meta_delete_x',array(
			'onclick'=>"return confirm('".$this->_T->lang('[[Attention_cal_delete]]')."')",
		));

		if (Framework::getParam('meta_delete_x',0,'P')) {
			$month=$formGui->getFieldVal('numMonth');
			if (intval($month)>0) {
				$delTime=mktime(0,0,0,date('m')-$month,date('d'),date('Y'));
				$numDel=$this->_Base->deleteDateEvents($delTime);
				$this->_E->setError('ok_num_del');
				$this->_E->setErrorMsg('ok_num_del',str_replace('{ERROR_MSG}',intval($numDel),$this->_T->lang('[[error_ok_num_del]]')));
				$this->_E->setTyp(1);
			} else {
				$this->_E->setError('fields','numMonth');
			}
		}



		$tplForm=new TemplateGui('core/form_3columns.inc.html');
		$tplForm->addContent('form1',$formGui,'FORM1',array('','field_l'));
		$tplForm->addContent('form2',$formGui,'FORM2',array('','field_r'));
		$tplForm->addContent('form3_1',$formGui,'FORM3',array('','field_c'));

		$box=new BoxGui($this->_Base->getModul().'|calAdminNull');
		$box->addTab('admin',$this->_T->lang('[[Datenpflege]]'),'#',true);
		$box->setTabContent('admin',$tplForm);
		$box->setTabOn('admin');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}

	function showPerms() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$Gui->setName($this->_T->lang('[[Rechte bearbeiten]]'));

		$box=new BoxGui($this->_Base->getModul().'|calAdminNull');
		$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
		$box->setTabContent('perms',$this->getPermsGui());
		$box->setTabOn('perms');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}

	function &getPermsGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_ApplicationListGui.php');

		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		$key='addPermsFrom';
		$mode='u|g';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);

		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,'','fields1');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));
		$formGui->setNoMeta($key);

		$avPerms=array(
			1=>'(r) '.$this->_T->lang('[[Lesen]]'),
			2=>'(w) '.$this->_T->lang('[[Schreiben]]'),
			4=>'(d) '.$this->_T->lang('[[Loeschen]]'),
		);
		$avPermsShort=array(
			1=>'(r)',
			2=>'(w)',
			4=>'(d)',
		);

		$formGui->addField('addPermsID','checklist_h',$this->_T->lang('[[Rechte]]'),0,'fields1');
		$formGui->setValues('addPermsID',$avPerms);

/*
		$key='lbl1';
		$formGui->addField($key,'label',$this->_T->lang('[[auf Kalender von]]'),'','fields1');
*/

		$key='addPermsTo';
		$mode='u|g';
		$params='';

		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[auf Kalender von]]'). ' : '.$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);

		/*
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[auf Kalender von]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);*/
		

		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,'','fields1');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));
		$formGui->setNoMeta($key);

		$formGui->addField('perms_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields3');





		if (Framework::getParam('perms_add',0,'P') && Framework::getParam('addPermsID',0,'P') && trim($formGui->getFieldVal('addPermsFrom')) && trim($formGui->getFieldVal('addPermsTo'))) {
			$permsFrom=explode('|',$formGui->getFieldVal('addPermsFrom'));
			$permsTo=explode('|',$formGui->getFieldVal('addPermsTo'));
			foreach ($permsFrom as $val) {
				$fid=substr($val,2);
				if ($val[0]=='g') {
					$typ='group';
				}
				if ($val[0]=='u') {
					$typ='user';
				}
					//debug($permsTo);
				foreach($permsTo as $toVal) {
					if ($toVal[0]=='g') {
						$toID='@'.substr($toVal,2);
					}
					if ($toVal[0]=='u') {
						$toID=substr($toVal,2);
					}
					//debug($toID);
				    $this->_Base->insertPerms($fid,array($toID=>array_sum(Framework::getParam('addPermsID',0,'P'))),$typ);
				}
			}
			$this->_L->goToLink();
		}


		if(is_array(Framework::getParam('permDeleteG_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteG_x',0,'P'));
			$tmp=explode('_',$key);
			if (intval($tmp[0]) && trim($tmp[1])) {
				$this->_Base->deletePerms($tmp[0],$tmp[1],'group');
			}
		}
		if(is_array(Framework::getParam('permDeleteU_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteU_x',0,'P'));
			$tmp=explode('_',$key);
			if (intval($tmp[0]) && trim($tmp[1])) {
				$this->_Base->deletePerms($tmp[0],$tmp[1],'user');
			}
		}



		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tabGui->setGroupFields(array('Name'));

		$tabGui->addHeaderCol('Name',$this->_T->lang('[[BenutzerInnen]]').'/'.$this->_T->lang('[[Gruppen]]'),'','','',1,'',2);
		//$tabGui->addHeaderCol('PermsOn',$this->_T->lang('[[auf Kalender von]]'),'','','',1,'',2);

		foreach ($avPermsShort as $pkey=>$pval) {
			$tabGui->addHeaderCol('Perms_'.$pkey,$pval,'','','',1);
		}
		$tabGui->addHeaderCol('Delete','','tras.gif');
		$tabGui->setLimit(0);

		$perms_g=$this->_Base->getAllPerms('group');
		$perms_u=$this->_Base->getAllPerms('user');

		//debug($perms_g);

		//debug($perms_u[16]);

		
		$rows=0;$hl=0;
		if (!empty($perms_g)) {
			$perms_users=$this->_frm->getAllGroups(array_keys($perms_g));
			foreach ($perms_users as $id=>$name) {
				foreach ($perms_g[$id] as $uid=>$val) {
					if (!$uid) continue;
					if ($uid[0]=='@') {
						$uname=$this->_frm->getCachedGroupName(substr($uid,1));
						$img='gruppe.gif';
					} else {
						$uname=$this->_frm->getCachedUserName($uid,0,1);
						$img='user.gif';
					}
					if (!$uname) continue;

					$hl=$hl?0:1;
					$tabGui->addRow($hl);
					$tabGui->setRowData(array('GroupValues'=>array('Name'=>$name)));

					$tabGui->addCol('IMG2','',$img);
					$tabGui->addCol('PermsOn',$uname,'','','',0,'2000');

					foreach ($avPermsShort as $pkey=>$pval) {
						$tabGui->addCol('Perms_'.$pkey,($perms_g[$id][$uid]&$pkey)?'X':'','','','center',1);
					}
					$btn=new SubmitImgBtn ('permDeleteG_x['.$id.'_'.$uid.']','img/'.APP_THEME.'/loeschen.gif');
					$tabGui->addCol('Delete',$btn);
				}
			}
		}
		if (!empty($perms_u)) {
			$perms_users=$this->_frm->getFullName(array_keys($perms_u),0,1);
			//debug($perms_users);
			foreach ($perms_users as $id=>$name) {
				
				//$perms_to=$this->_frm->getFullName(array_keys($perms_u[$id]),0,1);
				foreach ($perms_u[$id] as $uid=>$val) {
					if (!$uid) continue;
					if ($uid[0]=='@') {
						$uname=$this->_frm->getCachedGroupName(substr($uid,1));
						$img='gruppe.gif';
					} else {
						$uname=$this->_frm->getCachedUserName($uid,0,1);
						$img='user.gif';
					}
					if (!$uname) continue;

					$hl=$hl?0:1;
					$tabGui->addRow($hl);
					$tabGui->setRowData(array('GroupValues'=>array('Name'=>$name)));
					$tabGui->addCol('IMG2','',$img);
					$tabGui->addCol('PermsOn',$uname,'','','',0,'2000');

					foreach ($avPermsShort as $pkey=>$pval) {
						$tabGui->addCol('Perms_'.$pkey,($val&$pkey)?'X':'','','','center',1);
					}
					$btn=new SubmitImgBtn ('permDeleteU_x['.$id.'_'.$uid.']','img/'.APP_THEME.'/loeschen.gif');
					$tabGui->addCol('Delete',$btn);
				}
			}
		}




		//debug($perms_g);
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3_1',$formGui,'FORM3',array('','fields3'));
		$tplContent->addContent('form3_2',$tabGui,'FORM3');
		/*
		$f33=$this->listPerms('PermsUser',($perms_u),$avPermsShort,1);
		$tplContent->addContent('form3_3',$f33,'FORM3');*/
		return $tplContent;
	}
	function &listTimeTree() {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		$tabGui->addHeaderCol('Name',$this->_T->lang('[[Zeitvorlagen]]'),'','','','','',2);
		$entries=$this->_BaseTime->listObj();
		foreach ($entries as $key=>$val) {
			if ($key==$this->_oid) {
				$hl=2;
			} else {
				$hl=0;
			}
			$tabGui->addRow($hl);
			$tabGui->addCol('IMG','','obj_img/ex_tree.gif');
			$tabGui->addCol('Name',$val->getName(),'',$this->_L->getTempLink(null,array('oid'=>$key,'action'=>'n')),'',0,'2000');
		}
		return $tabGui;
	}
	function &newTimeEntry() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_oid) {
			$Gui->setName($this->_T->lang('[[Neuer Eintrag]]'));
		} else {
			$Gui->setName($this->_T->lang('[[Eintrag bearbeiten]]'));
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'|calAdminNull');
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getTimeMetaGui());
		}
		$box->setTabOn('meta');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getTimeMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		$defTrans=array();
		if (Framework::getParam('isset_oneLang',0,'P')) {
			$defOneLang=Framework::getParam('oneLang',0,'P');
		} elseif ($this->_Obj) {
			$defOneLang=1;
			$defTrans=$this->_Obj->getTrans('calTimeName');
			foreach ($this->_frm->getMaLang() as $lang) {
				if ($defTrans[$lang]!=$defTrans[$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
			}
		} else {
			$defOneLang=1;
		}
		foreach ($this->_frm->getMaLang() as $lang) {
			$key='Trans['.$lang.']';
			$formGui->addField($key,'text',$this->_T->lang('[[Name]]').' '.strtoupper($lang),$defTrans[$lang],'form_fields1');
			$formGui->setNoMeta($key);
			if ($lang!=$this->_frm->getLang()) {
				if ($defOneLang) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key,$attribs);
				} else {
					$formGui->setRequired($key);
				}
			} else {
				$formGui->setRequired($key);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'form_fields1');
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $lang2) {
					if ($lang2!=$lang) $attribs['onchange'].="disableEnable('Trans[".$lang2."]',this,this.checked?0:1);";
				}
				//debug($attribs);
				$formGui->setAttribs($key,$attribs);
			}
		}
		$defSettings=$this->_Obj?unserialize($this->_Obj->getMeta('calTimeSettings')):array();
		$key='calTimeSettings[starttime]';
		$formGui->addField($key,'unixdate',$this->_T->lang('[[Beginn]]'),$defSettings['starttime'],'form_fields2');
		$formGui->setNoMeta($key);
		$formGui->setRequired($key);
		$key='calTimeSettings[endtime]';
		$formGui->addField($key,'unixdate',$this->_T->lang('[[Ende]]'),$defSettings['endtime'],'form_fields2');
		$formGui->setNoMeta($key);
		$formGui->setRequired($key);

		/*$key='calTimeSettings[view]';
		$formGui->addField($key,'checklist_v',$this->_T->lang('[[Ende]]'),$defSettings['endtime'],'form_fields2');
		$formGui->setNoMeta($key);
		$formGui->setRequired($key);*/

		/*$key='calTimeView';
		$formGui->addField($key,'checklist_v',$this->_T->lang('[[Optionen]]'),'','form_fields2');
		$formGui->addField($key,'checklist_v',$this->_T->lang('[[Optionen]]'),'','form_fields2');
		$formGui->setNoMeta($key);
		$formGui->setRequired($key);*/




		$key='submit';
		$submitVals=array(
			'meta_save_x'=>$this->_T->lang('[[Speichern]]')
		);
		/*if ($this->_oid) {
			$submitVals['meta_delete_x']=$this->_T->lang('[[Loeschen]]');
			$formGui->setValuesAttribs($key,'meta_delete_x',array('onclick'=>'return lo_form();'));
		}*/
		$formGui->addField($key,'submit','','','form_submit');
		$formGui->setValues($key,$submitVals);

		if (Framework::getParam('meta_delete_x','0','P')) {
			$this->_BaseTime->deleteObj($this->_Obj);
			$this->_L->unsetParam('oid');
			$this->_L->setParam('action','b');
			$this->_L->goToLink();
		}
		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {

				$ObjTrans=array();
				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans[$val]=$formGui->getFieldVal('Trans['.$this->_frm->getLang().']');
					}
				} else {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans[$val]=$formGui->getFieldVal('Trans['.$val.']');
					}
				}
				if (!is_object($this->_Obj)) {
					$this->_Obj=new ObjCalTime();
				}
				$formGui->addMetaToObj($this->_Obj);
				$this->_Obj->setTrans('calTimeName',$ObjTrans);

				$calTimeSettings=array();
				$calTimeSettings['type']='abs';
				$calTimeSettings['starttime']=$formGui->getFieldVal('calTimeSettings[starttime]');
				$calTimeSettings['endtime']=$formGui->getFieldVal('calTimeSettings[endtime]');
				$this->_Obj->setMeta('calTimeSettings',serialize($calTimeSettings));


				if ($this->_oid) {
					$this->_BaseTime->updateObj($this->_Obj);
					$this->_L->unsetParam('oid');
					$this->_L->goToLink();
				} else {
					$this->_oid=$this->_BaseTime->insertObj($this->_Obj);
					$this->_L->setParam('action','n');
					$this->_L->goToLink();
				}
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}



	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result) $result=$default;
		return $result;
	}

}
?>