<?php
class ObjCalCategory extends baseObj {
	var $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['calCatName'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class CalCategory extends ObjCore {
	var $_modul='cal';
	var $_table='CalCategory';
	var $_cfgObjects=array (
		'IdField'=>'calCatID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'TranslationFields'=>array('calCatName'),
		'0'=>array(
			'ClassName'=>'ObjCalCategory',
			'Fields'=>array(
				'calCatID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'calCatName'=>array(
					'Typ'=>'core',
				),
				'calCatTest'=>array(
					'Typ'=>'core',
				),
				'calCatNoConflict'=>array(
					'Typ'=>'core',
				),
				'calCatView'=>array(
					'Typ'=>'core',
				),
				'calCatDeleted'=>array(
					'Typ'=>'core',
				),
			),
		),
	);

	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','cal')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function insertObj(&$Obj) {
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		$Obj->setMeta('calCatDeleted',1);
		return $this->updateObj($Obj);
	}
	function listObj($all=false,$calCatTest=false) {
		$searchQuery=array();
		if (!$all) $searchQuery[]=array('Field'=>'calCatDeleted','Typ'=>'=','Values'=>0);
		if ($calCatTest) $searchQuery[]=array('Field'=>'calCatTest','Typ'=>'=','Values'=>1);
		$rows=0;
		return $this->searchObj($rows,$searchQuery,'CalCategory.calCatName ASC');
	}
	function catName2ID($name) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'CalCategory.calCatName','Typ'=>'regexp','Values'=>'^'.str_replace(' ','[,;. ]',preg_quote($name,'')).'$');
		return $this->searchSingleObj($searchQuery);
	}
}
?>
