<?php
class CalMaintenanceGui {
	private $_Base;
	private $_Obj;
	private $_T;
	private $_t;
	private $_frm;
	private $_L;
	private $_E;
	private $_checks;
	function __construct() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_BaseCat=& $frm->getStaticModul('cal_cat');
		$this->_T=&$T;
		$this->_T->loadModul('cal');
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		if (is_object($P)) $this->_P=&$P;
		$this->_checks=array(
			'1'=>array(
				'n'=>$this->_T->lang('[[Datum]]').','.$this->_T->lang('[[Uhrzeit]]').','.$this->_T->lang('[[Titel]]'),
				'f'=>array('StartDate','StartTime','EndDate','EndTime','Title'),
			),
			'2'=>array(
				'n'=>$this->_T->lang('[[Datum]]').','.$this->_T->lang('[[Uhrzeit]]').','.$this->_T->lang('[[Ort]]'),
				'f'=>array('StartDate','StartTime','EndDate','EndTime','Place'),
			),
			'3'=>array(
				'n'=>$this->_T->lang('[[Datum]]').','.$this->_T->lang('[[Uhrzeit]]'),
				'f'=>array('StartDate','StartTime','EndDate','EndTime'),
			),
			'4'=>array(
				'n'=>$this->_T->lang('[[Datum]]').','.$this->_T->lang('[[Ort]]'),
				'f'=>array('StartDate','Place'),
			),
			'5'=>array(
				'n'=>$this->_T->lang('[[Datum]]').','.$this->_T->lang('[[Titel]]'),
				'f'=>array('StartDate','Title'),
			),
		);
		$this->_roots=array(
			'p'=>$this->_T->lang('[[Privatkalender]]'),
			'i'=>$this->_T->lang('[[Teamkalender]]'),
		);
		$this->_cat=$this->_BaseCat->listObj();
	}
	function _handleRequest() {

	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
	function process() {
		if (!Framework::getParam('search_x','','P')) {
			$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpDubSearch',1,0);
		}
		if (Framework::getParam('_del',0,'G') && ($evtVal=$this->_Base->readEvent(Framework::getParam('_del',0,'G'))) && !$evtVal['_Privat'] && $evtVal['OwnerID']==$this->_Base->getUser() && $this->_Base->getCalPerms(2)) {
			$this->_Base->deleteEventObject($evtVal,false);
		}
		if (Framework::getParam('mai_action_x',0,'P') && Framework::getParam('mai_action_val',0,'P') && Framework::getParam('ListID',array(),'P')) {
			require_once ('lib/addr/func_Action.php');
			switch(Framework::getParam('mai_action_val',0,'P')) {
				case 'delete':
					foreach (Framework::getParam('ListID',array(),'P') as $key=>$val) {
						$evtVal=$this->_Base->readEvent($val);
						if ($evtVal && !$evtVal['_Privat'] && $evtVal['OwnerID']==$this->_Base->getUser() && $this->_Base->getCalPerms(2)) {
							$this->_Base->deleteEventObject($evtVal,false);
						}
					}
				break;
			}
		}
		//debug($_POST);
		require_once('lib/class_TemplateGui.php');
		$TopGui=new TemplateGui('core/common_form.inc.html');
		require_once('lib/class_ApplicationTreeGui.php');
		$TreeGui=new ApplicationTreeGui();

		$cfgGui=& $this->getConfigGui($rootU);
		$TreeGui->addTreeContent($cfgGui);

		$listGui=& $this->getListGui();
		$TreeGui->addContent($listGui);

		$TopGui->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
		$TopGui->addContent('cont1',$TreeGui,'CONTENT');
		return $TopGui->process();
	}
	function &getListGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_FormFieldsCore.php');
		$navLink=Framework::cloneObj($this->_L);

		$attribs=array(
			'onclick'=>'return false;',
		);
		$btnList=new CheckBoxBtn ('ListID[]','');
		$btnList->setAttribs($attribs);

		$fields=$this->_checks[$this->_search['cid']]['f'];
		$search=array(
			'StartDate'=>time(),
			'UserID'=>$this->_search['croot']=='p'?$this->_Base->getUser():0,
			'CatID'=>$this->_search['CatID'],
			'TimeMode'=>$this->_search['TimeMode'],
		);
		//debug($search);
		$entries=$this->_Base->searchDublicate($fields,$search);
		$b=0;
		$rows=count($entries);

//debug($entries);
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		$Gui=new ApplicationListGui();
		$Gui->setGroupFields(array('gname'),true);
		$funcAction=new FunctionObjActionGui('mai_action',1);
		$funcAction->setName($this->_T->lang('[[Ausgewaehlte Events]]'));
		$funcAction->addValue('delete',$this->_T->lang('[[Loeschen]]'));
		$Gui->addFunction($funcAction);
		$Gui->setAutoBg(APP_FG10COLOR);
		$Gui->setID('addrTab');
		$Gui->setTrOver('trBOC({ROW},this);');
		$Gui->setTrDown('trBOI({ROW},this,1);');		$this->_frm->addOnLoad("disableSelection(document.getElementById('addrTab'));");
		$Gui->setRowClass(array('list_l','list_b','list_h','list_hb','list_s','list'));
		$Gui->setSumRows($rows);
		$Gui->setBegin($b);

		$Gui->addHeaderCol('Datum',$this->_T->lang('[[Datum]]'),'','','',1,'',3);
		$Gui->addHeaderCol('Time',$this->_T->lang('[[Uhrzeit]]'),'','','',1,'',1);
		$Gui->addHeaderCol('Title',$this->_T->lang('[[Titel]]'),'','','',0,'2000');
		$Gui->addHeaderCol('Ort',$this->_T->lang('[[Ort]]'),'','','',1,'',1);
		$Gui->addHeaderCol('OwnerID',$this->_T->lang('[[Erstellt von]]'),'','','',1,'');
		$Gui->addHeaderCol('del2','#','','','',1,'');

		$r=1;$n=0;
		foreach($entries as $gname=>$ids) {
			$event=$this->_Base->readEvent($ids);
			$hl=($hl?$hl=0:$hl=1);
			$lpos=$r-$n;
			$n=1;
			foreach ($event as $evtVal) {
				$Gui->addRow($hl?2:0,'top','');
				$Gui->setRowData(array('GroupValues'=>array('gname'=>$gname)));
				
				$key='del';
				if (!$evtVal['_Privat'] && $evtVal['OwnerID']==$this->_Base->getUser() && $this->_Base->getCalPerms(2)) {
					$Gui->addCol($key,$btnList->process($evtVal['EventID']),'','','',1,'1%',0,'',$noEnc);
				} else {
					$Gui->addCol($key,'','','','',0,'1%',0,'',$colAttribs);
				}
				$this->_addRow($Gui,$evtVal);

				$key='del2';
				if (!$evtVal['_Privat'] && $evtVal['OwnerID']==$this->_Base->getUser() && $this->_Base->getCalPerms(2)) {
					$btDel=new FunctionButtons($key.'_'.$evtVal['EventID'],'button_link',array('TITLE'=>$this->_T->lang('[[Loeschen]]'),'LINK'=>"javascript:lo('".$this->_L->getTempLink(null,array('_del'=>$evtVal['EventID']))."#row_".$lpos."');",'TARGET'=>''));
					$Gui->addCol($key,$btDel,'','','',0,'1%',0,'',$colAttribs);
				} else {
					$Gui->addCol($key,'','','','',0,'1%',0,'',$colAttribs);
				}
				$n++;
				$r++;
			}
		};
		return $Gui;
	}
	function _addRow($Gui,$evtVal) {
		$link='index.php?site=cal.php&action=view&view=event&back=0&event_id=';
		$params=array();
		if ($evtVal['Unsecure']) {
			$params['style'].='font-style:italic;';
		}
		if (!$evtVal['_Privat'] && $evtVal['OwnerID']==$this->_Base->getUser() && $this->_Base->getCalPerms(2)) {
			$params['LinkAttribs']['onclick']='return goToView(this);';
			$params['LinkAttribs']['ondblclick']='return goToEdit(this,\'action=view\',\'action=edit&back=0\');';
		}
		$Gui->addCol('DatumB',date('d.m.Y',$evtVal["StartDate"]).' - '.date('d.m.Y',$evtVal["EndDate"]),'','','',1,'',0,'',$params);
		$Gui->addCol('Rec','',($evtVal['RecType']?'wiederholungstermin.gif':''),'','',1,'',0,'',$params);
		$Gui->addCol('Time',$evtVal['TimeMode']?'':(date('H:i',$evtVal["StartDate"]).' - '.date('H:i',$evtVal["EndDate"])),'','','',1,'',0,'',$params);
		if (!$evtVal['TimeMode']) {
			$dur=($evtVal["EndDate"]-$evtVal["StartDate"])/60;
		} else {
			$dur=0;
		}
		$Gui->addCol('Title',$evtVal['Title'],'',$link.$evtVal['EventID'],'',0,'',0,'',$params);
		$Gui->addCol('Ort',$evtVal['Place'],'','','',0,'',0,'',$params);
		$Gui->addCol('OwnerID',$this->_frm->getCachedUserName($evtVal['OwnerID']),'','','',1,'',0,'',$params);
	}
	function &getConfigGui($rootObj) {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');

		$Gui=new TemplateGui('core/common_content_border.inc.html');
		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key='cid';
		$formGui->addField($key,'select',$this->_T->lang('[[Filter]]'),isset($this->_search[$key])?$this->_search[$key]:key($this->_checks),'fields1');
		$formGui->setValues($key,FrameWork::extractArrayMeta($this->_checks,'n'));

		$key="CatID";
		$formGui->addField($key,'select',$this->_T->lang('[[Art des Termins]]'),isset($this->_search[$key])?$this->_search[$key]:'','fields1');
		$formGui->setValues($key,array(0=>$this->_T->lang('[[Alle]]')) + $this->_frm->extractObjName($this->_cat));

		$key="TimeMode";
		$timemode_array=array(0=>$this->_T->lang('[[mit Uhrzeit]]'),1=>$this->_T->lang('[[ohne Uhrzeit]]'),2=>$this->_T->lang('[[ganzen Tag]]'));
		$formGui->addField($key,'checklist_v',$this->_T->lang('[[Uhrzeit]]'),isset($this->_search[$key])?$this->_search[$key]:array(1,2,0),'f_deftime');
		$formGui->setValues($key,$timemode_array);

		$key='croot';
		$formGui->addField($key,'radiolist_v',$this->_T->lang('[[Kalender]]'),isset($this->_search[$key])?$this->_search[$key]:key($this->_roots),'fields1');
		$formGui->setValues($key,$this->_roots);
		
		
		$submit_array=array(
			'search_x'=>' '.$this->_T->lang('[[Suchen]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','fields1');
		$formGui->setValues($key,$submit_array);

		$this->_search=array();
		$formGui->addMetaToArray($this->_search,'',true);

		$this->_frm->savePostData($this->_Base->getModul(),'tmpDubSearch',null,$this->_search);
		$Gui->addContent('config',$formGui,'CONTENT');

		return $Gui;
	}
}
?>