<?php
class CalPrintGui {
	var $_Base;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_Parameter=array('require'=>array());
	var $_Entries=array();
	var $_printEntries=array();
	var $_options=array(
		'TimeStart'=>0,
		'TimeEnd'=>0,
		'DayBegin'=>0,
		'DayEnd'=>1440,
		'SortCalUser'=>true,
		'TplID'=>'list_w',
		'Require'=>array(),
		'OverlapCfg'=>array(),
	);
	function CalPrintGui($options=array()) {
		global $frm,$t,$T,$E,$L,$P;
		$this->_BaseTpl=& $frm->getStaticModul('print_tpl');
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_BaseCat=& $frm->getStaticModul('cal_cat');
		$this->_BaseRes=& $frm->getStaticModul('cal_res');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_options=array_merge($this->_options,$options);
		$this->_tplPrint=$this->getPrintTemplate($this->getOption('TplID'));
		$this->initTemplate();
	}
	function setOption($key,$val) {
		$this->_options[$key]=$val;
	}
	function getOption($key,$ov=array()) {
		if (isset($ov[$key])) {
			return $ov[$key];
		} else {
			return $this->_options[$key];
		}
	}
	function setEntries($entries,$typ='privat') {
		$this->_Entries[$typ]=$entries;
	}
	function initTemplate() {
		$tplData=implode(file($this->_tplPrint));
		$matches=array();
		if (preg_match_all('/<!--\s*PARAMETER\s*:\s*([^=]+)=\s*"([^"]+)"\s*-->/',$tplData,$matches,PREG_SET_ORDER)) {
			foreach ($matches as $val) {
				if (substr($val[2],0,1)=='[' && substr($val[2],-1,1)==']') {
					$this->setOption($val[1],explode(',',substr($val[2],1,-1)));
				} else {
					$this->setOption($val[1],$val[2]);
				}
			}
		}
		if (in_array('invit_extern',$this->getOption('Require'))) {
			$this->_BaseAddr=& $this->_frm->getStaticModul('addr');
		}
	}
	function printList() {
		require_once('lib/class_MySmartyGui.php');
		$Gui=new MySmartyGui();

		if (in_array('simple_list',$this->getOption('Require'))) {
			$this->formatEntriesSimple();
		} else {
			$this->formatEntries();
		}

		$Gui->assign('cal_Title',$this->getTitles());
		$Gui->assign('cal_Config',$this->_options);
		//debug($this->_printEntries);
		$Gui->assign('cal_Entries',$this->_printEntries);

		$Gui->display($this->_tplPrint);
		exit;
	}
	function printObject() {
		require_once('lib/class_MySmartyGui.php');
		$Gui=new MySmartyGui();

		$Gui->assign('cal_Title',$this->getTitles());
		$Gui->assign('cal_Config',$this->_options);
		$Gui->assign('cal_Event',$this->formatObject($this->_Entries[0],true));
		$Gui->display($this->_tplPrint);
		exit;
	}
	function getTitles() {
		return array(
			'CalPrivat'=>$this->_T->lang('[[Privatkalender]]'),
			'CalTeam'=>$this->_T->lang('[[Teamkalender]]'),
			'Project'=>$this->_T->lang('[[Projekt]]'),
			'ViewWeek'=>$this->_T->lang('[[Wochenansicht]]'),
			'ViewMonth'=>$this->_T->lang('[[Monatsansicht]]'),
			'of'=>$this->_T->lang('[[von]]'),
		);
	}
	function calUserSort($a, $b) {
		if ($a==$b) return 0;
		if ($this->_options['CalUsers'][$a]['Typ']==$this->_options['CalUsers'][$b]['Typ']) {
			return strnatcasecmp($this->_options['CalUsers'][$a]['Name'],$this->_options['CalUsers'][$b]['Name']);
		} else {
			if ($this->_options['CalUsers'][$a]['Typ']=='info') return 1;
			elseif ($this->_options['CalUsers'][$b]['Typ']=='info') return -1;
			elseif ($this->_options['CalUsers'][$a]['Typ']=='g') return 1;
			else return -1;
		}
	}
	function calOverlapSort($a, $b) {
		if ($a['_min_b']==$b['_min_b']) return 0;
		return $a['_min_b']>$b['_min_b']?1:0;

	}
	function formatObject($val) {
		if (in_array('next_recurrence',$this->getOption('Require')) && $val['RecType']) {
			$val['nextRecurrence']=$this->_Base->nextRecurrence(array(
				"StartDate"=>$val['OrigStart']?$val['OrigStart']:$val['StartDate'],
				"EndDate"=>$val['OrigEnd']?$val['OrigEnd']:$val['EndDate'],
				"RecEnd"=>$val['RecEnd'],
				"RecType"=>$val['RecType'],
				"RecInt"=>$val['RecInt'],
				"RecCfg"=>$val['RecCfg'],
				'Exception'=>$val['Exception'],
			), time());
		}
		if (in_array('invit_intern',$this->getOption('Require'))) {
			$InvitGroups=$val['InvitGroups']?explode(',',$val['InvitGroups']):array();
			$InvitUsers=$val['InvitUsers']?explode(',',$val['InvitUsers']):array();
			$val['invitIntern']=$this->_frm->getFullName(array_unique(array_merge($this->_frm->getGroupUsers($InvitGroups),$InvitUsers,array($val['OwnerID']))),0,1);
			$val['invitInternStatus']=$this->_Base->readEventDone($val['EventID'],'u');
			if (!$val['invitInternStatus'][$val['OwnerID']]) $val['invitInternStatus'][$val['OwnerID']]=1;
			foreach ($val['invitInternStatus'] as $uid=>$status) {
				switch($status) {
					case 2:
						$val['invitInternLog'][$uid]=reset($this->_Base->listLog($val['EventID'],array('deny'),$uid));
					break;
					case 1:
						$val['invitInternLog'][$uid]=reset($this->_Base->listLog($val['EventID'],array('accept'),$uid));
					break;
				}
			}
		}
		if (in_array('invit_extern',$this->getOption('Require'))) {
			if ($val['InvitAddr']) {
				$val['invitExtern']=$this->_BaseAddr->getAddrObj(explode(',',$val['InvitAddr']));
			} else {
				$val['invitExtern']=array();
			}
		}
		if (in_array('invit_resources',$this->getOption('Require'))) {
			if ($val['InvitResources']) {
				$val['invitResources']=$this->_BaseRes->getCachedObj(explode(',',$val['InvitResources']));
			} else {
				$val['invitResources']=array();
			}
		}
		if (in_array('logbook',$this->getOption('Require'))) {
			$val['logBook']=$this->_Base->listLog($val['EventID'],'log',0);
		}
		if (in_array('project',$this->getOption('Require'))) {
			$val['Project']=$val['FKProjID']?$this->_P->getCachedObj($val['FKProjID']):'';
		}
		if (in_array('position',$this->getOption('Require')) || in_array('overlap',$this->getOption('Require'))) {
			$val['_min_b']=max($this->getOption('DayBegin'),date('H',$val['StartDate'])*60+date('i',$val['StartDate']));
			$val['_min_e']=min($this->getOption('DayEnd'),date('H',$val['EndDate'])*60+date('i',$val['EndDate']));
			$val['_left']=round(($val['_min_b']-$this->getOption('DayBegin'))/(($this->getOption('DayEnd')-$this->getOption('DayBegin'))/100),3);
			$val['_width']=round(($val['_min_e']-$val['_min_b'])/(($this->getOption('DayEnd')-$this->getOption('DayBegin'))/100),3);
		}

		$val['Owner']=$this->_frm->getCachedUserName($val['OwnerID'],0,1);
		$val['Category']=$this->_BaseCat->getCachedObj($val['FKCatID']);
		$val['Exception']=$val['Exception']?explode(',',$val['Exception']):array();

		if ($val['Owner']!=$this->getOption('CalUserID')) {
			$this->_Base->checkEventViewPerms($val,true);
		}


		return $val;
	}
	function formatEntries() {
		$calcEntries=array();
		$ck=0;
		foreach ($this->_Entries as $evtCalID=>$Events) {
			$dateStart=explode('/',date('j/n/Y',$this->getOption('TimeStart')));
			do {
				$dayTime=mktime(23,59,59,$dateStart[1],$dateStart[0],$dateStart[2]);
				$dayKey=date('j-n-Y',$dayTime);
				$dayKeyPrint=date('Y-m-d',$dayTime);
				if (!isset($this->_printEntries[$dayKeyPrint])) $this->_printEntries[$dayKeyPrint]=array();
				if (!isset($this->_options['OverlapCols'][$dayKeyPrint])) $this->_options['OverlapCols'][$dayKeyPrint]=1;

				if (is_array($Events[$dayKey])) {
					//debug($Events[$dayKey]);
					uasort($Events[$dayKey],array($this->_Base,"daycmp"));
					foreach ($Events[$dayKey] as $key=>$val) {
						if ($evtCalID=='info' && $this->_parsedEvt[$key]) {
							continue;
						} else {
							$this->_parsedEvt[$key]=true;
						}
						//debug($val["EventID"].':'.date('d.m.Y H:i',$val["StartDate"]).'-'.date('d.m.Y H:i',$val["EndDate"]));
						if ($val["EndDate"]>$dayTime) {
							if (!isset($val['OrigStart'])) $val['OrigStart']=$val["StartDate"];
							if (!isset($val['OrigEnd'])) $val['OrigEnd']=$val["EndDate"];

							$newEvt=$val;
							$val["EndDate"]=$dayTime;
							$newEvt["StartDate"]=$dayTime+1;
							$Events[date('j-n-Y',$newEvt["StartDate"])][$key]=$newEvt;
							//debug($newEvt);
							//debug('n'.date('j-n-Y',$newEvt["StartDate"]));
						}
						$val=$this->formatObject($val);

						$this->_printEntries[$dayKeyPrint][$evtCalID][$key]=$val;
						if (in_array('overlap',$this->getOption('Require'))) {
							if ($val['TimeMode']!=1) {
								$calcEntries[$dayKeyPrint][$ck]=array(
									'_min_b'=>$val['_min_b'],
									'_min_e'=>$val['_min_e'],
									'CalID'=>$evtCalID,
									'EvtID'=>$key,
									'key'=>$ck,
								);
								$ck++;
							}
						}

					}
					if (!empty($this->_printEntries[$dayKeyPrint]) && $this->getOption('SortCalUser')) {
						uksort($this->_printEntries[$dayKeyPrint],array($this,"calUserSort"));
					}
				}
				$dateStart[0]+=1;
			} while($dayTime<$this->getOption('TimeEnd'));

		}
		if (in_array('overlap',$this->getOption('Require'))) {
			foreach ($calcEntries as $dayKeyPrint=>$dayEvents) {
				$this->_belegt[$dayKeyPrint]=array();
				uasort($dayEvents,array($this,"calOverlapSort"));
				//debug($dayKeyPrint);
				//debug($dayEvents);
				foreach ($dayEvents as $val) {
					if (!isset($calcEntries[$dayKeyPrint][$val['key']]['_overlap_r'])) $calcEntries[$dayKeyPrint][$val['key']]['_overlap_r']=array();
					$parsed=false;
					if (isset($this->_belegt[$dayKeyPrint][$val['_min_b']])) {
						$akt_pos=count($this->_belegt[$dayKeyPrint][$val['_min_b']]);
						for ($i=0;$i<=count($this->_belegt[$dayKeyPrint][$val['_min_b']]);$i++) {
							if (!isset($this->_belegt[$dayKeyPrint][$val['_min_b']][$i])) {
								if (!$parsed) {
									$akt_pos=$i;
									$parsed=true;
								}
							} else {
								if ($parsed) $calcEntries[$dayKeyPrint][$val['key']]['_overlap_r'][$i]=1;
							}
						}
					} else {
						$akt_pos=0;
					}
					for ($i=$val['_min_b'];$i<=($val['_min_e']);$i++) {
						if (isset($this->_belegt[$dayKeyPrint][$i][$akt_pos-1])) {
							for ($j=$akt_pos-1;$j>=0;$j--) {
								if (isset($calcEntries[$dayKeyPrint][$this->_belegt[$dayKeyPrint][$i][$j]])) {
									$calcEntries[$dayKeyPrint][$this->_belegt[$dayKeyPrint][$i][$j]]['_overlap_r'][$akt_pos]=1;
									$tmpVal=$calcEntries[$dayKeyPrint][$this->_belegt[$dayKeyPrint][$i][$j]];
									$this->_printEntries[$dayKeyPrint][$tmpVal['CalID']][$tmpVal['EvtID']]['_overlap_r']=count($tmpVal['_overlap_r']);
								}
							}
						}
						$this->_belegt[$dayKeyPrint][$i][$akt_pos]=$val['key'];
					}
					$this->_printEntries[$dayKeyPrint][$val['CalID']][$val['EvtID']]['_overlap_l']=$akt_pos;
					$this->_printEntries[$dayKeyPrint][$val['CalID']][$val['EvtID']]['_overlap_r']=count($calcEntries[$dayKeyPrint][$val['key']]['_overlap_r']);
					$this->_options['OverlapCols'][$dayKeyPrint]=max($this->_options['OverlapCols'][$dayKeyPrint],$akt_pos+1);
				}
			}
		}
		//debug($this->_printEntries);
		//exit;
	}
	function formatEntriesSimple() {
		foreach ($this->_Entries as $evtCalID=>$Events) {
			foreach ($Events as $dayKey=>$dayEvt) {
				foreach ($dayEvt as $key=>$val) {
					$val=$this->formatObject($val);
					$this->_printEntries[$evtCalID][]=$val;
				}
			}
		}
		//debug($this->_printEntries);
		//exit;
	}
	function getPrintTemplate($tplID) {
		switch ($tplID) {
			case 'list_w':
				$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/cal/utf8.print_list.inc.html';
			break;
			case 'list_m':
				$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/cal/utf8.print_list.inc.html';
			break;
			case 'list_d':
				$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/cal/utf8.print_list.inc.html';
			break;
			case 'list_g':
				$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/cal/utf8.print_list.inc.html';
			break;
			case 'list_f':
				$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/cal/utf8.print_list_time.inc.html';
			break;
			case 'list_s':
				$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/cal/utf8.print_list_simple.inc.html';
			break;
			case 'view_e':
				$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/cal/utf8.print_object.inc.html';
			break;
			default:
				$tplPrint=realpath($this->_BaseTpl->getPrintTemplate($tplID,1));
			break;
		}
		return realpath($tplPrint);
	}
}
?>