<?php
class CalTrashGui {
	private $_Base;
	private $_BaseRes;
	private $_BaseCat;
	private $_T;
	private $_frm;
	private $_P;
	private $_E;
	private $_options=array(

	);
	function CalTrashGui($options=array()) {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_BaseRes=& $frm->getStaticModul('cal_res');
		$this->_BaseCat=& $frm->getStaticModul('cal_cat');
		$this->_T=&$T;
		$this->_frm=&$frm;
		$this->_P=&$P;
		$this->_L=&$L;
		$this->_E=&$E;
		$this->_options=array_merge($this->_options,$options);
		$this->_T->loadModul('cal');
		$this->_userID=$this->_frm->getUser();
		$this->_cat=$this->_BaseCat->listObj();

	}
	function setOption($key,$val) {
		$this->_options[$key]=$val;
	}
	function getOption($key,$ov=array()) {
		if (isset($ov[$key])) {
			return $ov[$key];
		} else {
			return $this->_options[$key];
		}
	}

	function _handleRequest() {
		$this->_calUser=$GLOBALS['CAL_USER'];
		$this->_date=Framework::getParam('date',time());
		if (!$this->_date) $this->_date=time();
		if (Framework::getParam('_loadSearch',0)) {
			$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpCalSearch',1,0);
		}
		if (Framework::getParam('list_action_x','0','P') && Framework::getParam('list_action_val','0','P')) {
			$list_action=$this->_frm->getObjAction($this->_Base->getModul(),'trash_l');
			switch (Framework::getParam('list_action_val','0','P')) {
				case 'undelete':
					$ListID=Framework::getParam('ListID','0','P');
					foreach ($ListID as $k=>$v) {
						$obj=$this->_Base->readEvent($v);
						if ($this->_Base->isAllowedAction($obj,$list_action[Framework::getParam('list_action_val','0','P')])) {
							$this->_Base->undeleteEvent($v);
							unset($ListID[$k]);
						}
					}
					Framework::importParam(array('ListID'=>$ListID),0,'P');
				break;
				case 'f_delete':
					$ListID=Framework::getParam('ListID','0','P');
					foreach ($ListID as $k=>$v) {
						$obj=$this->_Base->readEvent($v);
						if ($this->_Base->isAllowedAction($obj,$list_action[Framework::getParam('list_action_val','0','P')])) {
							$this->_Base->deleteEvent($v,true);
							unset($ListID[$k]);
						}
					}
					Framework::importParam(array('ListID'=>$ListID),0,'P');
				break;
				default:
					debug(Framework::getParam('list_action_val','0',''));
			}
		}
		
		return true;
	}
	function &process() {
		if ($this->_handleRequest()) {
			require_once('lib/cal/class_CalLayerGui.php');
			$this->_lGui=new CalLayerGui(array());

			require_once('lib/class_TemplateGui.php');
			$TopGui=new TemplateGui('core/common_form.inc.html');

			require_once('lib/class_ApplicationTreeGui.php');
			$TreeGui=new ApplicationTreeGui();

			$cGui=& $this->getConfigGui();
			$TreeGui->addTreeContent($cGui);

			$rGui=& $this->getResultGui();
			$TreeGui->addContent($rGui,null,null);

			$TopGui->addContent('cont1',$TreeGui,'CONTENT');
			$TopGui->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
			return $TopGui;
		}
	}
	function &getConfigGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_DateSelectForm.php');

		$Gui=new TemplateGui('core/common_content_border.inc.html');

		$selDateGui=new DateSelectForm();
		$selDateGui->setAvMode(array(3,8));
		$selDateGui->setMode($this->_search['DateMode']?$this->_search['DateMode']:3);
		$selDateGui->setStartMonths(6);
		$selDateGui->setStartQuarter(2);

		if ($this->_search['StartDate'] || $this->_search['EndDate']) {
			$selDateGui->setDate(array($this->_search['StartDate'],$this->_search['EndDate']));
		} else {
			$selDateGui->setDate(array(0,0));
		}
		$Gui->addContent('dateSelect',$selDateGui->process(),'CONTENT');

		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key="sInfo";
		$formGui->addField($key,'text',$this->_T->lang('[[Suchtext]]'),isset($this->_search['Info'])?$this->_search['Info']:'','fields1');

		$key="sCategory";
		$formGui->addField($key,'select',$this->_T->lang('[[Art des Termins]]'),isset($this->_search['CatID'])?$this->_search['CatID']:'','fields1');
		$formGui->setValues($key,array(0=>$this->_T->lang('[[Alle]]')) + $this->_frm->extractObjName($this->_cat));

		$submit_array=array(
			'search_x'=>' '.$this->_T->lang('[[Suchen]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','fields1');
		$formGui->setValues($key,$submit_array);


		$this->_search=array(
			'StartDate'=>$selDateGui->getDate('B'),
			'EndDate'=>$selDateGui->getDate('E'),
			'DateMode'=>$selDateGui->getMode(),
			'CatID'=>$formGui->getFieldVal('sCategory',1),
			'Info'=>$formGui->getFieldVal('sInfo',1),
		);

		$this->_frm->savePostData($this->_Base->getModul(),'tmpCalSearch',null,$this->_search);

		$Gui->addContent('config',$formGui,'CONTENT');
		return $Gui;
	}
	function sortData($a,$b) {
		//$evtA=reset($a);
		//$evtB=reset($b);
		return $a['StartDate']<$b['StartDate']?1:-1;
	}
	function getResultGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_FunctionButtons.php');

		$rows=0;
		if (Framework::issetParam('search_x','','P')) {
			$b=0;
		} else {
			$b=Framework::getParam('b');
		}
		$limit=50;

		$search=$this->_search;
		$search['_fetchSimple']=1;
		$search['Deleted']=1;
		$search['OwnerID']=$this->_Base->getUser();
		$search['Order']=array('StartDate'=>-1);


		$data=array();
		$data=$this->_Base->searchEvents($rows,$search,$b,$limit);
		if (!empty($data)) {
			uasort($data,array($this,'sortData'));
		}

		$Gui=new ApplicationListGui();

		$noEnc=array('NoEnc'=>1,'NoBr'=>1);

		

		$funcAction=new FunctionObjActionGui('list_action',1);
		$funcAction->setName($this->_T->lang('[[Ausgewaehlte Events]]'));

		$list_action=$this->_frm->getObjAction($this->_Base->getModul(),'trash_l');
		foreach ($list_action as $key=>$val) {
			if (!$val['Hidden']) {
				$funcAction->addValue($key,$val['Name']);
			}
		}
		$Gui->addFunction($funcAction);

		$funcSelAll=new FunctionButtons('trash_list','selectall',array('ListID'=>'ListID[]','ListOn'=>false));
		$Gui->addHeaderCol('ListID',$funcSelAll->process(),'','','',1,'1%',0,'',$noEnc);
		$Gui->setTrOver('trBOC({ROW},this);');
		$Gui->setTrDown('trBOI({ROW},this,1);');
		
		$Gui->addHeaderCol('Datum',$this->_T->lang('[[Datum]]'),'','','',1,'',2);
		$Gui->addHeaderCol('Time',$this->_T->lang('[[Uhrzeit]]'),'','','',1,'',1);
		$Gui->addHeaderCol('Duration',$this->_T->lang('[[Dauer]]'),'','','',1,'',2);
		$Gui->addHeaderCol('Title',$this->_T->lang('[[Titel]]'),'','','',0,'2000');
		$Gui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));
		$Gui->setLimit($limit);
		$Gui->setSumRows($rows);
		$Gui->setBegin($b);
		$L=Framework::cloneObj($this->_L);
		$L->setParam('_loadSearch',1);
		$Gui->setNavLink($L);

		$attribs=array(
			'onclick'=>'return false;',
		);
		$btnList=new CheckBoxBtn ('ListID[]','');
		$btnList->setAttribs($attribs);
		foreach ($data as $evtVal) {
			$Gui->addRow($hl?$hl=0:$hl=1);
			$Gui->addCol('ListID',$btnList->process($evtVal['EventID']),'','','',1,'1%',0,'',$noEnc);
			
			$link='index.php?site=cal.php&action=view&view=event&back=0&event_id='.$evtVal['EventID'];
			$params=array();
			$params['LinkAttribs']=$this->_lGui->addEventLayer($evtVal);
			if ($evtVal['EvtPrivat'] && $evtVal['OwnerID']==$this->_userID) {
				$params['style']='background-color:#ffe6cc;';
			} elseif ($evtVal['Unsecure']) {
				$params['style']='background-color:#ececec;';
			}
			if ($evtVal['Unsecure']) {
				$params['style'].='font-style:italic;';
			}
			if (!$evtVal['_Privat'] && $evtVal['OwnerID']==$this->_userID && $this->_Base->getCalPerms(2)) {
				$params['LinkAttribs']['onclick']='return goToView(this);';
				$params['LinkAttribs']['ondblclick']='return goToEdit(this,\'action=view\',\'action=edit&back=0\');';
			}

			$Gui->addCol('DatumB',date('d.m.Y',$evtVal["StartDate"]).' - '.date('d.m.Y',$evtVal["EndDate"]),'','','',1,'',0,'',$params);
			$Gui->addCol('Rec','',($evtVal['RecType']?'wiederholungstermin.gif':''),'','',1,'',0,'',$params);
			$Gui->addCol('Time',$evtVal['TimeMode']?'':(date('H:i',$evtVal["StartDate"]).' - '.date('H:i',$evtVal["EndDate"])),'','','',1,'',0,'',$params);
			if (!$evtVal['TimeMode']) {
				$dur=($evtVal["EndDate"]-$evtVal["StartDate"])/60;
			} else {
				$dur=0;
			}
			$Gui->addCol('Dauer',$dur?Framework::formatTime($dur):'','','','right',1,'',0,'',$params);
			$Gui->addCol('Alarm','',($evtVal['AlarmTime']?'alarm.gif':''),'','',1,'',0,'',$params);
			$Gui->addCol('Title',$evtVal['Title'],'',$link,'',0,'',0,'',$params);
			
		}
		return $Gui;
	}
}
?>