<?php
class EventGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	var $_minPixels=0.833333333;
	function EventGui() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_BaseCat=$frm->getStaticModul('cal_cat');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_T->loadModul('cal');
	}
	function processDayView($date) {
		require_once('lib/class_FastTemplateGui.php');
		$tpl=new FastTemplateGui('cal/dayjs_content.inc.html');
		$tpl->setEncode(false);
		$_day=date('j',$date);
		$_month=date('n',$date);
		$_year=date('Y',$date);
		$_evt_beginn=mktime(0,0,0,$_month,$_day,$_year);
		$_evt_end=mktime(23,59,59,$_month,$_day,$_year);

		$tpl->assign("PREV_DAY_LINK",$this->_L->getTempLink(null,array('date'=>$_evt_beginn-1)));
		$tpl->assign("NEXT_DAY_LINK",$this->_L->getTempLink(null,array('date'=>$_evt_end+1)));
		$tpl->assign("DAY_NAME",strftime("%A, %d.%B %Y",$date));
		$tpl->assign("BACK_LINK",$GLOBALS['CAL_REFERER'][2]);


		$this->_day_b=$this->_frm->getPrefs('cal',"db_h")*60+$this->_frm->getPrefs('cal',"db_m");;
		$this->_day_e=$this->_frm->getPrefs('cal',"de_h")*60+$this->_frm->getPrefs('cal',"db_m");

		$g_events=$this->_Base->listInfos($_evt_beginn,$_evt_end);
		if (is_array($g_events[$_day.'-'.$_month.'-'.$_year])) {
			uasort ($g_events[$_day.'-'.$_month.'-'.$_year],array('CalEvent',"daycmp"));
			foreach ($g_events[$_day.'-'.$_month.'-'.$_year] as $val) {
				if ($val['TimeMode']!=1 && date("H",$val["EndDate"])*60+date("i",$val["EndDate"])<=$this->_day_b) {
					$this->_day_b=min($this->_day_b,date("H",$val["StartDate"])*60+date("i",$val["StartDate"]));
				}
				if ($val['TimeMode']!=1 && date("H",$val["StartDate"])*60+date("i",$val["StartDate"])>=$this->_day_e) {
					$this->_day_e=max($this->_day_e,date("H",$val["EndDate"])*60+date("i",$val["EndDate"]));
				}
			}
		} else {
			$g_events[$_day.'-'.$_month.'-'.$_year]=array();
		}
		$p_events=$this->_Base->listEvents($_evt_beginn,$_evt_end);
		if (is_array($p_events[$_day.'-'.$_month.'-'.$_year])) {
			uasort ($p_events[$_day.'-'.$_month.'-'.$_year],array('CalEvent',"daycmp"));
			foreach ($p_events[$_day.'-'.$_month.'-'.$_year] as $val) {
				if ($val['TimeMode']!=1 && date("H",$val["EndDate"])*60+date("i",$val["EndDate"])<=$this->_day_b) {
					$this->_day_b=min($this->_day_b,date("H",$val["StartDate"])*60+date("i",$val["StartDate"]));
				}
				if ($val['TimeMode']!=1 && date("H",$val["StartDate"])*60+date("i",$val["StartDate"])>=$this->_day_e) {
					$this->_day_e=max($this->_day_e,date("H",$val["EndDate"])*60+date("i",$val["EndDate"]));
				}
			}
		} else {
			$p_events[$_day.'-'.$_month.'-'.$_year]=array();
		}
		$this->_day_b=floor($this->_day_b/60)*60;
		$this->_day_e=ceil($this->_day_e/60)*60;

		for ($i=$this->_day_b;$i<$this->_day_e;$i+=60) {
			$tpl->assign('TIME',sprintf('%02d:%02d',floor($i/60),$i%60));
			$tpl->assign('HEIGHT',round($this->_minPixels*60)-1);
			$tpl->parse('ROW','.bg_row_time');
			$tpl->assign('HEIGHT',round($this->_minPixels*30)-1);
			$tpl->parse('ROW','.bg_row_p');
			$tpl->parse('ROW','.bg_row_g');

		}

		$tpl->assign('DAYP_EVENTS',$this->_parseEvents($p_events[$_day.'-'.$_month.'-'.$_year]));
		$tpl->assign('DAYG_EVENTS',$this->_parseEvents($g_events[$_day.'-'.$_month.'-'.$_year]));
		return $tpl->process();
	}
	function _parseEvents($events) {
		$result='';
		require_once('lib/class_FastTemplateGui.php');
		$tpl=new FastTemplateGui('cal/day_view_evt.inc.html');
		$this->_evtTimeLine=array();
		foreach ($events as $key=>$val) {
			if ($val['TimeMode']!=1) {
				$min_b=date('H',$val['StartDate'])*60+date('i',$val['StartDate']);
				$min_e=date('H',$val['EndDate'])*60+date('i',$val['EndDate']);
				if ($min_b < $this->_day_b) {
					$min_b=$this->_day_b;
				}
				if ($min_e > $this->_day_e) {
					$min_e=$this->_day_e;
				}


				if ($min_e-$min_b < 30) $min_e=$min_b+30;
				$px_b=round($min_b*$this->_minPixels);
				$px_h=round(($min_e-$min_b)*$this->_minPixels);
				$rpos=array();
				$parsed=false;
				if (isset($this->_belegt[$px_b])) {
					$akt_pos=count($this->_belegt[$px_b]);
					for ($i=0;$i<=count($this->_belegt[$px_b]);$i++) {
						if (!isset($this->_belegt[$px_b][$i])) {
							if (!$parsed) {
								$akt_pos=$i;
								$parsed=true;
							}
						} else {
							if ($parsed) $rpos[$i]=1;
						}
					}
				} else {
					$akt_pos=0;
				}
				for ($i=$px_b;$i<($px_b+$px_h);$i++) {
					if (isset($this->_belegt[$i][$akt_pos-1])) {
						for ($j=$akt_pos-1;$j>=0;$j--) {
							if (isset($this->_evtTimeLine[$this->_belegt[$i][$j]])) $this->_evtTimeLine[$this->_belegt[$i][$j]]['rpos'][$akt_pos]=1;
						}
					}
					$this->_belegt[$i][$akt_pos]=$key;
				}
				$max_lpos=max($max_lpos,$akt_pos);
				$this->_evtTimeLine[$key]=array(
					'b'=>$min_b,
					'e'=>$min_e,
					'px_t'=>round(($min_b-$this->_day_b)*$this->_minPixels),
					'px_h'=>round(($min_e-$min_b)*$this->_minPixels)-2,
					'lpos'=>$akt_pos,
					'rpos'=>$rpos,
				);
			}
		}
		//debug($this->_evtTimeLine);
		$indent_val=100/($max_lpos+2);
		foreach ($this->_evtTimeLine as $key=>$val) {
			$l_indent=$val['lpos']*$indent_val;
			$r_indent=count($val['rpos'])*$indent_val;
			//debug($val['lpos'].'-'.count($val['rpos']));
			$tpl->assign('ID','evt_'.$key);
			$tpl->assign('TOP',$val['px_t']);
			$tpl->assign('HEIGHT',$val['px_h']);
			$tpl->assign('LEFT',$l_indent);
			$tpl->assign('Z_INDEX',$val['lpos']*10);
			$tpl->assign('WIDTH',99-$l_indent-$r_indent);
			if ($val['e']-$val['b'] < 45) {
				$tpl->assign('DATE',date("H:i-",$events[$key]["StartDate"]).date("H:i",$events[$key]["EndDate"]).' '.$events[$key]['Title']);
				$tpl->assign('TITLE','');
			} else {
				$tpl->assign('DATE',date("H:i-",$events[$key]["StartDate"]).date("H:i",$events[$key]["EndDate"]));
				$tpl->assign('TITLE',$events[$key]['Title']);
			}
			$result.=$tpl->process();
		}
		return $result;

	}
}
?>