<?php
class ResourcesSearchGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_search=array();
	function __construct() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FastTemplateGui.php');
		require_once('lib/class_ApplicationListGui.php');
		require_once("lib/uform/class_UserFormData.php");
		global $frm,$t,$T,$E,$L;
		$this->_uFormData=new UserFormData();
		$this->_BaseForm=& $frm->getStaticModul('uform');
		$this->_BaseFields=& $frm->getStaticModul('uform_fields');
		$this->_BaseSelect=& $frm->getStaticModul('uform_select');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$Obj=$this->_BaseForm->getSystemForm('cal_res');
		if (is_object($Obj)) {
			$this->_formObj=&$Obj;
			$this->_BaseFields->setFormObj($this->_formObj);
			$this->_uFormData->setFormObj($this->_formObj);
			$this->_formFields=$this->_uFormData->getFormFields();
		}
	}
	function getSearch() {
		return $this->_search;
	}
	function setSearch($search) {
		$this->_search=$search;
	}
	function getForm($formGui=null) {
		$ok=false;
		if ($formGui) {
			$this->_formGui=$formGui;
		} else {
			$this->_formGui=new FormGui();
			$this->_formGui->setFieldClass('ipts','ipts');
		}
		if (is_array($this->_formFields[0])) {
			foreach ($this->_formFields[0] as $fGroup) {
				if (is_array($this->_formFields[$fGroup->getID()])) {
					$key='cfgCrm'.$fGroup->getID();
					$this->_formGui->addField($key,'label',$fGroup->getName());
					$this->_formGui->setIptAttribs($key,array('style'=>'border-bottom:1px solid #000;margin-bottom:3px;'));
					
					foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
						if ($this->_addField2Form($this->_formGui,$fGroup,$fObj,'uformData',isset($this->_default['F_'.$fObj->getID()])?$this->_default['F_'.$fObj->getID()]:null)) {
							$ok=true;
						}
					}
				}
			}
		}
		return $ok?$this->_formGui:false;
	}
	function _addField2Form(&$FormGui,&$fGroup,&$fObj,$Prep='uformData',$Default=null) {
		$ok=false;
		$fTyp=$fObj->getMeta('Typ');
		$fConfig=unserialize($fObj->getMeta('Config'));
		switch ($fObj->getMeta('Typ')) {
			case 'select':
				$key='cfgCrm'.$fObj->getID();
				$default=isset($this->_search[$key])?$this->_search[$key][2]:'0';
				$Values=array(''=>'-') + Framework::extractObjName($this->_BaseSelect->listSelect($fObj->getID()));
				$FormGui->addField($key,'select',$fObj->getName(),$default);
				$FormGui->setValues($key,$Values);
				if (($v=$FormGui->getFieldVal($key,1)) && !empty($v)) {
					$this->_search[$key]=array(
						$fObj->getID(),
						'=',
						$v,
					);
				}
				$ok=true;
			break;
			case 'mselect':
				$key='cfgCrm'.$fObj->getID();
				$default=isset($this->_search[$key])?$this->_search[$key][2]:array();
				$Values=Framework::extractObjName($this->_BaseSelect->listSelect($fObj->getID()));
				$FormGui->addField($key,'checklist_v',$fObj->getName(),$default);
				$FormGui->setValues($key,$Values);
				//debug($default);
				if (($v=$FormGui->getFieldVal($key,1)) && !empty($v)) {
					$this->_search[$key]=array(
						$fObj->getID(),
						'inset',
						$v,
					);
					//debug($v);
				}
				$ok=true;
			break;
			case 'int':
				$fList=array();
				$key='cfgCrm'.$fObj->getID().'B';
				$default=isset($this->_search[$key])?$this->_search[$key][2]:'0';
				$FormGui->addField($key,'int','',$default);
				$FormGui->setAttribs($key,array('style'=>'width:75px;'));
				$FormGui->setParams($key,array('numdec'=>$fConfig['decimals']?$fConfig['decimals']:0));
				$FormGui->setNoParse($key);
				if (($v=$FormGui->getFieldVal($key,1)) && !empty($v)) {
					$this->_search[$key]=array(
						$fObj->getID(),
						'>=',
						$v,
					);
				}
				$fList[]=$this->_T->lang('[[von]]').'&nbsp;';
				$fList[]=$key;

				$key='cfgCrm'.$fObj->getID().'E';
				$default=isset($this->_search[$key])?$this->_search[$key][2]:'0';
				$FormGui->addField($key,'int','',$default);
				$FormGui->setAttribs($key,array('style'=>'width:75px;'));
				$FormGui->setParams($key,array('numdec'=>$fConfig['decimals']?$fConfig['decimals']:0));
				$FormGui->setNoParse($key);
				if (($v=$FormGui->getFieldVal($key,1)) && !empty($v)) {
					$this->_search[$key]=array(
						$fObj->getID(),
						'<=',
						$v,
					);
				}
				$fList[]='&nbsp;'.$this->_T->lang('[[bis]]').'&nbsp;';
				$fList[]=$key;

				$key='cfgCrm'.$fObj->getID();
				$FormGui->addField($key,'field_array',$fObj->getName(),$fList,'');
				$ok=true;
			break;
			case 'check':
				$key='cfgCrm'.$fObj->getID();
				$default=isset($this->_search[$key])?$this->_search[$key][2]:'0';
				$FormGui->addField($key,'radiolist_h',$fObj->getName(),$default);
				$FormGui->setValues($key,array(
					1=>$this->_T->Lang('[[Ja]]'),
					-1=>$this->_T->Lang('[[Nein]]'),
					0=>$this->_T->Lang('[[Ignorieren]]'),
				));
				if (($v=$FormGui->getFieldVal($key,1)) && !empty($v)) {
					$this->_search[$key]=array(
						$fObj->getID(),
						'=',
						$v,
					);
				}
				$ok=true;
			break;
		}
		return $ok;
	}

}
?>