<?php
class SmallCalGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_mode='m';
	var $_nw=1;
	var $_selColor=APP_FG20COLOR;
	var $_kwB=0;
	var $_nl='';
	var $_al='';
	var $_wl='';
	function SmallCalGui() {
		global $frm,$t,$T,$E,$L;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_wd=& $frm->getStaticModul('workday');
		$this->_T->loadModul('cal');
	}
	function setEvents($events) {
		$this->_events=$events;
	}
	function setMode($mode) {
		$this->_mode=$mode;
	}
	function setDate($date) {
		$this->_date=$date;
	}
	function setNumWeeks($nw) {
		$this->_nw=$nw;
	}
	function setNavLink($l) {
		$this->_nL=$l;
	}
	function setNavLinkWeek($l) {
		$this->_wL=$l;
	}
	function setAccessLink($l) {
		$this->_aL=$l;
	}
	function setSelColor($val) {
		$this->_selColor=$val;
	}
	function setWeekKwB($val) {
		$this->_kwB=$val;
	}
	function &process() {
		switch ($this->_mode) {
			case 'Y':
				return $this->getYearCal();
			break;
			case 'M':
				return $this->getMonthCal();
			break;
			default:
				return $this->getDayCal();
			break;
		}
	}
	function &getMonthCal() {
		require_once('lib/class_FastTemplateGui.php');
		$t=new FastTemplateGui('cal/cal_small.inc.html');
		$t->setEncode(false);

		$_month=date("n",$this->_date);
		$_year=date("Y",$this->_date);

		$t->assign("PREV_LINK_Y",$this->_nL.'&date='.mktime(0,0,0,$_month,1,$_year - 1));
		$t->assign("NEXT_LINK_Y",$this->_nL.'&date='.mktime(0,0,0,$_month,1,$_year + 1));
		$t->assign("SEL_YEAR",$_year);
		$a="";
		for ($i=1;$i<13;$i++) {
			$sel_date=mktime(0,0,0,$i,1,$_year);
			if ($i==$_month) $t->assign('MONTH_BG',APP_FG20COLOR); else  $t->assign('MONTH_BG',APP_FG10COLOR);
			$t->assign('MONTH_NAME','<a href="'.$this->_nL.'&date='.$sel_date.'">'.strftime("%B",$sel_date).'</a>');
			$t->parse("COL",$a.'m_month_col');
			$a='.';
			if (!($i%3)) {
				$t->parse('ROW','.m_month_row');
				$a='';
			}
		}
		$t->parse("ROW","month_cal");
		return $t;
	}
	function &getYearCal() {
		require_once('lib/class_FastTemplateGui.php');
		$t=new FastTemplateGui('cal/cal_small.inc.html');
		$t->setEncode(false);
		$_year=date("Y",$this->_date);
		$_akt_year=date("Y");
		if ($_year>($_akt_year+2) || $_year<($_akt_year-1)) $_akt_year=$_year;
		for ($i=$_akt_year-1;$i<$_akt_year+3;$i++) {
			$t->assign("L_YEAR",$this->_aL.'&date='.mktime(0,0,0,1,1,$i));
			$t->assign('NUM_YEAR',$i);
			if ($i==$_year) $t->assign('ROW_COLOR',APP_FG20COLOR);
			else $t->assign('ROW_COLOR',APP_FG10COLOR);
			$t->parse('ROW','.year_select');
		}
		$t->parse("ROW","year_cal");
		return $t;
	}

	function &getDayCal() {
		require_once('lib/class_FastTemplateGui.php');
		$t=new FastTemplateGui('cal/cal_small.inc.html');
		$t->setEncode(false);

		$_day=date("d",$this->_date);
		$_month=date("n",$this->_date);
		$_year=date("Y",$this->_date);
		$_days=date("t",$this->_date);
		$_wday=date("w",$this->_date)-1;
		if ($_wday<0) $_wday=6;

		$_beginn=mktime (0,0,0,$_month,1,$_year);
		$_end=mktime (23,59,59,$_month,$_days,$_year);

		$_pdays=date("t",$_beginn - 10);
		$_start=date("w",$_beginn)-1;
		if ($_start<0) $_start=6;

		$_sweek=mktime(0,0,0,$_month,$_day-$_wday,$_year);
		$_eweek=mktime(23,59,59,$_month,$_day-$_wday+(7*$this->_nw)-1,$_year);
		$_kw_b=strftime("%V",$_sweek);
		$_kw_e=strftime("%V",$_eweek);
		$_aktdate=mktime(23,59,59);

		if (($_start+$_days)>35) $cells=42; else $cells=35;

		$a="";$cell=1;
		$t->assign("CAL_BG","");
		$t->assign("CAL_COL_COLOR","");
		for($cell;$cell<=$_start;$cell++) {
			$celldate=mktime(0,0,0,$_month-1,($_pdays-$_start+$cell),$_year);
			$t->assign("CAL_DAY_NUM",'<a href="'.$this->_aL.'&date='.$celldate.'"><span style="color:#888888;">'.($_pdays-$_start+$cell).'</span></a>');
			$t->parse("COL",$a."month_col");
			$a=".";
		}
		for($cell;$cell<=($_days+$_start);$cell++){
			$day=$cell-$_start;
			$celldate=mktime(23,59,59,$_month,$day,$_year);
			$cellstring=$day.'-'.$_month.'-'.$_year;
			$t->assign("CAL_COL_COLOR","");
			//debug($cellstring);
			//debug($this->_events);
			if ($this->_events[$cellstring])  {
				foreach ($this->_events[$cellstring] as $key=>$val) {
					$end=$val["EndDate"];
					if ($end>$celldate) {
						$this->_events[($day+1).'-'.$_month.'-'.$_year][$key]=$val;
					}
					$t->assign("CAL_COL_COLOR","background-color:".$this->_selColor);
				}
			}
			if ($celldate==$_aktdate)  $t->assign("CAL_BG","calborder"); else  $t->assign("CAL_BG","");
			if (!is_object($this->_wd) || $this->_wd->is_workday($celldate)) {
				$t->assign("CAL_DAY_NUM",'<a href="'.$this->_aL.'&date='.$celldate.'">'.$day.'</a>');
			} else {
				$t->assign("CAL_DAY_NUM",'<a href="'.$this->_aL.'&date='.$celldate.'"><span style="color:red">'.$day.'</span></a>');
			}
			$t->parse("COL",$a."month_col");
			$a=".";
			if ($cell%7==0) {
				$cell_kw=strftime("%V",$celldate);
				$_sweek=mktime(0,0,0,$_month,$day-$this->_kwB,$_year);
				//echo $cell_kw;
				if ($cell_kw >=$_kw_b && $cell_kw <=$_kw_e) $t->assign("KW_BG",APP_FG20COLOR); else  $t->assign("KW_BG",APP_FG10COLOR);
				$t->assign("KW_NUM",'<a href="'.($this->_wL?$this->_wL:$this->_nL).'&date='.$_sweek.'">'.$cell_kw.'</a>');
				$t->parse("ROW",".month_row");
				$a="";
			}
		}
		$t->assign("CAL_BG","");
		$t->assign("CAL_COL_COLOR","");
		$i=1;
		for($cell;$cell<=$cells;$cell++) {
			$celldate=mktime(0,0,0,$_month+1,$i,$_year);
			$t->assign("CAL_DAY_NUM",'<a href="'.$this->_aL.'&date='.$celldate.'"><span style="color:#888888;">'.$i.'</span></a>');
			$t->parse("COL",$a."month_col");
			$a=".";$i++;
		}
		if ($a==".") {
			$cell_kw=strftime("%V",$celldate);
			$_sweek=mktime(0,0,0,$_month+1,$i-1-$this->_kwB,$_year);
			if ($cell_kw >=$_kw_b && $cell_kw <=$_kw_e) $t->assign("KW_BG",APP_FG20COLOR); else  $t->assign("KW_BG",APP_FG10COLOR);
			$t->assign("KW_NUM",'<a href="'.($this->_wL?$this->_wL:$this->_nL).'&date='.$_sweek.'">'.$cell_kw.'</a>');
			$t->parse("ROW",".month_row");
		}
		$t->assign("PREV_LINK",$this->_nL.'&date='.mktime(0,0,0,$_month-1,1,$_year));
		$t->assign("NEXT_LINK",$this->_nL.'&date='.mktime(0,0,0,$_month+1,1,$_year));
		$t->assign("SEL_MONTH",strftime("%B",$_beginn)." ".strftime("%Y",$_beginn));
		$t->parse("ROW","day_cal");
		return $t;
	}
}
?>