<?php
class SmallEventViewGui {
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_prjID=0;
	var $_prjPerms=0;
	function SmallEventViewGui() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_frm=&$frm;
		$this->_T=&$T;
		$this->_T->loadModul('cal');
	}
	function setUser($uid) {
		$this->_Base->setUser($uid);
		$this->_Base->setGroup($this->_frm->getUserGroups($uid));
	}
	function &process($obj,$GuiCfg) {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FastTemplateGui.php');
		$Gui=new FastTemplateGui('cal/small_event_view.inc.html');
		$Gui->setEncode(false);
		$Gui->assign("TOP_TITLE",'');
		if ($obj['Unsecure']) {
			$Gui->assign("EVENT_TITLE","<i>".Framework::entities($obj['Title'])."</i>");
		} else {
			$Gui->assign("EVENT_TITLE",Framework::entities($obj['Title']));
		}
		$Gui->assign("EVENT_DESC",nl2br(Framework::entities($obj['Text'])));
		if ($obj['RecType'] && ($next=$this->_Base->nextRecurrence($obj['EventID'], time()))) {
			$obj['StartDate']=$next['start'];
			$obj['EndDate']=$next['end'];
		}
		$start_date=strftime("%A, %d.%m.%Y",$obj['StartDate']);
		$end_date=strftime("%A, %d.%m.%Y",$obj['EndDate']);
		if ($start_date!=$end_date) $diff_date=1;
		else $diff_date=0;
		if ($obj['TimeMode']!=1) {
			$start_date.=strftime(" %H:%M",$obj['StartDate']);
			if ($diff_date) {
				$end_date.=strftime(" %H:%M",$obj['EndDate']);
			} else $start_date.=strftime("-%H:%M",$obj['EndDate']);
		}
		$Gui->assign("EVENT_START",$start_date);
		if ($diff_date ) {
			$Gui->assign("EVENT_END",$end_date);
			$Gui->parse('ROW','event_end');
		} else $Gui->clear_dynamic('event_end');

		if ($obj['Place']) {
			$Gui->assign("EVENT_PLACE",Framework::entities($obj['Place']));
			$Gui->parse('ROW','event_place');
		} else $Gui->clear_dynamic('event_place');

		if ($GuiCfg['showActions']) {
			$formGui=new FormGui();
			$formGui->setLabelClass('no','error');
			//debug($obj['UID']);
			if ($obj['UID']) {
				$aktObj=$this->_Base->getByUid($obj['UID']);
			} else {
				$aktObj=0;
			}
			if ($aktObj) {
				$Gui->assign("TOP_TITLE",$this->_T->lang('[[Termin bereits im Kalender eingetragen]]'));
				$formGui->addField('cal_action','submit','','','');
				$submitValues=array(
					'cal_view['.$aktObj['EventID'].']'=>' '.$this->_T->lang('[[Termin anzeigen]]').' ',
				);
				$formGui->setValues('cal_action',$submitValues);
				$Gui->assign("FORM",$formGui->process());
				$Gui->parse('ROW','.event_actions');
				if ($GuiCfg['method']=='REPLY') {
					if (is_array($obj['cardInvitUsers'])) {
						//debug($obj['cardInvitUsers']);
						$name=$obj['cardInvitUsers'][0]['name']?$obj['cardInvitUsers'][0]['name']:$obj['cardInvitUsers'][0]['mail'];
						switch ($obj['cardInvitUsers'][0]['status']) {
							case 1:
								$Gui->assign("TOP_TITLE",$name.': '.$this->_T->lang('[[Termin akzeptiert]]'));
							break;
							case 2:
								$Gui->assign("TOP_TITLE",$name.': '.$this->_T->lang('[[Termin abgelehnt]]'));
							break;
							case 3:
								$Gui->assign("TOP_TITLE",$name.': '.$this->_T->lang('[[Termin provisorisch akzeptiert]]'));
							break;
						}
					}
					//debug($obj);
				}
			} else {
				if ($GuiCfg['method']=='REQUEST') {
					$Gui->assign("TOP_TITLE",$this->_T->lang('[[Einladung zu Termin]]'));
					$formGui->addField('cal_action','submit','','','');
					$submitValues=array(
						'cal_insert['.$GuiCfg['Num'].']'=>' '.$this->_T->lang('[[Akzeptieren]]').' ',
						'cal_deny['.$GuiCfg['Num'].']'=>' '.$this->_T->lang('[[Ablehnen]]').' ',
					);
					$formGui->setValues('cal_action',$submitValues);
					if ($GuiCfg['cfgActionAttribs']) {
						foreach ($GuiCfg['cfgActionAttribs'] as $action=>$attribs) {
							$formGui->setValuesAttribs('cal_action',$action,$attribs);
							//debug($attribs);
						}
					}
					$Gui->assign("FORM",$formGui->process());
					$Gui->parse('ROW','.event_actions');
				}
			}
		}

		return $Gui->process();
	}

}
?>