<?php
class ViewDayGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	var $_minPixels=0.833333333;
	var $_minHeight=60; //in Minuten;
	var $_edate=0;
	var $_droppable=array();
	var $_draggable=array();
	var $_view='day';
	function ViewDayGui() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_T->loadModul('cal');

		$this->_dayUserB=$this->_frm->getPrefs('cal',"db_h")*60+$this->_frm->getPrefs('cal',"db_m");;
		$this->_dayUserE=$this->_frm->getPrefs('cal',"de_h")*60+$this->_frm->getPrefs('cal',"db_m");
		require_once('lib/class_ApplicationTreeGui.php');
		$this->_Gui=new ApplicationTreeGui();
		//$this->_Gui->setTreeWidth(200);
		require_once('lib/cal/class_CalLayerGui.php');
		$this->_lGui=new CalLayerGui(array(
			//'showText'=>false,
			'linkAsSting'=>true,
		));
		$this->_userID=$this->_frm->getUser();

	}
	function _handleRequest() {
		$this->_calUser=$GLOBALS['CAL_USER']; // eventuell auch 'info';
		$this->_view=Framework::getParam('view','day');
		if (Framework::getParam('sdate')) {
			$this->_date=$this->_frm->parseDate(Framework::getParam('sdate'));
		}
		if (!$this->_date) {
			$this->_date=Framework::getParam('date',0);
		}
		if (!$this->_date) {
			$this->_date=time();
		}
		$this->_L->setParam('date',$this->_date);
		if (Framework::getParam('print',0)) {
			if (Framework::getParam('sid')) {
				require('lib/cal/class_ViewFinderGui.php');
				$fGui=new ViewFinderGui(array('forceView'=>'d','getOnlyView'=>true));
				$fGui->process();
			} else {
				$this->getDayViewGui(true);
				exit;
			}
		} else {

			$sCalGui=& $this->getSmallCalGui();
			$this->_Gui->addTreeContent($sCalGui);

			require_once("lib/cal/class_CalListGui.php");
			$listGui=new CalListGui();
			$this->_invit_events=& $listGui->getInvitEvents();
			$invitGui=& $listGui->getInvitGui();
			if (is_object($invitGui)) {
				$this->_Gui->addTreeContent($invitGui);
			}
			$actGui=& $listGui->getActualGui();
			if (is_object($actGui)) {
				$this->_Gui->addTreeContent($actGui);
			}
			$finderGui=& $listGui->getFinderGui();
			if (is_object($finderGui)) {
				$this->_Gui->addTreeContent($finderGui);
			}
			/*if (is_object($this->_TaskGui)) {
				$sTaskGui=$this->_TaskGui->processActualGui(true);
				if (is_object($sTaskGui)) {
					$this->_Gui->addTreeContent($sTaskGui);
				}
			}*/
			if (Framework::getParam('sid')) {
				require('lib/cal/class_ViewFinderGui.php');
				$fGui=new ViewFinderGui(array('forceView'=>'d','getOnlyView'=>true,'linkBreak'=>$this->_L->getTempLink(array('sid'))));
				if ($Gui=$fGui->process()) {
					$this->_Gui->addContent($Gui,null,null);
				}
			} else {
				$dGui=& $this->getDayViewGui();
				$this->_Gui->addContent($dGui,null,null,'calDayContent');
			}
		}
	}
	function &process() {
		$this->_handleRequest();
		return $this->_Gui;
	}
	function &getSmallCalGui() {
		require_once("lib/cal/class_SmallCal.php");
		$listbeginn=mktime (0,0,0,date('m',$this->_date),1,date('Y',$this->_date));
		$days=date("t",$listbeginn);
		$listend=mktime (23,59,59,date('m',$this->_date),$days,date('Y',$this->_date));
		$events=$this->_Base->listEvents($listbeginn,$listend);
		$SmallCalGui=new SmallCalGui();
		$SmallCalGui->setMode('D');
		$SmallCalGui->setDate($this->_date);
		$SmallCalGui->setEvents($events);
		$SmallCalGui->setNumWeeks($this->_nw);
		$SmallCalGui->setNavLink("index.php?site=cal.php&action=view&view=day");
		$SmallCalGui->setAccessLink("index.php?site=cal.php&action=view&view=day");
		return $SmallCalGui->process();
	}
	function getDayViewGui($print=false) {
		$daydate=date("j",$this->_date);
		$month=date("n",$this->_date);
		$year=date("Y",$this->_date);
		$this->_edate=$date=mktime(0,0,0,$month,$daydate,$year);
		$dateend=mktime(23,59,59,$month,$daydate,$year);
		$this->_acLink="index.php?site=cal.php&action=view&view=event&date=".$this->_date;

		require_once('lib/class_FastTemplateGui.php');
		$tpl=new FastTemplateGui('cal/view_day.inc.html');
		$tpl->setEncode(false);
		$_day=date('j',$date);
		$_month=date('n',$date);
		$_year=date('Y',$date);
		$this->_viewBeginn=$_evt_beginn=mktime(0,0,0,$_month,$_day,$_year);
		$this->_viewEnd=$_evt_end=mktime(23,59,59,$_month,$_day,$_year);

		if ($print) {
			require_once('lib/cal/class_CalPrintGui.php');
			$printGui=new CalPrintGui(array(
				'TplID'=>intval(Framework::getParam('printTpl','','G'))?Framework::getParam('printTpl','','G'):'list_d',
				'TimeStart'=>$this->_viewBeginn,
				'TimeEnd'=>$this->_viewEnd,
				'CalUserID'=>$this->_Base->getUser(),
				'CalUserName'=>$this->_frm->getCachedUserName($this->_Base->getUser(),0,1),
				'ShowPrivate'=>1,
				'ShowTeam'=>($this->_calUser=='info'),
				'ShowTeamUsers'=>0,
			));
			$CalUsers=array();
			if ($printGui->getOption('ShowPrivate')) {
				$CalUsers['u_'.$this->_Base->getUser()]=array(
					'Typ'=>'u',
					'ID'=>$this->_Base->getUser(),
					'Name'=>$this->_frm->getCachedUserName($this->_Base->getUser(),0,1),
				);
				$printGui->setEntries($this->_Base->listEvents($this->_viewBeginn,$this->_viewEnd),'u_'.$this->_Base->getUser());
			}
			if ($printGui->getOption('ShowTeam')) {
				if ($printGui->getOption('ShowTeamUsers')) {
					$g_events_all=$this->_Base->listGroupEvents($this->_viewBeginn,$this->_viewEnd);
					foreach ($g_events_all as $guid=>$g_events) {
						if ($tmpName=$this->_frm->getCachedUserName($guid)) {
							$CalUsers['u_'.$guid]=array(
								'Typ'=>'u',
								'ID'=>$guid,
								'Name'=>$tmpName,
							);
							$printGui->setEntries($g_events,'u_'.$guid);
						}
					}
				} else {
					$CalUsers['info']=array(
						'Typ'=>'info',
						'ID'=>0,
						'Name'=>$this->_T->lang('[[Teamkalender]]'),
					);
					$printGui->setEntries($this->_Base->listInfos($this->_viewBeginn,$this->_viewEnd),'info');
				}
			}
			$printGui->setOption('CalUsers',$CalUsers);
			$printGui->printList();
		}


		$tpl->assign("PREV_DAY_LINK",$this->_L->getTempLink(null,array('date'=>$_evt_beginn-1)));
		$tpl->assign("NEXT_DAY_LINK",$this->_L->getTempLink(null,array('date'=>$_evt_end+1)));
		$tpl->assign("DAY_NAME",strftime("%A, %d.%B %Y",$date));
		$tpl->assign("BACK_LINK",$GLOBALS['CAL_REFERER'][2]);
		$tpl->assign("L_PRINT","javascript:showPrintDialog('list_l');");


		//$this->_day_b=$this->_frm->getPrefs('cal',"db_h")*60+$this->_frm->getPrefs('cal',"db_m");;
		//$this->_day_e=$this->_frm->getPrefs('cal',"de_h")*60+$this->_frm->getPrefs('cal',"db_m");

		$this->_firstPos=($this->_frm->getPrefs('cal',"db_h")*60+$this->_frm->getPrefs('cal',"db_m"))*$this->_minPixels;

		$this->_day_b=0;
		$this->_day_e=23*60+59;

		if ($this->_calUser=='info') {
			$g_events=$this->_Base->listInfos($_evt_beginn,$_evt_end);
			if (is_array($g_events[$_day.'-'.$_month.'-'.$_year])) {
				uasort ($g_events[$_day.'-'.$_month.'-'.$_year],array('CalEvent',"daycmp"));
				foreach ($g_events[$_day.'-'.$_month.'-'.$_year] as $val) {
					if ($val['TimeMode']!=1 && date("H",$val["EndDate"])*60+date("i",$val["EndDate"])<=($this->_day_b+60)) {
						$this->_day_b=min($this->_day_b,date("H",$val["StartDate"])*60+date("i",$val["StartDate"]));
					}
					if ($val['TimeMode']!=1 && date("H",$val["StartDate"])*60+date("i",$val["StartDate"])>=($this->_day_e-60)) {
						$this->_day_e=max($this->_day_e,date("H",$val["EndDate"])*60+date("i",$val["EndDate"]));
					}
				}
			} else {
				$g_events[$_day.'-'.$_month.'-'.$_year]=array();
			}
		}
		$p_events=$this->_Base->listEvents($_evt_beginn,$_evt_end);
		if (is_array($p_events[$_day.'-'.$_month.'-'.$_year])) {
			uasort ($p_events[$_day.'-'.$_month.'-'.$_year],array('CalEvent',"daycmp"));
			foreach ($p_events[$_day.'-'.$_month.'-'.$_year] as $val) {
				if ($val['TimeMode']!=1 && date("H",$val["EndDate"])*60+date("i",$val["EndDate"])<=($this->_day_b+60)) {
					$this->_day_b=min($this->_day_b,date("H",$val["StartDate"])*60+date("i",$val["StartDate"]));
				}
				if ($val['TimeMode']!=1 && date("H",$val["StartDate"])*60+date("i",$val["StartDate"])>=($this->_day_e-60)) {
					$this->_day_e=max($this->_day_e,date("H",$val["EndDate"])*60+date("i",$val["EndDate"]));
				}
			}
		} else {
			$p_events[$_day.'-'.$_month.'-'.$_year]=array();
		}
		$this->_day_b=floor($this->_day_b/60)*60;
		$this->_day_e=ceil($this->_day_e/60)*60;

		for ($i=$this->_day_b;$i<$this->_day_e;$i+=60) {
			$dTime=mktime(floor($i/60),$i%60,0,$_month,$_day,$_year);
			$tpl->assign('L_TIME','index.php?site=cal.php&action=insert&view=event&date='.$dTime);
			$tpl->assign('TIME',sprintf('%02d:%02d',floor($i/60),$i%60));
			$tpl->assign('HEIGHT',round($this->_minPixels*60)-1);
			$tpl->parse('ROW','.bg_row_time');
			$tpl->assign('HEIGHT',round($this->_minPixels*30)-1);
			$tpl->assign('ID_1','pt_'.$i);
			$this->_droppable['pt_'.$i]=array(
				'date'=>$dTime,
				'time'=>1,
			);
			$tpl->assign('ID_2','pt_'.($i+30));
			$this->_droppable['pt_'.($i+30)]=array(
				'date'=>$dTime+30*60,
				'time'=>1,
			);
			$tpl->parse('ROW','.bg_row_p');
			if ($this->_calUser=='info') {
				$tpl->parse('ROW','.bg_row_g');
			}

		}
		require_once('lib/class_SimpleListGui.php');
		$this->_nGui=new SimpleListGui();
		$this->_nGui->setClass('cal_list');

		$tpl->assign('DAYP_EVENTS',$this->_parseEvents($p_events[$_day.'-'.$_month.'-'.$_year],'p'));
		$this->parseJsDrop();
		if ($this->_calUser=='info') {
			$tpl->assign('DAYG_EVENTS',$this->_parseEvents($g_events[$_day.'-'.$_month.'-'.$_year],'g'));
			$tpl->parse('ROW','g_events');
		}
		if ($this->_nGui->hasEntries('p') || $this->_nGui->hasEntries('g')) {
			if ($this->_calUser=='info') {
				$tpl->assign('DAYG_NOTES',$this->_nGui->process('','g'));
				$tpl->parse('ROW','g_notes');
			}
			$tpl->assign('DAYP_NOTES',$this->_nGui->process('','p'));
			$tpl->parse('ROW','notes');
		}
		require_once('lib/class_PrintDialogGui.php');
		$printDialogGui=new PrintDialogGui('cal');
		$printDialogGui->process('list_d');

		$this->_frm->addonLoad("e7g_initScroll('#calContent',".($this->_firstPos?($this->_firstPos-1):0).");");

		return $tpl;
	}
	function _parseEvents($events,$evtTyp='p') {
		$result='';
		require_once('lib/class_FastTemplateGui.php');
		$tpl=new FastTemplateGui('cal/view_day_evt.inc.html');
		$tpl->setEncode(false);
		$this->_evtTimeLine=array();
		$this->_belegt=array();
		$this->_evtColors=$this->_Base->listEventColor(array_keys($events));
		foreach ($events as $key=>$val) {
			if (isset($this->_parsedEvent[$key])) continue;
			$this->_parsedEvent[$key]=true;
			if ($val['TimeMode']!=1) {
				if ($evtTyp=='g') {
					//debug($val);
				}
				$min_b=date('H',$val['StartDate'])*60+date('i',$val['StartDate']);
				$min_e=date('H',$val['EndDate'])*60+date('i',$val['EndDate']);
				if ($min_b < $this->_day_b) {
					$min_b=$this->_day_b;
				}
				if ($min_e > $this->_day_e) {
					$min_e=$this->_day_e;
				}


				if ($min_e-$min_b < $this->_minHeight) $min_e=$min_b+$this->_minHeight;
				$px_b=round($min_b*$this->_minPixels);
				$px_h=round(($min_e-$min_b)*$this->_minPixels);
				$rpos=array();
				$parsed=false;
				if (isset($this->_belegt[$px_b])) {
					$akt_pos=count($this->_belegt[$px_b]);
					for ($i=0;$i<=count($this->_belegt[$px_b]);$i++) {
						if (!isset($this->_belegt[$px_b][$i])) {
							if (!$parsed) {
								$akt_pos=$i;
								$parsed=true;
							}
						} else {
							if ($parsed) $rpos[$i]=1;
						}
					}
				} else {
					$akt_pos=0;
				}
				for ($i=$px_b;$i<=($px_b+$px_h);$i++) {
					if (isset($this->_belegt[$i][$akt_pos-1])) {
						for ($j=$akt_pos-1;$j>=0;$j--) {
							if (isset($this->_evtTimeLine[$this->_belegt[$i][$j]])) $this->_evtTimeLine[$this->_belegt[$i][$j]]['rpos'][$akt_pos]=1;
						}
					}
					$this->_belegt[$i][$akt_pos]=$key;
				}
				$max_lpos=max($max_lpos,$akt_pos);
				$this->_evtTimeLine[$key]=array(
					'b'=>$min_b,
					'e'=>$min_e,
					'px_t'=>round(($min_b-$this->_day_b)*$this->_minPixels)-1,
					'px_h'=>round(($min_e-$min_b)*$this->_minPixels)-1,
					'lpos'=>$akt_pos,
					'rpos'=>$rpos,
				);
			} else {
				$evtImg='';
				if ($evtTyp=='g') {
					$title[$key]=($val["NoOwner"]?'':$this->_frm->getCachedUserName($val["OwnerID"],0,1).': ');
					$img="month_all.gif";
				} else {
					$title[$key]='';
					$img=($val['GrantGroups'] || $val['GrantUsers'])?'month_mall.gif':'month_mine.gif';
					if ($this->_frm->getPrefs('cal',"showAlarm") && $events[$key]["AlarmTime"]) {
						$evtImg.='<img src="img/'.APP_THEME.'/alarm.gif" class="list_img" hspace="2" />';
					}
				}

				$params=array();
				$attribs=array();
				$params['LinkAttribs']=$this->_lGui->addEventLayer($val,array('linkAsSting'=>false));
				if (!$val['_Privat'] && $val['OwnerID']==$this->_userID && $this->_Base->getCalPerms(2)) {
					$params['LinkAttribs']['onclick']='return goToView(this);';
					$params['LinkAttribs']['ondblclick']='return goToEdit(this,\'action=view\',\'action=edit&back=0\');';
				}
				$link=$this->_acLink.'&event_id='.$key.'&edate='.$this->_edate;
				$title[$key].='<strong>'.Framework::entities($val["Title"]).'</strong>'.$evtImg;



				$this->_nGui->addContent('devt_'.$key,$title[$key],$evtTyp,$link,$img,$attribs,$params);
			}
		}
		//debug($this->_evtTimeLine);

		//$indent_val=100/($max_lpos+2);//ueberlappend
		$indent_val=100/($max_lpos+1);//nebeneinander

			//debug($indent_val);
		foreach ($this->_evtTimeLine as $key=>$val) {
			$l_indent=$val['lpos']*$indent_val;
			$r_indent=count($val['rpos'])*$indent_val;
			//debug($l_indent);
			$tpl->assign('ID','devt_'.$key);
			$tpl->assign('ID_H','h_devt_'.$key);
			$tpl->assign('STYLE_H','');
			
			$tpl->assign('LINK',$this->_acLink.'&event_id='.$key.'&edate='.$this->_edate);
			if (($val['e']-$val['b']) < 45) {

			}
			$linkAttribs=$this->_lGui->addEventLayer($events[$key]);
			if (!$events[$key]['_Privat'] && $events[$key]['OwnerID']==$this->_userID && $this->_Base->getCalPerms(2)) {
				$linkAttribs.=' onclick="return goToView(this);"';
				$linkAttribs.=' ondblclick="return goToEdit(this,\'action=view\',\'action=edit&back=0\');"';
			}
			//debug($linkAttribs);
			$tpl->assign('LINK_ATTRIBS',$linkAttribs);
			$this->_firstPos=min($this->_firstPos,$val['px_t']+$val['px_h']-round(60*$this->_minPixels));

			$tpl->assign('TOP',$val['px_t']);
			$tpl->assign('HEIGHT',$val['px_h']);
			$tpl->assign('LEFT',$l_indent);
			$tpl->assign('Z_INDEX',$val['lpos']*10);
			//$tpl->assign('WIDTH',99-$l_indent-$r_indent);//ueberlappend
			$tpl->assign('WIDTH',$indent_val-1);//nebeneinander
			if ($evtTyp=='g') {
				if (isset($this->_evtColors[$key]) && trim($this->_evtColors[$key])) {
					$tpl->assign('COLOR_BG',$this->_evtColors[$key]);
				} else {
					$tpl->assign('COLOR_BG','#e9e7e7');
				}
				$tpl->assign('COLOR_TI','#ccc');
				$tpl->assign('COLOR_BD','#999');
			} else {
				if (isset($this->_evtColors[$key]) && trim($this->_evtColors[$key])) {
					$tpl->assign('COLOR_BG',$this->_evtColors[$key]);
					$tpl->assign('COLOR_TI',APP_FG20COLOR);
					$tpl->assign('COLOR_BD',APP_FGCOLOR);
				} elseif ($this->_invit_events[$key]) {
					$tpl->assign('COLOR_BG',$this->_Base->getCfg('cfg/icolor'));
					$tpl->assign('COLOR_TI','#ddc318');
					$tpl->assign('COLOR_BD','#ddc318');
				} elseif ($events[$key]['EvtPrivat'] && $events[$key]['OwnerID']==$this->_userID) {
					$tpl->assign('COLOR_BG','#ffe6cc');
					$tpl->assign('COLOR_TI',APP_FG20COLOR);
					$tpl->assign('COLOR_BD',APP_FGCOLOR);
				} else {
					$tpl->assign('COLOR_BG',APP_FG10COLOR);
					$tpl->assign('COLOR_TI',APP_FG20COLOR);
					$tpl->assign('COLOR_BD',APP_FGCOLOR);
				}
			}

			$evtImg='';
			if ($evtTyp=='g') {
				$Time=($events[$key]["NoOwner"]?'':$this->_frm->getCachedUserName($events[$key]["OwnerID"],0,1).': ');
				$tpl->assign('ID_H','h_devt_'.$key);
			} else {
				$Time='';
				if ($this->_frm->getPrefs('cal',"showAlarm") && $events[$key]["AlarmTime"]) {
					$evtImg.='<img src="img/'.APP_THEME.'/alarm.gif" class="list_img" hspace="2" />';
				}
				if (!$events[$key]['_Privat'] && $events[$key]['OwnerID']==$this->_userID && $this->_Base->getCalPerms(2)) {
					$events[$key]['dayDate']=$this->_edate;
					$this->_draggable['h_devt_'.$key]=$events[$key];
					$tpl->assign('STYLE_H','cursor:move;');
				}
			}

			$tpl->assign('DATE',Framework::entities($Time.date("H:i-",$events[$key]["StartDate"]).date("H:i",$events[$key]["EndDate"])).$evtImg);
			$tpl->assign('TITLE',Framework::entities($events[$key]['Title']));
			$tpl->assign('TEXT',Framework::entities($events[$key]['Text']));

			$result.=$tpl->process();
		}
		
		return $result;

	}
	function parseJsDrop() {
		require_once('lib/cal/class_EventMoveGui.php');
		$Gui=new EventMoveGui();
		$Gui->setStart($this->_viewBeginn);
		$Gui->setEnd($this->_viewEnd);
		$Gui->setView($this->_view);
		$Gui->setDate($this->_date);
		$Gui->setDayUserB(0);
		$Gui->setDayUserE(24*60);
		
		$Gui->setDraggable($this->_draggable);
		$Gui->setDroppable($this->_droppable);
		$Gui->parseJsDrop();
	}
}
?>