<?php
class ViewMonthGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	function ViewMonthGui() {
		global $frm,$t,$T,$E,$L,$P,$Y;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_wd=& $frm->getStaticModul('workday');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_lGui=&$Y;
		$this->_T->loadModul('cal');
		require_once('lib/class_ApplicationTreeGui.php');
		$this->_Gui=new ApplicationTreeGui();
		//$this->_Gui->setTreeWidth(200);
		$this->_dayUserB=$this->_frm->getPrefs('cal',"db_h")*60+$this->_frm->getPrefs('cal',"db_m");;
		$this->_dayUserE=$this->_frm->getPrefs('cal',"de_h")*60+$this->_frm->getPrefs('cal',"db_m");
	}
	function _handleRequest() {
		$this->_date=Framework::getParam('date',time());
		if (!$this->_date) $this->_date=time();
		$this->_calUser=$GLOBALS['CAL_USER'];
		$this->_view=Framework::getParam('view','month');

		if (Framework::getParam('print',0)) {
			if (Framework::getParam('sid')) {
				require('lib/cal/class_ViewFinderGui.php');
				$fGui=new ViewFinderGui(array('forceView'=>'m','getOnlyView'=>true));
				$fGui->process();
			} else {
				$this->getMonthViewGui(true);
				exit;
			}
		} else {
			if ($this->_frm->getPrefs('cal','showTasks') && $this->_Base->getUser()==$this->_frm->getUser()) {
				require_once("lib/task/class_TaskActualGui.php");
				$this->_TaskGui=new TaskActualGui();
			}

			$sCalGui=& $this->getSmallCalGui();
			$this->_Gui->addTreeContent($sCalGui);

			require_once("lib/cal/class_CalListGui.php");
			$listGui=new CalListGui();
			$this->_invit_events=& $listGui->getInvitEvents();
			$invitGui=& $listGui->getInvitGui();
			if (is_object($invitGui)) {
				$this->_Gui->addTreeContent($invitGui);
			}
			$actGui=& $listGui->getActualGui();
			if (is_object($actGui)) {
				$this->_Gui->addTreeContent($actGui);
			}
			$finderGui=& $listGui->getFinderGui();
			if (is_object($finderGui)) {
				$this->_Gui->addTreeContent($finderGui);
			}
			if (is_object($this->_TaskGui)) {
				$sTaskGui=$this->_TaskGui->processActualGui(true);
				if (is_object($sTaskGui)) {
					$this->_Gui->addTreeContent($sTaskGui);
				}
			}
			if (Framework::getParam('sid')) {
				require('lib/cal/class_ViewFinderGui.php');
				$fGui=new ViewFinderGui(array('forceView'=>'m','getOnlyView'=>true,'linkBreak'=>$this->_L->getTempLink(array('sid'))));
				if ($Gui=$fGui->process()) {
					$this->_Gui->addContent($Gui,null,null);
				}
			} else {
				$wGui=& $this->getMonthViewGui();
				$this->_Gui->addContent($wGui,null,null);
				$this->parseJsDrop();
			}
		}
	}
	function &process() {
		$this->_handleRequest();
		return $this->_Gui;
	}
	function &getSmallCalGui() {
		require_once("lib/cal/class_SmallCal.php");
		$SmallCalGui=new SmallCalGui();
		$SmallCalGui->setMode('M');
		$SmallCalGui->setDate($this->_date);
		$SmallCalGui->setNavLink("index.php?site=cal.php&action=view&view=month");
		$SmallCalGui->setAccessLink("index.php?site=cal.php&action=view&view=month");
		return $SmallCalGui->process();
	}
	function parseJsDrop() {
		require_once('lib/cal/class_EventMoveGui.php');
		$Gui=new EventMoveGui();
		$Gui->setStart($this->_viewBeginn);
		$Gui->setEnd($this->_viewEnd);
		$Gui->setView($this->_view);
		$Gui->setDate($this->_date);
		$Gui->setDraggable($this->_draggable);
		$Gui->setDroppable($this->_droppable);
		$Gui->parseJsDrop();
	}
	function &getMonthViewGui($print=false) {
		require_once('lib/class_FastTemplateGui.php');
		$Gui=new FastTemplateGui('cal/view_month.inc.html');
		$Gui->setEncode(false);
		$Gui->assign("L_PRINT","javascript:showPrintDialog('list_l');");

		$_day=date("d",$this->_date);
		$_month=date("n",$this->_date);
		$_year=date("Y",$this->_date);
		$_days=date("t",$this->_date);

		$this->_viewBeginn=$_beginn=mktime (0,0,0,$_month,1,$_year);
		$this->_viewEnd=$_end=mktime (23,59,59,$_month,$_days,$_year);

		if ($print) {
			require_once('lib/cal/class_CalPrintGui.php');
			$printGui=new CalPrintGui(array(
				'TplID'=>intval(Framework::getParam('printTpl','','G'))?Framework::getParam('printTpl','','G'):'list_m',
				'TimeStart'=>$this->_viewBeginn,
				'TimeEnd'=>$this->_viewEnd,
				'CalUserID'=>$this->_Base->getUser(),
				'CalUserName'=>$this->_frm->getCachedUserName($this->_Base->getUser(),0,1),
				'ShowPrivate'=>1,
				'ShowTeam'=>($this->_calUser=='info'),
				'ShowTeamUsers'=>0,
			));
			$CalUsers=array();
			if ($printGui->getOption('ShowPrivate')) {
				$CalUsers['u_'.$this->_Base->getUser()]=array(
					'Typ'=>'u',
					'ID'=>$this->_Base->getUser(),
					'Name'=>$this->_frm->getCachedUserName($this->_Base->getUser(),0,1),
				);
				$printGui->setEntries($this->_Base->listEvents($this->_viewBeginn,$this->_viewEnd),'u_'.$this->_Base->getUser());
			}
			if ($printGui->getOption('ShowTeam')) {
				if ($printGui->getOption('ShowTeamUsers')) {
					$g_events_all=$this->_Base->listGroupEvents($this->_viewBeginn,$this->_viewEnd);
					foreach ($g_events_all as $guid=>$g_events) {
						if ($tmpName=$this->_frm->getCachedUserName($guid)) {
							$CalUsers['u_'.$guid]=array(
								'Typ'=>'u',
								'ID'=>$guid,
								'Name'=>$tmpName,
							);
							$printGui->setEntries($g_events,'u_'.$guid);
						}
					}
				} else {
					$CalUsers['info']=array(
						'Typ'=>'info',
						'ID'=>0,
						'Name'=>$this->_T->lang('[[Teamkalender]]'),
					);
					$printGui->setEntries($this->_Base->listInfos($this->_viewBeginn,$this->_viewEnd),'info');
				}
			}
			$printGui->setOption('CalUsers',$CalUsers);
			$printGui->printList();
		}

		$_wday=date("w",$_beginn)-1;
		if ($_wday<0) $_wday=6;
		$_aktdate=mktime(23,59,59);

		$Gui->assign("PREV_LINK","index.php?site=cal.php&action=view&view=month&date=".mktime(0,0,0,$_month-1,1,$_year));
		$Gui->assign("NEXT_LINK","index.php?site=cal.php&action=view&view=month&date=".mktime(0,0,0,$_month+1,1,$_year));
		$Gui->assign("SEL_MONTH",strftime("%B %Y",$_beginn));
		for($i=1;$i<8;$i++) {
			$Gui->assign("WEEK$i",strftime("%A",mktime(0,0,0,1,$i,2001)));
		}



		$p_events=$this->_Base->listEvents($_beginn,$_end);
		if ($this->_calUser=='info') {
			$g_events=$this->_Base->listInfos($_beginn,$_end);
		} else {
			$g_events=array();
		}
		if (is_object($this->_TaskGui)) {
			$numTasks=$this->_TaskGui->loadCalGui($_beginn-1,$_end,$this->_frm->getPrefs('cal','showTasksDone'));
		}
		require_once('lib/class_PrintDialogGui.php');
		$printDialogGui=new PrintDialogGui('cal');
		$printDialogGui->process('list_m');

		require_once('lib/cal/class_DayListGui.php');
		$dayListGui=new DayListGui();
		$dayListGui->setUserID($this->_Base->getUser());
		$dayListGui->setPrivateEvents($p_events);
		$dayListGui->setGroupEvents($g_events);
		$dayListGui->setInvitEvents($this->_invit_events);
		$dayListGui->setAccessLink("index.php?site=cal.php&action=view&view=event&date=".$this->_date);
		$dayListGui->setParseDragDrop(true);
		$dayListGui->setIdPrepend('drag');

		if (($_wday+$_days)>35) $cells=42; else $cells=35;
		$a="";$cell=1;
		$Gui->assign("DAY_TEXT",'&nbsp;');
		$Gui->assign("EXTRA",'');
		$Gui->assign("TDAY",'');
		$Gui->assign("DAY_ADD","");
		$Gui->assign("DAY_NUM","");
		$Gui->assign("DAY_COLOR","background-color:#ececec;");
		for($cell;$cell<=$_wday;$cell++) {
			$Gui->parse("COL",$a."month_col_num");
			$Gui->parse("COL",$a."month_col_text");
			if ($numTasks) {
				$Gui->parse("COL",$a."month_task_col");
			}
			$a=".";
		}
		$dayHasEntries=array();
		for($cell;$cell<=($_days+$_wday);$cell++){
			$_day_b=mktime(0,0,0,$_month,$cell-$_wday,$_year);
			$_day_e=mktime(23,59,59,$_month,$cell-$_wday,$_year);
			$_day_add=mktime(intval($this->_dayUserB/60),$this->_dayUserB%60,0,$_month,$cell-$_wday,$_year);
			$_day_str=date('j-n-Y',$_day_b);
			if ($this->_Base->getCalPerms(2)) {
				$Gui->assign("ADD","index.php?site=cal.php&action=insert&view=event&date=".$_day_add);
				$Gui->parse('ROW','add');
			} else {
				$Gui->clear_dynamic('add');
			}
			if ($_aktdate==$_day_e)  {
				$style="background-color:#eaeaea;";
			} else {
				$style="background-color:".APP_BGCOLOR.';';
			}
			if (!$this->_wd->is_workday($_day_b)) {
				$style.='color:red;';
				$extra='onmouseover="'.$this->_lGui->getFunctionOn('holy_'.$cell).'" onmouseout="'.$this->_lGui->getFunctionOff('holy_'.$cell).'"';
				$Gui->assign("EXTRA",$extra);
				$this->_lGui->addLayer('holy_'.$cell,'<strong>'.Framework::entities($this->_wd->get_name()).'</strong>','text');
			} else {
				$Gui->assign("EXTRA",'');
			}
			$Gui->assign("DAY_COLOR",$style);

			$Gui->assign("VIEW","index.php?site=cal.php&action=view&view=day&old_view=".$this->_view."&date=".$_day_b);
			$Gui->assign("DAY_NUM",strftime("%d",$_day_b));

			$dayListGui->processDay($_day_b,$_day_e,'');
			$dayCont=$dayListGui->getDayList($_day_b);
			$Gui->assign("DAY_TEXT",$dayCont?$dayCont:'&nbsp;');
			$Gui->assign('DAYID','day_'.$_day_b);
			$this->_droppable['day_'.$_day_b]=$_day_b;
			$Gui->parse("COL",$a."month_col_num");
			$Gui->parse("COL",$a."month_col_text");

			if ($numTasks) {
				$Gui->assign('TDAY',$this->_TaskGui->processCalGui($_day_str));
				$Gui->parse("COL",$a."month_task_col");
			}
			$a=".";
			if ($cell%7==0) {
				$Gui->assign("CAL_WEEK","<a href=\"index.php?site=cal.php&action=view&view=week&date=$_day_b\">".strftime("%V",$_day_b)."</a>");
				if ($numTasks) {
					$Gui->parse("ROW","month_task_row");
				}
				$Gui->parse("ROW",".month_row_det");
				$a="";
			}

		}
		$Gui->assign("EXTRA",'');
		$Gui->assign("DAY_ADD","");
		$Gui->assign("DAY_NUM","");
		$Gui->assign("DAY_TEXT",'&nbsp;');
		$Gui->assign("DAY_COLOR","background-color:#ececec;");
		$Gui->assign('TDAY','');
		for($cell;$cell<=$cells;$cell++) {
			$Gui->parse("COL",$a."month_col_num");
			$Gui->parse("COL",$a."month_col_text");
			if ($numTasks) {
				$Gui->parse("COL",$a."month_task_col");
			}
			$a=".";
		}
		if ($a==".") {
				$Gui->assign("CAL_WEEK","<a href=\"index.php?site=cal.php&action=view&view=week&date=$_day_b\">".strftime("%V",$_day_b)."</a>");
				if ($numTasks) {
					$Gui->parse("ROW","month_task_row");
				}
				$Gui->parse("ROW",".month_row_det");
		}
		$this->_draggable=$dayListGui->getDraggable();
		$this->_frm->addonLoad("e7g_initScroll('#calContent',0);");
		return $Gui;
	}

}
?>