<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
//$fp=fopen('/tmp/log.txt','a');
//fwrite($fp,date('H:s:i')."\n");
$cal=& $frm->getStaticModul('cal');
$cal->setAuthUser(0);
$alDate=time();
$events=$cal->listcronAlarms($alDate);
//print_r($events);
//exit;
//fwrite($fp,print_r($events,true));
if (!empty($events)) {
	$c_msg=& $frm->getStaticModul('msg');
	foreach ($events as $key=>$val) {
		$send_user=array();
		$user_done=$cal->readEventDone($key,'u');
		foreach ($user_done as $ukey=>$uval) {
			if ($uval==2) continue;
			if (!isset($users[$ukey])) {
				$ulang[$ukey]=$frm->getPrefs('global','lang',$ukey);
				if (!$ulang[$ukey]) $ulang[$ukey]='de';
				$tmp=$frm->read_user($ukey);
				$users[$ukey]=$tmp;
			}
			if (!$users[$ukey] || $users[$ukey]['perms']==='deleted' || $users[$ukey]['perms']==='system') continue;

			$send_user[$ulang[$ukey]][]=$ukey;
			//fwrite($fp,"EventID:$key - User:".$users[$ukey]['lastname'].' '.$users[$ukey]['firstname']."\n");
		}
		if (!empty($send_user)) {
			$i_users=array();
			$iv_users=array();
			if (trim($val['InvitUsers'])) $i_users=array_merge($i_users,explode(',',$val['InvitUsers']));
			if (trim($val['InvitGroups'])) {
				$tmpUsers=$frm->getGroupUsers(explode(',',$val['InvitGroups']));
				if ($tmpUsers && !empty($tmpUsers)) $i_users=array_merge($i_users,$tmpUsers);
			}
			if (!empty($i_users)) $iv_users=$frm->getFullName($i_users,0,1);
			if ($val['InvitAddr']) {
				if (!is_object($Addr)) $Addr=& $frm->getStaticModul('addr');
				$Addr->setUser($val['OwnerID']);
				$InvitAddr=explode(',',$val['InvitAddr']);
				foreach ($InvitAddr as $aval) {
					if ($address=$Addr->getAddrObj($aval)) {
						//print_r($address->getName(1));
						$iv_users[]=$address->getName(1);
					}
				}
			}
			//echo implode(', ',$iv_users);
			$log_tras=array(
					'{EDATE}'=>$cal->formatDate($val['StartDate'],$val['EndDate'],$val['TimeMode']),
					'{ETITLE}'=>trim($val['Title']),
					'{EPLACE}'=>trim($val['Place']),
					'{ETEXT}'=>trim($val['Text']),
					'{EUSER}'=>(is_array($iv_users)?implode(', ',$iv_users):''),
				);
			$link="?site=cal.php&action=view&view=event&event_id=$key";
			$link_title=$val['Title'];

			foreach ($send_user as $lang=>$send_to)  {
				$T->setLang($lang);
				$T->loadModul('cal');
				$s_subject=strtr($T->lang('[[action_notify_title]]'),$log_tras);
				$s_body=strtr($T->lang('[[action_notify_text]]'),$log_tras);

				$msg=new ObjMsgMessage();
				$msg->setMeta('msg_sendid',0);
				$msg->setMeta('msg_userid',$val['OwnerID']);
				$msg->setMeta('msg_from',$users[$val['OwnerID']]['lastname'].' '.$users[$val['OwnerID']]['firstname']);
				$msg->setMeta('msg_subject',$s_subject);
				$msg->setMeta('msg_message',$s_body);
				$msg->setMeta('msg_image',$cal->getCfg('cfg/img_alarms'));
				$msg->setMeta('msg_to','u_'.implode(',u_',$send_to));
				$msg->setMeta('msg_link',$params['msg_link']);
				$msg->setMeta('msg_link',json_encode(array(
					0=>array('N'=>$link_title,'U'=>"index.php".$link),
				)));
				$c_msg->sendMsgMessage($msg);

			}
		}
	}
	$cal->setSendAlarms(array_keys($events));
}
$cal->setAuthUser($frm->getUser());
?>
