<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$obj_action=$frm->getObjAction($cal->getModul(),'evt');
if ($cal->isAllowedAction($obj,$obj_action[$obj_action_val])) {
	$location='';
	switch ($obj_action_val) {
		case 'delete':
		case 'delete_a':
			$cal->deleteEventObject($obj);
			$location=$CAL_REFERER[0];
			break;
		case 'delete_o':
			$cal->deleteEventObject($obj,1);
			$location=$CAL_REFERER[0];
			break;
		case 'modify':
			$location="index.php?site=$site&view=event&action=edit&event_id=".$obj['EventID']."&edate=$edate";
			break;
		case 'copy':
			$location="index.php?site=$site&view=event&action=copy&event_id=".$obj['EventID']."&edate=$edate";
			break;
		case 'new':
			$location="index.php?site=$site&view=event&mode=tpl&action=e_new&event_id=".$obj['EventID'];
			break;
			
		case 'disinvite':
			$cal->deleteEventDone($obj['EventID'],'u',$cal->getUser());
			if ($obj['Message']) {
				$log_tras=array(
					'{EDATE}'=>$cal->formatDate($obj['StartDate'],$obj['EndDate'],$obj['TimeMode']),
					'{ETITLE}'=>trim($obj['Title']),
					'{EPLACE}'=>trim($obj['Place']),
					'{ETEXT}'=>trim($obj['Text']),
					'{TEXT}'=>'',
				);
				$frm->sendmessage(array($obj['OwnerID']),
					$cal->getUser(),
					strtr($T->lang('[[action_disinvite_title]]'),$log_tras),
					strtr($T->lang('[[action_disinvite_text]]'),$log_tras),
					"?site=cal.php&action=view&view=event&edate=".Framework::getParam('edate')."&event_id=".$obj['EventID'],
					$obj['Title'],
					$cal->getCfg('cfg/img_notes'));
			}
		break;
		case 's_msg':
			$target='';
			$msg_Link=array(
				0=>array(
					'U'=>"index.php?site=$site&action=$action&view=$view&edate=$edate&event_id=".$obj['EventID'],
					'N'=>$obj['Title'],
					'T'=>$target,
				),
			);
			if (!empty($msg_Link)) {
				$msgParams=array(
					'reset'=>1,
					'tab'=>'msg',
				);
				$msgParams['msgLink']=json_encode($msg_Link);
				$frm->addOnload('ge.registry.coreViewMessage.geMsgShow('.(json_encode($msgParams)).');');
			}
		break;
		case 's_mail':
			require_once ("lib/mail/class_MailIcalGui.php");
			$mailIcal=new MailIcalGui();
			$mailText=$mailIcal->getCalText($obj,'invit',array('{CUSER}'=>$CAL_USER_N,'{TEXT}'=>trim($comment)),true);

			$frm->setUserData('mail',1,$mailText['subject']);
			$frm->setUserData('mail',2,$mailText['body']);

			$Fname='invite.ics';
			$f_url=tempnam(Framework::getTempPath(),'ical');
			$fp=fopen($f_url,'w');
			fwrite($fp,$mailIcal->createCard($obj,'REQUEST'));
			fclose($fp);
			//debug($VcalWrite->getVcal($Vcal->event2vcal($obj),'VEVENT','2.0'));
			$location="index.php?site=mail.php&show=compose&a=new&getUserSubject=1&getUserBody=2&clearMail=1&f_name=".urlencode($Fname)."&f_url=".urlencode($f_url).'&f_type='.urlencode('application/ics');
			if ($mail_to) {
				$frm->setUserData('mail',3,$mail_to);
				$location.="&getUserTO=3";
			}
			$GLOBALS['SESS_MDATA']['mail.php']['L_BACK']=array(0=>$L->getTempLink(array('obj_action_val','obj_action_x','mail_to')));
		break;
		case 'undelete':
			$cal->undeleteEvent($obj['EventID']);
			$location=$CAL_REFERER[0];
		break;
	}
	if ($location) {
		page_close();
		header('Location:'.$location);
		exit;
	}
}
?>
