<?php
class ContentGui {
	var $_T;
	var $_t;
	var $_tpl='core/common_content.inc.html';
	var $_image='loc.gif';
	var $_tabs=array();
	var $_colspan=2;
	var $_title_width='254';
	var $_bg_color=APP_FG20COLOR;
	var $_bd_color=APP_FGCOLOR;
	var $_tab_toggle=0;
	var $_cont_style='';
	var $_ID='';
	function ContentGui($tpl='') {
		global $T;
		$this->_T=&$T;
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
		if ($tpl) $this->_tpl=$tpl;
	}
	function setName($name,$width='') {
		$this->_name=$name;
		if ($width) $this->_title_width=$width;
	}
	function setWidth($width=0) {
		$this->_table_width=$width;
	}
	function setImage($img) {
		$this->_image=$img;
	}
	function setColors($bg,$bd) {
		$this->_bg_color=$bg;
		$this->_bd_color=$bd;
	}
	function setToggle($key,$hide=0) {
		$this->_tab_toggle=array($key,$hide);		
	}
	function addFunction(&$obj) {
		$this->_header_functions[]=&$obj;
	}
	function addContent(&$obj,$params= null,$style='') {
		$this->_content[]=array(
			'Content'=>&$obj,
			'Params'=>$params,
			'Style'=>$style,
		);
	}
	function addTab($ID,$Name='',$Link='',$Image='',$On=false) {
		$this->_tabs[$ID]=array(
			'Name'=>$Name,
			'Link'=>$Link,
			'Image'=>$Image,
			'On'=>$On,
		);
	}
	function addTabSpacer() {
		$this->_tabs[]=1;
	}
	function setTabOn($ID) {
		if (isset($ID)) $this->_tabs[$ID]['On']=true;
	}
	function setTabOff($ID) {
		if (isset($ID)) $this->_tabs[$ID]['On']=false;
	}
	function processHeader() {
		if ($this->_table_width) $this->_t->assign('TABLE_WIDTH',$this->_table_width); else $this->_t->assign('TABLE_WIDTH','');
		if (!$this->_ID) $this->_ID=bin2hex(rand(0,65535));
		$this->_t->assign('ID',$this->_ID);
		$this->_t->clear_dynamic('content_header_tab');
		foreach ($this->_tabs as $ID=>$val) {
			if (is_array($val)) {
				$this->_t->clear_dynamic('content_header_space_tab');
				$this->_t->assign('NAME',Framework::entities($val['Name']));
				if ($val['Image']) {
					$this->_t->assign('IMAGE',$val['Image']);
					$this->_t->parse('ROW','content_header_tab_img');
				} else {
					$this->_t->clear_dynamic('content_header_tab_img');
				}
				if ($val['On']) {
					$this->_t->assign('C_LINK','tab_on');
				} else {
					$this->_t->assign('C_LINK','');
				}
				if ($val['Link']) {
					$this->_t->assign('LINK',htmlspecialchars($val['Link']));
				} else {
					$this->_t->assign('LINK','#');
				}
				$this->_t->parse('ROW','content_header_app_tab');
			} else {
				$this->_t->clear_dynamic('content_header_app_tab');
				$this->_t->parse('ROW','content_header_space_tab');
			}
			$this->_colspan+=1;
			$this->_t->parse('ROW','.content_header_tab');
		}
		if (is_array($this->_header_functions)) {
			foreach ($this->_header_functions as $val) {
				$this->_t->assign('HEADER_FUNCTION',$val->process());
				$this->_t->parse('ROW','.content_header_func');
			}

		}
		$this->_t->assign('NAME',Framework::entities($this->_name));
		if ($this->_tab_toggle && $this->_ID) {
			if ($this->_tab_toggle[1]) {
				$this->_t->assign('IMAGE','menu/wdown.gif');
				$this->_cont_style.='height:1px;overflow:hidden';
			} else {
				$this->_t->assign('IMAGE','menu/wup.gif');
			}
			$this->_t->assign('DATA_TOGGLE',$this->_tab_toggle[0]);
		} else {
			$this->_t->assign('DATA_TOGGLE','');
			$this->_t->assign('IMAGE',Framework::entities($this->_image));
		}
		
		$this->_t->assign('TITLE_WIDTH',$this->_title_width);
		$this->_t->assign('BG_COLOR',$this->_bg_color);
		$this->_t->assign('BD_COLOR',$this->_bd_color);
		$this->_t->parse('ROW','content_header');
	}
	function processContent() {
		$this->_t->assign('CONT_STYLE',$this->_cont_style);
		if (is_array($this->_content)) {
			$parse=false;
			foreach ($this->_content as $val) {
				$this->_t->assign('COLSPAN',$this->_colspan);
				$this->_t->assign('STYLE',$val['Style']);
				if (is_object($val['Content'])) {
					$this->_t->assign('CONTENT',call_user_func_array(array(&$val['Content'],'process'),is_array($val['Params'])?$val['Params']:array()));
				} else {
					$this->_t->assign('CONTENT',$val['Content']);
				}
				$this->_t->parse('ROW','.content_content');
				$parse=true;
			}
			if ($parse && $this->_t->issetKey('content_body')) {
				$this->_t->parse('ROW','content_body');
			}
			

		}
	}
	function process($handle='') {
		if (!$handle) {
			$handle='application_content';
			$return=true;
		} else {
			$return=false;
		}
		$this->_t->setRoot('tpl/'.APP_THEME);
		$this->_t->define (array($handle => $this->_tpl));
		$this->processHeader();
		$this->processContent();
		if ($return) {
			$this->_t->parse('TPL_TEMP',$handle);
			return $this->_t->getParsed();
		}
	}
}
?>