<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class ObjCoreSearch extends baseObj {
	var $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['sTitle'];
	}
	function getImage($open=0) {
		return 'user.gif';
	}
}

class CoreSearch extends ObjCore {
	var $_modul='core';
	var $_table='CoreSearch';
	var $_cfgObjects=array (
		'IdField'=>'sID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'sUsers',
		'GroupField'=>'sGroups',
		'OwnerField'=>'sOwner',
		'TranslationFields'=>array(),
		'0'=>array(
			'ClassName'=>'ObjCoreSearch',
			'Fields'=>array(
				'sID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'FKModulID'=>array(
					'Typ'=>'core',
				),
				'sTitle'=>array(
					'Typ'=>'core',
				),
				'sData'=>array(
					'Typ'=>'core',
				),
				'sOwner'=>array(
					'Typ'=>'core',
				),
				'sUsers'=>array(
					'Typ'=>'core',
				),
				'sGroups'=>array(
					'Typ'=>'core',
				),
			),
		),
	);

	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule(false);
		$this->setSuperAdmin(false);
	}
	function insertObj(&$Obj) {
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		return $this->deleteMeta($Obj);
	}
	function listObj($FKModul,$order='sTitle ASC') {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKModulID','Typ'=>'=','Values'=>$FKModul);
		$rows=0;
		return $this->searchObj($rows,$searchQuery,$order);
	}
}
?>