<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class CronJobs {
	var $_db;
	var $_uid;
	var $_lang;
	var $_rule=false;
	var $_sadmin=false;
	function CronJobs () {
		global $db,$frm;
		$this->_db=&$db;
		$this->_frm=&$frm;
	}
	function getJobs() {
		$query="SELECT * FROM CronJobs ORDER BY cronSequence";
		$this->_db->query($query);
		$result=array();
		while ($this->_db->next_record()) {
			$result[]=array (
				'cronName'=>$this->_db->f('cronName'),
				'cronApp'=>$this->_db->f('cronApp'),
				'cronTime'=>$this->_db->f('cronTime'),
				'cronParams'=>$this->_db->f('cronParams'),
			);
		}
		return $result;
	}
	function insertExecute($job,$user) {
		$insert=array(
			'FKcronName'=>$job['cronName'],
			'FKUserID'=>$user,
			'cronTime'=>time(),
		);
		$this->_db->insert ('CronJobsUser',$insert,0,1);
	}
	function isToExecute($job,$user) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKcronName','Typ'=>'=','Values'=>$job['cronName']);
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$user);

		$query="SELECT cronTime FROM CronJobsUser WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			if ($this->_db->f('cronTime')<(time()-$job['cronTime'])) {
				return true;
			} else {
				return false;
			}

		}
		return true;
	}
}