<?php
class ExportDialogGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_defConfig=array();
	var $_defChecked='0';
	var $_defLinkParams=array();
	function __construct() {
		global $frm,$t,$T,$E,$L;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
	}
	function setDefaultChecked($val) {
		$this->_defChecked=$val;
	}
	function setDefaultConfig($id='0',$name='') {
		$this->_defConfig[$id]=array(
			'n'=>$name,
		);
	}
	function setDefaultLinkParams($val) {
		$this->_defLinkParams=$val;
	}
	function process() {
		require_once('lib/class_FastTemplateGui.php');
		$resGui=new FastTemplateGui('core/export_dialog.inc.html');
		$resGui->setEncode(false);
		if (empty($this->_defConfig)) {
			$config=array(
				'csv'=>array(
					'n'=>$this->_T->lang('[[CSV]]'),
				)
			);
		} else {
			$config=$this->_defConfig;
		}

		//debug($config);
		$rows=count($config)-1;
		$resGui->assign('DIALOG_CFG',Framework::array2json($config));
		$resGui->assign('DIALOG_CHK',$this->_defChecked);

		$resGui->assign('NUM_ENTRIES',$rows);
		$this->_defLinkParams['export']=1;
		$this->_defLinkParams['_loadSearch']=1;
		$resGui->assign('LINK',$this->_L->getTempLink(null,$this->_defLinkParams));
		$this->_frm->addScript($resGui);
		$this->_frm->initExtJs();
	}
}
?>