<?php
class FastTemplateGui {
	var $_t;
	var $_encode=true;
	function FastTemplateGui($tpl='') {
		global $T;
		$this->_T=&$T;
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
		$this->_t->setRoot('tpl/'.APP_THEME);
		if ($tpl) $this->_t->define (array('templateContent' =>$tpl));
	}
	function define($params) {
		$this->_t->define($params);
	}
	function setRoot($params) {
		$this->_t->setRoot($params);
	}
	function setEncode($val) {
		$this->_encode=$val;
	}
	function assign($key,$val,$params=null,$nl2br=false) {
		if (is_array($val)) {
			$this->_t->assign($key,call_user_func_array($val,is_array($params)?$params:array()));
		} elseif (is_object($val)) {
			$this->_t->assign($key,$val->process($params));
		} else {
			if ($this->_encode) $val=Framework::entities($val);
			if ($nl2br) $val=nl2br($val);
			$this->_t->assign($key,$val);
		}
	}
	function parse($key,$val) {
		$this->_t->parse($key,$val);
	}
	function clear_dynamic($key) {
		$this->_t->clear_dynamic($key);
	}
	function issetkey($key) {
		return $this->_t->issetkey($key);
	}
	function process($handle='') {
		if ($handle) {
			$this->_t->parse('TPL_TEMP',$handle);
		} else {
			$this->_t->parse('TPL_TEMP','templateContent');
		}
		return $this->_t->getParsed();
	}
}
?>