<?php
class FunctionButtons {
	var $_T;
	var $_t;
	var $_tpl_function='core/function_buttons.inc.html';
	function FunctionButtons($ID='',$Type='',$params=null) {
		global $T;
		$this->_T=&$T;
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
		$this->_id=$ID;
		$this->_type=$Type;
		$this->_params=$params;
	}
	function setID($name) {
		$this->_id=$name;
	}
	function setType($name) {
		$this->_type=$name;
	}
	function setParams($params) {
		$this->_params=$params;
	}
	function process($handle='') {
		if (!$handle) {
			$handle='TPL_TEMP';
			$return=true;
		} else {
			$return=false;
		}
		$this->_t->define (array('function_button' => $this->_tpl_function));
		$this->_t->assign('ID',$this->_id);
		switch($this->_type) {
			case 'save':
				$this->_t->parse($handle,'function_button_save');
			break;
			case 'save_new':
				$this->_t->parse($handle,'function_button_save_new');
			break;
			case 'fastsearch':
				$this->_t->parse($handle,'function_button_fastsearch');
			break;
			case 'ajaxsearch':
				$extra='';
				if ($this->_params['UrlParams']) {
					foreach ($this->_params['UrlParams'] as $key=>$val) {
						$extra.='&'.$key.'='.urlencode($val);
					}
				}
				$this->_t->assign('LABEL',$this->_params['Label']);
				$this->_t->assign('VALUE',Framework::getParam($this->_id,$this->_params['Default']));
				$this->_t->assign('FUNC_AJAX',"window.setTimeout('sndReq(\'".$this->_id."\',\'ajax.php\',\'ajax_modul=".$this->_params['Modul']."$extra&\' + formToString(\'daten\'),true)',100)");
				$this->_t->parse($handle,'function_button_ajaxsearch');
			break;
			case 'break':
				if ($this->_params['LINK']) {
					$this->_t->assign('LINK',htmlspecialchars($this->_params['LINK']));
				} else {
					$this->_t->assign('LINK','#');
				}
				$this->_t->parse($handle,'function_button_break');
			break;
			case 'image':
				$this->_t->assign('TARGET',htmlspecialchars($this->_params['TARGET']));
				$this->_t->assign('IMG',htmlspecialchars($this->_params['IMG']));
				$this->_t->assign('LINK',htmlspecialchars($this->_params['LINK']));
				$this->_t->assign('TITLE',htmlspecialchars($this->_params['TITLE']));
				$this->_t->parse($handle,'function_button_image');
			break;
			case 'ajaxttiplabel':
				$extra='';
				$this->_t->clear_dynamic('function_ajax_ttip_label');
				if ($this->_params['Values']) {
					foreach ($this->_params['Values'] as $key=>$val) {
						$this->_t->assign('LABEL',$val['Label']);
						$this->_t->assign('LABEL_SEP',$val['LabelSep']);
						$this->_t->assign('FUNC_AJAX',"startManualAjaxTip('".$this->_id."','".$val['mode']."','".$val['app']."','".$val['params']."','".$val['FieldVal']."','".$val['jsSetFunction']."');return false;");
						$this->_t->parse($handle,'.function_ajax_ttip_label');
						$i++;
					}
				}
			break;
			case 'js_label':
				$extra='';
				$this->_t->clear_dynamic('function_js_label');
				if ($this->_params) {
					foreach ($this->_params as $key=>$val) {
						$this->_t->assign('LABEL',$val['Label']);
						$this->_t->assign('LABEL_SEP',$val['LabelSep']);
						$this->_t->assign('JS_LINK',$val['JsFunction'].';return false;');
						$this->_t->parse($handle,'.function_js_label');
						$i++;
					}
				}
				$this->_t->parse($handle,'function_js_label');
			break;
			case 'selectall':
				$this->_t->assign('LIST_ID',$this->_params['ListID']);
				if ($this->_params['ListOn']) {
					$this->_t->assign('DISPLAY_ALL','none');
					$this->_t->assign('DISPLAY_NONE','block');
				} else {
					$this->_t->assign('DISPLAY_ALL','block');
					$this->_t->assign('DISPLAY_NONE','none');
				}
				$this->_t->parse($handle,'function_button_selectall');
			break;
			case 'js_link':
				$extra='';
				$this->_t->clear_dynamic('function_js_link');
				$this->_t->assign('ID',$this->_id);
				$this->_t->assign('LABEL',$this->_params['Label']);
				$this->_t->assign('JS_ONCLICK',$this->_params['onClick'].';return false;');
				$this->_t->assign('JS_ONMOUSEOVER',$this->_params['onMouseOver']);
				$this->_t->assign('JS_ONMOUSEOUT',$this->_params['onMouseOut']);
				$this->_t->parse($handle,'function_js_link');
			break;
			case 'button_link':
				$this->_t->clear_dynamic('function_button_link');
				$this->_t->assign('TARGET',htmlspecialchars($this->_params['TARGET']));
				$this->_t->assign('LINK',htmlspecialchars($this->_params['LINK']));
				$this->_t->assign('TITLE',htmlspecialchars($this->_params['TITLE']));
				$this->_t->assign('WIDTH',$this->_params['WIDTH']?$this->_params['WIDTH']:70);
				$this->_t->parse($handle,'function_button_link');
			break;
		}
		if ($return) {
			return $this->_t->getParsed();
		}
	}
}
?>