<?php
class FunctionObjActionGui {
	var $_T;
	var $_t;
	var $_tpl_function='core/function_obj_action.inc.html';
	function FunctionObjActionGui($ID='obj_action',$isListAction=false) {
		global $T;
		$this->_T=&$T;
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
		$this->_id=$ID;
		if ($isListAction) $this->_tpl_function='core/function_list_action.inc.html';
	}
	function setID($name) {
		$this->_id=$name;
	}
	function setValues($values) {
		$this->_values=$values;
	}
	function setName($values) {
		$this->_name=$values;
	}
	function addValue($key,$value) {
		$this->_values[$key]=$value;
	}
	function process($handle='') {
		$this->_t->setRoot('tpl/'.APP_THEME);
		if (!$handle) {
			$handle='function_obj_action';
			$return=true;
		} else {
			$return=false;
		}
		$this->_t->define (array($handle => $this->_tpl_function));
		$this->_t->clear_dynamic('obj_action_val');
		$this->_t->clear_dynamic('obj_action_name');
		$this->_t->assign('ID',$this->_id);
		if ($this->_name) {
			$this->_t->assign('NAME',Framework::entities($this->_name));
			$this->_t->parse('ROW','obj_action_name');
		}
		if (is_array($this->_values)) {
			foreach ($this->_values as $key=>$val) {
				$this->_t->assign('KEY',htmlspecialchars($key));
				$this->_t->assign('VAL',Framework::entities($val));
				$this->_t->parse('ROW','.obj_action_val');
			}
		}
		if ($return) {
			$this->_t->parse('TPL_TEMP',$handle);
			return $this->_t->getParsed();
		}
	}
}
?>