<?php
class PermsGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_guiCfg=array(
		'permMode'=>0,
		'useSuperGroups'=>0,
		'useGroups'=>1,
		'useUsers'=>1,
		'useRules'=>0,
		'avPerms'=>array(),
		'avPermsShort'=>array(),
		'onlyApp'=>'',
		'tipParams'=>array(),
	);
	function PermsGui($id='') {
		global $frm,$t,$T,$E,$L,$P;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_id=$id;
	}
	function setGuiCfg($val,$ov=false) {
		if ($ov) {
			$this->_guiCfg=$val;
		} else {
			foreach ($val as $k=>$v) {
				$this->_guiCfg[$k]=$v;
			}
		}
	}
	function setAktPerms($typ,$perms,$isAcl=true) {
		if ($isAcl) {
			$this->_aktPerms[$typ]=Framework::aclToArray($perms);
		} else {
			$this->_aktPerms[$typ]=$perms;
		}
	}
	function getAktPerms($typ,$isAcl=true) {
		if ($isAcl) {
			return Framework::arrayToAcl($this->_aktPerms[$typ]);
		} else {
			return is_array($this->_aktPerms[$typ])?$this->_aktPerms[$typ]:array();
		}
	}
	function handleRequest() {
		$this->_update=false;
		if (Framework::getParam($this->_id.'perms_add',0,'P') && Framework::getParam($this->_id.'addPermsID',0,'P') && Framework::getParam('hid_'.$this->_id.'addPermsUser',0,'P')) {
			$permsUsers=explode('|',Framework::getParam('hid_'.$this->_id.'addPermsUser',0,'P'));
			foreach ($permsUsers as $val) {
				$tmp=explode('_',$val);
				if ($tmp[0]=='u' && $this->_guiCfg['useUsers']) {
					if ($this->_guiCfg['permMode']) {
						$this->_aktPerms['Users'][$tmp[1]]=array_sum(Framework::getParam($this->_id.'addPermsID',0,'P'));
					} else {
						$this->_aktPerms['Users'][$tmp[1]]=Framework::getParam($this->_id.'addPermsID',0,'P');
					}
					$this->_update=true;
				}
				if ($tmp[0]=='g' && $this->_guiCfg['useGroups']) {
					if ($this->_guiCfg['permMode']) {
						$this->_aktPerms['Groups'][$tmp[1]]=array_sum(Framework::getParam($this->_id.'addPermsID',0,'P'));
					} else {
						$this->_aktPerms['Groups'][$tmp[1]]=Framework::getParam($this->_id.'addPermsID',0,'P');
					}
					$this->_update=true;
				}
				if ($tmp[0]=='e' && $this->_guiCfg['useSuperGroups']) {
					if ($this->_guiCfg['permMode']) {
						$this->_aktPerms['SuperGroups'][$tmp[1]]=array_sum(Framework::getParam($this->_id.'addPermsID',0,'P'));
					} else {
						$this->_aktPerms['SuperGroups'][$tmp[1]]=Framework::getParam($this->_id.'addPermsID',0,'P');
					}
					$this->_update=true;
				}
				if ($tmp[0]=='r' && $this->_guiCfg['useRules']) {
					if ($this->_guiCfg['permMode']) {
						$this->_aktPerms['Rules'][$tmp[1]]=array_sum(Framework::getParam($this->_id.'addPermsID',0,'P'));
					} else {
						$this->_aktPerms['Rules'][$tmp[1]]=Framework::getParam($this->_id.'addPermsID',0,'P');
					}
					$this->_update=true;
				}
			}
		}
		if($this->_guiCfg['useRules'] && is_array(Framework::getParam($this->_id.'permDeleteR_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam($this->_id.'permDeleteR_x',0,'P'));
			if ($key) {
				unset($this->_aktPerms['Rules'][$key]);
				$this->_update=true;
			}
		}
		if($this->_guiCfg['useGroups'] && is_array(Framework::getParam($this->_id.'permDeleteG_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam($this->_id.'permDeleteG_x',0,'P'));
			if ($key) {
				unset($this->_aktPerms['Groups'][$key]);
				$this->_update=true;
			}
		}
		if($this->_guiCfg['useSuperGroups'] && is_array(Framework::getParam($this->_id.'permDeleteE_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam($this->_id.'permDeleteE_x',0,'P'));
			if ($key) {
				unset($this->_aktPerms['SuperGroups'][$key]);
				$this->_update=true;
			}
		}
		if($this->_guiCfg['useUsers'] && is_array(Framework::getParam($this->_id.'permDeleteU_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam($this->_id.'permDeleteU_x',0,'P'));
			if ($key) {
				unset($this->_aktPerms['Users'][$key]);
				$this->_update=true;
			}
		}
		return $this->_update;
	}
	function &getPermsGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$Gui=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		$mode=array();
		if ($this->_guiCfg['useUsers']) {
			$mode[]='u';
		}
		if ($this->_guiCfg['useGroups']) {
			$mode[]='g';
		}
		if ($this->_guiCfg['useSuperGroups']) {
			$mode[]='e';
		}
		if ($this->_guiCfg['useRules']) {
			$mode[]='r';
		}

		$ttipParams=base64_encode(serialize($this->_guiCfg['tipParams']));
		$ttipApp=$this->_guiCfg['onlyApp'];
		$ttipSep='';

		$lb_params=array('Values'=>array());
		if (in_array('u',$mode)) {
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
				'LabelSep'=>$ttipSep,
				'mode'=>implode('|',$mode),
				'app'=>$ttipApp,
				'params'=>$ttipParams,
				'FieldVal'=>'_USERS',
			);
			$ttipSep=' / ';
		}
		if (in_array('g',$mode)) {
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Gruppen]]'),
				'LabelSep'=>$ttipSep,
				'mode'=>implode('|',$mode),
				'app'=>$ttipApp,
				'params'=>$ttipParams,
				'FieldVal'=>'_GROUPS',
			);
			$ttipSep=' / ';
		}
		if (in_array('e',$mode)) {
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Supergruppen]]'),
				'LabelSep'=>$ttipSep,
				'mode'=>implode('|',$mode),
				'app'=>$ttipApp,
				'params'=>$ttipParams,
				'FieldVal'=>'_EGROUPS',
			);
			$ttipSep=' / ';
		}
		if (in_array('r',$mode)) {
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Projektrollen]]'),
				'LabelSep'=>$ttipSep,
				'mode'=>implode('|',$mode),
				'app'=>$ttipApp,
				'params'=>$ttipParams,
				'FieldVal'=>'_RRULES',
			);
			$ttipSep=' / ';
		}
		if (!empty($mode)) {
			$key='addPermsUser';
			$lb_Invit=new FunctionButtons($this->id.'addPermsUser','ajaxttiplabel',$lb_params);
			$formGui->addField($this->id.'addPermsUser','ttip',$lb_Invit,'','fields1');
			$formGui->setParams($this->id.'addPermsUser',array('mode'=>implode('|',$mode),'params'=>$ttipParams));
			$formGui->setNoMeta($this->id.'addPermsUser');
		}
		if ($this->_guiCfg['permMode']) {
			$formGui->addField($this->id.'addPermsID','checklist_v',$this->_T->lang('[[Rechte]]'),array(key($this->_guiCfg['avPerms'])),'fields2');
		} else {
			$formGui->addField($this->id.'addPermsID','radiolist_v',$this->_T->lang('[[Rechte]]'),key($this->_guiCfg['avPerms']),'fields2');
		}
		$formGui->setValues($this->id.'addPermsID',$this->_guiCfg['avPerms']);

		$formGui->addField($this->id.'perms_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields3');

		$Gui->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$Gui->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$Gui->addContent('form3',$formGui,'FORM3',array('','fields3'));
		if ($this->_guiCfg['useRules']) $Gui->addContent('form3_1',$this->listPerms('PermsRules',$this->_aktPerms['Rules']),'FORM3');
		if ($this->_guiCfg['useSuperGroups']) $Gui->addContent('form3_2',$this->listPerms('PermsSuperGroup',$this->_aktPerms['SuperGroups']),'FORM3');
		if ($this->_guiCfg['useGroups']) $Gui->addContent('form3_2',$this->listPerms('PermsGroup',$this->_aktPerms['Groups']),'FORM3');
		if ($this->_guiCfg['useUsers']) $Gui->addContent('form3_3',$this->listPerms('PermsUser',$this->_aktPerms['Users']),'FORM3');

		return $Gui;
	}
	function &listPerms($ptype,$perms) {
		if (!empty($perms)) {
			require_once('lib/class_ApplicationListGui.php');
			require_once('lib/class_FormGui.php');
			$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
			switch ($ptype) {
				case 'PermsRules':
					$title=$this->_T->lang('[[prjRules]]');
					$perms_users=array();
					foreach ($perms as $key=>$val) {
						$perms_users[$key]=$this->_T->lang($this->_P->getAvRules($key));

					}
					$img='rolle.gif';
					$dbtn=$this->id.'permDeleteR_x';
				break;
				case 'PermsSuperGroup':
					$title=$this->_T->lang('[[Supergruppen]]');
					$perms_users=array();
					foreach ($perms as $key=>$val) {
						$tmpVal=$this->_frm->readSuperGroup($key);
						if ($tmpVal) {
							$perms_users[$key]=$tmpVal['SGroupName'];
						}
					}
					$img='rolle.gif';
					$dbtn=$this->id.'permDeleteR_x';
				break;
				case 'PermsGroup':
					$title=$this->_T->lang('[[Gruppen]]');
					$perms_users=$this->_frm->getAllGroups(array_keys($perms),-1);
					$img='gruppe.gif';
					$dbtn=$this->id.'permDeleteG_x';
				break;
				case 'PermsUser':
					$title=$this->_T->lang('[[BenutzerInnen]]');
					$perms_users=$this->_frm->getFullName(array_keys($perms),0,1);
					$img='user.gif';
					$dbtn=$this->id.'permDeleteU_x';
				break;
			}
			$tabGui->addHeaderCol('Name',$title,'','','',0,0,2);
			foreach ($this->_guiCfg['avPerms'] as $pkey=>$pval) {
				$tabGui->addHeaderCol('Perms_'.$pkey,$this->_guiCfg['avPermsShort'][$pkey]?$this->_guiCfg['avPermsShort'][$pkey]:$pval,'','','',1);
			}
			$tabGui->addHeaderCol('Delete','','tras.gif');
			$tabGui->setLimit(0);
			$rows=0;$hl=0;
			if (is_array($perms_users)) {
				foreach ($perms_users as $key=>$val) {

					//debug($val);
					$hl=$hl?0:1;
					$tabGui->addRow($hl);
					$tabGui->addCol('IMG','',$img);
					$tabGui->addCol('Name',$val,'','','',0,'2000');

					foreach (array_keys($this->_guiCfg['avPerms']) as $pkey) {

						if ($this->_guiCfg['permMode']) {
							$tabGui->addCol('Perms_'.$pkey,($perms[$key]&$pkey)?'X':'','','','center',1);
						} else {
							$tabGui->addCol('Perms_'.$pkey,$pkey==$perms[$key]?'X':'','','','center',1);
						}
					}
					$btn=new SubmitImgBtn ($dbtn.'['.$key.']','img/'.APP_THEME.'/loeschen.gif');
					$tabGui->addCol('Delete',$btn);
				}
			}
		}
		return $tabGui;
	}


}
?>