<?php
class ObjPrintTemplate extends baseObj {
	var $_obj_typ='0';
	/* to owerwrite*/
	function ObjPrintTemplate($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['Name'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class PrintTemplates extends ObjCore {
	var $_modul='core';
	var $_table='PrintTemplates';
	var $_cfgObjects=array (
		'IdField'=>'ID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'TranslationFields'=>array('Name'),
		'0'=>array(
			'ClassName'=>'ObjPrintTemplate',
			'Fields'=>array(
				'ID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'PermsUsers'=>array(
					'Typ'=>'core',
				),
				'PermsGroups'=>array(
					'Typ'=>'core',
				),
				'PermsRules'=>array(
					'Typ'=>'core',
				),
				'Name'=>array(
					'Typ'=>'core',
				),
				'Typ'=>array(
					'Typ'=>'core',
				),
				'FKModul'=>array(
					'Typ'=>'core',
				),
				'Template'=>array(
					'Typ'=>'core',
				),
				'Format'=>array(
					'Typ'=>'core',
				),
				'ViewDefault'=>array(
					'Typ'=>'core',
				),
			),
		),
	);

	function PrintTemplates() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function setModul($val) {
		$this->_printModul=$val;
	}
	function listModulObj($Typ='',$order='PrintTemplates.Name') {
		$searchQuery=array(
			array('Field'=>'PrintTemplates.FKModul','Typ'=>'=','Values'=>$this->_printModul),
		);
		if ($Typ) {
			$searchQuery[]=array('Field'=>'PrintTemplates.Typ','Typ'=>'=','Values'=>$Typ);
		}
		$rows=0;
		return $this->searchObj($rows,$searchQuery,$order);
	}
	function insertObj(&$Obj) {
		$Obj->setMeta('FKModul',$this->_printModul);
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		if ($Obj->getMeta('ViewDefault')) {
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'PrintTemplates.FKModul','Typ'=>'=','Values'=>$Obj->getMeta('FKModul'));
			$searchQuery[]=array('Field'=>'PrintTemplates.Typ','Typ'=>'=','Values'=>$Obj->getMeta('Typ'));
			$this->_db->update('PrintTemplates',array('ViewDefault'=>0),$searchQuery);
		}
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		$Fmng=& $this->_frm->getStaticModul('fmng');
		$Fmng->setRule(true);
		$Fmng->deleteFile('print_tpl',$Obj->getID());
		return $this->deleteMeta($Obj);
	}
	function calcAcl(&$Obj,$myRules=null) {
		$acl=0;
		if (preg_match("/\|".$this->_frm->getUser().",([0-9]+)\|/",$Obj->getMeta('PermsUsers'),$res)) {
			$acl=intval($res[1]);
		} else {
			$chunks=array_chunk($this->_frm->getMyGroups(),100);
			foreach($chunks as $grp) {
				if (preg_match_all("/\|(?:".implode('|',$grp)."),([0-9]+)/",$Obj->getMeta('PermsGroups'),$res)) {
					foreach ($res[1] as $v) {
						$acl=$acl|intval($v);
					}
				}
			}
			if (isset($myRules) && !empty($myRules) && preg_match_all("/\|(?:".implode('|',$myRules)."),([0-9]+)/",$Obj->getMeta('PermsRules'),$res)) {
				foreach ($res[1] as $v) {
					$acl=$acl|intval($v);
				}
			}
		}
		return $acl;
	}
	function getPrintTemplate($tplID,$returnFile=0) {
		$tplObj=$this->getObj($tplID);
		if ($tplObj) {
			$Fmng=& $this->_frm->getStaticModul('fmng');
			$Fmng->setRule(true);
			$File=$Fmng->readFile('print_tpl',$tplObj->getID());
			if ($File['FilePath'] && file_exists($File['FilePath'])) {
				if ($returnFile) {
					return $File['FilePath'];
				} else {
					return implode('',file($File['FilePath']));
				}
			}
		}
	}
}
?>
