<?php
class PrintTemplatesGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_guiCfg=array(
		'defAction'=>'b',
		'defMode'=>'print_tpl',
		'showTree'=>false,
		'defOid'=>0,
		'avTyps'=>array(),
	);

	function PrintTemplatesGui() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=& $frm->getStaticModul('print_tpl');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
	}
	function isCallable() {
		return true;
	}
	function handleRequest() {
		$this->_mode=Framework::getParam('print_mode',$this->_guiCfg['defMode'],'G');
		$this->_action=Framework::getParam('print_action',$this->_guiCfg['defAction'],'G');
		$this->_oid=Framework::getParam('print_oid',$this->_guiCfg['defOid'],'G');
		if ($this->_oid) {
			$this->_Obj=$this->_Base->getObj($this->_oid,1);
			if (!is_object($this->_Obj)) {
				$this->_action=$this->_guiCfg['defAction'];
				$this->_oid=$this->_guiCfg['defOid'];
				if ($this->_oid) {
					$this->_Obj=$this->_Base->getObj($this->_oid);
				}
				$this->_L->setParam('print_oid',$this->_oid);
			}
		}
		if (Framework::getParam('print_obj_action_x','0','P') && Framework::getParam('print_obj_action_val','0','P')) {
			switch (Framework::getParam('print_obj_action_val','0','P')) {
				case 'delete':
					if (is_object($this->_Obj)) {
						$this->_Base->deleteObj($this->_Obj);
					}
					$this->_L->setParam('print_action',$this->_guiCfg['defAction']);
					$this->_L->setParam('print_oid',0);
					$this->_L->goToLink();
				break;
				case 'new':
					$this->_L->setParam('print_action','n');
					$this->_L->setParam('print_oid',0);
					$this->_L->goToLink();
				break;
				case 'edit':
					$this->_L->setParam('print_action','n');
					$this->_L->setParam('print_oid',$this->_oid);
					$this->_L->goToLink();
				break;
				default:
					//debug(Framework::getParam('obj_action_val','0','P'));
			}
		}
	}
	function &process($init=true) {
		if ($init) $this->handleRequest();
		switch ($this->_action) {
			case 'n':
				if (Framework::getParam('_clTab',0,'G')) {
					$this->setPrefs('showEditTab',Framework::getParam('_clTab',0,'G'));
				}
				return $this->getEditGui();
			break;
			case 'b':
				return $this->getListGui();
			break;
			case 'dl':
				$Fmng=& $this->_frm->getStaticModul('fmng');
				$Fmng->setRule(true);
				$Fmng->dumpFile('print_tpl',$this->_Obj->getID(),1,$this->_Obj->getName());
				exit;
			break;
		}
	}
	function setGuiCfg($val,$ov=false) {
		if ($ov) {
			$this->_guiCfg=$val;
		} else {
			foreach ($val as $k=>$v) {
				$this->_guiCfg[$k]=$v;
			}
		}
	}
	function setModul($val) {
		$this->_printModul=$val;
		$this->_Base->setModul($val);
	}
	function &getTreeGui() {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		$tabGui->addHeaderCol('Name',$this->_T->lang('[[Vorlagen]]'),'','','','','',2);
		$entries=$this->_Base->listModulObj();
		foreach ($entries as $val) {
			if ($this->_action!='c' && $val->getID()==$this->_oid) {
				$hl=2;
			} else {
				$hl=0;
			}
			$tabGui->addRow($hl);
			$tabGui->addCol('IMG','','obj_img/ex_tree.gif');
			$tabGui->addCol('Name',$val->getName(),'',$this->_L->getTempLink(null,array('print_oid'=>$val->getID(),'print_action'=>'v')),'',0,'2000');
		}
		return $tabGui;
	}
	function &getListGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new TemplateGui('core/common_simple_content.inc.html');
		if (empty($this->_guiCfg['avTyps'])) {
			$avTyps=array(0=>$this->_T->lang('[[Vorlagen]]'));
		} else {
			$avTyps=$this->_guiCfg['avTyps'];
		}
		foreach ($avTyps as $key=>$typName) {
			$tabGui[$key]=new ApplicationListGui();
			$tabGui[$key]->setName($typName);
			$tabGui[$key]->addHeaderCol('Name',$this->_T->lang('[[Name]]'),'','','','','',2);
			$tabGui[$key]->addHeaderCol('Standard',$this->_T->lang('[[Standard]]','','','',1));
			$tabGui[$key]->addHeaderCol('Template',$this->_T->lang('[[Vorlage]]','','','',1));
			$tabGui[$key]->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);
			$tabGui[$key]->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','',1);

			if (is_array($this->_guiCfg['systemTpls'][$key])) {
				foreach ($this->_guiCfg['systemTpls'][$key] as $val) {
					$tabGui[$key]->addRow(0);
					$tabGui[$key]->addCol('IMG','','obj_img/ex_tree.gif');
					$tabGui[$key]->addCol('Name',$val['Name'],'','','',0,'2000');
					$tabGui[$key]->addCol('Standard','','','','',1);
					$tabGui[$key]->addCol('Template',$this->_T->lang('[[Herunterladen]]'),'',$val['Link'],'',1);
					$tabGui[$key]->addCol('UserModify','','','','',1);
					$tabGui[$key]->addCol('TimeModify','','',',','',1);
				}
			}
			$entries=$this->_Base->listModulObj($key);
			foreach ($entries as $val) {
				if ($val->getID()==$this->_oid) {
					$hl=2;
				} else {
					$hl=0;
				}
				$tabGui[$key]->addRow($hl);
				$tabGui[$key]->addCol('IMG','','obj_img/ex_tree.gif');
				$tabGui[$key]->addCol('Name',$val->getName(),'',$this->_L->getTempLink(null,array('print_oid'=>$val->getID(),'print_action'=>'n')),'',0,'2000');
				$tabGui[$key]->addCol('Standard',$val->getMeta('ViewDefault')?'X':'','','','center',1);
				$tabGui[$key]->addCol('Template',$this->_T->lang('[[Herunterladen]]'),'',$this->_L->getTempLink(null,array('print_oid'=>$val->getID(),'print_action'=>'dl')),'',1);
				$tabGui[$key]->addCol('UserModify',$val->getMeta('UserModify')?$this->_frm->getCachedUserName($val->getMeta('UserModify')):'','','','',1);
				$tabGui[$key]->addCol('TimeModify',$val->getMeta('TimeModify')?date('d.m.Y',$val->getMeta('TimeModify')):'','',',','',1);
			}
			$Gui->addContent('content_'.$key,$tabGui[$key],'CONTENT');
		}
		return $Gui;

	}
	function &getEditGui() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_Obj) {
			$Gui->setName($this->_T->lang('[[Neue Vorlage anlegen]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('print_oid'),array('print_action'=>$this->_guiCfg['defAction']))));
		} else {
			$Gui->setName($this->_T->lang('[[Vorlage bearbeiten]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('print_oid'),array('print_action'=>$this->_guiCfg['defAction']))));
			if (!empty($this->_guiCfg['usePerms'])) {
				$usePermsRules=false;
				if (!empty($this->_guiCfg['avTyps'])) {
					if (in_array($this->_Obj->getMeta('Typ'),$this->_guiCfg['usePerms'])) {
						$tabs[]='perms';
						if (is_array($this->_guiCfg['usePermsRules']) && in_array($this->_Obj->getMeta('Typ'),$this->_guiCfg['usePermsRules'])) {
							$usePermsRules=true;
						}
					}
				} else {
					$tabs[]='perms';
					if ($this->_guiCfg['usePermsRules']) {
						$usePermsRules=true;
					}
				}
			}
		}
		$Gui->addFunction($btBreak);
		$box=new BoxGui($this->_mode.'|showEditTab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('showEditTab'));
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getMetaGui());
		}
		if (in_array('perms',$tabs)) {
			$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
			require_once('lib/class_PermsGui.php');
			$permsGui=new PermsGui();
			$guiCfg=array(
				'useRules'=>$usePermsRules,
				'avPerms'=>array(1=>$this->_T->Lang('[[Lesen]]')),
			);
			$permsGui->setGuiCfg($guiCfg);
			$permsGui->setAktPerms('Rules',$this->_Obj->getMeta('PermsRules'));
			$permsGui->setAktPerms('Groups',$this->_Obj->getMeta('PermsGroups'));
			$permsGui->setAktPerms('Users',$this->_Obj->getMeta('PermsUsers'));
			if ($permsGui->handleRequest()) {
				$this->_Obj->setMeta('PermsRules',$permsGui->getAktPerms('Rules'));
				$this->_Obj->setMeta('PermsGroups',$permsGui->getAktPerms('Groups'));
				$this->_Obj->setMeta('PermsUsers',$permsGui->getAktPerms('Users'));
				$this->_Base->updateObj($this->_Obj);
				$this->_L->goToLink();
			}
			$box->setTabContent('perms',$permsGui->getPermsGui());
		}
		$show_tap=$this->getPrefs('showEditTab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function getMetaGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		$defOneLang=1;
		$defTrans=array();
		if ($this->_Obj) {
			$defTrans=$this->_Obj->getTrans('Name');
			foreach ($this->_frm->getMaLang() as $lang) {
				if ($defTrans[$lang]!=$defTrans[$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
			}

		}
		foreach ($this->_frm->getMaLang() as $lang) {
			$key='Trans['.$lang.']';
			$formGui->addField($key,'text',$this->_T->lang('[[Name]]').' '.strtoupper($lang),$defTrans[$lang],'fields1');
			$formGui->setNoMeta($key);
			if ($lang!=$this->_frm->getLang()) {
				if (Framework::getParam('oneLang',$defOneLang,'P')) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key,$attribs);
				} else {
					$formGui->setRequired($key);
				}
			} else {
				$formGui->setRequired($key);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'fields1');
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $lang2) {
					if ($lang2!=$lang) $attribs['onchange'].="disableEnable('Trans[".$lang2."]',this,this.checked?0:1);";
				}
				//debug($attribs);
				$formGui->setAttribs($key,$attribs);
			}
		}
		$key='Template';
		$formGui->addField($key,'cached_file',$this->_T->lang('[[Vorlage]]'),'','fields2');
		$Params['TmpPath']=$this->_frm->getDynTempPath();
		$formGui->setParams($key,$Params);
		if (!$this->_Obj) $formGui->setRequired($key);
		$formGui->setNoMeta($key);

		if (!empty($this->_guiCfg['avTyps'])) {
			$key='Typ';
			$formGui->addField($key,'select',$this->_T->lang('[[Vorlage fuer]]'),$this->_Obj?$this->_Obj->getMeta($key):'','fields2');
			$formGui->setValues($key,$this->_guiCfg['avTyps']);
			$formGui->setRequired($key);
		}
		$key='Format';
		$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Seitenformat]]'),$this->_Obj?$this->_Obj->getMeta($key):0,'fields2');
		$formGui->setValues($key,array(0=>$this->_T->lang('[[Hochformat]]'),1=>$this->_T->lang('[[Querformat]]')));

		$key='ViewDefault';
		$formGui->addField($key,'radiolist_v',$this->_T->lang('[[Ersetzt Standardvorlage]]'),$this->_Obj?$this->_Obj->getMeta($key):0,'fields2');
		$formGui->setValues($key,array(
			0=>$this->_T->lang('[[Nein]]'),
			2=>$this->_T->lang('[[Ja]]'),
		));

		
		//$formGui->setRequired($key);

		$key='submit';
		$formGui->addField($key,'submit','','','fields3');
		$submit_array=array(
			'print_meta_save_x'=>' '.$this->_T->lang('[[Speichern]]').' ',
		);
		/*if (is_object($this->_Obj)) {
			$submit_array['print_meta_delete_x']=' '.$this->_T->lang('[[Loeschen]]').' ';
			$formGui->setValuesAttribs($key,'print_meta_delete_x',array('onclick'=>'return lo_form();'));
		}*/
		$formGui->setValues($key,$submit_array);

		/*if (Framework::getParam('print_meta_delete_x','0','P')) {
			if (is_object($this->_Obj) && !$this->_Obj->getMeta('System')) {
				$this->_BaseForm->deleteObj($this->_Obj);
				$this->_L->unsetParam('print_oid');
				$this->_L->setParam('print_action','b');
				$this->_L->goToLink();
			}
		}*/

		if (Framework::getParam('print_meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$ObjTrans=array();
				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans[$val]=$formGui->getFieldVal('Trans['.$this->_frm->getLang().']');
					}
				} else {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans[$val]=$formGui->getFieldVal('Trans['.$val.']');
					}
				}

				if (is_object($this->_Obj)) {
					$formGui->addMetaToObj($this->_Obj);
					$this->_Obj->setTrans('Name',$ObjTrans);
					$this->_Base->updateObj($this->_Obj);
					$this->_L->unsetParam('print_oid');
					$this->_L->setParam('print_action',$this->_guiCfg['defAction']);
				} else {
					$this->_Obj=new ObjPrintTemplate();
					$formGui->addMetaToObj($this->_Obj);
					$this->_Obj->setTrans('Name',$ObjTrans);
					$this->_Base->insertObj($this->_Obj);
					$this->_L->setParam('print_action',$this->_guiCfg['defAction']);
					if (!empty($this->_guiCfg['usePerms'])) {
						if (empty($this->_guiCfg['avTyps']) ||  in_array($this->_Obj->getMeta('Typ'),$this->_guiCfg['usePerms'])) {
							$this->_L->setParam('print_action','n');
							$this->_L->setParam('print_oid',$this->_Obj->getID());
							$this->_L->setParam('_clTab','perms');
						}
					}


				}
				$fileVal=$formGui->getFieldVal('Template');
				if (!empty($fileVal)) {
					$Fmng=& $this->_frm->getStaticModul('fmng');
					$Fmng->setRule(true);
					$error=$Fmng->replaceFile(null ,'print_tpl', $this->_Obj->getID(),$fileVal);
				}

				$this->_L->goToLink();
			}

		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		return $tplContent;
	}
	function &getObjActionGui() {
		require_once('lib/class_FunctionObjActionGui.php');
		$objActionGui=new FunctionObjActionGui('print_obj_action');
		$obj_action=$this->_frm->getObjAction('print','print_tpl');
		foreach ($obj_action as $key=>$val) {
			if ($val['Hidden']) continue;
			if (in_array('ID',$val['Extra']) && !is_object($this->_Obj)) continue;
			//if (in_array('!System',$val['Extra'])  && (!is_object($this->_Obj) || $this->_Obj->getMeta('System'))) continue;
			//if (in_array('empty',$val['Extra'])  && (!is_object($this->_Obj) || !$this->_BaseForm->isEmpty($this->_Obj))) continue;
			$objActionGui->addValue($key,$val['Name']);
		}
		return $objActionGui;
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_mode,array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_mode,$key);
		if (!$result) $result=$default;
		return $result;
	}
}
?>