<?php
class TemplateGui {
	var $_T;
	var $_t;
	var $_tpl='';
	var $_content=array();
	function TemplateGui($tpl='') {
		global $T;
		$this->_T=&$T;
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
		$this->_tpl=$tpl;
	}
	function setTemplate($tpl) {
		$this->_tpl=$tpl;
	}
	function addContent($ID,&$obj,$handle,$params = null) {
		$this->_content[$ID]=array(
			'Content'=>&$obj,
			'Handle'=>$handle,
			'Params'=>$params,
		);
	}
	function emptyContent() {
		return empty($this->_content);
	}
	function processContent() {
		if (is_array($this->_content)) {
			foreach ($this->_content as $key=>$val) {
				if (is_object($val['Content'])) {
					$this->_t->assign($val['Handle'],call_user_func_array(array(&$val['Content'],'process'),is_array($val['Params'])?$val['Params']:array()));
				} else {
					$this->_t->assign($val['Handle'],$val['Content']);
				}
				$this->_t->assign('ID',$key);
				if ($this->_t->issetKey(strtolower($val['Handle']))) {
					$this->_t->parse('ROW','.'.strtolower($val['Handle']));
					if ($this->_t->issetKey(strtolower($val['Handle']).'_spc')) {
						$this->_t->parse('ROW',strtolower($val['Handle']).'_spc');
					}
				}
			}
		}
	}
	function process($handle='') {
		if (!$handle) {
			$handle='templateContent';
			$return=true;
		} else {
			$return=false;
		}
		$this->_t->setRoot('tpl/'.APP_THEME);
		$this->_t->define (array($handle => $this->_tpl));
		$this->processContent();
		if ($return) {
			$this->_t->parse('TPL_TEMP',$handle);
			return $this->_t->getParsed();
		}
	}
}
?>