<?php
class TinyMceGui
{
	var $InstanceName ;
	var $BasePath ;
	var $Width ;
	var $Height ;
	var $ToolbarSet ;
	var $Value ;
	var $_spellLangs=array(
		'de'=>'Deutsch',
		'it'=>'Italiano',
		'en'=>'English',
	);
	var $_Config=array(
		'mode' => "exact",
		'elements' => "body",
		'auto_focus' => "mce_editor_0",
		'browsers' => "msie,gecko,opera",
		'language' => "en",
		'cleanup' => false,
		'cleanup_on_startup' => false,
		'verify_html' => false,
		'preformatted' => true,
		'cleanup_serializer'=> 'xml',
		'plugins' => "spellchecker,e7image,fullpage",
		'e7image_abs_path' => "",
		'e7image_rel_path' => "",
		'valid_elements' => "*[*]",
		'spellchecker_languages' => "+English=en,Deutsch=de,Italiano=it",
		'accessibility_warnings' => false,
		'convert_fonts_to_spans' => true,
		'convert_newlines_to_brs' => true,
		'theme' => "advanced",
		'theme_advanced_buttons1' => "fontselect,fontsizeselect,separator,forecolor,backcolor,separator,link,unlink,image,separator,undo,redo,separator,spellchecker",
		'theme_advanced_buttons2' => "bold,italic,underline,separator,justifyleft,justifycenter,justifyright,justifyfull,separator,bullist,numlist,hr,separator,outdent,indent",
		'theme_advanced_buttons3' => "fullpage",
		'theme_advanced_toolbar_location' => "top",
		'theme_advanced_toolbar_align' => "left",
		'theme_advanced_path_location' => "none",
	);

	function __construct(  ) {

	}
	// PHP 4 Contructor
	function TinyMceGui(  )	{

	}

	function Create() {
		return $this->getConfigJS() ;
	}
	function setConfig($key,$val) {
		$this->_Config[$key]=$val;
	}
	function getConfigJS() {
		$result='<script type="text/javascript">'."\n";
		$cfg_result=array();
		foreach ($this->_Config as $key=>$val) {
			if (is_bool($val)) {
				$cfg_result[]=$key.' : '.($val?'true':'false').'';
			} else {
				$cfg_result[]=$key.' : "'.$val.'"';
			}
		}
		$result.='tinyMCE.init({'."\n";
		$result.="\t".implode(','."\n\t",$cfg_result)."\n";
		$result.='});'."\n";
		$result.='</script>'."\n";
		return $result;
	}
	function spellConfig($lang,$default='') {
		$result=array();
		foreach($lang as $val) {
			if (isset($this->_spellLangs[$val])) {
				if ($val==$default) {
					$result[]='+'.$this->_spellLangs[$val].'='.$val;
				} else {
					$result[]=$this->_spellLangs[$val].'='.$val;
				}
			}
		}
		return implode(',',$result);
	}
}

?>