<?php

  /* mthaler 11.06.2001 */

class Translation  {
	var $_debug=0;
	var $_trans;
	var $_lang;
    var $MASTER_TPL='';  // root folder debug_prepend templates
	var $_char='iso';
	var $_isLoaded;
    var $REGEX_LANG = '/\[\[.+\]\]/eUS';
    var $_fallBackLang='en';
    var $_userTransTable='UserTrans';
	function Translation($lang='',$master_tpl='') {
		global $db;
		$this->_db=&$db;
		$this->_lang=$lang;
        if ($master_tpl) $this->MASTER_TPL=$master_tpl;
        if (GE_CHARSET=='UTF-8') $this->_char='utf8';
	}
	function getUserTable() {
		return $this->_userTransTable;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function getLang() {
		return $this->_lang;
	}
    function lang($key,$strip=false) {
		if ($strip) $key=stripslashes($key);
		if ($this->_debug && !isset($this->_trans[$this->_lang][$key])) {
			echo $key.'&lt;br /&gt;<br />';
		}
		return (isset($this->_trans[$this->_lang][$key])?$this->_trans[$this->_lang][$key]:$key);
	}
    function langStr($key,$replace=array()) {
		return strtr($this->lang($key),$replace);
	}
    function langArray($array,$strip=false) {
		foreach ($array as $key=>$val) {
			$array[$key]=$this->lang($val,$strip);
		}
		return $array;
	}
	function loadModul($modul,$lang='') {
		if (!$lang) $lang=$this->_lang;
		if (!isset($this->_isLoaded[$modul]) || !isset($this->_isLoaded[$modul][$lang])) {
			$file='tpl/'.APP_THEME.'/lang/'.$this->_char.'_'.$modul.'_'.$lang.'.txt';
			if ($this->MASTER_TPL && file_exists($this->MASTER_TPL.$file)) $file=$this->MASTER_TPL.$file;
			if (file_exists($file)) {
				$fp=fopen($file,'r');
				while (!feof($fp)) {
					$row=fgets($fp,512);
					$tmp=explode('##',$row);
					if ($tmp[0]) $this->_trans[$lang][$tmp[0]]=trim($tmp[1]);
				}
			}
			$this->_isLoaded[$modul][$lang]=true;
		}
	}
	function replaceString($string) {
		if ($this->_trans[$this->_lang]) {
			return preg_replace($this->REGEX_LANG,'$this->lang(\'\\0\',true)',$string);
		} else {
			return $string;
		}
	}
	function loadModulSql($modul,$lang='') {
		if (!$lang) $lang=$this->_lang;
		if (!isset($this->_isLoaded[$modul]) || !isset($this->_isLoaded[$modul][$lang])) {
			$searchQuery=array(
				array('Field'=>'TransLang','Typ'=>'=','Values'=>array($lang,$this->_fallBackLang)),
				array('Field'=>'FKModul','Typ'=>'=','Values'=>$modul),
			);
			$query="SELECT TransKey,TransVal,TransLang From ".$this->getUserTable()." WHERE ".$this->_db->getWhere($searchQuery);
			$this->_db->query($query);
			while ($this->_db->next_record()) {
				if ($this->_db->f('TransLang')==$lang || !isset($this->_trans[$lang][$this->_db->f('TransKey')])) {
					$this->_trans[$lang][$this->_db->f('TransKey')]=$this->_db->f('TransVal');
				}
			}
			$this->_isLoaded[$modul][$lang]=true;
		}
	}
	function readSqlTrans($modul,$key='') {
		$result=array();
		$searchQuery=array(
			array('Field'=>'FKModul','Typ'=>'=','Values'=>$modul),
		);
		if ($key) {
			$searchQuery[]=array('Field'=>'TransKey','Typ'=>'=','Values'=>$key);
		}
		$query="SELECT TransKey,TransVal,TransLang From ".$this->getUserTable()." WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			if ($key) {
				$result[$this->_db->f('TransLang')]=$this->_db->f('TransVal');
			} else {
				$result[$this->_db->f('TransKey')][$this->_db->f('TransLang')]=$this->_db->f('TransVal');
			}
		}
		return  $result;
	}
	function replaceSqlTrans($modul,$key,$val) {
		if (!isset($val[$this->_fallBackLang])) {
			$val[$this->_fallBackLang]=reset($val);
		}
		foreach ($val as $TransLang=>$TransVal) {
			$insert=array(
				'FKModul'=>$modul,
				'TransKey'=>$key,
				'TransLang'=>$TransLang,
				'TransVal'=>$TransVal,
			);
			$this->_db->insert($this->getUserTable(),$insert,'',1);
		}
	}
	function deleteSqlTrans($modul,$key='') {
		$result=array();
		$searchQuery=array(
			array('Field'=>'FKModul','Typ'=>'=','Values'=>$modul),
		);
		if ($key) {
			$searchQuery[]=array('Field'=>'TransKey','Typ'=>'=','Values'=>$key);
		}
		$this->_db->delete($this->getUserTable(),$searchQuery);
	}

}
?>
