<?php
class geCoreMailsimple {
	private $lf="\r\n";
	private $charset;
	private $subject;
	private $body;
	private $header=array(
		'MIME-Version'=>'1.0',
		'Content-Transfer-Encoding'=>'8bit',
	);
	
	private $to=array();
	
	public function __construct($charset=GE_CHARSET) {
		$this->lf=$GLOBALS['CFG']['NL_MAIL'];
		$this->charset=$charset;
		$this->header['Content-type']='text/plain; charset='.$this->charset;
		mb_internal_encoding($this->charset);
	}
	public static function get() {
		$c=__CLASS__;
		return new $c();
	}
	public function getLf() {
		return $this->lf;
	}
	public function setSubject($data) {
		$this->subject=mb_encode_mimeheader((string)$data, $this->charset, "Q",$this->lf);
	}
	public function setBody($data) {
		$this->body=(string)$data;
	}
	public function setFrom($mail,$name='') {
		if ($name) {
			$this->header['From']=mb_encode_mimeheader($name, $this->charset, "Q",$this->lf).' <'.$mail.'>';
		} else {
			$this->header['From']=(string)$mail;
		}
	}
	public function setReplyto($data) {
		$this->header['Reply-To']=(string)$data;
	}
	public function setHeader($k,$data) {
		$this->header[$k]=(string)$data;
	}
	public function addTo($mail,$name='') {
		if ($name) {
			$this->to[]=mb_encode_mimeheader($name, $this->charset, "Q",$this->lf).' <'.$mail.'>';
		} else {
			$this->to[]=(string)$mail;
		}
	}
	public function setTo($mail,$name='') {
		$this->to=array();
		$this->addTo($mail,$name);
	}
	public function send() {
		$header=array();
		foreach($this->header as $k=>$v) {
			$header[]=$k.': '.$v;
		}
		return mail(implode(',',$this->to),$this->subject,$this->body,implode($this->lf,$header),'-f'.$this->header['Reply-To']);
	}
}
?>
