<?php
class FmngGui {
	var $_Base;
	var $_Obj;
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	function __construct() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('fmng');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		if (is_object($P)) $this->_P=&$P;
		$this->_T->loadModul('fmng');
	}
	function setObj($obj) {
		$this->_Obj=$obj;
	}
	function _sortArray($a,$b) {
		foreach ($this->_sort as $sort) {
			$ID=$sort[0];
			$DIR=$sort[1]=='DESC'?array(-1,1):array(1,-1);
			if ($pos=strpos($ID,'.')) {
				$ID=substr($ID,$pos+1);
			}
			switch($ID) {
				case 'Version':
				case 'TimeModify':
				case 'UserModify':
					$res=($a->getMeta($ID)==$b->getMeta($ID)?0:($a->getMeta($ID)<$b->getMeta($ID)?-1:1));
				break;
				case 'FileSize':
					$res=($a->getFileMeta($ID)==$b->getFileMeta($ID)?0:($a->getFileMeta($ID)<$b->getFileMeta($ID)?-1:1));
				break;
				default:
					$res=strnatcasecmp($a->getMeta($ID),$b->getMeta($ID));
				break;
			}
			if ($res>0) return $DIR[0];
			if ($res<0) return $DIR[1];
		}
		return 0;
	}

	function &getFolderContent($search_sql,$mode='') {
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_ApplicationListGui.php');
		if (Framework::getParam('_OrderF',0,'G')) {
			$this->setPrefs('fmngOrderF',Framework::getParam('_OrderF',0,'G'));
			$this->setPrefs('fmngOrderD',Framework::getParam('_OrderD',0,'G'));
		}
		$orderF=$this->getPrefs('fmngOrderF','Title_'.$this->_frm->getLang());
		$orderD=$this->getPrefs('fmngOrderD',-1);
		$sqlOrder='DocType DESC, '.$orderF.($orderD==-1?' DESC':' ASC');
		$b=0;
		$limit=0;
		$use_limit=0;

		if ($this->_Base->getRootObj()->getMeta('System')=='t') {
			$tree=$this->_Base->ListTrashTree($this->_Base->getRootObj(),$sqlOrder,'','',true);
			$entries=isset($tree[$this->_Obj->getID()])?$tree[$this->_Obj->getID()]:array();

			$this->_sort=array();
			$this->_sort[]=array('DocType','DESC');
			$this->_sort[]=array($orderF,($orderD==-1?'DESC':'ASC'));
			uasort($entries,array(&$this, '_sortArray'));
		} else {
			$rows=0;
			$entries=$this->_Base->searchObj($rows,$b,$limit,$search_sql,$sqlOrder,$use_limit);
		}
		$Gui=new ApplicationListGui();

		$funcAction=new FunctionObjActionGui('list_action',true);
		$funcAction->setName($this->_T->lang('[[Ausgewaehlte Objekte]]'));
		$list_action=$this->_frm->getObjAction($this->_Base->getModul(),$mode?'m_'.$mode:$this->_Obj->getActionMode(1));
		foreach ($list_action as $key=>$val) {
			if ($val['Hidden'] || !$this->_Base->isAllowedAction($this->_Obj,$val)) continue;
			$funcAction->addValue($key,$val['Name']);
		}
		$Gui->addFunction($funcAction);
		$btnList=new CheckBoxBtn ('ListID[]','');
		$funcSelAll=new FunctionButtons('fmng_list','selectall',array('ListID'=>'ListID[]','ListOn'=>false));
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);

		$Gui->setActOrder($orderF,$orderD);
		$Gui->setOrderLink($this->_L);
		$Gui->addHeaderCol('ListID',$funcSelAll->process(),'','','',1,'1%',0,'',$noEnc);
		$key='Title_'.$this->_frm->getLang();
		$Gui->addHeaderCol($key,$this->_T->lang('[[Name]]'),'','','','','',1);
		$Gui->setHeaderOrder($key,$key,1);
		$key='FileSize';
		$Gui->addHeaderCol($key,$this->_T->lang('[[DateiGroesse]]'),'','','right',1);
		$Gui->setHeaderOrder($key,$key,-1);
		if ($this->_Base->getCfg('cfg/versioning/active')) {
			$key='Version';
			$Gui->addHeaderCol($key,$this->_T->lang('[[Version]]'),'','','',1);
			$Gui->setHeaderOrder($key,'FileMetabase.'.$key,-1);
		}
		$key='UserModify';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Geaendert von]]'),'','','',1);
		$Gui->setHeaderOrder($key,$key,1);
		$key='TimeModify';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Geaendert am]]'),'','','',1);
		$Gui->setHeaderOrder($key,$key,-1);
		$key='Edit';
		$Gui->addHeaderCol($key,'','','','',1);

		foreach ($entries as $key=>$val) {
			$Gui->addRow(($hl?$hl=0:$hl=1));
			$Gui->addCol('ListID',$btnList->process($val->getID()),'','','',1,'',0,'',$noEnc);
			//$Gui->addCol('Img','',$val->getImage(),'','',1);
			$goLink=$this->_L->getTempLink(null,array('action'=>$val->getAction(0),'oid'=>$val->getID()));
			$extra=array();
			if ($val->getACL(2)) {
				$extra['LinkAttribs']=array(
					'onclick'=>'return goToView(this);',
					'ondblclick'=>'return goToEdit(this,\'action='.$val->getAction(0).'\',\'action='.$val->getAction(1).'\');',
				);
			}
			$Gui->addCol('Name',$val->getName(),$val->getImage(0),$goLink,'',0,2000,0,'',$extra);
			$Gui->addCol('FileSize',($val->isFolder() || !$val->getFileMeta('FileSize'))?'':Framework::formatSize($val->getFileMeta('FileSize')).'&nbsp;&nbsp;','','','right',1,'',0,'',$noEnc);
			if ($this->_Base->getCfg('cfg/versioning/active')) {
				$Gui->addCol('Version',$val->getMeta('Version'),'','','',1);
			}
			$Gui->addCol('UserModify',$this->_frm->getCachedUsername($val->getMeta('UserModify'),1),'','','',1);
			$Gui->addCol('TimeModify',date('d.m.Y H:i',$val->getMeta('TimeModify')),'','','',1);
			$Gui->addCol('Edit','','ico-edit.gif',$this->_L->getTempLink(array('action'),array('oid'=>$val->getID())).'&action='.$val->getAction(1),'',1,'',0,'',$noEnc);
			
		}
		return $Gui;
	}
	function &getOverviewContent($mode,$rootIDs) {
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_ApplicationListGui.php');

		$order='';
		$use_limit=false;
		$limit=0;
		$search_sql="RootID IN (".implode(',',$this->_Base->_db->escape($rootIDs)).")";
		switch ($mode) {
			case 'fav':
				$title=$this->_T->lang('[[Favoriten]]');
				$search_sql.=" AND Trash=0 AND Favorite=1";
				$limit=0;
			break;
			case 'last':
				$title=$this->_T->lang('[[Zuletzt verwendete Dateien]]');
				$search_sql.=" AND Trash=0 AND DocType='ext' AND TimeDl!=0";
				$order="TimeDl DESC";
				$limit=5;
			break;
			case 'new':
				$title=$this->_T->lang('[[Neuzugaenge]]');
				$search_sql.=" AND Trash=0 AND DocType='ext'";
				$order="TimeCreate DESC";
				$limit=5;
			break;
			case 'used':
				$title=$this->_T->lang('[[Meist gebrauchte Dateien]]');
				$search_sql.=" AND Trash=0 AND DocType='ext' AND Counter!=0";
				$order="Counter DESC";
				$limit=5;
			break;
		}
		if ($order) {
			$order.=','.'Title_'.$this->_frm->getLang().' ASC';;
		} else {
			$order='Title_'.$this->_frm->getLang().' ASC';
		}
		
		$rows=0;
		$entries=$this->_Base->searchObj($rows,0,$limit,$search_sql,$order,$use_limit);

		
		$Gui=new ApplicationListGui();
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);

		$key='Title';
		$Gui->addHeaderCol($key,$title,'','','','','',1);
		$key='FileSize';
		$Gui->addHeaderCol($key,$this->_T->lang('[[DateiGroesse]]'),'','','right',1);
		if ($this->_Base->getCfg('cfg/versioning/active')) {
			$key='Version';
			$Gui->addHeaderCol($key,$this->_T->lang('[[Version]]'),'','','',1);
		}
		$key='UserModify';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Geaendert von]]'),'','','',1);
		$key='TimeModify';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Geaendert am]]'),'','','',1);
		$key='Edit';
		$Gui->addHeaderCol($key,'','','','',1);

		foreach ($entries as $key=>$val) {
			$Gui->addRow(($hl?$hl=0:$hl=1));
			$goLink=$this->_L->getTempLink(null,array('action'=>$val->getAction(0),'oid'=>$val->getID()));
			$extra=array();
			if ($val->getACL(2)) {
				$extra['LinkAttribs']=array(
					'onclick'=>'return goToView(this);',
					'ondblclick'=>'return goToEdit(this,\'action='.$val->getAction(0).'\',\'action='.$val->getAction(1).'\');',
				);
			}
			$Gui->addCol('Name',$val->getName(),$val->getImage(0),$goLink,'',0,2000,0,'',$extra);
			$Gui->addCol('FileSize',($val->isFolder() || !$val->getFileMeta('FileSize'))?'':Framework::formatSize($val->getFileMeta('FileSize')).'&nbsp;&nbsp;','','','right',1,'',0,'',$noEnc);
			if ($this->_Base->getCfg('cfg/versioning/active')) {
				$Gui->addCol('Version',$val->getMeta('Version'),'','','',1);
			}
			$Gui->addCol('UserModify',$this->_frm->getCachedUsername($val->getMeta('UserModify'),1),'','','',1);
			$Gui->addCol('TimeModify',date('d.m.Y H:i',$val->getMeta('TimeModify')),'','','',1);
			$Gui->addCol('Edit','','ico-edit.gif',$this->_L->getTempLink(array('action'),array('oid'=>$val->getID())).'&action='.$val->getAction(1),'',1,'',0,'',$noEnc);
		}
		return $Gui;
	}
	function processVersionContent() {
		if (FrameWork::getParam('version_action_x','','P') && FrameWork::getParam('version_action_val','','P') ) {
			switch (FrameWork::getParam('version_action_val','','P')) {
				case 'undelete':
					if (FrameWork::getParam('VersionID',0,'P') && FrameWork::getParam('VersionID',0,'P')!=$this->_Obj->getMeta('Version')) {
						$this->_Obj->setMeta('Version',$this->_Obj->getMeta('Version')+1);
						$error=$this->_Base->copyFile($this->_Obj,$this->_Base->getModul(),$this->_Obj->getMeta('Content')?$this->_Obj->getMeta('Content'):$this->_Obj->getID(),FrameWork::getParam('VersionID',0,'P'));
						if (!$error) {
							$this->_Base->updateMeta($this->_Obj);
							$this->_Base->syncLinkedFiles($this->_Obj);
							$this->_L->goToLink();
						}
						
					}
				break;
			}
			
		}
		return $this->getVersionContent();
	}
	function &getVersionContent() {
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_ApplicationListGui.php');
		$sqlOrder='Version DESC';
		$rows=0;
		$b=FrameWork::getParam('v_b',0);
		$limit=20;
		$entries=$this->_Base->searchFile($this->_Base->getModul(),$this->_Obj->getMeta('Content')?$this->_Obj->getMeta('Content'):$this->_Obj-getID(),$rows,$b,$limit,array(),'Version DESC');
		$Gui=new ApplicationListGui();

		$funcAction=new FunctionObjActionGui('version_action',true);
		$funcAction->setName($this->_T->lang('[[Ausgewaehlte Version]]'));
		$funcAction->addValue('undelete',$this->_T->lang('[[Wiederherstellen]]'));

		$Gui->addFunction($funcAction);
		//$funcSelAll=new FunctionButtons('fmng_list','selectall',array('VersionID'=>'VersionID[]','ListOn'=>false));

		$btnList=new RadioButtonBtn('VersionID',$this->_Obj->getMeta('Version'));
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);

		$Gui->setNumKey('v_b');
		$Gui->setOrderLink($this->_L);
		$Gui->setNavLink($this->_L);
		$Gui->setLimit($limit);
		$Gui->setSumRows($rows);
		$Gui->setBegin($b);
		$Gui->addHeaderCol('VersionID','#','','','',1,'1%',0,'',$noEnc);
		$key='Version';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Version]]'),'','','',1);
		//$key='FilePath';
		//$Gui->addHeaderCol($key,$this->_T->lang('[[FilePath]]'),'','','right',1);
		$key='FileSize';
		$Gui->addHeaderCol($key,$this->_T->lang('[[DateiGroesse]]'),'','','right',1);
		$key='UserModify';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Geaendert von]]'),'','','',1);
		$key='TimeModify';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Geaendert am]]'),'','','',1);
		$key='Edit';
		$Gui->addHeaderCol($key,'','','','',1);

		foreach ($entries as $key=>$val) {
			$Gui->addRow(($hl?$hl=0:$hl=1));
			$Gui->addCol('VersionID',$btnList->process($val['Version']),'','','',1,'',0,'',$noEnc);
			//$Gui->addCol('Img','',$val->getImage(),'','',1);
			$goLink=$this->_L->getTempLink(null,array('action'=>$this->_Obj->getAction(0),'oid'=>$this->_Obj->getID(),'version'=>$val['Version']));
			$Gui->addCol('Version',$this->_T->lang('[[Version]]').' '.$val['Version'],$val['FileImg']?'obj_img/'.$val['FileImg']:'',$goLink,'',0,2000,0,'');
		//	$Gui->addCol('FilePath',$val['FilePath'],'','','',1,'',0,'');
			$Gui->addCol('FileSize',$val['FileSize']?Framework::formatSize($val['FileSize']).'&nbsp;&nbsp;':'','','','right',1,'',0,'',$noEnc);
			$Gui->addCol('UserModify',$this->_frm->getCachedUsername($val['UserModify'],1),'','','',1);
			$Gui->addCol('TimeModify',date('d.m.Y H:i',$val['TimeModify']),'','','',1);
			$Gui->addCol('Edit','','ico-edit.gif',$this->_L->getTempLink(array('action'),array('oid'=>$this->_Obj->getID())),'',1,'',0,'',$noEnc);

		}
		return $Gui;
	}
	function &getSearchConfigGui(&$search) {
		//debug($_POST);
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_DateSelectForm.php');
		require_once('lib/class_FunctionButtons.php');


		$ContGui=new TemplateGui('core/common_content_border.inc.html');

		$TimeCreateGui=new DateSelectForm('s_TimeCreate',$this->_T->lang('[[Erstellt]]'));
		$TimeCreateGui->setAvMode(array(3));
		$TimeCreateGui->setMode($search['TimeCreateMode']?$search['TimeCreateMode']:3);
		if ($search['TimeCreateB'] || $search['TimeCreateE']) {
			$TimeCreateGui->setDate(array($search['TimeCreateB'],$search['TimeCreateE']));
		} else {
			$TimeCreateGui->setDate(array(0,0));
		}
		
		$TimeModifyGui=new DateSelectForm('s_TimeModify',$this->_T->lang('[[Geaendert]]'));
		$TimeModifyGui->setAvMode(array(3));
		$TimeModifyGui->setMode($search['TimeModifyMode']?$search['TimeModifyMode']:3);
		if ($search['TimeModifyB'] || $search['TimeModifyE']) {
			$TimeModifyGui->setDate(array($search['TimeModifyB'],$search['TimeModifyE']));
		} else {
			$TimeModifyGui->setDate(array(0,0));
		}
	
		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key="Info";
		$default=$search[$key]?$search[$key]:'';
		$formGui->addField('s_'.$key,'text',$this->_T->lang('[[Suchtext]]'),$default,'fields0');

		$key='UserCreate';
		$default=$search[$key]?'u_'.$search[$key]:0;
		$params=base64_encode(serialize(array('MaxEntries'=>1,'useAll'=>1)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Erstellt von]]'),
			'LabelSep'=>'',
			'mode'=>'u',
			'app'=>'zef',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_Invit=new FunctionButtons('s_'.$key,'ajaxttiplabel',$lb_params);
		$formGui->addField('s_'.$key,'ttip',$lb_Invit,$default,'fields1');
		$formGui->setParams('s_'.$key,array('mode'=>'u','no_width'=>1,'params'=>$params));

		$key='UserModify';
		$default=$search[$key]?'u_'.$search[$key]:0;
		$params=base64_encode(serialize(array('MaxEntries'=>1,'useAll'=>1)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Geaendert von]]'),
			'LabelSep'=>'',
			'mode'=>'u',
			'app'=>'zef',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_Invit=new FunctionButtons('s_'.$key,'ajaxttiplabel',$lb_params);
		$formGui->addField('s_'.$key,'ttip',$lb_Invit,$default,'fields1');
		$formGui->setParams('s_'.$key,array('mode'=>'u','no_width'=>1,'params'=>$params));

		if ($this->_Base->hasOss()) {
			$key='AllVersions';
			$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Alle Versionen durchsuchen]]'),$search[$key]?$search[$key]:0,'fields1');
			$values=array(
				0=>$this->_T->lang('[[Nein]]'),
				1=>$this->_T->lang('[[Ja]]'),
			);
			$formGui->setValues($key,$values);
			
			$key='SortScore';
			$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Nach Relevanz sortieren]]'),$search[$key]?$search[$key]:1,'fields1');
			$values=array(
				-1=>$this->_T->lang('[[Nein]]'),
				1=>$this->_T->lang('[[Ja]]'),
			);
			$formGui->setValues($key,$values);
		}
		
		


		$submit_array=array(
			'view_x'=>' '.$this->_T->lang('[[Suchen]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','fields2');
		$formGui->setValues($key,$submit_array);


		$ContGui->addContent('form0',$formGui,'CONTENT',array('','fields0'));
		$ContGui->addContent('timeCreate',$TimeCreateGui->process(),'CONTENT');
		$ContGui->addContent('timeModify',$TimeModifyGui->process(),'CONTENT');
		$ContGui->addContent('form1',$formGui,'CONTENT',array('','fields1'));
		$ContGui->addContent('form2',$formGui,'CONTENT',array('','fields2'));


		$search=array(
			'Info'=>$formGui->getFieldVal('s_Info',1),
			'UserCreate'=>$formGui->getFieldVal('s_UserCreate',1)?substr($formGui->getFieldVal('s_UserCreate',1),2):0,
			'UserModify'=>$formGui->getFieldVal('s_UserModify',1)?substr($formGui->getFieldVal('s_UserModify',1),2):0,
			'TimeCreateB'=>$TimeCreateGui->getDate('B'),
			'TimeCreateE'=>$TimeCreateGui->getDate('E'),
			'TimeCreateMode'=>$TimeCreateGui->getMode(),
			'TimeModifyB'=>$TimeModifyGui->getDate('B'),
			'TimeModifyE'=>$TimeModifyGui->getDate('E'),
			'TimeModifyMode'=>$TimeModifyGui->getMode(),
			'limit'=>50,
			'b'=>Framework::getParam('view_x','','P')?0:Framework::getParam('b',0,'G'),
		);
		if ($this->_Base->hasOss()) {
			$search['AllVersions']=$formGui->getFieldVal('AllVersions',1);
			$search['SortScore']=$formGui->getFieldVal('SortScore',1);
		}
		$this->_L->setParam('b',$search['b']);
		$this->_frm->savePostData($this->_Base->getModul(),'tmpSearch',null,$search);

		return $ContGui;
	}
	function &getSearchContent($search) {
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_ApplicationListGui.php');
		if (Framework::getParam('_OrderF',0,'G')) {
			$this->setPrefs('fmngOrderF',Framework::getParam('_OrderF',0,'G'));
			$this->setPrefs('fmngOrderD',Framework::getParam('_OrderD',0,'G'));
		}
		$orderF=$this->getPrefs('fmngOrderF','Title_'.$this->_frm->getLang());
		$orderD=$this->getPrefs('fmngOrderD',-1);
		$order=array($orderF=>$orderD);
		$b=$search['b'];
		$limit=$search['limit'];
		$rows=0;
		$entries=$this->_Base->searchDocument($rows,$search,$b,$limit,$order);

		$Gui=new ApplicationListGui();
		$L=Framework::cloneObj($this->_L);
		$L->setParam('_loadSearch',1);
		$Gui->setNavLink($L);
		$Gui->setOrderLink($L);
		$Gui->setLimit($limit);
		$Gui->setSumRows($rows);
		$Gui->setBegin($b);

		
		$funcAction=new FunctionObjActionGui('list_action',true);
		$funcAction->setName($this->_T->lang('[[Ausgewaehlte Objekte]]'));
		$list_action=$this->_frm->getObjAction($this->_Base->getModul(),'m_all');
		foreach ($list_action as $key=>$val) {
			if ($val['Hidden']) continue;
			$funcAction->addValue($key,$val['Name']);
		}
		$Gui->addFunction($funcAction);
		$btnList=new CheckBoxBtn ('ListID[]','');
		$funcSelAll=new FunctionButtons('fmng_list','selectall',array('ListID'=>'ListID[]','ListOn'=>false));
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);

		$Gui->setActOrder($orderF,$orderD);
		$Gui->addHeaderCol('ListID',$funcSelAll->process(),'','','',1,'1%',0,'',$noEnc);
		$key='Title_'.$this->_frm->getLang();
		$Gui->addHeaderCol($key,$this->_T->lang('[[Name]]'),'','','','','',1);
		$Gui->setHeaderOrder($key,$key,1);
		if ($this->_Base->hasOss() && $search['SortScore']>0) {
			$key='_Score';
			$Gui->addHeaderCol($key,$this->_T->lang('[[Score]]'),'','','','','',1);
		}
		$key='FileSize';
		$Gui->addHeaderCol($key,$this->_T->lang('[[DateiGroesse]]'),'','','right',1);
		$Gui->setHeaderOrder($key,$key,-1);
		if ($this->_Base->getCfg('cfg/versioning/active')) {
			$key='Version';
			$Gui->addHeaderCol($key,$this->_T->lang('[[Version]]'),'','','',1);
			$Gui->setHeaderOrder($key,'FileMetabase.'.$key,-1);
		}
		$key='UserModify';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Geaendert von]]'),'','','',1);
		$Gui->setHeaderOrder($key,$key,1);
		$key='TimeModify';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Geaendert am]]'),'','','',1);
		$Gui->setHeaderOrder($key,$key,-1);
		$key='Edit';
		$Gui->addHeaderCol($key,'','','','',1);

		foreach ($entries as $val) {
			$Gui->addRow(($hl?$hl=0:$hl=1),'top');
			$Gui->addCol('ListID',$btnList->process($val->getID()),'','','',1,'',0,'',$noEnc);
			//$Gui->addCol('Img','',$val->getImage(),'','',1);
			$goLink=$this->_L->getTempLink(null,array('action'=>$val->getAction(0),'oid'=>$val->getID()));
			$extra=array();
			if ($val->getACL(2)) {
				$extra['LinkAttribs']=array(
					'onclick'=>'return goToView(this);',
					'ondblclick'=>'return goToEdit(this,\'action='.$val->getAction(0).'\',\'action='.$val->getAction(1).'\');',
				);
			}
			if ($this->_Base->getCfg('cfg/versioning/active')) {
				$goLink.='&Version='.$val->getMeta('Version');
			}
			$Gui->addCol('Name',$val->getName(),$val->getImage(0),$goLink,'',0,2000,0,'',$extra);
			if ($this->_Base->hasOss() && $search['SortScore']>0) {
				$key='_Score';
				$Gui->addCol($key,$val->getMeta('_Score'),'','','','','',1);
			}
			$Gui->addCol('FileSize',($val->isFolder() || !$val->getFileMeta('FileSize'))?'':Framework::formatSize($val->getFileMeta('FileSize')).'&nbsp;&nbsp;','','','right',1,'',0,'',$noEnc);
			if ($this->_Base->getCfg('cfg/versioning/active')) {
				$Gui->addCol('Version',$val->getMeta('Version'),'','','',1);
			}
			$Gui->addCol('UserModify',$this->_frm->getCachedUsername($val->getMeta('UserModify'),1),'','','',1);
			$Gui->addCol('TimeModify',date('d.m.Y H:i',$val->getMeta('TimeModify')),'','','',1);
			$Gui->addCol('Edit','','ico-edit.gif',$this->_L->getTempLink(array('action'),array('oid'=>$val->getID())).'&action='.$val->getAction(1),'',1,'',0,'',$noEnc);
			if ($val->getMeta('_Highlights')) {
				$tmp=array();
				foreach($val->getMeta('_Highlights') as $k=>$v) {
					$tmp=array_merge($tmp,$v);
				}
				$Gui->addColSub('Name','N','<div class="snippet">'.implode('</div><div class="snippet">',$tmp).'</div>');
				$Gui->addColSub('Name','NoEnc',true);
			}

			
		}
		return $Gui;
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}

}
?>