<?php
class PublicBoxGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_disabled=false;
	var $_tab='meta';
	function __construct() {
		global $frm,$t,$T,$E,$L,$Y;
		$this->_Base=& $frm->getStaticModul('imng');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('imng');
	}
	function process($obj) {
		$this->_Obj=$obj;
		if ($this->_Obj->getMeta('Trash')) {
			$this->_disabled=true;
		}

		require_once('lib/class_BoxGui.php');
		$box=new BoxGui();
		$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
		$box->setTabContent('meta',$this->getMetaBox());

		$box->addTab('public',$this->_T->lang('[[Publikation]]'),'#',true);
		$box->setTabContent('public',$this->getPublicBox());

		$box->addTab('black',$this->_T->lang('[[Blackboard]]'),'#',true);
		$box->setTabContent('black',$this->getBlackboardBox());

		if (!$this->_Obj->isFolder()) {
			$box->addTab('escal',$this->_T->lang('[[Eskalation]]'),'#',true);
			$box->setTabContent('escal',$this->getEscalationBox());
		}

		$box->setTabOn($this->_tab);

		if (Framework::getParam('meta_save_x') && $this->_Obj->getAcl(2) && !$this->_disabled) {
			if (!$this->_E->isError()) {


				if ($this->_Obj->getID()) {
					if($this->_Obj->getMeta('EscalationEnd')>mktime(23,59,59) || (!$this->_Obj->getMeta('EscalationEnd') && $this->_Obj->getMeta('PublishEnd')>mktime(23,59,59))) {
						$this->_Obj->setMeta('EscalationSend',0);
					}
					$this->_Obj->setMeta('TimeModify',time());
					$this->_Obj->setMeta('UserModify',$this->_frm->getUser());
					$this->_Base->updateMeta($this->_Obj);
					$this->_Base->updateParentMeta($this->_Obj);
				} else {
					$this->_Obj->setMeta('EscalationSend',0);
					$this->_Obj->setMeta('TimeCreate',time());
					$this->_Obj->setMeta('TimeModify',time());
					$this->_Obj->setMeta('UserCreate',$this->_frm->getUser());
					$this->_Obj->setMeta('UserModify',$this->_frm->getUser());
					$this->_Obj->setParentMeta('Sequence',$this->_Base->getNextSequence($this->_Obj->getParentMeta('ParentID')));
					if ($this->_Base->insertMeta($this->_Obj)) {
						$this->_Base->insertParentMeta($this->_Obj);
						$this->_L->setParam(array('oid'=>$this->_Obj->getID()));
					}
				}
				if ($this->_Obj->getParentMeta('LangID')!='00' && $this->_Obj->getParentMeta('LangID')!=$this->_Base->getLangID()) {
					$this->_L->setParam('LangID',$this->_Obj->getParentMeta('LangID'));
				}
				$this->_L->unsetParam(array('action'));
				$this->_L->goToLink();
			}
		}


		return $box->process();
		//return false;
	}
	function getMetaBox() {
		require_once('lib/class_FormGui.php');
		$formGui=new FormGui();

		$lang_array=array($this->_Base->getLangID());
		$selLangArray=array('00'=>$this->_T->lang('[[Mehrsprachig]]'));
		foreach ($this->_Base->getAvLang() as $val) {
			$selLangArray[$val]=strtoupper($val);
			if (!in_array($val,$lang_array)) $lang_array[]=$val;
		}
		//debug($lang_array);

		$key='LangID';
		$def=$this->_Obj?$this->_Obj->getParentMeta($key):'00';
		if ($this->_Obj->isFolder()) {
			$formGui->addField($key,'hidden','','00','field1');
		} else {
			$formGui->addField($key,'select',$this->_T->lang('[[Sprache]]'),$def,'field1');
			$formGui->setValues($key,$selLangArray);
			$onchange="if(this.value=='00'){jQuery('div[id^=dispTitle_]').css('display','');jQuery('#oneLang').trigger('onchange');} else {jQuery('div[id^=dispTitle_]').css('display','none');jQuery('#dispTitle_' + this.value).css('display','');jQuery('#Title_' + this.value).attr('disabled',false);}";
			$formGui->setAttribs($key,array('onchange'=>$onchange));
			$formGui->setDisabled($key,$this->_disabled);
		}
		$formGui->setNoMeta($key);

		$defLang=$formGui->getFieldVal($key,1);

		$langID=$defLang=='00'?$this->_Base->getLangID():$defLang;


		if (Framework::getParam('isset_oneLang',0,'P')) {
			$defOneLang=Framework::getParam('oneLang',0,'P');
		} elseif ($this->_Obj) {
			$defOneLang=1;
			foreach ($lang_array as $lang) {
				if ($this->_Obj->getMeta('Title_'.$lang)!=$this->_Obj->getMeta('Title_'.$langID)) {
					$defOneLang=0;
					break;
				}
			}
		} else {
			$defOneLang=1;
		}


		foreach ($lang_array as $lang) {
			$key='Title_'.$lang;
			$def=$this->_Obj?$this->_Obj->getMeta($key):0;
			$formGui->addField($key,'text',$this->_T->lang('[[Bezeichnung]]').' '.strtoupper($lang),$def,'field1');
			$attribs=array();
			$iptAttribs=array('id'=>'dispTitle_'.$lang);
			if ($lang!=$langID) {
				if ($defLang!='00') {
					$iptAttribs['style']='display:none;';
				}
				if ($defOneLang) {
					$attribs['disabled']='disabled';
				}
				if ($defLang=='00' && !$defOneLang) {
				  $formGui->setRequired($key);
				}
			} else {
				$formGui->setRequired($key);
				if (count($lang_array)>1 && !$formGui->fieldExists('oneLang')) {
					$sKey='oneLang';
					$formGui->addField($sKey,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'form_fields1');
					$sAttribs=array();
					$sIptAttribs=array('id'=>'dispTitle_00');
					foreach ($lang_array as $lang2) {
						if ($lang2!=$lang) $sAttribs['onchange'].="disableEnable('Title_$lang2',this,this.checked?0:1,1);";
					}
					if ($defLang!='00') {
					   $sIptAttribs['style']='display:none;';
					}
					//debug($attribs);
					$formGui->setAttribs($sKey,$sAttribs);
					$formGui->setIptAttribs($sKey,$sIptAttribs);
					$formGui->setNoMeta($sKey);
					$formGui->setDisabled($sKey,$this->_disabled);
				}
			}
			$formGui->setIptAttribs($key,$iptAttribs);
			$formGui->setAttribs($key,$attribs);
			$formGui->setNoMeta($key);
			$formGui->setDisabled($key,$this->_disabled);
		}

		if (!$this->_Obj->isFolder()) {
			$key='Text';
			$def=$this->_Obj?$this->_Obj->getMeta($key):0;
			$formGui->addField($key,'area',$this->_T->lang('[[Beschreibung]]'),$def,'field1');
			$formGui->setAttribs($key,array('rows'=>5));
			$formGui->setDisabled($key,$this->_disabled);
		}

		if (Framework::getParam('meta_save_x') && $this->_Obj->getAcl(2)) {
			if (!$formGui->checkFields()) {
				$this->_tab='meta';
			} else {
				$formGui->addMetaToObj($this->_Obj);
				if ($formGui->fieldExists('oneLang') && $formGui->getFieldVal('oneLang')) {
					$lang_array=array($this->_Base->getLangID());
				}
				foreach ($this->_frm->getAvLang() as $lang) {
					if ($defLang=='00' && !$defOneLang && in_array($lang,$lang_array) && $formGui->fieldExists('Title_'.$lang)) {
						$this->_Obj->setMeta('Title_'.$lang,$formGui->getFieldVal('Title_'.$lang));
					} else {
						$this->_Obj->setMeta('Title_'.$lang,$formGui->getFieldVal('Title_'.$langID));
					}
				}
				//debug($defLang);
				$this->_Obj->setParentMeta('LangID',$defLang);
			}
		}
		return $formGui;
	}
	function getPublicBox() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		$formGui=new FormGui();
		$formGui->setLabelClass('no','no_error');
		//$formGui->setFieldClass('ipts','ipts');

		$key='lb0';
		$formGui->setLabelClass('','error',$key);
		$formGui->addField($key,'label',$this->_T->lang('[[Publikation]]'),'','field1');

		$key='Publish';
		$def=$this->_Obj?$this->_Obj->getMeta($key):0;
		$formGui->addField($key,'check',$this->_T->lang('[[Publikation freigeben]]'),$def,'field1');
		$formGui->setDisabled($key,$this->_disabled);

		$key='lb1';
		$formGui->setLabelClass('','error',$key);
		$formGui->addField($key,'label',$this->_T->lang('[[Dauer (optional)]]'),'','field1');

		$key='PublishStart';
		$def=$this->_Obj?$this->_Obj->getMeta($key):0;
		if ($def<0) $def=0;
		$formGui->addField($key,'unixdate',$this->_T->lang('[[von]]'),$def,'field1');
		$formGui->setIptAttribs($key,array('style'=>'width:160px;float:left;clear:none;'));
		$formGui->setAttribs($key,array('style'=>'width:120px;'));
		$formGui->setDisabled($key,$this->_disabled);


		$key='PublishEnd';
		$def=$this->_Obj?$this->_Obj->getMeta($key):0;
		if ($def<0) $def=0;
		$formGui->addField($key,'unixdate',$this->_T->lang('[[bis]]'),$def,'field1');
		$formGui->setIptAttribs($key,array('style'=>'width:140px;float:left;clear:none;'));
		$formGui->setAttribs($key,array('style'=>'width:120px;'));
		$formGui->setDisabled($key,$this->_disabled);



		$key='lb3';
		$formGui->setLabelClass('','error',$key);
		$formGui->addField($key,'label',$this->_T->lang('[[Publizieren fuer]]'),'','field1');
		$formGui->setIptAttribs($key,array('style'=>'clear:both;'));

		$key='PublishPerms';
		$mode='u|g';
		$params=base64_encode(serialize(array()));
		if (!$this->_disabled) {
			$lb_params=array('Values'=>array());
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
				'LabelSep'=>'',
				'mode'=>$mode,
				'app'=>'imng',
				'params'=>$params,
				'FieldVal'=>'_USERS',
			);
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Gruppen]]'),
				'LabelSep'=>' / ',
				'mode'=>$mode,
				'app'=>'inmg',
				'params'=>$params,
				'FieldVal'=>'_GROUPS',
			);
			$lb=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		} else {
			$lb='';
		}
		$def=array();
		if ($this->_Obj && trim($this->_Obj->getMeta('PublishGroups'))) {
			$defGroups=explode('|',substr($this->_Obj->getMeta('PublishGroups'),1,-1));
		} else {
			$defGroups=array();
		}
		foreach ($defGroups as $val) {
			if ($val) $def[]='g_'.$val;
		}
		if ($this->_Obj && trim($this->_Obj->getMeta('PublishUsers'))) {
			$defUsers=explode('|',substr($this->_Obj->getMeta('PublishUsers'),1,-1));
		} else {
			$defUsers=array();
		}
		foreach ($defUsers as $val) {
			if ($val) $def[]='u_'.$val;
		}
		$formGui->addField($key,'ttip',$lb,implode('|',$def),'f_fields');
		$formGui->setParams($key,array('mode'=>$mode,'app'=>'imng','params'=>$params));
		$formGui->setNoMeta($key);
		$formGui->setDisabled($key,$this->_disabled);

		if (Framework::getParam('meta_save_x') && $this->_Obj->getAcl(2)) {
			if (!$formGui->checkFields()) {
				$this->_tab='public';
			} else {
				$formGui->addMetaToObj($this->_Obj);

				if ($this->_Obj->getMeta('Publish')) {
					if ($this->_Obj->getMeta('PublishEnd')) {
						if ($this->_Obj->getMeta('PublishEnd')<$this->_Obj->getMeta('PublishStart')) {
							$this->_E->setError('fields','PublishEnd');
							$this->_tab='public';
						}
					}
				}

				$defGroups=array();
				$defUsers=array();
				$def=explode('|',$formGui->getFieldVal('PublishPerms'));
				foreach ($def as $val) {
					$tmp=explode('_',$val);
					if ($tmp[0]=='u') $defUsers[]=$tmp[1];
					if ($tmp[0]=='g') $defGroups[]=$tmp[1];
				}
				//debug($invitG);
				$this->_Obj->setMeta('PublishGroups','|'.implode('|',$defGroups).'|');
				$this->_Obj->setMeta('PublishUsers','|'.implode('|',$defUsers).'|');
			}
		}
		return $formGui;
	}
	function getBlackboardBox() {
		require_once('lib/class_FormGui.php');
		$formGui=new FormGui();
		$formGui->setLabelClass('no','no_error');

		$key='lb0';
		$formGui->setLabelClass('','error',$key);
		$formGui->addField($key,'label',$this->_T->lang('[[Blackboard]]'),'','field1');

		$key='Portal';
		$def=$this->_Obj?$this->_Obj->getMeta($key):0;
		$formGui->addField($key,'check',$this->_T->lang('[[Auf Blackboard anzeigen]]'),$def,'field1');
		$formGui->setDisabled($key,$this->_disabled);

		$key='lb1';
		$formGui->setLabelClass('','error',$key);
		$formGui->addField($key,'label',$this->_T->lang('[[Dauer (optional)]]'),'','field1');

		$key='PortalStart';
		$def=$this->_Obj?$this->_Obj->getMeta($key):0;
		if ($def<0) $def=0;
		$formGui->addField($key,'unixdate',$this->_T->lang('[[von]]'),$def,'field1');
		$formGui->setIptAttribs($key,array('style'=>'width:160px;float:left;clear:none;'));
		$formGui->setAttribs($key,array('style'=>'width:120px;'));
		$formGui->setDisabled($key,$this->_disabled);

		$key='PortalEnd';
		$def=$this->_Obj?$this->_Obj->getMeta($key):0;
		if ($def<0) $def=0;
		$formGui->addField($key,'unixdate',$this->_T->lang('[[bis]]'),$def,'field1');
		$formGui->setIptAttribs($key,array('style'=>'width:140px;float:left;clear:none;'));
		$formGui->setAttribs($key,array('style'=>'width:120px;'));
		$formGui->setDisabled($key,$this->_disabled);


		$key='lb_spc';
		$formGui->addField($key,'label','','','field1');
		$formGui->setIptAttribs($key,array('style'=>'clear:both;'));


		if (Framework::getParam('meta_save_x') && $this->_Obj->getAcl(2)) {
			if (!$formGui->checkFields()) {
				$this->_tab='black';
			} else {
				$formGui->addMetaToObj($this->_Obj);

				if ($this->_Obj->getMeta('Portal')) {
					if ($this->_Obj->getMeta('PortalEnd')) {
						if ($this->_Obj->getMeta('PortalEnd')<$this->_Obj->getMeta('PortalStart')) {
							$this->_E->setError('fields','lb1');
							$this->_E->setError('fields','PortalEnd');
							$this->_tab='black';
						}
						if ($this->_Obj->getMeta('PublishEnd') && $this->_Obj->getMeta('PortalEnd')>$this->_Obj->getMeta('PublishEnd')) {
							$this->_E->setError('fields','lb1');
							$this->_E->setError('fields','PortalEnd');
							$this->_tab='black';
						}
					}
					if ($this->_Obj->getMeta('PortalStart')) {
						if ($this->_Obj->getMeta('PortalStart')<$this->_Obj->getMeta('PublishStart')) {
							$this->_E->setError('fields','lb1');
							$this->_E->setError('fields','PortalStart');
							$this->_tab='black';
						}
					}
				}
			}
		}

		return $formGui;

	}
	function getEscalationBox() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		$formGui=new FormGui();
		$formGui->setLabelClass('no','no_error');

		/*$key='lb0';
		$formGui->setLabelClass('','error',$key);
		$formGui->addField($key,'label',$this->_T->lang('[[Bestaetigung innerhalb]]'),'','field1');*/
		$key='EscalationEnd';
		$def=$this->_Obj?$this->_Obj->getMeta($key):0;
		if ($def<0) $def=0;
		$formGui->setLabelClass('','error',$key);
		$formGui->addField($key,'unixdate',$this->_T->lang('[[Bestaetigung innerhalb]]'),$def,'field1');
		$formGui->setAttribs($key,array('style'=>'width:120px;'));
		$formGui->setDisabled($key,$this->_disabled);

		$key='lb3';
		$formGui->setLabelClass('','error',$key);
		$formGui->addField($key,'label',$this->_T->lang('[[Dokument vorlegen an]]'),'','field1');
		$formGui->setIptAttribs($key,array('style'=>'clear:both;'));
		$formGui->setDisabled($key,$this->_disabled);

		$key='EscalationPerms';
		$mode='u|g';
		$params=base64_encode(serialize(array()));
		if (!$this->_disabled) {
			$lb_params=array('Values'=>array());
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
				'LabelSep'=>'',
				'mode'=>$mode,
				'app'=>'imng',
				'params'=>$params,
				'FieldVal'=>'_USERS',
			);
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Gruppen]]'),
				'LabelSep'=>' / ',
				'mode'=>$mode,
				'app'=>'inmg',
				'params'=>$params,
				'FieldVal'=>'_GROUPS',
			);

			$lb=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		} else {
			$lb='';
		}

		$def=array();
		if ($this->_Obj && trim($this->_Obj->getMeta('EscalationGroups'))) {
			$defGroups=explode('|',substr($this->_Obj->getMeta('EscalationGroups'),1,-1));
		} else {
			$defGroups=array();
		}
		foreach ($defGroups as $val) {
			if ($val) $def[]='g_'.$val;
		}
		if ($this->_Obj && trim($this->_Obj->getMeta('EscalationUsers'))) {
			$defUsers=explode('|',substr($this->_Obj->getMeta('EscalationUsers'),1,-1));
		} else {
			$defUsers=array();
		}
		foreach ($defUsers as $val) {
			if ($val) $def[]='u_'.$val;
		}
		$formGui->addField($key,'ttip',$lb,implode('|',$def),'f_fields');
		$formGui->setParams($key,array('mode'=>$mode,'app'=>'imng','params'=>$params));
		$formGui->setNoMeta($key);
		$formGui->setDisabled($key,$this->_disabled);

		$key='lb4';
		$formGui->setLabelClass('','error',$key);
		$formGui->addField($key,'label',$this->_T->lang('[[Benachrichtigung]]'),'','field1');

		$key='EscalationNotice';
		$def=$this->_Obj?$this->_Obj->getMeta($key):0;
		$formGui->addField($key,'check',$this->_T->lang('[[Benachrichtigung wenn Bestaetigungszeit ueberschritten]]'),$def,'field1');
		$formGui->setDisabled($key,$this->_disabled);

		if (Framework::getParam('meta_save_x') && $this->_Obj->getAcl(2)) {
			if (!$formGui->checkFields()) {
				$this->_tab='escal';
			} else {
				$oldEscalationEnd=$this->_Obj->getMeta('EscalationEnd');
				$formGui->addMetaToObj($this->_Obj);

				if ($this->_Obj->getMeta('EscalationEnd')) {
					if ($this->_Obj->getMeta('EscalationEnd')<$this->_Obj->getMeta('PublishStart')) {
						$this->_E->setError('fields','EscalationEnd');
						$this->_tab='escal';
					}
					if ($this->_Obj->getMeta('PublishEnd') && $this->_Obj->getMeta('EscalationEnd')>$this->_Obj->getMeta('PublishEnd')) {
						$this->_E->setError('fields','EscalationEnd');
						$this->_tab='escal';
					}
					if ($oldEscalationEnd!=$this->_Obj->getMeta('EscalationEnd') && $this->_Obj->getMeta('EscalationEnd')<mktime(0,0,0)) {
						$this->_E->setError('fields','EscalationEnd');
						$this->_tab='escal';
					}
				}

				$defGroups=array();
				$defUsers=array();
				$def=explode('|',$formGui->getFieldVal('EscalationPerms'));
				foreach ($def as $val) {
					$tmp=explode('_',$val);
					if ($tmp[0]=='u') $defUsers[]=$tmp[1];
					if ($tmp[0]=='g') $defGroups[]=$tmp[1];
				}
				//debug($invitG);
				$this->_Obj->setMeta('EscalationGroups','|'.implode('|',$defGroups).'|');
				$this->_Obj->setMeta('EscalationUsers','|'.implode('|',$defUsers).'|');
			}
		}
		return $formGui;

	}
}
?>