<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if ($rootObj->getMeta('System')=='d') {
	$this_action=$frm->getObjAction ($Imng->getModul(),'m_'.$mode,$list_action_val);
} else {
	$this_action=$frm->getObjAction ($Imng->getModul(),$obj->getActionMode(1),$list_action_val);
}
if ($Imng->isAllowedAction($obj,reset($this_action))) {
	$location='';
	$ListID=Framework::getParam('ListID');
	switch (Framework::getParam('list_action_val','')) {
		case 'cut':
			if (!is_array($ListID)) break;
			if ($Imng->isClipboard('iobj')) {
				$frm->deleteClipboard('iobj');
				$Imng->setClipboard('iobj',false);
			}
			foreach ($ListID as $key=>$val) {
				$new_obj=$Imng->getObj($val);
				if (is_object($new_obj)) {
					$this_action=$frm->getObjAction($Imng->getModul(),$new_obj->getActionMode(0),Framework::getParam('list_action_val',''));
					if ($Imng->isAllowedAction($new_obj,reset($this_action))) {
						$frm->insertClipboard('iobj',$val,'cut');
						unset($ListID[$key]);
					} else {
						$ActionError['no_cut_perms'][]=$val;
					}
				}
			}
			$Imng->setClipboard('iobj',$frm->getClipboard('iobj'));
			break;
		case 'copy':
			if (!is_array($ListID)) break;
			if ($Imng->isClipboard('iobj')) {
				$frm->deleteClipboard('iobj');
				$Imng->setClipboard('iobj',false);
			}
			foreach ($ListID as $key=>$val) {
				$new_obj=$Imng->getObj($val);
				if (is_object($new_obj)) {
					$this_action=$frm->getObjAction ($Imng->getModul(),$new_obj->getActionMode(0),Framework::getParam('list_action_val',''));
					if ($Imng->isAllowedAction($new_obj,reset($this_action))) {
						$frm->insertClipboard('iobj',$val,'copy');
						unset($ListID[$key]);
					} else {
						$ActionError['no_copy_perms'][]=$val;
					}
				}
			}
			$Imng->setClipboard('iobj',$frm->getClipboard('iobj'));
			break;
		case 'l_insert':
			if ($Imng->isClipboard('iobj')) {
				foreach ($Imng->getClipboard('iobj') as $val) {
					$new_obj=$Imng->getObj($val['Content']);
					$tmp_error=CutCopyObject($obj,$new_obj,'link',true);
					if (!$tmp_error) {
						$frm->deleteClipboard('iobj',$val['Content']);
					} else {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
				$Imng->setClipboard('iobj',$frm->getClipboard('iobj'));
			}
			break;
		case 'insert':
			if ($Imng->isClipboard('iobj')) {
				foreach ($Imng->getClipboard('iobj') as $val) {
					$new_obj=$Imng->getObj($val['Content']);
					$tmp_error=CutCopyObject($obj,$new_obj,$val['Mode'],true);
					if (!$tmp_error) {
						$frm->deleteClipboard('iobj',$val['Content']);
					} else {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
				$Imng->setClipboard('iobj',$frm->getClipboard('iobj'));
			}
			break;
		case 'delete':
			if (!is_array($ListID)) break;
			if (is_object($trash_obj)) {
				foreach ($ListID as $key=>$val) {
					$new_obj=$Imng->getObj($val);
					if (is_object($new_obj)) {
						$tmp_error=TrashObject($trash_obj,$new_obj);
						if (!$tmp_error) {
							unset($ListID[$key]);
						} else {
							$ActionError[$tmp_error[0]][]=$tmp_error[1];
						}
					}
				}
			}
			break;
		case 'f_delete':
			if (!is_array($ListID)) break;
			foreach ($ListID as $key=>$val) {
				$new_obj=$Imng->getObj($val);
				if (is_object($new_obj)) {
					$tmp_error=DeleteObject($new_obj);
					if ($tmp_error) {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
			}
			break;
		case 'i_fav':
			if (!is_array($ListID)) break;
			foreach ($ListID as $key=>$val) {
				$new_obj=$Imng->getObj($val);
				if (is_object($new_obj)) {
					if (!$new_obj->getFavoriteMeta('Favorite')) {
						$new_obj->setFavoriteMeta('Favorite',1);
						$Imng->insertFavoriteMeta($new_obj);
					}
					unset($ListID[$key]);
				}
			}
			break;
		case 'd_fav':
			if (!is_array($ListID)) break;
			foreach ($ListID as $key=>$val) {
				$new_obj=$Imng->getObj($val);
				//debug($new_obj);
				if (is_object($new_obj)) {
					if ($new_obj->getFavoriteMeta('Favorite')) {
						$new_obj->setFavoriteMeta('Favorite',0);
						$Imng->insertFavoriteMeta($new_obj);
					}
					unset($ListID[$key]);
				}
			}
			break;
		case 's_msg':
			if (!is_array($ListID)) break;
			$msg_Link=array();
			foreach ($ListID as $key=>$val) {
				$new_obj=$Imng->getObj($val);
				if (is_object($new_obj)) {
					$msg_Link[]=array(
						'U'=>"index.php?site=".$new_obj->getSite()."&action=".$new_obj->getAction(0)."&oid=".$new_obj->getID(),
						'N'=>$new_obj->getName(),
					);
        		}
				unset($ListID[$key]);
			}
			if (!empty($msg_Link)) {
				$msgParams=array(
					'reset'=>1,
					'tab'=>'msg',
				);
				$msgParams['msgLink']=json_encode($msg_Link);
				$frm->addOnload('ge.registry.coreViewMessage.geMsgShow('.(json_encode($msgParams)).');');
			}
			break;

	}
	Framework::importParam(array('ListID'=>$ListID),'P');


	if ($location) {
		page_close();
		header('Location:'.$location);
		exit;
	}
}
?>
