<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$obj_action=$frm->getObjAction($Imng->getModul(),$obj->getActionMode(0));
if ($Imng->isAllowedAction($obj,$obj_action[$obj_action_val])) {
	$location='';
	switch ($obj_action_val) {
		case 'n_fol':
			$location="index.php?site=$site&action=b&new=$obj_action_val&edit=1&oid=".$obj->getID();
		break;
		case 'n_doc':
			$location="index.php?site=$site&action=vo&new=$obj_action_val&edit=1&&oid=".$obj->getID();
		break;
		case 'e_fol':
			$edit=1;
			break;

		case 'cut':
			if ($Imng->isClipboard('iobj')) {
				$frm->deleteClipboard('iobj');
				$Imng->setClipboard('iobj',false);
			}
			$Imng->setClipboard('iobj',$frm->insertClipboard('iobj',$obj->getID(),'cut'));
			break;
		case 'copy':
			if ($Imng->isClipboard('iobj')) {
				$frm->deleteClipboard('iobj');
				$Imng->setClipboard('iobj',false);
			}
			$Imng->setClipboard('iobj',$frm->insertClipboard('iobj',$obj->getID(),'copy'));
			break;
		case 'l_insert':
			if ($Imng->isClipboard('iobj')) {
				foreach ($Imng->getClipboard('iobj') as $val) {
					$new_obj=$Imng->getObj($val['Content']);
					$tmp_error=CutCopyObject($obj,$new_obj,'link',true);
					if (!$tmp_error) {
						$frm->deleteClipboard('iobj',$val['Content']);
					} else {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
				$Imng->setClipboard('iobj',$frm->getClipboard('iobj'));
			}
			break;
		case 'l_root_d':
			$new_obj=$Imng->getSystemObj('d',$session_lang,$user_id,true);
			if (is_object($new_obj)) {
				$tmp_error=CutCopyObject($new_obj,$obj,'link',true);
				if ($tmp_error) {
					$ActionError[$tmp_error[0]][]=$tmp_error[1];
				}
			}
			break;
		case 'insert':
			if ($Imng->isClipboard('iobj')) {
				foreach ($Imng->getClipboard('iobj') as $val) {
					$new_obj=$Imng->getObj($val['Content']);
					$tmp_error=CutCopyObject($obj,$new_obj,$val['Mode'],true);
					if (!$tmp_error) {
						$frm->deleteClipboard('iobj',$val['Content']);
					} else {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
				$Imng->setClipboard('iobj',$frm->getClipboard('iobj'));
			}
			break;
		case 'delete':
			if (is_object($trash_obj)) {
				$oldParentID=$obj->getParentMeta('ParentID');
				$tmp_error=TrashObject($trash_obj,$obj);
				if (!$tmp_error) {
					$location="index.php?site=$site&oid=".$oldParentID;
				} else {
					$ActionError[$tmp_error[0]][]=$tmp_error[1];
				}
			}
			break;
		case 'f_delete':
			$oldParentID=$obj->getParentMeta('ParentID');
			$tmp_error=DeleteObject($obj);
			if (!$tmp_error) {
				$location="index.php?site=$site&oid=".$oldParentID;
			} else {
				$ActionError[$tmp_error[0]][]=$tmp_error[1];
			}
			break;
		case 'tr_delete':
			if (is_object($trash_obj)) {
				$sub_entrys=$Imng->ListSubEntrys($trash_obj->getID(),'');
				foreach ($sub_entrys as $new_obj) {
					$tmp_error=DeleteObject($new_obj);
					if ($tmp_error) {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
			}
			break;
		case 'i_fav':
			if (!$obj->getFavoriteMeta('Favorite')) {
				$obj->setFavoriteMeta('Favorite',1);
				$Imng->insertFavoriteMeta($obj);
			}
			break;
		case 'd_fav':
			if ($obj->getFavoriteMeta('Favorite')) {
				$obj->setFavoriteMeta('Favorite',0);
				$Imng->insertFavoriteMeta($obj);
			}
			break;
		case 'modify':
			$location="index.php?site=$site&action=".$obj->getAction(1)."&oid=".$obj->getID();
			break;
		case 'perms':
			$action='p';
			//$location="index.php?site=$site&action=".$obj->getAction(1)."&oid=".$obj->getID();
			break;
		case 'config':
			$action='cfg';
			//$location="index.php?site=$site&action=".$obj->getAction(1)."&oid=".$obj->getID();
			break;
		case 'export':
			ExportSite($obj);
			break;
		case 'import':
			$action='imp';
			//$location="index.php?site=$site&action=".$obj->getAction(1)."&oid=".$obj->getID();
			break;
	}
	if ($location) {
		page_close();
		header('Location:'.$location);
		exit;
	}
}

?>
