<?php
class MailLogGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	var $_droppable=array();
	function MailLogGui() {
		global $frm,$T,$E,$L,$P,$Y;
		$this->_Log=& $frm->getStaticModul('core_log');
		$this->_T=&$T;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_Y=&$Y;
		$this->_T->loadModul('mail');
		require_once('lib/class_ApplicationTreeGui.php');
		$this->_Gui=new ApplicationTreeGui();
	}
	function _handleRequest() {
		$this->_view=Framework::getParam('view','forward');

		$this->_Gui->addTreeContent($this->getConfigGui());

		$this->_Gui->addContent($this->getContentGui());

	}
	function &process() {
		$this->_handleRequest();
		return $this->_Gui;
	}

	function getConfigGui() {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		$tabGui->setName($this->_T->lang('[[Logbuch]]'));
		if ($this->_view=='forward') {
			$hl=2;
		} else {
			$hl=0;
		}
		$tabGui->addRow($hl);
		$tabGui->addCol('IMG','','month_mine.gif');
		$tabGui->addCol('Name',$this->_T->lang('[[Intern weiterleiten]]'),'',$this->_L->getTempLink(null,array('view'=>'forward')),'',0,'2000');
		return $tabGui;
	}
	function &getContentGui() {
		require_once('lib/class_ApplicationListGui.php');
		$search=array(
			'FKModul'=>'mail',
			'FKUserID'=>$this->_frm->getUser(),
			'FKObjID'=>0,
			'b'=>Framework::getParam('b','G',0),
			'limit'=>20,
			'LogDesc'=>$this->_view,
		);
		$rows=0;
		$tabGui=new ApplicationListGui();
		$tabGui->setName($this->_T->lang('[[Logbuch]]'));

		$tabGui->addHeaderCol('LogDate',$this->_T->lang('[[Datum]]'),'','','',1,'');
		//$tabGui->addHeaderCol('LogUser',$this->_T->lang('[[BenutzerIn]]'),'','','',1,'');
		$tabGui->addHeaderCol('BoxFrom',$this->_T->lang('[[Von]]'),'','','',1,'');
		$tabGui->addHeaderCol('UserTo',$this->_T->lang('[[An]]'),'','','',1,'');
		$tabGui->addHeaderCol('MailFrom',$this->_T->lang('[[AbsenderIn]]'),'','','',1,'');
		$tabGui->addHeaderCol('MailSubject',$this->_T->lang('[[Betreff]]'),'','','',0,'2000');

		$logEntries=$this->_Log->searchLog($rows,$search);
		if ($rows) {
			$navLink=Framework::cloneObj($this->_L);
			$tabGui->setNavLink($this->_L);
			$tabGui->setLimit($search['limit']);
			$tabGui->setSumRows($rows);
			$tabGui->setBegin($search['b']);



			$logValues=$this->_Log->listLogValues(array_keys($logEntries));
			//debug($logValues);
			foreach ($logEntries as $val) {
				$hl=($hl?$hl=0:$hl=1);
				$tabGui->addRow($hl,'top','');
				$tabGui->addCol('LogDate',Framework::dateSql('d.m.Y H:i',$val->getMeta('LogDate')),'','','',1,'');
				//$tabGui->addCol('LogUser',$this->_frm->getCachedUserName($val->getMeta('FKUserID'),0,1),'','','',1,'');
				$fieldVal=array();
				if (is_array($logValues[$val->getID()])) {
					$i=0;
					foreach ($logValues[$val->getID()] as $subVal) {
						if ($i) {
							$tabGui->addRow($hl,'top','',1);
							$tabGui->addCol('LogDate','','','','',0,'',1);
						}
						$logData=unserialize($subVal['NewValue']);

						$tabGui->addCol('BoxFrom',$logData['FromBox'],'','','',1,'');
						$tabGui->addCol('UserTo',implode(',',$this->_frm->getCachedUserName($logData['ToUserID'],0,1)),'','','',1,'');
						$tabGui->addCol('MailFrom',Framework::wordSplit($logData['From'],30),'','','',1,'');
						$tabGui->addCol('MailSubject',$logData['Subject'],'','','',0,'2000');
						$i++;
					}
				}
			}
		}
		return $tabGui;
	}


}
?>