<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$obj_action=$frm->getObjAction($Mail->getModul(),$obj->getActionMode(0));
if ($Mail->isAllowedAction($obj,$obj_action[$obj_action_val])) {
	$location='';
	switch ($obj_action_val) {
		case 'n_fol':
			$new='n_fol';
		break;
		case 'f_delete':
			$oldBox=$obj->getMeta('ParentBox');
			$ActionError=$Mail->deleteFolder($obj->getBox());
			if (!$ActionError) {
				if ($P && is_object($P)) {
					$pObj=$P->isProjectMailFolder($obj->getBox());
					if (is_object($pObj) && $pObj->getMeta('Aktiv')) {
						$PrjGroups=$P->getRuleGroups($pObj);
						if (!empty($PrjGroups)) {
							$PrjUsers=$frm->getGroupUsers($PrjGroups);
							if (is_array($PrjUsers)) {
								foreach ($PrjUsers as $val) {
									$Mail->delteMailAbbo($val,$obj->getBox());
								}
							}
						}
					}
				}
				$BaseSync=$frm->getStaticModul('active_sync');
				$BaseSync->deleteSyncFolders($obj->getMeta('RootID')=='INBOX'?$frm->getUser():-1,-1,$obj->getBox());
				$BaseSync->deleteSyncFolders($obj->getMeta('RootID')=='INBOX'?$frm->getUser():-1,-1,$obj->getBox().'.%');

				$location="index.php?site=$site&action=$action&rid=".urlencode($rid)."&oid=".urlencode($oldBox);
			}
			break;
		case 'tr_delete':
			if (is_object($trash_obj)) {
				$sub_entrys=$Mail->listMailIDs($obj->getBox());
				foreach ($sub_entrys as $del_id) {
					$tmp_error=$Mail->deleteMail($obj->getBox(),$del_id);
				}
				$ActionError=$Mail->expungeBox($obj->getBox());
				if (!$ActionError) {
					$location="index.php?site=$site&action=$action&rid=".urlencode($rid)."&oid=".urlencode($obj->getBox());
				}
			}
			break;
		case 'spam_delete':
			if (is_object($spam_obj)) {
				$sub_entrys=$Mail->listMailIDs($obj->getBox());
				foreach ($sub_entrys as $del_id) {
					$tmp_error=$Mail->deleteMail($obj->getBox(),$del_id);
				}
				$ActionError=$Mail->expungeBox($obj->getBox());
				if (!$ActionError) {
					$location="index.php?site=$site&action=$action&rid=".urlencode($rid)."&oid=".urlencode($obj->getBox());
				}
			}
			break;
		case 'subscribe':
			if ($obj->getMeta('NoMails')) {
				$ActionError=0;
			} else {
				$ActionError=$Mail->subscribeFolder($obj->getBox());
			}
			if (!$ActionError) {
				$folders=$Mail->listFolders($obj->getBox().$Mail->getCfg('cfg/delim').'*',true,false);
				//debug($folders);
				foreach ($folders as $key=>$val) {
					$ActionError=$Mail->subscribeFolder($val->getBox());
					if ($ActionError) break;
				}
			}
			break;
		case 'unsubscribe':
			$ActionError=$Mail->unsubscribeFolder($obj->getBox());
			if (!$ActionError) {
				$folders=$Mail->listFolders($obj->getBox().$Mail->getCfg('cfg/delim').'*',false,false);
				foreach ($folders as $key=>$val) {
					$ActionError=$Mail->unsubscribeFolder($val->getBox());
					if ($ActionError) break;
				}
				if (!$ActionError) {
					$location="index.php?site=$site&action=$action&rid=".urlencode($rid)."&oid=".urlencode($obj->getMeta('ParentBox'));
				}
			}
			break;
		case 'e_fol':
			$edit=1;
			break;
		case 'vall':
			$Mail->setLimit(0);
			$b=0;
			break;
		case 'insert':
			if ($Mail->isClipboard('mobj')) {
				foreach ($Mail->getClipboard('mobj') as $val) {
					$temp=explode('||',$val['Content']);
					$copy_mail[$temp[0]][]=$temp[1];
				}
				foreach ($copy_mail as $oldBox=>$oldID) {
					if ($val['Mode']=='cut') {
						$tmp_error=$Mail->moveMail($oldBox,$oldID,$obj->getBox());
						if (!$tmp_error) {
							$Mail->expungeBox($oldBox);
						}
					}
					if ($val['Mode']=='copy') {
						$tmp_error=$Mail->copyMail($oldBox,$oldID,$obj->getBox());
					}
					if ($tmp_error) {
						$ActionError=$tmp_error;
					}
				}
				if (!$ActionError) {
					$frm->deleteClipboard('mobj');
					$location="index.php?site=$site&action=$action&rid=".urlencode($rid)."&oid=".urlencode($obj->getBox());
				}
			}
			break;
		case 'mark_r':
			if (is_array($ListID)) {
				foreach ($ListID as $key=>$val) {
					$temp=explode('||',$val);
					if (!$Mail->setFlag($obj->getBox(),$temp[1],"\\Seen")) {
						unset($ListID[$key]);
					}
					$location="index.php?site=$site&action=$action&rid=".urlencode($rid)."&oid=".urlencode($obj->getBox());
				}
			}
		break;
		case 'mark_u':
			if (is_array($ListID)) {
				foreach ($ListID as $key=>$val) {
					$temp=explode('||',$val);
					if (!$Mail->clearFlag($obj->getBox(),$temp[1],"\\Seen")) {
						unset($ListID[$key]);
					}
				}
				$location="index.php?site=$site&action=$action&rid=".urlencode($rid)."&oid=".urlencode($obj->getBox());
			}
		break;
	}
	if ($location) {
		page_close();
		header('Location:'.$location);
		exit;
	}
} elseif (strpos($obj_action_val,'filter_')===0) {
	$filter_id=intval(str_replace('filter_','',$obj_action_val));
	if ($filter_id) {
		require_once('lib/mail/classSieve.php');
		$sieve=new SieveDB($db);
		$sieve->filterMbox($Mail,$filter_id,$user_id,$obj->getBox(),$trash_obj->getBox());
		$location="index.php?site=$site&action=$action&rid=".urlencode($rid)."&oid=".urlencode($obj->getBox());
		page_close();
		header('Location:'.$location);
		exit;
	}
}
?>
