<?php
class geMsgCtrlMain {
	var $_Base;
	var $_Obj;
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	function __construct() {
		global $frm,$t,$T,$E,$L,$Y;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_Y=&$Y;
		$this->_T->loadModul('msg');
		$this->_T->loadModul('sms');
	}
	function process() {
		if (!$this->_handleRequest()) {
			return false;
		}
		require_once('lib/class_ApplicationGui.php');
		$this->_AppGui=new ApplicationGui();
		$this->_AppGui->setName($this->_T->lang('[[Nachrichten]]'));
		$this->_AppGui->setImage('appl_msg.gif');
		$this->_AppGui->addConfirm('delete');
		if ($this->_frm->getMyApps('msg')) {

			$this->_AppGui->addTab('msg_b',$this->_T->lang('[[Aktuelle Notes]]'),"index.php?site=msg.php&action=msg_b",'');
			$this->_AppGui->addTab('msg_a',$this->_T->lang('[[Archivierte Notes]]'),"index.php?site=msg.php&action=msg_a",'');
			$this->_AppGui->addTab('msg_s',$this->_T->lang('[[Gesendete Notes]]'),"index.php?site=msg.php&action=msg_s",'');
		}
		if ($this->_frm->getMyApps('rem')) {
			$this->_AppGui->addTab('rem_b',$this->_T->lang('[[remTitle]]'),"index.php?site=msg.php&action=rem_b",'');
		}
		if ($this->_frm->getMyApps('sms')) {
			$this->_AppGui->addTab('sms_s',$this->_T->lang('[[Gesendete SMS]]'),"index.php?site=msg.php&action=sms_s",'');
		}
		$this->_AppGui->setTabOn($this->_action);


		switch ($this->_action) {
			case 'msg_s':
			case 'msg_a':
			case 'msg_b':
				$Gui=$this->getListMsgGui();
			break;
			case 'sms_s':
				require_once('lib/class_ApplicationTreeGui.php');
				$Gui=new ApplicationTreeGui();
				$Gui->addTreeContent($this->getSearchSmsGui());
				$Gui->addContent($this->getListSmsGui());
			break;
			case 'rem_b':
				$this->_T->loadModul('rem');
				$Gui=$this->getListRemGui();
			break;
		}
		$this->_AppGui->addContent($Gui);
		$this->_AppGui->processApplication();
		return true;
	}

	function _handleRequest() {
		if (!$this->_frm->getMyApps('msg') && !$this->_frm->getMyApps('sms')) {
			return false;
		}
		$avAction=array();
		if ($this->_frm->getMyApps('msg')) {
			$avAction=array_merge($avAction,array('msg_b','msg_a','msg_s'));
		}
		if ($this->_frm->getMyApps('sms')) {
			$avAction=array_merge($avAction,array('sms_s'));
		}
		if ($this->_frm->getMyApps('rem')) {
			$avAction=array_merge($avAction,array('rem_b'));
		}
		$this->_action=Framework::getParam('action','');
		if (!$this->_action || !in_array($this->_action,$avAction)) {
			$this->_action=reset($avAction);
		}
		$this->_L->setParam('action',$this->_action);
		$this->_oid=Framework::getParam('oid',0);
		switch ($this->_action) {
			case 'msg_b':
			case 'msg_a':
			case 'msg_s':
				$this->_BaseMsg=& $this->_frm->getStaticModul('msg');
				$this->_BaseMsg->clearNew();
				if ($this->_oid) {
					//$this->_Obj=$this->_BaseMsg->getObj($this->_oid);
				}
				if (Framework::getParam('geMsgListAction_x','0','P') && Framework::getParam('geMsgListAction_val','0','P')) {
					$msgID=Framework::getParam('geMsgListID','0','P');
					switch (Framework::getParam('geMsgListAction_val','0','P')) {
						case 'delete':
							if (!empty($msgID)) {
								if ($this->_action=='msg_s') {
									$this->_BaseMsg->markDeleted($msgID);
								} else {
									$this->_BaseMsg->unlinkMessage($msgID);

								}
							}
						break;
						case 'archiv':
							if (!empty($msgID)) {
								$this->_BaseMsg->archivMessage($msgID);
							}
						break;
						case 'close':
							if (!empty($msgID)) {
								$this->_BaseMsg->markVisited($msgID);
							}
						break;
					}
				}


			break;
			case 'sms_s':
				$this->_BaseSms=& $this->_frm->getStaticModul('sms');
				$this->_BaseSmsRes=& $this->_frm->getStaticModul('sms_res');
				if (Framework::getParam('_loadSmsSearch',0)) {
					$this->_search=$this->_frm->loadPostData($this->_BaseSms->getModul(),'tmpSmsSearchUser',1,0);
				}
				if ($this->_oid) {
					//$this->_Obj=$this->_BaseSms->getObj($this->_oid);
				}
			break;
			case 'rem_b':
				$this->_BaseRem=& $this->_frm->getStaticModul('rem');
				if (Framework::getParam('geRemListAction_x','0','P') && Framework::getParam('geRemListAction_val','0','P')) {
					$msgID=Framework::getParam('geRemListID','0','P');
					switch (Framework::getParam('geRemListAction_val','0','P')) {
						case 'delete':
							if (!empty($msgID)) {
								$this->_BaseRem->markDeleted($msgID);
							}
						break;
					}
				}
			break;
		}
		return true;
	}
	function getListMsgGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');
		$search=array(
			'b'=>Framework::getParam('b',0),
			'limit'=>50,
			'use_limit'=>1,
		);
		$mode='to';

		$funcAction=new FunctionObjActionGui('geMsgListAction',1);
		$funcAction->setName($this->_T->lang('[[Ausgewaehlte Notes]]'));

		switch ($this->_action) {
			case 'msg_b':
				$search['msg_visited']=array(GE_MSG_VISITED_UNREAD,GE_MSG_VISITED_READ);
				$funcAction->addValue('delete',$this->_T->lang('[[Loeschen]]'));
				$funcAction->addValue('close',$this->_T->lang('[[Schliessen]]'));
				$funcAction->addValue('archiv',$this->_T->lang('[[Archivieren]]'));
			break;
			case 'msg_a':
				$funcAction->addValue('delete',$this->_T->lang('[[Loeschen]]'));
				$search['msg_visited']=array(GE_MSG_VISITED_ARCHIV);
			break;
			case 'msg_s':
				$mode='from';
				$funcAction->addValue('delete',$this->_T->lang('[[Loeschen]]'));
				$search['msg_sendid']=$this->_frm->getUser();
				$search['msg_deleted']=0;
			break;
		}
		$rows=0;
		$entries=$this->_BaseMsg->listUserMessages($rows,$this->_frm->getUser(),$search);
		if ($rows && empty($entries) && $search['b']>0) {
			$this->_L->setParam('b',$search['b']-$search['limit']);
			$this->_L->goToLink();
		}

		$noEnc=array('NoEnc'=>1,'NoBr'=>1);

		$tabGui=new ApplicationListGui();
		$tabGui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));

		$L=Framework::cloneObj($this->_L);
		$tabGui->setNavLink($L);
		$tabGui->setBegin($search['b']);
		$tabGui->setLimit($search['limit']);
		$tabGui->setSumRows($rows);
		$tabGui->setAutoBg(APP_FG10COLOR);

		$btnList=new CheckBoxBtn ('geMsgListID[]','');
		$btnList->setAttribs(array(
			'onclick'=>'return false;',
		));
		$tabGui->addFunction($funcAction);
		$tabGui->setTrOver('trBOC({ROW},this);');
		$tabGui->setTrDown('trBOI({ROW},this,1);');
		$tabGui->setID('geMsgViewList');
		//$tabGui->_frm->addOnLoad("disableSelection(document.getElementById('geMsgViewList'));");

		$funcSelAll=new FunctionButtons('geMsgListAll','selectall',array('ListID'=>'geMsgListID[]','ListOn'=>false));
		$tabGui->addHeaderCol('ListID',$funcSelAll,'','','',1,'1%',0,'');

		$tabGui->addHeaderCol('msg_subject',$this->_T->lang('[[Betreff]]'),'','','',0,'',2);
		if ($mode=='to') {
			$tabGui->addHeaderCol('msg_from',$this->_T->lang('[[Absender]]'),'','','',1);
		}
		$tabGui->addHeaderCol('msg_to',$this->_T->lang('[[Empfaenger]]'),'','','',0);
		$tabGui->addHeaderCol('msg_time',$this->_T->lang('[[Datum]]'),'','','',1);
		$tabGui->addHeaderCol('msg_reply','','','','',1);

		foreach ($entries as $val) {
			$hl=$hl?0:1;
			$showBody=0;
			if ($this->_oid==$val->getID()) {
				$tabGui->addRow(4,'top');
				$showBody=1;
			} elseif ($mode!='from' && $val->getUserMeta('msg_visited')==GE_MSG_VISITED_UNREAD) {
				$tabGui->addRow(2,'top');
				$showBody=1;
			} else {
				$tabGui->addRow($hl,'top');
			}
			$tabGui->addCol('ListID',$btnList->process($val->getID()),'','','',1,'1%',0,'',$noEnc);
			$tabGui->addCol('msg_image','',$val->getMeta('msg_image'),$this->_L->getTempLink(null,array('oid'=>$val->getID())),'',1);
			$tabGui->addCol('msg_subject',$val->getMeta('msg_subject'),'',$this->_L->getTempLink(null,array('oid'=>$val->getID())),'',0,'2000');
			if ($showBody) {
				$body=Framework::entities($val->getMeta('msg_message'));
				$body=$this->_BaseMsg->addLink($body);			
				if ($val->getMeta('msg_link')) {
					$links=json_decode($val->getMeta('msg_link'));
					foreach ($links as $l_val) {
						$body.="\n".'<a href="'.$l_val->U.'" '.($l_val->T?'target="'.$l_val->T.'"':'').'><img src="img/ge/omng_goto.gif" vspace="2" hspace="2">'.$l_val->N.'</a>';
					}
				}
				$tabGui->addColSub('msg_subject','N',$body);
				$tabGui->addColSub('msg_subject','NoEnc',1);
			}
			if ($mode=='to') {
				$tabGui->addCol('msg_from',$val->getMeta('msg_from'),'','','',1);
			}
			$tabGui->addCol('msg_to',implode(', ',$this->formatTo($val->getMeta('msg_to'))),'','','',0,'2000');
			$tabGui->addCol('msg_time',date('d.m.Y H:i',$val->getMeta('msg_time')),'','','',1,'');
			if ($mode=='to') {
				$msgParams=array(
					'tab'=>'msg',
					'reset'=>1,
				);
				$msgParams['msgTo']='u_'.$val->getMeta('msg_userid');
				if ($this->_frm->getMyApps('sms') && $this->_frm->getCachedUser($val->getMeta('msg_userid'),'mobil')) {
					$msgParams['smsToAdd']= $this->_frm->getStaticModul('sms')->formatNumber( $this->_frm->getCachedUser($val->getMeta('msg_userid'),'mobil'), $this->_frm->getCachedUserName($val->getMeta('msg_userid')));
					$msgParams['smsMessage']='';
				}

				$msgParams['msgSubject']='RE: '.$val->getMeta('msg_subject');
				$msgParams['msgMessage']="\n---- original message ----\n".$val->getMeta('msg_message');
				$tabGui->addCol('msg_reply','','msg_reply.gif','Javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));','',1);
			}
			if ($mode=='from') {
				$msgParams=array(
					'tab'=>'msg',
					'reset'=>1,
				);
				$msgParams['msgTo']=$val->getMeta('msg_to');
				foreach(explode(',',$val->getMeta('msg_to')) as $to_uid) {
					if ($to_uid[0]=='u') {
						if ($this->_frm->getMyApps('sms') && $this->_frm->getCachedUser(substr($to_uid,2),'mobil')) {
							if ($msgParams['smsToAdd']) $msgParams['smsToAdd'].=',';
							$msgParams['smsToAdd'].=$this->_frm->getStaticModul('sms')->formatNumber( $this->_frm->getCachedUser(substr($to_uid,2),'mobil'), $this->_frm->getCachedUserName(substr($to_uid,2)));
							$msgParams['smsMessage']='';
						}
					}
				}
				$msgParams['msgSubject']=$val->getMeta('msg_subject');
				$msgParams['msgMessage']="\n---- original message ----\n".$val->getMeta('msg_message');
				$tabGui->addCol('msg_reply','','msg_reply.gif','Javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));','',1);
			}

		}
		//debug($this->_BaseQuota->getMyQuota());

		return $tabGui;
	}
	/*
	function getListSmsGui() {
		require_once('lib/class_ApplicationListGui.php');
		$search=array(
			'b'=>Framework::getParam('b',0),
			'limit'=>50,
			'use_limit'=>1,
		);

		switch ($this->_action) {
			case 'sms_s':
				$search['grp_userid']=$this->_frm->getUser();
			break;
		}
		$this->_BaseSmsRes->synchronize();
		$rows=0;
		$entries=$this->_BaseSms->listAll($rows,$search,'sms_timecreate DESC');
		$responses=$this->_BaseSmsRes->getResponses(array_keys($entries));



		$tabGui=new ApplicationListGui();
		$tabGui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));

		$tabGui->setName($this->_T->lang('[[Gesendete SMS]]'));

		$L=Framework::cloneObj($this->_L);
		$tabGui->setNavLink($L);
		$tabGui->setBegin($search['b']);
		$tabGui->setLimit($search['limit']);
		$tabGui->setSumRows($rows);
		$tabGui->setAutoBg(APP_FG10COLOR);

		$tabGui->addHeaderCol('msg_date',$this->_T->lang('[[Datum]]'),'','','',1);
		$tabGui->addHeaderCol('msg_from',$this->_T->lang('[[Absender]]'),'','','',1);
		$tabGui->addHeaderCol('msg_to',$this->_T->lang('[[Empfaenger]]'),'','','',1);
		$tabGui->addHeaderCol('msg_senddate',$this->_T->lang('[[Versenden am]]'),'','','',1);
		$tabGui->addHeaderCol('msg_count',$this->_T->lang('[[Anzahl]]'),'','','',1);
		$tabGui->addHeaderCol('msg_status',$this->_T->lang('[[Status]]'),'','','',1);
		$tabGui->addHeaderCol('msg_lastchange',$this->_T->lang('[[Letzte Aenderung]]'),'','','',1);
		$tabGui->addHeaderCol('msg_reply','','','','',1);

		foreach ($entries as $val) {
			$hl=$hl?0:1;
			$showBody=0;
			if ($this->_oid==$val->getID()) {
				$tabGui->addRow(4,'top');
				$showBody=1;
			} else {
				$tabGui->addRow($hl,'top');
			}


			$tabGui->addCol('msg_date',date('d.m.Y H:i',$val->getMeta('sms_timecreate')),'',$this->_L->getTempLink(null,array('oid'=>$val->getID())),'',1,'');
			$tabGui->addCol('msg_from',$val->getMeta('sms_from'),'',$this->_L->getTempLink(null,array('oid'=>$val->getID())),'',1,'');
			$tabGui->addCol('msg_to',Framework::wordSplit($val->getMeta('sms_to'),100,$add='...'),'',$this->_L->getTempLink(null,array('oid'=>$val->getID())),'',1,'');
			$tabGui->addCol('msg_senddate',$val->getMeta('sms_senddate')?date('d.m.Y H:i',$val->getMeta('sms_senddate')):'','','','',1,'');
			$c=0;
			$res_txt=array();
			if (isset($responses[$val->getID()])) {
				foreach($responses[$val->getID()] as $k=>$v) {
				    $res_txt[]=$k.'('.$v['r'].')';
				    $c+=$v['n'];
				}
			}
			
			$tabGui->addCol('msg_count',$c,'','','',1,'');
			$tabGui->addCol('msg_status',implode(', ',$res_txt),'','','',1,'');
			$tabGui->addCol('msg_lastchange',$val->getMeta('_msg_lastchange')?date('d.m.Y H:i:s',$val->getMeta('_msg_lastchange')):'','','','',1,'');

			if ($showBody) {
				$body=Framework::entities($val->getMeta('sms_message'));
				$tabGui->addColSub('msg_to','N',$body);
				$tabGui->addColSub('msg_to','NoEnc',1);
			}

			$msgParams=array(
				'tab'=>'sms',
				'reset'=>1,
			);
			$msgParams['smsToAdd']=$val->getMeta('_sms_to');
			$msgParams['smsMessage']=$val->getMeta('_sms_message');
			$tabGui->addCol('msg_reply','','msg_reply.gif','Javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));','',1);


		}
		//debug($this->_BaseQuota->getMyQuota());

		return $tabGui;
	}
	*/
	function getSearchSmsGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_DateSelectForm.php');

		$Gui=new TemplateGui('core/common_content_border.inc.html');

		$selDateGui=new DateSelectForm();
		$selDateGui->setAvMode(array(4,1,2,3));
		$selDateGui->setMode($this->_search['DateMode']?$this->_search['DateMode']:4);

		if ($this->_search['StartDate'] || $this->_search['EndDate']) {
			$selDateGui->setDate(array($this->_search['StartDate'],$this->_search['EndDate']));
		} else {
			$selDateGui->setDate(array(0,0));
		}
		$Gui->addContent('dateSelect',$selDateGui->process(),'CONTENT');

		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		//debug($this->_BaseSmsRes->countSendWeek());
/*
		$key="Info";
		$formGui->addField($key,'text',$this->_T->lang('[[Suchtext]]'),isset($this->_search['Info'])?$this->_search['Info']:'','fields1');
*/

		$key='msg_status';
		$formGui->addField($key,'checklist_v',$this->_T->lang('[[Status]]'),$this->_search['Status']?$this->_search['Status']:array(),'fields1');

		$status=array(
			'TO_SEND'=>$this->_T->lang('[[sms_to_send]]'),
			'PENDING'=>$this->_T->lang('[[sms_pending]]'),
			'ACCEPTED'=>$this->_T->lang('[[sms_accepted]]'),
			'BUFFERED'=>$this->_T->lang('[[sms_buffered]]'),
			'TRANSMITTED'=>$this->_T->lang('[[sms_transmitted]]'),
			'DELIVERED'=>$this->_T->lang('[[sms_delivered]]'),
			'NOT_DELIVERED'=>$this->_T->lang('[[sms_not_delivered]]'),
			'ERROR'=>$this->_T->lang('[[sms_error]]'),
		);
		$formGui->setValues($key,$status);


		$submit_array=array(
			'search_x'=>' '.$this->_T->lang('[[Suchen]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','fields1');
		$formGui->setValues($key,$submit_array);



		$this->_search=array(
			'StartDate'=>$selDateGui->getDate('B'),
			'EndDate'=>$selDateGui->getDate('E'),
			'DateMode'=>$selDateGui->getMode(),
			'Status'=>$formGui->getFieldVal('msg_status',1),
		);
		$this->_frm->savePostData($this->_BaseSms->getModul(),'tmpSmsSearchUser',null,$this->_search);

		$Gui->addContent('config',$formGui,'CONTENT');
		return $Gui;
	}
	function getListSmsGui() {
		require_once('lib/class_ApplicationListGui.php');
		/*$search=array(
			'b'=>Framework::getParam('b',0),
			'limit'=>50,
			'use_limit'=>1,
		)*/;
		$this->_search['limit']=50;
		if (Framework::issetParam('search_x','','P')) {
			$this->_search['b']=0;
		} else {
			$this->_search['b']=Framework::getParam('b');
		}
		$this->_search['grp_userid']=$this->_frm->getUser();

		$this->_BaseSmsRes->synchronize();
		$rows=0;
		$entries=$this->_BaseSmsRes->listAll($rows,$this->_search,'msg_date DESC');
		
		$tabGui=new ApplicationListGui();
		$tabGui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));

		$tabGui->setName($this->_T->lang('[[Gesendete SMS]]'));

		$L=Framework::cloneObj($this->_L);
		$L->setParam('_loadSmsSearch',1);
		$tabGui->setNavLink($L);
		$tabGui->setBegin($this->_search['b']);
		$tabGui->setLimit($this->_search['limit']);
		$tabGui->setSumRows($rows);
		$tabGui->setAutoBg(APP_FG10COLOR);

		$tabGui->addHeaderCol('msg_date',$this->_T->lang('[[Datum]]'),'','','',1);
		$tabGui->addHeaderCol('msg_from',$this->_T->lang('[[Absender]]'),'','','',1);
		$tabGui->addHeaderCol('msg_to',$this->_T->lang('[[Empfaenger]]'),'','','',1);
		$tabGui->addHeaderCol('msg_senddate',$this->_T->lang('[[Versenden am]]'),'','','',1);
		$tabGui->addHeaderCol('msg_count',$this->_T->lang('[[Anzahl]]'),'','','',1);
		$tabGui->addHeaderCol('msg_status',$this->_T->lang('[[Status]]'),'','','',1);
		$tabGui->addHeaderCol('msg_lastchange',$this->_T->lang('[[Letzte Aenderung]]'),'','','',1);
		$tabGui->addHeaderCol('msg_reply','','','','',1);

		foreach ($entries as $val) {
			$hl=$hl?0:1;
			$showBody=0;
			if ($this->_oid==$val->getID()) {
				$tabGui->addRow(4,'top');
				$showBody=1;
			} else {
				$tabGui->addRow($hl,'top');
			}

			
			$tabGui->addCol('msg_date',date('d.m.Y H:i',$val->getMeta('msg_date')),'',$L->getTempLink(null,array('oid'=>$val->getID())),'',1,'');
			$tabGui->addCol('msg_from',$val->getMeta('msg_from'),'',$L->getTempLink(null,array('oid'=>$val->getID())),'',1,'');
			$tabGui->addCol('msg_to',$this->_BaseSms->formatNumber($val->getMeta('msg_to'),$val->getMeta('msg_to_text')),'',$L->getTempLink(null,array('oid'=>$val->getID())),'',1,'');
			$tabGui->addCol('msg_senddate',$val->getMeta('msg_senddate')?date('d.m.Y H:i',$val->getMeta('msg_senddate')):'','','','',1,'');
			$tabGui->addCol('msg_count',$val->getMeta('msg_count'),'','','',1,'');
			$tabGui->addCol('msg_status',$val->getMeta('msg_status'),'','','',1,'');
			$tabGui->addCol('msg_lastchange',date('d.m.Y H:i:s',$val->getMeta('msg_lastchange')),'','','',1,'');

			if ($showBody) {
				$body=Framework::entities($val->getMeta('_sms_message'));
				$tabGui->addColSub('msg_to','N',$body);
				$tabGui->addColSub('msg_to','NoEnc',1);
			}
			
			$msgParams=array(
				'tab'=>'sms',
				'reset'=>1,
			);
			$msgParams['smsToAdd']=$val->getMeta('_sms_to');
			$msgParams['smsMessage']=$val->getMeta('_sms_message');
			$tabGui->addCol('msg_reply','','msg_reply.gif','Javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));','',1);


		}
		//debug($this->_BaseQuota->getMyQuota());

		return $tabGui;
	}
	function getListRemGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');
		$search=array(
			'b'=>Framework::getParam('b',0),
			'limit'=>50,
			'use_limit'=>1,
		);
		$mode='b';

		$funcAction=new FunctionObjActionGui('geRemListAction',1);
		$funcAction->setName($this->_T->lang('[[Ausgewaehlte Erinnerungen]]'));

		switch ($this->_action) {
			case 'rem_b':
				$funcAction->addValue('delete',$this->_T->lang('[[Loeschen]]'));
			break;
		}
		$rows=0;
		$entries=$this->_BaseRem->listUserReminders($rows,$search,'RemMessagesUser.rem_time ASC');
		if ($rows && empty($entries) && $search['b']>0) {
			$this->_L->setParam('b',$search['b']-$search['limit']);
			$this->_L->goToLink();
		}

		$noEnc=array('NoEnc'=>1,'NoBr'=>1);

		$tabGui=new ApplicationListGui();
		$tabGui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));

		$L=Framework::cloneObj($this->_L);
		$tabGui->setNavLink($L);
		$tabGui->setBegin($search['b']);
		$tabGui->setLimit($search['limit']);
		$tabGui->setSumRows($rows);
		$tabGui->setAutoBg(APP_FG10COLOR);

		$btnList=new CheckBoxBtn ('geRemListID[]','');
		$btnList->setAttribs(array(
			'onclick'=>'return false;',
		));
		$tabGui->addFunction($funcAction);
		$tabGui->setTrOver('trBOC({ROW},this);');
		$tabGui->setTrDown('trBOI({ROW},this,1);');
		$tabGui->setID('geRemViewList');
		//$tabGui->_frm->addOnLoad("disableSelection(document.getElementById('geMsgViewList'));");

		$funcSelAll=new FunctionButtons('geRemListAll','selectall',array('ListID'=>'geRemListID[]','ListOn'=>false));
		$tabGui->addHeaderCol('ListID',$funcSelAll,'','','',1,'1%',0,'');

		$tabGui->addHeaderCol('rem_time',$this->_T->lang('[[Datum]]').' | '.$this->_T->lang('[[Link]]'),'','','',0,'',2);
		if ($this->_frm->getMyApps('msg')) {
			$tabGui->addHeaderCol('rem_msg_send',$this->_T->lang('[[Message]]'),'','','',1);
		}
		if ($this->_frm->getMyApps('email')) {
			$tabGui->addHeaderCol('rem_mail_send',$this->_T->lang('[[E-Mail]]'),'','','',1);
		}
		if ($this->_frm->getMyApps('sms')) {
			$tabGui->addHeaderCol('rem_sms_send',$this->_T->lang('[[SMS]]'),'','','',1);
		}
		$tabGui->addHeaderCol('rem_reply','','','','',1);


		foreach ($entries as $val) {
			$hl=$hl?0:1;
			$showBody=1;
			$objData=$this->_BaseRem->formatObj($val);
			
			$tabGui->addRow($val->getUserMeta('rem_time')<time()?4:$hl,'top');
			$tabGui->addCol('ListID',$btnList->process($val->getID()),'','','',1,'1%',0,'',$noEnc);
			$tabGui->addCol('msg_image','',$objData['img'],'','',1);
			$title='<strong>'.date('d.m.Y H:i',$val->getUserMeta('rem_time')).'</strong>';
			if ($objData['link']) {
				$title.=' | <strong>'.$objData['name'].'</strong>';
			}
			$tabGui->addCol('rem_time',$title,'',$objData['link'],'',0,'2000',0,'',$noEnc);
			if ($showBody) {
				$body=Framework::entities($val->getMeta('rem_message'));
				$tabGui->addColSub('rem_time','N',$body);
				$tabGui->addColSub('rem_time','NoEnc',1);
			}
			if ($this->_frm->getMyApps('msg')) {
				$tabGui->addCol('rem_msg_send',$val->getUserMeta('rem_msg_send')?'X':'','','','center',1);
			}
			if ($this->_frm->getMyApps('email')) {
				$tabGui->addCol('rem_mail_send',$val->getUserMeta('rem_mail_send')?'X':'','','','center',1);
			}
			if ($this->_frm->getMyApps('sms')) {
				$tabGui->addCol('rem_sms_send',$val->getUserMeta('rem_sms_send')?'X':'','','','center',1);
			}

			$sendBy=array();
			if ($val->getUserMeta('rem_mail_send')) $sendBy[]='mail';
			if ($val->getUserMeta('rem_msg_send')) $sendBy[]='msg';
			if ($val->getUserMeta('rem_sms_send')) $sendBy[]='sms';
			$msgParams=array(
				'reset'=>1,
				'tab'=>'rem',
				'remId'=>$val->getId(),
				'remSenddate'=>$val->getUserMeta('rem_time')*1000,
				'remMessage'=>$val->getMeta('rem_message'),
				'remObjName'=>$val->getMeta('rem_obj_name'),
				'remObjTyp'=>$val->getMeta('rem_obj_typ'),
				'remObjId'=>$val->getMeta('rem_obj_id'),
				'remSendby'=>$sendBy,
				'smsMessage'=>$val->getMeta('rem_message'),
				'msgMessage'=>$val->getMeta('rem_message'),
			);
			if ($objData['link']) {
				$msgParams['msgLink']=json_encode(array(array('U'=>$objData['link'],'N'=>$objData['name'])));
			}

			$tabGui->addCol('msg_reply','','msg_reply.gif','Javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));','',1);

		}
		//debug($this->_BaseQuota->getMyQuota());

		return $tabGui;
	}
	public function formatTo($to) {
		$result=array();
		foreach(explode(',',$to) as $val) {
			switch($val[0]) {
				case 'u';
					if ($tmp=$this->_frm->getCachedUserName(substr($val,2))) {
						$result[]=$tmp;
					}
				break;
				case 'g';
					if ($tmp=$this->_frm->getCachedGroupName(substr($val,2))) {
						$result[]=$tmp;
					}
				break;
				case 'r';
					if ($tmp=$this->_frm->getCachedRuleName(substr($val,2))) {
						$result[]=$tmp;
					}
				break;
			}
		}
		return $result;
	}
}
?>