<?php
class geMsgCtrlPortal {
	var $_Base;
	var $_T;
	var $_frm;
	var $_L;
	var $_E;
	function __construct() {
		global $frm,$t,$T,$E,$L,$Y;
		$this->_T=&$T;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('msg');
		$this->_BaseMsg=& $this->_frm->getStaticModul('msg');
	}
	function process() {
		if (!$this->_handleRequest()) {
			return false;
		}
		$Gui=$this->getPortalGui();
		return $Gui->process();
	}

	function _handleRequest() {
		if (!$this->_frm->getMyApps('msg')) {
			return false;
		}
		$this->_oid=FrameWork::getParam('show_msg_id');
		if (Framework::getParam('geMsgListAction_x','0','P') && Framework::getParam('geMsgListAction_val','0','P')) {
			$msgID=Framework::getParam('geMsgListID','0','P');
			switch (Framework::getParam('geMsgListAction_val','0','P')) {
				case 'delete':
					if (!empty($msgID)) {
						$this->_BaseMsg->unlinkMessage($msgID);
					}
				break;
				case 'archiv':
					if (!empty($msgID)) {
						$this->_BaseMsg->archivMessage($msgID);
					}
				break;
				case 'close':
					if (!empty($msgID)) {
						$this->_BaseMsg->markVisited($msgID);
					}
				break;
			}
		}
		return true;
	}
	function getPortalGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');
		$search=array(
			'b'=>0,
			'limit'=>0,
			'use_limit'=>0,
			'msg_visited'=>array(GE_MSG_VISITED_NEW,GE_MSG_VISITED_UNREAD,GE_MSG_VISITED_READ),
		);

		$funcAction=new FunctionObjActionGui('geMsgListAction',1);
		$funcAction->setName($this->_T->lang('[[Ausgewaehlte Notes]]'));
		$funcAction->addValue('delete',$this->_T->lang('[[Loeschen]]'));
		$funcAction->addValue('close',$this->_T->lang('[[Schliessen]]'));
		$funcAction->addValue('archiv',$this->_T->lang('[[Archivieren]]'));

		$rows=0;
		//$this->_BaseMsg->clearNew();
		$entries=$this->_BaseMsg->listUserMessages($rows,$this->_frm->getUser(),$search);

		$chdDefault=array();
		if ($this->_oid) {
			$chdDefault[]=$this->_oid;
		}

		$btnList=new CheckBoxBtn ('geMsgListID[]',$chdDefault);
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);

		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tabGui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));
		$tabGui->addFunction($funcAction);

		$tabGui->setID('geMsgViewPortal');
		//$tabGui->setAutoBg(APP_FG10COLOR);
		$hl=1;
		foreach ($entries as $val) {
			$showBody=0;
			if ($this->_oid==$val->getID()) {
				$hl=3;
				$showBody=1;
			} elseif ($val->getUserMeta('msg_visited')==GE_MSG_VISITED_UNREAD || $val->getUserMeta('msg_visited')==GE_MSG_VISITED_NEW) {
				$hl=3;
				$showBody=1;
			} else {
				$hl=1;
			}
			$msgParams=array(
				'tab'=>'msg',
				'reset'=>1,
			);
			$msgParams['msgTo']='u_'.$val->getMeta('msg_userid');
			if ($this->_frm->getMyApps('sms') && $this->_frm->getCachedUser($val->getMeta('msg_userid'),'mobil')) {
				$msgParams['smsToAdd']= $this->_frm->getStaticModul('sms')->formatNumber( $this->_frm->getCachedUser($val->getMeta('msg_userid'),'mobil'), $this->_frm->getCachedUserName($val->getMeta('msg_userid')));
				$msgParams['smsMessage']='';
			}

			$msgParams['msgSubject']='RE: '.$val->getMeta('msg_subject');
			$msgParams['msgMessage']="\n---- original message ----\n".$val->getMeta('msg_message');

			$tabGui->addRow($hl,'top',$hl==3?APP_FG10COLOR:'');
			$tabGui->addCol('msg_image','',$val->getMeta('msg_image'),$this->_L->getTempLink(null,array('show_msg_id'=>$val->getID())),'center',1);
			$tabGui->addCol('msg_subject',date('d.m.Y H:i',$val->getMeta('msg_time')).' '.$val->getMeta('msg_from'),'',$this->_L->getTempLink(null,array('show_msg_id'=>$val->getID())),'',0,'2000');


			$buttons=array();
			$buttons[]='<a href="javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));"><img src="img/ge/msg_reply.gif" title="'.$this->_T->Lang('[[Antworten]]').'" /></a>';
	
			
			$tabGui->addCol('msg_reply',implode('',$buttons),'','','',1,'',0,'',$noEnc);

			$tabGui->addRow($hl,'top',$hl==3?APP_FG10COLOR:'');
			$tabGui->addCol('ListID',$btnList->process($val->getID()),'','','',1,'1%',0,'',$noEnc);
			//debug($val->getMeta('msg_subject'));
			$tabGui->addCol('msg_subject',$val->getMeta('msg_subject'),'',$this->_L->getTempLink(null,array('show_msg_id'=>$val->getID())),'',0,'2000');
			if ($showBody) {
				$body=Framework::entities($val->getMeta('msg_message'));
				$body=$this->_BaseMsg->addLink($body);
				if ($val->getMeta('msg_link')) {
					$links=json_decode($val->getMeta('msg_link'));
					if (is_object($links) && isset($links->U)) $links=array($links);
					foreach ($links as $l_val) {
						$body.="\n".'<a href="'.$l_val->U.'" '.($l_val->T?'target="'.$l_val->T.'"':'').'><img src="img/ge/omng_goto.gif" vspace="2" hspace="2">'.$l_val->N.'</a>';
					}
				}
				$tabGui->addColSub('msg_subject','N',$body);
				$tabGui->addColSub('msg_subject','NoEnc',1);
			}
			
			$buttons=array();
			$buttons[]='<a href="javascript:void(geMsgPortalAction(\'msgPortalDelete\','.$val->getID().'));"><img src="img/ge/msg_clear.gif" title="'.$this->_T->Lang('[[Loeschen]]').'" /></a>';
			if ($showBody) $buttons[]='<a href="javascript:void(geMsgPortalAction(\'msgPortalClose\','.$val->getID().'));"><img src="img/ge/msg_collapse.gif" title="'.$this->_T->Lang('[[Schliessen]]').'" /></a>';
			//if ($showBody) $buttons[]='<a href="javascript:void(geMsgPortalAction(\'msgPortalArchiv\','.$val->getID().'));"><img src="img/ge/msg_archiv.gif" title="'.$this->_T->Lang('[[Archivieren]]').'" /></a>';
			$tabGui->addCol('msg_reply',implode('<br />',$buttons),'','','',1,'',0,'',$noEnc);

			$tabGui->addRow(0,'top');
			$tabGui->addCol('nix','','','','',0,'',3);

		}
		if (empty($entries)) {
			$tabGui->addRow(0,'top');
			$tabGui->addCol('nix',$this->_T->lang('[[Keine Messages]]'),'','','',0,'');


		}
		//debug($this->_BaseQuota->getMyQuota());

		return $tabGui;
	}
}
?>