<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require("cfg/$THEME/config.inc.php");
if (!in_array($session_lang,$CFG['MA_LANG'])) $session_lang=reset($CFG['MA_LANG']);
$frm->setLang($session_lang);
if ($auth->auth['uname']!='config') {
	$pre["global"]=$frm->getPrefs('global');
	$pre["global"]["lay"]=1;
	if (!$sess->is_registered("app")) {
		$sess->register("app");
	} else {
		$frm->setMyApps($app);
	}
	if (!$sess->is_registered("REG_USER")) {
		$REG_USER=array(
			"uid"=>0,
		);
		$sess->register("REG_USER");
	}
	if ($REG_USER["uid"]!=$auth->auth['uid']) {
		$app=$frm->getApplication($frm->getUsersApplication($auth->auth['uid'],1,1,1));
		$frm->setMyApps($app);
		
		$reg_user=$frm->read_user($auth->auth['uid']);
		$REG_USER["uid"]=$auth->auth['uid'];
		$REG_USER["firstname"]=$reg_user["firstname"];
		$REG_USER["lastname"]=$reg_user["lastname"];
		$REG_USER["email"]=$reg_user["email"];
		$REG_USER["name"]=$reg_user["lastname"].' '.$reg_user["firstname"];
		$REG_USER["pwd_time"]=$reg_user["pwd_time"];
		$REG_USER["shadowMax"]=$reg_user["shadowMax"];
		$REG_USER['groups']=implode(',',$frm->getMyGroups());
		
		$frm->logUser($auth->auth['uid'],'login',$REG_USER["name"]);
		if ($app['asx'] && $frm->getPrefs('asx','dnd')) {
			$Asx=$frm->getStaticModul('asx');
			$Asx->setDND(false);
		}
		if ($app['imng']) {
			$Imng=& $frm->getStaticModul('imng');
			$Imng->setPublic(1);
			$escObj=$Imng->listEscalationObj(array('EscalationEnd'=>mktime(23,59,58)));
			if (!empty($escObj)) {
				$L=new GlobLinkObj();
				$L->setParam('site','imng.php');
				if (count($escObj)>1) {
					$L->setParam('mode','esc');
				} else {
					$L->setParam('action','vo');
					$L->setParam('oid',reset($escObj)->getID());
				}
				$L->goToLink();
			}
		}
	}
	if (!isset($site) && is_array($app)) {
		foreach ($app as $val) {
			if (!$site) $site=$val['url'];
			if ($val['url']==$CFG['DEF_SITE']) $site=$CFG['DEF_SITE'];
		}
	}
}
require_once("cfg/$THEME/global/colors_managment.inc.php");
$bgcolor="#ffffff";
$fgcolor=$pre["global"]['ufgcolor'];
if (!$fgcolor) {
	$fgcolor=reset($colorfg);
}
list($key)=array_keys ($colorfg,$fgcolor);
$fg20color=$colorfg20[$key];
$fg10color=$colorfg10[$key];

define('APP_EXTJSTHEME',$extjsTheme[$key]);
define('APP_FG10COLOR',$fg10color);
define('APP_FG20COLOR',$fg20color);
define('APP_FGCOLOR',$fgcolor);
define('APP_BGCOLOR',$bgcolor);
define('APP_LANG',$session_lang);
$t->assign("LCOLOR",'#000000');
$t->assign("FG10COLOR",$fg10color);
$t->assign("FG20COLOR",$fg20color);
$t->assign("BGCOLOR",$bgcolor);
$t->assign("FGCOLOR",$fgcolor);
$t->assign("SESS_LANG",$session_lang);
$t->assign("GE_CHARSET",GE_CHARSET);

switch ($session_lang) {
        case "de":
			$locale="de_DE";
			if (GE_CHARSET=='UTF-8') {
				$locale.='.'.GE_CHARSET;
			} else {
				$locale.="@euro";
			}
			$winLocale='deu_deu';
			define('constDECIMAL',',');
			define('constTHOUSEND','.');
		break;
        case "it":
			$locale="it_IT";
			if (GE_CHARSET=='UTF-8'){
				$locale.='.'.GE_CHARSET;
			} else {
				$locale.="@euro";
			}
			$winLocale='ita_ita';
			define('constDECIMAL',',');
			define('constTHOUSEND','');
		break;
        case "fr":
			$locale="fr_FR";
			if (GE_CHARSET=='UTF-8'){
				$locale.='.'.GE_CHARSET;
			} else {
				$locale.="@euro";
			}
			$winLocale='fr_fra';
			define('constDECIMAL',',');
			define('constTHOUSEND','');
		break;
        default:
			$locale="en_GB";
			if (GE_CHARSET=='UTF-8') $locale.='.'.GE_CHARSET;
			$winLocale='eng_eng';
			define('constDECIMAL','.');
			define('constTHOUSEND','');
		break;
}
//echo $locale;
if (version_compare(phpversion(), "4.3.0", ">=")) {
	setlocale(LC_TIME,$locale,$winLocale);
	setlocale(LC_CTYPE,$locale,$winLocale);
} else {
	setlocale(LC_TIME,$locale);
	setlocale(LC_CTYPE,$locale);
}
if (function_exists('date_default_timezone_get') && ($TZ=date_default_timezone_get())) {
	date_default_timezone_set($TZ);
}
putenv('LANG='.$locale);

if ($pre["global"]['js']) {
	$t->assign("DEL_B","javascript:lo('");
	$t->assign("DEL_E","')");
	$t->assign("DEL_FORM",'return lo_form();');
	$del_form='return lo_form();';
	$del_b="javascript:lo('";
	$del_e="')";
	define('GE_delB',$del_b);
	define('GE_delE',$del_e);
} else {
	$t->assign("DEL_B","");
	$t->assign("DEL_E","");
	$t->assign("DEL_FORM","");
	$del_form='';
	$del_b="";
	$del_e="";
	define('GE_delB','');
	define('GE_delE','');
}

?>
