<?php
class ProjectAdminGui {
	var $_Wusr;
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_name_check_prf=array(
		'sfol'=>'/[^ ,+&0-9a-z_-~.]/i',
		'ffol'=>'/[^ ,+&0-9a-z_-~.]/i',
		'mfol'=>'/[^ ,+&0-9a-z_-]/i',
		'pfol'=>'/[^ ,+&0-9a-z_-]/i',
	);
	var $_name_check_prj=array(
		'0'=>'/[^ ,+&0-9a-z_-]/i',
	);
	function ProjectAdminGui() {
		global $frm,$t,$T,$E,$L;
		$this->_BasePrf=$frm->getStaticModul('proj_profiles');
		$this->_BasePrj=$frm->getStaticModul('proj');
		$this->_uFormData=$this->_BasePrj->initUform();
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_my_profiles=$this->_BasePrf->listProfiles(true);
		$this->_prjPerms=array(
			'ffol'=>array(
				1=>$this->_T->lang('[[Lesen]]'),
				3=>$this->_T->lang('[[Schreiben]]'),
				7=>$this->_T->lang('[[Verwalten]]'),
			),
			'sfol'=>array(
				5=>$this->_T->lang('[[Lesen]]'),
				7=>$this->_T->lang('[[Schreiben]]'),
			),
			'mfol'=>array(
				1=>$this->_T->lang('[[Lesen]]'),
				3=>$this->_T->lang('[[Schreiben]]'),
				7=>$this->_T->lang('[[Verwalten]]'),
			),
			'zfol'=>array(
				1=>$this->_T->lang('[[zef_Erstellen]]'),
				4=>$this->_T->lang('[[zef_Auswerten]]'),
			),
			'tel_fol'=>array(
				2=>$this->_T->lang('[[stel_Erstellen]]'),
				4=>$this->_T->lang('[[stel_Auswerten]]'),
			),
			'tfol'=>array(
				1=>$this->_T->lang('[[task_PrivatSchreiben]]'),
				2=>$this->_T->lang('[[task_Schreiben]]'),
				4=>$this->_T->lang('[[task_Auswerten]]'),
			),
			'kfol'=>array(
				1=>$this->_T->lang('[[cal_Sichtbarkeit_aendern]]'),
			),
			'calview'=>array(
				1=>$this->_T->lang('[[cal_Sichtbar]]'),
			),
			'pfol'=>array(
				1=>$this->_T->lang('[[Projekt erstellen]]'),
			),
			'doc_fol'=>array(
				1=>$this->_T->lang('[[Lesen]]'),
				3=>$this->_T->lang('[[Schreiben]]'),
			),
		);
		$this->_prjPermsShort=array(
			'ffol'=>array(
				1=>$this->_T->lang('[[Lesen]]'),
				3=>$this->_T->lang('[[Schreiben]]'),
				7=>$this->_T->lang('[[Verwalten]]'),
			),
			'sfol'=>array(
				5=>$this->_T->lang('[[Lesen]]'),
				7=>$this->_T->lang('[[Schreiben]]'),
			),
			'mfol'=>array(
				1=>$this->_T->lang('[[Lesen]]'),
				3=>$this->_T->lang('[[Schreiben]]'),
				7=>$this->_T->lang('[[Verwalten]]'),
			),
			'zfol'=>array(
				1=>$this->_T->lang('[[zef_Erstellen]]'),
				4=>$this->_T->lang('[[zef_Auswerten]]'),
			),
			'tel_fol'=>array(
				2=>$this->_T->lang('[[stel_Erstellen]]'),
				4=>$this->_T->lang('[[stel_Auswerten]]'),
			),
			'tfol'=>array(
				1=>$this->_T->lang('[[task_PrivatSchreiben_short]]'),
				2=>$this->_T->lang('[[task_Schreiben_short]]'),
				4=>$this->_T->lang('[[task_Auswerten_short]]'),
			),
			'kfol'=>array(
				1=>$this->_T->lang('[[cal_Sichtbarkeit_aendern]]'),
			),
			'calview'=>array(
				1=>$this->_T->lang('[[cal_Sichtbar]]'),
			),
			'pfol'=>array(
				1=>$this->_T->lang('[[Projekt erstellen]]'),
			),
			'doc_fol'=>array(
				1=>$this->_T->lang('[[Lesen]]'),
				3=>$this->_T->lang('[[Schreiben]]'),
			),
		);
		$this->_prjPermsOptions=array(
			'pfol'=>array(
				16=>$this->_T->lang('[[Administratoren verwalten]]'),
				32=>$this->_T->lang('[[Controller verwalten]]'),
				64=>$this->_T->lang('[[Mitglieder verwalten]]'),
				128=>$this->_T->lang('[[Rechte verwalten]]'),
			),
		);
		if ($this->_BasePrf->isAvApp('zfol')) {
			$this->_prjPermsOptions['pfol'][256]=$this->_T->lang('[[Projekt in Zeiterfassung anlegen]]');
		}
		if ($this->_BasePrf->isAvApp('mfol')) {
			$this->_prjPermsOptions['pfol'][512]=$this->_T->lang('[[Mailverzeichnis anlegen]]');
		}
		if ($this->_BasePrf->isAvApp('sfol')) {
			$this->_prjPermsOptions['pfol'][1024]=$this->_T->lang('[[Dateiverzeichnis anlegen]]').' (Samba)';
		}
		if ($this->_BasePrf->isAvApp('ffol')) {
			$this->_prjPermsOptions['pfol'][2048]=$this->_T->lang('[[Dateiverzeichnis anlegen]]').' (Virtual)';
		}
		$this->_prjPermsOptions['pfol'][4096]=$this->_T->lang('[[Projekt loeschen]]');


	}
	function _handleRequest() {
		$this->_mode=Framework::getParam('mode','proj_prj','G');
		$this->_oid=Framework::getParam('oid',0,'G');
		switch ($this->_mode) {
			case 'proj_prf':
				$this->_action=Framework::getParam('action','e','G');
				if ($this->_oid) {
					$this->_Obj=$this->_BasePrf->getObj($this->_oid);
					if (is_object($this->_Obj)) {
						$this->_RootObj=$this->_BasePrf->getObj($this->_Obj->getMeta('RootID'));
						//debug($this->_RootObj);
					} else {
						unset($this->_Obj);
					}
				}
				if (!is_object($this->_Obj)) {
					$this->_Obj=$this->_BasePrf->getSystemObj('p');
					$this->_RootObj=$this->_BasePrf->getObj($this->_Obj->getMeta('RootID'));
					$this->_oid=$this->_Obj->getID();
					$this->_L->setParam('oid',$this->_oid);
				}
				if (Framework::getParam('_clTab',0,'G')) {
					$this->setPrefs('showtab',Framework::getParam('_clTab',0,'G'));
				}
				$this->_obj_action='proj_prf_'.$this->_Obj->getMeta('ObjTyp');
				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'n_fol':
							$this->_L->setParam('action','n');
							$this->_L->goToLink();
						break;
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->goToLink();
						break;
						case 'copy':
							$this->_L->setParam('action','c');
							$this->_L->goToLink();
						break;
						case 'delete':
							if (is_object($this->_Obj)) {
								if ($this->_BasePrf->deleteObj($this->_Obj)) {
									$this->_L->unsetParam(array('oid','action'));
									if ($this->_Obj->getMeta('ParentID')) {
										$this->_L->setParam('oid',$this->_Obj->getMeta('ParentID'));
									}
									$this->_L->goToLink();
								}
							}
						break;
						default:
							//debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
			break;
			case 'proj_prj':
				$this->_action=Framework::getParam('action','b','G');
				if ($this->_oid) {
					$this->_Obj=$this->_BasePrj->getObj($this->_oid);
					if (is_object($this->_Obj)) {
						$this->_ObjProfile=$this->_BasePrf->getObj($this->_Obj->getMeta('FKProfileID'));
						if (!is_object($this->_ObjProfile)) {
							$this->_ObjProfile=new ObjProjPfol();
						}
						$this->_ObjProfile->setAcl($this->_BasePrf->getProfileACL($this->_ObjProfile));
					}
				}
				if (Framework::getParam('_loadSearch','')) {
					$this->_searchPrj=$this->_frm->loadPostData($this->_BasePrj->getModul(),'tmpSearchAdminProj',1,0);
					//debug($this->_searchPrj);
				} elseif (Framework::getParam('_vsrid',0)) {
					$vsObj=$this->_BasePrj->readSearch(Framework::getParam('_vsrid'));
					$this->_searchPrj=unserialize($vsObj['Sdata']);
					$this->_searchPrj['Vsrid']=Framework::getParam('_vsrid');
				} else {
					if (Framework::getParam('proj_search')) {
						$this->_searchPrj['info']=Framework::getParam('proj_search');
					}
					if (Framework::getParam('trash',0)) {
						$this->_searchPrj['trash']=1;
					}
					if (Framework::getParam('_searchFav','','G')) {
						$this->_searchPrj['Fav']=1;
					}
					if (Framework::getParam('_searchPrfID','','G')) {
						$this->_searchPrj['FKProfileID']=Framework::getParam('_searchPrfID','','G');
					}
				}
				if (Framework::getParam('_clTab',0,'G')) {
					$this->setPrefs('showtab',Framework::getParam('_clTab',0,'G'));
				}
				$this->_obj_action='proj_prj';
				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('oid');
							$this->_L->unsetParam('trash');
							$this->_searchPrj=$this->_frm->loadPostData($this->_BasePrj->getModul(),'tmpSearchAdminProj',1,0);
							$this->_L->setParam('defProfileID',$this->_searchPrj['FKProfileID']);
							$this->_L->goToLink();
						break;
						case 'copy':
							$this->_L->setParam('action','c');
							$this->_L->goToLink();
						break;
						case 'delete':
							$this->_L->setParam('action','d');
							$this->_L->goToLink();
						break;
						case 'vdel':
							$this->_L->setParam('action','b');
							$this->_L->setParam('trash','1');
							$this->_L->goToLink();
						break;
						default:
							debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
				if (Framework::getParam('list_action_x','0','P') && Framework::getParam('list_action_val','0','P')) {
					switch (Framework::getParam('list_action_val','0','P')) {
						case 'medit':
							$this->_frm->deleteClipboard('proj_s');
							$ok=false;
							foreach (Framework::getParam('ListID',array(),'P') as $val) {
								$this->_frm->insertClipboard('proj_s',$val,'edit');
								$ok=true;
							}
							if ($ok) {
								$this->_L->setParam('action','medit');
								$this->_L->setParam('editAll','0');
								$this->_action='medit';
							}
						break;
						case 'medit_all':
							$this->_frm->deleteClipboard('proj_s');
							$this->_L->setParam('action','medit');
							$this->_L->setParam('editAll','1');
							$this->_action='medit';
						break;
						case 'medit_aktiv':
							$this->_frm->deleteClipboard('proj_s');
							$this->_L->setParam('action','medit');
							$this->_L->setParam('editAll','2');
							$this->_action='medit';
						break;
						default:
							debug(Framework::getParam('list_action_val','0','P'));
					}
				}
			break;
			case 'proj_arc':
				$this->_frm->addJsScript('tpl/'.APP_THEME.'/cjs/applicationPrj.js');
				if ($this->_oid) {
					$this->_Obj=$this->_BasePrj->readProjectArchiv($this->_oid);
				}
				$this->_action=Framework::getParam('action','b','G');
				$this->_runningConfig=unserialize($this->_frm->getUserData('proj','archivConfig'));
				if ($this->_runningConfig && Framework::getParam('kill_archiv_x','0','P')) {
					if (file_exists($this->_runningConfig['archivPath'].'/MY_PID')) {
						$pid=implode('',file($this->_runningConfig['archivPath'].'/MY_PID'));
						posix_kill($pid,9);
					}
					$this->_frm->deleteUserData('proj','archivConfig');
					Framework::deleteFilesRecursive($this->_runningConfig['archivPath'],'/.*/');
					$this->_L->setParam(array('action'=>'b'));
					$this->_L->unsetParam(array('oid'));
					$this->_L->goToLink();
				}
				if ($this->_runningConfig && Framework::getParam('ok_archiv_x','0','P')) {
					$this->_frm->deleteUserData('proj','archivConfig');
					$this->_L->setParam(array('action'=>'b'));
					$this->_L->unsetParam(array('oid'));
					$this->_L->goToLink();
				}

				if (Framework::getParam('archiv_x','0','P') || !empty($this->_runningConfig)) {
					$this->_L->setParam('action','a');
					$this->_action='a';
				}
				$this->_obj_action='';
			break;
			case 'proj_crm':
				$this->_action=Framework::getParam('action','b','G');
				//$this->_frm->addJsScript('tpl/'.APP_THEME.'/cjs/applicationPrj.js');
				$this->_UserFormFieldsGui=& $this->_frm->getStaticGuiModul('uform','UserFormFieldsGui');
				$GuiCfg=array(
					'showUseSearch'=>0,
					'showUseList'=>1,
					'showUseQuick'=>1,
					'showUseExport'=>1,
					'extraVisibilityField'=>array(
						'FKProfileID'=>array(
							'Typ'=>'select',
							'ValuesTyp'=>'mselect',
							'Values'=>$this->_BasePrf->getProfileNames(),
							'Name'=>$this->_T->lang('[[Profil]]'),
						),
					),
					'useZefFirma'=>1,
					'usePerms'=>1,
					'usePrjRules'=>1,
					'defPermsRules'=>'|1,3|2,1|3,1|',
					'useHtmlArea'=>1,

				);
				$this->_UserFormFieldsGui->setGuiCfg($GuiCfg);
				$this->_UserFormFieldsGui->setFormObj($this->_uFormData->getFormObj());
				$this->_obj_action='';
			break;
			case 'proj_doc':
				$this->_BaseForm=& $this->_frm->getStaticModul('uform');
				$this->_obj_action='';
				$this->_UserFormGui=& $this->_frm->getStaticGuiModul('uform','UserFormGui');
				$guiCfg=array(
					'defAction'=>'n',
					'defMode'=>'form',
					'showTree'=>true,
					'defOid'=>0,
					'FieldGuiCfg'=>array(
						'showUseSearch'=>0,
						'showUseList'=>0,
						'showUseQuick'=>1,
						'extraVisibilityField'=>array(
							'FKProfileID'=>array(
								'Typ'=>'select',
								'ValuesTyp'=>'mselect',
								'Values'=>$this->_BasePrf->getProfileNames(),
								'Name'=>$this->_T->lang('[[Profil]]'),
							),
						),
						'useHtmlArea'=>1,
					),
					'useZefFirma'=>0,
				);
				$this->_UserFormGui->setGuiCfg($guiCfg);
				$this->_UserFormGui->setFormModul('proj');
				$this->_UserFormGui->handleRequest();
				$this->_ObjActionGui=$this->_UserFormGui->getObjActionGui();
			break;
			case 'proj_print':
				if (Framework::getParam('_getPrjPrintTpl','','G')) {
					require_once('lib/proj/class_ProjectPrintGui.php');
					$prjPrintGui=new ProjectPrintGui();
					$tpl=$prjPrintGui->getPrintTemplate(Framework::getParam('_getPrjPrintTpl','','G'));
					Framework::dumpFile($tpl,$this->_T->lang('[[Vorlage]]').'.html','application/save');
					exit;
				}
				$this->_obj_action='';
				$this->_PrintTemplatesGui=& $this->_frm->getStaticGuiModul('core','PrintTemplatesGui');
				$guiCfg=array(
					'defAction'=>'b',
					'defMode'=>'print_tpl',
					'showTree'=>false,
					'defOid'=>0,
					'avTyps'=>array(
						'obj'=>$this->_T->lang('[[Projektansicht]]'),
						'list'=>$this->_T->lang('[[Projektuebersicht]]'),
						'doc'=>$this->_T->lang('[[Dokumentation]]'),
					),
					'systemTpls'=>array(
						'obj'=>array(array('Name'=>$this->_T->lang('[[Standard]]'),'Link'=>$this->_L->getTempLink(null,array('_getPrjPrintTpl'=>'obj')))),
						'list'=>array(array('Name'=>$this->_T->lang('[[Standard]]'),'Link'=>$this->_L->getTempLink(null,array('_getPrjPrintTpl'=>'list')))),
						'doc'=>array(array('Name'=>$this->_T->lang('[[Standard]]'),'Link'=>$this->_L->getTempLink(null,array('_getPrjPrintTpl'=>'doc')))),
					),
					'usePerms'=>array('list','obj','doc'),
					'usePermsRules'=>array('obj','doc'),

				);
				$this->_PrintTemplatesGui->setGuiCfg($guiCfg);
				$this->_PrintTemplatesGui->setModul('proj');
				$this->_PrintTemplatesGui->handleRequest();
				$this->_ObjActionGui=$this->_PrintTemplatesGui->getObjActionGui();
			break;
			case 'proj_rules':
				$this->_allRules=$this->_BasePrj->getAvRules();
				$this->_rid=Framework::getParam('rid','G',0);
				if (!$this->_rid || !isset($this->_allRules[$this->_rid])) {
					$this->_rid=1;
				}

			break;
		}
	}
	function &getAdminHeader() {
		require_once("lib/class_ContentGui.php");
		$hGui=new ContentGui();
		$hGui->setName($this->_frm->getAppName('proj'));
		$hGui->addTab('proj_prj',$this->_T->lang('[[Projekte]]'),"index.php?site=admin.php&ac=proj&mode=proj_prj");
		if ($this->_BasePrj->getcfg('cfg/ProjectSmbBoxArchiv')) {
			$hGui->addTab('proj_arc',$this->_T->lang('[[Archivierung]]'),"index.php?site=admin.php&ac=proj&mode=proj_arc");
		}
		$hGui->addTab('proj_prf',$this->_T->lang('[[Profile]]'),"index.php?site=admin.php&ac=proj&mode=proj_prf");
		$hGui->addTab('proj_crm',$this->_T->lang('[[Projekt Felder]]'),"index.php?site=admin.php&ac=proj&mode=proj_crm");
		$hGui->addTab('proj_doc',$this->_T->lang('[[Dokumentation]]'),"index.php?site=admin.php&ac=proj&mode=proj_doc");
		$hGui->addTab('proj_print',$this->_T->lang('[[Druckvorlagen]]'),"index.php?site=admin.php&ac=proj&mode=proj_print");
		$hGui->addTab('proj_rules',$this->_T->lang('[[Projektrollen]]'),"index.php?site=admin.php&ac=proj&mode=proj_rules");

		$hGui->setTabOn($this->_mode);
		if ($this->_mode=='proj_prj') {
			require_once('lib/class_FunctionButtons.php');
			$sParams=array('Modul'=>'proj_search','Label'=>$this->_T->lang('[[Suche]]').': ','UrlParams'=>array('fieldID'=>'proj_list','Link'=>$this->_L->getLink()));
			$btAjaxSearch=new FunctionButtons('proj_search','ajaxsearch',$sParams);
			$hGui->addFunction($btAjaxSearch);
		}
		require_once('lib/class_FunctionObjActionGui.php');
		$objActionGui=new FunctionObjActionGui();
		if ($this->_obj_action) {
			$obj_action=$this->_frm->getObjAction('admin',$this->_obj_action);
			$parse=false;
			foreach ($obj_action as $key=>$val) {
				if ($val['Hidden']) continue;
				if ($this->_mode=='proj_prj' && !$this->isAllowedPrjAction($this->_Obj,$val)) continue;
				if ($this->_mode=='proj_prf' && !$this->isAllowedPrfAction($this->_Obj,$val)) continue;
				//print_r($val);
				$parse=true;
				$objActionGui->addValue($key,$val['Name']);
			}
			if ($parse) $hGui->addFunction($objActionGui);
		}
		if ($this->_ObjActionGui) {
			$hGui->addFunction($this->_ObjActionGui);
		}
		return $hGui;
	}
	function isAllowedPrfAction(&$obj,$action) {
		if ($action['Hidden']) return false;
		if (in_array('ID',$action['Extra']) && ($this->_action!='e' || !is_object($obj))) return false;
		if (in_array('empty',$action['Extra']) && (!$this->_BasePrf->isEmpty($obj))) return false;
		if (in_array('!Head',$action['Extra']) && ($obj->getMeta('HeadID')==$obj->getID())) return false;
		if (in_array('!System',$action['Extra']) && $obj->getMeta('System')) return false;
		return true;
	}
	function isAllowedPrjAction(&$obj,$action) {
		if ($action['Hidden']) return false;
		if (in_array('ID',$action['Extra']) && !is_object($obj)) return false;
		if (in_array('rule',$action['Extra']) && !$this->_BasePrj->isRuleUser()) return false;
		if (in_array('prjAdd',$action['Extra'])) {
			if (empty($this->_my_profiles)) return false;
		}
		if (in_array('prjDel',$action['Extra'])) {
			if (!is_object($this->_ObjProfile) || !$this->_ObjProfile->getAcl(4096)) return false;
		}
		return true;
	}
	function process(&$AppGui) {
		$this->_handleRequest();
		$AppGui->addContent($this->getAdminHeader());
		$formAction='';
		switch ($this->_mode) {
			case 'proj_prf':
				require_once('lib/class_ApplicationTreeGui.php');
				$this->_Gui=new ApplicationTreeGui();
				switch ($this->_action) {
					case 'c':
					case 'n':
					case 'e':
						$this->showProfileTree();
						$this->showProfileContent();
					break;
				}
				$AppGui->addContent($this->_Gui);
			break;
			case 'proj_prj':
				switch ($this->_action) {
					case 'n':
					case 'c':
						if (Framework::getParam('trash')) {
							$AppGui->addContent($this->showDeleteProject());
						} else {
							$AppGui->addContent($this->showEditProject());
						}
					break;
					case 'd':
						$AppGui->addContent($this->showDeleteProject());
					break;
					case 'b':
						$AppGui->addContent($this->showProjectList($this->_searchPrj),null,'proj_list');
						$L=Framework::cloneObj($this->_L);
						$L->setParam('_loadSearch',1);
						$formAction=$L->getTempLink();
					break;
					case 'medit':
						if ($this->_BasePrj->isRuleUser()) {
							require_once('lib/proj/class_ProjectMultiEditGui.php');
							$Gui=new ProjectMultiEditGui();
							$AppGui->addContent($Gui->process(),null,'proj_list');
						}
						$L=Framework::cloneObj($this->_L);
						$L->setParam('_loadSearch',1);
						$formAction=$L->getTempLink();
					break;
				}

			break;
			case 'proj_arc':
				require_once('lib/class_ApplicationTreeGui.php');
				$this->_Gui=new ApplicationTreeGui();
				switch ($this->_action) {
					case 'a':
						$this->showArchivSearchGui();
						$this->showArchivProjectGui();
					break;
					case 'v':
						$this->showArchivLogGui();
					break;
					default:
						$this->showArchivSearchGui();
						$this->showArchivListGui();
					break;
				}
				$AppGui->addContent($this->_Gui);

			break;
			case 'proj_crm':
				require_once('lib/class_ApplicationTreeGui.php');
				//$this->_Gui=new ApplicationTreeGui();
				$Gui=$this->_UserFormFieldsGui->process();
				$AppGui->addContent($Gui);
			break;
			case 'proj_doc':
				$Gui=$this->_UserFormGui->process(false);
				$AppGui->addContent($Gui);
			break;
			case 'proj_print':
				$Gui=$this->_PrintTemplatesGui->process(false);
				$AppGui->addContent($Gui);
			break;
			case 'proj_rules':
				require_once('lib/class_ApplicationTreeGui.php');
				$this->_Gui=new ApplicationTreeGui();
				$this->showProjectRulesList();
				$this->showProjectRulesGui();
				$AppGui->addContent($this->_Gui);
			break;
		}
		$AppGui->setFormAction($formAction?$formAction:$this->_L->getLink());
	}
	function &showProjectRulesList() {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		//$tabGui->setName($this->_T->lang('[[Rechte Profil]]'));
		//$tabGui->addHeaderCol('Name',$this->_T->lang('[[Spesentabellen]]'),'','','','','',2);
		foreach ($this->_allRules as $key=>$val) {
			if ($key==$this->_rid) {
				$hl=2;
			} else {
				$hl=0;
			}
			$tabGui->addRow($hl);
			$tabGui->addCol('IMG','','obj_img/ex_tree.gif');
			$tabGui->addCol('Name',$this->_T->lang($val),'',$this->_L->getTempLink(null,array('rid'=>$key)),'',0,'2000');
		}
		$this->_Gui->addTreeContent($tabGui);
	}
	function showProjectRulesGui() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		$Gui->setName($this->_T->lang('[[Eintrag bearbeiten]]'));

		$box=new BoxGui($this->_BasePrj->getModul().'|tabSelect');
		//$box->setCallbackOnChange(array(&$this,'setPrefs'),array('tabSelect'));
		$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
		$box->setTabContent('meta',$this->getTranslationMetaGui($this->_allRules[$this->_rid]));
		$box->setTabOn('meta');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		$this->_Gui->addContent($Gui);
	}
	function &getTranslationMetaGui($transKey) {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		$formGui=new FormGui();
		$defOneLang=1;
		$transData=$this->_T->readSqlTrans('proj_rule',$transKey);
		foreach ($this->_frm->getMaLang() as $val) {
			if ($transData[$val]!=$transData[$this->_frm->getLang()]) {
				$defOneLang=0;
				break;
			}
		}
		foreach ($this->_frm->getMaLang() as $val) {
			$key='transData['.$val.']';
			$formGui->addField($key,'text',$this->_T->lang('[[Bezeichnung]]').' '.$val,$transData[$val],'form_fields1');
			if ($val!=$this->_frm->getLang()) {
				if ((empty($_POST) && $defOneLang) || Framework::getParam('oneLang',0,'P')) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key,$attribs);
				} else {
					$formGui->setRequired($key);
				}
			} else {
				$formGui->setRequired($key);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'form_fields1');
				$formGui->setNoMeta($key);
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $val2) {
					if ($val2!=$val) $attribs['onchange'].="disableEnable('transData[".$val2."]',this,this.checked?0:1);";
				}
				$formGui->setAttribs($key,$attribs);
			}
		}
		$submit_array=array(
			'meta_save_x'=>' '.$this->_T->lang('[[Speichern]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','fields1');
		$formGui->setValues($key,$submit_array);


		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$Data=array('transData'=>$transData);
				$formGui->addMetaToArray($Data);
				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$Data['transData'][$val]=$Data['transData'][$this->_frm->getLang()];
					}
				}
				$this->_T->replaceSqlTrans('proj_rule',$transKey,$Data['transData']);
				$this->_L->goToLink();
			}
		}
		return $formGui;

	}


	function showProfileTree() {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		$tabGui->addHeaderCol('Name',$this->_T->lang('[[Profil]]'),'','','','','',2);
		$profiles=$this->_BasePrf->listProfiles();
		foreach ($profiles as $val) {
			if ($this->_action!='n' && $val->getID()==$this->_RootObj->getID()) {
				$hl=2;
			} else {
				$hl=0;
			}
			$tabGui->addRow($hl);
			$tabGui->addCol('IMG','','obj_img/ex_tree.gif');
			$tabGui->addCol('Name',$val->getName().($val->getMeta('System')=='p'?' (Default)':''),'',$this->_L->getTempLink(null,array('oid'=>$val->getID(),'action'=>'e')),'',0,'2000');
		}
		$this->_Gui->addTreeContent($tabGui);
		if (is_object($this->_RootObj)) {
			$this->showProfileTreeList();
		}
	}
	function showProfileTreeList() {
		$root_id=$this->_RootObj->getID();
		$ex_link=$this->_L->getTempLink();
		$ac_link=$this->_L->getTempLink(array('oid','action'));
		require_once('lib/class_ObjAjaxTreeGui.php');
		$up_tree=false;
		if (Framework::getParam('_open',0,'G')==1) {
			$open_tree=','.implode(',',array_keys($this->_BasePrf->listProfilesTree($root_id))).',';
			$this->_frm->setTree($this->_mode,$root_id,$open_tree);
		} elseif (Framework::getParam('_open',0,'G')==-1) {
			$open_tree=',';
			$this->_frm->setTree($this->_mode,$root_id,$open_tree);
		} else {
			$open_tree=$this->_frm->getTree($this->_mode,$root_id);
			if (Framework::getParam('_x',0,'G')) {
				$this->_frm->updateTree($open_tree,Framework::getParam('_x',0,'G'));
				$this->_frm->setTree($this->_mode,$root_id,$open_tree);
			}
		}
		$expand=array_flip(explode(',',$open_tree));
		$expand[$root_id]=1;
		if (!$expand[$this->_Obj->getID()]) {
			$expand[$this->_Obj->getID()]=1;
			$this->_frm->updateTree($open_tree,$this->_Obj->getID());
			$this->_frm->setTree($this->_mode,$root_id,$open_tree);
		}
		$ObjAjaxTreeGui=new ObjAjaxTreeGui(1);
		if ($this->_Obj->getMeta('ObjTyp')!='pfol' || $this->_action!='n') {
			$ObjAjaxTreeGui->setSelectedID($this->_Obj->getID());
		}
		$ObjAjaxTreeGui->setCallback(array(&$this->_BasePrf,'listSubTree'));
		$ObjAjaxTreeGui->setCallbackLen(array(&$this->_BasePrf,'isSubTreeLen'));
		$ObjAjaxTreeGui->setExpand($expand);
		$ObjAjaxTreeGui->setExLink($ex_link."&_x={OID}");
		$ObjAjaxTreeGui->setAcLink($ac_link."&action={ACTION}&oid={OID}");
		$ObjAjaxTreeGui->setOpenCloseLink($ex_link."&_open={MODE}");
		$ObjAjaxTreeGui->setImgPath("img/".APP_THEME);
		$ObjAjaxTreeGui->setColors(APP_BGCOLOR,APP_FG10COLOR);
		$ObjAjaxTreeGui->setRootObj($this->_RootObj);
		$ObjAjaxTreeGui->setRootID($root_id);
		$ObjAjaxTreeGui->setModul($this->_mode);
		$this->_Gui->addTreeContent($ObjAjaxTreeGui,$root_id);
	}
	function showProfileContent() {
		switch ($this->_Obj->getMeta('ObjTyp')) {
			case 'sfol':
			case 'ffol':
			case 'mfol':
				$this->showEditFolder();
			break;
			case 'zfol':
				$this->showEditZef();
			break;
			case 'tel_fol':
				$this->showEditStel();
			break;
			case 'doc_fol':
				$this->showEditDocumentation();
			break;
			case 'tfol':
				$this->showEditTask();
			break;
			case 'kfol':
				$this->showEditCal();
			break;
			case 'pfol':
				$this->checkProfile();
				$this->showEditProfile();
			break;
		}
	}
	function checkProfile() {
		$DefaultObj=$this->_BasePrf->getSystemObj('p');
		$avObjTyps=$this->_BasePrf->getObjTyps($DefaultObj->getID());
		$aktObjTyps=$this->_BasePrf->getObjTyps($this->_RootObj->getID());
		foreach ($avObjTyps as $val) {
			if (!in_array($val,$aktObjTyps)) {
				$this->_BasePrf->recursiveCopy($DefaultObj->getID(),$this->_RootObj,1,0,1,$val);
			}
		}
	}
	function showEditProfile() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		if ($this->_action=='n' || $this->_action=='c') {
			$Gui->setName($this->_T->lang('[[Neues Profil anlegen]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(null,array('action'=>'e'))));
			$req_check=1;
			$tabs[]='meta';
			//$tabs[]='perms';
		} else {
			$Gui->setName($this->_T->lang('[[Profil bearbeiten]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'))));
			$req_check=2;
			$tabs[]='meta';
			$tabs[]='perms';
			$tabs[]='members';
		}
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_mode.'|showtab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('showtab'));
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getProfilMetaGui());
		}
		if (in_array('perms',$tabs)) {
			$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
			$box->setTabContent('perms',$this->getProfilPermsGui());
		}
		if (in_array('members',$tabs)) {
			$box->addTab('members',$this->_T->lang('[[Mitglieder]]'),'#',true);
			$box->setTabContent('members',$this->getProfilMembersGui());
		}
		$show_tap=$this->getPrefs('showtab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		$this->_Gui->addContent($Gui);
	}
	function showEditFolder() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		if ($this->_action=='n') {
			$Gui->setName($this->_T->lang('[[Neues Verzeichnis anlegen]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(null,array('action'=>'e'))));
			$req_check=1;
			$tabs[]='meta';
		} else {
			$Gui->setName($this->_T->lang('[[Verzeichnis bearbeiten]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'))));
			$req_check=2;
			if ($this->_Obj->getMeta('HeadID')!=$this->_Obj->getID()) $tabs[]='meta';
			$tabs[]='perms';
		}
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_mode.'|showtab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('showtab'));
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getMetaGui());
		}
		if (in_array('perms',$tabs)) {
			$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
			$box->setTabContent('perms',$this->getPermsGui());
		}
		$show_tap=$this->getPrefs('showtab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		$this->_Gui->addContent($Gui);
	}
	function showEditCal() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$Gui->setName($this->_T->lang('[[Rechte bearbeiten]]'));
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_mode.'|showtab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('showtab'));
		$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
		$box->setTabContent('perms',$this->getPermsGui(1));
		$box->addTab('view',$this->_T->lang('[[cal_Sichtbarkeit]]'),'#',true);
		$box->setTabContent('view',$this->getCalViewGui());
		$show_tap=$this->getPrefs('showtab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:'perms');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		$this->_Gui->addContent($Gui);
	}
	function showEditZef() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$Gui->setName($this->_T->lang('[[Rechte bearbeiten]]'));
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'))));
		$Gui->addFunction($btBreak);
		$box=new BoxGui($this->_mode.'|showtab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('showtab'));
		$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
		$box->setTabContent('perms',$this->getPermsGui(1));
		$box->addTab('view',$this->_T->lang('[[zef_Taetigkeiten]]'),'#',true);
		$box->setTabContent('view',$this->getZefTaetigkeitenGui());


		$show_tap=$this->getPrefs('showtab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:'perms');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		$this->_Gui->addContent($Gui);
	}
	function showEditTask() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$Gui->setName($this->_T->lang('[[Rechte bearbeiten]]'));
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui();
		$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
		$box->setTabContent('perms',$this->getPermsGui(1));
		$box->setTabOn('perms');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		$this->_Gui->addContent($Gui);
	}
	function showEditStel() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$Gui->setName($this->_T->lang('[[Rechte bearbeiten]]'));
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui();
		$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
		$box->setTabContent('perms',$this->getPermsGui(1));
		$box->setTabOn('perms');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		$this->_Gui->addContent($Gui);
	}
	function showEditDocumentation() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$this->_T->loadModul('uform');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$Gui->setName($this->_T->lang('[[Formulare verwalten]]'));
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'))));
		$Gui->addFunction($btBreak);
		$box=new BoxGui($this->_mode.'|showtab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('showtab'));
		$box->addTab('view',$this->_T->lang('[[Formulare]]'),'#',true);
		$box->setTabContent('view',$this->getDocFormularGui(false));

		if ($this->_Obj->getMeta('AddOn')) {
			$AddOn=unserialize($this->_Obj->getMeta('AddOn'));
			//debug($AddOn);
			if (!empty($AddOn)) {
				$box->addTab('def',$this->_T->lang('[[Vorgabewerte]]'),'#',true);
				$box->setTabContent('def',$this->getDocFormularGuiDefault());
			}
		}
		$show_tap=$this->getPrefs('showtab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:'view');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		$this->_Gui->addContent($Gui);
	}
	function &getMetaGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		foreach ($this->_BasePrf->getObjFields($this->_Obj->getMeta('ObjTyp')) as $key=>$val) {
			switch ($val['Typ']) {
				case 'check':
				case 'text':
					$formGui->addField($key,$val['Typ'],$this->_T->lang($val['Name']),$this->_action!='n'?$this->_Obj->getMeta($key):'','fields1');
					if ($val['Required']) $formGui->setRequired($key);
					if ($val['Callback']) $formGui->setCallback($key,array(&$this,$val['Callback']));
				break;
			}
		}
		$formGui->addField('meta_save_x','submit','',$this->_T->lang('[[Speichern]]'),'fields2');
		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if ($this->_name_check_prf[$this->_Obj->getMeta('ObjTyp')] && preg_match($this->_name_check_prf[$this->_Obj->getMeta('ObjTyp')],$formGui->getFieldVal('Name'))) {
					$this->_E->setError('chars','Name');
				} elseif ($this->_BasePrf->nameExists($formGui->getFieldVal('Name'),$this->_action=='n'?$this->_Obj->getID():$this->_Obj->getMeta('ParentID'),$this->_action=='n'?0:$this->_Obj->getID())) {
					$this->_E->setError('fol_exists','Name');
				} else {
					if ($this->_action=='n') {
						$Obj=$this->_Obj;
						$Obj->setMeta('ParentID',$this->_Obj->getID());
						$Obj->setMeta('System',0);
						$Obj->setMeta('Sequence',0);
						$formGui->addMetaToObj($Obj);
						$this->_BasePrf->insertMeta($Obj);
						$this->_L->setParam('oid',$Obj->getID());
						$this->_L->setParam('action','e');
						$this->_L->setParam('_clTab','perms');
						$this->_L->goToLink();
					} else {
						$formGui->addMetaToObj($this->_Obj);
						$this->_BasePrf->updateMeta($this->_Obj);
						$this->_L->goToLink();
					}
				}
			}
		}
		//debug($this->_E->isError());
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$empty='&nbsp;';
		$tplContent->addContent('form2',$empty,'FORM2');
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields2'));
		return $tplContent;
	}
	function &getProfilMetaGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		foreach ($this->_BasePrf->getObjFields($this->_Obj->getMeta('ObjTyp')) as $key=>$val) {
			switch ($val['Typ']) {
				case 'check':
				case 'text':
					$formGui->addField($key,$val['Typ'],$this->_T->lang($val['Name']),$this->_action=='e'?$this->_Obj->getMeta($key):'','fields1');
					if ($val['Required']) $formGui->setRequired($key);
					if ($val['Callback']) $formGui->setCallback($key,array(&$this,$val['Callback']));
				break;
			}
		}
		if ($this->_action=='c') {
			$formGui->addField('copyID','hidden','',$this->_Obj->getID(),'fields1');
		}
		$formGui->addField('meta_save_x','submit','',$this->_T->lang('[[Speichern]]'),'fields2');
		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if ($this->_name_check_prf[$this->_Obj->getMeta('ObjTyp')] && preg_match($this->_name_check_prf[$this->_Obj->getMeta('ObjTyp')],$formGui->getFieldVal('Name'))) {
					$this->_E->setError('chars','Name');
				} elseif ($this->_BasePrf->nameExists($formGui->getFieldVal('Name'),$this->_Obj->getMeta('ParentID'),$this->_action=='n'?0:$this->_Obj->getID())) {
					$this->_E->setError('fol_exists','Name');
				} else {
					if (Framework::getParam('copyID','0','P')) $copyID=Framework::getParam('copyID','0','P'); else $copyID=0;
					if ($this->_action=='n' || $this->_action=='c') {
						if ($copyID) {
							$Obj=$this->_BasePrf->getObj($copyID);
							$oldID=$Obj->getID();
						} else {
							$Obj=$this->_BasePrf->getSystemObj('p');
							$oldID=$Obj->getID();
							$Obj->setMeta('PermsRules','||');
							$Obj->setMeta('PermsUser','||');
							$Obj->setMeta('PermsGroup','||');
							$Obj->setMeta('AddOn','');
						}
						$Obj->setMeta('System','');
						$formGui->addMetaToObj($Obj);
						if ($this->_BasePrf->insertMeta($Obj)) {
							$Obj->setMeta('HeadID',$Obj->getID());
							$Obj->setMeta('RootID',$Obj->getID());
							$this->_BasePrf->updateMeta($Obj);
							$this->_BasePrf->recursiveCopy($oldID,$Obj,1,$copyID?1:0,$copyID?1:0);
						}
						$this->_L->setParam('oid',$Obj->getID());
						$this->_L->setParam('action','e');
						$this->_L->setParam('_clTab','meta');
						$this->_L->goToLink();
					} else {
						$formGui->addMetaToObj($this->_Obj);
						$this->_BasePrf->updateMeta($this->_Obj);
						$this->_L->goToLink();
					}
				}
			}
		}
		//debug($this->_E->isError());
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$empty='&nbsp;';
		$tplContent->addContent('form2',$empty,'FORM2');
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields2'));
		return $tplContent;
	}
	function &getProfilMembersGui() {
		require_once('lib/class_TemplateGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		if ($this->_Obj->getMeta('AddOn')) {
			$AddOn=unserialize($this->_Obj->getMeta('AddOn'));
		} else {
			$AddOn=array();
		}
		$avRules=$this->_BasePrj->getAvRules();
		$ruleUsers=isset($AddOn['ruleUsers'])?$AddOn['ruleUsers']:array();
		$groupUsers=isset($AddOn['groupUsers'])?$AddOn['groupUsers']:array();
		$ruleUsersExtra=isset($AddOn['ruleUsersExtra'])?$AddOn['ruleUsersExtra']:array();

		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		$formGui=new FormGui();

		$key='addPermsUser_m';
		$mode='u|g';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'proj',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'proj',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);
		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,'','fields1');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));

		$extraUsers=array(
			0=>'-',
			1=>$this->_T->lang('[[prjOwner]]'),
		);
		$formGui->addField('addPermsExtra','select',$this->_T->lang('[[Sonderbenutzer]]'),0,'fields1');
		$formGui->setValues('addPermsExtra',$extraUsers);


		end($avRules);
		$formGui->addField('addRuleID_m','radiolist_v',$this->_T->lang('[[Hinzufuegen als]]'),key($avRules),'fields2');
		$formGui->setValues('addRuleID_m',$this->_T->langArray($avRules));

		$formGui->addField('perms_add_m','submit','',$this->_T->lang('[[Hinzufuegen]]'),'fields3');
		$update=false;
		if (Framework::getParam('perms_add_m',0,'P') && trim($formGui->getFieldVal('addPermsUser_m'))) {
			$permsUsers=explode('|',$formGui->getFieldVal('addPermsUser_m'));
			foreach ($permsUsers as $val) {
				$tmp=explode('_',$val);
				if ($tmp[0]=='u') {
					$ruleUsers[Framework::getParam('addRuleID_m',0,'P')][$tmp[1]]=1;
					$update=true;
				}
				if ($tmp[0]=='g') {
					$groupUsers[Framework::getParam('addRuleID_m',0,'P')][$tmp[1]]=1;
					$update=true;
				}
			}
		}
		if (Framework::getParam('perms_add_m',0,'P') && $formGui->getFieldVal('addPermsExtra')) {
			$ruleUsersExtra[Framework::getParam('addRuleID_m',0,'P')][$formGui->getFieldVal('addPermsExtra')]=1;
			$update=true;
		}
		foreach ($avRules as $rkey=>$rval) {
			if(is_array(Framework::getParam('permDelete_m'.$rkey.'_u_x',0,'P'))) {
				$ukey=key($tmpArray=Framework::getParam('permDelete_m'.$rkey.'_u_x',0,'P'));
				if ($ukey) {
					unset($ruleUsers[$rkey][$ukey]);
					$update=true;
				}
			}
			if(is_array(Framework::getParam('permDelete_m'.$rkey.'_g_x',0,'P'))) {
				$ukey=key($tmpArray=Framework::getParam('permDelete_m'.$rkey.'_g_x',0,'P'));
				if ($ukey) {
					unset($groupUsers[$rkey][$ukey]);
					$update=true;
				}
			}
			if(is_array(Framework::getParam('permDelete_m'.$rkey.'_e_x',0,'P'))) {
				$ukey=key($tmpArray=Framework::getParam('permDelete_m'.$rkey.'_e_x',0,'P'));
				if ($ukey) {
					unset($ruleUsersExtra[$rkey][$ukey]);
					$update=true;
				}
			}
		}
		if ($update) {
			$AddOn['ruleUsers']=$ruleUsers;
			$AddOn['groupUsers']=$groupUsers;
			$AddOn['ruleUsersExtra']=$ruleUsersExtra;
			$this->_Obj->setMeta('AddOn',serialize($AddOn));
			$this->_BasePrf->updateMeta($this->_Obj);
			$formGui->clearFields('fields1');
		}

		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		foreach ($avRules as $key=>$val) {
			$rUsers=array();
			$eUsers=array();
			$gUsers=array();
			if (is_array($ruleUsers[$key]) && !empty($ruleUsers[$key])) {
				$rUsers=$this->_frm->getFullName(array_keys($ruleUsers[$key]),0,1);
			}
			if (is_array($groupUsers[$key]) && !empty($groupUsers[$key])) {
				$gUsers=$this->_frm->getAllGroups(array_keys($groupUsers[$key]));
			}
			if (is_array($ruleUsersExtra[$key]) && !empty($ruleUsersExtra[$key])) {
				foreach (array_keys($ruleUsersExtra[$key]) as $eval) {
					$eUsers[$eval]=$extraUsers[$eval];
				}
			}
			$listGui[$key]=$this->listProjectMembers($key,$rUsers,$gUsers,$eUsers,true,'_m');
			if ($listGui[$key]) {
				$tplContent->addContent('form3_'.$key,$listGui[$key],'FORM3');
			}
		}
		return $tplContent;
	}

	function &getProfilPermsGui() {
		//debug($this->_Obj->getMeta('ObjTyp'));
		return $this->getPermsGui(0,0,1,1,$this->_T->lang('[[Besitzer darf]]'));
	}
	function &getPermsGui($perm_mode=0,$useRules=1,$useGroups=1,$useUsers=1,$optionTitle='') {
		if ($useRules) $perms_r=Framework::aclToArray($this->_Obj->getMeta('PermsRules'));
		if ($useGroups) $perms_g=Framework::aclToArray($this->_Obj->getMeta('PermsGroup'));
		if ($useUsers) $perms_u=Framework::aclToArray($this->_Obj->getMeta('PermsUser'));

		if ($this->_prjPermsOptions[$this->_Obj->getMeta('ObjTyp')]) {
			$i=1;
			foreach ($this->_prjPermsOptions[$this->_Obj->getMeta('ObjTyp')] as $key=>$val) {
				$avOptions[$key]='('.$i.') '.$val;
				$avOptionsShort[$key]='('.$i.')';
				$i++;
			}
		} else {
			$avOptions=false;
		}

		$update=false;
		if (Framework::getParam('perms_add',0,'P') && Framework::getParam('addPermsID',0,'P')) {
			if ($useRules && Framework::getParam('addFKProjRuleID',0,'P')) {
				if ($perm_mode) {
					$perms_r[Framework::getParam('addFKProjRuleID',0,'P')]=array_sum(Framework::getParam('addPermsID',0,'P'));
				} else {
					$perms_r[Framework::getParam('addFKProjRuleID',0,'P')]=Framework::getParam('addPermsID',0,'P');
				}
				if ($avOptions && is_array(Framework::getParam('addOptionsID',0,'P'))) {
					$perms_r[Framework::getParam('addFKProjRuleID',0,'P')]+=array_sum(Framework::getParam('addOptionsID',0,'P'));
				}
				$this->_Obj->setMeta('PermsRules',Framework::arrayToAcl($perms_r));
				$update=true;
			}
			if ($useGroups && Framework::getParam('addFKGroupID',0,'P')) {
				if ($perm_mode) {
					$perms_g[Framework::getParam('addFKGroupID',0,'P')]=array_sum(Framework::getParam('addPermsID',0,'P'));
				} else {
					$perms_g[Framework::getParam('addFKGroupID',0,'P')]=Framework::getParam('addPermsID',0,'P');
				}
				if ($avOptions && is_array(Framework::getParam('addOptionsID',0,'P'))) {
					$perms_g[Framework::getParam('addFKGroupID',0,'P')]+=array_sum(Framework::getParam('addOptionsID',0,'P'));
				}
				$this->_Obj->setMeta('PermsGroup',Framework::arrayToAcl($perms_g));
				$update=true;
			}
			if ($useUsers && Framework::getParam('addFKUserID',0,'P')) {
				if ($perm_mode) {
					$perms_u[Framework::getParam('addFKUserID',0,'P')]=array_sum(Framework::getParam('addPermsID',0,'P'));
				} else {
					$perms_u[Framework::getParam('addFKUserID',0,'P')]=Framework::getParam('addPermsID',0,'P');
				}
				if ($avOptions && is_array(Framework::getParam('addOptionsID',0,'P'))) {
					$perms_u[Framework::getParam('addFKUserID',0,'P')]+=array_sum(Framework::getParam('addOptionsID',0,'P'));
				}
				$this->_Obj->setMeta('PermsUser',Framework::arrayToAcl($perms_u));
				$update=true;
			}
			if ($useOwner) {


			}
		}
		if($useRules && is_array(Framework::getParam('permDeleteR_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteR_x',0,'P'));
			if ($key) {
				unset($perms_r[$key]);
				$this->_Obj->setMeta('PermsRules',Framework::arrayToAcl($perms_r));
				$update=true;
			}
		}
		if($useGroups && is_array(Framework::getParam('permDeleteG_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteG_x',0,'P'));
			if ($key) {
				unset($perms_g[$key]);
				$this->_Obj->setMeta('PermsGroup',Framework::arrayToAcl($perms_g));
				$update=true;
			}
		}
		if($useUsers && is_array(Framework::getParam('permDeleteU_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteU_x',0,'P'));
			if ($key) {
				unset($perms_u[$key]);
				$this->_Obj->setMeta('PermsUser',Framework::arrayToAcl($perms_u));
				$update=true;
			}
		}
		if ($update) {
			$this->_BasePrf->updateMeta($this->_Obj);
			$this->_L->goToLink();
		}

		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		if ($useRules) {
			$formGui->addField('addFKProjRuleID','select',$this->_T->lang('[[prjRules]]'),'','fields1');
			$formGui->setValues('addFKProjRuleID',array(0=>'-') + $this->_T->langArray($this->_BasePrj->getAvRules()));
		}
		if ($useGroups) {
			$formGui->addField('addFKGroupID','select',$this->_T->lang('[[Gruppen]]'),'','fields1');
			$formGui->setValues('addFKGroupID',array(0=>'-') + $this->_frm->getAllGroups());
		}
		if ($useUsers) {
			$formGui->addField('addFKUserID','select',$this->_T->lang('[[BenutzerInnen]]'),'','fields1');
			$formGui->setValues('addFKUserID',array(0=>'-') + $this->_frm->getFullName());
		}

		//$formGui->addField('FKUserID','ttip',$this->_T->lang('[[BenutzerInnen]]'),'u_16|u_1','fields1');
		//$formGui->setParams('FKUserID',array('mode'=>'u|g'));

		if ($perm_mode) {
			$formGui->addField('addPermsID','checklist_v',$this->_T->lang('[[Rechte]]'),1,'fields2');
		} else {
			$formGui->addField('addPermsID','radiolist_v',$this->_T->lang('[[Rechte]]'),1,'fields2');
		}
		$formGui->setValues('addPermsID',$this->_prjPerms[$this->_Obj->getMeta('ObjTyp')]);
		if ($avOptions) {
			if (!$optionTitle) $optionTitle=$this->_T->lang('[[Optionen]]');
			$formGui->addField('addOptionsID','checklist_v',$optionTitle,1,'fields2');
			$formGui->setValues('addOptionsID',$avOptions);
		}

		$formGui->addField('perms_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields3');

		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		//$tplContent->addContent('form2',$box,'CONTENT');

		if ($useRules) $tplContent->addContent('form3_1',$this->listPerms('PermsRules',$perms_r,$this->_prjPermsShort[$this->_Obj->getMeta('ObjTyp')],$perm_mode,'perm',$avOptionsShort),'FORM3');
		if ($useGroups) $tplContent->addContent('form3_2',$this->listPerms('PermsGroup',$perms_g,$this->_prjPermsShort[$this->_Obj->getMeta('ObjTyp')],$perm_mode,'perm',$avOptionsShort),'FORM3');
		if ($useUsers) $tplContent->addContent('form3_3',$this->listPerms('PermsUser',$perms_u,$this->_prjPermsShort[$this->_Obj->getMeta('ObjTyp')],$perm_mode,'perm',$avOptionsShort),'FORM3');
		return $tplContent;
	}
	function &listPerms($ptype,$perms,$av_perms,$perm_mode=0,$prep='perm',$av_options=null) {
		if (!empty($perms)) {
			require_once('lib/class_ApplicationListGui.php');
			require_once('lib/class_FormGui.php');
			$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
			switch ($ptype) {
				case 'PermsRules':
					$title=$this->_T->lang('[[prjRules]]');
					$perms_users=array();
					foreach ($perms as $key=>$val) {
						$perms_users[$key]=$this->_T->lang($this->_BasePrj->getAvRules($key));

					}
					$img='rolle.gif';
					$dbtn=$prep.'DeleteR_x';
				break;
				case 'PermsGroup':
					$title=$this->_T->lang('[[Gruppen]]');
					$perms_users=$this->_frm->getAllGroups(array_keys($perms),-1);
					$img='gruppe.gif';
					$dbtn=$prep.'DeleteG_x';
				break;
				case 'PermsUser':
					$title=$this->_T->lang('[[BenutzerInnen]]');
					$perms_users=$this->_frm->getFullName(array_keys($perms),0,1);
					$img='user.gif';
					$dbtn=$prep.'DeleteU_x';
				break;
			}
			$tabGui->addHeaderCol('Name',$title,'','','',0,0,2);
			foreach ($av_perms as $pkey=>$pval) {
				$tabGui->addHeaderCol('Perms_'.$pkey,$pval,'','','',1);
			}
			if (is_array($av_options)) {
				foreach ($av_options as $pkey=>$pval) {
					$tabGui->addHeaderCol('Perms_'.$pkey,$pval,'','','',1);
				}
			}
			$tabGui->addHeaderCol('Delete','','tras.gif');
			$tabGui->setLimit(0);
			$rows=0;$hl=0;
			if (is_array($perms_users)) {
				foreach ($perms_users as $key=>$val) {
					if (is_array($av_options)) {
						$perms_options=0;
						foreach ($av_options as $pkey=>$pval) {
							if ($perms[$key]&$pkey) {
								$perms[$key]-=$pkey;
								$perms_options+=$pkey;
							}
						}
					}

					//debug($val);
					$hl=$hl?0:1;
					$tabGui->addRow($hl);
					$tabGui->addCol('IMG','',$img);
					$tabGui->addCol('Name',$val,'','','',0,'2000');

					foreach ($av_perms as $pkey=>$pval) {

						if ($perm_mode) {
							$tabGui->addCol('Perms_'.$pkey,($perms[$key]&$pkey)?'X':'','','','center',1);
						} else {
							$tabGui->addCol('Perms_'.$pkey,$pkey==$perms[$key]?'X':'','','','center',1);
						}
					}
					if (is_array($av_options)) {
						foreach ($av_options as $pkey=>$pval) {
							$tabGui->addCol('Perms_'.$pkey,($perms_options&$pkey)?'X':'','','','center',1);
						}
					}
					//$tabGui->addCol('Perms',$av_perms[$val],'','','',1);
					$btn=new SubmitImgBtn ($dbtn.'['.$key.']','img/'.APP_THEME.'/loeschen.gif');
					$tabGui->addCol('Delete',$btn);
				}
			}
		}
		return $tabGui;
	}
	function &getCalViewGui() {
		if ($this->_Obj->getMeta('AddOn')) {
			$AddOn=unserialize($this->_Obj->getMeta('AddOn'));
		} else {
			$AddOn=array();
		}
		$update=false;
		if (Framework::getParam('calview_add',0,'P')) {
			if (Framework::getParam('addCalFKProjRuleID',0,'P')) {
				$AddOn['Visibility']['Rules'][Framework::getParam('addCalFKProjRuleID',0,'P')]=1;
				$this->_Obj->setMeta('AddOn',serialize($AddOn));
				$update=true;
			}
			if (Framework::getParam('addCalFKGroupID',0,'P')) {
				$AddOn['Visibility']['Groups'][Framework::getParam('addCalFKGroupID',0,'P')]=1;
				$this->_Obj->setMeta('AddOn',serialize($AddOn));
				$update=true;
			}
			if (Framework::getParam('addCalFKUserID',0,'P')) {
				$AddOn['Visibility']['Users'][Framework::getParam('addCalFKUserID',0,'P')]=1;
				$this->_Obj->setMeta('AddOn',serialize($AddOn));
				$update=true;
			}
		}
		if(is_array(Framework::getParam('calviewDeleteR_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('calviewDeleteR_x',0,'P'));
			if ($key) {
				unset($AddOn['Visibility']['Rules'][$key]);
				$this->_Obj->setMeta('AddOn',serialize($AddOn));
				$update=true;
			}
		}
		if(is_array(Framework::getParam('calviewDeleteG_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('calviewDeleteG_x',0,'P'));
			if ($key) {
				unset($AddOn['Visibility']['Groups'][$key]);
				$this->_Obj->setMeta('AddOn',serialize($AddOn));
				$update=true;
			}
		}
		if(is_array(Framework::getParam('calviewDeleteU_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('calviewDeleteU_x',0,'P'));
			if ($key) {
				unset($AddOn['Visibility']['Users'][$key]);
				$this->_Obj->setMeta('AddOn',serialize($AddOn));
				$update=true;
			}
		}
		if ($update) {
			$this->_BasePrf->updateMeta($this->_Obj);
			$this->_L->goToLink();
		}

		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		$formGui->addField('addCalFKProjRuleID','select',$this->_T->lang('[[prjRules]]'),'','fields1');
		$formGui->setValues('addCalFKProjRuleID',array(0=>'-') + $this->_T->langArray($this->_BasePrj->getAvRules()));
		$formGui->addField('addCalFKGroupID','select',$this->_T->lang('[[Gruppen]]'),'','fields1');
		$formGui->setValues('addCalFKGroupID',array(0=>'-') + $this->_frm->getAllGroups());
		$formGui->addField('addCalFKUserID','select',$this->_T->lang('[[BenutzerInnen]]'),'','fields1');
		$formGui->setValues('addCalFKUserID',array(0=>'-') + $this->_frm->getFullName());
		$formGui->addField('calview_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields1');

		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		//$tplContent->addContent('form2',$box,'CONTENT');
		$tplContent->addContent('form3_1',$this->listPerms('PermsRules',$AddOn['Visibility']['Rules'],$this->_prjPermsShort['calview'],0,'calview'),'FORM3');
		$tplContent->addContent('form3_2',$this->listPerms('PermsGroup',$AddOn['Visibility']['Groups'],$this->_prjPermsShort['calview'],0,'calview'),'FORM3');
		$tplContent->addContent('form3_3',$this->listPerms('PermsUser',$AddOn['Visibility']['Users'],$this->_prjPermsShort['calview'],0,'calview'),'FORM3');
		return $tplContent;
	}
	function &getZefTaetigkeitenGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormGui.php');

		$this->_T->loadModul('zef');
		$Zef=& $this->_frm->getStaticModul('zef');
		if ($this->_Obj->getMeta('AddOn')) {
			$AddOn=unserialize($this->_Obj->getMeta('AddOn'));
		} else {
			$AddOn=array();
		}

		$update=false;
		$formGui=new FormGui();
		$formGui->addField('addZefCat','mselect',$this->_T->lang('[[Taetigkeit]]'),'','fields1');
		$formGui->setValues('addZefCat',$Zef->listAllCatNames('',1,0));
		$formGui->setAttribs('addZefCat',array('size'=>'8'));
		$formGui->addField('addZefCatSoll','curr',$this->_T->lang('[[Sollstunden]]'),'','fields1');
		$formGui->addField('zef_cat_add','submit','',$this->_T->lang('[[Hinzufuegen]]'),'fields1');
		$formGui->addField('zef_cat_save','submit','',$this->_T->lang('[[Speichern]]'),'fields2');

		if (Framework::getParam('zef_cat_add',0,'P')) {
			$values=$formGui->getFieldVal('addZefCat');
			if (is_array($values) && !empty($values)) {
				foreach ($values as $tmp_id) {
					$AddOn['ZefCat'][$tmp_id]=array(
						'soll'=>$formGui->getFieldVal('addZefCatSoll'),
					);
				}
				$this->_Obj->setMeta('AddOn',serialize($AddOn));
				$update=true;
			}
		}
		if(is_array(Framework::getParam('zef_del_cat',0,'P'))) {
			$tmp_id=key($tmpArray=Framework::getParam('zef_del_cat',0,'P'));
			if ($tmp_id) {
				unset($AddOn['ZefCat'][$tmp_id]);
				$this->_Obj->setMeta('AddOn',serialize($AddOn));
				$update=true;
			}
		}
		if (Framework::getParam('zef_cat_save',0,'P')) {
			$values=Framework::getParam('zef_cat_soll',array(),'P');
			if (is_array($values) && !empty($values)) {
				foreach ($values as $tmp_id=>$tmp_val) {
					$txtSoll=new DecimalFieldBtn ('zef_cat_soll['.$tmp_id.']');
					$txtSoll->setNumDec(2);
					$AddOn['ZefCat'][$tmp_id]['soll']=$txtSoll->getVal(0);
				}
				$this->_Obj->setMeta('AddOn',serialize($AddOn));
				$update=true;
			}

		}
		if ($update) {
			$this->_BasePrf->updateMeta($this->_Obj);
			$this->_L->goToLink();
		}

		$tplContent=new TemplateGui('core/form_3columns.inc.html');


		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tabGui->setName($this->_T->lang('[[Im Projekt verfuegbare Taetigkeiten]]'));
		$tabGui->addHeaderCol('Name',$this->_T->lang('[[Taetigkeit]]'));
		$tabGui->addHeaderCol('Soll',$this->_T->lang('[[Sollstunden]]'),'','','',1);
		$tabGui->addHeaderCol('Delete','','tras.gif');
		$tabGui->setLimit(0);
		$rows=0;$hl=0;
		if (isset($AddOn['ZefCat']) && !empty($AddOn['ZefCat'])) {
			foreach ($AddOn['ZefCat'] as $key=>$val) {
				$hl=$hl?0:1;
				$tabGui->addRow($hl);
				$tabGui->addCol('Name',$Zef->getCachedCatName($key),'','','',0,'2000');
				$txtSoll=new DecimalFieldBtn ('zef_cat_soll['.$key.']',$val['soll'],array('style'=>'width:80px'));
				$txtSoll->setNumDec(2);
				$tabGui->addCol('Soll',$txtSoll,'','','',1);
				$btn=new SubmitImgBtn ('zef_del_cat['.$key.']','img/'.APP_THEME.'/loeschen.gif');
				$tabGui->addCol('Delete',$btn);
				$rows++;

			}
		} else {
			$tabGui->addRow(1);
			$tabGui->addCol('Name',$this->_T->lang('[[Alle]]'),'','','',0,'2000');
			$tabGui->addCol('Soll','-','','','right',1);
			$tabGui->addCol('Delete','','','','right',1);
		}

		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2_1',$tabGui,'FORM2');
		if ($rows)	$tplContent->addContent('form2_2',$formGui,'FORM2',array('','fields2'));
		return $tplContent;
	}
	function &getDocFormularGui($prjMode=false) {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormGui.php');

		$BaseForm=& $this->_frm->getStaticModul('uform');
		$BaseForm->setFormModul('proj');
		$avForms=$BaseForm->listModulForms();


		if ($prjMode) {
			$AddOn=$this->_BasePrj->getAllProjectPerms($this->_Obj->getID(),'doc');

			$avRules=array();
			$avGroups=$this->_frm->getAllGroups(0,$this->_Obj->getID());
			$avUsers=$this->_frm->getFullName();
		} else {
			if ($this->_Obj->getMeta('AddOn')) {
				$AddOn=unserialize($this->_Obj->getMeta('AddOn'));
			} else {
				$AddOn=array();
			}

			$avRules=$this->_T->langArray($this->_BasePrj->getAvRules());
			$avGroups=$this->_frm->getAllGroups();
			$avUsers=$this->_frm->getFullName();
		}
		$update=false;
		$defFormular=0;
		if (Framework::getParam('perms_add',0,'P') && Framework::getParam('addPermsID',0,'P') && Framework::getParam('addFormular',0,'P')) {
			$formID=Framework::getParam('addFormular',0,'P');
			$defFormular=$formID;
			if (Framework::getParam('addFKProjRuleID',0,'P')) {
				$perms=$AddOn[$formID]['PermsRules']?Framework::aclToArray($AddOn[$formID]['PermsRules']):array();
				$perms[Framework::getParam('addFKProjRuleID',0,'P')]=Framework::getParam('addPermsID',0,'P');
				$AddOn[$formID]['PermsRules']=Framework::arrayToAcl($perms);
				$update=true;
			}
			if (Framework::getParam('addFKGroupID',0,'P')) {
				$perms=$AddOn[$formID]['PermsGroup']?Framework::aclToArray($AddOn[$formID]['PermsGroup']):array();
				$perms[Framework::getParam('addFKGroupID',0,'P')]=Framework::getParam('addPermsID',0,'P');
				$AddOn[$formID]['PermsGroup']=Framework::arrayToAcl($perms);
				$update=true;
			}
			if (Framework::getParam('addFKUserID',0,'P')) {
				$perms=$AddOn[$formID]['PermsUser']?Framework::aclToArray($AddOn[$formID]['PermsUser']):array();
				$perms[Framework::getParam('addFKUserID',0,'P')]=Framework::getParam('addPermsID',0,'P');
				$AddOn[$formID]['PermsUser']=Framework::arrayToAcl($perms);
				$update=true;
			}
		}
		if (Framework::getParam('permDeleteR_x','','P')) {
			$tmpArray=Framework::getParam('permDeleteR_x',0,'P');
			$formID=key($tmpArray);
			if ($formID) {
				$perms=$AddOn[$formID]['PermsRules']?Framework::aclToArray($AddOn[$formID]['PermsRules']):array();
				unset($perms[key($tmpArray[$formID])]);
				if (empty($perms)) {
					unset($AddOn[$formID]['PermsRules']);
				} else {
					$AddOn[$formID]['PermsRules']=Framework::arrayToAcl($perms);
				}
				if (empty($AddOn[$formID])) unset($AddOn[$formID]);
				$update=true;
			}
		}
		if (Framework::getParam('permDeleteG_x','','P')) {
			$tmpArray=Framework::getParam('permDeleteG_x',0,'P');
			$formID=key($tmpArray);
			if ($formID) {
				$perms=$AddOn[$formID]['PermsGroup']?Framework::aclToArray($AddOn[$formID]['PermsGroup']):array();
				unset($perms[key($tmpArray[$formID])]);
				if (empty($perms)) {
					unset($AddOn[$formID]['PermsGroup']);
				} else {
					$AddOn[$formID]['PermsGroup']=Framework::arrayToAcl($perms);
				}
				if (empty($AddOn[$formID])) unset($AddOn[$formID]);
				$update=true;
			}
		}
		if (Framework::getParam('permDeleteU_x','','P')) {
			$tmpArray=Framework::getParam('permDeleteU_x',0,'P');
			$formID=key($tmpArray);
			if ($formID) {
				$perms=$AddOn[$formID]['PermsUser']?Framework::aclToArray($AddOn[$formID]['PermsUser']):array();
				unset($perms[key($tmpArray[$formID])]);
				if (empty($perms)) {
					unset($AddOn[$formID]['PermsUser']);
				} else {
					$AddOn[$formID]['PermsUser']=Framework::arrayToAcl($perms);
				}
				if (empty($AddOn[$formID])) unset($AddOn[$formID]);
				$update=true;
			}
		}
		if ($update) {
			if ($prjMode) {
				$this->_BasePrj->deleteProjectPerms($this->_Obj->geTID(),'doc');
				foreach ($AddOn as $FormID=>$FormPerms) {
					$this->_BasePrj->saveProjectPerms($this->_Obj->geTID(),'doc',$FormPerms,$FormID);
				}
			} else {
				$this->_Obj->setMeta('AddOn',serialize($AddOn));
				$this->_BasePrf->updateMeta($this->_Obj);
			}
		}


		$formGui=new FormGui();
		$formGui->addField('addFormular','select',$this->_T->lang('[[Formular]]'),$defFormular,'fields1');
		$formGui->setValues('addFormular',array(0=>'-') + Framework::extractObjName($avForms));

		if (!empty($avRules)) {
			$formGui->addField('addFKProjRuleID','select',$this->_T->lang('[[prjRules]]'),'','fields1');
			$formGui->setValues('addFKProjRuleID',array(0=>'-') + $avRules);
		}
		if (!empty($avGroups)) {
			$formGui->addField('addFKGroupID','select',$this->_T->lang('[[Gruppen]]'),'','fields1');
			$formGui->setValues('addFKGroupID',array(0=>'-') + $avGroups);
		}
		if (!empty($avUsers)) {
			$formGui->addField('addFKUserID','select',$this->_T->lang('[[BenutzerInnen]]'),'','fields1');
			$formGui->setValues('addFKUserID',array(0=>'-') + $avUsers);
		}

		$formGui->addField('addPermsID','radiolist_v',$this->_T->lang('[[Rechte]]'),1,'fields2');
		$formGui->setValues('addPermsID',$this->_prjPerms['doc_fol']);

		$formGui->addField('perms_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields3');
		if ($update) {
			$formGui->clearFields('fields1');
		}
		$tplContent=new TemplateGui('core/form_3columns.inc.html');

		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));

		foreach ($AddOn as $FormId=>$Perms) {
			if (is_object($avForms[$FormId])) {
				$process=false;
				$tabGui[$FormId]=new ApplicationListGui('core/common_table_intern_list.inc.html');
				$tabGui[$FormId]->setName($avForms[$FormId]->getName());
				$tabGui[$FormId]->addHeaderCol('Name',$this->_T->lang('[[Rechte]]'),'','','',0,0,2);
				foreach ($this->_prjPermsShort['doc_fol'] as $pkey=>$pval) {
					$tabGui[$FormId]->addHeaderCol('Perms_'.$pkey,$pval,'','','',1);
				}
				$tabGui[$FormId]->addHeaderCol('Delete','','tras.gif');

				$perms_r=$AddOn[$FormId]['PermsRules']?Framework::aclToArray($AddOn[$FormId]['PermsRules']):array();
				foreach ($perms_r as $ukey=>$uval) {
					$hl=$hl?0:1;
					$tabGui[$FormId]->addRow($hl);
					$tabGui[$FormId]->addCol('Img','','rolle.gif');
					$tabGui[$FormId]->addCol('Name',$this->_T->lang($this->_BasePrj->getAvRules($ukey)),'','','',0,'2000');
					foreach ($this->_prjPermsShort['doc_fol'] as $pkey=>$pval) {
						$tabGui[$FormId]->addCol('Perms_'.$pkey,$pkey==$uval?'X':'','','','center',1);
					}
					$btn=new SubmitImgBtn('permDeleteR_x['.$FormId.']['.$ukey.']','img/'.APP_THEME.'/loeschen.gif');
					$tabGui[$FormId]->addCol('Delete',$btn);
					$process=true;
				}

				$perms_g=$AddOn[$FormId]['PermsGroup']?Framework::aclToArray($AddOn[$FormId]['PermsGroup']):array();
				foreach ($perms_g as $ukey=>$uval) {
					$hl=$hl?0:1;
					$tabGui[$FormId]->addRow($hl);
					$tabGui[$FormId]->addCol('Img','','gruppe.gif');
					$tabGui[$FormId]->addCol('Name',$this->_frm->getCachedGroupName($ukey),'','','',0,'2000');
					foreach ($this->_prjPermsShort['doc_fol'] as $pkey=>$pval) {
						$tabGui[$FormId]->addCol('Perms_'.$pkey,$pkey==$uval?'X':'','','','center',1);
					}
					$btn=new SubmitImgBtn('permDeleteG_x['.$FormId.']['.$ukey.']','img/'.APP_THEME.'/loeschen.gif');
					$tabGui[$FormId]->addCol('Delete',$btn);
					$process=true;
				}

				$perms_u=$AddOn[$FormId]['PermsUser']?Framework::aclToArray($AddOn[$FormId]['PermsUser']):array();
				foreach ($perms_u as $ukey=>$uval) {
					$hl=$hl?0:1;
					$tabGui[$FormId]->addRow($hl);
					$tabGui[$FormId]->addCol('Img','','user.gif');
					$tabGui[$FormId]->addCol('Name',$this->_frm->getCachedUserName($ukey),'','','',0,'2000');
					foreach ($this->_prjPermsShort['doc_fol'] as $pkey=>$pval) {
						$tabGui[$FormId]->addCol('Perms_'.$pkey,$pkey==$uval?'X':'','','','center',1);
					}
					$btn=new SubmitImgBtn('permDeleteU_x['.$FormId.']['.$ukey.']','img/'.APP_THEME.'/loeschen.gif');
					$tabGui[$FormId]->addCol('Delete',$btn);
					$process=true;
				}
				if ($process) $tplContent->addContent('form3_'.$FormId,$tabGui[$FormId],'FORM3');
			}
		}
		return $tplContent;
	}
	function &showEditProject() {
		require_once('lib/class_ApplicationTreeGui.php');
		$TreeGui=new ApplicationTreeGui();

		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ApplicationListGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs['meta']=$this->_T->lang('[[Metadaten]]');
		if (!$this->_Obj) {
			$Gui->setName($this->_T->lang('[[Neues Projekt anlegen]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(null,array('action'=>'b'))));
		} else {
			$Gui->setName($this->_T->lang('[[Projekt bearbeiten]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));

			$tabs['members']=$this->_T->lang('[[Mitglieder]]');
			if ($this->_ObjProfile->getAcl(128)) {
				if ($this->_BasePrf->isAvApp('tfol')) $tabs['ptasks']=$this->_T->lang('[[Rechte Aufgaben]]');
				if ($this->_BasePrf->isAvApp('kfol')) $tabs['pcal']=$this->_T->lang('[[Rechte Kalender]]');
				if ($this->_BasePrf->isAvApp('kfol')) $tabs['pcal_grant']=$this->_T->lang('[[Sichtbarkeit Kalender]]');
				if ($this->_BasePrf->isAvApp('tel_fol')) $tabs['pstel']=$this->_T->lang('[[Rechte Anrufjournal]]');
			}
			if ($this->_ObjProfile->getAcl(256)) {
				if ($this->_BasePrf->isAvApp('zfol') && $this->_Obj->getMeta('ZefFolder') && $this->_BasePrj->existsZefFolder($this->_Obj->getMeta('ZefFolder'))) {
					$tabs['zef_cat']=$this->_T->lang('[[Zeitjournal Taetigkeiten]]');
					$zef=$this->_frm->getStaticModul('zef');
					if ($zef->getCfg('cfg/modul/company')) {
						 $tabs['zef_comp']=$this->_T->lang('[[Zeitjournal Aufteilung]]');
					}
				}
			}
			$tabs['doc']=$this->_T->lang('[[Dokumentation]]');

		}
		$Gui->addFunction($btBreak);
		reset($tabs);
		$editShow=Framework::getParam('editShow','meta');
		if (!isset($tabs[$editShow])) $editShow=key($tabs);

		$navGui=new ApplicationListGui();
		foreach ($tabs as $key=>$val) {
			if ($editShow==$key) {
				$navGui->addRow(2,'top');
			} else {
				$navGui->addRow(0,'top');
			}
			$navGui->addCol('Name',$val,'obj_img/ex_tree.gif',$this->_L->getTempLink(null,array('editShow'=>$key)),'',0,'2000',0,'');
		}
		$TreeGui->addTreeContent($navGui);

		$box=new BoxGui($this->_mode.'|showtab');
		switch ($editShow) {
			case 'meta';
				$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
				$box->setTabContent('meta',$this->getProjectMetaGui());
			break;
			case 'members';
				$membersGui=$this->getMembersGui();
				if (!$membersGui->emptyContent()) {
					$box->addTab('members',$this->_T->lang('[[Mitglieder]]'),'#',true);
					$box->setTabContent('members',$membersGui);
				}
			break;
			case 'ptasks';
				$box->addTab('ptasks',$this->_T->lang('[[Rechte Aufgaben]]'),'#',true);
				$box->setTabContent('ptasks',$this->getProjPermsGui('task',1));
			break;
			case 'pstel';
				$box->addTab('pstel',$this->_T->lang('[[Rechte Anrufjournal]]'),'#',true);
				$box->setTabContent('pstel',$this->getProjPermsGui('stel',1));
			break;
			case 'pcal';
				$box->addTab('pcal',$this->_T->lang('[[Rechte Kalender]]'),'#',true);
				$box->setTabContent('pcal',$this->getProjPermsGui('cal',1));
			break;
			case 'pcal_grant';
				$box->addTab('pcal_grant',$this->_T->lang('[[Sichtbarkeit Kalender]]'),'#',true);
				$box->setTabContent('pcal_grant',$this->getProjPermsGui('cal_grant',2));
			break;
			case 'zef_comp';
				require_once('lib/zef/class_zefAdminGui.php');
				$zefAdminGui=new zefAdminGui();
				$result='';
				$box->addTab('zef_comp',$this->_T->lang('[[Zeitjournal Aufteilung]]'),'#',true);
				$box->setTabContent('zef_comp',$zefAdminGui->getCompanyCalcGui($result,$this->_Obj->getMeta('ZefFolder'),'prj'));
				if ($result=='ok') {
					$this->_L->goToLink();
				}
			break;
			case 'zef_cat';
				require_once('lib/zef/class_zefProjectGui.php');
				$zefPrjGui=new zefProjectGui();
				$box->addTab('zef_cat',$this->_T->lang('[[Zeitjournal Taetigkeiten]]'),'#',true);
				$box->setTabContent('zef_cat',$zefPrjGui->getProjCatGui($this->_Obj->getMeta('ZefFolder')));
			break;
			case 'doc';
				$box->addTab('doc',$this->_T->lang('[[Dokumentation]]'),'#',true);
				$box->setTabContent('doc',$this->getDocFormularGui(true));
			break;
		}
		$box->setTabOn($editShow);
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		$TreeGui->addContent($Gui);
		return $TreeGui;
	}
	function &showDeleteProject() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$Gui->setName($this->_T->lang('[[Projekt loeschen]]'));
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$tabs[]='delete';
		$Gui->addFunction($btBreak);
		$box=new BoxGui($this->_mode.'|showtab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('showtab'));
		if (in_array('delete',$tabs)) {
			$box->addTab('delete',$this->_T->lang('[[Projekt loeschen]]'),'#',true);
			$box->setTabContent('delete',$this->getProjectDeleteGui());
		}
		$show_tap=$this->getPrefs('showtab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getProjectMetaGui($options=array()) {
		$this->formData['meta']=array();
		$this->formData['changes']=array();
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/uform/class_UserFormShowGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		if ($this->_oid) $req_check=2; else $req_check=1;
		foreach ($this->_BasePrj->getObjFields('0') as $key=>$val) {
			switch ($val['Typ']) {
				case 'text':
				case 'area':
				case 'check':
				case 'select':
				case 'curr':
				case 'int':
					$formGui->addField($key,$val['Typ'],$this->_T->lang($val['Name']),$this->_Obj?$this->_Obj->getMeta($key):$val['Default'],'form_fields'.$val['fGroup']);
					if ($val['Required']&$req_check) $formGui->setRequired($key);
					if ($val['Callback']) $formGui->setCallback($key,array(&$this,$val['Callback']));
					if ($val['Attribs']) $formGui->setAttribs($key,$val['Attribs']);
					if ($val['Values']) $formGui->setValues($key,$this->$val['Values']());
				break;
			}
			if ($key=='FKProfileID') {
				if (!$this->_oid || $this->_BasePrj->isRuleUser()) {
					if (Framework::getParam('defProfileID',0,'G')) {
						$formGui->setDefault('FKProfileID',Framework::getParam('defProfileID',0,'G'));
					} elseif (isset($options['defaultMeta']) && $options['defaultMeta']['FKProfileID']) {
						$formGui->setDefault('FKProfileID',$options['defaultMeta']['FKProfileID']);
					}
					$prfID=$formGui->getFieldVal('FKProfileID',true);
					if (!$prfID) $prfID=key($this->_my_profiles);
					$this->_ObjProfile=$this->_BasePrf->getObj($prfID);
					if (!is_object($this->_ObjProfile)) {
						$this->_ObjProfile=new ObjProjPfol();
					}
					$this->_ObjProfile->setAcl($this->_BasePrf->getProfileACL($this->_ObjProfile));
					$formGui->setAttribs('FKProfileID',array('onchange'=>'document.daten.submit()'));
					$formGui->setDefault('FKProfileID',$prfID);
					if ($this->_oid) {
						/*$formGui->addField('recalcPerms','check',$this->_T->lang('[[Rechte neu setzen]]'),0,'form_fields1');
						$formGui->setNoMeta('recalcPerms');*/
					}
				} else {
					$formGui->setValues('FKProfileID',array($this->_ObjProfile->getID()=>$this->_ObjProfile->getName()));
					$formGui->setDisabled('FKProfileID');
				}
				$formGui->addField('OldFKProfileID','hidden','',$this->_ObjProfile->getID(),'form_fields1');
				$formGui->setNoMeta('OldFKProfileID');

				if (isset($options['editOwner'])) {
					$fKey='UserCreate';
					$mode='u';
					$params=base64_encode(serialize(array('MaxEntries'=>1)));
					$lb_params=array('Values'=>array());
					$lb_params['Values'][]=array(
						'Label'=>$this->_T->lang('[[prjOwner]]'),
						'LabelSep'=>'',
						'mode'=>$mode,
						'app'=>'proj',
						'params'=>$params,
						'FieldVal'=>'_USERS',
					);
					$lb_Invit=new FunctionButtons($fKey,'ajaxttiplabel',$lb_params);
					$formGui->addField($fKey,'ttip',$lb_Invit,'u_'.$this->_frm->getUser(),'form_fields1');
					$formGui->setParams($fKey,array('mode'=>$mode,'params'=>$params));
					$formGui->setNoMeta($fKey);
				}
			}
		}
		if ($formGui->getFieldVal('OldFKProfileID',1)!=$this->_ObjProfile->getID()) {
			$this->formData['changes']['FKProfileID']=1;
		}

		$trasArray=array();
		$numFormat=isset($options['ProjNumCode'])?$options['ProjNumCode']:$this->_BasePrj->getCfg('cfg/prjNumberFormat');
		if (!$formGui->getFieldVal('ProjNumTxt',1) || ($formGui->getFieldVal('OldFKProfileID',1)!=$this->_ObjProfile->getID() && strpos($numFormat,'{')!==false)) {
			$formGui->setDefault('ProjNumTxt',$this->_BasePrj->getNextProjectNumber($this->_ObjProfile,$trasArray,$numFormat));
			$formGui->clearFields('',array('ProjNumTxt','OldFKProfileID'));

			if (isset($options['defaultMeta'])) {
				foreach ($options['defaultMeta'] as $fkey=>$fval) {
					if ($formGui->fieldExists($fkey) && strpos($fval,'{')!==false) {
						$formGui->clearFields('',array($fkey));
					}
				}
			}
			//debug('SSS');
		}
	
		
		$key='Options';
		$formGui->addField($key,'label',$this->_T->lang('[[Optionen]]'),'','form_fields2');
		$formOptions=false;
		if ($this->_BasePrf->isAvApp('zfol')) {
			$key='ZefFolder';
			if (!$this->_oid || !$this->_BasePrj->existsZefFolder($this->_Obj->getMeta($key))) {
				if ($this->_ObjProfile->getAcl(256)) {
					$default=$this->_oid?0:1;
					if (isset($options['defaultMeta'][$key])) {
						$default=$options['defaultMeta'][$key];
					}
					$formGui->addField($key,'check',$this->_T->lang('[[Projekt in Zeiterfassung anlegen]]'),$default,'form_fields2');
					$formGui->setNoMeta($key);
					$formOptions=true;
				}
			} else {
				$formGui->addField($key,'check',$this->_T->lang('[[Projekt in Zeiterfassung ist angelegt]]'),1,'form_fields2');
				$formGui->setDisabled($key);
				$formOptions=true;
			}
		}
		if ($this->_BasePrf->isAvApp('mfol') && $this->_BasePrj->getCfg('cfg/ProjectMailBox')) {
			$key='MailFolder';
			if (!$this->_oid || !$this->_BasePrj->existsMailFolder($this->_Obj->getMeta($key))) {
				if ($this->_ObjProfile->getAcl(512)) {
					$default=$this->_oid?0:1;
					if (isset($options['defaultMeta'][$key])) {
						$default=$options['defaultMeta'][$key];
					}
					$formGui->addField($key,'check',$this->_T->lang('[[Mailverzeichnis anlegen]]'),$default,'form_fields2');
					$formGui->setNoMeta($key);
					$formOptions=true;
				}
			} else {
				$formGui->addField($key,'check',$this->_T->lang('[[Mailverzeichnis ist angelegt]]'),1,'form_fields2');
				$formGui->setDisabled($key);
				$formOptions=true;
			}
		}
		if ($this->_BasePrf->isAvApp('ffol') && $this->_BasePrj->getCfg('cfg/ProjectFmngBox')) {
			$key='FmngFolder';
			if (!$this->_oid || !$this->_BasePrj->existsFmngFolder($this->_Obj->getMeta($key))) {
				if ($this->_ObjProfile->getAcl(2048)) {
					$default=$this->_oid?0:1;
					if (isset($options['defaultMeta'][$key])) {
						$default=$options['defaultMeta'][$key];
					}
					$formGui->addField($key,'check',$this->_T->lang('[[Dateiverzeichnis anlegen]]').' (Virtual)',$default,'form_fields2');
					$formGui->setNoMeta($key);
					$formOptions=true;
				}
			} else {
				$formGui->addField($key,'check',$this->_T->lang('[[Dateiverzeichnis ist angelegt]]').' (Virtual)',1,'form_fields2');
				$formGui->setDisabled($key);
				$formOptions=true;
			}
		}
		if ($this->_BasePrf->isAvApp('sfol') && $this->_BasePrj->getCfg('cfg/ProjectSmbBox')) {
			$key='SmbFolder';
			if (!$this->_oid || !$this->_BasePrj->existsSmbFolder($this->_Obj->getMeta($key))) {
				if ($this->_ObjProfile->getAcl(1024)) {
					$default=$this->_oid?0:1;
					if (isset($options['defaultMeta'][$key])) {
						$default=$options['defaultMeta'][$key];
					}
					$formGui->addField($key,'check',$this->_T->lang('[[Dateiverzeichnis anlegen]]').' (Samba)',$default,'form_fields2');
					$formGui->setNoMeta($key);
					$formOptions=true;
				}
			} else {
				$formGui->addField($key,'check',$this->_T->lang('[[Dateiverzeichnis ist angelegt]]').' (Samba)',1,'form_fields2');
				$formGui->setDisabled($key);
				$formOptions=true;
			}
		}
		if (isset($options['defaultMeta'])) {
			$trasArray['{P_NUM}']=$formGui->getFieldVal('ProjNumTxt',1);
			$trasArray['{P_S}']=$this->_ObjProfile->getMeta('NameShort');
			foreach ($options['defaultMeta'] as $fkey=>$fval) {
				if ($formGui->fieldExists($fkey)) {
					$formGui->setDefault($fkey,strtr($fval,$trasArray));
				}
			}
		}


		$key='meta_save_x';
		$formGui->addField($key,'submit','',$this->_T->lang('[[Speichern]]'),'form_submit');

		$UserFormShowGui=new UserFormShowGui();
		$UserFormShowGui->setFormObj($this->_uFormData->getFormObj());
		if ($this->_Obj) {
			$UserFormShowGui->loadDefault($this->_Obj->getID());
		} elseif($options['defaultUform']) {
			$UserFormShowGui->setDefault($options['defaultUform']);
		}
		if($options['paramsUform']) {
			$UserFormShowGui->setParams($options['paramsUform']);
		}
		$UserFormShowGui->setStaticVisibility(array('FKProfileID'=>$this->_ObjProfile->getID()));

		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			$UserFormShowGui->checkFields();
			if (!$this->_E->isError()) {
				if (!is_object($this->_Obj)) $this->_Obj=new ObjProject();
				if ($this->_name_check_prj[$this->_Obj->getObjTyp()] && preg_match($this->_name_check_prj[$this->_Obj->getObjTyp()],$formGui->getFieldVal('Title'))) {
					$this->_E->setError('chars','Title');
				} elseif ($this->_BasePrj->nameExists($formGui->getFieldVal('Title'),$this->_oid?$this->_oid:0)) {
					$this->_E->setError('prjname_exists','Title');
				} elseif ($this->_BasePrj->numberExists($formGui->getFieldVal('ProjNumTxt'),$this->_oid?$this->_oid:0)) {
					$this->_E->setError('prjnum_exists','ProjNumTxt');
				} else {
					if ($this->_oid) {
						$oldName=$this->_Obj->getName();
						$oldAktiv=$this->_Obj->getMeta('Aktiv');
						$oldProfileID=$this->_Obj->getMeta('FKProfileID');
					}
					$formGui->addMetaToObj($this->_Obj);
					if ($this->_oid) {
						if ($oldName!=$this->_Obj->getName() || ($this->_BasePrj->getCfg('cfg/useProfilPath') && $oldProfileID!=$this->_Obj->getMeta('FKProfileID'))) {
							if ($this->_BasePrf->isAvApp('mfol') && $this->_BasePrj->getCfg('cfg/ProjectMailBox') && $this->_Obj->getMeta('MailFolder') && $this->_BasePrj->existsMailFolder($this->_Obj->getMeta('MailFolder'))) {
								$folder=$this->_BasePrj->renameMailFolder($this->_Obj);
								if ($folder) {
									$this->_Obj->setMeta('MailFolder',$folder);
								}
							}
							if ($this->_BasePrf->isAvApp('ffol') && $this->_BasePrj->getCfg('cfg/ProjectFmngBox') && $this->_Obj->getMeta('FmngFolder') && $this->_BasePrj->existsFmngFolder($this->_Obj->getMeta('FmngFolder'))) {
								$folder=$this->_BasePrj->renameFmngFolder($this->_Obj);
								if ($folder) {
									$this->_Obj->setMeta('FmngFolder',$folder);
								}
							}
							if ($this->_BasePrf->isAvApp('sfol') && $this->_BasePrj->getCfg('cfg/ProjectSmbBox') && $this->_Obj->getMeta('SmbFolder') && $this->_BasePrj->existsSmbFolder($this->_Obj->getMeta('SmbFolder'))) {
								$folder=$this->_BasePrj->renameSmbFolder($this->_Obj);
								if ($folder) {
									$this->_Obj->setMeta('SmbFolder',$folder);
								}
							}
							if ($this->_BasePrf->isAvApp('zfol') && $this->_Obj->getMeta('ZefFolder') && $this->_BasePrj->existsZefFolder($this->_Obj->getMeta('ZefFolder'))) {
								$folder=$this->_BasePrj->renameZefFolder($this->_Obj);
								if ($folder) {
									$this->_Obj->setMeta('ZefFolder',$folder);
								}
							}
						}
						if ($this->_BasePrf->isAvApp('zfol') && $this->_BasePrj->existsZefFolder($this->_Obj->getMeta('ZefFolder'))) {
							$this->_BasePrj->updateZefFolder($this->_Obj);
						}
						if ($formGui->fieldExists('UserCreate') && $formGui->getFieldVal('UserCreate',1)) {
							$this->_Obj->setMeta('UserCreate',substr($formGui->getFieldVal('UserCreate',1),2));
						}
						$this->_BasePrj->updateObj($this->_Obj);
					} else {
						if ($this->_BasePrj->insertMeta($this->_Obj)) {
							if ($formGui->fieldExists('UserCreate') && $formGui->getFieldVal('UserCreate',1)) {
								$this->_Obj->setMeta('UserCreate',substr($formGui->getFieldVal('UserCreate',1),2));
								$this->_BasePrj->updateObj($this->_Obj);
							}
							$this->_Obj=$this->_BasePrj->getObj($this->_Obj->getId());
							$this->_BasePrj->createProjectRules($this->_Obj);
							$prjRuleGroups=$this->_BasePrj->getRuleGroups($this->_Obj);

							//Cal Perms
							$profObj=$this->_BasePrf->getHeadObj($this->_Obj->getMeta('FKProfileID'),'kfol');
							$UPerms=Framework::aclToArray($profObj->getMeta('PermsUser'));
							$Gperms=Framework::aclToArray($profObj->getMeta('PermsGroup'));
							$Pperms=Framework::aclToArray($profObj->getMeta('PermsRules'));
							foreach ($Pperms as $key=>$val) $Gperms[$prjRuleGroups[$key]]=$val;
							$this->_BasePrj->saveProjectPerms($this->_Obj->getID(),'cal',array('PermsUser'=>Framework::arrayToAcl($UPerms),'PermsGroup'=>Framework::arrayToAcl($Gperms)));
							if ($profObj->getMeta('AddOn')) {
								$AddOn=unserialize($profObj->getMeta('AddOn'));
							} else {
								$AddOn=array();
							}
							$Ugrant=array();$Ggrant=array();
							if (is_array($AddOn['Visibility']['Users'])) $Ugrant=array_keys($AddOn['Visibility']['Users']);
							if (is_array($AddOn['Visibility']['Groups'])) $Ggrant=array_keys($AddOn['Visibility']['Groups']);
							if (is_array($AddOn['Visibility']['Rules'])) {
								foreach (array_keys($AddOn['Visibility']['Rules']) as $val) $Ggrant[]=$prjRuleGroups[$val];
							}
							$this->_BasePrj->saveProjectPerms($this->_Obj->getID(),'cal_grant',array('PermsUser'=>implode(',',$Ugrant),'PermsGroup'=>implode(',',$Ggrant)));

							//Task Perms
							$profObj=$this->_BasePrf->getHeadObj($this->_Obj->getMeta('FKProfileID'),'tfol');
							$UPerms=Framework::aclToArray($profObj->getMeta('PermsUser'));
							$Gperms=Framework::aclToArray($profObj->getMeta('PermsGroup'));
							$Pperms=Framework::aclToArray($profObj->getMeta('PermsRules'));
							foreach ($Pperms as $key=>$val) $Gperms[$prjRuleGroups[$key]]=$val;
							$this->_BasePrj->saveProjectPerms($this->_Obj->getID(),'task',array('PermsUser'=>Framework::arrayToAcl($UPerms),'PermsGroup'=>Framework::arrayToAcl($Gperms)));

							//Stel Perms
							$profObj=$this->_BasePrf->getHeadObj($this->_Obj->getMeta('FKProfileID'),'tel_fol');
							$UPerms=Framework::aclToArray($profObj->getMeta('PermsUser'));
							$Gperms=Framework::aclToArray($profObj->getMeta('PermsGroup'));
							$Pperms=Framework::aclToArray($profObj->getMeta('PermsRules'));
							foreach ($Pperms as $key=>$val) $Gperms[$prjRuleGroups[$key]]=$val;
							$this->_BasePrj->saveProjectPerms($this->_Obj->getID(),'stel',array('PermsUser'=>Framework::arrayToAcl($UPerms),'PermsGroup'=>Framework::arrayToAcl($Gperms)));


							//Doc Perms
							$profObj=$this->_BasePrf->getHeadObj($this->_Obj->getMeta('FKProfileID'),'doc_fol');
							if ($profObj->getMeta('AddOn')) {
								$AddOn=unserialize($profObj->getMeta('AddOn'));
							} else {
								$AddOn=array();
							}
							if (!empty($AddOn)) {
								require_once("lib/uform/class_UserFormData.php");
								$uFormData=new UserFormData();
								foreach ($AddOn as $formId=>$formPerms) {
									if ($uFormData->loadFormByID($formId)) {
										$UPerms=array();$Gperms=array();$Pperms=array();
										if ($formPerms['PermsUser']) $UPerms=Framework::aclToArray($formPerms['PermsUser']);
										if ($formPerms['PermsGroup']) $Gperms=Framework::aclToArray($formPerms['PermsGroup']);
										if ($formPerms['PermsRules']) $Pperms=Framework::aclToArray($formPerms['PermsRules']);
										foreach ($Pperms as $key=>$val) $Gperms[$prjRuleGroups[$key]]=$val;
										$this->_BasePrj->saveProjectPerms($this->_Obj->getID(),'doc',array('PermsUser'=>Framework::arrayToAcl($UPerms),'PermsGroup'=>Framework::arrayToAcl($Gperms)),$formId);
										$defData=$uFormData->getData($profObj->getID(),'prof');
										if (!empty($defData)) {
											$uFormData->updateData($this->_Obj->getID(),$defData);
										}
									}
								}
							}

						}
						$this->_L->setParam('oid',$this->_Obj->getId());
					}

					if ($this->_BasePrf->isAvApp('mfol') && $this->_BasePrj->getCfg('cfg/ProjectMailBox') && $formGui->fieldExists('MailFolder') && $formGui->getFieldVal('MailFolder') && !$this->_BasePrj->existsMailFolder($this->_Obj->getMeta('MailFolder'))) {
						$folder=$this->_BasePrj->createMailFolder($this->_Obj);
						//debug($folder);
						if ($folder) {
							$this->_Obj->setMeta('MailFolder',$folder);
							$this->_BasePrj->updateObj($this->_Obj);
						}
					}
					if ($this->_BasePrf->isAvApp('ffol') && $this->_BasePrj->getCfg('cfg/ProjectFmngBox') && $formGui->fieldExists('FmngFolder') && $formGui->getFieldVal('FmngFolder') && !$this->_BasePrj->existsFmngFolder($this->_Obj->getMeta('FmngFolder'))) {
						$folder=$this->_BasePrj->createFmngFolder($this->_Obj);
						if ($folder) {
							$this->_Obj->setMeta('FmngFolder',$folder);
							$this->_BasePrj->updateObj($this->_Obj);
						}
					}
					if ($this->_BasePrf->isAvApp('sfol') && $this->_BasePrj->getCfg('cfg/ProjectSmbBox') && $formGui->fieldExists('SmbFolder') && $formGui->getFieldVal('SmbFolder') && !$this->_BasePrj->existsSmbFolder($this->_Obj->getMeta('SmbFolder'))) {
						$folder=$this->_BasePrj->createSmbFolder($this->_Obj);
						if ($folder) {
							$this->_Obj->setMeta('SmbFolder',$folder);
							$this->_BasePrj->updateObj($this->_Obj);
						}
					}
					if ($this->_BasePrf->isAvApp('zfol') && $formGui->fieldExists('ZefFolder') && $formGui->getFieldVal('ZefFolder') && !$this->_BasePrj->existsZefFolder($this->_Obj->getMeta('ZefFolder'))) {
						$folder=$this->_BasePrj->createZefFolder($this->_Obj);
						if ($folder) {
							$this->_Obj->setMeta('ZefFolder',$folder);
							$this->_BasePrj->updateObj($this->_Obj);
						}
					}

					if (!$this->_oid) {
						//Add Members
						if (!$options['noMembers']) {
							if ($this->_ObjProfile->getMeta('AddOn')) {
								$AddOn=unserialize($this->_ObjProfile->getMeta('AddOn'));
							} else {
								$AddOn=array();
							}
							$ruleUsers=isset($AddOn['ruleUsers'])?$AddOn['ruleUsers']:array();
							$groupUsers=isset($AddOn['groupUsers'])?$AddOn['groupUsers']:array();
							$ruleUsersExtra=isset($AddOn['ruleUsersExtra'])?$AddOn['ruleUsersExtra']:array();
							if (!empty($ruleUsersExtra)) {
								foreach ($ruleUsersExtra as $rkey=>$rval) {
									if (is_array($rval) && !empty($rval)) {
										foreach (array_keys($rval) as $addID) {
											if ($addID==1) {
												$ruleUsers[$rkey][$this->_frm->getUser()]=1;
											}
										}
									}
								}
							}
							if (!empty($groupUsers)) {
								foreach ($groupUsers as $rkey=>$rval) {
									if (is_array($rval) && !empty($rval)) {
										$users=$this->_frm->getGroupUsers(array_keys($rval));
										if (is_array($users)) {
											foreach ($users as $addID) {
												$ruleUsers[$rkey][$addID]=1;
											}
										}
									}
								}
							}
							if (!empty($ruleUsers)) {
								if ($this->_Obj->getMeta('MailFolder') && $this->_BasePrj->existsMailFolder($this->_Obj->getMeta('MailFolder'))) {
									$updateMail=true;
									$Mail=& $this->_frm->getStaticModul('mail');
								} else {
									$updateMail=false;
								}
								foreach ($ruleUsers as $rkey=>$rval) {
									if (is_array($rval)) {
										$groupID=$this->_BasePrj->getRuleGroupID($this->_Obj,$rkey);
										foreach (array_keys($rval) as $addID) {
											$this->_frm->insertGroupUsers($groupID,array($addID),false);
											if ($updateMail) {
												$Mail->delteMailAbbo($addID,$this->_Obj->getMeta('MailFolder'));
												if (!$this->_frm->getPrefs($this->_BasePrj->getModul(),'defMailNoAutoAbbo',$addID)) {
													$Mail->insertMailAbbo($addID,$this->_Obj->getMeta('MailFolder'));
												}
											}
										}
									}
								}
							}
						}
					}
					/* Extra Data*/

					$CrmValues=$UserFormShowGui->getDbValues('prj_'.$this->_Obj->getID());
					$UserFormShowGui->updateData($this->_Obj->getID(),$CrmValues);
					foreach($this->_uFormData->getFormFieldsByTyp('fk_addr') as $id) {
					    $Addr=& $this->_frm->getStaticModul('addr');
					    if (isset($CrmValues['F_'.$id]) && trim($CrmValues['F_'.$id])) {
							foreach(explode('|',$CrmValues['F_'.$id]) as $v) {
								//debug(substr($v,2));
								$Addr->addProjectsAddr($this->_Obj->getID(),array(substr($v,2)));
							}
							
						} 
					}
					

					if (!$this->_E->isError()) {
						Framework::deleteFilesRecursive($UserFormShowGui->getTempFilePath(),'/.*/');
						if (!$options['noGoTo']) {
							$this->_L->goToLink();
						}
					}
				}
			}
		}
		$formGui->addMetaToArray($this->formData['meta'],'',true);

		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		if ($formOptions) $tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3_1',$UserFormShowGui,'FORM3',array());
		$tplContent->addContent('form3_2',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}
	function &getProjectDeleteGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		$tplContent=new TemplateGui('proj/form_delete_project.inc.html');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		if ($this->_oid) $req_check=2; else $req_check=1;

		$key='PrjFolder';
		if ($this->_Obj->getMeta('Deleted')) {
			$formGui->addField($key,'check',$this->_T->lang('[[prjPrjDeleteFinal]]'),0,'form_fields1');
			$formGui->setAttribs($key,array('onchange'=>'checkDelFields(this)'));
		} else {
			$formGui->addField($key,'check',$this->_T->lang('[[prjPrjDelete]]'),0,'form_fields1');
		}
		$formGui->setNoMeta($key);

		$key='prjDelAll';
		$formGui->addField($key,'hidden','',0,'form_fields1');

		$ExtraEntries=array();
		if ($this->_BasePrf->isAvApp('kfol')) {
			$Cal=& $this->_frm->getStaticModul('cal');
			if ($Cal->hasProjectEntrys($this->_Obj->getID())) {
				$ExtraEntries['kfol']=1;
				$key='CalFolder';
				$formGui->addField($key,'check',$this->_T->lang('[[prjCalDelete]]'),0,'form_fields1');
				$formGui->setNoMeta($key);
			}
		}
		if ($this->_BasePrf->isAvApp('tfol')) {
			$Task=& $this->_frm->getStaticModul('task');
			if ($Task->hasProjectEntrys($this->_Obj->getID())) {
				$ExtraEntries['tfol']=1;
				$key='TaskFolder';
				$formGui->addField($key,'check',$this->_T->lang('[[prjTaskDelete]]'),0,'form_fields1');
				$formGui->setNoMeta($key);
			}
		}
		if ($this->_BasePrf->isAvApp('afol')) {
			$Addr=& $this->_frm->getStaticModul('addr');
			if ($Addr->hasProjectEntrys($this->_Obj->getID())) {
				$ExtraEntries['afol']=1;
				$key='AddrFolder';
				$formGui->addField($key,'check',$this->_T->lang('[[prjAddrDelete]]'),0,'form_fields1');
				$formGui->setNoMeta($key);
			}
		}
		if ($this->_BasePrf->isAvApp('zfol')) {
			$key='ZefFolder';
			if ($this->_BasePrj->existsZefFolder($this->_Obj->getMeta($key))) {
				$formGui->addField($key,'check',$this->_T->lang('[[prjZefDelete]]'),0,'form_fields1');
				$formGui->setNoMeta($key);
				$ExtraEntries['zfol']=1;
			}
		}
		if ($this->_BasePrf->isAvApp('mfol')) {
			$key='MailFolder';
			if ($this->_BasePrj->existsMailFolder($this->_Obj->getMeta($key))) {
				$formGui->addField($key,'check',$this->_T->lang('[[prjMailDelete]]'),0,'form_fields1');
				$formGui->setNoMeta($key);
				$ExtraEntries['mfol']=1;
			}
		}
		if ($this->_BasePrf->isAvApp('ffol')) {
			$key='FmngFolder';
			if ($this->_BasePrj->existsFmngFolder($this->_Obj->getMeta($key))) {
				$formGui->addField($key,'check',$this->_T->lang('[[prjFmngDelete]]'),0,'form_fields1');
				$formGui->setNoMeta($key);
				$ExtraEntries['ffol']=1;
			}
		}
		if ($this->_BasePrf->isAvApp('sfol')) {
			$key='SmbFolder';
			if ($this->_BasePrj->existsSmbFolder($this->_Obj->getMeta($key))) {
				$formGui->addField($key,'check',$this->_T->lang('[[prjSmbDelete]]'),0,'form_fields1');
				$formGui->setNoMeta($key);
				$ExtraEntries['sfol']=1;
			}
		}
		if ($this->_BasePrf->isAvApp('tel_fol')) {
			$Stel=& $this->_frm->getStaticModul('stel');
			if ($Stel->hasProjectEntrys($this->_Obj->getID())) {
				$ExtraEntries['tel_fol']=1;
				$key='StelFolder';
				$formGui->addField($key,'check',$this->_T->lang('[[prjStelDelete]]'),0,'form_fields1');
				$formGui->setNoMeta($key);
			}
		}



		$key='meta_delete_x';
		$formGui->addField($key,'submit','',$this->_T->lang('[[Loeschen]]'),'form_fields1');

		if (Framework::getParam('meta_delete_x','0','P')) {
			if ($this->_BasePrf->isAvApp('mfol') && $ExtraEntries['mfol'] && ($formGui->getFieldVal('MailFolder') || $formGui->getFieldVal('prjDelAll'))) {
				if ($this->_BasePrj->deleteMailFolder($this->_Obj)) {
					$this->_Obj->setMeta('MailFolder','');
					$this->_BasePrj->updateObj($this->_Obj);
					unset($ExtraEntries['mfol']);
				}
			}
			if ($this->_BasePrf->isAvApp('ffol') && $ExtraEntries['ffol'] && ($formGui->getFieldVal('FmngFolder') || $formGui->getFieldVal('prjDelAll'))) {
				if ($this->_BasePrj->deleteFmngFolder($this->_Obj)) {
					$this->_Obj->setMeta('FmngFolder','');
					$this->_BasePrj->updateObj($this->_Obj);
					unset($ExtraEntries['ffol']);
				}
			}
			if ($this->_BasePrf->isAvApp('sfol') && $ExtraEntries['sfol'] && ($formGui->getFieldVal('SmbFolder') || $formGui->getFieldVal('prjDelAll'))) {
				if ($this->_BasePrj->deleteSmbFolder($this->_Obj)) {
					$this->_Obj->setMeta('SmbFolder','');
					$this->_BasePrj->updateObj($this->_Obj);
					unset($ExtraEntries['sfol']);
				}
			}
			if ($this->_BasePrf->isAvApp('zfol') && $ExtraEntries['zfol'] && ($formGui->getFieldVal('ZefFolder') || $formGui->getFieldVal('prjDelAll'))) {
				if ($this->_BasePrj->deleteZefFolder($this->_Obj)) {
					$this->_Obj->setMeta('ZefFolder','');
					$this->_BasePrj->updateObj($this->_Obj);
					unset($ExtraEntries['zfol']);
				}
			}
			if ($this->_BasePrf->isAvApp('kfol') && $ExtraEntries['kfol'] && ($formGui->getFieldVal('CalFolder') || $formGui->getFieldVal('prjDelAll'))) {
				$Cal=& $this->_frm->getStaticModul('cal');
				$Cal->deleteProject($this->_Obj->getID());
				unset($ExtraEntries['kfol']);
			}
			if ($this->_BasePrf->isAvApp('tfol') && $ExtraEntries['tfol'] && ($formGui->getFieldVal('TaskFolder') || $formGui->getFieldVal('prjDelAll'))) {
				$Task=& $this->_frm->getStaticModul('task');
				$Task->deleteProject($this->_Obj->getID());
				unset($ExtraEntries['tfol']);
			}
			if ($this->_BasePrf->isAvApp('tel_fol') && $ExtraEntries['tel_fol'] && ($formGui->getFieldVal('StelFolder') || $formGui->getFieldVal('prjDelAll'))) {
				$Stel=& $this->_frm->getStaticModul('stel');
				$Stel->deleteProject($this->_Obj->getID());
				unset($ExtraEntries['tel_fol']);
			}
			if ($this->_BasePrf->isAvApp('afol') && $ExtraEntries['afol'] && ($formGui->getFieldVal('AddrFolder') || $formGui->getFieldVal('prjDelAll'))) {
				$Addr=& $this->_frm->getStaticModul('addr');
				$Addr->deleteProject($this->_Obj->getID());
				unset($ExtraEntries['afol']);
			}
			if ($formGui->getFieldVal('PrjFolder')) {
				$this->_Obj->setMeta('Deleted',1);
				$this->_Obj->setMeta('Aktiv',0);
				$this->_BasePrj->updateObj($this->_Obj);
				if (empty($ExtraEntries)) {
					$PrjGroups=$this->_BasePrj->getRuleGroups($this->_Obj);
					if (!empty($PrjGroups)) {
						foreach ($PrjGroups as $gid) {
							//debug($gid);
							$this->_frm->deleteGroupieGroup($gid);
						}
						$this->_uFormData->deleteData($this->_Obj->getID());
						$this->_BasePrj->deleteMeta($this->_Obj);
					}
				}
			}
			$this->_L->setParam('action','b');
			$this->_L->unsetParam('oid');
			$this->_L->goToLink();
		}

		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}
	function &getMembersGui() {
		require_once('lib/class_TemplateGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		//$perms_r=Framework::aclToArray($this->_Obj->getMeta('PermsRules'));
		//$perms_g=Framework::aclToArray($this->_Obj->getMeta('PermsGroup'));
		//$perms_u=Framework::aclToArray($this->_Obj->getMeta('PermsUser'));
		$avRules=$this->_BasePrj->getAvRules();
		if (!$this->_ObjProfile->getAcl(16)) unset($avRules[1]);
		if (!$this->_ObjProfile->getAcl(32)) unset($avRules[2]);
		if (!$this->_ObjProfile->getAcl(64)) unset($avRules[3]);
		if (!empty($avRules)) {
			end($avRules);
			$defRule=key($avRules);
			if ($this->_Obj) {
				foreach ($avRules as $rkey=>$rval) {
					$groupID=$this->_BasePrj->getRuleGroupID($this->_Obj,$rkey);
					$users=$this->_frm->getGroupUsers($groupID);
					if (!empty($users)) {
						foreach ($users as $val) {
							$ruleUsers[$val][$rkey]=$rkey;
						}
					}
				}
			}

			require_once('lib/class_FormGui.php');
			$formGui=new FormGui();
			$key='addPermsUser';
			$mode='u|g';
			$params='';
			$lb_params=array('Values'=>array());
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
				'LabelSep'=>'',
				'mode'=>$mode,
				'app'=>'proj',
				'params'=>$params,
				'FieldVal'=>'_USERS',
			);
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Gruppen]]'),
				'LabelSep'=>' / ',
				'mode'=>$mode,
				'app'=>'proj',
				'params'=>$params,
				'FieldVal'=>'_GROUPS',
			);
			$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
			$formGui->addField($key,'ttip',$lb_Invit,'','fields1');
			$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));

			$formGui->addField('addRuleID','radiolist_v',$this->_T->lang('[[Hinzufuegen als]]'),$defRule,'fields2');
			$formGui->setValues('addRuleID',$this->_T->langArray($avRules));

			$formGui->addField('perms_add','submit','',$this->_T->lang('[[Hinzufuegen]]'),'fields3');


			if (Framework::getParam('perms_add',0,'P') && Framework::getParam('addRuleID',0,'P') && trim($formGui->getFieldVal('addPermsUser'))) {
				$groupID=$this->_BasePrj->getRuleGroupID($this->_Obj,Framework::getParam('addRuleID',0,'P'));
				$permsUsers=explode('|',$formGui->getFieldVal('addPermsUser'));
				foreach ($permsUsers as $val) {
					$tmp=explode('_',$val);
					if ($tmp[0]=='u') {
						$this->_frm->insertGroupUsers($groupID,array($tmp[1]),false);
						if ($this->_Obj->getMeta('MailFolder') && $this->_BasePrj->existsMailFolder($this->_Obj->getMeta('MailFolder'))) {
							$Mail=& $this->_frm->getStaticModul('mail');
							$Mail->delteMailAbbo($tmp[1],$this->_Obj->getMeta('MailFolder'));
							if (!$this->_frm->getPrefs($this->_BasePrj->getModul(),'defMailNoAutoAbbo',$tmp[1])) {
								$Mail->insertMailAbbo($tmp[1],$this->_Obj->getMeta('MailFolder'));
							}
						}
					}
					if ($tmp[0]=='g') {
						$users=$this->_frm->getGroupUsers($tmp[1]);
						if (!empty($users)) {
							$this->_frm->insertGroupUsers($groupID,$users,false);
							if ($this->_Obj->getMeta('MailFolder') && $this->_BasePrj->existsMailFolder($this->_Obj->getMeta('MailFolder'))) {
								$Mail=& $this->_frm->getStaticModul('mail');
								foreach ($users as $val) {
									$Mail->delteMailAbbo($val,$this->_Obj->getMeta('MailFolder'));
									if (!$this->_frm->getPrefs($this->_BasePrj->getModul(),'defMailNoAutoAbbo',$val)) {
										$Mail->insertMailAbbo($val,$this->_Obj->getMeta('MailFolder'));
									}
								}
							}
						}
					}
				}
				$formGui->clearFields('fields1');
			}

			foreach ($avRules as $rkey=>$rval) {
				$tmpArray=Framework::getParam('permDelete'.$rkey.'_u_x',0,'P');
				if(is_array($tmpArray)) {
					$groupID=$this->_BasePrj->getRuleGroupID($this->_Obj,$rkey);
					$ukey=key($tmpArray);
					if ($groupID && $ukey) {
						$this->_frm->deleteUserGroups($ukey,$groupID,false,false);
						unset($ruleUsers[$ukey][$rkey]);
						if (empty($ruleUsers[$ukey]) && $this->_Obj->getMeta('MailFolder') && $this->_BasePrj->existsMailFolder($this->_Obj->getMeta('MailFolder'))) {
							$Mail=& $this->_frm->getStaticModul('mail');
							$Mail->delteMailAbbo($ukey,$this->_Obj->getMeta('MailFolder'));
							$Mail->insertMailAbbo($ukey,$this->_Obj->getMeta('MailFolder'),'un_abbo');
						}
					}
				}
			}
			$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
			$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
			$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		}
		foreach ($this->_BasePrj->getAvRules() as $key=>$val) {
			$groupID=$this->_BasePrj->getRuleGroupID($this->_Obj,$key);
			$gusers=$this->_frm->getGroupUsers($groupID);
			if (is_array($gusers) && !empty($gusers)) {
				$users=$this->_frm->getFullName($gusers,0,1);
			} else {
				$users=array();
			}
			$listGui[$key]=$this->listProjectMembers($key,$users,null,null,isset($avRules[$key]));
			if ($listGui[$key]) {
				$tplContent->addContent('form3_'.$key,$listGui[$key],'FORM3');
			}
		}
		return $tplContent;
	}
	function &listProjectMembers($rule,$users,$groups,$extra=null,$editable=true,$btSub='') {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormGui.php');
		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$title=$this->_T->lang($this->_BasePrj->getAvRules($rule));
		$tabGui->addHeaderCol('Name',$title,'','','',0,0,2);
		if ($editable) $tabGui->addHeaderCol('Delete','','tras.gif');
		$tabGui->setLimit(0);
		$rows=0;$hl=0;
		$content=false;
		if (is_array($groups) && !empty($groups)) {
			$img='gruppe.gif';
			$dbtn='permDelete'.$btSub.$rule.'_g_x';
			foreach ($groups as $key=>$val) {
				$hl=$hl?0:1;
				$tabGui->addRow($hl);
				$tabGui->addCol('IMG','',$img);
				$tabGui->addCol('Name',$val,'','','',0,'2000');
				if ($editable) {
					$btn=new SubmitImgBtn ($dbtn.'['.$key.']','img/'.APP_THEME.'/loeschen.gif');
					$btn->setAttribs(array('onclick'=>'return lo_form();'));
					$tabGui->addCol('Delete',$btn);
				}
			}
			$content=true;
		}
		if (is_array($users) && !empty($users)) {
			$img='user.gif';
			$dbtn='permDelete'.$btSub.$rule.'_u_x';
			foreach ($users as $key=>$val) {
				$hl=$hl?0:1;
				$tabGui->addRow($hl);
				$tabGui->addCol('IMG','',$img);
				$tabGui->addCol('Name',$val,'','','',0,'2000');
				if ($editable) {
					$btn=new SubmitImgBtn ($dbtn.'['.$key.']','img/'.APP_THEME.'/loeschen.gif');
					$btn->setAttribs(array('onclick'=>'return lo_form();'));
					$tabGui->addCol('Delete',$btn);
				}
			}
			$content=true;
		}
		if (is_array($extra) && !empty($extra)) {
			$img='rolle.gif';
			$dbtn='permDelete'.$btSub.$rule.'_e_x';
			foreach ($extra as $key=>$val) {
				$hl=$hl?0:1;
				$tabGui->addRow($hl);
				$tabGui->addCol('IMG','',$img);
				$tabGui->addCol('Name',$val,'','','',0,'2000');
				if ($editable) {
					$btn=new SubmitImgBtn ($dbtn.'['.$key.']','img/'.APP_THEME.'/loeschen.gif');
					$btn->setAttribs(array('onclick'=>'return lo_form();'));
					$tabGui->addCol('Delete',$btn);
				}
			}
			$content=true;
		}
		if ($content) {
			return $tabGui;
		} else {
			return false;
		}
	}
	function &addProjectListConfigGui(&$Gui,&$config) {
		require_once('lib/proj/class_ProjectSearchConfigGui.php');
		$sGui=new ProjectSearchConfigGui();
		$Gui->addTreeContent($sGui->getSearchList($this->_searchPrj,$config));
		$Gui->addTreeContent($this->getProfileList($this->_searchPrj['FKProfileID']));
	}
	function &getProfileList($selID=0) {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		//$tabGui->setName($this->_T->lang('[[Profil]]'));
		$profiles=$this->_BasePrf->listProfiles(true);
		foreach ($profiles as $val) {
			if ($val->getID()==$selID) {
				$hl=2;
			} else {
				$hl=0;
			}
			$tabGui->addRow($hl);
			$tabGui->addCol('IMG','','obj_img/ex_tree.gif');
			$tabGui->addCol('Name',$val->getName(),'',$this->_L->getTempLink(array('b'),array('_searchPrfID'=>$val->getID())),'',0,'2000');
		}
		return $tabGui;
	}
	function &showProjectList(&$search= null) {
		if ($search) $this->_searchPrj=&$search;
		require_once('lib/class_ApplicationTreeGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');
		$TreeGui=new ApplicationTreeGui();
		$config=array();
		$this->addProjectListConfigGui($TreeGui,$config);
		$this->_frm->savePostData('proj','tmpSearchAdminProj',null,$this->_searchPrj);
		//$TreeGui->addTreeContent($this->getProfileList($search['FKProfileID']));
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);

		require_once('lib/class_ApplicationListGui.php');
		if (Framework::getParam('_OrderF',0,'G')) {
			$this->setPrefs('prjOrderF',Framework::getParam('_OrderF',0,'G'));
			$this->setPrefs('prjOrderD',Framework::getParam('_OrderD',0,'G'));
		}
		$orderF=$this->getPrefs('prjOrderF','Aktiv');
		$orderD=$this->getPrefs('prjOrderD',-1);
		$sqlOrder=$orderF." ".($orderD==-1?'DESC':'ASC');
		if ($orderF!='Title') $sqlOrder.=",Title ASC";
		$L=Framework::cloneObj($this->_L);
		$L->setParam('_loadSearch',1);

		$rows=0;
		$limit=50;
		$b=Framework::getParam('b',0,'G');

		
		$entries=$this->_BasePrj->listAllPrj($rows,$search,$b,$limit,$sqlOrder);
		$Gui=new ApplicationListGui();
		$Gui->setNavLink($L);
		$Gui->setOrderLink($L);
		$Gui->setActOrder($orderF,$orderD);
		$Gui->setLimit($limit);
		$Gui->setSumRows($rows);
		$Gui->setBegin($b);
		$Gui->setAutoBg(APP_FG10COLOR);


		$funcAction=new FunctionObjActionGui('list_action',1);
		//$funcAction->setName($this->_T->lang('[[Ausgewaehlte Projekte]]'));
		$list_action=$this->_frm->getObjAction($this->_BasePrj->getModul(),'adm_l');
		$parseFunction=false;
		if ($this->_BasePrj->isRuleUser()) {
			$funcAction->addValue('medit',$this->_T->lang('[[Ausgewaehlte Projekte bearbeiten]]'));
			$funcAction->addValue('medit_aktiv',$this->_T->lang('[[Aktive Projekte bearbeiten]]'));
			$funcAction->addValue('medit_all',$this->_T->lang('[[Alle Projekte bearbeiten]]'));
			$parseFunction=true;
		}
		if ($parseFunction) {
			$Gui->addFunction($funcAction);

			$funcSelAll=new FunctionButtons('addr_list','selectall',array('ListID'=>'ListID[]','ListOn'=>false));
			$Gui->addHeaderCol('ListID',$funcSelAll,'','','',1,'1%',0,'');
			$Gui->setTrOver('trBOC({ROW},this);');
			$Gui->setTrDown('trBOI({ROW},this,1);');
			$Gui->setID('prjTab');
			$this->_frm->addOnLoad("disableSelection(document.getElementById('prjTab'));");

			$btnList=new CheckBoxBtn ('ListID[]','');
			$btnList->setAttribs(array(
				'onclick'=>'return false;',
			));
		}


		$Gui->addHeaderCol('ProjNumTxt',$this->_T->lang('[[ProjektnummerSmall]]'),'','','',1);
		$Gui->setHeaderOrder('ProjNumTxt','ProjNumTxt',1);
		$Gui->addHeaderCol('Title',$this->_T->lang('[[Name]]'),'','','',0,2000);
		$Gui->setHeaderOrder('Title','Title',1);
		$Gui->addHeaderCol('Aktiv',$this->_T->lang('[[Aktiv]]'),'','','',1);
		$Gui->setHeaderOrder('Aktiv','Aktiv',-1);
		$Gui->addHeaderCol('TimeCreate',$this->_T->lang('[[Erstellt am]]'),'','','',1);
		$Gui->setHeaderOrder('TimeCreate','TimeCreate',-1);
		$Gui->addHeaderCol('UserCreate',$this->_T->lang('[[Erstellt von]]'),'','','',1);
		$Gui->setHeaderOrder('UserCreate','UserCreate',1);


		foreach ($entries as $key=>$val) {
			$Gui->addRow($val->getID()==$this->_oid?2:($hl?$hl=0:$hl=1));
			if ($parseFunction) {
				$Gui->addCol('ListID',$btnList->process($val->getID()),'','','',1,'1%',0,'',$noEnc);
			}
			$Gui->addCol('ProjNumTxt',$val->getMeta('ProjNumTxt'),'',$this->_L->getTempLink(null,array('oid'=>$val->getID(),'action'=>'n')));
			$Gui->addCol('Title',$val->getName(),'',$this->_L->getTempLink(null,array('oid'=>$val->getID(),'action'=>'n')));
			$Gui->addCol('Aktiv',$val->getMeta('Aktiv')?'X':'-','','','',1);
			$Gui->addCol('TimeCreate',date('d.m.Y',$val->getMeta('TimeCreate')),'','','',1);
			$Gui->addCol('UserCreate',$this->_frm->getCachedUserName($val->getMeta('UserCreate')),'','','',1);
		}
		$TreeGui->addContent($Gui);
		return $TreeGui;
	}
	function &getProjPermsGui($Modul,$perm_mode=0) {
		switch ($Modul) {
			case 'task':
				$objTyp='tfol';
			break;
			case 'stel':
				$objTyp='tel_fol';
			break;
			case 'cal':
				$objTyp='kfol';
			break;
			case 'cal_grant':
				$objTyp='calview';
			break;

		}
		$ObjPerms=$this->_BasePrj->getProjectPerms($this->_Obj->getID(),$Modul);
		if ($perm_mode!=2) {
			$perms_g=Framework::aclToArray($ObjPerms['PermsGroup']);
			$perms_u=Framework::aclToArray($ObjPerms['PermsUser']);
		} else {
			$temp_perms_g=$ObjPerms['PermsGroup']?explode(',',$ObjPerms['PermsGroup']):array();
			$temp_perms_u=$ObjPerms['PermsUser']?explode(',',$ObjPerms['PermsUser']):array();
			$perms_g=array();$perms_u=array();
			foreach ($temp_perms_g as $val) $perms_g[$val]=1;
			foreach ($temp_perms_u as $val) $perms_u[$val]=1;
		}
		$update=false;
		if (Framework::getParam($Modul.'_perms_add',0,'P') && Framework::getParam($Modul.'_addPermsID',0,'P')) {
			if (Framework::getParam($Modul.'_addFKGroupID',0,'P')) {
				if ($perm_mode==2) {
					$perms_g[Framework::getParam($Modul.'_addFKGroupID',0,'P')]=1;
					$ObjPerms['PermsGroup']=implode(',',array_keys($perms_g));
				} elseif ($perm_mode) {
					$perms_g[Framework::getParam($Modul.'_addFKGroupID',0,'P')]=array_sum(Framework::getParam($Modul.'_addPermsID',0,'P'));
					$ObjPerms['PermsGroup']=Framework::arrayToAcl($perms_g);
				} else {
					$perms_g[Framework::getParam($Modul.'_addFKGroupID',0,'P')]=Framework::getParam($Modul.'_addPermsID',0,'P');
					$ObjPerms['PermsGroup']=Framework::arrayToAcl($perms_g);
				}
				$update=true;
			}
			if (Framework::getParam($Modul.'_addFKUserID',0,'P')) {
				if ($perm_mode==2) {
					$perms_u[Framework::getParam($Modul.'_addFKUserID',0,'P')]=1;
					$ObjPerms['PermsUser']=implode(',',array_keys($perms_u));
				} elseif ($perm_mode) {
					$perms_u[Framework::getParam($Modul.'_addFKUserID',0,'P')]=array_sum(Framework::getParam($Modul.'_addPermsID',0,'P'));
					$ObjPerms['PermsUser']=Framework::arrayToAcl($perms_u);
				} else {
					$perms_u[Framework::getParam($Modul.'_addFKUserID',0,'P')]=Framework::getParam($Modul.'_addPermsID',0,'P');
					$ObjPerms['PermsUser']=Framework::arrayToAcl($perms_u);
				}
				$update=true;
			}
		}
		if(is_array(Framework::getParam($Modul.'_permDeleteG_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam($Modul.'_permDeleteG_x',0,'P'));
			if ($key) {
				unset($perms_g[$key]);
				if ($perm_mode==2) {
					$ObjPerms['PermsGroup']=trim(implode(',',array_keys($perms_g)));
				} else {
					$ObjPerms['PermsGroup']=Framework::arrayToAcl($perms_g);
				}
				$update=true;
			}
		}
		if(is_array(Framework::getParam($Modul.'_permDeleteU_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam($Modul.'_permDeleteU_x',0,'P'));
			if ($key) {
				unset($perms_u[$key]);
				if ($perm_mode==2) {
					$ObjPerms['PermsUser']=trim(implode(',',array_keys($perms_u)));
				} else {
					$ObjPerms['PermsUser']=Framework::arrayToAcl($perms_u);
				}
				$update=true;
			}
		}
		//debug($ObjPerms);
		if ($update) {
			$this->_BasePrj->saveProjectPerms($this->_Obj->getID(),$Modul,$ObjPerms);
			$this->_L->goToLink();
		}

		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		$formGui->addField($Modul.'_addFKGroupID','select',$this->_T->lang('[[Gruppen]]'),'','fields1');
		$formGui->setValues($Modul.'_addFKGroupID',array(0=>'-') + $this->_frm->getAllGroups(0,$this->_Obj->getID()));
		$formGui->addField($Modul.'_addFKUserID','select',$this->_T->lang('[[BenutzerInnen]]'),'','fields1');
		$formGui->setValues($Modul.'_addFKUserID',array(0=>'-') + $this->_frm->getFullName());

		//$formGui->addField('FKUserID','ttip',$this->_T->lang('[[BenutzerInnen]]'),'u_16|u_1','fields1');
		//$formGui->setParams('FKUserID',array('mode'=>'u|g'));

		if ($perm_mode==2) {
			$formGui->addField($Modul.'_addPermsID','hidden','',1,'fields2');
		} elseif ($perm_mode) {
			$formGui->addField($Modul.'_addPermsID','checklist_v',$this->_T->lang('[[Rechte]]'),1,'fields2');
			$formGui->setValues($Modul.'_addPermsID',$this->_prjPerms[$objTyp]);
		} else {
			$formGui->addField($Modul.'_addPermsID','radiolist_v',$this->_T->lang('[[Rechte]]'),1,'fields2');
			$formGui->setValues($Modul.'_addPermsID',$this->_prjPerms[$objTyp]);
		}

		$formGui->addField($Modul.'_perms_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields3');

		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		//$tplContent->addContent('form2',$box,'CONTENT');
		//$tplContent->addContent('form3_1',$this->listPerms('PermsRules',$perms_r,$this->_prjPerms[$objTyp],$perm_mode,$Modul.'_perm'),'FORM3');
		$tplContent->addContent('form3_2',$this->listPerms('PermsGroup',$perms_g,$this->_prjPermsShort[$objTyp],$perm_mode,$Modul.'_perm'),'FORM3');
		$tplContent->addContent('form3_3',$this->listPerms('PermsUser',$perms_u,$this->_prjPermsShort[$objTyp],$perm_mode,$Modul.'_perm'),'FORM3');
		return $tplContent;
	}
	function &getDocFormularGuiDefault() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/uform/class_UserFormShowGui.php');

		$BaseForm=& $this->_frm->getStaticModul('uform');
		$BaseForm->setFormModul('proj');
		$avForms=$BaseForm->listModulForms();

		if ($this->_Obj->getMeta('AddOn')) {
			$AddOn=unserialize($this->_Obj->getMeta('AddOn'));
		} else {
			$AddOn=array();
		}
		$formArray=array();
		foreach ($AddOn as $FormId=>$Perms) {
			if (is_object($avForms[$FormId])) {
				$formArray[$FormId]=$avForms[$FormId]->getName();
			}
		}


		$formGui=new FormGui();
		$formGui->addField('defFormular','select',$this->_T->lang('[[Formular]]'),key($formArray),'fields1');
		$formGui->setValues('defFormular',$formArray);
		$formGui->setAttribs('defFormular',array('onchange'=>'document.daten.submit();'));

		$formGui->addField('uform_save_x','submit','',$this->_T->lang('[[Speichern]]'),'fields3');

		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));

		$aktFormularID=$formGui->getFieldVal('defFormular',1);
		if (is_object($avForms[$aktFormularID])) {
			$fGui=new UserFormShowGui();
			$fGui->setFormObj($avForms[$aktFormularID]);
			$fGui->loadDefault($this->_Obj->getID(),'prof');
			//debug($this->_Obj->getID());
			$fGui->setStaticVisibility(array('FKProfileID'=>$this->_RootObj->getID()));
			if (Framework::getParam('uform_save_x',0)) {
				//$fGui->checkFields();
				if (!$this->_E->isError()) {
					$Values=$fGui->getDbValues('uf_'.$aktFormularID.'_prof_'.$this->_Obj->getID());
					//debug($Values);
					$Values['FKModul']='prof';
					$fGui->updateData($this->_Obj->getID(),$Values);
				}
			}

			$tplContent->addContent('form3',$fGui,'FORM3');
			$tplContent->addContent('form3_1',$formGui,'FORM3',array('','fields3'));
		}

		return $tplContent;
	}


	function showArchivSearchGui() {
		require_once('lib/zef/class_DateSelectForm.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');

		$ContGui=new TemplateGui('core/common_content_border.inc.html');

		$selDateGui=new DateSelectForm();
		$ContGui->addContent('dateSelect',$selDateGui->process(),'CONTENT');
		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key='FKPrjID';
		$tMode='o';
		$params=base64_encode(serialize(array('MaxEntries'=>0,'useAll'=>0,'prjActiv'=>false,'prjPerms'=>false)));

		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Projekte]]'),
			'LabelSep'=>'',
			'mode'=>$tMode,
			'app'=>'proj',
			'params'=>$params,
			'FieldVal'=>'_PROJECTS',
		);
		$default='';
		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,$default,'fields1');
		$formGui->setParams($key,array('mode'=>$tMode,'no_width'=>1,'params'=>$params));

		$avSaveData=array();
		if ($this->_BasePrf->isAvApp('sfol')) {
			$avSaveData['sfol']=$this->_T->lang('[[Dateien]]');
		}
		if ($this->_BasePrf->isAvApp('mfol')) {
			$avSaveData['mfol']=$this->_T->lang('[[E-Mail]]');
		}
		$key='SaveData';
		$formGui->addField($key,'checklist_v',$this->_T->lang('[[Inhalte]]'),array_keys($avSaveData));
		$formGui->setValues($key,$avSaveData);

		$key='archiv_x';
		$formGui->addField($key,'submit','',' '.$this->_T->lang('[[Archivieren]]').' ');

		$ContGui->addContent('searchData',$formGui,'CONTENT');

		$actPrj=array();
		if (trim($formGui->getFieldVal('FKPrjID',1))) {
			$temp=explode('|',$formGui->getFieldVal('FKPrjID',1));
			foreach ($temp as $val) {
				if ($val[0]=='o') {
					$actPrj[]=substr($val,2);
				}
			}
			$actPrj=array_unique($actPrj);
		}


		$this->_searchArchiv=array(
			'DateB'=>$selDateGui->getDate('B'),
			'DateE'=>$selDateGui->getDate('E'),
			'SaveData'=>$formGui->getFieldVal('SaveData',1),
			'FKPrjID'=>empty($actPrj)?0:$actPrj,
		);

		if ($this->_action!='a') {
			$this->_Gui->addTreeContent($ContGui);
		}
	}
	function showArchivLogGui() {
		global $auth;
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionButtons.php');
		if (is_array($this->_Obj)) {
			if (Framework::getParam('delete_archiv_log_x','0','P')) {
				$this->_BasePrj->deleteProjectArchivLog($this->_Obj['ID']);
				$this->_L->setParam(array('action'=>'b'));
				$this->_L->unsetParam(array('oid'));
				$this->_L->goToLink();
			}
			$archivLog=unserialize($this->_Obj['ArchivLog']);
			$archivConfig=unserialize($this->_Obj['ArchivConfig']);
			if (Framework::getParam('delete_archiv_data_x','0','P')) {
				$delLog=true;
				$prjObj=$this->_BasePrj->getObj($this->_Obj['FKPrjID']);
				if (is_object($prjObj)) {
					foreach ($archivLog as $modKey=>$modData) {
						if ($modData['Status']==0) {
							switch ($modKey) {
								case 'mfol':
									$Mail=& $this->_frm->getStaticModul('mail');
									$Mail->setUser($auth->auth['uid']);
									$Mail->setUserName($auth->auth['uname']);
									$Mail->setPassword($auth->auth['password']);
									$Mail->deleteArchiv($this->_BasePrj->getCfg('cfg/ProjectMailBox'),$modData['log'],'user');
								break;
								case 'sfol':
									$SmbMnt=& $this->_frm->getStaticModul('smb_mnt');
									$mntObj=$SmbMnt->getAdminShareObj($this->_BasePrj->getCfg('cfg/ProjectSmbBox'),0);
									if (is_object($mntObj)) {
										$SmbMnt->setRule(true);
										$SmbMnt->setRootObj($mntObj);
										$SmbMnt->setTempAdmin();
										$SmbMnt->deleteArchivFolder($this->_BasePrj->getCfg('cfg/ProjectSmbBox'),$modData['log']);
										$SmbMnt->delTempAdmin();
									}
								break;
							}
						}
					}
				}
				$this->_BasePrj->deleteProjectArchivLog($this->_Obj['ID']);
				$this->_L->setParam(array('action'=>'b'));
				$this->_L->unsetParam(array('oid'));
				$this->_L->goToLink();
			}


			$noEnc=array('NoEnc'=>1,'NoBr'=>1);
			$Gui=new ApplicationListGui();
			$title=$this->_BasePrj->getCachedProjectName($this->_Obj['FKPrjID']).': ';
			$title.=$this->_T->Lang('[[von]]').' '.($archivConfig['DateB']?date('d.m.Y',$archivConfig['DateB']).' ':'- ');
			$title.=$this->_T->Lang('[[bis]]').' '.($archivConfig['DateE']?date('d.m.Y',$archivConfig['DateE']):'-');

			$Gui->setName($title);
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
			$Gui->addFunction($btBreak,1);

			if (Framework::getParam('viewLog','','G')) {
				if (is_array($archivLog[Framework::getParam('viewLog','','G')]['log'])) {
					$PrintID=$this->_frm->insertPrint('proj','html',implode('<br>',$archivLog[Framework::getParam('viewLog','','G')]['log']));
				} else {
					$PrintID=$this->_frm->insertPrint('proj','html','NO DATA');
				}
				page_close();
				header("Location:print.php?PrintID=$PrintID");
				exit;
			}
			foreach ($archivLog as $modKey=>$modData) {
				switch ($modKey) {
					case 'mfol':
						$modName=$this->_T->Lang('[[E-Mail]]');
					break;
					case 'sfol':
						$modName=$this->_T->Lang('[[Dateien]]');
					break;
				}
				$Gui->addRow(2);
				$Gui->addCol('Title',$modName,'','','',1,'',1);
				$extra=array();
				$extra['LinkAttribs']=array(
					'target'=>'_blank',
				);
				$Gui->addCol('ShowLog',$this->_T->Lang('[[Logdatei ansehen]]'),'',$this->_L->getTempLink(null,array('viewLog'=>$modKey)),'right',0,'2000',0,'',$extra);

				if ($modData['Status']==0) {
					$Gui->addRow($hl?$hl=0:$hl=1);
					$Gui->addCol('Title',$this->_T->Lang('[[Verzeichnise]]').':','','','right',1,'');
					$Gui->addCol('Value',$modData['numFolders']?$modData['numFolders']:'-','','','',0,'2000');
					$Gui->addRow($hl?$hl=0:$hl=1);
					$Gui->addCol('Title',$this->_T->Lang('[[Dateien]]').':','','','right',1,'');
					$Gui->addCol('Value',$modData['numFiles']?$modData['numFiles']:'-','','','',0,'2000');
				} else {
					$Gui->addRow($hl?$hl=0:$hl=1);
					$Gui->addCol('Title',$this->_T->Lang('[[Fehler]]').':','','','right',1,'');
					$Gui->addCol('Value',$modData['Status'],'','','',0,'2000');
				}
			}
			$deleteArc=new SubmitBtn('delete_archiv_log_x',' '.$this->_T->lang('[[Logeintrag entfernen]]').' ');
			$deleteBt=new SubmitBtn('delete_archiv_data_x',' '.$this->_T->lang('[[Alle Inhalte loeschen]]').' ');
			$deleteBt->setAttribs(array('onclick'=>"return lo_form();"));
			$Gui->addRow(2,'');
			$Gui->addCol('Delete',$deleteArc->process().'&nbsp;'.$deleteBt->process(),'','','center',0,0,2,'',$noEnc);


			$this->_Gui->addContent($Gui);
		}
	}
	function showArchivListGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionButtons.php');
		$Gui=new ApplicationListGui();
		$Gui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));
		$Gui->setAutoBg(APP_FG10COLOR);
		$Gui->setID('prjArcTab');
		$this->_frm->addOnLoad("disableSelection(document.getElementById('prjArcTab'));");
		$Gui->setName($this->_T->Lang('[[Erstellte Sicherungen]]'));

		/*$funcAction=new FunctionObjActionGui('zef_list_action',1);
		$funcAction->setName($this->_T->lang('[[Verrechnen in Quartal]]'));
		for ($i=ceil(date('n')/3)+1;$i>-12;$i--) {
			$time=mktime(0,0,0,$i*3);
			if ($time<=$Date[1]) break;
			$funcAction->addValue(date('Y',$time).'-'.ceil(date('n',$time)/3),ceil(date('n',$time)/3).' / '.date('Y',$time));
		}
		$Gui->addFunction($funcAction);*/

		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		$funcSelAll=new FunctionButtons('prj_list','selectall',array('ListID'=>'ListID[]','ListOn'=>false));
		//$Gui->addHeaderCol('ListID',$funcSelAll->process(),'','','',1,'1%',0,'',$noEnc);
		$Gui->setTrOver('trBOC({ROW},this);');
		$Gui->setTrDown('trBOI({ROW},this,1);');
		$Gui->addHeaderCol('TimeCreate',$this->_T->Lang('[[Erstellt am]]'),'','','',1,'');
		$Gui->addHeaderCol('PrjId',$this->_T->Lang('[[Projekt]]'),'','','',0,'2000');
		$Gui->addHeaderCol('Daten',$this->_T->Lang('[[Inhalte]]'),'','','',1,'');
		$Gui->addHeaderCol('DateB',$this->_T->Lang('[[von]]'),'','','',1,'');
		$Gui->addHeaderCol('DateE',$this->_T->Lang('[[bis]]'),'','','',1,'');

		$entries=$this->_BasePrj->listProjectArchiv();
		foreach ($entries as $key=>$val) {
			$archivConfig=unserialize($val['ArchivConfig']);
			//debug($archivConfig);

			$Gui->addRow(($hl?$hl=0:$hl=1),'top');

			$attribs=array(
				'onclick'=>'return false;',
			);
			$btnList=new CheckBoxBtn ('ListID[]','');
			$btnList->setAttribs($attribs);
			//$Gui->addCol('ListID',$btnList->process($key),'','','',1,'1%',0,'',$noEnc);
			$Gui->addCol('TimeCreate',date('d.m.Y H:i',$val['TimeCreate']),'',$this->_L->getTempLink(null,array('action'=>'v','oid'=>$key)),'',1,'');
			$Gui->addCol('PrjId',$this->_BasePrj->getCachedProjectName($val['FKPrjID']),'',$this->_L->getTempLink(null,array('action'=>'v','oid'=>$key)),'',0,'');
			$modName=array();
			foreach (explode(',',$val['ArchivModul']) as $modK) {
				switch ($modK) {
					case 'mfol':
						$modName[]=$this->_T->Lang('[[E-Mail]]');
					break;
					case 'sfol':
						$modName[]=$this->_T->Lang('[[Dateien]]');
					break;
				}
			}
			$Gui->addCol('Daten',implode(', ',$modName),'','','',1,'');
			$Gui->addCol('DateB',$archivConfig['DateB']?date('d.m.Y',$archivConfig['DateB']):'-','','','',1,'');
			$Gui->addCol('DateE',$archivConfig['DateE']?date('d.m.Y',$archivConfig['DateE']):'-','','','',1,'');
		}
		$this->_Gui->addContent($Gui);
	}
	function showArchivProjectGui() {
		require_once('lib/class_ApplicationListGui.php');
		set_time_limit(0);
		$archivPath=$this->_frm->getDynTempPath('prj_archiv');
		$statusFile=$archivPath.'/status.txt';


		if ($this->_runningConfig) {
			$this->_searchArchiv=$this->_runningConfig['searchArchiv'];
		}

		if ($this->_searchArchiv['FKPrjID']) {
			$Gui=new ApplicationListGui();
			$title.=$this->_T->Lang('[[von]]').' '.($this->_searchArchiv['DateB']?date('d.m.Y',$this->_searchArchiv['DateB']).' ':'- ');
			$title.=$this->_T->Lang('[[bis]]').' '.($this->_searchArchiv['DateE']?date('d.m.Y',$this->_searchArchiv['DateE']):'-');
			$Gui->setName($title);

			$allPrj=$this->_BasePrj->getPrjNames($this->_searchArchiv['FKPrjID'],0,'',0,true,false,false);
			$status=array();
			foreach ($allPrj as $prjObj) {
				$noEnc=array('NoEnc'=>1,'NoBr'=>1);

				$Gui->addRow(2);
				$Gui->addCol('Title',$prjObj->getName(),'','','',1,'',2);

				if (in_array('sfol',$this->_searchArchiv['SaveData']) && $prjObj->getMeta('SmbFolder')) {
					if (!$this->_runningConfig) $status[$prjObj->getID()]['sfol']['status']='waiting';
					$Gui->addRow($hl?$hl=0:$hl=1);
					$Gui->addCol('Title',$this->_T->Lang('[[Dateien]]').':','','','right',1,'');
					$Gui->addCol('StatusID','<div id="status_sfol_'.$prjObj->getID().'"><strong>'.($this->_runningConfig?'':$this->_T->lang('[[arcWaiting]]')).'</strong></div>','','','',0,'2000',0,'',$noEnc);
				}
				if (in_array('mfol',$this->_searchArchiv['SaveData']) && $prjObj->getMeta('MailFolder')) {
					if (!$this->_runningConfig) $status[$prjObj->getID()]['mfol']['status']='waiting';
					$Gui->addRow($hl?$hl=0:$hl=1);
					$Gui->addCol('Title',$this->_T->Lang('[[E-Mail]]').':','','','right',1,'');
					$Gui->addCol('StatusID','<div id="status_mfol_'.$prjObj->getID().'"><strong>'.($this->_runningConfig?'':$this->_T->lang('[[arcWaiting]]')).'</strong></div>','','','',0,'2000',0,'',$noEnc);

				}
			}
			if (!$this->_runningConfig) $this->_writeArchivStatus($statusFile,$status);

			$deletePit=new SubmitBtn('kill_archiv_x',' '.$this->_T->lang('[[Abbrechen]]').' ');
			$okBt=new SubmitBtn('ok_archiv_x',' '.$this->_T->lang('[[Weiter]]').' ');
			$okBt->setAttribs(array('style'=>"display:none;"));
			$Gui->addRow(2,'');
			$Gui->addCol('Delete',$deletePit->process().$okBt->process(),'','','center',0,0,2,'',$noEnc);


			$this->_Gui->addContent($Gui);
			if (!$this->_runningConfig) {
				$cfgData=array(
					'archivPath'=>$archivPath,
					'statusFile'=>$statusFile,
					'searchArchiv'=>$this->_searchArchiv,
				);
				$this->_frm->setUserData('proj','archivConfig',serialize($cfgData));
				//$result=$this->_ArchivProject();
				$this->_frm->addOnload('initProjectArchiv();');
			} else {
				$this->_frm->addOnload('continueProjectArchiv();');
			}


		} else {
			$this->_E->setError('fields','FKPrjID');
		}

		//$this->showArchivListGui();
	}
	function _getArchivStatus($file) {
		return unserialize(implode('',file($file)));
	}
	function _writeArchivStatus($file,$data) {
		$fp=fopen($file,'w+');
		fwrite($fp,serialize($data));
		fclose($fp);
	}
	function _AjaxArchivProjectStatus() {
		$allOK=array();
		$config=unserialize($this->_frm->getUserData('proj','archivConfig'));
		if (is_array($config)) {
			$statusFile=$config['statusFile'];
			$status=$this->_getArchivStatus($statusFile);
			foreach ($status as $prjID=>$val) {
				if (is_array($val)) {
					foreach ($val as $mKey=>$mVal) {
						$allOK[$mKey]=false;
						$statusTxt='';
						switch ($mVal['status']) {
							case 'generating':
								if (file_exists($mVal['tgzFile'])) {
									$fsize=filesize($mVal['tgzFile']);
									$statusTxt='<strong style="color:#f00;">'.$this->_T->lang('[[arcGenerating]]').': ';
									$statusTxt.=Framework::formatSize($fsize).'</strong>';
								} else {
									$statusTxt='<strong style="color:#f00;">'.$this->_T->lang('[[arcSearchFiles]]').'</strong>';
								}
							break;
							case 'generated':
								$statusTxt='<strong style="color:#F3C200;">'.$this->_T->lang('[[arcGenerated]]').'</strong>';
							break;
							case 'finished':
								$statusTxt='<strong style="color:#00963A;">'.$this->_T->lang('[[arcFinished]]').':';
								$statusTxt.=' '.$this->_T->lang('[['.$mKey.'Folders]]').': '.$mVal['numFolders'];
								$statusTxt.=' '.$this->_T->lang('[['.$mKey.'Files]]').': '.$mVal['numFiles'];
								$statusTxt.='</strong>';
								$allOK[$mKey]=true;
							break;
							case 'noData':
								$statusTxt='<strong style="color:#f00;">'.$this->_T->lang('[[arcNoData]]').'</strong>';
								$allOK[$mKey]=true;
							break;
							case 'Error':
								$statusTxt='<strong style="color:#f00;">Error: '.$mVal['errorCode'].'</strong>';
								$allOK[$mKey]=true;
							break;
							case 'uploading':
								if (file_exists($mVal['tgzFileFinalInt'])) {
									$fsize=filesize($mVal['tgzFileFinalInt']);
									$statusTxt='<strong style="color:#F3C200;">'.$this->_T->lang('[[arcUploading]]').': ';
									$statusTxt.=Framework::formatSize($fsize).'</strong>';
								} else {
									$statusTxt='<strong style="color:#F3C200;">'.$this->_T->lang('[[arcUploading]]').'</strong>';
								}
							break;
							case 'waiting':
								$statusTxt='<strong style="color:#f00;">'.$this->_T->lang('[[arcWaiting]]').'</strong>';
							break;

						}
						if ($statusTxt) setAjaxData('html','status_'.$mKey.'_'.$prjID,$statusTxt);
					}
				}
				if (!empty($allOK) && !in_array(false,$allOK)) {
					//$this->_frm->deleteUserData('proj','archivConfig');

					setAjaxData('eval','prjFinished','finishProjectArchiv()');
				}
			}
		}
	}
	function _ArchivProject() {
		global $auth;
		set_time_limit(0);
		$config=unserialize($this->_frm->getUserData('proj','archivConfig'));
		if (is_array($config)) {
			$archivPath=$config['archivPath'];
			$statusFile=$config['statusFile'];
			$searchArchiv=$config['searchArchiv'];

			Framework::deleteFilesRecursive($archivPath,'/.*/');
			$fp=fopen($archivPath.'/MY_PID','w+');
			fwrite($fp,posix_getpid());
			fclose($fp);

			$f_result=false;
			$closeSmb=false;
			$status=$this->_getArchivStatus($statusFile);

			if ($searchArchiv['FKPrjID']) {
				if ($this->_BasePrf->isAvApp('sfol') && in_array('sfol',$searchArchiv['SaveData']) && $this->_BasePrj->getCfg('cfg/ProjectSmbBox')) {
					$SmbMnt=& $this->_frm->getStaticModul('smb_mnt');
					$mntObj=$SmbMnt->getAdminShareObj($this->_BasePrj->getCfg('cfg/ProjectSmbBox'),0);
					if (is_object($mntObj)) {
						$SmbMnt->setRule(true);
						$SmbMnt->setRootObj($mntObj);
						$SmbMnt->setTempAdmin();
						$closeSmb=true;
					}
				}
				if ($this->_BasePrf->isAvApp('mfol') && in_array('mfol',$searchArchiv['SaveData'])) {
					$Mail=& $this->_frm->getStaticModul('mail');
					$Mail->setUser($auth->auth['uid']);
					$Mail->setUserName($auth->auth['uname']);
					$Mail->setPassword($auth->auth['password']);
				}

				//$fp=fopen($archivPath.'/status.txt');


				$arcResult=array();
				$allPrj=$this->_BasePrj->getPrjNames($searchArchiv['FKPrjID'],0,'',0,true,false,false);
				$archivConfig=array();



				foreach ($allPrj as $prjObj) {
					if (in_array('sfol',$searchArchiv['SaveData']) && $prjObj->getMeta('SmbFolder')) {
						if (is_object($mntObj) && $SmbMnt->getObj($prjObj->getMeta('SmbFolder'))) {
							$tgzFile=$prjObj->getName().'_'.($searchArchiv['DateB']?date('Ymd',$searchArchiv['DateB']):'00000000').'_'.date('Ymd',$searchArchiv['DateE']).'_samba.tar.gz';

							$status[$prjObj->getID()]['sfol']['tgzFile']=$archivPath.'/'.$tgzFile;
							$status[$prjObj->getID()]['sfol']['status']='generating';
							$this->_writeArchivStatus($statusFile,$status);

							$result=$SmbMnt->archivFolder($prjObj->getMeta('SmbFolder'),$searchArchiv,$archivPath,$tgzFile);
							//debugFile($result);
							$arcResult[$prjObj->getID()]['sfol']=array(
								'status'=>$result[0],
								'log'=>array_slice($result,1),
								'file'=>$tgzFile,
								'numFiles'=>0,
								'numFolders'=>0,
							);
							if ($result[0]==0 && !empty($arcResult[$prjObj->getID()]['sfol']['log'])) {
								foreach ($arcResult[$prjObj->getID()]['sfol']['log'] as $file) {
									$file=str_replace('./','',$file);
									if ($file[strlen($file)-1]=='/') {
										$arcResult[$prjObj->getID()]['sfol']['numFolders']++;
									} else {
										$arcResult[$prjObj->getID()]['sfol']['numFiles']++;
									}
								}
								$status[$prjObj->getID()]['sfol']['status']='generated';
								$status[$prjObj->getID()]['sfol']['numFolders']=$arcResult[$prjObj->getID()]['sfol']['numFolders'];
								$status[$prjObj->getID()]['sfol']['numFiles']=$arcResult[$prjObj->getID()]['sfol']['numFiles'];
								$this->_writeArchivStatus($statusFile,$status);
							} else {
								if ($result[0]==0) {
									$status[$prjObj->getID()]['sfol']['status']='noData';
								} else {
									$status[$prjObj->getID()]['sfol']['status']='Error';
									$status[$prjObj->getID()]['sfol']['errorCode']=$result[0];
								}
								$this->_writeArchivStatus($statusFile,$status);
							}
						} else {
							$status[$prjObj->getID()]['sfol']['status']='noData';
							$this->_writeArchivStatus($statusFile,$status);
						}
					}

					if (in_array('mfol',$searchArchiv['SaveData']) && $prjObj->getMeta('MailFolder')) {
						if ($this->_BasePrj->existsMailFolder($prjObj->getMeta('MailFolder'))) {
							$tgzFile=$prjObj->getName().'_'.($searchArchiv['DateB']?date('Ymd',$searchArchiv['DateB']):'00000000').'_'.date('Ymd',$searchArchiv['DateE']).'_mail.tar.gz';

							$status[$prjObj->getID()]['mfol']['tgzFile']=$archivPath.'/'.$tgzFile;
							$status[$prjObj->getID()]['mfol']['status']='generating';
							$this->_writeArchivStatus($statusFile,$status);

							$result=$Mail->archivFolder($prjObj->getMeta('MailFolder'),$searchArchiv,$archivPath,$tgzFile);
							$arcResult[$prjObj->getID()]['mfol']=array(
								'status'=>$result[0],
								'log'=>array_slice($result,1),
								'file'=>$tgzFile,
								'numFiles'=>0,
								'numFolders'=>0,
							);
							if ($result[0]==0 && !empty($arcResult[$prjObj->getID()]['mfol']['log'])) {
								foreach ($arcResult[$prjObj->getID()]['mfol']['log'] as $file) {
									$file=str_replace('./','',$file);
									if ($file[strlen($file)-1]=='/') {
										$arcResult[$prjObj->getID()]['mfol']['numFolders']++;
									} elseif (preg_match('@\.eml$@i',$file)) {
										$arcResult[$prjObj->getID()]['mfol']['numFiles']++;
									}
								}
								$status[$prjObj->getID()]['mfol']['status']='generated';
								$status[$prjObj->getID()]['mfol']['numFolders']=$arcResult[$prjObj->getID()]['mfol']['numFolders'];
								$status[$prjObj->getID()]['mfol']['numFiles']=$arcResult[$prjObj->getID()]['mfol']['numFiles'];
								$this->_writeArchivStatus($statusFile,$status);
							} else {
								if ($result[0]==0) {
									$status[$prjObj->getID()]['mfol']['status']='noData';
								} else {
									$status[$prjObj->getID()]['mfol']['status']='Error';
									$status[$prjObj->getID()]['mfol']['errorCode']=$result[0];
								}
								$this->_writeArchivStatus($statusFile,$status);
							}

						} else {
							$status[$prjObj->getID()]['mfol']['status']='noData';
							$this->_writeArchivStatus($statusFile,$status);
						}
					}
				}
				if ($closeSmb) {
					$SmbMnt->delTempAdmin();
				}

				$SmbMnt=& $this->_frm->getStaticModul('smb_mnt');
				$mntObj=$SmbMnt->getAdminShareObj($this->_BasePrj->getCfg('cfg/ProjectSmbBoxArchiv'),0,1);
				if (is_object($mntObj)) {
					$SmbMnt->setRootObj($mntObj);
					if ($this->_BasePrj->getCfg('cfg/ProjectSmbBoxArchivDir')) {
						$dirObj=$SmbMnt->getObj($mntObj->getID().'/'.$this->_BasePrj->getCfg('cfg/ProjectSmbBoxArchivDir'));
						if (!$dirObj) {
							$dirObj=Framework::cloneObj($mntObj);
							$tmp=explode('/',$this->_BasePrj->getCfg('cfg/ProjectSmbBoxArchivDir'));
							foreach ($tmp as $val) {
								if (trim($val) && !$SmbMnt->getObj($dirObj->getID().'/'.$val)) {
									$SmbMnt->createFolder($dirObj,$val);
									$dirObj=$SmbMnt->getObj($dirObj->getID().'/'.$val);
								}
							}
						}
					} else {
						$dirObj=Framework::cloneObj($mntObj);
					}

					if (!empty($arcResult)) {
						foreach ($arcResult as $prjID=>$resultModul) {
							$subFol=$this->_BasePrj->getCachedProjectName($prjID);
							$folObj=$SmbMnt->getObj($dirObj->getID().'/'.$subFol);

							if (!$folObj) {
								$SmbMnt->createFolder($dirObj,$subFol);
								$folObj=$SmbMnt->getObj($dirObj->getID().'/'.$subFol);
							}
							foreach ($resultModul as $modKey=>$result) {
								if ($result['status']==0) {
									if (!empty($result['log'])) {
										$status[$prjID][$modKey]['status']='uploading';
										$status[$prjID][$modKey]['tgzFileFinal']=$folObj->getID().'/'.$result['file'];
										$status[$prjID][$modKey]['tgzFileFinalInt']=$SmbMnt->getInternPath($folObj->getID().'/'.$result['file']);
										$this->_writeArchivStatus($statusFile,$status);

										$SmbMnt->uploadLocalFile($folObj,$archivPath.'/'.$result['file']);

										if (filesize($archivPath.'/'.$result['file'])!=filesize($status[$prjID][$modKey]['tgzFileFinalInt'])) {
											$status[$prjID][$modKey]['status']='Error';
											$status[$prjID][$modKey]['errorCode']='Filesize does not match !!';
											$status[$prjID][$modKey]['numFolders']=0;
											$status[$prjID][$modKey]['numFiles']=0;

											$resultModul[$modKey]['status']=1;
											$resultModul[$modKey]['numFolders']=0;
											$resultModul[$modKey]['numFiles']=0;
											$resultModul[$modKey]['log']=array('Error uploading Archiv: Filesize does not match !!');
										} else {
											$status[$prjID][$modKey]['status']='finished';
										}
										$this->_writeArchivStatus($statusFile,$status);
									}
								}
							}
							$insert=array(
								'FKPrjID'=>$prjID,
								'ArchivConfig'=>serialize($searchArchiv),
								'ArchivLog'=>serialize($resultModul),
								'ArchivModul'=>implode(',',array_keys($resultModul)),
							);
							$this->_BasePrj->insertProjectArchiv($insert);
						}
						$f_result=true;
					}
					$SmbMnt->logout();
				}
				//debug($this->_getArchivStatus($statusFile));
				//$this->_frm->deleteUserData('proj','archivConfig');
				Framework::deleteFilesRecursive($archivPath,'/.*/');
				$this->_writeArchivStatus($statusFile,$status);
				return $f_result;

			}
		}
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_mode,array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_mode,$key);
		if (!$result) $result=$default;
		return $result;
	}
	function getProfiles() {
		return $this->_BasePrf->getProfileNames(true);
	}


}
?>