<?php
class ProjectImportGui {
	private $_Base;
	private $_Obj;
	private $_T;
	private $_t;
	private $_frm;
	private $_L;
	private $_E;
	private $xml;
	private $_convertAddr=array(
		'fields'=>array(),
		'values'=>array(),
		'cat'=>array(),
	);
	private $_default=array();
	function __construct() {
		global $frm,$t,$T,$E,$L;
		$this->_frm=&$frm;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_Base=& $this->_frm->getStaticModul('proj');
		$this->_BasePrf=& $this->_frm->getStaticModul('proj_profiles');
		$this->_BaseSelect=& $this->_frm->getStaticModul('uform_select');
		$this->_BaseForm=& $this->_frm->getStaticModul('uform');
		$this->_Addr=& $this->_frm->getStaticModul('addr');
	}
	function _handleRequest() {

	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
	function &process() {
		$this->_handleRequest();
		return $this->getGui();
	}
	function setXml($xml) {
		$this->xml=$xml;
	}
	function setImpFile($imp_file) {
		$this->imp_file = $imp_file;
	}
	function setDefault($key,$val) {
		$this->_default[$key]=$val;
	}
	function isImported() {
		if (Framework::getParam('meta_save_x','0','P') && !$this->_E->isError() && $this->_adminGui->_Obj) {
			return $this->_adminGui->_Obj;
		}
		return false;
	}

	function &getGui() {
		libxml_use_internal_errors(true);
		require_once('lib/class_ApplicationTreeGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_TemplateGui.php');

		$ContGui=new ApplicationTreeGui();
		$this->imp_file=Framework::getParam('imp_file','','P');
		if (Framework::getParam('impFile[tmp_name]','','F')) {
			$tmp_file=Framework::getParam('impFile[tmp_name]','','F');

			if (file_exists($tmp_file) && is_file($tmp_file) && simplexml_load_file($tmp_file)) {
				$this->imp_file=basename(tempnam(Framework::getTempPath(),'prjImp'));
				//debug($this->imp_file);
				copy($tmp_file,Framework::getTempPath().'/'.$this->imp_file);
			} else {
				$this->_E->setError('fields','FieldUpload');
			}
		}
		//$imp_file='prj_import.xml';
		if (!$this->imp_file || !file_exists(Framework::getTempPath().'/'.$this->imp_file)) {
			$Gui=$this->getImportGui();
		} else {
			$this->xmlData = simplexml_load_file(Framework::getTempPath().'/'.$this->imp_file);
			if (isset($this->xmlData->entry)) {
				$this->xml = $this->xmlData->entry[0];
			} else {
				$this->xml = $this->xmlData;
			}
			$Gui=$this->getInsertGui();
			if (Framework::getParam('meta_save_x','0','P') && !$this->_E->isError()) {
				$this->_E->setTyp(1);
				$this->_E->setError('import_OK');
				$this->_E->setErrorMsg('import_OK',$this->_T->lang('[[Projekt wurde importiert]]'));
				if (isset($this->xmlData->entry) && count($this->xmlData->entry) > 1) {
					unset($this->xmlData->entry[0]);
					$this->xmlData->asXML(Framework::getTempPath().'/'.$this->imp_file);
					$this->xml = $this->xmlData->entry[0];
					$_POST=array();
					$Gui=$this->getInsertGui();
				} else {
					unlink(Framework::getTempPath().'/'.$this->imp_file);
					$this->imp_file='';
					$Gui=$this->getImportGui();
				}

			}
		}

		$ContGui->addContent($Gui);
		return $ContGui;

	}
	function getImportGui() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');

		$Gui=new ContentGui();
		$Gui->setName($this->_T->lang('[[Projekte importieren]]'));

		$tplContent=new TemplateGui('core/common_template_intern.inc.html');

		$formGui=new FormGui();
		$key='impFile';
		$formGui->addField($key,'file','','','form_fieldsimp');
		$formGui->setNoParse($key);
		$key='upload_x';
		$formGui->addField($key,'submit','',$this->_T->lang('[[Upload]]'),'form_fieldsimp');
		$formGui->setNoParse($key);

		$formGui->addField('FieldUpload','field_array',$this->_T->lang('[[Datei auswaehlen]]'),array('impFile','&nbsp;','upload_x'),'form_fieldsimp');


		$box=new BoxGui();
		$box->addTab('box_u',$this->_T->lang('[[XML-Datei hochladen]]'),'#',true);
		$box->setTabContent('box_u',$formGui,array('','form_fieldsimp'));

		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);

		return $Gui;
	}
	function getInsertGui() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/proj/class_ProjectAdminGui.php');
		$this->_T->loadModul('uform');
		$this->_adminGui=new ProjectAdminGui();
		$this->_convertAddr=array(
			'fields'=>array(),
			'values'=>array(),
			'changes'=>array(),
			'new'=>array(),
			'cat'=>array(),
		);
		$actTab='meta';
		if (Framework::getParam('meta_save_x','0','P')) {
			if (Framework::issetParam('hid_addrCatNew','P')) {
				if (!Framework::getParam('hid_addrCatNew','','P')) {
					$this->_E->setError('fields','addrCatNew');
					$actTab='address';
				} else {
					foreach(explode('|',Framework::getParam('hid_addrCatNew','','P')) as $val) {
						$this->_convertAddr['cat'][]=substr($val,2);
					}
					$this->_convertAddr['profil']=Framework::getParam('addrProfilNew',0,'P');
				}
			}
		}
		$parsedUforms=array();
		//XML Parsen
		$options=array(
			'noGoTo'=>1,
			'noMembers'=>1,
			'editOwner'=>1,
			'default'=>array(),
		);
		
//debug($this->xml->project);
		foreach ($this->_Base->getObjFields('0') as $key=>$val) {
			if (isset($val['import']) && $val['import']['name'] && isset($this->xml->project->$val['import']['name'])) {
				switch($key) {
					case 'ProjNumTxt':
						$options['ProjNumCode']=(string)$this->xml->project->$val['import']['name'];
					break;
					case 'FKProfileID':
						$values=$this->_BasePrf->listProfiles();
						foreach ($values as $tmp) {
							if ($tmp->getMeta('NameShort')==(string)$this->xml->project->$val['import']['name'] || $tmp->getMeta('Name')==(string)$this->xml->project->$val['import']['name']) {
								$options['defaultMeta'][$key]=$tmp->getID();
								break;
							}
						}
					break;
					case 'UserCreate':
						$rows=0;
						$allUsers=$this->_frm->searchUser($rows,'',0,0,0,0);
						$test=(string)$this->xml->project->$val['import']['name'];
						foreach($allUsers as $v) {
							if ($v['username']==$test || $v['firstname'].' '.$v['lastname']==$test || $v['lastname'].' '.$v['firstname']==$test || $v['email']==$test) {
								$options['defaultMeta'][$key]='u_'.$v['uidGroup-e'];
								break;
							}
						}
					break;
					default:
						$options['defaultMeta'][$key]=(string)$this->xml->project->$val['import']['name'];
					break;
				}
			}
		}
		if (isset($this->xml->project->fieldTimeFolder)) {
			$options['defaultMeta']['ZefFolder']=(int)$this->xml->project->fieldTimeFolder?1:0;
		}
		if (isset($this->xml->project->fieldMailFolder)) {
			$options['defaultMeta']['MailFolder']=(int)$this->xml->project->fieldMailFolder?1:0;
		}
		if (isset($this->xml->project->fieldFileFolder)) {
			$options['defaultMeta']['FmngFolder']=(int)$this->xml->project->fieldFileFolder?1:0;
		}
		if (isset($this->xml->project->fieldSambaFolder)) {
			$options['defaultMeta']['SmbFolder']=(int)$this->xml->project->fieldSambaFolder?1:0;
		}
		$uformResult=$this->processUform($this->xml->project,$this->_adminGui->_uFormData->getFormObj());
		if ($uformResult['default']) {
			$options['defaultUform']=$uformResult['default'];
		}
		if ($uformResult['params']) {
			$options['paramsUform']=$uformResult['params'];
		}
		$parsedUforms[]=$this->_adminGui->_uFormData->getFormObj();
		//Ende XML Parsen

		$Gui=new ContentGui();
		$Gui->setName($this->_T->lang('[[Projekte importieren]]'));
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		//debug($options);
		$box=new BoxGui();

		$metaGui=$this->_adminGui->getProjectMetaGui($options);
		$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
		$box->setTabContent('meta',$metaGui);

		$this->_profObj=$this->_BasePrf->getObj($this->_adminGui->formData['meta']['FKProfileID']);
		//debug($ProfAddOn);

		$membersGui=$this->getMembersGui();
		$box->addTab('members',$this->_T->lang('[[Mitglieder]]'),'#',true);
		$box->setTabContent('members',$membersGui);



		$docObj=$this->_BasePrf->getHeadObj($this->_adminGui->formData['meta']['FKProfileID'],'doc_fol');
		if ($docObj->getMeta('AddOn')) {
			$DocAddOn=unserialize($docObj->getMeta('AddOn'));
		} else {
			$DocAddOn=array();
		}
		if (!empty($DocAddOn)) {
			foreach ($DocAddOn as $formId=>$formPerms) {
				$formObj=$this->_BaseForm->getObj($formId);
				if (is_object($formObj)) {

					$box->addTab('uform_'.$formObj->getID(),$formObj->getName(),'#',true);
					$box->setTabContent('uform_'.$formObj->getID(),$this->editDocForm($formObj,0));
					$parsedUforms[]=$formObj;
				}
			}
		}

		if (!empty($this->_convertAddr['values'])) {
			$addrGui=$this->getAddrGui();
			$chg=false;
			foreach($this->_convertAddr['changes'] as $tmp) {
				if (!empty($tmp)) {
					$chg=true;
					break;
				}
			}
			if ($chg) {
				$box->addTab('address','* '.$this->_T->lang('[[Adressen]]').' *','#',true);
			} else {
				$box->addTab('address',$this->_T->lang('[[Adressen]]'),'#',true);
			}
			$box->setTabContent('address',$addrGui);

			if ($pObj=$this->isImported()) {
				foreach ($parsedUforms as $formObj) {
					$this->convertAddrUform($pObj->getID(),$formObj);
				}
			}
		}
		$box->setTabOn($actTab);

		$tplContent->addContent('content',$box,'CONTENT');


		require_once('lib/class_FormGui.php');
		$formGui=new FormGui();
		$formGui->addField('imp_file','hidden','',$this->imp_file,'fields1');
		$tplContent->addContent('content2',$formGui,'CONTENT');

		$Gui->addContent($tplContent);

		return $Gui;
	}
	function &getMembersGui() {
		if ($this->_profObj && $this->_profObj->getMeta('AddOn')) {
			$AddOn=unserialize($this->_profObj->getMeta('AddOn'));
		} else {
			$AddOn=array();
		}

		$default=array();
		if (!Framework::getParam('meta_save_x','0','P')) {
			$ruleUsers=isset($AddOn['ruleUsers'])?$AddOn['ruleUsers']:array();
			$groupUsers=isset($AddOn['groupUsers'])?$AddOn['groupUsers']:array();
			$ruleUsersExtra=isset($AddOn['ruleUsersExtra'])?$AddOn['ruleUsersExtra']:array();
			$default=array();
			if (!empty($groupUsers)) {
				foreach ($groupUsers as $rkey=>$rval) {
					if (!isset($default[$rkey])) $default[$rkey]=array();
					if (is_array($rval) && !empty($rval)) {
						foreach ($rval as $k=>$v) {
							$default[$rkey][]='g_'.$k;
						}
					}
				}
			}
			if (!empty($ruleUsers)) {
				foreach ($ruleUsers as $rkey=>$rval) {
					if (!isset($default[$rkey])) $default[$rkey]=array();
					if (is_array($rval) && !empty($rval)) {
						foreach ($rval as $k=>$v) {
							$default[$rkey][]='u_'.$k;
						}
					}
				}
			}
			if (!empty($ruleUsersExtra)) {
				foreach ($ruleUsersExtra as $rkey=>$rval) {
					if (!isset($default[$rkey])) $default[$rkey]=array();
					if (is_array($rval) && !empty($rval)) {
						foreach ($rval as $k=>$v) {
							if ($k==1) {
								$default[$rkey][]='u_'.$this->_frm->getUser();
							}
						}
					}
				}
			}
		}

		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormGui.php');
		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tabGui->setRowClass(array(0=>'list_hb',1=>'list'));

		$addUsers=array();
		$avRules=$this->_Base->getAvRules();
		if (!empty($avRules)) {
			$formGui=array();
			foreach ($avRules as $rkey=>$rval) {
				$formGui[$rkey]=new FormGui();
				$formGui[$rkey]->setLabelClass('no','no_error');
				$fKey='objRule_'.$rkey;
				$mode='u|g';
				$params='';
				$lb_params=array('Values'=>array());
				$lb_params['Values'][]=array(
					'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
					'LabelSep'=>'',
					'mode'=>$mode,
					'app'=>'proj',
					'params'=>$params,
					'FieldVal'=>'_USERS',
				);
				$lb_params['Values'][]=array(
					'Label'=>$this->_T->lang('[[Gruppen]]'),
					'LabelSep'=>' / ',
					'mode'=>$mode,
					'app'=>'proj',
					'params'=>$params,
					'FieldVal'=>'_GROUPS',
				);
				$lb_Invit=new FunctionButtons($fKey,'ajaxttiplabel',$lb_params);
				$formGui[$rkey]->addField($fKey,'ttip',$lb_Invit,isset($default[$rkey])?implode('|',$default[$rkey]):'','fields1');
				$formGui[$rkey]->setParams($fKey,array('mode'=>$mode,'params'=>$params));

				if ($this->_adminGui->formData['changes']['FKProfileID']) {
					$formGui[$rkey]->clearFields();
				}

				$tabGui->addRow(0,'top');
				$tabGui->addCol('Name',$this->_T->lang($rval),'','','',1,'200');
				$tabGui->addCol('Field',$formGui[$rkey],'','','',1,'400');

				$tabGui->addRow(1,'top');
				$tabGui->addCol('Name','','','','',1,'200');
				$tabGui->addCol('Field','','','','',1,'400');

				if ($this->isImported()) {
					$temp=$formGui[$rkey]->getFieldVal($fKey);
					if ($temp) {
						$addUsers[$rkey]=array();
						foreach(explode('|',$temp) as $val) {
							switch($val[0]) {
								case 'u':
									$addUsers[$rkey][]=substr($val,2);
								break;
								case 'g':
									$users=$this->_frm->getGroupUsers(substr($val,2));
									if (is_array($users)) {
										foreach ($users as $addID) {
											$addUsers[$rkey][]=$addID;
										}
									}
								break;
							}
						}
					}
				}

			}
			if (!empty($addUsers) && ($pObj=$this->isImported())) {
				if ($pObj->getMeta('MailFolder') && $this->_Base->existsMailFolder($pObj->getMeta('MailFolder'))) {
					$updateMail=true;
					$Mail=& $this->_frm->getStaticModul('mail');
				} else {
					$updateMail=false;
				}
				foreach ($addUsers as $rkey=>$rval) {
					$groupID=$this->_Base->getRuleGroupID($pObj,$rkey);
					foreach ($rval as $addID) {
						$this->_frm->insertGroupUsers($groupID,array($addID),false);
						if ($updateMail) {
							$Mail->delteMailAbbo($addID,$pObj->getMeta('MailFolder'));
							if (!$this->_frm->getPrefs($this->_Base->getModul(),'defMailNoAutoAbbo',$addID)) {
								$Mail->insertMailAbbo($addID,$pObj->getMeta('MailFolder'));
							}
						}
					}
				}
			}

		}

		return $tabGui;
	}
	function &getAddrGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_JsMenuGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');

		$tplContent=new TemplateGui('core/common_simple_content.inc.html');
		if ($this->_profObj && isset($this->_default['profileAddr'][$this->_profObj->getID()])) {
			$default=$this->_default['profileAddr'][$this->_profObj->getID()];
		} else {
			$default=array(
				'addrCatNew'=>'',
				'addrProfilNew'=>0,
			);
		}

		$key='addrCatNew';
		$rootObj=$this->_Addr->getSystemObj('s','',0);
		$addrTree=$this->_Addr->listAllTree($rootObj->getID());
		$jsMenu=new jsMenuGui('jsTree');
		$jsMenu->setMenuItems($this->_Addr->treeToJson($addrTree,$rootObj->getID(),'f_'));

		$params=array(
			'funcName'=>'upCpF',
			'ID'=>$key,
			'Mode'=>'f',
		);
		$jsMenu->setAction('ttip',$params);
		$this->_frm->addOnLoad("loadBoxMenu();");
		$this->_frm->addScript($jsMenu);

		$formGui=new FormGui();
		$params=array(
			0=>array(
				'Label'=>$this->_T->lang('[[Kategorie fuer neue Adressen]]'),
				'LabelSep'=>'',
				'JsFunction'=>"showBoxTree('".$key."','".$key."')",
			),
		);
		$label=new FunctionButtons('jsLabel','js_label',$params);
		$formGui->addField($key,'ttip',$label,$default[$key],'content');
		$formGui->setParams($key,array('no_width'=>'0','mode'=>'f','app'=>'','params'=>base64_encode(serialize(array('AddrServers'=>array($rootObj->getID()))))));

		$key='addrProfilNew';
		$addrProfiles=Framework::extractArrayMeta($this->_Addr->listPermsProfil(),'Title_'.$this->_frm->getLang());
		$formGui->addField($key,'select',$this->_T->lang('[[Profil fuer neue Adressen]]'),$default[$key],'content');
		$formGui->setValues($key,array(0=>'-') + $addrProfiles);

		if ($this->_adminGui->formData['changes']['FKProfileID']) {
			$formGui->clearFields();
		}

		$tplContent->addContent('content1',$formGui,'CONTENT');

		//	debug($this->_convertAddr);
		foreach ($this->_convertAddr['values'] as $id=>$AObj) {
			if (in_array($id,$this->_convertAddr['new'])) continue;
			$addrGui[$id]=$this->getChangeAddressGui($id,$AObj,$this->_convertAddr['changes'][$id]);
			$tplContent->addContent('content2',$addrGui[$id],'CONTENT');
		}
		if (!empty($this->_convertAddr['new'])) {
			$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
			$tabGui->setName($this->_T->lang('[[Neue Adressen]]'));
			$tabGui->addHeaderCol('Name',$this->_T->lang('[[Name]]'),'','','',1,'');
			$tabGui->addHeaderCol('Ort',$this->_T->lang('[[Ort]]'),'','','',1,'');
			$tabGui->addHeaderCol('Land',$this->_T->lang('[[Land]]'),'','','',1,'');
			$tabGui->addHeaderCol('EMail',$this->_T->lang('[[E-Mail]]'),'','','',1,'');
			foreach ($this->_convertAddr['new'] as $id) {
				$AObj=$this->_convertAddr['values'][$id];
				$tabGui->addRow($hl?$hl=0:$hl=1,'top');
				$tabGui->addCol('Name',$AObj->getName(),'','','',1,'400');
				$tabGui->addCol('Ort',trim($AObj->getMeta('APlz').' '.$AObj->getMeta('AOrt')),'','','',1,'200');
				$tabGui->addCol('Land',trim($AObj->getMeta('ALand')),'','','',1,'200');
				$tabGui->addCol('EMail',$AObj->getMeta('EMail'),'','','',1,'200');
			}
			$tplContent->addContent('content2',$tabGui,'CONTENT');
		}

		return $tplContent;
	}

	function &editDocForm(&$formObj,$onlyQuick=false) {
		require_once('lib/uform/class_UserFormShowGui.php');
		$Gui=new UserFormShowGui();
		$Gui->setFormObj($formObj,false);
		//debug($Gui->_formFields);
		$xmlKey=$formObj->getMeta('RefID');
		//Werte setzen
		if (isset($this->xml->documentation) && isset($this->xml->documentation->$xmlKey)) {
			$uformResult=$this->processUform($this->xml->documentation->$xmlKey,$formObj);
			$Gui->setDefault($uformResult['default']);
			$Gui->setParams($uformResult['params']);
		}
		//$Gui->setDefault();
		//debug($this->_adminGui->formData['meta']);
		$Gui->setStaticVisibility($this->_adminGui->formData['meta']);
		$Gui->setQuickMode($onlyQuick);

		if ($pObj=$this->isImported()) {
			$Values=$Gui->getDbValues('uf_'.$formObj->getID().'_'.$pObj->getID());
			if (!empty($Values)) {
				$Gui->updateData($pObj->getID(),$Values);
			}
		}


		return $Gui;
	}
	function convertAddrUform($ID,$formObj) {

		if (!empty($this->_convertAddr['cat']) && isset($this->_convertAddr['fields'][$formObj->getID()]) && !empty($this->_convertAddr['fields'][$formObj->getID()])) {
			require_once("lib/uform/class_UserFormData.php");
			$uForm=new UserFormData();
			$uForm->setFormObj($formObj,false);
			$formData=$uForm->getData($ID);
			$updateData=array();
			$prjAddrs=array();
			foreach ($this->_convertAddr['fields'][$formObj->getID()] as $fid) {
				if ($uForm->getFieldObj($fid) && $formData['F_'.$fid]) {
					$addrIDs=explode('|',$formData['F_'.$fid]);
					$update=false;
					foreach ($addrIDs as $k=>$val) {
						if (isset($this->_convertAddr['values'][substr($val,2)])) {
							$AObj=$this->_convertAddr['values'][substr($val,2)];
							//Adresse Konvertieren;
							if ($nObj=$this->existsAddr($AObj)) {
								//Soll das geänder Werden??
								//$AObj->setParentMeta('NodeIDs',$this->_convertAddr['cat']);
								//$AObj->setMeta('FKProfilID',$this->_convertAddr['profil']);

								$this->_Addr->updateAddrMeta($AObj);
								$addrIDs[$k]='a_'.$nObj->getID();
								$prjAddrs[]=$nObj->getID();
							} else {
								$AObj->setParentMeta('NodeIDs',$this->_convertAddr['cat']);
								$AObj->setMeta('FKProfilID',$this->_convertAddr['profil']);
								$AObj->setMeta('UserID',0);
								$AObj->setMeta('UserCreate',$this->_frm->getUser());
								$AObj->setMeta('TimeCreate',time());
								//debug($AObj);
								$this->_Addr->insertAddrMeta($AObj);
								$addrIDs[$k]='a_'.$AObj->getID();
								$prjAddrs[]=$AObj->getID();
							}
							$update=true;
						} else {
							$prjAddrs[]=substr($val,2);
						}
					}
					if ($update) {
						$updateData['F_'.$fid]=implode('|',$addrIDs);
					}
				}
			}
			if (!empty($updateData)) {
				$uForm->updateData($ID,$updateData);
			}
			if (!empty($prjAddrs)) {
				$this->_Addr->addProjectsAddr($ID,$prjAddrs);
			}
		}
	}
	function processUform($xml,$formObj) {
		$result=array();
		require_once("lib/uform/class_UserFormData.php");
		$uForm=new UserFormData();
		$uForm->setFormObj($formObj,false);
		foreach ($uForm->getAllFieldsID() as $fkey) {
			$fval=$uForm->getFieldObj($fkey);
			$fid=$fval->getMeta('RefID');
			if (isset($xml->$fid)) {
				switch($fval->getMeta('Typ')) {
					case 'fk_addr':
						$found=array();
						$result['params'][$fkey]['tipParams']=array('tempData'=>array(),'showPlace'=>1);
						if (isset($xml->$fid->address)) {
							foreach ($xml->$fid->address as $node) {
								if ($AObj=$this->_Addr->xml2addr($node)) {
									if (!isset($this->_convertAddr['fields'][$formObj->getID()])) {
										$this->_convertAddr['fields'][$formObj->getID()]=array();
									}
									if (!in_array($fkey,$this->_convertAddr['fields'][$formObj->getID()])) {
										$this->_convertAddr['fields'][$formObj->getID()][]=$fkey;
									}
									//debug($AObj);
									if ($nObj=$this->existsAddr($AObj)) {
										$id=$nObj->getID();
										$this->_convertAddr['changes'][$id]=array();
										$tmpObj=clone $nObj;
										$this->_convertAddr['values'][$id]=$this->_Addr->xml2addr($node,$tmpObj,$this->_convertAddr['changes'][$id]);
										$apply=Framework::getParam('geAddrChgListID_'.$id.'',array(),'P');
										$reparse=false;
										foreach($this->_convertAddr['changes'][$id] as $k=>$v) {
											if(!in_array($k,$apply)) {
												$refID=$this->_Addr->getFieldData($k,'RefID');
												if (isset($node->$refID)) {
													unset($node->$refID);
													$reparse=true;
												}
											}

										}
										if ($reparse) {
											$tmpObj=clone $nObj;
											$this->_convertAddr['values'][$id]=$this->_Addr->xml2addr($node,$tmpObj);
										}
										$found[]='a_'.$id;
									} elseif ($AObj->getName()) {
										$name=$AObj->getName().'_'.$AObj->getMeta('Email');
										if (isset($this->_convertAddr['new'][$name])) {
											$id=$this->_convertAddr['new'][$name];
										} else {
											$id=(count($this->_convertAddr['new'])*-1)-1;
											$this->_convertAddr['values'][$id]=$AObj;
											$this->_convertAddr['changes'][$id]=array();
											$this->_convertAddr['new'][$name]=$id;
											//$this->_Addr->xml2addr($node,null,$this->_convertAddr['changes'][$id]);
										}
										$found[]='a_'.$id;
									}
									if ($AObj->getName()) {
										$result['params'][$fkey]['tipParams']['tempData'][$id]=$AObj->getName();
										if (trim($AObj->getMeta('APlz').' '.$AObj->getMeta('AOrt'))) {
											$result['params'][$fkey]['tipParams']['tempData'][$id].=' (';
											if (trim($AObj->getMeta('ALand'))) {
												$result['params'][$fkey]['tipParams']['tempData'][$id].=trim($AObj->getMeta('ALand')).'-';
											}
											$result['params'][$fkey]['tipParams']['tempData'][$id].=trim($AObj->getMeta('APlz').' '.$AObj->getMeta('AOrt'));
											$result['params'][$fkey]['tipParams']['tempData'][$id].=')';
										}
									}

								}
							}
						} elseif ((int)$xml->$fid) {
							$found[]='a_'.(int)$xml->$fid;
						}
						if (!empty($found)) {
							$result['default']['F_'.$fkey]=implode('|',$found);
						}
					break;
					case 'check':
						if (count($xml->$fid->children())) {
							foreach ($xml->$fid->children() as $node) {
								if ((int)$node > 0) {
									$result['default']['F_'.$fkey]=1;
								} else {
									$result['default']['F_'.$fkey]=-1;
								}
							}
						} elseif ((int)$xml->$fid > 0) {
							$result['default']['F_'.$fkey]=1;
						} else {
							$result['default']['F_'.$fkey]=-1;
						}
					break;
					case 'date':
						if (trim((string)$xml->$fid) && FrameWork::parseSqlDate((string)$xml->$fid)) {
							$result['default']['F_'.$fkey]=(string)$xml->$fid;
						}
					break;
					case 'select':
					case 'mselect':
						$found=array();
						$values=array();
						if (count($xml->$fid->children())) {
							foreach ($xml->$fid->children() as $node) {
								if (trim((string)$node)) {
									$values[]=trim((string)$node);
								}
							}

						} elseif (trim((string)$xml->$fid)) {
							$values[]=trim((string)$xml->$fid);
						}
						if (!empty($values)) {
							$defValues=$this->_BaseSelect->listSelect($fval->getID());
							foreach ($defValues as $val) {
								 $val=$this->_BaseSelect->getObj($val->getID(),true);
								 foreach ($val->getTrans('Name') as $test) {
									 if (in_array($test,$values)) {
										 $found[]=$val->getID();
										 break;
									 }
								 }
							}
							if (!empty($found)) {
								if ($fval->getMeta('Typ')=='select') {
									$result['default']['F_'.$fkey]=$found[0];
								} else {
									$result['default']['F_'.$fkey]=implode(',',$found);
								}
							}
						}
					break;
					case 'int':
						if ((float)$xml->$fid) {
							$result['default']['F_'.$fkey]=(float)$xml->$fid;
						}
					break;
					case 'fk_user':
						$rows=0;
						$allUsers=$this->_frm->searchUser($rows,'',0,0,0,0);
						$values=array();
						if (count($xml->$fid->children())) {
							foreach ($xml->$fid->children() as $node) {
								if ($test=trim((string)$node)) {
									foreach($allUsers as $v) {
										if ($v['username']==$test || $v['firstname'].' '.$v['lastname']==$test || $v['lastname'].' '.$v['firstname']==$test || $v['email']==$test) {
											$values[]='u_'.$v['uidGroup-e'];
											break;
										}
									}
								}
							}

						} elseif ($test=trim((string)$xml->$fid)) {
							foreach($allUsers as $v) {
								if ($v['username']==$test || $v['firstname'].' '.$v['lastname']==$test || $v['lastname'].' '.$v['firstname']==$test || $v['email']==$test) {
									$values[]='u_'.$v['uidGroup-e'];
									break;
								}
							}
						}
						if (!empty($values)) {
							$result['default']['F_'.$fkey]=implode("|",$values);
						}
					break;
					default:
						if (count($xml->$fid->children())) {
							$values=array();
							foreach ($xml->$fid->children() as $node) {
								if (trim((string)$node)) {
									$values[]=trim((string)$node);
								}
							}
							$result['default']['F_'.$fkey]=implode("\n",$values);
						} elseif (trim((string)$xml->$fid)) {
							$result['default']['F_'.$fkey]=trim((string)$xml->$fid);
						}
						//debug($fval->getMeta('Typ'));
					break;
				}
			}
		}
		//debug($result);
		return $result;
	}
	function existsAddr($AObj) {
		$searchAddr=array();
		$searchAddr[]=array('Field'=>'UserID','Typ'=>'=','Values'=>0);
		$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);


		if ($AObj->getMeta('Nachname')) {
			$searchAddr[]=array('Field'=>'Nachname','Typ'=>'=','Values'=>$AObj->getMeta('Nachname'));
		}
		if ($AObj->getMeta('Vorname')) {
			$searchAddr[]=array('Field'=>'Vorname','Typ'=>'=','Values'=>$AObj->getMeta('Vorname'));
		}
		if ($AObj->getMeta('Firma')) {
			$searchAddr[]=array('Field'=>'Firma','Typ'=>'=','Values'=>$AObj->getMeta('Firma'));
		}
		if ($AObj->getMeta('Email')) {
			$searchAddr[]=array('Field'=>array('Email'),'Typ'=>'concat','Values'=>Addr::AddrExplode($AObj->getMeta('Email')),'UseCase'=>0,'OnlyWords'=>1);
		}
		//debug($searchAddr);
		if ($AObj=$this->_Addr->searchSingleAddr($searchAddr)) {
			return $AObj;
		}
		return false;
	}

	function getChangeAddressGui($id,$AObj,$changes) {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FormGui.php');
		$defBtnList=$changes;
		if (isset($this->_default['unsetAddrChange'])) {
			foreach($this->_default['unsetAddrChange'] as $v) {
				unset($defBtnList[$v]);
			}
		}
		$btnList=new CheckBoxBtn('geAddrChgListID_'.$id.'[]',array_keys($defBtnList));

		$funcSelAll=new FunctionButtons('geAddrChgListAll_'.$id.'','selectall',array('ListID'=>'geAddrChgListID_'.$id.'[]','ListOn'=>false));

		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		$nowrap=false;
		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tabGui->setName($AObj->getName());
		$tabGui->setStyle('width:100%');
		$tabGui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));
		$tabGui->setAutoBg(APP_FG10COLOR);

		if (count($changes)) {
			$funcSelAll=new FunctionButtons('geAddrChgListAll_'.$id.'','selectall',array('ListID'=>'geAddrChgListID_'.$id.'[]','ListOn'=>false));
			$tabGui->addHeaderCol('ListID',$funcSelAll,'','','',1,'1%',0,'');
		}
		$tabGui->addHeaderCol('LogField',$this->_T->lang('[[Feld]]'),'','','',1,'200');
		$tabGui->addHeaderCol('OldValue',$this->_T->lang('[[Alter Wert]]'),'','','',1,'300');
		$tabGui->addHeaderCol('NewValue',$this->_T->lang('[[Neuer Wert]]'),'','','',1,'300');
		
		foreach ($changes as $k=>$values) {
			$tabGui->addRow(0,'top','',1);
			$tabGui->addCol('ListID',$btnList->process($k),'','','',1,'1%',0,'',$noEnc);
			$tabGui->addCol('LogField',$this->_Addr->getFieldData($k,'Title'),'','','',0,'');
			$tmp=$this->_Addr->AddrExplode($values[0]);
			$this->_Addr->entry2Value($k,$tmp,$nowrap);
			$tabGui->addCol('OldValue',implode("\n",$tmp),'','','',0,'');
			$tmp=$this->_Addr->AddrExplode($values[1]);
			$this->_Addr->entry2Value($k,$tmp,$nowrap);
			$tabGui->addCol('NewValue',implode("\n",$tmp),'','','',0,'');
		}
		if (count($changes)) {

		} else {
			$tabGui->addRow(0,'top','',1);
			$tabGui->addCol('LogField',$this->_T->lang('[[Keine Aenderungen]]'),'','','',0,'',4);
		}



		return $tabGui;
	}

}
?>