<?php
class ProjectPrefsGui {
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	function ProjectPrefsGui() {
		global $frm,$t,$T,$E,$L,$P,$app;
		$this->_Base=& $frm->getStaticModul('proj');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_apps=$app;
	}
	function &process() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		$Gui=new ContentGui();
		$Gui->setName($this->_T->lang('[[Einstellungen fuer Projekte]]'));
		$btSave=new FunctionButtons('save','save');
		$Gui->addFunction($btSave);
		$Gui->addContent($this->getPrefsGui());
		return $Gui;
	}

	function &getPrefsGui() {
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$box=new BoxGui($this->_Base->getModul().'|showtab_prefs');
		$box->addTab('meta',$this->_T->lang('[[Quicklist]]'),'#',true);
		$Gui_1=new TemplateGui('core/form_3columns.inc.html');
		$Gui_1->addContent('form1',$this->getQuickListPrefs(),'FORM1');
		$box->setTabContent('meta',$Gui_1);

		$box->addTab('meta2',$this->_T->lang('[[Listenansicht]]'),'#',true);
		$Gui_2=new TemplateGui('core/form_3columns.inc.html');
		$Gui_2->addContent('form1',$this->getProjectListPrefs(),'FORM1');
		$box->setTabContent('meta2',$Gui_2);
		$box->setTabOn('meta');
		$tplContent->addContent('content',$box,'CONTENT');
		return $tplContent;
	}
	function &getProjectListPrefs() {
		require_once('lib/class_FormGui.php');
		$formGui=new FormGui();
		$formGui->setLabelClass('no','no_error');
		if ($this->_P->isRuleUser()) {
			$key='defViewAllPrj';
			$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Projekte]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$formGui->setValues($key,array(0=>$this->_T->lang('[[projViewMyPrj]]'),1=>$this->_T->lang('[[projViewAllPrj]]')));
			$formGui->setLabelClass('','',$key);
		}
		$defViewListArray=array('FKProfileID'=>$this->_T->lang('[[Profil]]'));
		$defViewListArray=array('Text'=>$this->_T->lang('[[Beschreibung]]'));
		$allRules=$this->_Base->getAvRules();
		foreach($allRules as $key=>$val) {
			$defViewListArray['rule_'.$key]=$this->_T->lang($val);
		}
		$defViewListArray['UserCreate']=$this->_T->lang('[[Erstellt von]]');
		$defViewListArray['TimeCreate']=$this->_T->lang('[[Erstellt am]]');
		$defViewListArray['UserModify']=$this->_T->lang('[[Geaendert von]]');
		$defViewListArray['TimeModify']=$this->_T->lang('[[Geaendert am]]');

		$key='defViewList';
		$formGui->addField($key,'checklist_v',$this->_T->lang('[[Angezeigte Felder]]'),explode(',',$this->_frm->getPrefs('proj',$key)),'fields1');
		$formGui->setValues($key,$defViewListArray);
		$formGui->setLabelClass('','',$key);

		$key='defViewListNum';
		$formGui->addField($key,'select',$this->_T->lang('[[projViewZefNum]]'),$this->_frm->getPrefs('proj',$key)?$this->_frm->getPrefs('proj',$key):50,'fields1');
		$formGui->setValues($key,array(20=>20,50=>50,100=>100,500=>500));

		if (Framework::getParam('save_x','0','P')) {
			$formGui->checkFields();

			if (!$this->_E->isError()) {
				$prefs=array();
				$formGui->addMetaToArray($prefs);
				if (is_array($prefs['defViewList'])) $prefs['defViewList']=implode(',',$prefs['defViewList']);
				$this->_frm->insertPrefs('proj',$prefs);
				//$this->_L->goToLink();
			}
		}
		return $formGui;
	}
	function &getQuickListPrefs() {
		require_once('lib/class_FormGui.php');
		$formGui=new FormGui();
		$formGui->setLabelClass('no','no_error');


		if ($this->_apps['task']) {
			$key='lbl1';
			$formGui->addField($key,'label',$this->_T->lang('[[Aufgaben]]'),'','fields1');
			$formGui->setLabelClass('','',$key);
			$key='defViewTask';
			$formGui->addField($key,'check',$this->_T->lang('[[projViewTask]]'),$this->_frm->getPrefs('proj',$key),'fields1');
		}
		if ($this->_apps['cal']) {
			$key='lbl2';
			$formGui->addField($key,'label',$this->_T->lang('[[Termine]]'),'','fields1');
			$formGui->setLabelClass('','',$key);
			$key='defViewCal';
			$formGui->addField($key,'check',$this->_T->lang('[[projViewCal]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$key='defViewCalNum';
			$formGui->addField($key,'select',$this->_T->lang('[[projViewCalNum]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$formGui->setValues($key,array(2=>2,5=>5,10=>10,30=>30,0=>$this->_T->lang('[[Alle]]')));
		}
		if ($this->_apps['addr']) {
			$key='lbl3';
			$formGui->addField($key,'label',$this->_T->lang('[[Adressen]]'),'','fields1');
			$formGui->setLabelClass('','',$key);
			$key='defViewAddr';
			$formGui->addField($key,'check',$this->_T->lang('[[projViewAddr]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$key='defViewAddrMode';
			$formGui->addField($key,'radiolist_h',$this->_T->lang('[[projViewAddrMode]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$formGui->setValues($key,array(0=>$this->_T->lang('[[projViewAddrMode1]]'),1=>$this->_T->lang('[[projViewAddrMode2]]')));
		}
		if ($this->_apps['zef']) {
			$key='lbl4';
			$formGui->addField($key,'label',$this->_T->lang('[[Zeitjournal]]'),'','fields1');
			$formGui->setLabelClass('','',$key);
			$key='defViewZef';
			$formGui->addField($key,'check',$this->_T->lang('[[projViewZef]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$key='defViewZefNum';
			$formGui->addField($key,'select',$this->_T->lang('[[projViewZefNum]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$formGui->setValues($key,array(2=>2,5=>5,10=>10,20=>20,0=>$this->_T->lang('[[Alle]]')));
		}
		if ($this->_apps['email'] && $this->_Base->getCfg('cfg/ProjectMailBox')) {
			$key='lbl5';
			$formGui->addField($key,'label',$this->_T->lang('[[E-Mail]]'),'','fields1');
			$formGui->setLabelClass('','',$key);
			$key='defViewMail';
			$formGui->addField($key,'check',$this->_T->lang('[[projViewMail]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$key='defViewMailMode';
			$formGui->addField($key,'radiolist_h',$this->_T->lang('[[projViewMailMode]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$formGui->setValues($key,array(0=>$this->_T->lang('[[projViewMailMode1]]'),1=>$this->_T->lang('[[projViewMailMode2]]')));
			$key='defViewMailNum';
			$formGui->addField($key,'select',$this->_T->lang('[[projViewMailNum]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$formGui->setValues($key,array(2=>2,5=>5,10=>10,20=>20,0=>$this->_T->lang('[[Alle]]')));

			$key='defMailNoAutoAbbo';
			$formGui->addField($key,'radiolist_h',$this->_T->lang('[[defMailNoAutoAbbo]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$formGui->setValues($key,array(0=>$this->_T->lang('[[Ja]]'),1=>$this->_T->lang('[[Nein]]')));


		}
		if ($this->_apps['smb'] && $this->_Base->getCfg('cfg/ProjectSmbBox')) {
			$key='lbl6';
			$formGui->addField($key,'label',$this->_T->lang('[[Dateien]]').' (Samba)','','fields1');
			$formGui->setLabelClass('','',$key);
			$key='defViewSmb';
			$formGui->addField($key,'check',$this->_T->lang('[[projViewSmb]]'),$this->_frm->getPrefs('proj',$key),'fields1');
		}
		if ($this->_apps['fmng'] && $this->_Base->getCfg('cfg/ProjectFmngBox')) {
			$key='lbl7';
			$formGui->addField($key,'label',$this->_T->lang('[[Dateien]]').' (Virtual)','','fields1');
			$formGui->setLabelClass('','',$key);
			$key='defViewFmng';
			$formGui->addField($key,'check',$this->_T->lang('[[projViewFmng]]'),$this->_frm->getPrefs('proj',$key),'fields1');
		}
		if ($this->_apps['stel']) {
			$key='lbl8';
			$formGui->addField($key,'label',$this->_T->lang('[[Anrufjournal]]'),'','fields1');
			$formGui->setLabelClass('','',$key);
			$key='defViewStel';
			$formGui->addField($key,'check',$this->_T->lang('[[projViewStel]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$key='defViewStelNum';
			$formGui->addField($key,'select',$this->_T->lang('[[projViewStelNum]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$formGui->setValues($key,array(2=>2,5=>5,10=>10,20=>20,0=>$this->_T->lang('[[Alle]]')));
			$key='defViewStelMode';
			$formGui->addField($key,'radiolist_h',$this->_T->lang('[[projViewStelMode]]'),$this->_frm->getPrefs('proj',$key),'fields1');
			$formGui->setValues($key,array(0=>$this->_T->lang('[[projViewStelMode1]]'),1=>$this->_T->lang('[[projViewStelMode2]]')));
		}
		if (Framework::getParam('save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$prefs=array();
				$formGui->addMetaToArray($prefs);
				//debug($prefs);
				$this->_frm->insertPrefs('proj',$prefs);
				//$this->_L->goToLink();
			}
		}
		return $formGui;
	}
}