<?php
class ProjectPrintGui {
	var $_Base;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_avTables=array();
	var $_cbValue=array();
	function ProjectPrintGui() {
		require_once("lib/uform/class_UserFormPrintGui.php");
		global $frm,$t,$T,$E,$L;
		$this->_BaseTpl=& $frm->getStaticModul('print_tpl');
		$this->_Base=& $frm->getStaticModul('proj');
		$this->_BasePrf=$frm->getStaticModul('proj_profiles');
		$this->_BaseForm=& $frm->getStaticModul('uform');
		$this->_BaseForm->setFormModul('proj');
		$this->_uFormDataPrj=$this->_Base->initUform();
		$this->_T=&$T;
		$this->_T->loadModul('uform');
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_viewAll=$this->getPrefs('defViewAllPrj') && $this->_Base->isRuleUser();
	}
	function setValueCallBack($typ,$callBack) {
		$this->_cbValue[$typ]=&$callBack;
	}
	function initTemplate($tplPrint) {
		$tplData=implode(file($tplPrint));
		$matches=array();
		if (preg_match_all('/<!--\s*LOAD_FORM\s*:\s*([_A-Za-z0-9]+)\s*-->/',$tplData,$matches)) {
			$this->_avTables=array_unique($matches[1]);
			foreach ($this->_avTables as $val) {
				if (!is_object($this->_uFormPrint[$val])) {
					$formObj[$val]=$this->_BaseForm->refExists($val);
					if (is_object($formObj[$val])) {
						$this->_uFormPrint[$formObj[$val]->getMeta('RefID')]=new UserFormPrintGui();
						$this->_uFormPrint[$formObj[$val]->getMeta('RefID')]->setFormObj($formObj[$val]);
						foreach ($this->_cbValue as $ckey=>$cval) {
							$this->_uFormPrint[$formObj[$val]->getMeta('RefID')]->setValueCallBack($ckey,$cval);
						}
					}
				}
			}
		}
	}
	function printObj(&$prjObj,$tplID=0) {
		require_once('lib/class_MySmartyGui.php');
		$Gui=new MySmartyGui();
		$tplPrint='';
		$tplPrint=$this->getPrintTemplate('obj',$tplID);
		$this->initTemplate($tplPrint);

		$Config['FieldsTree']=array(
			'project'=>array(
				'meta'=>array(
					'Number',
					'Name',
					'Profil',
					'Members_1',
					'Members_2',
					'Members_3',
				),
			),
		);
		$Config['Fields']['project']=$this->getMetaTitles();
		foreach ($this->_avTables as $RefID) {
			if (isset($this->_uFormPrint[$RefID])) {
				$formObj=$this->_uFormPrint[$RefID]->getFormObj();
				if ($formObj->getMeta('System')=='proj') {
					$Config['Forms'][$RefID]=array('Title'=>$prjObj->getName());
				} else {
					$Config['Forms'][$RefID]=array('Title'=>$formObj->getName());
				}
				if (!isset($Config['Fields'][$RefID])) $Config['Fields'][$RefID]=array();
				$Config['Fields'][$RefID]+=$this->_uFormPrint[$RefID]->getFieldsData();
				if (!isset($Config['FieldsTree'][$RefID])) $Config['FieldsTree'][$RefID]=array();
				$Config['FieldsTree'][$RefID]+=$this->_uFormPrint[$RefID]->getFieldsConfig();
			}
		}
		//debug($Config);

		$Gui->assign('proj_Config',$Config);
		$entriesView=$this->formatEntry($prjObj);
		//debug($entriesView);
		$Gui->assign('proj_Entry',$entriesView);
		$Gui->display($tplPrint);
		exit;

	}
	function printList(&$entries,$tplID=0,$Config=array()) {
		require_once('lib/class_MySmartyGui.php');
		$Gui=new MySmartyGui();
		$tplPrint='';
		$tplPrint=$this->getPrintTemplate('list',$tplID);
		$this->initTemplate($tplPrint);
		$Config['listFields']['project']=array(
			'Number',
			'Name',
			'Profile',
		);
		$dFields=explode(',',$this->getPrefs('defViewList'));
		foreach ($this->_Base->getAvRules() as $key=>$val) {
			if (in_array('rule_'.$key,$dFields)) {
				$Config['listFields']['project'][]='Members_'.$key;
			}
		}

		foreach ($this->_uFormDataPrj->getListFieldsShow() as $ID=>$Fval) {
			$fObj=$this->_uFormDataPrj->getFieldObj($ID);
			if (is_object($fObj)) {
				$Config['listFields']['project'][]=$fObj->getMeta('RefID');
			}
		}
		$Config['FieldsTree']=array(
			'project'=>array(
				'meta'=>array(
					'Number',
					'Name',
					'Profil',
				),
			),
		);
		foreach ($this->_Base->getAvRules() as $key=>$val) {
			$Config['FieldsTree']['project']['meta'][]='Members_'.$key;
		}
		$Config['Fields']['project']=$this->getMetaTitles();
		foreach ($this->_avTables as $RefID) {
			if (isset($this->_uFormPrint[$RefID])) {
				$formObj=$this->_uFormPrint[$RefID]->getFormObj();
				$Config['Forms'][$RefID]=array('Title'=>$formObj->getName());
				if (!isset($Config['Fields'][$RefID])) $Config['Fields'][$RefID]=array();
				$Config['Fields'][$RefID]+=$this->_uFormPrint[$RefID]->getFieldsData();
				if (!isset($Config['FieldsTree'][$RefID])) $Config['FieldsTree'][$RefID]=array();
				$Config['FieldsTree'][$RefID]+=$this->_uFormPrint[$RefID]->getFieldsConfig();
			}
		}
		//debug($Config);

		$Gui->assign('proj_Config',$Config);
		$entriesView=array();
		foreach ($entries as $key=>$val) {
			$entriesView[$key]=$this->formatEntry($val);
		}
		$Gui->assign('proj_Entries',$entriesView);
		$Gui->display($tplPrint);
		exit;

	}
	function getMetaTitles() {
		$result=array();
		$result['meta']=array(
			'Title'=>$this->_T->lang('[[Metadaten]]'),
			'ListTitle'=>$this->_T->lang('[[Metadaten]]'),
		);
		$result['Number']=array(
			'Title'=>$this->_T->lang('[[Projektnummer]]'),
			'ListTitle'=>$this->_T->lang('[[Projektnummer]]'),
		);
		$result['Name']=array(
			'Title'=>$this->_T->lang('[[Projektname]]'),
			'ListTitle'=>$this->_T->lang('[[Projektname]]'),
		);
		$result['Description']=array(
			'Title'=>$this->_T->lang('[[Beschreibung]]'),
			'ListTitle'=>$this->_T->lang('[[Beschreibung]]'),
		);
		$result['Profile']=array(
			'Title'=>$this->_T->lang('[[Profil]]'),
			'ListTitle'=>$this->_T->lang('[[Profil]]'),
		);
		$result['Owner']=array(
			'Title'=>$this->_T->lang('[[Besitzer]]'),
			'ListTitle'=>$this->_T->lang('[[Besitzer]]'),
		);
		$avRules=$this->_Base->getAvRules();
		foreach ($avRules as $rkey=>$rval) {
			$result['Members_'.$rkey]=array(
				'Title'=>$this->_T->lang($rval),
				'ListTitle'=>$this->_T->lang($rval),
			);
		}
		return $result;
	}

	function formatEntry(&$Obj) {
		$result=array();
		foreach ($this->_avTables as $RefID) {
			if (isset($this->_uFormPrint[$RefID])) {
				$formObj=$this->_uFormPrint[$RefID]->getFormObj();
				if ($this->_viewAll) {
					$formPerms=1;
				} elseif ($formObj->getMeta('System')=='proj') {
					$myRules=$this->_Base->getMyProjectRules($Obj->getID());
					$this->_uFormPrint[$RefID]->setUsePerms($myRules);
					$formPerms=1;
				} else {
					$formPerms=$this->_Base->checkProjectPerms($Obj->getID(),'doc',0,0,$formObj->getID());
				}
				$this->_uFormPrint[$RefID]->setStaticVisibility($Obj->_meta);
				$result[$RefID]=$this->_uFormPrint[$RefID]->getFormValues($Obj->getID(),$formPerms);
			}
		}
		$result['project']['meta']['Value']='';
		$result['project']['meta']['Show']=1;
		$result['project']['Number']['Value']=$Obj->getMeta('ProjNumTxt');
		$result['project']['Number']['Show']=1;
		$result['project']['Name']['Value']=$Obj->getMeta('Title');
		$result['project']['Name']['Show']=1;
		$result['project']['Description']['Value']=$Obj->getMeta('Text');
		$result['project']['Description']['Show']=1;
		$result['project']['Profile']['Value']=$this->_BasePrf->getCachedProfileName($Obj->getMeta('FKProfileID'));
		$result['project']['Profile']['Show']=1;
		$result['project']['ProfileID']['Value']=$Obj->getMeta('FKProfileID');
		$result['project']['ProfileID']['Show']=1;
		$result['project']['Owner']['Value']=$this->_frm->getCachedUserName($Obj->getMeta('UserCreate'));
		$result['project']['Owner']['Show']=1;
		$result['project']['OwnerID']['Value']=$Obj->getMeta('UserCreate');
		$result['project']['OwnerID']['Show']=1;
		$avRules=$this->_Base->getAvRules();
		foreach ($avRules as $rkey=>$rval) {
			$userTitles=array();
			$groupID=$this->_Base->getRuleGroupID($Obj,$rkey);
			$users=$this->_frm->getGroupUsers($groupID);
			if (!empty($users)) {
				$userTitles=$this->_frm->getFullName($users);
			}
			$result['project']['Members_'.$rkey]['Value']=$userTitles;
			$result['project']['Members_'.$rkey]['Show']=1;
		}
		return $result;
	}
	function getPrintTemplate($Typ,$tplID=0) {
		if ($tplID) {
			$tplPrint=realpath($this->_BaseTpl->getPrintTemplate($tplID,1));
			//debug($tplPrint);
		} else {
			switch ($Typ) {
				case 'list':
					$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/proj/utf8.print_proj_list.inc.html';
				break;
				case 'obj':
					$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/proj/utf8.print_proj_obj.inc.html';
				break;
				case 'doc':
					$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/uform/utf8.print_obj.inc.html';
				break;
			}
		}
		return realpath($tplPrint);
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
}
?>