<?php
class ProtAdminGui {
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_avSelect=array();
	function __construct() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=$frm->getStaticModul('prot');
		$this->_BaseSel=$frm->getStaticModul('prot_sel');
		$this->_BaseSlo=$frm->getStaticModul('prot_slo');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('prot');
	}
	function _handleRequest() {
		$this->_mode=Framework::getParam('mode','prot_slo','G');
		switch ($this->_mode) {
			case 'prot_cfg':
				$this->_avSelect=array(
					'dok'=>$this->_T->lang('[[Dokumentart]]'),
					'inh'=>$this->_T->lang('[[Inhaltstyp]]'),
					'auf'=>$this->_T->lang('[[Auftraggeber]]'),
					'abl'=>$this->_T->lang('[[Ablageort]]'),
				);
				$this->_action=Framework::getParam('action','b','G');

				$this->_oid=Framework::getParam('oid',0,'G');
				if ($this->_oid && ($this->_Obj=$this->_BaseSel->getObj($this->_oid,true))) {
					$this->_skey=$this->_Obj->getMeta('protSelTyp');
				} else {
					$this->_skey=Framework::getParam('skey',key($this->_avSelect),'G');
				}

				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('oid');
							$this->_L->goToLink();
						break;
						case 'delete':
							if ($this->_oid && $this->_Obj) {
								if ($this->_BaseSel->deleteObj($this->_Obj)) {
									$this->_L->unsetParam(array('oid','action'));
									$this->_L->goToLink();
								}
							}
						break;
						default:
							//debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
				$this->_ObjActionGui=$this->getObjActionGui('prot_cfg');
			break;
			case 'prot_slo':
				$this->_action=Framework::getParam('action','b','G');
				$this->_oid=Framework::getParam('oid',0,'G');
				if ($this->_oid && ($this->_Obj=$this->_BaseSlo->getObj($this->_oid,true))) {

				} else {
					$this->_oid=0;
				}
				if (Framework::getParam('_clTab',0,'G')) {
					$this->setPrefs('tabProtSlo',Framework::getParam('_clTab',0,'G'));
				}

				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('oid');
							$this->_L->goToLink();
						break;
						case 'delete':
							if ($this->_oid && $this->_Obj) {
								if ($this->_BaseSlo->deleteObj($this->_Obj)) {
									$this->_L->unsetParam(array('oid','action'));
									$this->_L->goToLink();
								}
							}
						break;
						default:
							//debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
				$this->_ObjActionGui=$this->getObjActionGui('prot_slo');
			break;
			case 'prot_print':
				if (Framework::getParam('_getPrintTpl','','G')) {
					require_once('lib/prot/class_ProtokollPrintGui.php');
					$printGui=new ProtokollPrintGui();
					$tpl=$printGui->getPrintTemplate(Framework::getParam('_getPrintTpl','','G'));
					//debug($tpl);
					Framework::dumpFile($tpl,$this->_T->lang('[[Vorlage]]').'.html','application/save');
					exit;
				}
				$this->_obj_action='';
				$this->_PrintTemplatesGui=& $this->_frm->getStaticGuiModul('core','PrintTemplatesGui');
				$guiCfg=array(
					'defAction'=>'b',
					'defMode'=>'print_tpl',
					'showTree'=>false,
					'defOid'=>0,
					'avTyps'=>array(
						'obj'=>$this->_T->lang('[[Detailansicht]]'),
					),
					'systemTpls'=>array(
						'obj'=>array(array('Name'=>$this->_T->lang('[[Standard]]'),'Link'=>$this->_L->getTempLink(null,array('_getPrintTpl'=>'obj')))),
					),
					'usePerms'=>array(),
					'usePermsRules'=>array(),
				);
				$this->_PrintTemplatesGui->setGuiCfg($guiCfg);
				$this->_PrintTemplatesGui->setModul('prot');
				$this->_PrintTemplatesGui->handleRequest();
				$this->_ObjActionGui=$this->_PrintTemplatesGui->getObjActionGui();
			break;
		}
	}
	function &getAdminHeader() {
		require_once("lib/class_ContentGui.php");
		$hGui=new ContentGui();
		$hGui->setName($this->_frm->getAppName('prot'));
		$hGui->addTab('prot_slo',$this->_T->lang('[[Protokollslots]]'),"index.php?site=admin.php&ac=prot&mode=prot_slo");
		$hGui->addTab('prot_cfg',$this->_T->lang('[[Hilfstabellen]]'),"index.php?site=admin.php&ac=prot&mode=prot_cfg");
		$hGui->addTab('prot_print',$this->_T->lang('[[Druckvorlagen]]'),"index.php?site=admin.php&ac=prot&mode=prot_print");
		$hGui->setTabOn($this->_mode);
		if ($this->_ObjActionGui) {
			$hGui->addFunction($this->_ObjActionGui);
		}
		return $hGui;
	}
	function process(&$AppGui) {
		$this->_handleRequest();
		$AppGui->addContent($this->getAdminHeader());

		switch ($this->_mode) {
			case 'prot_cfg':
				require_once('lib/class_ApplicationTreeGui.php');
				$Cont=new ApplicationTreeGui();
				$Cont->addTreeContent($this->listProtSelTyp());
				switch ($this->_action) {
					case 'n':
						$Cont->addContent($this->newProtSel());
					break;
					default:
						$Cont->addContent($this->listProtSel());
					break;
				}
				$AppGui->addContent($Cont);

			break;
			case 'prot_slo':
				require_once('lib/class_ApplicationTreeGui.php');
				switch ($this->_action) {
					case 'n':
						$AppGui->addContent($this->newProtSlo());
					break;
					default:
						$AppGui->addContent($this->listProtSlo());
					break;
				}
			break;
			case 'prot_print':
				$Gui=$this->_PrintTemplatesGui->process(false);
				$AppGui->addContent($Gui);
			break;
		}
		$AppGui->setFormAction($this->_L->getLink());
	}
	function &listProtSelTyp() {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		//$tabGui->setName($this->_T->lang('[[Rechte Profil]]'));
		//$tabGui->addHeaderCol('Name',$this->_T->lang('[[Spesentabellen]]'),'','','','','',2);
		foreach ($this->_avSelect as $key=>$val) {
			if ($key==$this->_skey) {
				$hl=2;
			} else {
				$hl=0;
			}
			$tabGui->addRow($hl);
			$tabGui->addCol('IMG','','obj_img/ex_tree.gif');
			$tabGui->addCol('Name',$val,'',$this->_L->getTempLink(array('oid'),array('skey'=>$key,'action'=>'b')),'',0,'2000');
		}
		return $tabGui;
	}
	function &listProtSel() {
		require_once('lib/class_ApplicationListGui.php');
		$Gui=new ApplicationListGui();
		$Gui->setName($this->_avSelect[$this->_skey]);
		switch ($this->_skey) {
			default:
				$entries=$this->_BaseSel->listObj(array('typ'=>$this->_skey));
				$Gui->addHeaderCol('Title',$this->_T->lang('[[Bezeichnung]]'),'','','',0,2000);
				$Gui->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','',1);
				$Gui->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);
				foreach ($entries as $key=>$val) {
					$Gui->addRow(($hl?$hl=0:$hl=1),'top');
					$Gui->addCol('Title',$val->getMeta('protSelName'),'',$this->_L->getTempLink(null,array('oid'=>$key,'action'=>'n')),'',1,'');
					$Gui->addCol('TimeModify',$val->getMeta('TimeModify')?date('d.m.Y',$val->getMeta('TimeModify')):'','','','','1');
					$Gui->addCol('UserModify',$val->getMeta('UserModify')?$this->_frm->getCachedUserName($val->getMeta('UserModify')):'','','','',1);
				}
			break;
		}
		return $Gui;
	}
	function newProtSel() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_oid) {
			$Gui->setName($this->_T->lang('[[Neuer Eintrag]]'));
		} else {
			$Gui->setName($this->_T->lang('[[Eintrag bearbeiten]]'));
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'|protAdminNull');
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getProtSelMetaGui());
		}
		$box->setTabOn('meta');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getProtSelMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		$defTrans=array();
		if (Framework::getParam('isset_oneLang',0,'P')) {
			$defOneLang=Framework::getParam('oneLang',0,'P');
		} elseif ($this->_Obj) {
			$defOneLang=1;
			$defTrans['protSelName']=$this->_Obj->getTrans('protSelName');
			foreach ($this->_frm->getMaLang() as $lang) {
				if ($defTrans['protSelName'][$lang]!=$defTrans['protSelName'][$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
			}
		} else {
			$defOneLang=1;
		}
		foreach ($this->_frm->getMaLang() as $lang) {
			$key1='Trans[protSelName]['.$lang.']';
			$formGui->addField($key1,'text',$this->_T->lang('[[Name]]').' '.strtoupper($lang),$defTrans['protSelName'][$lang],'form_fields1');
			$formGui->setNoMeta($key1);

			if ($lang!=$this->_frm->getLang()) {
				if ($defOneLang) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key1,$attribs);
				} else {
					$formGui->setRequired($key1);
				}
			} else {
				$formGui->setRequired($key1);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'form_fields1');
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $lang2) {
					if ($lang2!=$lang) {
						$attribs['onchange'].="disableEnable('Trans[protSelName][".$lang2."]',this,this.checked?0:1);";
					}
				}
				//debug($attribs);
				$formGui->setAttribs($key,$attribs);
			}
		}
		$key='submit';
		$submitVals=array(
			'meta_save_x'=>$this->_T->lang('[[Speichern]]')
		);

		$formGui->addField($key,'submit','','','form_submit');
		$formGui->setValues($key,$submitVals);

		if (Framework::getParam('meta_delete_x','0','P')) {
			$this->_BaseSel->deleteObj($this->_Obj);
			$this->_L->unsetParam('oid');
			$this->_L->setParam('action','b');
			$this->_L->goToLink();
		}
		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {

				$ObjTrans=array();
				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans['protSelName'][$val]=$formGui->getFieldVal('Trans[protSelName]['.$this->_frm->getLang().']');
					}
				} else {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans['protSelName'][$val]=$formGui->getFieldVal('Trans[protSelName]['.$val.']');
					}
				}
				if (!is_object($this->_Obj)) {
					$this->_Obj=new ObjProtSelect();
				}
				$formGui->addMetaToObj($this->_Obj);

				$this->_Obj->setTrans('protSelName',$ObjTrans['protSelName']);

				if ($this->_oid) {
					$this->_BaseSel->updateObj($this->_Obj);
				} else {
					$this->_Obj->setMeta('protSelTyp',$this->_skey);
					$this->_oid=$this->_BaseSel->insertObj($this->_Obj);
				}
				$this->_L->unsetParam('oid');
				$this->_L->setParam('action','b');
				$this->_L->goToLink();

			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}
	function &listProtSlo() {
		require_once('lib/class_ApplicationListGui.php');
		$Gui=new ApplicationListGui();
		$Gui->setName($this->_avSelect[$this->_skey]);
		switch ($this->_skey) {
			default:
				$entries=$this->_BaseSlo->listObj();
				//debug($entries);
				$Gui->addHeaderCol('Title',$this->_T->lang('[[Bezeichnung]]'),'','','',1);
				$Gui->addHeaderCol('NextNumber',$this->_T->lang('[[Naechste freie Nummer]]'),'','','',0,2000);


				$Gui->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','',1);
				$Gui->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);
				foreach ($entries as $key=>$val) {
					$Gui->addRow(($hl?$hl=0:$hl=1),'top');
					$Gui->addCol('Title',$val->getMeta('protSlotName'),'',$this->_L->getTempLink(null,array('oid'=>$key,'action'=>'n')),'',1);
					$Gui->addCol('NextNumber',$this->_Base->getNextID($val),'','','','0',2000);
					$Gui->addCol('TimeModify',$val->getMeta('TimeModify')?date('d.m.Y',$val->getMeta('TimeModify')):'','','','','1');
					$Gui->addCol('UserModify',$val->getMeta('UserModify')?$this->_frm->getCachedUserName($val->getMeta('UserModify')):'','','','',1);
				}
			break;
		}
		return $Gui;
	}
	function newProtSlo() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_oid) {
			$Gui->setName($this->_T->lang('[[Neuer Eintrag]]'));
		} else {
			$Gui->setName($this->_T->lang('[[Eintrag bearbeiten]]'));
			$tabs[]='perms';
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'|tabProtSlo');
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getProtSloMetaGui());
		}
		if (in_array('perms',$tabs)) {
			$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
			$box->setTabContent('perms',$this->getProtPermsGui(true));
		}
		$show_tap=$this->getPrefs('tabProtSlo');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getProtSloMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		if ($this->_Obj && $this->_Base->isUsedSlot($this->_Obj)) {
			$disabled=true;
		} else {
			$disabled=false;
		}
		// BEGIN FORM Metadaten
		$defTrans=array();
		if (Framework::getParam('isset_oneLang',0,'P')) {
			$defOneLang=Framework::getParam('oneLang',0,'P');
		} elseif ($this->_Obj) {
			$defOneLang=1;
			$defTrans['protSlotName']=$this->_Obj->getTrans('protSlotName');
			foreach ($this->_frm->getMaLang() as $lang) {
				if ($defTrans['protSlotName'][$lang]!=$defTrans['protSlotName'][$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
			}
		} else {
			$defOneLang=1;
		}

		foreach ($this->_frm->getMaLang() as $lang) {
			$key1='Trans[protSlotName]['.$lang.']';
			$formGui->addField($key1,'text',$this->_T->lang('[[Name]]').' '.strtoupper($lang),$defTrans['protSlotName'][$lang],'form_fields1');
			$formGui->setNoMeta($key1);

			if ($lang!=$this->_frm->getLang()) {
				if ($defOneLang) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key1,$attribs);
				} else {
					$formGui->setRequired($key1);
				}
			} else {
				$formGui->setRequired($key1);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'form_fields1');
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $lang2) {
					if ($lang2!=$lang) {
						$attribs['onchange'].="disableEnable('Trans[protSlotName][".$lang2."]',this,this.checked?0:1);";
					}
				}
				//debug($attribs);
				$formGui->setAttribs($key,$attribs);
			}
		}

		/*protSlotTyp
		protSlotDefinition
 		protSlotStart
 		protSlotPermsUsers
		protSlotPermsGroups
 	 	protSlotNextID
 	 	protSlotDeleted*/

		$key='protSlotDefinition';
		$formGui->addField($key,'text',$this->_T->lang('[[Definition]]'),$this->_Obj?$this->_Obj->getMeta($key):'{YYYY}/{NNNNNN}','form_fields2');
		$formGui->setRequired($key);
		$formGui->setDisabled($key,$disabled);


		$key='protSlotNextID';
		$formGui->addField($key,'int',$this->_T->lang('[[Naechste freie Nummer]]'),$this->_Obj?$this->_Obj->getMeta($key):1,'form_fields2');
		$formGui->setRequired($key);
		$formGui->setDisabled($key,$disabled);

		$key='protSlotTyp';
		$formGui->addField($key,'select',$this->_T->lang('[[Nummer zuruecksetzen]]'),$this->_Obj?$this->_Obj->getMeta($key):'Y','form_fields2');
		$formGui->setValues($key,array('Y'=>$this->_T->Lang('[[Jaehrlich]]'),'N'=>$this->_T->Lang('[[Nie zuruecksetzen]]')));
		$formGui->setAttribs($key,array('style'=>'width:190px;'));
		$formGui->setIptAttribs($key,array('style'=>'float:left;width:200px;clear:none;'));
		$formGui->setDisabled($key,$disabled);

		$key='protSlotStart';
		$formGui->addField($key,'int',$this->_T->lang('[[auf]]'),$this->_Obj?$this->_Obj->getMeta($key):1,'form_fields2');
		$formGui->setAttribs($key,array('style'=>'width:100px;'));
		$formGui->setIptAttribs($key,array('style'=>'float:left;width:100px;clear:none;'));
		if ($formGui->getFieldVal('protSlotTyp',1)!='N') {
			$formGui->setRequired($key);
		}
		$formGui->setDisabled($key,$disabled);


		$key='submit';
		$submitVals=array(
			'meta_save_x'=>$this->_T->lang('[[Speichern]]')
		);
		$formGui->addField($key,'submit','','','form_submit');
		$formGui->setValues($key,$submitVals);

		if (Framework::getParam('meta_delete_x','0','P')) {
			$this->_BaseSel->deleteObj($this->_Obj);
			$this->_L->unsetParam('oid');
			$this->_L->setParam('action','b');
			$this->_L->goToLink();
		}
		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();

			if (!$disabled) {
				switch ($formGui->getFieldVal('protSlotTyp')) {
					case 'Y':
						if (!preg_match('/{YYYY}/',$formGui->getFieldVal('protSlotDefinition'))) {
							$this->_E->setError('fields','protSlotDefinition');
						}
					break;
				}
				if (!preg_match('/{[N]+}/',$formGui->getFieldVal('protSlotDefinition'))) {
					$this->_E->setError('fields','protSlotDefinition');
				}
			}

			if (!$this->_E->isError()) {

				$ObjTrans=array();
				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans['protSlotName'][$val]=$formGui->getFieldVal('Trans[protSlotName]['.$this->_frm->getLang().']');
					}
				} else {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans['protSlotName'][$val]=$formGui->getFieldVal('Trans[protSlotName]['.$val.']');
					}
				}
				if (!is_object($this->_Obj)) {
					$this->_Obj=new ObjProtSelect();
				}
				$formGui->addMetaToObj($this->_Obj);

				$this->_Obj->setTrans('protSlotName',$ObjTrans['protSlotName']);

				if ($this->_oid) {
					$this->_BaseSlo->updateObj($this->_Obj);
					$this->_L->unsetParam('oid');
					$this->_L->setParam('action','b');
					$this->_L->goToLink();
				} else {
					$this->_Obj->setMeta('protSelTyp',$this->_skey);
					$this->_oid=$this->_BaseSlo->insertObj($this->_Obj);
					$this->_L->setParam('oid',$this->_oid);
					$this->_L->setParam('_clTab','perms');
					$this->_L->goToLink();
				}
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}


	function &getProtPermsGui($perm_mode=0) {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');

		switch ($this->_mode) {
			default:
				$avPerms=array(
					1=>$this->_T->lang('[[Lesen]]'),
					2=>$this->_T->lang('[[Schreiben]]'),
					4=>$this->_T->lang('[[Sensible Daten lesen]]'),
				);
				$avPermsShort=array(
					1=>$this->_T->lang('[[Lesen]]'),
					2=>$this->_T->lang('[[Schreiben]]'),
					4=>$this->_T->lang('[[Sensible Daten lesen]]'),
				);
				$perms_g=Framework::aclToArray($this->_Obj->getMeta('protSlotPermsGroups'));
				$perms_u=Framework::aclToArray($this->_Obj->getMeta('protSlotPermsUsers'));
			break;
		}

		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		$key='addPermsUser';
		$mode='u|g';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'vac',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'vac',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);

		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,'','fields1');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));
		$formGui->setNoMeta($key);
		$formGui->addField('perms_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields3');


		if ($perm_mode) {
			$formGui->addField('addPermsID','checklist_v',$this->_T->lang('[[Rechte]]'),1,'fields2');
		} else {
			$formGui->addField('addPermsID','radiolist_v',$this->_T->lang('[[Rechte]]'),1,'fields2');
		}
		$formGui->setValues('addPermsID',$avPerms);


		$update=false;
		if (Framework::getParam('perms_add',0,'P') && Framework::getParam('addPermsID',0,'P') && trim($formGui->getFieldVal('addPermsUser'))) {
			$permsUsers=explode('|',$formGui->getFieldVal('addPermsUser'));
			foreach ($permsUsers as $val) {
				$tmp=explode('_',$val);
				switch($tmp[0]) {
					case 'u':
						if ($perm_mode) {
							$perms_u[$tmp[1]]=array_sum(Framework::getParam('addPermsID',0,'P'));
						} else {
							$perms_u[$tmp[1]]=Framework::getParam('addPermsID',0,'P');
						}
						switch ($this->_mode) {
							default:
								if (($perms_u[$tmp[1]] | 6) && !($perms_u[$tmp[1]] & 1)) {
									$perms_u[$tmp[1]]+=1;
								}
								$update=true;
							break;
						}
					break;
					case 'g':
						if ($perm_mode) {
							$perms_g[$tmp[1]]=array_sum(Framework::getParam('addPermsID',0,'P'));
						} else {
							$perms_g[$tmp[1]]=Framework::getParam('addPermsID',0,'P');
						}
						switch ($this->_mode) {
							default:
								if (($perms_g[$tmp[1]] | 6) && !($perms_g[$tmp[1]] & 1)) {
									$perms_g[$tmp[1]]+=1;
								}
								$update=true;
							break;
						}
					break;

				}

			}
		}
		if(is_array(Framework::getParam('permDeleteG_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteG_x',0,'P'));
			if ($key) {
				unset($perms_g[$key]);
				switch ($this->_mode) {
					default:
						$update=true;
					break;
				}
			}
		}
		if(is_array(Framework::getParam('permDeleteU_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteU_x',0,'P'));
			if ($key) {
				unset($perms_u[$key]);
				switch ($this->_mode) {
					default:
						$update=true;
					break;
				}
			}
		}
		if ($update) {
			switch ($this->_mode) {
				default:
					$this->_Obj->setMeta('protSlotPermsGroups',Framework::arrayToAcl($perms_g));
					$this->_Obj->setMeta('protSlotPermsUsers',Framework::arrayToAcl($perms_u));
					$this->_BaseSlo->updateObj($this->_Obj);
				break;
			}
		}

		//debug($perms_g);
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3_1',$formGui,'FORM3',array('','fields3'));
		$f32=$this->listProtPermsGui('PermsGroup',($perms_g),$avPermsShort,$perm_mode);
		$tplContent->addContent('form3_2',$f32,'FORM3');
		$f33=$this->listProtPermsGui('PermsUser',($perms_u),$avPermsShort,$perm_mode);
		$tplContent->addContent('form3_3',$f33,'FORM3');
		return $tplContent;
	}
	function &listProtPermsGui($ptype,$perms,$av_perms,$perm_mode=0,$prep='perm') {
		//debug($perms);
		if (!empty($perms)) {
			require_once('lib/class_ApplicationListGui.php');
			$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
			//$tabGui->setName($this->_T->lang('[[Sichtbar fuer]]'));
			switch ($ptype) {
				case 'PermsGroup':
					$title=$this->_T->lang('[[Gruppen]]');
					$perms_users=$this->_frm->getAllGroups(array_keys($perms));
					$img='gruppe.gif';
					$dbtn=$prep.'DeleteG_x';
				break;
				case 'PermsUser':
					$title=$this->_T->lang('[[BenutzerInnen]]');
					$perms_users=$this->_frm->getFullName(array_keys($perms),0,1);
					$img='user.gif';
					$dbtn=$prep.'DeleteU_x';
				break;
			}
			$tabGui->addHeaderCol('Name',$title,'','','',0,'',2);
			foreach ($av_perms as $pkey=>$pval) {
				$tabGui->addHeaderCol('Perms_'.$pkey,$pval,'','','',1);
			}
			$tabGui->addHeaderCol('Delete','','tras.gif');
			$tabGui->setLimit(0);
			$rows=0;$hl=0;
			foreach ($perms as $key=>$val) {
				//debug($val);
				$hl=$hl?0:1;
				$tabGui->addRow($hl);
				$tabGui->addCol('IMG','',$img);
				$tabGui->addCol('Name',$perms_users[$key],'','','',0,'2000');
				foreach ($av_perms as $pkey=>$pval) {
					if ($perm_mode) {
						$tabGui->addCol('Perms_'.$pkey,($val&$pkey)?'X':'','','','center',1);
					} else {
						$tabGui->addCol('Perms_'.$pkey,$pkey==$val?'X':'','','','center',1);
					}
				}
				$btn=new SubmitImgBtn ($dbtn.'['.$key.']','img/'.APP_THEME.'/loeschen.gif');
				$tabGui->addCol('Delete',$btn);
			}
		}
		return $tabGui;
	}
	function getObjActionGui($action) {
		require_once('lib/class_FunctionObjActionGui.php');
		$objActionGui=new FunctionObjActionGui();
		$obj_action=$this->_frm->getObjAction('admin',$action);
		$parse=false;
		foreach ($obj_action as $key=>$val) {
			if ($val['Hidden']) continue;
			$parse=true;
			$objActionGui->addValue($key,$val['Name']);
		}
		if ($parse) {
			return $objActionGui;
		}
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result) $result=$default;
		return $result;
	}

}
?>