<?php
class ObjProtSelect extends baseObj {
	var $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['protSelName'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class ProtSelect extends ObjCore {
	var $_modul='prot';
	var $_table='ProtSelect';
	var $_cfgObjects=array (
		'IdField'=>'protSelID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'TranslationFields'=>array('protSelName'),
		'0'=>array(
			'ClassName'=>'ObjProtSelect',
			'Fields'=>array(
				'protSelID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'protSelTyp'=>array(
					'Typ'=>'core',
				),
				'protSelName'=>array(
					'Typ'=>'core',
				),
				'protSelData'=>array(
					'Typ'=>'core',
				),
				'protSelDeleted'=>array(
					'Typ'=>'core',
				),
			),
		),
	);

	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','prot')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function insertObj(&$Obj) {
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		$Obj->setMeta('protSelDeleted',1);
		return $this->updateObj($Obj);
	}
	function listObj($search=array(),$b=0,$limit=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'protSelDeleted','Typ'=>'=','Values'=>0);
		if ($search['info']) {
			$searchQuery[]=array('Field'=>array('ProtSelect.protSelName'),'Typ'=>'concat','Values'=>$search['info']);
		}
		if ($search['typ']) {
			$searchQuery[]=array('Field'=>'ProtSelect.protSelTyp','Typ'=>'=','Values'=>$search['typ']);
		}
		$rows=0;
		return $this->searchObj($rows,$searchQuery,'ProtSelect.protSelName ASC',$b,$limit);
	}
}
?>
