<?php
class geRemCtrlCron {
	public $_Base;
	public $_frm;
	public $_T;
	public function __construct() {
		global $frm,$T;
		$this->_T=&$T;
		$this->_frm=&$frm;
		$this->_BaseRem=$this->_frm->getStaticModul('rem');
	}
	function process() {
		$data=$this->_BaseRem->listCronReminders();
		if (!empty($data['msg'])) {
			$this->processMsg($data['msg']);
		}
		if (!empty($data['mail'])) {
			$this->processMail($data['mail']);
		}
		if (!empty($data['sms'])) {
			$this->processSms($data['sms']);
		}
		if (mt_rand(1,100)<=5) {
			$this->_BaseRem->deleteOldReminders(time()-3600*24*90);
		}
	}
	function processMsg($entries) {
		$baseMsg=& $this->_frm->getStaticModul('msg');
		foreach($entries as $v) {
			if ($obj=$this->_BaseRem->getCachedObj($v['rid'])) {
				$this->_BaseRem->markSend($v['rid'], 'msg', $v['uid']);

				$objData=$this->_BaseRem->formatObj($obj);
				$msg=new ObjMsgMessage();
				$msg->setMeta('msg_sendid',0);
				$msg->setMeta('msg_userid',$v['uid']);
				$msg->setMeta('msg_from','System');
				$msg->setMeta('msg_subject','[GROUP-E Reminder]');
				$msg->setMeta('msg_message',$obj->getMeta('rem_message'));
				$msg->setMeta('msg_image','msg_0.gif');
				$msg->setMeta('msg_to','u_'.$v['uid']);
				if ($objData['link']) {
					$msg->setMeta('msg_link',json_encode(array(array('U'=>$objData['link'],'N'=>$objData['name']))));
				}
				$baseMsg->sendMsgMessage($msg);
			}
		}
	}
	function processMail($entries) {
		require_once('lib/core/geCoreMailsimple.php');
		foreach($entries as $v) {
			if ($obj=$this->_BaseRem->getCachedObj($v['rid'])) {
				$objData=$this->_BaseRem->formatObj($obj);
				$mailUser=$this->_frm->getCachedUser($v['uid']);
				if ($mailUser['email'] && !$mailUser['deleted']) {
					$this->_BaseRem->markSend($v['rid'], 'mail', $v['uid']);

					$mail=new geCoreMailsimple();
					$linkBody='';
					if ($objData['link']) {
						$linkBody.=$mail->getLf().$mail->getLf().$objData['name'].$mail->getLf().Framework::getSelfDir(true).'/'.$objData['link'];
					}
					$mail->setFrom($mailUser['email'],'System');
					$mail->setReplyto($mailUser['email']);
					$mail->setSubject('[GROUP-E Reminder]');
					$mail->setTo($mailUser['email'],$mailUser['lastname'].' '.$mailUser['firstname']);
					$mail->setBody(preg_replace("/(\r\n|\r|\n)/",$mail->getLf(),$obj->getMeta('rem_message').$linkBody));
					$mail->send();
				}
			}
		}
	}
	function processSms($entries) {
		$BaseSms=$this->_frm->getStaticModul('sms');
		$BaseRes=$this->_frm->getStaticModul('sms_res');
		foreach($entries as $v) {
			if ($obj=$this->_BaseRem->getCachedObj($v['rid'])) {
				$objData=$this->_BaseRem->formatObj($obj);
				$smsUser=$this->_frm->getCachedUser($v['uid']);
				if ($smsUser['mobil'] ) {
					$message='Reminder: ';
					$msgLen=150;
					if ($objData['name']) {
						$msgLen-=strlen("\n".$objData['name']);
					}
					if (strlen($obj->getMeta('rem_message'))>$msgLen) {
						$message.=substr($obj->getMeta('rem_message'),0,$msgLen-3).'...';
					} else {
						$message.=$obj->getMeta('rem_message');
					}
					$message.="\n".$objData['name'];
					
					$msg=new ObjSmsMessage();
					$msg->setMeta('sms_userid',$v['uid']);
					$msg->setMeta('sms_email',$smsUser['email']);
					$msg->setMeta('sms_from','GROUP-E');
					$msg->setMeta('sms_to',$BaseSms->formatNumber($smsUser['mobil'],$smsUser['lastname'].' '.$smsUser['firstname']));
					$msg->setMeta('sms_senddate',0);
					$msg->setMeta('sms_message',$message);
					$msg->setMeta('sms_email_alert',1);

					//print_r($msg);
					if ($result=$BaseSms->sendSmsMessage($msg)) {
						$this->_BaseRem->markSend($v['rid'], 'sms', $v['uid']);
					}
				}
			}
		}
		
	}


}
?>