<?php
class SambaAdminGui {
	var $_Wusr;
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	function SambaAdminGui() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=$frm->getStaticModul('smb');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('smb');
	}
	function _handleRequest() {
		$this->_mode=Framework::getParam('mode','share','G');
		$this->_oid=Framework::getParam('oid',0,'G');
		switch ($this->_mode) {
			case 'share':
				$this->_action=Framework::getParam('action','b','G');
				$this->_obj_action='smb_share';
				if ($this->_oid) {
					$this->_Obj=$this->_Base->getAdminShareObj($this->_oid);
				}
				if (Framework::getParam('_clTab',0,'G')) {
					$this->setPrefs('showtab',Framework::getParam('_clTab',0,'G'));
				}
				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('oid');
							$this->_L->goToLink();
						break;
						case 'delete':
							if (is_object($this->_Obj)) {
								if ($this->_Base->deleteAdminShare($this->_Obj->getID())) {
									$this->_L->unsetParam(array('oid','action'));
									$this->_L->goToLink();
								}
							}
						break;
						default:
							//debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
			break;
		}
	}
	function &getAdminHeader() {
		require_once("lib/class_ContentGui.php");
		$hGui=new ContentGui();
		$hGui->setName($this->_frm->getAppName('smb'));
		$hGui->addTab('share',$this->_T->lang('[[Freigaben]]'),"index.php?site=admin.php&ac=smb&mode=share");
		$hGui->setTabOn($this->_mode);
		require_once('lib/class_FunctionObjActionGui.php');
		$objActionGui=new FunctionObjActionGui();
		if ($this->_obj_action) {
			$obj_action=$this->_frm->getObjAction('admin',$this->_obj_action);
			$parse=false;
			foreach ($obj_action as $key=>$val) {
				if ($val['Hidden']) continue;
				if ($this->_mode=='share' && !$this->isAllowedShareAction($this->_Obj,$val)) continue;
				//print_r($val);
				$parse=true;
				$objActionGui->addValue($key,$val['Name']);
			}
			if ($parse) $hGui->addFunction($objActionGui);
		}
		return $hGui;
	}
	function isAllowedShareAction(&$obj,$action) {
		if ($action['Hidden']) return false;
		if (in_array('ID',$action['Extra']) && !is_object($obj)) return false;
		return true;
	}
	function process(&$AppGui) {
		$this->_handleRequest();
		$AppGui->addContent($this->getAdminHeader());

		switch ($this->_mode) {
			case 'share':
				switch ($this->_action) {
					case 'n':
						$AppGui->addContent($this->showEditShare());
					break;
					case 'b':
						$AppGui->addContent($this->showShareList());
					break;
				}

			break;
		}
		$AppGui->setFormAction($this->_L->getLink());
	}

	function showEditShare() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_Obj) {
			$Gui->setName($this->_T->lang('[[Neue Freigabe einrichten]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(null,array('action'=>'b'))));
		} else {
			$Gui->setName($this->_T->lang('[[Freigabe bearbeiten]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
			$tabs[]='perms';
		}
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'|sharetab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('sharetab'));
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getShareMetaGui());
		}
		if (in_array('perms',$tabs)) {
			$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
			$box->setTabContent('perms',$this->getSharePermsGui());
		}
		$show_tap=$this->getPrefs('sharetab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}

	function &getShareMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		if ($this->_oid) $req_check=2; else $req_check=1;
		/*foreach ($this->_BasePrj->getObjFields('0') as $key=>$val) {
			switch ($val['Typ']) {
				case 'text':
				case 'area':
				case 'check':
				case 'select':
				case 'curr':
				case 'int':
					$formGui->addField($key,$val['Typ'],$this->_T->lang($val['Name']),$this->_Obj?$this->_Obj->getMeta($key):$val['Default'],'form_fields'.$val['fGroup']);
					if ($val['Required']&$req_check) $formGui->setRequired($key);
					if ($val['Callback']) $formGui->setCallback($key,array(&$this,$val['Callback']));
					if ($val['Attribs']) $formGui->setAttribs($key,$val['Attribs']);
					if ($val['Values']) $formGui->setValues($key,$this->$val['Values']());
					if ($val['Disabled']&$req_check) $formGui->setDisabled($key);
				break;
			}
		}*/
		$key='smbID';
		$formGui->addField($key,'text',$this->_T->lang('[[Freigabe (z.B. "workgroup/server/freigabe")]]'),$this->_Obj?$this->_Obj->getID():'','form_fields1');
		$formGui->setRequired($key);
		$key='adminGroups';
		$formGui->addField($key,'text',$this->_T->lang('[[AdminGroups]]'),$this->_Obj?$this->_Obj->getMeta($key):'','form_fields1');


		$key='meta_save_x';
		$formGui->addField($key,'submit','',$this->_T->lang('[[Speichern]]'),'form_submit');

		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$tmp=explode('/',$formGui->getFieldVal('smbID'));
				if (!trim($tmp[0]) || !trim($tmp[1]) || !trim($tmp[2])) {
					$this->_E->setError('fields','smbID');
				} elseif ($this->_Base->existsAdminShare($formGui->getFieldVal('smbID'),$this->_oid?$this->_oid:0)) {
					$this->_E->setError('fol_exists','smbID');
				} else {
					if (!is_object($this->_Obj)) $this->_Obj=new SObj_share($formGui->getFieldVal('smbID'));
					$formGui->addMetaToObj($this->_Obj);
					if ($this->_oid) {
						$this->_Obj->setID($formGui->getFieldVal('smbID'));
						$this->_Base->updateAdminShare($this->_oid,$this->_Obj);
					} else {
						if ($this->_Base->insertAdminShare($this->_Obj)) {

						}
					}
					if ($GLOBALS['CFG']['USER_CLASS']=='ldap_full' && $this->_Obj->getMeta('adminGroups') && !$this->_frm->check_group($this->_Obj->getMeta('adminGroups'))) {
						$group_name=$this->_Obj->getMeta('adminGroups');
						$group=array(
							'cn'=>$group_name,
							'activGroup-e'=>-1,
						);
						//echo "www";
						$gid=$this->_frm->insert_group($group);
					}
					//;
					$this->_L->setParam('oid',$this->_Obj->getId());
					$this->_L->goToLink();
				}
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}
	function &getSharePermsGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');

		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		$key='addPermsUser';
		$mode='u|g';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);

		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,'','fields1');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));
		$formGui->setNoMeta($key);
		$formGui->addField('perms_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields1');
		$error=0;
		//debug($this->_Obj);
		$perms_g=Framework::aclToArray($this->_Obj->getMeta('permsGroup'));
		$perms_u=Framework::aclToArray($this->_Obj->getMeta('permsUser'));
		$update=false;
		if (Framework::getParam('perms_add',0,'P') && trim($formGui->getFieldVal('addPermsUser'))) {
			$permsUsers=explode('|',$formGui->getFieldVal('addPermsUser'));
			foreach ($permsUsers as $val) {
				$tmp=explode('_',$val);
				if ($tmp[0]=='u') {
					$perms_u[$tmp[1]]=1;
					$update=true;
				}
				if ($tmp[0]=='g') {
					$perms_g[$tmp[1]]=1;
					$update=true;
				}
			}
		}
		if(is_array(Framework::getParam('permDeleteG_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteG_x',0,'P'));
			if ($key) {
				unset($perms_g[$key]);
				$update=true;
			}
		}
		if(is_array(Framework::getParam('permDeleteU_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteU_x',0,'P'));
			if ($key) {
				unset($perms_u[$key]);
				$update=true;
			}
		}
		if ($update) {
			$this->_Obj->setMeta('permsGroup',Framework::arrayToAcl($perms_g));
			$this->_Obj->setMeta('permsUser',Framework::arrayToAcl($perms_u));
			$this->_Base->updateAdminShare($this->_oid,$this->_Obj);
			$this->_L->goToLink();
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3_2',$this->listPerms('PermsGroup',$perms_g,array()),'FORM3');
		$tplContent->addContent('form3_3',$this->listPerms('PermsUser',$perms_u,array()),'FORM3');
		return $tplContent;
	}
	function listPerms($ptype,$perms,$av_perms,$perm_mode=0,$prep='perm') {
		if (!empty($perms)) {
			require_once('lib/class_ApplicationListGui.php');
			$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
			$tabGui->setName($this->_T->lang('[[Freigabe in Group-e sichtbar fuer]]'));
			switch ($ptype) {
				case 'PermsGroup':
					$title=$this->_T->lang('[[Gruppen]]');
					$perms_users=$this->_frm->getAllGroups(array_keys($perms));
					$img='gruppe.gif';
					$dbtn=$prep.'DeleteG_x';
				break;
				case 'PermsUser':
					$title=$this->_T->lang('[[BenutzerInnen]]');
					$perms_users=$this->_frm->getFullName(array_keys($perms),0,1);
					$img='user.gif';
					$dbtn=$prep.'DeleteU_x';
				break;
			}
			$tabGui->addHeaderCol('Name',$title,'','','',0,'',2);
			foreach ($av_perms as $pkey=>$pval) {
				$tabGui->addHeaderCol('Perms_'.$pkey,$pval,'','','',1);
			}
			$tabGui->addHeaderCol('Delete','','tras.gif');
			$tabGui->setLimit(0);
			$rows=0;$hl=0;
			foreach ($perms as $key=>$val) {
				//debug($val);
				$hl=$hl?0:1;
				$tabGui->addRow($hl);
				$tabGui->addCol('IMG','',$img);
				$tabGui->addCol('Name',$perms_users[$key],'','','',0,'2000');
				foreach ($av_perms as $pkey=>$pval) {
					if ($perm_mode) {
						$tabGui->addCol('Perms_'.$pkey,($val&$pkey)?'X':'','','','center',1);
					} else {
						$tabGui->addCol('Perms_'.$pkey,$pkey==$val?'X':'','','','center',1);
					}
				}
				//$tabGui->addCol('Perms',$av_perms[$val],'','','',1);
				$btn=new SubmitImgBtn ($dbtn.'['.$key.']','img/'.APP_THEME.'/loeschen.gif');
				$tabGui->addCol('Delete',$btn);
			}
		}
		return $tabGui;
	}


	function &showShareList($search= null) {
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		require_once('lib/class_ApplicationListGui.php');
		$entries=$this->_Base->listAdminShares();
		$Gui=new ApplicationListGui();
		$Gui->setName($this->_T->lang('[[Freigaben]]'));
		$Gui->addHeaderCol('Title',$this->_T->lang('[[Name]]'),'','','',1);
		$Gui->addHeaderCol('Perms',$this->_T->lang('[[Rechte]]'),'','','',0,2000);
		//$Gui->addHeaderCol('TimeCreate',$this->_T->lang('[[Erstellt am]]'),'','','',1);
		//$Gui->addHeaderCol('UserCreate',$this->_T->lang('[[Erstellt von]]'),'','','',1);
		foreach ($entries as $key=>$val) {
			$Gui->addRow(($hl?$hl=0:$hl=1),'top');
			$Gui->addCol('Title',$val->getID(),'',$this->_L->getTempLink(null,array('oid'=>$val->getID(),'action'=>'n')),'','1');
			$pusers=array();
			$perms_u=Framework::aclToArray($val->getMeta('permsUser'));
			foreach ($perms_u as $ukey=>$uval) {
					$pusers[]='<img src="img/'.APP_THEME.'/user.gif" class="list" border="0">'.FrameWork::entities($this->_frm->getCachedUserName($ukey,0,1));
			}
			$perms_g=Framework::aclToArray($val->getMeta('permsGroup'));
			foreach ($perms_g as $ukey=>$uval) {
					$pusers[]='<img src="img/'.APP_THEME.'/gruppe.gif" class="list" border="0">'.FrameWork::entities($this->_frm->getCachedGroupName($ukey));
			}
			$Gui->addCol('Perms',implode('<br />',$pusers),'','','',1,'',0,'',$noEnc);
			//$Gui->addCol('TimeCreate',date('d.m.Y',$val->getMeta('TimeCreate')),'','','',1);
			//$Gui->addCol('UserCreate',$this->_frm->getCachedUserName($val->getMeta('UserCreate')),'','','',1);
		}
		return $Gui;
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result) $result=$default;
		return $result;
	}

}
?>