<?php
class SambaGui {
	var $_Base;
	var $_Obj;
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	function SambaGui() {
		global $frm,$t,$T,$E,$L,$P;
		require_once('lib/class_ApplicationGui.php');
		$this->_Base=& $frm->getStaticModul('smb');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		if (is_object($P)) $this->_P=&$P;
		$this->_AppGui=new ApplicationGui();
		$this->_AppGui->addConfirm('delete');
	}
	function _handleRequest() {
		$this->_myShares=$this->_Base->listMyShares();
		if (!count($this->_myShares)) return true;
		$this->_action=Framework::getParam('action','b','G');
		$this->_oid=Framework::getParam('oid',key($this->_myShares));
		if ($this->_oid) {
			$this->_Obj=$this->_Base->getObj($this->_oid);
			if (is_object($this->_Obj)) {
				$this->_share=$this->_Obj->getShare();
				if (isset($this->_myShares[$this->_share])) {
					$this->_RootObj=$this->_myShares[$this->_share];
				}
			}
		}
		if (!is_object($this->_RootObj)) {
			$this->_RootObj=reset($this->_myShares);
			$this->_Obj=$this->_RootObj;
			$this->_oid=$this->_Obj->getID();
			$this->_share=$this->_Obj->getShare();
		}
		$this->_server=dirname($this->_RootObj->getID());
		$this->_Base->setRootObj($this->_RootObj);
		if ($this->_Base->isShareAdmin()) {
			$this->_AppGui->setHeaderAlert($this->_T->lang('[[Admin_Account_in_use]]'));
		}
		//debug($this->_Base->listSubEntries($this->_server));
		//$this->_Obj->setMeta('ACL',$this->_Base->getAcl($this->_Obj));
		$error=$this->_Base->getStatus();
		if ($error) {
			$this->_E->setError($error[0]);
			if ($error[1]) $this->_E->setErrorMsg($error[0],$error[1]);
			$this->_action='error';
		}
		if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
			switch (Framework::getParam('obj_action_val','0','P')) {
				case 'n_fol':
					$this->_L->setParam('action','n');
					$this->_action='n';
				break;
				case 'e_fol':
					$this->_L->setParam('action','e');
					$this->_action='e';
				break;
				case 'perms':
					$this->_L->setParam('action','p');
					$this->_action='p';
				break;
				case 'copy':
					//$this->_L->setParam('action','c');
					//$this->_L->goToLink();
				break;
				case 'delete':
					if (is_object($this->_Obj)) {
						$error=$this->_Base->deleteObj($this->_Obj);
						if (!$error) {
							$this->_L->setParam('action','b');
							$this->_L->setParam('oid',$this->_Obj->getParent());
							$this->_L->goToLink();
						} else {
							$this->_E->setError($error[0]);
							if ($error[1]) $this->_E->setErrorMsg($error[0],$error[1]);
						}
					}
				break;
				case 'set_admin':
					if ($this->_Base->isRuleUser()) {
						$this->_Base->setTempAdmin();
						$this->_L->goToLink();
					}
				break;
				case 'del_admin':
					$this->_Base->delTempAdmin();
					$this->_L->goToLink();
				break;
				default:
					//debug(Framework::getParam('obj_action_val','0','P'));
			}
		}
		if (Framework::getParam('smb_list_action_x','0','P') && Framework::getParam('smb_list_action_val','0','P')) {
			$location='';
			switch (Framework::getParam('smb_list_action_val','0','P')) {
				case 'delete':
					$ListID=Framework::getParam('ListID','0','P');
					if (is_array($ListID)) {
						foreach ($ListID as $key=>$val) {
							$new_obj=$this->_Base->getObj($val);
							if (is_object($new_obj)) {
								$error=$this->_Base->deleteObj($new_obj);
								if (!$error) {
									unset($ListID[$key]);
								} else {
									$this->_E->setError($error[0]);
									if ($error[1]) $this->_E->setErrorMsg($error[0],$error[1]);
								}
							}
						}
						Framework::importParam(array('ListID'=>$ListID),'P');
					}
				break;
				case 's_mail':
					$ListID=Framework::getParam('ListID','0','P');
					$loc_val=array();
					if (is_array($ListID)) {
						foreach ($ListID as $key=>$val) {
							$new_obj=$this->_Base->getObj($val);
							if (is_object($new_obj) && !$new_obj->isFolder()) {
								$loc_val[]=$new_obj->getID();
								unset($ListID[$key]);
							}
						}
						if (!empty($loc_val)) {
							$this->_frm->setUserData('mail',1,serialize($loc_val));
							if ($GLOBALS['SESS_MDATA']['smb.php']['MAIL_REFERER']) {
								$location=$GLOBALS['SESS_MDATA']['smb.php']['MAIL_REFERER'];
								unset($GLOBALS['SESS_MDATA']['smb.php']);
							} else {
								$location="index.php?site=mail.php&action=n&getUserSmb=1";
							}
						}
						Framework::importParam(array('ListID'=>$ListID),'P');
					}
				break;
				default:
					//debug(Framework::getParam('smb_list_action_val','0','P'));

			}
			if ($location) {
				page_close();
				header('Location:'.$location);
				exit;
			}
		}
		$this->_L->setParam('oid',$this->_oid);
		switch ($this->_action) {
			case 'fu':
				$error=$this->_Base->dumpFile($this->_Obj);
				if (!$error) {
					exit;
				} else {
					$this->_E->setError($error[0]);
					if ($error[1]) $this->_E->setErrorMsg($error[0],$error[1]);
				}
			break;
			case 'pv':
				$error=$this->_Base->convert2Html($this->_Obj);
				if (!$error) {
					exit;
				} else {
					$this->_E->setError($error[0]);
					if ($error[1]) $this->_E->setErrorMsg($error[0],$error[1]);
				}
			break;
		}
		return false;
	}
	function processRequest() {
		$error=$this->_handleRequest();
		if ($error) return true;
		$this->_AppGui->setName($this->_frm->getAppName('smb'));
		$this->_AppGui->setImage('appl_smb.gif');
		foreach ($this->_myShares as $val) {
			$this->_AppGui->addTab($val->getID(),$val->getName(),"index.php?site=smb.php&oid=".urlencode($val->getID()),'');
		}
		$this->_AppGui->setTabOn($this->_share);
		$this->_AppGui->setFormAction($this->_L->getLink());

		require_once('lib/class_ApplicationTreeGui.php');
		$this->_TreeGui=new ApplicationTreeGui();
		switch ($this->_action) {
			case 'b':
				$this->showFolderTree();
				$ContGui=& $this->getFolderContent();
				if (is_object($ContGui)) {
					$this->showFolderHeader();
					$this->_TreeGui->addContent($ContGui);
				} else {
					$this->showFolderHeader();
				}

			break;
			case 'n':
			case 'e':
			case 'p':
				$this->showFolderTree();
				$this->showFolderHeader();
			break;
			case 'fu':

			break;
		}
		$this->_AppGui->addContent($this->_TreeGui);
		$this->_AppGui->processApplication();
		return false;
	}
	function showFolderTree() {
		$root_id=$this->_RootObj->getMeta('rootID');
		$ex_link=$this->_L->getTempLink();
		$ac_link=$this->_L->getTempLink(array('oid','action'));
		require_once('lib/class_ObjAjaxTreeGui.php');
		$ObjAjaxTreeGui=new ObjAjaxTreeGui(1);
		$ObjAjaxTreeGui->setAllexpand(0);
		$up_tree=false;
		if (Framework::getParam('_open',0,'G')==1) {
			$ObjAjaxTreeGui->setAllexpand(1);
		} elseif (Framework::getParam('_open',0,'G')==-1) {
			$open_tree='|';
			$this->_frm->setTree($this->_Base->getModul(),$root_id,$open_tree);
		} else {
			$open_tree=$this->_frm->getTree($this->_Base->getModul(),$root_id);
			if (Framework::getParam('_x',0,'G')) {
				$this->_frm->updateTree($open_tree,base64_encode(Framework::getParam('_x',0,'G')),'|');
				//echo $open_tree;
				$this->_frm->setTree($this->_Base->getModul(),$root_id,$open_tree);
			}
		}
		//debug($open_tree);

		$expand=array();
		foreach (explode('|',$open_tree) as $val) {
			$tmp=base64_decode($val);
			if ($tmp && is_string($tmp)) $expand[$tmp]=1;
		}
		//$expand=array_flip(array_map('base64_decode',(explode('|',$open_tree))));
		$expand[$this->_RootObj->getID()]=1;
		if (!$expand[$this->_Obj->getID()]) {
			$expand[$this->_Obj->getID()]=1;
			$this->_frm->updateTree($open_tree,base64_encode($this->_Obj->getID()),'|');
			$this->_frm->setTree($this->_Base->getModul(),$root_id,$open_tree);
		}
		//debug($expand);
		$ObjAjaxTreeGui->setSelectedID($this->_Obj->getID());
		$ObjAjaxTreeGui->setEncodeID(true);
		$ObjAjaxTreeGui->setCallback(array(&$this->_Base,'listSubTree'));
		$ObjAjaxTreeGui->setCallbackLen(array(&$this->_Base,'isSubTreeLen'));
		$ObjAjaxTreeGui->setExpand($expand);
		$ObjAjaxTreeGui->setExLink($ex_link."&_x={OID}");
		$ObjAjaxTreeGui->setAcLink($ac_link."&action={ACTION}&oid={OID}");
		$ObjAjaxTreeGui->setOpenCloseLink($ex_link."&_open={MODE}");
		$ObjAjaxTreeGui->setImgPath("img/".APP_THEME);
		$ObjAjaxTreeGui->setColors(APP_BGCOLOR,APP_FG10COLOR);
		$ObjAjaxTreeGui->setRootObj($this->_RootObj);
		$ObjAjaxTreeGui->setRootID($root_id);
		$ObjAjaxTreeGui->setModul($this->_Base->getModul());
		$this->_TreeGui->addTreeContent($ObjAjaxTreeGui,$this->_RootObj->getID());
	}
	function showFolderHeader() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_TemplateGui.php');
		$ContGui=new ContentGui();
		$ContGui->setName($this->_Base->_smb_client->decode(str_replace($this->_server.'/','',$this->_Obj->getID())));
		$objActionGui=new FunctionObjActionGui();
		$obj_action=$this->_frm->getObjAction($this->_Base->getModul(),$this->_Obj->getActionMode());
		foreach ($obj_action as $key=>$val) {
			if ($val['Hidden'] || !$this->_Base->isAllowedAction($this->_Obj,$val)) continue;
			$objActionGui->addValue($key,$val['Name']);
		}
		$ContGui->addFunction($objActionGui);
		switch ($this->_action) {
			case 'n':
			case 'e':
				$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(null,array('action'=>$this->_Obj->getAction(0)))));
				$ContGui->addFunction($btBreak);
				$box=new BoxGui();
				$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
				$box->setTabContent('meta',$this->getMetaGui());
				$box->setTabOn('meta');
				$tplContent=new TemplateGui('core/common_template_intern.inc.html');
				$tplContent->addContent('content',$box,'CONTENT');
				$ContGui->addContent($tplContent);
			break;
			case 'p':
				$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(null,array('action'=>$this->_Obj->getAction(0)))));
				$ContGui->addFunction($btBreak);
				$box=new BoxGui();
				$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
				$box->setTabContent('perms',$this->getPermsGui());
				$box->setTabOn('perms');
				$tplContent=new TemplateGui('core/common_template_intern.inc.html');
				$tplContent->addContent('content',$box,'CONTENT');
				$ContGui->addContent($tplContent);
			break;
			default:
				if ($GLOBALS['SESS_MDATA']['smb.php']['L_BACK'][0]) {
					$btBreak=new FunctionButtons('break','break',array('LINK'=>$GLOBALS['SESS_MDATA']['smb.php']['L_BACK'][0]));
				} else {
					$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(null,array('oid'=>$this->_Obj->getParent()))));
				}
				$ContGui->addFunction($btBreak);
				if (!$this->_E->isError()) {
					$box=new BoxGui();
					$box->addTab('upload',$this->_T->lang('[[Datei upload]]'),'#',true);
					$box->setTabContent('upload',$this->getUploadGui());
					$box->setTabOn('upload');
					$tplContent=new TemplateGui('core/common_template_intern.inc.html');
					$tplContent->addContent('content',$box,'CONTENT');
					$ContGui->addContent($tplContent);
				}

		}
		$this->_TreeGui->addContent($ContGui);
	}
	function getPermsGui() {
		$objPerms=$this->_Base->getAcl($this->_Obj);
		$prjID=0;
		if ($this->_P && ($prjObj=$this->_P->isProjectSmbFolder($this->_Obj->getID()))) {
			$prjID=$prjObj->getID();
		}
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');

		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		$key='addPermsUser';
		if ($prjID) $mode='u|p|g'; else $mode='u|g';
		$params=base64_encode(serialize(array('prjID'=>$prjID)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		if ($prjID) {
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Projektrollen]]'),
				'LabelSep'=>' / ',
				'mode'=>$mode,
				'app'=>'cal',
				'params'=>$params,
				'FieldVal'=>'_PRULES',
			);
		}
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);

		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,'','fields1');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));
		$formGui->setNoMeta($key);


		if ($this->_Obj->isFolder()) {
			$perms=array(
				5=>$this->_T->lang('[[smb_LesenV]]'),
				7=>$this->_T->lang('[[smb_Schreiben]]'),
				0=>$this->_T->lang('[[smb_KeineRechte]]'),
			);
			$extraGroups=array(
				0=>'-',
				-1=>$this->_T->lang('[[smbEveryone]]'),
				-2=>$this->_T->lang('[[smbNewOwner]]'),
				-3=>$this->_T->lang('[[smbNewGroup]]'),
			);
			$formGui->addField('addPermsExtra','select',$this->_T->lang('[[Sondergruppen]]'),0,'fields1');
			$formGui->setValues('addPermsExtra',$extraGroups);

			$perms_mode=array(
				1=>$this->_T->lang('[[Ja]]'),
				0=>$this->_T->lang('[[Nein]]'),
				2=>$this->_T->lang('[[Nur vererben]]')
			);
			$formGui->addField('addPermsMode','radiolist_h',$this->_T->lang('[[Rechte vererben]]'),1,'fields2');
			$formGui->setValues('addPermsMode',$perms_mode);

			$apply_mode=array(
				1=>$this->_T->lang('[[Dieses Verzeichnis]]'),
				2=>$this->_T->lang('[[Alle enthaltenen Dateien]]'),
				4=>$this->_T->lang('[[Alle enthaltenen Verzeichnise]]'),
			);
			$formGui->addField('addApplyMode','checklist_v',$this->_T->lang('[[Rechte anwenden auf]]'),array(1,2),'fields2');
			$formGui->setValues('addApplyMode',$apply_mode);

			$apply_set_mode=array(
				2=>$this->_T->lang('[[Alle enthaltenen Dateien]]'),
				4=>$this->_T->lang('[[Alle enthaltenen Verzeichnise]]'),
			);
			$formGui->addField('setApplyMode','checklist_h',$this->_T->lang('[[Alle angezeigte Rechte anwenden auf]]'),array(),'fields4');
			$formGui->setValues('setApplyMode',$apply_set_mode);
			$formGui->addField('perms_set','submit','',$this->_T->lang('[[Zuweisen]]'),'fields4');

		} else {
			$perms=array(
				1=>$this->_T->lang('[[smb_Lesen]]'),
				2=>$this->_T->lang('[[smb_Schreiben]]'),
				4=>$this->_T->lang('[[smb_Ausfuehren]]'),
				0=>$this->_T->lang('[[smb_KeineRechte]]'),
			);
			$extraGroups=array(
				0=>'-',
				-1=>$this->_T->lang('[[smbEveryone]]'),
			);
			$formGui->addField('addPermsExtra','select',$this->_T->lang('[[Sondergruppen]]'),0,'fields1');
			$formGui->setValues('addPermsExtra',$extraGroups);
		}
		$formGui->addField('addPermsID','radiolist_v',$this->_T->lang('[[Rechte]]'),$this->_Obj->isFolder()?5:1,'fields1');
		$formGui->setValues('addPermsID',$perms);
		$formGui->addField('perms_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields3');

		$error=0;
		if (Framework::getParam('perms_add',0,'P') && trim($formGui->getFieldVal('addPermsUser'))) {
			$permSids=array();
			$permsUsers=explode('|',$formGui->getFieldVal('addPermsUser'));
			foreach ($permsUsers as $val) {
				$tmp=explode('_',$val);
				if ($tmp[0]=='u') $permSids[]=$this->_frm->idToSid($tmp[1],'u');
				if ($tmp[0]=='g' || $tmp[0]=='p') $permSids[]=$this->_frm->idToSid($tmp[1],'g');
			}
			if ($this->_Obj->isFolder()) {
				$this->_Base->modifyAcl($this->_Obj,$permSids,$formGui->getFieldVal('addPermsID'),$formGui->getFieldVal('addPermsMode'),$formGui->getFieldVal('addApplyMode'));
			} else {
				$this->_Base->modifyAcl($this->_Obj,$permSids,$formGui->getFieldVal('addPermsID'),0);
			}
			$error=$this->_Base->getStatus();
			if (!$error) $this->_L->goToLink();
		}
		if (Framework::getParam('perms_add',0,'P') && $formGui->getFieldVal('addPermsExtra')) {
			$fixFlag=0;
			$permSids=array();
			if ($formGui->getFieldVal('addPermsExtra')==-1) $permSids[]='S-1-1-0';
			if ($formGui->getFieldVal('addPermsExtra')==-2) {
				$permSids[]='S-1-3-0';
				$fixFlag=2;
			}
			if ($formGui->getFieldVal('addPermsExtra')==-3) {
				$permSids[]='S-1-3-1';
				$fixFlag=2;
			}
			if ($this->_Obj->isFolder()) {
				$this->_Base->modifyAcl($this->_Obj,$permSids,$formGui->getFieldVal('addPermsID'),($fixFlag?$fixFlag:$formGui->getFieldVal('addPermsMode')),$formGui->getFieldVal('addApplyMode'));
			} else {
				$this->_Base->modifyAcl($this->_Obj,$permSids,$formGui->getFieldVal('addPermsID'),0);
			}
			$error=$this->_Base->getStatus();
			if (!$error) $this->_L->goToLink();
		}
		if (Framework::getParam('perms_set',0,'P') && is_array($formGui->getFieldVal('setApplyMode'))) {
			$this->_Base->setAllAcl($this->_Obj,$formGui->getFieldVal('setApplyMode'));
			$error=$this->_Base->getStatus();
			if (!$error) $this->_L->goToLink();
		}
		if(is_array(Framework::getParam('permDelete_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDelete_x',0,'P'));
			if ($key) {
				$this->_Base->deleteAcl($this->_Obj,$key);
				$error=$this->_Base->getStatus();
			}
			if (!$error) $this->_L->goToLink();
		}
		if ($error) {
			$this->_E->setError($error[0]);
			if ($error[1]) $this->_E->setErrorMsg($error[0],$error[1]);
		}

		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		$tplContent->addContent('form3_2',$this->listPerms($objPerms,$this->_Obj->isFolder(),false),'FORM3');
		if ($this->_Obj->isFolder()) $tplContent->addContent('form3_3',$this->listPerms($objPerms,true,true),'FORM3');
		if ($this->_Obj->isFolder()) $tplContent->addContent('form3_4',$formGui,'FORM3',array('','fields4'));
		return $tplContent;
	}
	function listPerms($perms,$use_inherit=true,$inhert=false,$prep='perm') {
		$av_perms=array(
			1=>$this->_T->lang('[[Lesen]]'),
			2=>$this->_T->lang('[[Schreiben]]'),
			4=>$this->_T->lang('[[Ausfuehren]]'),
		);
		if (is_array($perms['ACL'])) {
			$parse=false;
			require_once('lib/class_ApplicationListGui.php');
			$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
			if ($inhert) {
				$tabGui->setName($this->_T->lang('[[Rechte die nur vererbt werden]]'));
			} else {
				$tabGui->setName($this->_T->lang('[[Wirksame Rechte]]'));
			}
			$title=$this->_T->lang('[[BenutzerInnen]]').'/'.$this->_T->lang('[[Gruppen]]');
			$tabGui->addHeaderCol('Name',$title,'','','',0,0,2);
			foreach ($av_perms as $pkey=>$pval) {
				$tabGui->addHeaderCol('Perms_'.$pkey,$pval,'','','',1);
			}
			if ($use_inherit) $tabGui->addHeaderCol('Perms_Inherit',$this->_T->lang('[[smbVererben]]'),'','','',1);
			$tabGui->addHeaderCol('Delete','','tras.gif');
			$tabGui->setLimit(0);

			$gUsers=$this->_frm->sidToId(array_keys($perms['ACL']),'g');
			$pUsers=$this->_frm->sidToId(array_keys($perms['ACL']),'u');
			//debug($perms);
			//debug($gUsers);
			$rows=0;$hl=0;
			foreach ($perms['ACL'] as $sid=>$acl_val) {
				foreach ($acl_val as $acl) {
					if ($use_inherit) {
						if ($inhert && !($acl['FLAGS']&8)) continue;
						if (!$inhert && $acl['FLAGS']&8) continue;
					}
					$Name='';
					$owner=false;
					switch ($sid) {
						case 'S-1-1-0':
							$Name='*'.$this->_T->lang('[[smbEveryone]]');
							$owner=true;
							$img='gruppe.gif';
							$dbtn=$prep.'Delete_x';
						break;
						case 'S-1-3-0':
							$Name='*'.$this->_T->lang('[[smbNewOwner]]');
							$owner=true;
							$img='user.gif';
							$dbtn=$prep.'Delete_x';
						break;
						case 'S-1-3-1':
							$Name='*'.$this->_T->lang('[[smbNewGroup]]');
							$owner=true;
							$img='gruppe.gif';
							$dbtn=$prep.'Delete_x';
						break;
						default:
							if (isset($gUsers[$sid])) {
								if($gUsers[$sid]['gidGroup-e']) {
									$Name=$this->_frm->getCachedGroupName($gUsers[$sid]['gidGroup-e']);
								} else {
									$Name=$gUsers[$sid]['cn'];
								}
								if (!$Name) $Name=$sid;
								$img='gruppe.gif';
								$dbtn=$prep.'Delete_x';
							}
							if (isset($pUsers[$sid])) {
								if($pUsers[$sid]['uidGroup-e']) {
									$Name=$this->_frm->getCachedUserName($pUsers[$sid]['uidGroup-e'],0,1);
								} else {
									$Name=$pUsers[$sid]['uid'];
								}
								if (!$Name) $Name=$sid;
								$img='user.gif';
								$dbtn=$prep.'Delete_x';
							}
					}
					if ($Name && $perms['GROUP']==$sid && !($acl['FLAGS']&8)) {
						$Name='*'.$Name.' ('.$this->_T->lang('[[smbBesitzerG]]').')';
						$owner=true;
					}
					if ($Name && $perms['OWNER']==$sid && !($acl['FLAGS']&8)) {
						$Name='*'.$Name.' ('.$this->_T->lang('[[smbBesitzerU]]').')';
						$owner=true;
					}
					if ($Name) {
						$tabGui->addRow(0);
						$tabGui->addCol('IMG','',$img);
						$tabGui->addCol('Name',$Name,'','','',0,'2000');
						foreach ($av_perms as $pkey=>$pval) {
							$tabGui->addCol('Perms_'.$pkey,($acl['MASK']&$pkey)?'X':'','','','center',1);
						}
						if ($use_inherit) $tabGui->addCol('Perms_inherit',($acl['FLAGS']&3)?'X':'','','','center',1);
						//$tabGui->addCol('Perms',$av_perms[$val],'','','',1);
						if (!$owner) {
							$dkey=$sid.':ALLOWED/'.$acl['FLAGS'].'/'.$this->_Base->aclToMask($acl['MASK']);
							$btn=new SubmitImgBtn ($dbtn.'['.$dkey.']','img/'.APP_THEME.'/loeschen.gif');
							$tabGui->addCol('Delete',$btn);
						} else {
							$tabGui->addCol('Delete','');
						}
						$parse=true;
					}
				}
			}
		}
		if ($parse) {
			$tabGui->sortRows(array(array('IMG',1,'I'),array('Name',0)),1);
			return $tabGui;
		}
	}
	function getMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		$formGui=new FormGui();
		$key='folderName';
		$formGui->addField($key,'text',$this->_T->lang('[[Bezeichnung]]'),$this->_action=='e'?$this->_Obj->getName():'','form');
		$formGui->setRequired($key);
		$key='meta_save_x';
		$formGui->addField($key,'submit','',$this->_T->lang('[[Speichern]]'),'form');

		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$newName=$formGui->getFieldVal('folderName');
				if ($this->_action=='n') {
					$error=$this->_Base->createFolder($this->_Obj,$newName);
				} else {
					if ($this->_Obj->getName()!=$newName) {
						$error=$this->_Base->updateObj($this->_Obj,$newName);
					}
				}
				if (!$error) {
					$this->_L->setParam('action','b');
					$this->_L->setParam('oid',$this->_Obj->getID());
					$this->_L->goToLink();
				} else {
					$this->_E->setError($error[0]);
					if ($error[1]) $this->_E->setErrorMsg($error[0],$error[1]);
				}
			}
		}
		return $formGui;
	}
	function getUploadGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		$formGui=new FormGui();
		$key='smbFile';
		$formGui->addField($key,'file',$this->_T->lang('[[Bezeichnung]]'),'','form');
		$formGui->setRequired($key);
		$key='upload_x';
		$formGui->addField($key,'submit','',$this->_T->lang('[[Upload]]'),'form');

		if (Framework::getParam('upload_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$File=$formGui->getFieldVal('smbFile');
				$error=$this->_Base->UploadFile($this->_Obj,$File);
				if (!$error) {
					$this->_L->goToLink();
				} else {
					$this->_E->setError($error[0]);
					if ($error[1]) $this->_E->setErrorMsg($error[0],$error[1]);
				}
			}
		}
		return $formGui;
	}
	function &getFolderContent() {
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_ApplicationListGui.php');
		if (Framework::getParam('_OrderF',0,'G')) {
			$this->setPrefs('smbOrderF',Framework::getParam('_OrderF',0,'G'));
			$this->setPrefs('smbOrderD',Framework::getParam('_OrderD',0,'G'));
		}
		$orderF=$this->getPrefs('smbOrderF','N');
		$orderD=$this->getPrefs('smbOrderD',-1);
		$sqlOrder=$orderF.($orderD==-1?'D':'A');
		//debugtime('B');
		$entries=$this->_Base->listSubEntries($this->_Obj->getID(),$sqlOrder);
		//debugtime('E');
		$error=$this->_Base->getStatus();
		if ($error) {
			$this->_E->setError($error[0]);
			if ($error[1]) $this->_E->setErrorMsg($error[0],$error[1]);
		} else {
			$Gui=new ApplicationListGui();

			$funcAction=new FunctionObjActionGui('smb_list_action',true);
			$funcAction->setName($this->_T->lang('[[Ausgewaehlte Objekte]]'));
			$list_action=$this->_frm->getObjAction($this->_Base->getModul(),'fol_l');
			foreach ($list_action as $key=>$val) {
				if ($val['Hidden'] || !$this->_Base->isAllowedAction($this->_Obj,$val)) continue;
				$funcAction->addValue($key,$val['Name']);
			}
			$Gui->addFunction($funcAction);
			$btnList=new CheckBoxBtn ('ListID[]','');
			$funcSelAll=new FunctionButtons('smb_list','selectall',array('ListID'=>'ListID[]','ListOn'=>false));
			$noEnc=array('NoEnc'=>1,'NoBr'=>1);

			$Gui->setActOrder($orderF,$orderD);
			$Gui->setOrderLink($this->_L);
			$Gui->addHeaderCol('ListID',$funcSelAll->process(),'','','',1,'1%',0,'',$noEnc);
			$Gui->addHeaderCol('Name',$this->_T->lang('[[Name]]'),'','','','','',2);
			$Gui->setHeaderOrder('Name','N',1);
			$Gui->addHeaderCol('Size',$this->_T->lang('[[DateiGroesse]]'),'','','',1);
			$Gui->setHeaderOrder('Size','S',-1);
			$Gui->addHeaderCol('Type',$this->_T->lang('[[DateiTyp]]'),'','','',1);
			$Gui->setHeaderOrder('Type','T',1);
			$Gui->addHeaderCol('Time',$this->_T->lang('[[Geaendert am]]'),'','','',1);
			$Gui->setHeaderOrder('Time','D',-1);


			foreach ($entries as $key=>$val) {
				$Gui->addRow($val->getID()==$this->_oid?2:($hl?$hl=0:$hl=1));
				$Gui->addCol('ListID',$btnList->process($val->getID()),'','','',1,'',0,'',$noEnc);
				$Gui->addCol('Img','',$val->getImage(),'','',1);
				$colAttribs=array();
				if ($val->isFolder()) {
					$link=$this->_L->getTempLink(null,array('oid'=>$val->getID(),'action'=>$val->getAction(0)));
				} else {
					$link=$this->_Base->path2local($val->getID());
					if (!$link) {
						$link=$this->_L->getTempLink(null,array('oid'=>$val->getID(),'action'=>$val->getAction(0)));
					} else {
						$colAttribs['LinkAttribs']=array(
							'target'=>'_blank',
						);
					}
				}
				$Gui->addCol('Name',$val->getName(),'',$link,'',0,2000,0,'',$colAttribs);
				$Gui->addCol('Size',Framework::formatSize($val->getMeta('size')),'','','',1);
				$Gui->addCol('Type',$val->getMeta('ext'),'','','',1);
				$Gui->addCol('Time',date('d.m.Y H:i',$val->getMeta('time')),'','','',1);
			}
			return $Gui;
		}
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}

}
?>