<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

class ObjSmsQuota extends baseObj {
	public $_action=array('e','e'); // to owerwrite;
	public $_site='sms.php'; // to owerwrite;
	public $_obj_typ='0';
	public $_umeta=array();
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['Title'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}


class geSmsModelQuota extends ObjCore{
	public $_modul='sms';
	public $_table='SmsQuota';
	public $_cfgObjects=array (
		'IdField'=>'id',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'0'=>array(
			'ClassName'=>'ObjSmsQuota',
			'Fields'=>array(
				'id'=>array(
					'TYP'=>'core',
					'Extra'=>'ID',
				),
				'quotaId'=>array(
					'TYP'=>'core',
				),
				'quotaTyp'=>array(
					'TYP'=>'core',
				),
				'dayLimit'=>array(
					'TYP'=>'core',
				),
				'weekLimit'=>array(
					'TYP'=>'core',
				),
				'monthLimit'=>array(
					'TYP'=>'core',
				),
				'yearLimit'=>array(
					'TYP'=>'core',
				),

			),
		),
	);
	public function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','sms')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
	}
	public function objExists($quotaId,$quotaTyp) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'quotaId','Typ'=>'=','Values'=>$quotaId);
		$searchQuery[]=array('Field'=>'quotaTyp','Typ'=>'=','Values'=>$quotaTyp);
		return $this->searchSingleObj($searchQuery);
	}

	public function getMyQuota($uid=0) {
		if (!$uid) {
			$uid=$this->_frm->getUser();
		}
		$result=array(
			'dayLimit'=>0,
			'weekLimit'=>0,
			'monthLimit'=>0,
			'yearLimit'=>0,
		);
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'quotaId','Typ'=>'=','Values'=>$this->_frm->getMyGroups($uid));
		$searchQuery[]=array('Field'=>'quotaTyp','Typ'=>'=','Values'=>'g');

		$rows=0;
		foreach($this->searchObj($rows,$searchQuery) as $Obj) {
			$result['dayLimit']=max($result['dayLimit'],$Obj->getMeta('dayLimit'));
			$result['weekLimit']=max($result['weekLimit'],$Obj->getMeta('weekLimit'));
			$result['monthLimit']=max($result['monthLimit'],$Obj->getMeta('monthLimit'));
			$result['yearLimit']=max($result['yearLimit'],$Obj->getMeta('yearLimit'));
		}
		if ($Obj=$this->objExists($uid,'u')) {
			if ($Obj->getMeta('dayLimit')) $result['dayLimit']=$Obj->getMeta('dayLimit');
			if ($Obj->getMeta('weekLimit')) $result['weekLimit']=$Obj->getMeta('weekLimit');
			if ($Obj->getMeta('monthLimit')) $result['monthLimit']=$Obj->getMeta('monthLimit');
			if ($Obj->getMeta('yearLimit')) $result['yearLimit']=$Obj->getMeta('yearLimit');
		}
		return $result;
	}

	
}
?>