<?php
class geSmsViewPreferences {
	private $_T;
	private $_t;
	private $_frm;
	private $_L;
	private $_E;
	function __construct() {
		global $frm,$t,$T,$E,$L;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_Base=$this->_frm->getStaticModul('sms');
	}

	function &process() {
		$this->Obj=$this->_frm->getPrefs($this->_Base->getModul());
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$box=new BoxGui($this->_Base->getModul().'|showtab_prefs');
		$box->addTab('ident',$this->_T->lang('[[Identitaeten]]'),'#',true);
		$box->setTabContent('ident',$this->getIdentitiesGui());

		$box->setTabOn('ident');
		$tplContent->addContent('content',$box,'CONTENT');
		return $tplContent;
	}
	function &getIdentitiesGui() {
		$Gui=new TemplateGui('core/form_3columns.inc.html');

		require_once('lib/class_FormGui.php');
		$formGui=new FormGui();
		$formGui->setLabelClass('no','no_error');
		$key='identKey';
		$formGui->addField($key,'select',$this->_T->lang('[[Identitaet]]'),0,'fields1');
		$formGui->setValues($key,array(
				0=>'1.'.$this->_T->lang('[[Identitaet]]'),
				1=>'2.'.$this->_T->lang('[[Identitaet]]'),
				2=>'3.'.$this->_T->lang('[[Identitaet]]'),
				3=>'4.'.$this->_T->lang('[[Identitaet]]'),
				4=>'5.'.$this->_T->lang('[[Identitaet]]'),
			)
		);
		$idKey=$formGui->getFieldVal($key,1);
		$formGui->setAttribs($key,array('onchange'=>'document.daten.submit()'));
		
		$key='idName_'.$idKey;
		$formGui->addField($key,'text',$this->_T->lang('[[Bezeichnung]]'),isset($this->Obj[$key])?$this->Obj[$key]:'','fields1');
		$formGui->setRequired($key);
		$key='idNumber_'.$idKey;
		$formGui->addField($key,'text',$this->_T->lang('[[SmsNummerName]]'),isset($this->Obj[$key])?$this->Obj[$key]:'','fields1');
		$formGui->setRequired($key);
		$key='idEMail_'.$idKey;
		$formGui->addField($key,'text',$this->_T->lang('[[E-Mail fuer Benachrichtigungen]]'),isset($this->Obj[$key])?$this->Obj[$key]:'','fields1');
		$formGui->setRequired($key);
		
		$key='idActiv_'.$idKey;
		$formGui->addField($key,'check',$this->_T->lang('[[Aktiv]]'),isset($this->Obj[$key])?$this->Obj[$key]:1,'fields1');
		$key='idDefault_'.$idKey;
		$formGui->addField($key,'check',$this->_T->lang('[[Standardidentitaet]]'),isset($this->Obj['idDefault'])?($this->Obj['idDefault']==$idKey?1:0):1,'fields1');
		$formGui->setNoMeta($key);

		$key='submit';
		$submitVals=array(
			'meta_save_x'=>$this->_T->lang('[[Speichern]]')
		);
		if ($formGui->getFieldVal('idName_'.$idKey,1)) {
			$submitVals['meta_delete_x']=$this->_T->lang('[[Loeschen]]');
			$formGui->setValuesAttribs($key,'meta_delete_x',array('onclick'=>'return lo_form();'));
		}
		$formGui->addField($key,'submit','','','form_submit');
		$formGui->setValues($key,$submitVals);
		
		if (Framework::getParam('meta_delete_x','0','P')) {
			$prefs=array(
				'idNumber_'.$idKey=>'',
				'idName_'.$idKey=>'',
				'idEMail_'.$idKey=>'',
				'idActiv_'.$idKey=>'',
			);
			$this->_frm->insertPrefs($this->_Base->getModul(),$prefs);
			$this->_L->goToLink();
		}

		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$prefs=array();
				$formGui->addMetaToArray($prefs);
				if (preg_match('/[^0-9+]/',$prefs['idNumber_'.$idKey])) {
					if (strlen($prefs['idNumber_'.$idKey])>11) {
						$this->_E->setError('fields','idNumber_'.$idKey);
					}
				} else {
					$prefs['idNumber_'.$idKey]=$this->_Base->formatNumber($prefs['idNumber_'.$idKey]);
					if (strlen($prefs['idNumber_'.$idKey])>16) {
						$this->_E->setError('fields','idNumber_'.$idKey);
					}
				}
				if ($formGui->getFieldVal('idDefault_'.$idKey)) {
					$prefs['idDefault']=$idKey;
				}
				if (!$this->_E->isError()) {
					$this->_frm->insertPrefs($this->_Base->getModul(),$prefs);
					$this->_L->goToLink();
				}
			}
		}
		$Gui->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$Gui->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$Gui->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $Gui;
	}
}