<?php
class StelPrefsGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	function StelPrefsGui() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=& $frm->getStaticModul('stel');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('stel');
	}
	function &process() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$Gui->setName($this->_T->lang('[[Einstellungen fuer Anrufjournal]]'));
		$btSave=new FunctionButtons('save','save');
		$Gui->addFunction($btSave);
		$Gui->addContent($this->getPrefsGui());
		return $Gui;
	}

	function &getPrefsGui() {
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$box=new BoxGui();
		$box->addTab('meta',$this->_T->lang('[[Einstellungen]]'),'#',true);
		$Gui=new TemplateGui('core/form_3columns.inc.html');
		$Gui->addContent('form1',$this->getPrefsForm(),'FORM1');
		//$Gui->addContent('form2',$this->getTimeFormGui(),'FORM2');
		$box->setTabContent('meta',$Gui);
		$tplContent->addContent('content',$box,'CONTENT');
		return $tplContent;
	}
	function &getPrefsForm() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		$formGui=new FormGui();
		//$formGui->setLabelClass('no','no_error');
		$key='defGrant';
		$formGui->setLabelClass('no','no_error',$key);
		$mode='u|g';
		$params=base64_encode(serialize(array('IgnoreUid'=>$this->_Base->getUser())));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);
		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);

		$formGui->addField('info','label',$this->_T->lang('[[Sichtbarkeit]]'),'','fields1');
		$formGui->addField($key,'ttip',$lb_Invit,$this->_frm->getPrefs($this->_Base->getModul(),$key),'fields1');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));

		$key='defCat';
		$formGui->addField($key,'select',$this->_T->lang('[[Kategorie]]'),$this->_frm->getPrefs($this->_Base->getModul(),$key),'fields1');
		$formGui->setValues($key,array(0=>'-') + $this->_Base->listAllCatNames());

		if (Framework::getParam('save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$prefs=array();
				$formGui->addMetaToArray($prefs);
				//debug($prefs);
				$this->_frm->insertPrefs($this->_Base->getModul(),$prefs);
				$this->_L->goToLink();
			}
		}
		return $formGui;
	}
}