<?php
class stelGui {
	var $_Base;
	var $_Obj;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_zefID=0;
	function stelGui() {
		global $frm,$t,$T,$E,$L,$Y,$P;
		$this->_Base=& $frm->getStaticModul('stel');
		$this->_T=&$T;
		$this->_T->loadModul('stel');
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_lGui=&$Y;
		$this->_lang=$this->_frm->getLang();
		if (is_object($this->_P)) {
			$this->_T->loadModul('proj');
			$this->_T->loadModulSql('proj_rule');
			$this->_prj=$this->_P->listMyPrj(1,$this->_Base->getUser());

			$this->_av_prj=array();
			if (is_array($this->_prj)) {
				foreach ($this->_prj as $prjObj) {
					$prjPerms=$this->_P->checkProjectPerms($prjObj->getID(),'stel',$this->_Base->getUser(),$this->_Base->getGroups());
					if ($prjPerms&2) {
						$this->_av_prj[$prjObj->getID()]=$prjObj->getName();
					}
				}
			}
		}

	}
	function _handleRequest() {

	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
	function process() {

	}
	function &getInsertGui() {
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ApplicationTreeGui.php');
		require_once('lib/class_FunctionButtons.php');

		if ($GLOBALS['SESS_MDATA']['stel.php']['L_BACK']) {
			$lBack=$GLOBALS['SESS_MDATA']['stel.php']['L_BACK'];
		} elseif (Framework::getParam('bdate')) {
			$lBack="index.php?site=stel.php&action=v&bdate=".Framework::getParam('bdate');
		} else {
			$lBack="index.php?site=stel.php&action=v";
		}

		$TreeGui=new ApplicationTreeGui();
		$ContGui=new ContentGui();
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$lBack));
		$ContGui->addFunction($btBreak);

		$this->_stelID=Framework::getParam('ID');
		if ($this->_stelID) {
			$this->_Obj=$this->_Base->readTel($this->_stelID);
			if (!$this->_Obj) $this->_stelID=0;
		}
		if ($this->_stelID) {
			$ContGui->setName($this->_T->lang('[[Arnruf bearbeiten]]'));
		} else {
			$ContGui->setName($this->_T->lang('[[Arnruf eintragen]]'));
		}
		//$ContGui->setWidth('650');
		$result=array();
		$InsertGui=$this->_getStelInsertGui($result,true);
		if ($result['insert_ok']) {
			if ($this->_stelID) {
				page_close();
				header("Location:".$lBack);
				exit;
			} else {
				page_close();
				$link='index.php?site=stel.php&action=i';
				header("Location:".$link);
				exit;
			}
		}



		$tplForm=new TemplateGui('core/common_form.inc.html');
		$ContGui->addContent($InsertGui);
		$tplForm->addContent('content',$ContGui,'CONTENT');
		$tplForm->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
		$TreeGui->addContent($tplForm);

		return $TreeGui;


	}
	function &getSimpleInsertGui() {
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_TemplateGui.php');

		$ContGui=new ContentGui();
		$ContGui->setName($this->_T->lang('[[Anrufe erfassen]]'));
		$ContGui->setWidth('650');

		$tplGui=$this->_getStelInsertGui($result);
		if ($result['close']) $this->_frm->addOnload('window.close();');
		$ContGui->addContent($tplGui);
		return $ContGui;


	}

	function &_getStelInsertGui(&$result,$useTime=false) {
		$all_perms=$this->_Base->getAllPerms('l');
		if (is_array($all_perms['l'])) {
			$sel_group=array_keys($all_perms['l']);
		} else {
			$sel_group=$GLOBALS['CFG']['GROUP_ALL'];
		}
		//debug($sel_group);
		$user_array=array(0=>'-',-1=>$this->_T->lang('[[Andere]]')) + $this->_frm->getFullName($this->_frm->getGroupUsers($sel_group));
		$cat_array=array(0=>'-') + $this->_Base->listAllCatNames();

		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');

		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		$formGui->setLabelClass('no','error');
		//$disabled=true;

		$formGui->setLabelClass('','error','info1');
		$formGui->addField('info1','label',$this->_T->lang('[[Metadaten]]'),'','fields1');

		if ($useTime) {
			$key="TelTime";
			$formGui->addField($key,'unixdatetime',$this->_T->lang('[[Datum]]'),$this->_Obj[$key]?$this->_Obj[$key]:time(),'fields1');
			$formGui->setRequired($key);
		}

		$key="TelFrom";
		$formGui->addField($key,'text',$this->_T->lang('[[Anruf von]]'),$this->_Obj[$key]?$this->_Obj[$key]:'','fields1');
		$formGui->setRequired($key);

		$key="TelUser";
		$formGui->addField($key,'select',$this->_T->lang('[[Anruf fuer]]'),$this->_Obj[$key]?$this->_Obj[$key]:'','fields1');
		$formGui->setValues($key,$user_array);
		$formGui->setRequired($key);

		$key="TelCatID";
		$formGui->addField($key,'select',$this->_T->lang('[[Kategorie]]'),$this->_Obj[$key]?$this->_Obj[$key]:$this->getPrefs('defCat'),'fields1');
		$formGui->setValues($key,$cat_array);
		$formGui->setRequired($key);

		if (is_array($this->_av_prj) && !empty($this->_av_prj)) {
			if ($this->_Obj) {
				$defPrjID=intval($this->_Obj['FKProjID']);
			} else {
				$defPrjID=Framework::getParam('_setPrjID',$this->_frm->getPrefs('proj','actualProject'));
			}
			$key='FKProjID';
			$params=base64_encode(serialize(array('MaxEntries'=>1,'useAll'=>0,'onlyIDs'=>array_keys($this->_av_prj))));
			$lb_params=array('Values'=>array());
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Projekt]]'),
				'LabelSep'=>'',
				'mode'=>'o',
				'app'=>'proj',
				'params'=>$params,
				'FieldVal'=>'_PROJECTS',
			);
			$default='';
			$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
			$formGui->addField($key,'ttip',$lb_Invit,$defPrjID?'o_'.$defPrjID:'','fields1');
			$formGui->setParams($key,array('mode'=>'o','params'=>$params));
			if (!Framework::issetParam($key,'P') && $defPrjID && ($defPrjID==Framework::getParam('_setPrjID',$this->_frm->getPrefs('proj','actualProject'),''))) {
				$formGui->setLabelClass('no_att','no_error',$key);
			}
		}


		$key="TelCatID";
		$formGui->addField($key,'select',$this->_T->lang('[[Kategorie]]'),$this->_Obj[$key]?$this->_Obj[$key]:$this->getPrefs('defCat'),'fields1');
		$formGui->setValues($key,$cat_array);
		$formGui->setRequired($key);

		$key="Description";
		$formGui->addField($key,'area',$this->_T->lang('[[Beschreibung]]'),$this->_Obj[$key]?$this->_Obj[$key]:'','fields1');
		$formGui->setAttribs($key,array('rows'=>5));

		$key="send_msg";
		$formGui->addField($key,'check',$this->_T->lang('[[Notes senden]]'),0,'fields1');
		$formGui->setNoMeta($key);

		if ($this->_Base->getCfg('cfg/modul/visibility')) {
			if ($this->_Obj) {
				$tmpGrant=array();
				if (trim($this->_Obj['Users'])) {
					$tmp=explode('|',$this->_Obj['Users']);
					foreach ($tmp as $val) {
						$tmpGrant[]='u_'.$val;
					}
				}
				if (trim($this->_Obj['Groups'])) {
					$tmp=explode('|',$this->_Obj['Groups']);
					foreach ($tmp as $val) {
						$tmpGrant[]='g_'.$val;
					}
				}
				$defGrant=implode('|',$tmpGrant);
			} else {
				$defGrant=$this->getPrefs('defGrant');
			}
			$key='stelGrant';
			$mode='u|g';
			$params=base64_encode(serialize(array('IgnoreUid'=>$this->_Base->getUser())));
			$lb_params=array('Values'=>array());
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
				'LabelSep'=>'',
				'mode'=>$mode,
				'app'=>'cal',
				'params'=>$params,
				'FieldVal'=>'_USERS',
			);
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Gruppen]]'),
				'LabelSep'=>' / ',
				'mode'=>$mode,
				'app'=>'cal',
				'params'=>$params,
				'FieldVal'=>'_GROUPS',
			);
			$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);

			$formGui->setLabelClass('','error','info');
			$formGui->addField('info','label',$this->_T->lang('[[Sichtbarkeit]]'),'','fields2');
			$formGui->addField($key,'ttip',$lb_Invit,$defGrant,'fields2');
			$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));
			$formGui->setNoMeta($key);
		}

		$key='submit';
		$formGui->addField($key,'submit','','','fields3');
		$submitValues=array('insert_x'=>' '.$this->_T->lang('[[Speichern]]').' ');
		if ($this->_stelID) {
			$submitValues['delete_x']=' '.$this->_T->lang('[[Loeschen]]').' ';
			$formGui->setValuesAttribs($key,'delete_x',array('onclick'=>'return lo_form();'));
		}
		$formGui->setValues($key,$submitValues);


		if (Framework::getParam('delete_x',0) && $this->_stelID) {
			$this->_Base->deleteTel($this->_stelID);
			$result['insert_ok']=true;
		}
		if (Framework::getParam('insert_x',0)) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if (!is_array($this->_Obj)) {
					$this->_Obj=array();
				}
				$formGui->addMetaToArray($this->_Obj);
				if ($this->_Obj['FKProjID']) $this->_Obj['FKProjID']=substr($this->_Obj['FKProjID'],2);
				if ($this->_Base->getCfg('cfg/modul/visibility')) {
					$grantG=array();
					$grantU=array();
					if (trim($formGui->getFieldVal('stelGrant',true))) {
						$inv=explode('|',$formGui->getFieldVal('stelGrant',true));
						foreach ($inv as $val) {
							$tmp=explode('_',$val);
							if ($tmp[0]=='u') $grantU[]=$tmp[1];
							if ($tmp[0]=='g') $grantG[]=$tmp[1];
						}
					}
					$this->_Obj['Groups']='|'.implode('|',$grantG).'|';
					$this->_Obj['Users']='|'.implode('|',$grantU).'|';
				}
				if ($this->_stelID) {
					$this->_Obj['TimeModify']=time();
					$this->_Obj['UserModify']=$this->_frm->getUser();
					$this->_Base->updateTel($this->_stelID,$this->_Obj);
					$result['insert_ok']=true;
				} else {
					$this->_Obj['TimeCreate']=$this->_Obj['TimeModify']=time();
					if (!$useTime) $this->_Obj['TelTime']=time();
					$this->_Obj['UserCreate']=$this->_Obj['UserModify']=$this->_frm->getUser();
					$this->_Base->insertTel($this->_Obj);
					$result['close']=true;
					$result['insert_ok']=true;
				}
				if ($formGui->getFieldVal('send_msg',true) && $this->_Obj['TelUser']!=-1) {
					$mailT= new mtFastTemplate ('tpl/'.APP_THEME);
					$mailT->define(array('tpl_email'=>'stel/mail.inc.html'));
					$mailT->assign('TEL_USER',$this->_Obj['TelFrom']);
					$mailT->assign('TEL_DESC',$this->_Obj['Description']);
					$mailT->assign('TEL_CAT',$cat_array[$this->_Obj['TelCatID']]);
					$mailT->assign('TEL_TIME',date('d.m.Y H:i',$this->_Obj['TelTime']));
					$mailT->parse('ROW','subject_mail');
					$mailT->parse('ROW','body_mail');
					$subject=$mailT->getParsed('subject_mail');
					$body=$mailT->getParsed('body_mail');
					$this->_frm->sendmessage(array($this->_Obj['TelUser']),$this->_frm->getUser(),$subject,$body,'','','msg_1.gif');
				}
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));

		$box1=new BoxGui($this->_Base->getModul().'|showtab_stel_ins');
		$defTap='stel_insert';
		$box1->addTab('stel_insert',$this->_T->lang('[[Anrufe erfassen]]'),'#',true);
		$box1->setTabContent('stel_insert',$tplContent);
		$show_tap=$this->getPrefs('showtab_stel_ins');
		$box1->setTabOn($box1->issetTab($show_tap)?$show_tap:$defTap);
		$tplGui=new TemplateGui('core/common_template_intern.inc.html');
		$tplGui->addContent('box1',$box1,'CONTENT');


		return $tplGui;
	}
}
?>