<?php
class TaskSearchGui {
	var $_Base;
	var $_Obj;
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	function TaskSearchGui() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('task');
		$this->_P=&$P;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('task');
		$this->_Base->setUser($this->_frm->getUser());
		$this->_Base->setUser(24);
		$this->_root['s']=$this->_Base->getSystemObj('s',$this->_frm->getLang(),0,true);
		$this->_root['u']=$this->_Base->getSystemObj('u',$this->_frm->getLang(),$this->_Base->getUser(),true);
		$this->_prefs=$this->_frm->getPrefs('task');
	}
	function _handleRequest() {
		if (Framework::getParam('_loadSearch',0) || Framework::getParam('print',0)) {
			$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpSearchTask',1,0);
			//debug($this->_search);
		}
	}
	function process() {
		$this->_handleRequest();
		require_once('lib/class_ApplicationTreeGui.php');
		require_once('lib/class_TemplateGui.php');
		if (Framework::getParam('print',0)) {
			$TopGui=new TemplateGui('core/common_simple_content.inc.html');
			$this->_search['b']=0;
			$this->_search['limit']=0;
			$Gui=$this->getListGui(true);
			$TopGui->addContent('content',$Gui,'CONTENT');
			$PrintID=$this->_frm->insertPrint('task','html',$Gui->process());
			page_close();
			header("Location:print.php?PrintID=$PrintID");
			exit;
		} else {
			$TopGui=new TemplateGui('core/common_form.inc.html');
			$Gui=new ApplicationTreeGui();
			$Gui->addTreeContent($this->getSearchGui());
			$Gui->addContent($this->getListGui($print));
			$TopGui->addContent('content',$Gui,'CONTENT');
			$TopGui->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
			return $TopGui->process();
		}
	}
	function &getListGui($print=false) {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FormFieldsCore.php');
		$rows=0;
		$sql_search=array();
		if ($this->_Base->isRuleUser()) {
			$sub_search=array(
				array(array('Field'=>'RootID','Typ'=>'=','Values'=>$this->_root['s']->getID())),
				array(array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_frm->getUser())),
			);
			$sql_search[]=array('Typ'=>'OR','Values'=>$sub_search);
			if ($this->_search['Member']) {
				$tmp=explode('|',$this->_search['Member']);
				$sUsers=array();
				foreach ($tmp as $val) {
					switch($val[0]) {
						case 'g':
							$sUsers=array_merge($sUsers,$this->_frm->getGroupUsers(substr($val,2)));
						break;
						case 'u':
							$sUsers[]=substr($val,2);
						break;
					}
				}
				$sUsers=array_unique($sUsers);
				if (!empty($sUsers)) {
					if ($this->_search['MemberMode']=='OR') {
						$sql_search[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$sUsers);
					} else {
						$sub_search=array(
							array('Field'=>'FKUserID','Typ'=>'=','Values'=>$sUsers),
							array('Field'=>'FKTaskID','Typ'=>'F=F','Values'=>'TaskID'),
						);
						$sql_search[]=array('Typ'=>'SQL','Values'=>count($sUsers)."=(SELECT COUNT(*) FROM TasksObjUser WHERE ".$this->_Base->_db->getWhere($sub_search).')');
					}
				}
			}
		} else {
			$sql_search[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_frm->getUser());
		}
		switch ($this->_search['Status']) {
			case 'ae':
				$sql_search[]=array('Field'=>'Status','Typ'=>'=','Values'=>4);
			break;
			case 'aa':

			break;
			default:
				$sql_search[]=array('Field'=>'Status','Typ'=>'!=','Values'=>4);
			break;
		}
		switch ($this->_search['Mode']) {
			case 'mf':
				$sql_search[]=array('Field'=>'StartDate','Typ'=>'F!=F','Values'=>'EndDate');
			break;
			case 'of':
				$sql_search[]=array('Field'=>'StartDate','Typ'=>'F=F','Values'=>'EndDate');
			break;
		}
		if ($this->_search['Deleg']) {
			if ($this->_search['Deleg']==1) {
				$sql_search[]=array('Field'=>'Deleg','Typ'=>'=','Values'=>'1');
				$sql_search[]=array('Field'=>'OwnerID','Typ'=>'=','Values'=>$this->_Base->getUser());
			} else {
				$sub_sql=array();
				$sub_sql[]=array(array('Field'=>'Deleg','Typ'=>'!=','Values'=>'1'));
				$sub_sql[]=array(array('Field'=>'OwnerID','Typ'=>'!=','Values'=>$this->_Base->getUser()));
				$sql_search[]=array('Typ'=>'OR','Values'=>$sub_sql);

			}
		}
		if ($this->_search['CatID']) {
			if (is_object($this->_root['u']) && $this->_root['u']->getID()==$this->_search['CatID']) {
				$sql_search[]=array('Field'=>'RootID','Typ'=>'=','Values'=>$this->_root['u']->getID());
			} elseif (is_object($this->_root['s']) && $this->_root['s']->getID()==$this->_search['CatID']) {
				$sql_search[]=array('Field'=>'RootID','Typ'=>'=','Values'=>$this->_root['s']->getID());
			} else {
				$sql_search[]=array('Field'=>'FKDocID','Typ'=>'=','Values'=>$this->_search['CatID']);
			}
		}
		if ($this->_search['FKProjID']) {
			$tmp=explode('|',$this->_search['FKProjID']);
			$sProjects=array();
			foreach ($tmp as $val) {
				$sProjects[]=substr($val,2);
			}

			$sql_search[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$sProjects);
		}
		if ($this->_search['Info']) {
			$sql_search[]=array('Field'=>array('Text','Title'),'Typ'=>'concat','Values'=>$this->_search['Info'],'UseCase'=>false,'OnlyWords'=>false);
		}
		if ($this->_search['DateEndB']) {
			$sql_search[]=array('Field'=>'EndDate','Typ'=>'>=','Values'=>$this->_search['DateEndB']);
		}
		if ($this->_search['DateEndE']) {
			$sql_search[]=array('Field'=>'EndDate','Typ'=>'<=','Values'=>$this->_search['DateEndE']);
		}
		if ($this->_search['DateStartB']) {
			$sql_search[]=array('Field'=>'StartDate','Typ'=>'>=','Values'=>$this->_search['DateStartB']);
		}
		if ($this->_search['DateStartE']) {
			$sql_search[]=array('Field'=>'StartDate','Typ'=>'<=','Values'=>$this->_search['DateStartE']);
		}
		if ($this->_search['Priority']!=-1) {
			$sql_search[]=array('Field'=>'Priority','Typ'=>'=','Values'=>$this->_search['Priority']);
		}

		if (Framework::getParam('_OrderF',0,'G')) {
			$this->setPrefs('taskOrderF',Framework::getParam('_OrderF',0,'G'));
			$this->setPrefs('taskOrderD',Framework::getParam('_OrderD',0,'G'));
		}
		$orderF=$this->getPrefs('taskOrderF','EndDate');
		$orderD=$this->getPrefs('taskOrderD',1);
		if ($orderF=='Members') {
			$this->_sortTask=$orderF;
			$this->_sortTaskOrder=$orderD;
			$sqlOrder="Title ASC";
		} else {
			$this->_sortTask='';
			$sqlOrder=$orderF." ".($orderD==-1?'DESC':'ASC');
			if ($orderF!='Title') $sqlOrder.=",Title ASC";
		}

		//debug($sqlOrder);
		if ($print) {
			$Gui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		} else {
			$Gui=new ApplicationListGui();
			$Gui->setName($this->_T->lang('[[Suche]]'));
		}
		$rows=0;
		$entries=$this->_Base->searchTask($rows,$this->_search['b'],$this->_search['limit'],$sql_search,$sqlOrder);

		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		$Gui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));
		$Gui->setLimit($this->_search['limit']);
		$Gui->setSumRows($rows);
		$Gui->setBegin($this->_search['b']);
		$L=Framework::cloneObj($this->_L);
		$L->setParam('_loadSearch',1);
		$Gui->setNavLink($L);
		$Gui->setActOrder($orderF,$orderD);
		$Gui->setOrderLink($L);

		$Gui->addHeaderCol('Status',$this->_T->lang('[[Status]]'),'','','',1,'',2);
		$Gui->setHeaderOrder('Status','Priority',1);
		$Gui->addHeaderCol('EndDate',$this->_T->lang('[[Aufgabe faellig am]]'),'','','',1);
		$Gui->setHeaderOrder('EndDate','EndDate',-1);
		$Gui->addHeaderCol('Title',$this->_T->lang('[[Aufgabe]]'),'','','',0,2000);
		$Gui->setHeaderOrder('Title','Title',1);
		$Gui->addHeaderCol('Project',$this->_T->lang('[[Projekt]]'),'','','',1);
		$Gui->setHeaderOrder('Project','FKProjID',1);
		$Gui->addHeaderCol('Members',$this->_T->lang('[[Zustaendigkeit]]'),'','','',1);
		$Gui->setHeaderOrder('Members','Members',1);
		$Gui->addHeaderCol('StartDate',$this->_T->lang('[[Start am]]'),'','','',1);
		$Gui->setHeaderOrder('StartDate','StartDate',1);
		$Gui->addHeaderCol('OwnerID',$this->_T->lang('[[Erstellt von]]'),'','','',1);
		$Gui->setHeaderOrder('OwnerID','OwnerID',1);



		$date=time();
		foreach (array_keys($entries) as $key) {
			$entries[$key]['Members']=$this->_Base->getTaskUserData($key);
		}
		if ($this->_sortTask) {
			uasort($entries,array($this,'sortTask'));
		}
		foreach ($entries as $key=>$val) {
			$Gui->addRow($hl?$hl=0:$hl=1,'top');
			if ($val['EndDate'] !=$val['StartDate']) {
				if ($val['Status']==4) {
					$img_prio=$GLOBALS['IMG_PRIO'][$val['Priority']][1];
				} else {
					if ($val['EndDate']<$date) $img_prio=$GLOBALS['IMG_PRIO'][$val['Priority']][0];
					elseif ($val['StartDate']>$date) $img_prio=$GLOBALS['IMG_PRIO'][$val['Priority']][2];
					else $img_prio=$GLOBALS['IMG_PRIO'][$val['Priority']][1];
				}
			} else {
				if ($val['Status']==4) {
					$img_prio=$GLOBALS['IMG_PRIO'][$val['Priority']][1];
				} else {
					if ($val['StartDate']>$date) $img_prio=$GLOBALS['IMG_PRIO'][$val['Priority']][2];
					else $img_prio=$GLOBALS['IMG_PRIO'][$val['Priority']][1];
				}
			}
			$Gui->addCol('Priority','',$img_prio);
			if ($val['Deleg']) {
				$img_team=$GLOBALS['IMG_DELEG'][$val['Status']];
			} elseif (count($val['Members'])==1) {
				$img_team=$GLOBALS['IMG_PERSONAL'][$val['Status']];
			} else {
				$img_team=$GLOBALS['IMG_TEAM'][$val['Status']];
			}
			//    addCol($ID,$Name='',$Image='',$Link='',$Align='',$NoWrap='',$Width='',$Span=0,$Valign='',$add=null)
			$Gui->addCol('Status','',$img_team,'','',1);

			$extra=array();
			$extra['Attribs']['style']='font-weight:bold;';
			$goLink='index.php?site=task.php&action=vo&TaskID='.$key;
			if ($val['OwnerID']==$this->_frm->getUser()) {
				$extra['LinkAttribs']=array(
					'onclick'=>'return goToView(this);',
					'ondblclick'=>'return goToEdit(this,\'action=vo\',\'action=i\');',
				);
			} else {
				//$goLink='';
			}

			if ($val['EndDate']!=$val['StartDate']) {
				$Gui->addCol('EndDate',date('d.m.Y',$val['EndDate']),'',$goLink,'',0,'',0,'',$extra);
			} else {
				$Gui->addCol('EndDate','-');
			}
			$Gui->addCol('Title',$val['Title'],'',$goLink,'',0,'',0,'',$extra);
			if ($this->_search['ViewDesc']) {
				$Gui->addColSub('Title','N',$val['Text']);
			}

			if ($val['FKProjID'] && $this->_P && ($pName=$this->_P->getCachedProjectName($val['FKProjID']))) {
				$Gui->addCol('Project',$pName,'','index.php?site=proj.php&oid='.$val['FKProjID'],'',0,'',0,'');
			} else {
				$Gui->addCol('Project','-');
			}


			//$Gui->addColSub('Title','C','');
			$iusers=array();
			foreach ($val['Members'] as $ukey=>$uval) {
				if ($uval['Done']==5 || ($uval['Done']==4 && $ukey==$val['OwnerID'] && $val['Deleg'])) continue;
				$iusers[]='<img src="img/'.APP_THEME.'/'.$GLOBALS['IMG_PERSONAL'][$uval['Done']].'" class="list" border="0">'.FrameWork::entities($this->_frm->getCachedUserName($ukey,1,1));
			}
			$Gui->addCol('Members',implode('<br />',$iusers),'','','',1,'',0,'',$noEnc);
			$Gui->addCol('StartDate',date('d.m.Y',$val['StartDate']),'','','',1);
			$Gui->addCol('OwnerID',$this->_frm->getCachedUserName($val['OwnerID'],1,1),'','','',1);
		}
		if (!$print) {
			$btPrint=new FunctionButtons('print','button_link',array('TITLE'=>$this->_T->lang('[[Drucken]]'),'LINK'=>$this->_L->getTempLink(null,array('print'=>1)),'TARGET'=>'_blank'));
			$Gui->addFunction($btPrint,1);
		}
		return $Gui;
	}

	function &getSearchGui() {
		//debug($_POST);
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_DateSelectForm.php');
		require_once('lib/class_FunctionButtons.php');

		$ContGui=new TemplateGui('core/common_content_border.inc.html');
		$selDateGuiEnd=new DateSelectForm('end',$this->_T->lang('[[Faelligkeit]]'));
		$selDateGuiEnd->setAvMode(array(3));
		$selDateGuiEnd->setMode(3);
		if ($this->_search['DateEndB'] || $this->_search['DateEndE']) {
			$selDateGuiEnd->setDate(array($this->_search['DateEndB'],$this->_search['DateEndE']));
		} else {
			$selDateGuiEnd->setDate(array(0,0));
		}
		$ContGui->addContent('dateSelectEnd',$selDateGuiEnd->process(),'CONTENT');

		$selDateGuiStart=new DateSelectForm('start',$this->_T->lang('[[Startdatum]]'));
		$selDateGuiStart->setAvMode(array(3));
		$selDateGuiStart->setMode(3);
		if ($this->_search['DateStartB'] || $this->_search['DateStartE']) {
			$selDateGuiStart->setDate(array($this->_search['DateStartB'],$this->_search['DateStartE']));
		} else {
			$selDateGuiStart->setDate(array(0,0));
		}
		$ContGui->addContent('dateSelectStart',$selDateGuiStart->process(),'CONTENT');

		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key='Info';
		$formGui->addField($key,'text',$this->_T->lang('[[Suchtext]]'),Framework::getParam('info',$this->_search[$key],'P'),'');

		$key='Status';
		$formGui->addField($key,'select',$this->_T->lang('[[Status]]'),$this->_search[$key]?$this->_search[$key]:'an','');
		$formGui->setValues($key,array(
			'an'=>$this->_T->lang('[[Alle nicht erledigten Aufgaben]]'),
			'ae'=>$this->_T->lang('[[Alle erledigten Aufgaben]]'),
			'aa'=>$this->_T->lang('[[Alle Aufgaben]]'),
		));

		$key='Mode';
		$formGui->addField($key,'select',$this->_T->lang('[[Aufgabenart]]'),$this->_search[$key]?$this->_search[$key]:'al','');
		$formGui->setValues($key,array(
			'al'=>$this->_T->lang('[[Alle]]'),
			'mf'=>$this->_T->lang('[[Mit Faelligkeit]]'),
			'of'=>$this->_T->lang('[[Ohne Faelligkeit]]'),
		));
		$key='Deleg';
		$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Delegiert]]'),$this->_search[$key]?$this->_search[$key]:'an','');
		$formGui->setValues($key,array(
			'0'=>$this->_T->lang('[[Alle]]'),
			'-1'=>$this->_T->lang('[[Nein]]'),
			'1'=>$this->_T->lang('[[Ja]]'),
		));

		$key='FKProjID';
		$params=base64_encode(serialize(array('useAll'=>1,'prjPerms'=>$this->_Base->isRuleUser()?0:1)));

		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Projekte]]'),
			'LabelSep'=>'',
			'mode'=>'o',
			'app'=>'proj',
			'params'=>$params,
			'FieldVal'=>'_PROJECTS',
		);
		$default='';
		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,$default,'fields1');
		$formGui->setParams($key,array('mode'=>'o','no_width'=>1,'params'=>$params));

		if ($this->_Base->isRuleUser()) {
			$lb_params=array('Values'=>array());
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
				'LabelSep'=>'',
				'mode'=>'u|g',
				'app'=>'task',
				'params'=>$params,
				'FieldVal'=>'_USERS',
			);
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Gruppen]]'),
				'LabelSep'=>' / ',
				'mode'=>'u|g',
				'app'=>'task',
				'params'=>$params,
				'FieldVal'=>'_GROUPS',
			);
			$key='Member';
			$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
			$formGui->addField($key,'ttip',$lb_Invit,isset($this->_search[$key])?$this->_search[$key]:'u_'.$this->_frm->getUser(),'');
			$formGui->setParams($key,array('mode'=>'u|g','no_width'=>1,'limit'=>20,'app'=>'task','params'=>''));


			$key='MemberMode';
			$formGui->addField($key,'radiolist_h','',$this->_search[$key]?$this->_search[$key]:'OR','');
			$formGui->setValues($key,array(
				'OR'=>$this->_T->lang('[[modeEiner]]'),
				'AND'=>$this->_T->lang('[[modeAlle]]'),
			));
		}
		$key='Priority';
		$formGui->addField($key,'select',$this->_T->lang('[[Prioritaet]]'),$this->_search[$key]?$this->_search[$key]:-1,'');
		$formGui->setValues($key,array(
			-1=>'-',
			0=>$this->_T->lang('[[HOCH]]'),
			1=>$this->_T->lang('[[NORMAL]]'),
			2=>$this->_T->lang('[[NIEDRIG]]'),
		));


		$catArray=array(
			0=>array(
				0=>'-',
			)
		);
		if (is_object($this->_root['u'])) {
			//$catArray[0][$this->_root['u']->getID()]=$this->_T->lang('[[Nur privat]]');
			$catArray[$this->_root['u']->getName()][$this->_root['u']->getID()]='--- '.$this->_T->lang('[[Alle]]').' ---';
			$catArray[$this->_root['u']->getName()]=$catArray[$this->_root['u']->getName()] + Framework::extractObjMeta($this->_Base->ListSubEntrys($this->_root['u']->getID(),'','Title_'.$this->_frm->getLang()),'Title_'.$this->_frm->getLang());
		}
		if (is_object($this->_root['s'])) {
			//$catArray[0][$this->_root['s']->getID()]=$this->_T->lang('[[Nur geschaeftlich]]');
			$catArray[$this->_root['s']->getName()][$this->_root['s']->getID()]='--- '.$this->_T->lang('[[Alle]]').' ---';
			$catArray[$this->_root['s']->getName()]=$catArray[$this->_root['s']->getName()] + Framework::extractObjMeta($this->_Base->ListSubEntrys($this->_root['s']->getID(),'','Title_'.$this->_frm->getLang()),'Title_'.$this->_frm->getLang());
		}
		$key='CatID';
		$formGui->addField($key,'select_grp',$this->_T->lang('[[Kategorie]]'),$this->_search[$key]?$this->_search[$key]:0,'');
		$formGui->setValues($key,$catArray);





		$key='ViewDesc';
		$formGui->addField($key,'check',$this->_T->lang('[[Beschreibung anzeigen]]'),$this->_search[$key]?$this->_search[$key]:0,'');

		$submit_array=array(
			'view_x'=>' '.$this->_T->lang('[[Suchen]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','fields1');
		$formGui->setValues($key,$submit_array);


		$ContGui->addContent('formgui',$formGui,'CONTENT');

		$this->_search=array(
			'DateEndB'=>$selDateGuiEnd->getDate('B'),
			'DateEndE'=>$selDateGuiEnd->getDate('E'),
			'DateStartB'=>$selDateGuiStart->getDate('B'),
			'DateStartE'=>$selDateGuiStart->getDate('E'),
			'limit'=>50,
			'b'=>Framework::getParam('view_x','','P')?0:Framework::getParam('b',0,'G'),
		);
		$formGui->addMetaToArray($this->_search,'',1);
		$this->_frm->savePostData($this->_Base->getModul(),'tmpSearchTask',null,$this->_search);
		return $ContGui;
	}
	function sortTask($a,$b) {
		//if ($a['StartDate']==$a['EndDate']) $aT=1; else  $aT=0;
		//if ($b['StartDate']==$b['EndDate']) $bT=1; else  $bT=0;
		if ($this->_sortTask=='Members') {
			$asort='';
			foreach ($a['Members'] as $ukey=>$uval) {
				if ($uval['Done']==5 || ($uval['Done']==4 && $ukey==$a['OwnerID'] && $a['Deleg'])) continue;
				$asort=$this->_frm->getCachedUserName($ukey,1,1);
				break;
			}
			$bsort='';
			foreach ($b['Members'] as $ukey=>$uval) {
				if ($uval['Done']==5 || ($uval['Done']==4 && $ukey==$b['OwnerID'] && $b['Deleg'])) continue;
				$bsort=$this->_frm->getCachedUserName($ukey,1,1);
				break;
			}
			return (strnatcasecmp($asort,$bsort)*$this->_sortTaskOrder);
		} else {
			return 0;
		}
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
}
?>