<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
function DeleteObject (&$new_obj) {
	global $frm,$Task;
	if (is_object($new_obj)) {
		$this_action=$frm->getObjAction ($Task->getModul(),$new_obj->getActionMode(0),'f_delete');
		if ($Task->isAllowedAction($new_obj,reset($this_action))) {
			if ($new_obj->isFolder()) {
				$sub_entrys=$Task->ListSubEntrys($new_obj->getID());
				foreach ($sub_entrys as $tmp_obj) {
					DeleteObject($tmp_obj);
				}
			}
			switch ($new_obj->getMeta('DocType')) {
				case 'link':
					$Task->deleteParentMeta($new_obj);
				break;
			}
			$Task->deleteMeta($new_obj);
		} else {
			return array('no_del_perms',$new_obj->getID());
		}
	}
	return false;
}
?>