<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$obj_action=$frm->getObjAction($Task->getModul(),$obj->getActionMode(0));
if ($Task->isAllowedAction($obj,$obj_action[$new])) {
	$update=false;
	switch ($new) {
		case 'n_fol':
			$new_obj=new TObj_fol();
			$new_obj->setMeta('DocType','fol');
			$new_obj->setMeta('MenuImage','tree.gif');
			$new_obj->setMeta('ParentID',$obj->getID());
			$new_obj->setMeta('RootID',$obj->getMeta('RootID'));
			break;
	}
	$new_obj->setAcl(-1);
	$meta_action=$frm->getObjAction($Task->getModul(),'e_'.$new_obj->getActionMode(0));
	//Title
	if ($Task->isAllowedAction($new_obj,$meta_action['e|title'])) {
		if ($ObjLang || !$Task->isAllowedAction($new_obj,$meta_action['e|title_lang'])) {
			if (trim($_POST['ObjTitle_'.$session_lang])) {
				foreach ($CFG['AV_LANG'] as $val) {
					$new_obj->setMeta('Title_'.$val,trim($_POST['ObjTitle_'.$session_lang]));
				}
				$update=true;
			} else {
				$ActionError['fields']['ObjTitle_'.$session_lang]=1;
			}
		} else {
			foreach ($CFG['AV_LANG'] as $val) {
				if (in_array($val,$CFG['MA_LANG'])) {
					if (trim($_POST['ObjTitle_'.$val])) {
						$new_obj->setMeta('Title_'.$val,trim($_POST['ObjTitle_'.$val]));
						$update=true;
					} else {
						$ActionError['fields']['ObjTitle_'.$val]=1;
					}
				} else {
					$new_obj->setMeta('Title_'.$val,trim($_POST['ObjTitle_'.$session_lang]));
				}
			}
		}
	}
	//Perms
	if ($Task->isAllowedAction($obj,$meta_action['e|groups'])) {
		if (is_array($_POST['ObjGroups']) && count($_POST['ObjGroups'])) {
			$tmp=array();
			foreach ($_POST['ObjGroups'] as $val) {
				$tmp[]=$val.',1';
			}
			$new_obj->setMeta('Groups','|'.implode('|',$tmp).'|');
			$update=true;
		} else {
			$ActionError['fields']['ObjGroups']=1;
		}
	} else {
		$new_obj->setMeta('Groups','|');
	}

	if (!$ActionError && $update) {
		$new_obj->setMeta('TimeCreate',time());
		$new_obj->setMeta('TimeModify',time());
		$new_obj->setMeta('UserCreate',$user_id);
		$new_obj->setMeta('UserModify',$user_id);
		$new_obj->setMeta('Users','|');
		$new_obj->setMeta('ParentID',$obj->getID());
		$new_obj->setMeta('RootID',$obj->getMeta('RootID'));
		$new_obj->setMeta('UserID',$obj->getMeta('UserID'));
		$Task->insertMeta($new_obj);
		page_close();
		header("Location:index.php?site=$site&oid=".$new_obj->getID());
		exit;
	}


} 