<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$obj_action=$frm->getObjAction($Task->getModul(),'task');
if ($Task->isAllowedTAction($TaskObj,$obj_action[$obj_action_val])) {
	$location='';
	switch ($obj_action_val) {
		case 'delete':
		case 'delete_a':
			$Task->deleteTaskObject($TaskObj);
			if (isset($SESS_MDATA[$site]['L_BACK'])) {
				$location=$SESS_MDATA[$site]['L_BACK'];
			} elseif ($qlink) {
				$location="index.php?site=$site&action=s$qlink";
			} else {
				$location="index.php?site=$site&action=b&mode=$mode&oid=$oid&o=$o&a=$a&b=$b";
			}
			break;
		case 'delete_o':
			$Task->deleteTaskObject($TaskObj,1);
			if (isset($SESS_MDATA[$site]['L_BACK'])) {
				$location=$SESS_MDATA[$site]['L_BACK'];
			} elseif ($qlink) {
				$location="index.php?site=$site&action=s$qlink";
			} else {
				$location="index.php?site=$site&action=b&mode=$mode&oid=$oid&o=$o&a=$a&b=$b";
			}
			break;
		case 'modify':
			$location="index.php?site=$site&action=i&mode=$mode&oid=$oid&o=$o&a=$a&b=$b&TaskID=".$TaskObj['TaskID'];
			if ($qlink) $location.="&qlink=".urlencode($qlink);
			break;
		case 'copy':
			$location="index.php?site=$site&action=i&mode=$mode&oid=$oid&o=$o&a=$a&b=$b&cop=1&TaskID=".$TaskObj['TaskID'];
			if ($qlink) $location.="&qlink=".urlencode($qlink);
		break;
		case 'disinvite':
			$Task->updateUserStatus($TaskObj['TaskID'],$Task->getUser(),2);
			$Task->deleteUserTaskLog($TaskObj['TaskID'],$Task->getUser());
			if ($TaskObj['Notes']) {
				$log_tras=array(
					'{EBEGIN}'=>date('d.m.Y',$TaskObj['StartDate']),
					'{ETITLE}'=>trim($TaskObj['Title']),
					'{ETEXT}'=>trim($TaskObj['Text']),
					'{TEXT}'=>'',
					'{OUSER}'=>'',
				);
				$frm->sendmessage(array($TaskObj['OwnerID']),
					$user_id,
					strtr($T->lang('[[task_action_disinvite_title]]'),$log_tras),
					strtr($T->lang('[[task_action_disinvite_text]]'),$log_tras),
					"?site=task.php&action=vo&TaskID=".$TaskObj['TaskID'],
					$TaskObj['Title'],
					$IMG_NOTES);
			}
		break;
		case 's_mail':
			$tmp_users=$Task->getTaskUsers($TaskObj['TaskID']);
			foreach ($tmp_users as $key=>$val) {
				if ($val==5 || $val==3) unset($tmp_users[$key]);
			}
			$iv_users=$frm->getFullName(array_keys($tmp_users),0,1);
			if (!is_array($iv_users)) $iv_users=array();
			$log_tras=array(
				'{EBEGIN}'=>date('d.m.Y',$TaskObj['StartDate']),
				'{ETITLE}'=>trim($TaskObj['Title']),
				'{ETEXT}'=>trim($TaskObj['Text']),
				'{TEXT}'=>trim($comment),
				'{EUSER}'=>implode(', ',$iv_users),
			);
			if ($TaskObj['StartDate']!=$TaskObj['EndDate']) $log_tras['{EEND}']=date('d.m.Y',$TaskObj['EndDate']); else $log_tras['{EEND}']='-';

			$body=strtr($T->lang('[[task_action_invit_text]]'),$log_tras);
			$body.="\r\n \r\n \r\n".Framework::getSelfDir(true).'/'."main.php?site=task.php&action=vo&TaskID=".$TaskObj['TaskID'];
			$frm->setUserData('mail',1,strtr($T->lang('[[task_action_invit_title]]'),$log_tras));
			$frm->setUserData('mail',2,$body);
			//debug($body);
			$location="index.php?site=mail.php&show=compose&a=new&getUserSubject=1&getUserBody=2";
			if ($mail_to) {
				$frm->setUserData('mail',3,$mail_to);
				$location.="&getUserTO=3";
			}
			$GLOBALS['SESS_MDATA']['mail.php']['L_BACK']=array(0=>$L->getTempLink(array('obj_action_val','obj_action_x','mail_to')));
			break;
	}
	if ($location) {
		page_close();
		header('Location:'.$location);
		exit;
	}
}
?>
