<?php
class UserStatusObj {
	function UserStatusObj($val='') {
		$this->_val=$val;
	}
	function getVal() {
		return $this->_val;
	}
	function process() {
		return $this->_val?'<span style="line-height:15px;font-size:10px;letter-spacing:10px;background-color:'.$this->_val.';border:1px solid #000;">&nbsp;</span>':'';
	}
}
class UserFormFileObj {
	function UserFormFileObj($val='',$fid='') {
		$this->_name=$val;
		$this->_fid=$fid;
	}
	function getVal() {
		return $this->_name;
	}
	function process() {
		global $frm,$L;
		$result=Framework::entities($this->_name);
		if ($this->_fid) {
			$Fmng=& $frm->getStaticModul('fmng');
			$Fmng->setRule(true);
			$File=$Fmng->readFile($this->_fid,0);
			if ($File) {
				if (Framework::getParam('dump_'.$this->_fid,0)) {
					$Fmng->dumpFile($this->_fid,0,1,$this->_name);
					exit;
				}
				$result='<a href="'.$L->getTempLink(null,array('dump_'.$this->_fid=>1)).'" style="white-space:nowrap"><img src="img/ge/obj_img/'.$File['FileImg'].'" class="list" />'.Framework::entities($this->_name).'</a>';
			}
		}
		return $result;
	}
}

class UserFormData {
	var $_modul='uform';
	var $_metaFields=array();
	var $_searchFields=array();
	var $_listFields=array();
	var $_listFieldsShow=array();
	var $_listFieldsExport=array();
	var $_listFieldsOver=array();
	var $_ID2Group=array();
	var $_print=false;
	function UserFormData($print=false) {
		global $db,$frm,$T;
		$this->_frm=&$frm;
		$this->_db=&$db;
		$this->_BaseForm=& $frm->getStaticModul('uform');
		$this->_BaseSelect=& $frm->getStaticModul('uform_select');
		$this->_BaseFields=& $frm->getStaticModul('uform_fields');
		$this->_T=&$T;
		$this->_print=$print;
	}
	function &loadSystemObj($val,$useFieldPerms=false,$myRules=null) {
		$Obj=$this->_BaseForm->getSystemForm($val);
		if (is_object($Obj)) {
			$this->setFormObj($Obj,$useFieldPerms,$myRules);
			return $Obj;
		}
	}
	function loadFormByID($ID) {
		$Obj=$this->_BaseForm->getObj($ID);
		if (is_object($Obj)) {
			$this->setFormObj($Obj);
			return $Obj;
		}
		return false;
	}
	function setFormObj(&$Obj,$useFieldPerms=false,$myRules=null) {
		$this->_formObj=&$Obj;
		$this->_BaseFields->setFormObj($this->_formObj);
		$this->_ID2Group=array();
		$this->_metaFields=array();
		$this->_listFields=array();
		$this->_listFieldsShow=array();
		$this->_listFieldsExport=array();
		$this->_listFieldsOver=array();
		$this->_searchFields=array();
		$this->_formFields=$this->_BaseFields->listFormFields();
		$this->_useFieldPerms=$useFieldPerms;

		if (is_array($this->_formFields[0])) {
			foreach ($this->_formFields[0] as $gkey=>$fGroup) {
				if ($this->_useFieldPerms) {
					$acl=$this->calcFieldAcl($fGroup,$myRules);
					//debug($acl);
					$this->_formFields[0][$gkey]->setAcl($acl);
				}
				$this->_ID2Group[$fGroup->getID()]=0;
				$this->_typ2ID[$fGroup->getMeta('Typ')][]=$fGroup->getID();
				if ($fGroup->getMeta('Multiple')) {
					$this->_metaFields[$fGroup->getID()]='F_'.$fGroup->getID();
				}
				if (is_array($this->_formFields[$fGroup->getID()])) {
					foreach ($this->_formFields[$fGroup->getID()] as $fkey=>$fObj) {
						if ($this->_useFieldPerms) {
							$this->_formFields[$fGroup->getID()][$fkey]->setAcl($acl);
						}
						$this->_ID2Group[$fObj->getID()]=$fGroup->getID();
						$this->_typ2ID[$fObj->getMeta('Typ')][]=$fObj->getID();
						if (!$fGroup->getMeta('Multiple')) {
							$this->_metaFields[$fObj->getID()]='F_'.$fObj->getID();
							if ($fObj->getMeta('useList')) {
								$this->_listFields[$fObj->getID()]='F_'.$fObj->getID();
								if ($fObj->getMeta('useList')==1) {
									$this->_listFieldsShow[$fObj->getID()]='F_'.$fObj->getID();
								}
								if ($fObj->getMeta('useList')==2) {
									$this->_listFieldsOver[$fObj->getID()]='F_'.$fObj->getID();
								}
								if ($fObj->getMeta('Typ')=='status' || $fObj->getMeta('Typ')=='status_txt') {
									$Values=unserialize($fObj->getMeta('Value'));
									if (is_array($Values['Status'])) {
										foreach ($Values['Status'] as $cval) {
											$this->_listFields[$cval['fid']]='F_'.$cval['fid'];
										}
									}
								}
							}
							if ($fObj->getMeta('useSearch')) {
								$this->_searchFields[$fObj->getID()]='F_'.$fObj->getID();
							}
						}
						if ($fObj->getMeta('useExport')==1) {
							$this->_listFieldsExport[$fObj->getID()]='F_'.$fObj->getID();
						}
					}
				}
			}
		}
	}
	function calcPerms($myRules=null,$quick=false) {
		$result=0;
		if (is_array($this->_formFields[0])) {
			foreach ($this->_formFields[0] as $fkey=>$fGroup) {
				$acl=$this->calcFieldAcl($fGroup,$myRules);
				$this->_formFields[0][$fkey]->setAcl($acl);
				if (!$quick || $fGroup->getMeta('useQuick')) {
					$result=$result|$acl;
				}
			}
		}
		return $result;
	}
	function calcFieldAcl(&$Obj,$myRules=null) {
		$acl=0;
		if (preg_match("/\|".$this->_frm->getUser().",([0-9]+)\|/",$Obj->getMeta('PermsUsers'),$res)) {
			$acl=intval($res[1]);
		} else {
			$chunks=array_chunk($this->_frm->getMyGroups(),100);
			foreach($chunks as $grp) {
				if (preg_match_all("/\|(?:".implode('|',$grp)."),([0-9]+)/",$Obj->getMeta('PermsGroups'),$res)) {
					foreach ($res[1] as $v) {
						$acl=$acl|intval($v);
					}
				}
			}
			if (isset($myRules) && !empty($myRules) && preg_match_all("/\|(?:".implode('|',$myRules)."),([0-9]+)/",$Obj->getMeta('PermsRules'),$res)) {
				foreach ($res[1] as $v) {
					$acl=$acl|intval($v);
				}
			}
		}
		return $acl;
	}
	function &getFormObj() {
		return $this->_formObj;
	}
	function &getFormFields($key=null) {
		if (isset($key)) {
			return $this->_formFields[$key];
		} else {
			return $this->_formFields;
		}
	}
	function getAllFieldsID() {
		return array_keys($this->_ID2Group);
	}
	function getMetaFields() {
		return $this->_metaFields;
	}
	function getSearchFields() {
		return $this->_searchFields;
	}
	function getListFields() {
		return $this->_listFields;
	}
	function getListFieldsShow() {
		return $this->_listFieldsShow;
	}
	function getListFieldsExport() {
		return $this->_listFieldsExport;
	}
	function getListFieldsOver() {
		return $this->_listFieldsOver;
	}
	function &getFieldObj($ID) {
		return isset($this->_formFields[$this->_ID2Group[$ID]][$ID])?$this->_formFields[$this->_ID2Group[$ID]][$ID]:false;
	}
	function setValueCallBack($typ,$callBack) {
		$this->_cbValue[$typ]=&$callBack;
	}
	function getFormFieldsByTyp($Typ) {
		if (isset($this->_typ2ID[$Typ])) {
			return $this->_typ2ID[$Typ];
		}
		return array();
	}
	function Entry2Value(&$fObj,&$valData,$valKey,$delim="\n",&$obj_list = null,$subId='') {
		$val=$valData[$valKey];
		if (isset($this->_cbValue[$fObj->getMeta('Typ')])) {
			$result=call_user_func_array($this->_cbValue[$fObj->getMeta('Typ')],array(&$fObj,&$val));
		} else {
			switch ($fObj->getMeta('Typ')) {
				case 'int':
					$fConfig=unserialize($fObj->getMeta('Config'));
					$result=Framework::numberFormat($val,$fConfig['decimals']);
				break;
				case 'fk_addr':
					if (trim($val)) {
						$Addr=& $this->_frm->getStaticModul('addr');
						$tmp=explode('|',$val);
						$result=array();
						foreach ($tmp as $id) {
							$tmpObj=$Addr->getAddrObj(substr($id,2));
							if (is_object($tmpObj)) {
								$result[]=$tmpObj->getName();
								if (isset($obj_list) && is_array($obj_list)) {
									$obj_list[]=$tmpObj;
								}
							}
						}
					}
				break;
				case 'fk_user':
					if (trim($val)) {
						$tmp=explode('|',$val);
						$result=array();
						foreach ($tmp as $id) {
							$tmpObj=$this->_frm->getCachedUserName(substr($id,2));
							if ($tmpObj) {
								$result[]=$tmpObj;
							}
						}
					}
				break;
				case 'date':
					if ($val && $val!='0000-00-00') {
						$result=Framework::dateSql('d.m.Y',$val);
					}
				break;
				case 'check':
					switch ($val) {
						case 1:
							$result=$this->_T->Lang('[[Ja]]');
						break;
						case -1:
							$result=$this->_T->Lang('[[Nein]]');
						break;

					}
				break;
				case 'select':
					if ($val) {
						$result=$this->_BaseSelect->getCachedValue($val);
					}
				break;
				case 'mselect':
					if (trim($val)) {
						$tmp=explode(',',$val);
						$result=array();
						foreach ($tmp as $id) {
							$tmpObj=$this->_BaseSelect->getCachedValue($id);
							if ($tmpObj) {
								$result[]=$tmpObj;
							}
						}
					}
				break;
				case 'fk_comp':
					if (trim($val)) {
						$Zef=& $this->_frm->getStaticModul('zef');
						$tmp=explode(',',$val);
						$result=array();
						foreach ($tmp as $id) {
							$tmpObj=$Zef->getCachedCompanyName($id);
							if ($tmpObj) {
								$result[]=$tmpObj;
							}
						}
					}
				break;
				case 'file':
					//debug($val);
					if (is_array($val)) {
						$result=new UserFormFileObj($val['name']);
					} elseif (trim($val)) {
						$tmp=explode('/',$val);
						$result=new UserFormFileObj($tmp[0],$tmp[1]);
					}
				break;
				case 'status':
					if ($val) {
						$Config=unserialize($fObj->getMeta('Config'));
						if ($Config['isEditable']) {
							$result=new UserStatusObj($val);
						} else {
							$result=$this->calcStatus($fObj,$valData);
						}
					} else {
						$result=$this->calcStatus($fObj,$valData);
					}
				break;
				case 'status_txt':
					if ($val) {
						$Config=unserialize($fObj->getMeta('Config'));
						if ($Config['isEditable']) {
							$result=$this->_BaseSelect->getCachedValue($val);
						} else {
							$result=$this->calcStatus($fObj,$valData);
						}
					} else {
						$result=$this->calcStatus($fObj,$valData);
					}
				break;
				case 'area':
					$result=$val;
					if ($val) {
						require_once('lib/class_IFrameGui.php');
						$Config=unserialize($fObj->getMeta('Config'));
						if ($Config['html']) {
							$settings=array(
								'id'=>$fObj->getId().$subId,
								'width'=>'100%',
								'height'=>'100px',
							);
							if ($this->_print) {
								$settings['maxheight']=0;
							}
							$result=new IFrameGui($val,$settings);
						}
					}
				break;
				default:
					$result=$val;
				break;
			}
		}
		return is_array($result)?implode($delim,$result):$result;
	}

	function calcStatus(&$fObj,&$valData) {
		$Values=unserialize($fObj->getMeta('Value'));
		if (is_array($Values['Status'])) {
			foreach ($Values['Status'] as $cfg) {
				$valObj=$this->getFieldObj($cfg['fid']);
				if (is_object($valObj)) {
					$fkey='F_'.$cfg['fid'];
					$return=false;
					switch ($cfg['mode']) {
						case 'em':
							switch($valObj->getMeta('Typ')) {
								case 'date':
									if (!$valData[$fkey] || $valData[$fkey]=='0000-00-00') $return=true;
								break;
								default:
									if (!$valData[$fkey]) $return=true;
								break;
							}
						break;
						case 'nem':
							switch($valObj->getMeta('Typ')) {
								case 'date':
									if ($valData[$fkey] && $valData[$fkey]!='0000-00-00') $return=true;
								break;
								default:
									if ($valData[$fkey]) $return=true;
								break;
							}
						break;
						case 'is':
							switch($valObj->getMeta('Typ')) {
								case 'date':
									if ($cfg['val']==-1) $cfg['val']=date('Y-m-d');
									if ($cfg['val']==$valData[$fkey]) $return=true;
								break;
								default:
									if ($cfg['val']==$valData[$fkey]) $return=true;
								break;
							}
						break;
						case 'nis':
							switch($valObj->getMeta('Typ')) {
								case 'date':
									if ($cfg['val']==-1) $cfg['val']=date('Y-m-d');
									if ($cfg['val']!=$valData[$fkey]) $return=true;
								break;
								default:
									if ($cfg['val']!=$valData[$fkey]) $return=true;
								break;
							}
						break;
						case 'lk':
							switch($valObj->getMeta('Typ')) {
								case 'fk_comp':
								case 'mselect':
									$tmp=explode(',',$valData[$fkey]);
									if (in_array($cfg['val'],$tmp)) $return=true;
								break;
								default:
									if (strpos($valData[$fkey],$cfg['val'])!==false) $return=true;
								break;
							}
						break;
						case 'nlk':
							switch($valObj->getMeta('Typ')) {
								case 'fk_comp':
								case 'mselect':
									$tmp=explode(',',$valData[$fkey]);
									if (!in_array($cfg['val'],$tmp)) $return=true;
								break;
								default:
									if (strpos($valData[$fkey],$cfg['val'])===false) $return=true;
								break;
							}
						break;
						case 'gt':
							switch($valObj->getMeta('Typ')) {
								case 'date':
									if ($cfg['val']==-1) $cfg['val']=date('Y-m-d');
									if (Framework::parseSqlDate($valData[$fkey])>=Framework::parseSqlDate($cfg['val'])) $return=true;
								break;
								default:
									if ($valData[$fkey]>=$cfg['val']) $return=true;
								break;
							}
						break;
						case 'lt':
							switch($valObj->getMeta('Typ')) {
								case 'date':
									if ($cfg['val']==-1) $cfg['val']=date('Y-m-d');
									if (Framework::parseSqlDate($valData[$fkey])<=Framework::parseSqlDate($cfg['val'])) $return=true;
								break;
								default:
									if (floatval($valData[$fkey])<=floatval($cfg['val'])) $return=true;
								break;
							}
						break;
					}
					if ($return) {
						switch ($fObj->getMeta('Typ')) {
							case 'status':
								return new UserStatusObj($cfg['key']);
							break;
							case 'status_txt':
								return $this->_BaseSelect->getCachedValue($cfg['key']);
							break;
						}
					}
				}
			}
		}
	}
	function groupSort($A,$B) {
		switch($this->_sortFobj->getMeta('Typ')) {
			case 'int':
				$result=$A['F_'.$this->_sortFobj->getID()]>$B['F_'.$this->_sortFobj->getID()]?1:-1;
			break;
			case 'fk_addr':
				$result=strnatcasecmp($this->Entry2Value($this->_sortFobj,$A,'F_'.$this->_sortFobj->getID()) ,$this->Entry2Value($this->_sortFobj,$B,'F_'.$this->_sortFobj->getID()));
			break;

			default:
				$result=strnatcasecmp($A['F_'.$this->_sortFobj->getID()],$B['F_'.$this->_sortFobj->getID()]);
			break;
		}
		return $this->_sortDir*$result;
	}
	function setSort(&$Obj,$dir) {
		$this->_sortFobj=&$Obj;
		$this->_sortDir=$dir;
	}
	function calcShow($Value,$Mode,$DefValue) {
		$result=true;
		switch ($Mode) {
			case 'is':
				if ($Value!=$DefValue) $result=false;
			break;
			case 'isn':
				if ($Value==$DefValue) $result=false;
			break;
			case 'lk':
				if (is_array($DefValue)) {
					if (!in_array($Value,$DefValue))  $result=false;
				} else {
					if ($Value!=$DefValue) $result=false;
				}
			break;
			case 'nlk':
				if (is_array($DefValue)) {
					if (in_array($Value,$DefValue))  $result=false;
				} else {
					if ($Value==$DefValue) $result=false;
				}
			break;
		}

		return $result;
	}
	function getData($ID,$FKModul='') {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKObjID','Typ'=>'=','Values'=>$ID);
		$searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$FKModul?$FKModul:$this->_formObj->getMeta('FKModul'));
		$query='SELECT * FROM `'.$this->_formObj->getMeta('Table').'` WHERE '.$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		//debug($query);
		if ($this->_db->next_record()) {
			foreach ($this->getMetaFields() as $key=>$val) {
				$result[$val]=$this->_db->f($val);
			}
		}
		return $result;
	}
	function updateData($ID,$Data) {
		if (!$Data['FKModul']) $Data['FKModul']=$this->_formObj->getMeta('FKModul');
		$OldValues=$this->getData($ID,$Data['FKModul']);
		$Data['TimeModify']=time();
		$Data['UserModify']=$this->_frm->getUser();
		if (empty($OldValues)) {
			$Data['FKObjID']=$ID;
			$this->_db->insert($this->_formObj->getMeta('Table'),$Data,'',1);
		} else {
			$this->_db->update($this->_formObj->getMeta('Table'),$Data,array(array('Field'=>'FKObjID','Typ'=>'=','Values'=>$ID)));
		}
	}
	function deleteData($ID) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKObjID','Typ'=>'=','Values'=>$ID);
		$this->_db->delete($this->_formObj->getMeta('Table'),$searchQuery);
	}
	function calcGroupSum(&$Entries,&$fGroup) {
		$result=array();
		foreach($Entries as $key=>$val) {
			foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
				switch ($fObj->getMeta('Typ')) {
					case 'int':
						$result['F_'.$fObj->getID()]+=$val['F_'.$fObj->getID()];
					break;
					default:

					break;
				}
			}

		}
		return $result;
	}
	function _getStatusSql(&$cfg,&$valObj) {
		$sql='';
		if (is_object($valObj)) {
			$Field='F_'.$cfg['fid'];
			switch ($cfg['mode']) {
				case 'em':
					switch($valObj->getMeta('Typ')) {
						case 'date':
							$sql=$Field."='0000-00-00' OR ".$Field.' IS NULL';
						break;
						default:
							$sql=$Field."='' OR ".$Field.' IS NULL';
						break;
					}
				break;
				case 'nem':
					switch($valObj->getMeta('Typ')) {
						case 'date':
							$sql=$Field."!='0000-00-00' AND ".$Field.' IS NOT NULL';
						break;
						default:
							$sql=$Field."!='' AND ".$Field.' IS NOT NULL';
						break;
					}
				break;
				case 'is':
					switch($valObj->getMeta('Typ')) {
						case 'date':
							if ($cfg['val']==-1) $cfg['val']=date('Y-m-d');
							$sql=$Field."=".$this->_db->escape($cfg['val']);
						break;
						default:
							$sql=$Field."=".$this->_db->escape($cfg['val']);
						break;
					}
				break;
				case 'nis':
					switch($valObj->getMeta('Typ')) {
						case 'date':
							if ($cfg['val']==-1) $cfg['val']=date('Y-m-d');
							$sql=$Field."!=".$this->_db->escape($cfg['val']);
						break;
						default:
							$sql=$Field."!=".$this->_db->escape($cfg['val']);
						break;
					}
				break;
				case 'lk':
					switch($valObj->getMeta('Typ')) {
						case 'fk_comp':
						case 'mselect':
							$sql=$Field." REGEXP '[[:<:]]".addslashes(preg_quote($cfg['val'],''))."[[:>:]]'";
						break;
						default:
							$sql=$Field." LIKE ".$this->_db->escape('%'.$cfg['val'].'%');
						break;
					}
				break;
				case 'nlk':
					switch($valObj->getMeta('Typ')) {
						case 'fk_comp':
						case 'mselect':
							$sql=$Field." NOT REGEXP '[[:<:]]".addslashes(preg_quote($cfg['val'],''))."[[:>:]]'";
						break;
						default:
							$sql=$Field." NOT LIKE ".$this->_db->escape('%'.$cfg['val'].'%');
						break;
					}
				break;
				case 'gt':
					switch($valObj->getMeta('Typ')) {
						case 'date':
							if ($cfg['val']==-1) $cfg['val']=date('Y-m-d');
							$sql=$Field.">=".$this->_db->escape($cfg['val']);
						break;
						default:
							$sql=$Field.">=".$this->_db->escape($cfg['val']);
						break;
					}
				break;
				case 'lt':
					switch($valObj->getMeta('Typ')) {
						case 'date':
							if ($cfg['val']==-1) $cfg['val']=date('Y-m-d');
							$sql=$Field."<=".$this->_db->escape($cfg['val']);
						break;
						default:
							$sql=$Field."<=".$this->_db->escape($cfg['val']);
						break;
					}
				break;
			}
		}
		return $sql;
	}
	function getStatusSql($fID) {
		$fObj=$this->getFieldObj($fID);
		//debug($fID);
		$result='';
		$depth=0;
		if (is_object($fObj)) {
			$Values=unserialize($fObj->getMeta('Value'));
			$Config=unserialize($fObj->getMeta('Config'));
			if ($Config['isEditable']) {
				$result.="IF(F_".$fID."!='',F_".$fID.",";
				$depth++;
			}
			if (is_array($Values['Status'])) {
				foreach ($Values['Status'] as $cfg) {
					$valObj=$this->getFieldObj($cfg['fid']);
					$sql=$this->_getStatusSql($cfg,$valObj);
					if ($sql) {
						$result.='IF('.$sql.','.$this->_db->escape($cfg['key']).',';
						$depth++;
					}
				}
			}
		}
		if ($depth) {
			$result.="''";
			for($i=0;$i<$depth;$i++) {
				$result.=')';
			}
		}
		return $result;
	}
}
?>