<?php
class UserFormGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_guiCfg=array(
		'defAction'=>'n',
		'defMode'=>'form',
		'showTree'=>true,
		'defOid'=>0,
	);
	function UserFormGui() {
		global $frm,$t,$T,$E,$L;
		$this->_BaseForm=& $frm->getStaticModul('uform');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('uform');
	}
	function isCallable() {
		return true;
	}
	function handleRequest() {
		$this->_mode=Framework::getParam('uform_mode',$this->_guiCfg['defMode'],'G');
		$this->_action=Framework::getParam('uform_action',$this->_guiCfg['defAction'],'G');
		$this->_oid=Framework::getParam('uform_oid',$this->_guiCfg['defOid'],'G');
		if ($this->_oid) {
			$this->_Obj=$this->_BaseForm->getObj($this->_oid,1);
			if (!is_object($this->_Obj)) {
				$this->_action=$this->_guiCfg['defAction'];
				$this->_oid=$this->_guiCfg['defOid'];
				if ($this->_oid) {
					$this->_Obj=$this->_BaseForm->getObj($this->_oid);
				}
				$this->_L->setParam('uform_oid',$this->_oid);
			}
		}
		if (Framework::getParam('uform_obj_action_x','0','P') && Framework::getParam('uform_obj_action_val','0','P')) {
			switch (Framework::getParam('uform_obj_action_val','0','P')) {
				case 'delete':
					if (is_object($this->_Obj)) {
						$this->_BaseForm->deleteObj($this->_Obj);
					}
					$this->_L->setParam('uform_action',$this->_guiCfg['defAction']);
					$this->_L->setParam('uform_oid',0);
					$this->_L->goToLink();
				break;
				case 'new':
					$this->_L->setParam('uform_action','n');
					$this->_L->setParam('uform_oid',0);
					$this->_L->goToLink();
				break;
				case 'edit':
					$this->_L->setParam('uform_action','n');
					$this->_L->setParam('uform_oid',$this->_oid);
					$this->_L->goToLink();
				break;
				default:
					//debug(Framework::getParam('obj_action_val','0','P'));
			}
		}
	}
	function &process($init=true) {
		require_once('lib/class_ApplicationTreeGui.php');
		if ($init) $this->handleRequest();
		if ($this->_guiCfg['showTree']) {
			$this->_Gui=new ApplicationTreeGui();
			$this->_Gui->addTreeContent($this->getFormularTree());
		}
		switch ($this->_action) {
			case 'n':
				$this->_Gui->addContent($this->getFormEditGui());
			break;
			case 'v':
				if (is_object($this->_Obj)) {
					$this->_UserFormFieldsGui=& $this->_frm->getStaticGuiModul('uform','UserFormFieldsGui');
					if ($this->_guiCfg['FieldGuiCfg']) {
						$this->_UserFormFieldsGui->setGuiCfg($this->_guiCfg['FieldGuiCfg']);
					} else {
						$this->_UserFormFieldsGui->setGuiCfg(array('showUseSearch'=>0,'showUseList'=>0));
					}
					$this->_UserFormFieldsGui->setFormObj($this->_Obj);
					$Gui=$this->_UserFormFieldsGui->process();
					$this->_Gui->addContent($Gui);
				}
			break;

		}
		return $this->_Gui;
	}
	function setGuiCfg($val) {
		$this->_guiCfg=$val;
	}
	function setFormModul($val) {
		$this->_formModul=$val;
		$this->_BaseForm->setFormModul($val);
	}
	function &getFormularTree() {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		$tabGui->addHeaderCol('Name',$this->_T->lang('[[Formulare]]'),'','','','','',2);
		$entries=$this->_BaseForm->listModulForms();
		foreach ($entries as $val) {
			if ($this->_action!='c' && $val->getID()==$this->_oid) {
				$hl=2;
			} else {
				$hl=0;
			}
			$tabGui->addRow($hl);
			$tabGui->addCol('IMG','','obj_img/ex_tree.gif');
			$tabGui->addCol('Name',$val->getName(),'',$this->_L->getTempLink(null,array('uform_oid'=>$val->getID(),'uform_action'=>'v')),'',0,'2000');
		}
		return $tabGui;
	}
	function &getFormEditGui() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_Obj) {
			$Gui->setName($this->_T->lang('[[Neues Formular anlegen]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('uform_oid'),array('uform_action'=>$this->_guiCfg['defAction']))));
		} else {
			$Gui->setName($this->_T->lang('[[Formular bearbeiten]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(null,array('uform_action'=>'v'))));
		}
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_mode.'|showFormTab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('showFormTab'));
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getMetaGui());
		}
		if (in_array('perms',$tabs)) {
			$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
			$box->setTabContent('perms',$this->getPermsGui());
		}
		$show_tap=$this->getPrefs('showFormTab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function getMetaGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		$key='RefID';
		$default=$this->_Obj?$this->_Obj->getMeta($key):'';
		$formGui->addField($key,'text','ID',$default?$default:$this->_BaseForm->getNextRefID(),'fields1');
		$formGui->setRequired($key);


		$defOneLang=1;
		$defTrans=array();
		if ($this->_Obj) {
			$defTrans=$this->_Obj->getTrans('Name');
			foreach ($this->_frm->getMaLang() as $lang) {
				if ($defTrans[$lang]!=$defTrans[$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
			}

		}
		foreach ($this->_frm->getMaLang() as $lang) {
			$key='Trans['.$lang.']';
			$formGui->addField($key,'text',$this->_T->lang('[[Name]]').' '.strtoupper($lang),$defTrans[$lang],'fields1');
			$formGui->setNoMeta($key);
			if ($lang!=$this->_frm->getLang()) {
				if (Framework::getParam('oneLang',$defOneLang,'P')) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key,$attribs);
				} else {
					$formGui->setRequired($key);
				}
			} else {
				$formGui->setRequired($key);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'fields1');
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $lang2) {
					if ($lang2!=$lang) $attribs['onchange'].="disableEnable('Trans[".$lang2."]',this,this.checked?0:1);";
				}
				//debug($attribs);
				$formGui->setAttribs($key,$attribs);
			}
		}
		$key='submit';
		$formGui->addField($key,'submit','','','fields3');
		$submit_array=array(
			'uform_meta_save_x'=>' '.$this->_T->lang('[[Speichern]]').' ',
		);
		/*if (is_object($this->_Obj)) {
			$submit_array['uform_meta_delete_x']=' '.$this->_T->lang('[[Loeschen]]').' ';
			$formGui->setValuesAttribs($key,'uform_meta_delete_x',array('onclick'=>'return lo_form();'));
		}*/
		$formGui->setValues($key,$submit_array);

		/*if (Framework::getParam('uform_meta_delete_x','0','P')) {
			if (is_object($this->_Obj) && !$this->_Obj->getMeta('System')) {
				$this->_BaseForm->deleteObj($this->_Obj);
				$this->_L->unsetParam('uform_oid');
				$this->_L->setParam('uform_action','b');
				$this->_L->goToLink();
			}
		}*/

		if (Framework::getParam('uform_meta_save_x','0','P')) {
			$formGui->checkFields();
			if (preg_match('/[^a-z0-9_]/i',$formGui->getFieldVal('RefID')) || $this->_BaseForm->refExists($formGui->getFieldVal('RefID'),$this->_Obj?$this->_Obj->getID():0)) {
				$this->_E->setError('fields','RefID');
			}
			if (!$this->_E->isError()) {
				$ObjTrans=array();
				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans[$val]=$formGui->getFieldVal('Trans['.$this->_frm->getLang().']');
					}
				} else {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans[$val]=$formGui->getFieldVal('Trans['.$val.']');
					}
				}
				if (is_object($this->_Obj)) {
					$formGui->addMetaToObj($this->_Obj);
					$this->_Obj->setTrans('Name',$ObjTrans);
					$this->_BaseForm->updateObj($this->_Obj);
					$this->_L->setParam('uform_oid',$this->_Obj->getID());
					$this->_L->setParam('uform_action','v');
				} else {
					$this->_Obj=new ObjUserForm();
					$formGui->addMetaToObj($this->_Obj);
					$this->_Obj->setTrans('Name',$ObjTrans);
					$this->_BaseForm->insertObj($this->_Obj);
					$this->_L->setParam('uform_oid',$this->_Obj->getID());
					$this->_L->setParam('uform_action','v');
				}
				$this->_L->goToLink();
			}

		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		return $tplContent;
	}
	function &getObjActionGui() {
		require_once('lib/class_FunctionObjActionGui.php');
		$objActionGui=new FunctionObjActionGui('uform_obj_action');
		$obj_action=$this->_frm->getObjAction('uform','form');
		foreach ($obj_action as $key=>$val) {
			if ($val['Hidden']) continue;
			if (in_array('ID',$val['Extra']) && !is_object($this->_Obj)) continue;
			if (in_array('!System',$val['Extra'])  && (!is_object($this->_Obj) || $this->_Obj->getMeta('System'))) continue;
			if (in_array('empty',$val['Extra'])  && (!is_object($this->_Obj) || !$this->_BaseForm->isEmpty($this->_Obj))) continue;
			$objActionGui->addValue($key,$val['Name']);
		}
		return $objActionGui;
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_mode,array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_mode,$key);
		if (!$result) $result=$default;
		return $result;
	}
}
?>