<?php
class ObjUserFormSelect extends baseObj {
	var $_obj_typ='0';
	/* to owerwrite*/
	function ObjUserFormSelect($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['Name'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class UserFormSelect extends ObjCore {
	var $_modul='uform';
	var $_table='UserFormSelect';
	var $_cfgObjects=array (
		'IdField'=>'ID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'TranslationFields'=>array('Name'),
		'0'=>array(
			'ClassName'=>'ObjUserFormSelect',
			'Fields'=>array(
				'ID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'FKFieldID'=>array(
					'Typ'=>'core',
				),
				'Name'=>array(
					'Typ'=>'core',
				),
				'Sequence'=>array(
					'Typ'=>'core',
				),

			),
		),
	);
	function UserFormSelect() {
		global $frm,$T;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->_T=&$T;
		$this->setRule($frm->isRuleUser(array('sysadmin')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}

	function insertObj(&$Obj) {
		$Obj->setMeta('Sequence',$this->getNextSequence($Obj));
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		return $this->deleteMeta($Obj);
	}
	function listSelect($FKFieldID) {
		$searchQuery=array(
			array('Field'=>'FKFieldID','Typ'=>'=','Values'=>$FKFieldID),
		);
		$rows=0;
		return $this->searchObj($rows,$searchQuery,"Sequence ASC",0,0,false,false,false);
	}
	function getCachedValue($ID) {
		if (!isset($this->_cachedSelect[$ID])) {
			$Obj=$this->getObj($ID);
			if (is_object($Obj)) {
				$this->_cachedSelect[$ID]=$Obj->getName();
			} else {
				$this->_cachedSelect[$ID]='';
			}
		}
		return $this->_cachedSelect[$ID];
	}
	function getNextSequence(&$Obj) {
		$searchQuery=array(
			array('Field'=>'FKFieldID','Typ'=>'=','Values'=>intval($Obj->getMeta('FKFieldID'))),
		);
		$query="SELECT max(Sequence) as num FROM ".$this->_table." WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" GROUP BY FKFieldID";
		$this->_db->query($query);
		$this->_db->next_record();
		return intval($this->_db->f('num') + 1);
	}
	function moveSequence (&$Obj,$dir='down') {
		$searchQuery=array(
			array('Field'=>'FKFieldID','Typ'=>'=','Values'=>intval($Obj->getMeta('FKFieldID'))),
		);
		return $this->_db->moveEntry ($this->_table,$this->getIDField(),'Sequence',$Obj->getID(),$dir,$searchQuery);
	}
}
?>