<?php
class UserFormViewGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_isLoaded=false;
	var $_multiple=array();
	var $_quickMode=false;
	var $_style='width:640px;';
	function UserFormViewGui($tpl='uform/uform_view.inc.html') {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FastTemplateGui.php');
		require_once('lib/class_ApplicationListGui.php');
		require_once("lib/uform/class_UserFormData.php");
		global $frm,$t,$T,$E,$L;
		$this->_uFormData=new UserFormData();
		$this->_BaseForm=& $frm->getStaticModul('uform');
		$this->_BaseFields=& $frm->getStaticModul('uform_fields');
		$this->_BaseSelect=& $frm->getStaticModul('uform_select');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('uform');
		$this->_Gui=new FastTemplateGui($tpl);
	}
	function isCallable() {
		return true;
	}
	function setStyle($val) {
		$this->_style=$val;
	}
	function setFormObj(&$Obj,$useFieldPerms=false,$myRules=null) {
		$this->_formObj=&$Obj;
		$this->_BaseFields->setFormObj($this->_formObj);
		$this->_uFormData->setFormObj($this->_formObj,$useFieldPerms,$myRules);
		$this->_formFields=$this->_uFormData->getFormFields();
	}
	function setQuickMode($val) {
		$this->_quickMode=$val;
	}
	function setDefault($val) {
		$this->_default=$val;
	}
	function loadDefault($ID,$FKModul='') {
		$this->_default=$this->_uFormData->getData($ID,$FKModul);
	}
	function setStaticVisibility($val) {
		$this->_staticVisibility=$val;
	}
	function setValueCallBack($typ,$callBack) {
		$this->_uFormData->setValueCallBack($typ,$callBack);
	}
	function _parseForm() {
		if (is_array($this->_formFields[0])) {
			foreach ($this->_formFields[0] as $fGroup) {
				if ($this->_quickMode && !$fGroup->getMeta('useQuick')) continue;
				if (!$fGroup->getAcl(1)) continue;
				$show=true;
				$fVisibility=unserialize($fGroup->getMeta('Visibility'));
				if ($fVisibility['Field']) {
					$show=$this->_uFormData->calcShow(isset($this->_staticVisibility[$fVisibility['Field']])?$this->_staticVisibility[$fVisibility['Field']]:$this->_default['F_'.$fVisibility['Field']],$fVisibility['Mode'],$fVisibility['Value']);
				}
				if ($show && is_array($this->_formFields[$fGroup->getID()])) {
					$this->_parseGroup($fGroup);
				}
			}
		}
	}
	function &_parseGroup($fGroup,$return=false) {
		if ($fGroup->getMeta('Multiple')) {
			$Entries=unserialize($this->_default['F_'.$fGroup->getID()]);
			if (!is_array($Entries)) $Entries=array();
			//debug($Entries);
			$this->_Gui->assign('GC_ID','uform_V_'.$fGroup->getID());
			$this->_Gui->assign('GROUP_CONTENT',$this->getGroupTable($fGroup,$Entries));
			$this->_Gui->parse('ROW','multiple_content');
		} else {
			foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
				$show=true;
				$i=0;
				$fVisibility=unserialize($fObj->getMeta('Visibility'));
				if ($fVisibility['Field']) {
					$show=$this->_uFormData->calcShow(isset($this->_staticVisibility[$fVisibility['Field']])?$this->_staticVisibility[$fVisibility['Field']]:$this->_default['F_'.$fVisibility['Field']],$fVisibility['Mode'],$fVisibility['Value']);
				}
				if ($show) {
					$this->_Gui->assign('TITLE',$fObj->getName());
					$this->_Gui->assign('VALUE',$this->_uFormData->Entry2Value($fObj,$this->_default,'F_'.$fObj->getID(),"; "),null,true);
					$this->_Gui->parse('ROW','.data_row');
					$i++;
				}
			}
			$this->_Gui->parse('ROW','simple_content');
			$this->_Gui->clear_dynamic('data_row');
		}
			
		$this->_Gui->assign('STYLE',$this->_style);
		$this->_Gui->assign('NAME',$fGroup->getName());
		$this->_Gui->assign('LID','lnk_'.$fGroup->getID());

		$this->_Gui->parse('ROW','.group');
		$this->_Gui->clear_dynamic('multiple_content');
		$this->_Gui->clear_dynamic('simple_content');
	}
	function &getGroupTable(&$fGroup,&$Entries) {
		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tabGui->setstyle('width:100%');
		$gConfig=unserialize($fGroup->getMeta('Config'));
		if ($gConfig['sortBy'] && is_object($this->_formFields[$fGroup->getID()][$gConfig['sortBy']])) {
			$this->_uFormData->setSort($this->_formFields[$fGroup->getID()][$gConfig['sortBy']],$gConfig['sortDir']);
			uasort($Entries, array($this->_uFormData,'groupSort'));
		}
		//$gConfig['viewDir']=1;
		if ($gConfig['viewDir']) {
			foreach($Entries as $key=>$val) {
				$hl=$hl?0:1;
				foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
					$tabGui->addRow($hl,'top');
					$tabGui->addCol('uform_T_'.$fObj->getID(),$fObj->getName().':','','','right',1);
					$tabGui->addCol('uform_V_'.$fObj->getID(),$this->_uFormData->Entry2Value($fObj,$val,'F_'.$fObj->getID(),"\n",$n=null,'_'.$key),'','','',0,'1000');
				}
				
			}
			if ($gConfig['showSum']) {
				$groupSum=$this->_uFormData->calcGroupSum($Entries,$fGroup);
				foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
					if (!isset($groupSum['F_'.$fObj->getID()])) continue;
					$tabGui->addRow(2);
					$tabGui->addCol('uform_T_'.$fObj->getID(),$fObj->getName(),'','','',0);
					$tabGui->addCol('uform_V_'.$fObj->getID(),isset($groupSum['F_'.$fObj->getID()])?$this->_uFormData->Entry2Value($fObj,$groupSum,'F_'.$fObj->getID()):'','','','',0);
				}
			}
		} else {
			foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
				$tabGui->addHeaderCol('uform_V_'.$fObj->getID(),$fObj->getName(),'','','',0);
			}
			foreach($Entries as $key=>$val) {
				$tabGui->addRow($hl?$hl=0:$hl=1,'top');
				foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
					$tabGui->addCol('uform_V_'.$fObj->getID(),$this->_uFormData->Entry2Value($fObj,$val,'F_'.$fObj->getID(),"\n",$n=null,'_'.$key),'','','',0);
				}
			}
			if ($gConfig['showSum']) {
				$tabGui->addRow(2);
				$groupSum=$this->_uFormData->calcGroupSum($Entries,$fGroup);
				foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
					$tabGui->addCol('uform_V_'.$fObj->getID(),isset($groupSum['F_'.$fObj->getID()])?$this->_uFormData->Entry2Value($fObj,$groupSum,'F_'.$fObj->getID()):'','','','',0);
				}
			}
		}
		return $tabGui;
	}
	function &process() {
		$this->_handleRequest();
		$this->_parseForm();
		return $this->_Gui->process();
	}
	function _handleRequest() {



	}
	function isEmpty() {
		if (is_array($this->_formFields[0])) {
			foreach ($this->_formFields[0] as $fGroup) {
				if ($this->_quickMode && !$fGroup->getMeta('useQuick')) continue;
				if (!$fGroup->getAcl(1)) continue;
				$show=true;
				$fVisibility=unserialize($fGroup->getMeta('Visibility'));
				if ($fVisibility['Field']) {
					$show=$this->_uFormData->calcShow(isset($this->_staticVisibility[$fVisibility['Field']])?$this->_staticVisibility[$fVisibility['Field']]:$this->_default['F_'.$fVisibility['Field']],$fVisibility['Mode'],$fVisibility['Value']);
				}
				if ($show && is_array($this->_formFields[$fGroup->getID()])) {
					return false;
				}
			}
		}
		return true;
	}
}
?>