<?php
class AdminGui_vac {
	private $_AppGui;
	private $_T;
	private $_t;
	private $_frm;
	private $_L;
	private $_E;
	function __construct($mode='') {
		global $frm,$t,$T,$E,$L;
		$this->_Base=$frm->getStaticModul('custom');
		$this->_BaseDep=$this->_Base->getStaticModul('vac_dep');
		$this->_BaseType=$this->_Base->getStaticModul('vac_type');
		$this->_CalCat=$frm->getStaticModul('cal_cat');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('vac');
		$this->_mode=$mode;
	}
	function isCallable() {
		return true;
	}
	function _handleRequest() {
		switch ($this->_mode) {
			case 'vac_dep':
				$this->_action=Framework::getParam('action','b','G');
				$this->_oid=Framework::getParam('oid',0,'G');
				if ($this->_oid && ($this->_Obj=$this->_BaseDep->getObj($this->_oid,true))) {
				} else {
					$this->_oid=0;
				}
				if (Framework::getParam('_clTab',0,'G')) {
					$this->setPrefs('tabVacDep',Framework::getParam('_clTab',0,'G'));
				}				
				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('oid');
							$this->_L->goToLink();
						break;
						case 'delete':
							if ($this->_oid && $this->_Obj) {
								if ($this->_BaseDep->deleteObj($this->_Obj)) {
									$this->_L->unsetParam(array('oid','action'));
									$this->_L->goToLink();
								}
							}
						break;
						default:
							//debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
				$this->_ObjActionGui=$this->getObjActionGui('vac_dep');
			break;
			case 'vac_type':
				$this->_action=Framework::getParam('action','b','G');
				$this->_oid=Framework::getParam('oid',0,'G');
				if ($this->_oid && ($this->_Obj=$this->_BaseType->getObj($this->_oid,true))) {
				} else {
					$this->_oid=0;
				}
				if (Framework::getParam('_clTab',0,'G')) {
					$this->setPrefs('tabVacType',Framework::getParam('_clTab',0,'G'));
				}
				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('oid');
							$this->_L->goToLink();
						break;
						case 'delete':
							if ($this->_oid && $this->_Obj) {
								if ($this->_BaseType->deleteObj($this->_Obj)) {
									$this->_L->unsetParam(array('oid','action'));
									$this->_L->goToLink();
								}
							}
						break;
						default:
							//debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
				$this->_ObjActionGui=$this->getObjActionGui('vac_type');
			break;
			case 'vac_print':
				if (Framework::getParam('_getPrintTpl','','G')) {
					require_once('lib/vac/class_VacPrintGui.php');
					$printGui=new VacPrintGui();
					$tpl=$printGui->getPrintTemplate(Framework::getParam('_getPrintTpl','','G'));
					//debug($tpl);
					Framework::dumpFile($tpl,$this->_T->lang('[[Vorlage]]').'.html','application/save');
					exit;
				}
				$this->_obj_action='';
				$this->_PrintTemplatesGui=& $this->_frm->getStaticGuiModul('core','PrintTemplatesGui');
				$guiCfg=array(
					'defAction'=>'b',
					'defMode'=>'print_tpl',
					'showTree'=>false,
					'defOid'=>0,
					'avTyps'=>array(
						'obj'=>$this->_T->lang('[[Detailansicht]]'),
					),
					'systemTpls'=>array(
						'obj'=>array(array('Name'=>$this->_T->lang('[[Standard]]'),'Link'=>$this->_L->getTempLink(null,array('_getPrintTpl'=>'obj')))),
					),
					'usePerms'=>array(),
					'usePermsRules'=>array(),
				);
				$this->_PrintTemplatesGui->setGuiCfg($guiCfg);
				$this->_PrintTemplatesGui->setModul('vac');
				$this->_PrintTemplatesGui->handleRequest();
				$this->_ObjActionGui=$this->_PrintTemplatesGui->getObjActionGui();
			break;
		}
	}
	function &addAdminHeader($hGui) {
		$hGui->addTab('vac_dep',$this->_T->lang('[[Personalstellen]]'),"index.php?site=admin.php&ac=custom&mode=vac_dep");
		$hGui->addTab('vac_type',$this->_T->lang('[[Urlaubstypen]]'),"index.php?site=admin.php&ac=custom&mode=vac_type");
		//$hGui->addTab('vac_print',$this->_T->lang('[[Druckvorlagen]]'),"index.php?site=admin.php&ac=vac&mode=vac_print");
		if ($this->_ObjActionGui) {
			$hGui->addFunction($this->_ObjActionGui);
		}
	}
	function process(&$AppGui) {
		switch ($this->_mode) {
			case 'vac_dep':
				require_once('lib/class_ApplicationTreeGui.php');
				switch ($this->_action) {
					case 'n':
						$AppGui->addContent($this->newVacDep());
						if ($this->_Obj) {
							$AppGui->addContent($this->listVacDepUserGui());
						}
					break;
					default:
						$AppGui->addContent($this->listVacDep());
					break;
				}
			break;
			case 'vac_type':
				require_once('lib/class_ApplicationTreeGui.php');
				switch ($this->_action) {
					case 'n':
						$AppGui->addContent($this->newVacType());
					break;
					default:
						$AppGui->addContent($this->listVacType());
					break;
				}
			break;
			case 'vac_print':
				$Gui=$this->_PrintTemplatesGui->process(false);
				$AppGui->addContent($Gui);
			break;
		}
	}

	function listVacDep() {
		require_once('lib/class_ApplicationListGui.php');
		$Gui=new ApplicationListGui();
		$Gui->setName($this->_T->lang('[[Personalstellen]]'));
		$entries=$this->_BaseDep->listObj();
		//debug($entries);
		$Gui->addHeaderCol('Name',$this->_T->lang('[[Bezeichnung]]'),'','','',0,2000);
		$Gui->addHeaderCol('DepUsers2',$this->_T->lang('[[Geschaeftsfuehrung]]'),'','','',1);
		$Gui->addHeaderCol('DepUsers1',$this->_T->lang('[[Personalleitung]]'),'','','',1);


		$Gui->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','',1);
		$Gui->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);
		foreach ($entries as $key=>$val) {
			$Gui->addRow(($hl?$hl=0:$hl=1),'top');
			$Gui->addCol('Title',$val->getName(),'',$this->_L->getTempLink(null,array('oid'=>$key,'action'=>'n')),'',0,2000);
			$tmp=array();
			foreach($this->_BaseDep->listDepUsers($val,array('vacDepRule'=>2)) as $v) {
				if ($v['FKUserType']=='u') $tmp[]=$this->_frm->getCachedUserNameAll($v['FKUserID']);
			};
			$Gui->addCol('DepUsers2',implode("\n",$tmp),'','','',1);

			$tmp=array();
			foreach($this->_BaseDep->listDepUsers($val,array('vacDepRule'=>1)) as $v) {
				if ($v['FKUserType']=='u') $tmp[]=$this->_frm->getCachedUserNameAll($v['FKUserID']);
			};
			$Gui->addCol('DepUsers1',implode("\n",$tmp),'','','',1);

			$Gui->addCol('TimeModify',$val->getMeta('TimeModify')?date('d.m.Y',$val->getMeta('TimeModify')):'','','','','1');
			$Gui->addCol('UserModify',$val->getMeta('UserModify')?$this->_frm->getCachedUserNameAll($val->getMeta('UserModify')):'','','','',1);
		}
		return $Gui;
	}
	function newVacDep() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_oid) {
			$Gui->setName($this->_T->lang('[[Neuer Eintrag]]'));
		} else {
			$Gui->setName($this->_T->lang('[[Eintrag bearbeiten]]'));
			$tabs[]='user';
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'|tabVacDep');
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getVacDepMetaGui());
		}
		if (in_array('user',$tabs)) {
			$box->addTab('user',$this->_T->lang('[[BenutzerInnen]]'),'#',true);
			$box->setTabContent('user',$this->getVacDepUserGui(true));
		}
		$show_tap=$this->getPrefs('tabVacDep');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getVacDepMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		$defTrans=array();
		if (Framework::getParam('isset_oneLang',0,'P')) {
			$defOneLang=Framework::getParam('oneLang',0,'P');
		} elseif ($this->_Obj) {
			$defOneLang=1;
			$defTrans['vacDepName']=$this->_Obj->getTrans('vacDepName');
			foreach ($this->_frm->getMaLang() as $lang) {
				if ($defTrans['vacDepName'][$lang]!=$defTrans['vacDepName'][$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
			}
		} else {
			$defOneLang=1;
		}

		foreach ($this->_frm->getMaLang() as $lang) {
			$key1='Trans[vacDepName]['.$lang.']';
			$formGui->addField($key1,'text',$this->_T->lang('[[Name]]').' '.strtoupper($lang),$defTrans['vacDepName'][$lang],'form_fields1');
			$formGui->setNoMeta($key1);
			if ($lang!=$this->_frm->getLang()) {
				if ($defOneLang) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key1,$attribs);
				} else {
					$formGui->setRequired($key1);
				}
			} else {
				$formGui->setRequired($key1);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'form_fields1');
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $lang2) {
					if ($lang2!=$lang) {
						$attribs['onchange'].="disableEnable('Trans[vacDepName][".$lang2."]',this,this.checked?0:1);";
					}
				}
				//debug($attribs);
				$formGui->setAttribs($key,$attribs);
			}
		}
		$default=array();
		if ($this->_Obj) {
			$entries=$this->_BaseDep->listDepUsers($this->_Obj,array('vacDepRule'=>1));
			foreach($entries as $v) {
				$default[]=$v['FKUserType'].'_'.$v['FKUserID'];
			}
		}
		$key='vacDepUserRule1';
		$mode='u';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Personalleitung]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'custom',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		/*$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'custom',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);*/

		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,implode('|',$default),'form_fields2');
		$formGui->setParams($key,array('mode'=>$mode,'app'=>'custom','params'=>$params));
		$formGui->setRequired($key);
		$formGui->setNoMeta($key);

		
		$default=array();
		if ($this->_Obj) {
			$entries=$this->_BaseDep->listDepUsers($this->_Obj,array('vacDepRule'=>2));
			foreach($entries as $v) {
				$default[]=$v['FKUserType'].'_'.$v['FKUserID'];
			}
		}
		$key='vacDepUserRule2';
		$mode='u';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Geschaeftsfuehrung]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'custom',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		/*$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'custom',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);*/

		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,implode('|',$default),'form_fields2');
		$formGui->setParams($key,array('mode'=>$mode,'app'=>'custom','params'=>$params));
		$formGui->setRequired($key);
		$formGui->setNoMeta($key);


		$key='submit';
		$submitVals=array(
			'meta_save_x'=>$this->_T->lang('[[Speichern]]')
		);
		$formGui->addField($key,'submit','','','form_submit');
		$formGui->setValues($key,$submitVals);

		if (Framework::getParam('meta_delete_x','0','P')) {
			$this->_BaseDep->deleteObj($this->_Obj);
			$this->_L->unsetParam('oid');
			$this->_L->setParam('action','b');
			$this->_L->goToLink();
		}
		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {

				$ObjTrans=array();
				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans['vacDepName'][$val]=$formGui->getFieldVal('Trans[vacDepName]['.$this->_frm->getLang().']');
					}
				} else {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans['vacDepName'][$val]=$formGui->getFieldVal('Trans[vacDepName]['.$val.']');
					}
				}
				if (!is_object($this->_Obj)) {
					$this->_Obj=new ObjVacDep();
				}
				$formGui->addMetaToObj($this->_Obj);

				$this->_Obj->setTrans('vacDepName',$ObjTrans['vacDepName']);

				if ($this->_oid) {
					$this->_BaseDep->updateObj($this->_Obj);
					$this->_L->unsetParam('oid');
					$this->_L->setParam('action','b');
				} else {
					$this->_oid=$this->_BaseDep->insertObj($this->_Obj);
					$this->_L->setParam('oid',$this->_oid);
					$this->_L->setParam('_clTab','user');
				}
				
				$insert=array();
				foreach (explode('|',$formGui->getFieldVal('vacDepUserRule1')) as $val) {
					$insert[]=array(
						'vacDepRule'=>1,
						'FKUserType'=>substr($val,0,1),
						'FKUserID'=>substr($val,2),
					);
				}
				$this->_BaseDep->deleteDepUsers($this->_Obj,array('vacDepRule'=>1));
				$this->_BaseDep->insertDepUsers($this->_Obj,$insert);
				
				$insert=array();
				foreach (explode('|',$formGui->getFieldVal('vacDepUserRule2')) as $val) {
					$insert[]=array(
						'vacDepRule'=>2,
						'FKUserType'=>substr($val,0,1),
						'FKUserID'=>substr($val,2),
					);
				}
				$this->_BaseDep->deleteDepUsers($this->_Obj,array('vacDepRule'=>2));
				$this->_BaseDep->insertDepUsers($this->_Obj,$insert);

				$this->_L->goToLink();
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}

	function &getVacDepUserGui($perm_mode=0) {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');


		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		$key='addVacDepUser';
		$mode='u|g';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'custom',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'custom',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);

		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,'','fields1');
		$formGui->setParams($key,array('mode'=>$mode,'app'=>'custom','params'=>$params));
		$formGui->setNoMeta($key);
		$formGui->addField('addVacDepUser_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields3');


		$update=false;
		if (Framework::getParam('addVacDepUser_add',0,'P')  && trim($formGui->getFieldVal('addVacDepUser'))) {
			$insert=array();
			$addUsers=explode('|',$formGui->getFieldVal('addVacDepUser'));
			foreach ($addUsers as $val) {
				$tmp=explode('_',$val);
				$insert[]=array(
					'vacDepRule'=>0,
					'FKUserType'=>$tmp[0],
					'FKUserID'=>$tmp[1],
				);
			}
			$this->_BaseDep->insertDepUsers($this->_Obj,$insert);
			$this->_L->goToLink();
		}
		//debug($perms_g);
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3_1',$formGui,'FORM3',array('','fields3'));
		return $tplContent;
	}
	function listVacDepUserGui() {
		if(is_array(Framework::getParam('delVacDepUser_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('delVacDepUser_x',0,'P'));
			if ($key) {
				$tmp=explode('_',$key);
				$search=array(
					'vacDepRule'=>0,
					'FKUserType'=>$tmp[0],
					'FKUserID'=>$tmp[1],
				);
				$this->_BaseDep->deleteDepUsers($this->_Obj,$search);
			}
		}
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		$tabGui->addHeaderCol('Name',$this->_T->lang('[[BenutzerInnen]]'),'','','',0,'',2);
		$tabGui->addHeaderCol('Delete','','tras.gif');
		$tabGui->setLimit(0);

		$search=array(
			'vacDepRule'=>0,
		);
		$entries=$this->_BaseDep->listDepUsers($this->_Obj,$search);
		
		$hl=0;
		foreach ($entries as $val) {
			//debug($val);
			$hl=$hl?0:1;
			$tabGui->addRow($hl);
			$name='';$img='';
			switch($val['FKUserType']) {
				case 'g':
					$img='gruppe.gif';
					$name=$this->_frm->getCachedGroupName($val['FKUserID']);
				break;
				case 'u':
					$img='user.gif';
					$name=$this->_frm->getCachedUserNameAll($val['FKUserID']);
				break;
			}
			$tabGui->addCol('IMG','',$img);
			$tabGui->addCol('Name',$name,'','','',0,'2000');

			$btn=new SubmitImgBtn ('delVacDepUser_x['.$val['FKUserType'].'_'.$val['FKUserID'].']','img/'.APP_THEME.'/loeschen.gif');
			$tabGui->addCol('Delete',$btn);
		}

		return $tabGui;
	}
	function getObjActionGui($action) {
		require_once('lib/class_FunctionObjActionGui.php');
		$objActionGui=new FunctionObjActionGui();
		$objActionGui->addValue('new',$this->_T->lang('[[Neuer Eintrag]]'));
		if ($this->_Obj) {
			$objActionGui->addValue('info_0','----------------------');
			$objActionGui->addValue('delete',$this->_T->lang('[[Eintrag loeschen]]'));
		}
		return $objActionGui;
	}

	function listVacType() {
		require_once('lib/class_ApplicationListGui.php');
		$Gui=new ApplicationListGui();
		$Gui->setName($this->_T->lang('[[Urlaubstypen]]'));
		switch ($this->_skey) {
			default:
				$entries=$this->_BaseType->listObj();
				//debug($entries);
				$Gui->addHeaderCol('Name',$this->_T->lang('[[Bezeichnung]]'),'','','',1);
				$Gui->addHeaderCol('FKCalCatID',$this->_T->lang('[[Art des Termins]]'),'','','',0,2000);
				$Gui->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','',1);
				$Gui->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);
				foreach ($entries as $key=>$val) {
					$Gui->addRow(($hl?$hl=0:$hl=1),'top');
					$Gui->addCol('Title',$val->getName(),'',$this->_L->getTempLink(null,array('oid'=>$key,'action'=>'n')),'',1);
					$tmp=$val->getMeta('FKCalCatID')?$this->_CalCat->getCachedObj($val->getMeta('FKCalCatID')):false;
					$Gui->addCol('FKCalCatID',$tmp?$tmp->getName():'','','','','0',2000);
					$Gui->addCol('TimeModify',$val->getMeta('TimeModify')?date('d.m.Y',$val->getMeta('TimeModify')):'','','','','1');
					$Gui->addCol('UserModify',$val->getMeta('UserModify')?$this->_frm->getCachedUserNameAll($val->getMeta('UserModify')):'','','','',1);
				}
			break;
		}
		return $Gui;
	}
	function newVacType() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_oid) {
			$Gui->setName($this->_T->lang('[[Neuer Eintrag]]'));
		} else {
			$Gui->setName($this->_T->lang('[[Eintrag bearbeiten]]'));
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'|tabVacType');
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getVacTypeMetaGui());
		}
		$show_tap=$this->getPrefs('tabVacType');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getVacTypeMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		$defTrans=array();
		if (Framework::getParam('isset_oneLang',0,'P')) {
			$defOneLang=Framework::getParam('oneLang',0,'P');
		} elseif ($this->_Obj) {
			$defOneLang=1;
			$defTrans['vacTypeName']=$this->_Obj->getTrans('vacTypeName');
			foreach ($this->_frm->getMaLang() as $lang) {
				if ($defTrans['vacTypeName'][$lang]!=$defTrans['vacTypeName'][$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
			}
		} else {
			$defOneLang=1;
		}

		foreach ($this->_frm->getMaLang() as $lang) {
			$key1='Trans[vacTypeName]['.$lang.']';
			$formGui->addField($key1,'text',$this->_T->lang('[[Name]]').' '.strtoupper($lang),$defTrans['vacTypeName'][$lang],'form_fields1');
			$formGui->setNoMeta($key1);
			if ($lang!=$this->_frm->getLang()) {
				if ($defOneLang) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key1,$attribs);
				} else {
					$formGui->setRequired($key1);
				}
			} else {
				$formGui->setRequired($key1);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'form_fields1');
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $lang2) {
					if ($lang2!=$lang) {
						$attribs['onchange'].="disableEnable('Trans[vacTypeName][".$lang2."]',this,this.checked?0:1);";
					}
				}
				//debug($attribs);
				$formGui->setAttribs($key,$attribs);
			}
		}
		$key='FKCalCatID';
		$cat=$this->_CalCat->listObj();
		$formGui->addField($key,'select',$this->_T->lang('[[Art des Termins]]'),$this->_Obj?$this->_Obj->getMeta($key):'','form_fields2');
		$formGui->setValues($key,array(0=>'-') + $this->_frm->extractObjName($cat));


;

		$key='FKCalGrant';
		$mode='u|g';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Sichtbar fuer]]').' '.$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);
		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);


		$formGui->addField($key,'ttip',$lb_Invit,$this->_Obj?$this->_Obj->getMeta($key):'','form_fields2');
		$formGui->setParams($key,array('mode'=>$mode,'app'=>'cal','params'=>$params));
		

		$key='submit';
		$submitVals=array(
			'meta_save_x'=>$this->_T->lang('[[Speichern]]')
		);
		$formGui->addField($key,'submit','','','form_submit');
		$formGui->setValues($key,$submitVals);

		if (Framework::getParam('meta_delete_x','0','P')) {
			$this->_BaseType->deleteObj($this->_Obj);
			$this->_L->unsetParam('oid');
			$this->_L->setParam('action','b');
			$this->_L->goToLink();
		}
		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {

				$ObjTrans=array();
				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans['vacTypeName'][$val]=$formGui->getFieldVal('Trans[vacTypeName]['.$this->_frm->getLang().']');
					}
				} else {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans['vacTypeName'][$val]=$formGui->getFieldVal('Trans[vacTypeName]['.$val.']');
					}
				}
				if (!is_object($this->_Obj)) {
					$this->_Obj=new ObjVacType();
				}
				$formGui->addMetaToObj($this->_Obj);

				$this->_Obj->setTrans('vacTypeName',$ObjTrans['vacTypeName']);

				if ($this->_oid) {
					$this->_BaseType->updateObj($this->_Obj);
					$this->_L->unsetParam('oid');
					$this->_L->setParam('action','b');
				} else {
					$this->_oid=$this->_BaseType->insertObj($this->_Obj);
					$this->_L->setParam('action','b');
				}
				$this->_L->goToLink();
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}	
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result) $result=$default;
		return $result;
	}

}
?>