<?php
class ObjVacAns extends baseObj {
	public $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return '';
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class Core_vac_ans extends ObjCore {
	public $_modul='vac';
	public $_table='VacAns';
	public $_cfgObjects=array (
		'IdField'=>'vacAnsID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'0'=>array(
			'ClassName'=>'ObjVacAns',
			'Fields'=>array(
				'vacAnsID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'FKUserID'=>array(
					'Typ'=>'core',
				),
				'FKVacAntID'=>array(
					'Typ'=>'core',
				),
				'vacAnsYear'=>array(
					'Typ'=>'core',
				),
				'vacAnsDays'=>array(
					'Typ'=>'core',
				),
				'vacAnsExpires'=>array(
					'Typ'=>'core',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
			),
		),
	);

	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','vac')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function insertObj(&$Obj) {
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		return $this->deleteMeta($Obj);
	}
	function existsObj($Obj) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'vacAnsYear','Typ'=>'=','Values'=>$Obj->getMeta('vacAnsYear'));
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$Obj->getMeta('FKUserID'));
		$searchQuery[]=array('Field'=>'FKVacAntID','Typ'=>'=','Values'=>$Obj->getMeta('FKVacAntID'));
		if ($Obj->getID()) {
			$searchQuery[]=array('Field'=>'vacAnsID','Typ'=>'!=','Values'=>$Obj->getID());
		}
		return $this->searchSingleObj($searchQuery);
	}
	function listObj($search=array(),$b=0,$limit=0) {
		$searchQuery=array();
		//$searchQuery[]=array('Field'=>'vacAnsDays','Typ'=>'!=','Values'=>0);
		if ($search['vacAnsYear']) {
			$searchQuery[]=array('Field'=>'vacAnsYear','Typ'=>'=','Values'=>$search['vacAnsYear']);
		}
		if ($search['FKUserID']) {
			$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$search['FKUserID']);
		}
		if ($search['FKVacAntID']) {
			$searchQuery[]=array('Field'=>'FKVacAntID','Typ'=>'=','Values'=>$search['FKVacAntID']);
		} else {
			$searchQuery[]=array('Field'=>'FKVacAntID','Typ'=>'=','Values'=>0);
		}
		if ($search['vacAnsExpires']) {
			$subQuery=array();
			$subQuery[]=array(array('Field'=>'vacAnsExpires','Typ'=>'=','Values'=>'0000-00-00'));
			$subQuery[]=array(array('Field'=>'vacAnsExpires','Typ'=>'>=','Values'=>$search['vacAnsExpires']));
			$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
		}
		$rows=0;
		return $this->searchObj($rows,$searchQuery,'vacAnsYear',$b,$limit);
	}
	function decreaseAns($AntID,$uid,$days) {
		$rest=0;
		$search=array(
			'FKUserID'=>$uid,
			'vacAnsExpires'=>date('Y-m-d'),
		);
		$entries=$this->listObj($search);
		foreach($entries as $obj) {
			if ($days) {
				$nObj=clone $obj;
				$nObj->setMeta('FKVacAntID',$AntID);
				if ($obj->getMeta('vacAnsDays')>=$days) {
					$nObj->setMeta('vacAnsDays',-$days);
					$this->insertObj($nObj);
					$obj->setMeta('vacAnsDays',$obj->getMeta('vacAnsDays')-$days);
					$this->updateObj($obj);
					$days=0;
				} else {
					$days-=$obj->getMeta('vacAnsDays');
					$nObj->setMeta('vacAnsDays',-$obj->getMeta('vacAnsDays'));
					$this->insertObj($nObj);
					$obj->setMeta('vacAnsDays',0);
					$this->updateObj($obj);
				}
			}
			$rest+=$obj->getMeta('vacAnsDays');
		}
		if ($days) {
			$nObj=clone $obj;
			$nObj->setMeta('FKVacAntID',$AntID);
			$nObj->setMeta('vacAnsDays',-$days);
			$this->insertObj($nObj);

			$obj->setMeta('vacAnsDays',$obj->getMeta('vacAnsDays')-$days);
			$this->updateObj($obj);
			
			$rest+=$obj->getMeta('vacAnsDays');
		}
		return $rest;
	}
	function restoreAns($AntID) {
		$search=array(
			'FKVacAntID'=>$AntID,
		);
		$entries=$this->listObj($search);
		foreach($entries as $obj) {
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'vacAnsYear','Typ'=>'=','Values'=>$obj->getMeta('vacAnsYear'));
			$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$obj->getMeta('FKUserID'));
			$searchQuery[]=array('Field'=>'FKVacAntID','Typ'=>'=','Values'=>0);
			if (($ansObj=$this->searchSingleObj($searchQuery))) {
				$ansObj->setMeta('vacAnsDays',$ansObj->getMeta('vacAnsDays') - $obj->getMeta('vacAnsDays'));
				$this->updateObj($ansObj);
				$this->deleteObj($obj);
			} else {
				$obj->setMeta('FKVacAntID',0);
				$obj->setMeta('vacAnsDays',0 - $obj->getMeta('vacAnsDays'));
				$this->updateObj($obj);
			}
		}
	}
	function listAns() {
		$result=array();
		$query="SELECT * FROM ".$this->_table.' WHERE FKVacAntID=0 ORDER BY vacAnsYear';
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FKUserID')][$this->_db->f('vacAnsYear')]=$this->_parseObjData();
		}
		return $result;
	}
	function getAntDays($AntID) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKVacAntID','Typ'=>'=','Values'=>$AntID);
		$result=array();
		$query="SELECT SUM(vacAnsDays) as tage FROM ".$this->_table.' WHERE '.$this->_db->getWhere($searchQuery);
		//debug($query);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('tage');
		}
		return 0;
	}	
	function getAvailableDays($FKUserID) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$FKUserID);
		$searchQuery[]=array('Field'=>'FKVacAntID','Typ'=>'=','Values'=>0);
		$subQuery=array();
		$subQuery[]=array(array('Field'=>'vacAnsExpires','Typ'=>'=','Values'=>'0000-00-00'));
		$subQuery[]=array(array('Field'=>'vacAnsExpires','Typ'=>'>=','Values'=>date('Y-m-d 00:00:00')));
		$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
		
		$result=array();
		$query="SELECT SUM(vacAnsDays) as tage FROM ".$this->_table.' WHERE '.$this->_db->getWhere($searchQuery);
		//debug($query);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('tage');
		}
		return 0;
	}
}
?>
