<?php
class ObjVacAnt extends baseObj {
	public $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return '';
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
	function getDays($force_calc=false) {
		$days=0;
		if (!$force_calc && $this->getMeta('vacAntStatus')=='confirmed') {
			$Base=$GLOBALS['frm']->getStaticModul('custom');
			$BaseAns=$Base->getStaticModul('vac_ans');
			return ($BaseAns->getAntDays($this->getID())*-1);
		} 
		$zef=$GLOBALS['frm']->getStaticModul('zef');
		$wd=$GLOBALS['frm']->getStaticModul('workday');
		if ($this->getMeta('FKUserID')) $wd->loadCountry($GLOBALS['frm']->getPrefs('cal','country',$this->getMeta('FKUserID')));
		$timeB=mktime(12,0,0,FrameWork::dateSql('m',$this->getMeta('vacAntStartDate')),FrameWork::dateSql('d',$this->getMeta('vacAntStartDate')),FrameWork::dateSql('Y',$this->getMeta('vacAntStartDate')));
		$timeE=mktime(23,0,0,FrameWork::dateSql('m',$this->getMeta('vacAntEndDate')),FrameWork::dateSql('d',$this->getMeta('vacAntEndDate')),FrameWork::dateSql('Y',$this->getMeta('vacAntEndDate')));
		$userTime=$zef->getUserDayTime($this->getMeta('FKUserID')?$this->getMeta('FKUserID'):-1);
		//debug($userTime);
		for ($time=$timeB;$time<$timeE;$time+=3600*24) {
			if (!empty($userTime)) {
				$wDay=date('N',$time);
				if ($userTime[$wDay] && $wd->is_workday($time)) {
					$num=1;
					if ($time==$timeB && FrameWork::dateSql('H',$this->getMeta('vacAntStartDate'))==12 && $userTime[$wDay]>=21600) {
						//erster Tag nur Nachmittag und Vollzeit (min 6 Stunden)
						$num=0.5;
					} elseif ($time+3600*2>$timeE && FrameWork::dateSql('H',$this->getMeta('vacAntEndDate'))==12 && $userTime[$wDay]>=21600) {
						//letzter Tag nur Vormittag und Vollzeit (min 6 Stunden)
						$num=0.5;
					}
					$days+=$num;
				}
			} else {
				if ($wd->is_workday($time,true)) {
					$days+=1;
				}
			}
		}
		return $days;
	}
	
}

class Core_vac_ant extends ObjCore {
	public $_modul='vac';
	public $_table='VacAnt';
	public $_cfgObjects=array (
		'IdField'=>'vacAntID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'0'=>array(
			'ClassName'=>'ObjVacAnt',
			'Fields'=>array(
				'vacAntID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'FKUserID'=>array(
					'Typ'=>'core',
				),
				'FKvacTypeID'=>array(
					'Typ'=>'core',
				),
				'vacAntStartDate'=>array(
					'Typ'=>'core',
				),
				'vacAntEndDate'=>array(
					'Typ'=>'core',
				),
				'vacAntNote'=>array(
					'Typ'=>'core',
				),
				'vacAntStatus'=>array(
					'Typ'=>'core',
					// 'processing','approved','confirmed','rejected','canceled'
				),
				'FKEventID'=>array(
					'Typ'=>'core',
				),
				'FKZefID'=>array(
					'Typ'=>'core',
				),
				'TimeCreate'=>array(
					'Typ'=>'core',
					'Extra'=>'cTime',
				),
				'UserCreate'=>array(
					'Typ'=>'core',
					'Extra'=>'cUser',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
			),
		),
	);

	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','vac')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function insertObj(&$Obj) {
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		return $this->deleteMeta($Obj);
	}
	function listObj(&$rows,$search=array(),$b=0,$limit=0) {
		$searchQuery=array();
		if ($search['_vacAntID']) {
			$searchQuery[]=array('Field'=>'vacAntID','Typ'=>'!=','Values'=>$search['_vacAntID']);
		}
		if ($search['FKUserID']) {
			$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$search['FKUserID']);
		}
		if ($search['FKvacTypeID']) {
			$searchQuery[]=array('Field'=>'FKvacTypeID','Typ'=>'=','Values'=>$search['FKvacTypeID']);
		}
		if ($search['TimeCreateB']) {
			$searchQuery[]=array('Field'=>'TimeCreate','Typ'=>'>=','Values'=>$search['TimeCreateB']);
		}
		if ($search['TimeCreateE']) {
			$searchQuery[]=array('Field'=>'TimeCreate','Typ'=>'<=','Values'=>$search['TimeCreateE']);
		}
		if ($search['vacAntStartDateB']) {
			$searchQuery[]=array('Field'=>'vacAntStartDate','Typ'=>'>=','Values'=>$search['vacAntStartDateB']);
		}
		if ($search['vacAntStartDateE']) {
			$searchQuery[]=array('Field'=>'vacAntStartDate','Typ'=>'<=','Values'=>$search['vacAntStartDateE']);
		}
		if ($search['vacAntEndDateB']) {
			$searchQuery[]=array('Field'=>'vacAntEndDate','Typ'=>'>=','Values'=>$search['vacAntEndDateB']);
		}
		if ($search['vacAntEndDateE']) {
			$searchQuery[]=array('Field'=>'vacAntEndDate','Typ'=>'>=','Values'=>$search['vacAntEndDateE']);
		}
		if ($search['vacAntStatus']) {
			$searchQuery[]=array('Field'=>'vacAntStatus','Typ'=>'=','Values'=>$search['vacAntStatus']);
		}
		//debug($this->_db->getWhere($searchQuery));
		return $this->searchObj($rows,$searchQuery,'TimeCreate',$b,$limit);
	}
	function getPlanedDays($FKUserID,$ignoreID=0) {
		$days=0;
		$rows=0;
		$search=array(
			'FKUserID'=>$FKUserID,
			'vacAntStatus'=>array('processing','approved'),
			'vacAntStartDate'=>date('Y-m-d 00:00:00')
		);
		foreach($this->listObj($rows,$search) as $obj) {
			if ($ignoreID && $ignoreID==$obj->getID()) continue;
			$days+=$obj->getDays();
			
		};
		return $days;
	}
}
?>
