<?php
class ObjVacType extends baseObj {
	public $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['vacTypeName']?$this->_meta['vacTypeName']:'??';
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class Core_vac_type extends ObjCore {
	public $_modul='vac';
	public $_table='VacType';
	public $_cfgObjects=array (
		'IdField'=>'vacTypeID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'TranslationFields'=>array('vacTypeName'),
		'0'=>array(
			'ClassName'=>'ObjVacType',
			'Fields'=>array(
				'vacTypeID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'vacTypeName'=>array(
					'Typ'=>'core',
				),
				'FKCalCatID'=>array(
					'Typ'=>'core',
				),
				'FKCalGrant'=>array(
					'Typ'=>'core',
				),
				'FKZefPrjID'=>array(
					'Typ'=>'core',
				),
				'FKZefCatID'=>array(
					'Typ'=>'core',
				),
				'vacTypeDeleted'=>array(
					'Typ'=>'core',
				),
			),
		),
	);

	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','vac')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function insertObj(&$Obj) {
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		$Obj->setMeta('vacTypeDeleted',1);
		return $this->updateObj($Obj);
	}
	function listObj($search=array(),$b=0,$limit=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'vacTypeDeleted','Typ'=>'=','Values'=>0);
		if ($search['info']) {
			$searchQuery[]=array('Field'=>array('VacType.vacTypeName'),'Typ'=>'concat','Values'=>$search['info']);
		}
		$rows=0;
		return $this->searchObj($rows,$searchQuery,'VacType.vacTypeName ASC',$b,$limit);
	}
}
?>
