<?php
class Gui_vac {
	var $_Base;
	var $_Obj;
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_usePerms=true;
	var $_avModuls=array();
	var $_ruleUsers=array(
		1=>array(),
		2=>array(),
	);
	function __construct($mode='') {
		global $frm,$t,$T,$E,$L,$Y;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_Y=&$Y;
		$this->_mode=$mode;
		$this->_avModuls=array();
		$this->_Base=$frm->getStaticModul('custom');
		$this->_BaseDep=$this->_Base->getStaticModul('vac_dep');
		$this->_BaseType=$this->_Base->getStaticModul('vac_type');
		$this->_BaseAns=$this->_Base->getStaticModul('vac_ans');
		$this->_BaseAnt=$this->_Base->getStaticModul('vac_ant');
		$this->_myRules=$this->_BaseDep->getMyRules();
		$this->_T->loadModul('vac');
		$this->_selTime=array('00:00'=>$this->_T->lang('[[morgens]]'),'12:00'=>$this->_T->lang('[[mittags]]'),'23:59'=>$this->_T->lang('[[abends]]'));
		$this->_selStatus=array(
			'processing'=>$this->_T->lang('[[in Bearbeitung]]'),
			'approved'=>$this->_T->lang('[[genehmigt]]'),
			'confirmed'=>$this->_T->lang('[[bestaetigt]]'),
			'rejected'=>$this->_T->lang('[[abgelehnt]]'),
			'canceled'=>$this->_T->lang('[[storniert]]'),
		);
		if (!$this->_mode) {
			if (isset($this->_myRules[0])) {
				$this->_mode='vac_ant';
			} elseif (isset($this->_myRules[1]) || isset($this->_myRules[2])) {
				$this->_mode='vac_ant_c';
			}
		}
	}
	function isCallable() {
		return true;
	}
	function _handleRequest() {
		if (isset($this->_myRules[1])) {
			$this->_ruleUsers[1]=$this->_BaseDep->getMyUsers($this->_myRules[1]);
		}
		if (isset($this->_myRules[2])) {
			$this->_ruleUsers[2]=$this->_BaseDep->getMyUsers($this->_myRules[2]);
		}
		switch ($this->_mode) {
			case 'vac_ans':
				$this->_action=Framework::getParam('action','b','G');
				$this->_oid=Framework::getParam('oid',0,'G');
				if ($this->_oid && ($this->_Obj=$this->_BaseAns->getObj($this->_oid))) {
				} else {
					$this->_oid=0;
				}
				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('oid');
							$this->_L->goToLink();
						break;
						case 'delete':
							if ($this->_oid && $this->_Obj) {
								if ($this->_BaseAns->deleteObj($this->_Obj)) {
									$this->_L->unsetParam(array('oid','action'));
									$this->_L->goToLink();
								}
							}
						break;
						default:
							//debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
				$this->_ObjActionGui=$this->getObjActionGui($this->_mode);
			break;
			case 'vac_ant':
				$this->_action=Framework::getParam('action','b','G');
				$this->_oid=Framework::getParam('oid',0,'G');
				switch ($this->_action) {
					case 'v':
						if ($this->_oid && ($this->_Obj=$this->_BaseAnt->getObj($this->_oid)) && $this->_Obj->getMeta('FKUserID')==$this->_frm->getUser()) {


						} else {
							$this->_oid=0;
							$this->_Obj=null;
							$this->_action='b';
						}
					break;
					case 'n':
						if ($this->_oid && ($this->_Obj=$this->_BaseAnt->getObj($this->_oid)) && $this->_Obj->getMeta('FKUserID')==$this->_frm->getUser()) {


						} else {
							$this->_oid=0;
							$this->_Obj=null;
						}
					break;
				}
				
				if (Framework::getParam('delete_x',0) && $this->_Obj && in_array($this->_Obj->getMeta('vacAntStatus'),array('processing'))) {
					if ($this->_BaseAnt->deleteObj($this->_Obj)) {
						if ($this->_Obj->getMeta('FKEventID')) {
							$BaseEvt=$this->_frm->getStaticModul('cal');
							$BaseEvt->deleteEvent($this->_Obj->getMeta('FKEventID'));
						}
						$this->_L->unsetParam(array('oid','action'));
						$this->_L->goToLink();
					}
				}
				if (Framework::getParam('edit_x',0) && $this->_Obj && in_array($this->_Obj->getMeta('vacAntStatus'),array('processing'))) {
					$this->_L->setParam('action','n');
					$this->_L->goToLink();
				}
				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('oid');
							$this->_L->goToLink();
						break;
					}
				}
				$this->_ObjActionGui=$this->getObjActionGui($this->_mode);
			break;
			case 'vac_ant_c':
				$this->_action=Framework::getParam('action','b','G');
				$this->_oid=Framework::getParam('oid',0,'G');
				switch ($this->_action) {
					case 'v':
						if ($this->_oid && ($this->_Obj=$this->_BaseAnt->getObj($this->_oid))) {

							
						} else {
							$this->_oid=0;
							$this->_Obj=null;
							$this->_action='b';
						}
					break;
				}
				/*
				if (Framework::getParam('edit_x',0) && $this->_Obj && in_array($this->_Obj->getMeta('vacAntStatus'),array('processing'))) {
					$this->_L->setParam('action','n');
					$this->_L->goToLink();
				}
				*/
			break;
			case 'vac_arch':
				$this->_action=Framework::getParam('action','b','G');
				if (Framework::getParam('search_x','','P')) {
					$this->_oid=0;
					$this->_action='b';
				} else {
					$this->_oid=Framework::getParam('oid',0,'G');
					$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpVacAntSearch',1,0);
				}
				switch ($this->_action) {
					case 'v':
						if ($this->_oid && ($this->_Obj=$this->_BaseAnt->getObj($this->_oid))) {
						} else {
							$this->_oid=0;
							$this->_action='b';
						}
					break;
				}
				break;
		}
		return $this->_mode;
	}
	function processAjax($request_str) {
		switch ($this->_mode) {
			case 'vac_ans':

			break;
		}
	}
	function process($AppGui) {
		if (isset($this->_myRules[0])) {
			$AppGui->addTab('vac_ant',$this->_T->lang('[[Meine Urlaubsantraege]]'),"index.php?site=custom.php&mode=vac_ant");
		}
		if (isset($this->_myRules[1]) || isset($this->_myRules[2])) {
			$AppGui->addTabSpacer();
			$AppGui->addTab('vac_ant_c',$this->_T->lang('[[Urlaubsantraege]]'),"index.php?site=custom.php&mode=vac_ant_c");
			$AppGui->addTab('vac_ans',$this->_T->lang('[[Urlaubsanspruch]]'),"index.php?site=custom.php&mode=vac_ans");
		}
		$AppGui->addTabSpacer();
		$AppGui->addTab('vac_arch',$this->_T->lang('[[Archiv]]'),"index.php?site=custom.php&mode=vac_arch");
		
		switch ($this->_mode) {
			case 'vac_ans':
				switch ($this->_action) {
					case 'n':
						$AppGui->addContent($this->newVacAns());
					break;
					default:
						$AppGui->addContent($this->listVacAns());
					break;
				}
			break;
			case 'vac_ant':
				require_once('lib/class_ApplicationTreeGui.php');
				$TreeGui=new ApplicationTreeGui();
				//$TreeGui->addTreeContent($this->cfgVacAnt());
				$TreeGui->addTreeContent($this->myVacAns());
				switch ($this->_action) {
					case 'n':
						$TreeGui->addContent($this->newVacAnt());
					break;
					case 'v':
						$TreeGui->addContent($this->viewVacAnt());
					break;
					default:
						$TreeGui->addContent($this->listVacAnt());
					break;
				}
				$AppGui->addContent($TreeGui);
			break;
			case 'vac_ant_c':
				require_once('lib/class_ApplicationTreeGui.php');
				$TreeGui=new ApplicationTreeGui();
				//$TreeGui->addTreeContent($this->cfgVacAnt());
				//$TreeGui->addTreeContent($this->myVacAns());
				switch ($this->_action) {
					case 'v':
						$TreeGui->addTreeContent($this->myVacAns($this->_Obj->getMeta('FKUserID')));
						$TreeGui->addContent($this->viewVacAntC());
						$TreeGui->addContent($this->listVacAntOther());
					break;
					default:
						$TreeGui->addContent($this->listVacAnt());
					break;
				}
				$AppGui->addContent($TreeGui);
			break;
			case 'vac_arch':
				require_once('lib/class_ApplicationTreeGui.php');
				$TreeGui=new ApplicationTreeGui();
				$TreeGui->addTreeContent($this->cfgVacArch());
				switch ($this->_action) {
					case 'v':
						$TreeGui->addContent($this->viewVacAnt());
					break;
					default:
						$TreeGui->addContent($this->listVacAntArchiv());
					break;
				}
				$AppGui->addContent($TreeGui);
			break;
		}
		if ($this->_ObjActionGui) {
			$AppGui->addFunction($this->_ObjActionGui);
		}
	}
	function &cfgVacArch() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_DateSelectForm.php');

		$Gui=new TemplateGui('core/common_content_border.inc.html');

		$selDateGui=new DateSelectForm();
		//$selDateGui->setAvMode(array(3,8));
		$selDateGui->setMode($this->_search['DateMode']?$this->_search['DateMode']:1);
		//$selDateGui->setStartMonths(6);
		//$selDateGui->setStartQuarter(2);

		if ($this->_search['TimeCreateB'] || $this->_search['TimeCreateE']) {
			$selDateGui->setDate(array($this->_search['TimeCreateB'],$this->_search['TimeCreateE']));
		} else {
			$selDateGui->setDate(array(0,0));
		}
		$Gui->addContent('dateSelect',$selDateGui->process(),'CONTENT');

		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		if (isset($this->_myRules[1]) || isset($this->_myRules[2])) {
			$key="FKUserID";
			$default=$this->_search['FKUserID']?('u_'.implode('|u_',$this->_search['FKUserID'])):'';
			$mode='u';
			$params=base64_encode(serialize(array('useAll'=>1)));
			$lb_params=array('Values'=>array());
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Antragsteller]]'),
				'LabelSep'=>'',
				'mode'=>$mode,
				'app'=>'custom',
				'params'=>$params,
				'FieldVal'=>'_USERS',
			);
			$lb_U=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
			$formGui->addField($key,'ttip',$lb_U,$default,'fields1');
			$formGui->setParams($key,array('mode'=>$mode,'app'=>'custom','width'=>'240px','params'=>$params));

			$FKUserID=array();
			if ($formGui->getFieldVal('FKUserID',1)) {
				$tmp=explode('|',$formGui->getFieldVal('FKUserID',1));
				foreach ($tmp as $val) {
					$FKUserID[]=substr($val,2);
				}
			}
		} else {
			$FKUserID=$this->_frm->getUser();
		}

		$key="vacAntStatus";
		$formGui->addField($key,'select',$this->_T->lang('[[Status]]'),$this->_search[$key]?$this->_search[$key]:'0','fields1');
		$formGui->setValues($key,array(0=>'-') + $this->_selStatus);

		$submit_array=array(
			'search_x'=>' '.$this->_T->lang('[[Suchen]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','fields1');
		$formGui->setValues($key,$submit_array);

		$this->_search=array(
			'TimeCreateB'=>$selDateGui->getDate('B'),
			'TimeCreateE'=>$selDateGui->getDate('E'),
			'DateMode'=>$selDateGui->getMode(),
			'FKUserID'=>$FKUserID,
			'vacAntStatus'=>$formGui->getFieldVal('vacAntStatus',1),
		);

		$this->_frm->savePostData($this->_Base->getModul(),'tmpVacAntSearch',null,$this->_search);
		$Gui->addContent('config',$formGui,'CONTENT');
		return $Gui;
	}	
	function listVacAntArchiv() {
		require_once('lib/class_ApplicationListGui.php');
		$Gui=new ApplicationListGui();
		$Gui->setRowClass(array(0=>'list_l',1=>'list_h',2=>'list_s',3=>'list_hb',4=>'list_b'));
		$Gui->setName($this->_T->lang('[[Urlaubsantraege]]'));

		$Gui->addHeaderCol('TimeCreate',$this->_T->lang('[[Antragsdatum]]'),'','','',1);
		if (isset($this->_myRules[1]) || isset($this->_myRules[2])) {
			$Gui->addHeaderCol('FKUserID',$this->_T->lang('[[Antragsteller]]'),'','','',1);
		}
		$Gui->addHeaderCol('vacAntStatus',$this->_T->lang('[[Status]]'),'','','',1);
		$Gui->addHeaderCol('vacAntStartDate',$this->_T->lang('[[Urlaubsbeginn]]'),'','','',1);
		$Gui->addHeaderCol('vacAntEndDate',$this->_T->lang('[[Urlaubsende]]'),'','','',1);
		$Gui->addHeaderCol('_Days',$this->_T->lang('[[Tage]]'),'','','',1);
		$Gui->addHeaderCol('FKvacTypeID',$this->_T->lang('[[Urlaubstyp]]'),'','','',1);
		$Gui->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','right',0,2000);
		$Gui->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);

		if (Framework::getParam('search_x','','P')) {
			$b=0;
		} else {
			$b=FrameWork::getParam('b',0);
		}
		$limit=50;
		$rows=0;
		$entries=array();

		$Gui->setLimit($limit);
		$Gui->setSumRows($rows);
		$Gui->setBegin($b);
		$Gui->setNavLink($this->_L);
		//debug($search);

		$entries=$this->_BaseAnt->listObj($rows,$this->_search,$b,$limit);

		foreach ($entries as $obj) {
			$Gui->addRow(0,'top');
			$Gui->addCol('TimeCreate',date('d.m.Y',$obj->getMeta('TimeCreate')),'',$this->_L->getTempLink(null,array('oid'=>$obj->getID(),'action'=>'v')),'',1);
			if (isset($this->_myRules[1]) || isset($this->_myRules[2])) {
				$Gui->addCol('FKUserID',$obj->getMeta('FKUserID')?$this->_frm->getCachedUserNameAll($obj->getMeta('FKUserID')):'','','','',1);
			}
			$Gui->addCol('vacAntStatus',$this->_selStatus[$obj->getMeta('vacAntStatus')],'','','',1);
			$txt=FrameWork::dateSql('d.m.Y',$obj->getMeta('vacAntStartDate'));
			$txt.=' '.$this->_selTime[FrameWork::dateSql('H:i',$obj->getMeta('vacAntStartDate'))];
			$Gui->addCol('vacAntStartDate',$txt,'','','',1);
			$txt=FrameWork::dateSql('d.m.Y',$obj->getMeta('vacAntEndDate'));
			$txt.=' '.$this->_selTime[FrameWork::dateSql('H:i',$obj->getMeta('vacAntEndDate'))];
			$Gui->addCol('vacAntEndDate',$txt,'','','',1);
			$Gui->addCol('_Days',$obj->getDays(),'','','',1);
			$tmpObj=$this->_BaseType->getObj($obj->getMeta('FKvacTypeID'),1);
			$Gui->addCol('FKvacTypeID',$tmpObj?$tmpObj->getName():'','','','',1);
			$Gui->addCol('TimeModify',$obj->getMeta('TimeModify')?date('d.m.Y',$obj->getMeta('TimeModify')):'','','','right',0);
			$Gui->addCol('UserModify',$obj->getMeta('UserModify')?$this->_frm->getCachedUserNameAll($obj->getMeta('UserModify')):'','','','',1);
		}
		return $Gui;
	}
	function myVacAns($userID=0) {
		require_once('lib/class_ApplicationListGui.php');
		$Gui=new ApplicationListGui();
		$Gui->setName($userID?$this->_frm->getCachedUserNameAll($userID):$this->_T->lang('[[Mein Urlaubsanspruch]]'));

		//debug($entries);
		$Gui->addHeaderCol('Name',$this->_T->lang('[[Jahr]]'),'','','',1);
		$Gui->addHeaderCol('VacDays',$this->_T->lang('[[Resturlaub]]'),'','','',1);
		$Gui->addHeaderCol('VacExpires',$this->_T->lang('[[Verfallsdatum]]'),'','','',1);

		$search=array(
			'FKUserID'=>$userID?$userID:$this->_frm->getUser(),
			'vacAnsExpires'=>date('Y-m-d',time()-3600*24*30),
		);
		$entries=$this->_BaseAns->listObj($search);
		foreach($entries as $obj) {
			$color='';
			if ($obj->getMeta('vacAnsDays') && $obj->getMeta('vacAnsExpires')!='0000-00-00') {
				$timeExp=FrameWork::parseSqlDate($obj->getMeta('vacAnsExpires'));
				if ($timeExp<time()) {
					$color='#ff9e9e';
				} elseif ($timeExp<time()+30*3600*24) {
					$color='#ffff00';
				}
			}
			$Gui->addRow(0,'top',$color);
			$Gui->addCol('vacAnsYear',$obj->getMeta('vacAnsYear'),'','','right',1);
			$Gui->addCol('vacAnsDays',FrameWork::numberFormat($obj->getMeta('vacAnsDays'),1),'','','right',1);
			$Gui->addCol('vacAnsExpires',$obj->getMeta('vacAnsExpires')!='0000-00-00'?FrameWork::dateSql('d.m.Y',$obj->getMeta('vacAnsExpires')):'','','','right',1);
		}
		return $Gui;
	}

	function cfgVacAnt() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_DateSelectForm.php');

		$Gui=new TemplateGui('core/common_content_border.inc.html');
		return $Gui;
	}
	function listVacAnt() {
		require_once('lib/class_ApplicationListGui.php');
		$colspan=7;
		$Gui=new ApplicationListGui();
		$Gui->setRowClass(array(0=>'list_l',1=>'list_h',2=>'list_s',3=>'list_hb',4=>'list_b',5=>'list_m'));
		$Gui->setName($this->_T->lang('[[Urlaubsantraege]]'));

		$Gui->addHeaderCol('TimeCreate',$this->_T->lang('[[Antragsdatum]]'),'','','',1);
		if ($this->_mode=='vac_ant_c') {
			$Gui->addHeaderCol('FKUserID',$this->_T->lang('[[Antragsteller]]'),'','','',1);
			$colspan++;
		}
		
		//$Gui->addHeaderCol('vacAntStatus',$this->_T->lang('[[Status]]'),'','','',1);
		$Gui->addHeaderCol('vacAntStartDate',$this->_T->lang('[[Urlaubsbeginn]]'),'','','',1);
		$Gui->addHeaderCol('vacAntEndDate',$this->_T->lang('[[Urlaubsende]]'),'','','',1);
		$Gui->addHeaderCol('_Days',$this->_T->lang('[[Tage]]'),'','','',1);
		$Gui->addHeaderCol('FKvacTypeID',$this->_T->lang('[[Urlaubstyp]]'),'','','',1);
		$Gui->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','right',0,2000);
		$Gui->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);

		$b=0;
		$limit=0;
		$rows=0;
		$entries=array();
		if ($this->_mode=='vac_ant_c') {
			$search=array(
				'vacAntStartDateB'=>date('Y-m-d'),
			);
			if (!empty($this->_ruleUsers[1])) {
				$search['FKUserID']=$this->_ruleUsers[1];
				$search['vacAntStatus']='processing';
				$entries['processing']=$this->_BaseAnt->listObj($rows,$search,$b,$limit);
			}
			$search['FKUserID']=array_merge($this->_ruleUsers[1],$this->_ruleUsers[2]);
		} else {
			$search=array(
				'vacAntEndDateE'=>date('Y-m-d'),
			);
			$search['FKUserID']=$this->_frm->getUser();
			$search['vacAntStatus']='processing';
			$entries['processing']=$this->_BaseAnt->listObj($rows,$search,$b,$limit);
		}

		$search['vacAntStatus']='approved';
		$entries['approved']=$this->_BaseAnt->listObj($rows,$search,$b,$limit);

		$search['vacAntStatus']='confirmed';
		$entries['confirmed']=$this->_BaseAnt->listObj($rows,$search,$b,$limit);

		$search['vacAntStatus']='rejected';
		$entries['rejected']=$this->_BaseAnt->listObj($rows,$search,$b,$limit);

		$search['vacAntStatus']='canceled';
		$entries['canceled']=$this->_BaseAnt->listObj($rows,$search,$b,$limit);

	

		foreach($entries as $typ=>$rows) {
			if (!empty($rows)) {
				$Gui->addRow(3,'top');
				$Gui->addCol('vacAntStatus',$this->_selStatus[$typ],'','','',0,2000,$colspan);
				$color='';
				switch($typ) {
					case 'approved':
						$color='#fff7ce';
					break;
					case 'confirmed':
						$color='#F2FFE6';
					break;
					case 'rejected':
						$color='#ffaaaa';
					break;
				}
				foreach ($rows as $obj) {
					$Gui->addRow(0,'top',$color);
					$Gui->addCol('TimeCreate',date('d.m.Y',$obj->getMeta('TimeCreate')),'',$this->_L->getTempLink(null,array('oid'=>$obj->getID(),'action'=>'v')),'',1);
					if ($this->_mode=='vac_ant_c') {
						$Gui->addCol('FKUserID',$obj->getMeta('FKUserID')?$this->_frm->getCachedUserNameAll($obj->getMeta('FKUserID')):'','','','',1);
					}
					//$Gui->addCol('vacAntStatus',$this->_selStatus[$obj->getMeta('vacAntStatus')],'','','',1);
					$txt=FrameWork::dateSql('d.m.Y',$obj->getMeta('vacAntStartDate'));
					$txt.=' '.$this->_selTime[FrameWork::dateSql('H:i',$obj->getMeta('vacAntStartDate'))];
					$Gui->addCol('vacAntStartDate',$txt,'','','',1);
					$txt=FrameWork::dateSql('d.m.Y',$obj->getMeta('vacAntEndDate'));
					$txt.=' '.$this->_selTime[FrameWork::dateSql('H:i',$obj->getMeta('vacAntEndDate'))];
					$Gui->addCol('vacAntEndDate',$txt,'','','',1);
					$Gui->addCol('_Days',$obj->getDays(),'','','',1);
					$tmpObj=$this->_BaseType->getObj($obj->getMeta('FKvacTypeID'),1);
					$Gui->addCol('FKvacTypeID',$tmpObj?$tmpObj->getName():'','','','',1);
					$Gui->addCol('TimeModify',$obj->getMeta('TimeModify')?date('d.m.Y',$obj->getMeta('TimeModify')):'','','','right',0);
					$Gui->addCol('UserModify',$obj->getMeta('UserModify')?$this->_frm->getCachedUserNameAll($obj->getMeta('UserModify')):'','','','',1);
				}
			}
		}
		return $Gui;
	}
	function listVacAntOther() {
		require_once('lib/class_ApplicationListGui.php');
		$Gui=new ApplicationListGui();
		$Gui->setRowClass(array(0=>'list_l',1=>'list_h',2=>'list_s',3=>'list_hb',4=>'list_b'));
		$Gui->setName($this->_T->lang('[[Urlaubsantraege]]'));

		$Gui->addHeaderCol('TimeCreate',$this->_T->lang('[[Antragsdatum]]'),'','','',1);
		$Gui->addHeaderCol('FKUserID',$this->_T->lang('[[Antragsteller]]'),'','','',1);
		$Gui->addHeaderCol('vacAntStatus',$this->_T->lang('[[Status]]'),'','','',1);
		$Gui->addHeaderCol('vacAntStartDate',$this->_T->lang('[[Urlaubsbeginn]]'),'','','',1);
		$Gui->addHeaderCol('vacAntEndDate',$this->_T->lang('[[Urlaubsende]]'),'','','',1);
		$Gui->addHeaderCol('_Days',$this->_T->lang('[[Tage]]'),'','','',1);
		$Gui->addHeaderCol('FKvacTypeID',$this->_T->lang('[[Urlaubstyp]]'),'','','',1);
		$Gui->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','right',0,2000);
		$Gui->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);

		$dateStart=FrameWork::parseSqlDate($this->_Obj->getMeta('vacAntStartDate')) - 3600*24*7 ;
		$dateEnd=FrameWork::parseSqlDate($this->_Obj->getMeta('vacAntEndDate')) + 3600*24*7;

		$Gui->setName($this->_T->lang('[[Urlaubsantraege]]').': '.date('d.m.Y',$dateStart).' - '.date('d.m.Y',$dateEnd));
		
		$b=0;
		$limit=0;
		$rows=0;
		$entries=array();

		$depUsers=array();
		$userRules=$this->_BaseDep->getMyRules($this->_Obj->getMeta('FKUserID'));
		if (isset($userRules[0])) {
			$depUsers=$this->_BaseDep->getMyUsers($userRules[0]);
		}

		if (!empty($depUsers)) {
			$search=array(
				'_vacAntID'=>$this->_Obj->getID(),
				'vacAntEndDateB'=>date('Y-m-d 00:00:00',$dateStart),
				'vacAntStartDateE'=>date('Y-m-d 23:59:59',$dateEnd),
			);
			$search['FKUserID']=$depUsers;
			$search['vacAntStatus']=array('processing','approved','confirmed');

			//debug($search);

			$entries=$this->_BaseAnt->listObj($rows,$search,$b,$limit);

			foreach ($entries as $obj) {
				$Gui->addRow(0,'top');
				$Gui->addCol('TimeCreate',date('d.m.Y',$obj->getMeta('TimeCreate')),'',$this->_L->getTempLink(null,array('oid'=>$obj->getID(),'action'=>'v')),'',1);
				$Gui->addCol('FKUserID',$obj->getMeta('FKUserID')?$this->_frm->getCachedUserNameAll($obj->getMeta('FKUserID')):'','','','',1);
				$Gui->addCol('vacAntStatus',$this->_selStatus[$obj->getMeta('vacAntStatus')],'','','',1);
				$txt=FrameWork::dateSql('d.m.Y',$obj->getMeta('vacAntStartDate'));
				$txt.=' '.$this->_selTime[FrameWork::dateSql('H:i',$obj->getMeta('vacAntStartDate'))];
				$Gui->addCol('vacAntStartDate',$txt,'','','',1);
				$txt=FrameWork::dateSql('d.m.Y',$obj->getMeta('vacAntEndDate'));
				$txt.=' '.$this->_selTime[FrameWork::dateSql('H:i',$obj->getMeta('vacAntEndDate'))];
				$Gui->addCol('vacAntEndDate',$txt,'','','',1);
				$Gui->addCol('_Days',$obj->getDays(),'','','',1);
				$tmpObj=$this->_BaseType->getObj($obj->getMeta('FKvacTypeID'),1);
				$Gui->addCol('FKvacTypeID',$tmpObj?$tmpObj->getName():'','','','',1);
				$Gui->addCol('TimeModify',$obj->getMeta('TimeModify')?date('d.m.Y',$obj->getMeta('TimeModify')):'','','','right',0);
				$Gui->addCol('UserModify',$obj->getMeta('UserModify')?$this->_frm->getCachedUserNameAll($obj->getMeta('UserModify')):'','','','',1);
			}
		}
		if (!$rows) {
			$Gui->addRow(0,'top');
			$Gui->addCol('info',$this->_T->lang('[[Keine Eintraege]]'),'','','',0,2000,9);
		}
		return $Gui;
	}
	function viewVacAntC() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ApplicationListGui.php');

		$Gui=new ContentGui();
		$Gui->setName($this->_T->lang('[[Urlaubsantrag]]'));

		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$tabGui=new ApplicationListGui();

		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Antragsdatum]]'),'','','',1,'');
		$tabGui->addCol('Name',date('d.m.Y',$this->_Obj->getMeta('TimeCreate')),'','','',0,'2000',1,'');

		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Antragsteller]]'),'','','',1,'');
		$tabGui->addCol('Name',$this->_frm->getCachedUserNameAll($this->_Obj->getMeta('FKUserID')),'','','',0,'2000',1,'');

		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Urlaubstyp]]'),'','','',1,'');
		$tmpObj=$this->_BaseType->getObj($this->_Obj->getMeta('FKvacTypeID'),1);
		$tabGui->addCol('Name',$tmpObj?$tmpObj->getName():'','','','',0,'2000',1,'');

		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Status]]'),'','','',1,'');
		$tabGui->addCol('Name',$this->_selStatus[$this->_Obj->getMeta('vacAntStatus')],'','','',0,'2000',1,'');

		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Urlaubsbeginn]]'),'','','',1,'');
		$txt=FrameWork::dateSql('d.m.Y',$this->_Obj->getMeta('vacAntStartDate'));
		$txt.=' '.$this->_selTime[FrameWork::dateSql('H:i',$this->_Obj->getMeta('vacAntStartDate'))];
		$tabGui->addCol('Name',$txt,'','','',0,'2000',1,'');

		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Urlaubsende]]'),'','','',1,'');
		$txt=FrameWork::dateSql('d.m.Y',$this->_Obj->getMeta('vacAntEndDate'));
		$txt.=' '.$this->_selTime[FrameWork::dateSql('H:i',$this->_Obj->getMeta('vacAntEndDate'))];
		$tabGui->addCol('Name',$txt,'','','',0,'2000',1,'');

		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Dauer]]'),'','','',1,'');
		$tabGui->addCol('Name',FrameWork::numberFormat($this->_Obj->getDays(),1).' '.$this->_T->lang('[[Tage]]'),'','','',0,'2000',1,'');

		if ($this->_Obj->getMeta('vacAntNote')) {
			$tabGui->addRow(0,'top');
			$tabGui->addCol('Title',$this->_T->lang('[[Bemerkung]]'),'','','',1,'');
			$tabGui->addCol('Name',$this->_Obj->getMeta('vacAntNote'),'','','',0,'2000',1,'');
		}

		$tabGui2=false;
		if (in_array($this->_Obj->getMeta('vacAntStatus'),array('processing','approved'))) {
			$tabGui2=new ApplicationListGui();
			$daysA=$this->_BaseAns->getAvailableDays($this->_Obj->getMeta('FKUserID'));
			$daysP=$this->_BaseAnt->getPlanedDays($this->_Obj->getMeta('FKUserID'),$this->_Obj->getID());
			$daysR=$daysA-$daysP-$this->_Obj->getDays();

			$tabGui2->addRow(1,'');
			$tabGui2->addCol('Title',$this->_T->lang('[[Aktueller Resturlaub]]'),'','','',1,'');
			$tabGui2->addCol('Name',FrameWork::numberFormat($daysA,1).' '.$this->_T->lang('[[Tage]]'),'','','',0,'2000',1,'');

			$tabGui2->addRow(0,'');
			$tabGui2->addCol('Title',$this->_T->lang('[[Urlaub in Bearbeitung]]'),'','','',1,'');
			$tabGui2->addCol('Name',FrameWork::numberFormat($daysP,1).' '.$this->_T->lang('[[Tage]]'),'','','',0,'2000',1,'');

			$tabGui2->addRow(0,'');
			$tabGui2->addCol('Title',$this->_T->lang('[[Dieser Urlaub]]'),'','','',1,'');
			$tabGui2->addCol('Name',FrameWork::numberFormat($this->_Obj->getDays(),1).' '.$this->_T->lang('[[Tage]]'),'','','',0,'2000',1,'');

			$tabGui2->addRow(1,'',$daysR<0?'#ffff00':'');
			$tabGui2->addCol('Title',$this->_T->lang('[[Berechneter Resturlaub]]'),'','','',1,'');
			$tabGui2->addCol('Name',FrameWork::numberFormat($daysR,1).' '.$this->_T->lang('[[Tage]]'),'','','',0,'2000',1,'');
		}



		require_once('lib/class_FormGui.php');
		$formGui=new FormGui();
		$formGui->setLabelClass('no','error');
		$key='note';
		$formGui->addField($key,'area',$this->_T->lang('[[Bemerkung]]'),'','field_s');
		$formGui->setAttribs($key,array('rows'=>5));

		$key='submit';
		$formGui->addField($key,'submit','','','field_s');
		$submitValues=array();
		if (in_array($this->_Obj->getMeta('vacAntStatus'),array('processing'))) {
			if (in_array($this->_Obj->getMeta('FKUserID'),$this->_ruleUsers[1])) {
				$formGui->setRequired('note');
				$submitValues['p_approve_x']=' '.$this->_T->lang('[[Genehmigen]]').' ';
				$submitValues['p_reject_x']=' '.$this->_T->lang('[[Ablehnen]]').' ';
			}
		}
		if (in_array($this->_Obj->getMeta('vacAntStatus'),array('approved'))) {
			if (in_array($this->_Obj->getMeta('FKUserID'),$this->_ruleUsers[2])) {
				$formGui->setRequired('note');
				$submitValues['g_confirm_x']=' '.$this->_T->lang('[[Bestaetigen]]').' ';
				$submitValues['g_reject_x']=' '.$this->_T->lang('[[Ablehnen]]').' ';
				//$formGui->setValuesAttribs($key,'reject_x',array('onclick'=>'return lo_form();'));
			} else {
				$submitValues['p_cancel_x']=' '.$this->_T->lang('[[Stornieren]]').' ';
			}
		}
		if (in_array($this->_Obj->getMeta('vacAntStatus'),array('confirmed'))) {
			if (in_array($this->_Obj->getMeta('FKUserID'),$this->_ruleUsers[1])) {
				$submitValues['p_cancel_x']=' '.$this->_T->lang('[[Stornieren]]').' ';
			}
		}
		if (FrameWork::getParam('p_approve_x')|| FrameWork::getParam('p_reject_x') || FrameWork::getParam('p_cancel_x') || FrameWork::getParam('g_confirm_x') || FrameWork::getParam('g_reject_x') ) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$oStatus=$this->_Obj->getMeta('vacAntStatus');
				$nStatus='';
				$actor='';
				if (FrameWork::getParam('p_approve_x')) {
					$nStatus='approved';
					$actor='p';
				}
				if (FrameWork::getParam('p_cancel_x')) {
					$nStatus='canceled';
					$actor='p';
				}
				if (FrameWork::getParam('p_reject_x')) {
					$nStatus='rejected';
					$actor='p';
				}
				if (FrameWork::getParam('g_reject_x')) {
					$nStatus='rejected';
					$actor='g';
				}
				if (FrameWork::getParam('g_confirm_x') && $oStatus=='approved' && in_array($this->_Obj->getMeta('FKUserID'),$this->_ruleUsers[2])) {
					$nStatus='confirmed';
					$actor='g';
				}
				if ($nStatus) {
					$this->_Obj->setMeta('vacAntStatus',$nStatus);
					$this->_BaseAnt->updateObj($this->_Obj);
					if ($nStatus=='confirmed') {
						$this->_BaseAns->decreaseAns($this->_Obj->getID(),$this->_Obj->getMeta('FKUserID'),$this->_Obj->getDays(true));
						if ($this->_Obj->getMeta('FKEventID')) {
							$BaseEvt=$this->_frm->getStaticModul('cal');
							if ($evtObj=$BaseEvt->readEvent($this->_Obj->getMeta('FKEventID'))) {
								$evtObj['Unsecure']=0;
								$BaseEvt->updateEvent($evtObj["EventID"],$evtObj);
							}
						}
						/*
						'FKZefPrjID'=>array(
							'Typ'=>'core',
						),
						'FKZefCatID'=>array(
							'Typ'=>'core',
						),
						*/
					}
					if ($nStatus=='rejected' || $nStatus=='canceled') {
						if ($this->_Obj->getMeta('FKEventID')) {
							$BaseEvt=$this->_frm->getStaticModul('cal');
							$BaseEvt->deleteEvent($this->_Obj->getMeta('FKEventID'));
						}
					}
					if ($oStatus=='confirmed' && $nStatus=='canceled') {
						$this->_BaseAns->restoreAns($this->_Obj->getID());
					}

					if ($this->_Obj->getMeta('FKUserID')!=$this->_frm->getUser()) {
						$this->_frm->sendmessage(array($this->_Obj->getMeta('FKUserID')),$this->_frm->getUser(),$this->_T->lang('[[msg_vac_'.$nStatus.'_'.$actor.']]'),$formGui->getFieldVal('note'),strstr($this->_L->getTempLink(null,array('mode'=>'vac_ant','action'=>'v')),'?'),$this->_T->lang('[[Urlaubsantrag]]'));
					}
					if ($actor=='p' && $nStatus=='approved') {
						$userRules=$this->_BaseDep->getMyRules($this->_Obj->getMeta('FKUserID'));
						if (isset($userRules[0])) {
							$depGS=$this->_BaseDep->getMyUsers($userRules[0],2);
							if (($k=array_search($this->_frm->getUser(),$depGS))!==false) {
								unset($depGS[$k]);
							}
							if (!empty($depGS)) {
								$this->_frm->sendmessage($depGS,$this->_frm->getUser(),$this->_T->lang('[[msg_vac_'.$nStatus.'_'.$actor.']]'),$formGui->getFieldVal('note'),strstr($this->_L->getTempLink(null,array('mode'=>'vac_ant_c','action'=>'v')),'?'),$this->_T->lang('[[Urlaubsantrag]]').': '.$this->_frm->getCachedUserNameAll($this->_Obj->getMeta('FKUserID')));
							}
						}
					}
					if ($actor=='g') {
						$userRules=$this->_BaseDep->getMyRules($this->_Obj->getMeta('FKUserID'));
						if (isset($userRules[0])) {
							$depPL=$this->_BaseDep->getMyUsers($userRules[0],1);
							if (($k=array_search($this->_frm->getUser(),$depPL))!==false) {
								unset($depPL[$k]);
							}
							if (!empty($depPL)) {
								$this->_frm->sendmessage($depPL,$this->_frm->getUser(),$this->_T->lang('[[msg_vac_'.$nStatus.'_'.$actor.']]'),$formGui->getFieldVal('note'),strstr($this->_L->getTempLink(null,array('mode'=>'vac_ant_c','action'=>'v')),'?'),$this->_T->lang('[[Urlaubsantrag]]').': '.$this->_frm->getCachedUserNameAll($this->_Obj->getMeta('FKUserID')));
							}
						}
					}


					$this->_L->unsetParam(array('oid','action'));
					$this->_L->goToLink();
				}
				
			}
		}

		$tplContent=new TemplateGui('core/common_template_2columns.inc.html');
		$tplContent->addContent('form1_1',$tabGui,'FORM1');
		if ($tabGui2) {
			$tplContent->addContent('form2_1',$tabGui2,'FORM2');
		}
		if (!empty($submitValues)) {
			$formGui->setValues('submit',$submitValues);
			$tplContent->addContent('form1_2',$formGui,'FORM1',array(''));
		}
		$Gui->addContent($tplContent);
		return $Gui;
	}	
	function viewVacAnt() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ApplicationListGui.php');

		$Gui=new ContentGui();
		$Gui->setName($this->_T->lang('[[Urlaubsantrag]]'));

		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$tabGui=new ApplicationListGui();

		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Antragsdatum]]'),'','','',1,'');
		$tabGui->addCol('Name',date('d.m.Y',$this->_Obj->getMeta('TimeCreate')),'','','',0,'2000',1,'');
		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Urlaubstyp]]'),'','','',1,'');
		$tmpObj=$this->_BaseType->getObj($this->_Obj->getMeta('FKvacTypeID'),1);
		$tabGui->addCol('Name',$tmpObj?$tmpObj->getName():'','','','',0,'2000',1,'');

		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Status]]'),'','','',1,'');
		$tabGui->addCol('Name',$this->_selStatus[$this->_Obj->getMeta('vacAntStatus')],'','','',0,'2000',1,'');

		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Urlaubsbeginn]]'),'','','',1,'');
		$txt=FrameWork::dateSql('d.m.Y',$this->_Obj->getMeta('vacAntStartDate'));
		$txt.=' '.$this->_selTime[FrameWork::dateSql('H:i',$this->_Obj->getMeta('vacAntStartDate'))];
		$tabGui->addCol('Name',$txt,'','','',0,'2000',1,'');

		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Urlaubsende]]'),'','','',1,'');
		$txt=FrameWork::dateSql('d.m.Y',$this->_Obj->getMeta('vacAntEndDate'));
		$txt.=' '.$this->_selTime[FrameWork::dateSql('H:i',$this->_Obj->getMeta('vacAntEndDate'))];
		$tabGui->addCol('Name',$txt,'','','',0,'2000',1,'');

		$tabGui->addRow(0,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Dauer]]'),'','','',1,'');
		$tabGui->addCol('Name',FrameWork::numberFormat($this->_Obj->getDays(),1).' '.$this->_T->lang('[[Tage]]'),'','','',0,'2000',1,'');
		
		if ($this->_Obj->getMeta('vacAntNote')) {
			$tabGui->addRow(0,'top');
			$tabGui->addCol('Title',$this->_T->lang('[[Bemerkung]]'),'','','',1,'');
			$tabGui->addCol('Name',$this->_Obj->getMeta('vacAntNote'),'','','',0,'2000',1,'');
		}
		
		$tabGui2=false;
		if (in_array($this->_Obj->getMeta('vacAntStatus'),array('processing','approved'))) {
			$tabGui2=new ApplicationListGui();
			$daysA=$this->_BaseAns->getAvailableDays($this->_Obj->getMeta('FKUserID'));
			$daysP=$this->_BaseAnt->getPlanedDays($this->_Obj->getMeta('FKUserID'),$this->_Obj->getID());
			$daysR=$daysA-$daysP-$this->_Obj->getDays();

			$tabGui2->addRow(1,'');
			$tabGui2->addCol('Title',$this->_T->lang('[[Aktueller Resturlaub]]'),'','','',1,'');
			$tabGui2->addCol('Name',FrameWork::numberFormat($daysA,1).' '.$this->_T->lang('[[Tage]]'),'','','',0,'2000',1,'');

			$tabGui2->addRow(0,'');
			$tabGui2->addCol('Title',$this->_T->lang('[[Urlaub in Bearbeitung]]'),'','','',1,'');
			$tabGui2->addCol('Name',FrameWork::numberFormat($daysP,1).' '.$this->_T->lang('[[Tage]]'),'','','',0,'2000',1,'');
		
			$tabGui2->addRow(0,'');
			$tabGui2->addCol('Title',$this->_T->lang('[[Dieser Urlaub]]'),'','','',1,'');
			$tabGui2->addCol('Name',FrameWork::numberFormat($this->_Obj->getDays(),1).' '.$this->_T->lang('[[Tage]]'),'','','',0,'2000',1,'');

			$tabGui2->addRow(1,'',$daysR<0?'#ffff00':'');
			$tabGui2->addCol('Title',$this->_T->lang('[[Berechneter Resturlaub]]'),'','','',1,'');
			$tabGui2->addCol('Name',FrameWork::numberFormat($daysR,1).' '.$this->_T->lang('[[Tage]]'),'','','',0,'2000',1,'');
		}


		if ($this->_mode=='vac_ant') {
			require_once('lib/class_FormGui.php');
			$formGui=new FormGui();
			$formGui->setLabelClass('no','error');
			$key='submit';
			$formGui->addField($key,'submit','','','field_s');
			$formGui->setIptAttribs($key,array('style'=>'margin-top:10px;'));
			$submitValues=array();
			if (in_array($this->_Obj->getMeta('vacAntStatus'),array('processing'))) {
				$submitValues['edit_x']=' '.$this->_T->lang('[[Bearbeiten]]').' ';
				$submitValues['delete_x']=' '.$this->_T->lang('[[Loeschen]]').' ';
				$formGui->setValuesAttribs($key,'delete_x',array('onclick'=>'return lo_form();'));
			}
			if (!empty($submitValues)) {
				$formGui->setValues($key,$submitValues);
				$tabGui->addRow(0,'top');
				$tabGui->addCol('Title',$formGui,'','','',0,'2000',2);
			}
		}

		$tplContent=new TemplateGui('core/common_template_2columns.inc.html');
		$tplContent->addContent('form1',$tabGui,'FORM1');
		if ($tabGui2) $tplContent->addContent('form2',$tabGui2,'FORM2');
		//$tplContent=new TemplateGui('core/common_content_border.inc.html');
		//$tplContent->addContent('content',$tabGui,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	
	function newVacAnt() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_oid) {
			$Gui->setName($this->_T->lang('[[Neuer Eintrag]]'));
		} else {
			$Gui->setName($this->_T->lang('[[Eintrag bearbeiten]]'));
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'|tabVacAnt');
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getVacAntMetaGui());
		}
		$show_tap='meta';
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getVacAntMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		$year=date('Y');



		$default=array();
		if ($this->_Obj) {
			$default['FKUserID']=$this->_Obj->getMeta('FKUserID');
			$default['FKvacTypeID']=$this->_Obj->getMeta('FKvacTypeID');
			$default['vacAntNote']=$this->_Obj->getMeta('vacAntNote');
			$default['vacAntStartDate']=$this->_Obj->getMeta('vacAntStartDate');
			$default['vacAntStartDate_Time']=FrameWork::dateSql('H:i',$default['vacAntStartDate']);
			$default['vacAntEndDate']=$this->_Obj->getMeta('vacAntEndDate');
			$default['vacAntEndDate_Time']=FrameWork::dateSql('H:i',$default['vacAntEndDate']);
		} else {
			$default['vacAntStartDate_Time']='00:00';
			$default['vacAntEndDate_Time']='23:59';
		}
		
		$key='FKvacTypeID';
		$formGui->addField($key,'select',$this->_T->lang('[[Urlaubstyp]]'),$default[$key],'form_fields1');
		$formGui->setValues($key,FrameWork::extractObjName($this->_BaseType->listObj()));
		$formGui->setRequired($key);

		
		$key='vacAntStartDate';
		$formGui->addField($key,'date',$this->_T->lang('[[Urlaubsbeginn]]'),$default[$key],'form_fields1');
		$formGui->setAttribs($key,array('style'=>'width:180px;'));
		$formGui->setIptAttribs($key,array('style'=>'width:200px;float:left;'));
		$formGui->setNoMeta($key);
		$formGui->setRequired($key);
		$key='vacAntStartDate_Time';
		$formGui->addField($key,'select','&nbsp;',$default[$key],'form_fields1');
		$values=$this->_selTime;
		unset($values['23:59']);
		$formGui->setValues($key,$values);
		$formGui->setIptAttribs($key,array('style'=>'width:100px;float:left;clear:none;'));
		$formGui->setAttribs($key,array('style'=>'width:100px;'));
		$formGui->setNoMeta($key);

		$key='vacAntEndDate';
		$formGui->addField($key,'date',$this->_T->lang('[[Urlaubsende]]'),$default[$key],'form_fields1');
		$formGui->setAttribs($key,array('style'=>'width:180px;'));
		$formGui->setIptAttribs($key,array('style'=>'width:200px;float:left;'));
		$formGui->setNoMeta($key);
		$formGui->setRequired($key);
		$key='vacAntEndDate_Time';
		$formGui->addField($key,'select','&nbsp;',$default[$key],'form_fields1');
		$values=$this->_selTime;
		unset($values['00:00']);
		$formGui->setValues($key,$values);
		$formGui->setIptAttribs($key,array('style'=>'width:100px;float:left;clear:none;'));
		$formGui->setAttribs($key,array('style'=>'width:100px;'));
		$formGui->setNoMeta($key);


		$key='vacAntNote';
		$formGui->addField($key,'area',$this->_T->lang('[[Bemerkung]]'),$default[$key],'form_fields2');
		$formGui->setAttribs($key,array('rows'=>'6'));

		$submitVals=array(
			'meta_save_x'=>$this->_T->lang('[[Speichern]]')
		);
		if (Framework::getParam('meta_delete_x','0','P')) {
			$this->_BaseAns->deleteObj($this->_Obj);
			$this->_L->unsetParam('oid');
			$this->_L->setParam('action','b');
			$this->_L->goToLink();
		}
		if (Framework::getParam('meta_save_x','0','P') || Framework::getParam('meta_confirm_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if (!is_object($this->_Obj)) {
					$this->_Obj=new ObjVacAnt();
					$this->_Obj->setMeta('FKUserID',$this->_frm->getUser());
					$this->_Obj->setMeta('vacAntStatus','processing');
				}
				$formGui->addMetaToObj($this->_Obj);

				$dateStart=FrameWork::parseSqlDate(substr($formGui->getFieldVal('vacAntStartDate'),0,10).' '.$formGui->getFieldVal('vacAntStartDate_Time'),true);
				$dateEnd=FrameWork::parseSqlDate(substr($formGui->getFieldVal('vacAntEndDate'),0,10).' '.$formGui->getFieldVal('vacAntEndDate_Time'),true);
				if (!$dateStart || $dateStart < mktime(23,59,59)) {
					$this->_E->setError('fields','vacAntStartDate');
				}
				if (!$dateEnd || $dateEnd<=$dateStart) {
					$this->_E->setError('fields','vacAntEndDate');
				}
				if (!$this->_E->isError()) {
					$this->_Obj->setMeta('vacAntStartDate',date('Y-m-d H:i:s',$dateStart));
					$this->_Obj->setMeta('vacAntEndDate',date('Y-m-d H:i:s',$dateEnd));
					$daysA=$this->_BaseAns->getAvailableDays($this->_Obj->getMeta('FKUserID'));
					$daysP=$this->_BaseAnt->getPlanedDays($this->_Obj->getMeta('FKUserID'),$this->_Obj->getID());
					if (!Framework::getParam('meta_confirm_x','0','P') && ($daysA-$daysP-$this->_Obj->getDays()) < 0) {
						$this->_E->setError('overflow');
						$this->_E->setErrorMsg('overflow',$this->_T->lang('[[Urlaub nicht ausreichend]]'));
						$submitVals=array(
							'meta_break_x'=>$this->_T->lang('[[Abbrechen]]'),
							'meta_confirm_x'=>$this->_T->lang('[[Speichern]]')
						);
					} else {
						$BaseEvt=$this->_frm->getStaticModul('cal');
						$objType=$this->_BaseType->getObj($this->_Obj->getMeta('FKvacTypeID'));
						if ($objType->getMeta('FKCalCatID')) {
							//Provisorischen Termin eintragen;
							if (!$this->_Obj->getMeta('FKEventID') || !($evtObj=$BaseEvt->readEvent($this->_Obj->getMeta('FKEventID')))) {
								$evtObj=array();
							}
							$evtObj["Title"]=$objType->getName();
							$evtObj["OwnerID"]=$this->_Obj->getMeta('FKUserID');
							$evtObj["StartDate"]=FrameWork::parseSqlDate($this->_Obj->getMeta('vacAntStartDate'));
							$evtObj["EndDate"]=FrameWork::parseSqlDate($this->_Obj->getMeta('vacAntEndDate'));
							$evtObj["FKCatID"]=$objType->getMeta('FKCalCatID');
							$evtObj["TimeMode"]=0;
							$evtObj["Unsecure"]=1;
							if (FrameWork::dateSql('H:i',$this->_Obj->getMeta('vacAntStartDate'))=='00:00' && FrameWork::dateSql('H:i',$this->_Obj->getMeta('vacAntEndDate'))=='23:59') {
								$evtObj['TimeMode']=1;
							}
							if ($objType->getMeta('FKCalGrant')) {
								$grantG=array();
								$grantU=array();
								foreach(explode('|',$objType->getMeta('FKCalGrant')) as $v)  {
									if ($v[0]=='u') $grantU[]=substr($v,2);
									if ($v[0]=='g') $grantG[]=substr($v,2);
								}
								$evtObj['GrantGroups']=implode(',',$grantG);
								$evtObj['GrantUsers']=implode(',',$grantU);
							}
							if ($evtObj["EventID"]) {
								$BaseEvt->updateEvent($evtObj["EventID"],$evtObj);
							} else {
								$this->_Obj->setMeta('FKEventID',$BaseEvt->saveEvent($evtObj));
							}
						} elseif($this->_Obj->getMeta('FKEventID')) {
							$BaseEvt->deleteEvent($this->_Obj->getMeta('FKEventID'));
							$this->_Obj->setMeta('FKEventID',0);
						}
						if ($this->_oid) {
							$this->_BaseAnt->updateObj($this->_Obj);
							$this->_L->unsetParam('oid');
						} else {
							$this->_oid=$this->_BaseAnt->insertObj($this->_Obj);
							$userRules=$this->_BaseDep->getMyRules($this->_Obj->getMeta('FKUserID'));
							if (isset($userRules[0])) {
								$depPL=$this->_BaseDep->getMyUsers($userRules[0],1);
								if (($k=array_search($this->_frm->getUser(),$depPL))!==false) {
									unset($depPL[$k]);
								}
								if (!empty($depPL)) {
									$this->_frm->sendmessage($depPL,$this->_frm->getUser(),$this->_T->lang('[[msg_vac_new_u]]'),$this->_Obj->getMeta('vacAntNote'),strstr($this->_L->getTempLink(null,array('mode'=>'vac_ant_c','action'=>'v','oid'=>$this->_Obj->getID())),'?'),$this->_T->lang('[[Urlaubsantrag]]').': '.$this->_frm->getCachedUserNameAll($this->_Obj->getMeta('FKUserID')));
								}
							}
						}
						$this->_L->setParam('action','b');
						$this->_L->goToLink();
					}
				}
			} else {

				
			}
		}
		
		$key='submit';
		$formGui->addField($key,'submit','','','form_submit');
		$formGui->setValues($key,$submitVals);
		
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}
	
	function listVacAns() {
		require_once('lib/class_ApplicationListGui.php');
		$Gui=new ApplicationListGui();
		$Gui->setRowClass(array(0=>'list_l',1=>'list_h',2=>'list_s',3=>'list_hb',4=>'list_b'));
		$Gui->setName($this->_T->lang('[[Urlaubsanspruch]]'));
		
				//debug($entries);
		$Gui->addHeaderCol('Name',$this->_T->lang('[[Jahr]]'),'','','',1);
		$Gui->addHeaderCol('VacDays',$this->_T->lang('[[Resturlaub]]'),'','','',1);
		$Gui->addHeaderCol('VacExpires',$this->_T->lang('[[Verfallsdatum]]'),'','','',1);
		$Gui->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','right',0,2000);
		$Gui->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);

		$entries=$this->_BaseAns->listAns();
		$users=$this->_frm->getCachedUserNameAll(array_merge($this->_ruleUsers[1],$this->_ruleUsers[2]));
		$year=date('Y');
		foreach ($users as $key=>$val) {
			$Gui->addRow(3,'top');
			$Gui->addCol('Name',$val,'',$this->_L->getTempLink(null,array('_FKUserID'=>$key,'action'=>'n')),'',0,2000,5);
			$hl=0;
			if (!isset($entries[$key]) || !$entries[$key][$year]) {
				$Gui->addRow(0,'top');
				$Gui->addCol('vacAnsYear',$year,'',$this->_L->getTempLink(null,array('_FKUserID'=>$key,'_vacAnsYear'=>$year,'action'=>'n','')),'',1);
				$Gui->addCol('vacAnsDays',0,'','','',1);
				$Gui->addCol('vacAnsExpires','','','','',1);
				$Gui->addCol('TimeModify','','','','',0);
				$Gui->addCol('UserModify','','','','',1);
			}
			if (isset($entries[$key])) {
				foreach($entries[$key] as $obj) {
					$color='';
					if ($obj->getMeta('vacAnsDays') && $obj->getMeta('vacAnsExpires')!='0000-00-00') {
						$timeExp=FrameWork::parseSqlDate($obj->getMeta('vacAnsExpires'));
						if ($timeExp<time()) {
							$color='#ff9e9e';
						} elseif ($timeExp<time()+30*3600*24) {
							$color='#ffff00';
						}
					}
					$Gui->addRow(0,'top',$color);
					$Gui->addCol('vacAnsYear',$obj->getMeta('vacAnsYear'),'',$this->_L->getTempLink(null,array('oid'=>$obj->getID(),'action'=>'n','')),'right',1);
					$Gui->addCol('vacAnsDays',FrameWork::numberFormat($obj->getMeta('vacAnsDays'),1),'','','right',1);
					$Gui->addCol('vacAnsExpires',$obj->getMeta('vacAnsExpires')!='0000-00-00'?FrameWork::dateSql('d.m.Y',$obj->getMeta('vacAnsExpires')):'','','','right',1);
					$Gui->addCol('TimeModify',$obj->getMeta('TimeModify')?date('d.m.Y',$obj->getMeta('TimeModify')):'','','','right',0);
					$Gui->addCol('UserModify',$obj->getMeta('UserModify')?$this->_frm->getCachedUserNameAll($obj->getMeta('UserModify')):'','','','',1);
				}
			}
		}
		return $Gui;
	}
	function newVacAns() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_oid) {
			$Gui->setName($this->_T->lang('[[Neuer Eintrag]]'));
		} else {
			$Gui->setName($this->_T->lang('[[Eintrag bearbeiten]]'));
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'|tabVacAns');
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getVacAnsMetaGui());
		}
		$show_tap='meta';
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getVacAnsMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		$year=date('Y');
				


		$default=array();
		if ($this->_Obj) {
			$default['FKUserID']=$this->_Obj->getMeta('FKUserID');
			$default['vacAnsYear']=$this->_Obj->getMeta('vacAnsYear');
			$default['vacAnsDays']=$this->_Obj->getMeta('vacAnsDays');
			$default['vacAnsExpires']=$this->_Obj->getMeta('vacAnsExpires');
		} else {
			$default['FKUserID']=FrameWork::getParam('_FKUserID',0);
			$default['vacAnsYear']=FrameWork::getParam('_vacAnsYear',date('Y'));
			$default['vacAnsDays']=0;
			$default['vacAnsExpires']='';
		}
		$key='FKUserID';
		$formGui->addField($key,'select',$this->_T->lang('[[BenutzerIn]]'),$default[$key],'form_fields1');
		$formGui->setValues($key,array(0=>'-') + $this->_frm->getCachedUserNameAll(array_merge($this->_ruleUsers[1],$this->_ruleUsers[2])));
		$formGui->setRequired($key);
		$key='vacAnsYear';
		$values=array();
		for($i=min($year-1,$default[$key]);$i<=max($year+1,$default[$key]);$i++) {
			$values[$i]=$i;
		}
		$formGui->addField($key,'select',$this->_T->lang('[[Jahr]]'),$default[$key],'form_fields1');
		$formGui->setValues($key,$values);
		$formGui->setRequired($key);
		$key='vacAnsDays';
		$formGui->addField($key,'curr',$this->_T->lang('[[Resturlaub]]'),$default[$key],'form_fields1');
		$formGui->setRequired($key);
		$key='vacAnsExpires';
		$formGui->addField($key,'date',$this->_T->lang('[[Verfallsdatum]]'),$default[$key],'form_fields1');



		$key='submit';
		$submitVals=array(
			'meta_save_x'=>$this->_T->lang('[[Speichern]]')
		);
		$formGui->addField($key,'submit','','','form_submit');
		$formGui->setValues($key,$submitVals);

		if (Framework::getParam('meta_delete_x','0','P')) {
			$this->_BaseAns->deleteObj($this->_Obj);
			$this->_L->unsetParam('oid');
			$this->_L->setParam('action','b');
			$this->_L->goToLink();
		}
		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if (!is_object($this->_Obj)) {
					$this->_Obj=new ObjVacAns();
				}
				$formGui->addMetaToObj($this->_Obj);
				if ($this->_BaseAns->existsObj($this->_Obj)) {
					$this->_E->setError('exists');
					$this->_E->setErrorMsg('exists',$this->_T->lang('[[error_entry_exists]]'));
				} else {
					if ($this->_oid) {
						$this->_BaseAns->updateObj($this->_Obj);
						$this->_L->unsetParam('oid');
					} else {
						$this->_oid=$this->_BaseAns->insertObj($this->_Obj);
					}
					$this->_L->setParam('action','b');
					$this->_L->goToLink();
				}
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}
	function getObjActionGui($action) {
		require_once('lib/class_FunctionObjActionGui.php');
		$objActionGui=new FunctionObjActionGui();
		switch($action) {
			case 'vac_ans':
				$objActionGui->addValue('new',$this->_T->lang('[[Neuer Eintrag]]'));
				if ($this->_Obj) {
					$objActionGui->addValue('info_0','----------------------');
					$objActionGui->addValue('delete',$this->_T->lang('[[Eintrag loeschen]]'));
				}
			break;
			case 'vac_ant':
				$objActionGui->addValue('new',$this->_T->lang('[[Neuer Eintrag]]'));
			break;
		}
		return $objActionGui;
	}


	function setPrefs($key,$val) {
		$this->_Base->setPrefs($key,$val);
	}
	function getPrefs($key,$default= null) {
		return $this->_Base->getPrefs($key,$default);
	}
}
?>