<?php
class ExcelExport {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	function ExcelExport() {
		global $frm,$T,$E,$L,$P,$Y;
		$this->_Base=& $frm->getStaticModul('zef');
		$this->_T=&$T;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_P=&$P;
		$this->_T->loadModul('zef');
		require_once("lib/class_WriteExcel.inc.php");
		$this->_tmp_file=tempnam(Framework::getTempPath(),'xls');
		$this->_Excel =& new writeexcel_workbook($this->_tmp_file);
		$this->_format['date'][0] =& $this->_Excel->addformat(array('num_format' => 'dd.mm.YYYY'));
		$this->_format['date'][1] =& $this->_Excel->addformat(array('num_format' => 'dd.mm.YYYY','bg_color' =>'aqua'));
		$this->_format['bold'][0] =& $this->_Excel->addFormat(array('bold' => 1));
		$this->_format['bold'][1] =& $this->_Excel->addFormat(array('bold' => 1,'bg_color' =>'aqua'));
		$this->_format['curr'][0] =& $this->_Excel->addFormat(array('num_format' => '##,#0.00'));
		$this->_format['curr'][1] =& $this->_Excel->addFormat(array('num_format' => '##,#0.00','bg_color' =>'aqua'));
		$this->_format['normal'][0] =& $this->_Excel->addFormat(array('bold' => 0));
		$this->_format['normal'][1] =& $this->_Excel->addFormat(array('bold' => 0,'bg_color' =>'aqua'));

	}
	function dump($fname) {
		$this->_Excel->close();
		Framework::dumpFile($this->_tmp_file,$fname,'application/x-msexcel',true);
	}
	function init($config) {
		$this->_config=$config;
		$this->_expFields['zef']=array();
		$this->_expFields['zef']['zefID']=array(
				'Title'=>'ID',
				'Typ'=>'Num',
			);
		$this->_expFields['zef']['zefBegin']=array(
				'Title'=>$this->_T->lang('[[Datum]]'),
				'Typ'=>'Date',
			);
		$this->_expFields['zef']['zefUser']=array(
				'Title'=>$this->_T->lang('[[BenutzerIn]]'),
				'Typ'=>'User',
			);
		if ($this->_Base->getCfg('cfg/modul/company')) {
			$this->_expFields['zef']['FKcompID']=array(
					'Title'=>$this->_T->lang('[[Firma]]'),
					'Typ'=>'Comp',
				);
		}
		$this->_expFields['zef']['FKzefCatID']=array(
				'Title'=>$this->_T->lang('[[Taetigkeit]]'),
				'Typ'=>'Cat',
			);
		$this->_expFields['zef']['FKzefPrjID']=array(
				'Title'=>$this->_T->lang('[[Projekt]]'),
				'Typ'=>'Prj',
			);
		$this->_expFields['zef']['zefDescription']=array(
				'Title'=>$this->_T->lang('[[Beschreibung]]'),
				'Typ'=>'Text',
			);
		$this->_expFields['zef']['zefDuration']=array(
				'Title'=>$this->_T->lang('[[Stunden]]'),
				'Typ'=>'Hour',
			);


		if ($this->_config['zef']['showEmpl']) {
			$this->_expFields['zef']['zefCosts']=array(
					'Title'=>$this->_T->lang('[[Stundensatz]]'),
					'Typ'=>'Curr',
				);
			$this->_expFields['zef']['zefCostsCalc']=array(
					'Title'=>$this->_T->lang('[[zefKosten]]'),
					'Typ'=>'Cost',
				);
		}
		if ($this->_config['zef']['showExp']) {
			$this->_expFields['zef']['costSum']=array(
					'Title'=>$this->_T->lang('[[Spesen]]'),
					'Typ'=>'Curr',
				);
		}
		if ($this->_config['zef']['showDeref']) {
			$this->_expFields['zef']['Derefed']=array(
					'Title'=>$this->_T->lang('[[Verrechnung]]'),
					'Typ'=>'Deref',
				);
			$this->_expFields['zef']['FKzefDerefID']=array(
					'Title'=>$this->_T->lang('[[Referenz]]'),
					'Typ'=>'Num',
				);
			$this->_expFields['zef']['zefMoveDate']=array(
					'Title'=>$this->_T->lang('[[Verrechnen am]]'),
					'Typ'=>'Date',
				);
		}

		$this->_expFields['exp']=array(
			'FKzefID'=>array(
				'Title'=>$this->_T->lang('[[Referenz]]'),
				'Typ'=>'Num',
			),
			'Name'=>array(
				'Title'=>$this->_T->lang('[[Spesenart]]'),
				'Typ'=>'Text',
			),
			'costDesc'=>array(
				'Title'=>$this->_T->lang('[[Beschreibung]]'),
				'Typ'=>'Text',
			),
			'costValue'=>array(
				'Title'=>$this->_T->lang('[[Menge]]'),
				'Typ'=>'Num',
			),
			'FKcostTabID'=>array(
				'Title'=>$this->_T->lang('[[Einheit]]'),
				'Typ'=>'cUnit',
			),
			'costCalc'=>array(
				'Title'=>$this->_T->lang('[[Spesen]]'),
				'Typ'=>'Curr',
			),
		);
		if ($this->_config['exp']['showExpCfg']) {
			$this->_expFields['exp']['FKUseCosts']=array(
				'Title'=>$this->_T->lang('[[Spesenabrechung]]'),
				'Typ'=>'YN',
			);
			$this->_expFields['exp']['FKUseDeref']=array(
				'Title'=>$this->_T->lang('[[Weiterverechnen]]'),
				'Typ'=>'YN',
			);
		}


	}
	function addSheet(&$entries,$Typ='zef',$sheetName='Sheet') {
		$worksheet=& $this->_Excel->addworksheet(Framework::convertCharset($sheetName,GE_CHARSET,$this->_config['Charset']));

		$rowNum=0;$colNum=0;
		foreach ($this->_expFields[$Typ] as $key=>$val) {
			//debug($val);
			$worksheet->write($rowNum,$colNum,Framework::convertCharset($val['Title'],GE_CHARSET,$this->_config['Charset']),$this->_format['bold'][0]);
			$colNum++;
		}
		$rowNum++;
		foreach ($entries as $Row=>$Col) {
			$colNum=0;
			if ($this->_config[$Typ]['showMove'] && $Col['zefMoveDate']!='0000-00-00') {
				$hl=1;
			} else {
				$hl=0;
			}

			//if ($rowNum>5) $worksheet->set_row($rowNum,Null,$hlFormat);
			foreach ($this->_expFields[$Typ] as $key=>$val) {
				switch ($val['Typ']) {
					case 'Date':
						if ($Col[$key]!='0000-00-00') {
							$xlsDate=$this->_Excel->xl_date_list(Framework::dateSql('Y',$Col[$key]), Framework::dateSql('m',$Col[$key]),Framework::dateSql('d',$Col[$key]));
							$worksheet->write($rowNum,$colNum,$xlsDate, $this->_format['date'][$hl]);
						}
					break;
					case 'User':
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($this->_frm->getCachedUserName($Col[$key]),GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);
					break;
					case 'Comp':
						if ($Col[$key]==-1) {
							$name=$this->_T->lang('[[FIRMENUEBERGREIFEND]]');
						} elseif ($Col[$key]) {
							$name=$this->_Base->getCachedCompanyName($Col[$key]);
						} else {
							$name='-';
						}
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($name,GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);
					break;
					case 'Cat':
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($this->_Base->getCachedCatName($Col[$key]),GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);
					break;
					case 'Prj':
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($this->_Base->getCachedPrjName($Col[$key]),GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);
					break;
					case 'Text':
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($Col[$key],GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);
					break;
					case 'Hour':
						$worksheet->write($rowNum,$colNum,$Col[$key]/3600,$this->_format['normal'][$hl]);
					break;
					case 'Cost':
						$worksheet->write($rowNum,$colNum,$Col['zefCosts']*$Col['zefDuration']/3600,$this->_format['curr'][$hl]);
					break;
					case 'Curr':
						$worksheet->write($rowNum,$colNum,$Col[$key],$this->_format['curr'][$hl]);
					break;
					case 'Num':
						$worksheet->write($rowNum,$colNum,$Col[$key],$this->_format['normal'][$hl]);
					break;
					case 'YN':
						$worksheet->write($rowNum,$colNum,$Col[$key]?$this->_T->lang('[[Ja]]'):$this->_T->lang('[[Nein]]'),$this->_format['normal'][$hl]);
					break;
					case 'Deref':
						$worksheet->write($rowNum,$colNum,$Col['FKzefDerefID']?$this->_T->lang('[[Umlage]]'):$this->_T->lang('[[Direkt]]'),$this->_format['normal'][$hl]);
					break;
					case 'cUnit':
						//;
						if ($Col['FKcostTabID']) {
							if (!isset($tabObj[$Col['FKcostTabID']])) {
								$tabObj[$Col['FKcostTabID']]=$this->_Base->readExpensesTable($Col['FKcostTabID']);
							}
							//debug($tabObj[$Col['FKcostTabID']]);
							if ($tabObj[$Col['FKcostTabID']]['tabTyp']==2) {
								if (!isset($tabEntry[$Col['FKcostEntryID']])) {
									$tabEntry[$Col['FKcostEntryID']]=$this->_Base->readExpensesEntry($Col['FKcostEntryID']);
								}
								$Unit=$tabEntry[$Col['FKcostEntryID']]['Unit'];
							} else {
								$Unit=$tabObj[$Col['FKcostTabID']]['tabUnit'];
							}
						} else {
							$Unit='';
						}
						//debug(Framework::convertCharset($Unit,GE_CHARSET,$this->_config['Charset']));
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($Unit,GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);

					break;
					default:
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($Col[$key],GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);
					break;


				}
				$colNum++;
			}
			$rowNum++;
		}
	}
}
?>