<?php
class ZefPrintGui {
	var $_Base;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	function ZefPrintGui() {
		global $frm,$t,$T,$E,$L;
		$this->_BaseTpl=& $frm->getStaticModul('print_tpl');
		$this->_Base=& $frm->getStaticModul('zef');
		$this->_BaseRes=$frm->getStaticModul('cal_res');
		if ($this->_Base->getUser()!=$this->_BaseRes->getUser()) {
			$this->_BaseRes->initUser($this->_Base->getUser());
		}
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
	}
	function printList(&$entries,&$allExpenses,$tplID=0,$Config) {
		$Config['Currency']=$this->_Base->getCfg('cfg/currency');
		$tplPrint=$this->getPrintTemplate('list_'.$Config['View'],$tplID);
		require_once('lib/class_MySmartyGui.php');
		$Gui=new MySmartyGui();
		$Gui->assign('zef_User',$this->_Base->getUser());
		$Gui->assign('zef_Title',$this->getTitles());
		$Gui->assign('zef_Config',$Config);
		$entriesSum=array();
		$entriesView=$this->formatEntries($entries);
		$expensesView=$this->formatExpenses($allExpenses);
		//debug($entriesView);

		$Gui->assign('zef_Entries',$entriesView);
		$Gui->assign('zef_Expenses',$expensesView);
		$Gui->display($tplPrint);
		exit;
	}
	function printGroup(&$entries,$tplID=0,$Config) {
		$Config['Currency']=$this->_Base->getCfg('cfg/currency');
		$tplPrint=$this->getPrintTemplate('list_'.$Config['View'],$tplID);
		require_once('lib/class_MySmartyGui.php');
		$Gui=new MySmartyGui();
		$Gui->assign('zef_User',$this->_Base->getUser());
		$Gui->assign('zef_Title',$this->getTitles());
		$entriesSum=array();
		$entriesView=$this->formatGroup($entries,$Config);
		$Gui->assign('zef_Config',$Config);
		$Gui->assign('zef_Entries',$entriesView);
		$Gui->display($tplPrint);
		exit;
	}
	function printPresenz(&$entries,&$entriesSum,$tplID=0,$Config) {
		$Config['Currency']=$this->_Base->getCfg('cfg/currency');
		$tplPrint=$this->getPrintTemplate('pres_v',$tplID);
		require_once('lib/class_MySmartyGui.php');
		$Gui=new MySmartyGui();
		$Gui->assign('zef_User',$this->_Base->getUser());
		$Gui->assign('zef_Title',$this->getTitles());
		$Gui->assign('zef_Config',$Config);
		$Gui->assign('zef_Entries',$entries);
		$Gui->assign('zef_EntriesSum',$entriesSum);
		$entriesSum=array();
		$Gui->display($tplPrint);
		exit;
	}
	function printExpenses(&$entries,&$entriesSum,$tplID=0,$Config) {
		$Config['Currency']=$this->_Base->getCfg('cfg/currency');
		$tplPrint=$this->getPrintTemplate('cost_v',$tplID);
		require_once('lib/class_MySmartyGui.php');
		$Gui=new MySmartyGui();
		$Gui->assign('zef_User',$this->_Base->getUser());
		$Gui->assign('zef_Title',$this->getTitles());
		$Gui->assign('zef_Config',$Config);
		$Gui->assign('zef_Entries',$entries);
		$Gui->assign('zef_EntriesSum',$entriesSum);
		$entriesSum=array();
		$Gui->display($tplPrint);
		exit;
	}
	function formatGroup(&$entries,&$Config) {
		$result=array();
		$i=0;
		foreach ($entries as $val) {
			$result[$i]=array(
				'DurationSum'=>$val['hourSum'],
				'EmployeesCostsSum'=>$val['emplSum'],
				'ExpensesSum'=>$val['costSum'],
			);
			if (isset($val['zefUser'])) {
				$result[$i]['User']=$this->_frm->getCachedUserName($val['zefUser'],2,1);
				$result[$i]['UserID']=$val['zefUser'];
			}
			if (isset($val['FKzefPrjID'])) {
				$result[$i]['Project']=$this->_Base->getCachedPrjName($val['FKzefPrjID']);
				$result[$i]['ProjectID']=$val['FKzefPrjID'];
			}
			if (isset($val['FKzefCatID'])) {
				$result[$i]['Category']=$this->_Base->getCachedcatName($val['FKzefCatID']);
				$result[$i]['CategoryID']=$val['FKzefCatID'];
			}
			if (isset($val['FKcompID'])) {
				$result[$i]['Company']=$val['FKcompID']?($val['FKcompID']==-1?$this->_T->lang('[[FIRMENUEBERGREIFEND]]'):$this->_Base->getCachedCompanyName($val['FKcompID'])):'';
				$result[$i]['CompanyID']=$val['FKcompID'];
			}
			if (isset($val['FKCalResID'])) {
				$result[$i]['Resource']=$val['FKCalResID']?$this->_BaseRes->getCachedName($val['FKCalResID']):'-';
				$result[$i]['ResourceID']=$val['FKCalResID'];
			}
			if ($Config['View']=='s') {
				if (!isset($prjCat[$val['FKzefPrjID']])) {
					$prjCat[$val['FKzefPrjID']]=$this->_Base->listPrjCat($val['FKzefPrjID']);
				}
				$result[$i]['SollSum']=intval($prjCat[$val['FKzefPrjID']][$val['FKzefCatID']]['soll']*3600);
				$Config['dataSum']['SollSum']+=intval($prjCat[$val['FKzefPrjID']][$val['FKzefCatID']]['soll']*3600);
			}
			$i++;
		}
		return $result;
	}
	function formatEntries(&$entries) {
		$result=array();
		foreach ($entries as $key=>$val) {
			$result[$key]=array(
				'DateStart'=>$val['zefBegin'],
				'DateEnd'=>$val['zefEnd'],
				'User'=>$this->_frm->getCachedUserName($val['zefUser'],2,1),
				'UserID'=>$val['zefUser'],
				'Project'=>$this->_Base->getCachedPrjName($val['FKzefPrjID']),
				'ProjectID'=>$val['FKzefPrjID'],
				'Category'=>$this->_Base->getCachedcatName($val['FKzefCatID']),
				'CategoryID'=>$val['FKzefCatID'],
				'Duration'=>$val['zefDuration'],
				'Company'=>$val['FKcompID']?($val['FKcompID']==-1?$this->_T->lang('[[FIRMENUEBERGREIFEND]]'):$this->_Base->getCachedCompanyName($val['FKcompID'])):'',
				'CompanyID'=>$val['FKcompID'],
				'Resource'=>$val['FKCalResID']?$this->_BaseRes->getCachedName($val['FKCalResID']):'',
				'ResourceID'=>$val['FKCalResID'],
				'Correction'=>$val['zefCorrection'],
				'EmployeesCosts'=>$val['zefCosts']*$val['zefDuration']/3600,
				'Expenses'=>$val['costSum'],
				'Description'=>$val['zefDescription'],
				'Charged'=>$val['zefCharged'],
			);
		}
		return $result;
	}
	function formatExpenses(&$allExpenses) {
		$result=array();
		foreach ($allExpenses as $val) {
			$result[$val['FKzefID']][]=array(
				'Name'=>$val['Name'],
				'Value'=>$val['costValue'],
				'Calc'=>$val['costCalc'],
				'Desc'=>$val['costDesc'],
			);
		}
		return $result;
	}
	function getTitles() {
		return array(
			'DateStart'=>$this->_T->lang('[[Datum]]'),
			'DateEnd'=>$this->_T->lang('[[Datum]]'),
			'User'=>$this->_T->lang('[[MitarbeiterIn]]'),
			'Description'=>$this->_T->lang('[[Beschreibung]]'),
			'Project'=>$this->_T->lang('[[Projekt]]'),
			'Category'=>$this->_T->lang('[[Taetigkeit]]'),
			'Duration'=>$this->_T->lang('[[Dauer]]'),
			'Hours'=>$this->_T->lang('[[Stunden]]'),
			'Company'=>$this->_T->lang('[[Firma]]'),
			'Resource'=>$this->_T->lang('[[Resource]]'),
			'Correction'=>$this->_T->lang('[[Korrektur]]'),
			'EmployeesCosts'=>$this->_T->lang('[[zefKosten]]'),
			'Expenses'=>$this->_T->lang('[[Spesen]]'),
			'Soll'=>$this->_T->lang('[[Soll]]'),
			'Charged'=>$this->_T->lang('[[Verrechnet]]'),
		);
	}
	function getPrintTemplate($Typ,$tplID=0) {
		if ($tplID) {
			$tplPrint=realpath($this->_BaseTpl->getPrintTemplate($tplID,1));
		} else {
			switch ($Typ) {
				case 'list_l':
					$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/zef/utf8.print_list_l.inc.html';
				break;
				case 'list_g':
					$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/zef/utf8.print_list_g.inc.html';
				break;
				case 'list_s':
					$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/zef/utf8.print_list_s.inc.html';
				break;
				case 'list_d':
					$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/zef/utf8.print_list_d.inc.html';
				break;
				case 'pres_v':
					$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/zef/utf8.print_pres_v.inc.html';
				break;
				case 'cost_v':
					$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/zef/utf8.print_cost_v.inc.html';
				break;
			}
		}
		//debug($tplPrint);
		return realpath($tplPrint);
	}
}
?>