<?php
class zefProjectGui {
	var $_Base;
	var $_Obj;
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	var $_projID=0;
	var $_projObj=false;
	function zefProjectGui() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_T=&$T;
		$this->_T->loadModul('zef');
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_Base=$frm->getStaticModul('zef');
		$this->_Perms=array(
				1=>$this->_T->lang('[[zef_Erstellen]]'),
				4=>$this->_T->lang('[[zef_Auswerten]]'),
		);
		$this->_search=array();
	}
	function _handleRequest() {
		$this->_action=Framework::getParam('action','pj','G');
		$this->_oid=Framework::getParam('zefPrjID',0,'G');
		if ($this->_oid) {
			$this->_Obj=$this->_Base->readPrj($this->_oid);
			if ($this->_P && ($this->_projObj=$this->_P->isProjectZefFolder($this->_oid))) {
				$this->_projID=$this->_projObj->getID();
			}
		}
		if (Framework::getParam('zef_prjsearch')) {
			Framework::importParam(array('zef_prjsearch'=>Framework::getParam('zef_prjsearch')),'P');
			$this->_L->setParam('zef_prjsearch',Framework::getParam('zef_prjsearch'));
			$this->_search['info']=Framework::getParam('zef_prjsearch');
		}
		if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
			switch (Framework::getParam('obj_action_val','0','P')) {
				case 'new':
					$this->_L->unsetParam('zefPrjID');
					$this->_L->goToLink();
				break;
				case 'delete':
					if ($this->_oid) {
						if ($this->_Base->deletePrj($this->_oid)) {
							$this->_L->unsetParam('zefPrjID');
							$this->_L->goToLink();
						}
					}
				break;
				case 'copy':
					$this->_L->unsetParam('zefPrjID');
					$this->_L->setParam('_cpPrjID',$this->_oid);
					$this->_L->goToLink();
				break;
				default:
					//debug(Framework::getParam('obj_action_val','0','P'));
			}
		}
	}
	function process($handle='') {
		require_once('lib/class_TemplateGui.php');
		$Gui=new TemplateGui('core/common_form.inc.html');
		$this->_handleRequest();
		switch ($this->_action) {
			case 'pj':
				$Gui->addContent('cont1',$this->showEditProjectGui(),'CONTENT');
				$Gui->addContent('cont2',$this->showProjectList($this->_search),'CONTENT');
			break;
		}
		$Gui->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
		return $Gui->process();
	}
	function &showEditProjectGui() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_TemplateGui.php');
		$ContGui=new ContentGui();
		$sParams=array('Modul'=>'zef_prjsearch','Label'=>$this->_T->lang('[[Suche]]').': ','UrlParams'=>array('fieldID'=>'cont2','Link'=>$this->_L->getLink()));
		$btAjaxSearch=new FunctionButtons('zef_prjsearch','ajaxsearch',$sParams);
		$ContGui->addFunction($btAjaxSearch);
		$objActionGui=new FunctionObjActionGui();
		$obj_action=$this->_frm->getObjAction($this->_Base->getModul(),'prj');
		foreach ($obj_action as $key=>$val) {
			if ($val['Hidden']) continue;
			if (in_array('ID',$val['Extra']) && !$this->_oid) continue;
			if (in_array('empty',$val['Extra']) && $this->_oid && $this->_Base->isUsedPrj($this->_oid)) continue;
			//print_r($val);
			$objActionGui->addValue($key,$val['Name']);
		}
		$ContGui->addFunction($objActionGui);
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('zefPrjID'))));
		$ContGui->addFunction($btBreak);
		$box=new BoxGui('zef|showtab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('showtab'));
		$tabs=array();
		$tabs[]='meta';
		if ($this->_oid) {
			$ContGui->setName($this->_T->lang('[[Projekt bearbeiten]]').': '.$this->_Obj['zefName']);
			$tabs[]='perms';
			$tabs[]='cat';
			if ($this->_Base->getCfg('cfg/modul/company')) $tabs[]='comp';

		} else {
			if (Framework::getParam('_cpPrjID',0,'G') || Framework::getParam('cpPrjID',0,'P')) {
				$ContGui->setName($this->_T->lang('[[Projekt kopieren]]'));
			} else {
				$ContGui->setName($this->_T->lang('[[Neues Projekt anlegen]]'));
			}
		}

		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getMetaGui());
		}
		if (in_array('perms',$tabs)) {
			$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
			$box->setTabContent('perms',$this->getPermissionsGui());
		}
		if (in_array('cat',$tabs)) {
			$box->addTab('cat',$this->_T->lang('[[Taetigkeiten]]'),'#',true);
			$box->setTabContent('cat',$this->getProjCatGui($this->_oid));
		}
		if (in_array('comp',$tabs)) {
			require_once('lib/zef/class_zefAdminGui.php');
			$admGui=new zefAdminGui();
			$result='';
			$box->addTab('comp',$this->_T->lang('[[Aufteilung]]'),'#',true);
			$box->setTabContent('comp',$admGui->getCompanyCalcGui($result,$this->_oid,'prj'));
			if ($result=='ok') {
				$this->_L->unsetParam('zefPrjID');
				$this->_L->goToLink();
			}
		}
		$show_tap=$this->getPrefs('showtab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));

		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tplContent->addContent('content',$box,'CONTENT');
		$ContGui->addContent($tplContent);
		return $ContGui;
	}
	function &getMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		$formGui=new FormGui();
		$key='zefName';
		$formGui->addField($key,'text',$this->_T->lang('[[Bezeichnung]]'),$this->_Obj?$this->_Obj[$key]:'','form');
		$formGui->setRequired($key);
		$key='zefAktiv';
		$formGui->addField($key,'check',$this->_T->lang('[[Aktiv]]'),$this->_Obj?$this->_Obj[$key]:1,'form');
		$key='cpPrjID';
		$formGui->addField($key,'hidden','',Framework::getParam('_cpPrjID',0,'G'),'form');
		$formGui->setNoMeta($key);
		$key='meta_save_x';
		$formGui->addField($key,'submit','',$this->_T->lang('[[Speichern]]'),'form');

		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if (!$this->_oid) {
					$this->_Obj=array(
						'zefTimeCreate'=>time(),
						'zefUserCreate'=>$this->_frm->getUser(),
					);
					if ($formGui->getFieldVal('cpPrjID')) {
						$cpObj=$this->_Base->readPrj($formGui->getFieldVal('cpPrjID'));
						$this->_Obj['PermsUser']=$cpObj['PermsUser'];
						$this->_Obj['PermsGroup']=$cpObj['PermsGroup'];
					}
				}
				if (!$formGui->getFieldVal('zefAktiv') && ($this->_Obj['zefAktiv'] || !$this->_oid)) {
					$this->_Obj['zefTimeAktiv']=time();
					$this->_Obj['zefUserAktiv']=$this->_frm->getUser();
				}
				$formGui->addMetaToArray($this->_Obj);
				if ($this->_oid) {
					$this->_Base->updatePrj($this->_oid,$this->_Obj);
					$this->_L->unsetParam('zefPrjID');
				} else {
					$oid=$this->_Base->insertPrj($this->_Obj);
					$this->_L->setParam(array('zefPrjID'=>$oid,'_clTab'=>'perms'));
				}
				$this->_L->goToLink();
			}
		}
		return $formGui;

	}
	function getPermissionsGui($perm_mode=1) {
		$perms_g=Framework::aclToArray($this->_Obj['PermsGroup']);
		$perms_u=Framework::aclToArray($this->_Obj['PermsUser']);
		$update=false;
		if (Framework::getParam('perms_add',0,'P') && Framework::getParam('addPermsID',0,'P')) {
			if (Framework::getParam('addFKGroupID',0,'P')) {
				if ($perm_mode) {
					$perms_g[Framework::getParam('addFKGroupID',0,'P')]=array_sum(Framework::getParam('addPermsID',0,'P'));
				} else {
					$perms_g[Framework::getParam('addFKGroupID',0,'P')]=Framework::getParam('addPermsID',0,'P');
				}
				$this->_Obj['PermsGroup']=Framework::arrayToAcl($perms_g);
				$update=true;
			}
			if (Framework::getParam('addFKUserID',0,'P')) {
				if ($perm_mode) {
					$perms_u[Framework::getParam('addFKUserID',0,'P')]=array_sum(Framework::getParam('addPermsID',0,'P'));
				} else {
					$perms_u[Framework::getParam('addFKUserID',0,'P')]=Framework::getParam('addPermsID',0,'P');
				}
				$this->_Obj['PermsUser']=Framework::arrayToAcl($perms_u);
				$update=true;
			}
		}
		if(is_array(Framework::getParam('permDeleteG_x',0,'P'))) {
			$tmp=Framework::getParam('permDeleteG_x',0,'P');
			$key=key($tmp);
			if ($key) {
				unset($perms_g[$key]);
				$this->_Obj['PermsGroup']=Framework::arrayToAcl($perms_g);
				$update=true;
			}
		}
		if(is_array(Framework::getParam('permDeleteU_x',0,'P'))) {
			$tmp=Framework::getParam('permDeleteU_x',0,'P');
			$key=key($tmp);
			if ($key) {
				unset($perms_u[$key]);
				$this->_Obj['PermsUser']=Framework::arrayToAcl($perms_u);
				$update=true;
			}
		}
		if ($update) {
			$this->_Base->updatePrj($this->_oid,$this->_Obj);
			$this->_L->goToLink();
		}
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		$formGui->addField('addFKGroupID','select',$this->_T->lang('[[Gruppen]]'),'','fields1');
		$formGui->setValues('addFKGroupID',array(0=>'-') + array(0=>'-') + $this->_frm->getAllGroups(0,$this->_projID));
		$formGui->addField('addFKUserID','select',$this->_T->lang('[[BenutzerInnen]]'),'','fields1');
		$formGui->setValues('addFKUserID',array(0=>'-') + $this->_frm->getFullName());

		//$formGui->addField('FKUserID','ttip',$this->_T->lang('[[BenutzerInnen]]'),'u_16|u_1','fields1');
		//$formGui->setParams('FKUserID',array('mode'=>'u|g'));

		if ($perm_mode) {
			$formGui->addField('addPermsID','checklist_v',$this->_T->lang('[[Rechte]]'),1,'fields2');
		} else {
			$formGui->addField('addPermsID','radiolist_v',$this->_T->lang('[[Rechte]]'),1,'fields2');
		}
		$formGui->setValues('addPermsID',$this->_Perms);


		$formGui->addField('perms_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields3');

		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		$p1=$this->listPerms('PermsGroup',$perms_g,$this->_Perms,$perm_mode);
		$p2=$this->listPerms('PermsUser',$perms_u,$this->_Perms,$perm_mode);
		$tplContent->addContent('form3_2',$p1,'FORM3');
		$tplContent->addContent('form3_3',$p2,'FORM3');
		return $tplContent;
	}
	function &listPerms($ptype,$perms,$av_perms,$perm_mode=0,$prep='perm') {
		if (!empty($perms)) {
			require_once('lib/class_ApplicationListGui.php');
			$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
			switch ($ptype) {
				case 'PermsGroup':
					$title=$this->_T->lang('[[Gruppen]]');
					$perms_users=$this->_frm->getAllGroups(array_keys($perms),$this->_projID);
					$img='gruppe.gif';
					$dbtn=$prep.'DeleteG_x';
				break;
				case 'PermsUser':
					$title=$this->_T->lang('[[BenutzerInnen]]');
					$perms_users=$this->_frm->getFullName(array_keys($perms),0,1);
					$img='user.gif';
					$dbtn=$prep.'DeleteU_x';
				break;
			}
			$tabGui->addHeaderCol('Name',$title,'','','',0,0,2);
			foreach ($av_perms as $pkey=>$pval) {
				$tabGui->addHeaderCol('Perms_'.$pkey,$pval,'','','',1);
			}
			$tabGui->addHeaderCol('Delete','','tras.gif');
			$tabGui->setLimit(0);
			$rows=0;$hl=0;
			foreach ($perms as $key=>$val) {
				//debug($val);
				$hl=$hl?0:1;
				$tabGui->addRow($hl);
				$tabGui->addCol('IMG','',$img);
				$tabGui->addCol('Name',$perms_users[$key],'','','',0,'2000');
				foreach ($av_perms as $pkey=>$pval) {
					if ($perm_mode) {
						$tabGui->addCol('Perms_'.$pkey,($val&$pkey)?'X':'','','','center',1);
					} else {
						$tabGui->addCol('Perms_'.$pkey,$pkey==$val?'X':'','','','center',1);
					}
				}
				//$tabGui->addCol('Perms',$av_perms[$val],'','','',1);
				$btn=new SubmitImgBtn ($dbtn.'['.$key.']','img/'.APP_THEME.'/loeschen.gif');
				$tabGui->addCol('Delete',$btn);
			}
		}
		return $tabGui;
	}
	function &getProjCatGui($oid=0) {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormGui.php');

		$ProjCatData=$this->_Base->listPrjCat($oid);

		$update=false;
		$formGui=new FormGui();
		$formGui->addField('addZefCat','mselect',$this->_T->lang('[[Taetigkeit]]'),'','fields1');
		$formGui->setValues('addZefCat',$this->_Base->listAllCatNames('',1,0));
		$formGui->setAttribs('addZefCat',array('size'=>'8'));
		$formGui->addField('addZefCatSoll','curr',$this->_T->lang('[[Sollstunden]]'),'','fields1');
		$formGui->addField('zef_cat_add','submit','',$this->_T->lang('[[Hinzufuegen]]'),'fields1');
		$formGui->addField('zef_cat_save','submit','',$this->_T->lang('[[Speichern]]'),'fields2');

		if (Framework::getParam('zef_cat_add',0,'P')) {
			$values=$formGui->getFieldVal('addZefCat');
			if (is_array($values) && !empty($values)) {
				foreach ($values as $tmp_id) {
					$this->_Base->replacePrjCat($oid,$tmp_id,$formGui->getFieldVal('addZefCatSoll'));
				}
				$update=true;
			}
		}
		if(is_array(Framework::getParam('zef_del_cat',0,'P'))) {
			$tmp_id=key($tmpArray=Framework::getParam('zef_del_cat',0,'P'));
			if ($tmp_id) {
				$this->_Base->deletePrjCat($oid,$tmp_id);
				$update=true;
			}
		}
		if (Framework::getParam('zef_cat_save',0,'P')) {
			$values=Framework::getParam('zef_cat_soll',array(),'P');
			if (is_array($values) && !empty($values)) {
				foreach ($values as $tmp_id=>$tmp_val) {
					$txtSoll=new DecimalFieldBtn ('zef_cat_soll['.$tmp_id.']');
					$txtSoll->setNumDec(2);
					$this->_Base->replacePrjCat($oid,$tmp_id,$txtSoll->getVal(0));
				}
				$update=true;
			}

		}
		if ($update) {
			$this->_L->goToLink();
		}

		$tplContent=new TemplateGui('core/form_3columns.inc.html');

		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tabGui->setName($this->_T->lang('[[Im Projekt verfuegbare Taetigkeiten]]'));
		$tabGui->addHeaderCol('Name',$this->_T->lang('[[Taetigkeit]]'));
		$tabGui->addHeaderCol('Soll',$this->_T->lang('[[Sollstunden]]'),'','','',1);
		$tabGui->addHeaderCol('Delete','','tras.gif');
		$tabGui->setLimit(0);
		$rows=0;$hl=0;
		if (!empty($ProjCatData)) {
			$ProjCatNames=$this->_Base->listAllCatNames('',0,0,-1,array_keys($ProjCatData));
			foreach ($ProjCatNames as $key=>$val) {
				$hl=$hl?0:1;
				$tabGui->addRow($hl);
				$tabGui->addCol('Name',$val,'','','',0,'2000');
				$txtSoll=new DecimalFieldBtn ('zef_cat_soll['.$key.']',$ProjCatData[$key]['soll'],array('style'=>'width:80px'));
				$txtSoll->setNumDec(2);
				$tabGui->addCol('Soll',$txtSoll,'','','',1);
				$btn=new SubmitImgBtn ('zef_del_cat['.$key.']','img/'.APP_THEME.'/loeschen.gif');
				$tabGui->addCol('Delete',$btn);
				$rows++;

			}
		} else {
			$tabGui->addRow(1);
			$tabGui->addCol('Name',$this->_T->lang('[[Alle]]'),'','','',0,'2000');
			$tabGui->addCol('Soll','-','','','right',1);
			$tabGui->addCol('Delete','','','','right',1);
		}

		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2_1',$tabGui,'FORM2');
		if ($rows)	$tplContent->addContent('form2_2',$formGui,'FORM2',array('','fields2'));
		return $tplContent;
	}
	function &showProjectList($search= null) {
		require_once('lib/class_ApplicationListGui.php');
		if (Framework::getParam('_OrderF',0,'G')) {
			$this->setPrefs('prjOrderF',Framework::getParam('_OrderF',0,'G'));
			$this->setPrefs('prjOrderD',Framework::getParam('_OrderD',0,'G'));
		}
		$orderF=$this->getPrefs('prjOrderF','zefAktiv');
		$orderD=$this->getPrefs('prjOrderD',-1);
		$sqlOrder=$orderF." ".($orderD==-1?'DESC':'ASC');
		if ($orderF!='zefName') $sqlOrder.=",zefName ASC";
		$rows=0;
		$limit=50;
		$b=Framework::getParam('b',0,'G');
		$entries=$this->_Base->listAllPrj($rows,$sqlOrder,$b,$limit,$search);
		$Gui=new ApplicationListGui();
		$Gui->setName($this->_T->lang('[[Projekte]]'));
		$Gui->setActOrder($orderF,$orderD);
		$Gui->setOrderLink($this->_L);
		$Gui->setLimit($limit);
		$Gui->setSumRows($rows);
		$Gui->setBegin($b);
		$Gui->setNavLink($this->_L);
		$Gui->addHeaderCol('zefName',$this->_T->lang('[[Name]]'),'','','',0,2000);
		$Gui->setHeaderOrder('zefName','zefName',1);
		$Gui->addHeaderCol('zefAktiv',$this->_T->lang('[[Aktiv]]'),'','','',1);
		$Gui->setHeaderOrder('zefAktiv','zefAktiv',-1);
		$Gui->addHeaderCol('zefTimeCreate',$this->_T->lang('[[Erstellt am]]'),'','','',1);
		$Gui->setHeaderOrder('zefTimeCreate','zefTimeCreate',-1);
		$Gui->addHeaderCol('zefUserCreate',$this->_T->lang('[[Erstellt von]]'),'','','',1);
		$Gui->setHeaderOrder('zefUserCreate','zefUserCreate',1);
		foreach ($entries as $key=>$val) {
			$Gui->addRow($key==$this->_oid?2:($hl?$hl=0:$hl=1));
			$Gui->addCol('zefName',$val['zefName'],'',$this->_L->getTempLink(null,array('zefPrjID'=>$key,'_clTab'=>'meta')));
			$Gui->addCol('zefAktiv',$val['zefAktiv']?'X':date('d.m.Y',$val['zefTimeAktiv']),'','','',1);
			$Gui->addCol('zefTimeCreate',date('d.m.Y',$val['zefTimeCreate']),'','','',1);
			$Gui->addCol('zefUserCreate',$this->_frm->getCachedUserName($val['zefUserCreate']),'','','',1);
		}
		return $Gui;
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
}
?>