<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if ($import_x) {
	$file=$_FILES['ext_file']['tmp_name'];
	if ($file && $file!='none' && file_exists($file) && is_file($file)) {
		$function='';
		$fp	= @fopen($file, "r-");
		if (@$fp) {
			$line =	str_replace("\n", "", fgets($fp, 4096));
			if (preg_match('/<!DOCTYPE NETSCAPE-Bookmark-file-1>/i', $line)) {
				$function=parseNetscape;
			}
			if (preg_match('/Opera Hotlist version 2.0/', $line))	{
				$function=parseOpera;
			}
			fclose($fp);
		}
		if ($function) {
			$DelFolder=$_POST['ObjDelFolder'];
			$UrlDuplicate=$_POST['ObjDuplicate'];
			$impFolder=$Lmng->getObj($ObjFolder);
			if (!is_object($impFolder) || !$impFolder->getAcl(2)) {
				$ActionError['no_write_perms']["ObjFolder"]=$ObjFolder;
			} else {
				$ParseResult=array();
				$FolderTrans=array(0=>&$impFolder);
				if ($DelFolder) {
					$delObjs=$Lmng->ListSubEntrys($impFolder->getID(),'','','');
				}
				require('lib/lmng/BookmarkParser.php');
				$BkmImp = new BookmarkParser();
				$error=$BkmImp->$function($file,0, 'parseURL', 'parseFolder');
				if ($error!=-1) {
					if ($DelFolder && is_object($trash_obj)) {
						require('lib/lmng/func_Action.php');
						foreach ($delObjs as $new_obj) {
							$tmp_error=TrashObject($trash_obj,$new_obj);
							if ($tmp_error) {
								$ActionError[$tmp_error[0]][]=$tmp_error[1];
							}
						}
					}
				}
			}
		} else {
			$ActionError['no_valid_file']=true;
		}
	} else {
		$ActionError['no_valid_file']=true;
	}
}
if ($export_x) {
	$expFolder=$Lmng->getObj($ObjFolderE);
	if (is_object($expFolder)) {
		$tree_apps=array('fol','link');
		$htmlCont='<!DOCTYPE NETSCAPE-Bookmark-file-1>'."\n";
		$htmlCont.='<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset='.GE_CHARSET.'">';
		$htmlCont.='<!-- Created by e-Groupie - www.endo7.com -->'."\n";
		$htmlCont.='<!-- on '.date('r').' -->'."\n\n";
		$htmlCont.='<TITLE>Bookmarks for '.Framework::entities($REG_USER["lastname"].' '.$REG_USER["firstname"]).'</TITLE>'."\n\n";
		$htmlCont.='<H1>Bookmarks for '.Framework::entities($REG_USER["lastname"].' '.$REG_USER["firstname"]).'</H1>'."\n\n";
		$htmlCont.='<DL><p>'."\n";
		$htmlCont.=parseExport($expFolder,1);
		$htmlCont.='</DL><p>'."\n";
		page_close();

		Framework::dumpText($htmlCont,'bookmarks.html');
		exit;
	}




}
function &parseExport(&$Folder,$depth=1) {
	global $Lmng,$session_lang;
	if (is_object($Folder) && $Folder->isFolder()) {
		$entrys=$Lmng->ListSubEntrys($Folder->getID(),array('link','fol'),'DocType ASC,Title_'.$session_lang.' ASC','');
		foreach ($entrys as $lobj) {
			if ($lobj->isFolder()) {
				$result.=str_repeat("\t",$depth).'<DT><H3 ADD_DATE="0">'.Framework::entities($lobj->getName()).'</H3>'."\n";
				$result.=str_repeat("\t",$depth).'<DL><p>'."\n";
				$depth++;
				$result.=parseExport($lobj,$depth);
				$depth--;
				$result.=str_repeat("\t",$depth).'</DL><p>'."\n";
			} else {
				$result.=str_repeat("\t",$depth);
				$result.='<DT><A HREF="'.Framework::entities($lobj->getMeta('Link')).'" ';
				$result.='ADD_DATE="'.intval($lobj->getMeta('TimeCreate')).'" ';
				$result.='LAST_VISIT="'.intval($lobj->getParentMeta('TimeLast')).'" ';
				$result.='LAST_MODIFIED="'.intval($lobj->getMeta('TimeModify')).'">';
				$result.=Framework::entities($lobj->getName()).'</A>'."\n";

			}
		}
	}
	return $result;
}


function parseURL($data, $depth, $no) {
	global $Lmng,$DelFolder,$UrlDuplicate,$FolderTrans,$ParseResult;
	$data['url']=trim($data['url']);
	//debug($data);return;
	if (!$data['url']) return;
	if (!trim($data['descr'])) $data['descr']=$data['url'];
	$PFolder=$FolderTrans[$data['parent']];
	if (is_object($PFolder)) {
		if (!$UrlDuplicate) $Link=$Lmng->searchLinkByUrl($PFolder->getID(),$data['url']);
		if (!is_object($Link)) {
			$Link=new LObj_link();
			$Link->setMeta('DocType','link');
			$Link->setMeta('MenuImage','bkm.gif');
			$Link->setMeta('Link',$data['url']);
			$Link->setMeta('Text',$data['comm']);
			$Link->setMeta('TimeCreate',time());
			$Link->setMeta('TimeModify',time());
			$Link->setMeta('UserCreate',$GLOBALS['user_id']);
			$Link->setMeta('UserModify',$GLOBALS['user_id']);
			$Link->setMeta('Users',$PFolder->getMeta('Users'));
			$Link->setMeta('Groups',$PFolder->getMeta('Groups'));
			$Link->setMeta('ParentID',$PFolder->getID());
			$Link->setMeta('RootID',$PFolder->getMeta('RootID'));
			$Link->setMeta('UserID',$PFolder->getMeta('UserID'));
			foreach ($GLOBALS['CFG']['AV_LANG'] as $val) {
				$Link->setMeta('Title_'.$val,$data['descr']);
			}
			$Lmng->insertMeta($Link);
			$Link->setParentMeta('TimeLast',$data['visited']);
			if ($data['visited']) $Link->setParentMeta('Counter',1);
			$Lmng->insertParentMeta($Link);
			$ParseResult['LinkCreate']+=1;
		} else {
			$ParseResult['LinkSkipped']+=1;
		}
	}
}

function parseFolder($data, $depth, $no) {
	global $Lmng,$DelFolder,$UrlDuplicate,$FolderTrans,$ParseResult;
	$data['name']=trim($data['name']);
	if (!$data['name']) $data['name']='NO NAME';
	//debug($data);return;

	$PFolder=$FolderTrans[$data['parent']];
	if (is_object($PFolder)) {
		if (!$DelFolder) $Folder=$Lmng->searchFolderByName($PFolder->getID(),$data['name']);
		if (!is_object($Folder)) {
			$Folder=new LObj_fol();
			$Folder->setMeta('DocType','fol');
			$Folder->setMeta('MenuImage','tree.gif');
			$Folder->setMeta('TimeCreate',time());
			$Folder->setMeta('TimeModify',time());
			$Folder->setMeta('UserCreate',$GLOBALS['user_id']);
			$Folder->setMeta('UserModify',$GLOBALS['user_id']);
			$Folder->setMeta('Users',$PFolder->getMeta('Users'));
			$Folder->setMeta('Groups',$PFolder->getMeta('Groups'));
			$Folder->setMeta('ParentID',$PFolder->getID());
			$Folder->setMeta('RootID',$PFolder->getMeta('RootID'));
			$Folder->setMeta('UserID',$PFolder->getMeta('UserID'));
			foreach ($GLOBALS['CFG']['AV_LANG'] as $val) {
				$Folder->setMeta('Title_'.$val,trim($data['name']));
			}
			$Lmng->insertMeta($Folder);
			$ParseResult['FolderCreate']+=1;
		}
		$FolderTrans[$no]=&$Folder;
	}
}







if (!$import_x || $ActionError) {
	require_once('lib/class_ObjSelect.php');
	$sel_int=new ObjSelect();
	$sel_int->setClass('noption');
	$sel_int->setSelectedID($ObjFolder);
	$sel_int->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');


	$tree_apps=array('fol');
	$option_tree='';
	foreach ($root_obj as $key=>$val) {
		if ($val->getMeta('System')=='u' || $val->getMeta('System')=='s') {
			$sel_int->setTree($Lmng->ListAllTree($key,-1,'Title_'.$session_lang,'ASC',$tree_apps));
			$option_tree.=$sel_int->parseSelect($val->getMeta('ParentID'));
		}
	}
	$t->assign('TREE_FOLDER',$option_tree);
	unset($option_tree);
	if ($ActionError['no_write_perms']["ObjFolder"]) {
		$t->assign('C_FOLDER','error');
	} else {
		$t->assign('C_FOLDER','');
	}

	$chk_del_folder=new CheckBox ('ObjDelFolder','',1);
	$t->assign('CHK_DEL_FOLDER',$chk_del_folder->f(1));

	$chk_duplicate=new CheckBox ('ObjDuplicate','',1);
	$t->assign('CHK_DUPLICATE',$chk_duplicate->f(1));
	$t->parse('ROW','edit_import');
	$t->parse('ROW','edit_export');
} else {
	$t->assign('FOLDER_CREATE',intval($ParseResult['FolderCreate']));
	$t->assign('LINK_CREATE',intval($ParseResult['LinkCreate']));
	$t->assign('LINK_SKIPPED',intval($ParseResult['LinkSkipped']));

	$t->parse('ROW','result_import');
}


$t->assign('L_BREAK',"index.php?site=$site");
$t->parse('ROW','break');
$t->assign('FORM_ACTION',"index.php?site=$site&action=$action&oid=$oid");

$t->assign('TPL_ROOT','');
?>