<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

if (!$obj || !$obj->getAcl(1) || ($obj->isFolder() && !$obj->getAcl(2))) {
	header("Location:index.php?site=$site");
	exit;
}
$ID=$obj->getID();
$l_this="index.php?site=$site&action=$action&edit=$edit&new=$new&oid=$oid";
$t->assign('FORM_ACTION',$l_this);

if ($new) {
	$t->parse('ROW','title_new');
	$new_obj=new LObj_link();
	$new_obj->setMeta('DocType','link');
	$new_obj->setMeta('ParentID',$obj->getID());
	$new_obj->setMeta('RootID',$obj->getMeta('RootID'));
	$new_obj->setMeta('Link','http://');
	$new_obj->setAcl(-1);
	if ($fetchurl_x && $ObjLink) {
		//echo "www";
		$temp=$Lmng->FetchHtml($ObjLink,$session_lang);
		if (is_array($temp)) {
			extract($temp);
		}
	
	}
	$edit=1;
} else {
	$new_obj=$obj;
	$t->parse('ROW','title_edit');

	$frm->addOnload('e7gMsgIntitObj('.json_encode(array(
		'typ'=>'lmng',
		'id'=>$obj->getID(),
		'name'=>$obj->getName(),
		'link'=>"index.php?site=".$obj->getSite()."&action=".$obj->getAction(0)."&oid=".$obj->getID()."&go_b=1",
		'target'=>'_blank'
	)).');');
	
}
$meta_action=$frm->getObjAction($Lmng->getModul(),'e_'.$new_obj->getActionMode(0));
$p_update=false;

if ($edit && $Lmng->isAllowedAction($new_obj,$meta_action['e|link'])) {
	$txt_link=new TextField('ObjLink','size="30" class="sel" style="width:300px"','0','%',$new_obj->getMeta('Link'));
	$t->assign('OBJ_LINK',$txt_link->f());
	if ($ActionError['fields']["ObjLink"]) {
		$t->assign('C_LINK','error');
	} else {
		$t->assign('C_LINK','');
	}
	if ($obj->isFolder()) {
		$t->parse('ROW','obj_link_get');
		$chk_fav=new CheckBox ('FavInsert','',1);
		$t->assign('CHK_FAV',$chk_fav->f(1));
		$t->parse('ROW','obj_fav_insert');
	}
	$t->assign('FOCUS_FIELD',"ObjLink");
	$p_update=true;
} else {
	$t->assign('OBJ_LINK','<div class="disable" style="width:300px;">'.FrameWork::entities($new_obj->getMeta('Link')).'&nbsp;</div>');
}
if ($edit && $Lmng->isAllowedAction($new_obj,$meta_action['e|title'])) {
	$tmp_name=$new_obj->getMeta('Title_'.$session_lang);
	$ObjLang=1;
	if ($Lmng->isAllowedAction($new_obj,$meta_action['e|title_lang'])) {
		$lang_array=$CFG['MA_LANG'];
	} else {
		$lang_array=array($session_lang);
	}
	foreach ($lang_array as $val) {
		$txt_title=new TextField("ObjTitle_$val",'size="30" class="sel" style="width:300px"','0','%',$new_obj->getMeta('Title_'.$val));
		if ($val==$session_lang) {
			$t->assign('OBJ_TITLE',$txt_title->f());
			$t->assign('OBJ_TITLE_LANG',strtoupper($val));
			if ($ActionError['fields']["ObjTitle_$val"]) {
				$t->assign('C_TITLE','error');
			} else {
				$t->assign('C_TITLE','');
			}
		} else {
			if (isset($_POST["ObjTitle_$val"]) && $_POST["ObjTitle_$val"]!=$tmp_name) $ObjLang=0;
			if ($new_obj->getMeta('Title_'.$val)!=$tmp_name) $ObjLang=0;
			$t->assign('OBJ_TITLE_A',$txt_title->f());
			$t->assign('OBJ_TITLE_LANG_A',strtoupper($val));
			if ($ActionError['fields']["ObjTitle_$val"]) {
				$t->assign('C_TITLE_A','error');
			} else {
				$t->assign('C_TITLE_A','');
			}
			$t->parse('ROW','.obj_lang');
		}
	}
	if (count($lang_array)>1) {
		$chk_lang=new CheckBox('ObjLang','',1);
		$t->assign('CHK_OBJ_LANG',$chk_lang->f());
		$t->parse('ROW','obj_lang_one');
	}
	$p_update=true;
} else {
	$t->assign('OBJ_TITLE','<div class="disable" style="width:300px">'.FrameWork::entities($new_obj->getName($session_lang)).'&nbsp;</div>');
	$t->assign('OBJ_TITLE_LANG',strtoupper($session_lang));
}

if ($edit && $Lmng->isAllowedAction($new_obj,$meta_action['e|text'])) {
	$txt_desc=new TextArea('ObjText','rows="7" cols="36" class="sel" style="width:300px;"','0','%',$new_obj->getMeta('Text'));
	$t->assign('OBJ_DESC',$txt_desc->f());
	$p_update=true;
} else {
	$t->assign('OBJ_DESC','<div class="disable" style="width:300px;min-height:70px;">'.FrameWork::entities($new_obj->getMeta('Text')).'</div>');
}

if (is_array($ActionError['fields'])) {
	$t->assign('FOCUS_FIELD',key($ActionError['fields']));
}

if ($new_obj->getMeta('TimeModify')) {
	$t->assign('OBJ_TIME_MODIFY',date('d.m.Y H:i',$new_obj->getMeta('TimeModify')));
} else {
	$t->assign('OBJ_TIME_MODIFY','-');
}
if ($new_obj->getMeta('UserModify')) {
	if (!isset($all_user[$new_obj->getMeta('UserModify')])) {
		$temp=$frm->getFullName($new_obj->getMeta('UserModify'),1,1);
		$all_user[$new_obj->getMeta('UserModify')]=$temp[$new_obj->getMeta('UserModify')];
	}
	$t->assign('OBJ_USER_MODIFY',FrameWork::entities($all_user[$new_obj->getMeta('UserModify')]));
} else {
	$t->assign('OBJ_USER_MODIFY','-');
}
$t->parse('ROW','last_modify');

if (!$new) {
	$obj_action=$frm->getObjAction($Lmng->getModul(),$obj->getActionMode(0));
	foreach ($obj_action as $key=>$val) {
		if (!$val['Hidden'] && $Lmng->isAllowedAction($obj,$val)) {
			$t->assign('SEL_VAL',$key);
			$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
			$t->parse('ROW','.obj_action_val');
		}
	}
	$t->parse('ROW','obj_action');
	$t->parse('ROW','public_box');
}

if ($p_update) {
	$t->parse('ROW','update');
}
$t->assign('L_BREAK',"index.php?site=$site&oid=".$new_obj->getMeta('ParentID'));
$t->parse('ROW','break');

?>
