<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
//
//debug($_POST);
//debug(htmlspecialchars($_POST['mail_body']));
set_time_limit(0);
if(isset($_GET['dl_attach'])){
	$file=$Mail->readEmailAttachment($_GET['dl_attach']);
	if ($file && $file['Name']) {
		$filename=basename($file['Name']);
		if (!strpos($filename,'.')) {
			$ext=$Mail->getMimeExtension($file['Type']);
			if ($ext) {
				$filename.='.'.$ext;
			}
		}
		Framework::dumpFile($Mail->getAttachPath().'/'.$file['Name'],$filename,$file['Type']);
		exit;
	}
}
$setEditorFocus=false;
$defFontName='verdana,geneva,sans-serif';
$defFontSize="12px";
$maxIdentities=10;
require_once("lib/mail/classHtmlToText.php");
require_once("lib/classUserGUI.php");
require_once("lib/mail/RFC822.php");
$mCheck=new Mail_RFC822();
if ($_POST['ajax_body']) $_POST['mail_body']=$mail_body=$_POST['ajax_body'];
if ($Mail->getCfg('cfg/all/allow_wysiwyg')) {
	$htmleditor_typ=$Mail->getPrefs('htmleditor_typ')?$Mail->getPrefs('htmleditor_typ'):'tiny_mce';
	$emptyRowB='<p><span style="font-size:'.$defFontSize.';font-family: '.$defFontName.'">';
	$emptyRowE='</span></p>';
	$emptyRow=$emptyRowB.' '.$emptyRowE;
	switch ($htmleditor_typ) {
		case 'tiny_mce':
			$emptyRow=$emptyRowB.' '.$emptyRowE;
		break;
		case 'ckeditor':
			$emptyRow=$emptyRowB.'<br />'.$emptyRowE;
		break;
	}
	if (!$sess->is_registered("use_wysiwyg")) {
		$sess->register("use_wysiwyg");
		$use_wysiwyg=$Mail->getPrefs("use_wysiwyg");
	}
	if ($clearMail || (!$load && $mid)) {
		$use_wysiwyg=$Mail->getPrefs("use_wysiwyg");
	}
	if (Framework::getParam('show_html_x',0)) {
		$addBodyB=$emptyRowB;
		if ($frm->getPrefs('email',"use".$identity)) {
			$txt_sign=$frm->getPrefs('email',"signatur".$identity);
			$htm_sign=$Mail->getPrefs("signatur_html".$identity);
			if (!strlen($htm_sign)) {
				$htm_sign=nl2br($txt_sign);
			} else {
				$relImgPath=Framework::getSelfDir().'/fetch_mail_img.php?img=htmlImg/';
				$htm_sign=preg_replace('/(src="?)[^ ]+\/htmlImg\/(.+\.(jpg|gif|jpeg|png))/i','\\1'.$relImgPath.'\\2',$htm_sign);
			}
			Framework::convertLineEndings($txt_sign,"\n");
			Framework::convertLineEndings($mail_body,"\n");
			$mail_body=preg_replace ('/'.preg_quote($txt_sign,'/').'/','',$mail_body,1);
			$addBodyE=$emptyRowE.$emptyRow.$emptyRow.'<!--BEGIN SIGNATUR--><div id="groupeMailSign" class="mceNonEditable">'.$htm_sign.'</div><!--END SIGNATUR-->';
		} else {
			$addBodyE=$emptyRowE.$emptyRow.$emptyRow.'<!--BEGIN SIGNATUR--><div id="groupeMailSign" class="mceNonEditable"></div><!--END SIGNATUR-->';
		}
		//debug(htmlentities(nl2br(htmlspecialchars($mail_body))));
		$mail_body=$Mail->formatNewHtmlMail(str_replace("\n",$emptyRowE.$emptyRowB,htmlspecialchars($mail_body)),$addBodyB,$addBodyE,GE_CHARSET);
		$use_wysiwyg=1;
	}
	if (Framework::getParam('show_txt_x',0)) {
		$use_wysiwyg=0;
		Framework::convertLineEndings($mail_body,"\n");
		if ($frm->getPrefs('email',"use".$identity)) {
			if (preg_match('/<!--BEGIN SIGNATUR-->.*<!--END SIGNATUR-->/s',$mail_body)) {
				$mail_body=preg_replace ('/<!--BEGIN SIGNATUR-->.*<!--END SIGNATUR-->/s','<pre>'.$frm->getPrefs('email',"signatur".$identity).'</pre>',$mail_body,1);
			} else {
				$addBodyB="\n\n".$frm->getPrefs('email',"signatur".$identity)."\n\n";
			}
		}
		//debug(htmlspecialchars($mail_body));
		$h2t = new html2text($mail_body);
		$mail_body=$addBodyB.Framework::convertCharset($h2t->get_text(),'HTML-ENTITIES');
		//debug($mail_body);
	}
	$comp_wysiwyg=1;
} else {
	$use_wysiwyg=0;
	$comp_wysiwyg=0;
}
$L_THIS="index.php?site=$site&action=$action&rid=".urlencode($rid)."&oid=".urlencode($obj->getBox())."&mid=$mid&mode=$mode&back=$back&load=1";
$send_to=str_replace('mailto:','',$send_to);

if ($fmng_x || $to_x || $cc_x || $bcc_x || $per_x) {
	$Mail->saveEmail(array(
				'TO'=>$send_to,
				'CC'=>$send_to_cc,
				'BCC'=>$send_to_bcc,
				'Subject'=>$subject,
				'Body'=>$mail_body,
				'identity'=>$identity,
				'copyto'=>trim($_POST['hid_FcopyTo'])?substr($_POST['hid_FcopyTo'],2):0,
				'read_confirm'=>$read_confirm,
				'extra'=>serialize(array(
					'move_orig'=>Framework::getParam('FmoveOrig',0,'P'),
					'root_fmng'=>Framework::getParam('root_fmng',0,'P')
				)),
			)
	);
	if ($fmng_x) {
		$SESS_MDATA[$GLOBALS['app']['fmng']['url']]=array(
			'MAIL_REFERER'=>$L_THIS.'&getUserFmng=1',
		);
		$location="index.php?site=".$GLOBALS['app']['fmng']['url'].'&action=b&oid='.Framework::getParam('root_fmng',0,'P');
	} elseif ($smb_x) {
		$SESS_MDATA[$GLOBALS['app']['smb']['url']]=array(
			'MAIL_REFERER'=>$L_THIS.'&getUserFmng=1',
		);
		$location="index.php?site=".$GLOBALS['app']['smb']['url'];
	} elseif ($to_x) {
		$SESS_MDATA[$GLOBALS['app']['addr']['url']]=array(
			'MAIL_REFERER'=>$L_THIS.'&getUserTO=1',
		);
		$location="index.php?site=".$GLOBALS['app']['addr']['url'];
	} elseif ($cc_x) {
		$SESS_MDATA[$GLOBALS['app']['addr']['url']]=array(
			'MAIL_REFERER'=>$L_THIS.'&getUserCC=1',
		);
		$location="index.php?site=".$GLOBALS['app']['addr']['url'];
	} elseif ($bcc_x) {
		$SESS_MDATA[$GLOBALS['app']['addr']['url']]=array(
			'MAIL_REFERER'=>$L_THIS.'&getUserBCC=1',
		);
		$location="index.php?site=".$GLOBALS['app']['addr']['url'];
	} elseif ($per_x) {
		$SESS_MDATA[$GLOBALS['app']['addr']['url']]=array(
			'MAIL_REFERER'=>$L_THIS.'&getUserPer=1',
		);
		$location="index.php?site=".$GLOBALS['app']['addr']['url'];
	}
	page_close();
	header("Location:$location");
	exit;
}

//Signatur
// Identit�ten formatieren
$identity_array=array();
for($i=1; $i<=$maxIdentities; $i++){
	if ($Mail->getPrefs("email".$i)) {
		$personal=$Mail->getPrefs("fullname".$i);
		$mailbox=substr($Mail->getPrefs("email".$i),0,strpos($Mail->getPrefs("email".$i),'@'));
		$host=substr($Mail->getPrefs("email".$i),strpos($Mail->getPrefs("email".$i),'@')+1);
		$name=imap_rfc822_write_address($mailbox,$host,$personal);
		$identity_array[$i]=$name;
	}
}


if(!$identity) {
	if ($Mail->getPrefs("defuse")) $identity=$Mail->getPrefs("defuse"); else $identity=1;
}


if ($Mail->getPrefs("use".$identity)) {
	$signatur=$CFG['NL_MAIL'].$Mail->getPrefs("signatur".$identity).$CFG['NL_MAIL'];
	if ($use_wysiwyg) {
		$signatur_html=$Mail->getPrefs("signatur_html".$identity);
		if (!strlen($signatur_html)) {
			$signatur_html=nl2br($signatur);
		} else {
			$relImgPath=Framework::getSelfDir().'/fetch_mail_img.php?img=htmlImg/';
			$signatur_html=preg_replace('/(src="?)[^ ]+\/htmlImg\/(.+\.(jpg|gif|jpeg|png))/i','\\1'.$relImgPath.'\\2',$signatur_html);
		}
	}
} else {
	$signatur='';
	$signatur_html='';
}
if (!isset($copyto)) $copyto=$Mail->getSentID();
if (!isset($_POST['subject']) && !isset($read_confirm)) $read_confirm=$Mail->getPrefs("use_notif");
if (!$load) {
	$cid=array();
	if ($mid) {
		$Mail->deleteEmail();
		$Mail->deleteAttachment();
		$Mobj=$Mail->getMailObj($obj->getBox(),$mid);
		$tm_send_to=$tm_send_to_cc=$tm_send_to_bcc=$from_emails=array();
		if (is_object($Mobj)) {
			require("lib/mail/classMailDecode.php");
			$MDec=new MailDecode($Mail);
			$bodyar=$MDec->getBody($obj->getBox(),$Mobj,0,false,true);
			if (!isset($bodyar['text']) && isset($bodyar['html'])) {
				if ($comp_wysiwyg) $use_wysiwyg=true;
				$h2t =& new html2text($bodyar['html']);
				$bodyar['text']=Framework::convertCharset($h2t->get_text(),'HTML-ENTITIES');
			}
			$frm->convertLineEndings($bodyar['text'],$CFG['NL_MAIL']);

			if (is_array($Mobj->getMail('From'))) {
				$from_emails=$Mail->formatMail($Mobj->getMail('From'),0,1);

			}
			if ($mode=='reply' || $mode=='reply_all') {
				$tm_send_to=array_merge($tm_send_to,$from_emails);
			}
			if ($mode=='reply_all') {
				if (is_array($Mobj->getMail('To'))) {
					$emails=$Mail->formatMail($Mobj->getMail('To'),0,1);
					$tm_send_to_cc=array_merge($tm_send_to_cc,$emails);
				}
			}
			if ($mode=='edit' || $mode=='draft') {
				if (is_array($Mobj->getMail('To'))) {
					$emails=$Mail->formatMail($Mobj->getMail('To'),0,1);
					$tm_send_to=array_merge($tm_send_to,$emails);
				}
				if (is_array($Mobj->getMail('From'))) {
					$tmp_Perc=5;
					foreach ($Mobj->getMail('From') as $mTo) {
						foreach ($identity_array as $iKey=>$iVal) {
							if ($Mail->getPrefs("email".$iKey)==$mTo->mailbox.'@'.$mTo->host) {
								$tmp=similar_text($iVal ,$Mail->formatMail($mTo,0,1));
								//debug(htmlentities($Mail->formatMail($mTo,0,1).' - '.$iVal.':'.$tmp));
								if ($tmp>$tmp_Perc) {
									$identity=$iKey;
									$tmp_Perc=$tmp;
								}
							}
						}
						if ($tmp_Perc>99) break;
					}
				}
				$FullHeader=$Mail->parseFullHeader($obj->getBox(),$Mobj->getID(),1);
				//debug($FullHeader);
				if ($Mail->getCfg('cfg/all/allow_notification')) {
					if ($FullHeader['disposition-notification-to'])	$read_confirm=1; else $read_confirm=0;
				}
				if ($FullHeader['x-group-e-copyto']) $copyto=trim($FullHeader['x-group-e-copyto']);
				if (isset($FullHeader['x-group-e-html'])) $use_wysiwyg=intval($FullHeader['x-group-e-html']);
			}
			if ($mode=='reply_all' || $mode=='edit' || $mode=='draft') {
				if (is_array($Mobj->getMail('Cc'))) {
					$emails=$Mail->formatMail($Mobj->getMail('Cc'),0,1);
					$tm_send_to_cc=array_merge($tm_send_to_cc,$emails);
				}
				if (is_array($Mobj->getMail('Bcc'))) {
					$emails=$Mail->formatMail($Mobj->getMail('Bcc'),0,1);
					$tm_send_to_bcc=array_merge($tm_send_to_bcc,$emails);
				}
			}
			if ($mode=='reply_all' || $mode=='reply' || $mode=='fwd') {
				if (is_array($Mobj->getMail('To'))) {
					$tmp_Perc=5;
					foreach ($Mobj->getMail('To') as $mTo) {
						foreach ($identity_array as $iKey=>$iVal) {
							if ($Mail->getPrefs("email".$iKey)==$mTo->mailbox.'@'.$mTo->host) {
								$tmp=similar_text($iVal ,$Mail->formatMail($mTo,0,1));
								//debug(htmlentities($Mail->formatMail($mTo,0,1).' - '.$iVal.':'.$tmp));
								if ($tmp>$tmp_Perc) {
									$identity=$iKey;
									$tmp_Perc=$tmp;
								}
							}
						}
						if ($tmp_Perc>99) break;
					}
				}
			}
			$send_to=implode(',',$tm_send_to);
			if ($mode=='reply_all') {
				for($i=1; $i<=$maxIdentities; $i++){
					$test_mail=$Mail->getPrefs("email".$i);
					if ($test_mail) {
						foreach ($tm_send_to_cc as $key=>$val) {
							if (preg_match('/(^|[<])'.preg_quote($test_mail,'/').'([>]|$)/i',$val)) {
								unset($tm_send_to_cc[$key]);
							}
						}
					}
				}
			}
			if ($Mail->getPrefs("use".$identity)) {
				$signatur=$CFG['NL_MAIL'].$Mail->getPrefs("signatur".$identity).$CFG['NL_MAIL'];
				if ($use_wysiwyg) {
					$signatur_html=$Mail->getPrefs("signatur_html".$identity);
					if (!strlen($signatur_html)) {
						$signatur_html=nl2br($signatur);
					} else {
						$relImgPath=Framework::getSelfDir().'/fetch_mail_img.php?img=htmlImg/';
						$signatur_html=preg_replace('/(src="?)[^ ]+\/htmlImg\/(.+\.(jpg|gif|jpeg|png))/i','\\1'.$relImgPath.'\\2',$signatur_html);
					}
				}
			} else {
				$signatur='';
				$signatur_html='';
			}
			$send_to_cc=implode(',',$tm_send_to_cc);
			$send_to_bcc=implode(',',$tm_send_to_bcc);
			$cid=array();
			if($bodyar['att']){
				//debug($bodyar['att']);
				foreach($bodyar['att'] as $var) {
					if ($var['id'] && $use_wysiwyg) {
						$type=$var['type'];
						$size=$var['size'];
						$name=$Mail->mail_enc($var['name']);
						$name=strtr($name,'/,|','-__');
						if (!$name) $name='no_name';
						$n_name=$name;$i=1;
						while(file_exists($Mail->getAttachPath()."/".$n_name)) {
							$n_name=$i.'_'.$name;
							$i++;
						}
						$fhandle=fopen($Mail->getAttachPath()."/".$n_name,'w+');
						fputs($fhandle,$Mail->getAttachment($obj->getBox(), $Mobj->getID(),  $var['part'],$var['enc']));
						fclose($fhandle);

						$duplicate=false;
						if ($n_name!=$name) {
							if (Framework::getMd5Sum($Mail->getAttachPath()."/".$n_name)==Framework::getMd5Sum($Mail->getAttachPath()."/".$name)) {
								$duplicate=true;
								unlink($Mail->getAttachPath()."/".$n_name);
							} else {
								$name=$n_name;
							}
						}
						//debug('DUPLICATE:'.$duplicate.':'.$name);
						$src=Framework::getSelfDir().'/fetch_mail_img.php?img='.urlencode($name);
						if (!$duplicate) $Mail->addEmailAttachments(array('Name'=>$name,'Size'=>$size,'Type'=>$type,'Cid'=>preg_replace('/[<>]/','',$var['id']),'Source'=>$src));
						$cid[preg_replace('/[<>]/','',$var['id'])]=$src;
							
							
					} elseif (($mode=='edit' || $mode=='draft' || $mode=='fwd')) {
						$type=$var['type'];
						$name=$Mail->mail_enc($var['name']);
						$size=$var['size'];
						$name=strtr($name,'/,|','-__');
						if (GE_CHARSET=='UTF-8') {
							$name=Framework::getUtf8Encoded($name);
						}
						if (!$name) $name='no_name';
						$fhandle=fopen($Mail->getAttachPath()."/".$name,'w+');
						fputs($fhandle,$Mail->getAttachment($obj->getBox(), $Mobj->getID(),  $var['part'],$var['enc']));
						fclose($fhandle);
						$Mail->addEmailAttachments(array('Name'=>$name,'Size'=>$size,'Type'=>$type));
					}
				}
			}
			$html_charset=$Mail->getHtmlCharset($bodyar['html'],$bodyar['html_charset']);
			switch ($mode) {
				case 'reply':
				case 'reply_all':
					$subject="RE: ".$Mail->mail_enc($Mobj->getName());
					if ($use_wysiwyg) {
						$addBodyB=$emptyRow.$emptyRow.'<!--BEGIN SIGNATUR--><div id="groupeMailSign" class="mceNonEditable">'.$signatur_html.'</div><!--END SIGNATUR-->';
						$addBodyB.=$emptyRow.$emptyRow.$emptyRowB."--------".htmlspecialchars($from_emails[0])." wrote--------".$emptyRowE;
						$addBodyB.=$emptyRowB."Subject: ".Framework::convertCharset($Mail->mail_enc($Mobj->getName()),GE_CHARSET,$html_charset).$emptyRowE;
						$addBodyB.=$emptyRowB."Date: ".date('d.m.Y H:i',$Mobj->getMeta('Date')).$emptyRowE.$emptyRow;
						$addBodyB.='<blockquote style="border-left:2px solid #00F;margin:0 0 0 10px;padding:0 0 0 5px;">';
						$addBodyE='</blockquote>';
						if (isset($bodyar['html'])) {
							$bodyar['html']=$Mail->convertHtml($bodyar['html'],$html_charset);
							if ($bodyar['text'] && !$bodyar['alt']) {
								$bodyar['html']=$Mail->convertHtml(nl2br(htmlspecialchars($bodyar['text'])),GE_CHARSET).'<hr />'.$bodyar['html'];
							}
							//debug(htmlentities($bodyar['html']));
							$mail_body=$Mail->formatNewHtmlMail($Mail->removeMailSignID($bodyar['html']),$addBodyB,$addBodyE,$html_charset);
							//debug(htmlentities($mail_body));
						} else {
							$mail_body=$Mail->formatNewHtmlMail(nl2br(htmlspecialchars($bodyar['text'])),$addBodyB,$addBodyE,GE_CHARSET);
						}
						$mail_body=$Mail->addHtmlImages($mail_body,$cid);
					} else {
						$mail_body=$CFG['NL_MAIL'].$CFG['NL_MAIL'].$CFG['NL_MAIL'].$signatur;
						$mail_body.=$CFG['NL_MAIL'].$CFG['NL_MAIL']."--------".htmlspecialchars(Framework::convertCharset(implode(', ',$Mail->formatMail($Mobj->getMail('From'),0,1)),GE_CHARSET,$html_charset))." wrote--------";
						$mail_body.=$CFG['NL_MAIL']."Subject: ".$Mail->mail_enc($Mobj->getName());
						$mail_body.=$CFG['NL_MAIL']."Date: ".date('d.m.Y H:i',$Mobj->getMeta('Date')).$CFG['NL_MAIL'].$CFG['NL_MAIL'];
						$mail_body.= '>'.str_replace($CFG['NL_MAIL'],$CFG['NL_MAIL'].'>',wordwrap($bodyar['text'],74,$CFG['NL_MAIL']));
					}
					$setEditorFocus=true;
				break;
				case 'fwd':
					$subject="FWD: ".$Mail->mail_enc($Mobj->getName());

					if ($use_wysiwyg) {
						//debug($html_charset);
						$addBodyB=$emptyRow.$emptyRow.'<!--BEGIN SIGNATUR--><div id="groupeMailSign" class="mceNonEditable">'.$signatur_html.'</div><!--END SIGNATUR-->';
						$addBodyB.=$emptyRow.$emptyRow.$emptyRowB."--------Original Message--------".$emptyRowE;
						$addBodyB.=$emptyRowB."Subject: ".Framework::convertCharset($Mail->mail_enc($Mobj->getName()),GE_CHARSET,$html_charset).$emptyRowE;
						$addBodyB.=$emptyRowB."Date: ".date('d.m.Y H:i',$Mobj->getMeta('Date')).$emptyRowE;
						$addBodyB.=$emptyRowB."From: ".htmlspecialchars($from_emails[0]).$emptyRowE;
						if (is_array($Mobj->getMail('To'))) {
							$addBodyB.=$emptyRowB."To: ".htmlspecialchars(Framework::convertCharset(implode(', ',$Mail->formatMail($Mobj->getMail('To'),0,1)),GE_CHARSET,$html_charset)).$emptyRowE;
						}
						if (is_array($Mobj->getMail('Cc'))) {
							$addBodyB.=$emptyRowB."Cc: ".htmlspecialchars(Framework::convertCharset(implode(', ',$Mail->formatMail($Mobj->getMail('Cc'),0,1)),GE_CHARSET,$html_charset)).$emptyRowE;
						}
						if (is_array($Mobj->getMail('Bcc'))) {
							$addBodyB.=$emptyRowB."Bcc: ".htmlspecialchars(Framework::convertCharset(implode(', ',$Mail->formatMail($Mobj->getMail('Bcc'),0,1)),GE_CHARSET,$html_charset)).$emptyRowE;
						}
						$addBodyB.=$emptyRow;

						$addBodyB.='<blockquote style="border-left:2px solid #00F;margin:0 0 0 10px;padding:0 0 0 5px;">';
						$addBodyE='</blockquote>';
						if (isset($bodyar['html'])) {
							
							$bodyar['html']=$Mail->convertHtml($bodyar['html'],$html_charset);
							//debug(htmlspecialchars($bodyar['html']));
							if ($bodyar['text'] && !$bodyar['alt']) {
								$bodyar['html']=$Mail->convertHtml(nl2br(htmlspecialchars($bodyar['text'])),GE_CHARSET).'<hr />'.$bodyar['html'];
							}
							$mail_body=$Mail->formatNewHtmlMail($Mail->removeMailSignID($bodyar['html']),$addBodyB,$addBodyE,$html_charset);
						} else {
							$mail_body=$Mail->formatNewHtmlMail(nl2br(htmlspecialchars($bodyar['text'])),$addBodyB,$addBodyE,GE_CHARSET);
						}
						//debug($cid);
						$mail_body=$Mail->addHtmlImages($mail_body,$cid);
						//debug(($mail_body));
					} else {
						$mail_body=$CFG['NL_MAIL'].$CFG['NL_MAIL'].$CFG['NL_MAIL'].$signatur;
						$mail_body.=$CFG['NL_MAIL'].$CFG['NL_MAIL']."--------Original Message--------";
						$mail_body.=$CFG['NL_MAIL']."Subject: ".$Mail->mail_enc($Mobj->getName());
						$mail_body.=$CFG['NL_MAIL']."Date: ".date('d.m.Y H:i',$Mobj->getMeta('Date'));
						$mail_body.=$CFG['NL_MAIL']."From: ".$from_emails[0];
						if (is_array($Mobj->getMail('To'))) {
							$mail_body.=$CFG['NL_MAIL']."To: ".implode(', ',$Mail->formatMail($Mobj->getMail('To'),0,1));
						}
						if (is_array($Mobj->getMail('Cc'))) {
							$mail_body.=$CFG['NL_MAIL']."Cc: ".implode(', ',$Mail->formatMail($Mobj->getMail('Cc'),0,1));
						}
						if (is_array($Mobj->getMail('Bcc'))) {
							$mail_body.=$CFG['NL_MAIL']."Bcc: ".implode(', ',$Mail->formatMail($Mobj->getMail('Bcc'),0,1));
						}
						$mail_body.=$CFG['NL_MAIL'].$CFG['NL_MAIL'];

						$mail_body.= '>'.str_replace($CFG['NL_MAIL'],$CFG['NL_MAIL'].'>',wordwrap($bodyar['text'],74,$CFG['NL_MAIL']));
					}
					$setEditorFocus=true;
				break;
				case 'edit':
				case 'draft':
					$subject=$Mail->mail_enc($Mobj->getName());
					if ($use_wysiwyg) {
						$addBodyB="";
						$addBodyE='';
						if (isset($bodyar['html'])) {
							$mail_body=$Mail->formatNewHtmlMail($bodyar['html'],$addBodyB,$addBodyE,$html_charset);
						} else {
							$mail_body=$Mail->formatNewHtmlMail($emptyRowB.str_replace("\n",$emptyRowE.$emptyRowB,htmlspecialchars($bodyar['text'])).$emptyRowE,$addBodyB,$addBodyE,GE_CHARSET);
						}
						$mail_body=$Mail->addHtmlImages($mail_body,$cid);
					} else {
						$mail_body=$bodyar['text'];
					}
				break;
			}
		}
	}
}
$t->assign('FOCUS_FIELD','');
if ($setEditorFocus) {
	$t->assign('MAIL_FOCUS','mail_body');
} else {
	$t->assign('MAIL_FOCUS','send_to');
}
$frm->addOnload('setNewMailFocus();');



if ((empty($_POST) && $mode!='draft' && !$_noLoad) || $getUserBody || $getUserSubject || $getUserFmng || $getUserSmb || $getUserTO || $getUserCC || $getUserBCC || $getUserPer || $f_url) {
	$temp_mail=$Mail->getEmail();
	if ($temp_mail) {
		$send_to=$temp_mail['TO'];
		$send_to_cc=$temp_mail['CC'];
		$send_to_bcc=$temp_mail['BCC'];
		$subject=$temp_mail['Subject'];
		$mail_body=$temp_mail['Body'];
		$identity=$temp_mail['identity'];
		$copyto=$temp_mail['copyto'];
		$mailExtra=$temp_mail['extra']?unserialize($temp_mail['extra']):array();
		$read_confirm=$temp_mail['read_confirm'];
		if ($mailExtra['wysiwyg']) {
			$use_wysiwyg=true;
		}
	} else {
		if ($mail_draft=$frm->getPrefs('email','mail_draft')) {
			$tmp=explode('||',$mail_draft);
			$Mobj=$Mail->getMailObj($tmp[0],$tmp[1]);
			if (is_object($Mobj)) {
				$tm_send_to=$tm_send_to_cc=$tm_send_to_bcc=$from_emails=array();
				require("lib/mail/classMailDecode.php");
				$MDec=new MailDecode($Mail);
				$bodyar=$MDec->getBody($tmp[0],$Mobj,0,false,true);
				//debug($bodyar['text']);
				if (!isset($bodyar['text']) && isset($bodyar['html'])) {
					if ($comp_wysiwyg) $use_wysiwyg=true;
					$h2t =& new html2text($bodyar['html']);
					$bodyar['text']=Framework::convertCharset($h2t->get_text(),'HTML-ENTITIES');
				}
				$frm->convertLineEndings($bodyar['text'],$CFG['NL_MAIL']);
				if (is_array($Mobj->getMail('From'))) {
					$from_emails=$Mail->formatMail($Mobj->getMail('From'),0,1);
				}
				if (is_array($Mobj->getMail('To'))) {
					$emails=$Mail->formatMail($Mobj->getMail('To'),0,1);
					$tm_send_to=array_merge($tm_send_to,$emails);
				}
				if (is_array($Mobj->getMail('Cc'))) {
					$emails=$Mail->formatMail($Mobj->getMail('Cc'),0,1);
					$tm_send_to_cc=array_merge($tm_send_to_cc,$emails);
				}
				if (is_array($Mobj->getMail('Bcc'))) {
					$emails=$Mail->formatMail($Mobj->getMail('Bcc'),0,1);
					$tm_send_to_bcc=array_merge($tm_send_to_bcc,$emails);
				}
				$FullHeader=$Mail->parseFullHeader($tmp[0],$Mobj->getID(),1);
				if ($Mail->getCfg('cfg/all/allow_notification')) {
					if ($FullHeader['disposition-notification-to'])	$read_confirm=1; else $read_confirm=0;
				}
				if ($FullHeader['x-group-e-copyto']) $copyto=trim($FullHeader['x-group-e-copyto']);
				$new_identity=array_search($from_emails[0],$identity_array);
				if ($new_identity) $identity=$new_identity;

				$send_to=implode(',',$tm_send_to);
				$send_to_cc=implode(',',$tm_send_to_cc);
				$send_to_bcc=implode(',',$tm_send_to_bcc);
				$cid=array();
				if($bodyar['att']){
					foreach($bodyar['att'] as $var) {
						if ($var['id'] && $use_wysiwyg) {
							$type=$var['type'];
							$size=$var['size'];
							$name=$Mail->mail_enc($var['name']);
							$name=strtr($name,'/,|','-__');
							if (!$name) $name='no_name';
							$n_name=$name;$i=1;
							while(file_exists($Mail->getAttachPath()."/".$n_name)) {
								$n_name=$i.'_'.$name;
								$i++;
							}
							$fhandle=fopen($Mail->getAttachPath()."/".$n_name,'w+');
							fputs($fhandle,$Mail->getAttachment($tmp[0], $Mobj->getID(),  $var['part'],$var['enc']));
							fclose($fhandle);

							$duplicate=false;
							if ($n_name!=$name) {
								if (Framework::getMd5Sum($Mail->getAttachPath()."/".$n_name)==Framework::getMd5Sum($Mail->getAttachPath()."/".$name)) {
									$duplicate=true;
									unlink($Mail->getAttachPath()."/".$n_name);
								} else {
									$name=$n_name;
								}
							}
							$src=Framework::getSelfDir().'/fetch_mail_img.php?img='.urlencode($name);
							if (!$duplicate) $Mail->addEmailAttachments(array('Name'=>$name,'Size'=>$size,'Type'=>$type,'Cid'=>preg_replace('/[<>]/','',$var['id']),'Source'=>$src));
							$cid[preg_replace('/[<>]/','',$var['id'])]=$src;
						} else {
							$type=$var['type'];
							$name=$Mail->mail_enc($var['name']);
							$size=$var['size'];
							$name=strtr($name,'/,|','-__');
							if (GE_CHARSET=='UTF-8') {
								$name=Framework::getUtf8Encoded($name);
							}
							if (!$name) $name='no_name';
							$fhandle=fopen($Mail->getAttachPath()."/".$name,'w+');
							fputs($fhandle,$Mail->getAttachment($tmp[0], $Mobj->getID(),  $var['part'],$var['enc']));
							fclose($fhandle);
							$Mail->addEmailAttachments(array('Name'=>$name,'Size'=>$size,'Type'=>$type));
						}
					}
				}
				$subject=$Mail->mail_enc($Mobj->getName());
				if ($use_wysiwyg) {
					$addBodyB="";
					$addBodyE='';
					if (isset($bodyar['html'])) {
						$html_charset=$Mail->getHtmlCharset($bodyar['html'],$bodyar['html_charset']);
						$mail_body=$Mail->formatNewHtmlMail($bodyar['html'],$addBodyB,$addBodyE,$html_charset);
					} else {
						$mail_body=$Mail->formatNewHtmlMail($emptyRowB.str_replace("\n",$emptyRowE.$emptyRowB,htmlspecialchars($bodyar['text'])).$emptyRowE,$addBodyB,$addBodyE,GE_CHARSET);
					}
					$mail_body=$Mail->addHtmlImages($mail_body,$cid);
				} else {
					$mail_body=$bodyar['text'];
				}
			}
 		}
	}
	if ($getUserBody) {
		if ($use_wysiwyg) {
			//debug($frm->getUserData('mail',$getUserBody));
			$mail_body=$Mail->formatNewHtmlMail($emptyRowB.preg_replace("/(\r|\n)+/",$emptyRowE.$emptyRowB,$Mail->addWebLink(htmlspecialchars($frm->getUserData('mail',$getUserBody)))).$emptyRow.$emptyRow.'<!--BEGIN SIGNATUR--><div id="groupeMailSign" class="mceNonEditable">'.$signatur_html.'</div><!--END SIGNATUR-->','','',GE_CHARSET);
		} else {
			$mail_body="\n\n".$frm->getUserData('mail',$getUserBody)."\n\n".$signatur;
		}
	}
	if ($getUserSubject) {
		$subject=$frm->getUserData('mail',$getUserSubject);
	}
	if ($getUserFmng) {
		$fmng_id=unserialize($frm->getUserData('mail',$getUserFmng));
	}
	if ($getUserSmb) {
		$smb_id=unserialize($frm->getUserData('mail',$getUserSmb));
	}
	if ($getUserTO) {
		if ($send_to) $send_to.=', ';
		$send_to.=$frm->getUserData('mail',$getUserTO);
	}
	if ($add_to) {
		if ($send_to) $send_to.=', ';
		$send_to.=$add_to;
	}
	if ($_GET['copyto']) {
		$copyto=$_GET['copyto'];
	}


	if ($getUserCC) {
		if ($send_to_cc) $send_to_cc.=', ';
		$send_to_cc.=$frm->getUserData('mail',$getUserCC);
	}
	if ($getUserBCC) {
		if ($send_to_bcc) $send_to_bcc.=', ';
		$send_to_bcc.=$frm->getUserData('mail',$getUserBCC);
	}
	if ($getUserPer) {
		$Mail->updateHotlist($frm->getUserData('mail',$getUserPer),'per');
	}
}

if ($Mail->getCfg('cfg/all/allow_wysiwyg')) {
	if ($use_wysiwyg) {
		$t->parse('ROW','switch_txt');
	} else {
		$t->parse('ROW','switch_html');
	}
}

if ($Mail->getPrefs("replyto".$identity)) $replyto=$Mail->getPrefs("replyto".$identity); else $replyto=$Mail->getPrefs("email".$identity);
$t->assign('OLD_SIGN',$identity);

// Wenn ein neues Attachment dazukommt
if($attach_x || $fmng_id || $smb_id || $f_url) {
	if(!is_dir($Mail->getAttachPath())) mkdir ($Mail->getAttachPath(), 0755);
	if ($fmng_id) {
		require_once("lib/fmng/header.php");
		if (!is_array($fmng_id)) $fmng_id=array($fmng_id);
		foreach ($fmng_id as $fid) {
			$Fobj=$Fmng->getObj($fid);
			if (is_object($Fobj) && $Fobj->getAcl(1) && $Fobj->getFileMeta('FilePath') && file_exists($Fobj->getFileMeta('FilePath'))) {
				$F_name=strtr($Fobj->getName($session_lang),'|,/','__');
				preg_match('/([.].+)$/',basename($Fobj->getFileMeta('FilePath')),$ext);
				if (!preg_match('/'.preg_quote($ext[1],'/').'$/',$F_name)) {
					$F_name.=$ext[1];
				}
				copy($Fobj->getFileMeta('FilePath'),$Mail->getAttachPath()."/".$F_name);
				$F_size=$Fobj->getFileMeta('FileSize');
				$F_type=$Fobj->getFileMeta('MimeType');
				if (!$F_type) $F_type=$frm->getMimeFile($Fobj->getFileMeta('FilePath'));
				$Mail->addEmailAttachments(array('Name'=>$F_name,'Size'=>$F_size,'Type'=>$F_type));
			}
		}
	} elseif ($smb_id) {
		$Smb=& $frm->getStaticModul('smb');
		if (!is_array($smb_id)) $smb_id=array($smb_id);
		foreach ($smb_id as $fid) {
			$Fobj=$Smb->getObj($fid);
			if (is_object($Fobj)) {
				$F_name=strtr($Fobj->getName(),'|,/','__');
				if (!$Smb->copyFileLocal($Fobj,$Mail->getAttachPath()."/".$F_name)) {
					$Mail->addEmailAttachments(array('Name'=>$F_name,'Size'=>$Fobj->getMeta('size'),'Type'=>$Fobj->getMeta('mime')));
				}
			}
		}
	} elseif ($f_url) {
		$f_url=str_replace('..','',$f_url);
		if (preg_match('/^(dyn|'.preg_quote(Framework::getTempPath(),'/').')\//',$f_url) && file_exists($f_url)) {
			$F_name=$f_name;
			$F_type=$f_type;
			$F_size=filesize($f_url);
			copy($f_url,$Mail->getAttachPath()."/".$F_name);
			$Mail->addEmailAttachments(array('Name'=>$F_name,'Size'=>$F_size,'Type'=>$F_type));
		}
	} else {
		if (is_array($_FILES['userfile']['name'])) {
			 for($i=0;$i<count($_FILES['userfile']['name']);++$i){
				$_FILES['userfile']['name'][$i]=str_replace('/','_',$_FILES['userfile']['name'][$i]);
				if (!$frm->scanFile($_FILES['userfile']['tmp_name'][$i]) && move_uploaded_file($_FILES['userfile']['tmp_name'][$i], $Mail->getAttachPath()."/".$_FILES['userfile']['name'][$i])) {
					$F_name=$_FILES['userfile']['name'][$i];
					$F_type=preg_replace('/;.*$/','',$_FILES['userfile']['type'][$i]);
					$F_size=$_FILES['userfile']['size'][$i];
					$Mail->addEmailAttachments(array('Name'=>$F_name,'Size'=>$F_size,'Type'=>$F_type));
				}
			}
		} else {
			if (!$frm->scanFile($_FILES['userfile']['tmp_name']) && move_uploaded_file($_FILES['userfile']['tmp_name'], $Mail->getAttachPath()."/".$_FILES['userfile']['name'])) {
				$F_name=$_FILES['userfile']['name'];
				$F_type=preg_replace('/;.*$/','',$_FILES['userfile']['type']);
				$F_size=$_FILES['userfile']['size'];
				$Mail->addEmailAttachments(array('Name'=>$F_name,'Size'=>$F_size,'Type'=>$F_type));
			}
		}
	}
}

// Att. loeschen
if (isset($delete)) {
	$attach_del=key($delete);
	$file=$Mail->readEmailAttachment($attach_del);
	if ($file['Name'] && file_exists($Mail->getAttachPath().'/'.$file['Name'])) {
		unlink($Mail->getAttachPath().'/'.$file['Name']);
	}
	$Mail->deleteEmailAttachments($attach_del);
}


if(isset($send_x)){
	$bccChunks=array();
	$send_to_bcc=trim($send_to_bcc);
	if($send_to_bcc) {
		if ($Mail->getCfg('cfg/all/check_mail')) {
			$msend=array();
			$mail_check=$mCheck->parseAddressList($send_to_bcc);
			if (!$mail_check) {
				foreach ($mCheck->getErrorAddr() as $val) {
					$ActionError["send_bcc"][]=$val['address'];
				}
				if (!$ActionError["send_bcc"]) $ActionError["send_bcc"]=$mCheck->error;
				//debug($ActionError["send_bcc"]);
			} else {
				foreach ($mail_check as $val) {
					$msend[]=$Mail->formatMail($val,0,1);
				}
				$send_to_bcc=implode(',',$msend);
				$bccChunks=array_chunk($msend,1000);
			}
		 }
	}
	$send_to_cc=trim($send_to_cc);
 	if($send_to_cc) {
		if ($Mail->getCfg('cfg/all/check_mail')) {
			$msend=array();
			$mail_check=$mCheck->parseAddressList($send_to_cc);
			if (!$mail_check) {
				foreach ($mCheck->getErrorAddr() as $val) {
					$ActionError["send_cc"][]=$val['address'];
				}
				if (!$ActionError["send_cc"]) $ActionError["send_cc"]=$mCheck->error;
				//debug($ActionError["send_bcc"]);
			} else {
				foreach ($mail_check as $val) {
					$msend[]=$Mail->formatMail($val,0,1);
				}
				$send_to_cc=implode(',',$msend);
			}
		}
	}
	$send_to=trim($send_to);
	if($send_to) {
		if ($Mail->getCfg('cfg/all/check_mail')) {
			$msend=array();
			$mail_check=$mCheck->parseAddressList($send_to);

			if (!$mail_check) {
				foreach ($mCheck->getErrorAddr() as $val) {
					$ActionError["send_to"][]=$val['address'];
				}
				if (!$ActionError["send_to"]) $ActionError["send_to"]=$mCheck->error;
			} else {
				foreach ($mail_check as $val) {
					$msend[]=$Mail->formatMail($val,0,1);
				}

				$send_to=implode(',',$msend);
			}
		}
		if (strlen($send_to)>2040) {
			$ActionError["send_to_len"]=1;
		}
	}
	if (!$send_to) {
		$ActionError["no_send_to"]=1;
	}
	if(!$Mail->getPrefs("email".$identity)) $ActionError["no_from"]=1;
	if (!$ActionError) {
		//debugtime('B');
		require_once('lib/mail/mimePart.php');
		require_once('lib/mail/mime.php');
		$personal=$Mail->getPrefs("fullname".$identity);
		$mailbox=substr($Mail->getPrefs("email".$identity),0,strpos($Mail->getPrefs("email".$identity),'@'));
		$host=substr($Mail->getPrefs("email".$identity),strpos($Mail->getPrefs("email".$identity),'@')+1);

		$smail=new Mail_mime($CFG['NL_MAIL']);
		$params=array(
			'text_encoding'=>'8bit',
			'html_charset'=>GE_CHARSET,
			'text_charset'=>GE_CHARSET,
			'head_charset'=>GE_CHARSET,
		);
		$headers=array(
			'From'=>imap_rfc822_write_address($mailbox,$host,$personal),
			'Subject'=>$subject?$subject:'no subject',
			'Reply-To'=>$replyto,
			'To'=>$send_to,
			'X-Priority'=>'3 (Normal)',
		);
		if (trim($send_to_cc)) {
			$headers['Cc']=$send_to_cc;
		}
		if (trim($send_to_bcc)) {
			$headers['Bcc']=$send_to_bcc;
		}

		if ($Mail->getCfg('cfg/all/allow_notification') && $read_confirm) {
			$headers["Disposition-Notification-To"] = $replyto;
		}
		$temp_body=$mail_body;
		$temp_body=str_replace('<!--BEGIN SIGNATUR-->','',$temp_body);
		$temp_body=str_replace('<!--END SIGNATUR-->','',$temp_body);


		$att=$Mail->getEmailAttachments();

		foreach($att as $val){
			//debug($val);
			if ($val['Cid'] && $val['Source'] && file_exists($Mail->getAttachPath()."/".$val['Name']) && preg_match('/'.preg_quote(basename($val['Source']),'/').'/',$temp_body)) {
				//debug('ERSETZEN:'.$val[4].'----'.$val[0]);
				$temp_body=preg_replace('/'.preg_quote($val['Source'],'/').'/',$val['Name'],$temp_body);
				//debug('ADDIMAGE:'.$Mail->getAttachPath()."/".$val[0].'---'.$val[2]);
				$smail->addHTMLImage($Mail->getAttachPath()."/".$val['Name'], $val['Type']);
			} elseif ($val['Name']) {
				$smail->addAttachment( $Mail->getAttachPath()."/".$val['Name'], $val['Type']);
				if ($val['Type']=='application/ics' && $val['Name']=='invite.ics' && file_exists($Mail->getAttachPath()."/".$val['Name'])) {
					$smail->addAlternativeContent(implode('',file($Mail->getAttachPath()."/".$val['Name'])),'text/calendar','7bit','UTF-8','REQUEST');
				}
			}
		}
		//exit;
		if ($use_wysiwyg) {
			$temp_body=$Mail->formatNewHtmlMail($temp_body,'','',GE_CHARSET,'<style>p {margin:0;padding:0;}</style>');
			$matches=array();
			$regex='/[^=("\']*fetch_mail_img.php\?img=(.+\.(jpg|gif|jpeg|png))/i';
			if (preg_match_all($regex,$temp_body,$matches,PREG_SET_ORDER)) {
				//debug($matches);
				foreach ($matches as $val) {
					//debug($Mail->getAttachPath()."/".$val[1]);
					if (file_exists($Mail->getAttachPath()."/".$val[1])) {
						//debug('ERSETZEN:'.$val[0].'----'.$val[1]);
						//falls Signatur Bild
						$name=basename($val[1]);
						if ($name!=$val[1]) {
							$n_name=$name;$i=1;
							while(file_exists($Mail->getAttachPath()."/".$n_name)) {
								$n_name=$i.'_'.$name;
								$i++;
							}
							copy($Mail->getAttachPath()."/".$val[1],$Mail->getAttachPath()."/".$n_name);
							//debug('N_NAME:'.$n_name);
							$duplicate=false;
							if ($n_name!=$name) {
								if (Framework::getMd5Sum($Mail->getAttachPath()."/".$n_name)==Framework::getMd5Sum($Mail->getAttachPath()."/".$name)) {
									$duplicate=true;
									unlink($Mail->getAttachPath()."/".$n_name);
								} else {
									$name=$n_name;
								}
							}
							//debug('DUPLICATE:'.$duplicate);
						}
						
						$temp_body=preg_replace('/'.preg_quote($val[0],'/').'/',$name,$temp_body);
						//debug('ADDIMAGE:'.$Mail->getAttachPath()."/".$val[1].'---'.$frm->getMimeFile($Mail->getAttachPath()."/".$val[1]));
						if (!$duplicate) {
							$smail->addHTMLImage($Mail->getAttachPath()."/".$name,$frm->getMimeFile($Mail->getAttachPath()."/".$name));
						}
					}
				}
			}
			//exit;
			
			$h2t = new html2text($temp_body);
			$temp_txt=Framework::convertCharset($h2t->get_text(),'HTML-ENTITIES');
			$smail->setTXTBody($temp_txt);      // set the body
			$smail->setHTMLBody($temp_body);      // set the body
		} else {
			$smail->setTXTBody($temp_body);      // set the body
		}
		$snd_body = $smail->get($params);
		$snd_hdrs = $smail->headers($headers);
		$subject=$snd_hdrs['Subject'];
		$to=$snd_hdrs['To'];
		$mail_hdrs = $snd_hdrs;
		unset($mail_hdrs['Subject']);
		unset($mail_hdrs['To']);
		//debug(htmlentities($subject));
		//debug(htmlentities($snd_body));
		if (strlen($to)>2040) {
			$ActionError["send_to_len"]=1;
		} else {
			$copyto=trim($_POST['hid_FcopyTo'])?substr($_POST['hid_FcopyTo'],2):0;
			if (!empty($bccChunks) && count($bccChunks)>1) {
				$append_body=$snd_body;
				Framework::convertLineEndings($append_body,"\r\n");
				foreach ($bccChunks as $bcc_chunk) {
					$snd_hdrs['Bcc']=$mail_hdrs['Bcc']=implode(',',$bcc_chunk);
					$OK=mail($to,$subject,$snd_body,$Mail->headersToTxt($mail_hdrs,$CFG['NL_MAIL']),'-f'.imap_rfc822_write_address($mailbox,$host,''));
					if ($OK && ($copyto || $Mail->getReadOnlyID())) {
						$snd_hdrs["Date"]=date('r');
						$mail_headers=$Mail->headersToTxt($snd_hdrs,$CFG['NL_MAIL']);
						Framework::convertLineEndings($mail_headers,"\r\n");
						//debugtime('E');
						if ($copyto) $Mail->appendMail($copyto,$mail_headers."\r\n"."\r\n".$append_body."\r\n","\\Seen");
						if ($Mail->getReadOnlyID()) $Mail->appendMail($Mail->getReadOnlyID(),$mail_headers."\r\n"."\r\n".$append_body."\r\n","\\Seen");
						//debugtime('E');
					}
				}
				unset($snd_hdrs,$snd_body,$mail_headers);
			} else {
				$OK=mail($to,$subject,$snd_body,$Mail->headersToTxt($mail_hdrs,$CFG['NL_MAIL']),'-f'.imap_rfc822_write_address($mailbox,$host,''));
				if ($OK && ($copyto || $Mail->getReadOnlyID())) {
					$snd_hdrs["Date"]=date('r');
					$mail_headers=$Mail->headersToTxt($snd_hdrs,$CFG['NL_MAIL']);
					Framework::convertLineEndings($mail_headers,"\r\n");
					Framework::convertLineEndings($snd_body,"\r\n");
					//debugtime('E');
					if ($copyto) $Mail->appendMail($copyto,$mail_headers."\r\n"."\r\n".$snd_body."\r\n","\\Seen");
					if ($Mail->getReadOnlyID()) $Mail->appendMail($Mail->getReadOnlyID(),$mail_headers."\r\n"."\r\n".$snd_body."\r\n","\\Seen");
					//debugtime('E');
					unset($snd_hdrs,$snd_body,$mail_headers);
				}
			}
			if ($OK) {
				//debugmem();
				//debug($smail->getMail());
				//debugmem();
				if ($mid) {
					switch ($mode) {
						case 'reply':
						case 'reply_all':
						case 'fwd':
							$Mail->setFlag($obj->getBox(),$mid,"\\Answered");
						break;
						case 'edit':
						case 'draft':
						break;

					}
					if ($copyto && Framework::getParam('FmoveOrig',0,'P')) {
						$ActionError=$Mail->moveMail($obj->getBox(),$mid,$copyto);
						if (!$ActionError) {
							$Mail->expungeBox($obj->getBox());
						}
					}

				}
				$Mail->deleteEmail();
				$Mail->deleteAttachment();
				$hot_mails=$send_to;
				if ($send_to_cc) $hot_mails.=', '.$send_to_cc;
				//if ($send_to_bcc) $hot_mails.=', '.$send_to_bcc;
				$Mail->updateHotlist($hot_mails);
				page_close();
				//debugmem();
				if ($H_REFERER[intval($back)]) {
					header('Location:'.$H_REFERER[intval($back)]);
				} else {
					header("Location:index.php?site=$site");
				}
				exit;
			} else $ActionError['not_send']=true;
		}
	}
}

//Mail als Entwurf ablegen
if(isset($draft_x)){
	$send_to_bcc=trim($send_to_bcc);
	if($send_to_bcc) {
		if ($Mail->getCfg('cfg/all/check_mail')) {
			$msend=array();
			$mail_check=$mCheck->parseAddressList($send_to_bcc);
			if (!$mail_check) {
				foreach ($mCheck->getErrorAddr() as $val) {
					$ActionError["send_bcc"][]=$val['address'];
				}
				if (!$ActionError["send_bcc"]) $ActionError["send_bcc"]=$mCheck->error;
				//debug($ActionError["send_bcc"]);
			} else {
				foreach ($mail_check as $val) {
					$msend[]=$Mail->formatMail($val,0,1);
				}
				$send_to_bcc=implode(',',$msend);
			}
		 }
	}
	$send_to_cc=trim($send_to_cc);
 	if($send_to_cc) {
		if ($Mail->getCfg('cfg/all/check_mail')) {
			$msend=array();
			$mail_check=$mCheck->parseAddressList($send_to_cc);
			if (!$mail_check) {
				foreach ($mCheck->getErrorAddr() as $val) {
					$ActionError["send_cc"][]=$val['address'];
				}
				if (!$ActionError["send_cc"]) $ActionError["send_cc"]=$mCheck->error;
				//debug($ActionError["send_bcc"]);
			} else {
				foreach ($mail_check as $val) {
					$msend[]=$Mail->formatMail($val,0,1);
				}
				$send_to_cc=implode(',',$msend);
			}
		}
	}
	$send_to=trim($send_to);
	if($send_to) {
		if ($Mail->getCfg('cfg/all/check_mail')) {
			$msend=array();
			$mail_check=$mCheck->parseAddressList($send_to);
			if (!$mail_check) {
				foreach ($mCheck->getErrorAddr() as $val) {
					$ActionError["send_to"][]=$val['address'];
				}
				if (!$ActionError["send_to"]) $ActionError["send_to"]=$mCheck->error;
			} else {
				foreach ($mail_check as $val) {
					$msend[]=$Mail->formatMail($val,0,1);
				}
				$send_to=implode(',',$msend);
			}
		}
		if (strlen($send_to)>2040) {
			$ActionError["send_to_len"]=1;
		}
	}
	if (!$ActionError) {
		require_once('lib/mail/mimePart.php');
		require_once('lib/mail/mime.php');
		$personal=$Mail->getPrefs("fullname".$identity);
		$mailbox=substr($Mail->getPrefs("email".$identity),0,strpos($Mail->getPrefs("email".$identity),'@'));
		$host=substr($Mail->getPrefs("email".$identity),strpos($Mail->getPrefs("email".$identity),'@')+1);

		$smail=new Mail_mime($CFG['NL_MAIL']);
		$params=array(
			'text_encoding'=>'8bit',
			'html_charset'=>GE_CHARSET,
			'text_charset'=>GE_CHARSET,
			'head_charset'=>GE_CHARSET,
		);
		$copyto=trim($_POST['hid_FcopyTo'])?substr($_POST['hid_FcopyTo'],2):0;
		$headers=array(
			'From'=>imap_rfc822_write_address($mailbox,$host,$personal),
			'Subject'=>$subject?$subject:'no subject',
			'Cc'=>$send_to_cc,
			'Bcc'=>$send_to_bcc,
			'Reply-To'=>$replyto,
			'To'=>$send_to,
			'X-Group-e-copyto'=>$copyto,
			'X-Group-e-html'=>$use_wysiwyg,
		);
		if ($Mail->getCfg('cfg/all/allow_notification') && $read_confirm) {
			$headers["Disposition-Notification-To"] = $replyto;
		}
		$temp_body=$mail_body;
		$att=$Mail->getEmailAttachments();
		foreach($att as $val){
			if ($val['Cid'] && $val['Source'] && file_exists($Mail->getAttachPath()."/".$val['Name']) && preg_match('/'.preg_quote($val['Source'],'/').'/',$temp_body)) {
				$temp_body=preg_replace('/'.preg_quote($val['Source'],'/').'/',$val['Name'],$temp_body);
				$smail->addHTMLImage( $Mail->getAttachPath()."/".$val['Name'], $val['Type']);
			} elseif ($val['Name']) {
				$smail->addAttachment( $Mail->getAttachPath()."/".$val['Name'], $val['Type']);
			}
		}
		if ($use_wysiwyg) {
			$temp_body=$Mail->formatNewHtmlMail($temp_body,'','',GE_CHARSET);
			$matches=array();
			$regex='/[^=("\']*fetch_mail_img.php\?img=(.+\.(jpg|gif|jpeg|png))/i';
			if (preg_match_all($regex,$temp_body,$matches,PREG_SET_ORDER)) {
				foreach ($matches as $val) {
					if (file_exists($Mail->getAttachPath()."/".$val[1])) {
						//debug('ERSETZEN:'.$val[0].'----'.$val[1]);
						$name=basename($val[1]);
						if ($name!=$val[1]) {
							$n_name=$name;$i=1;
							while(file_exists($Mail->getAttachPath()."/".$n_name)) {
								$n_name=$i.'_'.$name;
								$i++;
							}
							copy($Mail->getAttachPath()."/".$val[1],$Mail->getAttachPath()."/".$n_name);
							//debug('N_NAME:'.$n_name);
							$duplicate=false;
							if ($n_name!=$name) {
								if (Framework::getMd5Sum($Mail->getAttachPath()."/".$n_name)==Framework::getMd5Sum($Mail->getAttachPath()."/".$name)) {
									$duplicate=true;
									unlink($Mail->getAttachPath()."/".$n_name);
								} else {
									$name=$n_name;
								}
							}
							//debug('DUPLICATE:'.$duplicate);
						}
						$temp_body=preg_replace('/'.preg_quote($val[0],'/').'/',$name,$temp_body);
						//debug('ADDIMAGE:'.$Mail->getAttachPath()."/".$val[1].'---'.$frm->getMimeFile($Mail->getAttachPath()."/".$val[1]));
						if (!$duplicate) {
							$smail->addHTMLImage($Mail->getAttachPath()."/".$name,$frm->getMimeFile($Mail->getAttachPath()."/".$name));
						}
					}

				}
			}
			$h2t =& new html2text($temp_body);
			$temp_txt=Framework::convertCharset($h2t->get_text(),'HTML-ENTITIES');
			$smail->setTXTBody($temp_txt);      // set the body
			$smail->setHTMLBody($temp_body);      // set the body
		} else {
			$smail->setTXTBody($temp_body);      // set the body
		}

		$snd_body = $smail->get($params);
		$snd_hdrs = $smail->headers($headers);
		$mail_headers=$Mail->headersToTxt($snd_hdrs,$CFG['NL_MAIL']);
		Framework::convertLineEndings($mail_headers,"\r\n");
		Framework::convertLineEndings($snd_body,"\r\n");

		if ($mode=='draft') $box=$obj->getBox(); else $box=$Mail->getDraftID();
		$ActionError=$Mail->appendMail($box,$mail_headers."\r\n"."\r\n".$snd_body."\r\n","\\Draft \\Seen");
		unset($snd_hdrs,$snd_body,$mail_headers);

		if (!$ActionError) {
			if ($mode=='draft' && $mid) {
				$Mail->deleteMail($obj->getBox(),$mid);
				$Mail->expungeBox($obj->getBox());
			}
			$Mail->deleteEmail();
			$Mail->deleteAttachment();
			page_close();
			if ($H_REFERER[intval($back)]) {
				header('Location:'.$H_REFERER[intval($back)]);
			} else {
				header("Location:index.php?site=$site");
			}
			exit;
		}
	}
}
if(isset($print_x)){
	$t=new mtFastTemplate ('.',$MASTER_TPL);
	$t->setRoot("tpl/$THEME/mail/$session_lang");
	$t->define (array('tpl_print' => "print_content.inc.html"));
	$send_to_bcc=trim($send_to_bcc);
	if($send_to_bcc) {
		$t->assign('S_MAIL','');
		$t->assign('N_MAIL',Framework::entities($send_to_bcc));
		$t->parse('ROW','.mail_bcc_row');
		$t->parse('ROW','mail_bcc');
	}
	$send_to_cc=trim($send_to_cc);
 	if($send_to_cc) {
		$t->assign('S_MAIL','');
		$t->assign('N_MAIL',Framework::entities($send_to_cc));
		$t->parse('ROW','.mail_cc_row');
		$t->parse('ROW','mail_cc');
	}
	$send_to=trim($send_to);
	if($send_to) {
		$t->assign('S_MAIL','');
		$t->assign('N_MAIL',Framework::entities($send_to));
		$t->parse('ROW','.mail_to_row');
		$t->parse('ROW','mail_to');
	}

	$personal=$Mail->getPrefs("fullname".$identity);
	$mailbox=substr($Mail->getPrefs("email".$identity),0,strpos($Mail->getPrefs("email".$identity),'@'));
	$host=substr($Mail->getPrefs("email".$identity),strpos($Mail->getPrefs("email".$identity),'@')+1);

	$from=imap_rfc822_write_address($mailbox,$host,$personal);
	$t->assign('S_MAIL','');
	$t->assign('N_MAIL',Framework::entities($from));
	$t->parse('ROW','.mail_from_row');

	$t->assign('MAIL_SUBJECT',FrameWork::entities($subject?$subject:'no subject'));
	$t->assign('MAIL_DATE', strftime("%A, %d.%m.%Y %H:%M",time()));
	$t->assign('MAIL_SIZE',0);

	$att=$Mail->getEmailAttachments();
	$numAtt=0;

	foreach($att as $val) {
		if ($val['Cid'] && preg_match('/'.preg_quote(basename($val['Source']),'/').'/',$mail_body)) continue;
		if ($val['Name']) {
			$t->assign('FILE_TYPE',Framework::entities($val['Type']));
			$t->assign('FILE_NAME',Framework::entities($val['Name']));
			$t->assign('FILE_SIZE',Framework::formatSize($val['Size']));
			$t->parse('ROW','.attach_row');
			$numAtt++;
		}
	}
	if ($numAtt) $t->parse('ROW','attach');

	$header="<style>\n";
	$header.="blockquote {border-left:2px solid #00F;margin-left:10px;padding-left:5px;}\n";
	$header.="p {margin:0;padding:0;}\n";
	$header.="</style>\n";
	$t->parse('TPL_PRINT','tpl_print');

	if (!$use_wysiwyg) {
		$frm->convertLineEndings($mail_body,"\n");
		$mail_body='<pre>'.htmlspecialchars($Mail->wrap($mail_body)).'</pre>';
	}
	$mail_body=$Mail->formatNewHtmlMail($mail_body,$t->getparsed('TPL_PRINT').'<div>','</div>',GE_CHARSET,$header);
	$PrintID=$frm->insertPrint('email','html',$mail_body);
	page_close();
	header("Location:print.php?PrintID=$PrintID&addHeaderToBody=1");
	exit;
}

if (isset($hot_to_x) || isset($hot_cc_x) || isset($hot_bcc_x)) {
	if (is_array($sel_hot)) {
		if (isset($hot_to_x)) {
			if ($send_to) $send_to.=', ';
			$send_to.=implode(',',$sel_hot);
		}elseif (isset($hot_cc_x)) {
			if ($send_to_cc) $send_to_cc.=', ';
			$send_to_cc.=implode(',',$sel_hot);
		}elseif (isset($hot_bcc_x)) {
			if ($send_to_bcc) $send_to_bcc.=', ';
			$send_to_bcc.=implode(',',$sel_hot);
		}

	}
}
if (isset($per_to_x) || isset($per_cc_x) || isset($per_bcc_x)) {
	if (is_array($sel_per)) {
		if (isset($per_to_x)) {
			if ($send_to) $send_to.=', ';
			$send_to.=implode(',',$sel_per);
		}elseif (isset($per_cc_x)) {
			if ($send_to_cc) $send_to_cc.=', ';
			$send_to_cc.=implode(',',$sel_per);
		}elseif (isset($per_bcc_x)) {
			if ($send_to_bcc) $send_to_bcc.=', ';
			$send_to_bcc.=implode(',',$sel_per);
		}

	}
}
//Hotlist Ausgeben
if (isset($hot_del_x)) {
        $Mail->deleteHotList($sel_hot);
}
//Hotlist Ausgeben
if (isset($per_del_x)) {
        $Mail->deleteHotList($sel_per,'per');
}
$hot_list=$Mail->getHotlist();
foreach ($hot_list as $key=>$val) {
	$t->assign('HOT_MAIL',htmlspecialchars($key));
	$t->assign('HOT_TEXT',htmlspecialchars($val));
	$t->parse('ROW','.hot_list');
}
if ($app['addr']) {
	$per_list=$Mail->getHotlist('per');
	foreach ($per_list as $key=>$val) {
		$t->assign('PER_MAIL',htmlspecialchars($key));
		$t->assign('PER_TEXT',htmlspecialchars($val));
		$t->parse('ROW','.per_list');
	}
	$t->parse('ROW','per_addr');
}

// MailList ausgeben


if ($app['addr'] || $Mail->getCfg('cfg/all/addr_list')) {
	$Addr=& $frm->getStaticModul('addr');
	if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
		$AddrList=& $frm->getStaticModul('addr_list');
		$rows=0;
		$mlist=$AddrList->listSearch($rows,false,true);
		if (count($mlist)) {
			$mlist_array[0]='-';
			foreach ($mlist as $key=>$val) {
				$mlist_array[$key]=$val->getName();
			}
			$sel_mlist=new SelectField('Mail_List','class="sel" style="width:245px"',$mlist_array);
			$t->assign('SEL_MLIST',$sel_mlist->f());
			$t->parse('ROW','mail_list');
			if ((isset($list_to_x) || isset($list_cc_x) || isset($list_bcc_x)) && $Mail_List) {
				require_once("lib/addr/func_SearchListLdap.php");
				$result=getSearchList($Addr,$Mail_List,'mail');
				foreach ($result as $key=>$val) {
					if (isset($list_to_x)) {
						if ($send_to) $send_to.=',';
						$send_to.=$val['data'];
					} elseif (isset($list_cc_x)) {
						if ($send_to_cc) $send_to_cc.=',';
						$send_to_cc.=$val['data'];
					}elseif (isset($list_bcc_x)) {
						if ($send_to_bcc) $send_to_bcc.=',';
						$send_to_bcc.=$val['data'];
					}
				}

			}
		}
	} else {
		$mlist=$Addr->listAddrSearch(1);
		if (count($mlist)) {
			$mlist_array[0]='-';
			foreach ($mlist as $key=>$val) {
				$mlist_array[$key]=$val['Title'];
			}
			$sel_mlist=new SelectField('Mail_List','class="sel" style="width:245px"',$mlist_array);
			$t->assign('SEL_MLIST',$sel_mlist->f());
			$t->parse('ROW','mail_list');
			if ((isset($list_to_x) || isset($list_cc_x) || isset($list_bcc_x)) && $Mail_List) {
				require_once("lib/addr/func_SearchList.php");
				if ($Mail->getCfg('cfg/all/addr_list')) $uperms=true; else $uperms=false;
				$result=getSearchList($Addr,$db,$Mail_List,'mail',$uperms);
				foreach ($result as $key=>$val) {
					if (isset($list_to_x)) {
						if ($send_to) $send_to.=',';
						$send_to.=$val['data'];
					} elseif (isset($list_cc_x)) {
						if ($send_to_cc) $send_to_cc.=',';
						$send_to_cc.=$val['data'];
					}elseif (isset($list_bcc_x)) {
						if ($send_to_bcc) $send_to_bcc.=',';
						$send_to_bcc.=$val['data'];
					}
				}

			}
		}
	}
}
$defRootFmng=Framework::getParam('_root_fmng',0)?Framework::getParam('_root_fmng',0):$mailExtra['root_fmng'];

// Identit�ten ausgeben
foreach ($identity_array as $i=>$name) {
	$t->assign('IDENTITIES',htmlspecialchars($name));
	$t->assign('NUMSEL',$i);
	if($identity==$i) {
		$t->assign('SELECTED','SELECTED');
		if ($Mail->getPrefs("use".$i)) {
			$signatur=$CFG['NL_MAIL'].$Mail->getPrefs("signatur".$i).$CFG['NL_MAIL'];
			if ($use_wysiwyg) {
				$signatur_html=$Mail->getPrefs("signatur_html".$i);
				if (!strlen($signatur_html)) {
					$signatur_html=nl2br($signatur);
				} else {
					$relImgPath=Framework::getSelfDir().'/fetch_mail_img.php?img=htmlImg/';
					$signatur_html=preg_replace('/(src="?)[^ ]+\/htmlImg\/(.+\.(jpg|gif|jpeg|png))/i','\\1'.$relImgPath.'\\2',$signatur_html);
				}
			}
		}
	} else $t->assign('SELECTED','');
	$t->parse('ROW','.Identities');
}
$t->assign('USE_WYSIWYG',$use_wysiwyg);

if ($P && $app['addr'] && $frm->getPrefs('email','use_proj')) {
	$Addr=& $frm->getStaticModul('addr');
	if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {

	} else {
		$searchProject=array();
		$searchProject[]=array('Field'=>'FKProjID','Typ'=>'!=','Values'=>0);
		if ($mail_check=$mCheck->parseAddressList($send_to)) {
			$searchAddr=array();
			$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
			$searchAddr[]=array('Field'=>array('EMail'),'Typ'=>'concat','Values'=>$mail_check[0]->mailbox.'@'.$mail_check[0]->host,'UseCase'=>0,'OnlyWords'=>1);

			$entries=$Addr->searchAddr(0,'',$searchAddr,'','',$searchProject,false,true);
			$prjIds=array();
			foreach ($entries as $AObj) {
				$prjIds=array_merge($prjIds,$Addr->getAddrProjects($AObj));
			}
			if (!empty($prjIds)) {
				$rows=0;
				$t->assign('S_PROJ','');
				$entries=$P->searchMyPrj($rows,array('ProjID'=>$prjIds,'Aktiv'=>1),'',0,5);
				foreach ($entries as $PObj) {
					$t->assign('P_NAME',$PObj->getName());
					$t->parse('ROW','.proj_from_row');
					$t->assign('S_PROJ',', ');

					if (!$defRootFmng && $PObj->getMeta('FmngFolder')) {
						$defRootFmng=$PObj->getMeta('FmngFolder');
					}
				}
				if ($rows) {
					$t->parse('ROW','proj_from');
				}
			}
		}
	}
}

$t->assign('F_TO',UserGUI::showTtipInput('mail_hlist','send_to',400,$send_to));
if ($ActionError["send_to"] || $ActionError["no_send_to"] || $ActionError["send_to_len"] ) {
	$t->assign('C_SEND_TO','error');
	$t->assign('FOCUS_FIELD','send_to');
} else $t->assign('C_SEND_TO','desc');



$t->assign('F_TO_CC',UserGUI::showTtipInput('mail_hlist','send_to_cc',400,$send_to_cc));
if ($ActionError["send_cc"] ) {
	$t->assign('C_SEND_TO_CC','error');
	$t->assign('FOCUS_FIELD','send_to_cc');
} else $t->assign('C_SEND_TO_CC','desc');



$t->assign('F_TO_BCC',UserGUI::showTtipInput('mail_hlist','send_to_bcc',400,$send_to_bcc));
if ($ActionError["send_bcc"] ) {
	$t->assign('C_SEND_TO_BCC','error');
	$t->assign('FOCUS_FIELD','send_to_bcc');
} else $t->assign('C_SEND_TO_BCC','desc');

if ($Mail->getCfg('cfg/all/allow_notification')) {
	if ($read_confirm) {
		$t->assign('CHK_READ_CONFIRM','checked="checked"');
	} else {
		$t->assign('CHK_READ_CONFIRM','');
	}
	$t->parse('ROW','read_confirm');
}

$t->assign('SUBJECT',htmlspecialchars($subject));
//debug(htmlspecialchars($emptyRow));
if(!$mail_body) {
	if ($use_wysiwyg) {
		$mail_body=$Mail->formatNewHtmlMail($emptyRow.$emptyRow.$emptyRow.'<!--BEGIN SIGNATUR--><div id="groupeMailSign" class="mceNonEditable">'.$signatur_html.'</div><!--END SIGNATUR-->','','',GE_CHARSET);
	} else {
		$mail_body="\n\n\n".$signatur;
	}
}

//debug(htmlspecialchars($mail_body));
$t->assign('BODY',htmlspecialchars($mail_body));
if ($use_wysiwyg) {
	$t->assign('USE_WYSIWYG',$htmleditor_typ);
	switch ($htmleditor_typ) {
		case 'tiny_mce':
			require_once('add-on/tiny_mce/tiny_mce.php');
			$TinyMce = new TinyMce();
			$config=array(
				'script_url'=>'add-on/tiny_mce/tiny_mce.js?t='.TinyMce::timestamp,
				'content_css'=>"tpl/ge/cjs/htmleditor.css",
				'theme_advanced_font_sizes'=>"10px,12px,13px,14px,16px,18px,20px",
				'font_size_style_values'=>"10px,12px,13px,14px,16px,18px,20px",
				'phpimageUploadUrl'=>'ajax.php?ajax_modul=mail_img_upload&htmleditor=tiny_mce',
				'paste_retain_style_properties'=>'margin, padding, width, height, font-size, font-weight, line-height, color, text-align, ul, ol, li, text-decoration, border, float, display',
				'height'=>350,
				'width'=>680,
				'language'=>$session_lang,
			);
			$TinyMce->returnOutput=true;
			$TinyMce->basePath='add-on/tiny_mce/';
			$TinyMce->textareaAttributes=array('style'=>'width:660px;height:350px;visibility:hidden;');

			$t->assign('EDITOR',$TinyMce->editor("mail_body", $mail_body, $config));
			$t->parse('ROW','edit_html');
		break;
		case 'ckeditor':
			require_once('add-on/ckeditor/ckeditor.php');
			$CKEditor = new CKEditor();
			$CKEditor->returnOutput=true;
			$CKEditor->basePath='add-on/ckeditor/';
			$config = array(
				'height'=>350,
				'width'=>680,
				'language'=>$session_lang,
				'resize_maxWidth'=>680,
				'resize_minWidth'=>680,
				'filebrowserImageUploadUrl'=>'ajax.php?ajax_modul=mail_img_upload&htmleditor=ckeditor',
				'fullPage'=>true,
			);
			$t->assign('EDITOR',$CKEditor->editor("mail_body", $mail_body, $config));
			$t->parse('ROW','edit_html');
		break;
	}
} else {
	$t->assign('USE_WYSIWYG','');
	$t->parse('ROW','edit_txt');
}
$attID=-1;
$uplodadFiles=array();
$att=$Mail->getEmailAttachments();
$i=0;
foreach($att as $key=>$val){
	$attID=max($attID,$key);
	if ($val['Cid'] && preg_match('/'.preg_quote(basename($val['Source']),'/').'/',$mail_body)) continue;
 	if (!$val['Name'] || !file_Exists($Mail->getAttachPath().'/'.$val['Name'])) {
		$Mail->deleteEmailAttachments($key);
		continue;
	}
	$uplodadFiles[]=array(
		'id'=>$key,
		'name'=>$val['Name'],
		'size'=>$val['Size'],
		'type'=>$val['Type'],
		'status'=>'uploaded',
	);
	$Mail->encodeAttachment($Mail->getAttachPath().'/'.$val['Name']);
	$t->assign('ATT_LINK',$L_THIS.'&dl_attach='.$key);
	$t->assign('ATT_KEY',$key);
	$t->assign('ATT_REM_NAME',$val['Name']);
	$t->assign('ATT_FILE_TYPE',$val['Type']);
	$t->assign('ATT_READ_SIZE',Framework::formatSize($val['Size']));
	if ($i%2) $t->assign('ROW_COLOR',$bgcolor); else  $t->assign('ROW_COLOR','#f2f2f2');
	$t->parse('ROW','.attach_row');
	$i++;
}
$t->assign('JSON_UPLOADED_FILES',json_encode($uplodadFiles));
$t->assign('DL_LINK',$L_THIS);
$t->assign('DROP_TITLE',Framework::escapeJs($T->lang('[[Datei hierher kopieren]]')));
$t->assign('DIALOG_TITLE',Framework::escapeJs($T->lang('[[Datei auswaehlen]]')));
$t->assign('MAX_UPLOAD_SIZE',floor(Framework::getMaxUpload()/(1024*1024)));
$frm->addCssScript('add-on/dropzone/css/basic.css');
$frm->addJsScript('add-on/dropzone/dropzone.min.js');
if ($app['fmng']) {
	$t->parse('ROW','att_omng_d');
}
$t->parse('ROW','att_dropzone');

require_once('lib/class_FormGui.php');
require_once('lib/class_FunctionButtons.php');
$formGui=new FormGui();
$formGui->setLabelClass('no','no_error');
$key='FcopyTo';
$formGui->addField($key,'ttip','',trim($copyto)?'m_'.$copyto:'','field_copyto');
$formGui->setAttribs($key,array('style'=>'width:400px'));
$formGui->setParams($key,array('no_width'=>'1','width'=>'400px','mode'=>'m','app'=>'','params'=>base64_encode(serialize(array('MaxEntries'=>1,'skipBox'=>array($Mail->getTrashID()))))));
$t->assign('CPF_ID',$key);
$t->assign('CPF_MODE_LIST','m');
$t->assign('CPF_PARAMS_LIST',base64_encode(serialize(array('MaxEntries'=>1,'skipBox'=>array($Mail->getTrashID())))));
if ($mode=='reply' || $mode=='reply_all' || $mode=='fwd') {
	$key='FmoveOrig';
	$formGui->addField($key,'check',$T->lang('[[Original Mail verschieben]]'),$mailExtra['move_orig'],'field_copyto');
}
$key='root_fmng';
$formGui->addField($key,'hidden','',$defRootFmng,'field_copyto');

//debug(Framework::getParam('_root_fmng',0));

$t->assign('OBJ_COPY_TO',$formGui->process('','field_copyto'));
$t->assign('M_SENT_ID','m_'.$Mail->getSentID());
if (is_array($qtree[0])) {
	$t->assign('MNU_ITEMS',$Mail->treeToJson($qtree,0,'m_'));
} else {
	$t->assign('MNU_ITEMS','');
}
$t->parse('ROW','js_cp_menu');
$t->parse('ROW','js_cp_menu_head');
$frm->addOnLoad("loadBoxMenu();");


$form_action=$L_THIS;
$t->assign('FORM_ACTION',$form_action);

if ($H_REFERER[intval($back)]) {
	$t->assign('L_BREAK',$H_REFERER[intval($back)].'&clearMail=1');
} else {
	$t->assign('L_BREAK',"index.php?site=$site&clearMail=1");
}
$t->parse('ROW','break');
$t->parse('ROW','print');
$t->assign("TPL_LAYERS","");
$frm->addOnUnload("saveEmail();");
?>
