<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$Mobj=$Mail->getMailObj($obj->getBox(),$mid);
if (!is_object($Mobj)) {
	exit;
}
require("lib/mail/classMailDecode.php");
$MDec=new MailDecode($Mail);
$bodyar=$MDec->getBody($obj->getBox(),$Mobj);

$view_html=1;
$FullHeader=$Mail->parseFullHeader($obj->getBox(),$Mobj->getID(),1);
//debug($FullHeader);
if ($Mail->getCfg('cfg/spam/enable') && isset($FullHeader[strtolower($Mail->getCfg('cfg/spam/header'))])) {
	$bogosity=array_map('trim',explode(',',$FullHeader[strtolower($Mail->getCfg('cfg/spam/header'))]));
	if (!$Mobj->getMeta('Flagged') && $Mail->getCfg('cfg/spam/learn')) {
		if ($bogosity[0]==$Mail->getCfg('cfg/spam/header/unsure') || $bogosity[0]==$Mail->getCfg('cfg/spam/header/yes')) {
			$view_html=0;
		}
	}
	if (!$Mobj->getMeta('Flagged') && $bogosity[0]==$Mail->getCfg('cfg/spam/header/yes')) {
		$view_html=0;
	}
	if ($obj->getMeta('Type')=='X' && $Mobj->getMeta('Flagged') && $bogosity[0]==$Mail->getCfg('cfg/spam/header/unsure')) {
		$view_html=0;
	}
}

$t->assign('MAIL_SUBJECT',FrameWork::entities($Mail->mail_enc($Mobj->getName())));
$t->assign('MAIL_DATE', strftime("%A, %d.%m.%Y %H:%M",$Mobj->getMeta('Date')));
$t->assign('MAIL_SIZE',Framework::formatSize($Mobj->getMeta('Size')));
if (is_array($Mobj->getMail('From'))) {
	$emails=$Mail->formatMail($Mobj->getMail('From'),0,1);
	$t->assign('S_MAIL','');
	foreach ($emails as $val) {
		$t->assign('N_MAIL',Framework::entities($val));
		$t->parse('ROW','.mail_from_row');
		$t->assign('S_MAIL',', ');
	}
}
if (is_array($Mobj->getMail('To'))) {
	$emails=$Mail->formatMail($Mobj->getMail('To'),0,1);
	$t->assign('S_MAIL','');
	foreach ($emails as $val) {
		$t->assign('N_MAIL',Framework::entities($val));
		$t->parse('ROW','.mail_to_row');
		$t->assign('S_MAIL',', ');
	}
	$t->parse('ROW','mail_to');
}
if (is_array($Mobj->getMail('Cc'))) {
	$emails=$Mail->formatMail($Mobj->getMail('Cc'),0,1);
	$t->assign('S_MAIL','');
	foreach ($emails as $val) {
		$t->assign('N_MAIL',Framework::entities($val));
		$t->parse('ROW','.mail_cc_row');
		$t->assign('S_MAIL',', ');
	}
	$t->parse('ROW','mail_cc');
}
if (is_array($Mobj->getMail('Bcc'))) {
	$emails=$Mail->formatMail($Mobj->getMail('Bcc'),0,1);
	$t->assign('S_MAIL','');
	foreach ($emails as $val) {
		$t->assign('N_MAIL',Framework::entities($val));
		$t->parse('ROW','.mail_bcc_row');
		$t->assign('S_MAIL',', ');
	}
	$t->parse('ROW','mail_bcc');
}

$cid=array();
if($bodyar['att']){
	$numAtt=0;
	foreach($bodyar['att'] as $var) {
		if ($var['id']) {
			$cid[$var['id']]=array('part'=>$var['part'],'type'=>$var['type'],'enc'=>$var['enc']);
		}
		if (isset($bodyar['html']) && trim($var['id']) && preg_match('@image/(gif|png|jpeg|jpg)@i',$var['type']) && !($var['att'])) continue;
		if ((preg_match('@text/x-vcard@i',$var['type']) || preg_match('@\.vcf$@i',$var['name'])) && $app['addr']) {
			$t->assign('TARGET','');
		} else {
			$t->assign('TARGET','_blank');
		}
		$t->assign('FILE_TYPE',Framework::entities($var['type']));
		$t->assign('FILE_NAME',Framework::entities($Mail->mail_enc($var['name'])));
		$t->assign('FILE_SIZE',Framework::formatSize($var['size']));
		$t->parse('ROW','.attach_row');
		$numAtt++;
	}
	if ($numAtt) $t->parse('ROW','attach');
}
if(!isset($bodyar['html']) || !$view_html || !$bodyar['alt'] ){
	if(isset($bodyar['text'])) {
		$frm->convertLineEndings($bodyar['text'],"\n");
		$bodyar['text']=$Mail->wrap($Mail->mail_enc($bodyar['text']));
		$t->assign('BODY','<pre>'.htmlspecialchars($bodyar['text']).'</pre>');
		$t->parse('ROW','body_text');
		if (isset($bodyar['html']) && $view_html && !$bodyar['alt']) $t->parse('ROW','body_alt');
	}
}
if(isset($bodyar['html']) && $view_html){
	$bodyar['html']=Framework::convertCharset($bodyar['html'],GE_CHARSET,'HTML-ENTITIES');

	if (count($cid)) {
		$bodyar['html']=preg_replace('/(src|background)=["]?cid:([^"> ]+)["]?/sie','"\\1=\"fetch_mail_img.php?mbox=".urlencode($obj->getBox())."&mid=".$mid."&part=".urlencode($cid[\'<\\2>\']["part"])."&enc=".urlencode($cid[\'<\\2>\']["enc"])."&mime=".urlencode($cid[\'<\\2>\']["type"])."\""',$bodyar['html']);
	}
	$t->parse('TPL_CARD','tpl_card');

	$header="<head>\n";
	$header.="<style>\n";
	$header.="blockquote {border-left:2px solid #00F;margin-left:10px;padding-left:5px;}\n";
	$header.="p {margin:0;padding:0;}\n";
	$header.="</style>\n";
	if (preg_match('/<\s*head\s*>/i',$bodyar['html'])) {
		$bodyar['html']=preg_replace('/<\s*head\s*>/i',$header,$bodyar['html']);
	} else {
		$bodyar['html']=$header.'</head>'.$bodyar['html'];
	}
	if (!preg_match('/(<\s*body[^>]*>)/i',$bodyar['html'])) {
		if (preg_match('/(<\s*\/\s*head[^>]*>)/i',$bodyar['html'])) {
			$bodyar['html']=preg_replace('/(<\s*\/\s*head[^>]*>)/i','\\1'.'<body>',$bodyar['html']).'</body>';
		} else {
			$bodyar['html']='<body>'.$bodyar['html'].'</body>';
		}
	} else {
		$bodyar['html']=preg_replace('/(<\s*body([^>]*)>)/i','<body><div \\2>',$bodyar['html']);
		$bodyar['html']=preg_replace('/(<\s*\/\s*body([^>]*)>)/i','</div></body>',$bodyar['html']);
	}
	$bodyar['html']=preg_replace('/(<\s*body[^>]*>)/i','\\1'.$t->getparsed('TPL_CARD'),$bodyar['html'],1);
	//debug(htmlspecialchars($bodyar['html']));
	$PrintID=$frm->insertPrint('email','html',$bodyar['html']);
	page_close();
	header("Location:print.php?PrintID=$PrintID&addHeaderToBody=1");
	exit;
} else {
	$t->parse('TPL_CARD','tpl_card');
	$PrintID=$frm->insertPrint('email','html',$t->getparsed('TPL_CARD'));
	page_close();
	header("Location:print.php?PrintID=$PrintID");
	exit;
}
?>