<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->unload('tpl_error');
$t->define (array('tpl_error' => "error.inc.html"));
if (isset($ActionError['fwd'])) {
	$t->parse('ROW','error_fwd');
}
if (isset($ActionError['quota'])) {
	$t->parse('ROW','error_quota');
}
if (isset($ActionError['no_perms'])) {
	$t->parse('ROW','error_no_perms');
}
if (isset($ActionError['fields'])) {
	$t->parse('ROW','error_fields');
}
if (isset($ActionError['name'])) {
	$t->parse('ROW','error_name');
}
if (isset($ActionError['no_folder'])) {
	$t->parse('ROW','error_no_folder');
}
if (isset($ActionError['server'])) {
	$t->assign('ERROR_MSG',Framework::entities($ActionError['server']));
	$t->parse('ROW','error_server');
}
if (isset($ActionError['no_send_to'])) {
	$t->parse('ROW','error_no_send_to');
}
if (is_array($ActionError['send_to'])) {
	$t->assign('OBJECT_ERROR',implode('<br>',Framework::entities($ActionError['send_to'])));
	$t->parse('ROW','error_send_to');
}  elseif($ActionError['send_to']) {
	$t->assign('OBJECT_ERROR',Framework::entities($ActionError['send_to']));
	$t->parse('ROW','error_send_to');
}
if (is_array($ActionError['send_cc'])) {
	$t->assign('OBJECT_ERROR',implode('<br>',Framework::entities($ActionError['send_cc'])));
	$t->parse('ROW','error_send_cc');
}  elseif($ActionError['send_cc']) {
	$t->assign('OBJECT_ERROR',Framework::entities($ActionError['send_cc']));
	$t->parse('ROW','error_send_cc');
}
if (is_array($ActionError['send_bcc'])) {
	$t->assign('OBJECT_ERROR',implode('<br>',Framework::entities($ActionError['send_bcc'])));
	$t->parse('ROW','error_send_bcc');
} elseif($ActionError['send_bcc']) {
	$t->assign('OBJECT_ERROR',Framework::entities($ActionError['send_bcc']));
	$t->parse('ROW','error_send_bcc');
}
if (isset($ActionError['send_to_len'])) {
	$t->parse('ROW','error_to_len');
}

if (isset($ActionError['sieve_auth'])) {
	$t->parse('ROW','error_sieve_auth');
}
if (isset($ActionError['not_send'])) {
	$t->parse('ROW','error_not_send');
}
if (is_array($ActionError['del_quota'])) {
	foreach ($ActionError['del_quota'] as $val) {
		$t->assign('ERROR_DATA',htmlspecialchars($val));
		$t->parse('ROW','.error_del_quota_data');
	}
	$t->parse('ROW','error_del_quota');
}
if (isset($ActionError['server'])) {
	if (is_array($ActionError['server'])) {
		$t->assign('ERROR_MSG',nl2br(implode("\n\n",Framework::entities($ActionError['server']))));
	} else {
		$t->assign('ERROR_MSG',nl2br(Framework::entities($ActionError['server'])));
	}
	$t->parse('ROW','error_server');
}
$t->parse('TPL_ERROR','.tpl_error');
?>
