<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require("lib/class_form.inc.php");
require_once("lib/class_ApplicationGui.php");
$t->assign('MOD_TITLE','Preferences');
if (!isset($app_name)) {
    $app_name="global";
}
$t->setRoot("tpl/$THEME/prefs/$session_lang");

$TopGui=new ApplicationGui();
$TopGui->setName($frm->getAppName('prefs'));
$TopGui->setImage('appl_adm.gif');

$key='global';
$TopGui->addTab($key,$T->lang('[[Profil]]'),"index.php?site=$site&app_name=$key",'');
if ($app_name==$key) $TopGui->setTabOn($key);

$db->query("SELECT app_name,app_title_$session_lang as app_title FROM application WHERE app_enabled='1'  ORDER BY app_order ");
while($db->next_record()) {
	 $app_en=0;
     switch($db->f('app_name'))  {
		case 'cal':
			$app_en=1;
			break;
		case 'task':
			$app_en=1;
			break;
		case 'addr':
			$app_en=1;
			break;
		case 'sync':
			$app_en=1;
			break;
		case 'lmng':
			$app_en=1;
			break;
		case 'email':
			$app_en=1;
			break;
		case 'zef':
			$app_en=1;
			break;
		case 'proj':
			$app_en=1;
			break;
		case 'smb':
			$app_en=1;
			break;
		case 'sms':
			$app_en=1;
			break;
		case 'stel':
			if ($app['stel']) {
				$Stel=& $frm->getStaticModul('stel');
				if ($Stel->getCfg('cfg/modul/visibility')) {
					$app_en=1;
				} else {
					$app_en=0;
				}
			}
		break;
		case 'custom':
			if (GE_CUSTOM_APP=='blz') {
				$app_en=1;
			}
		break;
	}
    $key=$db->f('app_name');
	if ($app_en && $app[$key]) {
		$TopGui->addTab($key,$db->f('app_title'),"index.php?site=$site&app_name=$key",'');
		if ($app_name==$key) $TopGui->setTabOn($key);
	}
}

require ("prefs/prefs_".$app_name."_head.php");

if ($ActionError) {
	$t->unload('tpl_error');
	$t->define (array('tpl_error' => "error.inc.html"));
	if (isset($ActionError['fields'])) {
		$t->parse('ROW','error_fields');
		$E->setErrorMsg('fields',$t->getParsed());
		$E->setError('fields');
	}
	if (isset($ActionError['mail'])) {
		$t->parse('ROW','error_mail');
		$E->setErrorMsg('mail',$t->getParsed());
		$E->setError('mail');
	}
	if (isset($ActionError['sieve_auth'])) {
		$t->parse('ROW','error_sieve_auth');
		$E->setErrorMsg('sieve_auth',$t->getParsed());
		$E->setError('sieve_auth');
	}
	if (isset($ActionError['server'])) {
		$t->assign('ERROR_MSG',nl2br(Framework::entities($ActionError['server'])));
		$t->parse('ROW','error_server');
		$E->setErrorMsg('server',$t->getParsed());
		$E->setError('server');
	}
	if (isset($ActionError['pwd_time'])) {
		$t->parse('ROW','error_pwd_time');
		$E->setErrorMsg('pwd_time',$t->getParsed());
		$E->setError('pwd_time');
	}
	if (isset($ActionError['sieve_self'])) {
		$t->assign('ERROR_MSG',Framework::entities($ActionError['sieve_self']));
		$t->parse('ROW','error_sieve_self');
		$E->setErrorMsg('sieve_self',$t->getParsed());
		$E->setError('sieve_self');
	}
}
if ($t->issetkey("form_tpl")) {
	$t->parse("FORM_TPL","form_tpl");
	$TopGui->addContentText($t->getParsed());
}
$TopGui->addConfirm('delete');
$TopGui->processApplication();
  //rechte tabelle
?>
