<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array("form_tpl"=>"prefs_cal_form.inc.html"));
if (!isset($user_id)) $user_id=$auth->auth[uid];
if (!isset($action)) $action='edit';

$baseCat=& $frm->getStaticModul('cal_cat');
$category=Framework::extractObjName($baseCat->listObj());

$baseCal=& $frm->getStaticModul('cal');
$tplEntries=$baseCal->listEventTpl(true);
if (!empty($tplEntries)) {
	$templates=array(0=>'-') + Framework::extractArrayMeta($tplEntries,'TplTitle');
} else {
	$templates=array(0=>'-');
}


for ($i=0;$i<25;$i++) $hours[$i]=sprintf("%02d",$i);
$minutes=array("0"=>"00","15"=>"15","30"=>"30","45"=>"45");

$country_array=$frm->getSelectData('cou');
$groups_array=$frm->getAllGroups();
$app_users=array_keys($frm->getApplicationUsers('cal'));
$users_array=$frm->getFullName(array_unique($app_users));

$chk1=new CheckBox('showTasks',"",1);
$chk2=new CheckBox('showTasksDone',"",1);
$chk3=new CheckBox('defNotes',"",1);
$chk4=new CheckBox('showHour',"",1);
$chk5=new CheckBox('showAlarm',"",1);
$chk6=new CheckBox('defNoInvit',"",1);

$select2=new SelectField("db_h","class=sel",$hours);
$select3=new SelectField("db_m","class=sel",$minutes);
$select4=new SelectField("de_h","class=sel",$hours);
$select5=new SelectField("de_m","class=sel",$minutes);
$select6=new SelectField("country","class=sel",$country_array);
$select7=new SelectField("cat_id",'class="sel" style="width:200px;"',$category);
$select8=new SelectField("tpl_id",'class="sel" style="width:200px;" onchange="changeDisp(\'show_insert_cfg\',!this.value);"',$templates);
$sel_nw=new SelectField("nw","class=sel",array(1=>1,2=>2,3=>3,4=>4,8=>8,12=>12));
$sel_nd=new SelectField("nd","class=sel",array(1=>1,2=>2,3=>3,4=>4,5=>5,6=>6,7=>7,8=>8,9=>9));
$sel_du=new SelectField("du",'size="8" class="sel" style="width:200px;"',$users_array,"",1,"");
$sel_dg=new SelectField("dg",'size="8" class="sel" style="width:200px;"',$groups_array,"",1,"");

$view_array=array("year","month","week","day");
$inf_array=array(0,1);

$obj=$frm->getPrefs($app_name);
//debug($obj);
if (isset($save_x)) {
	$obj['db_h']=$db_h;
	$obj['db_m']=$db_m;
	$obj['de_h']=$de_h;
	$obj['de_m']=$de_m;
	$obj['country']=$country;
	$obj['view']=$view;
	$obj['inf']=$inf;
	$obj['nw']=$nw;
	$obj['nd']=$nd;
	$obj['showTasks']=intval($showTasks);
	$obj['showTasksDone']=intval($showTasksDone);
	$obj['showHour']=intval($showHour);
	$obj['showAlarm']=intval($showAlarm);
	$obj['tpl_id']=$tpl_id;
	if (!$obj['tpl_id']) {
		$obj['cat_id']=$cat_id;
		$obj['defNotes']=intval($defNotes);
		$obj['defNoInvit']=intval($defNoInvit);
		if (is_array($du)) $obj['du']=implode('|',$du); else $obj['du']='';
		if (is_array($dg)) $obj['dg']=implode('|',$dg); else $obj['dg']='';
	}
	$frm->insertPrefs($app_name,$obj);
	$action="";
	page_close();
	header("location:index.php?site=$site&app_name=$app_name");
	exit;
} elseif ($action=="edit") {
	if ($obj['du']) $obj['du']=explode('|',$obj['du']);
	if ($obj['dg']) $obj['dg']=explode('|',$obj['dg']);
	extract($frm->getDefaults($app_name));
	extract($obj);
}
require ("prefs/prefs_cal_form.php");
?>
