<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$Mail->open();
if ($Mail->isOpen() && ($Mail->getCfg('cfg/sieve/vacation') || ($Mail->getCfg('cfg/sieve/spam') && $Mail->getCfg('cfg/spam/enable')))) {
	$Mail->setCfg($GLOBALS['frm']->getCfg($Mail->getModul(),0,$Mail->getCfg('cfg/alias').'/%'));
	if ($Mail->getCfg('cfg/alias') && file_exists("lib/mail/classAlias_".$Mail->getCfg('cfg/alias').".php")) {
		require_once("lib/mail/classAlias_".$Mail->getCfg('cfg/alias').".php");
	} else {
		require_once("lib/mail/classAlias_mysql.php");
	}
	$Ali=new Aliases($Mail);
	require_once('lib/mail/classSieve.php');
	$sieve=new SieveDB($db);
	$sieve->setUid($user_id);
	$sieve->setUname($Mail->getUserName());
	$sieve->setAliasObj($Ali);
	$myAliases=$sieve->getMyAliases();
	if (!in_array('"'.$frm->getCachedUser($user_id,'email').'"',$myAliases)) {
		$myAliases[]='"'.$frm->getCachedUser($user_id,'email').'"';
	}
	sort($myAliases);
} else{
	$sieve=null;
	$myAliases=null;
}

if (isset($save_x)) {
	$pre[$app_name]=$Mail->getPrefs();
	$pre[$app_name]['fwd']=0;
	if ($sieve) {
		$load_script=array();
		if ($Mail->getCfg('cfg/sieve/spam') && $Mail->getCfg('cfg/spam/enable') && $Mail->getSpamID()) {
			$script=$sieve->getFilters('spam');
			if (!empty($script)) {
				$filter_id=key($script);
			} else {
				$filter_id=0;
			}
			$filter=$faction=array();
			$filter_name='NO SPAM';
			$filter[0]['key']='header';
			$filter[0]['test']='C';
			$filter[0]['value']=$Mail->getCfg('cfg/spam/header/yes');
			$filter[0]['value1']=$Mail->getCfg('cfg/spam/header');
			$faction['key']='M';
			$faction['value']=$Mail->getSpamID();
			$faction['stop']=1;
			$faction['match']='ONE';
			$require=array('fileinto');
			$filter_id=$sieve->saveFilter('spam',$filter_id,$filter_name,intval($spam_activ),$filter,$faction,implode(',',$require));
			$load_script[]='spam';
		}
		if ($Mail->getCfg('cfg/sieve/vacation')) {
			$script=$sieve->getFilters('vacation_1');
			if (!empty($script)) {
				$filter_id=key($script);
			} else {
				$filter_id=0;
			}
			$filter=$faction=array();
			$filter_name='VACATION';
			$filter[0]['key']='From';
			$filter[0]['test']='C';
			$filter[0]['value']='@';
			$faction['key']='V';
			$faction['value']=$vacation_text;
			$faction['value1']=1; // Tage Vacation;
			$faction['value2']=$vacation_alias;
			$faction['match']='ONE';
			$require=array('vacation');
			
			$save=true;
			if ($vacation1_activ) {
				if (is_array($myAliases) && !empty($myAliases) && empty($vacation_alias)) {
					$ActionError['fields']["vacation_alias"]=true;
					$save=false;
				}
				$pre[$app_name]['fwd']=1;
			}
			if ($save) $filter_id=$sieve->saveFilter('vacation_1',$filter_id,$filter_name,$vacation1_activ,$filter,$faction,implode(',',$require));
			$load_script[]='vacation_1';

			$script=$sieve->getFilters('vacation_2');
			if (!empty($script)) {
				$filter_id=key($script);
			} else {
				$filter_id=0;
			}
			$filter=$faction=array();
			$filter_name='FORWARD';
			$filter[0]['key']='From';
			$filter[0]['test']='C';
			$filter[0]['value']='@';
			$faction['key']='F';
			$save=true;
			if ($vacation2_activ) {
				$mail_check=imap_rfc822_parse_adrlist($vacation_mail,'');
				if (count($mail_check) > 1) $ActionError['fields']["vacation_mail"]=true;
				else {
					if ($Mail->getCfg('cfg/all/check_mail')) {
						if (!$mail_check[0]->mailbox || !$mail_check[0]->host || !$frm->is_email($mail_check[0]->mailbox.'@'.$mail_check[0]->host)) {
							$ActionError['fields']["vacation_mail"]=true;
							$save=false;
						}
						$vacation_mail=$Mail->formatMail($mail_check[0],0,1);
					}
				}
				if (!trim($vacation_mail)) $ActionError['fields']["vacation_mail"]=true;
				if (is_array($myAliases) && !empty($myAliases) && in_array('"'.trim($vacation_mail).'"',$myAliases)) {
					$ActionError['fields']["vacation_mail"]=true;
					$ActionError['sieve_self']=trim($vacation_mail);
					$save=false;
				}
				if (!$vacation_keep) {
					$pre[$app_name]['fwd']=1;
				}
			}

			$faction['value']=$vacation_mail;
			$faction['match']='ONE';
			if ($vacation_keep) {
				$faction['keep']=1;
			}
			$faction['stop']=1;
			$require=array();
			if ($save) $filter_id=$sieve->saveFilter('vacation_2',$filter_id,$filter_name,$vacation2_activ,$filter,$faction,implode(',',$require));
			$load_script[]='vacation_2';
		}
		if (!empty($load_script) && !$ActionError) {
			require('lib/mail/classSieveLib.php');
			//echo $Mail->getPassword();
			$sieve_lib=new Sieve($Mail->getCfg('cfg/Server'), $Mail->getCfg('cfg/sieve/port'),$Mail->getUserName(),$Mail->getUserName(),$Mail->getPassword());
			if ($sieve_lib->sieve_login()) {
				$load_script[]=$Mail->getUserName();
				$scripttext='';
				$scripttext.=$sieve->generateScript($load_script,$user_id,$Mail->getUserName());
				//$sieve->debug($scripttext);
				//debug($scripttext);
				//echo $scripttext;

				if ($scripttext) {
					if ($sieve_lib->sieve_sendscript($Mail->getUserName(),$scripttext)) {
						$sieve_lib->sieve_setactivescript($Mail->getUserName());
					} else {
						if(is_array($sieve_lib->error_raw)) {
							$ActionError['server']=implode("\n",$sieve_lib->error_raw);
						} else {
							$ActionError['server']=$sieve_lib->error_raw;
						}
					}
				} else {
					$sieve_lib->sieve_deletescript($Mail->getUserName());
				}
			} else {
				$ActionError['sieve_auth']=1;
			}
		}
	}
	if (!$ActionError) {
		$pre[$app_name]['htmleditor_typ']=$htmleditor_typ;
		$pre[$app_name]['limit']=$number;
		$pre[$app_name]['abs']=$abs;
		if ($app['addr']) $pre[$app_name]['addrhot']=$addrhot;
		$pre[$app_name]['msg']=$mail_msg;
		$pre[$app_name]['msg_int']=$mail_msg_int;
		$pre[$app_name]['use_wysiwyg']=$mail_wysiwyg;
		$pre[$app_name]['use_notif']=$mail_notif;
		$pre[$app_name]['show_thumb']=$mail_show_thumb;
		$pre[$app_name]['cron/trash']=$mail_cron_trash;
		$pre[$app_name]['cron/sent']=$mail_cron_sent;
		$pre[$app_name]['cron/spam']=$mail_cron_spam;
		$pre[$app_name]['mail_draft']=$mail_draft;
		$pre[$app_name]['use_proj']=$mail_proj;
		$frm->insertPrefs($app_name,$pre[$app_name]);
		page_close();
		header("location:index.php?site=$site&app_name=$app_name&mode=$mode");
		exit;
	}
}

if (!isset($number)) $number=$frm->getPrefs($app_name,'limit');
$sel_number=new SelectField("number","class=sel",array("10"=>"10","20"=>"20","50"=>"50","100"=>"100"));

if (!isset($abs)) $abs=$frm->getPrefs($app_name,'abs');
$chk_abs=new Checkbox("abs","class=sel",1);


if (!isset($addrhot)) $addrhot=$frm->getPrefs($app_name,'addrhot');
$chk_addrhot=new Checkbox("addrhot","class=sel",1);

if (!isset($mail_msg_int)) $mail_msg_int=$frm->getPrefs($app_name,'msg_int');
$sel_msg_int=new SelectField("mail_msg_int","class=sel",array('2'=>'2',"5"=>"5","15"=>"15","30"=>"30","60"=>"60"));

if (!isset($mail_msg)) $mail_msg=$frm->getPrefs($app_name,'msg');
$chk_msg=new Checkbox("mail_msg","",1);

if (!isset($mail_wysiwyg)) $mail_wysiwyg=$frm->getPrefs($app_name,'use_wysiwyg');
$chk_wysiwyg=new Checkbox("mail_wysiwyg","",1);

if (!isset($htmleditor_typ)) $htmleditor_typ=$frm->getPrefs($app_name,'htmleditor_typ')?$frm->getPrefs($app_name,'htmleditor_typ'):'tiny_mce';
$sel_htmleditor_typ=new SelectField("htmleditor_typ","class=sel",array("ckeditor"=>'CKEditor','tiny_mce'=>'Tiny Mce'));


if (!isset($mail_notif)) $mail_notif=$frm->getPrefs($app_name,'use_notif');
$chk_notif=new Checkbox("mail_notif","",1);

if (!isset($mail_proj)) $mail_proj=$frm->getPrefs($app_name,'use_proj');
$chk_proj=new Checkbox("mail_proj","",1);


if (!isset($mail_show_thumb)) $mail_show_thumb=$frm->getPrefs($app_name,'show_thumb');
$chk_show_thumb=new Checkbox("mail_show_thumb","",1);


if (!isset($mail_cron_trash)) $mail_cron_trash=$frm->getPrefs($app_name,'cron/trash');
$txt_cron_trash=new TextField('mail_cron_trash','class="sel" size="5" style="width:50px;"');

if (!isset($mail_cron_sent)) $mail_cron_sent=$frm->getPrefs($app_name,'cron/sent');
$txt_cron_sent=new TextField('mail_cron_sent','class="sel" size="5" style="width:50px;"');

if (!isset($mail_cron_spam)) $mail_cron_spam=$frm->getPrefs($app_name,'cron/spam');
$txt_cron_spam=new TextField('mail_cron_spam','class="sel" size="5" style="width:50px;"');

$dEntries=array();
if ($Mail->isOpen()) {
	$draft_obj=$Mail->getObj($Mail->getDraftID(),false);
	if (is_object($draft_obj)) {
		$dRows=0;
		$tmp=$Mail->listMails($dRows,$draft_obj->getBox(),0,0,SORTARRIVAL,true);
		foreach($tmp as $val) {
			$dEntries[$draft_obj->getBox().'||'.$val->getID()]=$Mail->mail_enc($val->getName());
		}
	}
}
if (!isset($mail_draft)) $mail_draft=$frm->getPrefs($app_name,'mail_draft');
$sel_draft=new SelectField("mail_draft",'class="sel" style="width:350px;"',array(''=>'-')+$dEntries);


$t->assign("NUMBER",$sel_number->f());
$t->assign("CHK_ABS",$chk_abs->f(1));

if ($app['addr'])  {
	$t->assign("CHK_ADDRHOT",$chk_addrhot->f(1));
	$t->parse('ROW','use_addrhot');
}
$t->assign("INTERVAL_F",$sel_msg_int->f());
$t->assign("DRAFT_F",$sel_draft->f());
$t->assign("CHK_MSG",$chk_msg->f(1));
if ($Mail->getCfg('cfg/all/allow_wysiwyg')) {
	$t->assign("CHK_USE_WYSIWYG",$chk_wysiwyg->f(1));
	$t->assign("SEL_EDITOR",$sel_htmleditor_typ->f());
	$t->parse('ROW','use_wysiwig');
}
$t->assign("CHK_SHOW_THUMB",$chk_show_thumb->f(1));

if ($Mail->getCfg('cfg/all/allow_notification')) {
	$t->assign("CHK_USE_NOTIF",$chk_notif->f(1));
	$t->parse('ROW','use_notif');
}
if ($app['proj']) {
	$t->assign("CHK_USE_PROJ",$chk_proj->f(1));
	$t->parse('ROW','use_proj');
}
$t->assign("CRON_TRASH_F",$txt_cron_trash->f());
$t->assign("CRON_SENT_F",$txt_cron_sent->f());
$t->assign("CRON_SPAM_F",$txt_cron_spam->f());

if ($Mail->getCfg('cfg/spam/enable') && $Mail->getSpamID()) {
	$t->parse('ROW','cron_spam');
}


if ($sieve) {
	if ($Mail->getSpamID() && $Mail->getCfg('cfg/sieve/spam') && $Mail->getCfg('cfg/spam/enable')) {
		$script=$sieve->getFilters('spam');
		if (!empty($script)) {
			$filter_id=key($script);
			$script_filter=$sieve->readFilter($filter_id);
			if (!isset($spam_activ)) $spam_activ=$script_filter['filter_activ'];
		}
		//debug($sieve->readFilter(103));
		$chk_spam=new RadioButton("spam_activ","class=sel");
		$t->assign("CHK_SPAM_Y",$chk_spam->f(1));
		$t->assign("CHK_SPAM_N",$chk_spam->f(0));
		$t->parse('ROW','spam_script');
	}
	if ($Mail->getCfg('cfg/sieve/vacation')) {
		$script=$sieve->getFilters('vacation_1');
		if (!empty($script)) {
			$filter_id=key($script);
			$script_filter=$sieve->readFilter($filter_id);
			if (!isset($vacation1_activ)) $vacation1_activ=$script_filter['filter_activ'];
			if (!isset($vacation_text)) $vacation_text=$script_filter['faction']['value'];
			if (!isset($vacation_alias)) $vacation_alias=$script_filter['faction']['value2'];
		} else {

		}
		//debug($sieve->readFilter(103));
		$chk_vacation_1=new RadioButton("vacation1_activ","class=sel");
		$t->assign("CHK_VACATION_1_Y",$chk_vacation_1->f(1));
		$t->assign("CHK_VACATION_1_N",$chk_vacation_1->f(0));
		$txt_vacation_text=new TextArea('vacation_text','class="sel" rows="6" cols="30" style="width:300px;"');
		$t->assign("TXT_VACATION_TEXT",$txt_vacation_text->f());

		if (is_array($myAliases) && !empty($myAliases)) {
			$alias_array=array();
			foreach ($myAliases as $val) {
				$alias_array[substr($val,1,-1)]=substr($val,1,-1);
			}
			if (count($alias_array)==1) $vacation_alias=array(reset($alias_array));
			require_once('lib/class_FormGui.php');
			$aliasForm=new FormGui();
			$aliasForm->addField('vacation_alias','mselect','',$vacation_alias);
			if ($ActionError['fields']['vacation_alias']) {
				$t->assign("C_VACATION_ALIAS",'error');
			} else {
				$t->assign("C_VACATION_ALIAS",'desc');
			}
			$aliasForm->setAttribs('vacation_alias',array('size'=>count($myAliases)>5?5:count($myAliases)));
			$aliasForm->setValues('vacation_alias',$alias_array);
			$t->assign("FIELD_ALIAS",$aliasForm->process());
			$t->parse('ROW','vacation_script_alias');
		}


		$script=$sieve->getFilters('vacation_2');
		if (!empty($script)) {
			$filter_id=key($script);
			$script_filter=$sieve->readFilter($filter_id);
			if (!isset($vacation2_activ)) $vacation2_activ=$script_filter['filter_activ'];
			if (!isset($vacation_mail)) $vacation_mail=$script_filter['faction']['value'];
			if (!isset($vacation_keep)) $vacation_keep=$script_filter['faction']['keep'];
		} else {

		}
		//debug($sieve->readFilter(103));
		$chk_vacation_2=new RadioButton("vacation2_activ","class=sel");
		$t->assign("CHK_VACATION_2_Y",$chk_vacation_2->f(1));
		$t->assign("CHK_VACATION_2_N",$chk_vacation_2->f(0));
		$txt_vacation_text=new TextField('vacation_mail','class="sel" size="30" style="width:300px;"');
		if ($ActionError['fields']['vacation_mail']) {
			$t->assign("C_VACATION_MAIL",'error');
		} else {
			$t->assign("C_VACATION_MAIL",'desc');
		}
		$t->assign("TXT_VACATION_MAIL",$txt_vacation_text->f());
		$chk_vacation_keep=new Checkbox("vacation_keep","",1);
		$t->assign("CHK_VACATION_KEEP",$chk_vacation_keep->f(1));

		$t->parse('ROW','vacation_script');

	}
}

$t->parse('ROW','update');
$t->assign('FORM_ACTION',"index.php?site=$site&app_name=$app_name&mode=$mode");

if ($Mail->isOpen()) {
	$root_obj_d=$Mail->getSystemObj('d');
	$root_obj_u=$Mail->getSystemObj('u');
	$root_obj_s=$Mail->getSystemObj('s');
	$qtree=$Mail->listTree();
	$qtree[0][$root_obj_u->getID()]=$root_obj_u;
	if (isset($qtree[$root_obj_s->getID()])) $qtree[0][$root_obj_s->getID()]=$root_obj_s;

	$update_mb_msg=false;
	$mb_msg=unserialize($frm->getPrefs($app_name,'mb_msg'));
	if (!is_array($mb_msg) || !count($mb_msg) || !isset($mb_msg[$root_obj_u->getID()])) {
		if (!is_array($mb_msg)) $mb_msg=array();
		if (!isset($mb_msg[$root_obj_u->getID()])) $mb_msg[$root_obj_u->getID()]=array('a'=>1,'m'=>'');
		$update_mb_msg=true;
	}

	if ($mb_key) {
		$sfolder=$mb_key;
		$m_popup=$mb_msg[$mb_key]['a'];
		$m_mel=$mb_msg[$mb_key]['m']?$mb_msg[$mb_key]['m']:'N';
	}
//	debug($mb_msg);
	if ($mb_delete) {
		unset($mb_msg[$mb_delete]);
		if ($mb_delete=='INBOX') {
			$mb_msg[$mb_delete]=array('a'=>0,'m'=>'');
		}
		$update_mb_msg=true;
	}
	//debug($mb_msg);
	if (isset($_POST['add_msg_x'])) {
		if (!$sfolder || $sfolder=='user') {
			$ActionError['fields']['sfolder']=1;
		}
		if (!$m_popup && $m_mel=='N') {
			$ActionError['fields']['m_mel']=1;
		}
		if (!$ActionError) {
			$mb_msg[$sfolder]=array(
				'a'=>$m_popup,
				'm'=>$m_mel=='N'?'':$m_mel,
			);
			$update_mb_msg=true;
			unset($sfolder,$m_popup,$m_mel);
		}
	}

	$t->assign('SEL_KEY',$root_obj_d->getBox());
	//if ($root_obj_d->getBox()==$sfolder) $t->assign('SEL_SELECT','selected="selected"'); else $t->assign('SEL_SELECT','');
	//$t->parse('ROW','sfolder_inbox');
	/*if (is_array($qtree[$root_obj_d->getID()])) {
		foreach ($qtree[$root_obj_d->getID()] as $val) {
			$t->assign('SEL_KEY',$val->getBox());
			if ($val->getBox()==$sfolder) $t->assign('SEL_SELECT','selected="selected"'); else $t->assign('SEL_SELECT','');
			if ($val->getMeta('Type')=='D')	$t->parse('ROW','sfolder_draft');
			if ($val->getMeta('Type')=='S')	$t->parse('ROW','sfolder_sent');
			if ($val->getMeta('Type')=='T')	$t->parse('ROW','sfolder_trash');
			if ($val->getMeta('Type')=='X')	$t->parse('ROW','sfolder_spam');
		}
	}*/
	require_once('lib/class_ObjSelect.php');
	$sel_int=new ObjSelect();
	$sel_int->setTree($qtree);
	$sel_int->setFolderPrep('');
	$sel_int->setDocPrep('');
	$sel_int->setSelKey('return $obj->getBox();');
	$sel_int->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');
	$sel_int->setSelectedID($sfolder);
	$t->assign('SFOLDER_SELECT',$sel_int->parseSelect(0));
	if ($ActionError['fields']['sfolder']) {
		$t->assign('C_SFOLDER','error');
	} else {
		$t->assign('C_SFOLDER','');
	}

	$rad_popup=new RadioButton('m_popup','',1);
	$t->assign('POP_N_F',$rad_popup->f(0));
	$t->assign('POP_J_F',$rad_popup->f(1));

	$rad_mel=new RadioButton('m_mel','','N');
	$t->assign('MEL_NO_F',$rad_mel->f('N'));
	if (file_exists("add-on/mail_sound") && is_dir("add-on/mail_sound")) {
		$dh=opendir("add-on/mail_sound");
		$i=0;
		while ($file = readdir($dh)) {
			if (is_file("add-on/mail_sound/".$file)) {
				$t->assign('MEL_NUM',$i++);
				$t->assign('MEL_F',$rad_mel->f($file));
				$t->assign('MEL_N',Framework::entities($file));
				$t->assign('MEL_L',"add-on/mail_sound/".$file);
				$t->parse('ROW','.mel_row');
			}

		}

	}
	if ($ActionError['fields']['m_mel']) {
		$t->assign('C_M_MEL','error');
	} else {
		$t->assign('C_M_MEL','');
	}
	uksort($mb_msg,array('Framework','sortByLenAsc'));
	foreach ($mb_msg as $key=>$val) {
		if ($Mail->getObj($key,false)) {
			if (!$val['m'] && !$val['a']) continue;
			$t->assign('N_MBOX',Framework::entities($key));
			$t->assign('P_MBOX',$val['a']?'X':'');
			if ($val['m']!='N' && file_exists("add-on/mail_sound/".$val['m'])) {
				$t->assign('M_MBOX',Framework::entities($val['m']));
			} else {
				unset($mb_msg[$key]);
				$t->assign('M_MBOX','-');
				$update_mb_msg=true;
			}
			$t->assign('L_MBOX',"index.php?site=$site&app_name=$app_name&mode=$mode&mb_key=".urlencode($key));
			//if ($key!=$root_obj_u->getID()) {
				$t->assign('L_DEL_MBOX',"index.php?site=$site&app_name=$app_name&mode=$mode&mb_delete=".urlencode($key));
				$t->parse('ROW','del_mbox');
			/*} else {
				$t->clear_dynamic('del_mbox');
			}*/
			$t->parse('ROW','.mbox_row');
		} else {

			unset($mb_msg[$key]);
			$update_mb_msg=true;
		}
	}
	if ($update_mb_msg) {
		$frm->insertPrefs($app_name,array('mb_msg'=>serialize($mb_msg)));
	}
}
/*
if ($Mail->getCfg('cfg/all/filter_colors')) {
	$av_colors=explode(',',$Mail->getCfg('cfg/all/filter_colors'));
	if (!isset($_POST['cfilter_typ'])) $cfilter_typ='from';
	if (!isset($_POST['cfilter_match'])) $cfilter_match='';
	if (!isset($_POST['cfilter_color'])) $cfilter_color=reset($av_colors);
	//debug($_POST);
	$update_cfilter=false;
	$cfilter=unserialize($frm->getPrefs($app_name,'cfilter'));
	if (!is_array($cfilter) || !count($cfilter)) {
		$cfilter=array();
	}
	if ($cfilter_key) {
		$cfilter_typ=$cfilter[$cfilter_key-1]['typ'];
		$cfilter_match=$cfilter[$cfilter_key-1]['match'];
		$cfilter_color=$cfilter[$cfilter_key-1]['color'];
	}
	if ($cfilter_delete) {
		unset($cfilter[$cfilter_delete-1]);
		$update_cfilter=true;
	}
	if (isset($_POST['add_cfilter_x'])) {
		if (!trim($_POST['cfilter_match'])) $ActionError['fields']['cfilter_match']=1;
		if (!$ActionError) {
			if (!$cfilter_key) $cfilter_key=count($cfilter)+1;
			$cfilter[$cfilter_key-1]=array(
				'typ'=>$_POST['cfilter_typ'],
				'match'=>$_POST['cfilter_match'],
				'color'=>$_POST['cfilter_color'],
			);
			$update_cfilter=true;
			$cfilter_typ='from';
			$cfilter_match='';
			$cfilter_color=reset($av_colors);
			$cfilter_key=0;
		}
	}

	if ($cfilter_typ=='from') $t->assign('SEL_FROM','selected="selected"'); else $t->assign('SEL_FROM','');
	if ($cfilter_typ=='to') $t->assign('SEL_TO','selected="selected"'); else $t->assign('SEL_TO','');
	if ($cfilter_typ=='subject') $t->assign('SEL_SUBJECT','selected="selected"'); else $t->assign('SEL_SUBJECT','');

	$t->assign('V_MATCH',$cfilter_match);
	if ($ActionError['fields']['cfilter_match'])  $t->assign('C_MATCH','error'); else $t->assign('C_MATCH','');

	$i=1;
	foreach ($av_colors as $val) {
		if ($cfilter_color==$val) $t->assign('SEL_COLOR','checked="checked"'); else $t->assign('SEL_COLOR','');
		$t->assign('V_COLOR',$val);
		$t->parse('ROW','.cfilter_color_col');
		$i++;
		if ($i>5) {
			$t->parse('ROW','.cfilter_color_row');
			$t->clear_dynamic('cfilter_color_col');
			$i=1;
		}
	}
	if ($i>1) $t->parse('ROW','.cfilter_color_row');

	$t->assign('C_FILTER_KEY',$cfilter_key);

	foreach ($cfilter as $key=>$val) {
			$t->assign('N_CFILTER',Framework::entities($val['typ']));
			$t->assign('E_CFILTER',Framework::entities($val['match']));
			$t->assign('C_CFILTER',Framework::entities($val['color']));
			$t->assign('L_CFILTER',"index.php?site=$site&app_name=$app_name&mode=$mode&cfilter_key=".urlencode($key+1));
			$t->assign('L_DEL_CFILTER',"index.php?site=$site&app_name=$app_name&mode=$mode&cfilter_delete=".urlencode($key+1));
			$t->parse('ROW','.cfilter_row');
	}

	$t->parse('ROW','mail_color');

	if ($update_cfilter) {
		$frm->insertPrefs($app_name,array('cfilter'=>serialize($cfilter)));
	}
}
*/


?>