<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if ($Mail->getCfg('cfg/all/allow_wysiwyg')) {
	$use_m_wysiwyg=1;
	$defFontName='verdana,geneva,sans-serif';
	$defFontSize="12px";
} else {
	$use_m_wysiwyg=0;
}
$maxIdentities=10;
if (!$pers_what) $pers_what=1;
if (isset($save_x)) {
	$pre[$app_name]=$Mail->getPrefs();
	$pre[$app_name]['fullname'.$pers_what]=$fullname;
	$pre[$app_name]['email'.$pers_what]=$email;
	$pre[$app_name]['replyto'.$pers_what]=$replyto;
	$pre[$app_name]['signatur'.$pers_what]=$signatur;
	if ($use_m_wysiwyg) {
		$pre[$app_name]['signatur_html'.$pers_what]=$html_signatur;
	}
	$pre[$app_name]['use'.$pers_what]=$use;
	if ($defuse) $pre[$app_name]['defuse']=$defuse;
	$frm->insertPrefs($app_name,$pre[$app_name]);
	//debug(htmlspecialchars($html_signatur));
	page_close();
	header("location:index.php?site=$site&app_name=$app_name&mode=$mode&pers_what=$pers_what");
	exit;

}
for ($i=1;$i<=$maxIdentities;$i++) {
	if ($i==$pers_what) {
		$t->assign('ROW_COLOR',"bgcolor=\"$fg10color\"");
	} else {
		$t->assign('ROW_COLOR','');
	}
	$t->assign('PERS_NUM',$i);
	$t->parse('ROW','.pers_what_row');
}


if (!isset($fullname)) $fullname=$Mail->getPrefs("fullname".$pers_what);
$txt_fullname=new TextField("fullname","class=sel size=40 maxlength=100");
if (!isset($email)) $email=$Mail->getPrefs("email".$pers_what);
$txt_email=new TextField("email","class=sel size=40 maxlength=100");
if (!isset($replyto)) $replyto=$Mail->getPrefs("replyto".$pers_what);
$txt_replyto=new TextField("replyto","class=sel size=40 maxlength=100");
if (!isset($signatur)) $signatur=$Mail->getPrefs("signatur".$pers_what);
$txt_signatur=new TextArea("signatur",'cols="75" rows="10" class="mailw" wrap="off" style="width:670px;"');
if (!isset($use)) $use=$Mail->getPrefs("use".$pers_what);
$chk_use=new CheckBox("use","",1);
if (!isset($defuse)) $defuse=$Mail->getPrefs("defuse");
$chk_defuse=new CheckBox("defuse","");

if ($use_m_wysiwyg) {
	$relImgPath=Framework::getSelfDir().'/fetch_mail_img.php?img=htmlImg/';
	if (!isset($html_signatur)) {
		$html_signatur=$Mail->getPrefs("signatur_html".$pers_what);
		$html_signatur=preg_replace('/(src="?)[^ ]+\/htmlImg\/(.+\.(jpg|gif|jpeg|png))/i','\\1'.$relImgPath.'\\2',$html_signatur);
		if (!$html_signatur) {
			$html_signatur='<span style="font-size:'.$defFontSize.'"><span style="font-family: '.$defFontName.'"><br/ ><br/ ><br /></span></span>';
		}
	}
	$htmleditor_typ=$Mail->getPrefs('htmleditor_typ')?$Mail->getPrefs('htmleditor_typ'):'tiny_mce';
	switch ($htmleditor_typ) {
		case 'tiny_mce':
			require_once('add-on/tiny_mce/tiny_mce.php');
			$config=array(
				'script_url'=>'add-on/tiny_mce/tiny_mce.js',
				'content_css'=>"tpl/ge/cjs/htmleditor.css",
				'phpimageUploadUrl'=>'ajax.php?ajax_modul=mail_img_upload&htmleditor=tiny_mce&isSign=1',
				'height'=>300,
				'width'=>680,
				'language'=>$session_lang,
			);
			$TinyMce = new TinyMce();
			$TinyMce->returnOutput=true;
			$TinyMce->basePath='add-on/tiny_mce/';
			$TinyMce->textareaAttributes=array('style'=>'width:660px;height:200px;visibility:hidden;');

			$t->assign('EDITOR',$TinyMce->editor("html_signatur", $html_signatur, $config));
			$t->parse('ROW','edit_html');
		break;
		case 'ckeditor':
			require_once('add-on/ckeditor/ckeditor.php');
			$CKEditor = new CKEditor();
			$CKEditor->returnOutput=true;
			$CKEditor->basePath='add-on/ckeditor/';
			$config = array(
				'height'=>300,
				'width'=>680,
				'language'=>$session_lang,
				'resize_maxWidth'=>680,
				'resize_minWidth'=>680,
				'filebrowserImageUploadUrl'=>'ajax.php?ajax_modul=mail_img_upload&htmleditor=ckeditor&isSign=1',
				'fullPage'=>false,
			);
			$t->assign('EDITOR',$CKEditor->editor("html_signatur", $html_signatur, $config));
			$t->parse('ROW','edit_html');
		break;
	}
}

$t->assign('PERS_WHAT',$pers_what);
$t->assign("USE",$chk_use->f());
$t->assign("DEFUSE",$chk_defuse->f($pers_what));
$t->assign("NAME",$txt_fullname->f());
$t->assign("EMAIL",$txt_email->f());
$t->assign("REPLYTO",$txt_replyto->f());
$t->assign("SIGNATUR",$txt_signatur->f());


$t->parse('ROW','update');
$t->assign('FORM_ACTION',"index.php?site=$site&app_name=$app_name&mode=$mode&pers_what=$pers_what");


?>