<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$user_id=$auth->auth['uid'];
$form_action="index.php?site=$site&action=$action&app_name=$app_name";
$t->assign("FORM_ACTION",$form_action);
foreach ($MODELL as $key=>$val) {
	if ($val['Title']) {
		if ($sync_prefs['all']['modell']==$key) {
			$t->assign('MODELL_CHK','selected="selected"');
		} else {
			$t->assign('MODELL_CHK','');
		}
		$t->assign('MODELL_K',$key);
		$t->assign('MODELL_V',$val['Title']);
		$t->parse('ROW','.modell_row');
	}
}

if ($app['addr'] && in_array('contacts',$defStores)) {
	if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
		$myBooks=$Addr->getMyBooks();
		if (!empty($myBooks)) {
			$T->loadModul('addr');
			require_once('lib/class_FormGui.php');
			require_once('lib/class_JsMenuGui.php');
			require_once('lib/class_FunctionButtons.php');
			require_once('lib/class_TemplateGui.php');
			$ldapGui=new TemplateGui('core/common_simple_content.inc.html');
			$formGui=new FormGui();
			$formGui->setLabelClass('no','no_error');
			$key='titFol';
			$formGui->addField($key,'label',$T->lang('[[AKategorien]]'),'','content');
			$formGui->setLabelClass('','error',$key);
			$privBooks=$Addr->getMyBooksPrivat();

			if (!empty($privBooks)) {
				$def_folder2ID='';
				$tmp=$frm->getPrefs('addr','syncCatNew');
				if ($tmp) $def_folder2ID='f_'.$tmp;
				$params=array(
					0=>array(
						'Label'=>$T->lang('[[Kategorie fuer neue Addressen]]'),
						'LabelSep'=>'',
						'JsFunction'=>"loadBoxMenu(1);showBoxTree('folder2ID','folder2ID')",
					),
				);
				$label=new FunctionButtons('jsLabel','js_label',$params);
				$key='folder2ID';
				$formGui->addField($key,'ttip',$label,$def_folder2ID,'content');
				$formGui->setParams($key,array('no_width'=>'1','width'=>'300px','mode'=>'f','app'=>'','params'=>base64_encode(serialize(array('MaxEntries'=>'1','AddrServers'=>$Addr->getMyBooksPrivat())))));
			}
			$def_folderID='';
			$tmp=$frm->getPrefs('addr','syncCat');
			if ($tmp) {
				$def_folderID='f_'.str_replace('|','|f_',$tmp);
			}
			//debug($def_folderID);
			$params=array(
				0=>array(
					'Label'=>$T->lang('[[Zu Synchronisierende Kategorien]]'),
					'LabelSep'=>'',
					'JsFunction'=>"loadBoxMenu(0);showBoxTree('folderID','folderID')",
				),
			);
			$label=new FunctionButtons('jsLabel','js_label',$params);
			$key='folderID';
			$formGui->addField($key,'ttip',$label,$def_folderID,'content');
			$formGui->setParams($key,array('no_width'=>'1','width'=>'300px','mode'=>'f','app'=>'','params'=>''));

			$key='searchSub';
			$formGui->addField($key,'check',$T->lang('[[searchSub]]'),$frm->getPrefs('addr','syncCatSub'),'content');


			$jsMenu=new jsMenuGui('jsTree');
			$jsMenu->setMenuItems($Addr->treeToJson($Addr->listAllTree(),0,'f_'),0);
			if (!empty($privBooks)) $jsMenu->setMenuItems($Addr->treeToJson($Addr->listAllTree($Addr->getMyBooksPrivat()),0,'f_'),1);
			$params=array(
				'funcName'=>'upCpF',
				'ID'=>'folderID',
				'Mode'=>array('folderID'=>'f','folder2ID'=>'f',),
				'Params'=>array('folderID'=>'','folder2ID'=>base64_encode(serialize(array('MaxEntries'=>'1','AddrServers'=>$Addr->getMyBooksPrivat())))),
			);
			$jsMenu->setAction('ttip_m',$params);

			$ldapGui->addContent('cont1',$formGui,'CONTENT');
			$ldapGui->addContent('cont2',$jsMenu,'CONTENT');
			$t->assign('CAT_CONTENT',$ldapGui->process());
			$t->parse('ROW','sync_addr_ldap');
			//$frm->addOnLoad("loadBoxMenu();");
		}
	} else {
			$T->loadModul('addr');
			require_once('lib/class_FormGui.php');
			require_once('lib/class_JsMenuGui.php');
			require_once('lib/class_FunctionButtons.php');
			require_once('lib/class_TemplateGui.php');
			$ldapGui=new TemplateGui('core/common_simple_content.inc.html');
			$formGui=new FormGui();
			$formGui->setLabelClass('no','no_error');

			$key='titFol';
			$formGui->addField($key,'label',$T->lang('[[AKategorien]]'),'','fields1');
			$formGui->setLabelClass('','error',$key);

			//$privBooks=$Addr->getMyBooksPrivat();
			if ($Addr->getPerms(1)) {
				$root_obj_s=false;
				$root_obj_u=$Addr->getSystemObj('u',$session_lang,$user_id,true);
				if (is_object($root_obj_u)) {
					$Addr->addRootID($root_obj_u->getID(),'u');
				} else {
					$root_obj_u=$Addr->getSystemObj('u',$CFG['AV_LANG'],0,false);
					if (is_object($root_obj_u)) {
						$Addr->insertMeta($root_obj_u);
						$root_obj_u->setMeta('UserID',$user_id);
						$root_obj_u->setMeta('RootID',$root_obj_u->getID());
						$Addr->updateMeta($root_obj_u);
						$Addr->addRootID($root_obj_u->getID(),'u');
					}
				}
				if ($Addr->havePermsProfilAcl(2) || $Addr->getPerms(2)) {
					$root_obj_s=$Addr->getSystemObj('s',$session_lang,0,true);
					if (is_object($root_obj_s)) {
						$Addr->addRootID($root_obj_s->getID(),'s');
					}
				}
				if (!isset($_POST['NodeID'])) {
					$sync_ids=$Addr->getSyncIDs($user_id,false);
					// debug($sync_ids);
					if (is_array($sync_ids)) {
						$NodeID=reset($sync_ids);
						$allNodeID=$sync_ids;
					} else {
						$NodeID=0;
					}
				}

				$def_folder2ID='';
				if ($NodeID) $def_folder2ID='f_'.$NodeID;
				$params=array(
					0=>array(
						'Label'=>$T->lang('[[Kategorie fuer neue Addressen]]'),
						'LabelSep'=>'',
						'JsFunction'=>"loadBoxMenu(1);showBoxTree('folder2ID','folder2ID')",
					),
				);
				$label=new FunctionButtons('jsLabel','js_label',$params);
				$key='folder2ID';
				$formGui->addField($key,'ttip',$label,$def_folder2ID,'content');
				$formGui->setParams($key,array('no_width'=>'1','width'=>'300px','mode'=>'f','app'=>'','params'=>base64_encode(serialize(array('MaxEntries'=>'1','AddrServers'=>array($root_obj_u->getID()))))));

				$def_folderID='';
				$allAddrTree=$Addr->listAllTree(array_keys($Addr->getRootIDs()));
				if (!isset($allAddrTree[0][$root_obj_u->getID()])) {
					$allAddrTree[0][$root_obj_u->getID()]=$root_obj_u;
				}
				if (is_object($root_obj_s)) {
					if (!isset($allAddrTree[0][$root_obj_s->getID()])) {
						$allAddrTree[0][$root_obj_s->getID()]=$root_obj_s;
					}
				}
				if ($frm->getPrefs('addr','syncCatSub')==-1) {
					$defSub=false;
				} else {
					$defSub=true;
				}
				$delNode=array();
				if (is_array($allNodeID) && !empty($allNodeID)) {
					if ($defSub) {
						foreach ($allNodeID as $val) {
							if (isset($allAddrTree[$val])) {
								foreach (array_keys($allAddrTree[$val]) as $key) {
									if (in_array($key,$allNodeID)) {
										$delNode[]=$key;
									}

								}
							}
						}
						foreach ($allNodeID as $key=>$val) {
							if (in_array($val,$delNode)) {
								unset($allNodeID[$key]);
							}
						}
					}
					$def_folderID='f_'.implode('|f_',$allNodeID);
				}
				$params=array(
					0=>array(
						'Label'=>$T->lang('[[Zu Synchronisierende Kategorien]]'),
						'LabelSep'=>'',
						'JsFunction'=>"loadBoxMenu(0);showBoxTree('folderID','folderID')",
					),
				);
				$label=new FunctionButtons('jsLabel','js_label',$params);
				$key='folderID';
				$formGui->addField($key,'ttip',$label,$def_folderID,'content');
				$formGui->setParams($key,array('no_width'=>'1','width'=>'300px','mode'=>'f','app'=>'','params'=>base64_encode(serialize(array('AddrServers'=>array_keys($Addr->getRootIDs()))))));

				$key='searchSub';
				$formGui->addField($key,'check',$T->lang('[[searchSub]]'),$defSub,'content');


				$jsMenu=new jsMenuGui('jsTree');
				$jsMenu->setMenuItems($Addr->treeToJson($allAddrTree,0,'f_'),0);
				$jsMenu->setMenuItems($Addr->treeToJson($Addr->listAllTree($root_obj_u->getID()),0,'f_'),1);
				//if (!empty($privBooks)) $jsMenu->setMenuItems($Addr->treeToJson($Addr->listAllTree($Addr->getMyBooksPrivat()),0,'f_'),1);
				$params=array(
					'funcName'=>'upCpF',
					'ID'=>'folderID',
					'Mode'=>array('folderID'=>'f','folder2ID'=>'f',),
					'Params'=>array('folderID'=>'','folder2ID'=>base64_encode(serialize(array('MaxEntries'=>'1')))),
				);// ,
				$jsMenu->setAction('ttip_m',$params);


				if ($app['proj'] && $P) {
					if (!isset($_POST['prjNodeID'])) {
						if ($frm->getPrefs('addr','syncProjects')) {
							$prjNodeID=explode(',',$frm->getPrefs('addr','syncProjects'));
						} else {
							$prjNodeID=array();
						}
					}
					if (!empty($prjNodeID) && !in_array(-1,$prjNodeID)) {
						$defProjects='o_'.implode('|o_',$prjNodeID);
					} else {
						$defProjects='';
					}
					if (!isset($_POST['syncPrjMode'])) {
						if ($frm->getPrefs('addr','syncPrjMode')) {
							$defProjectsMode=$frm->getPrefs('addr','syncPrjMode');
						} elseif ($defProjects) {
							$defProjectsMode='e';
						} else {
							$defProjectsMode='a';
						}
					}

					$key='titPrj';
					$formGui->addField($key,'label',$T->lang('[[Projekte]]'),'','fields1');
					$formGui->setLabelClass('','error',$key);

					$key='FKPrjID';
					$mode='o';
					$params=base64_encode(serialize(array('useNone'=>1)));
					$lb_params=array('Values'=>array());
					$lb_params['Values'][]=array(
						'Label'=>$T->lang('[[Projekte auswaehlen]]'),
						'LabelSep'=>'',
						'mode'=>$mode,
						'app'=>'cal',
						'params'=>$params,
						'FieldVal'=>'_PROJECTS',
					);
					$default='';
					$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
					$formGui->addField($key,'ttip',$lb_Invit,$defProjects,'fields1');
					$formGui->setParams($key,array('mode'=>$mode,'no_width'=>'1','width'=>'300px','params'=>$params));

					$key='syncPrjMode';
					$formGui->addField($key,'radiolist_v','',$defProjectsMode,'fields1');
					$formGui->setValues($key,array('a'=>$T->lang('[[Zusaetzlich zu den ausgewaehlten Kategorien]]'),'e'=>$T->lang('[[Nur ausgewaehlte Projekte synchronisieren]]')));

				}
				$ldapGui->addContent('cont1',$formGui,'CONTENT');
				$ldapGui->addContent('cont2',$jsMenu,'CONTENT');
				$t->assign('CAT_CONTENT',$ldapGui->process());
				$t->parse('ROW','sync_addr_ldap');
				//$frm->addOnLoad("loadBoxMenu();");
			}


	}
	if ($defSyncType=='syncml') {
		for ($ctype=1;$ctype<4;$ctype++) {
			for ($cres=0;$cres<3;$cres++) {
				if ($resolution['addr'][$ctype]==$cres) {
					$t->assign('SEL_ADDR_'.$ctype.'_'.$cres,'selected');
				} else {
					$t->assign('SEL_ADDR_'.$ctype.'_'.$cres,'');
				}
			}
		}
		$t->parse('ROW','sync_addr_conflict');

		$t->assign('SEL_ADDR_PREFS_0','');
		$t->assign('SEL_ADDR_PREFS_1','');
		if ($sync_prefs['all']['contacts/mode']=='1') $t->assign('SEL_ADDR_PREFS_1','selected="selected"');
		$t->parse('ROW','sync_addr_reload');
	}

	$t->parse('ROW','sync_addr');
}
if ($app['cal'] && (in_array('events',$defStores) || in_array('calendar',$defStores))) {

	$groups_array=$frm->getAllGroups();
	$app_users=array_keys($frm->getApplicationUsers('cal'));
	$users_array=$frm->getFullName(array_unique($app_users));
//
	$sel_du=new SelectField('sync_prefs[all][cal/grant_u]','size="8" class="sel" style="width:200px;"',$users_array,"",1,"");
	$sel_dg=new SelectField('sync_prefs[all][cal/grant_g]','size="8" class="sel" style="width:200px;"',$groups_array,"",1,"");

	$t->assign("DU_F",$sel_du->f());
	$t->assign("DG_F",$sel_dg->f());

	$defPrivat=getModellPrefs($sync_prefs['all']['modell'],'cal','privat');
	if (!isset($sync_prefs['all']['cal/no_privat']) || isset($_POST['sync_prefs'])) {
		$sync_prefs['all']['cal/no_privat']=$defPrivat?0:1;
	}
	if ($sync_prefs['all']['cal/no_privat']) {
		$t->assign('SEL_PRIVAT_1','checked="checked"');
		$t->assign('SEL_PRIVAT_0','');
	} else {
		$t->assign('SEL_PRIVAT_0','checked="checked"');
		$t->assign('SEL_PRIVAT_1','');
	}
	$defStatus=getModellPrefs($sync_prefs['all']['modell'],'cal','status');
	if (!isset($sync_prefs['all']['cal/no_status']) || isset($_POST['sync_prefs'])) {
		$sync_prefs['all']['cal/no_status']=$defStatus?0:1;
	}
	if ($sync_prefs['all']['cal/no_status']) {
		$t->assign('SEL_STATUS_1','checked="checked"');
		$t->assign('SEL_STATUS_0','');
	} else {
		$t->assign('SEL_STATUS_0','checked="checked"');
		$t->assign('SEL_STATUS_1','');
	}

	if ($defSyncType=='syncml') {
		for ($ctype=1;$ctype<4;$ctype++) {
			for ($cres=0;$cres<3;$cres++) {
				if ($resolution['cal'][$ctype]==$cres) {
					$t->assign('SEL_CAL_'.$ctype.'_'.$cres,'selected');
				} else {
					$t->assign('SEL_CAL_'.$ctype.'_'.$cres,'');
				}
			}
		}
		$t->parse('ROW','sync_cal_conflict');

		$t->assign('SEL_CAL_PREFS_0','');
		$t->assign('SEL_CAL_PREFS_1','');
		if ($sync_prefs['all']['events/mode']=='1') $t->assign('SEL_CAL_PREFS_1','selected="selected"');
		$t->parse('ROW','sync_cal_reload');
	}
	$t->parse('ROW','sync_cal');
}
if ($app['task'] && (in_array('tasks',$defStores) || in_array('calendar',$defStores))) {
	$sync_id=$Task->getSyncID();
	if (is_object($TaskRoot)) {
		$entrys=$Task->ListSubEntrys($TaskRoot->getID());
		foreach ($entrys as $val) {
			 $t->assign('CAT_VAL',$val->getID());
			 if ($val->getID()==$sync_id) $t->assign('CAT_CHK','selected'); else  $t->assign('CAT_CHK','');
			 $t->assign("CAT_TEXT",Framework::entities($val->getName()));
			 $t->parse("ROW",'.cat_row');
		}
	}
	if ($defSyncType=='syncml') {
		$defStartDate=getModellPrefs($sync_prefs['all']['modell'],'task','startdate');
		//debug($defStartDate);
		if (!isset($sync_prefs['all']['task/no_startdate']) || isset($_POST['sync_prefs'])) {
			$sync_prefs['all']['task/no_startdate']=$defStartDate?0:1;
		}
		if ($sync_prefs['all']['task/no_startdate']) {
			$t->assign('SEL_STARTDATE_1','checked="checked"');
			$t->assign('SEL_STARTDATE_0','');
		} else {
			$t->assign('SEL_STARTDATE_0','checked="checked"');
			$t->assign('SEL_STARTDATE_1','');
		}
		$t->parse('ROW','sync_task_no_startdate');

		for ($ctype=1;$ctype<4;$ctype++) {
			for ($cres=0;$cres<3;$cres++) {
				if ($resolution['task'][$ctype]==$cres) {
					$t->assign('SEL_TASK_'.$ctype.'_'.$cres,'selected');
				} else {
					$t->assign('SEL_TASK_'.$ctype.'_'.$cres,'');
				}
			}
		}
		$t->parse('ROW','sync_task_conflict');

		$t->assign('SEL_TASK_PREFS_0','');
		$t->assign('SEL_TASK_PREFS_1','');
		if ($sync_prefs['all']['tasks/mode']=='1') $t->assign('SEL_TASK_PREFS_1','selected="selected"');
		$t->parse('ROW','sync_task_reload');
	}
	$t->parse('ROW','sync_task');
}
if (is_array($error)) {
        $t->define (array('tpl_error' => "prefs_error.inc.html"));
        $t->parse('ROW','error_3');
        $t->unsetkey('TPL_ERROR');
        $t->parse('TPL_ERROR','tpl_error');
} else $t->assign('TPL_ERROR','');




?>
