<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
if ($auth->auth['uid']==$CFG['SUPERADMIN']) {
  $sadmin=1;
} else $sadmin=0;
$t->assign('MOD_TITLE','Print');
$print_obj=$frm->getPrint($PrintID);
$frm->clearPrint(date('Y-m-d').' 0:0:0');
if ($print_obj && $app[$print_obj['app']]) {
	if ($print_obj['typ']=='html') {
		$t->setRoot("tpl/$THEME/$session_lang");
		$t->define (array('content'=>"print_content.inc.html"));
		if (!$_GET['noDate']) {
			$t->assign('DATE',date('d.m.Y H:i'));
			$t->parse('ROW','print_date');
		}
		$user_array=$frm->read_user($auth->auth['uid']);
		$t->assign('FIRSTNAME',Framework::entities($user_array["firstname"]));
		$t->assign('LASTNAME',Framework::entities($user_array["lastname"]));
		if ($user_array["company"]) {
			$t->assign('COMPANY',Framework::entities($user_array["company"]));
			$t->parse('ROW','user_company');
		}
		if ($user_array["adress"]) $address=$user_array["adress"];
		if ($address && ($user_array["zip"] || $user_array["place"])) $address.=' - ';
		$address.=$user_array["zip"];
		if ($user_array["zip"]) $address.=' ';
		$address.=$user_array["place"];
		if ($address) {
			$t->assign('ADDRESS',Framework::entities($address));
			$t->parse('ROW','user_address');
		}
		if ($user_array["email"]) {
			$t->assign('EMAIL',Framework::entities($user_array["email"]));
			if ($t->issetkey('user_email')) $t->parse('ROW','user_email');
		}
		if ($user_array["tel"]) {
			$t->assign('TEL',Framework::entities($user_array["tel"]));
			$t->parse('ROW','user_tel');
		}
		if ($user_array["fax"]) {
			$t->assign('FAX',Framework::entities($user_array["fax"]));
			$t->parse('ROW','user_fax');
		}
		$t->parse('ROW','print_header');
		if ($addHeaderToBody) {
			header('Content-Type: text/html; charset='.strtolower(GE_CHARSET));
			$print_obj['text']=preg_replace('/(<\s*body[^>]*>)/i','\\1'.$t->getparsed(),$print_obj['text'],1);
			echo $print_obj['text'];
		} else {
			$t->assign('TPL_CONTENT',$print_obj['text']);
			$t->parse("CONTENT","content");
			$t->FastPrint();
		}
	}
	if ($print_obj['typ']=='pdf') {


	}
} else die ("acces denied");

page_close();
?>
