<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array('tpl_entry' => "view_entry.inc.html"));
$all_perms=$Stel->getAllPerms('l');
if (is_array($all_perms['l'])) {
	$sel_group=array_keys($all_perms['l']);
} else {
	$sel_group=array($CFG['GROUP_ALL']);
}
$user_array=array(0=>'-',-1=>$text_other) + $frm->getFullName($frm->getGroupUsers($sel_group));
$cat=$Stel->listAllCat($session_lang);
$cat_array=array(0=>'-');
foreach ($cat as $key=>$val) {
	$cat_array[$key]=$val['Name_'.$session_lang];
}
if ($delete_x) {
	$Stel->deleteTel($ID);
	page_close();
	header("Location:index.php?site=$site&action=v&bdate=$bdate");
	exit;
}
if (isset($_POST['save_x'])) {
	if (!$data['TelCatID']) {
		$ActionError['fields']['TelCatID']=1;
	}
	if (!trim($data['TelFrom'])) {
		$ActionError['fields']['TelFrom']=1;
	}
	if (!$data['TelUser']) {
		$ActionError['fields']['TelUser']=1;
	}
	$data['TelTime']=$frm->parseDate($dTelTime,$hTelTime,$mTelTime);
	if (!$data['TelTime']) $ActionError['fields']['TelTime']=1;
	if (!$ActionError) {
		$time=time();
		if ($ID) {
			$data['UserModify']=$auth->auth['uid'];
			$data['TimeModify']=$time;
			$Stel->updateTel($ID,$data);
		} else {
			$data['UserCreate']=$data['UserModify']=$auth->auth['uid'];
			$data['TimeCreate']=$data['TimeModify']=$time;
			$Stel->insertTel($data);
		}
		if ($send_msg) {
			$t->define(array('tpl_email'=>'mail.inc.html'));
			$t->assign('TEL_USER',$data['TelFrom']);
			$t->assign('TEL_DESC',$data['Description']);
			$t->assign('TEL_CAT',$cat_array[$data['TelCatID']]);
			$t->assign('TEL_TIME',date('d.m.Y H:i',$time));

			$t->parse('ROW','subject_mail');
			$t->parse('ROW','body_mail');
			$subject=$t->getParsed('subject_mail');
			$body=$t->getParsed('body_mail');
			$frm->sendmessage(array($data['TelUser']),$auth->auth['uid'],$subject,$body,'','','msg_1.gif');
		}
		page_close();
		header("Location:index.php?site=$site&action=v&bdate=$bdate");
		exit;

	}
} else {
	if ($ID) {
		$data=$Stel->readTel($ID);
		$dTelTime=date('d/m/Y',$data['TelTime']);
		$hTelTime=date('H',$data['TelTime']);
		$mTelTime=date('i',$data['TelTime']);
		if (!isset($cat_array[$data['TelCatID']])) {
			$tmp=$Stel->readCat($data['TelCatID'],$session_lang);
			if ($tmp) $cat_array[$data['TelCatID']]=$tmp["Name_$session_lang"];
		}
		if (!isset($user_array[$data['TelUser']])) {
			$tmp=$frm->getFullName($data['TelUser'],0,1);
			if ($tmp[$data['TelUser']]) $user_array[$data['TelUser']]=$tmp[$data['TelUser']];
		}

	} else {
		if ($TelTime) {
			$dTelTime=date('d/m/Y',$TelTime);
		} else {
			$dTelTime=date('d/m/Y');
		}
		$mTelTime='00';
		$hTelTime='00';
	}


}

if ($ActionError['fields']['TelFrom']) {
	$t->assign('C_TELFROM','error');
} else {
	$t->assign('C_TELFROM','');
}
$f_telfrom=new TextField ('data[TelFrom]','class="sel" style="width:240px"');
$t->assign('F_TELFROM',$f_telfrom->f());


if ($ActionError['fields']['TelUser']) {
	$t->assign('C_TELUSER','error');
} else {
	$t->assign('C_TELUSER','');
}
$f_teluser=new SelectField('data[TelUser]','class="sel" style="width:240px"',$user_array);
$t->assign('F_TELUSER',$f_teluser->f());

if ($ActionError['fields']['TelCatID']) {
	$t->assign('C_TELCAT','error');
} else {
	$t->assign('C_TELCAT','');
}
$f_telcat=new SelectField('data[TelCatID]','class="sel" style="width:240px"',$cat_array);
$t->assign('F_TELCAT',$f_telcat->f());

$f_desc=new TextArea ('data[Description]','class="sel" rows="6" style="width:240px"');
$t->assign('F_DESC',$f_desc->f());

$f_msg=new CheckBox ('send_msg','',1);
$t->assign('F_MSG',$f_msg->f(1));

if ($ActionError['fields']['TelTime']) {
	$t->assign('C_TELTIME','error');
} else {
	$t->assign('C_TELTIME','');
}

$t->assign('F_D_TELTIME',$dTelTime);
$t->assign('F_H_TELTIME',$hTelTime);
$t->assign('F_M_TELTIME',$mTelTime);
$date=$frm->parseDate($dTelTime);
if (!$date) $date=time();
$link="js_cal.php?date=".$date;
$t->assign('JS_CAL_B',"NewWindow('$link&field=dTelTime','Calendar',".$CFG['calwidth'].','.$CFG['calheight'].",0);");



$form_action="index.php?site=$site&action=$action";
if ($ID) {
	$form_action.="&ID=$ID";
	$t->parse('ROW','delete');
	$t->parse('ROW','title_edit');
} else {
	$t->parse('ROW','title_new');
}

if ($bdate) {
	$form_action.="&bdate=$bdate";
	$t->assign('L_BREAK',"index.php?site=$site&action=v&bdate=$bdate");
	$t->parse('ROW','break');
} else {
	$t->assign('L_BREAK',"index.php?site=$site&action=$action");
	$t->parse('ROW','break');
}
$t->assign('FORM_ACTION',$form_action);
$t->parse('ROW','update');
$t->assign('TPL_ROOT','');
?>