<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if (isset($noTpl_x)) unset($edit_tpl);

if ($tpl_action_x && $tpl_action_val) {
	switch($tpl_action_val) {
		case 'edit':
			$edit_tpl=1;
			break;
		case 'save':
			$edit_tpl=1;
			unset($TplID);
			break;
		case 'copy':
			$edit_tpl=1;
			unset($TplID);
			break;
		case 'delete':
			$Task->deleteTplTask($TplID);
			unset($edit_tpl,$TplID);
			break;

	}



}

if (isset($save_x)) {
	if (!$event_title) $ActionError['fields']['Title']=1;
	$nTaskObj['Title']=$event_title;
	$nTaskObj['Text']=$event_desc;
	$nTaskObj['OwnerID']=$user_id;
	$nTaskObj['Priority']=$event_priority;
	$nTaskObj['Notes']=$invit_notes;
	$tmp=$frm->parseDate($event_start);
	if (!$tmp) $ActionError['fields']['StartDate']=1;
	else $StartDate=$tmp;
	$nTaskObj['StartDate']=$StartDate;

	$tmp=$frm->parseDate($event_end,23,59,59);
	if ($tmp) {
		$EndDate=$tmp;
		if ($EndDate<$StartDate) $ActionError['fields']['EndDate']=1;
	} else $EndDate=$StartDate;
	$nTaskObj['EndDate']=$EndDate;

	if ($RadCat=='g') {
		if (!$CatG) $ActionError['fields']['Cat']=1; else $nTaskObj['FKDocID']=$CatG;
	}
	if ($RadCat=='p') {
		if (!$CatP) $ActionError['fields']['Cat']=1; else $nTaskObj['FKDocID']=$CatP;
	}
	if (!$nTaskObj['FKDocID']) $ActionError['fields']['Cat']=1;
	if ($event_rec_type) {
		$tmp=$frm->parseDate($rec_end,23,59,59);
		if ($tmp) {
			$RecDate=$tmp;
			if ($RecDate<$EndDate || $RecDate<$StartDate) $ActionError['fields']['RecDate']=1;
		} else $RecDate=-1;
		$nTaskObj['RecDate']=$RecDate;
		$nTaskObj['RecType']=$event_rec_type;
		$nTaskObj['RecInt']=$event_rec_int;
	} else {
		$nTaskObj['RecDate']=0;
		$nTaskObj['RecType']=0;
		$nTaskObj['RecInt']=0;
	}
	switch($AlarmTyp) {
		case 'm':
			$nTaskObj['Alarm']=intval($event_alarm_d)*30;
			break;
		case 'w':
			$nTaskObj['Alarm']=intval($event_alarm_d)*7;
			break;
		default:
			$nTaskObj['Alarm']=intval($event_alarm_d);
			break;
	}
	$task_users=array();
	if (is_array($invit_users) || is_array($invit_groups)) {
		$Typ='t';
		$TaskUsers[$user_id]=1;

		if (is_array($invit_users)) {
			$task_users=$invit_users;
			$nTaskObj['Users']=implode(',',$invit_users);
			foreach($invit_users as $val) $TaskUsers[$val]=1;
		}

		if (is_array($invit_groups)) {
			$gusers=$frm->getGroupUsers($invit_groups);
			$temp_app=$frm->getApplicationUsers('task');
			if (is_array($gusers)) {
				foreach ($gusers as $val) {
					if ($temp_app[$val] && $val!=$user_id) {
						$task_users[]=$val;
						$TaskUsers[$val]=1;
					}
				}
				$nTaskObj['Groups']=implode(',',$invit_groups);
			}
		}
		$task_users=array_unique($task_users);
		$nTaskObj['DoneOne']=$done_one;
		$nTaskObj['Deleg']=$invit_other;
		if (!count($task_users)) $ActionError['fields']['Invit']=1;
	} else {
		$Typ='p';
		if ($nTaskObj['Deleg']) $ActionError['fields']['Invit']=1;
		$nTaskObj['Users']='';
		$nTaskObj['Groups']='';
		$task_users[]=$user_id;
		$TaskUsers[$user_id]=1;
	}
	if ($edit_tpl) {
		unset($ActionError);
		if (!$TplName) $ActionError['fields']['TplName']=1;
		if (!$ActionError) {
			unset($edit_tpl);
			$nTaskObj['DurTyp']=$dur_typ;
			$nTaskObj['DurNum']=$dur_num;
			if ($done_one) $nTaskObj['DoneOne']=$done_one;
			if ($invit_other) $nTaskObj['Deleg']=$invit_other;
			if ($TplID) {
				$Task->updateTplTask($TplID,$TplName,$TplUsers,$nTaskObj);
			} else {
				$Task->saveTplTask($TplName,$TplUsers,$nTaskObj);
			}


		}

	} else {
		if (!$ActionError) {

			if ($TaskID && !$cop) {
				$log_tras=array(
					'{ESTART}'=>date('d.m.Y',$nTaskObj['StartDate']),
					'{ETITLE}'=>trim($nTaskObj['Title']),
					'{ETEXT}'=>trim($nTaskObj['Text']),
				);
				if ($nTaskObj['StartDate']!=$nTaskObj['EndDate']) $log_tras['{EEND}']=date('d.m.Y',$nTaskObj['EndDate']); else $log_tras['{EEND}']='-';

				$OldUsers=$Task->getTaskUsers($TaskID);
				$OldTaskObj=$Task->readTask($TaskID);
				foreach ($OldUsers as $key=>$val) {
					if ($key!=$user_id && !in_array($key,$task_users)) $delete_users[]=$key;
					elseif ($key!=$user_id) $update_users[]=$key;
				}
				foreach($task_users as $val) {
					if (!$OldUsers[$val]) $insert_users[]=$val;
				}
				if ($Typ=='t') $nTaskObj['Status']=2;
				else $nTaskObj['Status']=1;

				if ($Typ=='t' && $invit_other) {
					$Task->updateTaskUsers($TaskID,array($user_id),array('Done'=>5,'TaskType'=>'c'));
					if (count($task_users)==1) $Typ='p';
				} elseif ($Typ=='t' && !$invit_other) {
					if ($nTaskObj['EndDate']==$nTaskObj['StartDate']) $Typ='d';
					$Task->updateTaskUsers($TaskID,array($user_id),array('Done'=>1,'TaskType'=>$Typ));
				} else {
					if (!is_array($update_users) || !in_array($user_id,$update_users)) $update_users[]=$user_id;
				}
				if ($Typ=='p' && $nTaskObj['EndDate']==$nTaskObj['StartDate']) $Typ='o';
				if ($Typ=='t' && $nTaskObj['EndDate']==$nTaskObj['StartDate']) $Typ='d';

				if (is_array($insert_users)) {
					$Task->saveTaskUsers($TaskID,$insert_users,$Typ,$nTaskObj['Status']);
				}
				if (is_array($update_users)) {
					$Task->updateTaskUsers($TaskID,$update_users,array('TaskType'=>$Typ));
				}
				if (is_array($delete_users)) {
					$Task->deleteTaskUsers($TaskID,$delete_users);
					$Task->deleteTaskLog($TaskID,$delete_users);
				}
				$tmp_status=$Task->checkTaskStatus($TaskID,$nTaskObj['DoneOne']);
				$nTaskObj['Status']=$tmp_status;
				$Task->updateTask($TaskID,$nTaskObj);
				if ($tmp_status==4) {
					$Task->updateTask($TaskID,array('StatusDate'=>time()));
					if ($nTaskObj['RecType'] && ($next_recur=$Task->nextRecurrence(
						$nTaskObj['StartDate'],
						$nTaskObj['EndDate'],
						$nTaskObj['RecType'],
						$nTaskObj['RecInt'],
						$nTaskObj['RecDate']))) {
							$nTaskObj['StartDate']=$next_recur['start'];
							$nTaskObj['EndDate']=$next_recur['end'];
							if ($nTaskObj["Users"] || $nTaskObj["Groups"]) $Typ='t';
							else $Typ='p';
							$Task->saveAllTask($nTaskObj,$TaskUsers,$Typ);
					}
				} else {
					if (date('d.m.Y',$OldTaskObj['EndDate']) != date('d.m.Y',$nTaskObj['EndDate'])) {

						$log_tras['{ODATE}']=date('d.m.Y',$OldTaskObj['EndDate']);
						$log_tras['{NDATE}']=date('d.m.Y',$nTaskObj['EndDate']);


						$Task->insertLog($TaskID,$auth->auth['uid'],strtr($T->lang('[[task_action_move_title]]'),$log_tras),'log');
						if ($nTaskObj['Notes']) {
							$TaskUsers=$Task->getTaskUsers($TaskID);
							unset($send_user);
							foreach ($TaskUsers as $key=>$val) {
								//echo $key.'-'.$val;
								if ($key!=$auth->auth['uid'] && $val!=3 && $val!=2 && $val!=4) {
									$send_user[]=$key;
								}
							}
							if ($send_user) {
								$frm->sendmessage($send_user,
									$auth->auth['uid'],
									strtr($T->lang('[[task_action_move_title]]'),$log_tras),
									strtr($T->lang('[[task_action_move_text]]'),$log_tras),
									"?site=$site&action=vo&TaskID=$TaskID",
									$nTaskObj['Title'],
									$IMG_NOTES);

							}
						}
					}
				}
			} else {
				$nTaskObj['TimeCreate']=time();
				if ($Typ=='t') $nTaskObj['Status']=2;
				else $nTaskObj['Status']=1;
				$TaskID=$Task->saveAllTask($nTaskObj,$TaskUsers,$Typ);
				if ($CFG['USER_LIST'] && is_array($invit_users)) {
					$frm->updateHotlist($invit_users,'task');
				}
			}
			$location="index.php?site=$site&action=vo&oid=$oid&mode=$mode&o=$o&a=$a&b=$b&TaskID=".$TaskID;
			if ($qlink) $location.="&qlink=".urlencode($qlink);
			page_close();
			header ("Location:$location");
			exit;
		}
	}

}
$form_action="index.php?site=$site&action=$action&oid=$oid&mode=$mode&o=$o&a=$a&b=$b&TaskID=$TaskID";
if ($cop) $form_action.="&cop=$cop";
if ($qlink) $form_action.="&qlink=".urlencode($qlink);
if ($TplID) $form_action.="&TplID=$TplID";
$tpl_link=$form_action;
if ($edit_tpl) {
	$form_action.="&edit_tpl=$edit_tpl";
	if (!$save_x && $TplID && ($tpl_obj=$Task->readTpl($TplID))) {
		$TplName=$tpl_obj['TplName'];
		$TplUsers=$tpl_obj['TplUsers'];
		$t->parse('ROW','tit_tpl_edit');
	} else {
		$t->parse('ROW','tit_tpl');
	}
	$txt_name=new TextField("TplName","size=40 class=sel");
	$t->assign("TPL_NAME_F",$txt_name->f());
	if ($ActionError['fields']['TplName']) $t->assign('C_TPL_NAME','error'); else $t->assign('C_TPL_NAME','desc');
	$group_array=array(''=>'-') + $frm->getAllGroups();
	$sel_users=new SelectField("TplUsers","class=sel",$group_array);
	$t->assign("TPL_USERS_F",$sel_users->f());
	$t->parse('ROW','sel_tpl_team');
	$t->parse('ROW','con_tpl');

} elseif ($TaskID) {
	if ($cop) {
		$t->parse('ROW','tit_copy');
	} else {
		$t->parse('ROW','tit_edit');
	}
} else {
	$t->parse('ROW','tit_new');
}
$tpl_parse=0;
if ($TplID && !$edit_tpl) {
	$tpl_obj=$Task->readTpl($TplID);
	if ($tpl_obj) {
		$t->parse('ROW','obj_tpl_delete');
		$t->parse('ROW','obj_tpl_copy');
		$t->parse('ROW','obj_tpl_edit');
		$tpl_parse=1;
	} else {
		$t->parse('ROW','obj_tpl_copy');
		$tpl_parse=1;
	}
}
if (!$edit_tpl && !$TplID) {
	$t->parse('ROW','obj_tpl_save');
	$tpl_parse=1;
}
if ($tpl_parse) $t->parse('ROW','tpl_action');


if (!$save_x) {
	if ($TplID) $nTaskObj=$Task->readTplTask($TplID);
	elseif($TaskID) $nTaskObj=$Task->readTask($TaskID);
	if ($nTaskObj) {
		$event_title=$nTaskObj["Title"];
		$event_desc=$nTaskObj["Text"];
		$event_start=date('d/m/Y',$nTaskObj["StartDate"]);
		if ($nTaskObj["EndDate"]!=$nTaskObj["StartDate"]) {
			$event_end=date('d/m/Y',$nTaskObj["EndDate"]);
			$tmp_day=floor(($nTaskObj["EndDate"]-$nTaskObj["StartDate"])/(3600*24));
			if (($test=$tmp_day/30) && floor($test)==$test && $test<11) {
				$dur_num=$test;
				$dur_typ='month';
			} elseif (($test=$tmp_day/7) && floor($test)==$test && $test<11) {
				$dur_num=$test;
				$dur_typ='week';
			} elseif ($tmp_day<11) {
				$dur_num=$tmp_day;
				$dur_typ='day';
			}
		}
		if ($nTaskObj['DurTyp'] && $nTaskObj['DurNum']) {
			$dur_num=$nTaskObj['DurNum'];
			$dur_typ=$nTaskObj['DurTyp'];
		}


		if ($nTaskObj['Alarm']) {
			if ($nTaskObj['Alarm']%(30)==0) {
				$AlarmTyp='m';
				$event_alarm_d=$nTaskObj['Alarm']/(30);
			} elseif ($nTaskObj['Alarm']%(7)==0) {
				$AlarmTyp='w';
				$event_alarm_d=$nTaskObj['Alarm']/(7);
			} else {
				$AlarmTyp='d';
				$event_alarm_d=$nTaskObj['Alarm'];
			}

		} else {
			$event_alarm_d=0;
			$AlarmTyp='d';

		}

		if ($nTaskObj["Users"]) $invit_users=explode(',',$nTaskObj["Users"]);
		if ($nTaskObj["Groups"]) $invit_groups=explode(',',$nTaskObj["Groups"]);
		$event_priority=$nTaskObj["Priority"];
		if ($nTaskObj["RecDate"]>0) $rec_end=date('d/m/Y',$nTaskObj["RecDate"]);
		$event_rec_type=$nTaskObj["RecType"];
		$event_rec_int=$nTaskObj["RecInt"];
		$invit_notes=$nTaskObj["Notes"];
		$invit_other=$nTaskObj["Deleg"];
		$done_one=$nTaskObj["DoneOne"];
		$CatObj=$Task->getObj($nTaskObj['FKDocID']);
		if (is_object($CatObj) && $root_obj[$CatObj->getMeta('RootID')]) {
			if ($root_obj[$CatObj->getMeta('RootID')]->getMeta('System')=='u') {
				$CatP=$CatObj->getID();
			}
			if ($root_obj[$CatObj->getMeta('RootID')]->getMeta('System')=='s') {
				$CatG=$CatObj->getID();
			}
		} else {

		}
		if ($TplID) {
			unset($event_start,$event_end,$rec_end);

		}
	}
}


for ($i=1;$i<20;$i++) {$rec_int[$i]=$i;}

if (!isset($date)) $date=time();
if (!isset($event_start))  {
	if (isset($n_typ) && $n_num) {
		switch ($n_typ) {
			case 'day':
				$date+=$n_num*3600*24;
				break;
			case 'week':
				$date+=$n_num*7*3600*24;
				break;
			case 'month':
				$date+=$n_num*30*3600*24;
				break;
		}

	}
	$event_start=date('d/m/Y',$date);
}
if (!isset($event_end)) {
	if (isset($date_end)) $event_end=date('d/m/Y',$date_end);
	elseif (isset($dur_typ) && isset($dur_num)) {
		switch ($dur_typ) {
			case 'day':
				$date+=$dur_num*3600*24;
				break;
			case 'week':
				$date+=$dur_num*7*3600*24;
				break;
			case 'month':
				$date+=$dur_num*30*3600*24;
				break;
		}
		$event_end=date('d/m/Y',$date);
	}else $event_end='--/--/----';
}
$t->assign('FOCUS_FIELD','event_title');
$dur_num_array=range(0,10);
$txt_title=new TextField("event_title",'size="40" class="sel" style="width:300px;"');
$txt_desc=new TextArea("event_desc",'rows="5" cols="40" class="sel" style="width:300px;"');
$date_start=new TextField("event_start",'size="15" class="sel" style="width:100px;" onChange="checkStart()"',"","");
$date_end=new TextField("event_end",'size="15" class="sel" style="width:100px;" onChange="checkEnd()"',"","");
$txt_alarm=new TextField("event_alarm_d","size=4 class=sel maxlength=3","0","%","0");
$date_rec=new TextField("rec_end",'size="15" class="sel" style="width:100px;" onChange="checkRec()"',"","","--/--/----");
$sel_rec_int=new SelectField("event_rec_int","class=sel",$rec_int);
$rad_priority=new RadioButton("event_priority","class=sel",1);
$chk_msg=new CheckBox ("alarm_msg",'',1);
$sel_dur_num=new SelectField("dur_num",'class=sel onChange="checkDuration();" onKeyUp="checkDuration();"',$dur_num_array);

require('lib/class_ObjSelect.php');
foreach ($root_obj as $val) {
	if ($val->getMeta('System')=='u') {
		$sel_cat_p=new ObjSelect();
		$sel_cat_p->setClass('noption');
		$sel_cat_p->setSelectedID($CatP);
		$sel_cat_p->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');
		$sel_cat_p->setFolderPrep('');
		$sel_cat_p->setTree($Task->ListAllTree($val->getID(),-1,'Title_'.$session_lang,'ASC'));
		$option_tree=$sel_cat_p->parseSelect($val->getID());
		$t->assign('SEL_CAT_P',$option_tree);
	}
	if ($val->getMeta('System')=='s') {
		$sel_cat_g=new ObjSelect();
		$sel_cat_g->setClass('noption');
		$sel_cat_g->setSelectedID($CatG);
		$sel_cat_g->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');
		$sel_cat_g->setFolderPrep('');
		$sel_cat_g->setTree($Task->ListAllTree($val->getID(),-1,'Title_'.$session_lang,'ASC'));
		$option_tree=$sel_cat_g->parseSelect($val->getID());
		$t->assign('SEL_CAT_G',$option_tree);
	}
}
if ($CatP) $t->assign('CHK_RAD_CAT_P','checked'); else $t->assign('CHK_RAD_CAT_P','');
if ($CatG) $t->assign('CHK_RAD_CAT_G','checked'); else $t->assign('CHK_RAD_CAT_G','');
if ($ActionError['fields']['Cat']) $t->assign('C_CAT','error'); else $t->assign('C_CAT','desc');


$t->assign("FORM_ACTION",$form_action);
if ($ActionError['fields']['Title']) $t->assign('C_TITLE','error'); else $t->assign('C_TITLE','desc');
$t->assign("EVENT_TITLE_F",$txt_title->f());
$t->assign("EVENT_DESC_F",$txt_desc->f());

if ($ActionError['fields']['StartDate']) $t->assign('C_START','error'); else $t->assign('C_START','desc');
$t->assign("EVENT_START_F",$date_start->f());

	$link="js_cal.php?date=".time()."&field=event_start";
	$t->assign('JS_CAL_B',"NewWindow('$link','Calendar',".$CFG[calwidth].','.$CFG[calheight].",0);");


if ($ActionError['fields']['EndDate']) $t->assign('C_END','error'); else $t->assign('C_END','desc');
$t->assign("EVENT_END_F",$date_end->f());
for ($i_t=0;$i_t<6;$i_t++) {
	if ($i_t==$event_rec_type) {
		$t->assign('REC_CHK_'.$i_t,'selected');
	} else {
		$t->assign('REC_CHK_'.$i_t,'');
	}
}
$t->assign("REC_INT_F",$sel_rec_int->f());
if ($ActionError['fields']['RecDate']) $t->assign('C_REC','error'); else $t->assign('C_REC','desc');
$t->assign("REC_END_F",$date_rec->f());
$t->assign("PRIORITY_F_0",$rad_priority->f(0));
$t->assign("PRIORITY_F_1",$rad_priority->f(1));
$t->assign("PRIORITY_F_2",$rad_priority->f(2));
$t->assign("ALARM_MSG_F",$chk_msg->f(1));

$t->assign("SEL_DUR_NUM",$sel_dur_num->f());
if ($dur_typ=='day') $t->assign('SEL_DUR_DAY','selected'); else $t->assign('SEL_DUR_DAY','');
if ($dur_typ=='week') $t->assign('SEL_DUR_WEEK','selected'); else $t->assign('SEL_DUR_WEEK','');
if ($dur_typ=='month') $t->assign('SEL_DUR_MONTH','selected'); else $t->assign('SEL_DUR_MONTH','');
if ($dur_typ=='0') $t->assign('SEL_DUR_0','selected'); else $t->assign('SEL_DUR_0','');
$t->parse('ROW','duration');
$link="js_cal.php?date=".time()."&field=event_end";
$t->assign('JS_CAL_E',"NewWindow('$link','Calendar',".$CFG[calwidth].','.$CFG[calheight].",0);");
$link="js_cal.php?date=".time()."&field=rec_end";
$t->assign('JS_CAL_R',"NewWindow('$link','Calendar',".$CFG[calwidth].','.$CFG[calheight].",0);");

$t->assign("EVENT_ALARM_D_F",$txt_alarm->f());
$t->assign('ALARMTYP_D','');
$t->assign('ALARMTYP_W','');
$t->assign('ALARMTYP_M','');
$t->assign('ALARMTYP_'.strtoupper($AlarmTyp),'selected');


$temp_app=$frm->getApplicationUsers('task');
$users_array=$frm->getFullName(array_keys($temp_app));
unset($users_array[$user_id]);

$groups_array=$frm->getAllGroups();
$sel_groups=new SelectField("invit_groups",'size="8" class="sel" style="width:200px;" id=InvitGroups',$groups_array,"",1,"");
$sel_users=new SelectField("invit_users",'size="8" class="sel" style="width:200px;" id=InvitUsers',$users_array,"",1,"");
$chk_other=new CheckBox('invit_other','class=sel',1);
$chk_notes=new CheckBox('invit_notes','class=sel',1);
$chk_done_one=new CheckBox('done_one','class=sel',1);
if ($ActionError['fields']['Invit']) $t->assign('C_INVIT','error'); else $t->assign('C_INVIT','desc');
$t->assign("INVIT_GROUPS_F",$sel_groups->f());
$t->assign("INVIT_USERS_F",$sel_users->f());
$t->assign("INVIT_OTHER_F",$chk_other->f(1));
$t->assign("INVIT_NOTES_F",$chk_notes->f(1));
$t->assign("INVIT_DONE_ONE_F",$chk_done_one->f(1));
if ($CFG[USER_LIST]) {
	$link="js_user.php?modul=task&form=daten&field=invit_users&mult=1";
	$t->assign('JS_USER_I',"NewWindow('$link','User',".$CFG[userwidth].','.$CFG[userheight].",0)");
} else $t->assign('JS_USER_I','');
$t->parse("ROW","invitation");


$tpl_list=$Task->listTplTask(explode(',',$REG_USER['groups']));
foreach ($tpl_list as $key=>$val) {
	if ($TplID==$key || $eTplID==$key) {
		$t->assign('ROW_COLOR',$fg10color);
	} else {
		$t->assign('ROW_COLOR',$bgcolor);
	}
	$t->assign('TPL_NAME',Framework::entities($val['name']));
	$t->assign('L_VIEW',"$tpl_link&TplID=$key");
	$t->parse('ROW','.task_tpl_row');
}
$t->parse('ROW','task_tpl');

if ($edit_tpl) {
	$t->parse('ROW','tpl_break');
} else {
	if ($TaskID) $t_break="index.php?site=$site&action=vo&oid=$oid&mode=$mode&o=$o&a=$a&b=$b&TaskID=".$TaskID;
	else $t_break="index.php?site=$site&action=b&oid=$oid&mode=$mode&o=$o&a=$a&b=$b";
	if ($qlink) $t_break.="&qlink=".urlencode($qlink);
	$t->assign('L_BREAK',$t_break);
	$t->parse('ROW','break');
}




?>
