function loadEntry(zefId,prjId,catId,compId,compMode) {
	if (prjId) {
		setAjaxTip('FKzefPrjID','z_' + prjId,'','z','YToxOntzOjEwOiJNYXhFbnRyaWVzIjtpOjE7fQ==');
		loadZefCat('FKzefCatID',prjId,catId);
	}
	if (compId) {
		document.getElementById('FKcompID').value=compId;
		if (compId==-1) {
			changeDisp('disp_compMode',1);
			if (compMode==2) {
				document.getElementById('compMode_2').checked=true;
			} else if (compMode) {
				document.getElementById('compMode_1').checked=true;
			} else {
				document.getElementById('compMode_0').checked=true;
			}
			$('#compZefID').val(zefId);
			loadCompSchluessel('');
		} else {
			changeDisp('disp_compMode',-1);
			changeDisp('compSchluessel',-1);
		}
	} else {
		if (document.getElementById('FKcompID')) document.getElementById('FKcompID').value=0;
		changeDisp('disp_compMode',-1);
		changeDisp('compSchluessel',-1);
	}

	if (zefId && document.getElementById('zDesc_' + zefId)) {
		var htmlVal=document.getElementById('zDesc_' + zefId).innerHTML;
		htmlVal=htmlVal.replace(/&amp;/,'&');
		document.getElementById('zefDescription').value=htmlVal;
	} else {
		document.getElementById('zefDescription').value='';
	}
}
function loadEntry_I(zefId,prjId,catId,compId,compMode) {
	if (prjId) {
		setAjaxTip('iFKzefPrjID','z_' + prjId,'','z','YToxOntzOjEwOiJNYXhFbnRyaWVzIjtpOjE7fQ==');
		loadZefCat('iFKzefCatID',prjId,catId);
	}
	if (compId) {
		document.getElementById('iFKcompID').value=compId;
		if (compId==-1) {
			changeDisp('idisp_compMode',1);
			if (compMode==2) {
				document.getElementById('icompMode_2').checked=true;
			} else if (compMode) {
				document.getElementById('icompMode_1').checked=true;
			} else {
				document.getElementById('icompMode_0').checked=true;
			}
			$('#icompZefID').val(zefId);
			loadCompSchluessel('i');
		} else {
			changeDisp('idisp_compMode',-1);
			changeDisp('icompSchluessel',-1);
		}
	} else {
		changeDisp('idisp_compMode',-1);
		changeDisp('icompSchluessel',-1);
		if (document.getElementById('iFKcompID')) document.getElementById('iFKcompID').value=0;
	}
	if (zefId && document.getElementById('zDesc_' + zefId)) {
		var htmlVal=document.getElementById('zDesc_' + zefId).innerHTML;
		htmlVal=htmlVal.replace(/&amp;/,'&');
		document.getElementById('izefDescription').value=htmlVal;
	} else {
		document.getElementById('izefDescription').value='';
	}
}
function setDate(feld,day,month,year) {
	date_obj=new Date(year,month-1,day);
	setDateObj(document.getElementById(feld),date_obj);
	zefLoadLastCont(date_obj);
}
function checkDuration() {
	var mbegin=formatInt(document.getElementById("h_izefBeginB").value)*60 + formatInt(document.getElementById("i_izefBeginB").value);
	var mend=formatInt(document.getElementById("h_izefBeginE").value)*60 + formatInt(document.getElementById("i_izefBeginE").value);
	if (mend==0) mend=24*60;
	var mdiff=mend-mbegin;
	if (isNaN(mdiff) || mdiff < 0) mdiff=0;
	document.getElementById("h_izefBeginD").value=formatValue(Math.floor(mdiff / 60));
	document.getElementById("i_izefBeginD").value=formatValue(mdiff % 60);

}
function checkEnd() {
	var mbegin=formatInt(document.getElementById("h_izefBeginB").value)*60+formatInt(document.getElementById("i_izefBeginB").value);
	var mdiff=formatInt(document.getElementById("h_izefBeginD").value)*60+formatInt(document.getElementById("i_izefBeginD").value);
	var mend=mbegin + mdiff;
	if (isNaN(mend) || mend < 0) mend=mbegin;
	if (Math.floor(mend/60)>23) mend=0;
	document.getElementById("h_izefBeginE").value=formatValue(Math.floor(mend / 60));
	document.getElementById("i_izefBeginE").value=formatValue(mend % 60);
	checkDuration();

}
function zefDateChanged(dateVal) {
	var dateObj=getDateObj(dateVal);
	setDateObj(dateVal,dateObj);
	zefLoadLastCont(dateObj);
}
function zefLoadLastCont(dateObj) {
	if (dateObj && document.getElementById('lastZefCont')) {
		sndReq('lastZefCont','ajax.php','ajax_modul=loadLastZef' + '&zefDate=' + encodeURIComponent(dateObj.getFullYear() + '-' + (dateObj.getMonth()+1) + '-' + dateObj.getDate()));
	}
}
function loadZefCat(catFieldID,prjVal,catVal) {
	sndReq('loadZefCat','ajax.php','ajax_modul=loadZefCat' + '&CatFieldID=' + encodeURIComponent(catFieldID) + '&FKzefPrjID=' + encodeURIComponent(prjVal) + '&FKcatID=' + encodeURIComponent(catVal));
}

var actCostConfig;
var actCostId;
function showCosts(selObj) {
	if (costConfig[selObj.value]) {
		actCostId=selObj.value;
		actCostConfig=costConfig[selObj.value];
		var unitHTML='';
		//alert(actCostConfig['Typ']);
		switch (actCostConfig['Typ']) {
			case 0:
			case 1:
				unitHTML=actCostConfig['Unit'];
			break;
			case 2:
				unitHTML='<select id="costUnitVal">';
				for (var selKey in actCostConfig['Unit']) {
					unitHTML+='<option value="' + selKey + '">' + actCostConfig['Unit'][selKey] + '&nbsp;</option>';
				}
				unitHTML+='</select>';
			break;
		}
		document.getElementById('costUnit').innerHTML='&nbsp;' + unitHTML;
		document.getElementById('costDef1').style.display='';
		document.getElementById('costDef2').style.display='';
	} else {
		document.getElementById('costDef1').style.display='none';
		document.getElementById('costDef2').style.display='none';
	}
}
var numCostRows=0;
function insertCosts() {
	var costValue=formatFloat(document.getElementById('costValue').value);
	var costCalc=0;
	var costUnit=0;
	var costTabEntryID=0;
	if (costValue) {
		switch (actCostConfig['Typ']) {
			case 0:
			case 1:
				costCalc=costValue * actCostConfig['Values'];
				costUnit=actCostConfig['Unit'];
			break;
			case 2:
				costTabEntryID=document.getElementById('costUnitVal').value;
				costCalc=costValue * actCostConfig['Values'][document.getElementById('costUnitVal').value];
				costUnit=actCostConfig['Unit'][document.getElementById('costUnitVal').value];
			break;
		}
		insertCostsRow(actCostId,actCostConfig['FKTabID'],costTabEntryID,costValue,costCalc,actCostConfig['useCosts'],actCostConfig['useDeref'],actCostConfig['Name'],costUnit,document.getElementById('costDesc').value);
		document.getElementById('costValue').value='0' + costDecPoint + '00';
		document.getElementById('costDesc').value='';
	}
}
function insertCostsRow(costID,costTabID,costEntryID,costValue,costCalc,useCosts,useDeref,costName,costUnit,costDesc) {
	var htmlShow=document.getElementById('costRow');
	var hiddenRow='<input type="hidden" name="costData[' + numCostRows + '][Data]" value="' + costID + '|' + costTabID + '|' + costEntryID + '|' + costValue + '|' + costCalc + '|' + useCosts + '|' + useDeref + '" />';
	hiddenRow+='<input type="hidden" name="costData[' + numCostRows + '][Desc]" value="' + escapeHtml(costDesc) + '" />';
	if (costDisabled) {
		var imgRow='&nbsp;';
	} else {
		var imgRow='<img src="img/' + geAPP_THEME + '/loeschen.gif" onclick="deleteCosts(\'' + numCostRows + '\');" />';
	}
	var htmlRow='<tr id="costRow_' + numCostRows + '">';
	htmlRow+='<td rowspan="2" valign="top" style="width:15px;padding:2px 0 0 0;">' + imgRow + "</td>";
	htmlRow+='<td style="width:185px;">' + escapeHtml(costName) + ' (' + escapeHtml(costUnit) + ')' + "</td>";
	htmlRow+='<td align="right" nowrap="nowrap">' + numberFormat(costValue,2,costDecPoint) + "</td>";
	htmlRow+='<td align="right" nowrap="nowrap">' + numberFormat(costCalc,2,costDecPoint) + " " + costSign + "</td>";
	htmlRow+='</tr>';
	htmlRow+='<tr id="costRow2_' + numCostRows + '"><td colspan="3">' + escapeHtml(costDesc)  + hiddenRow + '</td></tr>';
	//alert(costDisabled);

	var oldHtml=htmlShow.innerHTML;
	if (oldHtml.search(/<\/tbody>/gi) != -1) {
		htmlShow.innerHTML=oldHtml.replace(/<\/tbody>/gi,htmlRow+ '</tbody>');
	} else {
		htmlShow.innerHTML=oldHtml.replace(/<\/table>/gi,htmlRow + '</table>');
	}
	//htmlShow.innerHTML=oldHtml.replace(/<\/table>/gi,htmlRow);
	htmlShow.style.display='';
	numCostRows++;
}

function deleteCosts(rowID) {
	var htmlShow=document.getElementById('costRow');
	deleteDomChild('costRow_' + rowID);
	deleteDomChild('costRow2_' + rowID);
	//alert(htmlShow.getElementsByTagName('TR').length);
	if (htmlShow.getElementsByTagName('TR').length<2) htmlShow.style.display='none';
}
function loadCostDefault() {
	for (i=0;i<costDefault.length;i++) {
		insertCostsRow(costDefault[i]['costID'],costDefault[i]['costTabID'],costDefault[i]['costEntryID'],costDefault[i]['costValue'],costDefault[i]['costCalc'],costDefault[i]['useCosts'],costDefault[i]['useDeref'],costDefault[i]['costName'],costDefault[i]['costUnit'],costDefault[i]['costDesc']);
	}
}

function insertComp() {
	var compObj=document.getElementById('calcFKCompID');
	var percObj=document.getElementById('calcPercent');
	var userObj=document.getElementById('hid_calcFKUserID');
	var userID='0';
	var userVal='';
	if (userObj) {
		if (userObj.value) {
			userID=userObj.value.substr(2);
		}
		var userColObj=document.getElementById('ajax_list_calcFKUserID').getElementsByTagName('td');
		if (userColObj && userColObj[1]) {
			userVal=userColObj[1].innerHTML;
		}
	}
	//alert(userVal);
	if (compObj.value!=0 && formatFloat(percObj.value) && percObj.value!=0) {
		insertCompRow(compObj.value,compObj.options[compObj.selectedIndex].text,formatFloat(percObj.value),userID,userVal);
	}
}

var sumPercent=new Array();
function insertCompRow(compID,compVal,percVal,userID,userVal) {
	var rowID=compID + '_' + userID;
	deleteComp(rowID,userID);
	if (!document.getElementById('compTable_' + userID)) {
		var newTable='';
		newTable+='<div id="compTable_' + userID + '"><table class="int_list" width="300" style="margin:0 0 5px 0;">';
		newTable+='<tbody><tr>';
		newTable+='<td nowrap="nowrap" colspan="3"><strong>' +  userVal + '</strong></td>';
		newTable+='</tr></tbody>';
		newTable+='</table></div>';

		document.getElementById('compRow').innerHTML=document.getElementById('compRow').innerHTML + newTable;
	}
	var htmlShow=document.getElementById('compTable_' + userID);
	var oldHtml=htmlShow.innerHTML;
	if (!sumPercent[userID]) sumPercent[userID]=0;
	sumPercent[userID]+=percVal;
	//alert(sumPercent[userID]);

	var hiddenRow='<input type="hidden" name="compData[' + rowID + ']" id="compData_' + rowID + '" value="' + compID + '|' + userID + '|' + percVal + '" />';
	var imgRow='<img src="img/' + geAPP_THEME + '/loeschen.gif" onclick="deleteComp(\'' + rowID + '\',\'' + userID + '\',1);" />';
	var htmlRow='<tr id="compRow_' + rowID + '">';
	htmlRow+='<td valign="top" style="width:15px;padding:2px 0 0 0;">' + imgRow + hiddenRow + "</td>";
	htmlRow+='<td style="width:185px;"><a href="javascript:void(editComp(\'' + compID + '\',\''+ percVal +'\'))">' + compVal + '</a>';
	//if (userID)  htmlRow+='<br />' + userVal;
	htmlRow+='</td>';
	htmlRow+='<td align="right" nowrap="nowrap">' + numberFormat(percVal,2,',') + " %</td>";
	htmlRow+='</tr>';
	htmlRow+='<tr id="compRow_' + userID + '">';
	htmlRow+='<td align="right" nowrap="nowrap" colspan="3" style="color:' + (sumPercent[userID]==100?'#000':'#f00') + '">' + numberFormat(sumPercent[userID],2,',') + " %</td>";
	htmlRow+='</tr>';

	htmlShow.innerHTML='';
	//alert('fff');
	//oldHtml=oldHtml.replace(/<tbody><\/tbody>/gi,'');
	//alert(oldHtml);
	if (oldHtml.search(/<\/tbody>/gi) != -1) {
		htmlShow.innerHTML=oldHtml.replace(/<\/tbody>/gi,htmlRow+ '</tbody>');
	} else {
		htmlShow.innerHTML=oldHtml.replace(/<\/table>/gi,htmlRow + '</table>');
	}
	document.getElementById('compRow').style.display='';
	document.getElementById('compTable_' + userID).style.display='';
}
function editComp(compID,percVal) {
	$('#calcFKCompID').val(compID);
	$('#calcPercent').val(percVal);
}
function deleteComp(rowID,userID,reCalc) {
	if (document.getElementById('compRow_' + rowID)) {
		var dataVal=document.getElementById('compData_' + rowID).value.split('|');
		sumPercent[userID]-=dataVal[2];
		deleteDomChild('compRow_' + rowID);

	}
	if (document.getElementById('compRow_' + userID)) {
		deleteDomChild('compRow_' + userID);
	}
	var htmlShow=document.getElementById('compTable_' + userID);
	if (htmlShow) {
		if (reCalc) {
			var oldHtml=htmlShow.innerHTML;
			var htmlRow='<tr id="compRow_' + userID + '">';
			htmlRow+='<td align="right" nowrap="nowrap" colspan="3" style="color:' + (sumPercent[userID]==100?'#000':'#f00') + '">' + numberFormat(sumPercent[userID],2,',') + " %</td>";
			htmlRow+='</tr>';
			if (oldHtml.search(/<\/tbody>/gi) != -1) {
				htmlShow.innerHTML=oldHtml.replace(/<\/tbody>/gi,htmlRow+ '</tbody>');
			} else {
				htmlShow.innerHTML=oldHtml.replace(/<\/table>/gi,htmlRow + '</table>');
			}
		}
		if(htmlShow.getElementsByTagName('TR').length<3) {
			htmlShow.style.display='none';
		}
	}
	//alert(htmlShow.getElementsByTagName('TR').length);
}
function loadCompDefault() {
	for (i=0;i<compDefault.length;i++) {
		insertCompRow(compDefault[i]['compID'],compDefault[i]['compVal'],compDefault[i]['percVal'],compDefault[i]['userID'],compDefault[i]['userVal']);
	}
}
function newZefWindow(zefID) {
	NewWindow('js_zef.php?zefID=' + zefID,'zef','670','500','yes',0,50);
}
function showCompMode(dispComp,fPrep) {
	if (dispComp==-1) {
		changeDisp(fPrep + 'disp_compMode',1);
		changeDisp(fPrep + 'compSchluessel',1);
		loadCompSchluessel(fPrep);
	} else {
		changeDisp(fPrep + 'disp_compMode',-1);
		changeDisp(fPrep + 'compSchluessel',-1);
	}

}
function loadCompSchluessel(fPrep) {
	//alert($('#' + fPrep + 'FKcompID').val());
	if ($('#' + fPrep + 'FKcompID').val()=='-1') {
		sndReq('loadCompSchluessel','ajax.php','ajax_modul=loadCompSchluessel&fPrep=' + fPrep + '&'  + formToString('daten'));
		changeDisp(fPrep + 'disp_compMode',1);
		changeDisp(fPrep + 'compSchluessel',1);
	}
}
function editCompCalc(defaultCalc,fPrep) {
	Groupe.CompanyCalc.show(fPrep);
	deleteDomChild('compTable_0');
 	sumPercent[0]=0;
	for (i=0;i<defaultCalc.length;i++) {
		insertCompRow(defaultCalc[i]['compID'],defaultCalc[i]['compVal'],defaultCalc[i]['percVal'],defaultCalc[i]['userID'],defaultCalc[i]['userVal']);
	}
	/*$('#' + fPrep + 'customCompCalc').val($("input[name^='compData']").map(function(){
		return $(this).val();
	}).get().join(","));*/
}
