<?php
/*
 * Session Management for PHP3
 *
 * Copyright (c) 1998,1999 SH Online Dienst GmbH
 *                    Boris Erdmann, Kristian Koehntopp
 *
 * $Id: prepend.php3,v 1.11 1999/10/28 20:12:32 kk Exp $
 *
 */ 

$_PHPLIB["libdir"]=dirname (__FILE__).'/lib/';

require($_PHPLIB["libdir"] . "db_mysql.inc");  /* Change this to match your database. */
require($_PHPLIB["libdir"] . "ct_sql.inc");    /* Change this to match your data storage container */
require($_PHPLIB["libdir"] . "session.inc");   /* Required for everything below.      */
require($_PHPLIB["libdir"] . "auth.inc");      /* Disable this, if you are not using authentication. */
require($_PHPLIB["libdir"] . "perm.inc");      /* Disable this, if you are not using permission checks. */
require($_PHPLIB["libdir"] . "user.inc");      /* Disable this, if you are not using per-user variables. */

/* Additional require statements go below this line */
## require($_PHPLIB["libdir"] . "menu.inc");        /* Enable this, if you want to use class Menu. */
## require($_PHPLIB["libdir"] . "menu_button.inc"); /* Enable menu.inc and this, if you want class Menu_Button. */
/* Additional require statements go before this line */

require($_PHPLIB["libdir"] . "local.inc");     /* Required, contains your local configuration. */


require($_PHPLIB["libdir"] . "page.inc");      /* Required, contains the page management functions. */


?>
