<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                                  |
	|	  39100 Bozen/Bolzano                                                     |
	|	  ITALIEN/ITALIA                                                          |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
    | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/


$t->assign('MOD_TITLE',$frm->getAppName('addr'));
if (!$app["addr"]) {
	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
} else {
	if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
		require_once("lib/addr/class_AddrLdapGui.php");
		$AddrGui=new AddrLdapGui();
		$error=$AddrGui->processRequest();
		if ($error) {
			$t->setRoot("tpl/$THEME/$session_lang");
			$t->define (array('application' => "no_app.inc.html"));
		}
	} else {
		$user_id=$auth->auth['uid'];
		$Addr=& $frm->getStaticModul('addr');

		$pre['addr']=$frm->getPrefs('addr');
		$T->loadModul('addr');

		//$Addr->loadExportFields();
		$t->setRoot("tpl/$THEME/addr/$session_lang");
		$t->define (array('application' => "header.inc.html"));
		unset($obj);
		unset($ActionError);
		$root_id=0;
		if ($Addr->getPerms(1) || ($Addr->havePermsProfilAcl(2) || $Addr->getPerms(2))) {
			$root_obj_d=$Addr->getSystemObj('d',$session_lang,0,true);
			if (is_object($root_obj_d)) {
				$root_obj[$root_obj_d->getID()]=$root_obj_d;
				unset($root_obj_d);
			}
			if ($Addr->getPerms(1)) {
				$root_obj_u=$Addr->getSystemObj('u',$session_lang,$user_id,true);
				if (is_object($root_obj_u)) {
					$root_obj[$root_obj_u->getID()]=$root_obj_u;
					$Addr->addRootID($root_obj_u->getID(),'u');
					//unset($root_obj_u);
				} else {
					$root_obj_u=$Addr->getSystemObj('u',$CFG['AV_LANG'],0,false);
					if (is_object($root_obj_u)) {
						$Addr->insertMeta($root_obj_u);
						$root_obj_u->setMeta('UserID',$user_id);
						$root_obj_u->setMeta('RootID',$root_obj_u->getID());
						$Addr->updateMeta($root_obj_u);
						$root_obj[$root_obj_u->getID()]=$root_obj_u;
						$Addr->addRootID($root_obj_u->getID(),'u');
					//unset($root_obj_u);
					}
				}
			}
			if (($Addr->havePermsProfilAcl(2) || $Addr->getPerms(2))) {
				$root_obj_s=$Addr->getSystemObj('s',$session_lang,0,true);
				if (is_object($root_obj_s)) {
					$root_obj[$root_obj_s->getID()]=$root_obj_s;
					$Addr->addRootID($root_obj_s->getID(),'s');
					//unset($root_obj_s);
				}

			}
			$trash_obj=$Addr->getSystemObj('t',$session_lang,0,true);
			if (is_object($trash_obj)) {
				$root_obj[$trash_obj->getID()]=$trash_obj;
			}

			if ($oid) {
				$obj=$Addr->getObj($oid,$CFG['MA_LANG']);
				if (is_object($obj)) {
					$root_id=$obj->getMeta('RootID');
				}
			}
			if ($aid) {
				$AObj=$Addr->getAddrObj($aid);
			}
			//file_put_contents('/tmp/addr.log',print_r($AObj,1));
			if ((!$root_id || !isset($root_obj[$root_id])) && is_array($root_obj)) {
				$oid=$root_id=key($root_obj);
				$obj=$Addr->getObj($oid,$CFG['MA_LANG']);
			}
			$rootObj=$root_obj[$root_id];
		} else {
			unset($rootObj);
		}
		if (!is_object($rootObj) || !is_object($obj) || (!$obj->getAcl(1) && !$obj->getAcl(2))) {
			$t->assign('TPL_ERROR','');
			$t->define (array('tpl_card' => "no_perms.inc.html"));
			$t->parse('TPL_CARD','tpl_card');
		} else {
			if (isset($SESS_MDATA[$site]['L_BACK'])) {
				$H_REFERER=$SESS_MDATA[$site]['L_BACK'];
			} else {
				$H_REFERER[0]="index.php?site=$site";
			}
			//debug($SESS_MDATA);
			if (isset($limit)) {
				$Addr->setLimit($limit);
			} elseif ($pre['addr']['limit']) {
				$Addr->setLimit($pre['addr']['limit']);
			}
			//if (!$mode) $mode='fav';
			if ($action=='s' || $action=='as') $mode='all';
			$Addr->setMode($mode);
			$Addr->setRootObj($rootObj);
			$t->parse("ROW","conf_delete");
			if (!$action) $action=$obj->getAction(0);
			$L_THIS="index.php?site=$site&action=$action&oid=$oid";
			$Addr->setClipboard('aobj',$frm->getClipboard('aobj'));
			$obj_tree=$Addr->getObjTree($oid);
			if (($meta_save_x)) {
				if ($new) {
					require ('lib/addr/inc_NewObject.php');
				} else {
					require ('lib/addr/inc_UpdateObject.php');
				}
			}
			if ($src_action_x && $src_action_val) {
				require_once ('lib/addr/func_Action.php');
				require ('lib/addr/inc_ActionSrcObject.php');
			}
			if ($addr_action_x && $addr_action_val) {
				require_once ('lib/addr/func_Action.php');
				require ('lib/addr/inc_AddrAction.php');
			}
			if ($org_action_x && $org_action_val) {
				require_once ('lib/addr/func_Action.php');
				require ('lib/addr/inc_OrgActionList.php');
			}
			if ($obj_action_x && $obj_action_val) {
				require_once ('lib/addr/func_Action.php');
				require ('lib/addr/inc_ActionObject.php');
			}
			if ($list_action_x && $list_action_val) {
				require_once ('lib/addr/func_Action.php');
				require ('lib/addr/inc_ActionList.php');
			}
			if ($del_srid) {
				$tmp=$Addr->readAddrSearch($del_srid);
				if ($tmp && $tmp['FKUserID']==$user_id || $Addr->isRuleUser()) {
					$Addr->deleteAddrSearch($del_srid,$tmp['FKUserID']);
					if ($vsrid==$del_srid) {
						unset($vsrid);
						if ($mode=='src') {
							$mode='fav';
							$Addr->setMode($mode);
						}
					}
				}

			}
			$tmp_tree='';
			if (is_array($obj_tree)) {
				foreach ($obj_tree as $key=>$val) {
					$tmp_tree="<a href=\"index.php?site=$site&oid=$key\">".FrameWork::entities($val).'</a>/'.$tmp_tree;
				}
			}
			$t->assign('OBJ_TREE',$tmp_tree);
			$t->assign('OBJ_NAME',FrameWork::entities($obj->getName()));
			if (is_object($AObj)) $t->assign('ADDR_NAME',Framework::entities($AObj->getName()));

			foreach ($root_obj as $val) {
				$t->assign('M_IMG',$val->getImage(0));
				$t->assign('M_NAME',FrameWork::entities($val->getName()));
				$t->assign('M_URL',"index.php?site=$site&oid=".$val->getID());
				if ($action!='import' && $action!='s' && $root_id==$val->getID()) {
					$t->assign('M_ON','on');
				} else {
					$t->assign('M_ON','off');
				}
				$t->parse('ROW','.root_header');
			}
			$t->assign('L_A_NAVBAR',"index.php?site=$site&action=b&mode=all");
			$nav_array=array_merge(range('A', 'Z'),range('0', '9'));
			foreach ($nav_array as $val) {
				$t->assign('L_NAVBAR',"index.php?site=$site&action=b&mode=all&sort=$val");
				if ($mode=='all' && $sort==$val) {
					$t->assign('N_NAVBAR','<strong>'.$val.'</strong>');
				} else {
					$t->assign('N_NAVBAR',$val);
				}
				$t->parse('ROW','.navbar_row');
			}
			$t->parse('ROW','navbar');


			$t->assign('CFG_ON','off');
			$t->assign('IMP_ON','off');
			$t->assign('MAI_ON','off');
			$t->assign('INS_ON','off');
			$t->assign('S_ON','off');



			if ($action=="import") {
				$t->assign('IMP_ON','on');
				$t->define (array('tpl_card' => "import_content.inc.html"));
				require("lib/class_form.inc.php");
				require("addr/browse_list_edit_js.php");
				require("addr/import_content.php");
				$t->parse('TPL_CARD','tpl_card');
			} elseif ($action=="b") {
				require("lib/class_form.inc.php");
				if ($mode=='src') {
					require_once('lib/addr/class_SearchEditGui.php');
					$searchEditGui=new SearchEditGui($Addr);
					$srcObj=$Addr->readAddrSearch(Framework::getParam('vsrid'));
					$tmpSearch=unserialize($srcObj['Sdata']);
					if (!$tmpSearch['search']) {
						require_once('update/convert_addr_search.php');
						$tmpSearch=oldSearch2NewSearch($tmpSearch);
						$Addr->updateAddrSearch(Framework::getParam('vsrid'),array('Sdata'=>serialize($tmpSearch)));
						//debug($tmpSearch);
					}
					$searchEditGui->setSearch($tmpSearch);
				}
				require("addr/browse_list_js.php");
				if (!$mode && $rootObj->getMeta('System')=='d') {
					$t->define (array('tpl_card' => "browse_overview.inc.html"));
					require("addr/browse_overview.php");
				} else {
					$t->define (array('tpl_card' => "browse_content.inc.html"));
					require("addr/browse_content.php");
				}
				$t->parse('TPL_CARD','tpl_card');
			} elseif ($action=="bt") {
				$t->define (array('tpl_card' => "browse_content.inc.html"));
				require("lib/class_form.inc.php");
				require("addr/browse_list_js.php");
				require("addr/browse_content.php");
				$t->parse('TPL_CARD','tpl_card');
			} elseif ($action=="v") {
				$t->define (array('tpl_card' => "view_content.inc.html"));
				require("lib/class_form.inc.php");
				require("addr/view_content.php");
				$t->parse('TPL_CARD','tpl_card');
			} elseif ($action=="pv") {
				$t->define (array('tpl_card' => "print_content.inc.html"));
				require("addr/print_content.php");

			} elseif ($action=="i") {
				$t->assign('INS_ON','on');
				$t->define (array('tpl_card' => "edit_content.inc.html"));
				require("lib/class_form.inc.php");
				require("addr/browse_list_edit_js.php");
				require("addr/edit_content.php");
				$t->parse('TPL_CARD','tpl_card');
			} elseif ($action=="org") {
				if ($save_x && is_object($AObj)) {
					if (is_array($sNodeID) && count($sNodeID)) {
						$AObj->setParentMeta('NodeIDs',$sNodeID);
						$Addr->updateAddrMeta($AObj);
						unset($AObj,$aid,$sNodeID);
					} else {
						$ActionError['no_cat']=true;
					}
				}
				$t->define (array('tpl_card' => "org_content.inc.html"));
				$Addr->setClipboard('addr_u',$frm->getClipboard('addr_u'));
				$Addr->setClipboard('addr_s',$frm->getClipboard('addr_s'));
				require("lib/class_form.inc.php");
				require("addr/browse_list_org_js.php");
				require("addr/org_content.php");
				$t->parse('TPL_CARD','tpl_card');
			} elseif ($action=="operm") {
				$t->define (array('tpl_card' => "operm_content.inc.html"));
				$Addr->setClipboard('addr_s',$frm->getClipboard('addr_s'));
				require("lib/class_form.inc.php");
				require("addr/operm_content.php");
				$t->parse('TPL_CARD','tpl_card');
			} elseif ($action=="medit") {
				require("lib/addr/class_AddrMultiEditGui.php");
				$Gui=new AddrMultiEditGui();
				$t->assign('TPL_CARD',$Gui->process());
			} elseif ($action=="p") {
				$t->define (array('tpl_card' => "perms_content.inc.html"));
				require("lib/class_form.inc.php");
				require("addr/browse_list_js.php");
				require("addr/perms_content.php");
				$t->parse('TPL_CARD','tpl_card');
			} elseif ($action=="s") {
				$t->assign('S_ON','on');
				require("lib/addr/class_AddrSearchGui.php");
				$sGui=new AddrSearchGui();
				$t->assign('TPL_CARD',$sGui->process());
			}  elseif ($action=="mai") {
				$t->assign('MAI_ON','on');
				require("lib/addr/class_AddrMaintenanceGui.php");
				$mGui=new AddrMaintenanceGui();
				$t->assign('TPL_CARD',$mGui->process());
			} else {
				$t->define (array('tpl_card' => "no_perms.inc.html"));
				$t->parse('TPL_CARD','tpl_card');
			}

			if ($Addr->getPerms(1) || ($Addr->havePermsProfilAcl(4) || $Addr->getPerms(4))) {
				$t->assign('INS_URL',"index.php?site=$site&action=i&oid=".$obj->getID());
				$t->parse('ROW','insert_header');
				$t->assign('IMP_URL',"index.php?site=$site&action=import&oid=".$obj->getID());
				$t->parse('ROW','import_header');
				$t->assign('MAI_URL',"index.php?site=$site&action=mai&oid=".$obj->getID());
				$t->parse('ROW','maintenance_header');
			}

			$t->assign('T_S_ACTION',"index.php?site=$site&action=s");
			if ($ActionError) {
				require('addr/view_error.php');
			}
			$SESS_MDATA[$site]['L_BACK']=$H_REFERER;

		}
	}

}
?>