<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$TMP_DIR=Framework::getTempPath();
$max_num=3;
$T->loadModul('addr');
if ($fname && !file_exists("$TMP_DIR/".basename($fname))) {
	unset($fname);
}
if ($z_sep=='t') $sep="\t";
else $sep=$z_sep;
if (isset($upload_x)) {
	if (file_exists($_FILES['csv_file']['tmp_name']) && is_uploaded_file($_FILES['csv_file']['tmp_name'])) {
		$fp=fopen($_FILES['csv_file']['tmp_name'],'r');
		if (($row=fgetcsv($fp,2000,$sep)) && (count($row)>1)) {
			fclose($fp);
			if (!$fname) $fname=basename(tempnam($TMP_DIR,'csv'));
			$data_string=implode('',file($_FILES['csv_file']['tmp_name']));
			if (GE_CHARSET=='UTF-8') {
				$data_string=Framework::getUtf8Encoded($data_string);
			}
			$fp=fopen($TMP_DIR.'/'.$fname,'w');
			fwrite($fp,$data_string);
			fclose($fp);
		} else $ActionError['csv']=1;
	} else $ActionError['csv']=1;
}
if (!is_array($field)) $field=array();
if ($fname) {
	$fp=fopen("$TMP_DIR/".$fname,'r');
	$num=0;
	while ($row[$num]=fgetcsv($fp,2000,$sep)) {
		$num++;
		if ($num>=$max_num) break;
	}
	fclose($fp);
	if ($num) {
		if (isset($save_x) || isset($save_as_x)) {
			if (!$z_name) $ActionError['fields']['z_name']=1;
			if (!$ActionError) {
				if ($z_id && isset($save_x)) {
					$Addr->updateImportFields($z_id,$z_name,$field);
					$z_import=$z_id;
				} else {
					$z_id=$Addr->insertImportFields($z_name,$field);
					$z_import=$z_id;
				}
			}
		} elseif (isset($import_x)) {
			//debug($field);
			$impField=array();
			foreach ($field as $key=>$val) {
				if ($val) $impField[$key]=$val;
			}
			if (!count($pNodeID) && !count($gNodeID)) {
				$ActionError['no_cat']=true;
			}
			if (!is_array($impField) || !count($impField)) $ActionError['fields']['imp_field']=1;
			if (!$ActionError) {
				$fp=fopen("$TMP_DIR/".$fname,'r');
				$num=0;$i=0;
				$addrSelArray=array();
				$allUsers=array();
				$catExists=array();
				while ($irow=fgetcsv($fp,2000,$sep)) {
					$i++;
					if ($i<$z_row) continue;
					$meta=array();
					$extra=array();
					foreach ($impField as $key=>$val) {
						if ($irow[$key]) {
							switch ($val) {
								case 'log':
									$extra[$val][]=$irow[$key];
								break;
								case 'catID':
									$extra[$val][]=$irow[$key];
								break;
								default:
									$meta[$val][]=$irow[$key];
							}
						}
					}
					//debug($extra);
					$new_obj=new AObj_addr(0);
					foreach ($meta as $key=>$val) {
						switch ($Addr->getFieldData($key,'Typ')) {
							case 'select':
							case 'mselect':
								$val=trim(implode(';',$val));
								if ($val) {
									$tmp=explode(';',$val);
									$val=array();
									foreach ($tmp as $sval) {
										$sval=trim($sval);
										if ($sval) {
											if (!isset($addrSelArray[$key][$sval])) {
												$addrSelArray[$key][$sval]=$Addr->getAddrSelectID($key,$CFG['AV_LANG'],$sval);
											}
											if ($addrSelArray[$key][$sval]===false) {
												if ($Addr->getFieldData($key,'FieldTyp')=='u' && $Addr->isRuleUser()) {
													$nSelect=array();
													foreach ($CFG['AV_LANG'] as $slang) {
														$nSelect['Name_'.$slang]=trim($sval);
													}
													$addrSelArray[$key][$sval]=$Addr->insertAddrSelect($key,$nSelect);
													$val[]=$addrSelArray[$key][$sval];
												}
											} else {
												$val[]=$addrSelArray[$key][$sval];
											}

										}
									}
								} else {
									$val=array('0');
								}
								$new_obj->setMeta($key,implode('||',array_unique($val)));
							break;
							case 'fk_user':
								$val=trim(implode(';',$val));
								if ($val) {
									if (empty($allUsers)) {
										$rows=0;
										$allUsers=$frm->searchUser($rows,'',0,0,0,0);
									}
									$tmp=explode(';',$val);
									$val=array();
									foreach ($tmp as $sval) {
										$sval=trim($sval);
										if ($sval) {
											foreach($allUsers as $v) {
												if ($v['username']==$sval || $v['firstname'].' '.$v['lastname']==$sval || $v['lastname'].' '.$v['firstname']==$sval || $v['email']==$sval) {
													$val[]=$v['uidGroup-e'];
													break;
												}
											}
										}
									}
								} else {
									$val=array();
								}
								$new_obj->setMeta($key,implode('||',array_unique($val)));
							break;
							case 'text':
								$new_obj->setMeta($key,implode(' ',$val));
							break;
							case 'area':
								$new_obj->setMeta($key,implode("\n",$val));
							break;
							default:
								$new_obj->setMeta($key,$Addr->AddrImplode($val));
							break;


						}
					}
					$new_obj->setMeta('UserModify',$user_id);
					$new_obj->setMeta('TimeModify',time());
					$new_obj->setMeta('UserCreate',$user_id);
					$new_obj->setMeta('TimeCreate',time());
					$new_obj->setParentMeta('NodeIDs',$ParentID);
					if (count($pNodeID)) {
						$new_obj->setParentMeta('NodeIDs',$pNodeID);
						$new_obj->setMeta('UserID',$user_id);
					} else {
						$new_obj->setParentMeta('NodeIDs',$gNodeID);
						$new_obj->setMeta('UserID',0);
					}
					if ($extra['catID']) {
						$tmpNodeIds=array();
						foreach ($extra['catID'] as $catVal) {
							if (trim($catVal)) {
								$tmpCat=explode(';',$catVal);
								foreach ($tmpCat as $tmpCatID) {
									if (isset($catExists[$tmpCatID]) || $Addr->objExists($tmpCatID)) {
										$catExists[$tmpCatID]=true;
										$tmpNodeIds[]=$tmpCatID;
									}
								}
							}
						}
						if (!empty($tmpNodeIds)) {
							$new_obj->setParentMeta('NodeIDs',array_unique($tmpNodeIds));
						}
					}
					$new_obj->setMeta('Name',$new_obj->getName());
					if ($Addr->insertAddrMeta($new_obj)) {
						if ($extra['log']) {
							foreach ($extra['log'] as $logVal) {
								$matches=array();
								$logTime=0;
								if (preg_match('/^(\d{2})[.\/-](\d{2})[.\/-](\d{4})[ ](\d{2})[:](\d{2})[ ]/',$logVal,$matches)) {
									$logTime=mktime((int)$matches[4],(int)$matches[5],0,(int)$matches[2],(int)$matches[1],(int)$matches[3]);
									$logVal=substr($logVal,strlen($matches[0]));
								}
								$Addr->insertLog($new_obj->getID(),$auth->auth['uid'],trim($logVal),'log',$logTime);
							}
						}
						$num++;
					}
				}
				fclose($fp);
				$ActionError['import']=$num;
				unset($row);
				@unlink("$TMP_DIR/".$fname);

			 }
		}  elseif (isset($delete_x) && $z_id) {
			$Addr->deleteImportFields($z_id);
			unset($z_id,$z_import,$z_name);
		} else {
			if ($z_import) {
				$field=$Addr->readImportFields($z_import);
				unset($z_name);
				$z_id=$z_import;
			}
		}
		if (is_array($row[0]) && ($cols=count ($row[0]))) {

			$z_array=array(0=>'-') + $Addr->getImportFields();
			$f_z_import=new SelectField("z_import",'class="sel" style="width:200px" onChange="document.daten.submit();"',$z_array);
			$t->assign('F_Z_IMPORT',$f_z_import->f());

			if (!isset($z_name) && $z_import) $z_name=$z_array[$z_import];
			$f_z_name=new Textfield("z_name",'class="sel" style="width:200px"');
			$t->assign('F_Z_NAME',$f_z_name->f());
			if ($ActionError['fields']['z_name']) $t->assign('C_Z_NAME','error'); else $t->assign('C_Z_NAME','desc');
			if ($z_id) {
				$t->parse('ROW','save_as');
				$t->parse('ROW','delete');
			}


			for($j=0;$j<$num;$j++) {
				$t->assign("HEAD_NUM",($j+1));
				$t->parse('ROW','.head_col');
			}
			$tmp_fields=$list_fields=array();
			foreach ($Addr->getFields() as $key=>$val) {
				switch ($val['Typ']) {
					case 'stamm':
						break;
					case 'perm':
						break;
					default:
						$tmp_fields[$val['Card']][]=$key;
				}
			}
			foreach ($tmp_fields as $tmp_val) {
				foreach ($tmp_val as $val) $list_fields[]=$val;
			}
			for ($i=0;$i<$cols;$i++) {
				$t->clear_dynamic('fields_col');
				$t->assign('F_NUM',$i);
				$parse_card=array();
				foreach ($Addr->getFields() as $key=>$val) {

					switch ($val['Typ']) {
						case 'stamm':
							break;
						default:
							if (!isset($field[$i])) $field[$i]=$list_fields[$i];
							$t->assign('F_VAL',$key);
							$t->assign('F_NAME',Framework::entities($val['Title']));
							if ($key==$field[$i]) {
								$t->assign('F_SEL','selected');
							} else {
								$t->assign('F_SEL','');
							}
							if ($val['Card'] && $t->issetkey('av_fields_'.$val['Card'].'_row')) {
								$t->parse('ROW','.av_fields_'.$val['Card'].'_row');
								$parse_card['av_fields_'.$val['Card']]=1;
							}
					}
				}

				$key='log';
				if (!isset($field[$i])) $field[$i]=$list_fields[$i];
				$t->assign('F_VAL',$key);
				$t->assign('F_NAME',Framework::entities($T->lang('[[Logbuch]]')));
				if ($key==$field[$i]) {
					$t->assign('F_SEL','selected');
				} else {
					$t->assign('F_SEL','');
				}
				$t->parse('ROW','.av_fields_e_row');

				if (defined('ADDR_IMPORT_CAT') && ADDR_IMPORT_CAT) {
					$key='catID';
					if (!isset($field[$i])) $field[$i]=$list_fields[$i];
					$t->assign('F_VAL',$key);
					$t->assign('F_NAME',Framework::entities($T->lang('[[Kategorie]]')));
					if ($key==$field[$i]) {
						$t->assign('F_SEL','selected');
					} else {
						$t->assign('F_SEL','');
					}
					$t->parse('ROW','.av_fields_e_row');
				}


				$parse_card['av_fields_e']=1;


				foreach (array_keys($parse_card) as $val) {
					if ($t->issetkey($val)) {
						$t->parse('ROW',$val);
					}
				}
				for($j=0;$j<$num;$j++) {
					if ($row[$j][$i])
						$t->assign("F_CSV",Framework::entities($row[$j][$i]));
					else
						$t->assign("F_CSV","&nbsp;");
					$t->parse('ROW','.fields_col');

				}
				if ($i%2) $t->assign('ROW_COLOR',"bgcolor=\"#f2f2f2\"");
				else $t->assign('ROW_COLOR',"");
				$t->Parse('ROW','.fields_row');
				foreach (array_keys($parse_card) as $val) {
					$t->clear_dynamic($val);
					$t->clear_dynamic($val.'_row');
				}

			}
			if ( $ActionError['fields']['imp_field']) $t->assign('C_FIELD','error'); else $t->assign('C_FIELD','desc');
			if (intval($z_row)<1) $z_row=1;
			$f_z_row=new Textfield("z_row",'class="sel" style="width:40px"');
			$t->assign('F_Z_ROW',$f_z_row->f());
			$t->assign('Z_SEP',$z_sep);
			$t->assign('FNAME',$fname);
			$t->parse('ROW','import');
		} else $t->parse('ROW','upload');
	} else $t->parse('ROW','upload');
} else {
	if (GE_CHARSET=='UTF-8') {
		$t->assign('SEL_CHAR_UTF8','selected="selected"');
	} else {
		$t->assign('SEL_CHAR_ISO','selected="selected"');
	}

	$t->parse('ROW','upload');
}



$form_action="index.php?site=$site&action=$action";
if ($z_id) $form_action.="&z_id=$z_id";
$t->assign('FORM_ACTION',$form_action);
?>
