<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

$t->define (array('tpl_addr' => 'view_address.inc.html'));
if (!is_object($AObj) || (!$AObj->getAcl(1) && !$AObj->getAcl(2))) {
	page_close();
	if ($H_REFERER[intval($back)]) {
		header('Location:'.$H_REFERER[intval($back)]);
	} else {
		header("Location:index.php?site=$site");
	}
	exit;
}
if ($go_b) {
	$H_REFERER[0]=$_SERVER['HTTP_REFERER'];
}
$AObj->setHotMeta('Counter',intval($AObj->getHotMeta('Counter'))+1);
$AObj->setHotMeta('TimeLast',time());
$Addr->insertHotMeta($AObj);
$Addr->updateAddrMetaVisited($AObj->getID());

$form_action="index.php?site=$site&action=$action&oid=$oid&aid=$aid&back=$back";
$t->assign('FORM_ACTION',$form_action);
$L_THIS=$form_action."&disp=$disp&vst=$vst";
$H_REFERER[1]=$L_THIS;

$frm->addOnload('e7gMsgIntitObj('.json_encode(array(
	'typ'=>'addr',
	'id'=>$AObj->getID(),
	'name'=>$AObj->getName(),
	'link'=>"index.php?site=".$AObj->getSite()."&action=".$AObj->getAction(0)."&oid=$oid&aid=".$AObj->getID().'&go_b=1',
)).');');

//$s=microtime(true);
if (FrameWork::getParam('sMd5',0)) {
	if ($tmp=$frm->getUserData('md5_src',FrameWork::getParam('sMd5',0))) {
		$tmpSearch=unserialize($tmp);
		$pos=FrameWork::getParam('pos',0);
		$Addr->setLimit(3);
		if ($tmpSearch['search']) {
			$posIDs=$Addr->searchAddrAdv($pos>0?$pos-1:0,$tmpSearch['sqlOrder'],$tmpSearch['search'],0,$tmpSearch['use_perms'],$tmpSearch['use_archiv'],0,true);
		} else {
			$posIDs=$Addr->searchAddr($pos>0?$pos-1:0,$tmpSearch['sqlOrder'],$tmpSearch['searchAddr'],$tmpSearch['searchNode'],$tmpSearch['searchHot'],$tmpSearch['searchProject'],0,$tmpSearch['use_perms'],null,true);
		}
		$aktPos=array_search($AObj->getID(),$posIDs);
		if ($aktPos===false || ($aktPos===0 && $pos>0) || !isset($posIDs[$aktPos+1])) {
			//Alle auslesen
			$Addr->setLimit(0);
			if ($tmpSearch['search']) {
				$posIDs=$Addr->searchAddrAdv(0,$tmpSearch['sqlOrder'],$tmpSearch['search'],0,$tmpSearch['use_perms'],$tmpSearch['use_archiv'],0,true);
			} else {
				$posIDs=$Addr->searchAddr(0,$tmpSearch['sqlOrder'],$tmpSearch['searchAddr'],$tmpSearch['searchNode'],$tmpSearch['searchHot'],$tmpSearch['searchProject'],0,$tmpSearch['use_perms'],null,true);
			}
			$pos=$aktPos=array_search($AObj->getID(),$posIDs);
			//debug($posIDs);
		}
		if ($aktPos!==false) {
			if (isset($posIDs[$aktPos-1])) {
				$t->assign('LINK',$L->getTempLink(null,array('aid'=>$posIDs[$aktPos-1],'pos'=>$pos-1)));
				$t->parse('ROW','l_prev');
			}
			if (isset($posIDs[$aktPos+1])) {
				$t->assign('LINK',$L->getTempLink(null,array('aid'=>$posIDs[$aktPos+1],'pos'=>$pos+1)));
				$t->parse('ROW','l_next');
			}
		}
	}
	$frm->setUserData('md5_aid',FrameWork::getParam('sMd5',0),$AObj->getID());
}
//debug(microtime(true)-$s);

//debug($disp);
$t->assign('ADDR_NAME',FrameWork::entities($AObj->getName()));
$AObj->setParentMeta('NodeIDs',$Addr->getAddrNodesIDs($aid));
foreach ($AObj->getParentMeta('NodeIDs') as $nid) {
	$obj_tree=$Addr->getObjTree($nid);
	$tmp_tree=array();
	if (is_array($obj_tree) && !empty($obj_tree)) {
		foreach ($obj_tree as $key=>$val) {
			if (!isset($root_obj[$nid]) && isset($root_obj[$key])) break;
			$tmp_tree[]="<a href=\"index.php?site=$site&oid=$key\">".FrameWork::entities($val).'</a>';
		}
	}
	$t->assign('CAT_TREE',implode(' / ',array_reverse($tmp_tree)));
	$t->parse('ROW','.cat_row');
}

$addrProjects=$Addr->getAddrProjects($AObj);
if (!empty($addrProjects) && $P) {
	$parse=false;
	foreach ($addrProjects as $val) {
		if ($P->getCachedProjectName($val)) {
			$t->assign('PROJ_NAME',Framework::entities($P->getCachedProjectName($val)));
			$t->assign('L_PROJ','index.php?site=proj.php&oid='.$val);
			$t->parse('ROW','.proj_row');
			$parse=true;
		}
	}
	if ($parse) $t->parse('ROW','view_project');
}

$parseCards=array();
parseAddress($AObj,$disp,0);
$view_crm=0;
if (count($Addr->getUserFields())) {
	$t->define (array('tpl_fields' => "view_content_fields.inc.html"));
	$crmFields=array();$crmGroup=0;
	foreach ($Addr->getUserFields() as $FieldID) {
		switch ($Addr->getFieldData($FieldID,'Typ')) {
			case 'title':
				$crmGroup=$FieldID;
			break;
			case 'chk':
			case 'text':
			case 'area':
			case 'select':
			case 'mselect':
			case 'fk_user':
			case 'password':
				if ($AObj->getMeta($FieldID)) {
					$crmFields[$crmGroup][]=$FieldID;
				}
			break;
			case 'num':
				if ((string)$AObj->getMeta($FieldID)!=='') {
					$crmFields[$crmGroup][]=$FieldID;
				}
			break;
			case 'date':
				if ($AObj->getMeta($FieldID) && $AObj->getMeta($FieldID) != '0000-00-00') {
					$crmFields[$crmGroup][]=$FieldID;
				}
			break;
		}

	}
	if (!empty($crmFields)) {
		foreach ($crmFields as $crmGroup=>$field_list) {
			$Field=$Addr->getFieldData($crmGroup);
			if ($Field) {
				$t->assign('N_FELD',Framework::entities($Field['Title']));
				$t->parse('C_FELD','field_title');
				$t->assign('C_FELD',$t->getParsed());
				if ($Field['Card'] && $t->issetkey('card_row_'.$Field['Card'])) {
					$t->parse('ROW','.card_row_'.$Field['Card']);
				}
			}
			foreach ($field_list as $FieldID) {
				$Field=$Addr->getFieldData($FieldID);
				//debug($FieldID);
				switch ($Field['Typ']) {
					case 'text':
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',Framework::entities($AObj->getMeta($FieldID)));
						$t->parse('C_FELD','field_text');
						$t->assign('C_FELD',$t->getParsed());
						break;
					case 'password':
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD','**********');
						$t->parse('C_FELD','field_text');
						$t->assign('C_FELD',$t->getParsed());
						break;
					case 'area':
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',nl2br(Framework::entities($AObj->getMeta($FieldID))));
						$t->parse('C_FELD','field_text');
						$t->assign('C_FELD',$t->getParsed());
						break;
					case 'select':
						$select_array=array('0'=>'-') + $Addr->listAddrSelect($FieldID);
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',Framework::entities($select_array[$AObj->getMeta($FieldID)]));
						$t->parse('C_FELD','field_select');
						$t->assign('C_FELD',$t->getParsed());
						break;
					case 'mselect':
						$select_array=array('0'=>'-') + $Addr->listAddrSelect($FieldID);
						$temp=$Addr->AddrExplode($AObj->getMeta($FieldID));
						$temp_val=array();
						foreach ($temp as $val) {
							$temp_val[]=$select_array[$val];
						}
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',implode('<br />',Framework::entities($temp_val)));
						$t->parse('C_FELD','field_select');
						$t->assign('C_FELD',$t->getParsed());
						break;
					case 'fk_user':
						$temp_val=$frm->getCachedUserName($Addr->AddrExplode($AObj->getMeta($FieldID)));
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',implode('<br />',Framework::entities($temp_val)));
						$t->parse('C_FELD','field_select');
						$t->assign('C_FELD',$t->getParsed());
						break;
					case 'chk':
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						if ($AObj->getMeta($FieldID)==1) {
							$t->parse('ROW','field_chk_y');
						}
						if ($AObj->getMeta($FieldID)==-1) {
							$t->parse('ROW','field_chk_n');
						}
						$t->parse('C_FELD','field_chk');
						$t->assign('C_FELD',$t->getParsed());
						$t->clear_dynamic('field_chk_y');
						$t->clear_dynamic('field_chk_n');
						break;
					case 'num':
						$temp=''.str_replace('.',constDECIMAL,floatval($AObj->getMeta($FieldID)));
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',Framework::entities($temp));
						$t->parse('C_FELD','field_text');
						$t->assign('C_FELD',$t->getParsed());
						break;
					case 'date':
						$temp=preg_split('/[^0-9]/',$AObj->getMeta($FieldID));
						if (!intval($temp[0])) $temp[0]='----';
						if (!intval($temp[1])) $temp[1]='--';
						if (!intval($temp[2])) $temp[2]='--';
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD_1',$temp[0]);
						$t->assign('F_FELD_2',$temp[1]);
						$t->assign('F_FELD_3',$temp[2]);
						$t->parse('C_FELD','field_date');
						$t->assign('C_FELD',$t->getParsed());
						break;
				}
				if ($Field['Card'] && $t->issetkey('card_row_'.$Field['Card'])) {
					$t->parse('ROW','.card_row_'.$Field['Card']);
				}
			}
		}
		$t->parse('ROW','view_crm');
	}
}
if ($disp=='l') {
	$t->assign('DISP_L_ON','on');
	$t->assign('DISP_G_ON','off');
	$t->assign('DISP_P_ON','off');
	$t->assign('DISP_ADDRCONT','none');
	$t->assign('DISP_OBJLOG','block');
} elseif ($disp=='p') {
	$t->assign('DISP_P_ON','on');
	$t->assign('DISP_G_ON','off');
	$t->assign('DISP_L_ON','off');
	$t->assign('DISP_ADDRCONT','block');
	$t->assign('DISP_OBJLOG','none');
} else {
	$t->assign('DISP_P_ON','off');
	$t->assign('DISP_G_ON','on');
	$t->assign('DISP_L_ON','off');
	$t->assign('DISP_ADDRCONT','block');
	$t->assign('DISP_OBJLOG','none');
}
$t->assign('L_DISP_P',"index.php?site=$site&action=$action&oid=$oid&aid=$aid&disp=p&vst=$vst");
$t->assign('L_DISP_G',"index.php?site=$site&action=$action&oid=$oid&aid=$aid&disp=g&vst=$vst");
$t->assign('L_DISP_L',"index.php?site=$site&action=$action&oid=$oid&aid=$aid&disp=l&vst=$vst");

if ($parseCards['ga'] || $parseCards['gf']) {
	$t->parse('ROW','view_g');
}
if ($parseCards['pa'] || $parseCards['pf']) {
	$t->parse('ROW','view_p');
}
if (($Addr->isRuleUser() && !$AObj->getMeta('UserID')) || $AObj->getMeta('UserID')==$frm->getUser()) {
	require_once('lib/addr/class_AddrLogGui.php');
	$logGui=new AddrLogGui();
	$logContent=$logGui->getAddrLogGui($AObj);
	$t->assign('TPL_OBJ_LOG',$logContent->process());


	$t->parse('ROW','view_l');
}

$t->parse('TPL_ADDR','tpl_addr');
clearAddress();

$obj_action=$frm->getObjAction($Addr->getModul(),$AObj->getActionMode(0));
foreach ($obj_action as $key=>$val) {
	if (!$val['Hidden'] && $Addr->isAllowedAddrAction($AObj,$val)) {
		$t->assign('SEL_VAL',$key);
		$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
		$t->parse('ROW','.obj_action_val');
		$parse=true;
	}
}
if ($parse) $t->parse('ROW','obj_action');

$seed=1;
if (!intval($vst)) $vst=1;
if ($AObj->getMeta('StammID') && ($tmpObj=$Addr->getAddrObj($AObj->getMeta('StammID')))) {
	if ($tmpObj->getAcl(1) || $tmpObj->getAcl(2)) {
		parseAddress($tmpObj,$disp,$seed,1);
		$t->parse('TPL_STAMM','tpl_addr');
		//$t->parse('ROW','txt_stamm');
		if ($vst==$seed) {
			$t->assign('DISP_STAMM','');
			$t->assign('ST_ON','on');
		} else {
			$t->assign('DISP_STAMM','none');
			$t->assign('ST_ON','off');
		}
		$t->assign('ST_URL',"index.php?site=$site&action=$action&oid=$oid&aid=$aid&disp=$disp&vst=$seed");
		$t->assign('ST_URL_EXT',"index.php?site=$site&action=$action&oid=$oid&aid=".$tmpObj->getID());
		$t->assign('ST_NAME',Framework::entities($tmpObj->getName()));
		$stFirma=$tmpObj->getMeta('Firma');
		$t->parse('ROW','.view_stamm_h');
		$t->parse('ROW','.tpl_stamm');
		$t->clear_dynamic('txt_stamm');
		clearAddress();
		$seed++;
	}
	$StammID=$AObj->getMeta('StammID');
} else {
	$StammID=$AObj->getID();
	$stFirma=$AObj->getMeta('Firma');
}

$st_list=$Addr->getStammAddr($StammID,$AObj->getID());
foreach ($st_list as $key=>$val) {
	$tmpObj=$Addr->getAddrObj($val);
	if ($tmpObj->getAcl(1) || $tmpObj->getAcl(2)) {
		parseAddress($tmpObj,$disp,$seed);
		$t->parse('TPL_STAMM','tpl_addr');
		if ($vst==$seed) {
			$t->assign('DISP_STAMM','');
			$t->assign('ST_ON','on');
		} else {
			$t->assign('DISP_STAMM','none');
			$t->assign('ST_ON','off');
		}
		$t->assign('ST_URL',"index.php?site=$site&action=$action&oid=$oid&aid=$aid&disp=$disp&vst=$seed");
		$t->assign('ST_URL_EXT',"index.php?site=$site&action=$action&oid=$oid&aid=".$tmpObj->getID());
		if ($tmpObj->getMeta('Firma')==$stFirma) {
			if ($tmpObj->getMeta('Nachname') || $tmpObj->getMeta('Vorname')) $tmpObj->setMeta('Firma','');
		}
		if ($tmpObj->getMeta('Nachname') && $tmpObj->getMeta('Vorname')) {
			$tmpObj->setMeta('Vorname',substr($tmpObj->getMeta('Vorname'),0,1).'.');
		}
		$t->assign('ST_NAME',Framework::entities($tmpObj->getName()));
		$t->parse('ROW','.view_stamm_h');
		$t->parse('ROW','.tpl_stamm');
		clearAddress();
		$seed++;
	}
}
if ($seed>1) {
	$t->parse('ROW','view_stamm');
}



if (($send_x)) {
	if (trim($comment)) {
		$Addr->insertLog($AObj->getID(),$auth->auth['uid'],$comment,'log');
		$comment='';
	}
}
$t->assign('COMMENT',Framework::entities($comment));


require_once ('lib/addr/view/geAddrViewLog.php');
$addrLogGui=new geAddrViewLog();
$addrLogGui->setData(array(
	'entries'=>$Addr->listLog($AObj->getID(),'log',''),
	'address'=>$AObj,
));
$t->assign('TPL_ADDR_LOG',$addrLogGui->process());
$t->parse('ROW','log_content');


$frm->addJsScript('js/core/view/coreViewLog.js');
$options=array(
	'modul'=>'addr',
);
$t->assign('ADDR_ID',$AObj->getID());
$t->assign('OPTIONS',json_encode($options));
$t->parse('ROW','js_log');


$kmng=0;$disp_kmng=1;
$kmng_list=$Addr->listKmng($AObj->getID());
if ($Addr->getPerms(16)) {
	$t->assign('SKMNG',htmlspecialchars($skmng));
	if ($dkmng) {
		$Addr->deleteKmng($AObj->getID(),$dkmng);
		$Addr->deleteKmng($dkmng,$AObj->getID());
	}
	if ($ikmng_x) {
		if ($KmngID) {
			$Addr->insertKmng($AObj->getID(),$KmngID,$kmng_text);
			$kmng_list=$Addr->listKmng($AObj->getID());
		} else {
			$search_x=1;
		}
	}
	if ($sbfeld=='skmng') $search_x=1;
	if ($search_x && $skmng) {
		$notIN=array();
		if (count($kmng_list)) $notIN = array_keys($kmng_list);
		$notIN[]=$AObj->getID();

		$searchAddr=array();
		$searchAddr[]=array('Field'=>$Addr->getSearchFields(),'Typ'=>'concat','Values'=>$skmng);
		$searchAddr[]=array('Field'=>'AddressID','Typ'=>'!=','Values'=>$notIN);
		$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
		$Addr->setLimit(5);
		$result=$Addr->searchAddr(0,array('Name'=>1),$searchAddr);

		if ($Addr->getRows()) {
			$chkKmng=new RadioButton('KmngID','');
			$i=1;
			foreach ($result as $key=>$val) {
				if ($Addr->getRows()==1) $KmngID=$key;
				$t->assign('CHK_ROW',$chkKmng->f($key));
				$t->assign('N_ROW',FrameWork::entities($val->getName()));
				$t->assign('I_ROW',$val->getImage());
				if ($i%2) $t->assign('ROW_COLOR','#efefef'); else $t->assign('ROW_COLOR',$bgcolor);
				$t->parse('ROW','.kmng_search_row');
				$i++;
			}
			$t->assign('KMNG_CLOSE',$L_THIS);
			$t->assign('S_NUM',$Addr->getRows());
			$t->assign('KMNG_TEXT',htmlspecialchars($kmng_text));
			$t->parse('ROW','kmng_search');
			$disp_kmng=0;
		}

	}
	$t->parse('ROW','kontakt_mng_edit');
	$kmng=1;
}
$i=1;
if ($disp_kmng) {
	foreach ($kmng_list as $key=>$val) {
		$tmpObj=$Addr->getAddrObj($key);
		if (is_object($tmpObj) && $tmpObj->getAcl(2) && $dkmng!=$key) {
			$t->assign('KMNG_LINK',"index.php?site=$site&action=$action&oid=$oid&aid=$key&back=0");
			$t->assign('KMNG_NAME',Framework::entities($tmpObj->getName()));
			$t->assign('KMNG_TEXT',nl2br(Framework::entities($val['Text'])));
			if ($Addr->getPerms(16)) {
				$t->assign('DEL_KMNG',$L_THIS.'&dkmng='.$key);
				$t->parse('ROW','del_kmng');
			} else {
				$t->clear_dynamic('ROW','del_kmng');
			}
			if ($i%2) $t->assign('ROW_COLOR','#efefef'); else $t->assign('ROW_COLOR',$bgcolor);
			$t->parse('ROW','.kmng_row');
			$kmng=1;
			$i++;
		}
	}
}



if ($kmng) {
	$t->parse('ROW','kontakt_mng');
}
$t->assign('HID_DISP',$disp);
$t->assign('HID_VST',$vst);
//debug($H_REFERER);
//debug($back);
if ($H_REFERER[intval($back)]) {
	$t->assign('L_BREAK',$H_REFERER[intval($back)]);
} else {
	$t->assign('L_BREAK',"index.php?site=$site");
}

$t->assign('L_PRINT',"index.php?site=$site&action=pv&oid=$oid&aid=$aid");
$t->parse('ROW','print');

function parseAddress(&$AObj,&$disp,$seed,$Stamm=0) {
	global $frm,$t,$Addr,$app,$H_REFERER,$parseCards;
	$t->assign('SEED',$seed);
	$parse_card=array();
	foreach ($Addr->getFields() as $FieldID=>$Field) {
		if ($Field['FieldTyp']!='u') {
			//echo $FieldID.'<br>';
			if ($FieldID=='Vorname') continue;
  		    if ($FieldID=='MaidenName') continue;
			if ($FieldID=='Geschlecht') $Field['Card']='ex';

			$parseCards[$Field['Card']]=true;
  		    if ($FieldID=='Nachname') {
				$values=array($AObj->getName(2));
  		    } else {
				$values=$Addr->AddrExplode($AObj->getMeta($FieldID));
			}

			$parse=0;
			foreach ($values as $tkey=>$tval) {
				$col_link='';
				$col_add='';
				$target='';
				if ($tval) {
					switch ($Field['Action']) {
						case 'mail':
							if ($app['email']) {
									$col_link=$H_REFERER[1]."&aid=".$AObj->getID()."&addr_action_x=1&addr_action_val=s_mail&addr_action_num=$tkey";
							} else {
								$col_link="mailto:".htmlspecialchars($Addr->formatMail($AObj,$tval));
							}
						break;
						case 'fax':
							if ($app['fax']) {
								$col_link="index.php?site=fax.php&action=&show=compose&m_t=new&Addr=".urlencode($Addr->formatFax($AObj,$tval));
							}
						break;
						case 'sms':
							$col_link=htmlspecialchars($Addr->formatCallto($AObj,$tval));
							if ($app['sms']) {
								$col_add='';
								$msgParams=array(
									'invReset'=>1,
									'tab'=>'sms',
								);
								$msgParams['smsToAdd']=$frm->getStaticModul('sms')->formatNumber($tval,$AObj->getName(1));
								$smsLink='javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));';
								if ($col_link) {
									$col_add='<a href="'.$smsLink.'"><img style="vertical-align:text-top" src="img/ge/js_send.gif" /></a>';
								} else {
									$col_link=$smsLink;
								}
							}
						break;
						case 'skype':
							$col_link=htmlspecialchars($Addr->formatCallto($AObj,$tval));
						break;
						case 'web':
							$col_link=htmlspecialchars($Addr->formatWeb($AObj,$tval));
							$target='target="_blank"';
						break;
					}
					$parse=1;
				}
				if ($col_link) {
					$values[$tkey]=$col_add.'<a href="'.$col_link.'" '.$target.'>'.nl2br(FrameWork::entities($tval)).'</a>';
				} else {
					$values[$tkey]=nl2br(FrameWork::entities($tval));
				}
			}

			switch ($Field['Typ']) {
				case 'area':
				case 'text':
				case 'kont':
					if ($parse && $t->issetkey("$FieldID")) {
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',implode('<br>',$values));
						$t->parse('ROW',"$FieldID");
						$parse_card[$Field['Card']]=1;
						if ($Field['Multi']) $mvalues[$Field['Multi']]+=1;
					}
					break;
				case 'select':
					if ($parse && $t->issetkey("$FieldID")) {
						foreach ($values as $key=>$val) {
							$tmp=$Addr->readAddrSelect($FieldID,$val,array($Addr->getLang()));
							$values[$key]=$tmp['Name_'.$Addr->getLang()];
						}
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',implode('<br>',$values));
						$t->parse('ROW',"$FieldID");
						$parse_card[$Field['Card']]=1;
						if ($Field['Multi']) $mvalues[$Field['Multi']]+=1;
					}
					break;
				case 'date':
					if ($parse && $t->issetkey("$FieldID") && $values[0]!= '0000-00-00') {
						$t->assign('N_FELD',Framework::entities($Field['Title']));
						$t->assign('F_FELD',Framework::dateSql('d.m.Y',$values[0]));
						$t->parse('ROW',"$FieldID");
						$parse_card[$Field['Card']]=1;
						if ($Field['Multi']) $mvalues[$Field['Multi']]+=1;
					}
					break;
				default:
					continue;
			}

		}
	}
	if (!$disp) {
		if (!$parseCards['ga'] && !$parseCards['gf']) {
			 $disp='p';
		} elseif ($mvalues[2]>$mvalues[1]) {
			$disp='p';
		} else $disp='g';
	}
	if ($disp=='p') {
		$t->assign('DISP_GA','none');
		$t->assign('DISP_GK','none');
		$t->assign('DISP_PA','');
		$t->assign('DISP_PK','');
	} else {
		$t->assign('DISP_GA','');
		$t->assign('DISP_GK','');
		$t->assign('DISP_PA','none');
		$t->assign('DISP_PK','none');
	}

	if ($Stamm) {
		$t->parse('ROW','StammAddr');
	}
	foreach ($parse_card as $key=>$val) {
		if ($t->issetkey('card_row_'.$key)) {
			$t->parse('ROW','card_row_'.$key);
		}
	}
}
function clearAddress() {
	global $t,$Addr;
	foreach ($Addr->getFields() as $FieldID=>$Field) {
		$t->clear_dynamic($FieldID);
		$t->clear_dynamic($Field['Card']);
		$t->clear_dynamic('card_row_'.$Field['Card']);
	}
	$t->clear_dynamic('StammAddr');
}
?>