<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array("form_tpl"=>"admin_acc_rule_form.inc.html"));



if ($ruleID) {
	$all_users=$frm->getFullName(0,0,array('','system'));
	foreach ($rule_users as $key=>$val) {
		$rule_user[$key]=$all_users[$val];
		if ($val!=$frm->getUser()) unset($all_users[$val]);
	}
	if (!is_array($all_users)) $all_users=array('');
	$select1=new SelectField ('add_user','class="sel" size="15" style="width:300px;"',$all_users);
	$t->assign('USERS',$select1->f());
	$f_user0=new TextField("rule_user[0]",'class="sel" size="20" style="width:300px;" readonly="readonly"');
	$t->assign("USER_0_F",$f_user0->f());
	for ($i=1;$i<$frm->getFrmCfg('cfg/usr/numRules');$i++) {
		$f_user=new TextField("rule_user[$i]",'class="sel" size="20" style="width:300px;" readonly="readonly"');
		$t->assign("USER_F",$f_user->f());
		$t->assign("RULE_NUM",$i);
		$t->parse('ROW','.rule_row');
	}
	$t->assign('RULE_NAME',Framework::entities($all_rules[$ruleID]['Name']));
	$t->assign('L_BREAK',"index.php?site=$site&ac=$ac");
	$t->parse('ROW','break');
	$t->parse('ROW','meta_content');
} else {
	foreach ($all_rules as $key=>$val) {
		$t->assign('LIST_LINK',"index.php?site=$site&ac=$ac&ruleID=$key");
		$t->assign('LIST_NAME',Framework::entities($val['Name']));
		$lusers=array();
		$temp=$frm->getRuleUsers($val['Perms'],1);
		if ($temp[$val['Perms']]) {
			foreach ($temp[$val['Perms']] as $uval) {
				if (!$all_users[$uval]) {
					$temp=$frm->getFullName($uval,0,array('','system'));
					$all_users[$uval]=$temp[$uval];
				}
				$lusers[]=$all_users[$uval];
			}
		}
		$t->assign('LIST_USERS',Framework::entities(implode(', ',$lusers)));
		if ($key==$ruleID) {
			$t->assign('ROW_COLOR',$fg10color);
		} elseif ($i%2) {
			$t->assign('ROW_COLOR','#f2f2f2');
		} else {
			$t->assign('ROW_COLOR',$bgcolor);
		}
		$t->parse('ROW','.list_row');
		$i++;
	}
	$t->parse('ROW','list_content');
}


$AdminGui->setFormAction("index.php?site=$site&ac=$ac&ruleID=$ruleID");
if($my_rule['sysadmin']) {
	$t->parse('ROW','app_rules');
	if (!$CFG['NoUserEdit']) $t->parse('ROW','app_import');
	if (defined('GE_SUPER_GROUPS_ENABLED') && GE_SUPER_GROUPS_ENABLED) {
		$t->parse('ROW','app_sgroups');
	}
}
