<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

if ($userID==$auth->auth["uid"]) {
	$ActionError['medel']=1;
} else {
	$urules=$frm->getUserRules($userID);
	if (is_array($urules)) {
		foreach(array_keys($urules) as $rval) {
			$rusers=$frm->getRuleUsers($rval);
			if (in_array($userID,$rusers) && count($rusers)==1) {
				$ActionError['udel']=1;
				break;
			}
		}
	}
}


if (!$ActionError && $userID && $userID!=$CFG['SUPERADMIN']) {
	$del_app=$frm->getApplication();
	if ($del_app["cal"]) {
		$cal=& $frm->getStaticModul('cal');
		$cal->deleteUser($userID);
	}
	if ($del_app["addr"]) {
		$Addr=& $frm->getStaticModul('addr');
		$Addr->deleteUser($userID);
	}
	if ($del_app["task"]) {
		$Task=& $frm->getStaticModul('task');
		$Task->deleteUser($userID);
	}
	if ($del_app["forum"]) {
		require_once ("lib/forum/header.php");
		$forum->deleteUser($userID);

	}
	if ($del_app["msg"]) {
		require_once ("lib/msg/header.php");
		$c_msg->deleteUser($userID);
	}
	if ($del_app["fax"]) {
		require('lib/fax/class_Db_Fax.php');
		$db_fax=new DB_Fax($db);
		$db_fax->deleteUser($userID);

	}
	if ($del_app["email"]) {
		$Mail=& $frm->getStaticModul('mail');
		$tmp=$frm->read_user($userID);
		$Mail->setUser($userID);
		$Mail->setUserName($tmp['username']);
		$Mail->deleteUser($userID);
		if ($Mail->getCfg('cfg/sieve/user') || $Mail->getCfg('cfg/filter/user')) {
			require_once('lib/mail/classSieve.php');
			$sieve=new SieveDB($db);
			$sieve->deleteUser($userID);
			if ($Mail->getCfg('cfg/sieve/user')) {
				require_once('lib/mail/classSieveLib.php');
				$sieve_lib=new Sieve($Mail->getCfg('cfg/Server'), $Mail->getCfg('cfg/sieve/port'),$Mail->getUserName(),$Mail->getCfg('cfg/admin'),$Mail->getAdminPwd());
				if ($sieve_lib->sieve_login()) $sieve_lib->sieve_deletescript($Mail->getUserName());
			}
		}
		if ($frm->getFrmCfg('cfg/delall')) {
			$CyrAdm=& $frm->getStaticModul('mail_adm');
			if ($CyrAdm->getCfg('cfg/alias') && file_exists("lib/mail/classAlias_".$CyrAdm->getCfg('cfg/alias').".php")) {
				require_once("lib/mail/classAlias_".$CyrAdm->getCfg('cfg/alias').".php");
			} else {
				require_once("lib/mail/classAlias_mysql.php");
			}
			$Mail->setCfg($frm->getCfg($Mail->getModul(),0,$Mail->getCfg('cfg/alias').'/%'));
			$Ali=new Aliases($Mail);
			if ($CyrAdm->imap_login()) {
				$user_alias=$Ali->get_alias_list_user($tmp['username']);
				if (is_array($user_alias)) {
					foreach($user_alias as $var){
						$Ali->alias_delete($var['alias'], $tmp['username']);
					}
				}
				$CyrAdm->deletemb("user".$CyrAdm->getCfg('cfg/delim').$tmp['username']);
			}
		}
	}

	$frm->delete_user($userID);
	$frm->deleteUserGroups($userID,0,true,false);
	$frm->deleteGroupieUser($userID);
}
?>
