<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

$Addr=$frm->getStaticModul('addr');
$error=false;
$av_perms_r=array(
	'ADN'=>0,
	'ADL'=>2, //Lesen
	'ADW'=>6, // Schreiben 2+4
	'ADD'=>6+128, // Loeschen 2+4+128
	'ADP'=>14+128, // Verwalten 2+4+8+128 (Kategorien anlegen)

);
$av_perms_c=array(
	'ADU'=>1,
	'ADK'=>16,
	'ADLI'=>32,
	'ADEX'=>64,
);
if (!isset($PermsR)) $PermsR=0;
if (isset($new_x)) {
	$temp=0;
	if (is_array($sel_user)) {
		foreach ($sel_user as $val) {
			$Addr->deletePerms('u',$val);
		}
	}
	if ($sel_group) {
		$Addr->deletePerms('g',$sel_group);
	}
	if (is_array($PermsC)) {
		if (is_array($sel_user)) {
			foreach ($sel_user as $val) {
				$Addr->ReplacePerms('u',$val,$PermsC);
			}
		}
		if ($sel_group) {
			$Addr->ReplacePerms('g',$sel_group,$PermsC);
		}
	}
	if ($PermsR) {
		if (is_array($sel_user)) {
			foreach ($sel_user as $val) {
				$Addr->ReplacePerms('u',$val,array($PermsR));
			}
		}
		if ($sel_group) {
			$Addr->ReplacePerms('g',$sel_group,array($PermsR));
		}
	}
	unset($sel_group,$sel_user,$PermsC,$PermsR);
}
if ($del && $UserTyp && $UserID) {
	$Addr->deletePerms($UserTyp,$UserID);
	unset($UserTyp,$UserID);
}
$app_users=$frm->getApplicationUsers('addr');
$users_array=$frm->getFullName(array_keys($app_users),0,array('','system'));
$groups_array=array(0=>'-') + $frm->getAllGroups();
$all_perms=$Addr->getAllPerms();
if ($UserTyp && $UserID) {
	$Perms=$all_perms[$UserTyp][$UserID];
	foreach ($Perms as $val) {
		if (in_array($val,$av_perms_r)) {
			$PermsR=$val;
		} else {
			$PermsC[]=$val;
		}
	}
	if ($UserTyp=='g') {
		$sel_group=$UserID;
	}
	if ($UserTyp=='u') {
		$sel_user=array($UserID);
	}

}
?>
