<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$no_mail=false;
$useMailGroups=($CFG['USER_CLASS']=='ldap_full' || $frm->getCfg('mail',0,'no_ldap/mailGroups'));
$CyrAdm=$frm->getStaticModul('mail_adm');
if ($CyrAdm->imap_login()) {
	if ($userName) {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		$formGui=new FormGui();
		$prjID=0;
		if ($P && ($projObj=$P->isProjectMailFolder($boxName))) {
			$prjID=$projObj->getID();
		}
		//debug($prjID);
		$key='permsUser';
		if ($useMailGroups) {
			if ($prjID) $kmode='u|p|g'; else $kmode='u|g';
		} else {
			$kmode='u';
		}

		$params=base64_encode(serialize(array('prjID'=>$prjID)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$kmode,
			'app'=>'email',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		if ($useMailGroups) {
			if ($prjID) {
				$lb_params['Values'][]=array(
					'Label'=>$T->lang('[[Projektrollen]]'),
					'LabelSep'=>' / ',
					'mode'=>$kmode,
					'app'=>'email',
					'params'=>$params,
					'FieldVal'=>'_PRULES',
				);
			}
			$lb_params['Values'][]=array(
				'Label'=>$T->lang('[[Gruppen]]'),
				'LabelSep'=>' / ',
				'mode'=>$kmode,
				'app'=>'email',
				'params'=>$params,
				'FieldVal'=>'_GROUPS',
			);
		}
		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,'','f_fields');
		$formGui->setParams($key,array('mode'=>$kmode,'app'=>'email','params'=>$params));


		if ($obj_action_x && $obj_action_val) {
			if ($obj_action_val=='new') {
				header("Location:index.php?site=$site&ac=$ac&userName=".urlencode($userName)."&boxName=".urlencode($boxName)."&mode=new");
				page_close();
				exit;
			}
			if ($obj_action_val=='delete') {
				if (!$CyrAdm->deletemb($boxName)) {
					$ActionError['server']=$CyrAdm->getError();
				} else {
					$mode="list";
				}
				if (!$ActionError) {
					page_close();
					header("Location:index.php?site=$site&ac=$ac&mode=$mode&userName=".urlencode($userName));
					exit;
				}
			}
		}
		if ($boxadd_x || $boxren_x || $perms_x || $delacl || $allacl_x) {
			if ($boxadd_x) {
				if (!trim($boxname) || preg_match('/[^\w-_ ]/',$boxname)) {
					$ActionError['fields']['boxname']=1;
				} else {
					$boxname=trim($boxname);
				}
				if (!$ActionError) {
					if ($CyrAdm->createmb($selbox.$CyrAdm->getCfg('cfg/delim').$boxname)) {
						$boxName=$selbox.$CyrAdm->getCfg('cfg/delim').$boxname;
						$mode="edit";
					} else {
						$ActionError['server']=$CyrAdm->getError();
					}
				}
			}
			if ($boxren_x) {
				if (!trim($boxname1) || preg_match('/[^\w-_ ]/',$boxname1)) {
					$ActionError['fields']['boxname1']=1;
				} else {
					$boxname=trim($boxname1);
				}
				if (!$ActionError) {
					if ($selbox1.$CyrAdm->getCfg('cfg/delim').$boxname1!=$boxName && $CyrAdm->renamemb($boxName, $selbox1.$CyrAdm->getCfg('cfg/delim').$boxname1)) {
						$boxName="";
						$mode="list";
					} else {
						$ActionError['server']=$CyrAdm->getError();
					}
				}
			}
			if ($perms_x) {
				if (trim($formGui->getFieldVal('permsUser')) && $boxperms) {
					$addUsers=array();
					$addGroups=array();
					$tmp=explode('|',$formGui->getFieldVal('permsUser'));
					foreach ($tmp as $val) {
						$tmp2=explode('_',$val);
						if ($tmp2[0]=='u') {
							$udata=$frm->read_user($tmp2[1]);
							if ($udata['username']) {
								$addUsers[]=$udata['username'];
							}
						}
						if ($tmp2[0]=='g' || $tmp2[0]=='p') {
							$udata=$frm->getAllGroups($tmp2[1],-1,'',0,false,false);
							if ($udata[$tmp2[1]]) {
								$addGroups[]=$udata[$tmp2[1]];
							}
						}
					}

					if($boxperms=='d') $acl=$CyrAdm->getPerms(7);
					elseif($boxperms=='w') $acl=$CyrAdm->getPerms(3);
					else $acl=$CyrAdm->getPerms(1);
					foreach($addUsers as $var){
						if ($var && GE_DOMAIN && $GLOBALS['CFG']['USER_CLASS']!='ldap_full') {
							$var=$var.'_'.str_replace('.','_',GE_DOMAIN);
						}
						if ($var && !$CyrAdm->setacl($boxName, $var, $acl)) {
							$ActionError['server']=$CyrAdm->getError();
							break;
						}
					}
					foreach($addGroups as $var){
						if ($var && !$CyrAdm->setacl($boxName, $var, $acl,1)) {
							$ActionError['server']=$CyrAdm->getError();
							break;
						}
					}

				}
			}
			if ($allacl_x) {
				$acl=array_reverse($CyrAdm->getacl($boxName),true);
				$all_folders=$CyrAdm->GetFolders($boxName);
				if (is_array($all_folders)) {
					foreach ($all_folders as $val) {
						$tmp_acl=$CyrAdm->getacl($val);
						foreach ($tmp_acl as $akey=>$aval) {
							$CyrAdm->deleteacl($val,$akey);
						}
						foreach ($acl as $akey=>$aval) {
							$CyrAdm->setacl($val, trim($akey), trim($aval));
						}
					}
				}
			}
			if ($delacl){
				if (!$CyrAdm->deleteacl($boxName, $delacl)) {
					$ActionError['server']=$CyrAdm->getError();
				}
			}


			if (!$ActionError) {
				page_close();
				header("Location:index.php?site=$site&ac=$ac&mode=$mode&userName=".urlencode($userName)."&boxName=".urlencode($boxName));
				exit;
			}
		}



	}

} else {
	$ActionError['server']=$CyrAdm->getError();
	$no_mail=true;
}






?>
