<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if (!$no_mail) {
	$t->define (array("form_tpl"=>"admin_email_user_form.inc.html"));
	$parse=false;
	if (!$CFG['NoMailEdit']) {
		$obj_action=$frm->getObjAction('admin','email_user');
		foreach ($obj_action as $key=>$val) {
			if ($val['Hidden']) continue;
			if (in_array('ID',$val['Extra']) && (!$userName || $mode!='edit')) continue;
			$t->assign('SEL_VAL',$key);
			$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
			$t->parse('ROW','.obj_action_val');
			$parse=true;
		}
	}
	if ($parse) $t->parse('ROW','obj_action');

	$form_action="index.php?site=$site&ac=$ac&mode=$mode";
	if ($userName) $form_action.="&userName=".urlencode($userName);
	if ($mode=='edit') {
		if (!$CFG['NoMailEdit']) {
			if ($ActionError['fields']['boxname']) $t->assign('C_BOXNAME','error'); else  $t->assign('C_BOXNAME','');
			$f_boxname=new TextField("boxname",'class="sel" size="30" style="width:300px"');
			$t->assign("F_BOXNAME",$f_boxname->f());
			$t->assign('FOCUS_FIELD','boxname');

			if ($ActionError['fields']['qmax']) $t->assign('C_QMAX','error'); else  $t->assign('C_QMAX','');
			$f_qmax=new TextField("qmax","class=\"sel\" size=\"6\" style=\"width:40px\" ");
			$t->assign("F_QMAX",$f_qmax->f());
		} else {
			$t->assign('F_BOXNAME','<div class="disable" style="width:300px;">'.FrameWork::entities($boxname).'</div>');
			$t->assign('F_QMAX',FrameWork::entities($qmax));
		}
		if ($userName) {
			$t->assign('USER_NAME',Framework::entities($userName));
			$t->assign("QUSED",intval($quota['usage']/1000));
			$t->parse('ROW','used_quota');
			$t->parse('ROW','title_edit');

			$user_alias=$Ali->get_alias_list_user($userName);
			if(is_array($user_alias)){
				$i=0;
				foreach($user_alias as $var){
					$t->assign('N_ALIAS',Framework::entities($var['alias']));
					$t->assign('DEL_ALIAS',$form_action."&dalias=".$var['alias']);
					if ($i%2) {
						$t->assign('ROW_COLOR','#f2f2f2');
					} else {
						$t->assign('ROW_COLOR',$bgcolor);
					}
					$t->parse('ROW','.alias_row');
				}

			}
			if ($ActionError['fields']['n_alias']) $t->assign('C_ALIAS','error'); else  $t->assign('C_ALIAS','');
			$f_alias=new TextField("n_alias",'class="sel" size="30" style="width:230px"');
			$t->assign("F_ALIAS",$f_alias->f());
			$t->parse('ROW','aliases');
		} else {
			$t->parse('ROW','title_new');
		}
		$t->assign('L_BREAK',"index.php?site=$site&ac=$ac");
		$t->parse('ROW','break');
		$t->parse('ROW','update');
		$t->parse('ROW','meta_content');
	} else {
		if (GE_mailUserSuffix) {
			$all_users=$CyrAdm->GetUsers('%'.GE_mailUserSuffix);
		} else {
			$all_users=$CyrAdm->GetUsers('%');
		}
		if (is_array($all_users)) {
			$i=0;
			foreach ($all_users as $val) {
				$list_quota=$CyrAdm->getquota("user".$CyrAdm->getCfg('cfg/delim').$val);
				$list_alias=$Ali->get_alias_list_user($val);
				$t->assign('LIST_LINK',"index.php?site=$site&ac=$ac&mode=edit&userName=".urlencode($val));
				$t->assign('LIST_NAME',Framework::entities($val));
				if ($val==$userName) {
					$t->assign('ROW_COLOR',$fg10color);
				} elseif ($i%2) {
					$t->assign('ROW_COLOR','#f2f2f2');
				} else {
					$t->assign('ROW_COLOR',$bgcolor);
				}
				if (isset($list_quota['usage']) && isset($list_quota['limit'])) {
					$t->assign('LIST_QUOTA_U',intval($list_quota['usage']/1000));
					$t->assign('LIST_QUOTA_M',intval($list_quota['limit']/1000));
					if ($list_quota['usage'] > ($list_quota['limit']*0.9)) $t->assign('C_LIST_QUOTA','error'); else $t->assign('C_LIST_QUOTA','');
				} else {
					$t->assign('LIST_QUOTA_U','-');
					$t->assign('LIST_QUOTA_M','-');
					$t->assign('C_LIST_QUOTA','');
				}
				if(is_array($list_alias)){
					$tmp_alias=array();
					foreach($list_alias as $var){
						$tmp_alias[]=Framework::entities($var['alias']);
					}
					$t->assign('LIST_ALIAS',implode(', ',$tmp_alias));
				} else {
					$t->assign('LIST_ALIAS','');
				}
				$t->parse('ROW','.list_row');
				$i++;
			}
		}
		$t->parse('ROW','list_content');
	}

	$AdminGui->setFormAction($form_action);
	$CyrAdm->imap_logout();
}
?>