<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->assign('MOD_TITLE',$frm->getAppName('cal'));
if (!$app["cal"]) {
	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
} else {

	if (Framework::getParam('_goToAddr','0','G')) {
		$GLOBALS['SESS_MDATA']['addr.php']['L_BACK']=array(0=>$L->getTempLink());
		$L=new GlobLinkObj();
		$L->setParam('site','addr.php');
		$L->setParam('aid',Framework::getParam('_goToAddr','0','G'));
		if (Framework::getParam('_goToEdit','0','G')) {
			$L->setParam('action','i');
		} else {
			$L->setParam('action','v');
		}
		$L->goToLink();
	}
	require_once("lib/class_ApplicationGui.php");
	$AppGui=new ApplicationGui();
	$AppGui->setName($frm->getAppName('cal'));
	$AppGui->setImage('appl_kal.gif');
	$T->loadModul('cal');
	$t->setRoot("tpl/$THEME/cal/$session_lang");
	$cal=& $frm->getStaticModul('cal');
	$pre["cal"]=$frm->getPrefs('cal');
	$wd=& $frm->getStaticModul('workday');
	if (!isset($CAL_REFERER)) {
		$CAL_REFERER[0]="index.php?site=$site";
		$sess->register('CAL_REFERER');
	}
	if (isset($SESS_MDATA[$site]['L_BACK'])) {
		$CAL_REFERER=$SESS_MDATA[$site]['L_BACK'];
	}
	if (!isset($NW)) {
		$sess->register('NW');
	}
	if (!$NW) {
		if ($frm->getPrefs('cal','nw')) {
			$NW=$frm->getPrefs('cal','nw');
		} else {
			$NW=1;
		}
	}
	if (Framework::getParam('_sNW',0) && intval(Framework::getParam('_sNW'))>0 && intval(Framework::getParam('_sNW'))<13) {
		$NW=intval(Framework::getParam('_sNW'));
	}

	$t->define (array('application' => "cal.inc.html"));
	if ($frm->getPrefs('global','js')) $t->parse("ROW","conf_delete");


	$daybeginn_h=$frm->getPrefs('cal',"db_h");
	$daybeginn_m=$frm->getPrefs('cal',"db_m");
	$dayend_h=$frm->getPrefs('cal',"de_h");
	$dayend_m=$frm->getPrefs('cal',"db_m");

	$PERMS=$cal->getPerms($frm->getUser(),$frm->getMyGroups());
	$PERMS_READ=array();
	//debug($PERMS);
	foreach ($PERMS as $key=>$val) {
		if ($val&1) {
			$PERMS_READ[]=$key;
		}
	}
	if (!empty($PERMS_READ)) {
		$cal_user_array=$frm->getFullName($PERMS_READ,0,array('','system'));
	} else {
		$cal_user_array=false;
	}

	$PERMS[$auth->auth['uid']]=7;
	$PERMS['info']=7;
	if (!isset($CAL_USER)) {
		$sess->register('CAL_USER');
		$CAL_USER=0;
	}

	if ($cal_user) $CAL_USER=$cal_user;
	if (!($PERMS[$CAL_USER]&1)) {
		if ($frm->getPrefs('cal','inf')) $CAL_USER='info';
		else $CAL_USER=$auth->auth['uid'];
	}
	$CAL_PERMS=$PERMS[$CAL_USER];

	if ($CAL_USER=='info') $user_id=$auth->auth['uid'];
	else $user_id=$CAL_USER;
	$cal->setUser($user_id);
	$cal->setCalPerms($CAL_PERMS);
	$cal->setAllCalPerms($PERMS);
	$user_gid=$frm->getUserGroups($user_id);
	$cal->setGroup($user_gid);
	if ($cal_user_array[$CAL_USER]) {
		$CAL_USER_N=$cal_user_array[$CAL_USER];
		$t->assign('CAL_USER',Framework::entities($CAL_USER_N));
		$t->parse('ROW','ext_user');
	} else {
		$CAL_USER_N=$REG_USER['lastname'].' '.$REG_USER['firstname'];
		$t->assign('CAL_USER',Framework::entities($REG_USER['lastname'].' '.$REG_USER['firstname']));
	}


	$action=Framework::getParam('action','view');
	$view=Framework::getParam('view',$frm->getPrefs('cal',"view"));
	$date=Framework::getParam('date');
	if ($view=='day' && Framework::getParam('sdate')) {
		$date=$frm->parseDate(Framework::getParam('sdate'));
	}
	if (!$date) {
		$date=time();
	}

	$t->assign('DAY_ON','off');
	$t->assign('WEEK_ON','off');
	$t->assign('MONTH_ON','off');
	$t->assign('YEAR_ON','off');
	$t->assign('OVER_ON','off');
	$t->assign('ENTRY_ON','off');
	$t->assign('IMPORT_ON','off');
	$t->assign('MAI_ON','off');
	$t->assign('T_ON','off');
	$t->assign('S_ON','off');
	$t->assign('E_ON','off');
	$i_action="index.php?site=$site&action=view&date=$date";
	if ($view!='event') $i_action.="&view=$view";
	else  $i_action.="&view=".$frm->getPrefs('cal',"view");
	$t->assign("I_ACTION",$i_action);
	$t->assign('L_PRINT',"index.php?site=$site&action=$action&view=$view&date=$date&event_id=$event_id&print=html");
	$t->assign("AUTH_USER_VAL",$auth->auth['uid']);
	if ($CAL_USER=='info') $t->assign("INFO_USER_CHK","selected");
	if (is_array($cal_user_array)) {
		foreach ($cal_user_array as $key=>$val) {
			if ($key==$CAL_USER) $t->assign("CAL_USER_CHK","selected");
			else $t->assign("CAL_USER_CHK","");
			$t->assign ("CAL_USER_VAL",$key);
			$t->assign ("CAL_USER_NAME",$val);
			$t->parse('ROW','.cal_user');

		}
	}
	if ($event_id) {
		$obj=$cal->readEvent($event_id);
		if ($obj['RecType'] && ($next=$cal->nextRecurrence($obj, $edate-1))) {
			$obj['StartDate']=$next['start'];
			$obj['EndDate']=$next['end'];
		}
	}

	if ($obj_action_x && $obj_action_val) {
		require ('lib/cal/inc_ActionObject.php');
	}

	$t->assign("M_LINK","index.php?site=$site&action=view&date=".time());
	$t->assign('A_LINK',"index.php?site=$site&action=insert&view=event&date=".time());
	$t->assign("S_ACTION","index.php?site=$site&action=view&view=day");
	$t->assign("S_DATE",date("d/m/Y"));
	switch($action) {
		case 'insert':
		case 'edit':
		case 'copy':
			if (!($CAL_PERMS&2)) {
				page_close();
				header("Location:index.php?site=cal.php");
				exit;
			}
			$t->assign('ENTRY_ON','on');
			require_once('lib/cal/class_EventEditGui.php');
			$contGui=new EventEditGui();
			$t->assign('TPL_CAL',$contGui->showEditContent());
		break;
		case 'view':
			if ($view=='week' || $view=='group') {
				$viewMode=$frm->getPrefs('cal','ViewMode');
				if (Framework::getParam('setViewMode',0,'P') && Framework::getParam('setViewMode',0,'P')!=$viewMode) {
					$viewMode=Framework::getParam('setViewMode',0,'P');
					$frm->insertPrefs('cal',array('ViewMode'=>$viewMode));
				}
				if ($viewMode==1) $view='group'; else $view='week';
				Framework::importParam(array('view'=>$view));
			}
			if (Framework::getParam('_clHistory')) {
				$CAL_REFERER=array();
			}
			switch ($view) {
				case 'year':
					$t->assign('YEAR_ON','on');
					$CAL_REFERER[0]=$L->getTempLink();
					unset($CAL_REFERER[1]);
					require_once('lib/cal/class_ViewYearGui.php');
					$ContGui=new ViewYearGui();
					if ($Gui=$ContGui->process()) {
						$t->assign('TPL_CAL',$Gui->process());
					} else {
						$t->assign('TPL_CAL','');
					}
				break;
				case 'month':
					$t->assign('MONTH_ON','on');
					$CAL_REFERER[0]=$L->getTempLink();
					unset($CAL_REFERER[1]);
					require_once('lib/cal/class_ViewMonthGui.php');
					$ContGui=new ViewMonthGui();
					if ($Gui=$ContGui->process()) {
						$t->assign('TPL_CAL',$Gui->process());
					} else {
						$t->assign('TPL_CAL','');
					}
				break;
				case 'group':
					$t->assign('WEEK_ON','on');
					$CAL_REFERER[0]=$L->getTempLink();
					unset($CAL_REFERER[1]);
					require_once('lib/cal/class_ViewGroupGui.php');
					$ContGui=new ViewGroupGui();
					if ($Gui=$ContGui->process()) {
						$t->assign('TPL_CAL',$Gui->process());
					} else {
						$t->assign('TPL_CAL','');
					}
				break;
				case 'week':
					$t->assign('WEEK_ON','on');
					$CAL_REFERER[0]=$L->getTempLink();
					unset($CAL_REFERER[1]);
					require_once('lib/cal/class_ViewWeekGui.php');
					$ContGui=new ViewWeekGui();
					if ($Gui=$ContGui->process()) {
						$t->assign('TPL_CAL',$Gui->process());
					} else {
						$t->assign('TPL_CAL','');
					}
				break;
				case 'day':
					$t->assign('DAY_ON','on');
					if (Framework::getParam('old_view')) $CAL_REFERER[2]=$CAL_REFERER[0];
					elseif (!$CAL_REFERER[2]) $CAL_REFERER[2]="index.php?site=cal.php";
					$CAL_REFERER[0]=$L->getTempLink();

					require_once('lib/cal/class_ViewDayGui.php');
					$ContGui=new ViewDayGui();
					if ($Gui=$ContGui->process()) {
						$t->assign('TPL_CAL',$Gui->process());
					} else {
						$t->assign('TPL_CAL','');
					}
				break;
				case 'over':
					$t->assign('OVER_ON','on');
					$CAL_REFERER[0]=$L->getTempLink(null,array('_loadSearch'=>1));
					unset($CAL_REFERER[1]);
					require_once('lib/cal/class_ViewFinderGui.php');
					$ContGui=new ViewFinderGui();
					if ($Gui=$ContGui->process()) {
						$t->assign('TPL_CAL',$Gui->process());
					} else {
						$t->assign('TPL_CAL','');
					}
				break;
				case 'event':
					$t->define (array('tpl_cal' => "view_event.inc.html"));
					require("cal/view_event.php");
					$t->parse('TPL_CAL','tpl_cal');
				break;
			}
		break;
		case 's':
			$t->assign('S_ON','on');
			$CAL_REFERER[0]=$L->getTempLink(null,array('_loadSearch'=>1));
			require_once('lib/cal/class_CalSearchGui.php');
			$ContGui=new CalSearchGui();
			if ($Gui=$ContGui->process()) {
				$t->assign('TPL_CAL',$Gui->process());
			} else {
				$t->assign('TPL_CAL','');
			}
		break;
		case 't':
			$t->assign('T_ON','on');
			$CAL_REFERER[0]=$L->getTempLink(null,array('_loadSearch'=>1));
			require_once('lib/cal/class_CalTrashGui.php');
			$ContGui=new CalTrashGui();
			if ($Gui=$ContGui->process()) {
				$t->assign('TPL_CAL',$Gui->process());
			} else {
				$t->assign('TPL_CAL','');
			}
		break;
		case 'e_new':
		case 'e_list':
			if (!($CAL_PERMS&2)) {
				page_close();
				header("Location:index.php?site=cal.php");
				exit;
			}
			$t->assign('E_ON','on');
			require_once('lib/cal/class_EventEditGui.php');
			$contGui=new EventEditGui();
			$t->assign('TPL_CAL',$contGui->showTplContent());
		break;
		case 'import':
			$t->assign('IMPORT_ON','on');
			require_once('lib/class_TemplateGui.php');
			$TopGui=new TemplateGui('core/common_form.inc.html');

			if ($cal->getCfg('cfg/import')) {
				require_once('lib/cal/class_CalImportGui.php');
				$ContGui=new CalImportGui(array(
					'impRes'=>0,
					'onlyOwner'=>$cal->getUser(),
					'showCategory'=>false,
					'defCategory'=>$frm->getPrefs('cal','cat_id'),
					'showOwner'=>false,
					'defOwner'=>$cal->getUser(),
				));
				$Gui=$ContGui->process();
				if ($Gui) {
					$TopGui->addContent('cont1',$Gui,'CONTENT');
					$TopGui->addContent('faction',$L->getLink(),'FORM_ACTION');
				}
			}
			$t->assign('TPL_CAL',$TopGui->process());

			
		break;
		case 'mai':
			$t->assign('MAI_ON','on');
			require_once('lib/class_TemplateGui.php');
			$TopGui=new TemplateGui('core/common_form.inc.html');

			if ($CAL_PERMS&2) {
				require_once('lib/cal/class_CalMaintenanceGui.php');
				$ContGui=new CalMaintenanceGui();
				$Gui=$ContGui->process();
				if ($Gui) {
					$TopGui->addContent('cont1',$Gui,'CONTENT');
					$TopGui->addContent('faction',$L->getLink(),'FORM_ACTION');
				}
			}
			$t->assign('TPL_CAL',$TopGui->process());
		break;
	}
	if ($CAL_PERMS&2) {
		$t->parse('ROW','menu_new');
		$t->parse('ROW','menu_maintenence');
		if ($cal->getCfg('cfg/import')) {
			$t->parse('ROW','menu_imp');
		}
	}

	if ($E->isError()) {
		$t->unload('tpl_error');
		$t->assign('TPL_ERROR',$E->process());
	}
}
?>
