<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$WBXML_TOKEN=array (
	'SWITCH_PAGE'=>'00',
	'END'=>'01',
	'ENTITY'=>'02',
	'STR_I'=>'03',
	'LITERAL'=>'04',
	'EXT_I_0'=>'40',
	'EXT_I_1'=>'41',
	'EXT_I_2'=>'42',
	'PI'=>'43',
	'LITRAL_C'=>'44',
	'EXT_T_0'=>'80',
	'EXT_T_1'=>'81',
	'EXT_T_2'=>'82',
	'STR_T'=>'83',
	'LITERAL_A'=>'84',
	'EXT_0'=>'C0',
	'EXT_1'=>'C1',
	'EXT_2'=>'C2',
	'OPAQUE'=>'C3',
	'LITERAL_AC'=>'C4',
);

$DTD=array(
	'SyncML'=>'00',
	'MetInf'=>'01',

);

$TABLES['SyncML']=array(
	'Add'=>'05',
	'Alert'=>'06',
	'Archive'=>'07',
	'Atomic'=>'08',
	'Chal'=>'09',
	'Cmd'=>'0A',
	'CmdID'=>'0B',
	'CmdRef'=>'0C',
	'Copy'=>'0D',
	'Cred'=>'0E',
	'Data'=>'0F',
	'Delete'=>'10',
	'Exec'=>'11',
	'Final'=>'12',
	'Get'=>'13',
	'Item'=>'14',
	'Lang'=>'15',
	'LocName'=>'16',
	'LocURI'=>'17',
	'Map'=>'18',
	'MapItem'=>'19',
	'Meta'=>'1A',
	'MsgID'=>'1B',
	'MsgRef'=>'1C',
	'NoResp'=>'1D',
	'NoResults'=>'1E',
	'Put'=>'1F',
	'Replace'=>'20',
	'RespURI'=>'21',
	'Results'=>'22',
	'Search'=>'23',
	'Sequence'=>'24',
	'SessionID'=>'25',
	'SftDel'=>'26',
	'Source'=>'27',
	'SourceRef'=>'28',
	'Status'=>'29',
	'Sync'=>'2A',
	'SyncBody'=>'2B',
	'SyncHdr'=>'2C',
	'SyncML'=>'2D',
	'Target'=>'2E',
	'TargetRef'=>'2F',
	'VerDTD'=>'31',
	'VerProto'=>'32',
	'NumberOfChanges'=>'33',
	'MoreData'=>'34',
	'Field'=>'35',
	'Filter'=>'36',
	'Record'=>'37',
	'FilterType'=>'38',
	'SourceParent'=>'39',
	'TargetParent'=>'3A',
	'Move'=>'3B',
	'Correlator'=>'3C',
);

$TABLES['DevInf']=array(
	'CTCap'=>'05',
	'CTType'=>'06',
	'DataStore'=>'07',
	'DataType'=>'08',
	'DevID'=>'09',
	'DevInf'=>'0A',
	'DevTyp'=>'0B',
	'DisplayName'=>'0C',
	'DSMem'=>'0D',
	'Ext'=>'0E',
	'FwV'=>'0F',
	'HwV'=>'10',
	'Man'=>'11',
	'MaxGUIDSize'=>'12',
	'MaxID'=>'13',
	'MaxMem'=>'14',
	'Mod'=>'15',
	'OEM'=>'16',
	'ParamName'=>'17',
	'PropName'=>'18',
	'Rx'=>'19',
	'RxPref'=>'1A',
	'SharedMem'=>'1B',
	'Size'=>'1C',
	'SourceRef'=>'1D',
	'SwV'=>'1E',
	'SyncCap'=>'1F',
	'SyncType'=>'20',
	'Tx'=>'21',
	'TxPref'=>'22',
	'ValEnum'=>'23',
	'VerCT'=>'24',
	'VerDTD'=>'25',
	'Xnam'=>'26',
	'Xval'=>'27',
	'UTC'=>'28',
	'SupportNumberOfChanges'=>'29',
	'SupportLargeObjs'=>'2A',
	'Property'=>'2B',
	'PropParam'=>'2C',
	'MaxOccur'=>'2D',
	'NoTruncate'=>'2E',
	'Filter-Rx'=>'30',
	'FilterCap'=>'31',
	'FilterKeyword'=>'32',
	'FieldLevel'=>'33',
	'SupportHierarchicalSync'=>'34',
);

$TABLES['MetInf']=array(
	'Anchor'=>'05',
	'EMI'=>'06',
	'Format'=>'07',
	'FreeID'=>'08',
	'FreeMem'=>'09',
	'Last'=>'0A',
	'Mark'=>'0B',
	'MaxMsgSize'=>'0C',
	'Mem'=>'0D',
	'MetInf'=>'0E',
	'Next'=>'0F',
	'NextNonce'=>'10',
	'SharedMem'=>'11',
 	'Size'=>'12',
	'Type'=>'13',
	'Version'=>'14',
	'MaxObjSize'=>'15',
	'FieldLevel'=>'16',
);
?>