<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$l_this="index.php?site=$site&action=$action&mode=$mode";
$t->define (array('application' => "check_install.inc.html"));
require_once('config/list_update.php');
$frm->setFrmCfg($frm->getCfg('global',0,array('cfg/%','ldap/%')));
if ($CFG['USER_CLASS']=='ldap_full') {
	if ($DomainUse) $frm->setDomain(str_replace('_',GE_LDAP_DOMAIN_SEP,$DomainUse));
	$adminUser=$frm->read_user($CFG['SUPERADMIN']);
	$adminGroup=$frm->getAdminGroups($CFG['GROUP_ALL'],true,false);
	if ($_POST['CreateGroup'] && empty($adminGroup)) {
		$groupdata=array();
		$groupdata['gidGroup-e']=$GLOBALS['CFG']['GROUP_ALL'];
		$groupdata['cn']='All';
		if ($myDomainIni['groupDomainSuffix']) $groupdata['cn'].='_'.$myDomainIni['groupDomainSuffix'];
		$groupdata['activGroup-e']=1;
		//debug($groupdata);
		if (!($groupID=$frm->insert_group($groupdata))) {
				$ActionError['server'][]=$frm->getError();
		} else {
			$adminGroup=$frm->getAdminGroups($CFG['GROUP_ALL'],true,false);
		}
	}
	if ($_POST['CreateUser'] && empty($adminUser)) {
		if (!empty($adminGroup)) {
			$userdata=array();
			$userdata["groupe"]=1;
			$userdata["firstname"]=trim('Sysadmin');
			$userdata["lastname"]=trim('Group-e');
			$userdata["username"]='sysadmin';
			if ($myDomainIni['userDomainSuffix']) $userdata['username'].='_'.$myDomainIni['userDomainSuffix'];
			$userdata["password"]='sysadmin';
			$userdata['perms']=0;
			$userdata['uidGroup-e']=$CFG['SUPERADMIN'];
			$userdata['gidnumber']=$adminGroup['gidnumber'];
			//debug($userdata);
			if (!($userID=$frm->insert_user($userdata))) {
				$ActionError['server'][]=$frm->getError();
			} else {
				$adminUser=$frm->read_user($CFG['SUPERADMIN']);
				$frm->insertGroupUsers($adminGroup['gidnumber'],array($adminUser['uidnumber']));
			}
		} else {
			$ActionError['server'][]='Please create first System Group';
		}
	}
	if (extension_loaded('ldap')) {
		$install_check['groupeLdap']['ldap_bind']=array($frm->_bind()?1:0,'notrans||'.$frm->getError());
		if ($install_check['groupeLdap']['ldap_bind'][0]) {
			$adminUser=$frm->read_user($CFG['SUPERADMIN']);
			$install_check['groupeLdap']['System User: '.($adminUser['username']?$adminUser['username']:'sysadmin')]=array(empty($adminUser)?0:1,'btn||CreateUser');
			$install_check['groupeLdap']['System Group: '.($adminGroup['cn']?$adminGroup['cn']:'All')]=array(empty($adminGroup)?0:1,'btn||CreateGroup');
		}
	}
}
foreach ($CFG['MA_LANG'] as $val) {
	$OK=0;
	switch ($val) {
		case "de":
			$test_locale="de_DE";
			if (GE_CHARSET=='UTF-8') {
				$test_locale.='.'.GE_CHARSET;
			} else {
				$test_locale.="@euro";
			}
			if (setlocale(LC_TIME,$test_locale)) {
				$OK=1;
			}
			break;
			break;
		case "it":
			$test_locale="it_IT";
			if (GE_CHARSET=='UTF-8'){
				$test_locale.='.'.GE_CHARSET;
			} else {
				$test_locale.="@euro";
			}
			if (setlocale(LC_TIME,$test_locale)) {
				$OK=1;
			}
			break;
		default:
			$test_locale="en_GB";
			if (GE_CHARSET=='UTF-8') $test_locale.='.'.GE_CHARSET;
			if (setlocale(LC_TIME,$test_locale)) {
				$OK=1;
			}
			break;
	}
	$install_check['Environment']['Locale: '.$test_locale]=array($OK,'notrans||'.'Locale not available');
}
$install_check['Environment']['Dyn Path is writable']=array(is_writable(GE_DYN_PATH)?1:0,'notrans||'.GE_DYN_PATH);

if ($av_apps['email']['enabled']) {
	if (extension_loaded('imap')) {
		$CyrAdm=& $frm->getStaticModul('mail_adm');
		$install_check['groupeMail']['cyrus_login']=array($CyrAdm->imap_login()?1:0,'notrans||'.$CyrAdm->getError());

	}

}
//
//$install_check['phpINI']['php-register_globals']=array(ini_get('register_globals'),'setON');
$install_check['phpINI']['magic_quotes_gpc']=array(ini_get('magic_quotes_gpc')?0:1,'setOFF');
$install_check['phpINI']['magic_quotes_runtime']=array(ini_get('magic_quotes_runtime')?0:1,'setOFF');
$install_check['phpINI']['file_uploads']=array(ini_get('file_uploads')?1:0,'setON');

$install_check['phpINI']['memory_limit']=array(-1,ini_get('memory_limit'));
$install_check['phpINI']['post_max_size']=array(-1,ini_get('post_max_size'));
$install_check['phpINI']['upload_max_filesize']=array(-1,ini_get('upload_max_filesize'));

$install_check['CommandLineTools']['zip']=array(checkExec('zip'),'exeNotInstalled');
$install_check['CommandLineTools']['unzip']=array(checkExec('unzip'),'exeNotInstalled');
$install_check['CommandLineTools']['file']=array(checkExec('file'),'exeNotInstalled');
$install_check['CommandLineTools']['imagemagick']=array(checkExec('convert'),'exeNotInstalled');
if ($av_apps['email']['enabled']) {
	$tnef=$frm->getCFG('mail',0,'cfg/tnef');
	if (!$tnef['cfg/tnef'] || !checkExec($tnef['cfg/tnef'])) {
		$install_check['CommandLineTools']['tnef']=array(0,'exeNotInstalled');
	} else {
		$install_check['CommandLineTools']['tnef']=array(1,'exeNotInstalled');
	}
}

if (extension_loaded('mbstring')) {
	$install_check['phpModules']['php-mbstring']=array(1,'libNotInstalled');
} else {
	$install_check['phpModules']['php-mbstring']=array(0,'libNotInstalled');
}
if (extension_loaded('xml')) {
	$install_check['phpModules']['php-xml']=array(1,'libNotInstalled');
} else {
	$install_check['phpModules']['php-xml']=array(0,'libNotInstalled');
}
if (extension_loaded('calendar')) {
	$install_check['phpModules']['php-calendar']=array(1,'libNotInstalled');
} else {
	$install_check['phpModules']['php-calendar']=array(0,'libNotInstalled');
}

if ($CFG['USER_CLASS']=='ldap_full') {
	if (extension_loaded('ldap')) {
		$install_check['phpModules']['php-ldap']=array(1,'libNotInstalled');
	} else {
		$install_check['phpModules']['php-ldap']=array(0,'libNotInstalled');
	}
	$mknt=$frm->getCFG('global',0,'ldap/%');
	if (!$mknt || !checkExec($mknt['ldap/mkntpwdCommand'])) {
		$install_check['CommandLineTools']['mkntpwd']=array(0,'exeNotInstalled');
	} else {
		$install_check['CommandLineTools']['mkntpwd']=array(1,'exeNotInstalled');
	}
}
if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
	if (extension_loaded('ldap')) {
		$install_check['phpModules']['php-ldap']=array(1,'libNotInstalled');
	} else {
		$install_check['phpModules']['php-ldap']=array(0,'libNotInstalled');
	}
}

if ($av_apps['email']['enabled']) {
	if (extension_loaded('imap')) {
		$install_check['phpModules']['php-imap']=array(1,'libNotInstalled');
	} else {
		$install_check['phpModules']['php-imap']=array(0,'libNotInstalled');
	}
	if (class_exists('tidy')) {
		$install_check['phpModules']['php-tidy']=array(1,'libNotInstalled');
	} else {
		$install_check['phpModules']['php-tidy']=array(0,'libNotInstalled');
	}
}


if ($av_apps['smb']['enabled']) {
	$install_check['CommandLineTools']['smbclient']=array(checkExec('smbclient'),'exeNotInstalled');
	$install_check['CommandLineTools']['smbcacls']=array(checkExec('smbcacls'),'exeNotInstalled');
}
if ($av_apps['asx']['enabled']) {
	if (extension_loaded('curl')) {
		$install_check['phpModules']['php-curl']=array(1,'libNotInstalled');
	} else {
		$install_check['phpModules']['php-curl']=array(0,'libNotInstalled');
	}
}

foreach ($install_check as $block=>$check) {
	$t->clear_dynamic('check_row');
	$t->assign('TITLE',$T->lang('[['.$block.']]'));
	foreach ($check as $key=>$val) {
		$t->assign('COL1',$key);
		if ($val[0]) {
			if ($val[0]==-1) {
				$t->assign('COL2','');
				$t->assign('COL3',$val[1]);
			} else {
				$t->assign('COL2','<span style="color:#008A00">'.$T->lang('[[OK]]').'</span>');
				$t->assign('COL3','');
			}
		} else {
			$t->assign('COL2','<span style="color:#ff0000">'.$T->lang('[[BAD]]').'</span>');
			if (strpos($val[1],'||')) {
				$tmp=explode('||',$val[1]);
				switch ($tmp[0]) {
					case 'notrans':
						$t->assign('COL3',$tmp[1]);
					break;
					case 'btn':
						$btn='<input type="submit" name="'.$tmp[1].'" value="'.$T->lang('[['.trim($tmp[1]).']]').'" />';
						$t->assign('COL3',$btn);
					break;
					default:
						$t->assign('COL3',$T->lang('[['.$tmp[1].']]'));
					break;
				}
			} else {
				$t->assign('COL3',$T->lang('[['.$val[1].']]'));
			}
		}

		$t->parse('ROW','.check_row');
	}
	$t->parse('ROW','.check_block');
}
$t->assign('FORM_ACTION',$l_this);

//debug($install_check);

function checkExec($exec) {
	exec($exec,$result,$return);
	if ($return==127) return 0; else return 1;
}
?>
