<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
if ($app["email"]) {
	$Mail=& $frm->getStaticModul('mail');
	$uaccess_ids=$Mail->listUserAccess($auth->auth['uid']);
	if ($uaccess_ids && $MACC_ID && $MACC_ID!=$auth->auth['uid'] && in_array($MACC_ID,$uaccess_ids)) {
		$tmp=$frm->read_user($MACC_ID);
		$username=$tmp['username'];
		$password=$tmp['password'];
		$user_id=$MACC_ID;
	} else {
		$username=$auth->auth['uname'];
		$password=$auth->auth['password'];
		$user_id=$auth->auth['uid'];
	}
	$Mail->setUser($user_id);
	$Mail->setUserName($username);
	$Mail->setPassword($password);
	if ($img) {
		if (preg_match('/htmlImg\//',$img)) {
			$file=$Mail->getAttachPath()."/htmlImg/".basename($img);
		} else {
			$file=$Mail->getAttachPath()."/".basename($img);
		}
		//debug($file);

		if (file_exists($file) && $info=getimagesize($file)) {
			switch ($info[2]) {
				case 1: $ext='image/gif';
					break;
				case 2: $ext='image/jpeg';
					break;
				case 3: $ext='image/png';
					break;
				default:
					exit;
			}
			header ("Content-type:$ext");
			readfile($file);
			exit;
		}
	} elseif($mime && $mid && $part && $enc) {
		$Mail->open();
		if ($Mail->isOpen()) {
			if ($_GET['thumb']) {
				$tmpImg=tempnam(Framework::getTempPath(),'img');
				$ext=$Mail->getMimeExtension($mime);
				unlink($tmpImg);
				$params='';
				//$params='-limit memory 32 -limit map 64 -limit area 10 -limit disk 500';
				if ($ext=='pdf') {
					$destImg=$tmpImg.'.gif';
					$tmpImg=$tmpImg.'.'.$ext;
					$params.=" -density '50x50' -trim +repage -geometry '300x>'   ";
					$fadd='[0]';
					$mime='image/gif';
				} else {
					if ($ext!='gif' && $ext!='png') {
						$destImg=$tmpImg.'.jpg';
						$mime='image/jpeg';
						$params.='-quality 85 ';
					} else {
						$destImg=$tmpImg.'.'.$ext;
					}
					$tmpImg=$tmpImg.'.'.$ext;
					$params.=" -resize '300x>'  +profile '*' -colorspace 'RGB'";
					$fadd='[0]';
				}
				$fp=fopen($tmpImg,'w+');
				fwrite($fp,$Mail->getAttachment($mbox, $mid, $part,$enc));
				fclose($fp);

				$exec='convert  '.$params.' '.$tmpImg.$fadd.' '.$destImg;
				//echo $exec.'<br>';
				exec($exec,$res);
				//debug($res);
				if (file_exists($destImg)) {
					header("Content-type:$mime");
					readfile($destImg);
					if ($destImg!=$tmpImg) unlink($destImg);
				}
				unlink($tmpImg);
			} else {
				header("Content-type:$mime");
				echo $Mail->getAttachment($mbox, $mid, $part,$enc);
			}
		}
	}
}
page_close();
exit;
?>
