<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if ($pre["global"]['lay']) $t->define (array('tpl_layer' => "layers.inc.html"));
$img_parent= "tree_expand.gif";
if (!$obj || !$obj->getAcl(1)) {
	header("Location:index.php?site=$site");
	exit;
}
$ID=$obj->getID();

$l_this="index.php?site=$site&action=$action&mode=$mode&oid=$oid&new=$new&edit=$edit";
$t->assign('FORM_ACTION',$l_this);
$t->assign('L_THIS',$l_this);

$use_limit=false;
if ($rootObj->getMeta('System')=='d') {
	if ($parse) $t->parse('ROW','obj_action');
	$search_sql="RootID IN (".implode(',',$db->escape(array_keys($root_obj))).")";
	switch ($mode) {
		case 'fav':
			$search_sql.=" AND Trash=0 AND Favorite=1";
			$limit=0;
		break;
		case 'last':
			$search_sql.=" AND Trash=0 AND DocType='ext' AND TimeDl!=0";
			$order="TimeDl DESC";
			$limit=20;
		break;
		case 'new':
			$search_sql.=" AND Trash=0 AND DocType='ext'";
			$order="TimeCreate DESC";
			$limit=20;
		break;
		case 'used':
			$search_sql.=" AND Trash=0 AND DocType='ext' AND Counter!=0";
			$order="Counter DESC";
			$limit=20;
		break;
		default:
			$t->assign('LIST_SORT',$sort);
			$search_sql.=" AND Trash=0 AND DocType='ext' AND Title_".$session_lang." LIKE '".addslashes($sort)."%'";
			$limit=20;
			$use_limit=true;
			$mode='all';
		break;
	}
	$t->parse('ROW','title_'.$mode);

	$edit=0;$new=0;
} else {

	if ($new) {
		$t->parse('ROW','title_cat_new');
		$new_obj=new FObj_fol();
		$new_obj->setMeta('DocType','fol');
		$new_obj->setParentMeta('ParentID',$obj->getID());
		$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
		$new_obj->setAcl(-1);
		$edit=1;
	} else {
		$new_obj=$obj;
		if ($edit) {
			$t->parse('ROW','title_cat_edit');
		} else {
			$t->parse('ROW','title_cat');
		}
	}

	$meta_action=$frm->getObjAction($Fmng->getModul(),'e_'.$new_obj->getActionMode(0));

	$p_update=false;

	if ($edit && $Fmng->isAllowedAction($new_obj,$meta_action['e|title'])) {
		$tmp_name=$new_obj->getMeta('Title_'.$session_lang);
		if (!isset($meta_save_x)) $ObjLang=1;
		if ($Fmng->isAllowedAction($new_obj,$meta_action['e|title_lang'])) {
			$lang_array=$CFG['MA_LANG'];
		} else {
			$lang_array=array($session_lang);
		}
		foreach ($lang_array as $val) {
			$txt_title=new TextField("ObjTitle_$val",'size="30" class="sel" style="width:300px"','0','%',$new_obj->getMeta('Title_'.$val));
			if ($val==$session_lang) {
				$t->assign('OBJ_TITLE',$txt_title->f());
				$t->assign('OBJ_TITLE_LANG',strtoupper($val));
				if ($ActionError['fields']["ObjTitle_$val"]) {
					$t->assign('C_TITLE','error');
				} else {
					$t->assign('C_TITLE','');
				}
				$t->assign('FOCUS_FIELD',"ObjTitle_$val");
			} else {
				if (isset($_POST["ObjTitle_$val"]) && $_POST["ObjTitle_$val"]!=$tmp_name) $ObjLang=0;
				if ($new_obj->getMeta('Title_'.$val)!=$tmp_name) $ObjLang=0;
				$t->assign('OBJ_TITLE_A',$txt_title->f());
				$t->assign('OBJ_TITLE_LANG_A',strtoupper($val));
				if ($ActionError['fields']["ObjTitle_$val"]) {
					$t->assign('C_TITLE_A','error');
				} else {
					$t->assign('C_TITLE_A','');
				}
				$t->parse('ROW','.obj_lang');
			}
		}
		if (count($lang_array)>1) {
			$chk_lang=new CheckBox('ObjLang','',1);
			$t->assign('CHK_OBJ_LANG',$chk_lang->f());
			$t->parse('ROW','obj_lang_one');
		}
		$p_update=true;
	} else {
		$t->assign('OBJ_TITLE','<div class="disable" style="width:300px">'.FrameWork::entities($new_obj->getName($session_lang)).'&nbsp;</div>');
		$t->assign('OBJ_TITLE_LANG',strtoupper($session_lang));
	}

	if (!$edit && $Fmng->isAllowedAction($new_obj,$meta_action['e|upload'])) {
		$txt_title=new TextField("FObjTitle",'size="30" class="sel" style="width:300px"','0','%',$FObjTitle);
		$t->assign('F_OBJ_TITLE',$txt_title->f());
		$txt_text=new TextArea("FObjText",'cols="30" rows="5" class="sel" style="width:300px"','0','%',$FObjText);
		$t->assign('F_OBJ_TEXT',$txt_text->f());
		$chk_fav=new CheckBox ('FavInsert','',1);
		$t->assign('CHK_FAV',$chk_fav->f(1));
		$t->parse('ROW','upload_box');
	}
	if ($new_obj->getMeta('TimeModify')) {
		$t->assign('OBJ_TIME_MODIFY',date('d.m.Y H:i',$new_obj->getMeta('TimeModify')));
	} else {
		$t->assign('OBJ_TIME_MODIFY','-');
	}

	if ($new_obj->getMeta('UserModify')) {
		if (!isset($all_user[$new_obj->getMeta('UserModify')])) {
			$temp=$frm->getFullName($new_obj->getMeta('UserModify'),1,1);
			$all_user[$new_obj->getMeta('UserModify')]=$temp[$new_obj->getMeta('UserModify')];
		}
		$t->assign('OBJ_USER_MODIFY',FrameWork::entities($all_user[$new_obj->getMeta('UserModify')]));
	} else {
		$t->assign('OBJ_USER_MODIFY','-');
	}
	$t->parse('ROW','last_modify');


	if ($p_update) {
		$t->parse('ROW','update');
	}

	if ($edit || $new) {
		$t->assign('L_BREAK',"index.php?site=$site&action=$action&oid=".$obj->getID());
		$t->parse('ROW','break');
	}

	$parse=false;
	if (!$new && !$edit) {
		$obj_action=$frm->getObjAction($Fmng->getModul(),$new_obj->getActionMode(0));
		foreach ($obj_action as $key=>$val) {
			if (!$val['Hidden'] && $Fmng->isAllowedAction($new_obj,$val)) {
				$t->assign('SEL_VAL',$key);
				$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
				$t->parse('ROW','.obj_action_val');
				$parse=true;
			}
		}
		if ($parse) $t->parse('ROW','obj_action');

	}
	if (!$new) $t->parse('ROW','public_box');

	$search_sql=" Trash=0 AND ParentID=".$db->escape($obj->getID());
	$limit=0;
	if ($edit || $new) $t->parse('ROW','meta_object');
	$t->parse('ROW','edit_object');
	$mode='';

}
if (!$edit) {

	require_once 'lib/fmng/class_FmngGui.php';
	$Gui=new FmngGui();
	$Gui->setObj($obj);
	$listGui=$Gui->getFolderContent($search_sql,$mode);
	$t->assign('LIST_CONTENT',$listGui->process());
	$t->parse("ROW","list_content");
}


if ($pre['global']['lay']) $t->parse("TPL_LAYERS","tpl_layer"); else
$t->assign("TPL_LAYERS","");

?>
