<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
if ($auth->auth['uid']==$CFG['SUPERADMIN']) {
	$sadmin=1;
} else {
	$sadmin=0;
}
if($oid && $mid) {
	$Mail=$frm->getStaticModul('mail');
	$uaccess_ids=$Mail->listUserAccess($auth->auth['uid']);
	if ($uaccess_ids && $MACC_ID && $MACC_ID!=$auth->auth['uid'] && in_array($MACC_ID,$uaccess_ids)) {
		$tmp=$frm->read_user($MACC_ID);
		$username=$tmp['username'];
		$password=$tmp['password'];
		$user_id=$MACC_ID;
	} else {
		$username=$auth->auth['uname'];
		$password=$auth->auth['password'];
		$user_id=$auth->auth['uid'];
	}
	$Mail->setUser($user_id);
	$Mail->setUserName($username);
	$Mail->setPassword($password);

	require("lib/mail/classMailDecode.php");
	$MDec=new MailDecode($Mail);

	$Mail->open();
	if ($Mail->isOpen()) {
		$obj=$Mail->getObj($oid);
		$Mobj=$Mail->getMailObj($obj->getBox(),$mid);
		if (is_object($Mobj)) {
			$mbox=$obj->getBox();
			$bodyar=$MDec->getBody($obj->getBox(),$Mobj,0);

			$cid=array();
			if($bodyar['att']){
				foreach($bodyar['att'] as $var){
					if ($var['id']) {
						$cid[preg_replace('/[<>]/','',$var['id'])]=array('part'=>$var['part'],'type'=>$var['type'],'enc'=>$var['enc']);
					}
				}
			}
			//debug($cid);

			if(isset($bodyar['html'])) {
				$matches=array();
				if (preg_match('/<\s*base\s*href=["]?([^">]+)[\/]?["]?[^>]*>/i',$bodyar['html'],$matches)) {
					//debug(htmlspecialchars($bodyar['html']));
					$bodyar['html'] = preg_replace('#(href|src)="([^:"]*)("|(?:(?:%20|\s|\+)[^"]*"))#','$1="'.$matches[1].'/$2$3',$bodyar['html']);
					//debug(htmlspecialchars($bodyar['html']));
				}
				if (count($cid)) {
					$bodyar['html']=preg_replace('/(src|background)=["]?cid:([^"> ]+)["]?/sie','"\\1=\"fetch_mail_img.php?mbox=".urlencode($mbox)."&mid=".$mid."&part=".urlencode($cid[\'\\2\']["part"])."&enc=".urlencode($cid[\'\\2\']["enc"])."&mime=".urlencode($cid[\'\\2\']["type"])."\""',$bodyar['html']);
					$bodyar['html']=preg_replace('/url[(]["\' ]*cid:([^)"\' ]+)["\' ]*[)]/sie','"url(\'fetch_mail_img.php?mbox=".urlencode($mbox)."&mid=".$mid."&part=".urlencode($cid[\'\\1\']["part"])."&enc=".urlencode($cid[\'\\1\']["enc"])."&mime=".urlencode($cid[\'\\1\']["type"])."\')"',$bodyar['html']);
				}
				$bodyar['html']=preg_replace('/<\s*base\s*[^>]*>/i',"",$bodyar['html']);
				$header="<head>\n<base target=\"_blank\">\n";
				$header.="<style>\n";
				$header.="blockquote {border-left:2px solid #00F;margin-left:10px;padding-left:5px;}\n";
				$header.="p {margin:0;padding:0;}\n";
				$header.="img {max-width:100%;}\n";
				$header.="</style>\n";
				if (preg_match('/<\s*head\s*>/i',$bodyar['html'])) {
					$bodyar['html']=preg_replace('/<\s*head\s*>/i',$header,$bodyar['html']);
				} else {
					$bodyar['html']=$header.'</head>'.$bodyar['html'];
				}
				if ($bodyar['status']) {
					if (preg_match('/<\s*body\s*>/i',$bodyar['html'])) {
						$bodyar['html']=preg_replace('/<\s*body\s*>/i','<body><br>'.nl2br($bodyar['report_txt'].'<br><hr><br>'.$bodyar['status']).'<br><hr><br>',$bodyar['html']);
					} else {
						$bodyar['html']=preg_replace('/<\s*\/head\s*>/i','</head><body><br>'.nl2br($bodyar['report_txt'].'<br><hr><br>'.$bodyar['status']).'<br><hr><br>',$bodyar['html']);
					}
				}
				$html_charset=$Mail->getHtmlCharset($bodyar['html'],$bodyar['html_charset']);
				header('Content-Type: text/html; charset='.$html_charset);
				echo $bodyar['html'];
			}
		}
	}
}
page_close();
?>
