<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

$t->assign('MOD_TITLE',$frm->getAppName('imng'));
if (!$app["imng"]) {
	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
} else {
	$user_id=$auth->auth['uid'];
	require_once('lib/imng/header.php');
	require_once('lib/bmng/header.php');
	$t->setRoot("tpl/$THEME/imng/$session_lang");
	$t->define (array('application' => "header.inc.html"));
	$T->loadModul('imng');
	$obj=false;
	$ActionError=false;
	$root_id=0;
	$root_obj=array();
	$root_ids=array();

	$root_obj_d=$Imng->getSystemObj('d','00',true);
	if (is_object($root_obj_d)) {
		$root_obj[$root_obj_d->getID()]=$root_obj_d;
		$root_ids[]=$root_obj_d->getID();
	}

	$root_obj_s=$Imng->getSystemObj('s','00',true);
	if (is_object($root_obj_s)) {
		$root_obj[$root_obj_s->getID()]=$root_obj_s;
		$root_ids[]=$root_obj_s->getID();
	}
	$oid=Framework::getParam('oid');
	if ($oid) {
		$obj=$Imng->getObj($oid);
		if (is_object($obj)) {
			$root_id=$obj->getParentMeta('RootID');
		}
	}

	if (!$root_id || !in_array($root_id,$root_ids)) {
		$oid=$root_id=key($root_obj);
		$obj=$Imng->getObj($oid);
	}
	if (!isset($BL)) $sess->register('BL');
	if (is_object($obj) && $obj->getParentMeta('LangID')!='00') {
		$BL=$obj->getParentMeta('LangID');
	}
	if ($LangID) $BL=$LangID;
	if (!in_array($BL,$Imng->getAvLang())) {
		if (in_array($session_lang,$Imng->getAvLang())) {
			$BL=$session_lang;
		} else {
			$BL=reset($Imng->getAvLang());
		}
	}
	if (!$BL) $BL=$session_lang;
	$Imng->setLangID($BL);
	$rootObj=$root_obj[$root_id];


	if (!is_object($rootObj) || !is_object($obj) || !$obj->getAcl(1)) {
		$t->assign('TPL_ERROR','');
		$t->define (array('tpl_card' => "no_perms.inc.html"));
		$t->parse('TPL_CARD','tpl_card');
	} else {
		$Imng->setPublic(1);
		foreach ($Imng->getAvLang() as $val) {
			if (is_object($root_obj_s)) {
				$t->assign('LANG_URL',"index.php?site=$site&oid=".$root_obj_s->getID()."&LangID=".$val);
				if ($BL==$val) {
					$t->assign('LANG_NAME','<strong>'.strtoupper($val).'</strong>');
				} else {
					$t->assign('LANG_NAME',strtoupper($val));
				}
				$t->parse('ROW','.root_lang');
			}
		}
		if ($Imng->getPerms(2)) {
			$t->parse('ROW','root_rimng');
		}
		$t->assign('L_A_NAVBAR',"index.php?site=$site&action=b&mode=all");
		$nav_array=array_merge(range('A', 'Z'),range('0', '9'));
		foreach ($nav_array as $val) {
			$t->assign('L_NAVBAR',"index.php?site=$site&action=b&mode=all&sort=$val");
			if ($mode=='all' && $sort==$val) {
				$t->assign('N_NAVBAR','<strong>'.$val.'</strong>');
			} else {
				$t->assign('N_NAVBAR',$val);
			}
			$t->parse('ROW','.navbar_row');
		}
		$t->parse('ROW','navbar');

		//if (!$mode) $mode='fav';
		$Imng->setMode($mode);
		$Imng->setRootObj($rootObj);
		$xmlFastText->setStyle($Imng->getBlackStyles(0),0);
		$xmlFastText->setImgClass($Bmng);
		$frm->setStyleSheet('0_style.css');
		if ($pre["global"]['js']) $t->parse("ROW","conf_delete");

		$action=Framework::getParam('action',$obj->getAction(0));
		$L_THIS="index.php?site=$site&action=$action&oid=$oid";
		$Imng->setClipboard('iobj',$frm->getClipboard('iobj'));

		if ($obj_action_x && $obj_action_val) {
			require ('lib/imng/func_Action.php');
			require ('lib/imng/inc_P_ActionObject.php');
		} elseif ($list_action_x && $list_action_val) {
			require ('lib/imng/func_Action.php');
			require ('lib/imng/inc_P_ActionList.php');
		}

		foreach ($root_obj as $val) {
			$t->assign('M_IMG',$val->getImage(0));
			$t->assign('M_NAME',FrameWork::entities($val->getName()));
			$t->assign('M_URL',"index.php?site=$site&oid=".$val->getID());
			if ($action!='esc' && $action!='esc_v' && $root_id==$val->getID()) {
				$t->assign('M_ON','on');
			} else {
				$t->assign('M_ON','off');
			}
			$t->parse('ROW','.root_header_'.$val->getMeta('System'));
		}

		if ($Imng->isRuleUser()) {
			$t->assign('ESC_URL',"index.php?site=$site&action=esc");
			if ($action=='esc' || $action=='esc_v') {
				$t->assign('ESC_ON','on');
			} else {
				$t->assign('ESC_ON','off');
			}

			$t->parse('ROW','.root_header_esc');
		}

		$obj_tree=$Imng->getObjTree($oid);
		$tmp_tree='';
		if (is_array($obj_tree)) {
			foreach ($obj_tree as $key=>$val) {
				$tmp_tree="<a href=\"index.php?site=$site&oid=$key\">".FrameWork::entities($val).'</a>/'.$tmp_tree;
			}
		}
		$t->assign('OBJ_TREE',$tmp_tree);
		$t->assign('OBJ_NAME',FrameWork::entities($obj->getName()));

		if ($action=="b" || $action=="vo" || $action=="wd" || $action=="esc" || $action=="esc_v") {
			require("lib/imng/class_ListImngGui.php");
			$ContGui=new ListImngGui($obj);
			if ($Gui=$ContGui->process()) {
				$t->assign('TPL_CARD',$Gui->process());
			} else {
				$t->assign('TPL_CARD','');
			}
		}

		/*if ($action=="vo" || $action=="wd") {
			$t->define (array('tpl_card' => "vview_content.inc.html"));
			require("lib/class_form.inc.php");
			require("imng/vbrowse_list_js.php");
			require("imng/vview_content.php");
			$t->parse('TPL_CARD','tpl_card');
		}*/

		if ($action=="s") {
			$t->define (array('tpl_card' => "vsearch.inc.html"));
			require("lib/class_form.inc.php");
			require("imng/vsearch.php");
			$t->parse('TPL_CARD','tpl_card');
		}

		$t->assign('T_S_ACTION',"index.php?site=$site&action=s");

		if ($E->isError()) {
			$t->unload('tpl_error');
			$t->assign('TPL_ERROR',$E->process());
		} elseif ($ActionError) {
			require('imng/view_error.php');
		}

	}
}
?>
