<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$img_parent= "tree_expand.gif";
if (!$obj || !$obj->getAcl(1)) {
	header("Location:index.php?site=$site");
	exit;
}
$t->define (array('tpl_table' => "browse_imng_table.inc.html"));
if ($pre["global"]['lay']) $t->define (array('tpl_layer' => "layers.inc.html"));

$ID=$obj->getID();

$l_this="index.php?site=$site&action=$action&oid=$oid";
$t->assign('FORM_ACTION',$l_this);
$t->assign('L_THIS',$l_this);

if ($Imng->getCfg('cfg/list_apps/'.$rootObj->getMeta('System'))) {
	$list_apps=explode(',',$Imng->getCfg('cfg/list_apps/'.$rootObj->getMeta('System')));
} else {
	$list_apps=0;
}

$av_modes=array('mod','mynew','new','sint','sexp','esc');
foreach ($av_modes as $mode) {
	$order='';
	$use_limit=false;
	$search_sql="System=''";
	switch ($mode) {
		case 'mod':
			$search_sql.=" AND Trash=0 AND UserModify=".$db->escape($user_id);
			$order="TimeModify DESC";
			$limit=5;
			//$use_limit=true;
		break;
		case 'mynew':
			$search_sql.=" AND Trash=0 AND UserCreate=".$db->escape($user_id);
			$order="TimeCreate DESC";
			$limit=5;
		break;
		case 'new':
			$search_sql.=" AND Trash=0";
			$order="TimeCreate DESC";
			$limit=5;
		break;
		case 'sint':
			$search_sql.=" AND Trash=0 AND Publish=0 ";
			$limit=5;
		break;
		case 'sexp':
			$search_sql.=" AND Trash=0 AND Publish=1 AND (PublishEnd<".time()." AND PublishEnd>0)";
			$limit=5;
		break;
		case 'esc':
			$search_sql.=" AND Trash=0 AND DocType='doc'";
			$search_sql.=" AND EscalationUsers!='' AND EscalationGroups !='' AND (EscalationUsers!='||' OR  EscalationGroups !='||')";
			$order="TimeModify DESC";
			$limit=5;
		break;
	}


	if ($order) {
		$order.=','.'Title_'.$Imng->getLangID().' ASC';;
	} else {
		$order='Title_'.$Imng->getLangID().' ASC';
	}

	$rows=0;$b=0;
	$ftree=$Imng->searchObj($rows,$b,$limit,$search_sql,$order,$use_limit);
	$num_entrys=count($ftree);
	if ($num_entrys) {
		$ac_link="index.php?site=$site";
		foreach ($ftree as $key=>$val) {
			$lid=$val->getID();

			$link=$ac_link."&action=".$val->getAction(0)."&oid=".$lid;
			if ($val->getACL(2)) {
				$link_d=$ac_link."&action=".$val->getAction(1)."&oid=".$lid;
			} else {
				$link_d="#";
			}
			$t->assign('LIST_OBJ_ID',$mode.$lid);
			$t->assign("LIST_IMG",$val->getImage(0));
			$t->assign("L_LIST_IMG",$link_d);
			$t->assign("L_LIST_ITEM",$link);
			$t->assign("LIST_ITEM",FrameWork::entities($val->getName()));
	//debug($val);
			if (!isset($all_user[$val->getMeta('UserCreate')])) {
				$temp=$frm->getFullName($val->getMeta('UserCreate'),1,1);
				$all_user[$val->getMeta('UserCreate')]=$temp[$val->getMeta('UserCreate')];
			}
			$t->assign('LIST_USER_CREATE',FrameWork::entities($all_user[$val->getMeta('UserCreate')]));

			if ($val->getMeta('TimeCreate')) {
				$t->assign('LIST_TIME_CREATE',date('d.m.Y',$val->getMeta('TimeCreate')));
			} else {
				$t->assign('LIST_TIME_CREATE','-');
			}

			if (!isset($all_user[$val->getMeta('UserModify')])) {
				$temp=$frm->getFullName($val->getMeta('UserModify'),1,1);
				$all_user[$val->getMeta('UserModify')]=$temp[$val->getMeta('UserModify')];
			}
			$t->assign('LIST_USER_MODIFY',FrameWork::entities($all_user[$val->getMeta('UserModify')]));

			if ($val->getMeta('TimeModify')) {
				$t->assign('LIST_TIME_MODIFY',date('d.m.Y',$val->getMeta('TimeModify')));
			} else {
				$t->assign('LIST_TIME_MODIFY','-');
			}

			if (!$val->isFolder() && $pre["global"]['lay']) {
				$div_row=0;
				if (trim($val->getMeta('Text'))) {
					$t->assign("DIV_DESC",Framework::entities($val->getMeta('Text')));
					$t->parse("ROW","div_desc");
					$div_row=1;
				} else {
					$t->clear_dynamic('div_desc');
				}
				if ($div_row) {
					$t->assign('LAY_LINK'," onMouseOver=\"show(event, 'fk_$key'); return true;\" onMouseOut=\"hide('fk_$key'); return true;\"");
					$t->assign("DIV_ID","fk_$key");
					$t->parse("ROW",".div_row");
				} else {
					$t->assign('LAY_LINK','');
				}
			} else {
				$t->assign('LAY_LINK','');
			}

			if ($val->isFolder()) {
				if ($j%2) $t->assign("ROW_COLOR",$bgcolor); else  $t->assign("ROW_COLOR","#f2f2f2");
				$t->parse("ROW",".folder_row");
				$j++;

			} else {
				if ($i%2) $t->assign("ROW_COLOR",$bgcolor); else  $t->assign("ROW_COLOR","#f2f2f2");
				$t->parse("ROW",".file_row");
				$i++;
			}

		}

		$t->parse('ROW','title_'.$mode);

		$t->parse('TPL_TABLE','tpl_table');
		$t->parse('ROW','.table_row');
		$t->clear_dynamic('title_'.$mode);
		$t->clear_dynamic('folder_row');
		$t->clear_dynamic('file_row');
		$t->unsetkey('tpl_table');
	} else {


	}



}

if ($pre['global']['lay']) $t->parse("TPL_LAYERS","tpl_layer"); else
$t->assign("TPL_LAYERS","");

?>
