<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if (!$obj || !$obj->getAcl(1)) {
	header("Location:index.php?site=$site");
	exit;
}
$ID=$obj->getID();
$tmp_path=Framework::getTempPath();
$fmng_root=0;
if ($Fmng->getPerms(2)) {
	$fmng_root_obj_s=$Fmng->getSystemObj('s',$session_lang,0,true);
	if (is_object($fmng_root_obj_s)) {
		$fmng_root=$fmng_root_obj_s->getID();
	}
}
if ($import_save_x) {
	if ($ImpFile && file_exists("$tmp_path/".basename($ImpFile).'/MetaObj.xml')) {
		unset($b_obj,$f_obj);
		if ($b_oid) {
			$b_obj=$Bmng->getObj($b_oid);
		}
		if ($f_oid) {
			$f_obj=$Fmng->getObj($f_oid);
		}
		$imp_path="$tmp_path/".basename($ImpFile);
		if (!is_object($f_obj) || $f_obj->getAcl(2)) {
			$new_obj=new IObj_doc();
			$new_obj->setMeta('DocType','doc');
			$new_obj->setMeta('MenuImage','doc.gif');
			$new_obj->setParentMeta('ParentID',$obj->getID());
			$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
			$new_obj->setParentMeta('LangID',$Imng->getLangID());
			if (trim($_POST['ObjTitle'])) {
				foreach ($CFG['AV_LANG'] as $val) {
					$new_obj->setMeta('Title_'.$val,trim($_POST['ObjTitle']));
				}
			} else {
				foreach ($CFG['AV_LANG'] as $val) {
					$new_obj->setMeta('Title_'.$val,'No Name');
				}
			}
			$new_obj->setMeta('Text',trim($_POST['Text']));
			$new_obj->setMeta('Version',1);
			$new_obj->setMeta('TimeCreate',time());
			$new_obj->setMeta('TimeModify',time());
			$new_obj->setMeta('UserCreate',$user_id);
			$new_obj->setMeta('UserModify',$user_id);
			$new_obj->setMeta('Users',$obj->getMeta('Users'));
			$new_obj->setMeta('Groups',$obj->getMeta('Groups'));
			$new_obj->setParentMeta('ParentID',$obj->getID());
			$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
			if ($Imng->insertMeta($new_obj)) {
				$Imng->insertParentMeta($new_obj);

				if (file_exists($imp_path.'/WebObj.xml')) {
					$meta=new Xml();
					$res=array();
					$from_chr=GE_CHARSET;
					$content=file($imp_path.'/MetaObj.xml');
					if (preg_match('/<?.*encoding="([^"]+)".*?>/i',$content[0],$res) && strtoupper($res[1])!=GE_CHARSET) $from_chr=$res[1];
					$meta->parseText(Framework::convertCharset(implode('',$content),$from_chr,GE_CHARSET),true);

					$res=array();
					$from_chr=GE_CHARSET;
					$content=file($imp_path.'/WebObj.xml');
					if (preg_match('/<?.*encoding="([^"]+)".*?>/i',$content[0],$res) && strtoupper($res[1])!=GE_CHARSET) $from_chr=$res[1];
					$xml->parseText(Framework::convertCharset(implode('',$content),$from_chr,GE_CHARSET),true);
					$recode_img=array();
					$recode_file=array();

					foreach ($meta->get_children(0) as $child) {
						//debug($child);
						switch($child->get_name()) {
							case 'Images':
								if ($child->children_len()) {
									foreach ($child->get_children() as $image) {
										unset($imgObj);
										if ($imgID=$Bmng->getID_Md5(Framework::getMd5Sum($imp_path.'/img/'.$image->get_attribs('url')))) {
											$imgObj=$Bmng->getObj($imgID);
										} else {
											$imgObj=$Bmng->saveImage($b_obj,$imp_path.'/img/'.$image->get_attribs('url'),$image->get_data());
										}
										if (is_object($imgObj)) {
											$recode_img[$image->get_attribs('url')]=$imgObj->getMeta('Content');
										}
									}
								}
							break;
							case 'Files':
								if ($child->children_len()) {
									foreach ($child->get_children() as $file) {
										unset($filObj);
										$fileIDs=$Fmng->getID_Md5($file->get_attribs('md5'));
										if ($fileIDs) {
											foreach ($fileIDs as $fileID) {
												$tmp=$Fmng->getLinkedObj($fileID,true);
												foreach ($tmp as $tmp_obj) {
													if($tmp_obj->getParentMeta('RootID')==$fmng_root) {
														$filObj=$tmp_obj;
														break;
													}
												}
												if ($filObj) {
													break;
												}
											}
										}

										if (!is_object($filObj) && $f_obj->getAcl(2)) {
											$filObj=new FObj_ext();
											$filObj->setMeta('DocType','ext');
											$filObj->setMeta('MenuImage','other.gif');
											foreach ($CFG['AV_LANG'] as $val) {
												$filObj->setMeta('Title_'.$val,$file->get_data());
											}
											$filObj->setMeta('Version',1);
											$filObj->setMeta('TimeCreate',time());
											$filObj->setMeta('TimeModify',time());
											$filObj->setMeta('UserCreate',$user_id);
											$filObj->setMeta('UserModify',$user_id);
											$filObj->setMeta('Users',$f_obj->getMeta('Users'));
											$filObj->setMeta('Groups',$f_obj->getMeta('Groups'));
											$filObj->setParentMeta('ParentID',$f_obj->getID());
											$filObj->setParentMeta('RootID',$f_obj->getParentMeta('RootID'));
											$filObj->setParentMeta('UserID',$f_obj->getParentMeta('UserID'));
											if ($Fmng->insertMeta($filObj)) {
												$Fmng->insertParentMeta($filObj);
												if (!$Fmng->replaceFile($filObj,$Fmng->getModul(),$filObj->getID(),array('tmp_name'=>$imp_path.'/other/'.$file->get_attribs('url'),'name'=>$file->get_attribs('url')))) {
													$Fmng->updateMeta($filObj);
												}
											}

										}
										if (is_object($filObj)) {
											$recode_file[$file->get_attribs('f_id')]=$filObj->getID();
										} else {
											$recode_file[$file->get_attribs('f_id')]=0;
										}
									}
								}
							break;
						}
					}
					if (!empty($recode_img)) {
						//debug($recode_img);
						$images=$xml->searchNode(0,'image');
						//debug($images);
						foreach ($images as $xml_id) {
							$attrib=$xml->get_attribs($xml_id,'base');
							if (isset($recode_img[$attrib])) {
								$xml->set_attribs($xml_id,array('base'=>$recode_img[$attrib]));
							}
						}
					}
					if (!empty($recode_file)) {
						$files=$xml->searchNode(0,'download');
						foreach ($files as $xml_id) {
							$attrib=$xml->get_attribs($xml_id,'url');
							if (isset($recode_file[$attrib])) {
								$xml->set_attribs($xml_id,array('url'=>$recode_file[$attrib]));
							}
						}
					}
					$new_obj->setMeta('Content',$new_obj->getID());
					$Imng->updateMeta($new_obj);
					$Imng->saveContent($new_obj->getID(),$new_obj->getMeta('Version'),$xml->getText(0,1,"",""));
					$images=$xmlFastText->searchImages($xml->get_node(0));
					$Bmng->deleteImgUsed($xmlFastText->getModul(),$new_obj->getID());
					foreach ($images as $imgFile=>$sizes) {
						if (is_array($sizes)) {
							$sizes=array_unique($sizes);
							foreach ($sizes as $val) {
								$Bmng->insertImgUsed($Bmng->getImgID($imgFile),$xmlFastText->getModul(),$new_obj->getID(),$val,$Bmng->getCfg('ImgPath'));
							}
						}
					}
				}
				$frm->deleteFiles($imp_path,'/.*/',array(),true,true);
				$location="index.php?site=$site&action=".$new_obj->getAction(0)."&oid=".$new_obj->getID();
				page_close();
				header('Location:'.$location);
				exit;
			}
		} else {
			$ActionError['folder_perms']=$f_obj->getName();
		}
		//$frm->deleteFiles("$tmp_path/".basename($ImpFile),'/.*/',array(),true,true);
	} else {
		if ($_FILES['doc_file']['tmp_name'] && is_uploaded_file($_FILES['doc_file']['tmp_name']) && FrameWork::getMimeFile($_FILES['doc_file']['tmp_name'])=="application/x-zip") {
			do {
				$path=$tmp_path.'/'.uniqid('EX');
			} while (file_exists($path));
			if (@mkdir($path,0755)) {
				$exec="unzip ".escapeshellarg($_FILES['doc_file']['tmp_name'])." -d ".escapeshellarg($path);
				exec($exec,$result);
				//debug($result);
				if (file_exists($path.'/MetaObj.xml')) {
					$ImpFile=basename($path);
				} else {
					$ActionError['no_valid_file']=1;
					$frm->deleteFiles($path,'/.*/',array(),true,true);
				}
			}
		} else {
			$ActionError['no_valid_file']=1;
		}
	}
}

$l_this="index.php?site=$site&action=$action&oid=$oid";
if ($ImpFile && file_exists("$tmp_path/".basename($ImpFile).'/MetaObj.xml')) {
	$l_this.="&ImpFile=".urlencode($ImpFile);
	$imp_path="$tmp_path/".basename($ImpFile);
} else {
	unset($ImpFile);
	$imp_path='';
}

$t->assign('FORM_ACTION',$l_this);
$t->assign('L_THIS',$l_this);

$t->parse('ROW','update');

if ($imp_path) {
	$meta=new Xml();
	$res=array();
	$from_chr='ISO-8859-1';
	$content=file($imp_path.'/MetaObj.xml');
	//debug($content);
	if (preg_match('/<?.*encoding="([^"]+)".*?>/i',$content[0],$res) && strtoupper($res[1])!=GE_CHARSET) $from_chr=$res[1];
	$meta->parseText(Framework::convertCharset(implode('',$content),$from_chr,GE_CHARSET),true);
	foreach ($meta->get_children(0) as $child) {
		//debug($child);
		switch($child->get_name()) {
			case 'MenuTitle':
				if (!isset($ObjMenuTitle)) $ObjMenuTitle=htmlspecialchars($child->get_data());
			break;
			case 'Title':
				if (!isset($ObjTitle)) $ObjTitle=htmlspecialchars($child->get_data());
			break;
			case 'Text':
				if (!isset($ObjText)) $ObjText=htmlspecialchars($child->get_data());
			break;
			case 'Images':
				if ($child->children_len()) {
					$all_exists=true;
					foreach ($child->get_children() as $image) {
						$Bmng->_resize($imp_path.'/img/'.$image->get_attribs('url'),$imp_path.'/img/tmp_'.$image->get_attribs('url'),0,$Bmng->getCfg('OrigSize'),0);
						$md5=Framework::getMd5Sum($imp_path.'/img/tmp_'.$image->get_attribs('url'));
						$t->assign('IMG_NAME',Framework::entities($image->get_data()));
						if ($Bmng->getID_Md5($md5)) {
							$t->assign('IMG_EXISTS','X');
						} else {
							$t->assign('IMG_EXISTS','');
							$all_exists=false;
						}
						$t->parse('ROW','.content_images_row');
					}
					if (!$all_exists) {
						require_once('lib/class_ObjSelect.php');
						$b_root_id=0;
						$b_root_obj=$Bmng->ListRoots();
						if ($b_oid) {
							$b_obj=$Bmng->getObj($b_oid);
							if (is_object($b_obj)) {
								$b_root_id=$b_obj->getParentMeta('RootID');
							}
						}
						if (!$b_root_id) {
							$b_obj=$Bmng->getSystemFolderObj();
							if (is_object($b_obj)) {
								$b_oid=$b_obj->getID();
								$b_root_id=$b_obj->getParentMeta('RootID');
							} else {
								$b_oid=$b_root_id=key($b_root_obj);
								$b_obj=$b_root_obj[$b_oid];
							}
						}
						if (is_object($b_obj)) {
      						$b_tree=$Bmng->ListAllTree($b_root_id,'Title','asc','pfol');
							$sel_int=new ObjSelect();
							$sel_int->setTree($b_tree);
							$sel_int->setClass('noption');
							$sel_int->setSelectedID($b_obj->getID());
							$sel_int->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');
							$sel_int->setFolderPrep('');
							$t->assign('TREE_IMG_OPTION',$sel_int->parseSelect($b_root_id));
							$t->parse('ROW','content_images_new');
						}
					}
					$t->parse('ROW','content_images');
				}
			break;
			case 'Files':
				if ($child->children_len()) {
					$all_exists=true;
					foreach ($child->get_children() as $file) {
						$exists=false;
						$t->assign('FILE_NAME',Framework::entities($file->get_data()));
						$fileIDs=$Fmng->getID_Md5($file->get_attribs('md5'));
						if ($fileIDs) {
							foreach ($fileIDs as $fileID) {
								$tmp=$Fmng->getLinkedObj($fileID,true);
								foreach ($tmp as $tmp_obj) {
									if($tmp_obj->getParentMeta('RootID')==$fmng_root) {
										$exists=true;
										break;
									}
								}
								if ($exists) {
									break;
								}
							}
						}
						if ($exists) {
							$t->assign('FILE_EXISTS','X');
						} else {
							$t->assign('FILE_EXISTS','');
							$all_exists=false;
						}
						$t->parse('ROW','.content_files_row');
					}
					if (!$all_exists) {
						require_once('lib/class_ObjSelect.php');
						$tree=$Fmng->ListAllTree($fmng_root,-1,'Title_'.$session_lang,'ASC','fol');
						$sel_int=new ObjSelect();
						$sel_int->setTree($tree);
						$sel_int->setClass('noption');
						$sel_int->setSelectedID($f_oid);
						$sel_int->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');
						$sel_int->setFolderPrep('');
						$t->assign('TREE_FILE_OPTION',$sel_int->parseSelect($fmng_root));
						$t->parse('ROW','content_files_new');
					}
					$t->parse('ROW','content_files');
				}


			break;


		}




	}


	$txt_title=new TextField('ObjTitle','size="30" class="sel" style="width:300px"','0','%',$obj->getMeta('Title'));
	$t->assign('OBJ_TITLE',$txt_title->f());
	$t->assign('OBJ_TITLE_LANG',strtoupper($Imng->getLangID()));
	$txt_desc=new TextArea('ObjText','rows="7" cols="36" class="sel" style="width:300px;"','0','%',$obj->getMeta('Text'));
	$t->assign('OBJ_DESC',$txt_desc->f());

	$t->parse('ROW','file_content');

} else {
	$t->parse('ROW','file_upload');

}
$t->assign('L_BREAK',"index.php?site=$site&oid=".$obj->getID());
$t->parse('ROW','break');

?>
