<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if (!$obj || !$obj->getAcl(1)) {
	header("Location:index.php?site=$site");
	exit;
}
if ($pre["global"]['lay']) $t->define (array('tpl_layer' => "layers.inc.html"));
$ID=$obj->getID();
$l_this="index.php?site=$site&action=$action&oid=$oid&new=$new";
$t->assign('FORM_ACTION',$l_this);

$obj_action=$frm->getObjAction($Imng->getModul(),$obj->getActionMode(0));
if ($new && $Imng->isAllowedAction($obj,$obj_action[$new])) {
	$new_obj=new IObj_doc();
	$new_obj->setMeta('Version',1);
	$new_obj->setMeta('DocType','doc');
	$new_obj->setMeta('MenuImage','doc.gif');
	$new_obj->setParentMeta('ParentID',$obj->getID());
	$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
	$new_obj->setParentMeta('LangID',$Imng->getLangID());
	$new_obj->setMeta('PublishGroups',$obj->getMeta('PublishGroups'));
	$new_obj->setMeta('PublishUsers',$obj->getMeta('PublishUsers'));
	$new_obj->setMeta('Publish',$obj->getMeta('Publish'));
	$new_obj->setMeta('PublishStart',$obj->getMeta('PublishStart'));
	$new_obj->setMeta('PublishEnd',$obj->getMeta('PublishEnd'));
	$new_obj->setMeta('Users',$obj->getMeta('Users'));
	$new_obj->setMeta('Groups',$obj->getMeta('Groups'));


	$new_obj->setAcl(-1);
	$t->parse('ROW','title_new');
} else {
	$new_obj=$obj;
	$t->parse('ROW','title_edit');
}

require_once('lib/imng/class_PublicBoxGui.php');
$box=new PublicBoxGui();

$t->assign('FORM_BOX',$box->process($new_obj));
$t->parse('ROW','form_box');

if (!$new) {
	
	if ($new_obj->getMeta('TimeModify')) {
		$t->assign('OBJ_TIME_MODIFY',date('d.m.Y H:i',$new_obj->getMeta('TimeModify')));
	} else {
		$t->assign('OBJ_TIME_MODIFY','-');
	}
	if ($new_obj->getMeta('UserModify')) {
		if (!isset($all_user[$new_obj->getMeta('UserModify')])) {
			$temp=$frm->getFullName($new_obj->getMeta('UserModify'),1,1);
			$all_user[$new_obj->getMeta('UserModify')]=$temp[$new_obj->getMeta('UserModify')];
		}
		$t->assign('OBJ_USER_MODIFY',FrameWork::entities($all_user[$new_obj->getMeta('UserModify')]));
	} else {
		$t->assign('OBJ_USER_MODIFY','-');
	}

	$t->parse('ROW','last_modify');

	if (!$new_obj->isFolder() && $new_obj->getMeta('Content')!=$new_obj->getID()) {
		$orig_obj=$Imng->getObj($new_obj->getMeta('Content'));
		if (is_object($orig_obj)) {
			$t->assign('ORIG_OBJ_TITLE',Framework::entities($orig_obj->getName()));
			$t->assign("ORIG_OBJ_IMG",$orig_obj->getImage(0));
			$t->assign("L_ORIG_OBJ_IMG","index.php?site=".$orig_obj->getSite()."&oid=".$orig_obj->getID()."&action=".$orig_obj->getAction(1));
			$t->assign("L_ORIG_OBJ_ITEM","index.php?site=".$orig_obj->getSite()."&oid=".$orig_obj->getID());
			if ($pre['global']['lay']) {
				$obj_tree=$Imng->getObjTree($orig_obj->getID(),$orig_obj->getParentMeta('LangID'));
				if (is_array($obj_tree)) {
					$t->assign("DIV_TREE",implode(' / ',array_reverse(FrameWork::entities($obj_tree))));
					$t->parse("ROW","div_tree");
					$t->assign('LAY_LINK'," onMouseOver=\"show(event, 'fk_$key'); return true;\" onMouseOut=\"hide('fk_$key'); return true;\"");
					$t->assign("DIV_ID","fk_$key");
					$t->parse("ROW",".div_row");
				} else {
					$t->assign('LAY_LINK','');
				}
			} else {
				$t->assign('LAY_LINK','');
			}
			$t->parse('ROW','orig_obj');
		}
	}
	if (!$new_obj->isFolder()) {
		$linked_objs=$Imng->getLinkedObj($new_obj->getID());
		if (!empty($linked_objs)) {
			foreach ($linked_objs as $linked_obj) {
				$t->assign('LINK_OBJ_TITLE',Framework::entities($linked_obj->getName()));
				$t->assign("LINK_OBJ_IMG",$linked_obj->getImage(0));
				$t->assign("L_LINK_OBJ_IMG","index.php?site=".$linked_obj->getSite()."&oid=".$linked_obj->getID()."&action=".$linked_obj->getAction(1));
				$t->assign("L_LINK_OBJ_ITEM","index.php?site=".$linked_obj->getSite()."&oid=".$linked_obj->getID());
				if ($pre['global']['lay']) {
					$obj_tree=$Imng->getObjTree($linked_obj->getID(),$linked_obj->getParentMeta('LangID'));
					if (is_array($obj_tree)) {
						$t->assign("DIV_TREE",implode(' / ',array_reverse(FrameWork::entities($obj_tree))));
						$t->parse("ROW","div_tree");
						$t->assign('LAY_LINK'," onMouseOver=\"show(event, 'fk_$key'); return true;\" onMouseOut=\"hide('fk_$key'); return true;\"");
						$t->assign("DIV_ID","fk_$key");
						$t->parse("ROW",".div_row");
					} else {
						$t->assign('LAY_LINK','');
					}
				} else {
					$t->assign('LAY_LINK','');
				}
				$t->parse('ROW','.linked_obj_row');
			}
			$t->parse('ROW','linked_obj');
		}

		$t->assign('PAGE_WIDTH',$xmlFastText->getValue('page|width'));
		$t->assign('PAGE_CLASS',$xmlFastText->getStyle('page|class|edit'));
		$t->assign('WEB_PAGE','&nbsp;');
		if ($new_obj->getMeta('Content')) {
			$xml_text=$Imng->getContent($new_obj->getMeta('Content'),$new_obj->getMeta('Version'));
			if ($xml_text) {
				$xml->parseText($xml_text);
				$xmlFastText->init('preview_int');
				$t->assign('WEB_PAGE',$xmlFastText->getHtml($xml->get_node(0)));
				if ($t->issetkey('anchors')) {
					$anchors=$xmlFastText->getAnchors();
					$t->clear_dynamic('anchors_row');
					if (!empty($anchors)) {
						foreach ($anchors as $a_key=>$a_name) {
							$t->assign('L_ANCHOR',$a_key);
							$t->assign('N_ANCHOR',$xmlFastText->entities($a_name));
							$t->parse('ROW','.anchors_row');
						}
						$t->parse('ROW','anchors');
					}
				}
			}
		}
		$t->parse('ROW','web_page');

	}
	foreach ($obj_action as $key=>$val) {
		if (!$val['Hidden'] && $Imng->isAllowedAction($new_obj,$val)) {
			$t->assign('SEL_VAL',$key);
			$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
			$t->parse('ROW','.obj_action_val');
			$parse=true;
		}
	}
	if ($parse) $t->parse('ROW','obj_action');

	$t->assign('STATUS',$Imng->getStatusName($new_obj->getStatus()));
	$t->parse('ROW','public_box');
}

if (!$obj->getMeta('Trash')) {
	$t->parse('ROW','update');
}
$t->assign('L_BREAK',"index.php?site=$site&oid=".$new_obj->getParentMeta('ParentID'));
$t->parse('ROW','break');

if ($pre['global']['lay']) $t->parse("TPL_LAYERS","tpl_layer"); else
$t->assign("TPL_LAYERS","");
?>
