<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->assign('FORM_ACTION',"index.php?site=$site&action=$action");

$txt_info=new TextField('info','size=25 class=sel style="width:230px"');
$t->assign('TXT_INFO',$txt_info->f());
$t->assign('FOCUS_FIELD','info');

$chk_only_words=new CheckBox("only_words",'class=sel',1);
$t->assign('CHK_ONLY_WORDS',$chk_only_words->f(1));
$chk_use_case=new CheckBox("use_case",'class=sel',1);
$t->assign('CHK_USE_CASE',$chk_use_case->f(1));

$sel_limit=new SelectField('limit','class=sel',array(50=>50,20=>20,10=>10),20);
$t->assign('SEL_LIMIT',$sel_limit->f());
$date=time();

$sql_search=array();
$qlink='';
$sql_search[]="RootID IN (".implode(',',array_keys($root_obj)).")";
if ($info) {
	$fields=array('BlackContent.Content','Text');
	foreach ($CFG['MA_LANG'] as $val) {
		$fields[]="Title_$val";
	}
	$sql_search[]=$db->formatSearch($info,$fields,$use_case,$only_words);



	$qlink.='&info='.urlencode($info);
	//$order="rang1 DESC,rang2 DESC";
	$order='Title_'.$Imng->getLangID().' ASC';
} else {
	$order='Title_'.$Imng->getLangID().' ASC';
}


$i=0;$rows=0;
//$search_array=$Imng->searchObj ($rows,$b,$limit,implode(' AND ',$sql_search),$order,true,true,$info);
$search_array=$Imng->searchObj ($rows,$b,$limit,implode(' AND ',$sql_search),$order,true,true,true);
foreach ($search_array as $list_obj) {
	$t->assign('LIST_OBJ_TITLE',Framework::entities($list_obj->getName()));
	$t->assign('LIST_OBJ_TEXT',nl2br(Framework::entities($list_obj->getMeta('Text'))));
	$t->assign('LIST_OBJ_ID',$list_obj->getID());
	$t->assign("LIST_OBJ_IMG",$list_obj->getImage(0));
	$t->assign("L_LIST_OBJ_IMG","index.php?site=".$list_obj->getSite()."&oid=".$list_obj->getID()."&action=".$list_obj->getAction(1));
	$t->assign("L_LIST_OBJ_ITEM","index.php?site=".$list_obj->getSite()."&oid=".$list_obj->getID());

	$t->assign('LIST_OBJ_USER_MODIFY',FrameWork::entities($users_array[$list_obj->getMeta('UserModify')]));
	
	if ($i%2) {
		$t->assign("ROW_COLOR","#f2f2f2");
	} else {
 		$t->assign("ROW_COLOR",$bgcolor);
	}
 	$t->parse('ROW','.search_row');
  	$i++;
}
$num=$i;
if ($rows>$limit) {
	$s_limit=10;
	$s_begin=1;
	$s_sites=ceil($rows/$limit);
	$a_site=($b/$limit);
	if ($a_site>=$s_limit) {
		$s_begin=floor($a_site/$s_limit)*$s_limit+1;
		$n_b=($s_begin-2)*$limit;
		$l_sites.="<a href=\"index.php?site=$site&action=$action&b=$n_b".$qlink."\">&lt;&lt;</a> ";
	}
	if (($s_begin+$s_limit)>$s_sites) {
		$len_sites=$s_sites-$s_begin+1;
	} else {
		$len_sites=$s_limit;
	}
	for ($i=$s_begin;$i<($s_begin+$len_sites);$i++) {
		$n_b=($i - 1)*$limit;
		if ($n_b==$b) { $temp_b='<b>'; $temp_e='</b>'; } else{ $temp_b=''; $temp_e=''; }
		$l_sites.="[<a href=\"index.php?site=$site&action=$action&b=$n_b".$qlink."\">".$temp_b.$i.$temp_e."</a>]";
	}
	if ($s_sites>$i) {
		$n_b=($i-1)*$limit;
		$l_sites.=" <a href=\"index.php?site=$site&action=$action&b=$n_b".$qlink."\">&gt;&gt;</a>";
		$t->parse("ROW","more");
	}
	$t->assign("S_SITES",$l_sites);
	$t->assign("S_NUM",($b+1)." - ".($b+$num));
	$t->assign("S_ALL",$rows);
	$t->parse("ROW","search_next");
} else {
	$t->assign("S_ALL",$num);
	$t->parse("ROW","search_one");
}



?>