<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require_once("lib/class_form.inc.php");
$this_action=$frm->getObjAction ($Imng->getModul(),$obj->getActionMode(0),'modify');
if ($Imng->isAllowedAction($obj,reset($this_action))) {
	$Imng->setClipboard('wcont',$frm->getClipboard('wcont'));
	$Status=$obj->getStatus();
	$ContID=$obj->getMeta('Content');
	$ContVersion=$obj->getMeta('Version');
	$this_link="index.php?site=$site&action=$action&oid=$oid&back=".$back;
	unset($TmpContent);
	$UpdateImg=false;
	if (isset($cont_save_x) && $ContID) {
		$TmpContent=$Imng->getContentTemp($ContID);
		if ($TmpContent) {
			$Imng->saveContent($ContID,$ContVersion,$TmpContent['Content']);
			$obj->setMeta('TimeModify',time());
			$obj->setMeta('UserModify',$user_id);
			$Imng->updateMeta($obj);
			$Imng->deleteContentTemp($ContID);
			unset($TmpContent);
			$ContReload=1;
			$UpdateImg=true;
			$mode='view';
		}
	}
	$ContMeta=$Imng->getMetaContent($ContID,$ContVersion);
	if (!$ContID || !$ContMeta) {
		$ContID=$obj->getID();
		$Imng->saveContent($ContID,$ContVersion,'<webobj></webobj>');
		$obj->setMeta('Content',$ContID);
		$obj->setMeta('TimeModify',time());
		$obj->setMeta('UserModify',$user_id);
		$Imng->updateMeta($obj);
		$ContMeta=$Imng->getMetaContent($ContID,$ContVersion);
	}
	if (!$ContReload) {
		$TmpContent=$Imng->getContentTemp($ContID);
	}
	if (!$TmpContent) {
		$TmpContent['TimeModify']=$ContMeta['TimeModify'];
		$TmpContent['Content']=$Imng->getContent($ContID,$ContVersion);

		$xml->parseText($TmpContent['Content'],true);
		if (!$xml->children_len(0)) {
			$xml->new_child (0,'paragraph');
		}
		$modify=true;
		$TmpContent['ContModified']=0;
	} else {
		$xml->parseText($TmpContent['Content'],false);
	}
	unset($TmpContent['Content']);
	if (!isset($OpenObjects[$Imng->getModul()][$obj->getID()])) {
		$frm->replaceOpenObjects($Imng->getModul(),$obj->getID());
		$OpenObjects=$frm->getOpenObjects();
	}
	if ($TmpContent['TimeModify']<$ContMeta['TimeModify']) {
		if ($ContIgnore) {
			$TmpContent['TimeModify']=$ContMeta['TimeModify'];
			$modify=true;
		} else {
			$tmp=$frm->getFullName($ContMeta['UserModify'],0,1);
			$ActionError['cont_conflict']=array(
				'CONF_USER'=>isset($tmp[$ContMeta['UserModify']])?$tmp[$ContMeta['UserModify']]:'-',
				'CONF_DATE'=>date('d.h.Y',$ContMeta['TimeModify']),
				'CONF_TIME'=>date('H:i:s',$ContMeta['TimeModify']),
				'L_CONF_RELOAD'=>$this_link."&ContReload=1",
				'L_CONF_IGNORE'=>$this_link."&ContIgnore=1",
			);
		}
	}
	if ($tab_action_x && $tab_action_val && $cont_id) {
		$node=$xml->get_node($cont_id);
		if (is_object($node)) {
			$node=$node->get_children(0);
			//echo $tab_action_row.'-'.$tab_action_col.'<br>';
			$node=$node->get_children($tab_action_row);
			if (is_object($node)) {
				$node=$node->get_children($tab_action_col);
				if (is_object($node)) {
					$colID=$node->get_id();
				}
			}
		}
		if ($colID) {
			if (!$node->children_len()) {
				if ($tab_action_val=='insert') {
					$cont_action_x=1;
					$cont_action_val='insert';
					$insertID=$colID;
				} elseif (substr($tab_action_val,0,2)=='n|') {
					$cont_pos=$colID.',0';
					$mode=substr($tab_action_val,2);
					unset($cont_id);
					//echo $cont_pos;
				}
			}
		}
	}
	if ($tab_action_del_x && $cont_id) {
		$node=$xml->get_node($cont_id);
		if (is_object($node)) {
			$node=$node->get_children(0);
			//echo $tab_del_row.'-'.$tab_del_col.'<br>';
			$node=$node->get_children($tab_del_row);
			if (is_object($node)) {
				$node=$node->get_children($tab_del_col);
				if (is_object($node)) {
					$colID=$node->get_id();
				}
			}
		}
		if ($colID) {
			if ($node->children_len()) {
				foreach ($node->get_children() as $del_node) {
					$xml->delete_node($del_node->get_id());
				}
				$modify=true;
			}
		}
	}

	if ($obj->getMeta('DocType')=='tdoc') {
		$xmlFastText->init('tpl');
		$link_mode=true;
	} elseif ($obj->getMeta('DocType')=='bdoc') {
		$xmlFastText->init('edit');
		$link_mode=true;
	} else {
		$xmlFastText->init('edit');
		$link_mode=false;
	}

	if ($cont_action_x && $cont_action_val) {
		switch ($cont_action_val) {
			case 'copy':
				if ($cont_id) {
					$clip_text=$xml->getText ($cont_id,1,"","",true);
					if ($clip_text) {
						if ($Imng->isClipboard('wcont')) {
							$frm->deleteClipboard('wcont');
							$Imng->setClipboard('wcont',false);
						}
						$Imng->setClipboard('wcont',$frm->insertClipboard('wcont',$clip_text,'copy'));
					}
					$mode='view';
					unset($clip_text,$cont_id);
				}
				break;
			case 'delete':
				if ($cont_id) {
					$node=&$xml->get_node($cont_id);
					if (is_object($node)) {
						switch ($node->get_name()) {
							case 'obj:mmedia':
								/*$node=&$node->get_children(0);
								if (is_object($node)) {
									if ($node->get_attribs('file') && file_exists($Imng->getFilePath().'/'.$node->get_attribs('file'))) {
										@unlink($Imng->getFilePath().'/'.$node->get_attribs('file'));
									}
								}*/
							break;
						}
					}
					$xml->delete_node($cont_id);
					$modify=true;
					$TmpContent['ContModified']=1;
					if (!$xml->children_len(0)) {
						$xml->new_child (0,'paragraph');
					}
					$modify=true;
					$mode='view';
					unset($cont_id);
				}
				break;
			case 'insert':
				$root_node=$xml->get_node(0);
				if ($insertID) {
					$insertNode=$xml->get_node($insertID);

				} else {
					$insertNode=$root_node->get_children(-1);
				}

				if ($insertNode) {
					$xml_cont=new Xml();
					foreach ($Imng->getClipboard('wcont') as $val) {
						$error=$xml_cont->parseText($val['Content'],true);
						//debug(htmlspecialchars($val['Content']));exit;
						if ($error!==false && ($cont_node=$xml_cont->get_node(0))) {

							if ($cont_node->get_name()=='paragraph') {
								if ($insertID) {
									$ActionError['insertPara']=true;
								} else {
									$error=$xml->addText($val['Content'],$root_node->get_id(),false);
								}
							} else {
								if (is_object($insertNode) && ($insertNode->get_name()!='col' || $insertNode->children_len() == 0)) {
									$error=$xml->addText($val['Content'],$insertNode->get_id(),false);
								}
							}
							if ($error!==false) {
								$modify=true;
							}
						}
					}
				}
				break;
			default:
				if (substr($cont_action_val,0,2)=='n|') {
					$mode=substr($cont_action_val,2);
				}
		}
	}

	if ($move) {
		$tmp=explode(',',$move);
		$xml->move_node($tmp[0],$tmp[1],$tmp[2]);
		$modify=true;
		$TmpContent['ContModified']=1;
	}
	if ($delete) {
		$node=&$xml->get_node($delete);
			if (is_object($node)) {
				switch ($node->get_name()) {
					case 'obj:mmedia':
						/*$node=&$node->get_children(0);
						if (is_object($node)) {
							if ($node->get_attribs('file') && file_exists($Imng->getFilePath().'/'.$node->get_attribs('file'))) {
								@unlink($Imng->getFilePath().'/'.$node->get_attribs('file'));
							}
						}*/
					break;
			}
		}
		$xml->delete_node($delete);
		$modify=true;
		$TmpContent['ContModified']=1;
		if (!$xml->children_len(0)) {
			$xml->new_child (0,'paragraph');
		}
	}
	if ($save_x || $copy_x) {
		if (isset($cont_pos)) {
			$tmp=explode(',',$cont_pos);
			$to_parent=$tmp[0];
			$to_pos=$tmp[1];
			$to_parent_node=&$xml->get_node($to_parent);
			/*
			if (!is_object($to_parent_node) || ($to_parent_node->get_name()=='col' && $to_parent_node->children_len() > 0)) {
				unset($to_parent,$to_parent_node,$to_pos);
			}*/
			if (!is_object($to_parent_node) > 0) {
				unset($to_parent,$to_parent_node,$to_pos);
			}
		} else {
			unset($to_parent);
		}
		$error=true;
		switch ($mode) {
			case 'paragraph':
				if (isset($cont_id) && !isset($copy_x)) {
					$node=&$xml->get_node($cont_id);
					if (is_object($node)) {
						if (is_array($attr)) {
							foreach ($attr as $key=>$val) {
								$node->set_attrib($key,$val);
							}
						}
						if (isset($to_parent)) {
							$parent=&$xml->get_node($to_parent);
							$s_parent=&$parent->get_parent();
							$to_sparent=$s_parent->get_id();
							$to_spos=$s_parent->get_child_pos($to_parent);
							$xml->move_node($cont_id,$to_sparent,$to_spos+1,1);
							$len=$parent->children_len();
						}
					}
				} else {
					if (isset($to_parent)) {
						$parent=&$xml->get_node($to_parent);
						$s_parent=&$parent->get_parent();
						$to_sparent=$s_parent->get_id();
						$to_spos=$s_parent->get_child_pos($to_parent);
						if (!isset($copy_x)) {
							$cont_id=$xml->new_child ($to_sparent,'paragraph',$attr, '',$to_spos+1,1);
							$len=$parent->children_len();
							//echo "len $len - $to_pos<br>";
							for ($i=$len;$i>$to_pos;$i--) {
								$temp=&$parent->get_children($i-1);
								$xml->move_node($temp->get_id(),$cont_id,0);
							}
						} else {
							foreach ($xml->get_children($cont_id) as $node) {
								$node_data.=$xml->getText ($node->get_id(),1,"","",true);
							}


							$cont_id=$xml->new_child ($to_sparent,'paragraph',$attr, '',$to_spos+1,1);
							$error=$xml->addText('<obj:parent>'.$node_data.'</obj:parent>',$cont_id,true);
							if ($error===false) {
								$xml->delete_node($cont_id);
								unset($cont_id);
							}
						}
						//
					} else $error=false;
				}
				break;
			case 'title':
				$tmp_data=$xml->convertEndings($node_data);
				$tmp_data=$xmlFastText->encodeText($tmp_data);
				if ($tmp_data!==false) {
					$tag_name='<title';
					if (is_array($attr)) {
						foreach ($attr as $key=>$val) {
							$tag_name.=" $key='".htmlspecialchars($val,ENT_QUOTES)."'";
						}
					}
					$tag_name.='>';

					if (isset($cont_id) && !isset($copy_x)) {
						$error=$xml->addText('<obj:parent>'.$tag_name.$tmp_data.'</title></obj:parent>',$cont_id,true);
						if ($error!==false && isset($to_parent)) $xml->move_node($cont_id,$to_parent,$to_pos,1);
					} else {
						if (isset($to_parent)) {
							$cont_id=$xml->new_child ($to_parent,'obj:title', '', '',$to_pos);
							$error=$xml->addText('<obj:parent>'.$tag_name.$tmp_data.'</title></obj:parent>',$cont_id,true);
							if ($error===false) {
								$xml->delete_node($cont_id);
								unset($cont_id);
							}
						} else $error=false;
					}
				} else {
					$error=false;
				}
				break;
			case 'text':
				$tmp_data=$xml->convertEndings($node_data);
				if ($sub_node['italic']) {
					$tmp_data='<i>'.preg_replace('/<\/?i>/i','',$tmp_data).'</i>';
				}
				if ($sub_node['bold']) {
					$tmp_data='<b>'.preg_replace('/<\/?b>/i','',$tmp_data).'</b>';
				}
				if ($sub_node['color']) {
					$tmp_data='<c>'.preg_replace('/<\/?c>i/','',$tmp_data).'</c>';
				}
				//echo $node_data;
				$tmp_data=$xmlFastText->encodeText($tmp_data);

				if ($tmp_data!==false) {
					if (isset($cont_id) && !isset($copy_x)) {
						//echo 'cont_pos'.$cont_pos.'<br>';
						$error=$xml->addText('<obj:parent>'.$tmp_data.'</obj:parent>',$cont_id,true);
						if ($error!==false && isset($to_parent)) $xml->move_node($cont_id,$to_parent,$to_pos,1);
					} else {
						if (isset($to_parent)) {
							$cont_id=$xml->new_child ($to_parent,'obj:text', '', '',$to_pos);
							$error=$xml->addText('<obj:parent>'.$tmp_data.'</obj:parent>',$cont_id,true);
							if ($error===false) {
								$xml->delete_node($cont_id);
								unset($cont_id);
							}
						} else $error=false;
					}
				} else {
					$error=false;
				}
				break;
			case 'fasttext':
				$tmp_data=$xml->convertEndings($node_data);
				$tmp_data=$xmlFastText->encodeText($tmp_data);
				if ($tmp_data!==false) {
					if (isset($cont_id) && !isset($copy_x)) {
						$error=$xml->addText('<obj:parent>'.$tmp_data.'</obj:parent>',$cont_id,true);

						if ($error!==false && isset($to_parent)) $xml->move_node($cont_id,$to_parent,$to_pos,1);
					} else {
						if (isset($to_parent)) {
							$cont_id=$xml->new_child ($to_parent,'obj:fasttext', '', '',$to_pos);
							$error=$xml->addText('<obj:parent>'.$tmp_data.'</obj:parent>',$cont_id,true);

							if ($error===false) {
								$xml->delete_node($cont_id);
								unset($cont_id);
							}
						} else $error=false;
					}
				} else {
					$error=false;
				}
				break;
			case 'list':

				$tmp_data=$xml->convertEndings($node_data);
				$tmp_data="<list style='".$attr['style']."'>".$tmp_data."</list>";
				$tmp_data=$xmlFastText->encodeText($tmp_data);
				if ($tmp_data!==false) {
					if (isset($cont_id) && !isset($copy_x)) {
						$error=$xml->addText('<obj:parent>'.$tmp_data.'</obj:parent>',$cont_id,true);
						if ($error!==false && isset($to_parent)) $xml->move_node($cont_id,$to_parent,$to_pos,1);
					} else {
						if (isset($to_parent)) {
							$cont_id=$xml->new_child ($to_parent,'obj:list', '', '',$to_pos);
							$error=$xml->addText('<obj:parent>'.$tmp_data.'</obj:parent>',$cont_id,true);
							if ($error===false) {
								$xml->delete_node($cont_id);
								unset($cont_id);
							}
						} else $error=false;
					}
				} else {
					$error=false;
				}

				break;
			case 'image':
				$tag_name='<image';
				$attr['link:type']=$l_type;
				if ($l_type=='int') {
					if ($url_search) {
						$attr['link:url']=$url_search;
					} else {
						$attr['link:url']=$url_int;
					}
				} elseif ($l_type=='ext') {
					$attr['link:url']=$url_ext;
				}
				if (intval($custom_width)) {
					$custom_perc=round($custom_width/($xmlFastText->getValue('image|max')/100),2);
					//echo $custom_perc;
					if ($custom_perc>100) $custom_perc=100;
					$attr['width']=$custom_perc.'%';
				}
				if (is_array($attr)) {
					foreach ($attr as $key=>$val) {
						$tag_name.=" $key='".htmlspecialchars($val,ENT_QUOTES)."'";
					}
				}
				$tag_name.=' />';
				if (isset($cont_id) && !isset($copy_x)) {
					$error=$xml->addText('<obj:parent>'.$tag_name.'</obj:parent>',$cont_id,true);
					if ($error!==false && isset($to_parent)) $xml->move_node($cont_id,$to_parent,$to_pos,1);
				} else {
					if (isset($to_parent)) {
						$cont_id=$xml->new_child ($to_parent,'obj:image', '', '',$to_pos);
						$error=$xml->addText('<obj:parent>'.$tag_name.'</obj:parent>',$cont_id,true);
						if ($error===false) {
							$xml->delete_node($cont_id);
							unset($cont_id);
						}
					} else $error=false;
				}
				break;
			case 'link':
				$tag_name='<link';
				if ($l_type=='int') {
					$attr['type']='int';
					if ($url_search) {
						$attr['url']=$url_search;
					} else {
						$attr['url']=$url_int;
					}
				} else {
					$attr['type']='ext';
					$attr['url']=$url_ext;
				}
				if (is_array($attr)) {
					foreach ($attr as $key=>$val) {
						$tag_name.=" $key='".htmlspecialchars($val,ENT_QUOTES)."'";
					}
				}
				if (!trim($node_data)) {
					if ($attr['type']=='ext') {
						$node_data=$attr['url'];
					} else {
						$url_obj=$Imng->getObj($attr['url']);
						if (is_object($url_obj)) {
							$node_data=$url_obj->getName();
						}
					}
				}
				$tag_name.='>';
				$tag_name.=$xmlFastText->encodeText($xml->convertEndings($node_data));
				$tag_name.='</link>';
				if (isset($cont_id) && !isset($copy_x)) {
					$error=$xml->addText('<obj:parent>'.$tag_name.'</obj:parent>',$cont_id,true);
					if ($error!==false && isset($to_parent)) $xml->move_node($cont_id,$to_parent,$to_pos,1);
				} else {
					if (isset($to_parent)) {
						$cont_id=$xml->new_child ($to_parent,'obj:link', '', '',$to_pos);
						$error=$xml->addText('<obj:parent>'.$tag_name.'</obj:parent>',$cont_id,true);
						if ($error===false) {
							$xml->delete_node($cont_id);
							unset($cont_id);
						}
					} else $error=false;
				}
				break;
			case 'table':
				if (isset($cont_id)) {
					$tab_node=$xml->get_child($cont_id,0);
					if (is_object($tab_node)) {
						if (!isset($attr['headrow'])) $attr['headrow']=0;
						if (!isset($attr['rowcolor'])) $attr['rowcolor']='none';
						$xml->set_attribs($tab_node->get_id(),$attr);
						if (isset($to_parent)) $xml->move_node($cont_id,$to_parent,$to_pos,1);
					}
				} else {
					if (isset($to_parent)) {
						if ($_FILES['csv_file'] && $_FILES['csv_file']['tmp_name'] && file_exists($_FILES['csv_file']['tmp_name'])) {
							$csv_data=$frm->importCsv ($_FILES['csv_file']['tmp_name'],$z_sep);
							//debug($csv_data);
							if (is_array($csv_data)) {
								$rows=count($csv_data);
								$cols=count($csv_data[0]);
							} else {
								$error=false;
							}
						} else {
							$csv_data='';
						}
						if ($error!==false) {
							if (!$rows) $rows=2;
							if (!$cols) $cols=2;
							$cont_id=$xml->new_child ($to_parent,'obj:table', '', '',$to_pos);
							$cont_id=$xml->new_child ($cont_id,'table',$attr);
							for ($i=0;$i<$rows;$i++) {
								$row_id=$xml->new_child ($cont_id,'row');
								for ($j=0;$j<$cols;$j++) {
									$col_id=$xml->new_child ($row_id,'col');
									if ($csv_data && trim($csv_data[$i][$j])) {
										$tmp_data=$xml->convertEndings($csv_data[$i][$j]);
										$tmp_data=$xmlFastText->encodeText($tmp_data);
										//debug(htmlentities($tmp_data));
										$cont_col_id=$xml->new_child ($col_id,'obj:fasttext', '', '');
										$tmp_error=$xml->addText('<obj:parent>'.$tmp_data.'</obj:parent>',$cont_col_id,true);
										if ($tmp_error===false) {
											$xml->delete_node($cont_col_id);
											unset($cont_col_id);
										}
									}
								}
							}
						}
					} else $error=false;
				}
 				break;
			case 'download':
				$tag_name='<download';
				if (is_array($attr)) {
					foreach ($attr as $key=>$val) {
						$tag_name.=" $key='".htmlspecialchars($val,ENT_QUOTES)."'";
					}
				}
				$tag_name.=' />';
				//var_Dump($attr);
				//$l_obj=$Imng->getObj($attr['url']);
				if ($attr['url']) {
					if (isset($cont_id) && !isset($copy_x)) {
						$error=$xml->addText('<obj:parent>'.$tag_name.'</obj:parent>',$cont_id,true);
						if ($error!==false && isset($to_parent)) $xml->move_node($cont_id,$to_parent,$to_pos,1);
					} else {
						if (isset($to_parent)) {
							$cont_id=$xml->new_child ($to_parent,'obj:download', '', '',$to_pos);
							$error=$xml->addText('<obj:parent>'.$tag_name.'</obj:parent>',$cont_id,true);
							if ($error===false) {
								$xml->delete_node($cont_id);
								unset($cont_id);
							}
						} else $error=false;
					}
				} else $error=false;
				break;
			case 'mmedia':
				$tag_name='<mmedia';
				if (is_array($attr)) {
					foreach ($attr as $key=>$val) {
						$tag_name.=" $key='".htmlspecialchars($val,ENT_QUOTES)."'";
					}
				}
				$tag_name.=' />';
				//var_Dump($attr);
				//$l_obj=$Imng->getObj($attr['url']);
				if ($attr['file']) {
					if (isset($cont_id) && !isset($copy_x)) {
						$error=$xml->addText('<obj:parent>'.$tag_name.'</obj:parent>',$cont_id,true);
						if ($error!==false && isset($to_parent)) $xml->move_node($cont_id,$to_parent,$to_pos,1);
					} else {
						if (isset($to_parent)) {
							$cont_id=$xml->new_child ($to_parent,'obj:mmedia', '', '',$to_pos);
							$error=$xml->addText('<obj:parent>'.$tag_name.'</obj:parent>',$cont_id,true);
							if ($error===false) {
								$xml->delete_node($cont_id);
								unset($cont_id);
							}
						} else $error=false;
					}
				} else $error=false;
				break;
			case 'address':
				$tag_name='<address';
				if (is_array($attr)) {
					foreach ($attr as $key=>$val) {
						$tag_name.=" $key='".htmlspecialchars($val,ENT_QUOTES)."'";
					}
				}
				$tag_name.=' />';
				//var_Dump($attr);
				//$l_obj=$Imng->getObj($attr['url']);
				if ($attr['url']) {
					if (isset($cont_id) && !isset($copy_x)) {
						$error=$xml->addText('<obj:parent>'.$tag_name.'</obj:parent>',$cont_id,true);
						if ($error!==false && isset($to_parent)) $xml->move_node($cont_id,$to_parent,$to_pos,1);
					} else {
						if (isset($to_parent)) {
							$cont_id=$xml->new_child ($to_parent,'obj:address', '', '',$to_pos);
							$error=$xml->addText('<obj:parent>'.$tag_name.'</obj:parent>',$cont_id,true);
							if ($error===false) {
								$xml->delete_node($cont_id);
								unset($cont_id);
							}
						} else $error=false;
					}
				} else $error=false;
				break;
			default:
				$error=false;
				break;
		}
		if ($error!==false) {
			if ($xmlFastText->getMode()=='tpl' ) {
				$fields=explode(',',$tattr_fields);
				foreach ($fields as $fkey) {
					if (isset($tattr[$fkey])) {
						$xml->set_attribs($cont_id,array($fkey=>htmlspecialchars($tattr[$fkey],ENT_QUOTES)));
					} else {
						$xml->unset_attribs($cont_id,$fkey);
					}

				}
				if ($mode=='table' && is_object($tab_node)) {
					foreach ($tab_node->get_children() as $pos=>$row_node) {
						if ($rtattr['repeat'] && $rtattr['row_num']==$pos) {
							$xml->set_attribs($row_node->get_id(),array('repeat'=>htmlspecialchars($rtattr['repeat'],ENT_QUOTES)));
							$xml->set_attribs($row_node->get_id(),array('rtitle'=>htmlspecialchars($rtattr['rtitle'],ENT_QUOTES)));
						} else {
							$xml->unset_attribs($row_node->get_id(),'repeat');
							$xml->unset_attribs($row_node->get_id(),'rtitle');
						}
					}
				}
			}
			$modify=true;
			$TmpContent['ContModified']=1;
			if ($p_mode) {
				$mode=$p_mode;
				$cont_id=$p_cont_id;
			} else {
				$mode='view';
			}
		}

	}
	unset($xml_text);
	$xmlFastText->setLink($this_link);
	switch ($mode) {
		case 'paragraph':
			$t->define (array('tpl_card' => "wdoc_edit_paragraph.inc.html"));
			require('wdoc_edit_paragraph.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
		case 'title':
			$t->define (array('tpl_card' => "wdoc_edit_title.inc.html"));
			require('wdoc_edit_title.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
		case 'text':
			$t->define (array('tpl_card' => "wdoc_edit_text.inc.html"));
			require('wdoc_edit_text.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
		case 'fasttext':
			$t->define (array('tpl_card' => "wdoc_edit_fasttext.inc.html"));
			require('wdoc_edit_fasttext.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
		case 'list':
			$t->define (array('tpl_card' => "wdoc_edit_list.inc.html"));
			require('wdoc_edit_list.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
		case 'link':
			$t->define (array('tpl_card' => "wdoc_edit_link.inc.html"));
			require('wdoc_edit_link.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
		case 'image':
			$t->define (array('tpl_card' => "wdoc_edit_image.inc.html"));
			require('wdoc_edit_image.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
		case 'table':
			$t->define (array('tpl_card' => "wdoc_edit_table.inc.html"));
			require('wdoc_edit_table.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
		case 'download':
			$t->define (array('tpl_card' => "wdoc_edit_download.inc.html"));
			require('wdoc_edit_download.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
		case 'mmedia':
			$t->define (array('tpl_card' => "wdoc_edit_mmedia.inc.html"));
			require('wdoc_edit_mmedia.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
		case 'address':
			$t->define (array('tpl_card' => "wdoc_edit_address.inc.html"));
			require('wdoc_edit_address.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
		default:
			$t->define (array('tpl_card' => "wdoc_view.inc.html"));
			require('wdoc_list.php');
			require('wdoc_view.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
	}
	if ($modify) {

		$Imng->saveContentTemp($ContID,$xml->getText(0,1,"",""),$TmpContent['TimeModify'],$TmpContent['ContModified']);
	}

} else {
	header ("Location:index.php?site=$site&oid=".$obj->getID());
	exit;
}
?>
