<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require_once('lib/class_ObjSelect.php');
if ($p_mode && $p_cont_id!=$cont_id) {
	$l_break=$this_link."&mode=$p_mode&cont_id=$p_cont_id";
	$form_action=$this_link."&mode=$mode&noload=1&p_mode=$p_mode&p_cont_id=$p_cont_id";
} else {
	$l_break=$this_link."&mode=view";
	$form_action=$this_link."&mode=$mode&noload=1";
}
if (isset($cont_id)) {
	$node=&$xml->get_node($cont_id);
	if (is_object($node)) {
		$parent=&$node->get_parent();
		$node=&$node->get_children(0);
		$t->assign('CONT_NUM',$cont_id);
		$form_action.='&cont_id='.$cont_id;
		if (is_object($parent)) {
			$parent_id=$parent->get_id();
			$parent_pos=$parent->get_child_pos($cont_id);
		}
		if (!$noload) {
			if (is_object($parent)) $cont_pos=$parent_id.','.$parent_pos;
			$attr=$node->get_attribs();
			$node_data=$xmlFastText->decodeText($node,1);
			//var_dump($attr);
			if ($attr['type']=='int') {
    				$url_int=$attr['url'];
			} else {
				$url_ext=$attr['url'];
			}
			$l_type=$attr['type'];
		}
		$t->parse('ROW','cont_edit');
	} else {
		page_close();
		header('Loaction:'.$l_break);
		exit;
	}
} else {
	if (!$noload) {
		$node_data='';
		$attr['type']='ext';
	}
	$t->parse('ROW','cont_new');
}
if ($cont_pos) {
	$parent_id=substr($cont_pos,0,strpos($cont_pos,','));
}

if ($l_type=='int') $t->assign('ATTR_TYPE_INT','checked'); else $t->assign('ATTR_TYPE_INT','');
if ($l_type=='ext' || !$l_type) $t->assign('ATTR_TYPE_EXT','checked'); else $t->assign('ATTR_TYPE_EXT','');

if (!$url_ext) $url_ext="http://";
$t->assign('NODE_DATA',htmlspecialchars($node_data));
$t->assign('URL_EXT',htmlspecialchars($url_ext));
$t->assign('LINK_SEARCH',htmlspecialchars($link_search));


if ($link_mode) {
	//$tree_root=$Imng->ListSubEntrys($Imng->getSite(),array('wcat'));
	//$tree=$Imng->ListAllTree(array_keys($tree_root),-1,'Sequence','ASC',$CFG['REDI']['Apps'],0);
} else {
	$tree=$Imng->ListAllTree($Imng->getLangID(),$root_id,-1);
}
$sel_int=new ObjSelect();
$sel_int->setTree($tree);
$sel_int->setObjClass('fol','foption');
$sel_int->setClass('noption');
if ($l_type=='int') {
	$sel_int->setSelectedID($url_int);
}
$sel_int->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');
if ($link_mode) {
	$t->assign('TREE_OPTION',$sel_int->parseSelect($Imng->getSite()));
} else {
	$t->assign('TREE_OPTION',$sel_int->parseSelect($root_id));
}

if ($link_search) {
	$rows=0;
	$sql_search=$db->formatSearch($link_search,array('Title_'.$Imng->getLangID(),'Text'));
	if ($link_mode) {
		$sql_search.=' AND RootID IN ('.implode(',',array_keys($tree_root)).')';
	} else {
		$sql_search.=' AND RootID='.intval($root_id);
	}
	$search_array=$Imng->searchObj ($rows,0,10,$sql_search,'Title_'.$Imng->getLangID());
	foreach ($search_array as $search_obj) {
		$t->assign('S_KEY',$search_obj->getID());
		$t->assign('S_IMG',$search_obj->getImage(0));
		$t->assign('S_TITLE',Framework::entities($search_obj->getName()));
		$t->parse('ROW','.l_search_row');
	}
}
$t->assign('FORM_ACTION',$form_action);
$t->assign('L_BREAK',$l_break);
$view_cont_action=false;
$cont_action=$frm->getObjAction($Imng->getModul(),'cont_link');
foreach ($cont_action as $key=>$val) {
	if (in_array('content',$val['Extra']) && !$cont_id) continue;
	$t->assign('SEL_VAL',$key);
	$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
	$t->parse('ROW','.cont_action_val');
	$view_cont_action=true;
}
if ($view_cont_action) {
	$t->parse('ROW','cont_action');
}
$t->parse('ROW','break');
$t->parse('ROW','update');
if ($xmlFastText->getMode()=='tpl') {
	$tattr=$xml->get_attribs($cont_id);
	if ($tattr['edit']=='1') $t->assign('TATTR_EDIT','checked'); else $t->assign('TATTR_EDIT','');
	$t->assign('TATTR_TITLE',htmlspecialchars($tattr['title']));
	if ($Imng->isSuperAdmin()) {
		$t->assign('TATTR_CID',htmlspecialchars($tattr['cid']));
		$t->assign('TATTR_FIELDS',',cid');
		$t->parse('ROW','tattr_cid');
	} else {
		$t->assign('TATTR_FIELDS','');
	}
	$t->parse('ROW','edit_tpl');
}
require ('imng/wdoc_edit_position.php');
?>
