<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if ($p_mode && $p_cont_id!=$cont_id) {
	$l_break=$this_link."&mode=$p_mode&cont_id=$p_cont_id";
	$form_action=$this_link."&mode=$mode&noload=1&p_mode=$p_mode&p_cont_id=$p_cont_id";
} else {
	$l_break=$this_link."&mode=view";
	$form_action=$this_link."&mode=$mode&noload=1";
}
if (isset($cont_id)) {
	$node=$xml->get_node($cont_id);
	if (is_object($node)) {
		$parent=$node->get_parent();
		$node=$node->get_children(0);
		$attr=$node->get_attribs();
		$t->assign('CONT_NUM',$cont_id);
		$form_action.='&cont_id='.$cont_id;

		if (is_object($parent)) {
			$parent_id=$parent->get_id();
			$parent_pos=$parent->get_child_pos($cont_id);
		}
		if (!$noload) {
			if (is_object($parent)) $cont_pos=$parent_id.','.$parent_pos;
			$node_data=$xmlFastText->decodeText($node,1);
		}
		$t->parse('ROW','cont_edit');
	} else {
		page_close();
		header('Loaction:'.$l_break);
		exit;
	}
} else {
	if (!$noload) {
		$node_data='';
		$attr['style']='h1';
	}
	$t->parse('ROW','cont_new');
}
if ($cont_pos) {
	$parent_id=substr($cont_pos,0,strpos($cont_pos,','));
}
if ($attr['style']=='h1') $t->assign('ATTR_STYLE_H1','checked'); else $t->assign('ATTR_STYLE_H1','');
if ($attr['style']=='h2') $t->assign('ATTR_STYLE_H2','checked'); else $t->assign('ATTR_STYLE_H2','');
if ($attr['style']=='h3') $t->assign('ATTR_STYLE_H3','checked'); else $t->assign('ATTR_STYLE_H3','');

if ($attr['anchor']=='1') $t->assign('ATTR_ANCHOR','checked'); else $t->assign('ATTR_ANCHOR','');

$t->assign('CLASS_H1',$xmlFastText->getStyle('title|h1'));
$t->assign('CLASS_H2',$xmlFastText->getStyle('title|h2'));
$t->assign('CLASS_H3',$xmlFastText->getStyle('title|h3'));

$t->assign('CLASS_AREA',$xmlFastText->getStyle('area|edit'));
$t->assign('NODE_DATA',htmlspecialchars($node_data));


$t->assign('FORM_ACTION',$form_action);
$t->assign('L_BREAK',$l_break);
$view_cont_action=false;
$cont_action=$frm->getObjAction($Imng->getModul(),'cont_title');
foreach ($cont_action as $key=>$val) {
	if (in_array('content',$val['Extra']) && !$cont_id) continue;
	$t->assign('SEL_VAL',$key);
	$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
	$t->parse('ROW','.cont_action_val');
	$view_cont_action=true;
}
if ($view_cont_action) {
	$t->parse('ROW','cont_action');
}
$t->parse('ROW','break');
$t->parse('ROW','update');

if ($xmlFastText->getMode()=='tpl') {
	$tattr=$xml->get_attribs($cont_id);
	if ($tattr['edit']=='1') $t->assign('TATTR_EDIT','checked'); else $t->assign('TATTR_EDIT','');
	$t->assign('TATTR_TITLE',htmlspecialchars($tattr['title']));
	if ($Imng->isSuperAdmin()) {
		$t->assign('TATTR_CID',htmlspecialchars($tattr['cid']));
		$t->assign('TATTR_FIELDS',',cid');
		$t->parse('ROW','tattr_cid');
	} else {
		$t->assign('TATTR_FIELDS','');
	}
	if (!$tattr['txt_rows']) $tattr['txt_rows']=1;
	$t->assign('TATTR_TXT_ROWS',htmlspecialchars($tattr['txt_rows']));
	$t->parse('ROW','edit_tpl');
}

require ('imng/wdoc_edit_position.php');
?>
