<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require_once("lib/class_form.inc.php");
$this_action=$frm->getObjAction ($Imng->getModul(),$obj->getActionMode(0),'modify');
if ($Imng->isAllowedAction($obj,reset($this_action))) {
	$Status=$obj->getStatus();
 	$ContID=$obj->getMeta('Content');
 	$ContVersion=$obj->getMeta('Version');
	$this_link="index.php?site=$site&action=$action&oid=$oid";
	unset($TmpContent);
	$UpdateImg=false;
	$ContMeta=$Imng->getMetaContent($ContID,$ContVersion);
	if (!$ContID || !$ContMeta) {
		$ContID=$obj->getID();
		if (!$Content) $Content='<wdoc></wdoc>';
		$Imng->saveContent($ContID,$ContVersion,$Content);
		$obj->setMeta('Content',$ContID);
		$obj->setMeta('TimeModify',time());
		$obj->setMeta('UserModify',$user_id);

		$Imng->updateMeta($obj);
		if ($Status==3) $Imng->setDocModified($Imng->getObjTreeIDs($obj->getParentMeta('ParentID'),$obj->getParentMeta('HeadID')),1);
		$ContMeta=$Imng->getMetaContent($ContID,$ContVersion);
		$ContReload=true;
	}
	if (!$ContReload) {
		$TmpContent=$Imng->getContentTemp($ContID);
	}

	if (!$TmpContent) {
		$TmpContent['TimeModify']=$ContMeta['TimeModify'];
		$TmpContent['Content']=$Imng->getContent($ContID,$ContVersion);

		$xml->parseText($TmpContent['Content'],true);
		if (!$xml->children_len(0)) {
			$xml->new_child (0,'paragraph');
		}
		$modify=true;
		$TmpContent['ContModified']=0;
	} else {
		$xml->parseText($TmpContent['Content'],false);
	}
	if (is_array($eimage)) {
		$cont_id=key($eimage);
		$img_save_x=1;
	}
	if (is_array($rep_add)) {
		$rep_id=key($rep_add);
		$add_node=$xml->get_node($rep_id);

		$add_content='';
		if (is_object($add_node)) {
			$add_parent=$add_node->get_parent();
			$unset_rdelete=false;
			if ($add_node->get_attribs('repeat')) {
				if (!$add_node->get_attribs('rdelete')) {
					$xml->set_attribs($add_node->get_id(),array('rdelete'=>1));
					$unset_rdelete=true;
				}
			}
			$add_content.=$xml->getText($add_node->get_id(),1,"","",true);
			if ($unset_rdelete) {
				$xml->unset_attribs($add_node->get_id(),'rdelete');
			}
			if ($add_content && is_object($add_parent)) {
				$xml->addText($add_content,$add_parent->get_id(),false,$add_parent->get_child_pos($add_node->get_id())+1);

			}
		}

		$tmp_save_x=1;
	}
	if (is_array($rep_del)) {
		$rep_id=key($rep_del);
		$xml->delete_node($rep_id);
		unset($enode[$rep_id]);
		$tmp_save_x=1;
	}

	if ($set_img && $img_id && $cont_id) {
		$node=$xml->get_node($cont_id);
		if (is_object($node) && $node->get_name()=='obj:image') {
			$cont_node=$node->get_children(0);
			$attr=array();
			if ($img_id!=-1) {
				$img_obj=$Bmng->getObj($img_id);
				if (is_object($img_obj) && is_object($cont_node)) {
					$attr['base']=$img_obj->getMeta('Content');
					$xml->set_attribs ($cont_node->get_id(),$attr);

				}
			} else {
				$attr['base']='space_edit.gif';
				$xml->set_attribs ($cont_node->get_id(),$attr);
				$modify=true;
			}
		}
	}
	if (($cont_save_x || $img_save_x || $tmp_save_x) && $ContID) {
		if (is_array($enode)) {
			foreach ($enode as $node_id=>$node_data) {
				$error=true;
				$node=$xml->get_node($node_id);
				switch ($node->get_name()) {
					case 'obj:title':
						$cont_node=$node->get_children(0);
						$tmp_data=$xml->convertEndings($node_data);
						$tmp_data=$xmlFastText->encodeText($tmp_data);
						if ($tmp_data===false) {
							$error=false;
						} else {
							$error=$xml->addText('<obj:parent>'.$tmp_data.'</obj:parent>',$cont_node->get_id(),true);
						}
						break;
					case 'obj:text':
						$cont_node=$node;
						while (is_object($node) && $node->children_len()==1) {
							$node=$node->get_children(0);
							if ($node->get_name()!='_text') {
								$cont_node=$node;
							} else {
								break;
							}
						}
						$tmp_data=$xmlFastText->encodeText($node_data);

						if ($tmp_data===false) {
							$error=false;
						} else {
							$error=$xml->addText('<obj:parent>'.$tmp_data.'</obj:parent>',$cont_node->get_id(),true);
						}
						break;
					case 'obj:fasttext':
						$tmp_data=$xml->convertEndings($node_data);
						$tmp_data=$xmlFastText->encodeText($tmp_data);
						if ($tmp_data===false) {
							$error=false;
						} else {
							$error=$xml->addText('<obj:parent>'.$tmp_data.'</obj:parent>',$node->get_id(),true);
						}
						//debug($error);
						break;
					case 'obj:list':
						$cont_node=$node->get_children(0);
						$tmp_data=$xml->convertEndings(trim($node_data));
						$tmp_data="<list style='".$cont_node->get_attribs('style')."'>".$tmp_data."</list>";
						$tmp_data=$xmlFastText->encodeText($tmp_data);
						if ($tmp_data===false) {
							$error=false;
						} else {
							$error=$xml->addText('<obj:parent>'.$tmp_data.'</obj:parent>',$node->get_id(),true);
						}
						break;
					case 'obj:link':
						$attr=array();
						$tag_name='<link';
						if ($enode_typ[$node_id]=='int') {
							$attr['type']='int';
							$attr['url']=$enode_url_int[$node_id];
						} else {
							$attr['type']='ext';
							$attr['url']=$enode_url_ext[$node_id];
						}
						foreach ($attr as $key=>$val) {
							$tag_name.=" $key='".htmlspecialchars($val,ENT_QUOTES)."'";
						}
						if (!trim($node_data)) {
							if ($attr['type']=='ext') {
								$node_data=$attr['url'];
							} else {
								$url_obj=$Imng->getObj($attr['url']);
								if (is_object($url_obj)) {
									$node_data=$url_obj->getName();
								}
							}
						}
						$tmp_data=$xmlFastText->encodeText($xml->convertEndings($node_data));
						$tag_name.='>';
						$tag_name.=$tmp_data;
						$tag_name.='</link>';
						if ($tmp_data===false) {
							$error=false;
						} else {
							$error=$xml->addText('<obj:parent>'.$tag_name.'</obj:parent>',$node->get_id(),true);
						}
						break;
					case 'obj:image':
						$cont_node=$node->get_children(0);
						$attr=array();
						if ($enode_typ[$node_id]=='int') {
							$attr['link:type']='int';
							$attr['link:url']=$enode_url_int[$node_id];
						} elseif ($enode_typ[$node_id]=='ext') {
							$attr['link:type']='ext';
							$attr['link:url']=$enode_url_ext[$node_id];
						} elseif ($enode_typ[$node_id]=='none') {
							$attr['link:type']='none';
							$attr['link:url']='';
						}
						$attr['title']=$node_data;
						$attr['base']=$enode_base[$node_id];
						foreach ($attr as $key=>$val) {
							$attr[$key]=htmlspecialchars($val,ENT_QUOTES);
						}
						$xml->set_attribs ($cont_node->get_id(),$attr);
						break;
					case 'obj:download':
						$attr=array();
						$cont_node=$node->get_children(0);
						$attr['url']=$node_data;
						foreach ($attr as $key=>$val) {
							$attr[$key]=htmlspecialchars($val,ENT_QUOTES);
						}
						$xml->set_attribs ($cont_node->get_id(),$attr);
						break;

				}
				if ($error===false) {
					$ActionError['EncText']=true;
					$cont_errors[$node_id]=$node_data;
				}
			}
			$modify=true;
			if ($cont_save_x) {
				if (!$ActionError['EncText']) {
					$TmpContent['TimeModify']=$ContMeta['TimeModify']=time();
					$Content=$xml->getText(0,1,"","");
					$Imng->saveContent($ContID,$ContVersion,$Content);
					$obj->setMeta('TimeModify',$ContMeta['TimeModify']);
					$obj->setMeta('UserModify',$user_id);
					$Imng->updateMeta($obj);
					if ($Status==3) $Imng->setDocModified($Imng->getObjTreeIDs($obj->getParentMeta('ParentID'),$obj->getParentMeta('HeadID')),1);
					$Imng->deleteContentTemp($ContID);

					$images=$xmlFastText->searchImages($xml->get_node(0));
					$linked_objs=$Imng->getLinkedObj($obj->getMeta('Content'),true);
					foreach ($linked_objs as $link_obj) {
						$Bmng->deleteImgUsed($xmlFastText->getModul(),$link_obj->getID());
						foreach ($images as $imgFile=>$sizes) {
							if (is_array($sizes)) {
								$sizes=array_unique($sizes);
								foreach ($sizes as $val) {
									$Bmng->insertImgUsed($Bmng->getImgID($imgFile),$xmlFastText->getModul(),$link_obj->getID(),$val,$Bmng->getCfg('ImgPath'));
								}
							}
						}
					}

					$TmpContent['ContModified']=0;
				}
			} else {
				$TmpContent['ContModified']=1;
			}
			if ($img_save_x) {
				$mode='image';
			}
		}

	}
	if (!isset($OpenObjects[$Imng->getModul()][$obj->getID()])) {
		$frm->replaceOpenObjects($Imng->getModul(),$obj->getID());
		$OpenObjects=$frm->getOpenObjects();
	}
	if ($TmpContent['TimeModify']<$ContMeta['TimeModify']) {
		if ($ContIgnore) {
			$TmpContent['TimeModify']=$ContMeta['TimeModify'];
			$modify=true;
		} else {
			$tmp=$frm->getFullName($ContMeta['UserModify'],0,1);
			$ActionError['cont_conflict']=array(
				'CONF_USER'=>isset($tmp[$ContMeta['UserModify']])?$tmp[$ContMeta['UserModify']]:'-',
				'CONF_DATE'=>date('d.h.Y',$ContMeta['TimeModify']),
				'CONF_TIME'=>date('H:i:s',$ContMeta['TimeModify']),
				'L_CONF_RELOAD'=>$this_link."&ContReload=1",
				'L_CONF_IGNORE'=>$this_link."&ContIgnore=1",
			);
		}
	}


	$xmlFastText->init('edit');


	if ($save_x || $copy_x) {


	}
	unset($xml_text);
	$xmlFastText->setLink($this_link);


	switch ($mode) {
		case 'image':
			$node=$xml->get_node($cont_id);
			if (is_object($node) && $node->get_name()=='obj:image') {
				$cont_node=$node->get_children(0);
				$attr=$cont_node->get_attribs();
				//var_dump($attr);
				if (!$img_id) {
					if ($attr['base']=='space_edit.gif') {
						$img_id=-1;
					} else {
						$img_id=$Bmng->getImgID($attr['base']);
					}
				}
			}
			$t->define (array('tpl_card' => "wdoc_tpl_edit_image.inc.html"));
			require ('wdoc_tpl_edit_image.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
		default:
			$t->define (array('tpl_card' => "wdoc_tpl_view.inc.html"));
			require('wdoc_tpl_view.php');
			$t->parse('TPL_CARD','tpl_card');
			break;
	}
	if ($modify) {

		$Imng->saveContentTemp($ContID,$xml->getText(0,1,"",""),$TmpContent['TimeModify'],$TmpContent['ContModified']);
	}

} else {
	header ("Location:index.php?site=$site&oid=".$obj->getID());
	exit;
}
?>
