<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require_once('lib/class_ObjSelect.php');
$RecurNodes=array('paragraph','obj:table','table','row','col');
$xmlFastText->setLink($this_link);


$t->assign('THIS_URL',$this_link);
$t->assign('ROOT_ID',$root_id);
$t->assign('PAGE_WIDTH',$xmlFastText->getValue('page|width'));
$t->assign('PAGE_CLASS',$xmlFastText->getStyle('page|class|edit'));
$node=$xml->get_node(0);



$t->define (array('tpl_container' => "wdoc_tpl_container.inc.html"));
$tree=$Imng->ListAllTree($root_id,-1,'Sequence','ASC',$CFG['REDI']['Apps'],0);
$sel_int=new ObjSelect();
$sel_int->setTree($tree);
$sel_int->setObjClass('wcat','poption');
$sel_int->setObjClass('wfol','foption');
$sel_int->setClass('noption');
$sel_int->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');


$DlObj=$Imng->listDownloadRoots($root_id);
if (!empty($DlObj)) {
	$dl_tree=$Imng->ListAllTree(-1,array_keys($DlObj),'Sequence','ASC',array('wcat','wfol','ext'),0);
}
$sel_dl=new ObjSelect();
$sel_dl->setTree($dl_tree);
$sel_dl->setObjClass('wcat','poption');
$sel_dl->setObjClass('wfol','foption');
$sel_dl->setClass('noption');
$sel_dl->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');

printTpl($node);

$t->assign('TPL_PREVIEW','');

$t->assign('FORM_ACTION',$this_link);
if ($TmpContent['ContModified'] || $ActionError['EncText']) {
	$t->assign('L_BREAK_CONF','return confirm_cont()');
	$t->assign('SAVE_MODE','on');
} else {
	$t->assign('L_BREAK_CONF','return checkModified()');
	$t->assign('SAVE_MODE','off');
}
$t->assign('L_BREAK',"index.php?site=$site&oid=".$obj->getID().'&CloseObj='.$obj->getID()."&CloseMod=".$Imng->getModul());
$t->parse('ROW','break');
$t->parse('ROW','update');


$t->assign('TPL_TABLE_JS_MENU','');

function printTpl(&$node,$pos=0) {
	global $t,$RecurNodes,$xmlFastText,$sel_int,$sel_dl,$root_id,$cont_errors,$Bmng;
	static $i=0,$repeat_obj=array(),$rdepth=0;
	foreach ($node->get_children() as $num=>$list_node) {
		if ($i) {
			$t->assign('ROW_COLOR','#ffffff');
		} else {
			$t->assign('ROW_COLOR','#f2f2f2');
		}
		$name=$list_node->get_name();
		$node_id=$list_node->get_id();
		if ($list_node->get_attribs('repeat')) {
			$t->assign('REPEAT_SPC',str_repeat('&nbsp',$rdepth*4));
			$t->assign('REPEAT_TITLE',Framework::entities($list_node->get_attribs('rtitle')));
			$t->parse('ROW','obj_repeat_b');
			$t->parse('TPL_CONTAINER','tpl_container');
			$t->parse('ROW','.edit_list');
			$t->clear_dynamic('obj_repeat_b');
			$rdepth++;
		}


		if ($list_node->get_attribs('edit')) {
			$t->assign('LIST_TITLE',Framework::entities($list_node->get_attribs('title')));
			$t->assign('LIST_ID',$list_node->get_id());
			switch ($name) {
				case 'obj:title':
					$cont_node=$list_node->get_children(0);
					$t->assign('LIST_VALUE',htmlspecialchars($xmlFastText->decodeText($cont_node,1)));
					$t->assign('TXT_ROWS',$list_node->get_attribs('txt_rows')?$list_node->get_attribs('txt_rows'):1);
				break;
				case 'obj:text':
					$cont_node=$list_node->get_children(0);
					while (is_object($cont_node) && $cont_node->children_len()==1) {
							$cont_node=$cont_node->get_children(0);
					}
					
					$t->assign('LIST_VALUE',htmlspecialchars($xmlFastText->decodeText($cont_node,1)));
					$t->assign('TXT_ROWS',$list_node->get_attribs('txt_rows')?$list_node->get_attribs('txt_rows'):5);
				break;
				case 'obj:fasttext':
					$cont_node=$list_node;
					$t->assign('LIST_VALUE',htmlspecialchars($xmlFastText->decodeText($cont_node,1)));
					$t->assign('TXT_ROWS',$list_node->get_attribs('txt_rows')?$list_node->get_attribs('txt_rows'):5);
				break;
				case 'obj:list':
					$cont_node=$list_node->get_children(0);
					$t->assign('LIST_VALUE',htmlspecialchars($xmlFastText->decodeText($cont_node,1)));
					$t->assign('TXT_ROWS',$list_node->get_attribs('txt_rows')?$list_node->get_attribs('txt_rows'):5);
				break;
				case 'obj:link':
					$cont_node=$list_node->get_children(0);
					if ($cont_node->get_attribs('type')=='int') {
						$t->assign('LIST_URL_EXT','');
						$t->assign('LIST_TYPE_INT','checked');
						$t->assign('LIST_TYPE_EXT','');
						$sel_int->setSelectedID($cont_node->get_attribs('url'));
					} else {
						$t->assign('LIST_URL_EXT',$cont_node->get_attribs('url'));
						$t->assign('LIST_TYPE_INT','');
						$t->assign('LIST_TYPE_EXT','checked');
					}
					$t->assign('TREE_OPTION',$sel_int->parseSelect($root_id));
					$t->assign('LIST_VALUE',htmlspecialchars($xmlFastText->decodeText($cont_node,1)));
				break;
				case 'obj:image':
					$cont_node=$list_node->get_children(0);
					if ($list_node->get_attribs('edit_link') && $cont_node->get_attribs('base')!='space_edit.gif') {
						$t->assign('LIST_TYPE_INT','');
						$t->assign('LIST_TYPE_EXT','');
						$t->assign('LIST_TYPE_NONE','');
						$t->assign('LIST_URL_EXT','http://');
						if ($cont_node->get_attribs('link:type')=='int') {
							$sel_int->setSelectedID($cont_node->get_attribs('link:url'));
							$t->assign('LIST_TYPE_INT','checked');
						} elseif ($cont_node->get_attribs('link:type')=='ext') {
							$t->assign('LIST_URL_EXT',$cont_node->get_attribs('link:url'));
							$t->assign('LIST_TYPE_EXT','checked');
						} else {
							$t->assign('LIST_TYPE_NONE','checked');
						}
						$t->assign('TREE_OPTION',$sel_int->parseSelect($root_id));
						$t->parse('ROW','obj_image_link');
					} else {
						$t->clear_dynamic('obj_image_link');
					}
					$t->assign('LIST_VALUE',htmlspecialchars($cont_node->get_attribs('title')));
					$src=$Bmng->getCfg('ThumbPath').'/'.$cont_node->get_attribs('base');
					$t->assign('LIST_IMG_SRC',$src);
					if ($cont_node->get_attribs('base')=='space_edit.gif') {
						$t->assign('LIST_IMG_HEIGHT','height="4"');
					} else {
						$t->assign('LIST_IMG_HEIGHT','');
					}
					$t->assign('LIST_IMG_BASE',$cont_node->get_attribs('base'));

				break;
				case 'obj:download':
					$cont_node=$list_node->get_children(0);
					$sel_dl->setSelectedID($cont_node->get_attribs('url'));
					if ($list_node->get_attribs('folder')) {
						$t->assign('TREE_OPTION',$sel_dl->parseSelect($list_node->get_attribs('folder')));
					} else {
						$t->assign('TREE_OPTION',$sel_dl->parseSelect($root_id));
					}
				break;
			}
			if ($cont_errors[$node_id]) {
				$t->assign('LIST_VALUE',htmlspecialchars($cont_errors[$node_id]));
				$t->assign('LIST_CLASS','error');
			} else {
				$t->assign('LIST_CLASS','descb');
			}

			if ($i) {
				$i=0;
			} else {
				$i=1;
			}
			$bname=str_replace(':','_',$name);
			$t->parse('ROW',$bname);
			$t->parse('TPL_CONTAINER','tpl_container');
			$t->parse('ROW','.edit_list');
			$t->clear_dynamic($bname);

		}

		if (in_array($name,$RecurNodes)) {
			printTpl($list_node,$num);
		}
		if ($list_node->get_attribs('repeat')) {
			$rdepth--;
			$t->assign('REPEAT_SPC',str_repeat('&nbsp',$rdepth*4));
			$t->assign('REPEAT_ID',$list_node->get_id());
			if ($list_node->get_attribs('rdelete')) {
				$t->parse('ROW','obj_repeat_del');
			}
			$t->parse('ROW','obj_repeat_e');
			$t->parse('TPL_CONTAINER','tpl_container');
			$t->parse('ROW','.edit_list');
			$t->clear_dynamic('obj_repeat_e');
			$t->clear_dynamic('obj_repeat_del');
		}

	}
}
?>
