<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
//phpinfo();
//echo date('d.m.Y H:i:s',1302299999) ;
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
//debug($_COOKIE);
if ($auth->auth['uname']=='config') {
	require("config.php");
} else {
	if ($frm->getUserStatus()==1) {
		page_close();
		header('Location:locked.php');
		exit;
	}
	$frm->insertUserMsg(0,'',0,time());
	$T->loadModul('core');
	if ($frm->appExists('proj')) {
		$T->loadModul('proj');
		$T->loadModulSql('proj_rule');
	}
	$L->init('index.php');
	if ($auth->auth['uid']==$CFG['SUPERADMIN']) {
		$sadmin=1;
		$DB_version=$frm->getVersion('group-e');
		if ($DB_version['Version']!=$VERSION) {
			echo '<h3 align="center">Wrong Database Version : '.$DB_version['Version'].' - '.$DB_version['UpdateDate'].'<br />Please update your System</h1>';
		}
	} else {
		$sadmin=0;
	}
	if (!isset($SESS_MDATA)) $sess->register("SESS_MDATA");
	$SESS_AJAX=array();
	if (!$sess->is_registered("SESS_AJAX")) {
		$sess->register("SESS_AJAX");
	}
	if (!$SEND_AJAX) {
		$frm->initExtJs();
		$frm->addJsScript('js/core/l10n/core_'.$frm->getLang().'.js');
		require("lib/menu_img.inc.php");
	}
	$site=basename($site);
	if (!$frm->pwdTimeIsValid($REG_USER['pwd_time'],$REG_USER['shadowMax'])) {
		$site='prefs.php';
		$app_name='global';
		$ActionError['pwd_time']=1;
	}
	if (!$site || !file_exists($site) || $site=='config.php') {
		$t->assign('MOD_TITLE','ERROR');
		$t->setRoot("tpl/$THEME/$session_lang");
		$t->define (array('application' => "no_app.inc.html"));
	} else {
		if (!isset($SESS_MDATA[$site])) $SESS_MDATA=array();
		if (Framework::getParam('_clearM',0,'G')) {
			unset($SESS_MDATA[$site]);
		}
		require($site);
	}
	if ($SEND_AJAX) {
		require("lib/ajax_content.inc.php");
	} else {
		$int=5;
		if ($frm->getPrefs('global','mse') || $frm->getPrefs('email','msg')) {
			if ($frm->getPrefs('global','int')) $int=min($int,$frm->getPrefs('global','int'));
			if ($frm->getPrefs('email','msg_int')) $int=min($int,$frm->getPrefs('email','msg_int'));
		}
		$frm->initExtJs();
		$frm->useFrame(true);
		$frm->addOnload('startCronJobs('.($int*60*1000).',\'ajax_modul=cronJobs&site='.$site.($site=='portal.php'?"&view_id=$view_id":'').'\');');
		require("lib/content.inc.php");
	}
}
page_close();
?>