Ext.BLANK_IMAGE_URL = 'img/tras.gif';
Ext.ns('ge.translation');
$T = function(key) {
	//console.log(key);
	//console.log(ge.translation);
	if (ge.translation[key]) {
		return ge.translation[key];
	} else {
		return key;
	}
};

Ext.ns('ge.registry');
ge.alert = function(title,msg) {
	Ext.MessageBox.show({
		title : title,
		msg : msg,
		buttons: Ext.MessageBox.OK,
		icon: Ext.MessageBox.WARNING,
		minWidth:300
    });
};
ge.info = function(title,msg) {
	Ext.MessageBox.show({
		title : title,
		msg : msg,
		buttons: Ext.MessageBox.OK,
		icon: Ext.MessageBox.INFO,
		minWidth:300
    });
};


ge.registry.stateForms=[];

ge.getFormState = function(form) {
	return ge.getFormStateData(form.getId());
};
ge.getFormStateData = function(dataKey) {
	if (parent.hidden.stateFormData && parent.hidden.stateFormData[dataKey]) {
		return parent.hidden.stateFormData[dataKey];
	}
	return false;
};
ge.setFormState = function(form) {
	ge.setFormStateData(form.getId(),form.getForm().getValues());
};
ge.setFormStateData = function(dataKey,values) {
	if (parent.hidden.stateFormData) {
		parent.hidden.stateFormData[dataKey]=values;
	}
};
ge.clearFormState = function(form) {
	ge.clearFormStateData(form.getId());
};
ge.clearFormStateData = function(dataKey) {
	if (parent.hidden.stateFormData && parent.hidden.stateFormData[dataKey]) {
		delete parent.hidden.stateFormData[dataKey];
	}
};
ge.addFormState = function(form) {
	ge.registry.stateForms.push(form);
};

Ext.EventManager.on(window, 'beforeunload', function() {
	Ext.each(ge.registry.stateForms,function(form) {
		ge.setFormState(form);
	});
	//console.log(form);
});
Ext.state.Manager.setProvider(new Ext.state.CookieProvider());

Ext.onReady(function() {
    Ext.QuickTips.init();
});