<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
require_once('lib/lmng/header.php');
if (!$app["lmng"] || (!$Lmng->getPerms(1) && !$Lmng->getPerms(2))) {
	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
} else {
	$t->setRoot("tpl/$THEME/lmng/$session_lang");
	$user_id=$auth->auth['uid'];
	$root_id=0;
	if ($Lmng->getPerms(1)) {
		$root_obj_u=$Lmng->getSystemObj('u',$session_lang,$user_id,true);
		if (is_object($root_obj_u)) {
			$root_obj[$root_obj_u->getID()]=$root_obj_u;
			unset($root_obj_u);
		} else {
			$root_obj_u=$Lmng->getSystemObj('u',$CFG['AV_LANG'],0,false);
			if (is_object($root_obj_u)) {
				$Lmng->insertMeta($root_obj_u);
				$root_obj_u->setMeta('UserID',$user_id);
				$root_obj_u->setMeta('RootID',$root_obj_u->getID());
				$Lmng->updateMeta($root_obj_u);
				$root_obj[$root_obj_u->getID()]=$root_obj_u;
				unset($root_obj_u);
			}
		}
	}
	if ($Lmng->getPerms(2)) {
		$root_obj_s=$Lmng->getSystemObj('s',$session_lang,0,true);
		if (is_object($root_obj_s)) {
			$root_obj[$root_obj_s->getID()]=$root_obj_s;
			unset($root_obj_s);
		}
	}
	if (!$root_id || !isset($root_obj[$root_id])) {
		$oid=$root_id=key($root_obj);
		$obj=$Lmng->getObj($oid,$CFG['MA_LANG']);
	}
	$close=false;
	$rootObj=$root_obj[$root_id];
	if ($meta_save_x) {
		$fobj=$Lmng->getObj($ObjFolder);
		if (!is_object($fobj) || !$fobj->getAcl(2)) {
			$ActionError['no_write_perms']["ObjLink"]=$fobj->getID();

		}
		if (!trim($_POST['ObjLink'])) {
			$ActionError['fields']["ObjLink"]=true;
		}
		if (!trim($_POST['ObjTitle'])) {
			$ActionError['fields']["ObjTitle"]=true;
		}
		if (!$ActionError) {
			$new_obj=new LObj_link();
			$new_obj->setMeta('DocType','link');
			$new_obj->setMeta('Link',trim($_POST['ObjLink']));
			foreach ($CFG['AV_LANG'] as $val) {
				$new_obj->setMeta('Title_'.$val,trim($_POST['ObjTitle']));
			}
			$new_obj->setMeta('Text',$_POST['ObjText']);
			$new_obj->setMeta('MenuImage','bkm.gif');
			$new_obj->setMeta('TimeCreate',time());
			$new_obj->setMeta('TimeModify',time());
			$new_obj->setMeta('UserCreate',$user_id);
			$new_obj->setMeta('UserModify',$user_id);
			$new_obj->setMeta('Users',$fobj->getMeta('Users'));
			$new_obj->setMeta('Groups',$fobj->getMeta('Groups'));
			$new_obj->setMeta('ParentID',$fobj->getID());
			$new_obj->setMeta('RootID',$fobj->getMeta('RootID'));
			$new_obj->setMeta('UserID',$fobj->getMeta('UserID'));
			$Lmng->insertMeta($new_obj);
			if ($FavInsert) {
				$new_obj->setParentMeta('Favorite',1);
				$Lmng->insertParentMeta($new_obj);

			}
			$close=true;

		}

	} else {
		$temp=$Lmng->FetchHtml($ObjLink,$session_lang);
		if (is_array($temp)) {
			extract($temp);
		}
	}
	$t->define(array('application'=>'js_add_link.inc.html'));
	if (!$close) {
		require("lib/class_form.inc.php");
		require_once('lib/class_ObjSelect.php');
		$txt_link=new TextField('ObjLink','size="30" class="sel" style="width:400px"');
		$t->assign('OBJ_LINK',$txt_link->f());
		if ($ActionError['fields']["ObjLink"]) {
			$t->assign('C_LINK','error');
		} else {
			$t->assign('C_LINK','');
		}
		$txt_title=new TextField("ObjTitle",'size="30" class="sel" style="width:400px"');
		$t->assign('OBJ_TITLE',$txt_title->f());
		$t->assign('OBJ_TITLE_LANG',strtoupper(''));
		if ($ActionError['fields']["ObjTitle"]) {
			$t->assign('C_TITLE','error');
		} else {
			$t->assign('C_TITLE','');
		}
		$sel_int=new ObjSelect();
		$sel_int->setClass('noption');
		$sel_int->setSelectedID($ObjFolder);
		$sel_int->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');


		$tree_apps=array('fol');
		$option_tree='';
		foreach ($root_obj as $key=>$val) {
			$sel_int->setTree($Lmng->ListAllTree($key,-1,'Title_'.$session_lang,'ASC',$tree_apps));
			$option_tree.=$sel_int->parseSelect($val->getMeta('ParentID'));
		}
		$t->assign('TREE_FOLDER',$option_tree);
		unset($option_tree);
		if ($ActionError['no_write_perms']["ObjLink"]) {
			$t->assign('C_FOLDER','error');
		} else {
			$t->assign('C_FOLDER','');
		}

		$txt_desc=new TextArea('ObjText','rows="7" cols="36" class="sel" style="width:400px;"');
		$t->assign('OBJ_DESC',$txt_desc->f());

		$chk_fav=new CheckBox ('FavInsert','',1);
		$t->assign('CHK_FAV',$chk_fav->f(1));

		$t->parse('ROW','update');
		$t->assign('L_BREAK','javascript:window.close();');
		$t->parse('ROW','break');

		$t->assign('FORM_ACTION','js_addLink.php');

		if ($ActionError) {
			require('lmng/view_error.php');
		} else $t->assign('TPL_ERROR','');
		$t->parse('ROW','win_view');
	} else {
		$t->parse('ROW','win_close');
	}
}
$t->parse('CONTENT','application');
$t->fastprint();
page_close();
?>
