<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$header=array();
$translation=array();
$translation_json='{}';
if ($_GET['init']) {
	require("cfg/global.inc.php");
	require("lib/head_auth.php");
	require("lib/parse_config.inc.php");
	$init='1';
	if ($frm->getMyApps('asx')) {
		$T->loadModul('asx');
		$translation['asx_transfer']=$T->lang('[[AnrufWeiterleiten]]');
		$translation['asx_newcall']=$T->lang('[[NeuerAnruf]]');
		$translation['asx_answer']=$T->lang('[[AnrufAbheben]]');
		$translation['asx_hangup']=$T->lang('[[AnrufAuflegen]]');


		$header[]='<script src="js/asx/ctrl/asxCtrlPoller.js?v='.(GE_VERSION).'" type="text/javascript"></script>';
	}
	$int=5;
	if ($frm->getPrefs('global','mse') || $frm->getPrefs('email','msg')) {
		if ($frm->getPrefs('global','int')) $int=min($int,$frm->getPrefs('global','int'));
		if ($frm->getPrefs('email','msg_int')) $int=min($int,$frm->getPrefs('email','msg_int'));
	}
	$translation_json=Framework::array2json($translation);
} else {
	$init='0';
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
	<script src="add-on/jquery/js/jquery.min.js?version=1.722" type="text/javascript"></script>
	<script src="add-on/jquery/js/jquery-ui.custom.min.js?version=1.722" type="text/javascript"></script>
	<script type="text/javascript">
		var stateFormData={};
		var grpInit=<?php echo $init?>;
		var grpError=false;
		var grpWin=parent.main;
		var geTranslation=<?php echo $translation_json?>;
	</script>
	<?php echo implode("\n",$header);?>
</head>
<body>
<div id="jsInfoBox"></div>
</body>