<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
require_once("lib/imng/header.php");
require_once('lib/class_ObjSelect.php');
$Imng->setLangID($BL);
$t->setRoot("tpl/$THEME/imng/$session_lang");
$t->define(array('application'=>'js_link.inc.html'));


if (!$url_ext) $url_ext="http://";
if ($Titel) $node_data=$Titel;
$t->assign('NODE_DATA',htmlspecialchars($node_data));
$t->assign('URL_EXT',htmlspecialchars($url_ext));
$t->assign('LINK_SEARCH',htmlspecialchars($link_search));

if (!$root_id) {
	//$tree_root=$Web->ListSubEntrys($Web->getSite(),array('wcat'));
	//$tree=$Web->ListAllTree(array_keys($tree_root),-1,'Sequence','ASC',$CFG['REDI']['Apps'],0);
} else {
	$tree=$Imng->ListAllTree($Imng->getLangID(),$root_id,-1);
}
$sel_int=new ObjSelect();
$sel_int->setTree($tree);
$sel_int->setObjClass('fol','foption');
$sel_int->setClass('noption');
if ($l_type=='int') {
	$sel_int->setSelectedID($url_int);
}
$sel_int->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');
if (!$root_id) {
	$t->assign('TREE_OPTION',$sel_int->parseSelect(0));
} else {
	$t->assign('TREE_OPTION',$sel_int->parseSelect($root_id));
}
if ($link_search) {
	$rows=0;
	$sql_search=$db->formatSearch($link_search,array('Title_'.$Imng->getLangID(),'Text'));
	if (!$root_id) {
		//$sql_search.=' AND RootID IN ('.implode(',',array_keys($tree_root)).')';
	} else {
		$sql_search.=' AND RootID='.intval($root_id);
	}
	$search_array=$Imng->searchObj ($rows,0,10,$sql_search,'Title_'.$Imng->getLangID());
	foreach ($search_array as $search_obj) {
		$t->assign('S_KEY',$search_obj->getID());
		$t->assign('S_IMG',$search_obj->getImage(0));
		$t->assign('S_TITLE',Framework::entities($search_obj->getName()));
		$t->parse('ROW','.l_search_row');
	}
	$l_type='int';
}


if ($l_type=='int') $t->assign('ATTR_TYPE_INT','checked'); else $t->assign('ATTR_TYPE_INT','');
if ($l_type=='ext' || !$l_type) $t->assign('ATTR_TYPE_EXT','checked'); else $t->assign('ATTR_TYPE_EXT','');

$t->assign('ROOT_ID',$root_id);

$t->parse('CONTENT','application');
$t->fastprint();
page_close();
?>
