<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$limit=10;
$limit_e=0;
require("cfg/global.inc.php");
require("lib/head_auth.php");
require("lib/parse_config.inc.php");
$t->setRoot("tpl/$THEME/$session_lang");
$t->define(array('application'=>'js_user.inc.html'));

$this_link="js_user.php?modul=$modul&mult=$mult&field=$field&form=$form&prep=$prep&jsub=$jsub";
$info=trim($info);
$group_id=intval($group_id);
$t->assign('INFO',htmlspecialchars($info));
$t->assign('JS_FIELD',$field);
$t->assign('JS_FORM',$form);
$t->assign('JS_JSUB',intval($jsub));
if (!$modul) $modul='objmng';
if (!isset($b)) $b=0;
$rows=0;
if ($info || $group_id) {
	if ($group_id) {
		$susers=$frm->getGroupUsers($group_id);
	} else {
		$susers=0;
	}
	$user_list=$frm->searchUser($rows,$info,$susers,0,$b,$limit,true,true);

} else {
	$hot_user=$frm->getHotlist($modul,($limit-$limit_e),$limit_e);
	if (count($hot_user)) {
		$user_list=$frm->searchUser($rows,'',$hot_user,0,0,0,false,true);
	}
}
if (is_array($user_list)) {
	$i=0;
	foreach ($user_list as $key=>$val) {
		if ($i%2) $t->assign('ROW_COLOR','#f2f2f2');
		else $t->assign('ROW_COLOR',$bgcolor);
		$t->assign('L_INSERT',"javascript:setUser('".$prep.''.$key."');");
		$t->assign('N_USER',Framework::entities($val['lastname'].' '.$val['firstname']));
		if ($mult) {
			$t->assign('CHK_USER','<input type="checkbox" name="user_chk" value="'.$key.'">');
		} else $t->assign('CHK_USER','&nbsp;');
		$t->parse('ROW','.user_row');
		$i++;
	}
	if ($mult) {
		$t->parse('ROW','mult_insert');
	}
	if ($rows>$limit) {
		$t->assign('L_NEXT',$this_link."&b=".($b+$limit)."&group_id=$group_id&info=".urlencode($info));
		$t->parse('ROW','next');
	}
	if ($b>0) {
		$t->assign('L_PREV',$this_link."&b=".($b-$limit)."&group_id=$group_id&info=".urlencode($info));
		$t->parse('ROW','prev');
	}
}
$groups_array=$frm->getAllGroups();
foreach ($groups_array as $key=>$val) {
	if ($key==$CFG['GROUP_ALL']) continue;
	if ($group_id==$key) $t->assign('SEL_CHK','selected');
	else  $t->assign('SEL_CHK','');
	$t->assign('SEL_KEY',$key);
	$t->assign('SEL_VAL',Framework::entities($val));
	$t->parse('ROW','.group_row');
}
$t->assign('FORM_ACTION',$this_link);
$t->parse('CONTENT','application');
$t->fastprint();
page_close();
?>
