<?php
class ObjAddrList extends baseObj {
	var $_action=array('l','l'); // to owerwrite;
	var $_site='addr.php'; // to owerwrite;
	var $_obj_typ='0';
	/* to owerwrite*/
	function ObjAddrList($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return true;
	}
	function getName() {
		return $this->_meta['Title'];
	}
	function getImage($open=0) {
		if ($this->_meta['isPrivat']) {
			return 'user.gif';
		} else {
			return 'gruppe.gif';
		}
	}
}

class AddrLdapList extends ObjCore {
	var $_modul='addr';
	var $_table='AddrSearchLdap';
	var $_cfgObjects=array (
		'IdField'=>'SearchID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'Users',
		'GroupField'=>'Groups',
		'OwnerField'=>'FKUserID',
		'0'=>array(
			'ClassName'=>'ObjAddrList',
			'Fields'=>array(
				'SearchID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'FKUserID'=>array(
					'Typ'=>'core',
					'Extra'=>'cUser',
				),
				'Groups'=>array(
					'Typ'=>'core',
				),
				'Users'=>array(
					'Typ'=>'core',
				),
				'Title'=>array(
					'Typ'=>'text',
					'Name'=>'[[Titel]]',
					'Required'=>3,
				),
				'isPrivat'=>array(
					'Typ'=>'check',
					'Name'=>'[[privatList]]',
				),
				'Sdata'=>array(
					'Typ'=>'core',
				),
				'Mlist'=>array(
					'Typ'=>'check',
					'Name'=>'[[Als E-Mail Liste verwenden]]',
					'Application'=>'email',
				),
				'Flist'=>array(
					'Typ'=>'check',
					'Name'=>'[[Als Fax Liste verwenden]]',
					'Application'=>'fax',
				),
			),
		),
	);

	function AddrLdapList () {
		global $frm;
		parent::ObjCore();
	}
	function setSite($site) {
		$this->_site=$site;
	}
	function getSite() {
		return $this->_site;
	}
	function listSearch(&$rows,$onlyMyList=false,$onlyMail=false,$onlyFax=false) {
		$search=array();
		if ($onlyMyList) $search[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_uid);
		if ($onlyMail) $search[]=array('Field'=>'Mlist','Typ'=>'=','Values'=>1);
		if ($onlyFax) $search[]=array('Field'=>'Flist','Typ'=>'=','Values'=>1);
		//print_r($this->_db->getWhere($search));
		return $this->searchObj ($rows,$search,'Title');
	}

}
?>
