<?php
class ObjAddrLdapServer extends baseObj {
	var $_action=array('l','l'); // to owerwrite;
	var $_site='addr.php'; // to owerwrite;
	var $_obj_typ='0';
	/* to owerwrite*/
	function ObjAddrLdapServer($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['Title'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class AddrLdapServer extends ObjCore {
	var $_modul='addr';
	var $_table='AddrServerMetabase';
	var $_cfgObjects=array (
		'IdField'=>'ID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'PermsUser',
		'GroupField'=>'PermsGroup',
		'OwnerField'=>'',
		'0'=>array(
			'ClassName'=>'ObjAddrLdapServer',
			'Fields'=>array(
				'ID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'Sequence'=>array(
					'Typ'=>'core',
				),
				'PermsGroup'=>array(
					'Typ'=>'core',
				),
				'PermsUser'=>array(
					'Typ'=>'core',
				),
				'Title'=>array(
					'Typ'=>'text',
					'Name'=>'[[Name]]',
					'Required'=>3,
					'fGroup'=>1,
				),
				'Server'=>array(
					'Typ'=>'text',
					'Name'=>'Server',
					'Required'=>3,
					'fGroup'=>1,
					'Default'=>'localhost',
				),
				'Port'=>array(
					'Typ'=>'text',
					'Name'=>'Port',
					'Required'=>3,
					'fGroup'=>1,
					'Default'=>'389',
				),
				'LdapVersion'=>array(
					'Typ'=>'select',
					'Name'=>'Ldap-Version',
					'Required'=>3,
					'fGroup'=>1,
					'Values'=>array(2=>'2',3=>'3'),
					'Default'=>'3',
				),
				'Security'=>array(
					'Typ'=>'select',
					'Name'=>'[[Sicherheit]]',
					'Required'=>0,
					'fGroup'=>1,
					'Values'=>array(0=>'-',1=>'TLS'),
					'Default'=>'0',
				),
				'BaseDN'=>array(
					'Typ'=>'text',
					'Name'=>'BaseDN',
					'Required'=>3,
					'fGroup'=>2,
				),
				'BindDN'=>array(
					'Typ'=>'text',
					'Name'=>'BindDN',
					'Required'=>0,
					'fGroup'=>2,
				),
				'BindPwd'=>array(
					'Typ'=>'pwd',
					'Name'=>'[[Password]]',
					'Required'=>0,
					'fGroup'=>2,
				),
				'isPrivat'=>array(
					'Typ'=>'check',
					'Name'=>'[[istPrivatesAddr]]',
					'Required'=>0,
					'fGroup'=>2,
				),

			),
		),
	);
	function AddrLdapServer () {
		parent::ObjCore();
		global $frm;
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','addr')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
	}
	function &listServers() {
		$rows=0;
		return $this->searchObj ($rows,$searchQuery,'Sequence ASC',0,0,false,false,false);
	}
	function &listMyServers() {
		$rows=0;
		return $this->searchObj ($rows,$searchQuery,'Sequence ASC',0,0,false,true,false);
	}
	function getNextSequence() {
		$query="SELECT max(Sequence) as num FROM AddrServerMetabase";
		$query.=" GROUP BY ID";
		$this->_db->query($query);
		$this->_db->next_record();
		return intval($this->_db->f('num') + 1);
	}
	function moveSequence ($ID,$dir='down') {
		return $this->_db->moveEntry ('AddrServerMetabase','ID','Sequence',$ID,$dir);
	}


}
?>
