<?php
class AddrLdapAdminGui {
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	function AddrLdapAdminGui() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=& $frm->getStaticModul('addr_server');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('addr');
	}
	function _handleRequest() {
		$this->_mode=Framework::getParam('mode','server','G');
		$this->_oid=Framework::getParam('oid',0,'G');
		$this->_obj_action='addr_ldap_'.$this->_mode;
		switch ($this->_mode) {
			case 'server':
				$this->_action=Framework::getParam('action','l','G');
				if ($this->_oid) {
					$this->_Obj=$this->_Base->getObj($this->_oid);
					if (!is_object($this->_Obj)) {
						unset($this->_Obj);
					}
				}
				if (Framework::getParam('_clTab',0,'G')) {
					$this->setPrefs('showtab',Framework::getParam('_clTab',0,'G'));
				}
				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->unsetParam(array('oid'));
							$this->_L->setParam('action','e');
							$this->_L->goToLink();
						break;
						case 'delete':
							if (is_object($this->_Obj)) {
								$this->_Base->deleteMeta($this->_Obj);
								$this->_L->unsetParam(array('oid'));
								$this->_L->setParam('action','l');
								$this->_L->goToLink();
							}
						break;
						default:
							debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
			break;
			case 'addr_crm':
				$this->_action=Framework::getParam('action','b','G');
				//$this->_frm->addJsScript('tpl/'.APP_THEME.'/cjs/applicationPrj.js');
				$this->_UserFormFieldsGui=& $this->_frm->getStaticGuiModul('uform','UserFormFieldsGui');
				$GuiCfg=array(
					'showUseSearch'=>0,
					'showUseList'=>0,
					'showUseQuick'=>0,
					'usePerms'=>1,
					'useMaxLen'=>1,
					'showUseMultiple'=>0,
					'showVisibility'=>0,
					'isLdap'=>1,
					'extraFieldMeta'=>array(
						'LdapServer'=>array(
							'typ'=>'checklist_v',
							'values'=>Framework::extractObjName($this->_Base->listServers()),
							'title'=>$this->_T->lang('[[Adressbuecher]]'),
							'handle'=>'fields2',
							'exFTyp'=>array('group'),
						),
					),
				);


				$this->_UserFormFieldsGui->setGuiCfg($GuiCfg);
				$this->_UserFormFieldsGui->loadSystemObj('addrldap');
			break;
		}
	}
	function isAllowedAction(&$obj,$action) {
		if ($action['Hidden']) return false;
		if (in_array('ID',$action['Extra']) && ($this->_action!='e' || !is_object($obj))) return false;
		return true;
	}
	function &getAdminHeader() {
		require_once("lib/class_ContentGui.php");
		$hGui=new ContentGui();
		$hGui->setName($this->_frm->getAppName('addr'));
		$hGui->addTab('server',$this->_T->lang('[[Adressbuecher]]'),"index.php?site=admin.php&ac=addr_ldap&mode=server");
		$hGui->addTab('addr_crm',$this->_T->lang('[[CRM - Daten]]'),"index.php?site=admin.php&ac=addr_ldap&mode=addr_crm");
		$hGui->setTabOn($this->_mode);
		require_once('lib/class_FunctionObjActionGui.php');
		$objActionGui=new FunctionObjActionGui();
		if ($this->_obj_action) {
			$obj_action=$this->_frm->getObjAction('admin',$this->_obj_action);
			$parse=false;
			foreach ($obj_action as $key=>$val) {
				if ($val['Hidden']) continue;
				if (!$this->isAllowedAction($this->_Obj,$val)) continue;
				$parse=true;
				$objActionGui->addValue($key,$val['Name']);
			}
			if ($parse) $hGui->addFunction($objActionGui);
		}
		return $hGui;
	}
	function process(&$AppGui) {
		$this->_handleRequest();
		$AppGui->addContent($this->getAdminHeader());

		switch ($this->_mode) {
			case 'server':
				switch ($this->_action) {
					case 'e':
						$AppGui->addContent($this->showEditServer());
					break;
					default:
						$AppGui->addContent($this->showListServer());
					break;
				}
				$AppGui->addContent($this->_Gui);
			break;
			case 'addr_crm':
				$Gui=$this->_UserFormFieldsGui->process();
				$AppGui->addContent($Gui);
			break;
			case 'addr_crm_schema':
				$AppGui->addContent($this->showCrmShema());
			break;
		}
		$AppGui->setFormAction($this->_L->getLink());
	}
	function &showListServer() {
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_ApplicationListGui.php');
		if (Framework::getParam('moveUp_x','0','P')) {
			$key=key($tmpArray=Framework::getParam('moveUp_x',0,'P'));
			if ($key) {
				$this->_Base->moveSequence($key,'up');
			}
		}
		if (Framework::getParam('moveDown_x','0','P')) {
			$key=key($tmpArray=Framework::getParam('moveDown_x',0,'P'));
			if ($key) {
				$this->_Base->moveSequence($key,'down');
			}
		}
		$entries=$this->_Base->listServers();
		$Gui=new ApplicationListGui();
		$Gui->setName($this->_T->lang('[[Adressbuecher]]'));
		$Gui->setLimit(0);
		$Gui->addHeaderCol('Title',$this->_T->lang('[[Name]]'),'','','',0,0,3);
		$Gui->addHeaderCol('Privat',$this->_T->lang('[[Privat]]'),'','','',1);
		$Gui->addHeaderCol('Server','Server','','','',1);
		$Gui->addHeaderCol('Port','Port','','','',1);
		$Gui->addHeaderCol('BaseDN','BaseDN','','','',1);
		foreach ($entries as $key=>$val) {
			$Gui->addRow($val->getID()==$this->_oid?2:($hl?$hl=0:$hl=1));
			$btn_up=new SubmitImgBtn ('moveUp_x['.$key.']','img/'.APP_THEME.'/rs_up.gif');
			$Gui->addCol('up',$btn_up);
			$btn_down=new SubmitImgBtn ('moveDown_x['.$key.']','img/'.APP_THEME.'/rs_down.gif');
			$Gui->addCol('down',$btn_down);
			$Gui->addCol('Title',$val->getName(),'',$this->_L->getTempLink(null,array('oid'=>$val->getID(),'action'=>'e')),'',0,2000);
			$Gui->addCol('Privat',$val->getMeta('isPrivat')?'X':'','','','center',1);
			$Gui->addCol('Server',$val->getMeta('Server'),'','','',1);
			$Gui->addCol('Port',$val->getMeta('Port'),'','','',1);
			$Gui->addCol('BaseDN',$val->getMeta('BaseDN'),'','','',1);
		}
		return $Gui;
	}
	function &showEditServer() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_Obj) {
			$Gui->setName($this->_T->lang('[[Neues Adressbuch anlegen]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(null,array('action'=>'l'))));
		} else {
			$Gui->setName($this->_T->lang('[[Adressbuch bearbeiten]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'l'))));
			$tabs[]='perms';
		}
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_mode.'|showtab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('showtab'));
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getMetaGui());
		}
		if (in_array('perms',$tabs)) {
			$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
			$box->setTabContent('perms',$this->getPermsGui());
		}
		$show_tap=$this->getPrefs('showtab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &showCrmShema() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$Gui->setName('Ldap Schema');
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$avClasses=array();
		$BaseForm=& $this->_frm->getStaticModul('uform');
		$uformObj=$BaseForm->getSystemForm('addrldap');
		$BaseFields=& $this->_frm->getStaticModul('uform_fields');
		$BaseFields->setFormObj($uformObj);
		$crmFields=$BaseFields->listFormFields(true,'FieldID');
		foreach ($crmFields[0] as $gid=>$crmGroup) {
			if (is_array($crmFields[$gid])) {
				foreach ($crmFields[$gid] as $fid=>$crmField) {
					$avClasses[$crmField->getMeta('RefClass')]=$crmField->getMeta('RefClass');
				}
			}
		}


		$formGui=new FormGui();
		$key='schemaID';
		$formGui->addField($key,'text','Schema Base OID','','');
		$formGui->setRequired($key);

		$key='schemaClass';
		$formGui->addField($key,'select','Schema Objectclass','','');
		$formGui->setValues($key,$avClasses);
		$formGui->setRequired($key);

		$formGui->addField('generate','submit','','Generate','');

		$tplContent->addContent('content',$formGui,'CONTENT');

		if (Framework::getParam('generate','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$baseClass=$formGui->getFieldVal('schemaClass');
				$baseOid=$formGui->getFieldVal('schemaID');
				$pos=strrpos($baseOid,".");
				$idClass=$id=intval(substr($baseOid,$pos+1));
				$baseOid=substr($baseOid,0,$pos);
				$parsedFields=array();
				foreach ($crmFields[0] as $gid=>$crmGroup) {
					if (is_array($crmFields[$gid])) {
						foreach ($crmFields[$gid] as $fid=>$crmField) {
							if ($crmField->getMeta('RefClass')!=$baseClass) continue;
							$id++;
							$result.="\nattributetype ($baseOid.$id ";
							$result.="\n\t\tNAME '".$crmField->getMeta('RefID')."' ";
							$parsedFields[]=$crmField->getMeta('RefID');
							switch ($crmField->getMeta('Typ')) {
								case 'text':
									$result.="\n\t\tEQUALITY caseIgnoreMatch ";
									$result.="\n\t\tSUBSTR caseIgnoreSubstringsMatch ";
									$result.="\n\t\tORDERING caseIgnoreOrderingMatch ";
									$result.="\n\t\tSYNTAX 1.3.6.1.4.1.1466.115.121.1.15{256} ";
									$result.="\n\t\tSINGLE-VALUE ) ";
								break;
								case 'area':
									$result.="\n\t\tEQUALITY caseIgnoreMatch ";
									$result.="\n\t\tSUBSTR caseIgnoreSubstringsMatch ";
									$result.="\n\t\tORDERING caseIgnoreOrderingMatch ";
									$result.="\n\t\tSYNTAX 1.3.6.1.4.1.1466.115.121.1.15 ";
									$result.="\n\t\tSINGLE-VALUE ) ";
								break;
								case 'check':
									$result.="\n\t\tEQUALITY integerMatch ";
									$result.="\n\t\tSYNTAX 1.3.6.1.4.1.1466.115.121.1.27 ";
									$result.="\n\t\tSINGLE-VALUE ) ";
								break;
								case 'select':
									$result.="\n\t\tEQUALITY caseExactMatch ";
									$result.="\n\t\tORDERING caseExactOrderingMatch ";
									$result.="\n\t\tSYNTAX 1.3.6.1.4.1.1466.115.121.1.15 ";
									$result.="\n\t\tSINGLE-VALUE ) ";
								break;
								case 'mselect':
									$result.="\n\t\tEQUALITY caseExactMatch ";
									$result.="\n\t\tORDERING caseExactOrderingMatch ";
									$result.="\n\t\tSYNTAX 1.3.6.1.4.1.1466.115.121.1.15 ) ";
								break;
								case 'date':
									$result.="\n\t\tEQUALITY generalizedTimeMatch ";
									$result.="\n\t\tORDERING generalizedTimeOrderingMatch ";
									$result.="\n\t\tSYNTAX 1.3.6.1.4.1.1466.115.121.1.24 ";
									$result.="\n\t\tSINGLE-VALUE ) ";
								break;
								case 'int':
									$result.="\n\t\tEQUALITY integerMatch ";
									$result.="\n\t\tORDERING integerOrderingMatch ";
									$result.="\n\t\tSYNTAX 1.3.6.1.4.1.1466.115.121.1.27 ";
									$result.="\n\t\tSINGLE-VALUE ) ";
								break;
							}
						}
					}
				}
				$result.="\n\nobjectClass ($baseOid.$idClass ";
				$result.="\n\t\tNAME '".$baseClass."' ";
				$result.="\n\t\tSUP top ";
				$result.="\n\t\tAUXILIARY ";
				$result.="\n\t\tMAY ( ";
				$result.="\n\t\t".implode(' $'."\n\t\t",$parsedFields).' ) ) ';

				$display='<div style="background-color:#fff;padding:5px;"><pre>'.$result.'</pre></div>';
				$tplContent->addContent('content1',$display,'CONTENT');

			}

		}


		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getMetaGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		if (!$this->_Obj) {
			$req_check=1;
		} else {
			$req_check=2;
		}
		foreach ($this->_Base->getObjFields(0) as $key=>$val) {
			switch ($val['Typ']) {
				case 'date':
				case 'text':
				case 'area':
				case 'check':
				case 'select':
				case 'curr':
				case 'int':
				case 'pwd':
					$formGui->addField($key,$val['Typ'],$this->_T->lang($val['Name']),$this->_Obj?$this->_Obj->getMeta($key):$val['Default'],'fields'.$val['fGroup']);
					if ($val['Required']&$req_check) $formGui->setRequired($key);
					if ($val['Callback']) $formGui->setCallback($key,array(&$this,$val['Callback']));
					if ($val['Attribs']) $formGui->setAttribs($key,$val['Attribs']);
					if ($val['Values']) {
						if (is_array($val['Values'])) {
							$formGui->setValues($key,$val['Values']);
						} else {
							$formGui->setValues($key,$this->$val['Values']());
						}
					}
				break;
			}
		}
		$formGui->addField('meta_save_x','submit','',$this->_T->lang('[[Speichern]]'),'fields3');
		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if (is_object($this->_Obj)) {
					$formGui->addMetaToObj($this->_Obj);
					$this->_Base->updateMeta($this->_Obj);
					$this->_L->goToLink();
				} else {
					$this->_Obj=new ObjAddrLdapServer();
					$formGui->addMetaToObj($this->_Obj);
					$this->_Obj->setMeta('Sequence',$this->_Base->getNextSequence());
					$this->_Base->insertMeta($this->_Obj);
					$this->_L->setParam('oid',$this->_Obj->getID());
					$this->_L->setParam('_clTab','perms');
					$this->_L->goToLink();
				}
			}

		}
		//debug($this->_E->isError());
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		return $tplContent;
	}
	function getPermsGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		$av_perms=array(
			1=>$this->_T->lang('[[Lesen]]'),
			3=>$this->_T->lang('[[Schreiben]]'),
		);

		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		$key='addPermsUser';
		$mode='u|g';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);

		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,'','fields1');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));
		$formGui->addField('addPermsID','radiolist_v',$this->_T->lang('[[Rechte]]'),1,'fields1');
		$formGui->setValues('addPermsID',$av_perms);


		$formGui->addField('perms_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields1');

		$error=0;
		$perms_g=Framework::aclToArray($this->_Obj->getMeta('PermsGroup'));
		$perms_u=Framework::aclToArray($this->_Obj->getMeta('PermsUser'));
		$update=false;
		if (Framework::getParam('perms_add',0,'P') && trim($formGui->getFieldVal('addPermsUser'))) {
			$permsUsers=explode('|',$formGui->getFieldVal('addPermsUser'));
			foreach ($permsUsers as $val) {
				$tmp=explode('_',$val);
				if ($tmp[0]=='u') {
					$perms_u[$tmp[1]]=Framework::getParam('addPermsID',0,'P');
					$update=true;
				}
				if ($tmp[0]=='g') {
					$perms_g[$tmp[1]]=Framework::getParam('addPermsID',0,'P');
					$update=true;
				}
			}
		}
		if(is_array(Framework::getParam('permDeleteG_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteG_x',0,'P'));
			if ($key) {
				unset($perms_g[$key]);
				$update=true;
			}
		}
		if(is_array(Framework::getParam('permDeleteU_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteU_x',0,'P'));
			if ($key) {
				unset($perms_u[$key]);
				$update=true;
			}
		}
		if ($update) {
			$this->_Obj->setMeta('PermsGroup',Framework::arrayToAcl($perms_g));
			$this->_Obj->setMeta('PermsUser',Framework::arrayToAcl($perms_u));
			$this->_Base->updateMeta($this->_Obj);
			$this->_L->goToLink();
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$gui1=$this->listPerms('PermsGroup',$perms_g,$av_perms,0);
		$tplContent->addContent('form3_2',$gui1,'FORM3');
		$gui2=$this->listPerms('PermsUser',$perms_u,$av_perms,0);
		$tplContent->addContent('form3_3',$gui2,'FORM3');
		return $tplContent;
	}
	function &listPerms($ptype,$perms,$av_perms,$perm_mode=0,$prep='perm') {
		if (!empty($perms)) {
			require_once('lib/class_ApplicationListGui.php');
			$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
			$tabGui->setName($this->_T->lang('[[Rechte]]'));
			switch ($ptype) {
				case 'PermsGroup':
					$title=$this->_T->lang('[[Gruppen]]');
					$perms_users=$this->_frm->getAllGroups(array_keys($perms));
					$img='gruppe.gif';
					$dbtn=$prep.'DeleteG_x';
				break;
				case 'PermsUser':
					$title=$this->_T->lang('[[BenutzerInnen]]');
					$perms_users=$this->_frm->getFullName(array_keys($perms),0,1);
					$img='user.gif';
					$dbtn=$prep.'DeleteU_x';
				break;
			}
			$tabGui->addHeaderCol('Name',$title,'','','',0,'',2);
			foreach ($av_perms as $pkey=>$pval) {
				$tabGui->addHeaderCol('Perms_'.$pkey,$pval,'','','',1);
			}
			$tabGui->addHeaderCol('Delete','','tras.gif');
			$tabGui->setLimit(0);
			$rows=0;$hl=0;
			foreach ($perms as $key=>$val) {
				//debug($val);
				$hl=$hl?0:1;
				$tabGui->addRow($hl);
				$tabGui->addCol('IMG','',$img);
				$tabGui->addCol('Name',$perms_users[$key],'','','',0,'2000');
				foreach ($av_perms as $pkey=>$pval) {
					if ($perm_mode) {
						$tabGui->addCol('Perms_'.$pkey,($val&$pkey)?'X':'','','','center',1);
					} else {
						$tabGui->addCol('Perms_'.$pkey,$pkey==$val?'X':'','','','center',1);
					}
				}
				//$tabGui->addCol('Perms',$av_perms[$val],'','','',1);
				$btn=new SubmitImgBtn ($dbtn.'['.$key.']','img/'.APP_THEME.'/loeschen.gif');
				$tabGui->addCol('Delete',$btn);
			}
		}
		return $tabGui;
	}

	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_mode,array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_mode,$key);
		if (!$result) $result=$default;
		return $result;
	}


}
?>