<?php
class AddrLogGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	function AddrLogGui() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('addr');
		$this->_Log=& $frm->getStaticModul('core_log');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('addr');
	}
	function &getAddrLogGui(&$AObj) {
		require_once('lib/class_ApplicationListGui.php');
		$search=array(
			'FKModul'=>'addr',
			'FKObjID'=>$AObj->getID(),
			'b'=>Framework::getParam('b','G',0),
			'limit'=>5,
		);
		$rows=0;
		$tabGui=new ApplicationListGui();
		$tabGui->setBorderColor('#fff');
		$tabGui->setTitleColor('#fff');
		$tabGui->setName($this->_T->lang('[[Erstellt am]]').' '.date('d.m.Y H:i',$AObj->getMeta('TimeCreate')).' '.$this->_T->lang('[[von]]').' '.$this->_frm->getCachedUserName($AObj->getMeta('UserCreate')),$AObj->getImage());

		$logEntries=$this->_Log->searchLog($rows,$search);
		if ($rows) {
			$navLink=Framework::cloneObj($this->_L);
			$this->_L->setParam('disp','l');
			$tabGui->setNavLink($this->_L);
			$tabGui->setLimit($search['limit']);
			$tabGui->setSumRows($rows);
			$tabGui->setBegin($search['b']);


			$tabGui->addHeaderCol('LogDate',$this->_T->lang('[[Datum]]'),'','','',1,'');
			$tabGui->addHeaderCol('LogUser',$this->_T->lang('[[BenutzerIn]]'),'','','',1,'');
			$tabGui->addHeaderCol('LogField',$this->_T->lang('[[Feld]]'),'','','',1,'');
			$tabGui->addHeaderCol('OldValue',$this->_T->lang('[[Alter Wert]]'),'','','',1,'');
			$tabGui->addHeaderCol('NewValue',$this->_T->lang('[[Neuer Wert]]'),'','','',1,'');
			if ($rows) {
				$logValues=$this->_Log->listLogValues(array_keys($logEntries));
				//debug($logValues);
				foreach ($logEntries as $val) {
					$hl=($hl?$hl=0:$hl=1);
					$tabGui->addRow($hl,'top','');
					$tabGui->addCol('LogDate',Framework::dateSql('d.m.Y H:i',$val->getMeta('LogDate')),'','','',1,'');
					$tabGui->addCol('LogUser',$this->_frm->getCachedUserName($val->getMeta('FKUserID')),'','','',1,'');
					$fieldVal=array();
					if (is_array($logValues[$val->getID()])) {
						$i=0;
						foreach ($logValues[$val->getID()] as $subVal) {
							if ($i) {
								$tabGui->addRow($hl,'top','',1);
								$tabGui->addCol('LogDate','','','','',0,'',2);
							}
							switch ($subVal['FieldID']) {
								case 'Cat':
									$tabGui->addCol('LogField',$this->_T->lang('[[Kategorie]]'),'','','',0,'');
									$tabGui->addCol('OldValue',$this->formatCatValue($subVal['OldValue']),'','','',0,'');
									$tabGui->addCol('NewValue',$this->formatCatValue($subVal['NewValue']),'','','',0,'');

								break;
								default:
									$tabGui->addCol('LogField',$this->_Base->getFieldData($subVal['FieldID'],'Title'),'','','',0,'');
									
									$tabGui->addCol('OldValue',$this->formatAddrValue($subVal['FieldID'],$subVal['OldValue']),'','','',0,'');
									$tabGui->addCol('NewValue',$this->formatAddrValue($subVal['FieldID'],$subVal['NewValue']),'','','',0,'');
								break;


							}
							$i++;
						}
					}


				}

			}
		}
		return $tabGui;
	}
	function formatCatValue($FieldValue) {
		$result=array();
		$Cat=unserialize($FieldValue);
		foreach ($Cat as $val) {
			$result[]=implode('->',array_reverse($this->_Base->getObjTree($val)));
		}
		return implode("\n",$result);


	}
	function formatAddrValue($FieldID,$FieldValue) {
		$result='-';
		if (strlen($FieldValue)) {
			$values=$this->_Base->AddrExplode($FieldValue);
			switch($this->_Base->getFieldData($FieldID,'Typ')) {
				case 'area':
				case 'text':
				case 'kont':
					$result=implode("\n",$values);
				break;
				case 'password':
					foreach ($values as $vkey=>$vval) {
						$values[$vkey]=$vval?'**********':'';
					}
					$result=implode("\n",$values);
				break;
				case 'select':
				case 'mselect':
					foreach ($values as $key=>$val) {
						$tmp=$this->_Base->readAddrSelect($FieldID,$val,array($this->_Base->getLang()));
						$values[$key]=$tmp['Name_'.$this->_Base->getLang()];
					}
					$result=implode("\n",$values);
					break;
				case 'fk_user':
					$result=implode("\n",$this->_frm->getCachedUserName($values));
				break;
				case 'date':
					if ($values[0]!= '0000-00-00') {
						$result=Framework::dateSql('d.m.Y',$values[0]);
					}
					break;
				case 'chk':
					if ($values[0]==1) $result='Y';
					if ($values[0]==-1) $result='N';
				break;
				case 'num':
					$result=''.str_replace('.',constDECIMAL,floatval($values[0]));
				break;
				case 'stamm':
					if ($values[0]) {
						$tmpObj=$this->_Base->getAddrObj($values[0]);
						if (is_object($tmpObj)) {
							$result=$tmpObj->getName();
						}
					}
				break;
				case 'perm':
					$Profiles=$this->_Base->listPermsProfil();
					if (isset($Profiles[$values[0]])) {
						$result=$Profiles[$values[0]]['Title_'.$this->_Base->getLang()];
					}

				break;
				default:
					//debug($this->_Base->getFieldData($FieldID,'Typ'));
				break;


			}
		}
		return $result;



	}
}
?>