<?php
class AddrMaintenanceGui {
	private $_Base;
	private $_Obj;
	private $_T;
	private $_t;
	private $_frm;
	private $_L;
	private $_E;
	private $_checks;
	function __construct() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('addr');
		$this->_T=&$T;
		$this->_T->loadModul('addr');
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		if (is_object($P)) $this->_P=&$P;
		$this->_checks=array(
			'fnv'=>array(
				'n'=>$this->_Base->getFieldData('Firma','Title').','.$this->_Base->getFieldData('Nachname','Title').','.$this->_Base->getFieldData('Vorname','Title'),
				'f'=>array(),
			),
			'nv'=>array(
				'n'=>$this->_Base->getFieldData('Nachname','Title').','.$this->_Base->getFieldData('Vorname','Title'),
				'f'=>array(),
			),
			'mail'=>array(
				'n'=>$this->_Base->getFieldData('Email','Title'),
				'f'=>array('Email'),
			),
			'mob'=>array(
				'n'=>$this->_Base->getFieldData('Mobil','Title'),
				'f'=>array('Mobil'),
			),
			'atel'=>array(
				'n'=>$this->_Base->getFieldData('ATel','Title'),
				'f'=>array('ATel'),
			),
			'ptel'=>array(
				'n'=>$this->_Base->getFieldData('PTel','Title'),
				'f'=>array('PTel'),
			),
			'fax'=>array(
				'n'=>$this->_Base->getFieldData('Fax','Title'),
				'f'=>array('Fax'),
			),
		);
		$this->_roots=array();
		if ($this->_Base->getPerms(1) && ($rootU=$this->_Base->getSystemObj('u',$this->_frm->getLang(),0))) {
			$this->_roots[$rootU->getMeta('System')]=$rootU;
		}
		if (($this->_Base->havePermsProfilAcl(4) || $this->_Base->getPerms(4)) && ($rootS=$this->_Base->getSystemObj('s',$this->_frm->getLang(),0))) {
			$this->_roots[$rootS->getMeta('System')]=$rootS;
		}
		
	}
	function _handleRequest() {

	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
	function process() {
		if (!Framework::getParam('search_x','','P')) {
			$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpDubSearch',1,0);
		}
		if (Framework::getParam('_del',0,'G') && ($AObj=$this->_Base->getAddrObj(Framework::getParam('_del',0,'G'))) && $AObj->getACL(4)) {
			if ($trash_obj=$this->_Base->getSystemObj('t',$this->_frm->getLang(),0)) {
				require_once ('lib/addr/func_Action.php');
				$tmp_error=TrashAddrObject($trash_obj,$AObj);
				//debug($tmp_error);
				if (!$tmp_error) {

				} else {
					$this->_E->setError($tmp_error[0]);
				}
			}
		}
		if (Framework::getParam('mai_action_x',0,'P') && Framework::getParam('mai_action_val',0,'P') && Framework::getParam('ListID',array(),'P')) {
			require_once ('lib/addr/func_Action.php');
			switch(Framework::getParam('mai_action_val',0,'P')) {
				case 'delete':
					if ($trash_obj=$this->_Base->getSystemObj('t',$this->_frm->getLang(),0)) {
						foreach (Framework::getParam('ListID',array(),'P') as $key=>$val) {
							$new_obj=$this->_Base->getAddrObj($val);
							if (is_object($new_obj)) {
								$tmp_error=TrashAddrObject($trash_obj,$new_obj);
								//debug($tmp_error);
								if (!$tmp_error) {
								} else {
									$ActionError[$tmp_error[0]][]=$tmp_error[1];
								}
							}
						}
					}
				break;
			}
		}
		
		
		//debug($_POST);
		require_once('lib/class_TemplateGui.php');
		$TopGui=new TemplateGui('core/common_form.inc.html');
		require_once('lib/class_ApplicationTreeGui.php');
		$TreeGui=new ApplicationTreeGui();

		$cfgGui=& $this->getConfigGui($rootU);
		$TreeGui->addTreeContent($cfgGui);

		$listGui=& $this->getListGui();
		$TreeGui->addContent($listGui);

		$TopGui->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
		$TopGui->addContent('cont1',$TreeGui,'CONTENT');
		return $TopGui->process();
	}
	function &getListGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_FormFieldsCore.php');
		$navLink=Framework::cloneObj($this->_L);
		$navLink->setParam('_loadTemp',1);

		$attribs=array(
			'onclick'=>'return false;',
		);
		$btnList=new CheckBoxBtn ('ListID[]','');
		$btnList->setAttribs($attribs);

		$user=array();
		if (in_array('u',$this->_search['croot'])) {
			$user[]=$this->_frm->getUser();
		}
		if (in_array('s',$this->_search['croot'])) {
			$user[]=0;
		}
		if (empty($user)) $user[]=$this->_frm->getUser();
			
			
		$entries=$this->_Base->searchDublicate($this->_search['cid'],$user);
		$b=0;
		$rows=count($entries);
	
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		$Gui=new ApplicationListGui();
		$funcAction=new FunctionObjActionGui('mai_action',1);
		$funcAction->setName($this->_T->lang('[[Ausgewaehlte Adressen]]'));
		$funcAction->addValue('delete',$this->_T->lang('[[Loeschen]]'));
		$Gui->addFunction($funcAction);

		
		$Gui->setGroupFields(array('gname'),true);
		$Gui->setNavLink($navLink);
		$Gui->setAutoBg(APP_FG10COLOR);
		$Gui->setID('addrTab');
		$Gui->setTrOver('trBOC({ROW},this);');
		$Gui->setTrDown('trBOI({ROW},this,1);');		$this->_frm->addOnLoad("disableSelection(document.getElementById('addrTab'));");
		$Gui->setRowClass(array('list_l','list_b','list_h','list_hb','list_s','list'));
		//$Gui->setLimit($this->_Base->getLimit()?$this->_Base->getLimit():$this->_Base->getRows());
		$Gui->setSumRows($rows);
		$Gui->setBegin($b);

		$fields=$this->_checks[$this->_search['cid']]['f'];
		foreach ($this->_Base->getlistFields() as $key) {
			if (in_array($key,$fields)) continue;
			$fields[]=$key;
		}

		$key='Name';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Name]]'),'','','',1,'',3);
		foreach ($fields as $key) {
			if ($this->_Base->getFieldData($key,'Title')) {
				$Gui->addHeaderCol($key,$this->_Base->getFieldData($key,'Title'),'','','',1,'');
			} elseif ($this->_Base->getFieldData($key,'Name',1)) {
				$Gui->addHeaderCol($key,$this->_T->lang($this->_Base->getFieldData($key,'Name',1)),'','','',1,'');
			}

		}
		$key='Cat';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Kategorie]]'),'','','',1,'',1);
		$key='del2';
		$Gui->addHeaderCol($key,'#','','','',1,'',1);

		$r=1;$n=0;
		foreach($entries as $gname=>$ids) {
			$adresses=$this->_Base->getAddrObj($ids);
			$hl=($hl?$hl=0:$hl=1);
			$lpos=$r-$n;
			$n=1;
			foreach ($adresses as $val) {
				$tras_array=array(
					'__AID__'=>urlencode($val->getID()),
					'__ACTION__'=>$val->getAction(0),
				);
				$Gui->addRow($hl?2:0,'top','');
				$Gui->setRowData(array('GroupValues'=>array('gname'=>$gname)));

				$key='del';
				if ($val->getAcl(4)) {
					/*$btDel=new FunctionButtons($key.'_'.$val->getID(),'button_link',array('TITLE'=>$this->_T->lang('[[Loeschen]]'),'LINK'=>"javascript:lo('".$this->_L->getTempLink(null,array('_del'=>$val->getID()))."#row_".$lpos."');",'TARGET'=>''));
					$Gui->addCol($key,$btDel,'','','',0,'1%',0,'',$colAttribs);*/
					$Gui->addCol($key,$btnList->process($val->getID()),'','','',1,'1%',0,'',$noEnc);
				} else {
					$Gui->addCol($key,'','','','',0,'1%',0,'',$colAttribs);
				}
			
				$colAttribs=array();
				$key='img';
				$Gui->addCol($key,'',$val->getImage(0),'','',0,'1%',0,'',$colAttribs);

				$key='Name';
				$colAttribs=array('ID'=>$val->getID(),);
				if ($val->getACL(4)) {
					$colAttribs['LinkAttribs']=array(
						'onclick'=>'return goToView(this);',
						'ondblclick'=>'return goToEdit(this,\'action='.$val->getAction(0).'\',\'action='.$val->getAction(1).'\');',
						'name'=>'row_'.($r),
					);
				}
				$Gui->addCol('Name',$val->getName(),'',$this->_L->getTempLink(null,array('aid'=>$val->getID(),'action'=>$val->getAction(0),'go_b'=>1)),'',0,'',0,'',$colAttribs);
				foreach ($fields as $fid) {
					$values=$this->_Base->AddrExplode($val->getMeta($fid));
					$nowrap=1;
					$this->_Base->entry2Value($fid,$values,$nowrap);
					$Gui->addCol($fid,implode('<br>',$values),'','','',$nowrap,'',0,'',$noEnc);
				}
				$values=array();
				foreach ($this->_Base->getAddrNodes($val->getID()) as $nObj) {
					$values[]=$nObj->getName();
				}
				$fid='cat';
				$Gui->addCol($fid,implode('<br>',$values),'','','',1,'',0,'',$noEnc);

				$key='del2';
				if ($val->getAcl(4)) {
					$btDel=new FunctionButtons($key.'_'.$val->getID(),'button_link',array('TITLE'=>$this->_T->lang('[[Loeschen]]'),'LINK'=>"javascript:lo('".$this->_L->getTempLink(null,array('_del'=>$val->getID()))."#row_".$lpos."');",'TARGET'=>''));
					$Gui->addCol($key,$btDel,'','','',0,'1%',0,'',$colAttribs);
				} else {
					$Gui->addCol($key,'','','','',0,'1%',0,'',$colAttribs);
				}

				
				$n++;
				$r++;
			}
		};
		return $Gui;
		
	}
	function &getConfigGui($rootObj) {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');

		$Gui=new TemplateGui('core/common_content_border.inc.html');
		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key='cid';
		$formGui->addField($key,'select',$this->_T->lang('[[Filter]]'),isset($this->_search[$key])?$this->_search[$key]:key($this->_checks),'fields1');
		$formGui->setValues($key,FrameWork::extractArrayMeta($this->_checks,'n'));

		$key='croot';
		$formGui->addField($key,'checklist_v','',isset($this->_search[$key])?$this->_search[$key]:array(key($this->_roots)),'fields1');
		$formGui->setValues($key,FrameWork::extractObjName($this->_roots));
		
		
		$submit_array=array(
			'search_x'=>' '.$this->_T->lang('[[Suchen]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','fields1');
		$formGui->setValues($key,$submit_array);

		$this->_search=array(
			'cid'=>$formGui->getFieldVal('cid',1),
			'croot'=>$formGui->getFieldVal('croot',1),
		);

		$this->_frm->savePostData($this->_Base->getModul(),'tmpDubSearch',null,$this->_search);
		$Gui->addContent('config',$formGui,'CONTENT');

		return $Gui;
	}
}
?>