<?php
class SearchEditGui {
	private $_T;
	private $_t;
	private $_frm;
	private $_L;
	private $_E;
	private $_P;
	private $_search;
	function __construct($Base) {
		global $frm,$t,$T,$E,$L,$P;
		$this->_T=$T;
		$this->_t=$t;
		$this->_frm=$frm;
		$this->_E=$E;
		$this->_L=$L;
		$this->_P=$P;
		$this->_Base=$Base;
	}
	function setSearch($search) {
		$this->_search=$search;
	}
	function getSearch() {
		return $this->_search;
	}
	function processEditGui() {
		//debug($this->_search);
		if (isset($this->_search['search']) && isset($this->_search['search'][0])) {
			require('lib/class_FormGui.php');
			$formGui=new FormGui();
			$formGui->setFieldClass('ipts','ipts');
			$formGui->setLabelClass('no','no_error');
			$BaseSelect=& $this->_frm->getStaticModul('uform_select');
			//debug($this->_searchPrj['search']);
			$parse=$this->_addSearchEditGroup($formGui,0);
			if ($parse) {
				$key='ovSubmit';
				$formGui->addField($key,'submit','',$this->_T->lang('[[Suchen]]'));
				return $formGui;
			}
		}
	}
	function _getField($value) {
		switch($value['typ']) {
			case 'addr':
			case 'crm':
				if ($value['key']=='all') {
					$sField=array('T'=>'text','N'=>$this->_T->lang('[[Irgend ein Feld]]'));
				} else {
					$sField=array(
						'T'=>$this->_Base->getFieldData($value['key'],'Typ'),
						'N'=>$this->_Base->getFieldData($value['key'],'Title'),
					);
				}
			break;
			case 'int':
				$sField=array(
					'T'=>$this->_Base->getFieldData($value['key'],'Typ',1),
					'N'=>$this->_T->lang($this->_Base->getFieldData($value['key'],'Name',1)),
				);
			break;
			case 'prj':
				$sField=array(
					'T'=>'prj',
					'N'=>$this->_T->lang('[[Projekte]]'),
				);
			break;
			case 'cat':
				$sField=array(
					'T'=>'cat',
					'N'=>$this->_T->lang('[[Kategorie]]'),
				);
			break;
			default:
				//debug($value);
			break;

		}
		return $sField;
	}
	function _addSearchEditGroup(&$formGui,$setID) {
		$parse=false;
		if (is_array($this->_search['search'][$setID]['field'])) {
			foreach ($this->_search['search'][$setID]['field'] as $fieldID=>$value) {
				//debug($value);
				if ($value['typ']=='grp') {
					if ($this->_addSearchEditGroup($formGui,$value['value'])) {
						$parse=true;
					}
				} else {
					$sField=$this->_getField($value);

					$keyV='ovV['.$setID.']['.$fieldID.']';
					$keyM='ovM['.$setID.']['.$fieldID.']';
					if($sField && $value['edit']) {
						switch($sField['T']) {
							case 'ruser':
							case 'user':
							case 'fuser':
							case 'fk_user':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!='));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'select',($sField['N']),$value['value']);
								if (!isset($appUsers)) {
									$appUserIDs=$this->_frm->getApplicationUsers('addr');
									if (!empty($appUserIDs)) {
										$appUsers=$this->_frm->getFullname(array_keys($appUserIDs));
									} else {
										$appUsers=array();
									}
								}
								$formGui->setValues($keyV,array(0=>'-') + $appUsers);
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));
								if ($formGui->getFieldVal($keyV,1)) {
									$this->_search['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
									$this->_search['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								} else {
									unset($this->_search['search'][$setID]['field'][$fieldID]);
								}
								$parse=true;
							break;
							case 'text':
							case 'area':
							case 'kont':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('lk'=>'~','nlk'=>'!~','is'=>'=','nis'=>'!=','bg'=>'^','nbg'=>'!^'));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'text',($sField['N']),$value['value']);
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));

								$this->_search['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_search['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'num':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!=','gt'=>'>=','lt'=>'<=','bg'=>'^','nbg'=>'!^'));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'text',($sField['N']),$value['value']);
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));


								$this->_search['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_search['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'date':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!=','gt'=>'>=','lt'=>'<='));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								//debug($value['value']);
								$formGui->addField($keyV,'text',($sField['N']),Framework::formatSearchDate($value['value']));
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));

								if ($formGui->getFieldVal($keyV,1)) {
									$this->_search['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
									$this->_search['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								} else {
									unset($this->_search['search'][$setID]['field'][$fieldID]);
								}
								$parse=true;
							break;
							case 'unixdate':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!=','gt'=>'>=','lt'=>'<='));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								//debug($value['value']);
								$formGui->addField($keyV,'text',($sField['N']),$value['value']);
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));
								if ($formGui->getFieldVal($keyV,1)) {
									$this->_search['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
									$this->_search['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								} else {
									unset($this->_search['search'][$setID]['field'][$fieldID]);
								}
								$parse=true;
							break;
							case 'chk':
							case 'check':
								$sArray=array('Y'=>$this->_T->lang('[[Ja]]'),'N'=>$this->_T->lang('[[Nein]]'),'0'=>$this->_T->lang('[[Nicht gesetzt]]'));
								$formGui->addField($keyV,'radiolist_h',($sField['N']),$value['value']);
								$formGui->setValues($keyV,$sArray);
								$this->_search['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'select':
							case 'mselect':
								$sArray=$this->_Base->listAddrSelect($value['key']);
				
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!='));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'select',($sField['N']),$value['value']);
								$formGui->setValues($keyV,array('0'=>$this->_T->lang('[[Nicht gesetzt]]')) + $sArray);
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));

								$this->_search['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_search['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'stamm':
								$sArray=FrameWork::extractArrayMeta($this->_Base->listAddrSearch(),'Title');
								if (!empty($sArray)) {
									$formGui->addField($keyV,'select',($sField['N']),$value['value']);
									$formGui->setValues($keyV,array('0'=>'--- '.$this->_T->lang('[[Unterabfrage auswaehlen]]').' ---') + $sArray);
									//$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
									$this->_search['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								}
							break;
							case 'password':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!='));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'text',($sField['N']),$value['value']);
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));

								$this->_search['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_search['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'addr':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!='));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'ttip',$this->_T->lang('[[Adresse]]'),$value['value'],'content');
								$formGui->setParams($keyV,array('mode'=>'a','no_width'=>1,'app'=>'','params'=>''));
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));
								$this->_search['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_search['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'prj':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!='));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'ttip',$sField['N'],$value['value'],'content');
								$formGui->setParams($keyV,array('mode'=>'o','no_width'=>1,'app'=>'','params'=>''));
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));
								$this->_search['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_search['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'cat':
								if ($value['rec']) {
									if ($value['mode']=='is') $value['mode']='lk';
									if ($value['mode']=='nis') $value['mode']='nlk';
								}
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!=','lk'=>'~','nlk'=>'!~'));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'ttip',$sField['N'],$value['value'],'content');
								$formGui->setParams($keyV,array('mode'=>'f','no_width'=>1,'app'=>'','params'=>base64_encode(serialize(array('AddrServers'=>array_keys($this->_Base->getRootIDs()))))));
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));
								
								switch ($formGui->getFieldVal($keyM,1)) {
									case 'is':
										$this->_search['search'][$setID]['field'][$fieldID]['mode']='is';
										$this->_search['search'][$setID]['field'][$fieldID]['rec']=0;
									break;
									case 'nis':
										$this->_search['search'][$setID]['field'][$fieldID]['mode']='nis';
										$this->_search['search'][$setID]['field'][$fieldID]['rec']=0;
									break;
									case 'lk':
										$this->_search['search'][$setID]['field'][$fieldID]['mode']='is';
										$this->_search['search'][$setID]['field'][$fieldID]['rec']=1;
									break;
									case 'nlk':
										$this->_search['search'][$setID]['field'][$fieldID]['mode']='nis';
										$this->_search['search'][$setID]['field'][$fieldID]['rec']=1;
									break;
								}
								$this->_search['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							default:
								//debug($sField);
							break;
						}
					}
				}
			}
		}
		return $parse;
	}	
	function getSearchText($setID=0) {
		$modeArray=array('lk'=>'~','nlk'=>'!~','is'=>'=','nis'=>'!=','gt'=>'>=','lt'=>'<=','bg'=>'^','nnbg'=>'!^');
		$resultTxt='';
		if (is_array($this->_search['search'][$setID]['field'])) {
			$num=0;
			$resultTxt.='(';
			foreach ($this->_search['search'][$setID]['field'] as $fieldID=>$value) {
				//debug($value);
				if ($value['typ']=='grp') {
					if ($num) {
						$resultTxt.=' '.$this->_T->lang($this->_search['search'][$setID]['mode']=='or'?'[[oder]]':'[[und]]').' ';
					}
					$resultTxt.=$this->getSearchText($value['value']);
					$num++;
				} else {
					$sField=$this->_getField($value);
					
					$tmpField=array(
						'T'=>$num?' '.$this->_T->lang($this->_search['search'][$setID]['mode']=='or'?'[[oder]]':'[[und]]').' ':'',
						'N'=>$sField['N'],
						'M'=>$modeArray[$value['mode']],
						'V'=>$value['value'],
					);
					switch ($value['mode']) {
						case 'lk':
						case 'nlk':
						case 'bg':
						case 'nbg':
							if (!$value['value']) $sField['T']='';
						break;
					}
					
					switch($sField['T']) {
						case 'ruser':
						case 'user':
						case 'fuser':
						case 'fk_user':
							$tmpField['V']=$this->_frm->getCachedUserName($value['value'],0,1);
							$num++;
						break;
						case 'num':
							$tmpField['V']=trim($value['value']);
							$tmpField['V']=str_replace(constTHOUSEND,'',$tmpField['V']);
							$tmpField['V']=str_replace(constDECIMAL,'.',$tmpField['V']);
							$tmpField['V']=floatval($tmpField['V']);
							$tmpField['V']=Framework::numberFormat($tmpField['V'],$sField['C']['decimals']);
							$num++;
						break;
						case 'text':
						case 'kont':
						case 'area':
						case 'date':
						case 'unixdate':
							$num++;
						break;
						case 'password':
							$num++;
						break;
						case 'check':
						case 'chk':
							$sArray=array('Y'=>$this->_T->lang('[[Ja]]'),'N'=>$this->_T->lang('[[Nein]]'),'0'=>$this->_T->lang('[[Nicht gesetzt]]'));
							$tmpField['V']=$sArray[$value['value']];
							$num++;
						break;
						case 'select':
						case 'mselect':
							if ($value['value']) {
								$sArray=$this->_Base->listAddrSelect($value['key']);
								$tmpField['V']=$sArray[$value['value']];
							} else {
								$tmpField['V']='';
							}
							$num++;
						break;
						case 'addr':
							if ($value['value']) {
								$Addr=& $this->_frm->getStaticModul('addr');
								if ($tmpObj=$Addr->getAddrObj(substr($value['value'],2))) {
									$tmpField['V']=$tmpObj->getName();
								} else {
									$tmpField['V']='';
								}
								$num++;
							} else {
								$tmpField=array();
							}
						break;
						case 'stamm':
							if ($value['value']) {
								$sArray=FrameWork::extractArrayMeta($this->_Base->listAddrSearch(),'Title');
								$tmpField['V']=$sArray[$value['value']];
								$tmpField['M']=$modeArray['is'];
								$num++;
							} else {
								$tmpField=array();
							}
						break;
						case 'prj':
							if ($value['value']) {
								$tmp=array();
								foreach(explode('|',$value['value']) as $v) {
									if ($tmpObj=$this->_P->getCachedObj(substr($v,2))) {
										$tmp[]=$tmpObj->getName();
									}
								}
								natcasesort($tmp);
								$tmpField['V']=implode(',',$tmp);
								$num++;
							} else {
								$tmpField=array();
							}
						break;
						case 'cat':
							if ($value['value']) {
								$tmp=array();
								foreach(explode('|',$value['value']) as $v) {
									if ($tmpObj=$this->_Base->getObj(substr($v,2))) {
										$tmp[]=implode('->',$this->_Base->getObjTreeNames($tmpObj));
									}
								}
								natcasesort($tmp);
								$tmpField['V']=implode(',',$tmp);
								$num++;
							} else {
								$tmpField=array();
							}
						break;
						default:
							$tmpField=array();
						break;
					}
					if (!empty($tmpField)) {
						$tmpField['V']="'".$tmpField['V']."'";
						$resultTxt.=implode('',$tmpField);
					}
				}
			}
			$resultTxt.=')';
		}
		return $resultTxt;
	}
}
?>