<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class geAddrCtrlAjax{
	private $result;
	private $_frm;
	private $T;
	public function __construct() {
		global $frm,$T;
		$this->_frm=$frm;
		$this->_T=$T;
		$this->_Base=$this->_frm->getStaticModul('addr');
	}
	public function addrLogSave($addrID,$logObj) {
		if ($AObj=$this->_Base->getAddrObj($addrID)) {
			$this->_Base->insertLog($addrID,$this->_frm->getUser(),$logObj->message,'log');
			$this->addrLogUpdate($addrID);
			return true;
		}
		$this->result['error']='GENERIC';
		return false;
	}
	public function addrLogDelete($addrID,$logId) {
		if (($AObj=$this->_Base->getAddrObj($addrID)) && $logId) {
			$this->_Base->deleteLog($logId,$addrID,$this->_frm->getUser());
			$this->addrLogUpdate($addrID);
			return true;
		}
		$this->result['error']='GENERIC';
		return false;
	}
	public function addrLogUpdate($addrID) {
		if (($AObj=$this->_Base->getAddrObj($addrID))) {
			require_once('lib/addr/view/geAddrViewLog.php');
			$Gui=new geAddrViewLog();
			$Gui->setData(array(
				'address'=>$AObj,		
				'entries'=>$this->_Base->listLog($AObj->getID(),'log',''),
			));
			$this->result=array(
				'error'=>'UPDATE_LOG',
				'content'=>$Gui->process(),
			);
		} else {
			$this->result['error']='GENERIC';
		}
	}
	public function getResult() {
		return $this->result;
	}
}
?>