<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
function getSearchList(&$Addr,&$db,$slist,$l_typ,$uperms=false) {
	global $frm;
	$sdata=$Addr->readAddrSearch($slist);
	if ($uperms && $Addr->getUser()!=$sdata['FKUserID']) {
		$tmp_rules=$frm->getUserRules($sdata['FKUserID']);
		if ($tmp_rules['addr'] || $tmp_rules['sysadmin']) $Addr->setRule(1);
		$Addr->setUser($sdata['FKUserID']);
		$Addr->setUser($sdata['FKUserID']);
		$Addr->setGroups($frm->getUserGroups($sdata['FKUserID']));
		$Addr->loadFields();
	}
	$result=array();
	$list_fields=array();
	foreach ($Addr->getFields() as $key=>$val) {
		if ($val['Action']==$l_typ) {
			$list_fields[]=$key;
		}
	}
	$Addr->setListFields($list_fields);
	$Addr->setLimit(0);
	$search=unserialize($sdata['Sdata']);

	$sqlOrder=array('Name'=>1);
	$ftree=$Addr->searchAddrAdv(0,$sqlOrder,$search['search'],false,true,$search['use_archiv']);
	if ($Addr->getRows()) {
		foreach ($ftree as $key=>$val) {
			foreach ($Addr->getListFields() as $FieldID) {
				$values=$Addr->AddrExplode($val->getMeta($FieldID));
				$data=$data_val='';
				if ($values[0]) {
					switch ($Addr->getFieldData($FieldID,'Action')) {
						case 'mail':
							$data=$Addr->formatMail($val,$values[0]);
							$data_val=$values[0];
						break;
						case 'fax':
							$data=$Addr->formatFax($val,$values[0]);
							$data_val=$values[0];
						break;
						case 'sms':
							$data=$frm->getStaticModul('sms')->formatNumber($values[0],$val->getName(1));
							$data_val=$values[0];
						break;
					}
				}
			}
			if ($data) {
				$result[]=array(
					'name'=>$val->getName(1),
					'data'=>$data,
					'data_val'=>$data_val,
				);
			}
		}
	}
	return $result;
}
?>