<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
function getSearchList(&$Addr,$slist,$l_typ) {
	global $frm;
	$result=array();
	$AddrList=& $frm->getStaticModul('addr_list');
	$LObj=$AddrList->getObj($slist);
	if (is_object($LObj) && $LObj->getMeta('Sdata')) {
		$list_fields=array();
		foreach ($Addr->getFields() as $key=>$val) {
			if ($val['Action']==$l_typ) {
				$list_fields[]=$key;
			}
		}
		$Addr->setListFields($list_fields);
		$search=unserialize($LObj->getMeta('Sdata'));
		$search['searchSub']=1;
		$ld_order=array('Name'=>1);
		$b=0;
		$Addr->setLimit(0);
		$entries=$Addr->searchAddr($b,$ld_order,$search);
		if ($Addr->getRows()) {
			foreach ($entries as $key=>$val) {
				foreach ($Addr->getListFields() as $FieldID) {
					$values=$Addr->AddrExplode($val->getMeta($FieldID));
					$data=$data_val='';
					if ($values[0]) {
						switch ($Addr->getFieldData($FieldID,'Action')) {
							case 'mail':
								$data=$Addr->formatMail($val,$values[0]);
								$data_val=$values[0];
							break;
							case 'fax':
								$data=$Addr->formatFax($val,$values[0]);
								$data_val=$values[0];
							break;
						}
					}
				}
				if ($data) {
					$result[]=array(
						'name'=>$val->getName(1),
						'data'=>$data,
						'data_val'=>$data_val,
					);
				}
			}
		}
	}
	return $result;
}
?>