<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$obj_action=$frm->getObjAction($Addr->getModul(),$obj->getActionMode(0));
if ($Addr->isAllowedAction($obj,$obj_action[$obj_action_val])) {
	$location='';
	switch ($obj_action_val) {
		case 'n_fol':
			$location="index.php?site=$site&action=b&new=$obj_action_val&edit=1&oid=".$obj->getID();
		break;
		case 'e_fol':
			$edit=1;
			break;
		case 'e_src':
			$new=1;
			break;
		case 'vall':
			$Addr->setLimit(0);
			break;
		case 'delete':
			if (is_object($trash_obj)) {
				$oldParentID=$obj->getMeta('ParentID');
				$tmp_error=TrashObject($trash_obj,$obj);
				if (!$tmp_error) {
					$location="index.php?site=$site&oid=".$oldParentID;
				} else {
					$ActionError[$tmp_error[0]][]=$tmp_error[1];
				}
			}
			break;
		case 'f_delete':
			$oldParentID=$obj->getMeta('ParentID');
			$tmp_error=DeleteObject($obj);
			if (!$tmp_error) {
				$location="index.php?site=$site&oid=".$oldParentID;
			} else {
				$ActionError[$tmp_error[0]][]=$tmp_error[1];
			}
			break;
		case 'tr_delete':
			if (is_object($trash_obj)) {
				$Addr->setLimit(0);
				$searchAddr=array();
				$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>1);
				$searchNode=array();
				$searchNode[]=array('Field'=>'FKNodeID','Typ'=>'=','Values'=>$trash_obj->getID());
				$sub_entrys=$Addr->searchAddr(0,'',$searchAddr,$searchNode);
				if (is_array($sub_entrys)) {
					foreach ($sub_entrys as $new_obj) {
						$tmp_error=DeleteAddrObject($new_obj);
						if ($tmp_error) {
							$ActionError[$tmp_error[0]][]=$tmp_error[1];
						}
					}
				}
			}
			break;
		case 'modify':
			$location="index.php?site=$site&action=".$obj->getAction(1)."&oid=".$obj->getID();
			break;
		case 's_msg':
			$msg_Link=array(
				0=>array(
					'U'=>"index.php?site=".$obj->getSite()."&action=".$obj->getAction(0)."&oid=".$obj->getID(),
					'N'=>$obj->getName(),
				),
			);
			if (!empty($msg_Link)) {
				$msgParams=array(
					'reset'=>1,
					'tab'=>'msg',
				);
				$msgParams['msgLink']=json_encode($msg_Link);
				$frm->addOnload('ge.registry.coreViewMessage.geMsgShow('.(json_encode($msgParams)).');');
			}
			break;
		case 's_mail':
			$frm->setUserData('mail',1,serialize(array($obj->getID())));
			$location="index.php?site=mail.php&show=compose&getUserFmng=1";
			break;
		case 'lexp':
			Framework::importParam(array('showExp'=>1),'G');
			$showExp=1;
			break;
		case 'go_src':
			$location="index.php?site=addr.php&action=s&vsrid=".Framework::getParam('vsrid');
			break;
	}
	if ($location) {
		page_close();
		header('Location:'.$location);
		exit;
	}
}
?>
