<?php
class geAddrViewLog {
	private $_Base;
	private $_T;
	private $_frm;
	private $_L;
	private $_E;
	private $_data;
	function __construct() {
		global $frm,$t,$T,$E,$L,$Y;
		$this->_frm=&$frm;
		$this->_T=&$T;
		$this->_T->loadModul('addr');
	}
	function setData($k,$v=null) {
		if (is_array($k)) {
			$this->_data=$k;
		} else {
			$this->_data[$k]=$v;
		}
	}
	function process($parse=true) {
		require_once('lib/class_ApplicationListGui.php');

		$rows=0;
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);

		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tabGui->setRowClass(array('list_b','list_hb','list_s'));
		$tabGui->setID('geAddrViewLog');

		$hl=1;
		foreach ($this->_data['entries'] as $key=>$val) {
			$showBody=0;
			$buttons=array();
			if ($this->_frm->getMyApps('sms') || $this->_frm->getMyApps('sms')) {
				$msgParams=array(
					'tab'=>'msg',
					'reset'=>1,
					'smsMessage'=>$this->_data['address']->getName()."\n".$val['Text'],
					'msgSubject'=>$this->_data['address']->getName(),
					'msgMessage'=>$val['Text'],
					'remMessage'=>$val['Text'],
					'remObjName'=>$this->_data['address']->getName(),
					'remObjTyp'=>'addr',
					'remObjId'=>$this->_data['address']->getID(),
					'smsTo'=>'',
					'msgTo'=>'',
				);
				$msgParams['msgLink']=json_encode(array(
					array('U'=>"index.php?site=addr.php&action=view&aid=".$this->_data['address']->getId()."&back=0",'N'=>$this->_data['address']->getName()),
				));
				$buttons[]='<a href="javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));"><img src="img/ge/js_send.gif" title="'.$this->_T->Lang('[[Neue Message]]').'" /></a>';
			}

			$tabGui->addRow($hl=$hl?0:1,'top');
			$tabGui->addCol('log_subject',date('d.m.Y - H:i',$val['Date']).' '.$this->_frm->getCachedUsername($val['User']),'','','',0,'2000');

			$buttons[]='<a href="javascript:void(geAddrAction(\'addrLogDelete\','.$this->_data['address']->getID().','.$key.'));"><img src="img/ge/msg_clear.gif" title="'.$this->_T->Lang('[[Loeschen]]').'" /></a>';
	
			$tabGui->addCol('log_buttons',implode('',$buttons),'','','',1,'',0,'',$noEnc);

			$body=Framework::entities($val['Text']);
			$tabGui->addColSub('log_subject','N',$body);
			$tabGui->addColSub('log_subject','NoEnc',1);
		}
		if (empty($this->_data['entries'])) {
			$tabGui->addRow(0,'top');
			$tabGui->addCol('nix',$this->_T->lang('[[Keine Eintraege]]'),'','','',0,'2000');
		}
		if ($parse) {
			return $tabGui->process();
		} else {
			return $tabGui;
		}
	}
}
?>