<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$this_action=$frm->getObjAction ($Bmng->getModul(),$obj->getActionMode(1),$list_action_val);
if ($Bmng->isAllowedAction($obj,reset($this_action))) {
	$location='';
	switch ($list_action_val) {
		case 'cut':
			if (!is_array($ListID)) break;
			if ($Bmng->isClipboard('bobj')) {
				$frm->deleteClipboard('bobj');
				$Bmng->setClipboard('bobj',false);
			}
			foreach ($ListID as $key=>$val) {
				$new_obj=$Bmng->getObj($val);
				if (is_object($new_obj)) {
					$this_action=$frm->getObjAction ($Bmng->getModul(),$new_obj->getActionMode(0),$list_action_val);
					if ($Bmng->isAllowedAction($new_obj,reset($this_action))) {
						$frm->insertClipboard('bobj',$val,'cut');
						unset($ListID[$key]);
					} else {
						$ActionError['no_cut_perms'][]=$val;
					}
				}
			}
			$Bmng->setClipboard('bobj',$frm->getClipboard('bobj'));
			break;
		case 'copy':
			if (!is_array($ListID)) break;
			if ($Bmng->isClipboard('bobj')) {
				$frm->deleteClipboard('bobj');
				$Bmng->setClipboard('bobj',false);
			}
			foreach ($ListID as $key=>$val) {
				$new_obj=$Bmng->getObj($val);
				if (is_object($new_obj)) {
					$this_action=$frm->getObjAction ($Bmng->getModul(),$new_obj->getActionMode(0),$list_action_val);
					if ($Bmng->isAllowedAction($new_obj,reset($this_action))) {
						$frm->insertClipboard('bobj',$val,'copy');
						unset($ListID[$key]);
					} else {
						$ActionError['no_copy_perms'][]=$val;
					}
				}
			}
			$Bmng->setClipboard('bobj',$frm->getClipboard('bobj'));
			break;
		case 'insert':
			if ($Bmng->isClipboard('bobj')) {
				foreach ($Bmng->getClipboard('bobj') as $val) {
					$new_obj=$Bmng->getObj($val['Content']);
					$tmp_error=CutCopyObject($obj,$new_obj,$val['Mode']);
					if (!$tmp_error) {
						$frm->deleteClipboard('bobj',$val['Content']);
					} else {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
				$Bmng->setClipboard('bobj',$frm->getClipboard('bobj'));
			}
			break;
		case 'delete':
			if (!is_array($ListID)) break;
			if (is_object($trash_obj)) {
				foreach ($ListID as $key=>$val) {
					$new_obj=$Bmng->getObj($val);
					if (is_object($new_obj)) {
						$tmp_error=TrashObject($trash_obj,$new_obj);
						if (!$tmp_error) {
								unset($ListID[$key]);
						} else {
							$ActionError[$tmp_error[0]][]=$tmp_error[1];
						}
					}
				}
			}
			break;
		case 'f_delete':
			if (!is_array($ListID)) break;
			foreach ($ListID as $key=>$val) {
				$new_obj=$Bmng->getObj($val);
				if (is_object($new_obj)) {
					$tmp_error=DeleteObject($new_obj);
					if ($tmp_error) {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
			}
			break;
	}
	if ($location) {
		page_close();
		header('Location:'.$location);
		exit;
	}
}
?>
