<?php
class CalConflictGui {
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_prjID=0;
	var $_prjPerms=0;
	function __construct() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_BaseCat=$frm->getStaticModul('cal_cat');
		$this->_BaseRes=$frm->getStaticModul('cal_res');
		$this->_frm=&$frm;
		$this->_T=&$T;
		$this->_T->loadModul('cal');
	}
	function isCallable() {
		return true;
	}
	function getConflictGui($conflict,$inc=false) {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_ApplicationTreeGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/common_simple_content.inc.html');
		$formGui=new FormGui();

		$Gui=new ApplicationTreeGui();

		if (!empty($conflict['confEvent'])) {
			if ($inc) {
				$tabGuiU=new ApplicationListGui('core/common_table_intern_list.inc.html');
			} else {
				$tabGuiU=new ApplicationListGui();
			}
			$tabGuiU->setName($this->_T->lang('[[Achtung: Konflikt mit folgende Termine]]'));
			$tabGuiU->addHeaderCol('User',$this->_T->lang('[[BenutzerIn]]'));
			$tabGuiU->addHeaderCol('Date',$this->_T->lang('[[Datum]]'));
			$tabGuiU->addHeaderCol('Title',$this->_T->lang('[[Titel]]'));
			$tabGuiU->addHeaderCol('Cat',$this->_T->lang('[[Kategorie]]'));
			$tabGuiU->setLimit(0);

			foreach ($conflict['confEvent'] as $uid=>$evt_array) {
				$rows=0;$hl=0;
				foreach ($evt_array as $val) {
					$hl=$hl?0:1;
					$tabGuiU->addRow($hl);
					$this->_Base->checkEventViewPerms($val,true);
					$tabGuiU->addCol('User',$this->_frm->getCachedUserName($uid,0,1),'','','',1);
					$tabGuiU->addCol('Date',$this->_Base->formatDate($val['StartDate'],$val['EndDate'],$val['TimeMode']),'','','',1);
					$tabGuiU->addCol('Title',$val['Title'],'','','',1,'0');
					$tabGuiU->addCol('Cat',$this->_BaseCat->getCachedObj($val["FKCatID"])->getName(),'','','',0,2000);
				}
			}
			$tplContent->addContent('conf_user',$tabGuiU,'CONTENT');
		}
		if (!empty($conflict['confResources'])) {
			if ($inc) {
				$tabGuiR=new ApplicationListGui('core/common_table_intern_list.inc.html');
			} else {
				$tabGuiR=new ApplicationListGui();
			}
			$tabGuiR->setName($this->_T->lang('[[Achtung: Folgende Resourcen wurden bereits gebucht]]'));
			$tabGuiR->addHeaderCol('Res',$this->_T->lang('[[Resource]]'));
			$tabGuiR->addHeaderCol('Date',$this->_T->lang('[[Datum]]'));
			$tabGuiR->addHeaderCol('Title',$this->_T->lang('[[Titel]]'));
			$tabGuiR->addHeaderCol('User',$this->_T->lang('[[BenutzerIn]]'));
			$tabGuiR->setLimit(0);

			foreach ($conflict['confResources'] as $rid=>$evt_array) {
				$rows=0;$hl=0;
				foreach ($evt_array as $val) {
					$hl=$hl?0:1;
					$tabGuiR->addRow($hl);
					$tabGuiR->addCol('Res',$this->_BaseRes->getCachedObj($rid)->getName(),'','','',1);
					$tabGuiR->addCol('Date',$this->_Base->formatDate($val['StartDate'],$val['EndDate'],$val['TimeMode']),'','','',1);
					$this->_Base->checkEventViewPerms($val,true);
					$tabGuiR->addCol('Title',$val['Title'],'','','',1,'0');
					$tabGuiR->addCol('User',$this->_frm->getCachedUserName($val['OwnerID'],0,1),'','','',0,2000);
				}
			}
			$tplContent->addContent('conf_res',$tabGuiR,'CONTENT');
		}
		if ($inc) {

		} else {
			$formGui->addField('conflictTested','hidden','',1,'fields1');
			$formGui->addField('loadPost','hidden','',1,'fields1');
			$formGui->addField('submit','submit','','','fields1');
			$sArray=array();
			if ($conflict['overwrite']) {
				$sArray[isset($conflict['buttonSave'])?$conflict['buttonSave']:'save_x']=$this->_T->lang('[[Termin speichern]]');
			}
			$sArray['break_x']=$this->_T->lang('[[Termin aendern]]');

			$formGui->setValues('submit',$sArray);
			$tplContent->addContent('submit',$formGui,'CONTENT');
		}
		$Gui->addContent($tplContent);
		return $tplContent;
	}
	function checkConflict($nObj,$exID=0,$checkConflict=true) {
		$conflict=false;
		$result=array(
			'overwrite'=>true,
			'confEvent'=>array(),
			'confResources'=>array(),
		);
		$iUsers=array($nObj['OwnerID']);
		if ($nObj['InvitUsers']) $iUsers=array_merge($iUsers,explode(',',$nObj['InvitUsers']));
		if ($nObj['InvitGroups']) {
			$tmpUsers=$this->_frm->getGroupUsers(explode(',',$nObj['InvitGroups']));
			if ($tmpUsers && !empty($tmpUsers)) {
				$tmpUsers=array_keys($this->_frm->getApplicationUsers('cal',$tmpUsers));
				if ($tmpUsers && !empty($tmpUsers)) {
					$iUsers=array_merge($iUsers,$tmpUsers);
				}
			}
		}
		//debug($nObj);
		$catObj=$this->_BaseCat->getCachedObj($nObj['FKCatID']);
		if ($catObj && $catObj->getMeta('calCatTest')) {
			$test_cat=$this->_BaseCat->listObj(false,true);
			foreach ($iUsers as $val) {
				$search=array(
					'UserID'=>$val,
					'GroupID'=>$this->_frm->getUserGroups($val),
					'CatID'=>array_keys($test_cat),
					'exEventID'=>$exID,
					'Mode'=>2,
				);
				if ($nObj['RecType']) {
					$date=$this->_Base->nextRecurrence($nObj,mktime(0,0,0));
				} else {
					$date=array('start'=>$nObj['StartDate'],'end'=>$nObj['EndDate']);
				}
				$count=0;
				while($date && $count<50) {
					$rows=0;
					$search['StartDate']=$date['start']+1;
					$search['EndDate']=$date['end']-1;
					//debug(date('d.m.Y',$search['StartDate']));

					$conf_event=$this->_Base->searchEvents($rows,$search);
					if ($conf_event) {
						if (isset($result['confEvent'][$val])) {
							$result['confEvent'][$val]+=$conf_event;
						} else {
							$result['confEvent'][$val]=$conf_event;
						}
						$conflict=true;
						foreach ($conf_event as $tpmEvent) {
							if ($test_cat[$tpmEvent['FKCatID']]->getMeta('calCatNoConflict')) {
								$result['overwrite']=false;
							}
						}
						//Abbrechen wenn mehr als 20 konflikte;
						if (count($result['confEvent'][$val])>20) {
							break;
						}
					}
					if ($nObj['RecType']) {
						$date=$this->_Base->nextRecurrence($nObj,$date["end"]);
					} else {
						$date=false;
					}
					$count++;
				}
			}
		}
		if ($nObj['InvitResources']) {
			$this->_confResources=array();
			$iResources=explode(',',$nObj['InvitResources']);
			foreach ($iResources as $val) {
				if (strpos($val,'@')) {
					$tmp=explode('@',$val);
					$rid=$tmp[0];
					$needed=$tmp[1];
				} else {
					$rid=$val;
					$needed=1;
				}
				$resObj=$this->_BaseRes->getCachedObj($rid);
				if ($resObj->getMeta('calResCheck')) {
					$search=array(
						'ResourceID'=>$rid,
						'exEventID'=>$exID,
						'Mode'=>2,
					);
					if ($nObj['RecType']) {
						$date=$this->_Base->nextRecurrence($nObj,mktime(0,0,0));
					} else {
						$date=array('start'=>$nObj['StartDate'],'end'=>$nObj['EndDate']);
					}
					$count=0;
					while($date && $count<50) {
						$rows=0;
						$search['StartDate']=$date['start']+1;
						$search['EndDate']=$date['end']-1;
						if ($conf_event=$this->_Base->searchEvents($rows,$search)) {
							if ($resObj->getMeta('calResAmount')>1) {
								$calcEntries=$this->_Base->calcEntries($conf_event,$search['StartDate'],$search['EndDate']);
								//debug($calcEntries);
								$numOverlapping=$calcEntries['options']['max_cols'];
							} else {
								$numOverlapping=1;
							}
							//debug($numOverlapping);
							if ($numOverlapping+$needed>$resObj->getMeta('calResAmount')) {
								if (isset($result['confResources'][$resObj->getID()])) {
									$result['confResources'][$resObj->getID()]+=$conf_event;
								} else {
									$result['confResources'][$resObj->getID()]=$conf_event;
								}
								$conflict=true;
								if ($resObj->getMeta('calResNoConflict')) {
									$result['overwrite']=false;
								}
								//Abbrechen wenn mehr als 20 konflikte;
								if (count($result['confResources'][$resObj->getID()])>20) {
									break;
								}
							}
						}
						if ($nObj['RecType']) {
							$date=$this->_Base->nextRecurrence($nObj,$date["end"]);
						} else {
							$date=false;
						}
						$count++;
					} 
				
				}
			}
		}
		if ($conflict && (!$result['overwrite'] || $checkConflict)) {
			return $result;
		}
		return false;
	}


	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_mode,array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_mode,$key);
		if (!$result) $result=$default;
		return $result;
	}


}
?>