<?php
class ObjCalImport extends baseObj {
	public $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['Subject'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class CalImport extends ObjCore {
	public $_modul='cal';
	public $_table='CalImport';
	public $_cfgObjects=array (
		'IdField'=>'impID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'0'=>array(
			'ClassName'=>'ObjCalImport',
			'Fields'=>array(
				'impID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'FKUserID'=>array(
					'Typ'=>'core',
				),
				'StartDate'=>array(
						'Typ'=>'date',
						'Req'=>1
					),
				'StartTime'=>array(
						'Typ'=>'time',
						'Req'=>1
					),
				'EndDate'=>array(
						'Typ'=>'date',
						'Req'=>0
					),
				'EndTime'=>array(
						'Typ'=>'time',
						'Req'=>1
					),
				'Owner'=>array(
						'Typ'=>'user',
						'Req'=>2
					),
				'Subject'=>array(
						'Typ'=>'text',
						'Req'=>1
					),
				'Body'=>array(
						'Typ'=>'text',
						'Req'=>0
					),
				'Place'=>array(
						'Typ'=>'text',
						'Req'=>0
					),
				'Category'=>array(
						'Typ'=>'cat',
						'Req'=>2,
					),
				'Attendees'=>array(
						'Typ'=>'invit',
						'Req'=>0
					),
				'NoInvitations'=>array(
						'Typ'=>'bool',
						'Req'=>0
					),
				'Resources'=>array(
						'Typ'=>'res',
						'Req'=>0
					),
				'Project'=>array(
						'Typ'=>'prj',
						'Req'=>0
					),
				'AllDayEvent'=>array(
						'Typ'=>'bool',
						'Req'=>0
					),
				'Privat'=>array(
						'Typ'=>'bool',
						'Req'=>0
					),
				'Tentative'=>array(
						'Typ'=>'bool',
						'Req'=>0
					),
				'Notifications'=>array(
						'Typ'=>'bool',
						'Req'=>0
					),
				'ReminderDate'=>array(
						'Typ'=>'date',
						'Req'=>0
					),
				'ReminderTime'=>array(
						'Typ'=>'time',
						'Req'=>0
					),
				'RecFreq'=>array(
						'Typ'=>'recf',
						'Req'=>0
					),
				'RecInterval'=>array(
						'Typ'=>'reci',
						'Req'=>0
					),
				'RecUntil'=>array(
						'Typ'=>'date',
						'Req'=>0
					),
				'Visibility'=>array(
						'Typ'=>'grant',
						'Req'=>0
					),
				'_startStamp'=>array(
						'Typ'=>'core',
						'Req'=>0
					),
				'_endStamp'=>array(
						'Typ'=>'core',
						'Req'=>0
					),
				'_error'=>array(
						'Typ'=>'core',
						'Req'=>0
					),
				'_importId'=>array(
						'Typ'=>'core',
						'Req'=>0
					),
			),
		),
	);

	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','cal')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function listObj($uid=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'_importId','Typ'=>'=','Values'=>0);
		if ($uid) $searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$uid);
		$rows=0;
		return $this->searchObj($rows,$searchQuery,'_startStamp ASC');
	}
	function deleteAll($uid=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'_importId','Typ'=>'=','Values'=>0);
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$uid);
		return $this->_db->delete('CalImport',$searchQuery);
	}
	
}
?>
