<?php
class ObjCalResource extends baseObj {
	var $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['calResName'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class CalResource extends ObjCore {
	var $_modul='cal';
	var $_table='CalResource';
	var $_cfgObjects=array (
		'IdField'=>'calResID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'calResPermsUser',
		'GroupField'=>'calResPermsGroup',
		'OwnerField'=>'',
		'AllReadPerms'=>true,
		'TranslationFields'=>array('calResName','calResText'),
		'0'=>array(
			'ClassName'=>'ObjCalResource',
			'Fields'=>array(
				'calResID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'calResName'=>array(
					'Typ'=>'core',
				),
				'calResText'=>array(
					'Typ'=>'core',
				),
				'calResColor'=>array(
					'Typ'=>'core',
				),
				'calResAmount'=>array(
					'Typ'=>'core',
				),
				'calResCheck'=>array(
					'Typ'=>'core',
				),
				'calResNoConflict'=>array(
					'Typ'=>'core',
				),
				'calResNotify'=>array(
					'Typ'=>'core',
				),
				'calResPermsUser'=>array(
					'Typ'=>'core',
				),
				'calResPermsGroup'=>array(
					'Typ'=>'core',
				),
				'calResUseCal'=>array(
					'Typ'=>'core',
				),
				'calResUseZef'=>array(
					'Typ'=>'core',
				),
				'calResDeleted'=>array(
					'Typ'=>'core',
				),
			),
		),
	);

	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','cal')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function initUser($uid) {
		$this->setUser($uid);
		$this->setGroups($this->_frm->getMyGroups($uid));
		$this->setRule($this->_frm->isRuleUser(array('sysadmin','cal'),$uid));
		$this->setSuperAdmin($this->_frm->isSuperAdmin($uid));
	}
	function insertObj(&$Obj) {
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		$Obj->setMeta('calResDeleted',1);
		return $this->updateObj($Obj);
	}
	function listObj($search=array(),$b=0,$limit=0) {
		$params=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'calResDeleted','Typ'=>'=','Values'=>0);
		if ($search['info']) {
			$searchQuery[]=array('Field'=>array('CalResource.calResName','CalResource.calResText'),'Typ'=>'concat','Values'=>$search['info']);
		}
		if ($search['id']) {
			$searchQuery[]=array('Field'=>'calResID','Typ'=>'=','Values'=>$search['id']);
		}
		if ($search['use_zef']) {
			$searchQuery[]=array('Field'=>'calResUseZef','Typ'=>'=','Values'=>$search['use_zef']);
		}
		if ($search['use_cal']) {
			$searchQuery[]=array('Field'=>'calResUseCal','Typ'=>'=','Values'=>$search['use_cal']);
		}
		if ($search['uform']) {
			$params['JOIN']=" LEFT JOIN CalResourceUser ON (CalResource.calResID=CalResourceUser.FKObjID AND CalResourceUser.FKModul='cal')";
			$ok=false;
			foreach($search['uform'] as $v) {
				if (is_array($v[2])) {
					foreach($v[2] as $sv) {
						$searchQuery[]=array('Field'=>'CalResourceUser.F_'.$v[0],'Typ'=>$v[1],'Values'=>$sv);
						$ok=true;
					}
				} elseif($v[1]) {
					$searchQuery[]=array('Field'=>'CalResourceUser.F_'.$v[0],'Typ'=>$v[1],'Values'=>$v[2]);
					$ok=true;
				}
			}
			if (!$ok) {
				return array();
			}
		}
		//debug($this->_db->getWhere($searchQuery));
		$rows=0;
		return $this->searchObj($rows,$searchQuery,'CalResource.calResName ASC',$b,$limit,true,false,false,$params);
	}
	function resName2ID($name) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'CalResource.calResName','Typ'=>'regexp','Values'=>'^'.str_replace(' ','[,;. ]',preg_quote($name,'')).'$');
		return $this->searchSingleObj($searchQuery);
	}
	function getCachedName($ID) {
		if ($Obj=$this->getCachedObj($ID)) {
			return $Obj->getName();
		}
		return '';
	}
	function hasZefEntries() {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'calResDeleted','Typ'=>'=','Values'=>0);
		$searchQuery[]=array('Field'=>'calResUseZef','Typ'=>'=','Values'=>1);
		return $this->searchSingleObj($searchQuery)?true:false;
	}
}
?>
