<?php
class CalSearchGui {
	var $_Base;
	var $_BaseRes;
	var $_BaseCat;
	var $_T;
	var $_frm;
	var $_P;
	var $_E;
	var $_options=array(

	);
	function CalSearchGui($options=array()) {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_BaseRes=& $frm->getStaticModul('cal_res');
		$this->_BaseCat=& $frm->getStaticModul('cal_cat');
		$this->_T=&$T;
		$this->_frm=&$frm;
		$this->_P=&$P;
		$this->_L=&$L;
		$this->_E=&$E;
		$this->_options=array_merge($this->_options,$options);
		$this->_T->loadModul('cal');
		$this->_userID=$this->_frm->getUser();
		$this->_cat=$this->_BaseCat->listObj();
	}
	function setOption($key,$val) {
		$this->_options[$key]=$val;
	}
	function getOption($key,$ov=array()) {
		if (isset($ov[$key])) {
			return $ov[$key];
		} else {
			return $this->_options[$key];
		}
	}

	function _handleRequest() {
		$this->_calUser=$GLOBALS['CAL_USER'];
		$this->_date=Framework::getParam('date',time());
		if (!$this->_date) $this->_date=time();
		if (Framework::getParam('_loadSearch',0) || Framework::getParam('save_x','','P') || Framework::getParam('copy_x','','P')) {
			$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpCalSearch',1,0);
		}
		if (Framework::getParam('print',0)) {
			$this->print=true;
			$this->getResultGui();
			exit;
		}
		if (Framework::getParam('export',0)) {
			$this->export=true;
			$this->getResultGui();
			exit;
		}
		return true;
	}
	function &process() {
		if ($this->_handleRequest()) {
			require_once('lib/cal/class_CalLayerGui.php');
			$this->_lGui=new CalLayerGui(array());

			require_once('lib/class_TemplateGui.php');
			$TopGui=new TemplateGui('core/common_form.inc.html');

			require_once('lib/class_ApplicationTreeGui.php');
			$TreeGui=new ApplicationTreeGui();

			$cGui=& $this->getConfigGui();
			$TreeGui->addTreeContent($cGui);

			$rGui=& $this->getResultGui();
			$TreeGui->addContent($rGui,null,null);

			$TopGui->addContent('cont1',$TreeGui,'CONTENT');
			$TopGui->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
			return $TopGui;
		}
	}
	function &getConfigGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_DateSelectForm.php');

		$Gui=new TemplateGui('core/common_content_border.inc.html');

		$selDateGui=new DateSelectForm();
		$selDateGui->setAvMode(array(3,8));
		$selDateGui->setMode($this->_search['DateMode']?$this->_search['DateMode']:3);
		$selDateGui->setStartMonths(6);
		$selDateGui->setStartQuarter(2);

		if ($this->_search['StartDate'] || $this->_search['EndDate']) {
			$selDateGui->setDate(array($this->_search['StartDate'],$this->_search['EndDate']));
		} else {
			$selDateGui->setDate(array(0,0));
		}
		$Gui->addContent('dateSelect',$selDateGui->process(),'CONTENT');

		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key="sDeref";
		$formGui->addField($key,'check',$this->_T->lang('[[Wiederholungen berechnen]]'),isset($this->_search['sDeref'])?$this->_search['sDeref']:0,'fields1');


		$key="sInfo";
		$formGui->addField($key,'text',$this->_T->lang('[[Suchtext]]'),isset($this->_search['Info'])?$this->_search['Info']:'','fields1');

		$key="sCategory";
		$formGui->addField($key,'select',$this->_T->lang('[[Art des Termins]]'),isset($this->_search['CatID'])?$this->_search['CatID']:'','fields1');
		$formGui->setValues($key,array(0=>$this->_T->lang('[[Alle]]')) + $this->_frm->extractObjName($this->_cat));

		$key="sResource";
		$default=$this->_search['invitResource']?('s_'.implode('|s_',$this->_search['invitResource'])):'';
		$mode='s';
		$params=base64_encode(serialize(array('resCal'=>1,'useAll'=>1)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Resourcen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_RESOURCES',
		);
		$lb_InvitR=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_InvitR,$default,'fields1');
		$formGui->setParams($key,array('mode'=>$mode,'width'=>'240px','params'=>$params));
		$invitResource=array();
		if ($formGui->getFieldVal('sResource',1)) {
			$tmp=explode('|',$formGui->getFieldVal('sResource',1));
			foreach ($tmp as $val) {
				$invitResource[]=substr($val,2);
			}
		}

		$key="sUser";
		$default=$this->_search['invitUser']?('u_'.implode('|u_',$this->_search['invitUser'])):'';
		$mode='u';
		$params=base64_encode(serialize(array('useAll'=>1)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Teilnehmer]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_InvitU=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_InvitU,$default,'fields1');
		$formGui->setParams($key,array('mode'=>$mode,'width'=>'240px','params'=>$params));

		$invitUser=array();
		if ($formGui->getFieldVal('sUser',1)) {
			$tmp=explode('|',$formGui->getFieldVal('sUser',1));
			foreach ($tmp as $val) {
				$invitUser[]=substr($val,2);
			}
		}

		$submit_array=array(
			'search_x'=>' '.$this->_T->lang('[[Suchen]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','fields1');
		$formGui->setValues($key,$submit_array);

		$this->_search=array(
			'StartDate'=>$selDateGui->getDate('B'),
			'EndDate'=>$selDateGui->getDate('E'),
			'DateMode'=>$selDateGui->getMode(),
			'CatID'=>$formGui->getFieldVal('sCategory',1),
			'Info'=>$formGui->getFieldVal('sInfo',1),
			'invitResource'=>$invitResource,
			'invitUser'=>$invitUser,
			'Mode'=>$formGui->getFieldVal('sDeref',1)?0:1,
		);

		if ($this->_search['Mode']==0 && (!$this->_search['StartDate'] || !$this->_search['EndDate'])) {
			$this->_E->setError('fields','sDeref');
			$this->_search['Mode']=1;
		}


		$this->_frm->savePostData($this->_Base->getModul(),'tmpCalSearch',null,$this->_search);

		$Gui->addContent('config',$formGui,'CONTENT');
		return $Gui;
	}
	function sortData($a,$b) {
		$evtA=reset($a);
		$evtB=reset($b);

		return $evtA['StartDate']>$evtB['StartDate']?-1:1;
	}
	function getResultGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');

		$rows=0;
		if (Framework::issetParam('search_x','','P')) {
			$b=0;
		} else {
			$b=Framework::getParam('b');
		}
		$limit=50;

		$search=$this->_search;
		$search['UserID']=$this->_Base->getUser();
		$search['GroupID']=$this->_Base->getGroup();
		$search['Order']=array('StartDate'=>-1);
		if ($this->export) {
			switch(Framework::getParam('exportTpl','xls')) {
				case 'ical':
				case 'xls_ms':
					$search['Mode']=1;
				break;
			}
		}

		if ($search['Mode']==0) {
			$limit=0;
			$b=0;
		} elseif ($this->export || $this->print) {
			$b=0;
			$limit=100000;
		}
		$data=array();
		$entries=$this->_Base->searchEvents($rows,$search,$b,$limit);
		if (!empty($entries)) {
			if ($search['Mode']) {
				foreach ($entries as $key=>$evtVal) {
					if (!$search['StartDate']) $search['StartDate']=$evtVal['StartDate'];
					$data[date('j-n-Y',$evtVal['StartDate'])][$key]=$evtVal;
					$search['EndDate']=max($search['EndDate'],$evtVal['EndDate']);
					$search['StartDate']=min($search['StartDate'],$evtVal['StartDate']);
				}
			} else {
				$data=$entries;
			}
			uasort($data,array($this,'sortData'));
		}

		if ($this->export) {
			switch(Framework::getParam('exportTpl','xls')) {
				case 'ical':
					$cardPrefs=array('ical'=>true,'attendee'=>true,'gmdate'=>1,'allDayMode'=>1);
					require_once ("lib/cal/ClassVcalWrite.php");
					require_once ("lib/cal/ClassVcal.php");
					$Vcal=new Vcal();
					$Vcal->setPrefs('cal',$cardPrefs);
					$VcalWrite= new VcalWrite();
					$VcalWrite->setPrefs('cal',$cardPrefs);
					$globalCard=array(
						'PRODID'=>array(
							'value'=>'-//Endo7 GmbH//GROUP-E Collaboration Software//EN',
						),
						'VERSION'=>array(
							'value'=>'2.0',
						),
						'CALSCALE'=>array(
							'value'=>'GREGORIAN',
						),
						'METHOD'=>array(
							'value'=>'PUBLISH',
						),
					);
					$VcalWrite->setGlobalCard($globalCard);
					$Card=array();
					foreach ($data as $dayStr=>$dayEvt) {
						foreach ($dayEvt as $evtVal) {
							$Card[]=$Vcal->event2vcal($evtVal);
						}
					}
					

					Framework::dumpText($VcalWrite->getVcal($Card,'VEVENT','2.0'),date('Ymd').'_calendar.ics','text/calendar');
	
					
				break;
				case 'csv-ms':
					$this->_Addr=& $this->_frm->getStaticModul('addr');
					$charset='WINDOWS-1252';
					$header=array(
						'StartDate'=>'StartDate',
						'StartTime'=>'StartDate',
						'EndDate'=>'EndDate',
						'EndTime'=>'EndDate',
						'Subject'=>'Title',
						'Body'=>'Text',
						'Place'=>'Place',
						'Category'=>'FKCatID',
						'Owner'=>'OwnerID',
						'Attendees'=>'',
						'NoInvitations'=>'NoInvit',
						'Resources'=>'InvitResources',
						'Project'=>'FKProjID',
						'AllDayEvent'=>'TimeMode',
						'Privat'=>'EvtPrivat',
						'Tentative'=>'Unsecure',
						'Notifications'=>'Message',
						'ReminderDate'=>'AlarmTime',
						'ReminderTime'=>'AlarmTime',
						'RecFreq'=>'RecType',
						'RecInterval'=>'RecInt',
						'RecUntil'=>'RecEnd',						
						'Visibility'=>'',
					);
					$csv=array();
					foreach ($data as $dayStr=>$dayEvt) {
						foreach ($dayEvt as $evtVal) {
							$row=array();
							foreach($header as $key=>$val) {
								$row[$key]='';
								switch($key) {
									case 'StartDate':
									case 'EndDate':
										$row[$key]=date('Y-m-d',$evtVal[$val]);
									break;
									case 'StartTime':
									case 'EndTime':
										$row[$key]=date('H:i',$evtVal[$val]);
									break;
									case 'Subject':
									case 'Body':
									case 'Place':
										$row[$key]=trim($evtVal[$val]);
									break;
									case 'Category':
										$row[$key]=$this->_BaseCat->getCachedObj($evtVal[$val])->getName();
									break;
									case 'Owner':
										$row[$key]=$this->_frm->getCachedUser($evtVal[$val],'email');
									break;
									case 'NoInvitations':
									case 'AllDayEvent':
									case 'Privat':
									case 'Tentative':
									case 'Notifications':
										$row[$key]=$evtVal[$val]?1:0;
									break;
									case 'RecInterval':
										$row[$key]=$evtVal[$val];
									break;
									case 'Resources':
										if ($evtVal[$val]) {
											$tmp=array();
											foreach (explode(',',$evtVal[$val]) as $id) {
												if ($tmpObj=$this->_BaseRes->getCachedObj($id)) {
													$tmp[]=$tmpObj->getName();
												}
											}
											$row[$key]=implode(',',$tmp);
										}
										
									break;
									case 'Project':
										if ($evtVal[$val] && ($tmpObj=$this->_P->getCachedObj($evtVal[$val]))) {
											$row[$key]=$tmpObj->getName();
										}
									break;
									case 'ReminderDate':
										if ($evtVal[$val]) $row[$key]=date('Y-m-d',$evtVal['StartDate']-$evtVal[$val]);
									break;
									case 'ReminderTime':
										if ($evtVal[$val]) $row[$key]=date('H:i',$evtVal['StartDate']-$evtVal[$val]);
									break;
										
									case 'RecFreq':
										switch($evtVal[$val]) {
											case 1:
												$row[$key]='D';
											break;
											case 2:
												$row[$key]='W';
											break;
											case 3:
												$row[$key]='M';
											break;
											case 5:
												$row[$key]='Y';
											break;
										}
									break;
									case 'RecUntil':
										$row[$key]=$evtVal[$val]>0?date('Y-m-d',$evtVal[$val]):'';
									break;
									case 'Attendees':
										$tmp=array();
										if (trim($evtVal['InvitUsers'])) {
											foreach (explode(',',$evtVal['InvitUsers']) as $uid) {
												$tmp[]=$this->_frm->getCachedUser((int)$uid,'email');
											}
										}
										if (trim($evtVal['InvitGroups'])) {
											foreach (explode(',',$evtVal['InvitGroups']) as $uid) {
												$tmp[]='@'.$this->_frm->getCachedGroupName((int)$uid);
											}
										}
										if (trim($evtVal['InvitAddr'])) {
											
											foreach (explode(',',$evtVal['InvitAddr']) as $uid) {
												if ($tmpObj=$this->_Addr->getAddrObj($val)) {
													$tmpMail=$this->_Addr->AddrExplode($AObj->getMeta('Email'));
													if ($tmpMail[0]) {
														$tmp[]=$tmpMail[0];
													}
												}
											}
										}
										$row[$key]=implode(',',$tmp);
									break;
									case 'Visibility':
										$tmp=array();
										if (trim($evtVal['GrantUsers'])) {
											foreach (explode(',',$evtVal['GrantUsers']) as $uid) {
												$tmp[]=$this->_frm->getCachedUser((int)$uid,'email');
											}
										}
										if (trim($evtVal['GrantGroups'])) {
											foreach (explode(',',$evtVal['GrantGroups']) as $uid) {
												$tmp[]='@'.$this->_frm->getCachedGroupName((int)$uid);
											}
										}
										$row[$key]=implode(',',$tmp);
									break;
								}
								
							}
							$csv[]=$row;
							
						}
					}

					Framework::exportCsv($csv,';',true,date('Ymd').'_calendar.csv',true,'WINDOWS-1252');
					
				break;
				default:
					$charset='WINDOWS-1252';
	
					require_once("lib/class_WriteExcel.inc.php");
					$_tmp_file=tempnam(Framework::getTempPath(),'xls');
					$xls=& new writeexcel_workbook($_tmp_file);
					$format=array();
					$format['normal']=& $xls->addFormat(array('bold' => 0));
					$format['date']=& $xls->addformat(array('num_format' => 'dd.mm.YYYY'));
					$format['datetime']=& $xls->addformat(array('num_format' => 'dd.mm.YYYY hh:mm'));
					$format['time']=& $xls->addformat(array('num_format' => 'hh:mm'));
					$format['bold']=& $xls->addFormat(array('bold' => 1));
		
					$worksheet=& $xls->addworksheet('Calendar');
					$rowNum=0;$colNum=0;
		
					$header=array(
						'id',
						'starttime',
						'endtime',
						'minutes',
						'alldayevent',
						'subject',
						'body',
						'location',
						'categories',
						'organizername',
						'organizeremail',
					);
					foreach($header as $val) {
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($val,GE_CHARSET,$charset),$format['bold']);
						$colNum++;
					}
					$rowNum++;
					$worksheet->set_column(0, 0, 10, $format['normal'],1);
					$worksheet->set_column(1, 2, 18, $format['datetime']);
					$worksheet->set_column(3, 4, 11, $format['normal']);
					$worksheet->set_column(5, 5, 40, $format['normal']);
					$worksheet->set_column(6, 10, 20, $format['normal']);
		
		
					foreach ($data as $dayStr=>$dayEvt) {
						foreach ($dayEvt as $evtVal) {
							$colNum=0;
							$uOwner=$this->_frm->getCachedUser($evtVal['OwnerID']);
		
							$worksheet->write($rowNum,$colNum,$evtVal['EventID'],$format['normal']);
							$colNum++;
							$xlsDate=$xls->xl_date_list(date('Y',$evtVal['StartDate']),date('m',$evtVal['StartDate']),date('d',$evtVal['StartDate']),date('H',$evtVal['StartDate']),date('i',$evtVal['StartDate']));
							$worksheet->write($rowNum,$colNum,$xlsDate);
							$colNum++;
							$xlsDate=$xls->xl_date_list(date('Y',$evtVal['EndDate']),date('m',$evtVal['EndDate']),date('d',$evtVal['EndDate']),date('H',$evtVal['EndDate']),date('i',$evtVal['EndDate']));
							$worksheet->write($rowNum,$colNum,$xlsDate);
							$colNum++;
							$worksheet->write($rowNum,$colNum,$evtVal['TimeMode']?'':(intval($evtVal["EndDate"]-$evtVal["StartDate"])/60),$format['normal']);
							$colNum++;
							$worksheet->write($rowNum,$colNum,$evtVal['TimeMode']?1:0,$format['normal']);
							$colNum++;
							$worksheet->write($rowNum,$colNum,Framework::convertCharset($evtVal['Title'],GE_CHARSET,$charset),$format['normal']);
							$colNum++;
							$worksheet->write($rowNum,$colNum,Framework::convertCharset($evtVal['Text'],GE_CHARSET,$charset),$format['normal']);
							$colNum++;
							$worksheet->write($rowNum,$colNum,Framework::convertCharset($evtVal['Place'],GE_CHARSET,$charset),$format['normal']);
							$colNum++;
							//debug($evtVal);
							$worksheet->write($rowNum,$colNum,Framework::convertCharset($this->_BaseCat->getCachedObj($evtVal['FKCatID'])->getName(),GE_CHARSET,$charset),$format['normal']);
							$colNum++;
							$worksheet->write($rowNum,$colNum,Framework::convertCharset($uOwner['lastname'].' '.$uOwner['firstname'],GE_CHARSET,$charset),$format['normal']);
							$colNum++;
							$worksheet->write($rowNum,$colNum,Framework::convertCharset($uOwner['email'],GE_CHARSET,$charset),$format['normal']);
							$colNum++;
		
		
							$rowNum++;
						}
					}
		
					$xls->close();
					Framework::dumpFile($_tmp_file,date('Ymd').'_calendar.xls','application/x-msexcel',true);
				break;
			}

		}

		if ($this->print) {
			require_once('lib/cal/class_CalPrintGui.php');
			$printGui=new CalPrintGui(array(
				'TplID'=>intval(Framework::getParam('printTpl','','G'))?Framework::getParam('printTpl','','G'):'list_s',
				'TimeStart'=>$search['StartDate'],
				'TimeEnd'=>$search['EndDate'],
				'CalUserID'=>$this->_Base->getUser(),
				'CalUserName'=>$this->_frm->getCachedUserName($this->_Base->getUser(),0,1),
			));
			$CalUsers=array();
			$CalUsers['u_'.$this->_Base->getUser()]=array(
				'Typ'=>'u',
				'ID'=>$this->_Base->getUser(),
				'Name'=>$this->_frm->getCachedUserName($this->_Base->getUser(),0,1),
			);
			$printGui->setOption('CalUsers',$CalUsers);

			$printGui->setEntries($data);
			$printGui->printList();

		} else {

			$Gui=new ApplicationListGui();
			$Gui->setName($this->_T->lang('[[Suche]]'));
			$Gui->addHeaderCol('Datum',$this->_T->lang('[[Datum]]'),'','','',1,'',2);
			$Gui->addHeaderCol('Time',$this->_T->lang('[[Uhrzeit]]'),'','','',1,'',1);
			$Gui->addHeaderCol('Duration',$this->_T->lang('[[Dauer]]'),'','','',1,'',2);
			$Gui->addHeaderCol('Title',$this->_T->lang('[[Titel]]'),'','','',0,'2000');
			$Gui->addHeaderCol('OwnerID',$this->_T->lang('[[Erstellt von]]'),'','','',1,'');
			$Gui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));
			$Gui->setLimit($limit);
			$Gui->setSumRows($rows);
			$Gui->setBegin($b);
			$L=Framework::cloneObj($this->_L);
			$L->setParam('_loadSearch',1);
			$Gui->setNavLink($L);

			//debug($entries);
			$totalDur=0;
			foreach ($data as $dayStr=>$dayEvt) {
				foreach ($dayEvt as $evtVal) {
					$Gui->addRow($hl?$hl=0:$hl=1);
					$this->_addRow($Gui,$evtVal);
					$totalDur+=($evtVal["EndDate"]-$evtVal["StartDate"])/60;
				}
			}
			$Gui->addRow(4);
			$Gui->addCol('DatumB',$this->_T->lang('[[Totale]]'),'','','right',1,'',3);
			$Gui->addCol('Dauer',Framework::formatTime($totalDur),'','','right',1,'',0,'',array());
			$Gui->addCol('Spc','','','','',1,'',3);


			require_once('lib/class_PrintDialogGui.php');
			$printDialogGui=new PrintDialogGui('cal');
			$printDialogGui->process('list_s');

			$btPrint=new FunctionButtons('print','button_link',array('TITLE'=>$this->_T->lang('[[Drucken]]'),'LINK'=>'javascript:showPrintDialog(\'list_s\');','TARGET'=>''));
			$Gui->addFunction($btPrint,1);
			
			require_once('lib/class_ExportDialogGui.php');
			$exportDialogGui=new ExportDialogGui();
			$exportDialogGui->setDefaultConfig('xls','Excel');
			$exportDialogGui->setDefaultConfig('csv-ms','CSV');
			$exportDialogGui->setDefaultConfig('ical','I-Cal');
			$exportDialogGui->process();
			
			
			$btExport=new FunctionButtons('export','button_link',array('TITLE'=>$this->_T->lang('[[Export]]'),'LINK'=>'javascript:showExportDialog();','TARGET'=>''));
			$Gui->addFunction($btExport,1);

			return $Gui;
		}
	}
	function _addRow($Gui,$evtVal) {
		$link='index.php?site=cal.php&action=view&view=event&back=0&event_id=';
		$params=array();
		$params['LinkAttribs']=$this->_lGui->addEventLayer($evtVal);
		if ($evtVal['EvtPrivat'] && $evtVal['OwnerID']==$this->_userID) {
			$params['style']='background-color:#ffe6cc;';
		} elseif ($evtVal['Unsecure']) {
			$params['style']='background-color:#ececec;';
		}
		if ($evtVal['Unsecure']) {
			$params['style'].='font-style:italic;';
		}
		if (!$evtVal['_Privat'] && $evtVal['OwnerID']==$this->_userID && $this->_Base->getCalPerms(2)) {
			$params['LinkAttribs']['onclick']='return goToView(this);';
			$params['LinkAttribs']['ondblclick']='return goToEdit(this,\'action=view\',\'action=edit&back=0\');';
		}

		$Gui->addCol('DatumB',date('d.m.Y',$evtVal["StartDate"]).' - '.date('d.m.Y',$evtVal["EndDate"]),'','','',1,'',0,'',$params);
		$Gui->addCol('Rec','',($evtVal['RecType']?'wiederholungstermin.gif':''),'','',1,'',0,'',$params);
		$Gui->addCol('Time',$evtVal['TimeMode']?'':(date('H:i',$evtVal["StartDate"]).' - '.date('H:i',$evtVal["EndDate"])),'','','',1,'',0,'',$params);
		if (!$evtVal['TimeMode']) {
			$dur=($evtVal["EndDate"]-$evtVal["StartDate"])/60;
		} else {
			$dur=0;
		}
		$Gui->addCol('Dauer',$dur?Framework::formatTime($dur):'','','','right',1,'',0,'',$params);
		$Gui->addCol('Alarm','',($evtVal['AlarmTime']?'alarm.gif':''),'','',1,'',0,'',$params);
		$Gui->addCol('Title',$evtVal['Title'],'',$link.$evtVal['EventID'],'',0,'',0,'',$params);
		$Gui->addCol('OwnerID',$this->_frm->getCachedUserName($evtVal['OwnerID']),'','','',1,'',0,'',$params);
	}

}
?>