<?php
class ObjCalTime extends baseObj {
	var $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['calTimeName'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class CalTime extends ObjCore {
	var $_modul='cal';
	var $_table='CalTime';
	var $_cfgObjects=array (
		'IdField'=>'calTimeID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'TranslationFields'=>array('calTimeName'),
		'0'=>array(
			'ClassName'=>'ObjCalTime',
			'Fields'=>array(
				'calTimeID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'calTimeName'=>array(
					'Typ'=>'core',
				),
				'calTimeSettings'=>array(
					'Typ'=>'core',
				),
				'calTimeDeleted'=>array(
					'Typ'=>'core',
				),
			),
		),
	);

	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','cal')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function insertObj(&$Obj) {
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		$Obj->setMeta('calTimeDeleted',1);
		return $this->updateObj($Obj);
	}
	function listObj($all=false) {
		$searchQuery=array();
		if (!$all) $searchQuery[]=array('Field'=>'calTimeDeleted','Typ'=>'=','Values'=>0);
		$rows=0;
		return $this->searchObj($rows,$searchQuery,'CalTime.calTimeName ASC');
	}
}
?>
