<?php
class DayListGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_mode='m';
	var $_nw=1;
	var $_parsed=array();
	var $_ignoreInvit=false;
	var $_ignoreOwner=false;
	var $_groupMode=false;
	var $_timeformat='short';
	var $_draggable=array();
	var $_idPrep='evt';
	var $_parsedRecur=array();
	var $_evtColors=array();
	function DayListGui() {
		global $frm,$t,$T,$E,$L,$Y,$P;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_BaseRes=& $frm->getStaticModul('cal_res');
		$this->_P=&$P;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('cal');
		require_once('lib/class_SimpleListGui.php');
		$this->_Gui=new SimpleListGui();
		$this->_Gui->setClass('cal_list');
		require_once('lib/cal/class_CalLayerGui.php');
		$this->_lGui=new CalLayerGui();
		$this->_userID=$this->_frm->getUser();
	}
	function setPrivateEvents(&$events) {
		$this->_p_events=&$events;
	}
	function setGroupEvents(&$events) {
		$this->_g_events=&$events;
	}
	function setInvitEvents(&$events) {
		$this->_i_events=&$events;
	}
	function setAccessLink($l) {
		$this->_aL=$l;
	}
	function setUserID($id) {
		$this->_userID=$id;
	}
	function setIgnoreInvit($val) {
		$this->_ignoreInvit=$val;
	}
	function setIgnoreOwner($val) {
		$this->_ignoreOwner=$val;
	}
	function setGroupMode($val) {
		$this->_groupMode=$val;
	}
	function setParseDragDrop($val) {
		$this->_dragDrop=$val;
	}
	function setIdPrepend($val) {
		$this->_idPrep=$val;
	}
	function setTimeFormat($val) {
		$this->_timeformat=$val;
	}
	function getDayList($day_b,$day_e=0) {
		return $this->_Gui->process('',$day_b);
	}
	function process($day_b) {
		return $this->_Gui->process('',$day_b);
	}
	function dayNumEntries($day_b) {
		return $this->_parsed[$day_b];
	}
	function getDraggable() {
		return $this->_draggable;
	}
	function processDay($day_b,$day_e,$title='') {
		$day_key=date('j-n-Y',$day_b);
		$parsed_p=false;
		if ($title) {
			$this->_Gui->addContent('title_'.$day_b,$title,$day_b,'','',array('class'=>'title'));
		}
		$this->_parsed[$day_b]=0;
		$this->_freePos[$day_b]=array();
		if (is_array($this->_p_events[$day_key])) {
			uasort($this->_p_events[$day_key],array('CalEvent',"daycmp"));
			$this->_evtColors=$this->_Base->listEventColor(array_keys($this->_p_events[$day_key]));
			//debug($this->_evtColors);
			foreach ($this->_p_events[$day_key] as $key=>$val) {
				if ($val['TimeMode']==1) {
					if (!$val['_row']) {
						$val['_row']=1;
						while(isset($this->_freePos[$day_b][$val['_row']])) {
							$val['_row']++;
						}
						$this->_p_events[$day_key][$key]['_row']=$val['_row'];
					}
					//debug($val['_row']);
					$this->_freePos[$day_b][$val['_row']]=$key;
				}
				if ($val["EndDate"]>$day_e) {
					if ($val["RecType"] && (!isset($this->_parsedRecur[$key]) || $this->_parsedRecur[$key]['_end']<$day_b || $this->_parsedRecur[$key]['_start']>$day_e)) {
						$this->_parsedRecur[$key]=array(
							'StartDate'=>$val["StartDate"],
							'EndDate'=>$val["EndDate"],
							'_start'=>mktime(0,0,0,date('m',$val["StartDate"]),date('d',$val["StartDate"]),date('Y',$val["StartDate"])),
							'_end'=>mktime(23,59,59,date('m',$val["EndDate"]),date('d',$val["EndDate"]),date('Y',$val["EndDate"])),
							'_cnt'=>isset($this->_parsedRecur[$key])?($this->_parsedRecur[$key]['_cnt']+1):1,
						);
						$val['OrigStart']=$val["StartDate"];
						$val['OrigEnd']=$val["EndDate"];

					}
					if (!isset($val['OrigStart'])) {
						$val['OrigStart']=$val["StartDate"];
					}
					if (!isset($val['OrigEnd'])) {
						$val['OrigEnd']=$val["EndDate"];
					}
					$newEvt=$val;
					$val["EndDate"]=$day_e;
					$newEvt["StartDate"]=$day_e+1;
					$newEvt["_seq"]=isset($val["_seq"])?($val["_seq"]+1):1;
					$this->_p_events[date('j',$newEvt["StartDate"]).'-'.date('n',$newEvt["StartDate"]).'-'.date('Y',$newEvt["StartDate"])][$key]=$newEvt;
					$this->_p_events[$day_key][$key]=$val;
				}
			}
			
			uasort($this->_p_events[$day_key],array('CalEvent',"daycmp"));
			foreach ($this->_p_events[$day_key] as $key=>$val) {
				if ($this->_ignoreInvit && $this->_i_events[$key]) continue;
				$this->addEventToList($day_b,$key,$val,1,$day_b);
				$this->_parsed[$day_b]+=1;
				$parsed[$key]=1;
				$parsed_p=true;
			}
		}
		$this->_freePos[$day_b]=array();
		//	debug($this->_g_events);
		if (is_array($this->_g_events[$day_key])) {
			uasort($this->_g_events[$day_key],array('CalEvent',"daycmp"));
			$this->_evtColors=$this->_Base->listEventColor(array_keys($this->_g_events[$day_key]));
			foreach ($this->_g_events[$day_key] as $key=>$val) {
				if ($parsed[$key]) continue;
				if ($this->_ignoreInvit && $this->_i_events[$key]) continue;
				if ($parsed_p) {
					$text='<div class="line" />';
					$this->_Gui->addContent('evt0_'.$day_b,$text,$day_b);
				}
				$parsed[$key]=1;
				if ($this->_groupMode && $val['TimeMode']==1) {
					if (!$val['_row']) {
						$val['_row']=1;
						while(isset($this->_freePos[$day_b][$val['_row']])) {
							$val['_row']++;
						}
						$this->_g_events[$day_key][$key]['_row']=$val['_row'];
					}
					//debug($val['_row']);
					$this->_freePos[$day_b][$val['_row']]=$key;
				}
				if ($val["EndDate"]>$day_e) {
					if ($val["RecType"] && (!isset($this->_parsedRecur[$key]) || $this->_parsedRecur[$key]['_end']<$day_b || $this->_parsedRecur[$key]['_start']>$day_e)) {
						$cnt=0;
						$this->_parsedRecur[$key]=array(
							'StartDate'=>$val["StartDate"],
							'EndDate'=>$val["EndDate"],
							'_start'=>mktime(0,0,0,date('m',$val["StartDate"]),date('d',$val["StartDate"]),date('Y',$val["StartDate"])),
							'_end'=>mktime(23,59,590,date('m',$val["EndDate"]),date('d',$val["EndDate"]),date('Y',$val["EndDate"])),
							'_cnt'=>isset($this->_parsedRecur[$key])?($this->_parsedRecur[$key]['_cnt']+1):1,
						);
						$val['OrigStart']=$val["StartDate"];
						$val['OrigEnd']=$val["EndDate"];

					}
					if (!isset($val['OrigStart'])) {
						$val['OrigStart']=$val["StartDate"];
					}
					if (!isset($val['OrigEnd'])) {
						$val['OrigEnd']=$val["EndDate"];
					}
					$newEvt=$val;
					$val["EndDate"]=$day_e;
					$newEvt["StartDate"]=$day_e+1;
					$this->_g_events[date('j',$newEvt["StartDate"]).'-'.date('n',$newEvt["StartDate"]).'-'.date('Y',$newEvt["StartDate"])][$key]=$newEvt;
					$this->_g_events[$day_key][$key]=$val;
				}
				$this->addEventToList($day_b,$key,$val,0,$day_b);
				$this->_parsed[$day_b]+=1;
			}
		}
		$bug_text='<div style="height:0px;" />';
		$this->_Gui->addContent('bug_'.$day_b,$bug_text,$day_b);

	}
	function addEventToList($day,$evtID,$evtVal,$privat=1,$group=0,$lay_prep='evt_') {
		if ($privat) {
			$img=($evtVal['GrantGroups'] || $evtVal['GrantUsers'])?'month_mall.gif':'month_mine.gif';
		} else {
			$img="month_all.gif";
		}
		$params=array();
		$attribs=array();
		if ($evtVal['_row']) {
			for($i=$evtVal['_row']-1;$i>=1;$i--) {
				if (isset($this->_freePos[$day][$i])) {
					break;
				} else {
					$spc='&nbsp;';
					//$attribs['style'].='margin-bottom:1px;padding-top:1px;padding-bottom:1px;';
					$this->_Gui->addContent('spc_'.$i.'_'.$day,$spc,$group,'','',$attribs,$params);
				}
				
			}
			
		}
		//if ($evtID==14088) echo $img.'<br>';
		$options=array(
			'prepend'=>'evt_'
		);
		if (isset($this->_parsedRecur[$evtID])) {
			$options['prepend'].=$this->_parsedRecur[$evtID]['_cnt'].'_';
		}
		$params['LinkAttribs']=$this->_lGui->addEventLayer($evtVal,$options);

		if (isset($this->_evtColors[$evtID]) && trim($this->_evtColors[$evtID])) {
			$attribs['style']='background-color:'.$this->_evtColors[$evtID].';';
		} elseif ($evtVal['EvtPrivat'] && $evtVal['OwnerID']==$this->_userID) {
			$attribs['style']='background-color:#ffe6cc;';
		} elseif ($this->_i_events[$evtID]) {
			$attribs['style']='background-color:'.$this->_Base->getCfg('cfg/icolor').';';
		} elseif ($evtVal['Unsecure']) {
			$attribs['style']='background-color:#ececec;';
		} else {
			//$attribs['style']='background-color:#efefef;';
		}
		//$attribs['style'].='margin-bottom:1px;padding-top:1px;padding-bottom:1px;';
		
		if ($evtVal['Unsecure']) {
			$attribs['style'].='font-style:italic;';
		}
		if (!$evtVal['_Privat'] && $evtVal['OwnerID']==$this->_userID && $this->_Base->getCalPerms(2)) {
			$params['LinkAttribs']['onclick']='return goToView(this);';
			$params['LinkAttribs']['ondblclick']='return goToEdit(this,\'action=view\',\'action=edit&back=0\');';
			if ($this->_dragDrop) {
				$evtVal['dayDate']=$day;
				$this->_draggable[$this->_idPrep.$evtID.'_'.$day]=$evtVal;
				$attribs['style'].='cursor:move;';
				//$params['LinkAttribs']['id']='evt'.$evtID.'_'.$day;
			}
		}
		$attribs['class']='grp_'.$evtID;
		
		
		$link=$this->_aL.'&event_id='.$evtID.'&edate='.$day;
		$title='';
		switch ($this->_timeformat) {
			case 'full':
				 $title.=$this->_Base->formatDate($evtVal["StartDate"],0,$evtVal['TimeMode']).'-';
			break;
			default:
				if ($evtVal['TimeMode']!=1) {
					$title.=date("H:i",$evtVal["StartDate"]);
					if ($this->_frm->getPrefs('cal',"showHour")) $title.=date("-H:i",$evtVal["EndDate"]);
					$title.=' ';
				}
		}


		if (!$this->_ignoreOwner && $evtVal["OwnerID"]!=$this->_userID && !$evtVal["NoOwner"]) {
			$title.=Framework::entities($this->_frm->getCachedUserName($evtVal["OwnerID"],0,1)).' ';
		}
		$title.=Framework::entities($evtVal["Title"]);
		if ($privat && $this->_frm->getPrefs('cal',"showAlarm") && $evtVal["AlarmTime"]) {
			$title.='<img src="img/'.APP_THEME.'/alarm.gif" class="list_img" />';
		}
		
		/*if ($evtVal['_row'] && $evtVal['_seq']) {
			$title='&nbsp;';
			$img='';
		}*/
		//$title.='-'.$evtVal['_row'];
		
		$this->_Gui->addContent($this->_idPrep.$evtID.'_'.$day,$title,$group,$link,$img,$attribs,$params);
	}
}
?>