<?php
class EventMoveGui {
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_Conflict=false;
	var $_checkConflict=true;
	var $_start=0;
	var $_end=0;
	var $_view='';
	var $_date=0;

	function EventMoveGui() {
		global $frm,$t,$T,$E,$L,$P,$Y;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_BaseCat=$frm->getStaticModul('cal_cat');
		$this->_wd=& $frm->getStaticModul('workday');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_P=&$P;
		$this->_lGui=&$Y;
		$this->_T->loadModul('cal');
		$this->_calUser=$GLOBALS['CAL_USER'];
		$this->_dayUserB=$this->_frm->getPrefs('cal',"db_h")*60+$this->_frm->getPrefs('cal',"db_m");
		if (!$this->_dayUserB) $this->_dayUserB=480;
		$this->_dayUserE=$this->_frm->getPrefs('cal',"de_h")*60+$this->_frm->getPrefs('cal',"db_m");
		if (!$this->_dayUserE) $this->_dayUserE=1200;
		$this->_ConfGui=$this->_frm->getStaticGuiModul('cal','CalConflictGui');
		$this->_cat=$this->_BaseCat->listObj();
	}
	function setStart($val) {
		$this->_start=$val;
	}
	function setEnd($val) {
		$this->_end=$val;
	}
	function setDayUserB($val) {
		$this->_dayUserB=$val;
	}
	function setDayUserE($val) {
		$this->_dayUserE=$val;
	}
	function setView($val) {
		$this->_view=$val;
	}
	function setDate($val) {
		$this->_date=$val;
	}
	function setDraggable(&$val) {
		$this->_draggable=&$val;
	}
	function setDroppable(&$val) {
		$this->_droppable=&$val;
	}
	function setCheckConflict($val=1) {
		$this->_checkConflict=$val;
	}
	function getConflict() {
		return $this->_Conflict;
	}
	function parseJsDrop() {
		require_once('lib/class_FastTemplateGui.php');
		$Gui=new FastTemplateGui('cal/drop_js.inc.html');
		$Gui->setEncode(false);
		$Gui->assign('DRAG_OBJECTS',$this->getJsDraggable());
		$Gui->assign('DROP_OBJECTS',$this->getJsDroppable());

		$js=array(
			'view'=>$this->_view,
			'start'=>$this->_start,
			'end'=>$this->_end,
			'date'=>$this->_date,
			'dayB'=>$this->_dayUserB,
			'dayE'=>$this->_dayUserE,
		);
		$Gui->assign('CAL_VIEW',Framework::array2json($js));

		$this->_frm->initExtJs();
		$this->_frm->addScript($Gui);
		
		require_once('lib/class_ColorPickerGui.php');
		$cGui=new ColorPickerGui();
		$cGui->setColors(explode(',','transparent,'.$this->_Base->getCfg('cfg/colors')));
		$cGui->setCallBack('setContextCalColor');
		$this->_frm->addScript($cGui);
	}
	function delEvent($oid,$nData,$evtDate) {
		$obj=$this->_Base->readEvent($oid);
		if (!is_array($obj)) return false;
		if ($this->_start && $this->_end) {
			$this->_origEvents=$this->_Base->listEvents($this->_start,$this->_end,0,$oid);
		}
		if ($obj['RecType'] && ($next=$this->_Base->nextRecurrence($obj, $evtDate))) {
			$obj['StartDate']=$next['start'];
			$obj['EndDate']=$next['end'];
		}
		$this->_Base->deleteEventObject($obj,$nData['moveOne']);
		return $oid;
	}
	function moveEvent($oid,$nData,$evtDate) {
		$this->_oldEvtID=$oid;
		$obj=$this->_Base->readEvent($oid);
		if (!is_array($obj)) return false;
		if ($this->_start && $this->_end) {
			$this->_origEvents=$this->_Base->listEvents($this->_start,$this->_end,0,$oid);
		}
		$catView=isset($this->_cat[$obj['FKCatID']])?$this->_cat[$obj['FKCatID']]->getMeta('calCatView'):0;
		
		if ($obj['RecType'] && ($next=$this->_Base->nextRecurrence($obj, $evtDate))) {
			$obj['StartDate']=$next['start'];
			$obj['EndDate']=$next['end'];
		}
		if ($obj['StartDate']==$nData['StartDate'] && $obj['EndDate']==$nData['EndDate'] && (!($catView&128) || !isset($nData['Unsecure']) || $nData['Unsecure']==$obj['Unsecure'])) {
			return $oid;
		}
		$log_tras=array(
			'{EDATE}'=>$this->_Base->formatDate($obj['StartDate'],$obj['EndDate'],$obj['TimeMode']),
			'{ETITLE}'=>trim($obj['Title']),
			'{EPLACE}'=>trim($obj['Place']),
			'{ETEXT}'=>trim($obj['Text']),
			'{TEXT}'=>'',
			'{CUSER}'=>$this->_frm->getCachedUserName($this->_Base->getUser(),0,1),
			'{OUSER}'=>$this->_frm->getCachedUserName($obj['OwnerID'],0,1),
		);
		$diff=($nData['StartDate']-$obj['StartDate'])+$this->_Base->date_dist_cmp($nData['StartDate'],$obj['StartDate']);
		$this->_UserDone=$this->_Base->readEventDone($oid,'u');
		if ($obj['RecType']) {
			if ($nData['moveOne']) {
				if ($obj['Exception']) {
					$c_ex=explode(',',$obj['Exception']);
				} else {
					$c_ex=array();
				}
				$c_ex[]=mktime(0,0,0,date('m',$obj['StartDate']),date('d',$obj['StartDate']),date('Y',$obj['StartDate']));

				$nobj=Framework::cloneObj($obj);
				$nobj['RecType']=0;
				$nobj['RecInt']=0;
				$nobj['RecEnd']=0;
				$nobj['UID']=0;
				$nobj['Sequence']=0;
				$nobj['Exception']='';
				$nobj['StartDate']=$nData['StartDate'];
				$nobj['EndDate']=$nData['EndDate'];
				$nobj['AlarmSend']=0;
				$nobj['TimeModify']=0;
				$nobj['TimeChange']=0;
				$nobj['UserModify']=0;
				if (($catView&128) && isset($nData['Unsecure'])) $nobj['Unsecure']=$nData['Unsecure'];
				$this->_Conflict=$this->_ConfGui->checkConflict($nobj,0,$this->_checkConflict);
				if (!$this->_Conflict) {
					$this->_Base->updateEvent($oid,array('UID'=>$obj['UID'],'TimeChange'=>$obj['TimeChange'],'Exception'=>implode(',',$c_ex),'Sequence'=>$obj['Sequence']+1),0);
					$nevent_id=$this->_Base->saveEvent($nobj);
					if ($this->_frm->getUser()!=$this->_Base->getUser()) {
						$logTyp='new';
						$this->_Base->insertLog($oid,$this->_Base->getAuthUser(),strtr($this->_T->lang('[[action_'.$logTyp.'_title]]'),$log_tras),'log');
					}
				}
			} else {
				if ($obj['RecEnd']>0) {
					$next_rec_end=$obj['RecEnd']+$diff;
					$next_rec_end+=$this->_Base->date_dist_cmp($next_rec_end,$obj['RecEnd']);
					$next_rec_end=mktime(23,59,59,date('m',$next_rec_end),date('d',$next_rec_end),date('y',$next_rec_end));
				} else {
					$next_rec_end=$obj['RecEnd'];
				}

				$nobj=Framework::cloneObj($obj);
				unset($nobj['TimeModify'],$nobj['UserModify'],$nobj['TimeChange']);
				$nobj['StartDate']=$nData['StartDate'];
				$nobj['EndDate']=$nData['EndDate'];
				$nobj['RecEnd']=$next_rec_end;
				$nobj['AlarmSend']=0;
				$nobj['Exception']='';
				$nobj['Sequence']=$obj['Sequence']+1;
				if (($catView&128) && isset($nData['Unsecure'])) $nobj['Unsecure']=$nData['Unsecure'];

				$this->_Conflict=$this->_ConfGui->checkConflict($nobj,$this->_oldEvtID,$this->_checkConflict);
				if (!$this->_Conflict) {
					$this->_Base->updateEvent($oid,$nobj,0);
					$iusers=$this->_UserDone;
					unset($iusers[$this->_Base->getUser()]);
					if (count($iusers)) $this->_Base->deleteEventDone($oid,'u',array_keys($iusers));
					$nevent_id=$oid;
				}
			}
		} else {
			$nobj=Framework::cloneObj($obj);
			unset($nobj['TimeModify'],$nobj['UserModify'],$nobj['TimeChange']);
			$nobj['StartDate']=$nData['StartDate'];
			$nobj['EndDate']=$nData['EndDate'];
			$nobj['AlarmSend']=0;
			$nobj['Sequence']=$obj['Sequence']+1;
			if (($catView&128) && isset($nData['Unsecure'])) $nobj['Unsecure']=$nData['Unsecure'];

			$this->_Conflict=$this->_ConfGui->checkConflict($nobj,$this->_oldEvtID,$this->_checkConflict);
			if (!$this->_Conflict) {
				$this->_Base->updateEvent($oid,$nobj,0);
				$iusers=$this->_UserDone;
				unset($iusers[$this->_Base->getUser()]);
				if (count($iusers)) $this->_Base->deleteEventDone($oid,'u',array_keys($iusers));
				$nevent_id=$oid;
			}
		}
		if (!$this->_Conflict) {
			$logTyp='move';
			$log_tras['{NDATE}']=$this->_Base->formatDate($nData['StartDate'],$nData['EndDate'],$obj['TimeMode']);
			$this->_Base->insertLog($oid,$this->_Base->getAuthUser(),strtr($this->_T->lang('[[action_'.$logTyp.'_title]]'),$log_tras),'log');

			if ($obj['Message']) {
				unset($send_user);
				foreach ($this->_UserDone as $key=>$val) {
					if ($key!=$this->_frm->getUser()) {
						$send_user[]=$key;
					}
				}
				if ($send_user) {
					$this->_frm->sendmessage($send_user,
						$this->_frm->getUser(),
						strtr($this->_T->lang('[[action_'.$logTyp.'_title]]'),$log_tras),
						strtr($this->_T->lang('[[action_'.$logTyp.'_text]]'),$log_tras),
						"?site=cal.php&action=view&view=event&edate=".$nData['StartDate']."&event_id=".$oid,
						$obj['Title'],
						$this->_Base->getCfg('cfg/img_notes'));
				}
			}
			$this->_newEvtID=$nevent_id;
			if ($this->_start && $this->_end) {
				$this->_newEvents=$this->_Base->listEvents($this->_start,$this->_end,0,$nevent_id);
			}
			return $nevent_id;
		}
		return false;
	}
	function copyEvent($oid,$nData) {
		$this->_oldEvtID=$oid;
		$obj=$this->_Base->readEvent($oid);
		if (!is_array($obj)) return false;
		$catView=isset($this->_cat[$obj['FKCatID']])?$this->_cat[$obj['FKCatID']]->getMeta('calCatView'):0;
		if ($this->_start && $this->_end) {
			$this->_origEvents=$this->_Base->listEvents($this->_start,$this->_end,0,$oid);
		}
		$evtFmng=$this->_Base->listEventFmng($oid);


		$nobj=Framework::cloneObj($obj);
		$nobj['StartDate']=$nData['StartDate'];
		$nobj['EndDate']=$nData['EndDate'];
		$nobj['Exception']='';
		$nobj['AlarmSend']=0;
		$nobj['UID']=0;
		if (($catView&128) && isset($nData['Unsecure'])) $nobj['Unsecure']=$nData['Unsecure'];

		if ($obj['RecType']) {
			if ($nData['moveOne']) {
				$nobj['RecType']=0;
				$nobj['RecInt']=0;
				$nobj['RecEnd']=0;
			} else {
				if ($obj['RecEnd']>0) {
					$diff=($nobj['StartDate']-$obj['StartDate'])+$this->_Base->date_dist_cmp($nobj['StartDate'],$obj['StartDate']);
					$nobj['RecEnd']=$obj['RecEnd']+$diff;
					$nobj['RecEnd']+=$this->_Base->date_dist_cmp($next_rec_end,$obj['RecEnd']);
					$nobj['RecEnd']=mktime(23,59,59,date('m',$next_rec_end),date('d',$next_rec_end),date('y',$next_rec_end));
				}
			}
		}
		$this->_Conflict=$this->_ConfGui->checkConflict($nobj,0,$this->_checkConflict);
		if (!$this->_Conflict) {
			$nevent_id=$this->_Base->saveEvent($nobj);
			if (!empty($evtFmng)) {
				$this->_Base->insertEventFmng($nevent_id,$evtFmng);
			}
			if ($nobj['OwnerID']!=$this->_Base->getAuthUser()) {
				$log_tras=array(
					'{EDATE}'=>$this->_Base->formatDate($nobj['StartDate'],$nobj['EndDate'],$nobj['TimeMode']),
					'{ETITLE}'=>trim($nobj['Title']),
					'{EPLACE}'=>trim($nobj['Place']),
					'{ETEXT}'=>trim($nobj['Text']),
					'{TEXT}'=>'',
					'{CUSER}'=>$this->_frm->getCachedUserName($nobj['OwnerID'],0,1),
				);
				$logTyp='new';
				$this->_Base->insertLog($nevent_id,$this->_Base->getAuthUser(),strtr($this->_T->lang('[[action_'.$logTyp.'_title]]'),$log_tras),'log');

			}
			$this->_newEvtID=$nevent_id;
			if ($this->_start && $this->_end) {
				$this->_newEvents=$this->_Base->listEvents($this->_start,$this->_end,0,$nevent_id);
			}
			return $nevent_id;
		}
		return false;
	}
	function getModifiedDays() {
		$result=array();
		$dayListGuiUser=array();
		$p_events=$this->_Base->listEvents($this->_start,$this->_end);
		if ($this->_view=='day') {
			require_once 'lib/cal/class_ViewDayGui.php';
			$Gui=new ViewDayGui();
			$Gui->_date=$this->_start;
			$Gui->_calUser=$this->_calUser;
			$dGui=$Gui->getDayViewGui();
			$result['calDayContent']=$dGui->process();
			$this->_draggable=$Gui->_draggable;
			$this->_droppable=$Gui->_droppable;
		} else {	
			$i_events=$this->_Base->listInvitations(mktime(0,0,0));
			if ($this->_calUser=='info') {
				if ($this->_view=='group') {
					$g_events_all=$this->_Base->listGroupEvents($this->_start,$this->_end);
				} else {
					$g_events=$this->_Base->listInfos($this->_start,$this->_end);
				}
			} else {
				$g_events=array();
			}
			require_once('lib/cal/class_DayListGui.php');
			$dayListGui=new DayListGui();
			$dayListGui->setUserID($this->_Base->getUser());
			$dayListGui->setPrivateEvents($p_events);
			if ($this->_view!='group') $dayListGui->setGroupEvents($g_events);
			$dayListGui->setInvitEvents($i_events);
			$dayListGui->setAccessLink("index.php?site=cal.php&action=view&view=event&date=".$this->_date);
			$dayListGui->setParseDragDrop(true);
			$dayListGui->setIdPrepend('drag');

			$_day=date("d",$this->_start);
			$_month=date("n",$this->_start);
			$_year=date("Y",$this->_start);
			//debug($this->_origEvents);
			//debug($this->_newEvents);
			$i=0;
			do {
				$_day_b=mktime(0,0,0,$_month,$_day,$_year);
				$_day_e=mktime(23,59,59,$_month,$_day,$_year);
				$_day_str=date('j-n-Y',$_day_b);
				//debug($_day_str);
				if (is_array($this->_origEvents[$_day_str]) || is_array($this->_newEvents[$_day_str])) {
					//debug('events');
					if (is_array($this->_origEvents[$_day_str])) {
						foreach ($this->_origEvents[$_day_str] as $key=>$val) {
							if ($val["EndDate"]>$_day_e) {
								$newEvt=$val;
								$val["EndDate"]=$_day_e;
								$newEvt["StartDate"]=$_day_e+1;
								$this->_origEvents[date('j',$newEvt["StartDate"]).'-'.date('n',$newEvt["StartDate"]).'-'.date('Y',$newEvt["StartDate"])][$key]=$newEvt;
							}
						}
					}
					if (is_array($this->_newEvents[$_day_str])) {
						foreach ($this->_newEvents[$_day_str] as $key=>$val) {
							if ($val["EndDate"]>$_day_e) {
								$newEvt=$val;
								$val["EndDate"]=$_day_e;
								$newEvt["StartDate"]=$_day_e+1;
								$this->_newEvents[date('j',$newEvt["StartDate"]).'-'.date('n',$newEvt["StartDate"]).'-'.date('Y',$newEvt["StartDate"])][$key]=$newEvt;
							}
						}
					}
					switch ($this->_view) {
						case 'week':
						case 'group':
							if (!$this->_wd->is_workday($_day_b)) {
								$extra='onmouseover="'.$this->_lGui->getFunctionOn('holy_'.($i)).'" onmouseout="'.$this->_lGui->getFunctionOff('holy_'.($i)).'"';
								$dayTitle='<div style="color:red" '.$extra.'>'.strftime("%d. %B %Y",$_day_b).'</div>';
							} else {
								$dayTitle=strftime("%d. %B %Y",$_day_b);
							}
						break;
						default:
							$dayTitle='';
						break;
					}
					if ($this->_view=='group') {
						foreach (array_keys($this->_UserDone) as $guser_id) {
							if ($guser_id==$this->_Base->getUser()) continue;
							if (!is_object($dayListGuiUser[$guser_id])) {
								$dayListGuiUser[$guser_id]=new DayListGui();
								$dayListGuiUser[$guser_id]->setUserID($this->_Base->getUser());
								$dayListGuiUser[$guser_id]->setAccessLink("index.php?site=cal.php&action=view&view=event&date=".$this->_date);
								$dayListGuiUser[$guser_id]->setGroupEvents($g_events_all[$guser_id]);
								$dayListGuiUser[$guser_id]->setIgnoreOwner(true);

							}
							$dayListGuiUser[$guser_id]->processDay($_day_b,$_day_e,'');
							$dayCont=$dayListGuiUser[$guser_id]->getDayList($_day_b);
							$result['day_'.$guser_id.'_'.$_day_b]=$dayCont?$dayCont:'&nbsp;';
						}
					}
					$dayListGui->processDay($_day_b,$_day_e,$dayTitle);
					$dayCont=$dayListGui->getDayList($_day_b);
					$result['day_'.$_day_b]=$dayCont?$dayCont:'&nbsp;';
				} else {
					$dayListGui->setParseDragDrop(false);
					$dayListGui->processDay($_day_b,$_day_e,$dayTitle);
					$dayListGui->setParseDragDrop(true);
				}
				$_day+=1;$i++;
			} while ($_day_e<$this->_end);
			$this->_draggable=$dayListGui->getDraggable();
			$result['evt_'.$this->_oldEvtID]=$this->_lGui->getSingleContent('evt_'.$this->_oldEvtID);
		}
		return $result;
	}
	function getDraggable() {
		$result=array();
		foreach ($this->_draggable as $key=>$val) {
			$result[$key]="setCfgDragCal('$key','".$val['EventID'].",".date('Y|m|d|H|i',$val['OrigStart']?$val['OrigStart']:$val["StartDate"]).",".date('Y|m|d|H|i',$val['OrigEnd']?$val['OrigEnd']:$val["EndDate"]).",".$val['TimeMode'].",".($val['RecType']?1:0).",".($val['dayDate'])."');";
		}
		return $result;
	}
	function getJsDraggable() {
		$js=array();
		foreach ($this->_draggable as $key=>$val) {
			$js[$key]=array(
				'evtID'=>$val['EventID'],
				'dateB'=>$val['OrigStart']?$val['OrigStart']:$val["StartDate"],
				'dateE'=>$val['OrigEnd']?$val['OrigEnd']:$val["EndDate"],
				'timeM'=>$val['TimeMode']?true:false,
				'rec'=>$val['RecType']?true:false,
				'prov'=>$val['Unsecure']?true:false,
				'dateD'=>$val['dayDate'],
				'view'=>isset($this->_cat[$val['FKCatID']])?$this->_cat[$val['FKCatID']]->getMeta('calCatView'):0,
			);
			
		}
		return Framework::array2json($js);
	}
	function getJsDroppable() {
		$js=array();
		foreach ($this->_droppable as $key=>$val) {
			if (is_array($val)) {
				$js[$key]=$val;
			} else {
				$js[$key]=array(
					'date'=>$val,
				);
			}
		}
		$js['cal_trash']=array(
			'date'=>0,
		);
		return Framework::array2json($js);
	}
	function getConflictGui($inc=0) {
		return $this->_ConfGui->getConflictGui($this->_Conflict,$inc);
	}
}
?>