<?php
class ViewFinderGui {
	var $_Base;
	var $_BaseRes;
	var $_BaseCat;
	var $_T;
	var $_frm;
	var $_P;
	var $_E;
	var $_options=array(
		'getOnlyView'=>false,
	);
	function ViewFinderGui($options=array()) {
		global $frm,$t,$T,$E,$L,$P;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_BaseRes=& $frm->getStaticModul('cal_res');
		$this->_BaseCat=& $frm->getStaticModul('cal_cat');
		$this->_BaseSearch=& $frm->getStaticModul('core_search');
		$this->_T=&$T;
		$this->_frm=&$frm;
		$this->_P=&$P;
		$this->_L=&$L;
		$this->_E=&$E;
		$this->_options=array_merge($this->_options,$options);
		$this->_T->loadModul('cal');
		$this->_dayUserB=$this->_frm->getPrefs('cal',"db_h")*60+$this->_frm->getPrefs('cal',"db_m");
		$this->_dayUserE=$this->_frm->getPrefs('cal',"de_h")*60+$this->_frm->getPrefs('cal',"db_m");
		$this->_userID=$this->_frm->getUser();
		$this->_cat=$this->_BaseCat->listObj(true);
	}
	function setOption($key,$val) {
		$this->_options[$key]=$val;
	}
	function getOption($key,$ov=array()) {
		if (isset($ov[$key])) {
			return $ov[$key];
		} else {
			return $this->_options[$key];
		}
	}

	function _handleRequest() {
		$this->_calUser=$GLOBALS['CAL_USER'];
		$this->_date=Framework::getParam('date',time());
		if (!$this->_date) $this->_date=time();
		if (Framework::getParam('sid',0)) {
			if ($this->_sObj=$this->_BaseSearch->getObj(Framework::getParam('sid',0))) {
				$this->_search=unserialize($this->_sObj->getMeta('sData'));
			} else {
				return false;
			}
		}

		if (!$this->getOption('getOnlyView') && Framework::getParam('_loadSearch',0) || Framework::getParam('save_x','','P') || Framework::getParam('copy_x','','P')) {
			$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpCalFinder',1,0);
		}
		if (Framework::getParam('print',0)) {
			$this->getViewGui(true);
			exit;
		}
		return true;
	}
	function &process() {
		if ($this->_handleRequest()) {
			require_once('lib/cal/class_CalLayerGui.php');
			$this->_lGui=new CalLayerGui(array());

			if ($this->getOption('getOnlyView')) {
				return $this->getViewGui();
			} else {
				require_once('lib/class_TemplateGui.php');
				$TopGui=new TemplateGui('core/common_form.inc.html');

				require_once('lib/class_ApplicationTreeGui.php');
				$TreeGui=new ApplicationTreeGui();

				$sCalGui=& $this->getSmallCalGui();
				$TreeGui->addTreeContent($sCalGui);

				$sGui=& $this->getConfigGui();
				$TreeGui->addTreeContent($sGui);

				require_once("lib/cal/class_CalListGui.php");
				$listGui=new CalListGui(array('loadInvitations'=>false,'loadActual'=>false));
				$finderGui=& $listGui->getFinderGui();
				if (is_object($finderGui)) {
					$TreeGui->addTreeContent($finderGui);
				}
				$dGui=& $this->getViewGui();
				$TreeGui->addContent($dGui,null,null);

				$TopGui->addContent('cont1',$TreeGui,'CONTENT');
				$TopGui->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
				return $TopGui;
			}
		}
	}
	function &getSmallCalGui() {
		require_once("lib/cal/class_SmallCal.php");
		$listbeginn=mktime (0,0,0,date('m',$this->_date),1,date('Y',$this->_date));
		$days=date("t",$listbeginn);
		$listend=mktime (23,59,59,date('m',$this->_date),$days,date('Y',$this->_date));
		$SmallCalGui=new SmallCalGui();
		$SmallCalGui->setMode('D');
		$SmallCalGui->setDate($this->_date);
		$SmallCalGui->setNumWeeks($this->_nw);
		$SmallCalGui->setNavLink("index.php?site=cal.php&action=view&view=over&_loadSearch=1");
		$SmallCalGui->setAccessLink("index.php?site=cal.php&action=view&view=over&_loadSearch=1");
		return $SmallCalGui->process();
	}
	function &getConfigGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once("lib/cal/class_ResourcesSearchGui.php");


		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key="cfgView";
		$default=isset($this->_search[$key])?$this->_search[$key]:'w';
		$formGui->addField($key,'select',$this->_T->lang('[[Ansicht]]'),$default,'fields1');
		$formGui->setValues($key,array(
			'd'=>$this->_T->lang('[[Tag]]'),
			'w'=>$this->_T->lang('[[Woche]]'),
			'm'=>$this->_T->lang('[[Monat]]'),
		));
		$formGui->setAttribs($key,array('style'=>'width:75px;'));
		$formGui->setIptAttribs($key,array('style'=>'float:left;width:80px;clear:none;'));

		$key="cfgTimeFrom";
		$default=isset($this->_search[$key])?$this->_search[$key]:$this->_dayUserB;
		$formGui->addField($key,'time',$this->_T->lang('[[von]]'),$default,'fields1');
		$formGui->setAttribs($key,array('style'=>'width:25px;'),false,array(1,2));
		$formGui->setIptAttribs($key,array('style'=>'float:left;width:80px;clear:none;'));
		$key="cfgTimeTo";
		$default=isset($this->_search[$key])?$this->_search[$key]:$this->_dayUserE;
		$formGui->addField($key,'time',$this->_T->lang('[[bis]]'),$default,'fields1');
		$formGui->setAttribs($key,array('style'=>'width:25px;'),false,array(1,2));
		$formGui->setIptAttribs($key,array('style'=>'float:left;width:80px;clear:none;'));



		$key="cfgUser";
		$default=isset($this->_search[$key])?$this->_search[$key]:'';
		$mode='u|g';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);
		$lb_InvitU=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_InvitU,$default,'fields1');
		$formGui->setParams($key,array('mode'=>$mode,'width'=>'240px','params'=>$params));




		$key='cfgLabel1';
		$formGui->addField($key,'label',$this->_T->lang('[[Optionen]]'),'','fields1');
		$key='cfgIgnEmpty';
		$default=isset($this->_search[$key])?$this->_search[$key]:0;
		$formGui->addField($key,'check',$this->_T->lang('[[Leere Zeilen ausblenden]]'),$default,'fields1');
		$formGui->setLabelClass('no','error',$key);
		$key='cfgShowOverlapping';
		$default=isset($this->_search[$key])?$this->_search[$key]:0;
		$formGui->addField($key,'check',$this->_T->lang('[[Ueberlappende Termine anzeigen]]'),$default,'fields1');
		$formGui->setLabelClass('no','error',$key);
		$key='cfgHideBusy';
		$default=isset($this->_search[$key])?$this->_search[$key]:0;
		$formGui->addField($key,'check',$this->_T->lang('[[Nur freie Eintraege anzeigen]]'),$default,'fields1');
		$formGui->setLabelClass('no','error',$key);
		$key='cfgUserMode';
		$default=isset($this->_search[$key])?$this->_search[$key]:0;
		$formGui->addField($key,'check',$this->_T->lang('[[Gruppenmitglieder anzeigen]]'),$default,'fields1');
		$formGui->setLabelClass('no','error',$key);

		

		$submit_array=array(
			'view_x'=>' '.$this->_T->lang('[[Anzeigen]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','fields1');
		$formGui->setValues($key,$submit_array);

		$box=new BoxGui($this->_Base->getModul().'|calFinderTab');
		$box->addTab('meta',$this->_T->lang('[[Suche]]'),'#',true);
		$box->setTabContent('meta',$formGui);



		$ResSearchGui=new ResourcesSearchGui();
		if (isset($this->_search['cfgCrm'])) {
			$ResSearchGui->setSearch($this->_search['cfgCrm']);
		}

		$formRes=new FormGui();
		$formRes->setFieldClass('ipts','ipts');

		$key="cfgResource";
		$default=isset($this->_search[$key])?$this->_search[$key]:'';
		$defaultVal=isset($this->_search[$key.'Amount'])?$this->_search[$key.'Amount']:array();
		if (!FrameWork::issetParam('val_'.$key)) {
			FrameWork::importParam(array('val_'.$key=>$defaultVal));
		}
		$mode='s';
		$params=base64_encode(serialize(array('resCal'=>1,'resUser'=>$this->_Base->getUser(),'showAmount'=>1)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Resourcen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_RESOURCES',
		);
		$lb_InvitR=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formRes->addField($key,'ttip',$lb_InvitR,$default,'fields1');
		$formRes->setParams($key,array('mode'=>$mode,'width'=>'240px','params'=>$params));
		
		$ResSearchGui->getForm($formRes);

		$submit_array=array(
			'crm_x'=>' '.$this->_T->lang('[[Anzeigen]]').' ',
		);
		$key='submit_crm';
		$formRes->addField($key,'submit','','','fields1');
		$formRes->setValues($key,$submit_array);

		$box->addTab('crm',$this->_T->lang('[[Resourcen]]'),'#',true);
		$box->setTabContent('crm',$formRes);


		$this->_search=array(
			'cfgView'=>$formGui->getFieldVal('cfgView',1),
			'cfgIgnEmpty'=>$formGui->getFieldVal('cfgIgnEmpty',1),
			'cfgShowOverlapping'=>$formGui->getFieldVal('cfgShowOverlapping',1),
			'cfgUser'=>$formGui->getFieldVal('cfgUser',1),
			'cfgUserMode'=>$formGui->getFieldVal('cfgUserMode',1),
			'cfgResource'=>$formRes->getFieldVal('cfgResource',1),
			'cfgResourceAmount'=>FrameWork::getParam('val_cfgResource',array()),
			'cfgTimeTo'=>$formGui->getFieldVal('cfgTimeTo',1),
			'cfgTimeFrom'=>$formGui->getFieldVal('cfgTimeFrom',1),
			'cfgCrm'=>$ResSearchGui->getSearch(),
			'cfgHideBusy'=>$formGui->getFieldVal('cfgHideBusy',1),
		);
		$this->_frm->savePostData($this->_Base->getModul(),'tmpCalFinder',null,$this->_search);


		$formGuiSave=new FormGui();
		$formGuiSave->setFieldClass('ipts','ipts');
		$formGuiSave->setLabelClass('no','error');

		$formGuiSave->addField('lb1','label',$this->_T->lang('[[Suchergebnis speichern]]'),'','');
		$formGuiSave->setLabelClass('','','lb1');
		$key='sTitle';
		$formGuiSave->addField($key,'text',$this->_T->lang('[[Bezeichnung]]'),$this->_sObj?$this->_sObj->getMeta($key):'','');
		$formGuiSave->setRequired($key);

		$formGuiSave->addField('lb2','label',$this->_T->lang('[[Sichtbar fuer]]'),'','');
		$formGuiSave->setLabelClass('','','lb2');
		$key='sPerms';
		$default='';
		if ($this->_sObj) {
			$tmpP=array_keys(Framework::aclToArray($this->_sObj->getMeta('sUsers')));
			if (!empty($tmpP)) {
				$default.='u_'.implode('|u_',$tmpP);
			};
			$tmpP=array_keys(Framework::aclToArray($this->_sObj->getMeta('sGroups')));
			if (!empty($tmpP)) {
				if ($default) $default.='|';
				$default.='g_'.implode(',g_',$tmpP);
			};
			//debug($default);
		}
		$mode='u|g';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);
		$lb_InvitU=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGuiSave->addField($key,'ttip',$lb_InvitU,$default,'fields1');
		$formGuiSave->setParams($key,array('mode'=>$mode,'width'=>'240px','params'=>$params));



		$submit_array=array(
			'save_x'=>' '.$this->_T->lang('[[Speichern]]').' ',
		);
		if ($this->_sObj) {
			$submit_array['copy_x']=' '.$this->_T->lang('[[Kopieren]]').' ';
		}
		$key='submit';
		$formGuiSave->addField($key,'submit','','','fields1');
		$formGuiSave->setValues($key,$submit_array);

		$box->addTab('save',$this->_T->lang('[[Speichern]]'),'#');
		$box->setTabContent('save',$formGuiSave);

		
		$show_tap=$this->getPrefs('calFinderTab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:'meta');

		if (Framework::getParam('save_x','','P') || Framework::getParam('copy_x','','P')) {
			$formGuiSave->checkFields();
			if (!$this->_E->isError()) {
				if (!$this->_sObj || Framework::getParam('copy_x','','P')) $this->_sObj=new ObjCoreSearch();
				$this->_sObj->setMeta('FKModulID','cal_find');
				$this->_sObj->setMeta('sTitle',$formGuiSave->getFieldVal('sTitle'));
				$this->_sObj->setMeta('sOwner',$this->_frm->getUser());
				$perms=array('u'=>array(),'g'=>array());
				$tmpPerms=explode('|',$formGuiSave->getFieldVal('sPerms',true));
				foreach ($tmpPerms as $val) {
					$perms[$val[0]][substr($val,2)]=1;
				}
				$this->_sObj->setMeta('sUsers',Framework::ArrayToAcl($perms['u']));
				$this->_sObj->setMeta('sGroups',Framework::ArrayToAcl($perms['g']));
				$this->_sObj->setMeta('sData',serialize($this->_search));
				if ($this->_sObj->getID()) {
					$this->_BaseSearch->updateObj($this->_sObj);
				} else {
					$this->_BaseSearch->insertObj($this->_sObj);
				}
				$this->_L->setParam('sid',$this->_sObj->getID());
				$this->_L->goToLink();
			}
			$box->setTabOn('save');

		}


		return $box;
	}
	function getNewEventForm($tmpInvit) {
		require_once('lib/class_FormGui.php');
		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');


		$formGui->addField('evtDate','hidden','','');

		$key='evtBeginn';
		$formGui->addField($key,'time',$this->_T->lang('[[Beginn]]'),60);
		$formGui->setIptAttribs($key,array('style'=>'width:100px;float:left;'));

		$key='evtDuration';
		$duration_array=array('0'=>'00:00','15'=>'00:15','30'=>'00:30','45'=>'00:45','60'=>'01:00','90'=>'01:30','120'=>'02:00','180'=>'03:00','240'=>'04:00');
		$formGui->addField($key,'select',$this->_T->lang('[[Dauer]]'),60);
		$formGui->setAttribs($key,array('style'=>'width:70px;'));
		$formGui->setIptAttribs($key,array('style'=>'clear:none;width:80px;float:left;'));
		$formGui->setValues($key,$duration_array);
		$default=array();
		if (count($tmpInvit['g'])==1) {
			$default['InvitGroups']=$tmpInvit['g'];
		}
		if (count($tmpInvit['u'])==1) {
			$default['InvitUsers']=$tmpInvit['u'];
		}
		if (count($tmpInvit['s'])==1) {
			$default['InvitResources']=$tmpInvit['s'];
		}
		if (count($default)!=1) {
			$default=array();
		}

		if ($tmpInvit['g'])	{
			$formGui->addField('InvitGroups','checklist_v',$this->_T->lang('[[Gruppen]]'),$default['InvitGroups']);
			$values=array();
			foreach($tmpInvit['g'] as $val) {
				$values[$val]=$this->_frm->getCachedGroupName($val);
			}
 			$formGui->setValues('InvitGroups',$values);
			$formGui->setIptAttribs('InvitGroups',array('id'=>'Invit_g'));
		}
		if ($tmpInvit['u']) {
			$formGui->addField('InvitUsers','checklist_v',$this->_T->lang('[[Teilnehmer]]'),$default['InvitUsers']);
			$values=array();
			foreach($tmpInvit['u'] as $val) {
				$values[$val]=$this->_frm->getCachedUserName($val,0,1);
			}
 			$formGui->setValues('InvitUsers',$values);
			$formGui->setIptAttribs('InvitUsers',array('id'=>'Invit_u'));
		}
		if ($tmpInvit['s']) {
			$formGui->addField('InvitResources','checklist_v',$this->_T->lang('[[Resourcen]]'),$default['InvitResources']);
			$values=array();
			foreach($tmpInvit['s'] as $val) {
				$values[$val]=$this->_BaseRes->getCachedObj($val)->getName();
			}
 			$formGui->setValues('InvitResources',$values);
			$formGui->setIptAttribs('InvitResources',array('id'=>'Invit_s'));
		}
		if (count($setDefault)==1) {

		}
		return $formGui;

	}
	function getViewGui($print=false) {
		require_once('lib/class_FastTemplateGui.php');
		$Gui=new FastTemplateGui('cal/view_finder.inc.html');
		$Gui->setEncode(false);
		$Gui->assign("L_PRINT","javascript:showPrintDialog('list_f');");
		if ($this->getOption('linkBreak')) {
			$Gui->assign("L_BREAK",$this->getOption('linkBreak'));
			$Gui->parse('ROW','break');
		}

		$_day=date("d",$this->_date);
		$_month=date("n",$this->_date);
		$_year=date("Y",$this->_date);
		if ($this->getOption('forceView')) {
			$this->_search['cfgView']=$this->getOption('forceView');
		}
		switch($this->_search['cfgView']) {
			case 'm':
				$_days=date("t",$this->_date);
				$this->_viewBeginn=mktime(0,0,0,$_month,1,$_year);
				$this->_viewEnd=mktime(23,59,59,$_month,$_days,$_year);
				$Gui->assign('NAV_TITLE',strftime('%B %Y',$this->_date));
			break;
			case 'd':
				$this->_viewBeginn=mktime(0,0,0,$_month,$_day,$_year);
				$this->_viewEnd=mktime(23,59,59,$_month,$_day,$_year);
				$Gui->assign('NAV_TITLE',strftime('%A, %d.%m.%Y',$this->_date));
			break;
			default:
				$_wday=date("w",$this->_date)-1;
				if ($_wday<0) $_wday=6;
				$this->_viewBeginn=mktime(0,0,0,$_month,$_day-$_wday,$_year);
				$this->_viewEnd=mktime(23,59,59,$_month,$_day-$_wday+(7)-1,$_year);
				$Gui->assign('NAV_TITLE',$this->_T->lang('[[KW]]').' '.strftime('%V',$this->_date));
			break;
		}
		if ($print) {
			require_once('lib/cal/class_CalPrintGui.php');
			$printGui=new CalPrintGui(array(
				'TplID'=>intval(Framework::getParam('printTpl','','G'))?Framework::getParam('printTpl','','G'):'list_f',
				'TimeStart'=>$this->_viewBeginn,
				'TimeEnd'=>$this->_viewEnd,
				'CalUserID'=>$this->_Base->getUser(),
				'CalUserName'=>$this->_frm->getCachedUserName($this->_Base->getUser(),0,1),
			));
		}

		$viewEvents=array();
		$searchUsers=array();
		$calUserArray=array();
		$tmpInvit=array();

		if ($this->_search['cfgUser']) {
			$searchUsers=explode('|',$this->_search['cfgUser']);
		}
		if ($this->_search['cfgUserMode']) {
			$addUsers=array();
			foreach ($searchUsers as $key=>$val) {
				if ($val[0]=='g') {
					$tmpUsers=$this->_frm->getApplicationUsers('cal',$this->_frm->getGroupUsers(substr($val,2)));
					if (!empty($tmpUsers)) {
						foreach (array_keys($tmpUsers) as $val) {
							$addUsers[$val]='u_'.$val;
						}
					}
					unset($searchUsers[$key]);
				}
			}
			if (!empty($addUsers)) {
				$searchUsers=array_unique(array_merge($addUsers,$searchUsers));
			}
		}

		if ($this->_search['cfgResource']) {
			$searchUsers=array_merge($searchUsers,explode('|',$this->_search['cfgResource']));
		}
		if ($this->_search['cfgCrm']) {
			$search=array('uform'=>$this->_search['cfgCrm'],'use_cal'=>1);
			foreach($this->_BaseRes->listObj($search) as $v) {
				$searchUsers[]='s_'.$v->getID();
			}
		
		} elseif (empty($searchUsers)) {
			$searchUsers[]='u_'.$this->_Base->getUser();
		}
		//debug($searchUsers);
		foreach ($searchUsers as $val) {
			$tmpInvit[$val[0]][]=substr($val,2);
			if ($val[0]=='g') {
				$tmpUsers=$this->_frm->getApplicationUsers('cal',$this->_frm->getGroupUsers(substr($val,2)));
				if (!empty($tmpUsers)) {
					$search=array(
						'UserID'=>array_keys($tmpUsers),
						'GroupID'=>$this->_frm->getUserGroups(array_keys($tmpUsers)),
						'Mode'=>0,
					);
				} else {
					$search=array();
				}
				$name=$this->_frm->getCachedGroupName(substr($val,2));
			}
			if ($val[0]=='u') {
				$search=array(
					'UserID'=>substr($val,2),
					'GroupID'=>$this->_frm->getUserGroups(substr($val,2)),
					'Mode'=>0,
				);
				$name=$this->_frm->getCachedUserName(substr($val,2),0,1);
			}
			if ($val[0]=='s') {
				$search=array(
					'ResourceID'=>substr($val,2),
					'Mode'=>0,
				);
				$name=$this->_BaseRes->getCachedObj(substr($val,2))->getName();
			}
			$search['StartDate']=$this->_viewBeginn;
			$search['EndDate']=$this->_viewEnd;
			$rows=0;
			if ($print) {
				$printGui->setEntries(empty($search)?array():$this->_Base->searchEvents($rows,$search),$val);
				$calUserArray[$val]=array(
					'Typ'=>$val[0],
					'ID'=>substr($val,2),
					'Name'=>$name,
				);
			} else {
				$viewEvents[]=array(
					'Typ'=>$val[0],
					'ID'=>substr($val,2),
					'Name'=>$name,
					'Events'=>empty($search)?array():$this->_Base->searchEvents($rows,$search),
				);
			}
		}
		//debug($viewEvents);
		$this->_day_b=$this->_day_calc_b=floor(max($this->_search['cfgTimeFrom'],0)/60)*60;
		$this->_day_e=$this->_day_calc_e=ceil(min($this->_search['cfgTimeTo'],60*24)/60)*60;
		if (($this->_day_e-$this->_day_b)<=120) {
			$this->_day_e=min($this->_day_e+=60,60*24);
			$this->_day_b=max($this->_day_b-=60,0);
		}


		if ($print) {
			$printGui->setOption('IgnEmptyRows',$this->_search['cfgIgnEmpty']);
			$printGui->setOption('ShowOverlapping',$this->_search['cfgShowOverlapping']);
			$printGui->setOption('DayBegin',$this->_day_b);
			$printGui->setOption('DayEnd',$this->_day_e);
			$printGui->setOption('CalUsers',$calUserArray);
			$printGui->printList();
		}

		$nForm=$this->getNewEventForm($tmpInvit);
		$Gui->assign('FORM',$nForm->process());
		//$link.="&date=$window_date&date_end=$window_end_date";
		/*$tmp_ins_u=array();
		$tmp_ins_g=array();
		foreach ($search_user as $ins_user) {
				if ($ins_user[0]=='g') $tmp_ins_g[]=substr($ins_user,1);
				else $tmp_ins_u[]=$ins_user;
		}
		$link.="&InvitUsers=".implode(',',$tmp_ins_u)."&InvitGroups=".implode(',',$tmp_ins_g);*/


		//cfgTimeFrom();
		$hunderPct=$this->_day_e-$this->_day_b;

		for($i=$this->_day_b;$i<$this->_day_e;$i+=60) {
			//$style='width:'.round(60/($hunderPct/100),3).'%;';
			$style='left:'.round(($i-$this->_day_b)/($hunderPct/100),3).'%;';
			//debug($style);
			$Gui->assign('TIME',sprintf('%02d',($i)/60));
			$Gui->assign('COL_STYLE',$style);
			$Gui->parse('ROW','.time_col');
		}

		$cell=$this->_viewBeginn+3600*12;
		for($cell;$cell<$this->_viewEnd;$cell+=86400){
			$pRow=false;
			$pDay=false;
			$Gui->assign('DAY_NAME',Framework::entities(strftime("%a %d.%m.%Y",$cell)));
			//$Gui->assign('DAY_LINK',$newLink.'&_bDate='.date('Ymd',$cell));
			$dayKey=date('j-n-Y',$cell);
			$dayEnd=mktime(23,59,59,date('m',$cell),date('d',$cell),date('Y',$cell));
			$dayBegin=mktime(0,0,0,date('m',$cell),date('d',$cell),date('Y',$cell));
			foreach ($viewEvents as $key=>$eventUser) {
				$rowClass='first';
				if (isset($eventUser['Events'][$dayKey])) {
					uasort($eventUser['Events'][$dayKey],array('CalEvent',"daycmp"));
					$calcEntries=$this->_Base->calcEntries($eventUser['Events'][$dayKey],$dayBegin+$this->_day_b*60,$dayBegin+$this->_day_e*60);
					$isBusy=false;
					if ($this->_search['cfgHideBusy']) {
						for($i=$this->_day_calc_b-$this->_day_b;$i<$this->_day_calc_e-$this->_day_b;$i+=1) {
							if ($calcEntries['busy'][$i]) {
								$isBusy=true;
								break;
							}
						}
						$pDay=true;
						if ($isBusy) continue;
					}

					if ($eventUser['Typ']=='s' && $this->_BaseRes->getCachedObj($eventUser['ID'])) {
						$maxAmount=$this->_BaseRes->getCachedObj($eventUser['ID'])->getMeta('calResAmount');
						if ($maxAmount<1)$maxAmount=1;
						if (isset($this->_search['cfgResourceAmount']['s_'.$eventUser['ID']]) && $this->_search['cfgResourceAmount']['s_'.$eventUser['ID']]) {
							$needed=$this->_search['cfgResourceAmount']['s_'.$eventUser['ID']];
						} else {
							$needed=1;
						}
					} else {
						$maxAmount=1;
						$needed=1;
					}
					if ($this->_search['cfgShowOverlapping']==1) {
						$numRows=$calcEntries['options']['max_cols'];
						if ($eventUser['Typ']=='s' && ($maxAmount-$needed)>=$numRows) {
							$numRows++;
						}
					} else {
						$numRows=1;
						if ($eventUser['Typ']=='s' && ($maxAmount-$needed)>=$numRows) {
							$numRows++;
						}
					}
					$aktRow=0;
					//debug($calcEntries);
					//debug($eventUser['Typ']);
					for ($ck=0;$ck<$numRows; $ck++) {
						$rowEmpty=true;
						//debug($eventUser['Events'][$dayKey]);
						foreach ($eventUser['Events'][$dayKey] as $evtID=>$event) {
							if ($this->_search['cfgShowOverlapping'] && $calcEntries['events'][$evtID]['_overlap_l']!=$ck) continue;
							if (!$this->_search['cfgShowOverlapping'] && $ck!=0) continue;
							//debug($event);
							//debug(date('j-n-Y',$event["StartDate"]));
							//debug(date('j-n-Y',$event["OrigStart"]));

							if (isset($this->_cat[$event['FKCatID']]) && $this->_cat[$event['FKCatID']]->getMeta('calCatView')&256) {
								if ($this->_Base->checkEventViewPerms($event,true)) {
									$attribs='onclick="e7gGoEvt('.$evtID.','.$dayBegin.')" ';
								} else {
									$attribs.='';
								}
								if ($event["EndDate"]>$dayEnd) {
									if (!isset($event['OrigStart'])) {
										$event['OrigStart']=$event["StartDate"];
									}
									if (!isset($event['OrigEnd'])) {
										$event['OrigEnd']=$event["EndDate"];
									}
									$newEvt=$event;
									$event["EndDate"]=$dayEnd;
									$newEvt["StartDate"]=$dayEnd+1;
									$viewEvents[$key]['Events'][date('j-n-Y',$newEvt["StartDate"])][$evtID]=$newEvt;
								}
								$style='';
								//debug($event);
								//debug(date('H',$event['EndDate']));

								if ($calcEntries['events'][$evtID]['_min_e']<=0) continue;
								if ($calcEntries['events'][$evtID]['_min_b']>=$this->_day_e-$this->_day_b) continue;
								
								//debug($eventUser['Events'][$dayKey][$evtID]);
								$style='width:'.$calcEntries['events'][$evtID]['_width'].'%;';
								$style.='left:'.$calcEntries['events'][$evtID]['_left'].'%;';
								if ($event['Unsecure']) {
									$style.='background-color:#ff6600;font-style:italic;';
								}
								$Gui->assign('COL_NAME',$event['Title']);
								$Gui->assign('COL_STYLE',$style);
								$Gui->assign('COL_CLASS','e7g_busy_col');
								$Gui->assign('ATTRIBS',$attribs.$this->_lGui->addEventLayer($event,array('linkAsSting'=>true,'showTitle'=>true,'showOwner'=>true)));
								$Gui->parse('ROW','.busy_col');
								$rowEmpty=false;
							}

						}
						if (!$rowEmpty || !$this->_search['cfgIgnEmpty']) {
							$Gui->assign('DATA',date('Ymd',$cell).','.$eventUser['Typ'].','.$eventUser['ID']);
							if ($eventUser['Typ']=='s' && $aktRow > ($maxAmount-$needed)) {
								$rowClass.=' e7g_busy_empty';
							}
							if (!$this->_search['cfgShowOverlapping'] && $eventUser['Typ']=='s' && $aktRow>0) {
								$busyEvents=array();
								$aktBusyEvent=array();
								$showRow=0;
								foreach ($calcEntries['busy'] as $pos=>$num) {
									if (($num+$needed)>$maxAmount) {
										if (empty($aktBusyEvent)) $aktBusyEvent=array($pos,$pos);
										$aktBusyEvent[1]=$pos;
									} else {
										$showRow=1;
										if ($aktBusyEvent[0]) {
											$busyEvents[]=$aktBusyEvent;
											$aktBusyEvent=array();
										}
									}
									
								}
								if (!empty($aktBusyEvent)) {
									$busyEvents[]=$aktBusyEvent;
								}
								foreach($busyEvents as $event) {
									$style='';
									$style='width:'.round(($event[1]-$event[0])/($hunderPct/100),3).'%;';
									$style.='left:'.round($event[0]/($hunderPct/100),3).'%;';
									$Gui->assign('COL_NAME','');
									$Gui->assign('COL_STYLE',$style);
									$Gui->assign('COL_CLASS','e7g_busy_col e7g_busy_empty');
									$Gui->assign('ATTRIBS','');
									$Gui->parse('ROW','.busy_col');
									
									
								}
								
								//$rowClass.=' amount_busy';
							} else {
								$showRow=1;
							}
							if ($showRow) {
								$Gui->assign('ROW_SUB_CLASS',trim($rowClass));
								$Gui->parse('ROW','.busy_row_sub');
								$Gui->clear_dynamic('busy_col');
								//$Gui->parse('ROW','.busy_row');
								$rowClass='';
								$aktRow++;
								$pRow=true;
							}
						}
					}
					if ($pRow) {
						$Gui->assign('ROW_NAME',Framework::entities($eventUser['Name']));
						$Gui->parse('ROW','.busy_row');
						$Gui->clear_dynamic('busy_row_sub');
					}
				} elseif (!$this->_search['cfgIgnEmpty']) {
					if ($eventUser['Typ']=='s' && $needed > $maxAmount) {
						$rowClass.=' e7g_busy_empty';
					}
					$Gui->assign('ROW_NAME',Framework::entities($eventUser['Name']));
					$Gui->assign('DATA',date('Ymd',$cell).','.$eventUser['Typ'].','.$eventUser['ID']);
					$Gui->assign('ROW_SUB_CLASS',$rowClass);
					$Gui->parse('ROW','.busy_row_sub');
					$Gui->clear_dynamic('busy_col');
					$Gui->parse('ROW','.busy_row');
					$Gui->clear_dynamic('busy_row_sub');
					$pRow=true;
				}
			}
			if ($pRow || $pDay) {
				if (!$pRow) {
					$Gui->assign('ROW_NAME','');
					$Gui->assign('DATA','');
					$Gui->assign('ROW_SUB_CLASS','e7g_busy_empty');
					$Gui->parse('ROW','.busy_row_sub');
					$Gui->clear_dynamic('busy_col');
					$Gui->parse('ROW','.busy_row');
					$Gui->clear_dynamic('busy_row_sub');
					
				}
				$Gui->parse('ROW','.busy_day');
				$Gui->clear_dynamic('busy_row');
			}
		}
		if ($this->getOption('getOnlyView')) {
			$Gui->assign("PREV_DAY_LINK",$this->_L->getTempLink(null,array('date'=>($this->_viewBeginn-1))));
			$Gui->assign("NEXT_DAY_LINK",$this->_L->getTempLink(null,array('date'=>($this->_viewEnd+1))));
		} else {
			$Gui->assign("PREV_DAY_LINK",$this->_L->getTempLink(null,array('_loadSearch'=>1,'date'=>($this->_viewBeginn-1))));
			$Gui->assign("NEXT_DAY_LINK",$this->_L->getTempLink(null,array('_loadSearch'=>1,'date'=>($this->_viewEnd+1))));
		}
		$Gui->assign('CONFIG',Framework::array2json(array(
			'DayB'=>$this->_day_b,
			'DayE'=>$this->_day_e,
		)));
		$Gui->assign('FORM_ACTION',$this->_L->getTempLink());

		if ($this->_Base->getCalPerms(2)) {
			$Gui->parse('ROW','busy_day_edit');
		}

		require_once('lib/class_PrintDialogGui.php');
		$printDialogGui=new PrintDialogGui('cal');
		$printDialogGui->setDefaultFormat(1);
		$printDialogGui->process('list_f');

		return $Gui;
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result) $result=$default;
		return $result;
	}

}
?>