<?php
class ViewWeekGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	var $_droppable=array();
	function ViewWeekGui() {
		global $frm,$t,$T,$E,$L,$P,$Y;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_wd=& $frm->getStaticModul('workday');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_lGui=&$Y;
		$this->_T->loadModul('cal');
		$this->_dayUserB=$this->_frm->getPrefs('cal',"db_h")*60+$this->_frm->getPrefs('cal',"db_m");;
		$this->_dayUserE=$this->_frm->getPrefs('cal',"de_h")*60+$this->_frm->getPrefs('cal',"db_m");
		require_once('lib/class_ApplicationTreeGui.php');
		$this->_Gui=new ApplicationTreeGui();
		//$this->_Gui->setTreeWidth(200);
	}
	function _handleRequest() {
		$this->_date=Framework::getParam('date',time());
		if (!$this->_date) $this->_date=time();
		$this->_nw=$GLOBALS['NW'];
		$this->_calUser=$GLOBALS['CAL_USER'];
		$this->_view=Framework::getParam('view','week');

		if (Framework::getParam('print',0)) {
			if (Framework::getParam('sid')) {
				require('lib/cal/class_ViewFinderGui.php');
				$fGui=new ViewFinderGui(array('forceView'=>'w','getOnlyView'=>true));
				$fGui->process();
			} else {
				$this->getWeekViewGui(true);
				exit;
			}
		} else {
			if ($this->_frm->getPrefs('cal','showTasks') && $this->_Base->getUser()==$this->_frm->getUser()) {
				require_once("lib/task/class_TaskActualGui.php");
				$this->_TaskGui=new TaskActualGui();
			}
			$sCalGui=& $this->getSmallCalGui();
			$this->_Gui->addTreeContent($sCalGui);

			require_once("lib/cal/class_CalListGui.php");
			$listGui=new CalListGui();
			$this->_invit_events=& $listGui->getInvitEvents();
			$invitGui=& $listGui->getInvitGui();
			if (is_object($invitGui)) {
				$this->_Gui->addTreeContent($invitGui);
			}
			$actGui=& $listGui->getActualGui();
			if (is_object($actGui)) {
				$this->_Gui->addTreeContent($actGui);
			}
			$finderGui=& $listGui->getFinderGui();
			if (is_object($finderGui)) {
				$this->_Gui->addTreeContent($finderGui);
			}
			if (is_object($this->_TaskGui)) {
				$sTaskGui=$this->_TaskGui->processActualGui(true);
				if (is_object($sTaskGui)) {
					$this->_Gui->addTreeContent($sTaskGui);
				}
			}
			if (Framework::getParam('sid')) {
				require('lib/cal/class_ViewFinderGui.php');
				$fGui=new ViewFinderGui(array('forceView'=>'w','getOnlyView'=>true,'linkBreak'=>$this->_L->getTempLink(array('sid'))));
				if ($Gui=$fGui->process()) {
					$this->_Gui->addContent($Gui,null,null);
				}
			} else {
				$wGui=& $this->getWeekViewGui();
				$this->_Gui->addContent($wGui,null,null);
				$this->parseJsDrop();
			}
		}
	}
	function &process() {
		$this->_handleRequest();
		return $this->_Gui;
	}
	function &getSmallCalGui() {
		require_once("lib/cal/class_SmallCal.php");
		$listbeginn=mktime (0,0,0,date('m',$this->_date),1,date('Y',$this->_date));
		$days=date("t",$listbeginn);
		$listend=mktime (23,59,59,date('m',$this->_date),$days,date('Y',$this->_date));
		$events=$this->_Base->listEvents($listbeginn,$listend);
		$SmallCalGui=new SmallCalGui();
		$SmallCalGui->setMode('D');
		$SmallCalGui->setDate($this->_date);
		$SmallCalGui->setEvents($events);
		$SmallCalGui->setNumWeeks($this->_nw);
		$SmallCalGui->setNavLink("index.php?site=cal.php&action=view&view=week&sid=".Framework::getParam('sid',0));
		$SmallCalGui->setAccessLink("index.php?site=cal.php&action=view&view=day&old_view=".$this->_view);
		return $SmallCalGui->process();
	}
	function parseJsDrop() {
		require_once('lib/cal/class_EventMoveGui.php');
		$Gui=new EventMoveGui();
		$Gui->setStart($this->_viewBeginn);
		$Gui->setEnd($this->_viewEnd);
		$Gui->setView($this->_view);
		$Gui->setDate($this->_date);
		$Gui->setDraggable($this->_draggable);
		$Gui->setDroppable($this->_droppable);
		$Gui->parseJsDrop();
		
		$this->_frm->addScript($cGui);
	}


	function &getWeekViewGui($print=false) {
		require_once('lib/class_FastTemplateGui.php');
		$Gui=new FastTemplateGui('cal/view_week.inc.html');
		$Gui->setEncode(false);
		$Gui->assign("I_ACTION","index.php?site=cal.php&action=view&view=week&date=".$this->_date);
		$Gui->assign("L_PRINT","javascript:showPrintDialog('list_l');");

		$_day=date("d",$this->_date);
		$_month=date("n",$this->_date);
		$_year=date("Y",$this->_date);
		$_days=date("t",$this->_date);
		$_wday=date("w",$this->_date)-1;
		if ($_wday<0) $_wday=6;

		$_sweek=mktime(0,0,0,$_month,$_day-$_wday,$_year);
		$_eweek=mktime(23,59,59,$_month,$_day-$_wday+(7*$this->_nw)-1,$_year);
		$this->_viewBeginn=$_sweek;
		$this->_viewEnd=$_eweek;

		if ($print) {
			require_once('lib/cal/class_CalPrintGui.php');
			$printGui=new CalPrintGui(array(
				'TplID'=>intval(Framework::getParam('printTpl','','G'))?Framework::getParam('printTpl','','G'):'list_w',
				'TimeStart'=>$this->_viewBeginn,
				'TimeEnd'=>$this->_viewEnd,
				'CalUserID'=>$this->_Base->getUser(),
				'CalUserName'=>$this->_frm->getCachedUserName($this->_Base->getUser(),0,1),
				'ShowPrivate'=>1,
				'ShowTeam'=>($this->_calUser=='info'),
				'ShowTeamUsers'=>0,
			));
			$CalUsers=array();
			if ($printGui->getOption('ShowPrivate')) {
				$CalUsers['u_'.$this->_Base->getUser()]=array(
					'Typ'=>'u',
					'ID'=>$this->_Base->getUser(),
					'Name'=>$this->_frm->getCachedUserName($this->_Base->getUser(),0,1),
				);
				$printGui->setEntries($this->_Base->listEvents($this->_viewBeginn,$this->_viewEnd),'u_'.$this->_Base->getUser());
			}
			if ($printGui->getOption('ShowTeam')) {
				if ($printGui->getOption('ShowTeamUsers')) {
					$g_events_all=$this->_Base->listGroupEvents($this->_viewBeginn,$this->_viewEnd);
					foreach ($g_events_all as $guid=>$g_events) {
						if ($tmpName=$this->_frm->getCachedUserName($guid)) {
							$CalUsers['u_'.$guid]=array(
								'Typ'=>'u',
								'ID'=>$guid,
								'Name'=>$tmpName,
							);
							$printGui->setEntries($g_events,'u_'.$guid);
						}
					}
				} else {
					$CalUsers['info']=array(
						'Typ'=>'info',
						'ID'=>0,
						'Name'=>$this->_T->lang('[[Teamkalender]]'),
					);
					$printGui->setEntries($this->_Base->listInfos($this->_viewBeginn,$this->_viewEnd),'info');
				}
			}
			$printGui->setOption('CalUsers',$CalUsers);
			$printGui->printList();
		}

		$_aktdate=mktime(23,59,59);
		$_day=date("j",$_sweek);
		$_month=date("n",$_sweek);
		$_year=date("Y",$_sweek);
		$_kw_b=strftime("%V",$_sweek);
		$_kw_e=strftime("%V",$_eweek);

		if ($_kw_b!=$_kw_e) {
			$Gui->assign("KW_NUM",$_kw_b.' - '.$_kw_e);
		} else {
			$Gui->assign("KW_NUM",$_kw_b);
		}
		$Gui->assign("KW_PREV_LINK",$this->_L->getTempLink(null,array('date'=>($_sweek-1))));
		$Gui->assign("KW_NEXT_LINK",$this->_L->getTempLink(null,array('date'=>($_eweek+1))));

		for ($i=1;$i<13	;$i++) {
			$Gui->assign('S_SNW','');
			$Gui->assign('N_SNW',$i);
			if ($i==$this->_nw) {
				$Gui->assign('S_SNW','selected="selected"');
			} 
			$Gui->parse('ROW','.snw_row');
		}

		$p_events=$this->_Base->listEvents($_sweek,$_eweek);
		if ($this->_calUser=='info') {
			$g_events=$this->_Base->listInfos($_sweek,$_eweek);
		} else {
			$g_events=array();
		}
		if (is_object($this->_TaskGui)) {
			$numTasks=$this->_TaskGui->loadCalGui($_sweek-1,$_eweek,$this->_frm->getPrefs('cal','showTasksDone'));
		}
		require_once('lib/class_PrintDialogGui.php');
		$printDialogGui=new PrintDialogGui('cal');
		$printDialogGui->process('list_w');

		require_once('lib/cal/class_DayListGui.php');
		$dayListGui=new DayListGui();
		$dayListGui->setUserID($this->_Base->getUser());
		$dayListGui->setPrivateEvents($p_events);
		$dayListGui->setGroupEvents($g_events);
		$dayListGui->setInvitEvents($this->_invit_events);
		$dayListGui->setAccessLink("index.php?site=cal.php&action=view&view=event&date=".$this->_date);
		$dayListGui->setParseDragDrop(true);
		$dayListGui->setIdPrepend('drag');
		for ($week=0;$week<$this->_nw;$week++) {
			$week_tasks=0;
			$dayHasEntries=array();
			for ($i=0;$i<7;$i++) {
				$_day_b=mktime(0,0,0,$_month,$_day+$i+($week*7),$_year);
				$_day_e=mktime(23,59,59,$_month,$_day+$i+($week*7),$_year);
				$_day_add=mktime(intval($this->_dayUserB/60),$this->_dayUserB%60,0,$_month,$_day+$i+($week*7),$_year);
				$_day_str=date('j-n-Y',$_day_b);
				if ($this->_Base->getCalPerms(2)) {
					$Gui->assign("ADD_$i","index.php?site=cal.php&action=insert&view=event&date=".$_day_add);
					$Gui->parse('ROW','add_'.$i);
				}
				$Gui->assign('DAYID_'.$i,'day_'.$_day_b);
				$this->_droppable['day_'.$_day_b]=$_day_b;
				$Gui->assign("VIEW_$i","index.php?site=cal.php&action=view&view=day&old_view=".$this->_view."&date=".$_day_b);
				//echo date('d.m.Y',$_day_b).'<br>';
				$style='';
				if ($_aktdate==$_day_e)  {
					$style.="background-color:#eaeaea;";
				} else {
					$style.="background-color:".APP_BGCOLOR.';';
				}
				$Gui->assign("DAY".$i."_BG",$style);
				if (!$this->_wd->is_workday($_day_b)) {
					$extra='onmouseover="'.$this->_lGui->getFunctionOn('holy_'.($i+($week*7))).'" onmouseout="'.$this->_lGui->getFunctionOff('holy_'.($i+($week*7))).'"';
					$this->_lGui->addLayer('holy_'.($i+($week*7)),'<strong>'.Framework::entities($this->_wd->get_name()).'</strong>','text');
					$dayTitle='<div style="color:red" '.$extra.'>'.strftime("%d. %B %Y",$_day_b).'</div>';
				} else {
					$dayTitle=strftime("%d. %B %Y",$_day_b);
				}
				$dayListGui->processDay($_day_b,$_day_e,$dayTitle);
				$dayCont=$dayListGui->getDayList($_day_b);
				$Gui->assign("DAY$i",$dayCont?$dayCont:'&nbsp;');

				if ($numTasks && $this->_TaskGui->hasDayEntries($_day_str)) {
					$dayHasEntries[$i]=1;
					$week_tasks=1;
					$Gui->assign('TDAY'.$i,$this->_TaskGui->processCalGui($_day_str));
				} else {
					$Gui->assign('TDAY'.$i,'');
				}


			}
			if ($numTasks && $week_tasks) {
				if ($dayHasEntries[5] && $dayHasEntries[6]) {
					$Gui->parse('ROW','week_task_row_sep');
				} else {
					$Gui->clear_dynamic('week_task_row_sep');
				}
				$Gui->parse('ROW','week_task_row');
			}
			$Gui->parse('ROW','.week_row');
			$Gui->clear_dynamic('week_task_row');
		}
		$this->_draggable=$dayListGui->getDraggable();
		$this->_frm->addonLoad("e7g_initScroll('#calContent',".($this->_firstPos?($this->_firstPos-1):0).");");
		return $Gui;
	}

}
?>