<?php
class ViewYearGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	function ViewYearGui() {
		global $frm,$t,$T,$E,$L,$P,$Y;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_wd=& $frm->getStaticModul('workday');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_lGui=&$Y;
		$this->_T->loadModul('cal');
		require_once('lib/class_ApplicationTreeGui.php');
		$this->_Gui=new ApplicationTreeGui();
		//$this->_Gui->setTreeWidth(200);
	}
	function _handleRequest() {
		$this->_date=Framework::getParam('date',time());
		if (!$this->_date) $this->_date=time();
		$this->_calUser=$GLOBALS['CAL_USER'];
		$this->_view=Framework::getParam('view','year');

		if ($this->_frm->getPrefs('cal','showTasks') && $this->_Base->getUser()==$this->_frm->getUser()) {
			require_once("lib/task/class_TaskActualGui.php");
			$this->_TaskGui=new TaskActualGui();
		}

		$sCalGui=& $this->getSmallCalGui();
		$this->_Gui->addTreeContent($sCalGui);

		require_once("lib/cal/class_CalListGui.php");
		$alarmGui=new CalListGui();
		$this->_invit_events=& $alarmGui->getInvitEvents();
		$invitGui=& $alarmGui->getInvitGui();
		if (is_object($invitGui)) {
			$this->_Gui->addTreeContent($invitGui);
		}
		$actGui=& $alarmGui->getActualGui();
		if (is_object($actGui)) {
			$this->_Gui->addTreeContent($actGui);
		}


		if (is_object($this->_TaskGui)) {
			$sTaskGui=$this->_TaskGui->processActualGui(true);
			if (is_object($sTaskGui)) {
				$this->_Gui->addTreeContent($sTaskGui);
			}
		}

		$wGui=& $this->getYearViewGui();
		$this->_Gui->addContent($wGui,null,null);
	}
	function &process() {
		$this->_handleRequest();
		return $this->_Gui;
	}
	function &getSmallCalGui() {
		require_once("lib/cal/class_SmallCal.php");
		$SmallCalGui=new SmallCalGui();
		$SmallCalGui->setMode('Y');
		$SmallCalGui->setDate($this->_date);
		$SmallCalGui->setNavLink("index.php?site=cal.php&action=view&view=year");
		$SmallCalGui->setAccessLink("index.php?site=cal.php&action=view&view=year");
		return $SmallCalGui->process();
	}
	function &getYearViewGui() {
		require_once('lib/class_FastTemplateGui.php');
		$Gui=new FastTemplateGui('cal/view_year.inc.html');
		$Gui->setEncode(false);

		$_year=date("Y",$this->_date);

		$_beginn=mktime (0,0,0,1,1,$_year);
		$_end=mktime (23,59,59,12,31,$_year);

		$p_events=$this->_Base->listEvents($_beginn,$_end);
		if ($this->_calUser=='info') {
			$g_events=$this->_Base->listInfos($_beginn,$_end);
		} else {
			$g_events=array();
		}
		for ($m=1;$m<13;$m++) {
			$_day1=mktime (0,0,0,$m,1,$_year);
			$mGui=& $this->getMonthGui($_day1,$p_events,$g_events);
			$Gui->assign('MONTH',$mGui->process());
			if (($m%4)==0) {
				$Gui->assign("STYLE","padding: 3px 0px 0 0");
				$Gui->parse('ROW','.month_col');
				$Gui->parse('ROW','.month_row');
				$Gui->clear_dynamic('month_col');
			} else {
				$Gui->assign("STYLE","padding: 3px 3px 0 0");
				$Gui->parse('ROW','.month_col');
			}
		}

		$Gui->assign("PREV_LINK","index.php?site=cal.php&action=view&view=year&date=".($_beginn-1));
		$Gui->assign("NEXT_LINK","index.php?site=cal.php&action=view&view=year&date=".($_end+1));
		$Gui->assign("YEAR",$_year);

		return $Gui;
	}
	function &getMonthGui($_day1,&$p_events,&$g_events) {
		require_once('lib/class_FastTemplateGui.php');
		$Gui=new FastTemplateGui('cal/view_year_month.inc.html');
		$Gui->setEncode(false);
		$Gui->assign('MONTH',strtoupper(strftime('%B',$_day1)));
		$_aktdate=mktime(23,59,59);
		$_days=date("t",$_day1);
		$_month=date("m",$_day1);
		$_year=date("Y",$_day1);
		$_startday=date("w",$_day1)-1;
		if ($_startday<0) $_startday=6;
		$cells=42;
		$cell=1;
		for($cell;$cell<=$_startday;$cell++) {
			$Gui->assign("STYLE","");
			$Gui->assign("CAL_DAY_NUM","");
			$Gui->parse('ROW','.week_col');
			if (($cell%7)==0) {
				$Gui->parse('ROW','.week_row');
				$Gui->clear_dynamic('week_col');
			}
		}
		for($cell;$cell<=($_days+$_startday);$cell++){
			$day=$cell-$_startday;
			$day_e=mktime(23,59,59,$_month,$day,$_year);
			$day_key=date('j-n-Y',$day_e);
			$style='';
			if ($p_events[$day_key])  {
				foreach ($p_events[$day_key] as $key=>$val) {
					if ($val["EndDate"]>$day_e) {
						$newEvt=$val;
						$val["EndDate"]=$day_e;
						$newEvt["StartDate"]=$day_e+1;
						$p_events[date('j',$newEvt["StartDate"]).'-'.date('n',$newEvt["StartDate"]).'-'.date('Y',$newEvt["StartDate"])][$key]=$newEvt;
					}

				}
				$style="background-color:".APP_FG20COLOR.';';
			}
			if ($g_events[$day_key])  {
				foreach ($g_events[$day_key] as $key=>$val) {
					if ($val["EndDate"]>$day_e) {
						$newEvt=$val;
						$val["EndDate"]=$day_e;
						$newEvt["StartDate"]=$day_e+1;
						$p_events[date('j',$newEvt["StartDate"]).'-'.date('n',$newEvt["StartDate"]).'-'.date('Y',$newEvt["StartDate"])][$key]=$newEvt;
					}

				}
				$style="background-color:".APP_FG20COLOR.';';
			}
			if (!$this->_wd->is_workday($day_e)) {
				$lstyle='color:red;';
				$extra='onmouseover="'.$this->_lGui->getFunctionOn('holy_'.$day_e).'" onmouseout="'.$this->_lGui->getFunctionOff('holy_'.$day_e).'"';
				$this->_lGui->addLayer('holy_'.$day_e,'<strong>'.Framework::entities($this->_wd->get_name()).'</strong>','text');
			} else {
				$lstyle='';
				$extra='';
			}
			if ($_aktdate==$day_e) {
				$style.='border:1px solid #f00;';
			} else {

			}


			$Gui->assign("STYLE",$style);
			$Gui->assign("CAL_DAY_NUM","<a href=\"index.php?site=cal.php&action=view&view=day&old_view=year&date=$day_e\" $extra style=\"$lstyle\">$day</a>");
			$Gui->parse('ROW','.week_col');
			if (($cell%7)==0) {
				$Gui->parse('ROW','.week_row');
				$Gui->clear_dynamic('week_col');
			}
		}
        for($cell;$cell<=$cells;$cell++) {
			$Gui->assign("STYLE","");
			$Gui->assign("CAL_DAY_NUM","");
 			$Gui->parse('ROW','.week_col');
			if (($cell%7)==0) {
				$Gui->parse('ROW','.week_row');
				$Gui->clear_dynamic('week_col');
			}
		}
		$this->_frm->addonLoad("e7g_initScroll('#calContent',0);");
		return $Gui;
	}

}
?>