<?php
class AdminGui {
	function AdminGUI() {
		global $frm,$t,$T;
		$this->_frm=&$frm;
		$this->_t=&$t;
		$this->_T=$T;
		$this->_T->loadModul('admin');
		$this->_t->setRoot("tpl/".APP_THEME."/admin/".$this->_frm->getLang());
		if ($GLOBALS['CFG']['USER_CLASS']=='ldap_full') {
			$this->_ldap=1;
		} else {
			$this->_ldap=0;
		}
		$this->_allowed_fields=$this->_frm->getUserFields();
	}
	function show($mode,$return=false) {
		switch ($mode) {
			case 'list':
				return $this->showList($return);
			break;
			case 'edit':
				return $this->showEdit($return);
			break;
		}

	}
	function showList($return) {
		global $fg10color,$bgcolor,$CFG,$av_apps;
		$this->_t->define (array("tpl_adim_form"=>"admin_acc_user_form_list.inc.html"));
		$rows=0;
		$info=$this->_frm->getParam('info','');
		$b=$this->_frm->getParam('b',0);
		$limit=$this->_frm->getParam('limit',50);
		$all_users=$this->_frm->searchUser($rows,$info,0,array('','system'),$b,$limit,true,false);
		//debug($all_users);
		$num_entrys=0;
		$show_mail=false;
		if ($av_apps['email'] && !$CFG['NoMailAdmin']) {
			$CyrAdm=& $this->_frm->getStaticModul('mail_adm');
			if ($CyrAdm->imap_login()) {
				if (GE_mailUserSuffix) {
					$all_mail_users=$CyrAdm->GetUsers('%'.GE_mailUserSuffix);
				} else {
					$all_mail_users=$CyrAdm->GetUsers('%');
				}
				$show_mail=true;
			}
		}
		foreach ($this->_allowed_fields as $val) {
			$this->_t->parse('ROW','lhead_'.$val);
		}
		if ($show_mail) {
			$this->_t->parse('ROW','lhead_m');
		}
		//debug($all_mail_users);
		foreach ($all_users as $key=>$val) {
			$this->_t->assign('LIST_LINK',"index.php?site=admin.php&ac=acc_user&userID=$key&mode=edit&b=$b&info=".urlencode($info));
			$this->_t->assign('LIST_NAME',Framework::entities($val["lastname"].' '.$val["firstname"]));
			$this->_t->assign('LIST_UNAME',Framework::entities($val["username"]));

			foreach ($this->_allowed_fields as $fval) {
				switch ($fval) {
					case 'g':
						if ($val['groupe']) {
							if ($val['perms']==1) $this->_t->assign('LIST_GROUP-E','S'); else  $this->_t->assign('LIST_GROUP-E','X');
						} else {
							$this->_t->assign('LIST_GROUP-E','');
						}
					break;
					case 'gb':
						if ($val['startdate']>0) {
							$this->_t->assign('LIST_BAKTIV',date('d.m.Y',$val['startdate']));
						} else {
							$this->_t->assign('LIST_BAKTIV','');
						}
					break;
					case 'ge':
						if ($val['enddate']>0) {
							$this->_t->assign('LIST_EAKTIV',date('d.m.Y',$val['enddate']));
						} else {
							$this->_t->assign('LIST_EAKTIV','');
						}
					break;
					case 's':
						if ($val['samba']>0) {
							$this->_t->assign('LIST_SAMBA','X');
						} else {
							$this->_t->assign('LIST_SAMBA','');
						}
					break;
					case 'p':
						if ($val['posix']>0) {
							$this->_t->assign('LIST_POSIX','X');
						} else {
							$this->_t->assign('LIST_POSIX','');
						}
					break;
					case 'i':
						if ($val['internet']>0) {
							$this->_t->assign('LIST_INTERNET','X');
						} else {
							$this->_t->assign('LIST_INTERNET','');
						}
					break;
				}
				$this->_t->parse('ROW','llist_'.$fval);
			}
			if ($show_mail) {
				if (in_array($val["username"],$all_mail_users)) {
					$list_quota=$CyrAdm->getquota("user".$CyrAdm->getCfg('cfg/delim').$val["username"]);
					$quota=intval($list_quota['usage']/1000).'/'.intval($list_quota['limit']/1000).' MB';
					$this->_t->assign('LIST_MAIL',$quota);
					if ($list_quota['usage'] > ($list_quota['limit']*0.9)) $this->_t->assign('C_LIST_MAIL','error'); else $this->_t->assign('C_LIST_MAIL','');
				} else {
					$this->_t->assign('LIST_MAIL','');
				}
				$this->_t->parse('ROW','llist_m');
			}

			if ($key==$userID) {
				$this->_t->assign('ROW_COLOR',$fg10color);
			} elseif ($num_entrys%2) {
				$this->_t->assign('ROW_COLOR','#f2f2f2');
			} else {
				$this->_t->assign('ROW_COLOR',$bgcolor);
			}
			$this->_t->parse('ROW','.list_row');
			foreach ($this->_allowed_fields as $val) {
				$this->_t->clear_dynamic('llist_'.$val);
			}
			if ($show_mail) {
				$this->_t->clear_dynamic('llist_m');
			}
			$i++;
			$num_entrys++;
		}
		$link="index.php?site=admin.php&ac=acc_user&info=".urlencode($info);
		if ($limit && $rows>$limit) {
			$s_limit=10;
			$s_begin=1;
			$s_sites=ceil($rows/$limit);
			$a_site=($b/$limit);
			if ($a_site>=$s_limit) {
				$s_begin=floor($a_site/$s_limit)*$s_limit+1;
				$n_b=($s_begin-2)*$limit;
				$l_sites.="<a href=\"$link&b=$n_b\">&lt;&lt;</a> ";
			}
			if (($s_begin+$s_limit)>$s_sites) {
				$len_sites=$s_sites-$s_begin+1;
			} else {
				$len_sites=$s_limit;
			}
			for ($i=$s_begin;$i<($s_begin+$len_sites);$i++) {
				$n_b=($i - 1)*$limit;
				if ($i==$s_begin && $b!=0) $l_sites.="<a href=\"$link&b=".($b-$limit)."\">&lt;</a> ";
				if ($n_b==$b) { $temp_b='<b>'; $temp_e='</b>'; } else{ $temp_b=''; $temp_e=''; }
				$l_sites.="[<a href=\"$link&b=$n_b\">".$temp_b.$i.$temp_e."</a>]";
			}
			if ($b!=($s_sites-1)*$limit) $l_sites.=" <a href=\"$L_THIS&b=".($b+$limit)."\">&gt;</a>";
			if ($s_sites>$i) {
				$n_b=($i-1)*$limit;
				$l_sites.=" <a href=\"$link&b=$n_b\">&gt;&gt;</a>";
				$this->_t->parse("ROW","more");
			}
			$this->_t->assign("S_SITES",$l_sites);
			$this->_t->assign("S_NUM",($b+1)." - ".($b+$num_entrys));
			$this->_t->assign("S_ALL",$rows);
			$this->_t->parse("ROW","search_next");
		} else {
			$this->_t->assign("S_ALL",$num_entrys);
			$this->_t->parse("ROW","search_one");
		}
		$this->_t->parse('TPL_ADMIN_FORM','tpl_adim_form');
		if ($return) {
			return $this->_t->getParsed();
		}
	}
	/*function showEditBox() {
		require_once('lib/class_BoxGui.php');
		$box=new BoxGui('global|adminUserBox');
		$box->addTab('muser',$this->_T->lang('[[BenutzerIn]]'),'#',true);
		$box->setTabContent('muser',$this->getUserMeta());

		$show_tap=$this->_frm->getPrefs('global','adminUserBox');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:'muser');
		return $box;
	}
	function getUserMeta() {
		global $CFG;
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		$userID=$this->_frm->getParam('userID',0);
		$uidGroupe=0;
		if ($userID) {
			$userdata=$this->_frm->read_user($userID,true);
			if ($userdata['startdate']!=-1) {
				$def_startdate=date('d/m/Y',$userdata['startdate']);
			} else {
				$def_startdate='--/--/----';
			}
			if ($userdata['enddate']!=-1) {
				$def_enddate=date('d/m/Y',$userdata['enddate']);
			} else {
				$def_enddate='--/--/----';
			}
			$uidGroupe=$userdata['uidGroup-e']?$userdata['uidGroup-e']:$userID;
			if($CFG['NoUserEdit'] && $uidGroupe==$CFG['SUPERADMIN']) {
				$this->_allowed_fields=array();
				$CFG['NoPassword']=true;
			}
			$def_restrict_ip=$this->_frm->getModulData('global','u',$userdata['uidGroup-e']?$userdata['uidGroup-e']:$userID,'restrict_ip');;
		} else {
			$userdata=array();
			$userdata['groupe']=1;
			$userdata['mail']=1;
			$userdata['enddate']=-1;
			$userdata['startdate']=-1;
			$def_startdate='--/--/----';
			$def_enddate='--/--/----';
			if ($this->_ldap) {
				$userdata['shadowMax']=$frm->getFrmCfg('cfg/usr/MaxPassDays');
			} else {

			}
			$def_restrict_ip='';
		}

		$key='username';
		$formGui->addField($key,'text',$this->_T->lang('[[Username]]'),$userdata[$key],'form_fields1');
		if ($CFG['NoUserEdit']) {
			$formGui->setDisabled($key);
		}
		if (!$userID && $GLOBALS['sadmin'] && $GLOBALS['DEBUG']==2) {
			$key='uidNumber';
			$formGui->addField($key,'text','uidNumber',$userdata[$key],'form_fields1');
		}
		$key='firstname';
		$formGui->addField($key,'text',$this->_T->lang('[[Vorname]]'),$userdata[$key],'form_fields1');
		$key='lastname';
		$formGui->addField($key,'text',$this->_T->lang('[[Nachname]]'),$userdata[$key],'form_fields1');
		$key='email';
		$formGui->addField($key,'text',$this->_T->lang('[[E-Mail]]'),$userdata[$key],'form_fields1');
		
		if (!$CFG['NoPassword']) {
			$key='npassword';
			$formGui->addField($key,'pwd',$this->_T->lang('[[Passwort]]'),'','form_fields1');
			$formGui->setNoMeta($key);
			$key='npassword_b';
			$formGui->addField($key,'pwd',$this->_T->lang('[[Best&auml;tigung Passwort]]'),'','form_fields1');
			$formGui->setNoMeta($key);

			if ($this->_ldap && $this->_frm->getFrmCfg('cfg/usr/MaxPassDays')) {
				$key='shadowMax';
				$formGui->addField($key,'select',$this->_T->lang('[[Passwort verfaellt nach]]'),'','form_fields1');
				$formGui->setValues($key,array(
					0=>$this->_T->lang('[[Nie]]'),
					30=>"1 ".$this->_T->lang('[[Monate]]'),
					60=>"2 ".$this->_T->lang('[[Monate]]'),
					90=>"3 ".$this->_T->lang('[[Monate]]'),
					180=>"6 ".$this->_T->lang('[[Monate]]'),
				));
			}
		}
		
		
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;
	}*/
	function showEdit($return) {
		global $ActionError,$av_apps,$my_rule,$CFG,$frm,$T;

		
		$this->_t->define (array("tpl_adim_form"=>"admin_acc_user_form_edit.inc.html"));
		$userID=$this->_frm->getParam('userID',0);
		$uidGroupe=0;

		if ($userID) {
			$userdata=$this->_frm->read_user($userID,true);
			if (!$this->_frm->getParam('save_x',0)) {
				if ($userdata['startdate']!=-1) {
					$def_startdate=date('d/m/Y',$userdata['startdate']);
				} else {
					$def_startdate='--/--/----';
				}
				if ($userdata['enddate']!=-1) {
					$def_enddate=date('d/m/Y',$userdata['enddate']);
				} else {
					$def_enddate='--/--/----';
				}
				$user_groups=$this->_frm->getUserGroups($userID,true);
				$user_app=$this->_frm->getUsersApplication($userdata['uidGroup-e']?$userdata['uidGroup-e']:$userID,1,0);
				$def_restrict_ip=$this->_frm->getModulData('global','u',$userdata['uidGroup-e']?$userdata['uidGroup-e']:$userID,'restrict_ip');;
			}
			if ($av_apps['email'] && !$CFG['NoMailAdmin']) {
				$CyrAdm=& $frm->getStaticModul('mail_adm');
				if ($CyrAdm->imap_login()) {
					if (GE_DOMAIN && $GLOBALS['CFG']['USER_CLASS']!='ldap_full') {
						$m_username=$userdata['username'].'_'.str_replace('.','_',GE_DOMAIN);
					} else {
						$m_username=$userdata['username'];
					}
					$result=$CyrAdm->GetUsers($m_username);
					if ($result!==false) {
						if (is_array($result) && in_array($m_username,$result)) $mailacc="yes";
					} else {
						$ActionError['server']=$CyrAdm->getError();
						$no_mail=true;
					}
				} else {
					$ActionError['server']=$CyrAdm->getError();
					$no_mail=true;
				}
			}
			$group_app=$this->_frm->getUsersApplication($userdata['uidGroup-e']?$userdata['uidGroup-e']:$userID,0,1);
			$uidGroupe=$userdata['uidGroup-e']?$userdata['uidGroup-e']:$userID;
			if($CFG['NoUserEdit'] && $uidGroupe==$CFG['SUPERADMIN']) {
				$this->_allowed_fields=array();
				$CFG['NoPassword']=true;
			}
		} else {
			if (!$this->_frm->getParam('save_x',0)) {
				$userdata['groupe']=1;
				$userdata['mail']=1;
				$userdata['enddate']=-1;
				$userdata['startdate']=-1;
				$def_startdate='--/--/----';
				$def_enddate='--/--/----';
				if ($this->_ldap) {
					$userdata['shadowMax']=$frm->getFrmCfg('cfg/usr/MaxPassDays');
					$userdata['gidnumber']=$this->_frm->getGroupAllLdapID();
					$user_groups=array($this->_frm->getGroupAllLdapID());
				} else {
					$user_groups=array($CFG['GROUP_ALL']);
				}
				$user_app=array();
				$def_restrict_ip='';
			}
			$group_app=array();
		}
		//debug($userdata);
		if (!$CFG['NoUserEdit']) {
			if ($ActionError['fields']['username'] || $ActionError['userlen'] || $ActionError['username']) $this->_t->assign('C_UNAME','error'); else  $this->_t->assign('C_UNAME','');
			$f_username=new TextField("username","class=sel  style=\"width:300px\" size=15",'','',$userdata['username']);
			$this->_t->assign("F_UNAME",$f_username->f());
			$this->_t->assign('FOCUS_FIELD','username');
			if (!$userID && $GLOBALS['sadmin'] && $GLOBALS['DEBUG']==2) {
				$f_uid=new TextField("uidNumber","class=sel  style=\"width:300px\" size=15");
				$this->_t->assign("F_UIDNUMBER",$f_uid->f());
				$this->_t->parse('ROW','uid_edit');
			}
		} else {
			$this->_t->assign('F_UNAME','<div class="disable" style="width:300px;">'.FrameWork::entities($userdata['username']).'</div>');
		}

		if ($ActionError['fields']['vorname']) $this->_t->assign('C_VORNAME','error'); else  $this->_t->assign('C_VORNAME','');
		$f_vorname=new TextField("firstname","class=sel size=15 style=\"width:300px\"",'','',$userdata['firstname']);
		$this->_t->assign("F_VORNAME",$f_vorname->f());

		if ($ActionError['fields']['nachname']) $this->_t->assign('C_NACHNAME','error'); else  $this->_t->assign('C_NACHNAME','');
		$f_nachname=new TextField("lastname","class=sel size=15 style=\"width:300px\"",'','',$userdata['lastname']);
		$this->_t->assign("F_NACHNAME",$f_nachname->f());

		if ($this->_ldap) {
			$f_title=new TextField("title","class=sel size=15 style=\"width:300px\"",'','',$userdata['title']);
			$this->_t->assign("F_TITLE",$f_title->f());
			$this->_t->parse("ROW",'user_title');
		}

		$f_mobil=new TextField("mobil","class=sel size=15 style=\"width:300px\"",'','',$userdata['mobil']);
		$this->_t->assign("F_MOBIL",$f_mobil->f());
		$f_tel=new TextField("tel","class=sel size=15 style=\"width:300px\"",'','',$userdata['tel']);
		$this->_t->assign("F_TEL",$f_tel->f());
		$f_fax=new TextField("fax","class=sel size=15 style=\"width:300px\"",'','',$userdata['fax']);
		$this->_t->assign("F_FAX",$f_fax->f());
		
		$f_company=new TextField("company","class=sel size=15 style=\"width:300px\"",'','',$userdata['company']);
		$this->_t->assign("F_COMPANY",$f_company->f());
		$f_adress=new TextField("adress","class=sel size=15 style=\"width:300px\"",'','',$userdata['adress']);
		$this->_t->assign("F_ADRESS",$f_adress->f());
		$f_zip=new TextField("zip","class=sel size=15 style=\"width:300px\"",'','',$userdata['zip']);
		$this->_t->assign("F_ZIP",$f_zip->f());
		$f_place=new TextField("place","class=sel size=15 style=\"width:300px\"",'','',$userdata['place']);
		$this->_t->assign("F_PLACE",$f_place->f());
		

		if ($ActionError['fields']['email']) $this->_t->assign('C_EMAIL','error'); else  $this->_t->assign('C_EMAIL','');
		$f_email=new TextField("email","class=sel size=15 style=\"width:300px\"",'','',$userdata['email']);
		$this->_t->assign("F_EMAIL",$f_email->f());


		if (!$CFG['NoPassword']) {
			if ($ActionError['fields']['passwort']) $this->_t->assign('C_PASSWORT','error'); else  $this->_t->assign('C_PASSWORT','');
			$f_passwort=new PasswordField("npassword","class=sel  size=10 style=\"width:300px\"");
			$this->_t->assign("F_PASSWORT",$f_passwort->f());

			if ($ActionError['fields']['passwort2']) $this->_t->assign('C_PASSWORT2','error'); else  $this->_t->assign('C_PASSWORT2','');
			$f_passwort2=new PasswordField("npassword_b","class=sel  size=10 style=\"width:300px\"");
			$this->_t->assign("F_PASSWORT2",$f_passwort2->f());
			$this->_t->parse("ROW",'user_pwd');
			if ($this->_ldap && $frm->getFrmCfg('cfg/usr/MaxPassDays')) {
				$f_password_time=new SelectField("password_time","class=sel",array(0=>$T->lang('[[Nie]]'),30=>"1 ".$T->lang('[[Monate]]'),60=>"2 ".$T->lang('[[Monate]]'),90=>"3 ".$T->lang('[[Monate]]'),180=>"6 ".$T->lang('[[Monate]]')),$userdata['shadowMax']);
				$this->_t->assign("F_PASSWORT_TIME",$f_password_time->f());
				$this->_t->parse("ROW",'user_pwd_time');
			}
		}

		if (in_array('g',$this->_allowed_fields)) {
			$f_activ_groupe=new CheckBox ("groupe","class=sel",1,$userdata['groupe']);
			$this->_t->assign("F_AKTIV_GROUP-E",$f_activ_groupe->f());

			if ($my_rule['sysadmin']) {
				$f_perms=new CheckBox ("perms","class=sel",1,$userdata['perms']);
				$this->_t->assign("F_PERMS",$f_perms->f(1));
				$this->_t->parse('ROW','user_perms');
			}
			if (in_array('gb',$this->_allowed_fields) && in_array('ge',$this->_allowed_fields)) {
				$f_startdate=new TextField("startdate",'size="15" class="sel" style="width:100px;"',"","",$def_startdate);
				$this->_t->assign("F_STARTDATE",$f_startdate->f());
				$f_enddate=new TextField("enddate",'size="15" class="sel" style="width:100px;"',"","",$def_enddate);
				$this->_t->assign("F_ENDDATE",$f_enddate->f());
				$this->_t->parse('ROW','use_gbe');
			}
			$f_restrict=new TextField("restrict_ip",'lass="sel" size=15 style="width:300px"',"","",$def_restrict_ip);
			$this->_t->assign("F_RESTRICT_IP",$f_restrict->f());

			$this->_t->parse('ROW','use_g');
		}

		if (in_array('s',$this->_allowed_fields)) {
			$servers=$this->_frm->getSmbServers();
			//debug($userdata);
			if (count($servers)>1) {
				$servers_array=array();
				foreach ($servers as $val) {
					$servers_array[$val]=$val;
				}
				$f_smb_servers=new SelectField("sambaServer","class=sel",$servers_array,$userdata['smbServer']);
				$this->_t->assign("F_SAMBA_SERVERS",$f_smb_servers->f());
				$this->_t->parse('ROW','use_s_servers');
			}

			$f_activ_samba=new CheckBox ("samba","class=sel",1,$userdata['samba']);
			$this->_t->assign("F_AKTIV_SAMBA",$f_activ_samba->f(1));
			$this->_t->parse('ROW','use_s');

		}

		if (in_array('p',$this->_allowed_fields)) {
			$f_activ_posix=new CheckBox ("posix","class=sel",1,$userdata['posix']);
			$this->_t->assign("F_AKTIV_POSIX",$f_activ_posix->f(1));
			$this->_t->parse('ROW','use_p');
		}
		if (in_array('i',$this->_allowed_fields)) {
			$f_activ_posix=new CheckBox ("internet","class=sel",1,$userdata['internet']);
			$this->_t->assign("F_AKTIV_INTERNET",$f_activ_posix->f(1));
			$this->_t->parse('ROW','use_i');
		}



		if ($av_apps['email'] && !$no_mail &&  !$CFG['NoMailAdmin'] && !$CFG['NoMailEdit']) {
			if($mailacc=="yes"){
				$this->_t->assign("USERNAME",$userdata['username']);
				$this->_t->parse("ROW",'exist_mail');
			} else {
				$f_email=new CheckBox ("mail","class=sel",1,$userdata['mail']);
				$this->_t->assign("F_MAIL",$f_email->f());
				//$f_quota=new SelectField("selquota","class=sel",array("20"=>"20","50"=>"50","100"=>"100"));
				$f_quota=new TextField("selquota","class=sel size=5 style=\"width:100px\"",'','',"50");
				$this->_t->assign("F_QUOTA",$f_quota->f());
				$this->_t->parse("ROW",'new_mail_ac');
			}
			$this->_t->parse("ROW",'mail');
		}
		if ($this->_frm->getFrmCfg('ldap/mailRouting')) {
				if ($ActionError['fields']['maillocaladdress']) $this->_t->assign('C_M_LOCAL','error'); else  $this->_t->assign('C_M_LOCAL','');
				$f_maillocaladdress=new TextField("maillocaladdress","class=sel size=15 style=\"width:300px\"",'','',$userdata['maillocaladdress']);
				$this->_t->assign("F_M_LOCAL",$f_maillocaladdress->f());

				if ($ActionError['fields']['mailhost']) $this->_t->assign('C_M_HOST','error'); else  $this->_t->assign('C_M_HOST','');
				$f_mailhost=new TextField("mailhost","class=sel size=15 style=\"width:300px\"",'','',$userdata['mailhost']);
				$this->_t->assign("F_M_HOST",$f_mailhost->f());

				if ($ActionError['fields']['mailroutingaddress']) $this->_t->assign('C_M_ROUTING','error'); else  $this->_t->assign('C_M_ROUTING','');
				$f_mailroutingaddress=new TextField("mailroutingaddress","class=sel size=15 style=\"width:300px\"",'','',$userdata['mailroutingaddress']);
				$this->_t->assign("F_M_ROUTING",$f_mailroutingaddress->f());

				$this->_t->parse("ROW",'mail_routing');
		}
		$chk_user_app=new CheckBox ("user_app","","",$user_app,1);
		$apps=$this->_frm->getApplication(0,-1);
		$num=ceil(count($apps)/3);
		if ($num<5) $num=5;
		$i=0;$col=1;
		foreach ($apps as $key=>$val) {
			$this->_t->assign("APP_RIGHTS_F",$chk_user_app->f($val['id']));
			if (in_array($val['id'],$group_app)) {
				$this->_t->assign("APP_E_RIGHTS_F","<img src=img/".APP_THEME."/checked.gif width=17 height=17 border=0>");
			} else {
				$this->_t->assign("APP_E_RIGHTS_F","<img src=img/".APP_THEME."/unchecked.gif width=17 height=17 border=0>");
			}
			$this->_t->assign("APP_NAME_LIST",Framework::entities($val['title']));
			$this->_t->parse("ROW",".app_row_".$col);
			$i++;
			if ($i>=$num) {
				$col++;
				$i=0;
			}
		}
		$chk_user_groups=new CheckBox ("user_groups","","",$user_groups,1);
		if ($this->_ldap) {
			$groups=$frm->getAdminGroups(0,false);
			$primaryGroups=Framework::extractArrayMeta($groups,'cn');
			if (!isset($primaryGroups[$userdata['gidnumber']])) {
				$tmpGroup=$frm->getAdminGroups($userdata['gidnumber']);
				if ($tmpGroup) {
					$primaryGroups[$userdata['gidnumber']]=$tmpGroup['cn'];
				} else {
					$primaryGroups[$userdata['gidnumber']]='-';
				}
			}
			$f_gidNumber=new SelectField("gidNumber","class=sel",$primaryGroups,$userdata['gidnumber']);
			$this->_t->assign("F_PRIMARY_GROUP",$f_gidNumber->f());
			if ($ActionError['fields']['gidNumber']) $this->_t->assign('C_PRIMARY_GROUP','error'); else  $this->_t->assign('C_PRIMARY_GROUP','');
			$this->_t->parse('ROW','use_primary_group');

			$num=ceil(count($groups)/3);
			if ($num<5) $num=5;
			$i=0;$col=1;
			foreach ($groups as $key=>$val) {
				if ($key==$this->_frm->getGroupAllLdapID() && !$userdata["perms"]) {
					$disabled=1;
				} else {
					$disabled=0;
				}
				$this->_t->assign("GROUP_RIGHTS_F",$chk_user_groups->f($key,$disabled));
				$this->_t->assign("GROUP_NAME_LIST",$val['cn']);
				$this->_t->parse("ROW",".group_row_".$col);
				$i++;
				if ($i>=$num) {
					$col++;
					$i=0;
				}
			}
		} else {
			$groups=$this->_frm->getAllGroups();

			$num=ceil(count($groups)/3);
			if ($num<5) $num=5;
			$i=0;$col=1;
			foreach ($groups as $key=>$val) {
				if ($key==$CFG['GROUP_ALL'] && !$userdata["perms"]) {
					$disabled=1;
				} else {
					$disabled=0;
				}
				$this->_t->assign("GROUP_RIGHTS_F",$chk_user_groups->f($key,$disabled));
				$this->_t->assign("GROUP_NAME_LIST",$val);
				$this->_t->parse("ROW",".group_row_".$col);
				$i++;
				if ($i>=$num) {
					$col++;
					$i=0;
				}
			}
		}
		if ($userID) {
			$this->_t->assign('USER_NAME',Framework::entities($userdata["lastname"].' '.$userdata["firstname"]));
			$this->_t->parse('ROW','title_edit');
		} else {
			$this->_t->parse('ROW','title_new');
		}

		if ($av_apps['zef']) {
			$zef=$this->_frm->getStaticModul('zef');
			$userTime=$zef->getUserTime($userdata['uidGroup-e']?$userdata['uidGroup-e']:-1);
			$start_day=mktime(0,0,0,1,1,2001);
			for ($i=1;$i<8;$i++) {
				$this->_t->assign('WEEK_DAY',strftime('%A',$start_day));

				$f_bhour[$i][1]=new TextField("bhour[$i][1]",'class="sel" size=3 maxlenght=2 style="width:30px"','','',sprintf('%02d',$userTime['bhour'][$i][1]));
				$f_bhour[$i][2]=new TextField("bhour[$i][2]",'class="sel" size=3 maxlenght=2 style="width:30px"','','',sprintf('%02d',$userTime['bhour'][$i][2]));
				$f_bmin[$i][1]=new TextField("bmin[$i][1]",'class="sel" size=3 maxlenght=2 style="width:30px"','','',sprintf('%02d',$userTime['bmin'][$i][1]));
				$f_bmin[$i][2]=new TextField("bmin[$i][2]",'class="sel" size=3 maxlenght=2 style="width:30px"','','',sprintf('%02d',$userTime['bmin'][$i][2]));

				$this->_t->assign('BHOUR1_F',$f_bhour[$i][1]->f());
				$this->_t->assign('BHOUR2_F',$f_bhour[$i][2]->f());
				$this->_t->assign('BMIN1_F',$f_bmin[$i][1]->f());
				$this->_t->assign('BMIN2_F',$f_bmin[$i][2]->f());


				$f_ehour[$i][1]=new TextField("ehour[$i][1]",'class="sel" size=3 maxlenght=2 style="width:30px"','','',sprintf('%02d',$userTime['ehour'][$i][1]));
				$f_ehour[$i][2]=new TextField("ehour[$i][2]",'class="sel" size=3 maxlenght=2 style="width:30px"','','',sprintf('%02d',$userTime['ehour'][$i][2]));
				$f_emin[$i][1]=new TextField("emin[$i][1]",'class="sel" size=3 maxlenght=2 style="width:30px"','','',sprintf('%02d',$userTime['emin'][$i][1]));
				$f_emin[$i][2]=new TextField("emin[$i][2]",'class="sel" size=3 maxlenght=2 style="width:30px"','','',sprintf('%02d',$userTime['emin'][$i][2]));

				$this->_t->assign('EHOUR1_F',$f_ehour[$i][1]->f());
				$this->_t->assign('EHOUR2_F',$f_ehour[$i][2]->f());
				$this->_t->assign('EMIN1_F',$f_emin[$i][1]->f());
				$this->_t->assign('EMIN2_F',$f_emin[$i][2]->f());

				if ($ActionError['fields']['bhour'][$i][1] || $ActionError['fields']['bmin'][$i][1]) $this->_t->assign('B1_C','error'); else $this->_t->assign('B1_C','');
				if ($ActionError['fields']['bhour'][$i][2] || $ActionError['fields']['bmin'][$i][2]) $this->_t->assign('B2_C','error'); else $this->_t->assign('B2_C','');
				if ($ActionError['fields']['ehour'][$i][1] || $ActionError['fields']['emin'][$i][1]) $this->_t->assign('E1_C','error'); else $this->_t->assign('E1_C','');
				if ($ActionError['fields']['ehour'][$i][2] || $ActionError['fields']['emin'][$i][2]) $this->_t->assign('E2_C','error'); else $this->_t->assign('E2_C','');

				$this->_t->parse('ROW','.week_days');
				$start_day+=3600*24;
			}
			$this->_t->parse('ROW','pres_box_h');
			$this->_t->parse('ROW','pres_box_c');
		}


		
		$this->_t->assign('L_BREAK',"index.php?site=admin.php&ac=acc_user&b=".$this->_frm->getParam('b',0)."&info=".urlencode($this->_frm->getParam('info','')));
		$this->_t->parse('ROW','break');
		$this->_t->parse('ROW','update');
		$this->_t->parse('TPL_ADMIN_FORM','tpl_adim_form');
		if ($return) return $this->_t->getParsed();
	}
}

?>