<?php
class ApplicationListGui {
	var $_T;
	var $_t;
	var $_tpl_list='';
	var $_header=array();
	var $_rows=array();
	var $_row_count=0;
	var $_row_count_minus=0;
	var $_limit=0;
	var $_max_pages=10;
	var $_begin=0;
	var $_class=array('list_l','list_h','list_s');
	var $_orderimg=array(0=>'ar_none.gif',1=>'ar_down.gif',-1=>'ar_up.gif');
	var $_order_params=array('_OrderF','_OrderD');
	var $_func_align='left';
	var $_numKey='b';
	var $_trOver='';
	var $_trOut='';
	var $_trClick='';
	var $_trDown='';
	var $_ID='';
	var $_tab_style='';
	var $_bgHeader=APP_FG10COLOR;
	var $_bgTitle=APP_FG20COLOR;
	var $_borderColor=APP_FGCOLOR;
	var $_groupFields=array();
	var $_xlsFields=array();
	var $_tab_toggle=0;
	var $_name='';
	var $_autoBg='';
	var $_top_name='';
	var $_header_functions=array();
	var $_addGroupNum=0;
	var $_trClass='';
	var $_editable=0;

	function ApplicationListGui($tpl='core/common_table_list.inc.html') {
		global $T,$frm;
		$this->_T=&$T;
		$this->_frm=&$frm;
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
		$this->_tpl_list=$tpl;
	}
	function setName($name,$img='loc.gif') {
		$this->_name=$name;
		$this->_img=$img;
	}
	function setStyle($val) {
		$this->_tab_style=$val;
	}
	function setTopName($name) {
		$this->_top_name=$name;
	}
	function setNumKey($name) {
		$this->_numKey=$name;
	}
	function setAutoBg($val) {
		$this->_autoBg=$val;
	}
	function setTrOver($val) {
		$this->_trOver=$val;
	}
	function setTrOut($val) {
		$this->_trOut=$val;
	}
	function setTrClick($val) {
		$this->_trClick=$val;
	}
	function setTrDown($val) {
		$this->_trDown=$val;
	}
	function setTrClass($val,$num=false) {
		if ($num===false) $num=$this->_row_count;
		$this->_trClass[$num]=$val;
	}
	function setID($val) {
		$this->_ID=$val;
	}
	function setToggle($key,$hide=0) {
		$this->_tab_toggle=array($key,$hide);
		
	}
	function allowEdit($config) {
		require_once('lib/class_JsEditGui.php');
		$this->_editable=1;
		$this->_editGui=new JsEditGui();
		$this->_editGui->setConfig($config);
	}
	function setColEdit($col,$val) {
		$this->_editGui->setFieldConfig($col,$val);
	}
	function addFunction(&$obj,$pos=0) {
		$this->_header_functions[$pos][]=&$obj;
	}
	function setFunctionAlign($align) {
		$this->_func_align=$align;
	}
	function setRowClass($ll,$hl='',$sl='') {
		if (is_array($ll)) {
			$this->_class=$ll;
		} else {
			$this->_class=array($ll,$hl,$sl);
		}
	}
	function setTemplate($name) {
		$this->_tpl_list=$name;
	}
	function setLimit($limit=0) {
		$this->_limit=$limit;
	}
	function setNavLink(&$link) {
		$this->_nav_link=&$link;
	}
	function setSumRows($num=0) {
		$this->_sum_rows=$num;
	}
	function setMaxPages($max) {
		$this->_max_pages=$max;
	}
	function setBegin($b) {
		$this->_begin=$b;
	}
	function setOrderImg($down,$up,$none) {
		$this->_orderimg=array(0=>$none,1=>$down,-1=>$up);
	}
	function setOrderParams($o,$a) {
		$this->_order_params=array($o,$a);
	}
	function setActOrder($o,$a) {
		$this->_act_order=array($o,$a);
	}
	function setOrderLink(&$obj) {
		$this->_orderLink=&$obj;
	}
	function setHeaderColor($val) {
		$this->_bgHeader=$val;
	}
	function setBorderColor($val) {
		$this->_borderColor=$val;
	}
	function setTitleColor($val) {
		$this->_bgTitle=$val;
	}
	function setHeaderOrder($ID,$orderField,$defdir=1) {
		$this->_header[$ID]['OF']=$orderField;
		$this->_header[$ID]['OD']=$defdir;
	}
	function setGroupFields($val,$addNum=false) {
		$this->_groupFields=$val;
		$this->_addGroupNum=$addNum;
	}
	function addHeaderCol($ID,$Name='',$Image='',$Link='',$Align='',$NoWrap='',$Width='',$Span=0,$Valign='',$add=null) {
		$this->_header[$ID]=array(
			'N'=>$Name,
			'I'=>$Image,
			'W'=>$Width,
			'L'=>$Link,
			'A'=>$Align,
			'X'=>$NoWrap,
			'S'=>$Span,
			'V'=>$Valign,
		);
		if (is_array($add)) {
			foreach ($add as $skey=>$data) {
				$this->_header[$ID][$skey]=$data;
			}
		}
	}
	function addRow($highlight=0,$valign='',$color='',$ignore_count=false) {
		$this->_row_count++;
		$this->_rows[$this->_row_count]=array(
			'H'=>$highlight,
			'V'=>$valign,
			'C'=>$color,
		);
		if ($ignore_count) $this->_row_count_minus+=1;
		return $this->_row_count;
	}
	function addCol($ID,$Name='',$Image='',$Link='',$Align='',$NoWrap='',$Width='',$Span=0,$Valign='',$add=null) {
		$this->_rows[$this->_row_count]['col'][$ID]=array(
			'N'=>&$Name,
			'I'=>$Image,
			'W'=>$Width,
			'L'=>$Link,
			'A'=>$Align,
			'X'=>$NoWrap,
			'S'=>$Span,
			'V'=>$Valign,
		);
		if (is_array($add)) {
			foreach ($add as $skey=>$data) {
				$this->_rows[$this->_row_count]['col'][$ID][$skey]=$data;
			}
		}
	}
	function setRowData($data='') {
		foreach ($data as $key=>$val) {
			$this->_rows[$this->_row_count][$key]=$val;
		}
	}
	function setColData($ID,$data='') {
		foreach ($data as $key=>$val) {
			$this->_rows[$this->_row_count]['col'][$ID][$key]=$val;
		}
	}
	function setXlsFields($ID,$data='') {
		$this->_xlsFields[$ID]=$data;
	}
	function sortRows($sort,$highlight=0) {
		$this->_sort=$sort;
		usort ($this->_rows,array($this,'_sortRows'));
		if ($highlight) {
			$hl=0;
			foreach (array_keys($this->_rows) as $val) {
				if (!$this->_rows[$val]['H']) {
					$this->_rows[$val]['H']=($hl?$hl=0:$hl=$highlight);
				}
			}
		}
	}
	function _sortRows($a,$b) {
		foreach ($this->_sort as $sort) {
			$ID=$sort[0];
			$DIR=$sort[1]?array(-1,1):array(1,-1);
			//debug($DIR);
			$TYP=$sort[2]?$sort[2]:'N';

			$MODE=$sort[3]?$sort[3]:'C';
			$SORKEY=$sort[4]?$sort[4]:'col';

			//debug($a[$SORKEY][$ID]);
			//debug('--'.$a[$SORKEY][$ID][$TYP]);
			if ($MODE=='C')	$res=strnatcasecmp ($a[$SORKEY][$ID][$TYP],$b[$SORKEY][$ID][$TYP]);
			if ($MODE=='N')	{
				$res=$a[$SORKEY][$ID][$TYP]==$b[$SORKEY][$ID][$TYP]?0:($a[$SORKEY][$ID][$TYP]<$b[$SORKEY][$ID][$TYP]?-1:1);
			}
			if ($res>0) return $DIR[0];
			if ($res<0) return $DIR[1];
		}
		return 0;
	}
	function addColSub($ID,$key,$data='') {
		if (is_array($key)) {
			foreach ($key as $skey=>$data) {
				$this->_rows[$this->_row_count]['col'][$ID]['SUB'][$skey]=$data;
			}
		} else {
			$this->_rows[$this->_row_count]['col'][$ID]['SUB'][$key]=$data;
		}
	}
	function process($handle='') {
		if (!$handle) {
			$handle='application_list_content';
			$return=true;
		} else {
			$return=false;
		}
		$this->_t->setRoot('tpl/'.APP_THEME);
		$this->_t->define (array($handle => $this->_tpl_list));
		$this->_t->assign('JS_AUTO_BG','');
		$this->_t->assign('C_AUTO_BG','');
		if (!$this->_ID) $this->_ID=FrameWork::getUniqeID();
		$this->_t->assign('TAB_ID',$this->_ID);
		$this->_t->assign('BORDER_COLOR',$this->_borderColor);
		$this->_t->assign('TITLE_COLOR',$this->_bgTitle);

		$header=false;
		$this->_t->assign('NAME',Framework::entities($this->_name));
		if ($this->_tab_toggle && $this->_ID && $this->_t->issetHandle('table_name')) {
			if ($this->_tab_toggle[1]) {
				$this->_t->assign('IMG','menu/wdown.gif');
				 $this->_tab_style.='height:1px;overflow:hidden';
			} else {
				$this->_t->assign('IMG','menu/wup.gif');
			}
			$this->_t->assign('DATA_TOGGLE',$this->_tab_toggle[0]);
			$this->_t->parse('ROW','table_name');
			$header=true;
		} else {
			$this->_t->assign('DATA_TOGGLE','');
			if ($this->_name && $this->_t->issetHandle('table_name')) {
				$this->_t->assign('IMG',Framework::entities($this->_img));
				$this->_t->parse('ROW','table_name');
				$header=true;
			}
		}
		$this->_t->assign('STYLE',$this->_tab_style);
		
		if ($this->_autoBg) {
			$this->_t->assign('C_AUTO_BG',$this->_autoBg);
			$this->_trOver.="setAutoBg('{ROW}',this);";
			$this->_trOut.="clearAutoBg('{ROW}',this)";
			if ($this->_t->issetHandle('table_auto_bg')) $this->_t->parse('ROW','table_auto_bg');
		}
		$numKey=$this->_numKey;
		if ($this->_top_name && $this->_t->issetHandle('table_top_name')) {
			$this->_t->assign('NAME',Framework::entities($this->_top_name));
			$this->_t->parse('ROW','table_top_name');
			$header=true;
		}
		$this->_t->assign('FUNC_ALIGN',$this->_func_align);
		if (isset($this->_header_functions[0]) && is_array($this->_header_functions[0]) && $this->_t->issetHandle('table_list_func')) {
			foreach ($this->_header_functions[0] as $val) {
				$this->_t->assign('HEADER_FUNCTION',$val->process());
				$this->_t->parse('ROW','.table_list_func');
				$header=true;
			}

		}
		if (isset($this->_header_functions[1]) && is_array($this->_header_functions[1]) && $this->_t->issetHandle('table_header_func')) {
			foreach ($this->_header_functions[1] as $val) {
				$this->_t->assign('HEADER_FUNCTION',$val->process());
				$this->_t->parse('ROW','.table_header_func_row');
				$header=true;
			}
			$this->_t->parse('ROW','.table_header_func');

		}
		if ($this->_limit && $this->_t->issetHandle('table_limit')) {
			if ($this->_sum_rows>$this->_limit) {
				$s_begin=1;
				$s_sites=ceil($this->_sum_rows/$this->_limit);
				$a_site=($this->_begin/$this->_limit);
				if ($a_site>=$this->_max_pages) {
					$s_begin=floor($a_site/$this->_max_pages)*$this->_max_pages+1;
					$n_b=($s_begin-2)*$this->_limit;
					$l_sites.='<a href="'.htmlspecialchars($this->_nav_link->getTempLink(null,array($numKey=>$n_b))).'">&lt;&lt;</a> ';
				}
				if (($s_begin+$this->_max_pages)>$s_sites) {
					$len_sites=$s_sites-$s_begin+1;
				} else {
					$len_sites=$this->_max_pages;
				}
				for ($i=$s_begin;$i<($s_begin+$len_sites);$i++) {
					$n_b=($i - 1)*$this->_limit;
					if ($n_b==$this->_begin) { $temp_b='<b>'; $temp_e='</b>'; } else {$temp_b=''; $temp_e='';}
					$l_sites.='[<a href="'.htmlspecialchars($this->_nav_link->getTempLink(null,array($numKey=>$n_b))).'">'.$temp_b.$i.$temp_e."</a>]";
				}
				if ($s_sites>=$i) {
					$n_b=($i-1)*$this->_limit;
					$l_sites.=' <a href="'.htmlspecialchars($this->_nav_link->getTempLink(null,array($numKey=>$n_b))).'">&gt;&gt;</a>';
					$this->_t->parse("ROW","more");
				}
				$this->_t->assign("S_SITES",$l_sites);
				$this->_t->assign("S_NUM",($this->_begin+1)." - ".($this->_begin+$this->_row_count-$this->_row_count_minus));
				$this->_t->assign("S_ALL",$this->_sum_rows);
				$this->_t->parse("ROW","search_next");
			} else {
				$this->_t->assign("S_ALL",$this->_row_count-$this->_row_count_minus);
				$this->_t->parse("ROW","search_one");
			}
			$this->_t->parse('ROW','table_limit');
			$header=true;
		}
		if ($header && $this->_t->issetHandle('table_header')) {
			$this->_t->parse('ROW','table_list_header');
		}

		$pimg='';
		if (!empty($this->_header) && $this->_t->issetHandle('table_header')) {
			$this->_t->assign('BG_HEADER',$this->_bgHeader);
			$j=0;
			$maxColspan=0;
			foreach ($this->_header as $ID=>$val) {
				if ($j==0 && !empty($this->_groupFields)) {
					$val['S']=(count($this->_groupFields)-1) + (intval($val['S'])?$val['S']:1);
				}
				$attribs='';$pimg='';
				$this->_t->assign('ID',$ID);
				if ($val['W']) $attribs.=' width="'.$val['W'].'"';
				if ($val['S']) {
					$attribs.=' colspan="'.$val['S'].'"';
					$maxColspan+=$val['S'];
				} else {
					$maxColspan+=1;
				}
				if ($val['X']) $attribs.=' nowrap="nowrap"';
				$val['Attribs']['style'].='text-align:'.($val['A']?$val['A']:'left');
				if (is_array($val['Attribs'])) {
					foreach ($val['Attribs'] as $akey=>$aval) {
						$attribs.=' '.$akey.'="'.$aval.'"';
					}
				}
				$this->_t->assign('ATTRIBS',$attribs);
				if (is_object($this->_orderLink)) {
					if ($val['OF']) {
						if ($val['OF']==$this->_act_order[0]) {
							$porder=$val['OF'];
							$pimg=$this->_orderimg[$this->_act_order[1]];
							$pdir=$this->_act_order[1]==1?-1:1;
						} else {
							$porder=$val['OF'];
							$pdir=$val['OD'];
							$pimg=$this->_orderimg[0];
						}
						$val['L']=$this->_orderLink->getTempLink(null,array($this->_order_params[0]=>$porder,$this->_order_params[1]=>$pdir));
					} elseif (is_object($this->_orderLink)) {
						//$pimg=$this->_orderimg[0];
					}
				}
				if ($val['L']) {
					$link_attribs='';
					if (is_array($val['LinkAttribs'])) {
						foreach ($val['LinkAttribs'] as $akey=>$aval) {
							$link_attribs.=' '.$akey.'="'.$aval.'"';
						}
					}
					$this->_t->assign('B_LINK','<a href="'.$val['L'].'"'.$link_attribs.'>');
					$this->_t->assign('E_LINK','</a>');
				} else {
					$this->_t->assign('B_LINK','');
					$this->_t->assign('E_LINK','');
				}
				if ($val['I']) {
					$this->_t->assign('IMAGE',htmlspecialchars($val['I']));
					$this->_t->parse('ROW','table_header_col_img');
				} else {
					$this->_t->clear_dynamic('table_header_col_img');
				}
				if ($val['N']) {
					if (is_object($val['N'])) {
						$this->_t->assign('NAME',$val['N']->process());
					} else {
						if (!$val['NoEnc']) $val['N']=Framework::entities($val['N']);
						if (!$val['NoBr']) $val['N']=nl2br($val['N']);
						$this->_t->assign('NAME',$val['N']);
					}
					$this->_t->parse('ROW','table_header_col_name');
				} else {
					$this->_t->clear_dynamic('table_header_col_name');
				}
				if ($pimg) {
					$this->_t->assign('IMAGE',htmlspecialchars($pimg));
					$this->_t->parse('ROW','table_header_col_order');
				} else {
					$this->_t->clear_dynamic('table_header_col_order');
				}
				$this->_t->parse('ROW','.table_header_col');
				$j++;
			}
			$this->_t->parse('ROW','table_header');
		}
		if (!empty($this->_rows)) {
			if ($this->_addGroupNum && !empty($this->_groupFields)) {
				foreach ($this->_rows as $num=>$col) {
					$str='$grpCount';
					foreach ($this->_groupFields as $fid) {
						if (is_object($col['GroupValues'][$fid])) {
							$str.="['".base64_encode($col['GroupValues'][$fid]->getVal())."']";
						} else {
							$str.="['".base64_encode($col['GroupValues'][$fid])."']";
						}
					}
					$str.='+=1;';
					eval($str);
				}
			}
			$oldRowValues=array();
			foreach ($this->_rows as $num=>$col) {
				$this->_t->clear_dynamic('table_row_col');
				if (!empty($this->_groupFields)) {
					//debug($col['GroupValues']);
					$g_depth=0;$parseGroup=false;$str='$grpCount';
					foreach ($this->_groupFields as $fid) {
						if ($oldRowValues[$fid]!=$col['GroupValues'][$fid]) {
							$parseGroup=true;
						}
						if ($this->_addGroupNum) {
							if (is_object($col['GroupValues'][$fid])) {
								$str.="['".base64_encode($col['GroupValues'][$fid]->getVal())."']";
							} else {
								$str.="['".base64_encode($col['GroupValues'][$fid])."']";
							}
						}
						$oldRowValues[$fid]=$col['GroupValues'][$fid];
						if ($parseGroup) {
							if (!$maxColspan) {
								foreach ($col['col'] as $val) {
									if ($val['S']) {
										$maxColspan+=$val['S'];
									} else {
										$maxColspan+=1;
									}
								}
							}
							$this->_t->assign('B_LINK','');
							$this->_t->assign('E_LINK','');
							for ($k=0;$k<$g_depth;$k++) {
								$this->_t->clear_dynamic('table_row_col_name');
								$this->_t->clear_dynamic('table_row_col_img');
								$this->_t->assign('CLASS','');
								$this->_t->assign('ATTRIBS','width="1%"');
								$this->_t->assign('NAME','&nbsp;');
								$this->_t->parse('ROW','table_row_col_name');
								$this->_t->parse('ROW','.table_row_col');

							}
							$this->_t->clear_dynamic('table_row_col_name');
							$this->_t->clear_dynamic('table_row_col_img');
							$this->_t->assign('CLASS','list_g');
							$this->_t->assign('ATTRIBS','colspan="'.($maxColspan-$g_depth).'"');
							$tmpName=is_object($col['GroupValues'][$fid])?$col['GroupValues'][$fid]->process():trim($col['GroupValues'][$fid]);
							if ($this->_addGroupNum) {
								$tmpName.=' ('.eval('return ApplicationListGui::arrayRecSum('.$str.');').')';
							}
							$this->_t->assign('NAME',trim($tmpName)?$tmpName:'&nbsp;');
							$this->_t->parse('ROW','table_row_col_name');
							/*$this->_t->assign('IMAGE','add_event.gif');
							$this->_t->parse('ROW','table_row_col_img');*/

							$this->_t->parse('ROW','.table_row_col');
							$this->_t->parse('ROW','.table_row');
							$this->_t->clear_dynamic('table_row_col');

						}
						$g_depth++;
					}


					for ($k=0;$k<$g_depth-1;$k++) {
						$this->_t->clear_dynamic('table_row_col_name');
						$this->_t->clear_dynamic('table_row_col_img');
						$this->_t->assign('CLASS','');
						$this->_t->assign('ATTRIBS','width="1%"');
						$this->_t->assign('NAME','&nbsp;');
						$this->_t->parse('ROW','table_row_col_name');
						$this->_t->parse('ROW','.table_row_col');

					}
				}

				if (is_array($col['H'])) {

				} elseif (isset($this->_class[$col['H']])) {
					$this->_t->assign('CLASS',$this->_class[$col['H']]);
				} else {
					$this->_t->assign('CLASS','');
				}
				$jsAutoBg='';
				$jsTras=array(
					'{ROW}'=>$num,
				);
				if ($this->_trOver) {
					$jsAutoBg.=' onmouseover="'.strtr($this->_trOver,$jsTras).'"';
				}
				if ($this->_trOut) {
					$jsAutoBg.=' onmouseout="'.strtr($this->_trOut,$jsTras).'"';
				}
				if ($this->_trClick) {
					$jsAutoBg.=' onclick="'.strtr($this->_trClick,$jsTras).'"';
				}
				if ($this->_trDown) {
					$jsAutoBg.=' onmousedown="'.strtr($this->_trDown,$jsTras).'"';
				}
				if (isset($this->_trClass[$num]) && $this->_trClass[$num]) {
					$jsAutoBg.=' class="'.$this->_trClass[$num].'"';
				}
				$this->_t->assign('JS_AUTO_BG',$jsAutoBg);
				if (is_array($col['col'])) {
					$colHl=0;$j=0;
					foreach ($col['col'] as $ID=>$val) {
						if ($this->_editable && $this->_editGui->isEditField($ID)) {
							 $this->_editGui->processField($col['ID'],$ID,$val);
						}
						$this->_t->assign('ID',isset($val['ID'])?$val['ID']:'');
						$attribs='';
						if (is_array($col['H'])) {
							$colHl=$colHl?0:1;
							if (isset($this->_class[$col['H'][$colHl]])) {
								$this->_t->assign('CLASS',$this->_class[$col['H'][$colHl]]);
							} else {
								$this->_t->assign('CLASS','');
							}
						}
						if (isset($val['W']) && $val['W']) $attribs.=' width="'.$val['W'].'"';
						if (isset($val['S']) && $val['S']) $attribs.=' colspan="'.$val['S'].'"';
						if (isset($val['X']) && $val['X']) $attribs.=' nowrap="nowrap"';
						if (isset($val['A']) && $val['A']) $attribs.=' align="'.$val['A'].'"';
						if (isset($val['V']) && $val['V']) $attribs.=' valign="'.$val['V'].'"';
						elseif(isset($col['V']) && $col['V']) $attribs.=' valign="'.$col['V'].'"';
						if (isset($col['V']) && $col['C']) {
							if (!isset($val['Attribs'])) $val['Attribs']=array('style'=>'');
							$val['Attribs']['style'].='background-color:'.$col['C'].';';
							//$attribs.=' bgcolor="'.$col['C'].'"';
						}
						if (isset($val['Attribs']) && is_array($val['Attribs'])) {
							foreach ($val['Attribs'] as $akey=>$aval) {
								$attribs.=' '.$akey.'="'.$aval.'"';
							}
						}
						$this->_t->assign('ATTRIBS',$attribs);
						if (isset($val['L']) && $val['L']) {
							$link_attribs='';
							if (isset($val['LinkAttribs']) && is_array($val['LinkAttribs'])) {
								foreach ($val['LinkAttribs'] as $akey=>$aval) {
									$link_attribs.=' '.$akey.'="'.$aval.'"';
								}
							}
							if (substr($val['L'],0,1)=='#' && strlen($val['L'])>1) {
								$this->_t->assign('B_LINK','<a name="'.substr($val['L'],1).'"'.$link_attribs.'>');
							} else {
								$this->_t->assign('B_LINK','<a href="'.$val['L'].'"'.$link_attribs.'>');
							}
							$this->_t->assign('E_LINK','</a>');
						} else {
							$this->_t->assign('B_LINK','');
							$this->_t->assign('E_LINK','');
						}
						if (isset($val['I']) && $val['I']) {
							$this->_t->assign('IMAGE',htmlspecialchars($val['I']));
							$this->_t->parse('ROW','table_row_col_img');
						} else {
							$this->_t->clear_dynamic('table_row_col_img');
						}
						if (isset($val['N']) && $val['N']) {
							//debug($val['N']);
							if (is_object($val['N'])) {
								$this->_t->assign('NAME',$val['N']->process());
							} else {
								if (!isset($val['NoEnc']) || !$val['NoEnc']) $val['N']=Framework::entities($val['N']);
								if (!isset($val['NoBr']) || !$val['NoBr']) $val['N']=nl2br($val['N']);
								$this->_t->assign('NAME',$val['N']);
							}
							$this->_t->parse('ROW','table_row_col_name');
						} else {
							$this->_t->clear_dynamic('table_row_col_name');
						}
						if (isset($val['SUB']) && $val['SUB']) {
							if (isset($val['SUB']['C'])) $this->_t->assign('SCLASS',$val['SUB']['C']); else $this->_t->assign('SCLASS','list_sub');
							if (is_object($val['SUB']['N'])) {
								$this->_t->assign('SUB',$val['SUB']['N']->process());
							} else {
								if (!isset($val['SUB']['NoEnc']) || !$val['SUB']['NoEnc']) $val['SUB']['N']=Framework::entities($val['SUB']['N']);
								if (!isset($val['SUB']['NoBr']) || !$val['SUB']['NoBr']) $val['SUB']['N']=nl2br($val['SUB']['N']);
								$this->_t->assign('SUB',$val['SUB']['N']);
							}
							$this->_t->parse('ROW','table_row_col_sub');
						} else {
							$this->_t->clear_dynamic('table_row_col_sub');
						}
						$this->_t->parse('ROW','.table_row_col');
						$j++;

					}
				}
				$this->_t->parse('ROW','.table_row');
			}
		}
		if ($this->_editable && $this->_editGui) {
			$this->_frm->addScript($this->_editGui);
		}
		if ($return) {
			$this->_t->parse('TPL_TEMP',$handle);
			return $this->_t->getParsed();
		}

	}
	function exportXls($title='',$expChar='ISO-8859-1') {
		if (!$title) $title=trim($this->_name);
		require_once("lib/class_WriteExcel.inc.php");
		$tmp_file=tempnam(Framework::getTempPath(),'xls');
		$Excel = new writeexcel_workbook($tmp_file);

		$format=array();
		$format['date']=& $Excel->addformat(array('num_format' => 'dd.mm.YYYY'));
		$format['bold']=& $Excel->addFormat(array('bold' => 1));
		$format['curr']=& $Excel->addFormat(array('num_format' => '##,#0.00'));
		$format['normal']=& $Excel->addFormat(array('bold' => 0));

		$worksheet=& $Excel->addworksheet(Framework::convertCharset($title,GE_CHARSET,$expChar));
		$rowNum=0;$colNum=0;
		foreach ($this->_header as $ID=>$val) {
			if (!isset($this->_xlsFields[$ID])) {
				$this->_xlsFields[$ID]=array('typ'=>'text','hidden'=>false);
			}
			if ($this->_xlsFields[$ID]['hidden']) continue;
			$worksheet->write($rowNum,$colNum,Framework::convertCharset($val['N'],GE_CHARSET,$expChar),$format['bold']);
			$colNum++;
		}
		$rowNum++;
//debug($this->_xlsFields);exit;
		if (!empty($this->_rows)) {
			foreach ($this->_rows as $col) {
				$colNum=0;
				foreach ($col['col'] as $ID=>$val) {
					if ($this->_xlsFields[$ID]['hidden']) continue;
					switch ($this->_xlsFields[$ID]['Typ']) {
						case 'date':
							if ($val['N']!='0000-00-00') {
								$xlsDate=$Excel->xl_date_list(Framework::dateSql('Y',$val['N']), Framework::dateSql('m',$val['N']),Framework::dateSql('d',$val['N']));
								$worksheet->write($rowNum,$colNum,$xlsDate, $format['date']);
							}
						break;
						case 'curr':
							$worksheet->write($rowNum,$colNum,(float)$val['N'],$format['curr']);
						break;
						case 'num':
							$worksheet->write($rowNum,$colNum,(float)$val['N'],$format['normal']);
						break;
						default:
							$worksheet->write($rowNum,$colNum,Framework::convertCharset($val['N'],GE_CHARSET,$expChar,$format['normal']));
						break;
					}
					$colNum++;
				}
				$rowNum++;
			}
		}
		$Excel->close();
		Framework::dumpFile($tmp_file,$title.'.xls','application/x-msexcel',true);
		exit;
	}
	function arrayRecSum(&$sumArray) {
		$result=0;
		if (is_array($sumArray)) {
			foreach($sumArray as $val) {
				$result+=ApplicationListGui::arrayRecSum($val);
			}
		} else {
			$result=$sumArray;
		}
		return $result;
	}
}
?>