<?php
class ApplicationTreeGui {
	var $_T;
	var $_t;
	var $_tpl='core/common_application_tree.inc.html';
	var $_width=250;
	function ApplicationTreeGui() {
		global $T;
		$this->_T=&$T;
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);;
	}
	function addTreeContent(&$obj,$params= null,$label= null,$ID=null) {
		if ($params && !is_array($params)) {
			$params=array($params);
		}
		$this->_tree_content[]=array(
			'Content'=>&$obj,
			'Params'=>$params,
			'Label'=>$label,
			'ID'=>$ID,
		);
		return count($this->_tree_content)-1;
	}
	function addContent(&$obj,$params= null,$label= null,$ID=null) {
		if ($params && !is_array($params)) {
			$params=array($params);
		}
		$this->_content[]=array(
			'Content'=>&$obj,
			'Params'=>$params,
			'Label'=>$label,
			'ID'=>$ID,
		);
		return count($this->_content)-1;
	}
	function addContentText($text,$ID=null) {
		$this->_content[]=array(
			'Content'=>$text,
			'ID'=>$ID,
		);
	}
	function setTreeWidth($value) {
		$this->_width=$value;
	}
	function processContent() {
		$this->_t->assign('TREE_WIDTH',$this->_width);
		if (is_array($this->_tree_content)) {
			foreach ($this->_tree_content as $val) {
				if ($val['Label']) {
					$this->_t->assign('LABEL',Framework::entities($val['Label']));
					$this->_t->parse('ROW','tree_content_label');
				} else {
					$this->_t->clear_dynamic('tree_content_label');
				}
				if ($val['ID']) {
					$this->_t->assign('ID',$val['ID']);
				} else {
					$this->_t->assign('ID','');
				}
				$this->_t->assign('CONTENT',call_user_func_array(array(&$val['Content'],'process'),is_array($val['Params'])?$val['Params']:array()));
				$this->_t->parse('ROW','.tree_content');
			}
		}
		if (is_array($this->_content)) {
			foreach ($this->_content as $val) {
				if ($val['Label']) {
					$this->_t->assign('LABEL',Framework::entities($val['Label']));
					$this->_t->parse('ROW','content_label');
				} else {
					$this->_t->clear_dynamic('content_label');
				}
				if ($val['ID']) {
					$this->_t->assign('ID',$val['ID']);
				} else {
					$this->_t->assign('ID','');
				}
				if (is_object($val['Content'])) {
					$this->_t->assign('CONTENT',call_user_func_array(array(&$val['Content'],'process'),is_array($val['Params'])?$val['Params']:array()));
				} else {
					$this->_t->assign('CONTENT',$val['Content']);
				}
				$this->_t->parse('ROW','.content');
				$this->_t->parse('ROW','content_sep');

			}
		}
	}
	function process($handle='') {
		if (!$handle) {
			$handle='application_tree_content';
			$return=true;
		} else {
			$return=false;
		}
		$this->_t->setRoot('tpl/'.APP_THEME);
		$this->_t->define (array($handle => $this->_tpl));
		$this->processContent();
		if ($return) {
			$this->_t->parse('TPL_TEMP',$handle);
			return $this->_t->getParsed();
		}
	}
}
?>