<?php
class BoxGui {
	var $_T;
	var $_t;
	var $_tpl='core/common_content_box.inc.html';
	var $_tabs=array();
	var $_JsCallback=array(
			'Mode'=>'ajax',
			'Param'=>'changeBox',
		);
	var $_bdColor='#000';
	function BoxGui($ID='box',$tpl='') {
		global $T;
		$this->_T=&$T;
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
		$this->_ID=$ID;
		if ($tpl) $this->_tpl=$tpl;
	}
	function addTab($ID,$Name,$Link='',$On=false) {
		$this->_tabs[$ID]=array(
			'Name'=>$Name,
			'Link'=>$Link,
		);
		if ($On) $this->_tabOn=$ID;
	}
	function setTabContent($ID,&$Content,$Params= null) {
		$this->_tabs[$ID]['Content']=&$Content;
		$this->_tabs[$ID]['Params']=$Params;
	}
	function setTabOn($ID) {
		if ($ID && isset($this->_tabs[$ID])) {
			$this->_tabOn=$ID;
		} else {
			reset($this->_tabs);
			$this->_tabOn=key($this->_tabs);
		}
	}
	function issetTab($ID) {
		return (isset($this->_tabs[$ID]));
	}
	function setCallbackOnChange($callback,$params = null) {
		$this->_Callback=array(
			'Callback'=>&$callback,
			'Params'=>is_array($params)?$params:array(),
		);
	}
	function setJsCallback($mode,$param) {
		$this->_JsCallback=array(
			'Mode'=>$mode,
			'Param'=>$param,
		);
	}
	function setBorderColor($val) {
		$this->_bdColor=$val;
	}
	function _handleRequest() {
		foreach (array_keys($this->_tabs) as $ID) {
			if (Framework::getParam('box_'.$ID,0,'P')) {
				$this->_tabOn=$ID;
				if ($this->_Callback) {
					$this->_Callback['Params'][]=$ID;
     				 call_user_func_array($this->_Callback['Callback'],is_array($this->_Callback['Params'])?$this->_Callback['Params']:array());
				}
			}
		}
	}

	function process($handle='') {
		if (!$handle) {
			$handle='content_box';
			$return=true;
		} else {
			$return=false;
		}
		$this->_handleRequest();
		$this->_t->setRoot('tpl/'.APP_THEME);
		$this->_t->define (array($handle => $this->_tpl));
		$this->_t->clear_dynamic('content_box_tab');
		$this->_t->clear_dynamic('content_box_tab_content');
		$this->_t->assign('ALL_IDS',implode(',',array_keys($this->_tabs)));
		$this->_t->assign('BOX_ID',$this->_ID);
		$this->_t->assign('BDCOLOR',$this->_bdColor);
		$this->_t->assign('CALL_MODE',$this->_JsCallback['Mode']);
		$this->_t->assign('CALL_BACK',$this->_JsCallback['Param']);
		if (!isset($this->_tabs[$this->_tabOn])) $this->_tabOn=key($this->_tabs);
		foreach ($this->_tabs as $key=>$tab) {
			$this->_t->assign('ID',$key);
			$this->_t->assign('NAME',Framework::entities($tab['Name']));
			if ($this->_tabOn==$key) {
				$this->_t->assign('CLASS','cont_tab_on');
			} else {
				$this->_t->assign('CLASS','cont_tab');
			}
			$this->_t->parse('ROW','.content_box_tab');
			if (is_object($tab['Content'])) {
				$this->_t->assign('CONTENT',call_user_func_array(array(&$tab['Content'],'process'),is_array($tab['Params'])?$tab['Params']:array()));
			} else {
				$this->_t->assign('CONTENT',$tab['Content']);
			}
			if ($this->_tabOn==$key) {
				$this->_t->assign('CLASS','cont_tab_on');
			} else {
				$this->_t->assign('CLASS','cont_tab');
			}
			$this->_t->parse('ROW','.content_box_tab_content');
		}
		if ($return) {
			$this->_t->parse('TPL_TEMP',$handle);
			return $this->_t->getParsed();
		}
	}
}
?>