<?php
class ColorPickerGui {
	private $_T;
	private $_t;
	private $_tpl='core/common_colorpicker.inc.html';
	private $_colors=array(
		'transparent',
		'#000',
	);
	private $_callback='0';
	function __construct() {
		global $T;
		$this->_T=&$T;
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
	}
	function setColors($colors) {
		$this->_colors=$colors;
	}
	function setCallback($val) {
		$this->_callback=$val;
	}
	function processContent() {
		$this->_t->assign('PICKER_CALLBACK',$this->_callback);
		$i=0;
		foreach ($this->_colors as $key=>$val) {
			$this->_t->assign('V_COLOR',$val);
			$this->_t->parse('ROW','.cpicker_color_col');
			$i++;
			if ($i>5) {
				$this->_t->parse('ROW','.cpicker_color_row');
				$this->_t->clear_dynamic('cpicker_color_col');
				$i=0;
			}
		}
		if ($i>0) $this->_t->parse('ROW','.cpicker_color_row');
	}
	function process($handle='') {
		if (!$handle) {
			$handle='application_content';
			$return=true;
		} else {
			$return=false;
		}
		$this->_t->setRoot('tpl/'.APP_THEME);
		$this->_t->define (array($handle => $this->_tpl));
		$this->processContent();
		if ($return) {
			$this->_t->parse('TPL_TEMP',$handle);
			return $this->_t->getParsed();
		}
	}
}
?>