<?php
class DateSelectForm {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	var $_defMode=1;
	var $_avModes=array(1,2,3,4);
	var $_modTitle=array(
		1=>'[[Monat]]',
		2=>'[[Quartal]]',
		3=>'[[Datum]]',
		4=>'[[Alle]]',
		5=>'[[Jahr]]',
		6=>'[[Woche]]',
		7=>'[[Tag]]',
		8=>'[[ZeitvorlageShort]]',
	);
	var $_monthsStart=0;
	var $_monthsNum=12;
	var $_monthsDir=0;
	var $_quarterStart=0;
	var $_quarterNum=5;
	var $_yearsStart=0;
	var $_yearsNum=5;
	var $_weeksStart=0;
	var $_weeksNum=30;
	var $_weeksDir=0;


	function DateSelectForm($id='dsel',$title='') {
		global $frm,$t,$T,$E,$L,$P,$Y;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_id=$id;
		$this->_title=$title;
		require_once('lib/class_FormGui.php');
		$this->_Gui=new FormGui('core/form_date_select.inc.html');
		$this->_Gui->setFieldClass('ipts','ipts');
		$this->_date=array(
			0=>mktime(0,0,0,date('m'),1),
			1=>mktime(23,59,59,date('m'),date('t')),
		);
		//$this->_Gui->setTreeWidth(200);
	}
	function setDate($val) {
		$this->_date=$val;
	}
	function getDate($key='') {
		switch($key) {
			case 'B':
				return $this->_date[0];
			break;
			case 'E':
				return $this->_date[1];
			break;
			default:
				return $this->_date;
			break;
		}
	}
	function setMode($val) {
		$this->_defMode=$val;
	}
	function getMode() {
		return Framework::getParam($this->_id.'DateMode',$this->_defMode,'P');
	}
	function setAvMode($val) {
		$this->_avModes=$val;
	}
	function setStartMonths($val) {
		$this->_monthsStart=$val;
	}
	function setNumMonths($val) {
		$this->_monthsNum=$val;
	}
	function setDirMonths($val) {
		$this->_monthsDir=$val;
	}
	function setStartWeeks($val) {
		$this->_weeksStart=$val;
	}
	function setNumWeeks($val) {
		$this->_weeksNum=$val;
	}
	function setDirWeeks($val) {
		$this->_weeksDir=$val;
	}
	function setStartQuarter($val) {
		$this->_quarterStart=$val;
	}
	function setNumQuarter($val) {
		$this->_quarterNum=$val;
	}
	function _handleRequest() {
		if (Framework::getParam($this->_id.'DateMode',0,'P')) {
			switch (Framework::getParam($this->_id.'DateMode',0,'P')) {
				case 1:
					$tmp=explode('-',Framework::getParam($this->_id.'DateMonth','','P'));
					$this->_date[0]=mktime(0,0,0,$tmp[1],1,$tmp[0]);
					$this->_date[1]=mktime(23,59,59,$tmp[1],date('t',$this->_date[0]),$tmp[0]);
				break;
				case 2:
					$tmp=explode('-',Framework::getParam($this->_id.'DateQuarter','','P'));
					$this->_date[0]=mktime(0,0,0,$tmp[1]*3-2,1,$tmp[0]);
					$this->_date[1]=mktime(23,59,59,$tmp[1]*3,date('t',mktime(0,0,0,$tmp[1]*3,1,$tmp[0])),$tmp[0]);
				break;
				case 3:
					$tmp=Framework::parseDate(Framework::getParam($this->_id.'DateDateB','','P'),0,0,0);
					if ($tmp) $this->_date[0]=$tmp;
					$tmp=Framework::parseDate(Framework::getParam($this->_id.'DateDateE','','P'),23,59,59);
					if ($tmp) $this->_date[1]=$tmp;
				break;
				case 4:
					$this->_date[0]=0;
					$this->_date[1]=0;
				break;
				case 5:
					$tmp=Framework::getParam($this->_id.'DateYear','','P');
					$this->_date[0]=mktime(0,0,0,1,1,$tmp);
					$this->_date[1]=mktime(23,59,59,12,31,$tmp);
				break;
				case 6:
					$tmp=explode('-',Framework::getParam($this->_id.'DateWeek','','P'));
					$wDay=date('w',mktime(0,0,0,1,1,$tmp[0]));
					if ($wDay==0) $wDay=7;
					if ($wDay==1) $wDay=8;

					$this->_date[0]=mktime(0,0,0,1,($tmp[1]-1)*7+9-$wDay,$tmp[0]);
					$this->_date[1]=mktime(23,59,59,1,($tmp[1]-1)*7+9-$wDay+6,$tmp[0]);
				break;
				case 7:
					$tmp=Framework::parseDate(Framework::getParam($this->_id.'DateDay','','P'),0,0,0);
					if ($tmp) {
						$this->_date[0]=$tmp;
						$this->_date[1]=$tmp;
					}
				break;
				case 8:
					$calTime=$this->_frm->getStaticModul('cal_time');
					if ($tObj=$calTime->getObj(Framework::getParam($this->_id.'DateTimeId',0,'P'))) {
						$timeSettings=unserialize($tObj->getMeta('calTimeSettings'));
						switch($timeSettings['type']) {
							case 'abs':
								$this->_date[0]=$timeSettings['starttime'];
								$this->_date[1]=$timeSettings['endtime'];
							break;
						}
					}
				break;

			}
			$this->_defMode=Framework::getParam($this->_id.'DateMode',0,'P');
		}
		$this->_defMonth=$this->_date[0]?date('Y-m',$this->_date[0]):date('Y-m');
		$this->_defQuarter=$this->_date[0]?(date('Y',$this->_date[0]).'-'.ceil(date('n',$this->_date[0])/3)):(date('Y').'-'.ceil(date('n')/3));
		$this->_defYear=$this->_date[0]?date('Y',$this->_date[0]):date('Y');
		$this->_defWeek=$this->_date[0]?date('Y-W',$this->_date[0]):date('Y-W');
		$this->_defDate=$this->_date;
		$this->processSelectForm();
		//$this->_Gui->addContent($wGui,null,null);
		//$this->parseJsDrop();
	}
	function &process() {
		$this->_handleRequest();
		return $this->_Gui;
	}
	function &processSelectForm() {
		$selectModes=array();
		$selectTimesId=array();
		foreach ($this->_avModes as $val) {
			switch ($val) {
				case 8:
					$calTime=$this->_frm->getStaticModul('cal_time');
					$tmp=$calTime->listObj();
					if (!empty($tmp)) {
						$selectTimesId=Framework::extractObjName($tmp);
						$selectModes[$val]=$this->_T->lang($this->_modTitle[$val]);
					}
				break;
				default:
					$selectModes[$val]=$this->_T->lang($this->_modTitle[$val]);
				break;



			}

		}

		$attribs=array(
			'onchange'=>$this->_id.'Change(this);',
			'onclick'=>$this->_id.'Change(this);',
			'style'=>'margin-right:0;margin-left:0;',
		);
		$key=$this->_id."DateMode";
		if (count($selectModes)>1) {
			$this->_Gui->addField($key,'radiolist_h',$this->_title,$this->_defMode,'fields1');
			$this->_Gui->setValues($key,$selectModes);
			$this->_Gui->setAttribs($key,$attribs);
		} else {
			$this->_Gui->addField($key,'hidden',$this->_title,$this->_defMode,'fields1');
		}

		$selectMonths=array();
		if ($this->_monthsDir) {
			for($i=date('n')+$this->_monthsStart;$i<date('n')+$this->_monthsStart+$this->_monthsNum;$i++) {
				$time=mktime(0,0,0,$i,1);
				$selectMonths[date('Y-m',$time)]=strftime('%Y / %B',$time);
			}
		} else {
			for($i=date('n')+$this->_monthsStart;$i>date('n')+$this->_monthsStart-$this->_monthsNum;$i--) {
				$time=mktime(0,0,0,$i,1);
				$selectMonths[date('Y-m',$time)]=strftime('%Y / %B',$time);
			}
		}
		$key=$this->_id."DateMonth";
		$this->_Gui->addField($key,'select','',$this->_defMonth,'fields_m');
		$this->_Gui->setValues($key,$selectMonths);


		$selectWeeks=array();
		$start=mktime(12,0,0);
		$wDay=date('w',$start);
		if ($wDay==0) $wDay=7;
		$start=$start-($wDay-1)*3600*24+3600*24*7*$this->_weeksStart;
		//debug(date('d.m.Y',$start));
		if ($this->_weeksDir) {
			for($i=$start;$i<$start+$this->_weeksNum*3600*24*7;$i+=3600*24*7) {
				$selectWeeks[date('Y-W',$i)]=strftime('%Y / %W',$i);
			}
		} else {
			for($i=$start;$i>$start-$this->_weeksNum*3600*24*7;$i-=3600*24*7) {
				$selectWeeks[date('Y-W',$i)]=strftime('%Y / %W',$i);
			}
		}
		$key=$this->_id."DateWeek";
		$this->_Gui->addField($key,'select','',$this->_defWeek,'fields_w');
		$this->_Gui->setValues($key,$selectWeeks);



		$selectQuarter=array();
		for ($i=ceil(date('n')/3)+$this->_quarterStart;$i>ceil(date('n')/3)+$this->_quarterStart-$this->_quarterNum;$i--) {
			$time=mktime(0,0,0,$i*3,1);
			$selectQuarter[date('Y',$time).'-'.ceil(date('n',$time)/3)]=ceil(date('n',$time)/3).' / '.date('Y',$time);
		}
		$key=$this->_id."DateQuarter";
		$this->_Gui->addField($key,'select','',$this->_defQuarter,'fields_q');
		$this->_Gui->setValues($key,$selectQuarter);

		$selectYears=array();
		for($i=date('Y')+$this->_yearsStart;$i>date('Y')+$this->_yearsStart-$this->_yearsNum;$i--) {
			$selectYears[$i]=$i;
		}
		$key=$this->_id."DateYear";
		$this->_Gui->addField($key,'select','',$this->_defYear,'fields_y');
		$this->_Gui->setValues($key,$selectYears);

		$key=$this->_id."DateDay";
		$this->_Gui->addField($key,'unixdate','',$this->_defDate[0],'fields_d');

		$attribs=array(
			'style'=>'width:80px;',
		);
		$key=$this->_id."DateDateB";
		$this->_Gui->addField($key,'unixdate','',$this->_defDate[0],'fields_d_b');
		$this->_Gui->setAttribs($key,$attribs);
		$key=$this->_id."DateDateE";
		$this->_Gui->addField($key,'unixdate','',$this->_defDate[1],'fields_d_e');
		$this->_Gui->setAttribs($key,$attribs);


		$key=$this->_id."DateTimeId";
		$this->_Gui->addField($key,'select','',0,'fields_t');
		$this->_Gui->setValues($key,$selectTimesId);


		$this->_Gui->addCustumTplValue('ID',$this->_id);
		$this->_Gui->addCustumTplValue('DISP_MODE_1','none');
		$this->_Gui->addCustumTplValue('DISP_MODE_2','none');
		$this->_Gui->addCustumTplValue('DISP_MODE_3','none');
		$this->_Gui->addCustumTplValue('DISP_MODE_4','none');
		$this->_Gui->addCustumTplValue('DISP_MODE_5','none');
		$this->_Gui->addCustumTplValue('DISP_MODE_6','none');
		$this->_Gui->addCustumTplValue('DISP_MODE_7','none');
		$this->_Gui->addCustumTplValue('DISP_MODE_8','none');
		$this->_Gui->addCustumTplValue('DISP_MODE_'.$this->_Gui->getFieldVal($this->_id.'DateMode',1),'block');

		$this->_Gui->clearFields();
	}

}
?>