<?php
class GlobLinkObj {
	var $_params=array();
	var $_base='index.php';
	function GlobLinkObj() {


	}
	function init($base='index.php') {
		$this->_base=$base;
		foreach ($_GET as $key=>$val) {
			if ($key[0]!='_' && $key[0]!='go_b') {
				$this->_params[$key]=$val;
			}
		}
	}
	function setBase($base) {
		$this->_base=$base;
	}
	function getBase() {
		return $this->_base;
	}
	function clearParams($params=array(),$exclude=array('site')) {
		if (is_array($exclude)) {
			foreach($exclude as $val) {
				$params[$val]=$this->_params[$val];
			}
		}
		$this->_params=$params;
	}
	function setParam() {
		if (func_num_args()==2) {
			$this->_params[func_get_arg(0)]=func_get_arg(1);
		} elseif (is_array(func_get_arg(0))) {
			foreach (func_get_arg(0) as $key=>$val) {
				$this->_params[$key]=$val;
			}
		}
	}
	function getParam($key='',$def=null) {
		if ($key) {
			return isset($this->_params[$key])?$this->_params[$key]:$def;
		} else {
			return $this->_params;
		}
	}
	function unsetParam($key) {
		if (is_array($key)) {
			foreach ($key as $val) {
				unset($this->_params[$val]);
			}
		} else {
			unset($this->_params[$key]);
		}
	}
	function getLink() {
		$result=$this->_base;
		$sep='?';
		foreach ($this->_params as $key=>$val) {
			$result.=$sep.$this->_parseVal($key,$val);
			$sep='&';
		}
		return $result;
	}
	function getTempLink($delete = null ,$add = null ) {
		$result=$this->_base;
		$sep='?';
		foreach ($this->_params as $key=>$val) {
			if (is_array($delete) && in_array($key,$delete)) continue;
			if (is_array($add) && isset($add[$key])) {
				$val=$add[$key];
				unset($add[$key]);
			}
			$result.=$sep.$this->_parseVal($key,$val);
			$sep='&';
		}
		if (is_array($add)) {
			foreach ($add as $key=>$val) {
				$result.=$sep.$this->_parseVal($key,$val);
				$sep='&';
			}
		}
		return $result;
	}
	function goToLink() {
		page_close();
		header('Location:'.$this->getLink());
		exit;
	}
	function _parseVal($key,$val) {
		$result='';
		if (is_array($val)) {
			$sep='';
			foreach ($val as $sub_key=>$sub_val) {
				$result.=$sep.$key.'['.$sub_key.']='.urlencode($sub_val);
				$sep='&';
			}
		} else {
			$result.=$key.'='.urlencode($val);
		}
		return $result;
	}
}
?>