<?php
class JsPrintGui {
	var $_T;
	var $_t;
	var $_tpl_function='core/common_js_print.inc.html';
	var $_defaultConfig=array(
		'orientation'=>0,
		'marginTop'=>20,
		'marginBottom'=>20,
		'marginLeft'=>20,
		'marginRight'=>20,
		'headerStrLeft'=>'',
		'headerStrCenter'=>'&T',
		'headerStrRight'=>'',
		'footerStrLeft'=>'',
		'footerStrCenter'=>'',
		'footerStrRight'=>'',
		'printBGColors'=>1,
		'printBGImages'=>1,
		'shrinkToFit'=>1,
		'shrinkToFit'=>1,
	);
	var $_autoprint=false;

	function JsPrintGui($options=null) {
		global $T;
		$this->_T=&$T;
		$this->_defaultConfig['footerStrCenter']=$this->_T->lang('[[Seite]]').' &PT';
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
		if (is_array($options)) {
			$this->setOptions($options);
		}
	}
	function setAutprint($val) {
		$this->_autoprint=$val;
	}
	function setOption($key,$val) {
		$this->_defaultConfig[$key]=$val;
	}
	function setOptions($values) {
		foreach ($values as $key=>$val) {
			$this->setOption($key,$val);
		}
	}
	function process($handle='') {
		if (!$handle) {
			$handle='js_print';
			$return=true;
		} else {
			$return=false;
		}
		$this->_t->define (array($handle => $this->_tpl_function));
		foreach ($this->_defaultConfig as $key=>$val) {
			$this->_t->assign('OP_KEY',$key);
			switch ($key) {
				case 'orientation':
					if ($val) {
						$jsVal='jsPrintSetup.kLandscapeOrientation';
					} else {
						$jsVal='jsPrintSetup.kPortraitOrientation';
					}
				break;
				case 'marginTop':
				case 'marginBottom':
				case 'marginLeft':
				case 'marginRight':
				case 'printBGColors':
				case 'printBGImages':
				case 'shrinkToFit':
					$jsVal=intval($val);
				break;
				default:
					$jsVal="'".Framework::escapeJs($val)."'";
				break;
			}
			$this->_t->assign('OP_VAL',$jsVal);
			$this->_t->parse('ROW','.options');
		}
		if ($this->_autoprint) {
			$this->_t->parse('ROW','autoprint');
		}
		if ($return) {
			$this->_t->parse('TPL_TEMP',$handle);
			return $this->_t->getParsed();
		}
	}
}
?>