<?php
class LayerGui {
	var $_T;
	var $_t;
	var $_tpl='core/common_layer.inc.html';
	var $_width='250px';
	function LayerGui($tpl='') {
		global $T;
		$this->_T=&$T;
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
		if ($tpl) $this->_tpl=$tpl;
	}
	function addLayer($ID,$content,$typ='array',$width=0,$title='') {
		$this->_layers[$ID]=array(
			'Content'=>$content,
			'Typ'=>$typ,
			'Width'=>$width,
			'Title'=>$title,
		);
	}
	function issetLayers() {
		if (is_array($this->_layers) && !empty ($this->_layers)) {
			return true;
		} else {
			return false;
		}
	}
	function setWidth($val) {
		$this->_width=$val;
	}
	function getFunctionOn($ID) {
		return "show(event, '".$ID."'); return true;";
	}
	function getFunctionOff($ID) {
		return "hide('".$ID."'); return true;";
	}
	function processContent() {
		if (is_array($this->_layers)) {
			foreach (array_keys($this->_layers) as $key) {
				$this->parseLayer($key);
			}
		}
	}
	function getSingleContent($key) {
		$this->_t->setRoot('tpl/'.APP_THEME);
		$this->_t->define (array('application_content' => $this->_tpl));
		return $this->parseLayer($key,true);
	}
	function parseLayer($key,$returnCont=false) {
		$result='';
		if (isset($this->_layers[$key])) {
			$val=$this->_layers[$key];
			$this->_t->assign('ID',$key);
			$this->_t->assign('WIDTH',$val['Width']?$val['Width']:$this->_width);
			if ($val['Title']) {
				$this->_t->assign('TITLE',$val['Title']);
				$this->_t->parse('ROW','top_title');
				if ($returnCont) $result.=$this->_t->getParsed();
			}
			$parse_cont=false;
			switch ($val['Typ']) {
				case 'array':
					foreach ($val['Content'] as $ckey=>$cval) {
						if (is_object($ckey)) {
							$this->_t->assign('TITLE',$ckey->process());
						} else {
							$this->_t->assign('TITLE',$ckey);
						}
						if (is_object($cval)) {
							$this->_t->assign('CONTENT',$cval->process());
						} else {
							$this->_t->assign('CONTENT',$cval);
						}
						$this->_t->parse('ROW','.layer_row');
						$parse_cont=true;
					}
				break;
				case 'text':
					$this->_t->assign('CONTENT','');
					$this->_t->assign('TITLE','');
					if (is_object($val['Content'])) {
						$this->_t->assign('TITLE',$val['Content']->process());
					} else {
						$this->_t->assign('TITLE',$val['Content']);
					}
					$this->_t->parse('ROW','.layer_row');
					$parse_cont=true;
				break;
			}
			if ($parse_cont) {
				$this->_t->parse('ROW','content');
				if ($returnCont) $result.=$this->_t->getParsed();
			}
			$this->_t->parse('ROW','.layer');
			$this->_t->clear_dynamic('layer_row');
			$this->_t->clear_dynamic('top_title');
			$this->_t->clear_dynamic('content');
		}
		return $result;
	}
	function process($handle='') {
		if (!$handle) {
			$handle='application_content';
			$return=true;
		} else {
			$return=false;
		}
		$this->_t->setRoot('tpl/'.APP_THEME);
		$this->_t->define (array($handle => $this->_tpl));
		$this->processContent();
		if ($return) {
			$this->_t->parse('TPL_TEMP',$handle);
			return $this->_t->getParsed();
		}
	}
}
?>