<?php
class ObjAjaxTreeGui {
	var $_tpl='core/common_ajax_tree.inc.html';
	var $_use_tpl=0;
	var $_class=array('it_n','it_s');
	var $_func_entity=array('Framework','entities');
	var	$_maxlen=30;
	var $_minlen=5;
	var $_js_prepend='';
	var	$_img_split='tree_split.gif';
	var	$_img_split_ex='tree_split_ex.gif';
	var	$_img_split_co='tree_split_co.gif';
	var	$_img_end='tree_end.gif';
	var	$_img_end_ex='tree_end_ex.gif';
	var	$_img_end_co='tree_end_co.gif';
	var	$_img_line='tree_vertline.gif';
	var $_encodeID=false;
	var $_metaID='';
	var $_extraParams='';
	var $_jsID=array();
	var $_noDLink=false;
	function ObjAjaxTreeGui($use_tpl=0,$tpl='') {
		$this->_use_tpl=$use_tpl;
		if ($tpl) $this->_tpl=$tpl;
	}
	function setSplitImages($img_split,$img_split_ex,$img_split_co) {
		$this->_img_split=$img_split;
		$this->_img_split_ex=$img_split_ex;
		$this->_img_split_co=$img_split_co;
	}
	function setEndImages($img_end,$img_end_ex,$img_end_co) {
		$this->_img_end=$img_end;
		$this->_img_end_ex=$img_end_ex;
		$this->_img_end_co=$img_end_co;
	}
	function setJsPrepend($prep) {
		$this->_js_prepend=$prep;
	}
	function setLineImages($img_line) {
		$this->_img_line=$img_line;
	}
	function setExpand(&$expand) {
		$this->_expand=&$expand;
	}
	function setAllExpand($mode=0) {
		$this->_all_expand=$mode;
	}
	function setExLink($ex_link) {
		$this->_ex_link=$ex_link;
	}
	function setAcLink($ac_link) {
		$this->_ac_link=$ac_link;
	}
	function setOpenCloseLink($oc_link) {
		$this->_oc_link=$oc_link;
	}
	function setImgPath($img_path) {
		$this->_img_path=$img_path;
	}
	function setColors($bgcolor,$fg10color) {
		$this->_bgcolor=$bgcolor;
		$this->_fgcolor=$fgcolor;
	}
	function setClass($class,$class_sel) {
		$this->_class[0]=$class;
		$this->_class[1]=$class_sel;
	}
	function setSelectedID($oid) {
		$this->_oid=$oid;
	}
	function getSelectedID() {
		return $this->_oid;
	}
	function setRootObj(&$obj) {
		$this->_rootObj=&$obj;
	}
	function setRootID($root_id) {
		$this->_root_id=$root_id;
	}
	function setModul($modul) {
		$this->_modul=$modul;
	}
	function setEntityFunc($func) {
		$this->_func_entity=$func;
	}
	function setNameFunc($func) {
		$this->_func_name=$func;
	}
	function setMaxLen($len) {
		$this->_maxlen=$len;
	}
	function setNoDlink($val) {
		$this->_noDLink=$val;
	}
	function setCallback($callback,$params=null) {
		$this->_callback=&$callback;
		$this->_callback_params=$params;
	}
	function setCallbackLen($callback,$params=null) {
		$this->_callback_len=&$callback;
		$this->_callback_params_len=$params;
	}
	function setLinkAttribs($attribs) {
		$this->_linkAttribs=$attribs;
	}
	function setRowObject(&$obj) {
		$this->_objRight=&$obj;
	}
	function setEncodeID($yes=true) {
		$this->_encodeID=$yes;
	}
	function setObjID($field) {
		$this->_metaID=$field;
	}
	function setExtraParams($params) {
		$this->_extraParams=$params;
	}
	function processObj(&$obj,$len,$i,$depth=0) {
		if ($this->_metaID) {
			$ID=$obj->getMeta($this->_metaID);
		} else {
			$ID=$obj->getID();
		}
		$jsID=$this->encodeID($ID);
		$this->_jsId[]='l:'.$jsID;
		if ($this->_func_name) {
			$Title=call_user_func($this->_func_name,$obj);//$this->_func_entity;
		} else {
			$Title=$obj->getName();
		}
		$tTitle=$Title;
		$dplen=$this->_maxlen - $depth*2;
		if ($dplen<$this->_minlen) $dplen=$this->_minlen;
		if ($this->_maxlen) {
			$Title=Framework::wordSplit($Title,$dplen);
		}
		if ($this->_func_entity) {
			$Title=call_user_func($this->_func_entity,$Title);//$this->_func_entity;
		}
		if ($obj->isFolder()) {
			if (isset($this->_expand[$ID]) || $this->_all_expand) {
				if (!isset($this->len[$ID])) {
					$this->_callback_params['ParentID']=$ID;
					$this->entries[$ID]=call_user_func($this->_callback,$this->_callback_params);
					if ($this->entries[$ID] && !empty($this->entries[$ID])) {
						$this->len[$ID]=count($this->entries[$ID]);
					}
					//$this->_callback_params_len['ParentID']=$ID;
					//$this->len[$ID]=call_user_func($this->_callback_len,$this->_callback_params_len);
				}
				if ($this->len[$ID]) {
					if ($len==$i) $img=$this->_img_end_co; else $img=$this->_img_split_co;
				} else {
					if ($len==$i) $img=$this->_img_end; else $img=$this->_img_split;
				}
			} else {
				if ($len==$i) $img=$this->_img_end_ex; else $img=$this->_img_split_ex;
			}

		} else {
			if ($len==$i) {
				$img=$this->_img_end;
			} else {
				$img=$this->_img_split;
			}
		}
		if ($ID==$this->_oid) {
			$class=$this->_class[1];
		} else {
			$class=$this->_class[0];
		}
		//echo $class.'<br>';
		//unset ($img[0]);
		if (is_array($this->_ac_link)) {
			$link=call_user_func($this->_ac_link,$obj,0);//$this->_func_entity;
		} else {
			$link=str_replace('{ACTION}',$obj->getAction(0),$this->_ac_link);
			$link=str_replace('{OID}',urlencode($ID),$link);
		}
		$link_d="";
		if (!$this->_noDLink) {
			if (is_array($this->_ac_link)) {
				$link_d=call_user_func($this->_ac_link,$obj,1);//$this->_func_entity;
			} elseif ($obj->getACL(2)) {
				$link_d=str_replace('{ACTION}',$obj->getAction(1),$this->_ac_link);
				$link_d=str_replace('{OID}',urlencode($ID),$link_d);
			}
		}
		if ($class!=$this->_class[1]) {
			$js_fc="id=\"l:$jsID\" nC=\"$class\" oC=\"".$this->_class[1]."\" onmouseover=\"setClass('l:$jsID', 'over');\" onmouseout=\"setClass('l:$jsID', 'out');\" ";
		} else {
			$js_fc="id=\"l:$jsID\"";
		}
		$chkdiv="";
		if (is_object($this->_objRight)) {
			$chkdiv="<div class=\"$class\" align=\"right\">".$this->_objRight->process($jsID)."</div>";
		}


		$linkAttribs=array('title'=>htmlspecialchars(strip_tags($tTitle)));
		if (is_array($this->_linkAttribs)) {
			$tras_array=array(
				'{OID}'=>$jsID,
				'{ACTION}'=>$obj->getAction(0),
			);
			foreach ($this->_linkAttribs as $key=>$val) {
				$linkAttribs[$key]=strtr($val,$tras_array);
			}
		}
		$nav="<tr>\n";
		$nav.="<td width=\"14\" valign=\"top\"";
		if ($obj->isFolder()) {
			if ($len==$i) {
				$nav.=">";
			} else {
				$nav.=" background=\"".$this->_img_path.'/'.$this->_img_line."\">";
			}
			if (is_array($this->_ex_link)) {
				$link_ex=call_user_func($this->_ex_link,$obj,2);//$this->_func_entity;
			} else {
				$link_ex=str_replace('{OID}',urlencode($ID),$this->_ex_link);
			}
			$nav.="<a href=\"".$link_ex."\" onclick=\"return toggleAjax".$this->_js_prepend."('$jsID',$depth);\"><img src=\"".$this->_img_path.'/'.$img."\" border=\"0\" id=\"i1_$jsID\"></a></td>\n";
		} else {
			$nav.="><img src=\"".$this->_img_path.'/'.$img."\"></td>\n";
		}
		$nav.="<td><div style=\"float:left;\" class=\"$class\" $js_fc>";
		if ($link_d) $nav.="<a href=\"$link_d\">";
		$nav.="<img src=\"".$this->_img_path.'/'.$obj->getImage((isset($this->_expand[$ID]) || $this->_all_expand) && $this->len[$ID])."\" class=\"nav\" id=\"i2_$jsID\">";
		if ($link_d) $nav.="</a>";
		$nav.="<a href=\"$link\" class=\"$class\" ";
		foreach ($linkAttribs as $key=>$val) {
			$nav.=' '.$key.'="'.$val.'""';
		}
		$nav.=" >".$Title."</a></div>\n";
		if ($chkdiv) $nav.=$chkdiv;
		if ($obj->isFolder()) {
			$depth++;
			$nav.=$this->_process($ID,$depth);
			$depth--;
		}
		$nav.="</td>\n";
		$nav.="</tr>\n";
		return $nav;
	}
	function process($prev=0,$depth=0) {
		if ($this->_use_tpl) {
			$handle='tpl_tree_content';
			$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
			$this->_t->define (array($handle => $this->_tpl));
			$this->_t->assign('JS_PREPEND',$this->_js_prepend);
			$this->_t->assign('EX_LINK',$this->_ex_link);
			$this->_t->assign('AC_LINK',$this->_ac_link);
			$this->_t->assign('MODUL',$this->_modul);
			$this->_t->assign('OBJ_SELECTED',$this->_oid);
			$this->_t->assign('OBJ_ROOTID',$this->_root_id);
			$this->_t->assign('EXTRA_PARAMS',$this->_extraParams);
			$this->_t->assign('NAV_TREE',$this->_process($prev,$depth));
			if (is_object($this->_rootObj)) {
				if ($this->_metaID) {
					$ID=$this->_rootObj->getMeta($this->_metaID);
				} else {
					$ID=$this->_rootObj->getID();
				}
				$jsID=$this->encodeID($ID);
				if ($ID==$this->_oid) {
					$this->_t->assign('ROOT_CLASS',$this->_class[1]);
				} else {
					$this->_t->assign('ROOT_CLASS',$this->_class[0]);
				}
				if ($this->_func_name) {
					$Title=call_user_func($this->_func_name,$this->_rootObj);//$this->_func_entity;
				} else {
					$Title=$this->_rootObj->getName();
				}
				if ($this->_func_entity) {
					$Title=call_user_func($this->_func_entity,$Title);//$this->_func_entity;
				}
				if (!isset($this->entries[$ID]) && (isset($this->_expand[$ID]) || $this->_all_expand)) {
					$this->_callback_params['ParentID']=$ID;
					$this->entries[$ID]=call_user_func($this->_callback,$this->_callback_params);
					if (!empty($this->entries[$ID])) {
						$this->len[$ID]=count($this->entries[$ID]);
					}
				}
					//debug($this->entries[$ID]);
				$this->_t->assign('ROOT_NAME',$Title);
				$this->_t->assign('ROOT_IMG',$this->_rootObj->getImage($this->len[$ID] && (isset($this->_expand[$ID]) || $this->_all_expand)));
				$link=str_replace('{ACTION}',$this->_rootObj->getAction(0),$this->_ac_link);
				$link=str_replace('{OID}',urlencode($ID),$link);
				$this->_t->assign('ROOT_L',$link);
				$linkAttribs='';
				if (is_array($this->_linkAttribs)) {
					$tras_array=array(
						'{OID}'=>$jsID,
						'{ACTION}'=>$this->_rootObj->getAction(0),
					);
					foreach ($this->_linkAttribs as $key=>$val) {
						$linkAttribs.=$key.'="'.strtr($val,$tras_array).'" ';
					}
				}
				$this->_t->assign('ROOT_ATTRIBS',$linkAttribs);
				if ($this->_oc_link) {
					$link=str_replace('{MODE}',1,$this->_oc_link);
					$this->_t->assign('LINK_OPEN',$link);
					$link=str_replace('{MODE}',-1,$this->_oc_link);
					$this->_t->assign('LINK_CLOSE',$link);
					$this->_t->parse('ROW','openclose');
				}
				if (is_object($this->_objRight)) {
					$this->_t->assign('RCONTENT',$this->_objRight->process($jsID));
					$this->_t->parse('ROW','contentright');
				}
			}
			$this->_t->parse('TPL_TEMP',$handle);
			return $this->_t->getParsed();
		} else {
			return $this->_process($prev,$depth);
		}
	}

	function _process($prev=0,$depth=0) {
		if (isset($this->_expand[$prev]) || $this->_all_expand) {
			$style='style="display:block;clear:both;"';
		} else {
			$style='style="display:none;clear:both;"';
		}
		$nav="<div id=\"nav".$this->encodeID($prev)."\" $style>\n";
		$nav.=$this->processSub($prev,$depth);
		$nav.="</div>\n";
		return $nav;
	}
	function processSub($prev=0,$depth=0) {
		$nav="<table width=\"100%\" bgcolor=\"".$this->_bgcolor."\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n";
		if (isset($this->_expand[$prev]) || $this->_all_expand) {
			/*if (!isset($this->len[$prev])) {
				$this->_callback_params_len['ParentID']=$prev;
				$this->len[$prev]=call_user_func($this->_callback_len,$this->_callback_params_len);
			}*/
			//if ($this->len[$prev]) {

				if (!isset($this->entries[$prev])) {
					$this->_callback_params['ParentID']=$prev;
					$this->entries[$prev]=call_user_func($this->_callback,$this->_callback_params);
				}
				if ($this->entries[$prev] && !empty($this->entries[$prev])) {
					$this->len[$prev]=count($this->entries[$prev]);
					$i=1;
					foreach ($this->entries[$prev] as $obj) {
						$nav.=$this->processObj($obj,$this->len[$prev],$i,$depth);
						$i++;
					}
				}
			//}
		}
		$nav.="</table>\n";
		return $nav;
	}
	function getLen($ID) {
		return $this->len[$ID];
	}
	function setEntries($prev,$entries) {
		$this->entries[$prev]=$entries;
	}
	function encodeID($ID) {
		if ($this->_encodeID) {
			return base64_encode($ID);
		} else {
			return $ID;
		}
	}
	function decodeID($ID) {
		return base64_decode($ID);
	}
	function getJsIds() {
		return $this->_jsId;
	}

}
