<?php
class baseObj {
	var $_meta=array();
	var $_trans=array();
	var $_acl;
	var $_ID;
	var $_action=array(); // to owerwrite;
	var $_site=''; // to owerwrite;
	var $_obj_typ=''; // to owerwrite;
	function baseObj($id=0,$meta='',$acl=0) {
		$this->_id=$id;
		$this->_acl=$acl;
		if (is_array($meta))$this->_meta=$meta;
	}
	function getID() {
		return $this->_id;
	}
	function setID($ID) {
		$this->_id=$ID;
	}
	function getMeta($key) {
		return $this->_meta[$key];
	}
	function setMeta($key,$data) {
		$this->_meta[$key]=$data;
	}
	function getTrans($key) {
		return $this->_trans[$key];
	}
	function setTrans($key,$data) {
		$this->_trans[$key]=$data;
	}
	function getACL($chk=0) {
		$chk=intval($chk);
		if ($chk) {
			if ($this->_acl==-1) {
				return true;
			} else {
				return ($this->_acl&$chk);
			}
		} else {
			return $this->_acl;
		}
	}
	function setAcl($acl) {
		$this->_acl=$acl;
	}
	function getAction($typ) {
		return $this->_action[$typ];
	}
	function getSite() {
		return $this->_site;
	}
	function getObjTyp() {
		return $this->_obj_typ;
	}
	/* to owerwrite*/
	function isFolder() {

	}
	function getName() {

	}
	function getImage($open=0) {

	}
}

class ObjCore {
	var $_frm;
	var $_db;
	var $_uid;
	var $_lang;
	var $_gid;
	var $_rule=false;
	var $_sadmin=false;
	var $_locked_obj=array();
	var $_clipboard=array();
	var $_modul='';
	var $_table='';
	var $_cache=array();
	var $_cfgObjects=array (
		'IdField'=>'',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'TranslationFields'=>array(),
		'AllReadPerms'=>false,
		'ObjTyp'=>array (
			'ClassName'=>'',
			'Fields'=>array(
				'FieldName'=>array(
					'Typ'=>'',

				),
			),
		),
	);

	function ObjCore () {
		global $db,$frm,$T;
		$this->_db=$db;
		$this->_uid=$frm->getUser();
		$this->_lang=$frm->getLang();
		$this->_gid=$frm->getMyGroups();
		$this->_frm=$frm;
		$this->_T=$T;
	}
	function getModul() {
		return $this->_modul;
	}
	function setModul($modul) {
		$this->_modul=$modul;
	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function getUser() {
		return $this->_uid;
	}
	function setGroups($gid) {
		$this->_gid=$gid;
	}
	function getGroups() {
		return $this->_gid;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function getLang() {
		return $this->_lang;
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function isRuleUser() {
		if ($this->_sadmin || $this->_rule) {
			return true;
		} else {
			return false;
		}
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function setClipboard($what,$content) {
		$this->_clipboard[$what]=$content;
	}
	function getClipboard($what) {
		return $this->_clipboard[$what];
	}
	function isClipboard($what) {
		if ($this->_clipboard[$what]) {
			return true;
		} else {
			return false;
		}
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
	}
	function getCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}
	function setException() {


	}
	function getIDField() {
		return $this->_cfgObjects['IdField'];
	}
	function _getParentField() {
		return $this->_cfgObjects['ParentField'];
	}
	function _getUserField() {
		return $this->_cfgObjects['UserField'];
	}
	function _getGroupField() {
		return $this->_cfgObjects['GroupField'];
	}
	function _getOwnerField() {
		return $this->_cfgObjects['OwnerField'];
	}
	function _getObjTypField() {
		return $this->_cfgObjects['ObjTypField'];
	}
	function _getAllReadPerms() {
		return isset($this->_cfgObjects['AllReadPerms'])?$this->_cfgObjects['AllReadPerms']:'';
	}

	function getObjFields($ObjTyp) {
		return $this->_cfgObjects[$ObjTyp]['Fields'];
	}
	function _getObjClass($ObjTyp) {
		return $this->_cfgObjects[$ObjTyp]['ClassName'];
	}
	function _parseObjData() {
		$id=$this->_db->f($this->getIDField());
		$objTyp=$this->_getObjTypField()?$this->_db->f($this->_getObjTypField()):'0';
		$class=$this->_getObjClass($objTyp);
		$acl=$this->_fetchACL($this->_getUserField(),$this->_getGroupField(),$this->_getOwnerField());
		if ($acl) return new $class($id,$this->_fetchData($this->getObjFields($objTyp)),$acl);
	}
	function getObj($ID,$loadTrans=false) {
		if (empty($this->_cfgObjects['TranslationFields'])) {
			$query="SELECT * FROM ".$this->_table;
		} else {
			$query="SELECT * FROM ".$this->_table;
			$addFields=array();
			$addJoins='';
			foreach ($this->_cfgObjects['TranslationFields'] as $TransField) {
				$addFields[]=$this->_T->getUserTable().'_'.$TransField.'.TransVal AS '.$TransField;
				$TransTab=$this->_T->getUserTable().'_'.$TransField;
				$addJoins.=' LEFT JOIN '.$this->_T->getUserTable().' as '.$TransTab.' ON ('.$this->_table.'.'.$TransField.'='.$TransTab.'.TransKey AND '.$TransTab.'.FKModul='.$this->_db->escape($this->_table).' AND '.$TransTab.'.TransLang='.$this->_db->escape($this->_lang).')';
			}
			$query='SELECT '.$this->_table.'.*,'.implode(',',$addFields).' FROM '.$this->_table.$addJoins;
		}

		$query.=" WHERE ".$this->getIDField()."=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$tmpObj=$this->_parseObjData();
			if ($loadTrans && is_object($tmpObj)) {
				foreach ($this->_cfgObjects['TranslationFields'] as $TransField) {
					$tmpObj->setTrans($TransField,$this->_T->readSqlTrans($this->_table,'[['.$TransField.'_'.$tmpObj->getID().']]'));
				}
			}
			return $tmpObj;
		}
	}
	function getCachedObj($ID) {
		if (is_array($ID)) {
			$result=array();
			foreach ($ID as $val) {
				if ($this->getCachedObj($val)) {
					$result[$val]=$this->getCachedObj($val);
				}
			}
			return $result;
		} elseif (!isset($this->_cache[$ID])) {
			$this->_cache[$ID]=$this->getObj($ID);
		}
		return $this->_cache[$ID];
	}
	function searchSingleObj($searchQuery,$use_perms=true) {
		$where=array();
		if (!empty($searchQuery)) {
			$userWhere=$this->_db->getWhere($searchQuery);
		} else {
			$userWhere='';
		}
		if (empty($this->_cfgObjects['TranslationFields'])) {
			$query="SELECT * FROM ".$this->_table;
		} else {
			$addFields=array();
			$addJoins='';
			foreach ($this->_cfgObjects['TranslationFields'] as $TransField) {
				$addFields[]=$this->_T->getUserTable().'_'.$TransField.'.TransVal AS '.$TransField;
				$TransTab=$this->_T->getUserTable().'_'.$TransField;
				$addJoins.=' LEFT JOIN '.$this->_T->getUserTable().' as '.$TransTab.' ON ('.$this->_table.'.'.$TransField.'='.$TransTab.'.TransKey AND '.$TransTab.'.FKModul='.$this->_db->escape($this->_table).' AND '.$TransTab.'.TransLang='.$this->_db->escape($this->_lang).')';
				if ($userWhere) {
					$userWhere=preg_replace('/\b'.preg_quote($this->_table.'.'.$TransField,'/').'\b/',$this->_T->getUserTable().'_'.$TransField.'.TransVal',$userWhere);
				}
			}
			$query='SELECT '.$this->_table.'.*,'.implode(',',$addFields).' FROM '.$this->_table.$addJoins;
		}

		if (!$this->isRuleUser() && $use_perms && !$this->_getAllReadPerms()) {
			$acl_where=array();
			if ($this->_getOwnerField()) $acl_where[]=$this->_getOwnerField().'='.$this->_db->escape($this->_uid);
			if ($this->_getUserField()) $acl_where[]=$this->_getUserField().' LIKE '.$this->_db->escape('%|'.$this->_uid.',%');
			if ($this->_getGroupField() && is_array($this->_gid)) {
				foreach ($this->_gid as $val) {
					$acl_where[]=$this->_getGroupField()." LIKE ".$this->_db->escape('%|'.$val.',%');
				}
			}
			if (!empty($acl_where)) {
				$where[]='('.implode (' OR ',$acl_where).')';
			}
		}
		if ($userWhere) {
			$where[]=$userWhere;
		}
		if (!empty($where)) $query.=' WHERE '.implode(' AND ',$where);
		$query.=' '.$this->_db->formatLimit(0,1);
		//debug($query);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_parseObjData();
		}
	}
	function searchObj (&$rows,$searchQuery,$order='',$b=0,$limit=0,$use_limit=false,$use_perms=true,$tree_mode=false,$params= null) {
		$result=array();
		$where=array();
		if (!empty($searchQuery)) {
			$userWhere=$this->_db->getWhere($searchQuery);
		} else {
			$userWhere='';
		}

		if (!empty($this->_cfgObjects['TranslationFields'])) {
			$addFields=array();
			foreach ($this->_cfgObjects['TranslationFields'] as $TransField) {
				if ($params['FIELDS']) $params['FIELDS'].=',';
				$params['FIELDS'].=$this->_T->getUserTable().'_'.$TransField.'.TransVal AS '.$TransField;
				$TransTab=$this->_T->getUserTable().'_'.$TransField;
				$params['JOIN'].=' LEFT JOIN '.$this->_T->getUserTable().' as '.$TransTab.' ON ('.$this->_table.'.'.$TransField.'='.$TransTab.'.TransKey AND '.$TransTab.'.FKModul='.$this->_db->escape($this->_table).' AND '.$TransTab.'.TransLang='.$this->_db->escape($this->_lang).')';
				if ($order) {
					$order=preg_replace('/\b'.preg_quote($this->_table.'.'.$TransField,'/').'\b/',$this->_T->getUserTable().'_'.$TransField.'.TransVal',$order);
				}
				if ($userWhere) {
					$userWhere=preg_replace('/\b'.preg_quote($this->_table.'.'.$TransField,'/').'\b/',$this->_T->getUserTable().'_'.$TransField.'.TransVal',$userWhere);
				}
			}
		}


		$query="SELECT ".$this->_table.".*";
		if ($params['FIELDS']) {
			$query.=",".$params['FIELDS'];
		}
		$query.=" FROM ".$this->_table;
		if ($params['JOIN']) {
			$query.=" ".$params['JOIN'];
		}
		if (!$this->isRuleUser() && $use_perms && !$this->_getAllReadPerms()) {
			$acl_where=array();
			if ($this->_getOwnerField()) $acl_where[]=$this->_getOwnerField().'='.$this->_db->escape($this->_uid);
			if ($this->_getUserField()) $acl_where[]=$this->_getUserField().' LIKE '.$this->_db->escape('%|'.$this->_uid.',%');
			if ($this->_getGroupField() && is_array($this->_gid)) {
				foreach ($this->_gid as $val) {
					$acl_where[]=$this->_getGroupField()." LIKE ".$this->_db->escape('%|'.$val.',%');
				}
			}
			if (!empty($acl_where)) {
				$where[]='('.implode (' OR ',$acl_where).')';
			}
		}
		if ($userWhere) {
			$where[]=$userWhere;
		}
		if (!empty($where)) $query.=' WHERE '.implode(' AND ',$where);
		if ($params['GROUP_FIELD']) {
			$query.=" GROUP BY ".$params['GROUP_FIELD'];
		}
		if ($order) {
			$query.=" ORDER BY $order";
		}
		if ($limit) $query.=' '.$this->_db->formatLimit($b,$limit);
		//debug($query);
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$tmp_obj=$this->_parseObjData();
			if ($tmp_obj) {
				if (isset($params['CALLBACK']) && $params['CALLBACK']) {
					call_user_func_array ($params['CALLBACK'],array(&$tmp_obj));
				}
				//debug($tmp_obj);
				if ($tree_mode && $this->_getParentField()) {
					$result[$this->_db->f($this->_getParentField())][$tmp_obj->getID()]=$tmp_obj;
				} else {
					$result[$tmp_obj->getID()]=$tmp_obj;
				}
			}
		}
		if ($use_limit && $limit && ($b!=0 || $limit==$rows)) {
			if ($params['GROUP_FIELD']) {
				$count=" DISTINCT ".$params['GROUP_FIELD'];
			} else {
				$count="*";
			}
			$query="SELECT count($count) as num FROM ".$this->_table;
			if ($params['JOIN']) {
				$query.=" ".$params['JOIN'];
			}
			if (!empty($where)) $query.=' WHERE '.implode(' AND ',$where);
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
		}
		return $result;
	}
	function _fetchData(&$fields) {
		foreach ($fields as $key=>$val) {
			$result[$key]=$this->_db->f($key);
		}
		return $result;
	}
	function _fetchACL($UserField,$GroupField,$OwnerField) {
		if ($this->isRuleUser() || ($OwnerField && $this->_db->f($OwnerField)==$this->_uid)) {
			return -1;
		} elseif ($UserField || $GroupField) {
			$acl=$this->_frm->calcAcl($this->_db->f($UserField),$this->_db->f($GroupField),$this->_uid);
			if ($this->_getAllReadPerms()) {
				$acl=$acl|1;
			}
			return $acl;
		} else {
			return -1;
		}
	}
	function updateMeta($obj) {
		$update=array();
		if ($obj->getID()) {
			foreach ($this->getObjFields($obj->getObjTyp()) as $key=>$val) {
				switch ($val['Extra']) {
					case 'ID':
					break;
					case 'mTime':
						$update[$key]=time();
						$obj->setMeta($key,$update[$key]);
					break;
					case 'mUser':
						$update[$key]=$this->_uid;
						$obj->setMeta($key,$update[$key]);
					break;
					case 'ObjTyp':
						//$update[$key]=$obj->getObjTyp();
					break;
					default:
						$update[$key]=$obj->getMeta($key);
					break;
				}
			}
			if (!empty($this->_cfgObjects['TranslationFields'])) {
				foreach ($this->_cfgObjects['TranslationFields'] as $TransField) {
					$update[$TransField]='[['.$TransField.'_'.$obj->getID().']]';
					$updateTrans=$obj->getTrans($TransField);

					if (!empty($updateTrans)) {
						$this->_T->replaceSqlTrans($this->_table,$update[$TransField],$updateTrans);
					}
				}
			}
			$this->_db->update($this->_table,$update,$this->getIDField()."=".$this->_db->escape($obj->getID()));
			return $obj->getID();
		}
		return false;
	}
	function insertMeta($obj) {
		$update=array();
		foreach ($this->getObjFields($obj->getObjTyp()) as $key=>$val) {
			switch ($val['Extra']) {
				case 'ID':
					$update[$key]=$this->_db->nextid($this->_table);
					$obj->setID($update[$key]);
				break;
				case 'mTime':
				case 'cTime':
					$update[$key]=time();
					$obj->setMeta($key,$update[$key]);
				break;
				case 'mUser':
				case 'cUser':
					$update[$key]=$this->_uid;
					$obj->setMeta($key,$update[$key]);
				break;
				case 'ObjTyp':
					$update[$key]=$obj->getObjTyp();
					$obj->setMeta($key,$update[$key]);
				break;
				case 'Fixed':
					$update[$key]=$val['Default'];
					$obj->setMeta($key,$update[$key]);
				break;
				default:
					$update[$key]=$obj->getMeta($key);
				break;
			}
		}
		if (!empty($this->_cfgObjects['TranslationFields'])) {
			foreach ($this->_cfgObjects['TranslationFields'] as $TransField) {
				$update[$TransField]='[['.$TransField.'_'.$obj->getID().']]';
				$updateTrans=$obj->getTrans($TransField);
				if (!empty($updateTrans)) {
					$this->_T->replaceSqlTrans($this->_table,$update[$TransField],$updateTrans);
				}
			}
		}
		if ($this->_db->insert($this->_table,$update)) {
			return $obj->getID();
		}

		return false;
	}
	function deleteMeta($obj,$rec=0) {
		return $this->_deleteMeta($obj->getID(),$rec);
	}
	function _deleteMeta($ID,$rec=0) {
		if ($rec && $this->_getParentField()) {
			$query="SELECT ".$this->getIDField()." FROM ".$this->_table." WHERE ".$this->_getParentField().'='.$this->_db->escape($ID);
			$this->_db->query($query);
			$sub=array();
			while ($this->_db->next_record()) {
				$sub[]=$this->_db->f($this->getIDField());
			}
			if (!empty($sub)) {
				foreach ($sub as $val) {
					$this->_deleteMeta($val,$rec);
				}
			}
		}
		if (!empty($this->_cfgObjects['TranslationFields'])) {
			foreach ($this->_cfgObjects['TranslationFields'] as $TransField) {
				$this->_T->deleteSqlTrans($this->_table,'[['.$TransField.'_'.$ID.']]');
			}
		}
		$query="DELETE FROM ".$this->_table." WHERE ".$this->getIDField().'='.$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
}
?>
