<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class ObjSelect {
	var $_sel_key='return $obj->getID();';
	var $_f_prep='+';
	var $_d_prep='';
	function ObjSelect() {

	}
	function setObjClass($DocType,$class) {
		$this->_obj_class[$DocType]=$class;
	}
	function setClass($class) {
		$this->_class=$class;
	}
	function setTree(&$tree) {
		$this->_tree=&$tree;
	}
	function setSelKey($key) {
		$this->_sel_key=$key;
	}
	function setSelectedID($oid) {
		$this->_oid=$oid;
	}
	function setRootID($root_id) {
		$this->_root_id=$root_id;
	}
	function setModul($modul) {
		$this->_modul=$modul;
	}
	function setIndent($indent=' ') {
		$this->_indent=$indent;
	}
	function setFolderPrep($prep=' ') {
		$this->_f_prep=$prep;
	}
	function setDocPrep($prep=' ') {
		$this->_d_prep=$prep;
	}
	function parseArray(&$nav,$prev=0,$start=true) {
		if ($start) $this->_depth=0;
		if (is_array($this->_tree[$prev])) {
			foreach ($this->_tree[$prev] as $obj) {
				$ID=$obj->getID();
				$Title=$obj->getName();

				$sel_key=eval($this->_sel_key);
				//echo $sel_key.'<br>';
				$nav[$sel_key]=str_repeat($this->_indent,$this->_depth);
				if ($obj->isFolder()) {
					$nav[$sel_key].=$this->_f_prep;
				} else {
					$nav[$sel_key].=$this->_d_prep;
				}
				$nav[$sel_key].=htmlspecialchars($Title);
				if (isset($this->_tree[$ID])) {
					$this->_depth++;
					$this->parseArray($nav,$ID,false);
					$this->_depth--;
				}
			}
		}
	}
	function parseSelect($prev=0,$start=true) {
		if ($start) $this->_depth=0;
		if (is_array($this->_tree[$prev])) {
			foreach ($this->_tree[$prev] as $obj) {
				$ID=$obj->getID();
				$Title=$obj->getName();

				$sel_key=eval($this->_sel_key);
				//echo $sel_key.'<br>';
				$nav.="<option value=\"$sel_key\"";
				if ($this->_obj_class[$obj->getMeta('DocType')]) {
					$nav.=' class="'.$this->_obj_class[$obj->getMeta('DocType')].'"';
				} elseif ($this->_class) {
					$nav.=' class="'.$this->_class.'"';
				}
				if (is_array($this->_oid)) {
					if (in_array($sel_key,$this->_oid)) {
						$nav.=' selected';
					}
				} else {
					if ($this->_oid.''==$sel_key.'') {
						$nav.=' selected';
					}
				}
				$nav.=">";
				$nav.=str_repeat($this->_indent,$this->_depth);
				if ($obj->isFolder()) {
					$nav.=$this->_f_prep;
				} else {
					$nav.=$this->_d_prep;
				}
				$nav.=htmlspecialchars($Title);
				$nav.="</option>\n";
				if (isset($this->_tree[$ID])) {
					$this->_depth++;
					$nav.=$this->parseSelect($ID,false);
					$this->_depth--;
				}
			}
		}
		return $nav;
	}
}
