<?php
class PrintDialogGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_id='';
	var $_defFormat=0;
	var $_defConfig=array();
	var $_defChecked='0';
	var $_defLinkParams=array();
	var $_usePerms=true;
	function PrintDialogGui($modul='') {
		global $frm,$t,$T,$E,$L;
		$this->_Base=& $frm->getStaticModul('print_tpl');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		if ($modul) $this->setModul($modul);
	}
	function setModul($val) {
		$this->_Base->setModul($val);
	}
	function setID($id) {
		$this->_id=$id;
	}
	function setUsePerms($val) {
		$this->_usePerms=$val;
	}
	function setDefaultFormat($val) {
		$this->_defFormat=$val;
	}
	function setDefaultChecked($val) {
		$this->_defChecked=$val;
	}
	function setDefaultConfig($id='0',$name='',$format=0) {
		$this->_defConfig[$id]=array(
			'f'=>$format,
			'n'=>$name,
		);
	}
	function setDefaultLinkParams($val) {
		$this->_defLinkParams=$val;
	}
	function process($typ,$myRules=null) {
		require_once('lib/class_FastTemplateGui.php');
		$resGui=new FastTemplateGui('core/print_dialog.inc.html');
		$resGui->assign('DIALOG_ID',$this->_id);
		$resGui->setEncode(false);
		if (empty($this->_defConfig)) {
			$config=array(
				'0'=>array(
					'f'=>$this->_defFormat,
					'n'=>$this->_T->lang('[[Standard]]'),
				)
			);
		} else {
			$config=$this->_defConfig;
		}
		$entries=$this->_Base->listModulObj($typ);
		foreach ($entries as $val) {
			if (!$this->_usePerms || $this->_Base->calcAcl($val,$myRules)) {
				if ($val->getMeta('ViewDefault')==2 && isset($config['0'])) unset($config['0']);
				if ($val->getMeta('ViewDefault'))  {
					$this->_defChecked=$val->getID();
				}
				$config[$val->getID()]=array(
					'f'=>$val->getMeta('Format'),
					'n'=>$val->getName()
				);
			}
		}
		//debug($config);
		$rows=count($config)-1;
		$resGui->assign('DIALOG_CFG',Framework::array2json($config));
		$resGui->assign('DIALOG_CHK',$this->_defChecked);

		$resGui->assign('NUM_ENTRIES',$rows);
		$this->_defLinkParams['print']=1;
		$this->_defLinkParams['_loadSearch']=1;
		$resGui->assign('LINK',$this->_L->getTempLink(null,$this->_defLinkParams));
		$this->_frm->addScript($resGui);
		$this->_frm->initExtJs();
	}
}
?>