<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class Form {
	var $table;
	var $elements;
	var $db_form;
	var $primary;
              var $errortxt;
	function Form($db_form,$table,$primary) {
		$this->db_form=$db_form;
		$this->table=$table;
		$this->primary=$primary;
	}
	function addfield($var,$field="",$static=0) {
                        if ($field=="") $field=$var->name;
                        $this->elements[]=array($field,$var,$static);
	}
	function values() {
		foreach ($this->elements as $elements) {
			list($field,$value,$static)=$elements;
			echo "Feld:".$field." VarName:".$value->name." Wert:".$value->getchecked()." Static:$static<br>";
		}
	}
	function insert($id=0) {
		$fields[]=$this->primary;
		if (!$id) $values[]=$this->db_form->nextid($this->table); else $values[]=$id;
		foreach ($this->elements as $elements) {
			list($field,$var,)=$elements;
			if ($var->classname=="ImageField") $var->save($values[0]);
                                                        //echo $var->name;
                                                        $varval=$var->getchecked();
			if ($varval=="||") {
                                                $this->errortxt=$var->errortxt;
                                                return 0;
                                          }
			$fields[]=$field;
			$values[]="'".addslashes($varval)."'";
		}
		$query="INSERT INTO ".$this->table." (".implode (",",$fields).") VALUES (".implode (",",$values).")";

                   if (!$this->db_form->query($query)) return 0;
                        	return $values[0];
	}
	function update($id) {
		foreach ($this->elements as $elements) {
			list($field,$var,)=$elements;
			if ($var->classname=="ImageField") {
				if (is_file($GLOBALS[$var->name])) {$var->save($id);} else { continue;};
			}
			$varval=$var->getchecked();
                                          if ($varval=="||") {
                                                $this->errortxt=$var->errortxt;
                                                return 0;
                                          }
                                         	$fields[]="$field='".addslashes($varval)."'";
		}
		$query="UPDATE ".$this->table." SET ".implode (",",$fields)." WHERE ".$this->primary."=$id";
                                     if (!$this->db_form->query($query)) return 0;
		return $id;
	}
	function delete($id) {
		foreach ($this->elements as $elements) {
			list($field,$var,)=$elements;
			if ($var->classname=="ImageField") {
				$query="select $field from ".$this->table." WHERE ".$this->primary."=$id";
				$this->db_form->query($query);
				$this->db_form->next_record();
				$file=$this->db_form->f($field);
				$var->delete($file);
			}
		}
		$query="DELETE FROM ".$this->table." WHERE ".$this->primary."=$id";
		if (!$this->db_form->query($query)) return 0;
		return $id;
	}
	function read($id) {
                if (!is_array($id))   {
                        $query="SELECT * FROM ".$this->table." WHERE ".$this->primary."=$id";
                } else {
                        $and="";
                       foreach ($id as $key=>$val) {
                                $where.=$and.$key."='$val'";
                                $and=" and ";
                       }
                       $query="SELECT * FROM ".$this->table." WHERE $where";
                }
                            $this->db_form->query($query);
		if (!($this->db_form->next_record()))return 0;
		foreach ($this->elements as $elements) {
			list($field,$var,)=$elements;
                                                        if (!isset($GLOBALS[$var->name])) $GLOBALS[$var->name]=$this->db_form->f($field);

		}
                            $GLOBALS[$this->primary]=$this->db_form->f($this->primary);
                            return $id;
	}
	function clear() {
		foreach ($this->elements as $elements) {
				list(,$var,$static)=$elements;
				if ($static) continue;
				$var->clear();
		}
              $GLOBALS[$this->primary]=0;

	}
       function begin($name="",$action="",$method="POST",$extra="") {
            global $PHP_SELF;
            if ($name=="") $name=$this->table;
            if ($action=="") $action=$PHP_SELF;
            echo "<form name=$name action=$action method=$method $extra>";
       }
       function fbegin($name="",$action="",$method="POST",$extra="") {
            global $PHP_SELF;
            if ($name=="") $name=$this->table;
            if ($action=="") $action=$PHP_SELF;
            return "<form name=$name action=$action method=$method $extra>";
       }
       function end() {
            foreach ($this->elements as $elements) {
			list($field,$var,)=$elements;
			if ($var->classname=="HiddenField") $var->p();
	     }
            echo "<input type=hidden name=".$this->primary." value=\"".$GLOBALS[$this->primary]."\">\n";
            echo "</form>\n";
       }
       function fend() {
           $rval="";
            if (is_array($this->elements)) {
                foreach ($this->elements as $elements) {
                                list($field,$var,)=$elements;
                                if ($var->classname=="HiddenField") $rval.=$var->f();
                }
            }
            $rval.="<input type=hidden name=".$this->primary." value=\"".$GLOBALS[$this->primary]."\">\n";
            $rval.="</form>";
            return $rval;
       }
}
class Field {
	var $name;
	var $min;
	var $max;
	var $default;
	var $errortxt;
	var $extra;
	function clear() {
		$name=preg_replace('/^([^[]+)/','[\\1]',str_replace('[]','',$this->name));
		$name=str_replace('[',"['",str_replace(']',"']",$name));
		eval('$GLOBALS'.$name.'=$this->default;');
	}
	function getvalue() {
		if (!$this->get_value($this->name)) $this->clear();
		return $this->get_value($this->name);
	}
	function is_set($name) {
		$name=preg_replace('/^([^[]+)/','[\\1]',str_replace('[]','',$name));
		$name=str_replace('[',"['",str_replace(']',"']",$name));
		return eval('return isset ($GLOBALS'.$name.');');
	}
	function get_value($name) {
		$name=preg_replace('/^([^[]+)/','[\\1]',str_replace('[]','',$name));
		$name=str_replace('[',"['",str_replace(']',"']",$name));
		return eval('return $GLOBALS'.$name.';');
	}

}
class RadioButton extends Field{
        var $classname="RadioButton";
        function RadioButton ($name,$extra="",$default="") {
                $this->name=$name;
                $this->default=$default;
                $this->extra=$extra;
       }

       function f($value,$disabled=0) {
                if (!$this->is_set($this->name)) $this->clear();
                $rval=  "<input type=\"radio\" name=\"".$this->name."\" value=\"$value\" ".$this->extra;;
                if (
                        (is_array($this->get_value($this->name)) && in_array($value,$this->get_value($this->name)))
                        || $this->get_value($this->name)==$value
                ) {
                        $rval.= " checked=\"checked\"";
                        if ($disabled) {
				$rval.=' disabled="disabled"';
				$hidden="<input type=\"hidden\" name=\"".$this->name."\" value=\"".$value."\">";
			}
                }
                $rval.= " />".$hidden;
                return $rval;
       }
       function getchecked() {
              if ($GLOBALS[$this->name]=="") $this->clear();
              return $GLOBALS[$this->name];
       }

}
class HiddenField extends Field {
       var $classname="HiddenField";
       function HiddenField ($name,$default="") {
                $this->name=$name;
                $this->default=$default;
        }
        function getchecked() {
              if ($this->get_value($this->name)=="") $this->clear();
              return $this->get_value($this->name);
        }
        function f() {
            return '<input type="hidden" name="'.$this->name.'" value="'.$this->get_value($this->name).'" />';
        }
}
class TextField extends Field {
        var $classname="TextField";
        var $firstup;
        function TextField ($name,$extra="",$min=0,$max="%",$default="",$firstup=0,$errortxt="") {
                $this->name=$name;
                $this->min=$min;
                $this->max=$max;
                $this->default=$default;
                $this->firstup=$firstup;
                $this->errortxt=$errortxt;
                $this->extra=$extra;
       }
       function getchecked() {
                if (!$this->is_set($this->name)) $this->clear();
                $value=$this->get_value($this->name);
                if (strlen($value)<$this->min) return "||";
                if ($this->max!="%" and strlen($value)>$this->max) $value=substr($value,0,$max);
                if ($this->firstup==1) $value=ucfirst(strtolower($value));
                return $value;
        }
        function f() {
                if (!$this->is_set($this->name)) $this->clear();
                return '<input type="text" name="'.$this->name.'" value="'.htmlspecialchars($this->get_value($this->name)).'" '.$this->extra.' />';
        }
}
class PasswordField extends TextField {
    function f() {
        return '<input type="password" name="'.$this->name.'" value="'.$this->get_value($this->name).'" '.$this->extra.' />';
    }
    function getchecked() {
              if ($this->get_value($this->name)=="") $this->clear();
              $value=$this->is_set($this->name);
                if (strlen($value)<$this->min) return "||";
                if ($this->max!="%" and strlen($value)>$this->max) return "||";
                if ($this->firstup==1) $value=md5($value);
                return $value;
    }
}
class IntField extends Field {
        var $classname="IntField";
        var $format;
        function IntField ($name,$extra="",$min="%",$max="%",$default="",$format="",$errortxt="") {
                $this->name=$name;
                $this->min=$min;
                $this->max=$max;
                $this->default=$default;
                $this->format=$format;
                $this->errortxt=$errortxt;
                $this->extra=$extra;
        }
        function getchecked() {
                $value=$this->get_value($this->name);
                if ($format!="") $value=sprintf($format,$value);
                if ($this->min!="%" and $value<$this->min) return "||";
                if ($this->max!="%" and $value>$this->max) return "||";
                if ($format!="") $value=sprintf($format,$value);
                return $value;
        }
        function f() {
                if (!$this->is_set($this->name)) $this->clear();
                return '<input type="text" name="'.$this->name.'" value="'.htmlspecialchars($this->get_value($this->name)).'" '.$this->extra.' />';
        }
}
class TextArea extends TextField {
        var $classname="TextArea";
        function TextArea ($name,$extra="",$min=0,$max="%",$default="",$firstup=0,$errortxt="") {
                $this->name=$name;
                $this->min=$min;
                $this->max=$max;
                $this->default=$default;
                $this->firstup=$firstup;
                $this->errortxt=$errortxt;
                $this->extra=$extra;
       }
       function f() {
                if (!$this->is_set($this->name)) $this->clear();
                return '<textarea name="'.$this->name.'"  '.$this->extra.'>'.htmlspecialchars($this->get_value($this->name))."</textarea>";
       }
}
class SelectField  extends Field{
        var $classname="SelectField";
        var $values;
        var $name;
        var $extra;
        var $default;
        var $multiple;
        var $sep;
        function SelectField ($name,$extra="",$values,$default="",$multiple=0,$sep="|") {
                $this->name=$name;
                $this->default=$default;
                $this->values=$values;
                $this->extra=$extra;
                $this->multiple=$multiple;
		if (!$sep) $sep="|";
                $this->sep=$sep;
       }
       function f() {
       //	echo $this->get_value($this->name).'<br>';
                if ($this->get_value($this->name)=="") $this->clear();
                if ($this->multiple==1) {
                        if (is_array($this->get_value($this->name))) $selected=$this->sep.implode($this->sep,$this->get_value($this->name)).$this->sep;
                        else $selected=$this->get_value($this->name);
                        $mul=" multiple";
                        $ar="[]";
                }
                $rval= "<select name=\"".$this->name."$ar\" ".$this->extra."$mul>\n";
                if($this->values){
                        foreach ($this->values as $key=>$val) {
                                $rval.= "<option value=\"$key\"";
                                if ($this->multiple==0) {
                                        if ($this->get_value($this->name)==$key) $rval.= ' selected="selected"';
                                } else {
                                        if (preg_match('/'.preg_quote($this->sep.$key.$this->sep,'/').'/',$selected)) $rval.=' selected="selected"';
                                }
                                $rval.= ">$val\n";
                        }
                }
                $rval.= "</select>";
                return $rval;
       }
       function getvalue() {
                if ($this->multiple) return is_array($GLOBALS[$this->name])?$GLOBALS[$this->name]:array();
                else return $GLOBALS[$this->name];
       }
       function getchecked() {
                if (is_array($GLOBALS[$this->name])) return $this->sep.implode($this->sep,$GLOBALS[$this->name]).$this->sep;
                else return  $GLOBALS[$this->name];

      }
}
class CheckBox extends SelectField {
        var $classname="CheckBox";
        var $extra='';
        function CheckBox ($name,$extra="",$values=0,$default="",$multiple=0) {
                $this->name=$name;
                $this->default=$default;
                $this->values=$values;
                $this->extra=$extra;
                $this->multiple=$multiple;
       }
       function f($val=0,$disabled=0) {
                $hidden="";
                if (!$this->is_set($this->name)) $this->clear();
                if ($this->multiple) {
					$rval= '<input type="checkbox" name="'.$this->name.'[]" value="'.$val.'" '.$this->extra;
                    if (is_array($this->get_value($this->name)) && in_array($val,$this->get_value($this->name))) {
						$rval.= ' checked="checked"';
						if ($disabled) {
							$hidden='<input type="hidden" name="'.$this->name.'[]" value="'.$val.'" />';
						}
					}
                } else  {
                    if (!$val) $val=$this->values;
                    $rval=  '<input type="checkbox" name="'.$this->name.'" value="'.$val.'" '.$this->extra;
                       if (
                                (is_array($this->get_value($this->name)) && in_array($val,$this->get_value($this->name)))
                                || $this->get_value($this->name)==$val
                        ) {
                                $rval.= ' checked="checked"';
								if ($disabled) {
										$hidden=='<input type="hidden" name="'.$this->name.'" value="'.$val.'" />';
								}
                        }
                }
				if ($disabled) {
					$rval.=' disabled="disabled"';
				}
                $rval.= " />".$hidden;
                return $rval;
       }
}
class ImageField {
	var $convertpath="/usr/X11R6/bin/";
	var $classname="ImageField";
       var $name;
	var $path;
	var $width;
	var $height;
	var $border;
	var $twidth;
	var $theight;
	var $tborder;
       var $extra;
       function ImageField($name,$path,$width,$height,$border,$twidth=0,$theight=0,$tborder=0,$extra="") {
    	$this->name=$name;
		$this->path=$path;
		$this->width=$width;
		$this->height=$height;
		$this->border=$border;
		$this->twidth=$twidth;
		$this->theight=$theight;
		$this->tborder=$tborder;
              $this->extra=$extra;
	}
	function getchecked() {
		return $GLOBALS[$this->name];
	}
	function getvalue() {
		return $GLOBALS[$this->name];
	}
	function clear() {
		$GLOBALS[$this->name]="";
	}
	function save($id) {
		if ($GLOBALS[$this->name]=$this->resize($GLOBALS[$this->name],$this->path."/$id",$this->width,$this->height,$this->border)){
			if ($this->twidth && $this->theight) {
				$this->resize($GLOBALS[$this->name],$this->path."/thumb_$id",$this->twidth,$this->theight,$this->tborder);
			}
		} else {
			$GLOBALS[$this->name]="";
		}
	}
	function delete($file) {
		if (is_file($file)) {
			unlink($file);
			$thumb=dirname($file)."/thumb_".basename($file);
		}
		if (is_file($thumb)) unlink($thumb);
	}
	function resize($source,$dest,$maxwidth,$maxheigth,$border=0){
	if (!is_file($source)) return 0;
	if ($size=getimagesize($source)){
		switch ($size[2]) {
			case 1:	$dest.=".gif";
					break;
			case 2:	$dest.=".jpg";
					break;
			case 3:	$dest.=".png";
					break;
		}
		if ($size[0]<$maxwidth and $size[1]<$maxheigth) {
			$geometry=$size[0]."x".$size[1];
		} else {
			$propx=$maxwidth/$size[0];
			$propy=$maxheigth/$size[1];
			$geometry=($propx<$propy)?($maxwidth."x".floor($size[1]*$propx)):(floor($propy*$size[0])."x".$maxheigth);
		}
		$exec=$this->convertpath."convert -geometry ".$geometry." -bordercolor black -border $border $source $dest";
		exec($exec);
		return $dest;
	} else {
		return false;
	}
	}
       function f() {
        return "<input type=file name=".$this->name."  ".$this->extra.">";
       }
}
class DateField {
	var $classname="DateField";
	var $name;
	var $default;
	var $style;
	var $clear;
    var $errortxt;
	function DateField ($name,$default,$style="",$clear=0,$errortxt="") {
		$this->name=$name;
		$this->default=$default;
		$this->style=$style;
		$this->clear=$clear;
        $this->errortxt=$errortxt;
	}
    function f($field=0,$start=0,$end=0) {
		if (!$field) {
			return $this->f("d")."&nbsp;".$this->f("m")."&nbsp;".$this->f("y");
		}
        $name=$this->name;
		if (isset($GLOBALS[$this->name])){
			$GLOBALS[$name."_d"]=date("d",$GLOBALS[$this->name]);
			$GLOBALS[$name."_m"]=date("m",$GLOBALS[$this->name]);
			$GLOBALS[$name."_y"]=date("Y",$GLOBALS[$this->name]);
			$GLOBALS[$name."_h"]=date("H",$GLOBALS[$this->name]);
			$GLOBALS[$name."_i"]=date("i",$GLOBALS[$this->name]);
		}
		if ($GLOBALS[$this->name]>mktime(0,0,0,1,1,2030) || $GLOBALS[$this->name]==-1) $GLOBALS[$name."_".$field]="";
		if ($this->getchecked()=="||") $this->clear();
		switch($field) {
			case d:
				$start=1;$end=31;$tras="-";break;
			case m:
				$start=1;$end=12;$tras="-";break;
			case y:
				if (!$start)  $start=1995;
				if (!$end)  $end=2006;
				$tras="-";break;
			default:
				return 0;
		}
		$rval= "<select name=".$name."_$field ".$this->style.">\n";
		if ($this->clear) $rval.= "<option value=0>$tras\n";
		for ($i=$start;$i<=$end;$i++) {
			if ($GLOBALS[$name."_".$field]==$i) $checked=" selected";
			$rval.= "<option value=$i$checked>";
			if ($field!="y") { $rval.=sprintf("%02d",$i); } else { $rval.=$i; }
			$rval.= "\n";
			$checked="";
		}
		$rval.="</select>\n";
                                return $rval;
	}
	function getvalue() {
		$name=$this->name;
		return mktime($GLOBALS[$name."_h"],$GLOBALS[$name."_i"],0,$GLOBALS[$name."_m"],$GLOBALS[$name."_d"],$GLOBALS[$name."_y"]);
	}
	function getchecked() {
		$name=$this->name;
		if (isset($GLOBALS[$name])) {
			$value=$GLOBALS[$name];
		} else {
			if (!(checkdate(intval($GLOBALS[$name."_m"]),intval($GLOBALS[$name."_d"]),intval($GLOBALS[$name."_y"])))) {
				if (!$this->clear) return "||";
				else return -1;
			}
	        $value=mktime($GLOBALS[$name."_h"],$GLOBALS[$name."_i"],0,$GLOBALS[$name."_m"],$GLOBALS[$name."_d"],$GLOBALS[$name."_y"]);
        }
		return $value;
	}
	function clear() {
		$name=$this->name;
		if ($this->default=="") {
			$GLOBALS[$name."_d"]="";
			$GLOBALS[$name."_m"]="";
			$GLOBALS[$name."_y"]="";
			$GLOBALS[$name."_h"]="";
			$GLOBALS[$name."_i"]="";
			unset($GLOBALS[$name]);
		} else {
			$GLOBALS[$name."_d"]=date("d",$this->default);
			$GLOBALS[$name."_m"]=date("m",$this->default);
			$GLOBALS[$name."_y"]=date("Y",$this->default);
			$GLOBALS[$name."_h"]=date("H",$this->default);
			$GLOBALS[$name."_i"]=date("i",$this->default);
			$GLOBALS[$name]=$this->default;
		}
	}
}
class DateSqlField {
	var $classname="DateSqlField";
	var $name;
	var $default;
	var $style;
	var $clear;
 	var $errortxt;
	function DateSqlField ($name,$default,$style="",$clear=0,$errortxt="") {
		$this->name=$name;
		$this->default=$default;
		$this->style=$style;
		$this->clear=$clear;
  		$this->errortxt=$errortxt;
		if (isset($GLOBALS[$name."_y"]) && isset($GLOBALS[$name."_m"]) && isset($GLOBALS[$name."_d"])) {
				$GLOBALS[$name]=$GLOBALS[$name."_y"]."-".$GLOBALS[$name."_m"]."-".$GLOBALS[$name."_d"];
		}
	}
 	function f($field=0) {

		if (!$field) {
				return $this->f("d")."&nbsp;".$this->f("m")."&nbsp;".$this->f("y");
		}
		$name=$this->name;
		if (isset($GLOBALS[$this->name])){
			$temp=explode("-",$GLOBALS[$this->name]);
			if ($temp[0]=="00") {
				$temp[2]="";$temp[1]="";$temp[0]="";
			}
			$GLOBALS[$name."_d"]=$temp[2];
			$GLOBALS[$name."_m"]=$temp[1];
			$GLOBALS[$name."_y"]=$temp[0];
		}

		if ($this->getchecked()=="||") $this->clear();
		switch($field) {
			case d:
				$size=2;break;
			case m:
				$size=2;break;
			case y:
				$size=4;break;
			default:
				return 0;
		}
		$rval= "<input type=text name=".$name."_$field value=\"".sprintf('%0'.$size.'d',$GLOBALS[$name."_".$field])."\" size=$size maxlength=$size ".$this->style.">\n";
		return $rval;
	}
	function getvalue() {
		$name=$this->name;
		return $GLOBALS[$name."_y"]."-".$GLOBALS[$name."_m"]."-".$GLOBALS[$name."_d"];
	}
	function getchecked() {
		$name=$this->name;
		if (isset($GLOBALS[$name])) {
			$value=$GLOBALS[$name];
		} else {
			if ($this->clear==0 and !(checkdate((int)$GLOBALS[$name."_m"],(int)$GLOBALS[$name."_d"],(int)$GLOBALS[$name."_y"]))) return "||";
			$value=$GLOBALS[$name."_y"]."-".$GLOBALS[$name."_m"]."-".$GLOBALS[$name."_d"];
   		}
   		return $value;
	}
	function clear() {
		$name=$this->name;
		if ($this->default=="") {
			$GLOBALS[$name."_d"]="";
			$GLOBALS[$name."_m"]="";
			$GLOBALS[$name."_y"]="";
			unset($GLOBALS[$name]);
		} else {
			$temp=explode("-",$this->default);
			$GLOBALS[$name."_d"]=$temp[2];
			$GLOBALS[$name."_m"]=$temp[1];
   			$GLOBALS[$name."_y"]=$temp[0];
      			$GLOBALS[$name]=$this->default;
		}
	}
}
?>
