<?php
class fmngAdminGui {
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_avTools=array();
	function fmngAdminGui() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=$frm->getStaticModul('fmng');
		$this->_Log=& $frm->getStaticModul('core_log');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('fmng');
	}
	function _handleRequest() {
		$this->_mode=Framework::getParam('mode','perms','G');
		switch ($this->_mode) {
			case 'perms':
				$this->_obj_action='';
			break;
			case 'log':
				$this->_obj_action='';
				if (Framework::getParam('_loadSearch',0)) {
					$this->_searchLog=$this->_frm->loadPostData($this->_Base->getModul(),Framework::getParam('_loadSearch',0),1,0);
				}
			break;

		}
	}
	function &getAdminHeader() {
		require_once("lib/class_ContentGui.php");
		$hGui=new ContentGui();
		$hGui->setName($this->_frm->getAppName('fmng'));
		$hGui->addTab('perms',$this->_T->lang('[[Rechte]]'),"index.php?site=admin.php&ac=fmng&mode=perms");
		$hGui->addTab('log',$this->_T->lang('[[Logbuch]]'),"index.php?site=admin.php&ac=fmng&mode=log");
		$hGui->setTabOn($this->_mode);
		return $hGui;
	}
	function process(&$AppGui) {
		$this->_handleRequest();
		$AppGui->addContent($this->getAdminHeader());

		switch ($this->_mode) {
			case 'perms':
				switch ($this->_action) {
					default:
						$AppGui->addContent($this->showPerms());
					break;
				}

			break;
			case 'log':
				require_once('lib/class_ApplicationTreeGui.php');
				$this->_Gui=new ApplicationTreeGui();
				switch ($this->_action) {
					default:
						$this->showLogSearch();
						$this->showLogContent();
					break;
				}
				$AppGui->addContent($this->_Gui);

			break;
		}
		$AppGui->setFormAction($this->_L->getLink());
	}

	function addObjActionGui(&$Gui) {
		require_once('lib/class_FunctionObjActionGui.php');
		$objActionGui=new FunctionObjActionGui();
		if ($this->_obj_action) {
			$obj_action=$this->_frm->getObjAction('admin',$this->_obj_action);
			$parse=false;
			foreach ($obj_action as $key=>$val) {
				if ($val['Hidden']) continue;
				//print_r($val);
				$parse=true;
				$objActionGui->addValue($key,$val['Name']);
			}
			if ($parse) $Gui->addFunction($objActionGui,1);
		}


	}

	function showPerms() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$Gui->setName($this->_T->lang('[[Rechte bearbeiten]]'));

		$box=new BoxGui($this->_Base->getModul().'|AdminNull');
		$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
		$box->setTabContent('perms',$this->getPermsGui());
		$box->setTabOn('perms');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function &getPermsGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');

		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		$key='addPermsUser';
		$mode='u|g';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);

		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,'','fields1');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));
		$formGui->setNoMeta($key);
		$formGui->addField('perms_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields3');

		$avPerms=array(
			1=>$this->_T->lang('[[Eigene Dateien]]'),
			2=>$this->_T->lang('[[Gemeinsame Dateien]]'),
		);
		$avPermsShort=array(
			1=>$this->_T->lang('[[Eigene Dateien]]'),
			2=>$this->_T->lang('[[Gemeinsame Dateien]]'),
		);

		$formGui->addField('addPermsID','checklist_v',$this->_T->lang('[[Rechte]]'),0,'fields2');
		$formGui->setValues('addPermsID',$avPerms);



		if (Framework::getParam('perms_add',0,'P') && Framework::getParam('addPermsID',0,'P') && trim($formGui->getFieldVal('addPermsUser'))) {
			$permsUsers=explode('|',$formGui->getFieldVal('addPermsUser'));
			foreach ($permsUsers as $val) {
				$tmp=explode('_',$val);
				if ($tmp[0]=='u') {
					$this->_Base->deletePerms('u',$tmp[1]);
					$this->_Base->ReplacePerms('u',$tmp[1],Framework::getParam('addPermsID',0,'P'));
					$update=true;
				}
				if ($tmp[0]=='g') {
					$this->_Base->deletePerms('g',$tmp[1]);
					$this->_Base->ReplacePerms('g',$tmp[1],Framework::getParam('addPermsID',0,'P'));
					$update=true;
				}
			}
		}
		if(is_array(Framework::getParam('permDeleteG_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteG_x',0,'P'));
			$this->_Base->deletePerms('g',$key);
			$update=true;
		}
		if(is_array(Framework::getParam('permDeleteU_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteU_x',0,'P'));
			$this->_Base->deletePerms('u',$key);
			$update=true;
		}
		if ($update) {
			$this->_L->goToLink();
		}

		$perms_g=array();
		$perms_u=array();
		$perms=$this->_Base->getAllPerms();
		if (is_array($perms['g'])) {
			foreach ($perms['g'] as $key=>$val) {
				$perms_g[$key]=array_sum($val);
			}
		}
		if (is_array($perms['u'])) {
			foreach ($perms['u'] as $key=>$val) {
				$perms_u[$key]=array_sum($val);
			}
		}

		//debug($perms_g);
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3_1',$formGui,'FORM3',array('','fields3'));
		$f32=$this->listPerms('PermsGroup',($perms_g),$avPermsShort,1);
		$tplContent->addContent('form3_2',$f32,'FORM3');
		$f33=$this->listPerms('PermsUser',($perms_u),$avPermsShort,1);
		$tplContent->addContent('form3_3',$f33,'FORM3');
		return $tplContent;
	}
	function &listPerms($ptype,$perms,$av_perms,$perm_mode=0,$prep='perm') {
		//debug($perms);
		if (!empty($perms)) {
			require_once('lib/class_ApplicationListGui.php');
			$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
			//$tabGui->setName($this->_T->lang('[[Sichtbar fuer]]'));
			switch ($ptype) {
				case 'PermsGroup':
					$title=$this->_T->lang('[[Gruppen]]');
					$perms_users=$this->_frm->getAllGroups(array_keys($perms));
		//debug($perms_users);
					$img='gruppe.gif';
					$dbtn=$prep.'DeleteG_x';
				break;
				case 'PermsUser':
					$title=$this->_T->lang('[[BenutzerInnen]]');
					$perms_users=$this->_frm->getFullName(array_keys($perms),0,1);
					$img='user.gif';
					$dbtn=$prep.'DeleteU_x';
				break;
			}
			$tabGui->addHeaderCol('Name',$title,'','','',0,'',2);
			foreach ($av_perms as $pkey=>$pval) {
				$tabGui->addHeaderCol('Perms_'.$pkey,$pval,'','','',1);
			}
			$tabGui->addHeaderCol('Delete','','tras.gif');
			$tabGui->setLimit(0);
			$rows=0;$hl=0;
			foreach ($perms as $key=>$val) {
				if (!isset($perms_users[$key])) continue;
				//debug($val);
				$hl=$hl?0:1;
				$tabGui->addRow($hl);
				$tabGui->addCol('IMG','',$img);
				$tabGui->addCol('Name',$perms_users[$key],'','','',0,'2000');
				foreach ($av_perms as $pkey=>$pval) {
					if ($perm_mode) {
						$tabGui->addCol('Perms_'.$pkey,($val&$pkey)?'X':'','','','center',1);
					} else {
						$tabGui->addCol('Perms_'.$pkey,$pkey==$val?'X':'','','','center',1);
					}
				}
				$btn=new SubmitImgBtn ($dbtn.'['.$key.']','img/'.APP_THEME.'/loeschen.gif');
				$tabGui->addCol('Delete',$btn);
			}
		}
		return $tabGui;
	}
	function showLogSearch() {
		require_once('lib/class_DateSelectForm.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');

		$ContGui=new TemplateGui('core/common_content_border.inc.html');



		$selDateGui=new DateSelectForm();
		$selDateGui->setMode($this->_search['DateMode']?$this->_search['DateMode']:1);
		if ($this->_search['DateB'] || $this->_search['DateE']) {
			$selDateGui->setDate(array($this->_search['DateB'],$this->_search['DateE']));
		} else {
			//$selDateGui->setDate(array(0,0));
		}
		$ContGui->addContent('dateSelect',$selDateGui->process(),'CONTENT');


		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');


		$submitVals=array(
			'view_x'=>$this->_T->lang('[[Anzeigen]]'),
			'export_x'=>$this->_T->lang('[[Exportieren]]'),
		);
		$key='submit';
		$formGui->addField($key,'submit','','');
		$formGui->setValues($key,$submitVals);

		$ContGui->addContent('searchData',$formGui,'CONTENT');


		$this->_searchLog=array(
			'DateB'=>$selDateGui->getDate('B'),
			'DateE'=>$selDateGui->getDate('E'),
			'DateMode'=>$selDateGui->getMode(),
			'FKModul'=>$this->_Base->getModul(),
			'b'=>Framework::getParam('view_x','','P')?0:Framework::getParam('b',0,'G'),
			'limit'=>5,
		);
		//debug($this->_searchLog);
		$this->_frm->savePostData($this->_Base->getModul(),'searchLog',null,$this->_searchLog);
		$this->_Gui->addTreeContent($ContGui);
	}
	function &showLogContent() {
		require_once('lib/class_ApplicationListGui.php');
		$rows=0;
		if (Framework::getParam('export_x',0)) {
			$this->_searchLog['b']=0;
			$this->_searchLog['limit']=0;
			$logEntries=$this->_Log->searchLog($rows,$this->_searchLog);

			$i=0;
			$row[$i][]=$this->_T->lang('[[Datum]]');
			$row[$i][]=$this->_T->lang('[[BenutzerIn]]');
			$row[$i][]=$this->_T->lang('[[Datei]]');
			$row[$i][]=$this->_T->lang('FileID');
			$row[$i][]=$this->_T->lang('[[Aktion]]');
			$i++;
			foreach ($logEntries as $val) {
				$row[$i][]=Framework::dateSql('d.m.Y H:i',$val->getMeta('LogDate'));
				$row[$i][]=$this->_frm->getCachedUserName($val->getMeta('FKUserID'));
				$tmpObj=$this->_Base->getObj($val->getMeta('FKObjID'));
				if (is_object($tmpObj)) {
					$row[$i][]=$tmpObj->getName();
				} else {
					$row[$i][]='-';
				}
				$row[$i][]=$val->getMeta('FKObjID');
				$row[$i][]=$val->getMeta('LogDesc');
				$i++;
			}
			$this->_frm->exportCsv($row,';',false,'fileLog_'.date('Ymd').'.csv');
			exit;

		} else {
			$logEntries=$this->_Log->searchLog($rows,$this->_searchLog);

			$tabGui=new ApplicationListGui();
			$tabGui->setName($this->_T->lang('[[Logbuch]]'));

			$navLink=Framework::cloneObj($this->_L);
			$navLink->setParam('_loadSearch','searchLog');
			$tabGui->setNavLink($navLink);
			$tabGui->setLimit($this->_searchLog['limit']);
			$tabGui->setSumRows($rows);
			$tabGui->setBegin($this->_searchLog['b']);


			$tabGui->addHeaderCol('LogDate',$this->_T->lang('[[Datum]]'),'','','',1,'');
			$tabGui->addHeaderCol('LogUser',$this->_T->lang('[[BenutzerIn]]'),'','','',1,'');
			$tabGui->addHeaderCol('LogObj',$this->_T->lang('[[Datei]]'),'','','',1,'');
			$tabGui->addHeaderCol('LogObjID','FileID','','','',1,'');
			$tabGui->addHeaderCol('LogVal',$this->_T->lang('[[Aktion]]'),'','','',1,'');
			if ($rows) {
				$logValues=$this->_Log->listLogValues(array_keys($logEntries));

				foreach ($logEntries as $val) {
					$hl=($hl?$hl=0:$hl=1);
					$tabGui->addRow($hl,'top','');
					$tabGui->addCol('LogDate',Framework::dateSql('d.m.Y H:i',$val->getMeta('LogDate')),'','','',1,'');
					$tabGui->addCol('LogUser',$this->_frm->getCachedUserName($val->getMeta('FKUserID')),'','','',1,'');
					$tmpObj=$this->_Base->getObj($val->getMeta('FKObjID'));
					if (is_object($tmpObj)) {
						$tabGui->addCol('LogObj',$tmpObj->getName(),$tmpObj->getImage(),'','',1,'');
					} else {
						$tabGui->addCol('LogObj','-','obj_img/ex_trash.gif','','',1,'');
					}
					$tabGui->addCol('LogObjID',$val->getMeta('FKObjID'),'','','',1,'');

					$tabGui->addCol('LogDesc',$val->getMeta('LogDesc'),'','','',0,'1000');

				}

			}
			$this->_Gui->addContent($tabGui);
		}
	}



	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result) $result=$default;
		return $result;
	}

}
?>