<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$obj_action=$frm->getObjAction($Fmng->getModul(),$obj->getActionMode(0));
if ($Fmng->isAllowedAction($obj,$obj_action[$new])) {
	switch ($new) {
		case 'n_fol':
			$new_obj=new FObj_fol();
			$new_obj->setMeta('DocType','fol');
			$new_obj->setMeta('MenuImage','tree.gif');
			$new_obj->setParentMeta('ParentID',$obj->getID());
			$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
			break;
		case 'n_ext':
			$new_obj=new FObj_ext();
			$new_obj->setMeta('DocType','ext');
			$new_obj->setMeta('MenuImage','other.gif');
			$new_obj->setParentMeta('ParentID',$obj->getID());
			$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
			break;
	}
	$new_obj->setAcl(-1);
	$meta_action=$frm->getObjAction($Fmng->getModul(),'e_'.$new_obj->getActionMode(0));

	//Title
	if ($Fmng->isAllowedAction($new_obj,$meta_action['e|title'])) {
		if ($ObjLang || !$Fmng->isAllowedAction($new_obj,$meta_action['e|title_lang'])) {
			if (trim($_POST['ObjTitle_'.$session_lang])) {
				foreach ($CFG['AV_LANG'] as $val) {
					if ($Fmng->nameExists($_POST['ObjTitle_'.$session_lang],$new_obj->getParentMeta('ParentID'),0,$val)) {
						$ActionError['fields']['ObjTitle_'.$session_lang]=1;
						break;
					}
					$new_obj->setMeta('Title_'.$val,$_POST['ObjTitle_'.$session_lang]);
				}
			} else {
				$ActionError['fields']['ObjTitle_'.$session_lang]=1;
			}
		} else {
			foreach ($CFG['AV_LANG'] as $val) {
				if (in_array($val,$CFG['MA_LANG'])) {
					if (trim($_POST['ObjTitle_'.$val])) {
						if ($Fmng->nameExists($_POST['ObjTitle_'.$val],$new_obj->getParentMeta('ParentID'),0,$val)) {
							$ActionError['fields']['ObjTitle_'.$val]=1;
						} else {
							$new_obj->setMeta('Title_'.$val,trim($_POST['ObjTitle_'.$val]));
						}
					} else {
						$ActionError['fields']['ObjTitle_'.$val]=1;
					}
				} else {
					if (trim($_POST['ObjTitle_'.$session_lang])) {
						if ($Fmng->nameExists($_POST['ObjTitle_'.$session_lang],$new_obj->getParentMeta('ParentID'),0,$val)) {
							$ActionError['fields']['ObjTitle_'.$session_lang]=1;
						} else {
							$new_obj->setMeta('Title_'.$val,trim($_POST['ObjTitle_'.$session_lang]));
						}
					} else {
						$ActionError['fields']['ObjTitle_'.$session_lang]=1;
					}
				}

			}
		}
	}
	//Text
	if ($Fmng->isAllowedAction($new_obj,$meta_action['e|text'])) {
		$new_obj->setMeta('Text',trim($_POST['ObjText']));
	}
	//File
	if (!$new_obj->isFolder() && $Fmng->isAllowedAction($new_obj,$meta_action['e|upload'])) {
		$file=$_FILES['ext_file']['tmp_name'];
		if ($file && $file!='none' && file_exists($file)) {
			if (!trim($_POST['ObjTitle_'.$session_lang])) {
				foreach ($CFG['AV_LANG'] as $val) {
					$new_obj->setMeta('Title_'.$val,$_FILES['ext_file']['name']);
				}
				unset($ActionError['fields']['ObjTitle_'.$session_lang]);
			}
			$ext=$Fmng->getExt($_FILES['ext_file']);
			foreach($CFG['AV_LANG'] as $val) {
				$new_obj->setMeta('Title_'.$val,$Fmng->replaceExt($new_obj->getMeta('Title_'.$val),$ext));
			}
		} else {
			$ActionError['no_valid_file']=true;
		}
	}

	if (!$ActionError) {
		$new_obj->setMeta('Version',1);
		$new_obj->setMeta('TimeCreate',time());
		$new_obj->setMeta('TimeModify',time());
		$new_obj->setMeta('UserCreate',$user_id);
		$new_obj->setMeta('UserModify',$user_id);
		$new_obj->setMeta('Users',$obj->getMeta('Users'));
		$new_obj->setMeta('Groups',$obj->getMeta('Groups'));
		$new_obj->setParentMeta('ParentID',$obj->getID());
		$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
		$new_obj->setParentMeta('UserID',$obj->getParentMeta('UserID'));
		if ($Fmng->insertMeta($new_obj)) {
			$Fmng->insertParentMeta($new_obj);
		}
		if (!$new_obj->isFolder() && $Fmng->isAllowedAction($new_obj,$meta_action['e|upload'])) {
			$error=$Fmng->replaceFile($new_obj,$Fmng->getModul(),$new_obj->getID(),$_FILES['ext_file']);
			if ($error===false){
				$Fmng->updateMeta($new_obj);
			} else {
				$ActionError[$error]=true;
				$Fmng->deleteMeta($new_obj);
				$Fmng->deleteParentMeta($new_obj);
			}
		}
		if (!$ActionError) {
			if ($FavInsert) {
				$new_obj->setFileMeta('Favorite',1);
				$Fmng->setFavorite($new_obj);
			}
			page_close();
			header("Location:index.php?site=$site&oid=".$new_obj->getID());
			exit;
		}
	}


}
?>