<?php
class ListImngGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	function __construct($Obj) {
		global $frm,$t,$T,$E,$L;
		$this->_Base=& $frm->getStaticModul('imng');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('imng');
		$this->_Obj=$Obj;
		if (substr($this->_Obj->getMeta('EscalationGroups'),1,-1) || substr($this->_Obj->getMeta('EscalationUsers'),1,-1)) {
			$this->_escObj=$this->_Base->listEscalationObj(array('ID'=>$this->_Obj->getID(),'Confirmed'=>-1));
		} else {
			$this->_escObj=array();
		}
		if($this->_Obj->getStatus()!=3 && $this->_Obj->getParentMeta('ParentID')) {
			$this->_L->setParam(array('oid'=>$this->_Obj->getParentMeta('ParentID')));
			$this->_L->unsetParam(array('action'));
			$this->_L->goToLink();
		}

		require_once('lib/class_TemplateGui.php');
		$this->_AppGui=new TemplateGui('core/common_form.inc.html');
		require_once('lib/class_ApplicationTreeGui.php');
		$this->_Gui=new ApplicationTreeGui();
		$this->_avModes=array(
			'esc'=>$this->_T->lang('[[Dokumente mit Bestaetigung]]'),
			'fav'=>$this->_T->lang('[[Favoriten]]'),
			'used'=>$this->_T->lang('[[Meist besuchte Dokumente]]'),
			'last'=>$this->_T->lang('[[Zuletzt besuchte Dokumente]]'),
			'new'=>$this->_T->lang('[[Neuzugaenge]]'),
		);
		$this->_escModes=array(
			'akt_1'=>$this->_T->lang('[[Aktive Dokumente mit Verfallsdatum]]'),
			'akt_0'=>$this->_T->lang('[[Aktive Dokumente ohne Verfallsdatum]]'),
			'inv_1'=>$this->_T->lang('[[Abgelaufene Dokumente mit Verfallsdatum]]'),
			'inv_0'=>$this->_T->lang('[[Abgelaufene Dokumente ohne Verfallsdatum]]'),
		);
	}
	function _handleRequest() {
		$this->_action=Framework::getParam('action',$this->_Obj->getAction(0));
		$this->_mode=$this->_Base->getMode();
		$this->_rootObj=$this->_Base->getRootObj();
		if (FrameWork::getParam('confirm_x') && isset($this->_escObj[$this->_Obj->getID()])) {
			$this->_Obj->setFavoriteMeta('Confirmed',time());
			$this->_Base->insertFavoriteMeta($this->_Obj);
		}
	}
	function &process() {
		$this->_handleRequest();
		switch($this->_action) {
			case 'b':
				if ($this->_rootObj->getMeta('System')=='d') {
					$this->processOverviewTree();
					if (!$this->_mode ) {
						$this->processOverviewList();
					} else {
						$this->processList();
					}
				} else {
					$this->processTree();
					$this->processList();
				}
			break;
			case 'vo':
			case 'wd':
				$this->_Obj->setFavoriteMeta('Counter',$this->_Obj->getFavoriteMeta('Counter')+1);
				$this->_Obj->setFavoriteMeta('TimeLast',time());
				$this->_Base->insertFavoriteMeta($this->_Obj);

				$this->processTree();
				$this->processView();
			break;
			case 'esc':
				$this->processEscTree();
				$this->processEscList();
			break;
			case 'esc_v':
				$this->processEscTree();
				$this->processEscView();
			break;
		}
		$this->_AppGui->addContent('cont1',$this->_Gui,'CONTENT');
		$this->_AppGui->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
		return $this->_AppGui;
	}
	function &processOverviewTree() {
		require_once('lib/class_ApplicationListGui.php');
		$Gui=new ApplicationListGui();
		foreach ($this->_avModes as $mode=>$modeText) {
			$Gui->addRow($mode==$this->_mode?2:0);
			$Gui->addCol('IMG','','obj_img/ex_tree.gif');
			$Gui->addCol('Name',$modeText,'',$this->_L->getTempLink(array('oid','action'),array('mode'=>$mode)),'',0,'2000');
		}
		$this->_Gui->addTreeContent($Gui);
	}
	function &processEscTree() {
		require_once('lib/class_ApplicationListGui.php');
		$Gui=new ApplicationListGui();
		foreach ($this->_escModes as $mode=>$modeText) {
			$Gui->addRow($mode==$this->_mode?2:0);
			$Gui->addCol('IMG','','obj_img/ex_tree.gif');
			$Gui->addCol('Name',$modeText,'',$this->_L->getTempLink(array('oid'),array('mode'=>$mode,'action'=>'esc')),'',0,'2000');
		}
		$this->_Gui->addTreeContent($Gui);
	}
	function &processTree() {
		$root_id=$this->_rootObj->getID();
		$ex_link=$this->_L->getTempLink();
		$ac_link=$this->_L->getTempLink(array('oid','action'));
		require_once('lib/class_ObjAjaxTreeGui.php');
		$ObjAjaxTreeGui=new ObjAjaxTreeGui(1);
		$ObjAjaxTreeGui->setAllexpand(0);
		$up_tree=false;
		if (Framework::getParam('_open',0,'G')==1) {
			$ObjAjaxTreeGui->setAllexpand(1);
		} elseif (Framework::getParam('_open',0,'G')==-1) {
			$open_tree='|';
			$this->_frm->setTree($this->_Base->getModul(),$root_id,$open_tree);
		} else {
			$open_tree=$this->_frm->getTree($this->_Base->getModul(),$root_id);
			if (Framework::getParam('_x',0,'G')) {
				$this->_frm->updateTree($open_tree,base64_encode(Framework::getParam('_x',0,'G')),'|');
				//echo $open_tree;
				$this->_frm->setTree($this->_Base->getModul(),$root_id,$open_tree);
			}
		}
		//debug($open_tree);
		$expand=array();
		foreach (explode('|',$open_tree) as $val) {
			$tmp=base64_decode($val);
			if ($tmp && is_string($tmp)) $expand[$tmp]=1;
		}
		$expand[$this->_rootObj->getID()]=1;
		if ($this->_Obj->isFolder() && !$expand[$this->_Obj->getID()]) {
			$expand[$this->_Obj->getID()]=1;
			$this->_frm->updateTree($open_tree,base64_encode($this->_Obj->getID()),'|');
			$this->_frm->setTree($this->_Base->getModul(),$root_id,$open_tree);
		}
		//debug($expand);
		$ObjAjaxTreeGui->setSelectedID($this->_Obj->getID());
		$ObjAjaxTreeGui->setEncodeID(true);
		$ObjAjaxTreeGui->setCallback(array(&$this->_Base,'listSubTree'));
		$ObjAjaxTreeGui->setCallbackLen(array(&$this->_Base,'isSubTreeLen'));
		$ObjAjaxTreeGui->setExpand($expand);
		$ObjAjaxTreeGui->setExLink($ex_link."&_x={OID}");
		$ObjAjaxTreeGui->setAcLink($ac_link."&action={ACTION}&oid={OID}");
		$ObjAjaxTreeGui->setOpenCloseLink($ex_link."&_open={MODE}");
		$ObjAjaxTreeGui->setImgPath("img/".APP_THEME);
		$ObjAjaxTreeGui->setColors(APP_BGCOLOR,APP_FG10COLOR);
		$ObjAjaxTreeGui->setRootObj($this->_rootObj);
		$ObjAjaxTreeGui->setRootID($root_id);
		$ObjAjaxTreeGui->setModul($this->_Base->getModul());
		$this->_Gui->addTreeContent($ObjAjaxTreeGui,$this->_rootObj->getID());
	}
	function &processOverviewList() {
		require_once('lib/class_ApplicationListGui.php');
		foreach ($this->_avModes as $mode=>$modeText) {
			$order='';
			$use_limit=false;
			$search_sql='';
			switch ($mode) {
				case 'fav':
					$search_sql.="Trash=0 AND Favorite=1";
					$limit=0;
					$order="DocType DESC";
					//$use_limit=true;
				break;
				case 'esc':
					$search_sql.="Trash=0 AND DocType='doc' AND (Confirmed=0 OR Confirmed IS NULL)";
					$search_sql.=" AND (EscalationUsers LIKE '%|".$this->_Base->getUser()."|%' OR  EscalationGroups LIKE '%|".implode("|%' OR EscalationGroups LIKE '%|",$this->_Base->getGroups())."|%')";
					$limit=0;
					$order="DocType DESC";
					//$use_limit=true;
				break;
				case 'used':
					$search_sql.="Trash=0 AND DocType='doc' AND Counter!=0";
					$order="Counter DESC";
					$limit=5;
				break;
				case 'last':
					$search_sql.="Trash=0 AND DocType='doc' AND TimeLast!=0";
					$order="TimeLast DESC";
					$limit=5;
				break;
				case 'new':
					$search_sql.="Trash=0 AND DocType='doc'";
					$order="TimeCreate DESC";
					$limit=5;
				break;
			}

			if ($order) {
				$order.=','.'Title_'.$this->_Base->getLangID().' ASC';;
			} else {
				$order='Title_'.$this->_Base->getLangID().' ASC';
			}

			$rows=0;$b=0;
			$ftree=$this->_Base->searchObj($rows,$b,$limit,$search_sql,$order,$use_limit);
			$num_entrys=count($ftree);
			if ($num_entrys) {

				$lGui=new ApplicationListGui();
				$lGui->addHeaderCol('Title',$modeText,'','','',0,2000);
				$lGui->addHeaderCol('UserCreate',$this->_T->lang('[[Erstellt von]]'),'','','',1);
				$lGui->addHeaderCol('TimeCreate',$this->_T->lang('[[Erstellt am]]'),'','','',1);
				$lGui->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);
				$lGui->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','',1);

				foreach ($ftree as $val) {
					if ($mode=='esc' && $val->getMeta('EscalationEnd')>0 && $val->getMeta('EscalationEnd')<mktime(23,59,59)) {
						$lGui->addRow(2,'top');
					} else {
						$lGui->addRow($hl?$hl=0:$hl=1,'top');
					}
					$goLink=$this->_L->getTempLink(null,array('action'=>$val->getAction(0),'oid'=>$val->getID()));
					$extra=array();
					if ($val->getACL(2)) {
						$extra['LinkAttribs']=array(
							'onclick'=>'return goToView(this);',
							'ondblclick'=>'return goToEdit(this,\'action='.$val->getAction(0).'\',\'action='.$val->getAction(1).'\');',
						);
					}
					$lGui->addCol('Title',$val->getName(),$val->getImage(0),$goLink,'',0,'',0,'',$extra);
					$lGui->addCol('UserCreate',$this->_frm->getCachedUserName($val->getMeta('UserCreate'),1,1),'','','',1);
					$lGui->addCol('TimeCreate',date('d.m.Y',$val->getMeta('TimeCreate')),'','','',1);
					$lGui->addCol('UserModify',$this->_frm->getCachedUserName($val->getMeta('UserModify'),1,1),'','','',1);
					$lGui->addCol('TimeModify',date('d.m.Y',$val->getMeta('TimeModify')),'','','',1);
				}
				$this->_Gui->addContent(clone $lGui);
			}
		}
	}
	function processHeader() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FormGui.php');

		$this->_frm->addOnload('e7gMsgIntitObj('.json_encode(array(
			'typ'=>'imng',
			'id'=>$this->_Obj->getID(),
			'name'=>$this->_Obj->getName(),
			'link'=>"index.php?site=imng.php&action=".$this->_Obj->getAction(0)."&oid=".$this->_Obj->getID().'&go_b=1',
		)).');');
		
		$hGui=new ApplicationListGui();
		$hGui->setRowClass(array(0=>'list',1=>'list_b'));
		$hGui->setName($this->_Obj->getName());
		$objActionGui=new FunctionObjActionGui();
		$obj_action=$this->_frm->getObjAction($this->_Base->getModul(),'p_'.$this->_Obj->getActionMode(0));
		foreach ($obj_action as $key=>$val) {
			if ($val['Hidden'] || !$this->_Base->isAllowedAction($this->_Obj,$val)) continue;
			$objActionGui->addValue($key,$val['Name']);
		}
		$hGui->addRow(0,'top');

		$tGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tGui->setRowClass(array(0=>'list',1=>'list_b'));
		$tGui->addRow(1,'top');
		$tGui->addCol('Col1',$this->_Obj->getName(),'','','',0,2000);
		$tGui->addRow(0,'top');
		$tGui->addCol('Col1',$this->_Obj->getMeta('Text'),'','','',0,2000);

		$extraB=array('Attribs'=>array('style'=>'font-weight:normal;'));
		$extraR=array('Attribs'=>array('style'=>'font-weight:bold;color:red;'));

		$hGui->addCol('Col1',$tGui,'','','',0,2000);

		$mGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$mGui->setRowClass(array(0=>'list',1=>'list_b'));
		/*$mGui->addRow(1,'top');
		$mGui->addCol('Col1',$this->_T->lang('[[Erstellt von]]'),'','','',1);
		$mGui->addCol('Col2',$this->_T->lang('[[am]]'),'','','',0,2000);
		$mGui->addRow(0,'top');
		$mGui->addCol('Col1',$this->_frm->getCachedUserName($this->_Obj->getMeta('UserCreate'),1,1),'','','',1);
		$mGui->addCol('Col2',date('d.m.Y',$this->_Obj->getMeta('TimeCreate')),'','','',1);;*/
		$mGui->addRow(1,'top');
		$mGui->addCol('Col1',$this->_T->lang('[[Geaendert von]]'),'','','',1);
		$mGui->addCol('Col2',$this->_frm->getCachedUserName($this->_Obj->getMeta('UserModify'),1,1),'','','',1,'',0,'',$extraB);
		$mGui->addCol('Col3',$this->_T->lang('[[am]]'),'','','',1);
		$mGui->addCol('Col4',date('d.m.Y',$this->_Obj->getMeta('TimeModify')),'','','',1,'',0,'',$extraB);

		if ($this->_Obj->getMeta('PublishEnd')>0) {
			$mGui->addRow(1,'top');
			$mGui->addCol('Col1',$this->_T->lang('[[Gueltig bis]]'),'','','right',1,0,3);
			$mGui->addCol('Col4',date('d.m.Y',$this->_Obj->getMeta('PublishEnd')),'','','',1,'',0,'',$extraB);
		}



		$hGui->addCol('Col2',$mGui,'','','',1,'300');


		if (isset($this->_escObj[$this->_Obj->getID()])) {
			if ($this->_Obj->getFavoriteMeta('Confirmed')) {
				$mGui->addRow(1,'top');
				$mGui->addCol('Col1',$this->_T->lang('[[Bestaetigt am]]'),'','','right',1,0,3);
				$mGui->addCol('Col4',date('d.m.Y',$this->_Obj->getFavoriteMeta('Confirmed')),'','','',1,'',0,'',$extraB);

			} else {
				$formGui=new FormGui();
				$formGui->addField('confirm_x','submit','',$this->_T->lang('[[Ich habe das Dokument gelesen]]'),'fields1');

				$hGui->addRow(1,'top');
				$hGui->addCol('Col1',$formGui,'','','',0,'',2);

				$escalEnd=$this->_Obj->getMeta('EscalationEnd');
				if (!$escalEnd) $escalEnd=$this->_Obj->getMeta('PublishEnd');
				if ($escalEnd>0) {
					$mGui->addRow(1,'top');
					$mGui->addCol('Col1',$this->_T->lang('[[Bestaetigung innerhalb]]'),'','','right',1,0,3,'',$escalEnd<mktime(23,59,59)?$extraR:'');
					$mGui->addCol('Col4',date('d.m.Y',$this->_Obj->getMeta('EscalationEnd')),'','','',1,'',0,'',$extraB);
				}
			}

		}



		$hGui->addFunction($objActionGui,1);
		if (FrameWork::getParam('go_b',0)) {
			$lBack=$_SERVER['HTTP_REFERER'];
		} else {
			$lBack=$this->_L->getTempLink(array('action'),array('oid'=>$this->_Obj->getParentMeta('ParentID')));
		}
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$lBack));
		$hGui->addFunction($btBreak,1);

		$this->_Gui->addContent($hGui);
	}
	function processList() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FunctionObjActionGui.php');

		$lGui=new ApplicationListGui();
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		$btnList=new CheckBoxBtn ('ListID[]','');
		$btnList->setAttribs(array(
			'onclick'=>'return false;',
		));
		$funcSelAll=new FunctionButtons('addr_list','selectall',array('ListID'=>'ListID[]','ListOn'=>false));
		$lGui->setTrOver('trBOC({ROW},this);');
		$lGui->setTrDown('trBOI({ROW},this,1);');
		$lGui->addHeaderCol('ListID',$funcSelAll,'','','',1,'1%',0,'');
		$lGui->addHeaderCol('Title',$this->_T->lang('[[Titel]]'),'','','',0,2000,2);

		$order='';
		$use_limit=false;
		$search_sql='';
		$b=0;

		if ($this->_rootObj->getMeta('System')=='d') {
			switch ($this->_mode) {
				case 'fav':
					$search_sql.="Trash=0 AND Favorite=1";
					$limit=20;
					$order="DocType DESC";
					//$use_limit=true;
				break;
				case 'esc':
					$search_sql.="Trash=0 AND DocType='doc' AND (Confirmed=0 OR Confirmed IS NULL)";
					$search_sql.=" AND (EscalationUsers LIKE '%|".$this->_Base->getUser()."|%' OR  EscalationGroups LIKE '%|".implode("|%' OR EscalationGroups LIKE '%|",$this->_Base->getGroups())."|%')";
					$limit=0;
					$order="DocType DESC";
					//$use_limit=true;
				break;
				case 'used':
					$search_sql.="Trash=0 AND DocType='doc' AND Counter!=0";
					$order="Counter DESC";
					$limit=20;
				break;
				case 'last':
					$search_sql.="Trash=0 AND DocType='doc' AND TimeLast!=0";
					$order="TimeLast DESC";
					$limit=20;
				break;
				case 'new':
					$search_sql.="Trash=0 AND DocType='doc'";
					$order="TimeCreate DESC";
					$limit=20;
				break;
				default:
					$info=Framework::getParam('sort');
					//$t->assign('LIST_SORT',$sort);
					$search_sql.="Trash=0 AND DocType='doc' AND Title_".$this->_Base->getLangID()." LIKE '".addslashes($info)."%'";
					$limit=20;
					$use_limit=true;
					$b=Framework::getParam('b',0);
				break;
			}
		} else {
			$this->processHeader();

			$search_sql="Trash=0 AND ParentID=".$this->_Obj->getID();
			$search_sql.=" AND (LangID='".$this->_Base->getLangID()."' OR LangID='00')";
			$limit=0;
		}
		if ($order) {
			$order.=','.'Title_'.$this->_Base->getLangID().' ASC';;
		} else {
			$order='Title_'.$this->_Base->getLangID().' ASC';
		}
		$rows=0;
		$ftree=$this->_Base->searchObj($rows,$b,$limit,$search_sql,$order,$use_limit);

		$lGui->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);
		$lGui->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','',1);

		$lGui->setLimit($limit);
		$lGui->setSumRows($rows);
		$lGui->setBegin($b);
		$lGui->setNavLink($this->_L);

		foreach ($ftree as $val) {
			if ($this->_mode=='esc' && $val->getMeta('EscalationEnd')>0 && $val->getMeta('EscalationEnd')<mktime(23,59,59)) {
				$lGui->addRow(2,'top');
			} else {
				$lGui->addRow($hl?$hl=0:$hl=1,'top');
			}
			$lGui->addCol('ListID',$btnList->process($val->getID()),'','','',1,'1%',0,'',$noEnc);
			$lGui->addCol('ListImg','',$val->getImage(0),'','',1,'');
			$goLink=$this->_L->getTempLink(null,array('action'=>$val->getAction(0),'oid'=>$val->getID()));
			$extra=array();
			if ($val->getACL(2)) {
				$extra['LinkAttribs']=array(
					'onclick'=>'return goToView(this);',
					'ondblclick'=>'return goToEdit(this,\'action='.$val->getAction(0).'\',\'action='.$val->getAction(1).'\');',
				);

			}

			$lGui->addCol('Title',$val->getName(),'',$goLink,'',0,'2000',0,'',$extra);
			$lGui->addColSub('Title','N',$val->getMeta('Text'));
			$lGui->addCol('UserModify',$this->_frm->getCachedUserName($val->getMeta('UserModify'),1,1),'','','',1);
			$lGui->addCol('TimeModify',date('d.m.Y',$val->getMeta('TimeModify')),'','','',1);
		}

		$funcAction=new FunctionObjActionGui('list_action',1);
		$funcAction->setName($this->_T->lang('[[Ausgewaehlte Objekte]]'));
		$list_action=$this->_frm->getObjAction($this->_Base->getModul(),'p_m_all');
		foreach ($list_action as $key=>$val) {
			if ($val['Hidden'] || !$this->_Base->isAllowedAction($this->_Obj,$val)) continue;
			$funcAction->addValue($key,$val['Name']);
		}
		$lGui->addFunction($funcAction);

		$this->_Gui->addContent(clone $lGui);


	}
	function processView() {
		global $xmlFastText,$xml;
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FastTemplateGui.php');
		$webGui=new FastTemplateGui('imng/web_page.inc.html');
		$webGui->setEncode(false);
		$this->processHeader();

		if ($this->_Obj->getMeta('Content')) {
			$xml_text=$this->_Base->getContent($this->_Obj->getMeta('Content'),$this->_Obj->getMeta('Version'));
			if ($xml_text) {
				$xml->parseText($xml_text);
				$xmlFastText->setImgFunction('formatImgSrc');
				$xmlFastText->setLinkFunction('formatLink');
				$xmlFastText->init('preview_int');

				$Gui=new ApplicationListGui();
				$Gui->setRowClass(array(0=>'list',1=>'list_b'));
				//$Gui->setName($this->_Obj->getName());
				$Gui->addRow(0,'top');

				//debug($xmlFastText->getValue('page|width'));
				$noEnc=array('NoEnc'=>1,'NoBr'=>1);
				$extra=$noEnc;
				$extra['Attribs']=array('style'=>'background-color:#eee;');

				$Gui->addCol('SpcLeft','&nbsp;','','','',1,'20',1,'',$extra);

				$webGui->assign('CONTENT',$xmlFastText->getHtml($xml->get_node(0)));
				$webGui->assign('CLASS',$xmlFastText->getStyle('page|class|edit'));
				$webGui->assign('WIDTH',$xmlFastText->getValue('page|width'));
				
				$Gui->addCol('Content',$webGui,'','','',0,$xmlFastText->getValue('page|width'));

				$Gui->addCol('SpcRight','&nbsp;','','','',0,'2000',0,'',$extra);

				$this->_Gui->addContent($Gui);

				if ($webGui->issetkey('anchors')) {
					$anchors=$xmlFastText->getAnchors();
					$webGui->clear_dynamic('anchors_row');
					if (!empty($anchors)) {
						foreach ($anchors as $a_key=>$a_name) {
							$webGui->assign('L_ANCHOR',$a_key);
							$webGui->assign('N_ANCHOR',$xmlFastText->entities($a_name));
							$webGui->parse('ROW','.anchors_row');
						}
						$webGui->parse('ROW','anchors');
					}
				}
			}
		}
	}
	function processEscList() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FunctionObjActionGui.php');

		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		/*$btnList=new CheckBoxBtn ('ListID[]','');
		$btnList->setAttribs(array(
			'onclick'=>'return false;',
		));
		$funcSelAll=new FunctionButtons('addr_list','selectall',array('ListID'=>'ListID[]','ListOn'=>false));
		$lGui->setTrOver('trBOC({ROW},this);');
		$lGui->setTrDown('trBOI({ROW},this,1);');
		$lGui->addHeaderCol('ListID',$funcSelAll,'','','',1,'1%',0,'');
		$lGui->addHeaderCol('Title',$this->_T->lang('[[Titel]]'),'','','',0,2000,2);*/

		$b=FrameWork::getParam('b');
		$order='';
		$search_sql='';

		if ($this->_mode) {
			$modes=array($this->_mode);
			$limit=50;
			$use_limit=true;
		} else {
			$modes=array_keys($this->_escModes);
			$limit=20;
			$use_limit=false;
			$b=0;
		}
		foreach ($modes as $mode) {
			switch ($mode) {
				case 'akt_1':
					$search=array('Publish'=>1,'MinEscalationEnd'=>1);
					$order="IF(EscalationEnd>0,EscalationEnd,PublishEnd) ASC";
				break;
				case 'akt_0':
					$search=array('Publish'=>1,'NoEscalationEnd'=>1);
					$order="TimeCreate ASC";
				break;
				case 'inv_1':
					$search=array('Publish'=>-1,'MinEscalationEnd'=>1);
					$order="IF(EscalationEnd>0,EscalationEnd,PublishEnd) DESC";
				break;
				case 'inv_0':
					$search=array('Publish'=>-1,'NoEscalationEnd'=>1);
					$order="TimeCreate DESC";
				break;
			}
			$rows=0;
			$entrys=$this->_Base->searchEscalationObj($rows,$search,$b,$limit,$order,$use_limit);

			$lGui=new ApplicationListGui();
			$lGui->setName($this->_escModes[$mode]);
			$lGui->addHeaderCol('Title',$this->_T->lang('[[Titel]]'),'','','',0,2000);
			$lGui->addHeaderCol('PublishStart',$this->_T->lang('[[Gueltig von]]'),'','','',1);
			$lGui->addHeaderCol('PublishEnd',$this->_T->lang('[[Gueltig bis]]'),'','','',1);
			$lGui->addHeaderCol('EscalationEnd',$this->_T->lang('[[Bestaetigung innerhalb]]'),'','','',1);
			$lGui->addHeaderCol('ConfUsers',$this->_T->lang('[[Anzahl BenutzerInnen]]'),'','','',1);
			$lGui->addHeaderCol('ConfOK',$this->_T->lang('[[Anzahl bestaetigt]]'),'','','',1);
			//$lGui->addHeaderCol('UserModify',$this->_T->lang('[[Geaendert von]]'),'','','',1);
			//$lGui->addHeaderCol('TimeModify',$this->_T->lang('[[Geaendert am]]'),'','','',1);

			$lGui->setLimit($limit);
			$lGui->setSumRows($rows);
			$lGui->setBegin($b);
			$lGui->setNavLink($this->_L);

			if ($rows) {
				$confUsers=$this->_Base->listEscalationConfirmed(array_keys($entrys));
				foreach ($entrys as $val) {
					$aktUsers=array();
					if (substr($val->getMeta('EscalationUsers'),1,-1)) {
						$aktUsers=array_merge($aktUsers,explode('|',substr($val->getMeta('EscalationUsers'),1,-1)));
					}
					if (substr($val->getMeta('EscalationGroups'),1,-1)) {
						$tmp=explode('|',substr($val->getMeta('EscalationGroups'),1,-1));
						foreach ($tmp as $v) {
							if ($v) $aktUsers=array_merge($aktUsers,$this->_frm->getCachedGroupUsers($v));
						}
					}

					$lGui->addRow($hl?$hl=0:$hl=1,'top');
					$lGui->addCol('Title',$val->getName(),$val->getImage(0),$this->_L->getTempLink(null,array('action'=>'esc_v','oid'=>$val->getID())),'',0,'2000',0,'');
					$timeP=$timeE=0;
					if($val->getMeta('PublishEnd')>1) {
						$timeP=$timeE=$val->getMeta('PublishEnd');
					}
					if ($val->getMeta('EscalationEnd')>1) {
						$timeE=$val->getMeta('EscalationEnd');
					}

					$lGui->addCol('PublishStart',$val->getMeta('PublishStart')>0?date('d.m.Y',$val->getMeta('PublishStart')):'-','','','center',1);
					$lGui->addCol('PublishEnd',$timeP?date('d.m.Y',$timeP):'-','','','center',1);
					$lGui->addCol('EscalationEnd',$timeE?date('d.m.Y',$timeE):'-','','','center',1);
					$lGui->addCol('ConfUsers',count(array_unique($aktUsers)),'','','center',1);
					$lGui->addCol('ConfOK',isset($confUsers[$val->geTID()])?count($confUsers[$val->geTID()]):'-','','','center',1);
					//$lGui->addCol('UserModify',$this->_frm->getCachedUserName($val->getMeta('UserModify'),1,1),'','','',1);
					//$lGui->addCol('TimeModify',date('d.m.Y',$val->getMeta('TimeModify')),'','','',1);
				}
			}
			$this->_Gui->addContent(clone $lGui);
		}
	}
	function processEscView() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');

		$hGui=new ApplicationListGui();
		$hGui->setName($this->_Obj->getName());
		$hGui->addHeaderCol('ConfUser',$this->_T->lang('[[BenutzerIn]]'),'','','',1);
		$hGui->addHeaderCol('ConfOK',$this->_T->lang('[[Bestaetigt am]]'),'','','',0,2000);

		$confUsers=$this->_Base->listEscalationConfirmed($this->_Obj->getID());
		$aktUsers=array();
		if (substr($this->_Obj->getMeta('EscalationUsers'),1,-1)) {
			$aktUsers=array_merge($aktUsers,explode('|',substr($this->_Obj->getMeta('EscalationUsers'),1,-1)));
		}
		if (substr($this->_Obj->getMeta('EscalationGroups'),1,-1)) {
			$tmp=explode('|',substr($this->_Obj->getMeta('EscalationGroups'),1,-1));
			foreach ($tmp as $v) {
				if ($v) $aktUsers=array_merge($aktUsers,$this->_frm->getCachedGroupUsers($v));
			}
		}



		$entries=$this->_frm->getCachedUserName($aktUsers);
		foreach ($entries as $uid=>$val) {
			if (isset($confUsers[$this->_Obj->getID()][$uid])) {
				$confOk=$confUsers[$this->_Obj->getID()][$uid];
				$hGui->addRow($hl?$hl=0:$hl=1,'top');
			} else {
				$confOk=0;
				$hGui->addRow(2,'top');
			}
			$hGui->addCol('ConfUser',$val,'user.gif','','',1);
			$hGui->addCol('ConfOK',$confOk?date('d.m.Y',$confOk):'-','','','',1);
		}


		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'esc'))));
		$hGui->addFunction($btBreak,1);

		$this->_Gui->addContent($hGui);


	}

}
?>