<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
function CutCopyObject (&$obj,&$new_obj,$mode,$first=true) {
	global $Imng,$frm,$Bmng;

	if (is_object($new_obj)) {
		if ($mode=='link') {
			$ac_mode='copy';
		} else {
			$ac_mode=$mode;
		}
		if ($mode!='cut' || $first) {
			$nmode='n_';
			$nmode.=$new_obj->getMeta('DocType');
			$this_action=$frm->getObjAction ($Imng->getModul(),$new_obj->getActionMode(0),$ac_mode);
			$obj_action=$frm->getObjAction ($Imng->getModul(),$obj->getActionMode(0),$nmode);
			if ($Imng->isAllowedAction($new_obj,reset($this_action)) && $Imng->isAllowedAction($obj,reset($obj_action))) {
				if ( $new_obj->isFolder() && $Imng->isSubfolder($obj->getID(),$new_obj->getID())) {
					return array('to_self',$new_obj->getID());
				}
				/*
				if ($new_obj->getParentMeta('ParentID')==$obj->getID() && ($new_obj->getParentMeta('LangID')=='00' || $new_obj->getParentMeta('LangID')==$Imng->getLangID())) {
					if ($mode=='cut') {
						return;
					} elseif ($mode=='copy' || ($mode=='link' && $new_obj->isFolder())) {
						//$new_obj->setMeta('MenuTitle','copy of '.$new_obj->getMeta('MenuTitle'));
					} elseif ($mode=='link' ) {
						//$new_obj->setMeta('MenuTitle','link to '.$new_obj->getMeta('MenuTitle'));
					}
				}*/
				if (!$new_obj->isFolder() || $mode=='copy' ||  $mode=='link') {
					$new_obj->setMeta('Users',$obj->getMeta('Users'));
					$new_obj->setMeta('Groups',$obj->getMeta('Groups'));
				}
				$oldID=$new_obj->getID();
				$oldVersion=$new_obj->getMeta('Version');

				$new_obj->setMeta('TimeModify',time());
				$new_obj->setMeta('UserModify',$Imng->getUser());
				$new_obj->setMeta('Trash',$obj->getMeta('Trash'));
				$new_obj->setParentMeta('ParentID',$obj->getID());
				$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
				$new_obj->setParentMeta('Sequence',$Imng->getNextSequence($obj->getID()));
				if (!$new_obj->isFolder()) {
					$new_obj->setParentMeta('LangID',$Imng->getLangID());
				} else {
					$new_obj->setParentMeta('LangID',$obj->getParentMeta('LangID'));
				}
				if ($mode=='cut') {
					$Imng->updateMeta($new_obj);
					$Imng->updateParentMeta($new_obj);
				} elseif ($mode=='copy' || $mode=='link') {
					$new_obj->setMeta('TimeCreate',time());
					$new_obj->setMeta('UserCreate',$Imng->getUser());
					$new_obj->setMeta('Version',1);
					if (!$new_obj->isFolder() && $mode=='link' && !$new_obj->getMeta('Content')) {
						$new_obj->setMeta('Content',$oldID);
					}

					if ($new_obj->getMeta('DocType')=='doc' || $new_obj->getMeta('DocType')=='tdoc' || $new_obj->getMeta('DocType')=='bdoc') {
						$Bmng->copyImgUsed($Imng->getModul(),$oldID,$new_obj->getID());
					}

					$Imng->insertMeta($new_obj);
					$Imng->insertParentMeta($new_obj);
					if ($mode=='copy' && $new_obj->getMeta('Content')==$oldID) {
						if ($new_obj->getMeta('DocType')=='doc' || $new_obj->getMeta('DocType')=='tdoc' || $new_obj->getMeta('DocType')=='bdoc') {
							$Imng->saveContent($new_obj->getID(),1,$Imng->getContent($oldID,$oldVersion));
							$new_obj->setMeta('Content',$new_obj->getID());
							$Imng->updateMeta($new_obj);
						}
					}

				}
				if ($new_obj->isFolder()) {
					$sub_entrys=$Imng->ListSubEntrys($oldID,'');
					foreach ($sub_entrys as $tmp_obj) {
						CutCopyObject($new_obj,$tmp_obj,$mode,false);
					}
				}
			} else {
				return array("no_".$mode."_perms",$new_obj->getID());
			}
		} else {
			$new_obj->setMeta('Trash',$obj->getMeta('Trash'));
			$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
			$Imng->updateMeta($new_obj);
			$Imng->updateParentMeta($new_obj);
			$oldID=$new_obj->getID();
			if ($new_obj->isFolder()) {
				$sub_entrys=$Imng->ListSubEntrys($oldID,'',0);
				foreach ($sub_entrys as $tmp_obj) {
					CutCopyObject($new_obj,$tmp_obj,$mode,false);
				}
			}
		}
	}
	return false;
}


function TrashObject (&$obj,&$new_obj,$first=1) {
	global $Imng,$frm;
	$error=false;
	if (is_object($new_obj)) {
		$this_action=$frm->getObjAction ($Imng->getModul(),$new_obj->getActionMode(0),'delete');
		if ($new_obj->getParentMeta('RootID')==$obj->getParentMeta('RootID')) {
			return;
		}
		if ($Imng->isAllowedAction($new_obj,reset($this_action))) {
			$new_obj->setMeta('TimeModify',time());
			$new_obj->setMeta('UserModify',$Imng->getUser());
			$new_obj->setMeta('Trash',1);
			$new_obj->setParentMeta('ParentID',$obj->getID());
			$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
			$new_obj->setParentMeta('Sequence',$Imng->getNextSequence($obj->getID()));
			if ($new_obj->isFolder()) {
				$oldObj=Framework::cloneObj($new_obj);
				$Imng->insertMeta($new_obj);
				$Imng->insertParentMeta($new_obj);
				$sub_entrys=$Imng->ListSubEntrys($oldObj->getID());
				if (!empty($sub_entrys)) {
					$sub_ok=0;
					foreach ($sub_entrys as $tmp_obj) {
						$tmp_error=TrashObject($new_obj,$tmp_obj,0);
						if ($tmp_error) {
							$error=array('no_sub_del_perms',$oldObj->getID());
						} else {
							$sub_ok++;
						}
					}

					if (!$sub_ok) {
						$Imng->deleteParentMeta($new_obj);
						$Imng->deleteMeta($new_obj);
					}
				}
				if (!$error) {
					$Imng->deleteParentMeta($oldObj);
					$Imng->deleteMeta($oldObj);
				}
			} else {
				if ($new_obj->getMeta('Content')==$new_obj->getID()) {
					$linked_objs=$Imng->getLinkedObj($new_obj->getID(),false);
					foreach ($linked_objs as $link_obj) {
						$tmp_error=TrashObject($obj,$link_obj);
					}

				}
				$Imng->updateMeta($new_obj);
				$Imng->updateParentMeta($new_obj);
			}
		} else {
			return array('no_del_perms',$new_obj->getID());
		}
	}
	return $error;
}
function DeleteObject (&$new_obj) {
	global $frm,$Imng,$Bmng;
	if (is_object($new_obj)) {
		$this_action=$frm->getObjAction ($Imng->getModul(),$new_obj->getActionMode(0),'f_delete');
		if ($Imng->isAllowedAction($new_obj,reset($this_action))) {
			if ($new_obj->isFolder()) {
				$sub_entrys=$Imng->ListSubEntrys($new_obj->getID());
				foreach ($sub_entrys as $tmp_obj) {
					DeleteObject($tmp_obj);
				}
			}
			switch ($new_obj->getMeta('DocType')) {
				case 'ext':
					if ($new_obj->getMeta('Content')==$new_obj->getID()) {
						$Imng->deleteFile($Imng->getModul(),$new_obj->getMeta('Content'));
					}
				break;
				case 'doc':
				case 'bdoc':
				case 'tdoc':
					if ($new_obj->getMeta('Content')==$new_obj->getID()) {
						$Imng->deleteContent($new_obj->getID(),-1);
						$Imng->deleteContentTemp($new_obj->getID(),1);
					}
					$Bmng->deleteImgUsed($Imng->getModul(),$new_obj->getID());
				break;
				case 'fol':
					$Imng->deleteOrder($new_obj->getID());
				break;
			}
			$Imng->deleteParentMeta($new_obj);
			$Imng->deleteMeta($new_obj);
		} else {
			return array('no_del_perms',$new_obj->getID());
		}
	}
	return false;
}
function ExportSite(&$obj) {
	global $frm,$Imng,$xml,$xmlFastText,$Bmng,$Fmng;

	$tmp_path=Framework::getTempPath();
	if (file_exists($tmp_path) && is_writable($tmp_path)) {
		do {
			$path=$tmp_path.'/'.uniqid('EX');
		} while (file_exists($path));
		if (@mkdir($path,0755)) {
			mkdir($path.'/img',0755);
			mkdir($path.'/other',0755);
			$meta=new Xml();
			$root=$meta->new_root ('meta');
			$meta->new_child ($root,'Title', '', $obj->getMeta('Title_'.$Imng->getLangID()));
			$meta->new_child ($root,'MenuTitle', '', $obj->getMeta('Title_'.$Imng->getLangID()));
			$meta->new_child ($root,'Text', '', $obj->getMeta('Text'));
			$img_xml=$meta->new_child ($root,'Images');
			$file_xml=$meta->new_child ($root,'Files');

			if ($obj->getMeta('Content')) {
				$xml_text=$Imng->getContent($obj->getMeta('Content'),$obj->getMeta('Version'));
				//debug(nl2br(htmlspecialchars($xml_text)));
				if ($xml_text) {
					$xml->parseText($xml_text);

					$images=$xmlFastText->searchImages($xml->get_node(0));
					foreach (array_keys($images) as $image) {
						if (file_exists($Bmng->getCfg('OrigPath').'/'.$image)) {
							$img_id=$Bmng->getImgID($image);
							$iobj=$Bmng->getObj($img_id);
							if (is_object($iobj) && copy($Bmng->getCfg('OrigPath').'/'.$image,$path.'/img/'.$image)) {
								$meta->new_child($img_xml,'Image',array('md5'=>$frm->getMd5Sum($path.'/img/'.$image),'i_id'=>$img_id,'url'=>$image),$iobj->getName());
							}

						};
					}
					//debug($images);
					//foreach ()

					$files=array_unique($xmlFastText->searchFiles($xml->get_node(0)));
					foreach ($files as $file_id) {
						$fobj=$Fmng->getObj($file_id);
						//debug($fobj);
						if ((is_object($fobj) && $fobj->getAcl(1) && $fobj->getMeta('DocType')=='ext')) {
							if ($fobj->getFileMeta('FilePath') && file_exists($fobj->getFileMeta('FilePath'))) {
								if (copy($fobj->getFileMeta('FilePath'),$path.'/other/'.basename($fobj->getFileMeta('FilePath')))) {
									$meta->new_child($file_xml,'File',array('md5'=>$frm->getMd5Sum($fobj->getFileMeta('FilePath')),'f_id'=>$file_id,'url'=>basename($fobj->getFileMeta('FilePath'))),$fobj->getName());
								}
							}
						}

					}
				//debug(nl2br(htmlspecialchars($xml->getText(0,1,"",""))));
					$fp=fopen($path.'/WebObj.xml','w');
					fwrite($fp,'<?xml version="1.0" encoding="'.GE_CHARSET.'"?>');
					fwrite($fp,$xml->getText(0,1,"",""));
					fclose($fp);
				}
			}

			$fp=fopen($path.'/MetaObj.xml','w');
			fwrite($fp,'<?xml version="1.0" encoding="'.GE_CHARSET.'"?>');
			fwrite($fp,$meta->getText(0,1,"",""));
			fclose($fp);
			if (chdir($path)) {
				page_close();
				$exec="zip -rX $tmp_path/".basename($path).".zip *";
				exec($exec);
				$frm->deleteFiles($path,'/.*/',array(),true,true);
				$Name=preg_replace('/[^a-zA-Z1-9 _-]/i','',str_replace(' ','_',$obj->getName())).".zip";
				Framework::dumpFile("$tmp_path/".basename($path).'.zip',$Name,'application/x-zip');
				@unlink("$tmp_path/".basename($path).'.zip');
				exit;
			}
		}
	}
}
?>