<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$obj_action=$frm->getObjAction($Lmng->getModul(),$obj->getActionMode(0));
if ($Lmng->isAllowedAction($obj,$obj_action[$obj_action_val])) {
	$location='';
	switch ($obj_action_val) {
		case 'n_fol':
			$location="index.php?site=$site&action=b&new=$obj_action_val&edit=1&oid=".$obj->getID();
		break;
		case 'n_link':
			$location="index.php?site=$site&action=vo&new=$obj_action_val&edit=1&&oid=".$obj->getID();
		break;
		case 'cut':
			if ($Lmng->isClipboard('lobj')) {
				$frm->deleteClipboard('lobj');
				$Lmng->setClipboard('lobj',false);
			}
			$Lmng->setClipboard('lobj',$frm->insertClipboard('lobj',$obj->getID(),'cut'));
			break;
		case 'copy':
			if ($Lmng->isClipboard('lobj')) {
				$frm->deleteClipboard('lobj');
				$Lmng->setClipboard('lobj',false);
			}
			$Lmng->setClipboard('lobj',$frm->insertClipboard('lobj',$obj->getID(),'copy'));
			break;
		case 'insert':
			if ($Lmng->isClipboard('lobj')) {
				foreach ($Lmng->getClipboard('lobj') as $val) {
					$new_obj=$Lmng->getObj($val['Content']);
					$tmp_error=CutCopyObject($obj,$new_obj,$val['Mode'],true);
					if (!$tmp_error) {
						$frm->deleteClipboard('lobj',$val['Content']);
					} else {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
				$Lmng->setClipboard('lobj',$frm->getClipboard('lobj'));
			}
			break;
		case 'delete':
			if (is_object($trash_obj)) {
				$oldParentID=$obj->getMeta('ParentID');
				$tmp_error=TrashObject($trash_obj,$obj);
				if (!$tmp_error) {
					$location="index.php?site=$site&oid=".$oldParentID;
				} else {
					$ActionError[$tmp_error[0]][]=$tmp_error[1];
				}
			}
			break;
		case 'f_delete':
			$oldParentID=$obj->getMeta('ParentID');
			$tmp_error=DeleteObject($obj);
			if (!$tmp_error) {
				$location="index.php?site=$site&oid=".$oldParentID;
			} else {
				$ActionError[$tmp_error[0]][]=$tmp_error[1];
			}
			break;
		case 'tr_delete':
			if (is_object($trash_obj)) {
				$sub_entrys=$Lmng->ListSubEntrys($trash_obj->getID(),'');
				foreach ($sub_entrys as $new_obj) {
					$tmp_error=DeleteObject($new_obj);
					if ($tmp_error) {
						$ActionError[$tmp_error[0]][]=$tmp_error[1];
					}
				}
			}
			break;
		case 'i_fav':
			if (!$obj->getParentMeta('Favorite')) {
				$obj->setParentMeta('Favorite',1);
				$Lmng->insertParentMeta($obj);
			}
			break;
		case 'd_fav':
			if ($obj->getParentMeta('Favorite')) {
				$obj->setParentMeta('Favorite',0);
				$Lmng->insertParentMeta($obj);
			}
			break;
		case 'e_fol':
			$edit=1;
			break;
		case 'perms':
			$action='p';
			//$location="index.php?site=$site&action=".$obj->getAction(1)."&oid=".$obj->getID();
			break;
		case 'config':
			$action='cfg';
			//$location="index.php?site=$site&action=".$obj->getAction(1)."&oid=".$obj->getID();
			break;
		case 's_mail':
			$frm->setUserData('mail',1,"\r\n".$obj->getName()."\r\n".$obj->getMeta('Link'));
			$location="index.php?site=mail.php&show=compose&a=new&getUserBody=1";
			$GLOBALS['SESS_MDATA']['mail.php']['L_BACK']=array(0=>$L->getTempLink(array('obj_action_val','obj_action_x')));
			break;
	}
	if ($location) {
		page_close();
		header('Location:'.$location);
		exit;
	}
}
?>
