<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class Aliases {
 	var $Mail;
	var $alias_file='';
	function Aliases(&$Mail) {
        $this->Mail=&$Mail;
		if ($Mail->getCfg('file/alias_file') && file_exists($Mail->getCfg('file/alias_file'))) {
			$this->alias_file=$Mail->getCfg('file/alias_file');
		} else {
			$this->alias_file=GE_DYN_PATH.'/'.GE_DOMAIN_PATH.'alias/aliases';
			if (!file_exists(GE_DYN_PATH.'/'.GE_DOMAIN_PATH.'alias')) {
				mkdir(GE_DYN_PATH.'/'.GE_DOMAIN_PATH.'alias',0755);
			}
		}
		if (!file_exists($this->alias_file)) {
			touch($this->alias_file);
		}
 	}
	function getError() {
		return $this->error;
	}
 	function get_alias($username) {
  		$list = array();
 		$myfile = file($this->alias_file);
  		sort($myfile);
  		//print_r($myfile);
        for ($i=0; $i<count($myfile); $i++) {
                $uid_entry = split(":", $myfile[$i], 2);
                $uid_entry[1] = trim($uid_entry[1]);
                $list[$uid_entry[1]] = $uid_entry[0];
        }
  		return($list[$username]);
 	}

 	function get_alias_list() {
        $mylist=array();
        $uid_entry=array();
        $myfile = file($this->alias_file);
        sort($myfile);
        reset($myfile);
        for ($i=0; $i<count($myfile); $i++) {
			if(!preg_match("/^#/",$myfile[$i]) && $myfile[$i]["alias"]){
					$uid_entry = split(":", $myfile[$i],2);
					$mylist[$i]["alias"]=trim($uid_entry[0]);
					$mylist[$i]["username"]=trim($uid_entry[1]);
			}
        }
  		return $mylist;
 	}

 	function get_alias_list_user($mb) {
        $mylist=array();
        $uid_entry=array();
        $myfile = file($this->alias_file);
        sort($myfile);
        //print_r($myfile);
        reset($myfile);
        for ($i=0; $i<count($myfile); $i++) {
			if(!preg_match("/^#/",$myfile[$i]) && $myfile[$i]["alias"]){
				$uid_entry = split(":", $myfile[$i],2);
				if(trim($uid_entry[1])==$mb){
					$mylist[$i]["alias"]=trim($uid_entry[0]);
					$mylist[$i]["username"]=trim($uid_entry[1]);
				}
			}
        }
        //print_r($mylist);
  		return $mylist;
 	}

 	function alias_delete($aliasname, $mailboxname){
		$far=file($this->alias_file);
		foreach($far as $key=>$var){
			$entry=explode(":",$var);
			if(trim($entry[0])!=$aliasname || trim($entry[1])!=$mailboxname)$result[]=trim($entry[0]).":".trim($entry[1]);
		}
		//print_r($result);
		$alfp=fopen($this->alias_file, "w+");
		flock($alfp,2);
		foreach($result as $var){
			$fileline=$var."\n";
			$error=fwrite($alfp, $fileline);
			if($error==-1) {
				flock($alfp,3);
				$this->error="File: Write Error";
				return false;
			}
		}
		flock($alfp,3);
 		fclose($alfp);
		return true;
	}

 	function alias_add($aliasname, $mailboxname){
  		$far=file($this->alias_file);
		foreach($far as $var){
             $entry=explode(":",$var);
             if(trim($entry[0])==$aliasname && trim($entry[1])==$mailboxname) {
				$this->error="File: Alias \"$aliasname\" exists";
				return false;
			 }
             if(trim($entry[0]) && trim($entry[1])) $result[]=trim($entry[0]).":".trim($entry[1]);
  		}
  		$result[]=trim($aliasname).":".trim($mailboxname);
  		$alfp=fopen($this->alias_file, "w+");
  		flock($alfp,2);
  		foreach($result as $var){
            if($var)$fileline=$var."\n";
            if($fileline) $error=fwrite($alfp, $fileline);
			if($error==-1) {
				flock($alfp,3);
 				$this->error="File: Write Error";
				return false;
			}
  		}
 		flock($alfp,3);
 		fclose($alfp);
		return true;
	}
}
?>
