<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class Aliases{
	var $error;
	var $Mail;
	var $vtable="aliases";
	function Aliases(&$Mail) {
		$this->Mail=&$Mail;
		if ($Mail->getCfg('mysql/aliastable')) $this->vtable=$Mail->getCfg('mysql/aliastable');
	}
	function getError() {
		return $this->error;
	}
    function get_alias_list_user($username) {
		$query="SELECT alias,username FROM ".$this->vtable." WHERE username=".$this->Mail->_db->escape($username);
		$this->Mail->_db->query($query);
		while ($this->Mail->_db->next_record()) {
			$list[]=array("alias"=>$this->Mail->_db->f('alias'),"username"=>$this->Mail->_db->f('username'));
		}
		return($list);
	}

	function alias_delete($aliasname, $mailboxname){
		if( $aliasname && $mailboxname) {
		   	$this->Mail->_db->query("delete from ".$this->vtable." where alias=".$this->Mail->_db->escape($aliasname)." and username=".$this->Mail->_db->escape($mailboxname));
		}
		return true;
	}

	function alias_add($aliasname, $mailboxname){
		if( $aliasname && $mailboxname) {
			$this->Mail->_db->query("SELECT * FROM ".$this->vtable." WHERE alias=".$this->Mail->_db->escape($aliasname)." and username=".$this->Mail->_db->escape($mailboxname));
			if (!$this->Mail->_db->next_record()) {
				$values=array(
					'alias'=>$aliasname,
					'username'=>$mailboxname,
					'status'=>'1',
				);
				$this->Mail->_db->insert($this->vtable,$values);
			} else {
				$this->error="MYSQL: Alias \"$aliasname\" exists";
				return false;
			}
		}
		return true;
	}


}
?>
