<?php
class MailFolderGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	function __construct() {
		global $frm,$t,$T,$E,$L,$P,$Y;
		$this->_Base=& $frm->getStaticModul('mail');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_T->loadModul('mail');
		require_once('lib/class_TemplateGui.php');
		$this->_AppGui=new TemplateGui('core/common_form.inc.html');
		require_once('lib/class_ApplicationTreeGui.php');
		$this->_Gui=new ApplicationTreeGui();
		if ($this->_frm->getMyApps('sync')) {
			require_once('lib/sync/SyncDB.php');
			$this->_BaseSync=$frm->getStaticModul('active_sync');
		}
	}
	function setObj(&$obj) {
		$this->_Obj=&$obj;
	}
	function setRootObj(&$obj) {
		$this->_RootObj=&$obj;
	}
	function setTree(&$qtree) {
		$this->_Tree=&$qtree;
	}
	function _handleRequest() {
		if (Framework::getParam('_load',0)) {
			$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpSearchFolder',1,0);
		}
		if (Framework::getParam('obj_action_x','','P')) {
			switch(Framework::getParam('obj_action_val','','P')) {
				default:
					//debug(Framework::getParam('obj_action_val','','P'));
				break;
			}
		}
		if (Framework::getParam('geMailListAction_x','0','P') && Framework::getParam('geMailListAction_val','0','P')) {
			$folID=Framework::getParam('geMailListID','0','P');
			if (!empty($folID)) {
				switch (Framework::getParam('geMailListAction_val','0','P')) {
					case 'subscribe':
						foreach($folID as $box) {
						    if ($tmpObj=$this->_Base->getObj($box)) {
								if (!$tmpObj->getMeta('NoMails')) {
									$this->_Base->subscribeFolder($tmpObj->getBox());
								}
							}
						}
						break;
					case 'unsubscribe':
						foreach($folID as $box) {
						    if ($tmpObj=$this->_Base->getObj($box)) {
								if (!$tmpObj->getMeta('NoMails')) {
									$this->_Base->unsubscribeFolder($tmpObj->getBox());
								}
							}
						}
					break;
					case 'sync':
						$this->_BaseSync->insertSyncFolders($this->_frm->getUser(),'',$folID);
					break;
					case 'unsync':
						$this->_BaseSync->deleteSyncFolders($this->_frm->getUser(),'',$folID);
					break;
				}
			}
		}
		$searchGui=$this->getSearchConfig();
		$this->_Gui->addTreeContent($searchGui);
		$contentGui=$this->getSearchContent();
		$this->_Gui->addContent($contentGui);
	}
	function &process() {
		$this->_handleRequest();
		$this->_AppGui->addContent('cont1',$this->_Gui,'CONTENT');
		$this->_AppGui->addContent('faction',$this->_L->getTempLink(array('_load','b')),'FORM_ACTION');
		$GLOBALS['H_REFERER'][0]=$this->_L->getTempLink();
		return $this->_AppGui;
	}
	function getSearchConfig() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/mail/class_MailGui.php');


		$ContGui=new TemplateGui('core/common_content_border.inc.html');

		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key='info';
		$formGui->addField($key,'text',$this->_T->lang('[[Suchtext]]'),$this->_search[$key],'');

		$key='start';
		$formGui->addField($key,'radiolist_v',$this->_T->lang('[[Postfaecher]]'),$this->_search[$key]?$this->_search[$key]:'*','');
		$values=array(
			'*'=>$this->_T->lang('[[Alle]]'),
			'INBOX.*'=>$this->_T->lang('[[Eigene Postfaecher]]'),
			'user.*'=>$this->_T->lang('[[Gemeinsame Postfaecher]]'),
		);
		$formGui->setValues($key,$values);

		$key='proj';
		$params=base64_encode(serialize(array('MaxEntries'=>1,'useAll'=>1,)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Projekt]]'),
			'LabelSep'=>'',
			'mode'=>'o',
			'app'=>'proj',
			'params'=>$params,
			'FieldVal'=>'_PROJECTS',
		);
		$default='';
		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,$this->_search[$key]?'o_'.$this->_search[$key]:'','');
		$formGui->setParams($key,array('mode'=>'o','params'=>$params,'no_width'=>1));


		$key='abbo';
		$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Aboniert]]'),$this->_search[$key]?$this->_search[$key]:0,'');
		$values=array(
			'0'=>$this->_T->lang('[[Alle]]'),
			'1'=>$this->_T->lang('[[Ja]]'),
			'-1'=>$this->_T->lang('[[Nein]]'),
		);
		$formGui->setValues($key,$values);

		if ($this->_frm->getMyApps('sync')) {
			$key='sync';
			$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Synchronisiert]]'),$this->_search[$key]?$this->_search[$key]:1,'');
			$values=array(
				'0'=>$this->_T->lang('[[Alle]]'),
				'1'=>$this->_T->lang('[[Ja]]'),
				'-1'=>$this->_T->lang('[[Nein]]'),
			);
			$formGui->setValues($key,$values);
		}
		

		$key='search_x';
		$formGui->addField($key,'submit','',$this->_T->lang('[[Suchen]]'),'');

		$this->_search=array(
			'info'=>$formGui->getFieldVal('info',1),
			'start'=>$formGui->getFieldVal('start',1),
			'abbo'=>$formGui->getFieldVal('abbo',1),
			'proj'=>'',
		);
		if ($this->_frm->getMyApps('sync')) {
			$this->_search['sync']=$formGui->getFieldVal('sync',1);
		}
		if ($formGui->getFieldVal('proj',1)) {
			$this->_search['proj']=substr($formGui->getFieldVal('proj',1),2);
		}
		$this->_frm->savePostData($this->_Base->getModul(),'tmpSearchFolder',null,$this->_search);
		$ContGui->addContent('formgui',$formGui,'CONTENT');
		return $ContGui;
	}

	function getSearchContent() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');

		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		$btnList=new CheckBoxBtn ('geMailListID[]','');
		$btnList->setAttribs(array(
			'onclick'=>'return false;',
		));

		$funcAction=new FunctionObjActionGui('geMailListAction',1);
		$funcAction->setName($this->_T->lang('[[Ausgewaehlte Postfaecher]]'));
		if (!$this->_search['abbo'] || $this->_search['abbo']==-1) {
			$funcAction->addValue('subscribe',$this->_T->lang('[[Abonnieren]]'));
		}
		if (!$this->_search['abbo'] || $this->_search['abbo']==1) {
			$funcAction->addValue('unsubscribe',$this->_T->lang('[[Abmelden]]'));
		}
		if ($this->_frm->getMyApps('sync')) {
			$funcAction->addValue('info','----------------------');
			if (!$this->_search['sync'] || $this->_search['sync']==-1) {
				$funcAction->addValue('sync',$this->_T->lang('[[box_synchronisieren]]'));
			}
			if (!$this->_search['sync'] || $this->_search['sync']==1) {
				$funcAction->addValue('unsync',$this->_T->lang('[[Nicht synchronisieren]]'));
			}
		}
		
		$tabGui=new ApplicationListGui();
		$tabGui->addFunction($funcAction);
		$tabGui->setAutoBg(APP_FG10COLOR);
		$tabGui->setTrOver('trBOC({ROW},this);');
		$tabGui->setTrDown('trBOI({ROW},this,1);');
		$tabGui->setID('geMailFolderList');

		$funcSelAll=new FunctionButtons('folder_list','selectall',array('ListID'=>'geMailListID[]','ListOn'=>false));
		$tabGui->addHeaderCol('ListID',$funcSelAll->process(),'','','',1,'1%',0,'',$noEnc);
		$tabGui->addHeaderCol('Box',$this->_T->lang('[[Name]]'),'','','',1,'');
		$tabGui->addHeaderCol('Abbo',$this->_T->lang('[[Aboniert]]'),'','','',1,'');
		if ($this->_frm->getMyApps('sync')) {
			$tabGui->addHeaderCol('Sync',$this->_T->lang('[[Synchronisiert]]'),'','','',1,'');
		}
		$tabGui->addHeaderCol('Spc','','','','',0,'2000');

		$folInbox=$this->_Base->getObj('INBOX',true,false);

		if ($this->_search['proj'] && ($pObj=$this->_P->getObj($this->_search['proj']))) {
			if($pObj->getMeta('MailFolder')) {
				$start=$pObj->getMeta('MailFolder').'*';
			}
		} else {
			$start=$this->_search['start'];
		}

		//$entries=$this->_Base->searchFolders($this->_search['start'],$this->_search['info'],null,0,false);
		$entries=$this->_Base->listFolders($start,$this->_search['abbo']==1?false:true,false,true,0,0,$this->_search['info']);
		if ($start=='INBOX.*') {
			$entries[$folInbox->getID()]=$folInbox;
		}
		if ($this->_search['abbo']==1) {
			$entries_abbo=$entries;
			$entries_abbo[$folInbox->getID()]=$folInbox;
		} else {
			$entries_abbo=$this->_Base->listFolders($start,false,false,true,0,0,$this->_search['info']);
			$entries_abbo[$folInbox->getID()]=$folInbox;
			if ($this->_search['abbo']==-1) {
				foreach($entries_abbo as $k=>$v) {
					unset($entries[$k]);
				}
			}
		}
		$entries_sync=array();
		if ($this->_frm->getMyApps('sync')) {
			$entries_sync=$this->_BaseSync->listSyncFolders($this->_frm->getUser(),'');
			if (empty($entries_sync)) {
				$entries_sync=$this->_Base->listFolders('INBOX.%',false,false,true,0,0,'');
				$entries_sync[$folInbox->getBox()]=$folInbox;
				foreach($entries_sync as $val) {
					$this->_BaseSync->insertSyncFolders($this->_frm->getUser(),'',array($val->getBox()));
				}
			}
			if ($this->_search['sync']==-1) {
				foreach($entries_sync as $k=>$v) {
					unset($entries[$k]);
				}
			}
			if ($this->_search['sync']==1) {
				foreach($entries as $k=>$v) {
					if (!isset($entries_sync[$k])) {
						unset($entries[$k]);
					}
				}
			}
		}
		
		ksort($entries);
		$rows=count($entries);
		$navLink=Framework::cloneObj($this->_L);
		$tabGui->setNavLink($this->_L);
		$tabGui->setSumRows($rows);
		//$tabGui->setLimit($search['limit']);
		//$tabGui->setBegin($search['b']);
		foreach ($entries as $k=>$val) {
			$hl=($hl?$hl=0:$hl=1);
			if ($val->getMeta('RootID')=='QUICK') {
				if ($this->_frm->getMyApps('sync') && !isset($entries_sync[$val->getBox()])) {
					$this->_BaseSync->insertSyncFolders($this->_frm->getUser(),'',array($val->getBox()));
				}
				continue;
			}
			$tabGui->addRow($hl,'top','');
			$tabGui->addCol('ListID',$val->getBox()!='INBOX'?$btnList->process($val->getBox()):'','','','',1,'',0,'',$noEnc);
			$tabGui->addCol('Box',$val->getBox(),'','','',1,'');
			$tabGui->addCol('Abbo',isset($entries_abbo[$k])?'X':'-','','','center',1,'');
			//$tabGui->addCol('Parent',$val->getMeta('ParentBox'),'','','',1,'');
			if ($this->_frm->getMyApps('sync')) {
				$tabGui->addCol('Sync',isset($entries_sync[$k])?'X':'-','','','center',1,'');
			}
			$tabGui->addCol('Spc','','','','center',1,'');
		}
		return $tabGui;
	}

	function setPrefs($key,$val) {
		$this->_frm->insertPrefs('email',array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs('email',$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
}
?>