<?php
class MailGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	function MailGui() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_T->loadModul('mail');
		$this->initTransDate();
	}
	function initTransDate() {
		$time=time();
		$day=date('d');
		$month=date('m');
		$year=date('Y');
		$week_day=date("w")-1;
		if ($week_day<0) $week_day=6;
		$heute=mktime(0,0,0,$month,$day,$year);
		$this->_trans_date[$heute]=$this->_T->lang('[[Heute]]');
		$gestern=mktime(0,0,0,$month,$day-1,$year);
		$this->_trans_date[$gestern]=$this->_T->lang('[[Gestern]]');
		$startweek=mktime(0,0,0,$month,$day-$week_day,$year);
		if ($startweek<$gestern) {
			$this->_trans_date[$startweek]=$this->_T->lang('[[Diese Woche]]');
		}
		$lastweek=mktime(0,0,0,$month,$day-$week_day-7,$year);
		$this->_trans_date[$lastweek]=$this->_T->lang('[[Letzte Woche]]');
		$pre_lastweek=mktime(0,0,0,$month,$day-$week_day-14,$year);
		$this->_trans_date[$pre_lastweek]=$this->_T->lang('[[Vorletzte Woche]]');
		$this_month=mktime(0,0,0,$month,1,$year);
		if ($this_month<$pre_lastweek) {
			$this->_trans_date[$this_month]=$this->_T->lang('[[Diesen Monat]]');
		}
		$last_month=mktime(0,0,0,$month-1,1,$year);
		$this->_trans_date[$last_month]=$this->_T->lang('[[Letzten Monat]]');
		$this->_trans_date[0]=$this->_T->lang('[[Aelter]]');
	}
	function parseFwdJs() {
		require_once('lib/class_FastTemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		$Gui=new FastTemplateGui('mail/js_forward.inc.html');
		$Gui->setEncode(false);

		$formGui=new FormGui();
		$key='fwdToID';
		$tMode='u|g';
		$params=base64_encode(serialize(array('MaxEntries'=>0)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$tMode,
			'app'=>'email',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$tMode,
			'app'=>'mail',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);
		$default='';
		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,$default,'fields1');
		$formGui->setParams($key,array('mode'=>$tMode,'no_width'=>1,'params'=>$params));
		$Gui->assign('TPL_FORM',$formGui);

		$this->_frm->initExtJs();

		$resGui=new FastTemplateGui('core/js_result.inc.html');
		$this->_frm->addScript($resGui);
		$this->_frm->addScript($Gui);
	}
	function parseCpMvJs() {
		require_once('lib/class_FastTemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		$Gui=new FastTemplateGui('mail/js_copy_move.inc.html');
		$Gui->setEncode(false);

		$formGui=new FormGui();
		$formGui=new FormGui();
		$formGui->setLabelClass('no','no_error');
		$key='cpmvToID';
		$formGui->addField($key,'ttip','','','field_copyto');
		$formGui->setAttribs($key,array('style'=>'width:300px'));
		$formGui->setParams($key,array('no_width'=>'1','width'=>'300px','mode'=>'m','app'=>'','jsSetFunction'=>'Groupe.mailCpMv.set','params'=>base64_encode(serialize(array('MaxEntries'=>1)))));
		$Gui->assign('TPL_FORM_CPMV',$formGui);
		$this->_frm->initExtJs();
		$this->_frm->addScript($Gui);
	}
	function parseHeadJs(&$root_obj_d,&$qtree,$mailActionConfig) {
		require_once('lib/class_FastTemplateGui.php');
		$Gui=new FastTemplateGui('mail/js_browse.inc.html');
		$Gui->setEncode(false);
		$Gui->assign('SEL_KEY',$root_obj_d->getBox());
		$Gui->parse('ROW','js_cp_menu_inbox');
		if (is_array($qtree[$root_obj_d->getID()])) {
			foreach ($qtree[$root_obj_d->getID()] as $val) {
				$Gui->assign('SEL_KEY',$val->getBox());
				if ($val->getMeta('Type')=='D')	$Gui->parse('ROW','js_cp_menu_draft');
				if ($val->getMeta('Type')=='S')	$Gui->parse('ROW','js_cp_menu_sent');
				if ($val->getMeta('Type')=='T')	$Gui->parse('ROW','js_cp_menu_trash');
				if ($val->getMeta('Type')=='X')	$Gui->parse('ROW','js_cp_menu_spam');
				if ($val->getMeta('Type')=='R')	$Gui->parse('ROW','js_cp_menu_readonly');
			}
		}
		$Gui->assign('MNU_ITEMS','');
		if (is_array($qtree[0])) {
			$Mail=& $this->_frm->getStaticModul('mail');
			$Gui->assign('MNU_ITEMS',$Mail->treeToJson($qtree,0));
		}
		$Gui->assign('MAIL_ACTION_CONFIG',Framework::array2json($mailActionConfig));
		$this->_frm->addScript($Gui);
		$this->_frm->initExtJs();
		$this->_frm->addOnLoad("loadBoxMenu();");
	}
	function getMailListGui(&$Mail,$search,$headers,$BoxType='') {
		//$Mail->initColorFilter();

		$this->_parsedKeys=array();

		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_FunctionButtons.php');

		$Gui=new ApplicationListGui('core/common_table_list_js.inc.html');
		$Gui->setID('mailTab');
		/*
		$Gui=new ApplicationListGui('core/common_table_list_scroll.inc.html');
		$this->_frm->addOnLoad("e7g_initScroll('#mailTab_c',0);");
		$this->_frm->addOnLoad("e7g_syncWidth('#mailTab_h','#mailTab_c');");
		*/
		if ($BoxType!='R') {
			/*$funcMoveTo=new FunctionButtons('boxMove','js_link',array('Label'=>$this->_T->lang('[[Verschieben nach]]'),'onClick'=>"showBoxTree('move','boxMove')",'onMouseOver'=>'','onMouseOut'=>'cmMainMouseOut();'));
			$Gui->addFunction($funcMoveTo);*/
			$funcMoveTo=new FunctionButtons('boxMove','js_link',array('Label'=>$this->_T->lang('[[Verschieben nach]]'),'onClick'=>"showMailActionDialog('ListID[]','move','boxMove');"));
			$Gui->addFunction($funcMoveTo);
		}
		/*
		$funcCopyTo=new FunctionButtons('boxCopy','js_link',array('Label'=>$this->_T->lang('[[Kopieren nach]]'),'onClick'=>"showBoxTree('copy','boxCopy')",'onMouseOver'=>'','onMouseOut'=>'cmMainMouseOut();'));
		$Gui->addFunction($funcCopyTo);
		*/
		$funcCopyTo=new FunctionButtons('boxCopy','js_link',array('Label'=>$this->_T->lang('[[Kopieren nach]]'),'onClick'=>"showMailActionDialog('ListID[]','copy','boxCopy');"));
		$Gui->addFunction($funcCopyTo);

		if ($Mail->getCfg('cfg/all/fwd_intern') && $BoxType!='R') {
			$funcFwd=new FunctionButtons('boxFwd','js_link',array('Label'=>$this->_T->lang('[[Intern weiterleiten]]'),'onClick'=>"showMailActionDialog('ListID[]','forward','boxFwd')",'onMouseOver'=>'','onMouseOut'=>''));
			$Gui->addFunction($funcFwd);
		}
		if ($Mail->getCfg('cfg/archiv/enable') && $BoxType!='R') {
			$funcArch=new FunctionButtons('boxArchiv','js_link',array('Label'=>$this->_T->lang('[[Archivieren]]'),'onClick'=>"showMailActionDialog('ListID[]','archiv','boxArchiv')",'onMouseOver'=>'','onMouseOut'=>''));
			$Gui->addFunction($funcArch);
		}
		if ($BoxType!='R') {
			$funcDelete=new FunctionButtons('boxDelete','js_link',array('Label'=>$this->_T->lang('[[Loeschen]]'),'onClick'=>"showMailActionDialog('ListID[]','delete','boxDelete')",'onMouseOver'=>'','onMouseOut'=>''));
			$Gui->addFunction($funcDelete);
		}

		if (Framework::getParam('_OrderF',0,'G')) {
			$this->setPrefs('MailOrderF',Framework::getParam('_OrderF',0,'G'));
			$this->setPrefs('MailOrderD',Framework::getParam('_OrderD',0,'G'));
		}
		$search['orderF']=$this->getPrefs('MailOrderF',SORTARRIVAL);
		$search['orderD']=$this->getPrefs('MailOrderD',-1);
		$rows=0;
		if (!isset($search['b'])) $search['b']=intval(Framework::getParam('b',0,'G'));
		if (!isset($search['limit'])) $search['limit']=$Mail->getLimit();
		if (!isset($search['group'])) $search['group']=1;
		if (!isset($search['filter'])) $search['filter']='';
		if (!isset($search['use_limit'])) $search['use_limit']=true;

		$header_links=array(
			'subject'=>$this->_L->getTempLink(null,array('mid'=>'__MID__','action'=>'__ACTION__','oid'=>'__BOX__')),
			'from'=>$this->_L->getTempLink(null,array('add_to'=>'__FROM__','action'=>'n')),
			'to'=>$this->_L->getTempLink(null,array('add_to'=>'__TO__','action'=>'n')),
		);
		if (Framework::getParam('_ignoreID','')) {
			$ignoreID=explode('||',Framework::getParam('_ignoreID',''));
		}
		if (is_array($search['box'])) {
			$rspan=5;
			if ($Mail->getCfg('cfg/all/filter_colors')) $rspan+=1;
			if ($headers['ListID']) $rspan+=1;
			if ($headers['from']) $rspan+=1;
			if ($headers['to']) $rspan+=1;
			$subSearch=$search;
			$trows=0;
			foreach ($search['box'] as $sBox) {
				$brows=0;
				$subSearch['box']=$sBox;

				//debug($subSearch);
				$entries=$Mail->listMails($brows,$subSearch['box'],$subSearch['b'],$subSearch['limit'],$subSearch['orderF'],$subSearch['orderD']==-1?true:false,$subSearch['filter'],$search['use_limit']);
				if ($subSearch['box']==$ignoreID[0] && isset($entries[$ignoreID[1]])) {
					$entries[$ignoreID[1]]->setMeta('Trash',1);
				}
				$trows+=count($entries);

				if ($brows && !empty($entries)) {
					$Gui->addRow(4,'top','',true);
					$key='colGroup2';
					//debug($rspan);
					$Gui->addCol($key,$subSearch['box'],'','','center',0,'',$rspan);
					$this->fillMailListRows($Mail,$Gui,$entries,$subSearch,$brows,$headers,$header_links);
				}
				$rows+=$brows;
				if ($search['limit']) {
					if ($rows<($search['b']+$search['limit'])) {
						if ($rows) {
							if ($trows) {
								$subSearch['b']=0;
							} else {
								$subSearch['b']-=$brows;
							}
							$subSearch['limit']=$search['limit']-$trows;
						}
						if ($subSearch['b']<=0) $subSearch['b']=0;
						if ($subSearch['limit']<=0) break;
					} else {
						$subSearch['limit']=-1;
					}
				}

			}
		} else {
			$entries=$Mail->listMails($rows,$search['box'],$search['b'],$search['limit'],$search['orderF'],$search['orderD']==-1?true:false,$search['filter'],$search['use_limit']);
			if ($search['box']==$ignoreID[0] && isset($entries[$ignoreID[1]])) {
				$entries[$ignoreID[1]]->setMeta('Trash',1);
				//unset($entries[$ignoreID[1]]);
				//$rows-=1;
			}
			$this->fillMailListRows($Mail,$Gui,$entries,$search,$rows,$headers,$header_links);
		}


		$this->fillMailListHeaders($Mail,$Gui,$this->_L,$search,$rows,$headers,$header_links);
		return $Gui;
	}
	function fillMailListHeaders(&$Mail,&$Gui,&$navLink,$search,$rows,$headers,$header_links) {
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionButtons.php');
		if ($search['orderF']) {
			$Gui->setActOrder($search['orderF'],$search['orderD']);
			$Gui->setOrderLink($navLink);
		}
		$Gui->setNavLink($navLink);
		$Gui->setAutoBg(APP_FG10COLOR);
		$Gui->setRowClass(array('list_l','list_b','list_h','list_hb','list_s','list'));
		$Gui->setLimit($search['limit']);
		$Gui->setSumRows($rows);
		$Gui->setBegin($search['b']);

		if ($Mail->getCfg('cfg/all/filter_colors')) {
			$hspan=4;
		} else {
			$hspan=3;
		}
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		if ($headers['ListID']) {
			$funcSelAll=new FunctionButtons('mail_list','selectall',array('ListID'=>'ListID[]','ListOn'=>false));
			$Gui->addHeaderCol('ListID',$funcSelAll->process(),'','','',1,'1%',0,'',$noEnc);
			$Gui->setTrOver('trBOC({ROW},this);');
			$Gui->setTrDown('trBOI({ROW},this,1);');
		}
		$key='hdSubject';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Betreff]]'),'','','',0,'',$hspan);
		$Gui->setHeaderOrder($key,SORTSUBJECT,1);
		if ($headers['from']) {
			$key='hdFrom';
			$Gui->addHeaderCol($key,$this->_T->lang('[[AbsenderIn]]'),'','','',1);
			$Gui->setHeaderOrder($key,SORTFROM,1);
		}
		if ($headers['to']) {
			$key='hdTo';
			$Gui->addHeaderCol($key,$this->_T->lang('[[EmpfaengerIn]]'),'','','',1);
			$Gui->setHeaderOrder($key,SORTTO,1);
		}
		$key='hdDate';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Datum]]'),'','','',1);
		$Gui->setHeaderOrder($key,SORTARRIVAL,-1);
		$key='hdSize';
		$Gui->addHeaderCol($key,$this->_T->lang('[[Dateigroesse]]'),'','','',1);
		$Gui->setHeaderOrder($key,SORTSIZE,1);
	}

	function fillMailListRows(&$Mail,&$Gui,&$entries,$search,$rows,$headers,$header_links) {
		$av_colors=explode(',',$Mail->getCfg('cfg/all/filter_colors'));
		array_unshift($av_colors,'transparent');
		$rspan=4;
		if ($Mail->getCfg('cfg/all/filter_colors')) $rspan+=1;
		if ($headers['ListID']) $rspan+=1;
		if ($headers['from']) $rspan+=1;
		if ($headers['to']) $rspan+=1;

		if ($headers['ListID']) {
			$attribs=array(
				'onclick'=>'return false;',
			);
			$btnList=new CheckBoxBtn ('ListID[]','');
			$btnList->setAttribs($attribs);
		}
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		$hl=0;
		if ($rows) {
			$mColor=$Mail->getMailColor(Framework::extractObjMeta($entries,'Md5Id'));
			//debugtime('B');
			$oldOrderVal='';
			foreach ($entries as $mkey=>$val) {
				$tras_array=array(
					'__MID__'=>urlencode($val->getID()),
					'__BOX__'=>urlencode($search['box']),
					'__ACTION__'=>$val->getAction(0),
					'__FROM__'=>urlencode($Mail->formatMail($val->getMail('From',0),0,1)),
					'__TO__'=>urlencode($Mail->formatMail($val->getMail('To',0),0,1)),
				);
				if ($search['group']) {
					switch ($search['orderF']) {
						case SORTFROM:
							$mobj=$val->getMail('From',0);
							$newOrderVal=$mobj->mailbox.'@'.$mobj->host;
						break;
						case SORTTO:
							$mobj=$val->getMail('To',0);
							$newOrderVal=$mobj->mailbox.'@'.$mobj->host;
						break;
						case SORTARRIVAL:
							$newOrderVal=strftime("%a, %d.%m.%Y",$val->getMeta('Date'));
							foreach ($this->_trans_date as $d_key=>$d_val) {
								if ($val->getMeta('Date')>$d_key) {
									$newOrderVal=$d_val;
									break;
								}
							}

						break;
						default:
							$newOrderVal='';
						break;
					}
					if ($newOrderVal!=$oldOrderVal) {
						$Gui->addRow(1,'top','',true);
						if ($headers['ListID']) {
							$key='colGroup';
							$Gui->addCol($key,'','','','left',0,'',1);
						}
						$key='colGroup2';
						$Gui->addCol($key,$newOrderVal,'','','left',0,'',$rspan);
						$hl=0;
						$oldOrderVal=$newOrderVal;
					}
				}
				if (isset($mColor[$val->getMeta('Md5Id')])) {
					$color=$av_colors[$mColor[$val->getMeta('Md5Id')]];
				} else {
					//$color=$Mail->getColor($val);
					$color='';
				}
				$hl=($hl?$hl=0:$hl=1);
				/*if (Framework::getParam('_omid',-1,'G')==$val->getID()) {
					$Gui->addRow(4,'top','');
				} else
				*/
				if ($val->isNew()) {
					$Gui->addRow($hl?3:1,'top','');
				} else {
					$Gui->addRow($hl?2:0,'top','');
				}
				if ($val->getMeta('Trash')) {
					$Gui->setTrClass('strike');
				}

				if ($headers['ListID']) {
					$Gui->addCol('ListID',$btnList->process($search['box'].'||'.$val->getID()),'','','',1,'',0,'',$noEnc);
				}
				if ($Mail->getCfg('cfg/all/filter_colors')) {
					$Gui->addCol('Color','<div id="cp'.$val->getID().'" onmousedown="sEvt(event);" onclick="showColorPicker(event,\''.$search['box'].'||'.$val->getID().'\',\'cp'.$val->getID().'\');" style="width:11px;height:11px;margin-top:2px;background-color:'.$color.'; border:1px solid #000;cursor:pointer;">&nbsp;</div>','','','',1,'',0,'',$noEnc);
				}
				$key='img';
				$colAttribs=array(
					'ID'=>$search['box'].'||'.$val->getID(),
					'Attribs'=>array('style'=>'cursor:move;'),
				);
				$Gui->addCol($key,'',$val->getImage(0),'','',0,'',0,'',$colAttribs);
				$key='att';
				$Gui->addCol($key,'',$val->getMeta('Attachment')?'obj_img/mail_attach.gif':'tras.gif');
				$key='subject';
				$colAttribs=array(
					/*'ID'=>$search['box'].'||'.$val->getID(),*/
					/*'Attribs'=>array('style'=>'cursor:move;'),*/
					'ID'=>$search['box'].'||'.$val->getID().'_cont',
					'LinkAttribs'=>array(
						'onmouseover'=>"showAktMail(event,1,'".$search['box']."','".$val->getID()."');",
						'onmouseout'=>"showAktMail(event,0);",
						'onclick'=>'return goToView(this);',
						'ondblclick'=>$header_links[$key.'_dbl']?'return goToEdit(this,\''.$header_links[$key.'_dbl'][0].'\',\''.$header_links[$key.'_dbl'][1].'\');':'return goToEdit(this,\'action=v\',\'action=n&mode=reply&back=0&_noLoad=1\');',
					),
				);
				$Gui->addCol($key,$Mail->mail_enc($val->getName()),'',$header_links[$key]?strtr($header_links[$key],$tras_array):'','',0,'2000',0,'',$colAttribs);
				if ($headers['from']) {
					$key='from';
					$Gui->addCol($key,$Mail->mail_enc($Mail->formatMail($val->getMail('From',0),20)),'',$header_links[$key]?strtr($header_links[$key],$tras_array):'','',1);
				}
				if ($headers['to']) {
					$key='to';
					$Gui->addCol($key,$Mail->mail_enc($Mail->formatMail($val->getMail('To',0),20)),'',$header_links[$key]?strtr($header_links[$key],$tras_array):'','',1);
				}
				$key='date';
				$Gui->addCol($key,strftime("%a, %d.%m.%Y %H:%M",$val->getMeta('Date')),'','','',1);
				$key='size';
				$Gui->addCol($key,Framework::formatSize($val->getMeta('Size')),'','','',1);
				$this->_parsedKeys[]=$search['box'].'||'.$val->getID();
			}
			//debugtime('E');
		}
	}
	function parseJsDrop($dropIDs) {
		if (!empty($dropIDs)) {
			require_once('lib/class_FastTemplateGui.php');
			$Gui=new FastTemplateGui('mail/drop_js.inc.html');
			$Gui->setEncode(false);
			$Gui->assign('DRAG_IDS','["'.implode('","',$this->_parsedKeys).'"]');
			$Gui->assign('DROP_IDS','["'.implode('","',$dropIDs).'"]');
			$this->_frm->initExtJs();
			$this->_frm->addScript($Gui);
		}
	}
	function getColorPicker(&$Mail) {
		if ($Mail->getCfg('cfg/all/filter_colors')) {
			require_once('lib/class_FastTemplateGui.php');
			$Gui=new FastTemplateGui('mail/color_picker.inc.html');
			$Gui->setEncode(false);
			$av_colors=explode(',',$Mail->getCfg('cfg/all/filter_colors'));
			array_unshift($av_colors,'transparent');
			foreach ($av_colors as $key=>$val) {
				$Gui->assign('V_COLOR',$val);
				$Gui->assign('K_COLOR',$key);
				$Gui->parse('ROW','.cpciker_color_col');
				$i++;
				if ($i>5) {
					$Gui->parse('ROW','.cpciker_color_row');
					$Gui->clear_dynamic('cpciker_color_col');
					$i=0;
				}
			}
			if ($i>0) $Gui->parse('ROW','.cpciker_color_row');
			return $Gui;
		}
	}
	function getAktMailScript(&$Mail) {
		require_once('lib/class_FastTemplateGui.php');
		$Gui=new FastTemplateGui('mail/show_akt_mail.inc.html');
		$Gui->setEncode(false);
		return $Gui;
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs('email',array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs('email',$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
}
?>