<?php
class MailSearchGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	function MailSearchGui() {
		global $frm,$t,$T,$E,$L,$P,$Y;
		$this->_Base=& $frm->getStaticModul('mail');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_T->loadModul('mail');
		require_once('lib/class_TemplateGui.php');
		$this->_AppGui=new TemplateGui('core/common_form.inc.html');
		require_once('lib/class_ApplicationTreeGui.php');
		$this->_Gui=new ApplicationTreeGui();
	}
	function setObj(&$obj) {
		$this->_Obj=&$obj;
	}
	function setRootObj(&$obj) {
		$this->_RootObj=&$obj;
	}
	function setTree(&$qtree) {
		$this->_Tree=&$qtree;
	}
	function _handleRequest() {
		if (Framework::getParam('_archivID',0) && ($archivMail=$this->_Base->getArchivMail(Framework::getParam('_archivID',0)))) {
				//debug($archivMail);
			if ($this->_Base->getCfg('cfg/archiv/enable_d3') && defined('GE_mailArchiv_D3lFileContent')) {
				$text=str_replace('{ID}',$archivMail['ID'],GE_mailArchiv_D3lFileContent);
				Framework::dumpText($text,$archivMail['ID'].'.d3l','application/D3L');
				exit;
			} elseif (file_exists($archivMail['ArchivPath'])) {
				Framework::dumpFile($archivMail['ArchivPath'],$archivMail['Subject'].'.eml','message/rfc822');
				exit;
			}
		}
		if (Framework::getParam('_load',0)) {
			$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpSearchMail',1,0);
			$this->_mode=$this->_search['smode'];
			$this->setPrefs('showtab_search',$this->_mode);
			//debug($this->_search);
		} elseif (Framework::getParam('info','','P')) {
			$this->_mode='search';
			$this->setPrefs('showtab_search',$this->_mode);
		} else {
			$this->_mode=$this->getPrefs('showtab_search');
		}
		if (Framework::getParam('obj_action_x','','P')) {
			switch(Framework::getParam('obj_action_val','','P')) {
				case 'export':
					$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpSearchMail',1,0);
					$this->parseExportGui();
				break;
				default:
					//debug(Framework::getParam('obj_action_val','','P'));
				break;
			}
		}
		$searchGui=& $this->getSearchGui();
		$this->_Gui->addTreeContent($searchGui);
		$this->parseContentGui();
	}
	function &process() {
		$this->_handleRequest();
		$this->_AppGui->addContent('cont1',$this->_Gui,'CONTENT');
		$this->_AppGui->addContent('faction',$this->_L->getTempLink(array('_load','b')),'FORM_ACTION');
		$GLOBALS['H_REFERER'][0]=$this->_L->getTempLink();
		return $this->_AppGui;
	}
	function _getSearchConfigSearch($aktMode) {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/mail/class_MailGui.php');
		$mailGui=new MailGui();
		$mailActionConfig=array(
			'search_cfg'=>array(
				'id'=>'search_sfolder',
				'mode'=>'m',
				'params'=>'',
			),
		);
		$mailGui->parseHeadJs($this->_RootObj,$this->_Tree,$mailActionConfig);

		$ContGui=new TemplateGui('core/common_simple_content.inc.html');

		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key='search_info';
		$formGui->addField($key,'text',$this->_T->lang('[[Suchtext]]'),Framework::getParam('info',$this->_search['info']),'');
		$key='search_where';
		$formGui->addField($key,'select',$this->_T->lang('[[Wo soll gesucht werden]]'),isset($this->_search['swhere'])?$this->_search['swhere']:'TEXT','');
		$avValues=array(
			'TEXT'=>$this->_T->lang('[[Gesamte E-Mail]]'),
			'SUBJECT'=>$this->_T->lang('[[Betreff]]'),
			'BODY'=>$this->_T->lang('[[Nachricht]]'),
			'FROM'=>$this->_T->lang('[[AbsenderIn]]'),
			'TO'=>$this->_T->lang('[[EmpfaengerIn]]'),
			'CC'=>$this->_T->lang('[[CC]]'),
		);
		$formGui->setValues($key,$avValues);


		$key='search_sfolder';
		if (isset($this->_search['sfolder'])) {
			$default='m_'.implode('|m_',$this->_search['sfolder']);
		} else {
			$default='m_'.$this->_Obj->getBox();
		}
		$lb_params=array();
		$lb_params[]=array(
			'Label'=>$this->_T->lang('[[Folgende Postfaecher durchsuchen]]'),
			'LabelSep'=>'',
			'JsFunction'=>"showBoxTree('search','lbl_search_sfolder')",
		);
		$lb_Box=new FunctionButtons($key,'js_label',$lb_params);
		$formGui->addField($key,'ttip',$lb_Box,$default,'');
		$formGui->setParams($key,array('no_width'=>'1','width'=>'235px','mode'=>'m','app'=>'','params'=>''));
		$key='search_sub';
		$formGui->addField($key,'check',$this->_T->lang('[[Recursiv suchen]]'),isset($this->_search['ssub'])?$this->_search['ssub']:0,'');

		$key='search_x';
		$formGui->addField($key,'submit','',$this->_T->lang('[[Suchen]]'),'');

		if (trim($formGui->getFieldVal('search_sfolder',1))) {
			$temp=explode('|',$formGui->getFieldVal('search_sfolder',1));
			foreach ($temp as $val) {
				if ($val[0]=='m') {
					$sFolder[]=substr($val,2);
				}
			}
			$sFolder=array_unique($sFolder);
		} else {
			$sFolder=array('INBOX');
		}

		if ($aktMode=='search') {
			$this->_search=array(
				'smode'=>$aktMode,
				'info'=>$formGui->getFieldVal('search_info',1),
				'swhere'=>$formGui->getFieldVal('search_where',1),
				'sfolder'=>$sFolder,
				'ssub'=>$formGui->getFieldVal('search_sub',1),
			);
			//debug($this->_search);
			$this->_frm->savePostData($this->_Base->getModul(),'tmpSearchMail',null,$this->_search);
		}
		$ContGui->addContent('formgui',$formGui,'CONTENT');
		return $ContGui;
	}
	function _getSearchConfigArchiv($aktMode) {
		require_once('lib/class_MergeGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		$ContGui=new MergeGui();

		require_once('lib/class_DateSelectForm.php');
		$selDateGui=new DateSelectForm('dsel',$this->_T->lang('[[Datum]]'));
		$selDateGui->setAvMode(array(4,2,1,3));
		$selDateGui->setMode($this->_search['DateM']?$this->_search['DateM']:4);
		if ($this->_search['DateB'] || $this->_search['DateE']) {
			$selDateGui->setDate(array($this->_search['DateB'],$this->_search['DateE']));
		} else {
			$selDateGui->setDate(array(0,0));
		}

		$ContGui->addContent($selDateGui->process());


		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key='archiv_info';
		$formGui->addField($key,'text',$this->_T->lang('[[Suchtext]]'),Framework::getParam('info',$this->_search['info']),'');
		$key='archiv_where';
		$formGui->addField($key,'select',$this->_T->lang('[[Wo soll gesucht werden]]'),isset($this->_search['where'])?$this->_search['where']:'TEXT','');
		$formGui->setValues($key,array(
			'TEXT'=>$this->_T->lang('[[Gesamte E-Mail]]'),
			'SUBJECT'=>$this->_T->lang('[[Betreff]]'),
			'BODY'=>$this->_T->lang('[[Nachricht]]'),
			'FROM'=>$this->_T->lang('[[AbsenderIn]]'),
			'TO'=>$this->_T->lang('[[EmpfaengerIn]]'),
			'CC'=>$this->_T->lang('[[CC]]'),
		));
		if (defined('GE_mailArchiv_NoBody') && GE_mailArchiv_NoBody) unset($avValues['BODY']);


		$key='archiv_search_x';
		$formGui->addField($key,'submit','',$this->_T->lang('[[Suchen]]'),'');

		if ($aktMode=='archiv') {
			$this->_search=array(
				'smode'=>$aktMode,
				'info'=>$formGui->getFieldVal('archiv_info',1),
				'where'=>$formGui->getFieldVal('archiv_where',1),
				'DateB'=>$selDateGui->getDate('B'),
				'DateE'=>$selDateGui->getDate('E'),
				'DateM'=>$selDateGui->getMode(),
			);
			$this->_frm->savePostData($this->_Base->getModul(),'tmpSearchMail',null,$this->_search);
		}
		$ContGui->addContent($formGui);
		return $ContGui;
	}
	function &getSearchGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');

		$tabs=array('search');
		if ($this->_Base->getCfg('cfg/archiv/enable')) {
			$tabs[]='archiv';
		}
		if (!in_array($this->_mode,$tabs)) {
			$this->_mode=reset($tabs);
		}
		$boxGui=new BoxGui('email|showtab_search');
		$boxGui->setBorderColor(APP_FGCOLOR);
		$boxGui->addTab('search',$this->_T->lang('[[Suche]]'),'#',true);
		$boxGui->setTabContent('search',$this->_getSearchConfigSearch($this->_mode));
		if ($this->_Base->getCfg('cfg/archiv/enable')) {
			$boxGui->addTab('archiv',$this->_T->lang('[[Archiv]]'),'#',true);
			$boxGui->setTabContent('archiv',$this->_getSearchConfigArchiv($this->_mode));
		}
		$boxGui->setTabOn($this->_mode);
		return $boxGui;
	}
	function &parseContentGui($print=false) {
		switch ($this->_search['smode']) {
			case 'archiv':
				$this->parseContentGuiArchiv($print);
			break;
			default:
				$this->parseContentGuiSearch($print);
			break;
		}
	}
	function &parseContentGuiArchiv($print=false) {
		if (trim($this->_search['info']) || $this->_search['DateB'] || $this->_search['DateE']) {
			$rows=0;
			$limit=10;
			$b=Framework::getParam('b',0);

			require_once('lib/class_ApplicationListGui.php');
			$Gui=new ApplicationListGui();
			$Gui->setName($this->_T->lang('[[Archiv]]'));
			if (Framework::getParam('_OrderF',0,'G')) {
				$this->setPrefs('MailOrderF',Framework::getParam('_OrderF',0,'G'));
				$this->setPrefs('MailOrderD',Framework::getParam('_OrderD',0,'G'));
			}
			$orderF=$this->getPrefs('MailOrderF',SORTARRIVAL);
			$orderD=$this->getPrefs('MailOrderD',-1);

			switch($orderF) {
				case SORTSUBJECT:
					$order='Subject';
				break;
				case SORTFROM:
					$order='MailFrom';
				break;
				case SORTTO:
					$order='MailTo';
				break;
				case SORTSIZE:
					$order='MailSize';
				break;
				default:
					$order='MailDate';
				break;
			}
			$order.=' '.($orderD==-1?'DESC':'ASC');

			$entries=$this->_Base->searchArchiv($rows,$this->_search,$order,$b,$limit,true,true);


			$this->_L->setParam('_load',1);
			if ($orderF) {
				$Gui->setActOrder($orderF,$orderD);
				$Gui->setOrderLink($this->_L);
			}
			$Gui->setNavLink($this->_L);
			$Gui->setAutoBg(APP_FG10COLOR);
			$Gui->setID('mailTab');
			$this->_frm->addOnLoad("disableSelection(document.getElementById('mailTab'));");

			$Gui->setRowClass(array('list_l','list_b','list_h','list_hb','list_s','list'));
			$Gui->setLimit($limit);
			$Gui->setSumRows($rows);
			$Gui->setBegin($b);

			$hspan=3;
			$noEnc=array('NoEnc'=>1,'NoBr'=>1);

			$key='hdSubject';
			$Gui->addHeaderCol($key,$this->_T->lang('[[Betreff]]'),'','','',0,'',$hspan);
			$Gui->setHeaderOrder($key,SORTSUBJECT,1);
			$key='hdFrom';
			$Gui->addHeaderCol($key,$this->_T->lang('[[AbsenderIn]]'),'','','',1);
			$Gui->setHeaderOrder($key,SORTFROM,1);
			$key='hdTo';
			$Gui->addHeaderCol($key,$this->_T->lang('[[EmpfaengerIn]]'),'','','',1);
			$Gui->setHeaderOrder($key,SORTTO,1);
			$key='hdDate';
			$Gui->addHeaderCol($key,$this->_T->lang('[[Datum]]'),'','','',1);
			$Gui->setHeaderOrder($key,SORTARRIVAL,-1);
			$key='hdSize';
			$Gui->addHeaderCol($key,$this->_T->lang('[[Dateigroesse]]'),'','','',1);
			$Gui->setHeaderOrder($key,SORTSIZE,1);

			$len=50;

			$hl=0;
			if ($rows) {
				$oldOrderVal='';
				foreach ($entries as $mkey=>$val) {
					$hl=($hl?$hl=0:$hl=1);
					$Gui->addRow($hl?2:0,'top','');

					$key='img';
					$Gui->addCol($key,'','obj_img/m_send.gif','','',0,'',0,'','');
					$key='att';
					$Gui->addCol($key,'',$val['AttachmentsNum']?'obj_img/mail_attach.gif':'tras.gif');

					$key='subject';
					$Gui->addCol($key,$val['Subject'],'',$this->_L->getTemplink(null,array('_archivID'=>$mkey)),'',0,'2000',0,'','');
					$key='from';
					$Gui->addCol($key,Framework::wordSplit($val['MailFrom'],$len),'','','',1);
					$key='to';
					$Gui->addCol($key,Framework::wordSplit($val['MailTo'],$len),'','','',1);

					$key='date';
					$Gui->addCol($key,strftime("%a, %d.%m.%Y %H:%M",$val['MailDate']),'','','',1);
					$key='size';
					$Gui->addCol($key,Framework::formatSize($val['MailSize']),'','','',1);
				}
			}
			$this->_Gui->addContent($Gui);
		}
	}

	function &parseContentGuiSearch() {
			require_once('lib/class_ContentGui.php');
			require_once('lib/class_FunctionObjActionGui.php');
			$hGui=new ContentGui();
			$hGui->setName($this->_T->lang('[[Suche]]'));

			$objActionGui=new FunctionObjActionGui();
			$obj_action=$this->_frm->getObjAction($this->_Base->getModul(),'search');
			$parse=false;
			foreach ($obj_action as $key=>$val) {
				if ($val['Hidden']) continue;
				$objActionGui->addValue($key,$val['Name']);
				$parse=true;
			}
			if ($parse) $hGui->addFunction($objActionGui);

			$this->_Gui->addContent($hGui);
		//if (trim($this->_search['info'])) {
			require_once('lib/mail/class_MailGui.php');
			$mailGui=new MailGui();

			$headers=array('ListID'=>1);
			if (($this->_Obj->getMeta('Type')!='S' &&  $this->_Obj->getMeta('Type')!='R') || $this->_Base->getPrefs('abs')) {
				$headers['from']=1;
			}
			if ($this->_Obj->getMeta('Type')=='S' || $this->_Obj->getMeta('Type')=='R' || $this->_Base->getPrefs('abs')) {
				$headers['to']=1;
			}
			$this->_L->setParam('_load',1);
			$ssFolders=array_unique($this->_search['sfolder']);
			if ($this->_search['ssub']) {
				foreach ($this->_search['sfolder'] as $val) {
					$subFolders=$this->_Base->listFolders($val.$this->_Base->getCfg('cfg/delim').'*',true,false);
					//debug($subFolders);
					foreach ($subFolders as $subObj) {
						if (!in_array($subObj->getBox(),$ssFolders)) {
							$ssFolders[]=$subObj->getBox();
						}
					}

				}
			}
			$search=array(
				'box'=>array_unique($ssFolders),
				'limit'=>100,
				'b'=>Framework::getParam('b',0),
				'use_limit'=>false,
			);
			if ($this->_search['info']) {
				$search['filter']=$this->_search['swhere']." \"".$this->_search['info']."\"";
			}
			$listContent=$mailGui->getMailListGui($this->_Base,$search,$headers);
			$colorPicker=$mailGui->getColorPicker($this->_Base);
			$showAktMail=$mailGui->getAktMailScript($this->_Base);

			if ($this->_Base->getCfg('cfg/all/fwd_intern')) $mailGui->parseFwdJs();
			$mailGui->parseCpMvJs();

			if (is_object($listContent)) $this->_Gui->addContent($listContent);
			if (is_object($showAktMail)) $this->_Gui->addContent($showAktMail);
			if (is_object($colorPicker)) $this->_Gui->addContent($colorPicker);

		//}


	}
	function parseExportGui() {
		$ssFolders=array_unique($this->_search['sfolder']);
		if ($this->_search['ssub']) {
			foreach ($this->_search['sfolder'] as $val) {
				$subFolders=$this->_Base->listFolders($val.$this->_Base->getCfg('cfg/delim').'*',true,false);
				foreach ($subFolders as $subObj) {
					if (!in_array($subObj->getBox(),$ssFolders)) {
						$ssFolders[]=$subObj->getBox();
					}
				}

			}
		}
		$search=array();
		if ($this->_search['info']) {
			$search['Filter']=$this->_search['swhere']." \"".$this->_search['info']."\"";
		}
		set_time_limit(0);
		$file=date('Ymd').'_mail.zip';
		Framework::deleteFilesRecursive($this->_Base->getExportPath(),'/.*/');
		$result=$this->_Base->archivFolder(array_unique($ssFolders),$search,$this->_Base->getExportPath(),$file,false) ;
		if (file_exists($this->_Base->getExportPath().'/'.$file)) {
			FrameWork::dumpFile($this->_Base->getExportPath().'/'.$file,$file,'application/x-gzip',true);
		}
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs('email',array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs('email',$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
}
?>