<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->setRoot("tpl/$THEME/$session_lang");
$t->define (array('menu'=>"menu_img.inc.html"));
$name=$REG_USER["firstname"]." ".$REG_USER["lastname"];
$t->assign("USER",$name);
$t->assign("DATE",strftime("%A, %d. %B %Y"));
$t->assign("GE_VERSION_DISP",sprintf('%1.3f',GE_VERSION));
$t->assign('LOGO_BG','');
if (defined('GE_GroupeLogo')) {
	$t->assign('GRUOPE_LOGO',GE_GroupeLogo);
} else {
	$tmpDate=date('m');
	$tmpOstern=easter_date(date("Y"));
	$tmpTime=mktime(0,0,0);
	if ($tmpDate==10 && date("d")>=29 && file_exists('img/'.APP_THEME.'/menu/group-e_halloween.gif')) {
		$t->assign('GRUOPE_LOGO','img/'.APP_THEME.'/menu/group-e_halloween.gif');
	} elseif (($tmpTime>$tmpOstern-53*3600*24 && $tmpTime<$tmpOstern-46*3600*24) && file_exists('img/'.APP_THEME.'/menu/group-e_carneval.gif')) {
		$t->assign('GRUOPE_LOGO','img/'.APP_THEME.'/menu/group-e_carneval.gif');
	} elseif (($tmpTime>$tmpOstern-45*3600*24 && $tmpTime<$tmpOstern+2*3600*24) && file_exists('img/'.APP_THEME.'/menu/group-e_easter.gif')) {
		$t->assign('GRUOPE_LOGO','img/'.APP_THEME.'/menu/group-e_easter.gif');
	} elseif (($tmpDate==12 || $tmpDate==1) && file_exists('img/'.APP_THEME.'/menu/group-e_snow.gif')) {
		$t->assign('GRUOPE_LOGO','img/'.APP_THEME.'/menu/group-e_snow.gif');
		$t->assign('LOGO_BG','background:url(img/'.APP_THEME.'/menu/bg_snow.gif) left bottom repeat-x;');
	} else {
		$t->assign('GRUOPE_LOGO','img/'.APP_THEME.'/menu/group-e.gif');
	}
}

if ($P && $app['proj']) {
	$actProj=$frm->getPrefs('proj','actualProject');
	$myProjects=$P->listMyPrj();
	if (is_array($myProjects) && !empty($myProjects)) {
		require_once('lib/class_FormFieldsCore.php');
		$prjSel=new SelectFieldGroupBtn('actProject',$actProj,array('id'=>'actProject','style'=>'"width:250px;','onchange'=>"setPrefs('proj','actualProject',this.value);this.blur();"));
		$prjSel->setValues(array(0=>array(0=>$T->Lang('[[selProjekt]]'))) + $P->getPrjGroupList(array_keys($myProjects)));
		$t->assign('SEL_PROJECT',$prjSel->process());
		$t->parse('ROW','act_project');
	}
	if ($actProj && !isset($myProjects[$actProj])) $frm->insertPrefs('proj',array('actualProject'=>0));
}
//$loadAjax=" onclick=\"return loadContent('appContent',this.href);\"";
$av_apps=$frm->getApplication();
if ($av_apps['proj']) {
	if ($app['proj']) {
		$t->assign('PRJ_IMG','on');
		$t->assign('PRJ_LB',"<a href=\"index.php?site=proj.php&_clearM=".($site=='proj.php'?'0':'1')."\">");
		$t->assign('PRJ_LE',"</a>");
		$t->parse('ROW','menu_prj');
	} else {
		$t->assign('PRJ_IMG','off');
		$t->assign('PRJ_LB',"");
		$t->assign('PRJ_LE',"");
	}
}
if ($av_apps['cal']) {
	if ($app['cal']) {
		$t->assign('CAL_IMG','on');
		$t->assign('CAL_LB',"<a href=\"index.php?site=cal.php&_clearM=".($site=='cal.php'?'0':'1')."\">");
		$t->assign('CAL_LE',"</a>");
		$t->parse('ROW','menu_cal');
	} else {
		$t->assign('CAL_IMG','off');
		$t->assign('CAL_LB',"");
		$t->assign('CAL_LE',"");
	}
}
if ($av_apps['task']) {
	if ($app['task']) {
		$t->assign('AUF_IMG','on');
		$t->assign('AUF_LB',"<a href=\"index.php?site=task.php&_clearM=".($site=='task.php'?'0':'1')."\">");
		$t->assign('AUF_LE',"</a>");
		$t->parse('ROW','menu_auf');
	} else {
		$t->assign('AUF_IMG','off');
		$t->assign('AUF_LB',"");
		$t->assign('AUF_LE',"");
	}
}
if ($av_apps['addr']) {
	if ($app['addr']) {
		$t->assign('ADR_IMG','on');
		$t->assign('ADR_LB',"<a href=\"index.php?site=addr.php&_clearM=".($site=='addr.php'?'0':'1')."\">");
		$t->assign('ADR_LE',"</a>");
		$t->parse('ROW','menu_adr');
	} else {
		$t->assign('ADR_IMG','off');
		$t->assign('ADR_LB',"");
		$t->assign('ADR_LE',"");
	}
}
if ($av_apps['email']) {
	if ($app['email']) {
		$t->assign('MAI_IMG','on');
		$t->assign('MAI_LB',"<a href=\"index.php?site=mail.php&_clearM=".($site=='mail.php'?'0':'1')."\">");
		$t->assign('MAI_LE',"</a>");
		$t->parse('ROW','menu_mai');
	} else {
		$t->assign('MAI_IMG','off');
		$t->assign('MAI_LB',"");
		$t->assign('MAI_LE',"");
	}
}
if ($av_apps['forum']) {
	if ($app['forum']) {
		$t->assign('FOR_IMG','on');
		$t->assign('FOR_LB',"<a href=\"index.php?site=forum.php&_clearM=".($site=='forum.php'?'0':'1')."\">");
		$t->assign('FOR_LE',"</a>");
		$t->parse('ROW','menu_for');
	} else {
		$t->assign('FOR_IMG','off');
		$t->assign('FOR_LB',"");
		$t->assign('FOR_LE',"");
	}
}
if ($av_apps['fax']) {
	if ($app['fax']) {
		$t->assign('FAX_IMG','on');
		$t->assign('FAX_LB',"<a href=\"index.php?site=fax.php&_clearM=".($site=='fax.php'?'0':'1')."\">");
		$t->assign('FAX_LE',"</a>");
		$t->parse('ROW','menu_fax');
	} else {
		$t->assign('FAX_IMG','off');
		$t->assign('FAX_LB',"");
		$t->assign('FAX_LE',"");
	}

}
if ($av_apps['msg']) {
	if ($app['msg']) {
		$t->assign('NOT_IMG','on');
		$t->assign('NOT_LB',"<a href=\"index.php?site=msg.php&_clearM=".($site=='msg.php'?'0':'1')."\">");
		$t->assign('NOT_LE',"</a>");
		$t->parse('ROW','menu_not');
	} else {
		$t->assign('NOT_IMG','off');
		$t->assign('NOT_LB',"");
		$t->assign('NOT_LE',"");
	}
}
if ($av_apps['lmng']) {
	if ($app['lmng']) {
		$t->assign('BOO_IMG','on');
		$t->assign('BOO_LB',"<a href=\"index.php?site=lmng.php&_clearM=".($site=='lmng.php'?'0':'1')."\">");
		$t->assign('BOO_LE',"</a>");
		$t->parse('ROW','menu_boo');
	} else {
		$t->assign('BOO_IMG','off');
		$t->assign('BOO_LB',"");
		$t->assign('BOO_LE',"");
	}
}
if ($av_apps['fmng']) {
	if ($app['fmng']) {
		$t->assign('DAT_IMG','on');
		$t->assign('DAT_LB',"<a href=\"index.php?site=fmng.php&_clearM=".($site=='fmng.php'?'0':'1')."\">");
		$t->assign('DAT_LE',"</a>");
		$t->parse('ROW','menu_dat');
	} else {
		$t->assign('DAT_IMG','off');
		$t->assign('DAT_LB',"");
		$t->assign('DAT_LE',"");
	}
}
if ($av_apps['smb']) {
	if ($app['smb']) {
		$t->assign('SMB_IMG','on');
		$t->assign('SMB_LB',"<a href=\"index.php?site=smb.php&_clearM=".($site=='smb.php'?'0':'1')."\">");
		$t->assign('SMB_LE',"</a>");
		$t->parse('ROW','menu_smb');
	} else {
		$t->assign('SMB_IMG','off');
		$t->assign('SMB_LB',"");
		$t->assign('SMB_LE',"");
	}
}

if ($av_apps['admin']) {
	if ($app['admin']) {
		$t->assign('ADM_IMG','on');
		$t->assign('ADM_LB',"<a href=\"index.php?site=admin.php&_clearM=".($site=='admin.php'?'0':'1')."\">");
		$t->assign('ADM_LE',"</a>");
		$t->parse('ROW','menu_adm');
	} else {
		$t->assign('ADM_IMG','off');
		$t->assign('ADM_LB',"");
		$t->assign('ADM_LE',"");
	}
}
if ($av_apps['zef']) {
	if ($app['zef']) {
		$t->assign('ZEF_IMG','on');
		$t->assign('ZEF_LB',"<a href=\"index.php?site=zef.php&_clearM=".($site=='zef.php'?'0':'1')."\">");
		$t->assign('ZEF_LE',"</a>");
		require_once('lib/zef/class_zefMenuGui.php');
		$zefMenu=new zefMenuGui();
		$t->assign('CONTENT',$zefMenu->process());
		$t->parse('ROW','menu_zef_app');
		$t->parse('ROW','menu_zef');
	} else {
		$t->assign('ZEF_IMG','off');
		$t->assign('ZEF_LB',"");
		$t->assign('ZEF_LE',"");
	}
}
if ($av_apps['imng']) {
	if ($app['imng']) {
		$t->assign('BLA_IMG','on');
		$t->assign('BLA_LB',"<a href=\"index.php?site=imng.php&_clearM=".($site=='imng.php'?'0':'1')."\">");
		$t->assign('BLA_LE',"</a>");
		$t->parse('ROW','menu_bla');
	} else {
		$t->assign('BLA_IMG','off');
		$t->assign('BLA_LB',"");
		$t->assign('BLA_LE',"");
	}
}
if ($av_apps['stel']) {
	if ($app['stel']) {
		$t->assign('STEL_IMG','on');
		$t->assign('STEL_LB',"<a href=\"index.php?site=stel.php&_clearM=".($site=='stel.php'?'0':'1')."\">");
		$t->assign('STEL_LE',"</a>");
		$Stel=& $frm->getStaticModul('stel');
		if ($Stel->getPerms(2)) {
			$t->parse('ROW','menu_js_stel');
		}
		$t->parse('ROW','menu_stel');
	} else {
		$t->assign('STEL_IMG','off');
		$t->assign('STEL_LB',"");
		$t->assign('STEL_LE',"");
	}
}
if ($av_apps['prot']) {
	if ($app['prot']) {
		$t->assign('PRO_IMG','on');
		$t->assign('PRO_LB',"<a href=\"index.php?site=prot.php&_clearM=".($site=='prot.php'?'0':'1')."\">");
		$t->assign('PRO_LE',"</a>");
		$t->parse('ROW','menu_js_prot');
		$t->parse('ROW','menu_pro');
	} else {
		$t->assign('PRO_IMG','off');
		$t->assign('PRO_LB',"");
		$t->assign('PRO_LE',"");
	}
}

if ($av_apps['custom'] && defined('GE_CUSTOM_APP') && GE_CUSTOM_APP) {
	$t->assign('CUSTOM_TITLE',$av_apps['custom']['title']);
	if ($app['custom']) {
		$t->assign('CUSTOM_IMG','on');
		$t->assign('CUSTOM_LB',"<a href=\"index.php?site=custom.php&_clearM=".($site=='custom.php'?'0':'1')."\">");
		$t->assign('CUSTOM_LE',"</a>");
		$t->parse('ROW','menu_custom');
	} else {
		$t->assign('CUSTOM_IMG','off');
		$t->assign('CUSTOM_LB',"");
		$t->assign('CUSTOM_LE',"");
	}
}
if ($CFG['USER_CLASS']=='ldap_full' && $frm->getFrmCfg('ldap/squid') && $app['squid']) {
	$t->parse('ROW','menu_js_squid');
}
if ($site=='portal.php') {
	$t->parse('ROW','.edit_portal');
}
if ($pre["global"]["gs"] || ($site=='portal.php' && $app["portal"])) {
	if ($app['proj'] && $pre["global"]['s_proj']) {
			$tmpClear=($site=='proj.php')?0:1;
			if ($tmpClear) $t->assign('CLEAR_M',0); else $t->assign('CLEAR_M',0);
			$tmp=1;
			$t->parse('ROW','s_proj');
	}
	if ($app['fmng'] && $pre["global"]['s_fmng']) {
			$tmpClear=($site=='fmng.php')?0:1;
			if ($tmpClear) $t->assign('CLEAR_M',0); else $t->assign('CLEAR_M',0);
			$t->parse('ROW','s_fmng');
			$tmp=1;
	}
	if ($app['addr'] && $pre["global"]['s_addr']) {
			$tmpClear=($site=='addr.php')?0:1;
			if ($tmpClear) $t->assign('CLEAR_M',0); else $t->assign('CLEAR_M',0);
			$tmp=1;
			$t->parse('ROW','s_addr');
	}
	if ($app['task'] && $pre["global"]['s_task']) {
			$tmpClear=($site=='task.php')?0:1;
			if ($tmpClear) $t->assign('CLEAR_M',0); else $t->assign('CLEAR_M',0);
			$tmp=1;
			$t->assign('TASK_ADD',"index.php?site=task.php&action=i".'&_clearM='.$tmpClear);
			$t->parse('ROW','s_task');
	}
	if ($app['cal'] && $pre["global"]['s_gz']) {
			$tmpClear=($site=='cal.php')?0:1;
			if ($tmpClear) $t->assign('CLEAR_M',0); else $t->assign('CLEAR_M',0);
			$tmp=1;
			$t->assign('CAL_ADD',"index.php?site=cal.php&action=insert&date=".time()."&view=event&cal_user=".$auth->auth['uid'].'&_clearM='.$tmpClear);
			$t->assign("S_DATE",date("d/m/Y"));
			$t->parse('ROW','s_gehezu');
	}
	if ($pre["global"]['s_web'] && $frm->getFrmCfg('cfg/global/websearch')) {
			$tmp=1;
			$tmpUrl=explode('?',$frm->getFrmCfg('cfg/global/websearch'));
			$t->assign("ACTION_SEARCH",array_shift($tmpUrl));
			$t->assign("KEY_SEARCH","search");
			if (!empty($tmpUrl)) {
				$s_query=array();
				parse_str(implode('?',$tmpUrl),$s_query);
				foreach ($s_query as $s_key=>$s_val) {
					switch($s_val) {
						case '{SEARCH}':
							$t->assign("KEY_SEARCH",$s_key);
						break;
						case '{LANG}':
							$t->assign("KEY",$s_key);
							$t->assign("VAL",$frm->getLang());
							$t->parse('ROW','.s_web_param');
						break;
						default:
							$t->assign("KEY",$s_key);
							$t->assign("VAL",$s_val);
							$t->parse('ROW','.s_web_param');
						break;
					}
				}
			}
			$t->parse('ROW','s_web');
	}
	if ($app['email'] && $pre["global"]['s_email']) {
			$tmpClear=($site=='mail.php')?0:1;
			if ($tmpClear) $t->assign('CLEAR_M',0); else $t->assign('CLEAR_M',0);
			$tmp=1;
			$t->parse('ROW','s_email');
	}
	if ($app['forum'] && $pre["global"]['s_forum']) {
			$tmpClear=($site=='forum.php')?0:1;
			if ($tmpClear) $t->assign('CLEAR_M',0); else $t->assign('CLEAR_M',0);
			$tmp=1;
			$t->parse('ROW','s_forum');
	}
	if ($app['lmng'] && $pre["global"]['s_lmng']) {
			$tmpClear=($site=='lmng.php')?0:1;
			if ($tmpClear) $t->assign('CLEAR_M',0); else $t->assign('CLEAR_M',0);
			$tmp=1;
			$t->parse('ROW','s_lmng');
	}
	if ($app['imng'] && $pre["global"]['s_imng']) {
			$tmpClear=($site=='imng.php')?0:1;
			if ($tmpClear) $t->assign('CLEAR_M',0); else $t->assign('CLEAR_M',0);
			$tmp=1;
			$t->parse('ROW','s_imng');
	}
	if ($tmp) $t->parse('ROW','glob_search');
}
if ($app['sms'] || $app['msg'] || $app['rem']) {
	$options=array();
	if ($app['sms']) {
		require_once('lib/sms/options/geSmsOptionsSendsms.php');
		$frm->addJsScript('js/sms/store/smsStoreRecipient.js');
		$frm->addJsScript('js/sms/view/smsViewSendsms.js');
		$options['sendsmsShow']=true;
		$options['sendsmsOptions']=new geSmsOptionsSendsms();
	}
	if ($app['msg']) {
		require_once('lib/msg/options/geMsgOptionsSendmsg.php');
		$frm->addJsScript('js/msg/store/msgStoreRecipient.js');
		$frm->addJsScript('js/msg/view/msgViewSendmsg.js');
		$options['sendmsgShow']=true;
		$options['sendmsgOptions']=new geMsgOptionsSendmsg();
	}
	if ($app['rem']) {
		require_once('lib/rem/options/geRemOptionsSendrem.php');
		//$frm->addJsScript('js/msg/store/msgStoreRecipient.js');
		$frm->addJsScript('js/rem/view/remViewSendrem.js');
		$options['sendremShow']=true;
		$options['sendremOptions']=new geRemOptionsSendrem();
		if ($app['sms']) $options['sendremOptions']->showSms=1;
		if ($app['msg']) $options['sendremOptions']->showMsg=1;
		if ($app['email']) $options['sendremOptions']->showMail=1;
	}

	$frm->addJsScript('js/core/view/coreViewMessage.js');

	require_once('lib/class_FastTemplateGui.php');
	$initGui=new FastTemplateGui('core/js_init_messages.inc.html');
	$initGui->setEncode(false);
	$initGui->assign('OPTIONS',json_encode($options));
	$frm->addScript($initGui,'h');

	$t->parse('ROW','menu_js_msg');

}
$t->parse('ROW','menu_app');

?>