<?php
class ProjectMultiEditGui {
	var $_Base;
	var $_Obj;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_editAll=0;
	function ProjectMultiEditGui() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=& $frm->getStaticModul('proj');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
	}
	function _handleRequest() {
		$this->_editAll=$this->_L->getParam('editAll',0);
		$this->_searchPrj=array();
		if (Framework::getParam('_loadSearch','')) {
			$this->_searchPrj=$this->_frm->loadPostData($this->_Base->getModul(),'tmpSearchAdminProj',1,0);
		} 
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
	function &process() {
		$this->_handleRequest();
		return $this->getGui();
	}
	function &getGui() {
		require_once('lib/class_ApplicationTreeGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FunctionObjActionGui.php');
		require_once('lib/class_TemplateGui.php');

		$ContGui=new ApplicationTreeGui();
		$configValues=array();
		$configGui=$this->getConfigGui($configValues);
		$ContGui->addTreeContent($configGui);

		$listFields=array();
		if ($configValues['fieldID']) {
			$listFields[]=$configValues['fieldID'];
		}
		$listGui=$this->getListGui($listFields);

		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(null,array('action'=>'b','_loadSearch'=>1))));
		$listGui->addFunction($btBreak,1);

		$ContGui->addContent($listGui);
		return $ContGui;

	}
	function &getConfigGui(&$formValues) {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		$ContGui=new TemplateGui('core/common_content_border.inc.html');

		$avFieldArray=array(0=>array(0=>'-'));
		$avFields=array();

		$avFieldArray[0]['Aktiv']=$this->_T->lang('[[Aktiv]]');
		$avFields['Aktiv']=array(
			'Typ'=>'bool',
		);
		

		$avRules=$this->_T->langArray($this->_Base->getAvRules());
		foreach ($avRules as $key=>$val) {
			$avFieldArray[$this->_T->lang('[[Mitglieder]]')]['rule_'.$key]=$val;
			$avFields['rule_'.$key]=array(
				'Typ'=>'rule',
				'ID'=>$key,
			);
		}


		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key='fieldID';
		$formGui->addField($key,'select_grp',$this->_T->lang('[[Feld auswaehlen]]'),'','fields1');
		$formGui->setValues($key,$avFieldArray);
		$formGui->setAttribs($key,array('onchange'=>'document.daten.submit()'));


		$parseEdit=false;
		$isMulti=false;
		$aktField=$formGui->getFieldVal('fieldID',true);

		if ($aktField) {
			switch ($avFields[$aktField]['Typ']) {
				case 'rule':
					$key='fieldData';
					$mode='u';
					$params='';
					$lb_params=array('Values'=>array());
					$lb_params['Values'][]=array(
						'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
						'LabelSep'=>'',
						'mode'=>$mode,
						'app'=>'cal',
						'params'=>$params,
						'FieldVal'=>'_USERS',
					);
					$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
					$formGui->addField($key,'ttip',$lb_Invit,'','fields1');
					$formGui->setParams($key,array('mode'=>$mode,'width'=>200,'params'=>$params));

					$key='fieldMode';
					$formGui->addField($key,'radiolist_v',$this->_T->lang('[[Aktion]]'),'a','fields1');
					$select_array=array();
					$select_array['a']=$this->_T->Lang('[[BenutzerIn hinzufuegen]]');
					$select_array['d']=$this->_T->Lang('[[BenutzerIn entfernen]]');
					$formGui->setValues($key,$select_array);

					$parseEdit=true;
				break;
				case 'bool':
					$key='fieldData';
					$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Neuer Wert]]'),1,'fields1');
					$select_array=array(1=>$this->_T->Lang('[[Ja]]'),0=>$this->_T->Lang('[[Nein]]'));
					$formGui->setValues($key,$select_array);
					$parseEdit=true;
				break;
				default:
				break;
			}
		}




		if ($parseEdit) {
			$formGui->addField('save','submit','',$this->_T->lang('[[Aendern]]'),'fields1');
		}
		$formGui->addMetaToArray($formValues,'',true);

		if (Framework::getParam('save','','P')) {
			if ($this->_editAll) {
				$rows=0;
				$search=$this->_searchPrj;
				if ($this->_editAll==2) {
					$search['Aktiv']=1;
				}
				$ListID=$this->_Base->listAllPrj($rows,$search,0,0,'');
			} else {
				$ListID=Framework::getParam('ListID','','P');
			}
			//debug(count($ListID));exit;
			if (is_array($ListID)) {
				foreach($ListID as $val) {
					if (is_object($val)) {
						$PObj=$val;
					} else {
						$PObj=$this->_Base->getObj($val);
					}
					if (is_object($PObj) && $this->_Base->isRuleUser()) {
						switch ($avFields[$formValues['fieldID']]['Typ']) {
							case 'rule':
								$groupID=$this->_Base->getRuleGroupID($PObj,$avFields[$formValues['fieldID']]['ID']);
								if ($formValues['fieldData']) {
									$tmp=explode('|',$formValues['fieldData']);
									foreach ($tmp as $tmp_uid) {
										$memberID=substr($tmp_uid,2);
										switch ($formValues['fieldMode']) {
											case 'a':
												$this->_frm->insertGroupUsers($groupID,array($memberID),false);
												if ($PObj->getMeta('MailFolder')/* && $this->_Base->existsMailFolder($PObj->getMeta('MailFolder'))*/) {
													$Mail=& $this->_frm->getStaticModul('mail');
													$Mail->delteMailAbbo($memberID,$PObj->getMeta('MailFolder'));
													$Mail->insertMailAbbo($memberID,$PObj->getMeta('MailFolder'));
												}
											break;
											case 'd':
												$this->_frm->deleteUserGroups($memberID,$groupID,false,false);
												if ($PObj->getMeta('MailFolder')/* && $this->_Base->existsMailFolder($PObj->getMeta('MailFolder'))*/) {
													$Mail=& $this->_frm->getStaticModul('mail');
													$Mail->delteMailAbbo($memberID,$PObj->getMeta('MailFolder'));
													$Mail->insertMailAbbo($memberID,$PObj->getMeta('MailFolder'),'un_abbo');
												}
											break;
										}
									}
								} else {

								}
							break;
							case 'bool':
								if (isset($formValues['fieldData'])) {
									$PObj->setMeta($formValues['fieldID'],$formValues['fieldData']);
									$this->_Base->updateObj($PObj);
								}
							break;
						}
					}
				}
			}
		}
		$ContGui->addContent('formConfig',$formGui,'CONTENT');
		return $ContGui;
	}
	function &getListGui($listFields) {
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		require_once('lib/class_ApplicationTreeGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_ApplicationListGui.php');
		if (Framework::getParam('_OrderF',0,'G')) {
			$this->setPrefs('prjOrderF',Framework::getParam('_OrderF',0,'G'));
			$this->setPrefs('prjOrderD',Framework::getParam('_OrderD',0,'G'));
		}
		$orderF=$this->getPrefs('prjOrderF','Aktiv');
		$orderD=$this->getPrefs('prjOrderD',-1);
		$sqlOrder=$orderF." ".($orderD==-1?'DESC':'ASC');
		if ($orderF!='Title') $sqlOrder.=",Title ASC";
		$L=Framework::cloneObj($this->_L);
		$L->setParam('_loadSearch',1);

		$rows=0;
		$limit=0;
		$b=0;

		if ($this->_editAll) {
			$rows=0;
			$search=$this->_searchPrj;
			if ($this->_editAll==2) {
				$search['Aktiv']=1;
			}
			$entries=$this->_Base->listAllPrj($rows,$search,0,0,'');
		} else {
			$tmp=$this->_frm->getClipboard('proj_s');
			$prjIDs=array(0);
			if (is_array($tmp)) {
				foreach($tmp as $val) {
					$prjIDs[]=$val['Content'];
				}
			}
			$search=array('ProjID'=>$prjIDs);
			$entries=$this->_Base->listAllPrj($rows,$search,$b,$limit,$sqlOrder);
		}
		$Gui=new ApplicationListGui();
		$Gui->setName($this->_T->lang('[[Projekte bearbeiten]]'));
		if ($this->_editAll) {
			$Gui->addRow($hl?$hl=0:$hl=1,'top');
			if ($this->_editAll==2) {
				$Gui->addCol('Title',$this->_T->lang('[[Aktive Projekte]]').': '.count($entries));
			} else {
				$Gui->addCol('Title',$this->_T->lang('[[Alle Projekte]]').': '.count($entries));
			}
		} else {
			$Gui->setNavLink($L);
			$Gui->setOrderLink($L);
			$Gui->setActOrder($orderF,$orderD);
			$Gui->setLimit($limit);
			$Gui->setSumRows($rows);
			$Gui->setBegin($b);

			$funcSelAll=new FunctionButtons('prj_list','selectall',array('ListID'=>'ListID[]','ListOn'=>count($entries)==count(Framework::getParam('ListID',array(),'P'))));
			$Gui->addHeaderCol('ListID',$funcSelAll,'','','',1,'1%',0,'');
			$Gui->setTrOver('trBOC({ROW},this);');
			$Gui->setTrDown('trBOI({ROW},this,1);');
			$Gui->setAutoBg(APP_FG10COLOR);
			$Gui->setID('prjTab');
			$this->_frm->addOnLoad("disableSelection(document.getElementById('prjTab'));");

			$Gui->addHeaderCol('ProjNumTxt',$this->_T->lang('[[ProjektnummerSmall]]'),'','','',1);
			$Gui->setHeaderOrder('ProjNumTxt','ProjNumTxt',1);
			$Gui->addHeaderCol('Title',$this->_T->lang('[[Name]]'),'','','',1);
			$Gui->setHeaderOrder('Title','Title',1);

			$calcRules=array();
			foreach ($this->_Base->getAvRules() as $key=>$val) {
				if (in_array('rule_'.$key,$listFields)) {
					$Gui->addHeaderCol('rule_'.$key,$this->_T->lang($val),'','','',1);
					$calcRules[]=$key;
					//$Gui->setHeaderOrder('FKProfileID','ProjMetabase.FKProfileID',1);
				}
			}
			$Gui->addHeaderCol('Aktiv',$this->_T->lang('[[Aktiv]]'),'','','',1);
			$Gui->setHeaderOrder('Aktiv','Aktiv',-1);
			$Gui->addHeaderCol('TimeCreate',$this->_T->lang('[[Erstellt am]]'),'','','',1);
			$Gui->setHeaderOrder('TimeCreate','TimeCreate',-1);
			$Gui->addHeaderCol('UserCreate',$this->_T->lang('[[Erstellt von]]'),'','','',1);
			$Gui->setHeaderOrder('UserCreate','UserCreate',1);

			$btnList=new CheckBoxBtn ('ListID[]','');
			$btnList->setAttribs(array(
				'onclick'=>'return false;',
			));

			if (!empty($calcRules)) {
				$getGroups=array();
				$allPrjGroups=$this->_Base->getAllRuleGroupID(array_keys($entries),$calcRules);
				foreach($allPrjGroups as $val) {
					$getGroups=array_merge($getGroups,$val);
				}
				$allGroupMembers=$this->_frm->getAllGroupUsers($getGroups);
			}


			foreach ($entries as $key=>$val) {
				$Gui->addRow($hl?$hl=0:$hl=1,'top');
				$Gui->addCol('ListID',$btnList->process($val->getID()),'','','',1,'1%',0,'',$noEnc);
				$Gui->addCol('ProjNumTxt',$val->getMeta('ProjNumTxt'),'',$this->_L->getTempLink(null,array('oid'=>$val->getID(),'action'=>'n')));
				$Gui->addCol('Title',$val->getName(),'',$this->_L->getTempLink(null,array('oid'=>$val->getID(),'action'=>'n')));
				if (!empty($calcRules)) {
					foreach ($calcRules as $rkey) {
						$tmp=array();
						if (isset($allPrjGroups[$key][$rkey])) {
							//$users=$this->_frm->getGroupUsers($allPrjGroups[$key][$rkey]);
							if (isset($allGroupMembers[$allPrjGroups[$key][$rkey]])) {
								$users=$allGroupMembers[$allPrjGroups[$key][$rkey]];
								foreach ($users as $uval) {
									$tmp[]=$this->_frm->getCachedUserName($uval,0,1);
								}
							}
						}
						$Gui->addCol('rule_'.$rkey,implode("\n",$tmp),'','','',1);
					}
				}
				$Gui->addCol('Aktiv',$val->getMeta('Aktiv')?'X':'-','','','',1);
				$Gui->addCol('TimeCreate',date('d.m.Y',$val->getMeta('TimeCreate')),'','','',1);
				$Gui->addCol('UserCreate',$this->_frm->getCachedUserName($val->getMeta('UserCreate')),'','','',1);
			}
		}
		return $Gui;

	}

}
?>