<?php
class ProjectSearchConfigGui {
	var $_Base;
	var $_Obj;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_editAll=0;
	function __construct() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=& $frm->getStaticModul('proj');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
	function &getSearchList(&$search,&$config) {
		$this->_searchPrj=&$search;
		require_once('lib/class_ApplicationListGui.php');

		$tabGui=new ApplicationListGui();
		$tabGui->addRow($this->_searchPrj['Fav']?2:0);
		$tabGui->addCol('IMG','','month_mine.gif');
		$tabGui->addCol('Name',$this->_T->Lang('[[Favoriten]]'),'',$this->_L->getTempLink(array('b'),array('_searchFav'=>1)),'',0,'2000');
		$tabGui->addCol('IMG_DEL','','tras.gif');


		$slist=$this->_Base->listSearch();
		foreach ($slist as $key=>$val) {
			if ($key) {
				$tabGui->addRow($this->_searchPrj['Vsrid']==$key?2:0);
				if ($val['FKUserID']==$this->_frm->getUser()) {
					$tabGui->addCol('IMG','','month_mine.gif');
				} else {
					$tabGui->addCol('IMG','','month_all.gif');
				}
				$tabGui->addCol('Name',$val['Title'],'',$this->_L->getTempLink(array('b'),array('_vsrid'=>$key)),'',0,'2000');
				if ($val['FKUserID']==$this->_frm->getUser() || $this->_Base->isRuleUser()) {
					$tabGui->addCol('IMG_DEL','','loeschen.gif',$this->_L->getTempLink(null,array('_delSrid'=>$key)));
				} else {
					$tabGui->addCol('IMG_DEL','','tras.gif');
				}
				if ($this->_searchPrj['Vsrid']==$key) {
					$searchEditGui=$this->getSearchEditGui();
					if ($searchEditGui) {
						$tabGui->addRow(0);
						$tabGui->addCol('IMG','','');
						$tabGui->addCol('Name',$searchEditGui,'','','',0,'','2');
					}
				}
			}
		}
		return $tabGui;
	}
	function getSearchEditGui() {
		if (is_array($this->_searchPrj['search'])) {
			require('lib/class_FormGui.php');
			$formGui=new FormGui();
			$formGui->setFieldClass('ipts','ipts');
			$formGui->setLabelClass('no','no_error');
			$BaseSelect=& $this->_frm->getStaticModul('uform_select');
			//debug($this->_searchPrj['search']);
			$parse=$this->_addSearchEditGroup($formGui,0);
			if ($parse) {
				$key='ovSubmit';
				$formGui->addField($key,'submit','',$this->_T->lang('[[Suchen]]'));
				return $formGui;
			}
		}
	}
	function _addSearchEditGroup(&$formGui,$setID) {
		$parse=false;
		if (is_array($this->_searchPrj['search'][$setID]['field'])) {
			foreach ($this->_searchPrj['search'][$setID]['field'] as $fieldID=>$value) {
				//debug($value);
				if ($value['typ']=='grp') {
					if ($this->_addSearchEditGroup($formGui,$value['value'])) {
						$parse=true;
					}
				} else {
					if ($value['key']=='all') {
						$sField=array('T'=>'text','N'=>'[[Irgend ein Feld]]');
					} else {
						$sField=$this->_Base->getSearchFields($value['key']);
					}
					$keyV='ovV['.$setID.']['.$fieldID.']';
					$keyM='ovM['.$setID.']['.$fieldID.']';
					if($value['edit']) {
						switch($sField['T']) {
							case 'ruser':
							case 'user':
							case 'fuser':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!='));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'select',$this->_T->lang($sField['N']),$value['value']);
								if (!isset($appUsers)) {
									$appUserIDs=$this->_frm->getApplicationUsers('proj');
									if (!empty($appUserIDs)) {
										$appUsers=$this->_frm->getFullname(array_keys($appUserIDs));
									} else {
										$appUsers=array();
									}
								}
								$formGui->setValues($keyV,array(0=>'-') + $appUsers);
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));

								$this->_searchPrj['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_searchPrj['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'text':
							case 'area':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('lk'=>'~','nlk'=>'!~','is'=>'=','nis'=>'!=','bg'=>'^','nbg'=>'!^'));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'text',$this->_T->lang($sField['N']),$value['value']);
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));

								$this->_searchPrj['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_searchPrj['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'num':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!=','gt'=>'>=','lt'=>'<=','bg'=>'^','nbg'=>'!^'));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'text',$this->_T->lang($sField['N']),$value['value']);
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));
								//$fObj=& $formGui->getFieldObj($keyV);
								//$fObj->setNumDec(intval($sField['C']['decimals']));
								//$fObj->setDefault($value['value']);
								//debug($value['value']);

								$this->_searchPrj['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_searchPrj['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'date':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!=','gt'=>'>=','lt'=>'<='));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								//debug($value['value']);
								$formGui->addField($keyV,'text',$this->_T->lang($sField['N']),Framework::formatSearchDate($value['value']));
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));

								$this->_searchPrj['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_searchPrj['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'unixdate':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!=','gt'=>'>=','lt'=>'<='));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								//debug($value['value']);
								$formGui->addField($keyV,'text',$this->_T->lang($sField['N']),$value['value']);
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));

								$this->_searchPrj['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_searchPrj['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'check':
								$sArray=array('0'=>$this->_T->lang('[[Ignorieren]]'),'Y'=>$this->_T->lang('[[Ja]]'),'N'=>$this->_T->lang('[[Nein]]'));
								$formGui->addField($keyV,'radiolist_h',$this->_T->lang($sField['N']),$value['value']);
								$formGui->setValues($keyV,$sArray);
								$this->_searchPrj['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'select':
							case 'status_txt':
							case 'mselect':
							case 'comp':
								if ($value['key']=='ProjMetabase.FKProfileID') {
									$prfIds=$this->_Base->listMyPrjProfiles();
									$sArray=array();
									foreach ($this->_BasePrf->getProfileNames() as $k=>$v) {
										if (!in_array($k,$prfIds)) continue;
										$sArray[$k]=$v;
									}
								} elseif ($sField['T']=='comp') {
									$Zef=& $this->_frm->getStaticModul('zef');
									$sArray=$Zef->listAllCompanyNames();
								} else {
									$BaseSelect=& $this->_frm->getStaticModul('uform_select');
									$sArray=$sField['V']?Framework::extractObjName($BaseSelect->listSelect($sField['V'])):array();
								}
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!='));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'select',$this->_T->lang($sField['N']),$value['value']);
								$formGui->setValues($keyV,array('0'=>$this->_T->lang('[[Nicht gesetzt]]')) + $sArray);
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));

								$this->_searchPrj['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_searchPrj['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'addr':
								$formGui->addField($keyM,'select','',$value['mode']);
								$formGui->setValues($keyM,array('is'=>'=','nis'=>'!='));
								$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
								$formGui->setNoParse($keyM);

								$formGui->addField($keyV,'ttip',$this->_T->lang('[[Adresse]]'),$value['value'],'content');
								$formGui->setParams($keyV,array('mode'=>'a','no_width'=>1,'app'=>'','params'=>''));
								$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
								$formGui->setPrependFields($keyV,array($keyM));
								//$formGui->setNoParse($keyV);

								//$formGui->addField($keyF,'field_array',$this->_T->lang($sField['N']),array($keyM,$keyV));
								$this->_searchPrj['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
								$this->_searchPrj['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
								$parse=true;
							break;
							case 'status':
								$sArray=array();
								if (is_array($sField['V'])) {
									foreach ($sField['V'] as $temp) {
										$sArray[$temp]=new UserStatusObj($temp,'ipt_hlist');
									}
								}
								if (!empty($sArray)) {
									$formGui->addField($keyM,'select','',$value['mode']);
									$formGui->setValues($keyM,array('is'=>'=','nis'=>'!='));
									$formGui->setAttribs($keyM,array('style'=>'width:40px;'));
									$formGui->setNoParse($keyM);

									$formGui->addField($keyV,'radiolist_h',$this->_T->lang($sField['N']),$value['value']);
									$formGui->setValues($keyV,$sArray);
									$formGui->setAttribs($keyV,array('style'=>'width:190px;'));
									$formGui->setPrependFields($keyV,array($keyM));

									$this->_searchPrj['search'][$setID]['field'][$fieldID]['mode']=$formGui->getFieldVal($keyM,1);
									$this->_searchPrj['search'][$setID]['field'][$fieldID]['value']=$formGui->getFieldVal($keyV,1);
									$parse=true;
								}
							break;
							default:
							//	debug($sField);
							break;
						}
					}
				}
			}
		}
		return $parse;
	}

}
?>