<?php
class ObjProtSlot extends baseObj {
	var $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['protSlotName'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class ProtSlot extends ObjCore {
	var $_modul='prot';
	var $_table='ProtSlot';
	var $_cfgObjects=array (
		'IdField'=>'protSlotID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'protSlotPermsUsers',
		'GroupField'=>'protSlotPermsGroups',
		'OwnerField'=>'',
		'TranslationFields'=>array('protSlotName'),
		'0'=>array(
			'ClassName'=>'ObjProtSlot',
			'Fields'=>array(
				'protSlotID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'protSlotName'=>array(
					'Typ'=>'core',
				),
				'protSlotTyp'=>array(
					'Typ'=>'core',
				),
				'protSlotDefinition'=>array(
					'Typ'=>'core',
				),
				'protSlotStart'=>array(
					'Typ'=>'core',
				),
				'protSlotPermsUsers'=>array(
					'Typ'=>'core',
				),
				'protSlotPermsGroups'=>array(
					'Typ'=>'core',
				),
				'protSlotNextID'=>array(
					'Typ'=>'core',
				),
				'protSlotKeyID'=>array(
					'Typ'=>'core',
				),
				'protSlotDeleted'=>array(
					'Typ'=>'core',
				),
			),
		),
	);

	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','prot')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function insertObj(&$Obj) {
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		$Obj->setMeta('protSlotDeleted',1);
		return $this->updateObj($Obj);
	}
	function listObj($search=array(),$b=0,$limit=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'protSlotDeleted','Typ'=>'=','Values'=>0);
		if ($search['info']) {
			$searchQuery[]=array('Field'=>array('CalResource.calResName'),'Typ'=>'concat','Values'=>$search['info']);
		}
		$rows=0;
		return $this->searchObj($rows,$searchQuery,'ProtSlot.protSlotName ASC',$b,$limit);
	}
}
?>
