<?php
class ObjProtocoll extends baseObj {
	var $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['protName'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class Protocoll extends ObjCore {
	var $_modul='prot';
	var $_table='ProtMetabase';
	var $_cfgObjects=array (
		'IdField'=>'protID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'TranslationFields'=>array(),
		'0'=>array(
			'ClassName'=>'ObjProtocoll',
			'Fields'=>array(
				'protID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'protNumber'=>array(
					'Typ'=>'core',
				),
				'FKprotSlotID'=>array(
					'Typ'=>'core',
				),
				'protMode'=>array(
					'Typ'=>'core',
				),
				'FKprotDokID'=>array(
					'Typ'=>'core',
				),
				'protAddress'=>array(
					'Typ'=>'core',
				),
				'FKprotInhID'=>array(
					'Typ'=>'core',
				),
				'protSubject'=>array(
					'Typ'=>'core',
				),
				'protDate'=>array(
					'Typ'=>'core',
				),
				'FKprotSacID'=>array(
					'Typ'=>'core',
				),
				'FKprotAufID'=>array(
					'Typ'=>'core',
				),
				'FKprotAblID'=>array(
					'Typ'=>'core',
				),
				'FKprotFileID'=>array(
					'Typ'=>'core',
				),
				'protNotes'=>array(
					'Typ'=>'core',
				),
				'protContent'=>array(
					'Typ'=>'core',
				),
				'protComplete'=>array(
					'Typ'=>'core',
				),
				'protDeleted'=>array(
					'Typ'=>'core',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'TimeCreate'=>array(
					'Typ'=>'core',
					'Extra'=>'cTime',
				),
				'UserCreate'=>array(
					'Typ'=>'core',
					'Extra'=>'cUser',
				),
			),
		),
	);
	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','prot')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->_BaseSlo=$frm->getStaticModul('prot_slo');
	}
	function insertObj(&$Obj) {
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		$Obj->setMeta('protDeleted',1);
		return $this->updateObj($Obj);
	}
	function undeleteObj(&$Obj) {
		$Obj->setMeta('protDeleted',0);
		return $this->updateObj($Obj);
	}
	function listObj(&$rows,$search=array(),$order='protID ASC') {
		$searchQuery=array();
		if (!isset($search['protDeleted'])) {
			$searchQuery[]=array('Field'=>'protDeleted','Typ'=>'=','Values'=>0);
		} elseif($search['protDeleted']!=-1) {
			$searchQuery[]=array('Field'=>'protDeleted','Typ'=>'=','Values'=>$search['protDeleted']);
		}
		if (isset($search['protComplete']) && $search['protComplete']!=-1) {
			$searchQuery[]=array('Field'=>'protComplete','Typ'=>'=','Values'=>$search['protComplete']);
		}
		if ($search['UserCreate']) {
			$searchQuery[]=array('Field'=>'UserCreate','Typ'=>'=','Values'=>$search['UserCreate']);
		}
		if ($search['TimeCreateB']) {
			$searchQuery[]=array('Field'=>'TimeCreate','Typ'=>'>=','Values'=>$search['TimeCreateB']);
		}
		if ($search['TimeCreateE']) {
			$searchQuery[]=array('Field'=>'TimeCreate','Typ'=>'<=','Values'=>$search['TimeCreateE']);
		}
		if ($search['protMode']) {
			$searchQuery[]=array('Field'=>'protMode','Typ'=>'=','Values'=>$search['protMode']);
		}
		if ($search['FKprotSlotID']) {
			$searchQuery[]=array('Field'=>'FKprotSlotID','Typ'=>'=','Values'=>$search['FKprotSlotID']);
		}
		if ($search['protDateB']) {
			$searchQuery[]=array('Field'=>'protDate','Typ'=>'>=','Values'=>date('Y-m-d',$search['protDateB']));
		}
		if ($search['protDateE']) {
			$searchQuery[]=array('Field'=>'protDate','Typ'=>'<=','Values'=>date('Y-m-d',$search['protDateE']));
		}
		if ($search['FKprotSacID']) {
			$searchQuery[]=array('Field'=>'FKprotSacID','Typ'=>'=','Values'=>$search['FKprotSacID']);
		}
		if ($search['FKprotAufID']) {
			$searchQuery[]=array('Field'=>'FKprotAufID','Typ'=>'=','Values'=>$search['FKprotAufID']);
		}
		if ($search['FKprotAblID']) {
			$searchQuery[]=array('Field'=>'FKprotAblID','Typ'=>'=','Values'=>$search['FKprotAblID']);
		}


//debug($search);

		$searchQueryOR=array();

		$subQueryS=array();
		if ($search['Info'] || $search['FKprotDokID'] || $search['FKprotInhID']) {
			if (!$this->isRuleUser()) {
				$subQueryOR=array();
				$subQueryOR[]=array(array('Field'=>'UserCreate','Typ'=>'=','Values'=>$this->_frm->getUser()));
				if(!empty($search['_slotSensible'])) {
					$subQueryOR[]=array(array('Field'=>'FKprotSlotID','Typ'=>'=','Values'=>$search['_slotSensible']));
				}
				$subQueryS[]=array('Typ'=>'OR','Values'=>$subQueryOR);
			}
			if ($search['FKprotDokID']) {
				$subQueryS[]=array('Field'=>'FKprotDokID','Typ'=>'=','Values'=>$search['FKprotDokID']);
			}
			if ($search['FKprotInhID']) {
				$subQueryS[]=array('Field'=>'FKprotInhID','Typ'=>'=','Values'=>$search['FKprotInhID']);
			}
			if ($search['Info']) {
				$subQueryS[]=array('Field'=>array('protNumber','protAddress','protSubject','protNotes'),'Typ'=>'concat','Values'=>$search['Info']);
			}
			$searchQueryOR[]=$subQueryS;
		}

		if ($search['Info'] && !$this->isRuleUser()) {
			$subQueryU=array();
			$subQueryU[]=array('Field'=>array('protNumber'),'Typ'=>'concat','Values'=>$search['Info']);
			$searchQueryOR[]=$subQueryU;
		}
		if (!empty($searchQueryOR)) {
			$searchQuery[]=array('Typ'=>'OR','Values'=>$searchQueryOR);
		}

		$rows=0;
		return $this->searchObj($rows,$searchQuery,$order,$search['b'],$search['limit'],true);
	}
	function isUsedSlot($sObj) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKprotSlotID','Typ'=>'=','Values'=>$sObj->getID());
		return $this->searchSingleObj($searchQuery);
	}
	function getNextID($sObj,$updateCnt=false) {
		$update=array();
		$matches=array();
		$f_len=0;
		if (preg_match('/{([N]+)}/',$sObj->getMeta('protSlotDefinition'),$matches)) {
			$f_len=strlen($matches[1]);
		}
		switch($sObj->getMeta('protSlotTyp')) {
			case 'Y':
				//Jaehrlich zuruecksetzten
				$update['protSlotNextID']=$sObj->getMeta('protSlotNextID');
				if (!$sObj->getMeta('protSlotKeyID')) {
					$update['protSlotKeyID']=date('Y');
				} elseif ($sObj->getMeta('protSlotKeyID')!=date('Y')) {
					$update['protSlotNextID']=$sObj->getMeta('protSlotStart');
					$update['protSlotKeyID']=date('Y');
				}
			break;
			default:
				$update['protSlotNextID']=$sObj->getMeta('protSlotNextID');
			break;
		}
		do {
			$strtr=array(
				'/{YYYY}/'=>date('Y'),
				'/{([N]+)}/'=>str_pad((string)$update['protSlotNextID'],$f_len,'0',STR_PAD_LEFT),
			);


			$nextNumber=preg_replace(array_keys($strtr),array_values($strtr),$sObj->getMeta('protSlotDefinition'));
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'protNumber','Typ'=>'=','Values'=>$nextNumber);
			$update['protSlotNextID']++;
		} while ($this->searchSingleObj($searchQuery));

		if ($updateCnt) {
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'protSlotID','Typ'=>'=','Values'=>$sObj->getID());
			$this->_db->update('ProtSlot',$update, $searchQuery);
		}

		return $nextNumber;
	}
	function checkPerms($Obj,$check=0) {
		$acl=0;
		if ($this->isRuleUser()) {
			$acl=-1;
		} elseif ($Obj->getMeta('UserCreate')==$this->_frm->getUser()) {
			$acl=-1;
		} elseif ($sObj=$this->_BaseSlo->getCachedObj($Obj->getMeta('FKprotSlotID'))) {
			$acl=$sObj->getAcl();
		}
		if ($check) {
			return $check&$acl;
		} else {
			return $acl;
		}
	}

}
?>
