<?php
class ProtokollGui {
	var $_Base;
	var $_Obj;
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	function __construct() {
		global $frm,$t,$T,$E,$L,$Y;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_Y=&$Y;
		$this->_Base=& $frm->getStaticModul('prot');
		$this->_BaseSel=$frm->getStaticModul('prot_sel');
		$this->_BaseSlo=$frm->getStaticModul('prot_slo');
		$this->_T->loadModul('prot');
	}

	function _handleRequest() {
		$this->_action=Framework::getParam('action','b');
		if (Framework::getParam('view_x','','P')) {
			$this->_action='b';
		}
		$this->_L->setParam('action',$this->_action);

		$this->_avSlots=$this->_BaseSlo->listObj();
		if (empty($this->_avSlots)) {
			return false;
		}

		$this->_slotWrite=array();
		$this->_slotSensible=array();
		$this->_select=array(
			'slo'=>array(),
			'dok'=>array(),
			'inh'=>array(),
			'auf'=>array(),
			'abl'=>array(),
		);
		$this->_select['mode']=array('I'=>$this->_T->lang('[[Eingehend]]'),'O'=>$this->_T->lang('[[Ausgehend]]'));

		foreach ($this->_avSlots as $val) {
			if ($val->getACL(2)) {
				$this->_slotWrite[]=$val->getID();
			}
			if ($val->getACL(4)) {
				$this->_slotSensible[]=$val->getID();
			}
		}
		$this->_avSelect=$this->_BaseSel->listObj();
		foreach ($this->_avSelect as $val) {
			$this->_select[$val->getMeta('protSelTyp')][$val->getID()]=$val->getName();
		}
		$this->_oid=Framework::getParam('oid',0);
		$this->_ObjPerms=0;
		if ($this->_oid && ($this->_Obj=$this->_Base->getObj(Framework::getParam('oid',0)))) {
			if (!$this->_Base->checkPerms($this->_Obj,1)) {
				$this->_oid=0;
				$this->_Obj=false;
			}
		}
		if (Framework::getParam('_load',0)) {
			$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpSearchProt',1,0);
		}
		switch ($this->_action) {
			case 'i':
			case 'v':
				if (Framework::getParam('_load',0)) {
					$this->_L->setParam('_load',1);
				}

				if (Framework::getParam('_dump','') && $this->_Obj && $this->_Base->checkPerms($this->_Obj,4)) {
					$Fmng=$this->_frm->getStaticModul('fmng');
					$Fmng->dumpFile('prot_'.Framework::getParam('_dump',''),$this->_Obj->getID(),1,$this->_Obj->getMeta(Framework::getParam('_dump','')));
					exit;
				}
				if (Framework::getParam('delete_x',0) && $this->_Obj && $this->_Base->isRuleUser()) {
					$this->_Base->deleteObj($this->_Obj);
					$this->_L->unsetParam('oid');
					$this->_L->setParam('action','b');
					$this->_L->goToLink();
				}
				if (Framework::getParam('undelete_x',0) && $this->_Obj && $this->_Base->isRuleUser()) {
					$this->_Base->undeleteObj($this->_Obj);
					$this->_L->unsetParam('oid');
					$this->_L->setParam('action','b');
					$this->_L->goToLink();
				}
				if (Framework::getParam('edit_x',0) && $this->_Obj && ($this->_Base->isRuleUser() || $this->_Obj->getMeta('UserCreate')==$this->_frm->getUser())) {
					$this->_L->setParam('action','i');
					$this->_L->goToLink();
				}
			break;
			case 'b':
				if (Framework::getParam('export',0)) {
					$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpSearchProt',1,0);
					//$this->exportAuswertungGui();
				}
			break;
		}
		return true;

	}
	function processRequest() {
		if (!$this->_handleRequest()) {
			return false;
		}
		require_once('lib/class_ApplicationGui.php');
		$this->_AppGui=new ApplicationGui();
		$this->_AppGui->setName($this->_frm->getAppName('prot'));
		$this->_AppGui->setImage('appl_prot.gif');
		$this->_AppGui->addTab('b',$this->_T->lang('[[Protokoll]]'),"index.php?site=prot.php&action=b",'');
		if (!empty($this->_slotWrite)) {
			$this->_AppGui->addTab('i',$this->_T->lang('[[Neuer Eintrag]]'),"index.php?site=prot.php&action=i",'');
		}
		$this->_AppGui->setTabOn($this->_action);

		$formAction='';
		require_once('lib/class_ApplicationTreeGui.php');
		$Gui=new ApplicationTreeGui();
		$Gui->addTreeContent($this->getSearchGui());

		switch ($this->_action) {
			case 'i':
				$Gui->addContent($this->getInsertGui());
			break;
			case 'v':
				$Gui->addContent($this->getViewGui());
				if ($this->_Obj->getMeta('protContent')) {
					$Gui->addContent($this->getContentGui());
				}
			break;
			default:
				if ($this->_search['Mode'] || empty($this->_slotWrite)) {
					$Gui->addContent($this->getListSearchGui());
				} else {
					$uGui=$this->getListUncompleteGui();
					if ($uGui) {
						$Gui->addContent($uGui);
					}
					$Gui->addContent($this->getListLastGui());
				}


				/*$this->_E->setError('bd');
				$this->_E->setErrorMsg('bd',$this->_T->lang('[[ProtokollDbError]]'));
*/
				//$this->_AppGui->addContent($this->_T->lang('[[ProtokollDbError]]'),null,'proj_list');
			break;
		}
		$this->_AppGui->addContent($Gui);
		$this->_AppGui->setFormAction($formAction);
		$this->_AppGui->processApplication();
		return true;
	}
	function _fillListGui($mode,$tabGui,$entries) {
		$tabGui->setRowClass(array('list_l','list_h','list_s','list_y'));
		$tabGui->addHeaderCol('protNumber',$this->_T->lang('[[Protokollnummer]]'),'','','',1,'');
		$tabGui->addHeaderCol('TimeCreate',$this->_T->lang('[[Erstellt am]]'),'','','',1,'');
		$tabGui->addHeaderCol('protMode',$this->_T->lang('[[Protokollart]]'),'','','',1,'');
		$tabGui->addHeaderCol('FKprotDokID',$this->_T->lang('[[Dokumentart]]'),'','','',1,'');
		$tabGui->addHeaderCol('FKprotInhID',$this->_T->lang('[[Inhaltstyp]]'),'','','',1,'');
		$tabGui->addHeaderCol('protAddress',$this->_T->lang('[[Absender/Empfaenger]]'),'','','',0,'2000');
		if($mode=='search') {
			$tabGui->addHeaderCol('UserCreate',$this->_T->lang('[[Erstellt von]]'),'','','',1,'');
		}

		foreach ($entries as $key=>$val) {
			$permsV=$this->_Base->checkPerms($val,4);
			if ($val->getMeta('protComplete') || $mode=='uncomplete') {
				$tabGui->addRow(($hl?$hl=0:$hl=1),'top');
			} else {
				$tabGui->addRow(3,'top');
			}
			if ($val->getMeta('protDeleted')) {
				$tabGui->setTrClass('strike');
			}
			$tabGui->setRowData(array('GroupValues'=>array('protDay'=>date('d.m.Y',$val->getMeta('TimeCreate')))));
			switch($mode) {
				case 'last':
					$link=$this->_L->getTempLink(array(),array('action'=>'v','oid'=>$val->getID()));
				case 'search':
					$link=$this->_L->getTempLink(array(),array('action'=>'v','oid'=>$val->getID(),'_load'=>1));
				break;
				case 'uncomplete':
					$link=$this->_L->getTempLink(array(),array('action'=>'i','oid'=>$val->getID()));
				break;
			}

			$tabGui->addCol('protNumber',$val->getMeta('protNumber'),'',$link,'',1,'');
			$tabGui->addCol('TimeCreate',date('d.m.Y H:i',$val->getMeta('TimeCreate')),'',$link,'',1,'');
			$tabGui->addCol('protMode',$this->_select['mode'][$val->getMeta('protMode')],'','','',1,'');

			if (!$permsV) {
				$data='PRIVACY';
			} elseif($val->getMeta('FKprotDokID') && ($tmp=$this->_BaseSel->getCachedObj($val->getMeta('FKprotDokID')))) {
				$data=$tmp->getName();
			} else {
				$data='-';
			}
			$tabGui->addCol('FKprotDokID',$data,'','','',1,'');
			if (!$permsV) {
				$data='PRIVACY';
			} elseif($val->getMeta('FKprotInhID') && ($tmp=$this->_BaseSel->getCachedObj($val->getMeta('FKprotInhID')))) {
				$data=$tmp->getName();
			} else {
				$data='-';
			}
			$tabGui->addCol('FKprotInhID',$data,'','','',1,'');

			if (!$permsV) {
				$data='PRIVACY';
			} elseif($val->getMeta('protAddress')) {
				$data=$val->getMeta('protAddress');
			} else {
				$data='-';
			}
			$tabGui->addCol('protAddress',$data,'','','',0,'2000');
			if($mode=='search') {
				$tabGui->addCol('UserCreate',$val->getMeta('UserCreate')?$this->_frm->getCachedUserName($val->getMeta('UserCreate')):'','','','',1);
			}
		}
	}
	function &getListSearchGui() {
		require_once('lib/class_ApplicationListGui.php');

		$search=$this->_search;


		$rows=0;
		$entries=$this->_Base->listObj($rows,$search,'TimeCreate DESC');

		$tabGui=new ApplicationListGui();
		$tabGui->setName($this->_T->lang('[[Suche]]'));
		$tabGui->setAutoBg(APP_FG10COLOR);

		$tabGui->setLimit($search['limit']);
		$tabGui->setSumRows($rows);
		$tabGui->setBegin($search['b']);
		$L=Framework::cloneObj($this->_L);
		$L->setParam('_load',1);
		$tabGui->setNavLink($L);
		$tabGui->setGroupFields(array('protDay'),false);


		$this->_fillListGui('search',$tabGui,$entries);
		return $tabGui;
	}
	function &getListLastGui() {
		require_once('lib/class_ApplicationListGui.php');
		$search=array(
			'protComplete'=>1,
			'UserCreate'=>$this->_Base->getUser(),
			'b'=>Framework::getParam('b',0),
			'limit'=>50,
		);
		$rows=0;
		$entries=$this->_Base->listObj($rows,$search,'TimeCreate DESC');

		$tabGui=new ApplicationListGui();
		$tabGui->setName($this->_T->lang('[[Letzte Eintraege]]'));
		$tabGui->setAutoBg(APP_FG10COLOR);

		$tabGui->setLimit($search['limit']);
		$tabGui->setSumRows($rows);
		$tabGui->setBegin($search['b']);
		$L=Framework::cloneObj($this->_L);
		$tabGui->setNavLink($L);
		$tabGui->setGroupFields(array('protDay'),false);


		$this->_fillListGui('last',$tabGui,$entries);
		return $tabGui;
	}
	function &getListUncompleteGui() {
		require_once('lib/class_ApplicationListGui.php');
		$search=array(
			'protComplete'=>0,
			'UserCreate'=>$this->_Base->getUser(),
		);
		$rows=0;
		$entries=$this->_Base->listObj($rows,$search,'TimeCreate DESC');
		if ($rows) {

			$tabGui=new ApplicationListGui();
			$tabGui->setBorderColor('#ddc318');
			$tabGui->setHeaderColor('#fff7ce');
			$tabGui->setTitleColor('#ddc318');
			//$tabGui->setBorderColor('#ddc318','#ddc318');
			$tabGui->setName($this->_T->lang('[[Unvollstaendige Eintraege]]'));
			$tabGui->setAutoBg(APP_FG10COLOR);

			$this->_fillListGui('uncomplete',$tabGui,$entries);
			return $tabGui;
		}

	}
	function &getSearchGui() {
		//debug($_POST);
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_DateSelectForm.php');
		require_once('lib/class_FunctionButtons.php');


		$ContGui=new TemplateGui('core/common_content_border.inc.html');

		$TimeCreateGui=new DateSelectForm('s_TimeCreate',$this->_T->lang('[[Erstellt am]]'));
		$TimeCreateGui->setAvMode(array(1,5,3,4));
		$TimeCreateGui->setMode($this->_search['TimeCreateMode']?$this->_search['TimeCreateMode']:3);
		if ($this->_search['TimeCreateB'] || $this->_search['TimeCreateE']) {
			$TimeCreateGui->setDate(array($this->_search['TimeCreatB'],$this->_search['TimeCreatE']));
		} else {
			$TimeCreateGui->setDate(array(0,0));
		}
		$TimeCreateGui->_yearsNum=10;

		$ProtDateGui=new DateSelectForm('s_protDate',$this->_T->lang('[[Datum Dokument]]'));
		$ProtDateGui->setAvMode(array(3));
		$ProtDateGui->setMode($this->_search['protDateMode']?$this->_search['protDateMode']:3);
		if ($this->_search['protDateB'] || $this->_search['protDateE']) {
			$ProtDateGui->setDate(array($this->_search['protDateB'],$this->_search['protDateE']));
		} else {
			$ProtDateGui->setDate(array(0,0));
		}
		$ProtDateGui->_yearsNum=10;


		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key="Mode";
		$default='search';
		$formGui->addField('s_'.$key,'hidden','',$default,'fields0');
		$aktMode=$this->_search[$key]?$this->_search[$key]:$formGui->getFieldVal('s_'.$key,0);


		$key="Info";
		$default=$this->_search[$key]?$this->_search[$key]:'';
		$formGui->addField('s_'.$key,'text',$this->_T->lang('[[Suchtext]]'),$default,'fields0');

		$key='UserCreate';
		$default=$this->_search[$key]?'u_'.$this->_search[$key]:0;
		$params=base64_encode(serialize(array('MaxEntries'=>1,'useAll'=>1)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Erstellt von]]'),
			'LabelSep'=>'',
			'mode'=>'u',
			'app'=>'zef',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_Invit=new FunctionButtons('s_'.$key,'ajaxttiplabel',$lb_params);
		$formGui->addField('s_'.$key,'ttip',$lb_Invit,$default,'fields1');
		$formGui->setParams('s_'.$key,array('mode'=>'u','no_width'=>1,'params'=>$params));

		reset($this->_avSlots);
		if (count($this->_avSlots)>1) {
			$key="FKprotSlotID";
			$default=($this->_search[$key] && !is_array($this->_search[$key]))?$this->_search[$key]:0;
			$formGui->addField('s_'.$key,'select',$this->_T->lang('[[Protokollslot]]'),$default,'fields1');
			$formGui->setValues('s_'.$key,array(0=>$this->_T->lang('[[Alle]]')) +  Framework::extractObjName($this->_avSlots));
			$aktProtSlotID=$formGui->getFieldVal('s_'.$key,1);
		} else {
			$aktProtSlotID=key($this->_avSlots);
		}
		if (!$aktProtSlotID || empty($aktProtSlotID))  $aktProtSlotID=array_keys($this->_avSlots);

		$key="protMode";
		$default=$this->_search[$key]?$this->_search[$key]:'';
		$formGui->addField('s_'.$key,'select',$this->_T->lang('[[Protokollart]]'),$default,'fields1');
		$formGui->setValues('s_'.$key,array(''=>$this->_T->lang('[[Alle]]')) + $this->_select['mode']);



		$key="FKprotDokID";
		$default=$this->_search[$key]?$this->_search[$key]:0;
		$formGui->addField('s_'.$key,'select',$this->_T->lang('[[Dokumentart]]'),$default,'fields1');
		$formGui->setValues('s_'.$key,array(0=>$this->_T->lang('[[Alle]]')) + $this->_select['dok']);

		$key="FKprotInhID";
		$default=$this->_search[$key]?$this->_search[$key]:0;
		$formGui->addField('s_'.$key,'select',$this->_T->lang('[[Inhaltstyp]]'),$default,'fields1');
		$formGui->setValues('s_'.$key,array(0=>$this->_T->lang('[[Alle]]')) + $this->_select['inh']);



		$key='FKprotSacID';
		$default=$this->_search[$key]?'u_'.$this->_search[$key]:0;
		$mode='u';
		$params=base64_encode(serialize(array('MaxEntries'=>1,'useAll'=>1)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Sachbearbeiter]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_sac=new FunctionButtons('s_'.$key,'ajaxttiplabel',$lb_params);

		$formGui->addField('s_'.$key,'ttip',$lb_sac,$default,'fields2');
		$formGui->setParams('s_'.$key,array('mode'=>$mode,'no_width'=>1,'params'=>$params));

		$key="FKprotAufID";
		$default=$this->_search[$key]?$this->_search[$key]:0;
		$formGui->addField('s_'.$key,'select',$this->_T->lang('[[Auftraggeber]]'),$default,'fields2');
		$formGui->setValues('s_'.$key,array(0=>$this->_T->lang('[[Alle]]')) + $this->_select['auf']);

		$key="FKprotAblID";
		$default=$this->_search[$key]?$this->_search[$key]:0;
		$formGui->addField('s_'.$key,'select',$this->_T->lang('[[Ablageort]]'),$default,'fields2');
		$formGui->setValues('s_'.$key,array(0=>$this->_T->lang('[[Alle]]')) + $this->_select['abl']);

		if ($this->_Base->isRuleUser()) {
			$key="protDeleted";
			$default=$this->_search[$key]?$this->_search[$key]:-1;
			$formGui->addField('s_'.$key,'radiolist_h',$this->_T->lang('[[Annullierte Eintraege anzeigen]]'),$default,'fields2');
			$formGui->setValues('s_'.$key,array(0=>$this->_T->lang('[[Nein]]'),1=>$this->_T->lang('[[Ja]]'),-1=>$this->_T->lang('[[Alle]]')));

		}


		$submit_array=array(
			'view_x'=>' '.$this->_T->lang('[[Suchen]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','fields2');
		$formGui->setValues($key,$submit_array);


		$ContGui->addContent('form0',$formGui,'CONTENT',array('','fields0'));
		$ContGui->addContent('timeCreate',$TimeCreateGui->process(),'CONTENT');
		$ContGui->addContent('form1',$formGui,'CONTENT',array('','fields1'));
		$ContGui->addContent('protDate',$ProtDateGui->process(),'CONTENT');
		$ContGui->addContent('form2',$formGui,'CONTENT',array('','fields2'));




		$this->_search=array(
			'Mode'=>$aktMode,
			'Info'=>$formGui->getFieldVal('s_Info',1),
			'UserCreate'=>$formGui->getFieldVal('s_UserCreate',1)?substr($formGui->getFieldVal('s_UserCreate',1),2):0,
			'TimeCreateB'=>$TimeCreateGui->getDate('B'),
			'TimeCreateE'=>$TimeCreateGui->getDate('E'),
			'TimeCreateMode'=>$TimeCreateGui->getMode(),
			'protMode'=>$formGui->getFieldVal('s_protMode',1),
			'FKprotDokID'=>$formGui->getFieldVal('s_FKprotDokID',1),
			'FKprotInhID'=>$formGui->getFieldVal('s_FKprotInhID',1),
			'FKprotSlotID'=>$aktProtSlotID,
			'_slotSensible'=>$this->_slotSensible,
			'protDateB'=>$ProtDateGui->getDate('B'),
			'protDateE'=>$ProtDateGui->getDate('E'),
			'protDateMode'=>$ProtDateGui->getMode(),
			'FKprotSacID'=>$formGui->getFieldVal('s_FKprotSacID',1)?substr($formGui->getFieldVal('s_FKprotSacID',1),2):0,
			'FKprotAufID'=>$formGui->getFieldVal('s_FKprotAufID',1),
			'FKprotAblID'=>$formGui->getFieldVal('s_FKprotAblID',1),
			'protDeleted'=>$this->_Base->isRuleUser()?$formGui->getFieldVal('s_protDeleted',1):0,
			'limit'=>100,
			'b'=>Framework::getParam('view_x','','P')?0:Framework::getParam('b',0,'G'),
		);
		$this->_L->setParam('b',$this->_search['b']);
		$this->_frm->savePostData($this->_Base->getModul(),'tmpSearchProt',null,$this->_search);

		return $ContGui;
	}

	function &getInsertGui() {
		require_once('lib/prot/class_ProtokollObjectGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');

		$contGui=new ContentGui();

		$Gui=new ProtokollObjectGui();
		if ($this->_Obj && ($this->_Obj->getMeta('UserCreate')==$this->_Base->getUser() || $this->_Base->isRuleUser())) {
			$Gui->setObj($this->_Obj);
			$contGui->setName($this->_T->lang('[[Protokoll bearbeiten]]'));
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
			$contGui->addFunction($btBreak);
		} else {
			$contGui->setName($this->_T->lang('[[Protokoll erstellen]]'));
		}
		$tplGui=new TemplateGui('core/common_template_intern.inc.html');
		$tplGui->addContent('box',$Gui->processInsert(),'CONTENT');
		//debug($Gui->getStatus());
		if ($Gui->getStatus()=='update_ok') {
			$this->_L->unsetParam('oid');
			$this->_L->setParam('action','b');
			$this->_L->goToLink();
		}
		if ($Gui->getStatus()=='insert_ok') {
			$this->_Obj=$Gui->getObj();
			$this->_L->setParam('oid',$this->_Obj->getID());
			$this->_L->setParam('action','v');
			$this->_L->goToLink();
		}
		$contGui->addContent($tplGui);
		return $contGui;
	}
	function &getViewGui() {
		require_once('lib/prot/class_ProtokollObjectGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		if (FrameWork::getParam('print',0)) {

			$Config=array(

			);
			$Data=array(
				'selData'=>$this->_select,
				'protObj'=>$this->_Obj,
				'permsView'=>$this->_Base->checkPerms($this->_Obj,4),
			);
			require_once('lib/prot/class_ProtokollPrintGui.php');
			$printGui=new ProtokollPrintGui();
			$printGui->printData($Data,$Config,'obj',FrameWork::getParam('printTpl',0));
		}

		$Gui=new ProtokollObjectGui();
		$Gui->setObj($this->_Obj);

		$contGui=$Gui->processView();
		$contGui->setName($this->_T->lang('[[Protokoll]]').': '.$this->_Obj->getMeta('protNumber'));

		require_once('lib/class_PrintDialogGui.php');
		$printDialogGui=new PrintDialogGui('prot');
		$printDialogGui->setUsePerms(false);
		$printDialogGui->process('obj');

		$btPrint=new FunctionButtons('print','button_link',array('TITLE'=>$this->_T->lang('[[Drucken]]'),'LINK'=>'javascript:showPrintDialog(\'obj\');','TARGET'=>''));
		$contGui->addFunction($btPrint,1);
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$contGui->addFunction($btBreak,1);

		if ($this->_Obj->getMeta('UserCreate')==$this->_frm->getUser() || $this->_Base->isRuleUser()) {
			require_once('lib/class_FormGui.php');
			$formGui=new FormGui();
			$formGui->setLabelClass('no','error');
			$key='submit';
			$formGui->addField($key,'submit','','','field_s');
			$submitValues=array('edit_x'=>' '.$this->_T->lang('[[Bearbeiten]]').' ');
			if ($this->_Base->isRuleUser()) {
				if ($this->_Obj->getMeta('protDeleted')) {
					$submitValues['undelete_x']=' '.$this->_T->lang('[[Wiederherstellen]]').' ';
				} else {
					$submitValues['delete_x']=' '.$this->_T->lang('[[Loeschen]]').' ';
					$formGui->setValuesAttribs($key,'delete_x',array('onclick'=>'return lo_form();'));
				}
			}
			$formGui->setValues($key,$submitValues);

			$contGui->addRow(2,'top');
			$contGui->addCol('Title',$formGui,'','','',0,'2000',2);
		}
		return $contGui;
	}
	function &getContentGui() {
		require_once('lib/prot/class_ProtokollObjectGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');

		$Gui=new ProtokollObjectGui();
		$Gui->setObj($this->_Obj);

		$contGui=$Gui->processContent();
		$contGui->setName($this->_T->lang('[[Inhalt]]'));
		return $contGui;
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
}
?>