<?php
class geRemCtrlPortal {
	public $_Base;
	public $_T;
	public $_frm;
	public $_L;
	public $_E;
	public function __construct() {
		global $frm,$t,$T,$E,$L,$Y;
		$this->_T=&$T;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('rem');
		$this->_BaseRem=$this->_frm->getStaticModul('rem');
	}
	function process() {
		if (!$this->_handleRequest()) {
			return false;
		}
		$Gui=$this->getPortalGui();
		return $Gui->process();
	}

	function _handleRequest() {
		if (!$this->_frm->getMyApps('rem')) {
			return false;
		}
		return true;
	}
	function getPortalGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');


		$entries=$this->_BaseRem->listAktivReminders();
		//debug($entries);

		$noEnc=array('NoEnc'=>1,'NoBr'=>1);

		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tabGui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));
		$tabGui->setID('geRemViewPortal');
		//$tabGui->setAutoBg(APP_FG10COLOR);
		$hl=1;
		foreach ($entries as $val) {
			$hl=$hl?0:1;
			if ($val->getUserMeta('rem_time')<time()-3600*24) $hl=3;
			$remParams=array(
				'tab'=>'rem',
				'reset'=>1,
			);
			$remParams['remMessage']=$val->getMeta('rem_message');

			$objData=$this->_BaseRem->formatObj($val);
			
			$tabGui->addRow($hl,'top',$hl==3?APP_FG10COLOR:'');
			$tabGui->addCol('msg_image','',$objData['img'],'','center',1);
			$tabGui->addCol('rem_title','<strong>'.date('d.m.Y H:i',$val->getUserMeta('rem_time')).'</strong>','','','',0,'2000',0,'',$noEnc);
			
			$body=Framework::entities($val->getMeta('rem_message'));
			if ($objData['link']) {
				$body.="\n".'<a href="'.$objData['link'].'" target="'.$objData['target'].'"><img src="img/ge/omng_goto.gif" style="margin-right:5px;"><strong>'.$objData['name'].'</strong></a>';
			}
			$tabGui->addColSub('rem_title','N',trim($body));
			$tabGui->addColSub('rem_title','NoEnc',1);

			$sendBy=array();
			if ($val->getUserMeta('rem_mail_send')) $sendBy[]='mail';
			if ($val->getUserMeta('rem_msg_send')) $sendBy[]='msg';
			if ($val->getUserMeta('rem_sms_send')) $sendBy[]='sms';

			$msgParams=array(
				'reset'=>1,
				'tab'=>'rem',
				'remId'=>$val->getId(),
				'remMessage'=>$val->getMeta('rem_message'),
				'remObjName'=>$val->getMeta('rem_obj_name'),
				'remObjTyp'=>$val->getMeta('rem_obj_typ'),
				'remObjId'=>$val->getMeta('rem_obj_id'),
				'remSendby'=>$sendBy,
				'smsMessage'=>$val->getMeta('rem_message'),
				'msgMessage'=>$val->getMeta('rem_message'),
			);
			if ($objData['link']) {
				$msgParams['msgLink']=json_encode(array(array('U'=>$objData['link'],'N'=>$objData['name'])));
			}

			
			$buttons=array();
			$buttons[]='<a href="javascript:void(ge.registry.coreViewMessage.geMsgShow('.htmlspecialchars(json_encode($msgParams)).'));"><img src="img/ge/msg_reply.gif" title="'.$this->_T->Lang('[[Verschieben]]').'" /></a>';
			$buttons[]='<a href="javascript:void(geRemPortalAction(\'remPortalDelete\','.$val->getID().'));"><img src="img/ge/msg_clear.gif" title="'.$this->_T->Lang('[[Loeschen]]').'" /></a>';
			$tabGui->addCol('rem_buttons',implode('<br />',$buttons),'','','',1,'',0,'',$noEnc);

			$tabGui->addRow(0,'top');
			$tabGui->addCol('nix','','','','',0,'',3);

		}
		if (empty($entries)) {
			$tabGui->addRow(0,'top');
			$tabGui->addCol('nix',$this->_T->lang('[[Keine Eintraege]]'),'','','',0,'');
		}
		return $tabGui;
	}
}
?>