<?php
class geSmsCtrlAdmin {
	private $_AppGui;
	private $_T;
	private $_t;
	private $_frm;
	private $_L;
	private $_E;
	private $_search=array();
	function __construct() {
		global $frm,$t,$T,$E,$L;
		$this->_frm=&$frm;
		$this->_Base=$this->_frm->getStaticModul('sms');
		$this->_BaseQuota=$this->_frm->getStaticModul('sms_quota');
		$this->_BaseRes=$this->_frm->getStaticModul('sms_res');
		$this->_t=&$t;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T=&$T;
		$this->_T->loadModul('sms');
	}
	function _handleRequest() {
		$this->_mode=Framework::getParam('mode','log','G');
		$this->_oid=Framework::getParam('oid','','G');
		switch ($this->_mode) {
			case 'quota':
				$this->_action=Framework::getParam('action','b','G');
				$this->_obj_action='';
			break;
			case 'log':
				if (Framework::getParam('_loadSearch',0)) {
					$this->_search=$this->_frm->loadPostData($this->_Base->getModul(),'tmpSmsSearch',1,0);
				}
				$this->_action=Framework::getParam('action','b','G');
				$this->_obj_action='';
			break;
		}
		return true;
	}
	function &getAdminHeader() {
		require_once("lib/class_ContentGui.php");
		$hGui=new ContentGui();
		$hGui->setName($this->_frm->getAppName('sms'));
		$hGui->addTab('log',$this->_T->lang('[[Logbuch]]'),"index.php?site=admin.php&ac=sms&mode=log");
		$hGui->addTab('quota',$this->_T->lang('[[Quoten]]'),"index.php?site=admin.php&ac=sms&mode=quota");
		$hGui->setTabOn($this->_mode);
		require_once('lib/class_FunctionObjActionGui.php');
		$objActionGui=new FunctionObjActionGui();
		if ($this->_obj_action) {
			$obj_action=$this->_frm->getObjAction('admin',$this->_obj_action);
			$parse=false;
			foreach ($obj_action as $key=>$val) {
				if ($val['Hidden']) continue;
				//print_r($val);
				$parse=true;
				$objActionGui->addValue($key,$val['Name']);
			}
			if ($parse) $hGui->addFunction($objActionGui);
		}
		return $hGui;
	}
	function process(&$AppGui) {
		if ($this->_handleRequest()) {
			$AppGui->addContent($this->getAdminHeader());

			switch ($this->_mode) {
				case 'quota':
					switch ($this->_action) {
						default;
							$AppGui->addContent($this->editQuota());
							$AppGui->addContent($this->listQuota());
						break;
					}
				break;
				case 'log':
					require_once('lib/class_ApplicationTreeGui.php');
					$TreeGui=new ApplicationTreeGui();
					switch ($this->_action) {
						default;
							$TreeGui->addTreeContent($this->showLogSearch());
							$TreeGui->addContent($this->showLogContent());
						break;
					}
					$AppGui->addContent($TreeGui);
				break;
			}
			$AppGui->setFormAction($this->_L->getLink());
		}
	}

	function editQuota() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$Gui->setName($this->_T->lang('[[Quoten]]'));

		$box=new BoxGui($this->_Base->getModul().'|smsAdminNull');
		$box->addTab('quota',$this->_T->lang('[[Quoten]]'),'#',true);
		$box->setTabContent('quota',$this->getQuotaGui());
		$box->setTabOn('quota');
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);


		return $Gui;
	}

	function &getQuotaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_ApplicationListGui.php');

		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		$key='addQuotaUser';
		$mode='u|g';
		$params='';
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Gruppen]]'),
			'LabelSep'=>' / ',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_GROUPS',
		);

		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,'','fields1');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));
		$formGui->setNoMeta($key);


		$key='dayLimit';
		$formGui->addField($key,'int',$this->_T->lang('[[SMS Limit pro Tag]]'),'','fields2');
		$key='weekLimit';
		$formGui->addField($key,'int',$this->_T->lang('[[SMS Limit pro Woche]]'),'','fields2');
		$key='monthLimit';
		$formGui->addField($key,'int',$this->_T->lang('[[SMS Limit pro Monat]]'),'','fields2');
		$key='yearLimit';
		$formGui->addField($key,'int',$this->_T->lang('[[SMS Limit pro Jahr]]'),'','fields2');


		$formGui->addField('quota_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields3');


		if (Framework::getParam('quota_add',0,'P') && trim($formGui->getFieldVal('addQuotaUser'))) {
			$users=explode('|',$formGui->getFieldVal('addQuotaUser'));
			foreach ($users as $val) {
				$Obj=$this->_BaseQuota->objExists(substr($val,2),$val[0]);
				if (!$Obj) {
					$Obj=new ObjSmsQuota();
					$Obj->setMeta('quotaTyp',$val[0]);
					$Obj->setMeta('quotaId',substr($val,2));
				}
				$formGui->addMetaToObj($Obj);
				if ($Obj->getID()) {
					$this->_BaseQuota->updateMeta($Obj);
				} else {
					$this->_BaseQuota->insertMeta($Obj);
				}
			}
			$this->_L->goToLink();
		}


		if(is_array(Framework::getParam('quota_del_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('quota_del_x',0,'P'));
			if ($key && ($Obj=$this->_BaseQuota->getObj($key))) {
				$this->_BaseQuota->deleteMeta($Obj);
			}
		}

		//debug($perms_g);
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3_1',$formGui,'FORM3',array('','fields3'));
		return $tplContent;
	}
	function listQuota() {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		$tabGui->setName($this->_T->lang('[[Quoten]]'));

		$tabGui->addHeaderCol('Name',$this->_T->lang('[[BenutzerInnen]]').'/'.$this->_T->lang('[[Gruppen]]'),'','','',1,'',2);
		$tabGui->addHeaderCol('dayLimit',$this->_T->lang('[[SMS Limit pro Tag]]'),'','','',1);
		$tabGui->addHeaderCol('weekLimit',$this->_T->lang('[[SMS Limit pro Woche]]'),'','','',1);
		$tabGui->addHeaderCol('monthLimit',$this->_T->lang('[[SMS Limit pro Monat]]'),'','','',1);
		$tabGui->addHeaderCol('yearLimit',$this->_T->lang('[[SMS Limit pro Jahr]]'),'','','',1);

		$tabGui->addHeaderCol('Delete','','tras.gif');
		$tabGui->setLimit(0);

		$rows=0;
		$entries=$this->_BaseQuota->searchObj($rows,null,'quotaTyp ASC');

		foreach ($entries as $val) {
			$hl=$hl?0:1;
			$tabGui->addRow($hl);

			if ($val->getMeta('quotaTyp')=='u') {
				$tabGui->addCol('Img','','user.gif');
				$tabGui->addCol('Name',$this->_frm->getCachedUsername($val->getMeta('quotaId')),'','','',0,'2000');
			} else {
				$tabGui->addCol('Img','','gruppe.gif');
				$tabGui->addCol('Name',$this->_frm->getCachedGroupName($val->getMeta('quotaId')),'','','',0,'2000');
			}
			$tabGui->addCol('dayLimit',$val->getMeta('dayLimit'),'','','',1,'');
			$tabGui->addCol('weekLimit',$val->getMeta('weekLimit'),'','','',1,'');
			$tabGui->addCol('monthLimit',$val->getMeta('monthLimit'),'','','',1,'');
			$tabGui->addCol('yearLimit',$val->getMeta('yearLimit'),'','','',1,'');

			$btn=new SubmitImgBtn ('quota_del_x['.$val->getID().']','img/'.APP_THEME.'/loeschen.gif');
			$tabGui->addCol('Delete',$btn);
		}
		//debug($this->_BaseQuota->getMyQuota());

		return $tabGui;
	}
	function &showLogSearch() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_DateSelectForm.php');

		$Gui=new TemplateGui('core/common_content_border.inc.html');

		$selDateGui=new DateSelectForm();
		$selDateGui->setAvMode(array(1,2,3,4));
		$selDateGui->setMode($this->_search['DateMode']?$this->_search['DateMode']:1);

		if ($this->_search['StartDate'] || $this->_search['EndDate']) {
			$selDateGui->setDate(array($this->_search['StartDate'],$this->_search['EndDate']));
		} else {
			//$selDateGui->setDate(array(0,0));
		}
		$Gui->addContent('dateSelect',$selDateGui->process(),'CONTENT');

		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		

		
/*
		$key="Info";
		$formGui->addField($key,'text',$this->_T->lang('[[Suchtext]]'),isset($this->_search['Info'])?$this->_search['Info']:'','fields1');
*/

		$key='grp_userid';
		$params=base64_encode(serialize(array('MaxEntries'=>0,'useAll'=>1)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>'u',
			'app'=>'sms',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$default='';
		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,$default,'fields1');
		$formGui->setParams($key,array('mode'=>'u','no_width'=>1,'params'=>$params));

		$key='msg_status';
		$formGui->addField($key,'checklist_v',$this->_T->lang('[[Status]]'),$this->_search['Status']?$this->_search['Status']:array(),'fields1');

		$status=array(
			'TO_SEND'=>$this->_T->lang('[[sms_to_send]]'),
			'PENDING'=>$this->_T->lang('[[sms_pending]]'),
			'ACCEPTED'=>$this->_T->lang('[[sms_accepted]]'),
			'BUFFERED'=>$this->_T->lang('[[sms_buffered]]'),
			'TRANSMITTED'=>$this->_T->lang('[[sms_transmitted]]'),
			'DELIVERED'=>$this->_T->lang('[[sms_delivered]]'),
			'NOT_DELIVERED'=>$this->_T->lang('[[sms_not_delivered]]'),
			'ERROR'=>$this->_T->lang('[[sms_error]]'),
		);
		$formGui->setValues($key,$status);

		
		$submit_array=array(
			'search_x'=>' '.$this->_T->lang('[[Suchen]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','fields1');
		$formGui->setValues($key,$submit_array);

		

		$this->_search=array(
			'StartDate'=>$selDateGui->getDate('B'),
			'EndDate'=>$selDateGui->getDate('E'),
			'DateMode'=>$selDateGui->getMode(),
			'grp_userid'=>array(),
			'Status'=>$formGui->getFieldVal('msg_status',1),
		);
		foreach (explode('|',$formGui->getFieldVal('grp_userid',1)) as $val) {
			if ($val[0]=='u') {
				$this->_search['grp_userid']=substr($val,2);
			}
		}

		$this->_frm->savePostData($this->_Base->getModul(),'tmpSmsSearch',null,$this->_search);

		$Gui->addContent('config',$formGui,'CONTENT');
		return $Gui;
	}
	function showLogContent() {
		require_once('lib/class_ApplicationListGui.php');
		$this->_BaseRes->synchronize();

		$this->_search['limit']=50;
		if (Framework::issetParam('search_x','','P')) {
			$this->_search['b']=0;
		} else {
			$this->_search['b']=Framework::getParam('b');
		}
		

		$rows=0;
		$entries=$this->_BaseRes->listAll($rows,$this->_search,'msg_date DESC');
		


		$tabGui=new ApplicationListGui();

		$L=Framework::cloneObj($this->_L);
		$tabGui->setNavLink($L);
		$tabGui->setBegin($this->_search['b']);
		$tabGui->setLimit($this->_search['limit']);
		$tabGui->setSumRows($rows);
		$tabGui->setAutoBg(APP_FG10COLOR);

		$tabGui->setName($this->_T->lang('[[Logbuch]]'));
		$tabGui->addHeaderCol('msg_date',$this->_T->lang('[[Datum]]'),'','','',1);
		$tabGui->addHeaderCol('grp_userid',$this->_T->lang('[[BenutzerIn]]'),'','','',1);
		$tabGui->addHeaderCol('msg_from',$this->_T->lang('[[Absender]]'),'','','',1);
		$tabGui->addHeaderCol('msg_to',$this->_T->lang('[[Empfaenger]]'),'','','',1);
		$tabGui->addHeaderCol('msg_senddate',$this->_T->lang('[[Versenden am]]'),'','','',1);
		$tabGui->addHeaderCol('msg_count',$this->_T->lang('[[Anzahl]]'),'','','',1);
		$tabGui->addHeaderCol('msg_status',$this->_T->lang('[[Status]]'),'','','',1);
		$tabGui->addHeaderCol('msg_lastchange',$this->_T->lang('[[Letzte Aenderung]]'),'','','',1);

		foreach ($entries as $val) {
			$hl=$hl?0:1;
			$tabGui->addRow($hl);
			$tabGui->addCol('msg_date',date('d.m.Y H:i',$val->getMeta('msg_date')),'','','',1,'');
			$tabGui->addCol('grp_userid',$this->_frm->getCachedUsername($val->getMeta('grp_userid')),'','','',1,'');
			$tabGui->addCol('msg_from',$val->getMeta('msg_from'),'','','',1,'');
			$tabGui->addCol('msg_to',$this->_Base->formatNumber($val->getMeta('msg_to'),$val->getMeta('msg_to_text')),'','','',1,'');
			$tabGui->addCol('msg_senddate',$val->getMeta('msg_senddate')?date('d.m.Y H:i',$val->getMeta('msg_senddate')):'','','','',1,'');
			$tabGui->addCol('msg_count',$val->getMeta('msg_count'),'','','',1,'');
			$tabGui->addCol('msg_status',$val->getMeta('msg_status'),'','','',1,'');
			$tabGui->addCol('msg_lastchange',date('d.m.Y H:i:s',$val->getMeta('msg_lastchange')),'','','',1,'');
		}

		$sumMsg=$this->_BaseRes->getSum($this->_search);
		
		$tabGui->addRow(2,'','',true);
		$tabGui->addCol('sum_title',$this->_T->lang('[[Totale]]'),'','','right',1,'',5);
		$tabGui->addCol('sum',$sumMsg,'','','',1);
		$tabGui->addCol('nbsp','','','','right',1,'',2);

		//debug($this->_BaseQuota->getMyQuota());
		return $tabGui;
	}

	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result) $result=$default;
		return $result;
	}

}
?>