<?php
class PrefsGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_avModuls=array();
	function PrefsGui() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=& $frm->getStaticModul('active_sync');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('sync');


	}
	function _handleRequest() {
		$this->_mode=Framework::getParam('mode','','G');
		switch ($this->_mode) {
			default:

			break;
		}
	}

	function &process() {
		$this->_handleRequest();

		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_ApplicationTreeGui.php');
		$this->_TreeGui=new ApplicationTreeGui();
		$this->_TreeGui->addTreeContent($this->listDevices());

		$TopGui=new TemplateGui('core/common_form.inc.html');
		$Gui=new ContentGui();
		$btSave=new FunctionButtons('save','save');
		$Gui->addFunction($btSave);
		$Gui->setName($this->_avModuls[$this->_mode]);
		switch ($this->_mode) {
			case 'cfg':
				$Gui->addContent($this->getConfigGui());
			break;
			default:
				$Gui->addContent($this->getViewGui());
			break;
		}

		$TopGui->addContent('cont1',$Gui,'CONTENT');
		$TopGui->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
		$this->_TreeGui->addContent($TopGui);
		return $this->_TreeGui->process();
	}
	function &listDevices() {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		$avDevices=array();
		foreach ($avDevices as $key=>$val) {
			if ($key==$this->_oid) {
				$hl=2;
			} else {
				$hl=0;
			}
			$tabGui->addRow($hl);
			$tabGui->addCol('IMG','','month_all.gif');
			$tabGui->addCol('Name',$val,'',$this->_L->getTempLink(null,array('oid'=>$key)),'',0,'2000');
		}
		return $tabGui;
	}

	function &getViewGui() {
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$box=new BoxGui();
		$box->addTab('meta',$this->_T->lang('[[Spendenregister]]'),'#',true);
		$Gui=new TemplateGui('core/form_3columns.inc.html');
		//$Gui->addContent('form1',$this->getPrefsFormSpd(),'FORM1');
		$box->setTabContent('meta',$Gui);
		$tplContent->addContent('content',$box,'CONTENT');
		return $tplContent;
	}
	function &getConfigGui() {
		require_once('lib/class_FastTemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		$formGui=new FormGui();
		//$formGui->setLabelClass('no','no_error');


		$avEmpfWrite=$this->_BaseSpd->listEmpf(true,2);
		reset($avEmpfWrite);
		$allZweck=$this->_BaseSpd->listZweck(array(),true,true);
		$allKonto=$this->_BaseSpd->listKonto(array(),true,true);

		$jsEmpfGui=new FastTemplateGui('custom_blz/js_empfaenger.inc.html');
		$jsEmpfGui->assign('JSON_ZWECKE',Framework::array2json($allZweck));
		$jsEmpfGui->assign('JSON_KONTEN',Framework::array2json($allKonto));
		$jsEmpfGui->assign('JSON_PATEN_ZWECKE','{}');
		$this->_frm->addScript($jsEmpfGui);


		$key="defFKEmpfaengerID";
		$formGui->addField($key,'select',$this->_T->lang('[[Empfaenger]]'),$this->_frm->getPrefs($this->_Base->getModul(),$key)?$this->_frm->getPrefs($this->_Base->getModul(),$key):key($avEmpfWrite),'form1');
		$formGui->setValues($key,Framework::extractArrayMeta($avEmpfWrite,'Title'));
		$formGui->setAttribs($key,array('onchange'=>"changeEmpfaenger(this,0,'-')"));
		$aktEmpf=$formGui->getFieldVal($key,1);

		$key="defFKZweckID";
		$formGui->addField($key,'select',$this->_T->lang('[[Zweck]]'),$this->_frm->getPrefs($this->_Base->getModul(),$key),'form1');
		if (is_array($allZweck[$aktEmpf])) {
			$formGui->setValues($key,array(0=>'-') + $allZweck[$aktEmpf]);
		} else {
			$formGui->setValues($key,array(0=>'-'));
		}

		$key="defFKKontoID";
		$formGui->addField($key,'select',$this->_T->lang('[[Konto]]'),$this->_frm->getPrefs($this->_Base->getModul(),$key),'form_fields1');
		if (is_array($allKonto[$aktEmpf])) {
			$formGui->setValues($key,array(0=>'-') + $allKonto[$aktEmpf]);
		} else {
			$formGui->setValues($key,array(0=>'-'));
		}



		if (Framework::getParam('save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$prefs=array();
				$formGui->addMetaToArray($prefs);
				//debug($prefs);
				$this->_frm->insertPrefs($this->_Base->getModul(),$prefs);
				$this->_L->goToLink();
			}
		}
		return $formGui;
	}
	/*function &getPrefsGuiPaz() {
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$box=new BoxGui();
		$box->addTab('meta',$this->_T->lang('[[Patientenkartei]]'),'#',true);
		$Gui=new TemplateGui('core/form_3columns.inc.html');
		$formGui=$this->getPrefsFormPaz();
		$Gui->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$Gui->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$box->setTabContent('meta',$Gui);
		$tplContent->addContent('content',$box,'CONTENT');
		return $tplContent;
	}
	function &getPrefsFormPaz() {
		require_once('lib/class_FastTemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		$formGui=new FormGui();
		$formGui->setLabelClass('no','no_error');

		$defPazListFields=$this->_frm->getPrefs($this->_Base->getModul(),'defPazListFields')?explode(',',$this->_frm->getPrefs($this->_Base->getModul(),'defPazListFields')):array();

		$this->_T->loadModul('addr');
		$Addr=& $this->_frm->getStaticModul('addr');
		$cardTitle=array();
		$selFieldArray=array($this->_T->lang('[[AddrCard_n]]')=>array(-1=>$this->_T->lang('[[Name]]')));
		foreach ($Addr->getFields() as $key=>$val) {
			if (!$cardTitle[$val['Card']]) {
				$cardTitle[$val['Card']]=$this->_T->lang('[[AddrCard_'.$val['Card'].']]');
			}
			switch ($val['Typ']) {
				case 'stamm':
				case 'perm':

				break;
				case 'title':
					$cardTitle[$val['Card']]=$val['Title'];
				break;
				default:
					if ($val['Card']!='n') {
						if (in_array($key,$defPazListFields)) {
							$selFieldArray[$cardTitle[$val['Card']]][$key]=$val['Title'];
						} else {
							$avFieldArray[$cardTitle[$val['Card']]][$key]=$val['Title'];
						}
					}
				break;
			}
		}


		$key='avFields';
		$formGui->addField($key,'select_grp',$this->_T->lang('[[Alle Felder]]'),'','fields1');
		$formGui->setValues($key,$avFieldArray);
		$formGui->setAttribs($key,array('multiple'=>'multiple','size'=>10));
		$key='addField_x';
		$formGui->addField($key,'submit','','>> '.$this->_T->lang('[[Hinzufuegen]]').' >>','fields1');

		$key='selFields';
		$formGui->addField($key,'select_grp',$this->_T->lang('[[Angezeigte Felder]]'),'','fields2');
		$formGui->setValues($key,$selFieldArray);
		$formGui->setAttribs($key,array('multiple'=>'multiple','size'=>10));
		$key='remField_x';
		$formGui->addField($key,'submit','','<< '.$this->_T->lang('[[Entfernen]]').' <<','fields2');


		$update=false;
		if (Framework::getParam('addField_x','0','P')) {
			$formGui->setRequired('avFields');
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$tmpFields=$formGui->getFieldVal('avFields');
				foreach ($tmpFields as $val) {
					if (!in_array($val,$defPazListFields)) {
						$defPazListFields[]=$val;
						$update=true;
					}
				}
			}
		}
		if (Framework::getParam('remField_x','0','P')) {
			$formGui->setRequired('selFields');
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$tmpFields=$formGui->getFieldVal('selFields');
				foreach ($tmpFields as $val) {
					if (($key=array_search($val, $defPazListFields))!==false) {
						unset($defPazListFields[$key]);
						$update=true;
					}
				}
				//$defPazListFields=array();
			}
		}
		if ($update) {
			$this->_frm->insertPrefs($this->_Base->getModul(),array('defPazListFields'=>implode(',',$defPazListFields)));
			$this->_L->goToLink();
		}
		return $formGui;
	}*/
}