<?php
class ObjUserForm extends baseObj {
	var $_obj_typ='0';
	/* to owerwrite*/
	function ObjUserForm($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['Name'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class UserForm extends ObjCore {
	var $_modul='uform';
	var $_table='UserForm';
	var $_cfgObjects=array (
		'IdField'=>'FormID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'TranslationFields'=>array('Name'),
		'0'=>array(
			'ClassName'=>'ObjUserForm',
			'Fields'=>array(
				'FormID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'TimeCreate'=>array(
					'Typ'=>'core',
					'Extra'=>'cTime',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserCreate'=>array(
					'Typ'=>'core',
					'Extra'=>'cUser',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'RefID'=>array(
					'Typ'=>'core',
				),
				'Name'=>array(
					'Typ'=>'core',
				),
				'System'=>array(
					'Typ'=>'core',
				),
				'FKModul'=>array(
					'Typ'=>'core',
				),
				'Table'=>array(
					'Typ'=>'core',
				),
			),
		),
	);

	function UserForm() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
	}
	function &getSystemForm($val) {
		$searchQuery=array(
			array('Field'=>'System','Typ'=>'=','Values'=>$val),
		);
		return $this->searchSingleObj($searchQuery);
	}
	function setFormModul($val) {
		$this->_formModul=$val;
	}
	function listModulForms($order='UserForm.Name') {
		$searchQuery=array(
			array('Field'=>'UserForm.FKModul','Typ'=>'=','Values'=>$this->_formModul),
			array('Field'=>'UserForm.System','Typ'=>'=','Values'=>''),
		);
		$rows=0;
		return $this->searchObj($rows,$searchQuery,$order);
	}
	function getQuickForms() {
		$searchQuery=array(
			array('Field'=>'UserForm.FKModul','Typ'=>'=','Values'=>$this->_formModul),
			array('Field'=>'UserFormFields.useQuick','Typ'=>'=','Values'=>1),
		);
		$PARAMS['JOIN']='INNER JOIN UserFormFields ON (UserForm.FormID=UserFormFields.FKFormID)';
		$PARAMS['GROUP_FIELD']='UserForm.FormID';
		$rows=0;
		return $this->searchObj($rows,$searchQuery,'',0,0,false,true,false,$PARAMS);
	}

	function refExists($val,$ExcludeID=0) {
		$searchQuery=array(
			array('Field'=>'UserForm.FKModul','Typ'=>'=','Values'=>$this->_formModul),
			array('Field'=>'RefID','Typ'=>'=','Values'=>$val),
		);
		if ($ExcludeID) {
			$searchQuery[]=array('Field'=>'FormID','Typ'=>'!=','Values'=>$ExcludeID);
		}
		return $this->searchSingleObj($searchQuery);
	}
	function getNextRefID() {
		$searchQuery=array(
			array('Field'=>'UserForm.FKModul','Typ'=>'=','Values'=>$this->_formModul),
		);
		$query="SELECT count(*) as num FROM UserForm WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		$this->_db->next_record();
		$num=intval($this->_db->f('num'));
		do {
			if ($num>25) {
				$result=chr(floor($num/26)+64).chr($num%26+65);
			} else {
				$result=chr($num%26+65);
			}
			$num++;
		} while ($this->refExists($result));
		return $result;
	}
	function isEmpty($Obj) {
		$searchQuery=array(
			array('Field'=>'FKFormID','Typ'=>'=','Values'=>intval($Obj->getID())),
		);
		$query="SELECT * FROM UserFormFields WHERE ".$this->_db->getWhere($searchQuery);
		$query.=' '.$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return false;
		} else {
			return true;
		}
	}
	function insertObj(&$Obj) {
		$Obj->setMeta('FKModul',$this->_formModul);
		if ($this->insertMeta($Obj)) {
			$query="CREATE TABLE `UserFormData_".$Obj->getID()."` (
				`FKObjID` INT NOT NULL ,
				`FKModul` varchar(255) NOT NULL DEFAULT '',
				`UserModify` INT NOT NULL ,
				`TimeModify` INT NOT NULL,
				INDEX FKObjID (FKObjID)
			);";
			$this->_db->query($query);
			$Obj->setMeta('Table',"UserFormData_".$Obj->getID());
			return $this->updateMeta($Obj);
		}
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		if (!$Obj->getMeta('System') && $this->isEmpty($Obj)) {
			$query="DROP TABLE `UserFormData_".$Obj->getID()."`;";
			$this->_db->query($query);
			return $this->deleteMeta($Obj);
		}
	}
	function getCachedFormName($ID,$returnObj=0) {
		if (!isset($this->_cached[$ID])) {
			$this->_cached[$ID]=$this->getObj($ID);
		}
		if ($returnObj) {
			return $this->_cached[$ID];
		} elseif (is_object($this->_cached[$ID])) {
			return $this->_cached[$ID]->getName();
		}
	}
}
?>
