<?php
class UserFormFieldsGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_mode='fields';
	var $_guiCfg=array(
		'showUseSearch'=>0,
		'showUseQuick'=>0,
		'showUseList'=>0,
		'showUseExport'=>0,
		'showUseMultiple'=>1,
		'showVisibility'=>1,
		'extraVisibilityField'=>array(),
		'useZefFirma'=>0,
		'usePerms'=>0,
		'usePrjRules'=>0,
		'useMaxLen'=>0,
		'isLdap'=>0,
		'extraFieldMeta'=>array(),
		'allowedFields'=>array(),
		'requiredFields'=>array(),
	);
	function UserFormFieldsGui() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_BaseForm=& $frm->getStaticModul('uform');
		$this->_BaseFields=& $frm->getStaticModul('uform_fields');
		$this->_BaseSelect=& $frm->getStaticModul('uform_select');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_T->loadModul('uform');
	}
	function isCallable() {
		return true;
	}
	function &loadSystemObj($val) {
		$Obj=$this->_BaseForm->getSystemForm($val);
		if (is_object($Obj)) {
			$this->setFormObj($Obj);
			return $Obj;
		}
	}
	function setFormObj(&$Obj) {
		$this->_formObj=&$Obj;
		$this->_BaseFields->setFormObj($this->_formObj);
	}
	function setGuiCfg($cfg) {
		foreach ($cfg as $key=>$val) {
			$this->_guiCfg[$key]=$val;
		}
	}
	function _handleRequest() {
		$this->_action=Framework::getParam('uform_f_action','b','G');
		$this->_ftyp=Framework::getParam('uform_f_ftyp','','G');
		$this->_oid=Framework::getParam('uform_f_oid',0,'G');
		if ($this->_oid) {
			$this->_Obj=$this->_BaseFields->getObj($this->_oid,1);
			if (is_object($this->_Obj)) {
				$this->_ftyp=$this->_Obj->getMeta('Typ');
				$this->_defParentID=$this->_Obj->getMeta('FKParentID');
			} else {
				$this->_oid=0;
			}
		}

		if (Framework::getParam('uform_f_obj_action_x','0','P') && Framework::getParam('uform_f_obj_action_val','0','P')) {
			switch (Framework::getParam('uform_f_obj_action_val','0','P')) {
				case 'n_group':
					$temp=explode('_',Framework::getParam('uform_f_obj_action_val','0','P'));
					$this->_action=$temp[0];
					$this->_ftyp=$temp[1];
				break;
				default:
					debug(Framework::getParam('uform_f_obj_action_val','0','P'));
			}
		}
		if (Framework::getParam('uform_f_new','0','P')) {
			$tmpArray=Framework::getParam('uform_f_new',0,'P');
			if (is_array($tmpArray)) {
				foreach ($tmpArray as $key=>$val) {
					if ($val) {
						$this->_action='n';
						$this->_ftyp=$val;
						$this->_defParentID=$key;
						break;
					}
				}
				//debug($tmpArray);
			}
		}
		$this->_L->setParam('uform_f_action',$this->_action);
		$this->_L->setParam('uform_f_ftyp',$this->_ftyp);
	}
	function &process() {
		$this->_handleRequest();
		switch ($this->_action) {
			case 'b':
				$Gui=$this->getFieldListGui();
			break;
			case 'n':
				$Gui=$this->getFieldEditGui();
			break;
		}
		return $Gui;
	}


	function &getFieldListGui() {
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionObjActionGui.php');
		if (Framework::getParam('moveUp_x','0','P')) {
			$key=key($tmpArray=Framework::getParam('moveUp_x',0,'P'));
			if ($key) {
				$tmpObj=$this->_BaseFields->getObj($key);
				if (is_object($tmpObj)) {
					$this->_BaseFields->moveSequence($tmpObj,'up');
				}
			}
		}
		if (Framework::getParam('moveDown_x','0','P')) {
			$key=key($tmpArray=Framework::getParam('moveDown_x',0,'P'));
			if ($key) {
				$tmpObj=$this->_BaseFields->getObj($key);
				if (is_object($tmpObj)) {
					$this->_BaseFields->moveSequence($tmpObj,'down');
				}
			}
		}

		$newFieldArray=array(''=>'----- '.$this->_T->lang('[[Neues Feld]]').' -----');
		foreach ($this->_BaseFields->getFields() as $key=>$val) {
			if ($this->_guiCfg['isLdap'] && !$val['ldap']) continue;
			if (!empty($this->_guiCfg['allowedFields']) && !in_array($key,$this->_guiCfg['allowedFields'])) continue;
			if ($val['extra']) {
				$break=0;
				switch ($val['extra']) {
					case 'zef_comp':
						$Zef=& $this->_frm->getStaticModul('zef');
						if (is_object($Zef) && !$Zef->getCfg('cfg/modul/company')) {
							 $break=1;
						}
					break;
				}
				if ($break) continue;
			}
			if (!$val['isGroup']) {
				$newFieldArray[$key]=$this->_T->lang($val['name']);
			}
		}

		$entries=$this->_BaseFields->listFormFields(true);
		$Gui=new ApplicationListGui();
		$Gui->setName($this->_T->lang('[[Felder]]'));
		$Gui->setLimit(0);
		$Gui->addHeaderCol('Pos','#','','','',0,0,2);
		$Gui->addHeaderCol('Name',$this->_T->lang('[[Name]]'),'','','',0,0,4);
		$Gui->addHeaderCol('Typ',$this->_T->lang('[[Art]]'),'','','',1);
		if ($this->_guiCfg['showUseSearch']) {
			$Gui->addHeaderCol('useSearch',$this->_T->lang('[[useSuche]]'),'','','',1);
		}
		if ($this->_guiCfg['showUseList']) {
			$Gui->addHeaderCol('useList',$this->_T->lang('[[useListe]]'),'','','',1);
		}
		$Gui->addHeaderCol('Aktiv',$this->_T->lang('[[Aktiv]]'),'','','',1);
		$Gui->addHeaderCol('required',$this->_T->lang('[[Pflicht]]'),'','','',1);
		if (!empty($entries[0])) {
			foreach ($entries[0] as $key=>$val) {
				//$Gui->addRow($hl?$hl=0:$hl=1);
				$Gui->addRow(2);
				$btn_up=new SubmitImgBtn ('moveUp_x['.$key.']','img/'.APP_THEME.'/rs_up.gif');
				$Gui->addCol('up',$btn_up);
				$btn_down=new SubmitImgBtn ('moveDown_x['.$key.']','img/'.APP_THEME.'/rs_down.gif');
				$Gui->addCol('down',$btn_down);
				$Gui->addCol('Name',$val->getMeta('RefID').' | '.$val->getName().($val->getMeta('Multiple')?' ('.$this->_T->lang('[[Multiple]]').')':''),'',$this->_L->getTempLink(array('uform_f_sid'),array('uform_f_oid'=>$val->getID(),'uform_f_action'=>'n')),'',1,0,3);
				$sel_new=new SelectFieldBtn('uform_f_new['.$key.']','',array('onchange'=>'document.daten.submit();'));
				$sel_new->setValues($newFieldArray);
				$Gui->addCol('Neu',$sel_new,'','','right',0,2000);
				$Gui->addCol('Typ',$this->_T->lang($this->_BaseFields->getFieldData($val->getMeta('Typ'),'name')),'','','',1);
				if ($this->_guiCfg['showUseSearch']) {
					$Gui->addCol('useSearch','','','','',1);
				}
				if ($this->_guiCfg['showUseList']) {
					$Gui->addCol('useList','','','','',1);
				}
				$Gui->addCol('Aktiv',$val->getMeta('Aktiv')?$this->_T->lang('[[Ja]]'):$this->_T->lang('[[Nein]]'),'','','',1);
				$Gui->addCol('required','','','','',1);
				if (is_array($entries[$key])) {
					foreach ($entries[$key] as $fkey=>$fval) {
						$Gui->addRow($hl?$hl=0:$hl=1);
						$Gui->addCol('empty','','','','',1,0,2);
						$btn_up=new SubmitImgBtn ('moveUp_x['.$fkey.']','img/'.APP_THEME.'/rs_up.gif');
						$Gui->addCol('up',$btn_up);
						$btn_down=new SubmitImgBtn ('moveDown_x['.$fkey.']','img/'.APP_THEME.'/rs_down.gif');
						$Gui->addCol('down',$btn_down);
						$Gui->addCol('Name',$fval->getMeta('RefID').' | '.$fval->getName(),'',$this->_L->getTempLink(null,array('uform_f_oid'=>$fval->getID(),'uform_f_action'=>'n')),'',1);
						$Gui->addCol('Neu','','','','right',0,2000);
						$Gui->addCol('Typ',$this->_T->lang($this->_BaseFields->getFieldData($fval->getMeta('Typ'),'name')),'','','',1);
						if ($this->_guiCfg['showUseSearch']) {
							$Gui->addCol('useSearch',$fval->getMeta('useSearch')?$this->_T->lang('[[Ja]]'):$this->_T->lang('[[Nein]]'),'','','',1);
						}
						if ($this->_guiCfg['showUseList']) {
							$Gui->addCol('useList',$fval->getMeta('useList')?($fval->getMeta('useList')==1?$this->_T->lang('[[Ja]]'):$this->_T->lang('[[Ja]]')):$this->_T->lang('[[Nein]]'),'','','',1);
						}
						$Gui->addCol('Aktiv',$fval->getMeta('Aktiv')?$this->_T->lang('[[Ja]]'):$this->_T->lang('[[Nein]]'),'','','',1);
						$Gui->addCol('required',$fval->getMeta('Required')?$this->_T->lang('[[Ja]]'):$this->_T->lang('[[Nein]]'),'','','',1);
					}
				}
			}
		}
		$objActionGui=new FunctionObjActionGui('uform_f_obj_action');
		$objActionGui->addValue('n_group',$this->_T->lang('[[Neue Feldgruppe]]'));
		$Gui->addFunction($objActionGui,1);
		return $Gui;
	}
	function getFieldEditGui() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		if (!$this->_Obj) {
			$Gui->setName($this->_T->lang('[[Neues Feld anlegen]]').' ('.$this->_T->lang($this->_BaseFields->getFieldData($this->_ftyp,'name')).')');
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(null,array('uform_f_action'=>'b'))));
		} else {
			$Gui->setName($this->_T->lang('[[Feld bearbeiten]]').' ('.$this->_T->lang($this->_BaseFields->getFieldData($this->_ftyp,'name')).')');
			$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('uform_f_oid','uform_f_sid'),array('uform_f_action'=>'b'))));

			switch ($this->_ftyp) {
				case 'select':
					$tabs[]='values';
					$tabs[]='config';
				break;
				case 'mselect':
					$tabs[]='values';
					$tabs[]='config';
				break;
				case 'group':
					if ($this->_Obj->getMeta('Multiple')) {
						$tabs[]='config';
					}
					if ($this->_guiCfg['usePerms']) {
						$tabs[]='perms';
					}
				break;
				case 'file':

				break;
				case 'status':
					$tabs[]='status';
					$tabs[]='config';
				break;
				case 'status_txt':
					$tabs[]='values';
					$tabs[]='status';
					$tabs[]='config';
				break;
				default:
					$tabs[]='config';
				break;
			}
			if ($this->_guiCfg['showVisibility']) {
				$tabs[]='visibility';
			}
		}
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_mode.'|showtab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('showtab'));
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getMetaGui());
		}
		if (in_array('values',$tabs)) {
			$box->addTab('values',$this->_T->lang('[[Werte]]'),'#',true);
			$box->setTabContent('values',$this->getValuesGui());
		}
		if (in_array('status',$tabs)) {
			$box->addTab('status',$this->_T->lang('[[Status]]'),'#',true);
			$box->setTabContent('status',$this->getStatusFieldGui());
		}
		if (in_array('config',$tabs)) {
			$box->addTab('config',$this->_T->lang('[[uform_Einstellungen]]'),'#',true);
			$box->setTabContent('config',$this->getConfigGui());
		}
		if (in_array('visibility',$tabs)) {
			$box->addTab('visibility',$this->_T->lang('[[Sichtbarkeit]]'),'#',true);
			$box->setTabContent('visibility',$this->getVisibilityGui());
		}
		if (in_array('perms',$tabs)) {
			$box->addTab('perms',$this->_T->lang('[[Rechte]]'),'#',true);
			$box->setTabContent('perms',$this->getPermsGui(0,$this->_guiCfg['usePrjRules']));
		}
		if (Framework::getParam('_clTab','')) {
			$this->setPrefs('showtab',Framework::getParam('_clTab',''));
		}
		$show_tap=$this->getPrefs('showtab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}
	function getMetaGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();


		if (!$this->_BaseFields->getFieldData($this->_ftyp,'isGroup') && $this->_guiCfg['isLdap']) {
			$key='RefID';
			$default=$this->_Obj?$this->_Obj->getMeta($key):'';
			$formGui->addField($key,'text','LDAP Fieldname',$default?$default:'','fields1');
			$formGui->setRequired($key);

			$key='RefClass';
			$default=$this->_Obj?$this->_Obj->getMeta($key):'';
			$formGui->addField($key,'text','LDAP Objectclass',$default?$default:'','fields1');
			$formGui->setRequired($key);
		} else {
			$key='RefID';
			$default=$this->_Obj?$this->_Obj->getMeta($key):'';
			$formGui->addField($key,'text','ID',$default?$default:$this->_BaseFields->getNextRefID(),'fields1');
			$formGui->setRequired($key);
		}


		$defOneLang=1;
		$defTrans=array();
		$defConfig=array();
		if ($this->_Obj) {
			$defConfig=unserialize($this->_Obj->getMeta('Config'));
			$defTrans=$this->_Obj->getTrans('Name');
			foreach ($this->_frm->getMaLang() as $lang) {
				if ($defTrans[$lang]!=$defTrans[$this->_frm->getLang()]) {
					$defOneLang=0;
					break;
				}
			}

		}
		foreach ($this->_frm->getMaLang() as $lang) {
			$key='Trans['.$lang.']';
			$formGui->addField($key,'text',$this->_T->lang('[[Name]]').' '.strtoupper($lang),$defTrans[$lang],'fields1');
			$formGui->setNoMeta($key);
			if ($lang!=$this->_frm->getLang()) {
				if (Framework::getParam('oneLang',$defOneLang,'P')) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key,$attribs);
				} else {
					$formGui->setRequired($key);
				}
			} else {
				$formGui->setRequired($key);
				$key='oneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'fields1');
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $lang2) {
					if ($lang2!=$lang) $attribs['onchange'].="disableEnable('Trans[".$lang2."]',this,this.checked?0:1);";
				}
				//debug($attribs);
				$formGui->setAttribs($key,$attribs);
			}
		}
		if (!$this->_BaseFields->getFieldData($this->_ftyp,'isGroup')) {
			$allGroups=$this->_BaseFields->listParentFields(0);
			$key='FKParentID';
			$formGui->addField($key,'select',$this->_T->lang('[[Feldgruppe]]'),intval($this->_defParentID),'fields2');
			$formGui->setValues($key,Framework::extractObjName($allGroups));
			$formGui->setAttribs($key,array('onchange'=>'document.daten.submit()'));
			$this->_aktParentObj=$this->_BaseFields->getObj($formGui->getFieldVal($key,1));
		}

		$key='lb1';
		$formGui->addField($key,'label',$this->_T->lang('[[Optionen]]'),'','fields2');
		$key='Aktiv';
		$formGui->addField($key,'check',$this->_T->lang('[[Aktiv]]'),$this->_Obj?$this->_Obj->getMeta($key):1,'fields2');
		if ($this->_BaseFields->getFieldData($this->_ftyp,'isGroup')) {
			if ($this->_guiCfg['showUseMultiple']) {
				$key='Multiple';
				$formGui->addField($key,'check',$this->_T->lang('[[Multiple]]'),$this->_Obj?$this->_Obj->getMeta($key):'','fields2');
			}
			if ($this->_guiCfg['showUseQuick']) {
				$key='useQuick';
				$formGui->addField($key,'check',$this->_T->lang('[[In Quicklist anzeigen]]'),$this->_Obj?$this->_Obj->getMeta($key):0,'fields2');
			}
		} else {
			if ($this->_ftyp!='status' && $this->_ftyp!='status_txt') {
				$key='Required';
				if (empty($this->_guiCfg['requiredFields']) || in_array($this->_ftyp,$this->_guiCfg['requiredFields'])) {
					$formGui->addField($key,'check',$this->_T->lang('[[Pflichtfeld]]'),$this->_Obj?$this->_Obj->getMeta($key):0,'fields2');
				}
				if ($this->_guiCfg['showUseSearch'] && (!is_object($this->_aktParentObj) || !$this->_aktParentObj->getMeta('Multiple'))) {
					$key='useSearch';
					$formGui->addField($key,'check',$this->_T->lang('[[In Suche verwenden]]'),$this->_Obj?$this->_Obj->getMeta($key):0,'fields2');
				}
			}
			if ($this->_guiCfg['showUseList'] && (!is_object($this->_aktParentObj) || !$this->_aktParentObj->getMeta('Multiple'))) {
				$key='useList';
				$formGui->addField($key,'radiolist_h',$this->_T->lang('[[In Liste anzeigen]]'),$this->_Obj?$this->_Obj->getMeta($key):0,'fields1');
				$formGui->setValues	($key,array(0=>$this->_T->lang('[[Nein]]'),1=>$this->_T->lang('[[Ja]]'),2=>$this->_T->lang('[[Nur bei Mouseover]]')));
				$attribs=array();
				$attribs['onchange']="changeDisp('oneLangList_div',this.checked&&this.value!=0?1:-1);";
				foreach ($this->_frm->getMaLang() as $lang) {
					$attribs['onchange'].="changeDisp('TransList_".$lang."',this.checked&&this.value!=0?1:-1);";
				}
				$formGui->setAttribs($key,$attribs);

				$defOneLang=1;
				$defTrans=array();
				if ($this->_Obj) {
					$defTrans=$this->_Obj->getTrans('NameList');
					foreach ($this->_frm->getMaLang() as $lang) {
						if ($defTrans[$lang]!=$defTrans[$this->_frm->getLang()]) {
							$defOneLang=0;
							break;
						}
					}

				}
				foreach ($this->_frm->getMaLang() as $lang) {
					$key='TransList['.$lang.']';
					$formGui->addField($key,'text',$this->_T->lang('[[NameList]]').' '.strtoupper($lang),$defTrans[$lang],'fields1');
					$formGui->setNoMeta($key);
					$iptAttribs=array(
						'id'=>'TransList_'.$lang,
					);
					if (!$formGui->getFieldVal('useList',1)) {
						$iptAttribs['style']='display:none';
					}
					$formGui->setIptAttribs($key,$iptAttribs);
					if ($lang!=$this->_frm->getLang()) {
						if (Framework::getParam('oneLangList',$defOneLang,'P')) {
							$attribs=array(
								'disabled'=>'disabled',
							);
							$formGui->setAttribs($key,$attribs);
						}
					} else {
						$key='oneLangList';
						$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'fields1');
						$attribs=array();
						foreach ($this->_frm->getMaLang() as $lang2) {
							if ($lang2!=$lang) $attribs['onchange'].="disableEnable('TransList[".$lang2."]',this,this.checked?0:1);";
						}
						//debug($attribs);
						$formGui->setAttribs($key,$attribs);
						$iptAttribs=array(
							'id'=>'oneLangList_div',
						);
						if (!$formGui->getFieldVal('useList',1)) {
							$iptAttribs['style']='display:none';
						}

						$formGui->setIptAttribs($key,$iptAttribs);
					}
				}
			}

		}
		if ($this->_guiCfg['showUseExport']) {
			$key='useExport';
			$formGui->addField($key,'check',$this->_T->lang('[[In Export anzeigen]]'),$this->_Obj?$this->_Obj->getMeta($key):1,'fields2');
		}

		if ($this->_guiCfg['extraFieldMeta']) {
			foreach ($this->_guiCfg['extraFieldMeta'] as $fid=>$fval) {
				if (in_array($this->_ftyp,$fval['exFTyp'])) continue;
				$key='Config['.$fid.']';
				$formGui->addField($key,$fval['typ'],$fval['title'],$this->_Obj?$defConfig[$fid]:$fval['default'],$fval['handle']);
				if (!empty($fval['values'])) {
					$formGui->setValues	($key,$fval['values']);
				}
			}
		}

		switch ($this->_ftyp) {
			case 'select':
				$nextTab='values';
			break;
			case 'mselect':
				$nextTab='values';
			break;
			case 'group':
				$nextTab='perms';
			break;
			case 'file':
				$nextTab='';
			break;
			default:
				$nextTab='config';
			break;
		}

		$key='submit';
		$formGui->addField($key,'submit','','','fields3');
		$submit_array=array(
			'uform_f_meta_save_x'=>' '.$this->_T->lang('[[Speichern]]').' ',
		);
		if (is_object($this->_Obj)) {
			$submit_array['uform_f_meta_delete_x']=' '.$this->_T->lang('[[Loeschen]]').' ';
			$formGui->setValuesAttribs($key,'uform_f_meta_delete_x',array('onclick'=>'return lo_form();'));
		}
		$formGui->setValues($key,$submit_array);

		if (Framework::getParam('uform_f_meta_delete_x','0','P')) {
			if (is_object($this->_Obj)) {
				$this->_BaseFields->deleteObj($this->_Obj);
				$this->_L->unsetParam('uform_f_oid');
				$this->_L->setParam('uform_f_action','b');
				$this->_L->goToLink();
			}
		}

		if (Framework::getParam('uform_f_meta_save_x','0','P')) {
			$formGui->checkFields();
			if ($this->_guiCfg['isLdap']) {
				$regex='/[^a-z0-9_-]/i';
			} else {
				$regex='/[^a-z0-9_]/i';
			}
			if (preg_match($regex,$formGui->getFieldVal('RefID')) || $this->_BaseFields->refExists($formGui->getFieldVal('RefID'),$this->_Obj?$this->_Obj->getID():0)) {
				$this->_E->setError('fields','RefID');
			}
			$ObjTransList=array();
			if ($formGui->fieldExists('useList') && $formGui->getFieldVal('useList')) {
				if ($formGui->getFieldVal('oneLangList')) {
					foreach ($this->_frm->getMaLang() as $val) {
						if ($formGui->getFieldVal('TransList['.$this->_frm->getLang().']')) {
							$ObjTransList[$val]=$formGui->getFieldVal('TransList['.$this->_frm->getLang().']');
						} else {
							$this->_E->setError('fields','TransList['.$this->_frm->getLang().']');
						}
					}
				} else {
					foreach ($this->_frm->getMaLang() as $val) {
						if ($formGui->getFieldVal('TransList['.$val.']')) {
							$ObjTransList[$val]=$formGui->getFieldVal('TransList['.$val.']');
						} else {
							$this->_E->setError('fields','TransList['.$val.']');
						}
					}
				}

			}
			if (!$this->_E->isError()) {
				$ObjTrans=array();
				if ($formGui->getFieldVal('oneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans[$val]=$formGui->getFieldVal('Trans['.$this->_frm->getLang().']');
					}
				} else {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans[$val]=$formGui->getFieldVal('Trans['.$val.']');
					}
				}
				if (is_object($this->_Obj)) {
					$formGui->addMetaToObj($this->_Obj);
					$this->_Obj->setMeta('Config',serialize(Framework::getParam('Config',array(),'P')));
					$this->_Obj->setTrans('Name',$ObjTrans);
					if (!empty($ObjTransList)) $this->_Obj->setTrans('NameList',$ObjTransList);
					$this->_BaseFields->updateObj($this->_Obj,$this->_guiCfg['usePerms']);
					$this->_L->unsetParam('uform_f_oid');
					$this->_L->setParam('uform_f_action','b');
				} else {
					$this->_Obj=new ObjUserFormField();
					$this->_Obj->setMeta('Typ',$this->_ftyp);
					if ($this->_BaseFields->getFieldData($this->_ftyp,'isGroup')) {
						$this->_Obj->setMeta('FKParentID',0);
					}
					$formGui->addMetaToObj($this->_Obj);
					$this->_Obj->setTrans('Name',$ObjTrans);
					if (!empty($ObjTransList)) $this->_Obj->setTrans('NameList',$ObjTransList);
					$this->_Obj->setMeta('Config',serialize(Framework::getParam('Config',array(),'P')));
					if ($this->_guiCfg['usePerms'] && !$this->_Obj->getMeta('ParentID')) {
						if ($this->_guiCfg['defPermsRules']) {
							$this->_Obj->setMeta('PermsRules',$this->_guiCfg['defPermsRules']);
						}
						if ($this->_guiCfg['defPermsGroups']) {
							$this->_Obj->setMeta('PermsGroups',$this->_guiCfg['defPermsGroups']);
						}
						if ($this->_guiCfg['defPermsUsers']) {
							$this->_Obj->setMeta('PermsUsers',$this->_guiCfg['defPermsUsers']);
						}
					}
					$this->_BaseFields->insertObj($this->_Obj,$this->_guiCfg['usePerms']);
					if ($nextTab) {
						$this->_L->setParam('uform_f_oid',$this->_Obj->getID());
						$this->_L->setParam('_clTab',$nextTab);
					} else {
						$this->_L->setParam('uform_f_action','b');
					}
				}
				$this->_L->goToLink();
			}

		}


		//debug($this->_E->isError());
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		return $tplContent;
	}
	function getValuesGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		$defOneLang=1;
		$defTrans=array();
		if (Framework::getParam('uform_f_sid',0,'G') && !Framework::getParam('uform_f_list_break_x','0','P')) {
			$selObj=$this->_BaseSelect->getObj(Framework::getParam('uform_f_sid',0,'G'),true);
			if ($selObj) {
				$defTrans=$selObj->getTrans('Name');
				foreach ($this->_frm->getMaLang() as $lang) {
					if ($defTrans[$lang]!=$defTrans[$this->_frm->getLang()]) {
						$defOneLang=0;
						break;
					}
				}
			}
		}
		if (Framework::getParam('uform_f_list_delete_x','0','P') && $selObj) {
			$this->_BaseSelect->deleteObj($selObj);
			$this->_L->unsetParam('uform_f_sid');
			$this->_L->goToLink();
		}

		foreach ($this->_frm->getMaLang() as $lang) {
			$key='listTrans['.$lang.']';
			$formGui->addField($key,'text',$this->_T->lang('[[Bezeichnung]]').' '.strtoupper($lang),$defTrans[$lang],'fields1');
			$formGui->setNoMeta($key);
			if ($lang!=$this->_frm->getLang()) {
				if (Framework::getParam('listOneLang',$defOneLang,'P')) {
					$attribs=array(
						'disabled'=>'disabled',
					);
					$formGui->setAttribs($key,$attribs);
				} else {
					$formGui->setRequired($key);
				}
			} else {
				$formGui->setRequired($key);
				$key='listOneLang';
				$formGui->addField($key,'check',$this->_T->lang('[[Nur eine Sprache verwenden]]'),$defOneLang,'fields1');
				$attribs=array();
				foreach ($this->_frm->getMaLang() as $lang2) {
					if ($lang2!=$lang) $attribs['onchange'].="disableEnable('listTrans[".$lang2."]',this,this.checked?0:1);";
				}
				//debug($attribs);
				$formGui->setAttribs($key,$attribs);
			}
		}

		$key='list_submit';
		$formGui->addField($key,'submit','','','fields1');
		$submit_array=array(
			'uform_f_list_save_x'=>' '.$this->_T->lang('[[Speichern]]').' ',
		);
		if (is_object($selObj)) {
			$submit_array['uform_f_list_break_x']=' '.$this->_T->lang('[[Abbrechen]]').' ';
			$submit_array['uform_f_list_delete_x']=' '.$this->_T->lang('[[Loeschen]]').' ';
			$formGui->setValuesAttribs($key,'uform_f_list_delete_x',array('onclick'=>'return lo_form();'));
		}
		$formGui->setValues($key,$submit_array);
		$clear=0;
		if (Framework::getParam('uform_f_list_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				$ObjTrans=array();
				if ($formGui->getFieldVal('listOneLang')) {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans[$val]=$formGui->getFieldVal('listTrans['.$this->_frm->getLang().']');
					}
				} else {
					foreach ($this->_frm->getMaLang() as $val) {
						$ObjTrans[$val]=$formGui->getFieldVal('listTrans['.$val.']');
					}
				}
				if (is_object($selObj)) {
					$selObj->setTrans('Name',$ObjTrans);
					$this->_BaseSelect->updateObj($selObj);
					$this->_L->unsetParam('uform_f_sid');
					$this->_L->goToLink();
				} else {
					$selObj=new ObjUserFormSelect();
					$selObj->setMeta('FKFieldID',$this->_Obj->getID());
					$selObj->setTrans('Name',$ObjTrans);
					$this->_BaseSelect->insertObj($selObj);
				}
				unset($selObj);
				$clear=1;
			}
		} else {
			$clear=1;
		}
		if ($clear) {
			$formGui->clearFields();
		}

		if ($selObj) {
			$this->_L->setParam('uform_f_sid',$selObj->getID());
		} else {
			$this->_L->unsetParam('uform_f_sid');
		}

		if (Framework::getParam('moveSelUp_x','0','P')) {
			$key=key($tmpArray=Framework::getParam('moveSelUp_x',0,'P'));
			if ($key) {
				$tmpObj=$this->_BaseSelect->getObj($key);
				if (is_object($tmpObj)) {
					$this->_BaseSelect->moveSequence($tmpObj,'up');
				}
			}
		}
		if (Framework::getParam('moveSelDown_x','0','P')) {
			$key=key($tmpArray=Framework::getParam('moveSelDown_x',0,'P'));
			if ($key) {
				$tmpObj=$this->_BaseSelect->getObj($key);
				if (is_object($tmpObj)) {
					$this->_BaseSelect->moveSequence($tmpObj,'down');
				}
			}
		}

		$listEntries=$this->_BaseSelect->listSelect($this->_Obj->getID());

		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tabGui->addHeaderCol('Pos','#','','','',0,0,2);
		$tabGui->addHeaderCol('Name',$this->_T->lang('[[Name]]'),'','','',0,2000);
		foreach ($listEntries as $key=>$val) {
			if ($selObj && $selObj->getID()==$key) {
				$tabGui->addRow(2);
			} else {
				$tabGui->addRow($hl?$hl=0:$hl=1);
			}
			$btn_up=new SubmitImgBtn ('moveSelUp_x['.$key.']','img/'.APP_THEME.'/rs_up.gif');
			$tabGui->addCol('up',$btn_up);
			$btn_down=new SubmitImgBtn ('moveSelDown_x['.$key.']','img/'.APP_THEME.'/rs_down.gif');
			$tabGui->addCol('down',$btn_down);
			$tabGui->addCol('Name',$val->getName(),'',$this->_L->getTempLink(null,array('uform_f_sid'=>$val->getID())),'',1);
		}

		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$tabGui,'FORM2',array());
		//$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		return $tplContent;

	}
	function getConfigGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		$defConfig=unserialize($this->_Obj->getMeta('Config'));
		switch ($this->_ftyp) {
			case 'int':
				$key='Config[decimals]';
				if ($this->_guiCfg['isLdap']) {
					$formGui->addField($key,'hidden','',0,'fields1');
				} else {
					$formGui->addField($key,'int',$this->_T->lang('[[Dezimalstellen]]'),isset($defConfig['decimals'])?$defConfig['decimals']:2,'fields1');
				}
				$key='Config[default]';
				$formGui->addField($key,'int',$this->_T->lang('[[Vorgabewert]]'),isset($defConfig['default'])?$defConfig['default']:'','fields1');
				$formGui->setParams($key,array('numdec'=>$formGui->getFieldVal('Config[decimals]',1)));
			break;
			break;
			case 'select':
				$key='Config[default]';
				$formGui->addField($key,'select',$this->_T->lang('[[Vorgabewert]]'),isset($defConfig['default'])?$defConfig['default']:'','fields1');
				$Values=array(''=>'-') + Framework::extractObjName($this->_BaseSelect->listSelect($this->_Obj->getID()));
				$formGui->setValues($key,$Values);
			break;
			case 'mselect':
				$key='Config[rows]';
				$formGui->addField($key,'int',$this->_T->lang('[[Zeilen]]'),isset($defConfig['rows'])?$defConfig['rows']:5,'fields1');
				$key='Config[default]';
				$formGui->addField($key,'mselect',$this->_T->lang('[[Vorgabewert]]'),isset($defConfig['default'])?$defConfig['default']:array(),'fields1');
				$Values=Framework::extractObjName($this->_BaseSelect->listSelect($this->_Obj->getID()));
				$formGui->setValues($key,$Values);
				$formGui->setAttribs($key,array('size'=>$formGui->getFieldVal('Config[rows]',1)?$formGui->getFieldVal('Config[rows]',1):count($Values)));
			break;
			case 'check':
				$key='Config[default]';
				$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Vorgabewert]]'),isset($defConfig['default'])?$defConfig['default']:0,'fields1');
				$Values=array(1=>$this->_T->Lang('[[Ja]]'),-1=>$this->_T->Lang('[[Nein]]'));
				$Values[0]=$this->_T->Lang('[[Ignorieren]]');
				$formGui->setValues($key,$Values);
			break;
			case 'area':
				$key='Config[rows]';
				$formGui->addField($key,'int',$this->_T->lang('[[Zeilen]]'),isset($defConfig['rows'])?$defConfig['rows']:5,'fields1');
				$key='Config[default]';
				$formGui->addField($key,'area',$this->_T->lang('[[Vorgabewert]]'),isset($defConfig['default'])?$defConfig['default']:'','fields1');
				$formGui->setAttribs($key,array('rows'=>$formGui->getFieldVal('Config[rows]',1)));
				if ($this->_guiCfg['useMaxLen']) {
					$key='Config[maxlen]';
					$formGui->addField($key,'text',$this->_T->lang('[[Max Laenge]]'),isset($defConfig['maxlen'])?$defConfig['maxlen']:0,'fields1');
				}
				
				$key='lb1';
				$formGui->addField($key,'label',$this->_T->lang('[[Optionen]]'),'','fields2');
				if ($this->_guiCfg['useHtmlArea']) {
					$key='Config[html]';
					$formGui->addField($key,'check',$this->_T->lang('[[HTML-Editor verwenden]]'),isset($defConfig['html'])?$defConfig['html']:0,'fields2');
				}
			break;
			case 'text':
				$key='Config[default]';
				$formGui->addField($key,'text',$this->_T->lang('[[Vorgabewert]]'),isset($defConfig['default'])?$defConfig['default']:'','fields1');
				if ($this->_guiCfg['useMaxLen']) {
					$key='Config[maxlen]';
					$formGui->addField($key,'text',$this->_T->lang('[[Max Laenge]]'),isset($defConfig['maxlen'])?$defConfig['maxlen']:0,'fields1');
				}
			break;
			case 'date':
				$key='Config[default]';
				$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Vorgabewert]]'),isset($defConfig['default'])?$defConfig['default']:'','fields1');
				$Values=array(''=>$this->_T->Lang('[[Keiner]]'),'%Y-%m-%d'=>$this->_T->Lang('[[Aktuelles Datum]]'));
				$formGui->setValues($key,$Values);
			break;
			case 'group':
				if ($this->_Obj->getMeta('Multiple')) {
					$groupFields=$this->_BaseFields->listParentFields($this->_Obj->getID());

					$key='Config[sortBy]';
					$formGui->addField($key,'select',$this->_T->lang('[[Sortieren nach]]'),isset($defConfig['sortBy'])?$defConfig['sortBy']:'','fields1');
					$Values=array(''=>'-') + Framework::extractObjName($groupFields);
					$formGui->setValues($key,$Values);
					$key='Config[sortDir]';
					$formGui->addField($key,'radiolist_h','',isset($defConfig['sortDir'])?$defConfig['sortDir']:1,'fields1');
					$Values=array(1=>$this->_T->Lang('[[Aufsteigend]]'),-1=>$this->_T->Lang('[[Absteigend]]'));
					$formGui->setValues($key,$Values);
					$key='Config[showSum]';
					$formGui->addField($key,'check',$this->_T->lang('[[Feldsummen anzeigen]]'),isset($defConfig['showSum'])?$defConfig['showSum']:0,'fields1');

					$key='Config[viewDir]';
					$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Listenansicht]]'),isset($defConfig['viewDir'])?$defConfig['viewDir']:0,'fields2');
					$Values=array(0=>$this->_T->Lang('[[Horizontal]]'),-1=>$this->_T->Lang('[[Vertikal]]'));
					$formGui->setValues($key,$Values);
					
				}
			break;
			case 'fk_addr':
				$key='Config[MaxEntries]';
				$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Anzahl Eintraege]]'),isset($defConfig['MaxEntries'])?$defConfig['MaxEntries']:0,'fields1');
				$Values=array(1=>$this->_T->Lang('[[Einer]]'),0=>$this->_T->Lang('[[Mehrere]]'));
				$formGui->setValues($key,$Values);
			
				$Addr=& $this->_frm->getStaticModul('addr');
				$this->_T->loadModul('addr');
				$cardTitle=array();
				$avFieldArray=array();
				$viewFields=isset($defConfig['ViewAddrFields'])?$defConfig['ViewAddrFields']:array('ATel','Mobil','Fax');
				foreach ($Addr->getFields() as $k=>$v) {
					if (!$cardTitle[$v['Card']]) {
						$cardTitle[$v['Card']]=$this->_T->lang('[[AddrCard_'.$v['Card'].']]');
					}
					switch ($v['Typ']) {
						case 'stamm':
						case 'perm':

						break;
						case 'title':
							$cardTitle[$v['Card']]=$v['Title'];
						break;
						default:
							if ($v['Card']!='n') {
								$avFieldArray[$cardTitle[$v['Card']]][$k]=$v['Title'];
							}
						break;
					}
				}
			
				$cTitle=$this->_T->lang('[[Internes - Feld]]');
				foreach ($Addr->getIntFields() as $k=>$v) {
					$avFieldArray[$cTitle][$key]=$this->_T->lang($v['Name']);
				}
				$avFieldArray[$this->_T->lang('[[Projekte]]')]['FKProjID']=$this->_T->lang('[[Projektzugehoerigkeit]]');
				
				$key='Config[ViewAddrFields]';
				$formGui->addField($key,'select_grp',$this->_T->lang('[[Angezeigte Felder]]'),$viewFields,'fields1');
				$formGui->setValues($key,$avFieldArray);
				$formGui->setAttribs($key,array('multiple'=>'multiple','size'=>20));
			break;
			case 'fk_user':
				$key='Config[MaxEntries]';
				$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Anzahl Eintraege]]'),isset($defConfig['MaxEntries'])?$defConfig['MaxEntries']:0,'fields1');
				$Values=array(1=>$this->_T->Lang('[[Einer]]'),0=>$this->_T->Lang('[[Mehrere]]'));
				$formGui->setValues($key,$Values);
				$key='Config[default]';
				$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Vorgabewert]]'),isset($defConfig['default'])?$defConfig['default']:'','fields1');
				$Values=array(''=>$this->_T->Lang('[[Keiner]]'),'-1'=>$this->_T->Lang('[[Angemeldeter BenutzerIn]]'));
				$formGui->setValues($key,$Values);
			break;
			case 'fk_comp':
				$key='Config[MaxEntries]';
				$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Anzahl Eintraege]]'),isset($defConfig['MaxEntries'])?$defConfig['MaxEntries']:0,'fields1');
				$Values=array(1=>$this->_T->Lang('[[Einer]]'),0=>$this->_T->Lang('[[Mehrere]]'));
				$formGui->setValues($key,$Values);

				$key='Config[useZef]';
				if ($this->_guiCfg['useZefFirma']) {
					$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Fuer Zeiterfassung verwenden]]'),isset($defConfig['useZef'])?$defConfig['useZef']:0,'fields1');
					$Values=array(1=>$this->_T->Lang('[[Ja]]'),0=>$this->_T->Lang('[[Nein]]'));
					$formGui->setValues($key,$Values);
				}
			break;
			case 'status':
			case 'status_txt':
				$key='Config[isEditable]';
				$formGui->addField($key,'check',$this->_T->lang('[[Status kann manuell geaendert werden]]'),isset($defConfig['isEditable'])?$defConfig['isEditable']:0,'fields1');
			break;
		}

		$key='submit';
		$formGui->addField($key,'submit','','','fields3');
		$submit_array=array(
			'uform_f_config_save_x'=>' '.$this->_T->lang('[[Speichern]]').' ',
		);
		$formGui->setValues($key,$submit_array);

		if (Framework::getParam('uform_f_config_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if (is_object($this->_Obj)) {
					$this->_Obj->setMeta('Config',serialize(Framework::getParam('Config',array(),'P')));
					$this->_BaseFields->updateObj($this->_Obj);
					$this->_L->unsetParam('uform_f_oid');
					$this->_L->setParam('uform_f_action','b');
				}
				$this->_L->goToLink();
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		return $tplContent;
	}
	function getVisibilityGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FastTemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new FastTemplateGui('uform/visibility_config.inc.html');
		$tplContent->setEncode(false);
		$formGui=new FormGui();
		$Visibility=unserialize($this->_Obj->getMeta('Visibility'));


		$avOptions=array();
		$avOptions['lk']=$this->_T->lang('[[Enthaelt]]');
		$avOptions['nlk']=$this->_T->lang('[[Enthaelt nicht]]');
		$avOptions['is']=$this->_T->lang('[[Ist genau]]');
		$avOptions['nis']=$this->_T->lang('[[Ist nicht genau]]');
		$avOptions['em']=$this->_T->lang('[[Ist leer]]');
		$avOptions['nem']=$this->_T->lang('[[Ist nicht leer]]');
		$avOptions['gt']=$this->_T->lang('[[Ist groesser gleich als]]');
		$avOptions['lt']=$this->_T->lang('[[Ist kleiner gleich als]]');


		$FieldConfig=array();
		$allFields=$this->_BaseFields->listFormFields(true);
		$typFields=array();
		if (is_array($allFields[0])) {
			foreach ($allFields[0] as $gkey=>$gval) {
				if (is_array($allFields[$gkey])) {
					foreach ($allFields[$gkey] as $fkey=>$fval) {
						$typFields[$fval->getMeta('Typ')][$fkey]=$fval->getName();
					}
				}
			}
		}

		$selFieldsValues[0]=array(0=>'-');
		if (!empty($this->_guiCfg['extraVisibilityField'])) {
			foreach($this->_guiCfg['extraVisibilityField'] as $fkey=>$fval) {
				$FieldConfig[$fkey]['typ']=$fval['Typ'];
				$FieldConfig[$fkey]['val']=$fval['Values'];
				$FieldConfig[$fkey]['valTyp']=$fval['ValuesTyp'];
				$selFieldsValues[0][$fkey]=$fval['Name'];
			}
		}


		if (is_array($allFields[0])) {
			foreach ($allFields[0] as $gkey=>$gval) {
				if (is_array($allFields[$gkey])) {
					foreach ($allFields[$gkey] as $fkey=>$fval) {
						if ($fkey==$this->_Obj->getID()) continue;
						$parse=false;
						switch ($fval->getMeta('Typ')) {
							case 'check':
								$fValues=array(1=>$this->_T->Lang('[[Ja]]'),-1=>$this->_T->Lang('[[Nein]]'));
								if (!$fval->getMeta('Required')) {
									$fValues[0]=$this->_T->Lang('[[Ignorieren]]');
								}
								$ValuesTyp='select';
								$parse=true;
							break;
							case 'select':
								$fValues=Framework::extractObjName($this->_BaseSelect->listSelect($fval->getID()));;
								$ValuesTyp='mselect';
								$parse=true;
							break;
							/*case 'fk_comp':
								$Zef=& $this->_frm->getStaticModul('zef');
								$fValues=$Zef->listAllCompanyNames();
								$ValuesTyp='mselect';
								$parse=true;
							break;
							case 'file':
							case 'fk_addr':
							case 'fk_user':
							case 'text':
							case 'area':
								$fValues=array();
								$parse=true;
								$ValuesTyp='';
							break;
							case 'mselect':
								$fValues=Framework::extractObjName($this->_BaseSelect->listSelect($fval->getID()));;
								$ValuesTyp='select';
								$parse=true;
							break;
							case 'date':
								$fValues=array();
								$ValuesTyp='select';
								$fValues=array(-1=>$this->_T->Lang('[[Aktuelles Datum]]'));
								$parse=true;
							break;
							case 'int':
								$fValues=array();
								$ValuesTyp='text';
								$parse=true;
							break;
							*/
						}
						if ($parse) {
							$FieldConfig[$fkey]['typ']=$fval->getMeta('Typ');
							$FieldConfig[$fkey]['val']=$fValues;
							$FieldConfig[$fkey]['valTyp']=$ValuesTyp;
							$selFieldsValues[$gval->getName()][$fkey]=$fval->getName();
						}
					}
				}
			}
		}

		$formGui->addField('visibilityField','select_grp',$this->_T->lang('[[Dieses Feld nur anzeigen wenn]]'),$Visibility['Field'],'fields1');
		$formGui->setValues('visibilityField',$selFieldsValues);
		$formGui->setAttribs('visibilityField',array('onchange'=>'changeVisibilityField(this.value)'));



		if (Framework::getParam('uform_f_visibility_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if (is_object($this->_Obj)) {
					$Visibility=array(
						'Field'=>$formGui->getFieldVal('visibilityField'),
						'Mode'=>Framework::getParam('visibilityMode','','P'),
						'Value'=>Framework::getParam('visibilityValue','','P'),
					);
					$this->_Obj->setMeta('Visibility',serialize($Visibility));
					$this->_BaseFields->updateObj($this->_Obj);
					$this->_L->unsetParam('uform_f_oid');
					$this->_L->setParam('uform_f_action','b');
				}
				$this->_L->goToLink();
			}
		}

		$tplContent->assign('FORM_FIELDS',$formGui->process());
		$submitField=new SubmitBtn('uform_f_visibility_save_x',' '.$this->_T->lang('[[Speichern]]').' ');
		$tplContent->assign('C_SELECT_FIELD','');

		$tplContent->assign('JS_FIELD_CONFIG',Framework::array2json($FieldConfig));
		$tplContent->assign('JS_VISIBILITY_OPTIONS',Framework::array2json($avOptions));
		$tplContent->assign('SUBMIT_FIELD',$submitField);


		if ($formGui->getFieldVal('visibilityField',1)) {
			$defField=$formGui->getFieldVal('visibilityField',1);
			$defMode=Framework::getParam('visibilityMode',$Visibility['Mode'],'P');
			$defValue=Framework::getParam('visibilityValue',$Visibility['Value'],'P');
			$this->_frm->addOnLoad("changeVisibilityField('".$defField."','".$defMode."','".(is_array($defValue)?'|'.implode('|',$defValue).'|':$defValue)."');");
		}




		/*$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));*/
		return $tplContent;
	}
	function getStatusFieldGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FastTemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new FastTemplateGui('uform/status_config.inc.html');
		$tplContent->setEncode(false);
		$formGui=new FormGui();
		$Values=unserialize($this->_Obj->getMeta('Value'));
		$update=false;
		if (!is_array($Values['Status'])) $Values['Status']=array();
		if (Framework::getParam('deleteStatus_x','0','P')) {
			$key=key($tmpArray=Framework::getParam('deleteStatus_x',0,'P'));
			unset($Values['Status'][$key]);
			$Values['Status']=array_values($Values['Status']);
			$update=true;
		}
		if (Framework::getParam('moveStatusUp_x','0','P')) {
			$key=key($tmpArray=Framework::getParam('moveStatusUp_x',0,'P'));
			if ($key>0) {
				$tmpData= array_splice($Values['Status'], $key, 1);
				array_splice($Values['Status'], $key-1, 0, $tmpData);
				$update=true;
			}
		}
		if (Framework::getParam('moveStatusDown_x','0','P')) {
			$key=key($tmpArray=Framework::getParam('moveStatusDown_x',0,'P'));
			if ($key<count($Values['Status'])-1) {
				$tmpData= array_splice($Values['Status'], $key, 1);
				array_splice($Values['Status'], $key+1, 0, $tmpData);
				$update=true;
			}
		}
		if ($update) {
			$this->_Obj->setMeta('Value',serialize($Values));
			$this->_BaseFields->updateObj($this->_Obj);
		}

		$avOptions=array();
		$avOptions['lk']=$this->_T->lang('[[Enthaelt]]');
		$avOptions['nlk']=$this->_T->lang('[[Enthaelt nicht]]');
		$avOptions['is']=$this->_T->lang('[[Ist genau]]');
		$avOptions['nis']=$this->_T->lang('[[Ist nicht genau]]');
		$avOptions['em']=$this->_T->lang('[[Ist leer]]');
		$avOptions['nem']=$this->_T->lang('[[Ist nicht leer]]');
		$avOptions['gt']=$this->_T->lang('[[Ist groesser gleich als]]');
		$avOptions['lt']=$this->_T->lang('[[Ist kleiner gleich als]]');

		switch ($this->_Obj->getMeta('Typ')) {
			case 'status_txt':
				$avValues=array(0=>'-') + Framework::extractObjName($this->_BaseSelect->listSelect($this->_Obj->getID()));;
				$formGui->addField('statusKey','select',$this->_T->lang('[[Status]]'),'','fields1');
			break;
			case 'status':
				$avColors=array(
					'#fff',
					'#f00',
					'#FF9900',
					'#FFCC00',
					'#ff0',
					'#0f0',
					'#669900',
					'#99CC00',
					'#00f',
					'#6699CC',
					'#0ff',
					'#834100',
					'#CC00CC',
					'#FF66FF',
					'#000',
					'#ccc',
				);
				foreach ($avColors as $val) {
					$avValues[$val]=new UserStatusObj($val);
				}
				$formGui->addField('statusKey','radiolist_h',$this->_T->lang('[[Status]]'),'','fields1');
			break;
		}
		$formGui->setValues('statusKey',$avValues);
		$formGui->setRequired('statusKey');

		$FieldConfig=array();
		$allFields=$this->_BaseFields->listFormFields(true);
		$typFields=array();
		if (is_array($allFields[0])) {
			foreach ($allFields[0] as $gkey=>$gval) {
				if (is_array($allFields[$gkey])) {
					foreach ($allFields[$gkey] as $fkey=>$fval) {
						$typFields[$fval->getMeta('Typ')][$fkey]=$fval->getName();
					}
				}
			}
		}

		$selFieldsValues[0]=array(0=>'-');
		if (is_array($allFields[0])) {
			foreach ($allFields[0] as $gkey=>$gval) {
				if ((!is_object($this->_aktParentObj) || !$this->_aktParentObj->getMeta('Multiple'))) {
					if ($gval->getMeta('Multiple')) continue;
				} else {
					if ($this->_aktParentObj->getID()!=$gkey) continue;
				}
				if (is_array($allFields[$gkey])) {
					foreach ($allFields[$gkey] as $fkey=>$fval) {
						$parse=false;
						switch ($fval->getMeta('Typ')) {
							case 'file':
							case 'fk_addr':
							case 'fk_user':
							case 'text':
							case 'area':
								$fValues=array();
								$parse=true;
								$ValuesTyp='';
							break;
							case 'fk_comp':
								$Zef=& $this->_frm->getStaticModul('zef');
								$fValues=$Zef->listAllCompanyNames();
								$ValuesTyp='select';
								$parse=true;
							break;
							case 'select':
								$fValues=Framework::extractObjName($this->_BaseSelect->listSelect($fval->getID()));;
								$ValuesTyp='select';
								$parse=true;
							break;
							case 'mselect':
								$fValues=Framework::extractObjName($this->_BaseSelect->listSelect($fval->getID()));;
								$ValuesTyp='select';
								$parse=true;
							break;
							case 'check':
								$fValues=array(1=>$this->_T->Lang('[[Ja]]'),-1=>$this->_T->Lang('[[Nein]]'));
								if (!$fval->getMeta('Required')) {
									$fValues[0]=$this->_T->Lang('[[Ignorieren]]');
								}
								$ValuesTyp='select';
								$parse=true;
							break;
							case 'date':
								$fValues=array();
								$ValuesTyp='select';
								$fValues=array(-1=>$this->_T->Lang('[[Aktuelles Datum]]'));
								/*if (is_array($typFields[$fval->getMeta('Typ')])) {
									foreach ($typFields[$fval->getMeta('Typ')] as $skey=>$sval) {
										$fValues[$skey]=$sval;
									}
								}*/
								$parse=true;
							break;
							case 'int':
								$fValues=array();
								$ValuesTyp='text';
								$parse=true;
							break;
						}
						if ($parse) {
							$FieldConfig[$fkey]['typ']=$fval->getMeta('Typ');
							$FieldConfig[$fkey]['val']=$fValues;
							$FieldConfig[$fkey]['valTyp']=$ValuesTyp;
							$selFieldsValues[$gval->getName()][$fkey]=$fval->getName();
						}
					}
				}
			}
		}

		$formGui->addField('statusField','select_grp',$this->_T->lang('[[wenn Feld]]'),0,'fields1');
		$formGui->setValues('statusField',$selFieldsValues);
		$formGui->setRequired('statusField');
		$formGui->setAttribs('statusField',array('onchange'=>'changeStatusField(this.value)'));

		if (Framework::getParam('uform_f_Values_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if (is_object($this->_Obj)) {
					$Values['Status'][]=array(
						'fid'=>$formGui->getFieldVal('statusField'),
						'mode'=>Framework::getParam('statusMode','','P'),
						'val'=>Framework::getParam('statusValue','','P'),
						'key'=>$formGui->getFieldVal('statusKey'),
					);
					$this->_Obj->setMeta('Value',serialize($Values));
					$this->_BaseFields->updateObj($this->_Obj);
				}
				$this->_L->goToLink();
			}
		}
		$tplContent->assign('FORM_FIELDS',$formGui->process());
		$submitField=new SubmitBtn('uform_f_Values_save_x',' '.$this->_T->lang('[[Speichern]]').' ');
		$tplContent->assign('C_SELECT_FIELD','');

		$tplContent->assign('JS_FIELD_CONFIG',Framework::array2json($FieldConfig));
		$tplContent->assign('JS_STATUS_OPTIONS',Framework::array2json($avOptions));
		$tplContent->assign('SUBMIT_FIELD',$submitField);

		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tabGui->addHeaderCol('Pos','#','','','',0,0,2);
		$tabGui->addHeaderCol('status',$this->_T->lang('[[Status]]'));
		$tabGui->addHeaderCol('fid',$this->_T->lang('[[Feld]]'));
		$tabGui->addHeaderCol('mode',$this->_T->lang('[[Bedingung]]'),'','','',0,2000,3);
		foreach ($Values['Status'] as $key=>$val) {
			$fObj=$this->_BaseFields->getObj($val['fid']);
			if (is_object($fObj) && $FieldConfig[$fObj->getID()]) {
				$tabGui->addRow($hl?$hl=0:$hl=1);
				$btn_up=new SubmitImgBtn ('moveStatusUp_x['.$key.']','img/'.APP_THEME.'/rs_up.gif');
				$tabGui->addCol('up',$btn_up);
				$btn_down=new SubmitImgBtn ('moveStatusDown_x['.$key.']','img/'.APP_THEME.'/rs_down.gif');
				$tabGui->addCol('down',$btn_down);
				switch ($this->_Obj->getMeta('Typ')) {
					case 'status_txt':
						$tabGui->addCol('status',$avValues[$val['key']],'','','',1);
					break;
					case 'status':
						$tabGui->addCol('status',new UserStatusObj($val['key']),'','','center',1);
					break;
				}
				$tabGui->addCol('Name',$fObj->getMeta('RefID').'-'.$fObj->getName(),'','','',1);
				$tabGui->addCol('mode',$avOptions[$val['mode']],'','','',1);
				switch ($FieldConfig[$fObj->getID()]['valTyp']) {
					case 'select':
						$tmpVal=$FieldConfig[$fObj->getID()]['val'][$val['val']];
					break;
					default:
						$tmpVal=$val['val'];
					break;
				}
				$tabGui->addCol('val',$tmpVal,'','','',0,2000);
				$btn_del=new SubmitImgBtn ('deleteStatus_x['.$key.']','img/'.APP_THEME.'/clear.gif');
				$tabGui->addCol('del',$btn_del,'','','',1);
			}
		}
		$tplContent->assign('CONTENT_TABLE',$tabGui);

		return $tplContent;
	}
	function getPermsGui($perm_mode=0,$useRules=1,$useGroups=1,$useUsers=1,$optionTitle='') {
		$avPerms=array(
			1=>$this->_T->lang('[[Lesen]]'),
			3=>$this->_T->lang('[[Schreiben]]'),
		);

		if ($useRules) $perms_r=Framework::aclToArray($this->_Obj->getMeta('PermsRules'));
		if ($useGroups) $perms_g=Framework::aclToArray($this->_Obj->getMeta('PermsGroups'));
		if ($useUsers) $perms_u=Framework::aclToArray($this->_Obj->getMeta('PermsUsers'));

		$update=false;
		if (Framework::getParam('perms_add',0,'P') && Framework::getParam('addPermsID',0,'P')) {
			if ($useRules && Framework::getParam('addFKProjRuleID',0,'P')) {
				if ($perm_mode) {
					$perms_r[Framework::getParam('addFKProjRuleID',0,'P')]=array_sum(Framework::getParam('addPermsID',0,'P'));
				} else {
					$perms_r[Framework::getParam('addFKProjRuleID',0,'P')]=Framework::getParam('addPermsID',0,'P');
				}
				$this->_Obj->setMeta('PermsRules',Framework::arrayToAcl($perms_r));
				$update=true;
			}
			if ($useGroups && Framework::getParam('addFKGroupID',0,'P')) {
				if ($perm_mode) {
					$perms_g[Framework::getParam('addFKGroupID',0,'P')]=array_sum(Framework::getParam('addPermsID',0,'P'));
				} else {
					$perms_g[Framework::getParam('addFKGroupID',0,'P')]=Framework::getParam('addPermsID',0,'P');
				}
				$this->_Obj->setMeta('PermsGroups',Framework::arrayToAcl($perms_g));
				$update=true;
			}
			if ($useUsers && Framework::getParam('addFKUserID',0,'P')) {
				if ($perm_mode) {
					$perms_u[Framework::getParam('addFKUserID',0,'P')]=array_sum(Framework::getParam('addPermsID',0,'P'));
				} else {
					$perms_u[Framework::getParam('addFKUserID',0,'P')]=Framework::getParam('addPermsID',0,'P');
				}
				$this->_Obj->setMeta('PermsUsers',Framework::arrayToAcl($perms_u));
				$update=true;
			}
		}
		if($useRules && is_array(Framework::getParam('permDeleteR_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteR_x',0,'P'));
			if ($key) {
				unset($perms_r[$key]);
				$this->_Obj->setMeta('PermsRules',Framework::arrayToAcl($perms_r));
				$update=true;
			}
		}
		if($useGroups && is_array(Framework::getParam('permDeleteG_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteG_x',0,'P'));
			if ($key) {
				unset($perms_g[$key]);
				$this->_Obj->setMeta('PermsGroups',Framework::arrayToAcl($perms_g));
				$update=true;
			}
		}
		if($useUsers && is_array(Framework::getParam('permDeleteU_x',0,'P'))) {
			$key=key($tmpArray=Framework::getParam('permDeleteU_x',0,'P'));
			if ($key) {
				unset($perms_u[$key]);
				$this->_Obj->setMeta('PermsUsers',Framework::arrayToAcl($perms_u));
				$update=true;
			}
		}
		if ($update) {
			$this->_BaseFields->updateObj($this->_Obj,1);
			$this->_L->goToLink();
		}

		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();

		if ($useRules) {
			$formGui->addField('addFKProjRuleID','select',$this->_T->lang('[[prjRules]]'),'','fields1');
			$formGui->setValues('addFKProjRuleID',array(0=>'-') + $this->_T->langArray($this->_P->getAvRules()));
		}
		if ($useGroups) {
			$formGui->addField('addFKGroupID','select',$this->_T->lang('[[Gruppen]]'),'','fields1');
			$formGui->setValues('addFKGroupID',array(0=>'-') + $this->_frm->getAllGroups());
		}
		if ($useUsers) {
			$formGui->addField('addFKUserID','select',$this->_T->lang('[[BenutzerInnen]]'),'','fields1');
			$formGui->setValues('addFKUserID',array(0=>'-') + $this->_frm->getFullName());
		}

		//$formGui->addField('FKUserID','ttip',$this->_T->lang('[[BenutzerInnen]]'),'u_16|u_1','fields1');
		//$formGui->setParams('FKUserID',array('mode'=>'u|g'));

		if ($perm_mode) {
			$formGui->addField('addPermsID','checklist_v',$this->_T->lang('[[Rechte]]'),1,'fields2');
		} else {
			$formGui->addField('addPermsID','radiolist_v',$this->_T->lang('[[Rechte]]'),1,'fields2');
		}
		$formGui->setValues('addPermsID',$avPerms);

		$formGui->addField('perms_add','submit','',$this->_T->lang('[[Zuweisen]]'),'fields3');

		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));
		//$tplContent->addContent('form2',$box,'CONTENT');

		if ($useRules) $tplContent->addContent('form3_1',$this->listPerms('PermsRules',$perms_r,$avPerms,$perm_mode,'perm'),'FORM3');
		if ($useGroups) $tplContent->addContent('form3_2',$this->listPerms('PermsGroups',$perms_g,$avPerms,$perm_mode,'perm'),'FORM3');
		if ($useUsers) $tplContent->addContent('form3_3',$this->listPerms('PermsUsers',$perms_u,$avPerms,$perm_mode,'perm'),'FORM3');
		return $tplContent;
	}
	function &listPerms($ptype,$perms,$av_perms,$perm_mode=0,$prep='perm') {
		if (!empty($perms)) {
			require_once('lib/class_ApplicationListGui.php');
			require_once('lib/class_FormGui.php');
			$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
			switch ($ptype) {
				case 'PermsRules':
					$title=$this->_T->lang('[[prjRules]]');
					$perms_users=array();
					foreach ($perms as $key=>$val) {
						$perms_users[$key]=$this->_T->lang($this->_P->getAvRules($key));

					}
					$img='rolle.gif';
					$dbtn=$prep.'DeleteR_x';
				break;
				case 'PermsGroups':
					$title=$this->_T->lang('[[Gruppen]]');
					$perms_users=$this->_frm->getAllGroups(array_keys($perms),-1);
					$img='gruppe.gif';
					$dbtn=$prep.'DeleteG_x';
				break;
				case 'PermsUsers':
					$title=$this->_T->lang('[[BenutzerInnen]]');
					$perms_users=$this->_frm->getFullName(array_keys($perms),0,1);
					$img='user.gif';
					$dbtn=$prep.'DeleteU_x';
				break;
			}
			$tabGui->addHeaderCol('Name',$title,'','','',0,0,2);
			foreach ($av_perms as $pkey=>$pval) {
				$tabGui->addHeaderCol('Perms_'.$pkey,$pval,'','','',1);
			}
			$tabGui->addHeaderCol('Delete','','tras.gif');
			$tabGui->setLimit(0);
			$rows=0;$hl=0;
			if (is_array($perms_users)) {
				foreach ($perms_users as $key=>$val) {
					//debug($val);
					$hl=$hl?0:1;
					$tabGui->addRow($hl);
					$tabGui->addCol('IMG','',$img);
					$tabGui->addCol('Name',$val,'','','',0,'2000');

					foreach ($av_perms as $pkey=>$pval) {

						if ($perm_mode) {
							$tabGui->addCol('Perms_'.$pkey,($perms[$key]&$pkey)?'X':'','','','center',1);
						} else {
							$tabGui->addCol('Perms_'.$pkey,$pkey==$perms[$key]?'X':'','','','center',1);
						}
					}
					//$tabGui->addCol('Perms',$av_perms[$val],'','','',1);
					$btn=new SubmitImgBtn ($dbtn.'['.$key.']','img/'.APP_THEME.'/loeschen.gif');
					$tabGui->addCol('Delete',$btn);
				}
			}
		}
		return $tabGui;
	}

	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_mode,array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_mode,$key);
		if (!$result) $result=$default;
		return $result;
	}



}
?>