<?php
class UserFormPrintGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_isLoaded=false;
	var $_multiple=array();
	function UserFormPrintGui() {
		global $frm;
		$this->_frm=&$frm;
		require_once("lib/uform/class_UserFormData.php");
		$this->_uFormData=new UserFormData(true);
		$this->_BaseForm=& $this->_frm->getStaticModul('uform');
		$this->_BaseTpl=& $frm->getStaticModul('print_tpl');
	}
	function loadObj($ID) {
		$Obj=$this->_BaseForm->getObj($ID);
		if (is_object($Obj)) {
			$this->setFormObj($Obj);
			return $Obj;
		}
	}
	function &loadSystemObj($val,$useFieldPerms=false,$myRules=null) {
		$Obj=$this->_BaseForm->getSystemForm($val);
		if (is_object($Obj)) {
			$this->setFormObj($Obj,$useFieldPerms,$myRules);
			return $Obj;
		}
	}
	function setFormObj(&$Obj,$useFieldPerms=false,$myRules=null) {
		$this->_formObj=&$Obj;
		$this->_uFormData->setFormObj($this->_formObj);
		$this->_useFieldPerms=$useFieldPerms;
		if ($this->_useFieldPerms) {
			$this->_uFormData->calcPerms($myRules);
		}
		$this->_formFields=$this->_uFormData->getFormFields();
	}
	function &getFormObj() {
		return $this->_formObj;
	}
	function setUsePerms($myRules) {
		$this->_useFieldPerms=1;
		$this->_uFormData->calcPerms($myRules);
		$this->_formFields=$this->_uFormData->getFormFields();
	}
	function setStaticVisibility($val) {
		$this->_staticVisibility=$val;
	}
	function setValueCallBack($typ,$callBack) {
		$this->_uFormData->setValueCallBack($typ,$callBack);
	}
	function getFieldsData() {
		$result=array();
		$Fields=$this->_uFormData->getAllFieldsID();
		foreach ($Fields as $ID) {
			$fObj=$this->_uFormData->getFieldObj($ID);
			if (is_object($fObj)) {
				$result[$fObj->getMeta('RefID')]=array(
					'Title'=>$fObj->getMeta('Name'),
					'ListTitle'=>$fObj->getMeta('useList')?$fObj->getMeta('NameList'):$fObj->getMeta('Name'),
					'Multiple'=>$fObj->getMeta('Multiple'),
					'Typ'=>$fObj->getMeta('Typ'),
					'Config'=>unserialize($fObj->getMeta('Config')),
				);
			}
		}
		return $result;
	}
	function getFieldsConfig() {
		$result=array();
		if (is_array($this->_formFields[0])) {
			foreach ($this->_formFields[0] as $fGroup) {
				foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
					$result[$fGroup->getMeta('RefID')][]=$fObj->getMeta('RefID');
				}
			}
		}
		return $result;
	}
	function getFormValues($ObjID,$Perms) {
		$result=array();
		$Data=$this->_uFormData->getData($ObjID);
		$RefID=$this->_formObj->getMeta('RefID');
		if (is_array($this->_formFields[0])) {
			foreach ($this->_formFields[0] as $fGroup) {
				if ($this->_useFieldPerms && !$fGroup->getAcl(1)) {
					$aclPerms=0;
				} else {
					$aclPerms=1;
				}
				$gshow=true;
				$fVisibility=unserialize($fGroup->getMeta('Visibility'));
				if ($fVisibility['Field']) {
					$gshow=$this->_uFormData->calcShow(isset($this->_staticVisibility[$fVisibility['Field']])?$this->_staticVisibility[$fVisibility['Field']]:$Data['F_'.$fVisibility['Field']],$fVisibility['Mode'],$fVisibility['Value']);
				}
				if ($fGroup->getMeta('Multiple')) {
					if ($Perms && $gshow && $aclPerms) {
						$subEntries=unserialize($Data['F_'.$fGroup->getID()]);
						$result[$fGroup->getMeta('RefID')]['Value']=$this->_getFormGroupValues($fGroup,$subEntries);
					}
				} elseif (is_array($this->_formFields[$fGroup->getID()])) {
					foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
						if (is_object($fObj)) {
							$fshow=true;
							$fVisibility=unserialize($fObj->getMeta('Visibility'));
							if ($fVisibility['Field']) {
								$fshow=$this->_uFormData->calcShow(isset($this->_staticVisibility[$fVisibility['Field']])?$this->_staticVisibility[$fVisibility['Field']]:$Data['F_'.$fVisibility['Field']],$fVisibility['Mode'],$fVisibility['Value']);
							}
							$obj_list=array();
							if ($Perms && $fshow && $gshow && $aclPerms) {
								$value=$this->_uFormData->Entry2Value($fObj,$Data,'F_'.$fObj->getID(),"\n",$obj_list);
								$result[$fObj->getMeta('RefID')]['Key']=$Data['F_'.$fObj->getID()];
							} else {
								$value='';
								$result[$fObj->getMeta('RefID')]['Key']='';
							}
							if (is_object($value)) {
								$result[$fObj->getMeta('RefID')]['Value']=$value->process();
							} else {
								$result[$fObj->getMeta('RefID')]['Value']=nl2br($value);
							}
							if (!empty($obj_list)) {
								$result[$fObj->getMeta('RefID')]['Obj']=$obj_list;
							}
							$result[$fObj->getMeta('RefID')]['Show']=($Perms && $fshow && $gshow && $aclPerms);
						}
					}
				}
				$result[$fGroup->getMeta('RefID')]['Show']=($Perms && $gshow && $aclPerms);
			}
		}
		return $result;
	}
	function _getFormGroupValues(&$fGroup,&$subEntries) {
		$RefID=$this->_formObj->getMeta('RefID');
		$result=array();
		if (is_array($this->_formFields[$fGroup->getID()])) {
			if (is_array($subEntries)) {
				$gConfig=unserialize($fGroup->getMeta('Config'));
				if ($gConfig['sortBy'] && is_object($this->_formFields[$fGroup->getID()][$gConfig['sortBy']])) {
					$this->_uFormData->setSort($this->_formFields[$fGroup->getID()][$gConfig['sortBy']],$gConfig['sortDir']);
					uasort($subEntries, array($this->_uFormData,'groupSort'));
				}
				$row=0;
				foreach ($subEntries as $subVal) {
					foreach($this->_formFields[$fGroup->getID()] as $fObj) {
						$value=$this->_uFormData->Entry2Value($fObj,$subVal,'F_'.$fObj->getID(),"\n",$n=null,'_'.$row);
						
						if (is_object($value)) {
							$result[$row][$fObj->getMeta('RefID')]['Value']=$value->process();
						} else {
							$result[$row][$fObj->getMeta('RefID')]['Value']=nl2br($value);
						}
						$result[$row][$fObj->getMeta('RefID')]['Key']=$subVal['F_'.$fObj->getID()];
						$result[$row][$fObj->getMeta('RefID')]['Show']=1;
					}
					$row++;
				}
				if ($gConfig['showSum'] && $row) {
					$groupSum=$this->_uFormData->calcGroupSum($subEntries,$fGroup);
					foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
						$value=$this->_uFormData->Entry2Value($fObj,$groupSum,'F_'.$fObj->getID());
						if (is_object($value)) {
							$result[$row][$fObj->getMeta('RefID')]['Value']=$value->process();
						} else {
							$result[$row][$fObj->getMeta('RefID')]['Value']=nl2br($value);
						}
						$result[$row][$fObj->getMeta('RefID')]['Sum']=1;
						if (!isset($groupSum['F_'.$fObj->getID()])) {
							$result[$row][$fObj->getMeta('RefID')]['Show']=0;
						} else {
							$result[$row][$fObj->getMeta('RefID')]['Show']=1;
						}
					}
				}
			}
		}
		return $result;
	}
	function printObj(&$ObjID,$tplID=0,$formPerms=0,$formTitle='') {
		require_once('lib/class_MySmartyGui.php');
		$Gui=new MySmartyGui();
		$tplPrint='';
		$tplPrint=$this->getPrintTemplate('obj',$tplID);
		$formTitle.=$this->_formObj->getName();
		$Config['Forms'][$this->_formObj->getMeta('RefID')]['Title']=$formTitle;
		$Config['Fields']=array($this->_formObj->getMeta('RefID')=>$this->getFieldsData());
		$Config['FieldsTree']=array($this->_formObj->getMeta('RefID')=>$this->getFieldsConfig());
		$Gui->assign('form_Config',$Config);
		$entriesView=array($this->_formObj->getMeta('RefID')=>$this->getFormValues($ObjID,$formPerms));
		$Gui->assign('form_Entry',$entriesView);
		//debug($entriesView);
		$Gui->display($tplPrint);
		exit;

	}
	function getPrintTemplate($Typ,$tplID=0) {
		if ($tplID) {
			$tplPrint=realpath($this->_BaseTpl->getPrintTemplate($tplID,1));
		} else {
			switch ($Typ) {
				case 'obj':
					$tplPrint=($GLOBALS['MASTER_TPL']?$GLOBALS['MASTER_TPL']:'').'tpl/'.APP_THEME.'/uform/utf8.print_obj.inc.html';
				break;
			}
		}
		return realpath($tplPrint);
	}


}
?>