<?php
class UserFormShowGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_isLoaded=false;
	var $_quickMode=false;
	var $_multiple=array();
	var $_simple=array();
	var $_modifiedGroup=array();
	var $_requestHandled=false;
	var $_form_style="";
	var $_field_class=array('ipt','ipt');
	function UserFormShowGui($tpl='uform/uform_show.inc.html') {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FastTemplateGui.php');
		require_once('lib/class_ApplicationListGui.php');
		require_once("lib/uform/class_UserFormData.php");
		global $frm,$t,$T,$E,$L;
		$this->_uFormData=new UserFormData();
		$this->_BaseForm=& $frm->getStaticModul('uform');
		$this->_BaseFields=& $frm->getStaticModul('uform_fields');
		$this->_BaseSelect=& $frm->getStaticModul('uform_select');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('uform');
		$this->_Gui=new FastTemplateGui($tpl);
		$this->_tmpFilePath=$this->_frm->getDynTempPath('uform');

	}
	function isCallable() {
		return true;
	}
	function &loadSystemObj($val,$useFieldPerms=false,$myRules=null) {
		$Obj=$this->_BaseForm->getSystemForm($val);
		if (is_object($Obj)) {
			$this->setFormObj($Obj,$useFieldPerms,$myRules);
			return $Obj;
		}
	}
	function setFormObj(&$Obj,$useFieldPerms=false,$myRules=null) {
		$this->_formObj=&$Obj;
		$this->_BaseFields->setFormObj($this->_formObj);
		$this->_uFormData->setFormObj($this->_formObj,$useFieldPerms,$myRules);
		$this->_formFields=$this->_uFormData->getFormFields();
		
	}
	function setQuickMode($val) {
		$this->_quickMode=$val;
	}
	function setDefault($val) {
		$this->_default=$val;
	}
	function getDefault() {
		return $this->_default;
	}
	function setFormStyle($val) {
		$this->_form_style=$val;
	}
	function setParams($val) {
		$this->_params=$val;
	}
	function getParams() {
		return $this->_params;
	}
	function loadDefault($ID,$FKModul='') {
		$this->_default=$this->_uFormData->getData($ID,$FKModul);
	}
	function getTempFilePath() {
		return $this->_tmpFilePath;
	}
	function setStaticVisibility($val) {
		$this->_staticVisibility=$val;
	}
	function hasMultipleGroups() {
		$this->_loadForm();
		return empty($this->_multiple)?false:true;
	}
	function hasSimpleGroups() {
		$this->_loadForm();
		return empty($this->_simple)?false:true;
	}
	function &getUFormDataObj() {
		return $this->_uFormData;
	}
	function setFieldClass($a,$b) {
		return $this->_field_class=array($a,$b);
	}
	function _loadForm() {
		if (!$this->_isLoaded) {
			$this->_cfgVisiblity=array();
			$this->_formGui=new FormGui('uform/form.inc.html','uform/form_fields.inc.html');
			$this->_formGui->setFieldClass($this->_field_class[0],$this->_field_class[1]);
			$this->_formGui->addCustumTplValue('STYLE',$this->_form_style);
			if (is_array($this->_formFields[0])) {
				foreach ($this->_formFields[0] as $fGroup) {
					$fVisibility=unserialize($fGroup->getMeta('Visibility'));
					if ($fVisibility['Field']) {
						$this->_cfgVisiblity[$fGroup->getID()]=$fVisibility;
					}
					if (is_array($this->_formFields[$fGroup->getID()])) {
						if ($fGroup->getMeta('Multiple')) {
							$this->_formGui->addField('uformData[F_'.$fGroup->getID().']','hidden','',base64_encode(isset($this->_default['F_'.$fGroup->getID()])?$this->_default['F_'.$fGroup->getID()]:serialize(array())),'uform_G_'.$fGroup->getID());
						}
						foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
							$fVisibility=unserialize($fObj->getMeta('Visibility'));
							if ($fVisibility['Field']) {
								$this->_cfgVisiblity[$fObj->getID()]=$fVisibility;
							}

							if ($this->_addField2Form($this->_formGui,$fGroup,$fObj,'uformData',isset($this->_default['F_'.$fObj->getID()])?$this->_default['F_'.$fObj->getID()]:null)) {
								$this->_groupNotEmpty[$fGroup->getID()]=1;
							}
						}
						if ($fGroup->getMeta('Multiple')) {
							$this->_formGui->addField('uform_G_add_'.$fGroup->getID(),'submit','',$this->_T->lang('[[Hinzufuegen]]'),'uform_G_'.$fGroup->getID());
							$this->_formGui->setAttribs('uform_G_add_'.$fGroup->getID(),array('onclick'=>"addFormAnchor('#lnk_".$fGroup->getID()."');"));
							if ($fGroup->getAcl(2)) {
								if (!$this->_quickMode || $fGroup->getMeta('useQuick')) {
									$this->_multiple[]=$fGroup->getID();
								}
							}
						} else {
							if ($fGroup->getAcl(2)) {
								if (!$this->_quickMode || $fGroup->getMeta('useQuick')) {
									$this->_simple[]=$fGroup->getID();
								}
							}
						}
					}
				}
			}
			$this->_isLoaded=true;
		}
	}
	function _addField2Form(&$FormGui,&$fGroup,&$fObj,$Prep='uformData',$Default=null) {
		$fID=$Prep.'[F_'.$fObj->getID().']';
		$fTyp=$fObj->getMeta('Typ');
		$fConfig=unserialize($fObj->getMeta('Config'));
		$Values=array();
		$Params=array();
		$Attribs=array();
		switch ($fTyp) {
			case 'select':
				$Values=array(''=>'-') + Framework::extractObjName($this->_BaseSelect->listSelect($fObj->getID()));
				if (!isset($Default)) $Default=$fConfig['default'];
			break;
			case 'mselect':
				$Values=Framework::extractObjName($this->_BaseSelect->listSelect($fObj->getID()));
				$Attribs['size']=$fConfig['rows']?$fConfig['rows']:count($Values);
				if (!isset($Default)) $Default=$fConfig['default']; else $Default=explode(',',$Default);
			break;
			case 'text':
				if (!isset($Default)) $Default=$fConfig['default'];
			break;
			case 'area':
				if ($fConfig['html']) {
					$fTyp='html';
					$Attribs['rows']=$fConfig['rows']?$fConfig['rows']:5;
					$Attribs['cols']=60;
				} else {
					$Attribs['rows']=$fConfig['rows']?$fConfig['rows']:5;
					if (!isset($Default)) $Default=$fConfig['default'];
				}
			break;
			case 'date':
				if (!isset($Default)) $Default=strftime($fConfig['default']);
			break;
			case 'int':
				$Params['numdec']=$fConfig['decimals']?$fConfig['decimals']:0;
				if (!isset($Default)) $Default=$fConfig['default'];
			break;
			case 'check':
				$Values=array(1=>$this->_T->Lang('[[Ja]]'),-1=>$this->_T->Lang('[[Nein]]'));
				if (!$fObj->getMeta('Required')) {
					$Values[0]=$this->_T->Lang('[[Ignorieren]]');
				}
				$fTyp='radiolist_h';
				if (!isset($Default)) $Default=$fConfig['default'];
			break;
			case 'file':
				$fTyp='cached_file';
				if ($Default) {
					if (!is_array($Default)) {
						$tmp=explode('/',$Default);
						$Fmng=& $this->_frm->getStaticModul('fmng');
						$Fmng->setRule(true);
						$defFile=$Fmng->readFile($tmp[1],0);
						if ($defFile) {
							$Default=array(
								'tmp_name'=>$defFile['FilePath'],
								'name'=>$tmp[0],
							);
						} else {
							$Default=array();
						}
					}
				}
				$Params['TmpPath']=$this->getTempFilePath();
				//$Params['numdec']=$fConfig['decimals'];
			break;
			case 'fk_addr':
				$fTyp='ttip';
				$tmpParams=array(
					'MaxEntries'=>$fConfig['MaxEntries'],
					'showPlace'=>0,
					'onlyName'=>0,
					'onlyNameSearch'=>0,
					'useAll'=>0,
					'onlyCatSub'=>1,
					'onlyCat'=>0,
				);
				if (isset($this->_params[$fObj->getID()]) && $this->_params[$fObj->getID()]['tipParams']) {
					foreach ( $this->_params[$fObj->getID()]['tipParams'] as $k=>$v) {
						$tmpParams[$k]=$v;
					}
				}
				//debug($tmpParams);
				//$tmpParams=base64_encode(serialize(array('MaxEntries'=>1,'showPlace'=>1,'onlyName'=>0,'onlyNameSearch'=>0,'useAll'=>1,'onlyCatSub'=>1,'onlyCat'=>$this->_addrSpdCat)));
				$Params['mode']='a';
				$Params['limit']=10;
				$Params['params']=base64_encode(serialize($tmpParams));

			break;
			case 'fk_user':
				$fTyp='ttip';
				$tmpParams=array(
					'MaxEntries'=>$fConfig['MaxEntries'],
					'useAll'=>0,
				);
				//$tmpParams=base64_encode(serialize(array('MaxEntries'=>1,'showPlace'=>1,'onlyName'=>0,'onlyNameSearch'=>0,'useAll'=>1,'onlyCatSub'=>1,'onlyCat'=>$this->_addrSpdCat)));
				$Params['mode']='u';
				$Params['limit']=10;
				$Params['params']=base64_encode(serialize($tmpParams));
				if (!isset($Default)) {
					if ($fConfig['default']==-1) {
						$Default='u_'.$this->_frm->getUser();
					}

				}
			break;
			case 'fk_comp':
				$Zef=& $this->_frm->getStaticModul('zef');
				if ($fConfig['MaxEntries']==1) {
					$fTyp='select';
					$Values=array(0=>'-') + $Zef->listAllCompanyNames();
				} else {
					$fTyp='mselect';
					$Values=$Zef->listAllCompanyNames();
					$Attribs['size']=5;
					if (!isset($Default)) $Default=$fConfig['default']; else $Default=explode(',',$Default);
				}
			break;
			case 'status':
				$fTyp='';
				if ($fConfig['isEditable']) {
					$Values=array();
					$fValue=unserialize($fObj->getMeta('Value'));
					if (is_array($fValue['Status'])) {
						$Values['']=$this->_T->lang('[[automatisch]]');
						foreach ($fValue['Status'] as $temp) {
							$Values[$temp['key']]=new UserStatusObj($temp['key'],'ipt_hlist');
						}
						if (!empty($Values)) {
							$fTyp='radiolist_h';
						}
					}
				}
			break;
			case 'status_txt':
				$fTyp='';
				if ($fConfig['isEditable']) {
					$Values=array();
					$fValue=unserialize($fObj->getMeta('Value'));
					if (is_array($fValue['Status'])) {
						$Values['']=$this->_T->lang('[[automatisch]]');
						foreach ($fValue['Status'] as $temp) {
							$Values[$temp['key']]=$this->_BaseSelect->getCachedValue($temp['key']);
							if (!trim($Values[$temp['key']])) unset($Values[$temp['key']]);
						}
						if (!empty($Values)) {
							$fTyp='select';
						}
					}
				}
			break;
			default:
				$fTyp='';
			break;
		}
		if ($fTyp) {
			$FormGui->addField($fID,$fTyp,$fObj->getName(),$Default,'uform_G_'.$fGroup->getID());
			if (!empty($Values)) {
				$FormGui->setValues($fID,$Values);
			}
			if (!empty($Attribs)) {
				$FormGui->setAttribs($fID,$Attribs);
			}
			if (!empty($Params)) {
				$FormGui->setParams($fID,$Params);
			}
			if ($fObj->getMeta('Required')) {
				$FormGui->setRequired($fID);
			}
			return true;
		} else {
			return false;
		}
	}
	function _parseForm() {
		$jsVisibility=array();
		$show=array();
		foreach ($this->_cfgVisiblity as $fkey=>$fVisibility) {
			$fieldID='uformData[F_'.$fVisibility['Field'].']';
			if ($this->_formGui->fieldExists($fieldID)) {
				$Attribs=array('onchange'=>"uformCheckVisibility('".$this->_formGui->getFieldType($fieldID)."','".$fVisibility['Field']."','".$fieldID."')");
				$this->_formGui->setAttribs($fieldID,$Attribs);

				$iptAttribs=array('id'=>'view_'.$fkey);
				$show[$fkey]=$this->_uFormData->calcShow($this->_formGui->getFieldVal($fieldID,1),$fVisibility['Mode'],$fVisibility['Value']);
				if (!$show[$fkey]) {
					$iptAttribs['style']='display:none';
				}
				$this->_formGui->setIptAttribs('uformData[F_'.$fkey.']',$iptAttribs);

				$jsVisibility[$fVisibility['Field']][]=array('fid'=>'view_'.$fkey,'mode'=>$fVisibility['Mode'],'def'=>$fVisibility['Value']);
			} elseif (isset($this->_staticVisibility[$fVisibility['Field']])) {
				$iptAttribs=array();
				$show[$fkey]=$this->_uFormData->calcShow($this->_staticVisibility[$fVisibility['Field']],$fVisibility['Mode'],$fVisibility['Value']);
				if (!$show[$fkey]) {
					$iptAttribs['style']='display:none';
				}
				$this->_formGui->setIptAttribs('uformData[F_'.$fkey.']',$iptAttribs);
			} elseif(isset($this->_default['F_'.$fVisibility['Field']])) {
				$iptAttribs=array();
				$show[$fkey]=$this->_uFormData->calcShow($this->_default['F_'.$fVisibility['Field']],$fVisibility['Mode'],$fVisibility['Value']);
				if (!$show[$fkey]) {
					$iptAttribs['style']='display:none';
				}
				$this->_formGui->setIptAttribs('uformData[F_'.$fkey.']',$iptAttribs);
			}
		}
		$this->_Gui->assign('JS_VISIBILITY',Framework::array2json($jsVisibility));

		if (is_array($this->_formFields[0])) {
			foreach ($this->_formFields[0] as $fGroup) {
				//debug($fGroup);
				if ($this->_groupNotEmpty[$fGroup->getID()]) {
					if ($this->_quickMode && !$fGroup->getMeta('useQuick')) continue;
					if (!$fGroup->getAcl(2)) continue;
					if (isset($show[$fGroup->getID()]) && !$show[$fGroup->getID()]) {
						$this->_Gui->assign('STYLE','display:none');
					} else {
						$this->_Gui->assign('STYLE','');
					}
					$this->_parseGroup($fGroup);
					$this->_Gui->parse('ROW','.group');
				}
			}
		}
	}
	function &_parseGroup(&$fGroup,$return=false) {
		$this->_Gui->assign('ID','view_'.$fGroup->getID());
		$this->_Gui->assign('LID','lnk_'.$fGroup->getID());
		$this->_Gui->assign('NAME',$fGroup->getName());
		$this->_Gui->assign('FORM',array($this->_formGui,'process'),array('','uform_G_'.$fGroup->getID()));
		if ($fGroup->getMeta('Multiple')) {
			if (is_array($this->_formFields[$fGroup->getID()])) {
				$Entries=unserialize(base64_decode($this->_formGui->getFieldVal('uformData[F_'.$fGroup->getID().']',true)));
				if (!is_array($Entries)) $Entries=array();
				$this->_Gui->assign('GC_ID','uform_V_'.$fGroup->getID());
				$this->_Gui->assign('GROUP_CONTENT',$this->getGroupTable($fGroup,$Entries));
				$this->_Gui->parse('ROW','group_content');
			}
		}
		$this->_Gui->parse('ROW','group_data');
		$this->_Gui->clear_dynamic('group_content');
	}
	function groupSort($A,$B) {
		switch($this->_sortFobj->getMeta('Typ')) {
			case 'int':
				$result=$A['F_'.$this->_sortFobj->getID()]>$B['F_'.$this->_sortFobj->getID()]?1:-1;
			break;
			case 'fk_addr':
				$result=strnatcasecmp($this->_uFormData->Entry2Value($this->_sortFobj,$A,'F_'.$this->_sortFobj->getID()) ,$this->_uFormData->Entry2Value($this->_sortFobj,$B,'F_'.$this->_sortFobj->getID()));
			break;
			default:
				$result=strnatcasecmp($A['F_'.$this->_sortFobj->getID()],$B['F_'.$this->_sortFobj->getID()]);
			break;
		}
		return $this->_sortDir*$result;
	}
	function &getGroupTable(&$fGroup,&$Entries) {
		$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$tabGui->setStyle('width:100%');

		$gConfig=unserialize($fGroup->getMeta('Config'));
		if ($gConfig['sortBy'] && is_object($this->_formFields[$fGroup->getID()][$gConfig['sortBy']])) {
			$this->_sortFobj=$this->_formFields[$fGroup->getID()][$gConfig['sortBy']];
			$this->_sortDir=$gConfig['sortDir'];
			uasort($Entries, array($this,'groupSort'));
		}


		if ($gConfig['viewDir']) {
			$tabGui->addHeaderCol('uform_V_edit','#','','','center',1,0,1);
			$tabGui->addHeaderCol('uform_V_key',$fGroup->getName(),'','','',0);
			$tabGui->addHeaderCol('uform_V_value','','','','',0);
			$tabGui->addHeaderCol('uform_V_del','#','','','center',1,0,1);
		} else {
			$tabGui->addHeaderCol('uform_V_edit','#','','','center',1,0,1);
			foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
				$tabGui->addHeaderCol('uform_V_'.$fObj->getID(),$fObj->getName(),'','','',0);
			}
			$tabGui->addHeaderCol('uform_V_del','#','','','center',1,0,1);
			
		}
		
		foreach($Entries as $key=>$val) {
			if ($key==$this->_GroupEditID[$fGroup->getID()]) {
				$tabGui->addRow(2,'top','#ff0');
				$btn_break=new SubmitImgBtn ('uform_G_break_'.$fGroup->getID().'['.$key.']','img/'.APP_THEME.'/de/bt_abbrechen.gif');
				$btn_break->setAttribs(array('onclick'=>"addFormAnchor('#lnk_".$fGroup->getID()."');"));
				//$tabGui->addCol('uform_V_break',$btn_break,'','','center',1,'','');
				//$tabGui->addCol('uform_V_break','','','','center',1,'','');

				$this->_loadGroupEditForm($fGroup,$key,$val);
				$colspan=count($this->_formFields[$fGroup->getID()]) ;
				if (Framework::getParam('uform_G_save_'.$fGroup->getID().'['.$key.']','0','P')) {

				} else {
					$this->_editFormGui[$fGroup->getID()]->clearFields();
				}
				$tabGui->addCol('uform_V_edit',$this->_editFormGui[$fGroup->getID()],'','','',1,0,$colspan+2);

				/*$btn_del=new SubmitImgBtn ('uform_G_del_'.$fGroup->getID().'['.$key.']','img/'.APP_THEME.'/clear.gif');
				$btn_del->setAttribs(array('onclick'=>"addFormAnchor('#lnk_".$fGroup->getID()."');return lo_form();"));
				$tabGui->addCol('uform_V_del',$btn_del,'','','',1,'1%');*/

			} else {
				if ($gConfig['viewDir']) {
					$hl=$hl?0:1;
					$j=0;
					foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
						$tabGui->addRow($hl,'top');
						if (!$j) {
							$btn_edit=new SubmitImgBtn ('uform_G_edit_'.$fGroup->getID().'['.$key.']','img/'.APP_THEME.'/ico-edit.gif');
							$btn_edit->setAttribs(array('onclick'=>"addFormAnchor('#lnk_".$fGroup->getID()."');"));
							$tabGui->addCol('uform_V_edit',$btn_edit,'','','',1,'1%');
						} else {
							$tabGui->addCol('uform_V_edit','','','','',1,'');
						}
						$tabGui->addCol('uform_T_'.$fObj->getID(),$fObj->getName().':','','','right',1);
						$tabGui->addCol('uform_V_'.$fObj->getID(),$this->_uFormData->Entry2Value($fObj,$val,'F_'.$fObj->getID(),"\n",$n=null,'_'.$key),'','','',0,'100%');
						if (!$j) {
							$btn_del=new SubmitImgBtn ('uform_G_del_'.$fGroup->getID().'['.$key.']','img/'.APP_THEME.'/clear.gif');
							$btn_del->setAttribs(array('onclick'=>"addFormAnchor('#lnk_".$fGroup->getID()."');return lo_form();"));
							$tabGui->addCol('uform_V_del',$btn_del,'','','',1,'1%');
						} else {
							$tabGui->addCol('uform_V_del','','','','',1,'');
						}
						$j++;
				}
				} else {
					$tabGui->addRow($hl?$hl=0:$hl=1);
					$btn_edit=new SubmitImgBtn ('uform_G_edit_'.$fGroup->getID().'['.$key.']','img/'.APP_THEME.'/ico-edit.gif');
					$btn_edit->setAttribs(array('onclick'=>"addFormAnchor('#lnk_".$fGroup->getID()."');"));
					$tabGui->addCol('uform_V_edit',$btn_edit,'','','',1,'1%');

					foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
						$tabGui->addCol('uform_V_'.$fObj->getID(),$this->_uFormData->Entry2Value($fObj,$val,'F_'.$fObj->getID(),"\n",$n=null,'_'.$key),'','','',0);
					}

					$btn_del=new SubmitImgBtn ('uform_G_del_'.$fGroup->getID().'['.$key.']','img/'.APP_THEME.'/clear.gif');
					$btn_del->setAttribs(array('onclick'=>"addFormAnchor('#lnk_".$fGroup->getID()."');return lo_form();"));
					$tabGui->addCol('uform_V_del',$btn_del,'','','',1,'1%');
				}
			}
		}
		if ($gConfig['showSum']) {
			$tabGui->addRow(2);
			$tabGui->addCol('uform_V_edit','','','','',0);
			$groupSum=$this->_calcGroupSum($Entries,$fGroup);
			foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
				$tabGui->addCol('uform_V_'.$fObj->getID(),isset($groupSum['F_'.$fObj->getID()])?$this->_uFormData->Entry2Value($fObj,$groupSum,'F_'.$fObj->getID()):'','','','',0);
			}
			$tabGui->addCol('uform_V_del','','','','',0);
		}
		return $tabGui;

	}
	function _calcGroupSum(&$Entries,&$fGroup) {
		$result=array();
		foreach($Entries as $key=>$val) {
			foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
				switch ($fObj->getMeta('Typ')) {
					case 'int':
						$result['F_'.$fObj->getID()]+=$val['F_'.$fObj->getID()];
					break;
					default:

					break;
				}
			}

		}
		return $result;
	}
	function _loadGroupEditForm(&$fGroup,$rowID=0,$Default=null) {
		$this->_editFormGui[$fGroup->getID()]=new FormGui('uform/form.inc.html','uform/form_fields.inc.html');
		$this->_editFormGui[$fGroup->getID()]->setFieldClass($this->_field_class[0],$this->_field_class[1]);
		foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
			$this->_addField2Form($this->_editFormGui[$fGroup->getID()],$fGroup,$fObj,'uformDataEdit',$Default['F_'.$fObj->getID()]);
		}
		$this->_editFormGui[$fGroup->getID()]->addField('submit','submit','','','fields1');
		$submit_array=array(
			'uform_G_save_'.$fGroup->getID().'['.$rowID.']'=>' '.$this->_T->lang('[[Aendern]]').' ',
			'uform_G_break_'.$fGroup->getID().'['.$rowID.']'=>' '.$this->_T->lang('[[Abbrechen]]').' ',
			//'uform_G_del_'.$fGroup->getID().'['.$rowID.']'=>' '.$this->_T->lang('[[Loeschen]]').' ',
		);
		$this->_editFormGui[$fGroup->getID()]->setValues('submit',$submit_array);
		//$this->_editFormGui[$fGroup->getID()]->setValuesAttribs('submit','uform_G_del_'.$fGroup->getID().'['.$rowID.']',array('onclick'=>"addFormAnchor('#lnk_".$fGroup->getID()."');return lo_form();"));
		$this->_editFormGui[$fGroup->getID()]->setValuesAttribs('submit','uform_G_break_'.$fGroup->getID().'['.$rowID.']',array('onclick'=>"addFormAnchor('#lnk_".$fGroup->getID()."');"));
		$this->_editFormGui[$fGroup->getID()]->setValuesAttribs('submit','uform_G_save_'.$fGroup->getID().'['.$rowID.']',array('onclick'=>"addFormAnchor('#lnk_".$fGroup->getID()."');"));
	}
	function &process() {
		$this->_loadForm();
		$this->_handleRequest();
		$this->_parseForm();
		return $this->_Gui->process();
	}
	function checkFields($handle='') {
		$this->_loadForm();
		$show=array();
		foreach ($this->_cfgVisiblity as $fkey=>$fVisibility) {
			$fieldID='uformData[F_'.$fVisibility['Field'].']';
			if ($this->_formGui->fieldExists($fieldID)) {
				$show[$fkey]=$this->_uFormData->calcShow($this->_formGui->getFieldVal($fieldID,1),$fVisibility['Mode'],$fVisibility['Value']);
			} elseif (isset($this->_staticVisibility[$fVisibility['Field']])) {
				$show[$fkey]=$this->_uFormData->calcShow($this->_staticVisibility[$fVisibility['Field']],$fVisibility['Mode'],$fVisibility['Value']);
			}
			if (!$show[$fkey] && $this->_formGui->fieldExists('uformData[F_'.$fkey.']')) {
				$this->_formGui->setRequired('uformData[F_'.$fkey.']',false);
			}
		}
		if (is_array($this->_formFields[0])) {
			foreach ($this->_formFields[0] as $fGroup) {
				if (isset($show[$fGroup->getID()]) && !$show[$fGroup->getID()]) {
					if (is_array($this->_formFields[$fGroup->getID()])) {
						foreach ($this->_formFields[$fGroup->getID()] as $fobj) {
							if ($this->_formGui->fieldExists('uformData[F_'.$fobj->getID().']')) {
								$this->_formGui->setRequired('uformData[F_'.$fobj->getID().']',false);
							}

						}
					}
				}
			}
		}
		if (!$handle) {
			if (is_array($this->_formFields[0])) {
				foreach ($this->_formFields[0] as $fGroup) {
					if ($this->_quickMode && !$fGroup->getMeta('useQuick')) continue;
					if (!$fGroup->getAcl(2)) continue;
					if (!$fGroup->getMeta('Multiple')) {
						$this->_formGui->checkFields('uform_G_'.$fGroup->getID());
					}
				}
			}
		} else {
			$this->_formGui->checkFields($handle);
		}
	}
	function getValues($handle='',$use_default=false) {
		$this->_loadForm();
		$result=array();
		$this->_formGui->addMetaToArray($result,$handle,$use_default);
		return $result;
	}

	function getModifiedGroupDbValues($ObjModul) {
		$this->_handleRequest();
		//debug($this->_modifiedGroup);
		if (!empty($this->_modifiedGroup)) {
			return $this->getDbValues($ObjModul,array_keys($this->_modifiedGroup));
		}
	}
	function getDbValues($ObjModul,$onlyGroups=null) {
		$Fmng=& $this->_frm->getStaticModul('fmng');
		$Fmng->setRule(true);
		$this->_loadForm();
		$result=array();
		if (is_array($this->_formFields[0])) {
			foreach ($this->_formFields[0] as $fGroup) {
				if ($this->_quickMode && !$fGroup->getMeta('useQuick')) continue;
				if (!$fGroup->getAcl(2)) continue;
				if (is_array($onlyGroups) && !in_array($fGroup->getID(),$onlyGroups)) continue;
				if ($fGroup->getMeta('Multiple')) {
					if ($this->_formGui->fieldExists('uformData[F_'.$fGroup->getID().']')) {
						$gData=unserialize(base64_decode($this->_formGui->getFieldVal('uformData[F_'.$fGroup->getID().']',1)));
						//debug($this->_formGui->getFieldVal('uformData[F_'.$fGroup->getID().']',1));
						$gDataDefault=unserialize($this->_default['F_'.$fGroup->getID()]);
						if (is_array($this->_formFields[$fGroup->getID()])) {
							foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
								switch ($fObj->getMeta('Typ')) {
									case 'file':
										foreach ($gData as $gkey=>$grow) {
											$value='';
											$fileVal=$grow['F_'.$fObj->getID()];
											$fModul=$ObjModul.'_uform_'.$fObj->getID().'_'.$gkey;
											if (is_array($fileVal)) {
												$error=$Fmng->replaceFile(null,$fModul,0,$fileVal,0);
												if (!$error) {
													$value=$fileVal['name'].'/'.$fModul;
												}
											} elseif ($fileVal==$gDataDefault[$gkey]['F_'.$fObj->getID()]) {
												$value=$fileVal;
											} else {
												if ($gDataDefault[$gkey]['F_'.$fObj->getID()]) {
													$tmp=explode('/',$gDataDefault[$gkey]['F_'.$fObj->getID()]);
													$Fmng->deleteFile($tmp[1],0);
												}
											}
											$gData[$gkey]['F_'.$fObj->getID()]=$value;
										}
									break;
								}
							}
						}
						if (is_array($gData)) {
							$result['F_'.$fGroup->getID()]=serialize($gData);
						}
					}
				} elseif (is_array($this->_formFields[$fGroup->getID()])) {
					foreach ($this->_formFields[$fGroup->getID()] as $fObj) {
						if ($this->_formGui->fieldExists('uformData[F_'.$fObj->getID().']')) {
							switch ($fObj->getMeta('Typ')) {
								case 'mselect':
									$value=$this->_formGui->getFieldVal('uformData[F_'.$fObj->getID().']');
									if (is_array($value)) $value=implode(',',$value);
								break;
								case 'file':
									$value='';
									$fileVal=$this->_formGui->getFieldVal('uformData[F_'.$fObj->getID().']');
									$fModul=$ObjModul.'_uform_'.$fObj->getID();
									if (!empty($fileVal)) {
										$error=$Fmng->replaceFile(null,$fModul,0,$fileVal,0);
										if (!$error) {
											$value=$fileVal['name'].'/'.$fModul;
										}
									} else {
										if ($this->_default['F_'.$fObj->getID()]) {
											$tmp=explode('/',$this->_default['F_'.$fObj->getID()]);
											$Fmng->deleteFile($tmp[1],0);
										}
									}
								break;
								case 'status':
									if ($this->_formGui->fieldExists('uformData[F_'.$fObj->getID().']')) {
										$value=$this->_formGui->getFieldVal('uformData[F_'.$fObj->getID().']');
									} else {
										$value='';
									}
								break;
								case 'fk_comp':
									$value=$this->_formGui->getFieldVal('uformData[F_'.$fObj->getID().']');
									if (is_array($value)) $value=implode(',',$value);
								break;
								default:
									$value=$this->_formGui->getFieldVal('uformData[F_'.$fObj->getID().']');
								break;
							}
							$result['F_'.$fObj->getID()]=$value;
						}
					}
				}
			}
		}
		return $result;
	}
	function _handleRequest() {
		if (!$this->_requestHandled) {
			$this->_loadForm();
			$this->_GroupEditID=array();
			if (!empty($this->_multiple)) {
				foreach ($this->_multiple as $gid) {
					$this->_GroupEditID[$gid]=-1;
					if (Framework::getParam('uform_G_edit_'.$gid,0)) {
						$tmpArray=Framework::getParam('uform_G_edit_'.$gid,0);
						$key=key($tmpArray);
						$this->_GroupEditID[$gid]=$key;
					} elseif (Framework::issetParam('uform_GroupEditID_'.$gid)) {
						$this->_GroupEditID[$gid]=Framework::getParam('uform_GroupEditID_'.$gid,-1);
					}
					if (Framework::getParam('uform_G_add_'.$gid,'0','P')) {
						$this->checkFields('uform_G_'.$gid);
						if (!$this->_E->isError()) {
							$Values=unserialize(base64_decode($this->_formGui->getFieldVal('uformData[F_'.$gid.']',true)));
							//debug($Values);
							$Insert=$this->getValues('uform_G_'.$gid);
							unset($Insert['uformData']['F_'.$gid]);
							$Values[]=$Insert['uformData'];
							//debug($Values);
							$this->_formGui->setDefault('uformData[F_'.$gid.']',base64_encode(serialize($Values)));
							$this->_formGui->clearFields('uform_G_'.$gid);
							$this->_modifiedGroup[$gid]=1;
						}
						$this->_GroupEditID[$gid]=-1;
					}
					if (Framework::getParam('uform_G_save_'.$gid,'0','P')) {
						$tmpArray=Framework::getParam('uform_G_save_'.$gid,0,'P');
						$key=key($tmpArray);
						$this->_loadGroupEditForm($this->_formFields[0][$gid]);
						$this->_editFormGui[$gid]->checkFields();
						if (!$this->_E->isError()) {
							$Values=unserialize(base64_decode($this->_formGui->getFieldVal('uformData[F_'.$gid.']',true)));
							$Insert=array();
							$this->_editFormGui[$gid]->addMetaToArray($Insert);
							$Values[$key]=$Insert['uformDataEdit'];
							$this->_formGui->setDefault('uformData[F_'.$gid.']',base64_encode(serialize($Values)));
							$this->_formGui->clearFields('uform_G_'.$gid);
							$this->_GroupEditID[$gid]=-1;
							$this->_modifiedGroup[$gid]=1;
						}

					}
					if (Framework::getParam('uform_G_del_'.$gid,'0','P')) {
						$tmpArray=Framework::getParam('uform_G_del_'.$gid,0,'P');
						$key=key($tmpArray);
						$Values=unserialize(base64_decode($this->_formGui->getFieldVal('uformData[F_'.$gid.']',true)));
						unset($Values[$key]);
						$this->_formGui->setDefault('uformData[F_'.$gid.']',base64_encode(serialize($Values)));
						$this->_formGui->clearFields('uform_G_'.$gid);
						$this->_GroupEditID[$gid]=-1;
						$this->_modifiedGroup[$gid]=1;

					}
					if (Framework::getParam('uform_G_break_'.$gid,'0','P')) {
						$this->_GroupEditID[$gid]=-1;
					}

					if ($this->_GroupEditID[$gid]!=-1) {
						$this->_L->setParam('uform_GroupEditID_'.$gid,$this->_GroupEditID[$gid]);
					} else {
						$this->_L->unsetParam('uform_GroupEditID_'.$gid);
					}

				}
			}
			$this->_requestHandled=true;
		}
	}
	function updateData($ID,$Data) {
		$this->_uFormData->updateData($ID,$Data);
	}
	function isEmpty() {
		$this->_loadForm();
		$jsVisibility=array();
		$show=array();
		if (is_array($this->_formFields[0])) {
			foreach ($this->_formFields[0] as $fGroup) {
				if ($this->_quickMode && !$fGroup->getMeta('useQuick')) continue;
				if (!$fGroup->getAcl(2)) continue;
				if ($this->_cfgVisiblity[$fGroup->getID()]) {
					$fVisibility=$this->_cfgVisiblity[$fGroup->getID()];
					$fieldID='uformData[F_'.$fVisibility['Field'].']';
					if ($this->_formGui->fieldExists($fieldID)) {
						$show[$fGroup->getID()]=$this->_uFormData->calcShow($this->_formGui->getFieldVal($fieldID,1),$fVisibility['Mode'],$fVisibility['Value']);
					} elseif (isset($this->_staticVisibility[$fVisibility['Field']])) {
						$show[$fGroup->getID()]=$this->_uFormData->calcShow($this->_staticVisibility[$fVisibility['Field']],$fVisibility['Mode'],$fVisibility['Value']);
					}
				}
				if (isset($show[$fGroup->getID()]) && !$show[$fGroup->getID()]) {

				} else {
					return false;
				}
			}
		}
		return true;
	}
}
?>