<?php
class DateSelectForm {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	var $_defMode=1;
	var $_label='';
	function DateSelectForm($id='dsel') {
		global $frm,$t,$T,$E,$L,$P,$Y;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_id=$id;
		$this->_T->loadModul('zef');
		require_once('lib/class_FormGui.php');
		$this->_Gui=new FormGui('zef/form_date_select.inc.html');
		$this->_Gui->setFieldClass('ipts','ipts');
		$this->_date=array(
			0=>mktime(0,0,0,date('m'),1),
			1=>mktime(23,59,59,date('m'),date('t')),
		);
		//$this->_Gui->setTreeWidth(200);
	}
	function setLabel($val) {
		$this->_label=$val;
	}
	function setDate($val) {
		$this->_date=$val;
	}
	function getDate($key='') {
		switch($key) {
			case 'B':
				return $this->_date[0];
			break;
			case 'E':
				return $this->_date[1];
			break;
			default:
				return $this->_date;
			break;
		}
	}
	function setMode($val) {
		$this->_defMode=$val;
	}
	function _handleRequest() {
		if (Framework::getParam($this->_id.'DateMode',0,'P')) {
			switch (Framework::getParam($this->_id.'DateMode',0,'P')) {
				case 1:
					$tmp=explode('-',Framework::getParam($this->_id.'DateMonth','','P'));
					$this->_date[0]=mktime(0,0,0,$tmp[1],1,$tmp[0]);
					$this->_date[1]=mktime(23,59,59,$tmp[1],date('t',$this->_date[0]),$tmp[0]);
				break;
				case 2:
					$tmp=explode('-',Framework::getParam($this->_id.'DateQuarter','','P'));
					$this->_date[0]=mktime(0,0,0,$tmp[1]*3-2,1,$tmp[0]);
					$this->_date[1]=mktime(23,59,59,$tmp[1]*3,date('t',mktime(0,0,0,$tmp[1]*3,1,$tmp[0])),$tmp[0]);
				break;
				case 3:
					$tmp=Framework::parseDate(Framework::getParam($this->_id.'DateDateB','','P'),0,0,0);
					if ($tmp) $this->_date[0]=$tmp;
					$tmp=Framework::parseDate(Framework::getParam($this->_id.'DateDateE','','P'),23,59,59);
					if ($tmp) $this->_date[1]=$tmp;
				break;
				case 4:
					$this->_date[0]=0;
					$this->_date[1]=mktime(23,59,59);
				break;

			}
			$this->_defMode=Framework::getParam($this->_id.'DateMode',0,'P');
		}
		$this->_defMonth=$this->_date[0]?date('Y-m',$this->_date[0]):date('Y-m');
		$this->_defQuarter=$this->_date[0]?(date('Y',$this->_date[0]).'-'.ceil(date('n',$this->_date[0])/3)):(date('Y').'-'.ceil(date('n')/3));
		$this->_defDate=$this->_date;
		$this->processSelectForm();
		//$this->_Gui->addContent($wGui,null,null);
		//$this->parseJsDrop();
	}
	function &process() {
		$this->_handleRequest();
		return $this->_Gui;
	}
	function &processSelectForm() {
		$selectModes=array(
			1=>$this->_T->lang('[[Monat]]'),
			2=>$this->_T->lang('[[Quartal]]'),
			3=>$this->_T->lang('[[Datum]]'),
			4=>$this->_T->lang('[[Alles]]'),
		);
		$attribs=array(
			'onchange'=>$this->_id.'Change(this);',
			'onclick'=>$this->_id.'Change(this);',
		);
		$key=$this->_id."DateMode";
		$this->_Gui->addField($key,'radiolist_h',$this->_label,$this->_defMode,'fields1');
		$this->_Gui->setValues($key,$selectModes);
		$this->_Gui->setAttribs($key,$attribs);

		$selectMonths=array();

		for($i=date('n');$i>date('n')-12;$i--) {
			$time=mktime(0,0,0,$i);
			$selectMonths[date('Y-m',$time)]=strftime('%Y / %B',$time);
		}
		$key=$this->_id."DateMonth";
		$this->_Gui->addField($key,'select','',$this->_defMonth,'fields_m');
		$this->_Gui->setValues($key,$selectMonths);

		$selectQuarter=array();

		for ($i=ceil(date('n')/3);$i>ceil(date('n')/3)-5;$i--) {
			$time=mktime(0,0,0,$i*3);
			$selectQuarter[date('Y',$time).'-'.ceil(date('n',$time)/3)]=ceil(date('n',$time)/3).' / '.date('Y',$time);
		}
		$key=$this->_id."DateQuarter";
		$this->_Gui->addField($key,'select','',$this->_defQuarter,'fields_q');
		$this->_Gui->setValues($key,$selectQuarter);


		$attribs=array(
			'style'=>'width:80px;',
		);
		$key=$this->_id."DateDateB";
		$this->_Gui->addField($key,'unixdate','',$this->_defDate[0],'fields_d_b');
		$this->_Gui->setAttribs($key,$attribs);
		$key=$this->_id."DateDateE";
		$this->_Gui->addField($key,'unixdate','',$this->_defDate[1],'fields_d_e');
		$this->_Gui->setAttribs($key,$attribs);

		$this->_Gui->addCustumTplValue('ID',$this->_id);
		$this->_Gui->addCustumTplValue('DISP_MODE_1','none');
		$this->_Gui->addCustumTplValue('DISP_MODE_2','none');
		$this->_Gui->addCustumTplValue('DISP_MODE_3','none');
		$this->_Gui->addCustumTplValue('DISP_MODE_4','none');
		$this->_Gui->addCustumTplValue('DISP_MODE_'.$this->_Gui->getFieldVal($this->_id.'DateMode',1),'block');

		$this->_Gui->clearFields();
	}

}
?>