<?php
class DayListGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_mode='m';
	var $_nw=1;
	var $_parsed=array();
	var $_draggable=array();
	var $_idPrep='zef';
	function DayListGui() {
		global $frm,$t,$T,$E,$L,$Y;
		$this->_Base=$frm->getStaticModul('zef');
		$this->_BaseRes=$frm->getStaticModul('cal_res');
		if ($this->_Base->getUser()!=$this->_BaseRes->getUser()) {
			$this->_BaseRes->initUser($this->_Base->getUser());
		}
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_lGui=&$Y;
		$this->_T->loadModul('zef');
		require_once('lib/class_SimpleListGui.php');
		$this->_Gui=new SimpleListGui();
		$this->_Gui->setClass('cal_list');
		$this->_userID=$this->_frm->getUser();
		
	}
	function setAccessLink($l) {
		$this->_aL=$l;
	}
	function setNewLink($l) {
		$this->_nL=$l;
	}
	function setUserID($id) {
		$this->_userID=$id;
	}
	function setParseDragDrop($val) {
		$this->_dragDrop=$val;
	}
	function setIdPrepend($val) {
		$this->_idPrep=$val;
	}
	function setTimeFormat($val) {
		$this->_timeformat=$val;
	}
	function dayNumEntries($day_b) {
		return $this->_parsed[$day_b];
	}
	function getDraggable() {
		return $this->_draggable;
	}
	function setEntrys($val) {
		$this->_entries=$val;
	}
	function process($day_b,$title='',$borderColor='') {
		require_once('lib/class_ApplicationListGui.php');
		$this->_Gui=new ApplicationListGui();
		$this->_Gui->setHeaderColor(APP_FG20COLOR);
		$this->_Gui->setAutoBg(APP_FG10COLOR);
		if ($borderColor) {
			$this->_Gui->setBorderColor($borderColor);
			//$this->_Gui->setHeaderColor(APP_FGCOLOR);
		}
		$this->_hl=0;

		$day_key=date('Y-m-d',$day_b);
		$this->_parsed[$day_b]=0;
		$this->_sum[$day_b]=0;
		if (is_array($this->_entries[$day_key])) {
			foreach ($this->_entries[$day_key] as $key=>$val) {
				$this->addEventToList($key,$val,$day_b);
				$this->_parsed[$day_b]+=1;
				$this->_sum[$day_b]+=$val['zefDuration'];
			}
		}
		$this->_Gui->addHeaderCol('Img','','add_event.gif',$this->_aL.'&defTime='.$day_b);
		$this->_Gui->addHeaderCol('Name',$title,'','','',0,'2000');
		$this->_Gui->addHeaderCol('Dur',sprintf('%02d:%02d',$this->_sum[$day_b]/3600,($this->_sum[$day_b]%3600)/60),'','','right',1);

		return $this->_Gui->process();
	}
	function addEventToList($zefID,$zefVal,$group=0,$lay_prep='evt_') {
		//debug($zefVal);
		$img='month_mine.gif';
		$style='white-space:normal;';
		if ($this->_dragDrop) {
			$this->_draggable[$this->_idPrep.$zefID]=$zefID;
			$style.='cursor:move;';
		}

		$link=$this->_aL.'&zefID='.$zefID;

		$title='';
		if ($this->_Base->getCfg('cfg/modul/company')) {
			if ($zefVal['FKcompID']==-1) {
				$title=$this->_T->lang('[[FIRMENUEBERGREIFEND]]').' / ';
				if ($zefVal['compMode']==2) {
					$style.='font-style:italic;';
				}
			} elseif ($zefVal['FKcompID']) {
				$title=$this->_Base->getCachedCompanyName($zefVal['FKcompID']).' / ';
			}
		} else {
			$title=$this->_Base->getCachedPrjName($zefVal['FKzefPrjID']).' / ';
		}
		$title.=$this->_Base->getCachedCatName($zefVal['FKzefCatID']);
		$extra=array(
			'Attribs'=>array(
				'onmouseover'=>$this->_lGui->getFunctionOn($lay_prep.$zefID),
				'onmouseout'=>$this->_lGui->getFunctionOff($lay_prep.$zefID),
				'style'=>$style,
			),
		);
		$extraImg=array('Attribs'=>array(
				'style'=>'padding-top:6px;',
			),
		);


		$this->_hl=$this->_hl?0:1;
		$this->_Gui->addRow($this->_hl,'top');
		$this->_Gui->addCol('Img','',$img,'','right',0,'',0,'',$extraImg);
		$this->_Gui->addCol('Name',$title,'',$link,'',0,'',0,'',$extra);
		$this->_Gui->addCol('Dur',sprintf('%02d:%02d',$zefVal['zefDuration']/3600,($zefVal['zefDuration']%3600)/60),'','','right',1);


		$lay_title=Framework::dateSql('d.m.Y',$zefVal['zefBegin']);
		if ($this->_Base->getCfg('cfg/noTime')) {
			$lay_title.=' '.sprintf('%02d:%02d',$zefVal['zefDuration']/3600,($zefVal['zefDuration']%3600)/60);
		} else {
			$lay_title.=' '.Framework::dateSql('H:i',$zefVal['zefBegin']).' - '.Framework::dateSql('H:i',$zefVal['zefEnd']);
		}

		$lay_array=array();
		if ($this->_Base->getCfg('cfg/modul/company')) {
			$lay_array[$this->_T->lang('[[Projekt]]').':']=' '.Framework::entities($this->_Base->getCachedPrjName($zefVal['FKzefPrjID']));
			//$lay_array[$this->_T->lang('[[Firma]]').':']=' '.Framework::entities($compName).'<span id="zCompID_'.$key.'" style="display:none;">'.$val['FKcompID'].'</span>';
		}
		if ($zefVal['FKCalResID']) {
			$lay_array[$this->_T->lang('[[Resource]]').':']=' '.Framework::entities($this->_BaseRes->getCachedName($zefVal['FKCalResID']));
		}

		if ($zefVal['zefDescription']) {
			$lay_array[$this->_T->lang('[[Beschreibung]]').':']='<div>'.Framework::entities($zefVal['zefDescription']).'</div>';
		} else {
			//$lay_array[$this->_T->lang('[[Beschreibung]]').':']='';
		}
		if ($this->_Base->getCfg('cfg/modul/expenses')) {
			$costData=$this->_Base->listZefCosts($zefID);
			if (!empty($costData)) {
				require_once('lib/class_ApplicationListGui.php');
				$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
				foreach ($costData as $costVal) {
					$CostObj=$this->_Base->readCosts($costVal['FKcostID']);
					if ($costVal['FKcostTabID']) {
						$tabObj=$this->_Base->readExpensesTable($costVal['FKcostTabID']);
						if ($tabObj['tabTyp']==2) {
							$tabEntry=$this->_Base->readExpensesEntry($costVal['FKcostEntryID']);
							$Unit=$tabEntry['Unit'];
						} else {
							$Unit=$tabObj['tabUnit'];
						}
					} else {
						$Unit=$this->_Base->getCfg('cfg/currency');;
					}

					$hl=$hl?0:1;
					$tabGui->addRow($hl,'top');
					$tabGui->addCol('Name',$CostObj['Name'.$this->_Base->_lang].' ('.$Unit.')','','','',0,'2000',0,'');
					$tabGui->addCol('Val',Framework::numberFormat($costVal['costValue']),'','','right',1);
					$tabGui->addCol('Calc',Framework::numberFormat($costVal['costCalc']).' '.$this->_Base->getCfg('cfg/currency'),'','','right',1);
				}
				$lay_array[$this->_T->lang('[[Spesen]]').':']=$tabGui->process();
			}
		}
		$this->_lGui->addLayer($lay_prep.$zefID,$lay_array,'array',0,$lay_title);
	}
}
?>