<?php
class ViewExpensesGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_P;
	var $_droppable=array();
	function ViewExpensesGui() {
		global $frm,$t,$T,$E,$L,$P,$Y;
		$this->_Base=& $frm->getStaticModul('zef');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_lGui=&$Y;
		$this->_T->loadModul('zef');
		require_once('lib/class_TemplateGui.php');
		$this->_AppGui=new TemplateGui('core/common_form.inc.html');
		require_once('lib/class_ApplicationTreeGui.php');
		$this->_Gui=new ApplicationTreeGui();
		//$this->_Gui->setTreeWidth(200);
	}
	function _handleRequest() {
		$searchGui=& $this->getSearchGui();
		$this->_Gui->addTreeContent($searchGui);
		$printGui=& $this->getPrintConfigGui();
		$this->_Gui->addTreeContent($printGui);
		if (Framework::getParam('print_x',0)) {
			$this->printExpensesGui();
		} else {
			$contGui=& $this->getExpensesGui();
			
			$this->_Gui->addContent($contGui,null,null);
		}
	}
	function &process() {
		$this->_handleRequest();
		$this->_AppGui->addContent('cont1',$this->_Gui,'CONTENT');
		$this->_AppGui->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
		return $this->_AppGui->process();
	}
	function &getPrintConfigGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		$ContGui=new TemplateGui('core/common_content_border.inc.html');
		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');
		$key='printDesc';
		$formGui->addField($key,'area',$this->_T->lang('[[Beschreibung]]'),'','form_fields1');
		$formGui->setAttribs($key,array('rows'=>5));

		$printTpl=$this->_frm->getStaticModul('print_tpl');
		$printTpl->setModul('zef');
		$entries=$printTpl->listModulObj('cost_v');
		//debug($entries);
		$config=array('0'=>array(
			'f'=>0,
			'n'=>$this->_T->lang('[[Standard]]'),
		));
		$defTpl=0;
		foreach ($entries as $val) {
			if ($printTpl->calcAcl($val,null)) {
				if ($val->getMeta('ViewDefault')==2 && isset($config['0'])) unset($config['0']);
				if ($val->getMeta('ViewDefault'))  {
					$defTpl=$val->getID();
				}
				$config[$val->getID()]=array(
					'f'=>$val->getMeta('Format'),
					'n'=>$val->getName()
				);
			}
		}
		if (count($config)>1) {
			$key='printTpl';
			$formGui->addField($key,'radiolist_v',$this->_T->lang('[[Druckvorlagen]]'),$defTpl,'form_fields1');
			$formGui->setValues($key,FrameWork::extractArrayMeta($config,'n'));
		}

		$key='print_x';
		$formGui->addField($key,'hidden','',0,'form_fields1');

		$key='go_print_x';
		$formGui->addField($key,'submit','',' '.$this->_T->lang('[[Drucken]]').' ','form_fields1');
		$formGui->setAttribs($key,array('onclick'=>"return formSubmitBlank(document.daten,'print_x');"));

		$ContGui->addContent('formgui',$formGui,'CONTENT');
		$this->_search['printDesc']=$formGui->getFieldVal('printDesc',1);
		$this->_search['printTpl']=$formGui->fieldExists('printTpl')?$formGui->getFieldVal('printTpl',1):$defTpl;
		return $ContGui;
	}
	function &getSearchGui() {
		require_once('lib/class_DateSelectForm.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');

		$selDateGui=new DateSelectForm();
		$ContGui=new TemplateGui('core/common_content_border.inc.html');
		$ContGui->addContent('dateSelect',$selDateGui->process(),'CONTENT');

		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');
		if ($this->_Base->getPerms(16)) {
			$key='FKUserID';
			$mode='u';
			$params=base64_encode(serialize(array('MaxEntries'=>1)));
			$lb_params=array('Values'=>array());
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
				'LabelSep'=>'',
				'mode'=>$mode,
				'app'=>'zef',
				'params'=>$params,
				'FieldVal'=>'_USERS',
			);
			$default='u_'.$this->_frm->getUser();
			$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
			$formGui->addField($key,'ttip',$lb_Invit,$default,'form_fields1');
			$formGui->setParams($key,array('mode'=>$mode,'no_width'=>1,'params'=>$params));
		}
		$key='view_x';
		$formGui->addField($key,'submit','',' '.$this->_T->lang('[[Anzeigen]]').' ','form_fields1');
		$ContGui->addContent('formgui',$formGui,'CONTENT');

		$this->_search=array(
			'DateB'=>$selDateGui->getDate('B'),
			'DateE'=>$selDateGui->getDate('E'),
			'DateMode'=>$selDateGui->getMode(),
		);

		if ($this->_Base->getPerms(16)) {
			$this->_search['FKUserID']=substr($formGui->getFieldVal('FKUserID',1),2);
		} else {
			$this->_search['FKUserID']=$this->_frm->getUser();
		}
		$this->_frm->savePostData($this->_Base->getModul(),'tmpSearch',null,$this->_search);
		return $ContGui;
	}
	function &getExpensesGui($print=false) {
		$data=array();$dataSum=array();
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		if ($print) {
			$tabGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		} else {
			$tabGui=new ApplicationListGui();
			$tabGui->setName($this->_T->lang('[[Spesenabrechnung]]'));
		}
		$tabGui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));
		$hl=0;
		$entries=$this->_Base->searchExpenses($this->_search);
		foreach ($entries as $zefID=>$costEntries) {
			$firstVal=reset($costEntries);
			$data[$zefID]=array(
				'ID'=>$zefID,
				'costEntries'=>array(),
				'zefUser'=>$firstVal['zefUser'],
				'zefBegin'=>$firstVal['zefBegin'],
				'zefEnd'=>$firstVal['zefEnd'],
				'FKzefPrjID'=>$firstVal['FKzefPrjID'],
				'FKzefPrjName'=>$this->_Base->getCachedPrjName($firstVal['FKzefPrjID']),
				'FKzefCatID'=>$firstVal['FKzefCatID'],
				'FKzefCatName'=>$this->_Base->getCachedCatName($firstVal['FKzefCatID']),
				'FKCalResID'=>$firstVal['FKCalResID'],
			);
			if ($this->_Base->getCfg('cfg/modul/company')) {
				$data[$zefID]['FKcompID']=$firstVal['FKcompID'];
				if ($firstVal['FKcompID']==-1) {
					$data[$zefID]['FKcompName']=$this->_T->lang('[[FIRMENUEBERGREIFEND]]');
				} elseif ($firstVal['FKcompID']) {
					$data[$zefID]['FKcompName']=$this->_Base->getCachedCompanyName($firstVal['FKcompID']);
				} else {
					$data[$zefID]['FKcompName']='';
				}
			}
			foreach ($costEntries as $costID=>$Values) {
				$data[$zefID]['costEntries'][$costID]=array(
					'FKcostID'=>$Values['FKcostID'],
					'FKcostTabID'=>$Values['FKcostTabID'],
					'costName'=>$Values['Name'],
					'costDesc'=>$Values['costDesc'],
					'costCalc'=>$Values['costCalc'],
					'costValue'=>0,
					'costUnit'=>'',
				);
				if (!isset($dataSum[$Values['FKcostID']])) {
					$dataSum[$Values['FKcostID']]=array(
						'costName'=>$Values['Name'],
						'costCalc'=>0,
					);
				}
				$dataSum[$Values['FKcostID']]['costCalc']+=$Values['costCalc'];
				if ($Values['FKcostTabID']) {
					if (!isset($tabObj[$Values['FKcostTabID']])) {
						$tabObj[$Values['FKcostTabID']]=$this->_Base->readExpensesTable($Values['FKcostTabID']);
					}
					if ($tabObj[$Values['FKcostTabID']]['tabTyp']==2) {
						if (!isset($tabEntry[$Values['FKcostEntryID']])) {
							$tabEntry[$Values['FKcostEntryID']]=$this->_Base->readExpensesEntry($Values['FKcostEntryID']);
						}
						$data[$zefID]['costEntries'][$costID]['costUnit']=$tabEntry[$Values['FKcostEntryID']]['Unit'];
					} else {
						$data[$zefID]['costEntries'][$costID]['costUnit']=$tabObj[$Values['FKcostTabID']]['tabUnit'];
					}
					$data[$zefID]['costEntries'][$costID]['costValue']=$Values['costValue'];
				}
			}
		}
		if ($print) {
			require_once('lib/zef/class_ZefPrintGui.php');
			$printGui=new ZefPrintGui();
			switch($this->_search['DateMode']) {
				case 1;
					$dateTitle=strftime('%B %Y',$this->_search['DateB']);
				break;
				case 6;
					$dateTitle=$this->_T->Lang('[[KW]]').strftime(' %W / %Y',$this->_search['DateB']);
				break;
				case 3;
					$dateTitle=date('d.m.Y',$this->_search['DateB']).'-'.date('d.m.Y',$this->_search['DateE']);
				break;
			}
			$printConfig=array(
				'FKUserID'=>$this->_search['FKUserID'],
				'DateMode'=>$this->_search['DateMode'],
				'DateStart'=>$this->_search['DateB'],
				'DateEnd'=>$this->_search['DateE'],
				'DateTitle'=>$dateTitle,
				'Description'=>$this->_search['printDesc'],
				'Currency'=>$this->_Base->getCfg('cfg/currency'),
			);
			//debug($printConfig);
			$printGui->printExpenses($data,$dataSum,$this->_search['printTpl'],$printConfig);
		}
		
		if (empty($data)) {
			$tabGui->addRow(0,'top');
			$tabGui->addCol('Date','','','','',1);
		} else {
			$sumCost=0;
			foreach ($data as $zefID=>$costEntries) {
				$tabGui->addRow(2,'top');
				$catNames=array();
				if ($costEntries['FKcompName']) {
					$catNames[]=$costEntries['FKcompName'];
				}
				$catNames[]=$costEntries['FKzefPrjName'];
				$catNames[]=$costEntries['FKzefCatName'];
				$tabGui->addCol('Date',Framework::dateSql('d.m.Y',$costEntries['zefBegin']),'','','',1);
				$tabGui->addCol('CatName',implode(" -> ",$catNames),'','','',0,0,3);

				foreach ($costEntries['costEntries'] as $costID=>$Values) {
					$tabGui->addRow($hl=$hl?0:1,'top');
					$costName=array();
					$costName[]=$Values['costName'];
					Framework::convertLineEndings($Values['costDesc'],'');
					$costName[]=$Values['costDesc'];
					if ($Values['costValue'] && $Values['costUnit']) {
						$costVal=Framework::numberFormat($Values['costValue']).' '.$Values['costUnit'];
					} else {
						$costVal='';
					}
					$tabGui->addCol('Date','');
					$tabGui->addCol('CostName',implode("\n",$costName),'','','',0,2000);
					$tabGui->addCol('Val',$costVal,'','','right',1);
					$tabGui->addCol('Calc',Framework::numberFormat($Values['costCalc']).' '.$this->_Base->getCfg('cfg/currency'),'','','right',1);
					$sumCost+=$Values['costCalc'];
				}
			}
		
			if ($hl==1) $hl=3;
			if ($hl==0) $hl=2;
			$tabGui->addRow(2,'',$print?'#cccccc':APP_FG10COLOR);
			$tabGui->addCol('Title',$this->_T->lang('[[Totale]]'),'','','center',1,'',4);
			foreach ($dataSum as $key=>$val) {
				$tabGui->addRow($hl==3?$hl=2:$hl=3);
				$tabGui->addCol('Title',$val['costName'].':','','','right',1,'',3);
				$tabGui->addCol('Cost',Framework::numberFormat($val['costCalc'],2).' '.$this->_Base->getCfg('cfg/currency'),'','','right',1,'');
			}
			$tabGui->addRow($hl==3?$hl=2:$hl=3,'');
			$tabGui->addCol('Title',$this->_T->lang('[[Totale]]').':','','','right',1,'',3);
			$tabGui->addCol('Cost',Framework::numberFormat($sumCost,2).' '.$this->_Base->getCfg('cfg/currency'),'','','right',1,'');

		}
		return $tabGui;
	}
	function printExpensesGui() {
		$this->getExpensesGui(true);

		/*
		require_once('lib/class_FastTemplateGui.php');
		$Gui=new FastTemplateGui('zef/print_expenses.inc.html');
		$Gui->assign('ZEF_USER',$this->_frm->getCachedUsername($this->_search['FKUserID']));
		$Gui->assign('DATE_VAL',date('d.m.Y',$this->_search['DateB']).' - '.date('d.m.Y',$this->_search['DateE']));
		$Gui->assign('PRINT_DESC',Framework::entities($this->_search['PrintDesc']));
		$contGui=$this->getExpensesGui(true);
		$Gui->assign('CONTENT',array($contGui,'process'));

		
		$PrintID=$this->_frm->insertPrint('zef','html',$Gui->process());
		page_close();
		header("Location:print.php?PrintID=$PrintID");
		exit;*/
	}

}
?>