<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

$t->assign('MOD_TITLE',$frm->getAppName('lmng'));
if (!$app["lmng"]) {
	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
} else {

	$user_id=$auth->auth['uid'];
	require_once('lib/lmng/header.php');

	$t->setRoot("tpl/$THEME/lmng/$session_lang");
	$t->define (array('application' => "header.inc.html"));
	unset($obj);
	unset($ActionError);
	$root_id=0;

	if ($Lmng->getPerms(1) || $Lmng->getPerms(2)) {
		$root_obj_d=$Lmng->getSystemObj('d',$session_lang,0,true);
		if (is_object($root_obj_d)) {
			$root_obj[$root_obj_d->getID()]=$root_obj_d;
			unset($root_obj_d);
		}
		if ($Lmng->getPerms(1)) {
			$root_obj_u=$Lmng->getSystemObj('u',$session_lang,$user_id,true);
			if (is_object($root_obj_u)) {
				$root_obj[$root_obj_u->getID()]=$root_obj_u;
				unset($root_obj_u);
			} else {
				$root_obj_u=$Lmng->getSystemObj('u',$CFG['AV_LANG'],0,false);
				if (is_object($root_obj_u)) {
					$Lmng->insertMeta($root_obj_u);
					$root_obj_u->setMeta('UserID',$user_id);
					$root_obj_u->setMeta('RootID',$root_obj_u->getID());
					$Lmng->updateMeta($root_obj_u);
					$root_obj[$root_obj_u->getID()]=$root_obj_u;
					unset($root_obj_u);
				}
			}
		}
		if ($Lmng->getPerms(2)) {
			$root_obj_s=$Lmng->getSystemObj('s',$session_lang,0,true);
			if (is_object($root_obj_s)) {
				$root_obj[$root_obj_s->getID()]=$root_obj_s;
				unset($root_obj_s);
			}
		}
		$trash_obj=$Lmng->getSystemObj('t',$session_lang,0,true);
		if (is_object($trash_obj)) {
			$root_obj[$trash_obj->getID()]=$trash_obj;
		}

		if ($oid) {
			$obj=$Lmng->getObj($oid,$CFG['MA_LANG']);
			if (is_object($obj)) {
				$root_id=$obj->getMeta('RootID');
			}
		}

		if (!$root_id || !isset($root_obj[$root_id])) {
			$oid=$root_id=key($root_obj);
			$obj=$Lmng->getObj($oid,$CFG['MA_LANG']);
		}
		$rootObj=$root_obj[$root_id];
	} else {
		unset($rootObj);
	}
	if (!is_object($rootObj) || !is_object($obj) || !$obj->getAcl(1)) {
		$t->assign('TPL_ERROR','');
		$t->define (array('tpl_card' => "no_perms.inc.html"));
		$t->parse('TPL_CARD','tpl_card');
	} else {
		//if (!$mode) $mode='fav';
		if ($action=='s') $mode='all';
		$Lmng->setMode($mode);
		$Lmng->setRootObj($rootObj);
		if ($pre["global"]['js']) $t->parse("ROW","conf_delete");

		if (!$action) $action=$obj->getAction(0);
		$L_THIS="index.php?site=$site&action=$action&oid=$oid";
		$Lmng->setClipboard('lobj',$frm->getClipboard('lobj'));
		$obj_tree=$Lmng->getObjTree($oid);
		if (($meta_save_x) && $obj->getAcl(2)) {
			if ($new) {
				require ('lib/lmng/inc_NewObject.php');
			} else {
				require ('lib/lmng/inc_UpdateObject.php');
			}
		}
		if ($obj_action_x && $obj_action_val) {
			require ('lib/lmng/func_Action.php');
			require ('lib/lmng/inc_ActionObject.php');
		}
		if ($list_action_x && $list_action_val) {
			require ('lib/lmng/func_Action.php');
			require ('lib/lmng/inc_ActionList.php');
		}
		if ($open_x && $obj->getMeta('DocType')=='link') {
			require ('lib/lmng/inc_OpenLink.php');
		}
		$tmp_tree='';
		if (is_array($obj_tree)) {
			foreach ($obj_tree as $key=>$val) {
				$tmp_tree="<a href=\"index.php?site=$site&oid=$key\">".FrameWork::entities($val).'</a>/'.$tmp_tree;
			}
		}
		$t->assign('OBJ_TREE',$tmp_tree);
		$t->assign('OBJ_NAME',FrameWork::entities($obj->getName()));
		foreach ($root_obj as $val) {
			$t->assign('M_IMG',$val->getImage(0));
			$t->assign('M_NAME',FrameWork::entities($val->getName()));
			$t->assign('M_URL',"index.php?site=$site&oid=".$val->getID());
			if ($action!='import' && $root_id==$val->getID()) {
				$t->assign('M_ON','on');
			} else {
				$t->assign('M_ON','off');
			}
			$t->parse('ROW','.root_header');
		}
		$t->assign('L_A_NAVBAR',"index.php?site=$site&action=b&mode=all");
		$nav_array=array_merge(range('A', 'Z'),range('0', '9'));
		foreach ($nav_array as $val) {
			$t->assign('L_NAVBAR',"index.php?site=$site&action=b&mode=all&sort=$val");
			if ($mode=='all' && $sort==$val) {
				$t->assign('N_NAVBAR','<strong>'.$val.'</strong>');
			} else {
				$t->assign('N_NAVBAR',$val);
			}
			$t->parse('ROW','.navbar_row');
		}
		$t->parse('ROW','navbar');

		$t->assign('CFG_ON','off');
		if ($action=='import') {
			$t->assign('IMP_ON','on');
		} else {
			$t->assign('IMP_ON','off');
		}
		$t->assign('IMP_URL',"index.php?site=$site&action=import&oid=".$obj->getID());
		$t->parse('ROW','import_header');

		if ($action=="import") {
			$t->define (array('tpl_card' => "import.inc.html"));
			require("lib/class_form.inc.php");
			//require("lmng/browse_list_js.php");
			require("lmng/import.php");
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=="b") {
			require("lib/class_form.inc.php");
			require("lmng/browse_list_js.php");
			if (!$mode && $rootObj->getMeta('System')=='d') {
				$t->define (array('tpl_card' => "browse_overview.inc.html"));
				require("lmng/browse_overview.php");
			} else {
				$t->define (array('tpl_card' => "browse_content.inc.html"));
				require("lmng/browse_content.php");
			}
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=="bt") {
			$t->define (array('tpl_card' => "browse_content.inc.html"));
			require("lib/class_form.inc.php");
			require("lmng/browse_list_js.php");
			require("lmng/browse_content.php");
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=="vo") {
			$t->define (array('tpl_card' => "view_content.inc.html"));
			require("lib/class_form.inc.php");
			require("lmng/browse_list_js.php");
			require("lmng/view_content.php");
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=="p") {
			$t->define (array('tpl_card' => "perms_content.inc.html"));
			require("lib/class_form.inc.php");
			require("lmng/browse_list_js.php");
			require("lmng/perms_content.php");
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=='convert' && $Lmng->isSuperAdmin()) {
			require("lmng/convert.php");
			$t->assign('TPL_CARD','');
		} elseif ($action=="s") {
			$t->define (array('tpl_card' => "search.inc.html"));
			require("lib/class_form.inc.php");
			require("lmng/search.php");
			$t->parse('TPL_CARD','tpl_card');
		} else {
			$t->define (array('tpl_card' => "no_perms.inc.html"));
			$t->parse('TPL_CARD','tpl_card');
		}

		$t->assign('T_S_ACTION',"index.php?site=$site&action=s");

		if ($ActionError) {
			require('lmng/view_error.php');
		}

	}
}
?>
