<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
if ($pre["global"]['lay']) $t->define (array('tpl_layer' => "layers.inc.html"));
$img_parent= "tree_expand.gif";
if (!$obj || !$obj->getAcl(1)) {
	header("Location:index.php?site=$site");
	exit;
}
$ID=$obj->getID();
$list_apps=array('link');
$order='';
$l_this="index.php?site=$site&action=$action&mode=$mode&sort=$sort&oid=$oid&edit=$edit&new=$new";
$form_action=$l_this."&o=$o&a=$a";
$t->assign('FORM_ACTION',$form_action."&b=$b");
$t->assign('L_THIS',$form_action."&b=$b");
$use_limit=false;
if ($rootObj->getMeta('System')=='d') {
	if ($parse) $t->parse('ROW','obj_action');
	$search_sql="RootID IN (".implode(',',$db->escape(array_keys($root_obj))).")";
	switch ($mode) {
		case 'fav':
			$search_sql.=" AND Trash=0 AND DocType='link' AND Favorite=1 AND FKUserID=".$db->escape($user_id);
			$limit=0;
		break;
		case 'used':
			$search_sql.=" AND Trash=0 AND DocType='link' AND Counter!=0 AND FKUserID=".$db->escape($user_id);
			$order="Counter DESC";
			$limit=20;
		break;
		case 'last':
			$search_sql.=" AND Trash=0 AND DocType='link' AND TimeLast!=0  AND FKUserID=".$db->escape($user_id);
			$order="TimeLast DESC";
			$limit=20;
		break;
		case 'new':
			$search_sql.=" AND Trash=0 AND DocType='link'";
			$order="TimeCreate DESC";
			$limit=20;
		break;
		case 'all':
			$t->assign('LINK_SORT',$sort);
			$search_sql.=" AND Trash=0 AND DocType='link' AND Title_".$session_lang." LIKE '".addslashes($sort)."%'";
			$limit=20;
			$use_limit=true;
		break;
	}
	$t->parse('ROW','title_'.$mode);

	$list_action=$frm->getObjAction($Lmng->getModul(),'m_'.$mode);
	foreach ($list_action as $key=>$val) {
		if (!$val['Hidden'] && $Lmng->isAllowedAction($obj,$val)) {
			$t->assign('SEL_VAL',$key);
			$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
			$t->parse('ROW','.list_action_val');
		}
	}
	$edit=0;$new=0;
} else {
	if ($new) {
		$t->parse('ROW','title_cat_new');
		$new_obj=new LObj_fol();
		$new_obj->setMeta('DocType','fol');
		$new_obj->setMeta('ParentID',$obj->getID());
		$new_obj->setMeta('RootID',$obj->getMeta('RootID'));
		$new_obj->setAcl(-1);
		$edit=1;
	} else {
		$new_obj=$obj;
		if ($edit) {
			$t->parse('ROW','title_cat_edit');
		} else {
			$t->parse('ROW','title_cat');
		}
	}
	$meta_action=$frm->getObjAction($Lmng->getModul(),'e_'.$new_obj->getActionMode(0));
	$p_update=false;
	if ($edit && $Lmng->isAllowedAction($new_obj,$meta_action['e|title'])) {
		$tmp_name=$new_obj->getMeta('Title_'.$session_lang);
		$ObjLang=1;
		if ($Lmng->isAllowedAction($new_obj,$meta_action['e|title_lang'])) {
			$lang_array=$CFG['MA_LANG'];
		} else {
			$lang_array=array($session_lang);
		}
		foreach ($lang_array as $val) {
			$txt_title=new TextField("ObjTitle_$val",'size="30" class="sel" style="width:300px"','0','%',$new_obj->getMeta('Title_'.$val));
			if ($val==$session_lang) {
				$t->assign('OBJ_TITLE',$txt_title->f());
				$t->assign('OBJ_TITLE_LANG',strtoupper($val));
				if ($ActionError['fields']["ObjTitle_$val"]) {
					$t->assign('C_TITLE','error');
				} else {
					$t->assign('C_TITLE','');
				}
				$t->assign('FOCUS_FIELD',"ObjTitle_$val");
			} else {
				if (isset($_POST["ObjTitle_$val"]) && $_POST["ObjTitle_$val"]!=$tmp_name) $ObjLang=0;
				if ($new_obj->getMeta('Title_'.$val)!=$tmp_name) $ObjLang=0;
				$t->assign('OBJ_TITLE_A',$txt_title->f());
				$t->assign('OBJ_TITLE_LANG_A',strtoupper($val));
				if ($ActionError['fields']["ObjTitle_$val"]) {
					$t->assign('C_TITLE_A','error');
				} else {
					$t->assign('C_TITLE_A','');
				}
				$t->parse('ROW','.obj_lang');
			}
		}
		if (count($lang_array)>1) {
			$chk_lang=new CheckBox('ObjLang','',1);
			$t->assign('CHK_OBJ_LANG',$chk_lang->f());
			$t->parse('ROW','obj_lang_one');
		}
		$p_update=true;
	} else {
		$t->assign('OBJ_TITLE','<div class="disable" style="width:300px">'.FrameWork::entities($new_obj->getName($session_lang)).'&nbsp;</div>');
		$t->assign('OBJ_TITLE_LANG',strtoupper($session_lang));
	}
	/*
	if ($Fmng->isAllowedAction($obj,$meta_action['e|text'])) {
		$txt_desc=new TextArea('ObjText','rows="7" cols="36" class="sel" style="width:300px;"','0','%',$obj->getMeta('Text'));
		$t->assign('OBJ_DESC',$txt_desc->f());
		$p_update=true;
	} else {
		$t->assign('OBJ_DESC','<div class="disable" style="width:300px;min-height:70px">'.FrameWork::entities($obj->getMeta('Desc')).'</div>');
	}*/

	if ($new_obj->getMeta('TimeModify')) {
		$t->assign('OBJ_TIME_MODIFY',date('d.m.Y H:i',$new_obj->getMeta('TimeModify')));
	} else {
		$t->assign('OBJ_TIME_MODIFY','-');
	}

	if ($new_obj->getMeta('UserModify')) {
		if (!isset($all_user[$new_obj->getMeta('UserModify')])) {
			$temp=$frm->getFullName($new_obj->getMeta('UserModify'),1,1);
			$all_user[$new_obj->getMeta('UserModify')]=$temp[$new_obj->getMeta('UserModify')];
		}
		$t->assign('OBJ_USER_MODIFY',FrameWork::entities($all_user[$new_obj->getMeta('UserModify')]));
	} else {
		$t->assign('OBJ_USER_MODIFY','-');
	}
	$t->parse('ROW','last_modify');
	if ($edit || $new) {
		$t->assign('L_BREAK',"index.php?site=$site&action=$action&o=$o&a=$a&b=$b&oid=".$obj->getID());
		$t->parse('ROW','break');
	}

	if ($p_update) {
		$t->parse('ROW','update');
	}

	$parse=false;
	if (!$new && !$edit) {
		$obj_action=$frm->getObjAction($Lmng->getModul(),$obj->getActionMode(0));
		foreach ($obj_action as $key=>$val) {
			if (!$val['Hidden'] && $Lmng->isAllowedAction($obj,$val)) {
				$t->assign('SEL_VAL',$key);
				$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
				$t->parse('ROW','.obj_action_val');
				$parse=true;
			}
		}
		if ($parse) $t->parse('ROW','obj_action');
	}
	if (!$new) $t->parse('ROW','public_box');

	$list_action=$frm->getObjAction($Lmng->getModul(),$obj->getActionMode(1));
	foreach ($list_action as $key=>$val) {
		if (!$val['Hidden'] && $Lmng->isAllowedAction($obj,$val)) {
			$t->assign('SEL_VAL',$key);
			$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
			$t->parse('ROW','.list_action_val');
		}
	}

	if (is_array($ActionError['fields'])) {
		$t->assign('FOCUS_FIELD',key($ActionError['fields']));
	}

	$search_sql="DocType='link' AND ParentID=".$db->escape($obj->getID());
	$limit=0;
	if ($edit || $new) $t->parse('ROW','meta_object');
	$t->parse('ROW','edit_object');
}
if (!$edit) {

	if (!$o) {
		$o='Title';
		$a='asc';
	}
	if ($o=='UserCreate') {
		$Fo='UserCreate';
		if ($a=='asc') {
			$Fa='asc';
			$t->assign('USERCREATE_IMG','ar_down.gif');
			$na='desc';
		} else {
			$Fa='desc';
			$t->assign('USERCREATE_IMG','ar_up.gif');
			$na='asc';
		}
	} else {
		$t->assign('USERCREATE_IMG','tras.gif');
		$na='asc';
	}
	$t->assign("L_USERCREATE","$l_this&o=UserCreate&a=$na");

	if ($o=='Title') {
		$Fo='Title_'.$session_lang;
		if ($a=='asc') {
			$Fa='asc';
			$t->assign('NAME_IMG','ar_down.gif');
			$na='desc';
		} else {
			$Fa='desc';
			$t->assign('NAME_IMG','ar_up.gif');
			$na='asc';
		}
	} else {
		$t->assign('NAME_IMG','tras.gif');
		$na='asc';
	}
	$t->assign("L_NAME","$l_this&o=Title&a=$na");

	if ($o=='TimeCreate') {
		$Fo='TimeCreate';
		if ($a=='asc') {
			$Fa='asc';
			$t->assign('TIMECREATE_IMG','ar_down.gif');
			$na='desc';
		} else {
			$Fa='desc';
			$t->assign('TIMECREATE_IMG','ar_up.gif');
			$na='asc';
		}
	} else {
		$t->assign('TIMECREATE_IMG','tras.gif');
		$na='desc';
	}
	$t->assign("L_TIMECREATE","$l_this&o=TimeCreate&a=$na");

	if ($o=='TimeLast') {
		$Fo='TimeLast';
		if ($a=='asc') {
			$Fa='asc';
			$t->assign('TIMELAST_IMG','ar_down.gif');
			$na='desc';
		} else {
			$Fa='desc';
			$t->assign('TIMELAST_IMG','ar_up.gif');
			$na='asc';
		}
	} else {
			$t->assign('TIMELAST_IMG','tras.gif');
			$na='asc';
	}
	$t->assign("L_TIMELAST","$l_this&o=TimeLast&a=$na");

	if ($o=='Counter') {
		$Fo='Counter';
		if ($a=='asc') {
			$Fa='asc';
			$t->assign('COUNTER_IMG','ar_down.gif');
			$na='desc';
		} else {
			$Fa='desc';
			$t->assign('COUNTER_IMG','ar_up.gif');
			$na='asc';
		}
	} else {
			$t->assign('COUNTER_IMG','tras.gif');
			$na='asc';
	}
	$t->assign("L_COUNTER","$l_this&o=Counter&a=$na");

	if (!$Fo) {
		$Fo='Title_'.$session_lang;
	}
	if (!$Fa) {
		$Fa='asc';
	}
	if ($order) {
		$order.=','.$Fo.' '.$Fa;
	} else {
		$order=$Fo.' '.$Fa;
	}



	$rows=0;
	$ftree=$Lmng->searchObj($rows,$b,$limit,$search_sql,$order,$use_limit);
	$num_entrys=count($ftree);
	if ($rows) {
		$j=$i=1;
		$chk_list=new CheckBox("ListID",'id="ListID"',"","",1);
		if (is_array($ListID) && count($ListID) == $num_entrys) {
			$sel_all=true;
		}
		if ($sel_all) {
			$ListID=array_keys($ftree);
			$t->assign('DISPLAY_ALL','none');
			$t->assign('DISPLAY_NONE','normal');
		} else {
			if ($sel_none) {
				$ListID=array();
			}
			$t->assign('DISPLAY_ALL','normal');
			$t->assign('DISPLAY_NONE','none');
		}
		$ac_link="index.php?site=$site";
		$i=1;
		foreach ($ftree as $key=>$val) {
			$lid=$val->getID();
			$link=$ac_link."&action=".$val->getAction(0)."&oid=".$lid;
			if ($val->getACL(2)) {
				$link_d=$ac_link."&action=".$val->getAction(1)."&oid=".$lid;
			} else {
				$link_d="#";
			}
			$t->assign("LIST_CHK",$chk_list->f($lid));
			$t->assign('LIST_OBJ_ID',$lid);
			$t->assign("LIST_IMG",$val->getImage(0));
			$t->assign("L_LIST_IMG",$link_d);
			$t->assign("L_LIST_ITEM",$link);
			$t->assign("LIST_ITEM",FrameWork::entities($val->getName($session_lang)));
			$t->assign("LIST_ITEM_LINK",FrameWork::entities($val->getMeta('Link')));

			if (!isset($all_user[$val->getMeta('UserCreate')])) {
				$temp=$frm->getFullName($val->getMeta('UserCreate'),1,1);
				$all_user[$val->getMeta('UserCreate')]=$temp[$val->getMeta('UserCreate')];
			}
			$t->assign('LIST_USER_CREATE',FrameWork::entities($all_user[$val->getMeta('UserCreate')]));

			if ($val->getMeta('TimeCreate')) {
				$t->assign('LIST_TIME_CREATE',date('d.m.Y',$val->getMeta('TimeCreate')));
			} else {
				$t->assign('LIST_TIME_CREATE','-');
			}
			if ($val->getParentMeta('TimeLast')) {
				$t->assign('LIST_TIME_USED',date('d.m.Y',$val->getParentMeta('TimeLast')));
			} else {
				$t->assign('LIST_TIME_USED','-');
			}
			$t->assign('LIST_COUNT',intval($val->getParentMeta('Counter')));
			if ($i%2) $t->assign("ROW_COLOR",$bgcolor); else  $t->assign("ROW_COLOR","#f2f2f2");

			if ($pre["global"]['lay']) {
				$div_row=0;
				if ($val->getMeta('Text')) {
					$t->assign("DIV_DESC",Framework::entities($val->getMeta('Text')));
					$t->parse("ROW","div_desc");
					$div_row=1;
				} else {
					$t->clear_dynamic('div_desc');
				}
				if ($div_row) {
					$t->assign('LAY_LINK'," onMouseOver=\"show(event, 'lk_$key'); return true;\" onMouseOut=\"hide('lk_$key'); return true;\"");
					$t->assign("DIV_ID","lk_$key");
					$t->parse("ROW",".div_row");
				} else {
					$t->assign('LAY_LINK','');
				}
			} else {
				$t->assign('LAY_LINK','');
			}

			$t->parse('ROW','.file_row');

			$i++;
		}


	} else {
		$t->assign('DISPLAY_ALL','normal');
		$t->assign('DISPLAY_NONE','none');

	}

	if ($use_limit && $limit && $rows>$limit) {
		$s_limit=10;
		$s_begin=1;
		$s_sites=ceil($rows/$limit);
		$a_site=($b/$limit);
		if ($a_site>=$s_limit) {
			$s_begin=floor($a_site/$s_limit)*$s_limit+1;
			$n_b=($s_begin-2)*$limit;
			$l_sites.="<a href=\"$form_action&b=$n_b\">&lt;&lt;</a> ";
		}
		if (($s_begin+$s_limit)>$s_sites) {
			$len_sites=$s_sites-$s_begin+1;
		} else {
			$len_sites=$s_limit;
		}
		for ($i=$s_begin;$i<($s_begin+$len_sites);$i++) {
			$n_b=($i - 1)*$limit;
			if ($n_b==$b) { $temp_b='<b>'; $temp_e='</b>'; } else{ $temp_b=''; $temp_e=''; }
			$l_sites.="[<a href=\"$form_action&b=$n_b\">".$temp_b.$i.$temp_e."</a>]";
		}
		if ($s_sites>$i) {
			$n_b=($i-1)*$limit;
			$l_sites.=" <a href=\"$form_action&b=$n_b\">&gt;&gt;</a>";
			$t->parse("ROW","more");
		}
		$t->assign("S_SITES",$l_sites);
		$t->assign("S_NUM",($b+1)." - ".($b+$num_entrys));
		$t->assign("S_ALL",$rows);
		$t->parse("ROW","search_next");
	} else {
		$t->assign("S_ALL",$num_entrys);
		$t->parse("ROW","search_one");
	}
	$t->parse("ROW","list_content");
}
if ($pre['global']['lay']) $t->parse("TPL_LAYERS","tpl_layer"); else
$t->assign("TPL_LAYERS","");

?>
