<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$img_parent= "tree_expand.gif";
if (!$obj || !$obj->getAcl(1)) {
	header("Location:index.php?site=$site");
	exit;
}
$t->define (array('tpl_table' => "browse_lmng_table.inc.html"));
if ($pre["global"]['lay']) $t->define (array('tpl_layer' => "layers.inc.html"));

$ID=$obj->getID();


$l_this="index.php?site=$site&action=$action&oid=$oid";
$t->assign('FORM_ACTION',$l_this);
$t->assign('L_THIS',$l_this);


$av_modes=array('fav','used','last','new');
foreach ($av_modes as $mode) {
	$order='';
	$use_limit=false;
	$search_sql="RootID IN (".implode(',',$db->escape(array_keys($root_obj))).")";
	switch ($mode) {
		case 'fav':
			$search_sql.=" AND Trash=0 AND DocType='link' AND Favorite=1 AND FKUserID=".$db->escape($user_id);
			$limit=0;
		break;
		case 'used':
			$search_sql.=" AND Trash=0 AND DocType='link' AND Counter!=0 AND FKUserID=".$db->escape($user_id);
			$order="Counter DESC";
			$limit=5;
		break;
		case 'last':
			$search_sql.=" AND Trash=0 AND DocType='link' AND TimeLast!=0  AND FKUserID=".$db->escape($user_id);
			$order="TimeLast DESC";
			$limit=5;
		break;
		case 'new':
			$search_sql.=" AND Trash=0 AND DocType='link'";
			$order="TimeCreate DESC";
			$limit=5;
		break;
	}


	if ($order) {
		$order.=','.'Title_'.$session_lang.' ASC';;
	} else {
		$order='Title_'.$session_lang.' ASC';
	}

	$rows=0;$b=0;
	$ftree=$Lmng->searchObj($rows,$b,$limit,$search_sql,$order,$use_limit);
	$num_entrys=count($ftree);
	if ($num_entrys) {
		$j=$i=1;
		$ac_link="index.php?site=$site";
		foreach ($ftree as $key=>$val) {
			$lid=$val->getID();
			$link=$ac_link."&action=".$val->getAction(0)."&oid=".$lid;
			if ($val->getACL(2)) {
				$link_d=$ac_link."&action=".$val->getAction(1)."&oid=".$lid;
			} else {
				$link_d="#";
			}
			$t->assign('LIST_OBJ_ID',$mode.$lid);
			$t->assign("LIST_IMG",$val->getImage(0));
			$t->assign("L_LIST_IMG",$link_d);
			$t->assign("L_LIST_ITEM",$link);
			$t->assign("LIST_ITEM",FrameWork::entities($val->getName($session_lang)));
			$t->assign("LIST_ITEM_LINK",FrameWork::entities($val->getMeta('Link')));

			if (!isset($all_user[$val->getMeta('UserCreate')])) {
				$temp=$frm->getFullName($val->getMeta('UserCreate'),1,1);
				$all_user[$val->getMeta('UserCreate')]=$temp[$val->getMeta('UserCreate')];
			}
			$t->assign('LIST_USER_CREATE',FrameWork::entities($all_user[$val->getMeta('UserCreate')]));

			if ($val->getMeta('TimeCreate')) {
				$t->assign('LIST_TIME_CREATE',date('d.m.Y',$val->getMeta('TimeCreate')));
			} else {
				$t->assign('LIST_TIME_CREATE','-');
			}
			if ($val->getParentMeta('TimeLast')) {
				$t->assign('LIST_TIME_USED',date('d.m.Y',$val->getParentMeta('TimeLast')));
			} else {
				$t->assign('LIST_TIME_USED','-');
			}
			$t->assign('LIST_COUNT',intval($val->getParentMeta('Counter')));
			if ($i%2) $t->assign("ROW_COLOR",$bgcolor); else  $t->assign("ROW_COLOR","#f2f2f2");

			if ($pre["global"]['lay']) {
				$div_row=0;
				if ($val->getMeta('Text')) {
					$t->assign("DIV_DESC",Framework::entities($val->getMeta('Text')));
					$t->parse("ROW","div_desc");
					$div_row=1;
				} else {
					$t->clear_dynamic('div_desc');
				}
				if ($div_row) {
					$t->assign('LAY_LINK'," onMouseOver=\"show(event, 'lk_$key'); return true;\" onMouseOut=\"hide('lk_$key'); return true;\"");
					$t->assign("DIV_ID","lk_$key");
					$t->parse("ROW",".div_row");
				} else {
					$t->assign('LAY_LINK','');
				}
			} else {
				$t->assign('LAY_LINK','');
			}

			$t->parse('ROW','.file_row');

			$i++;
		}

		$t->parse('ROW','title_'.$mode);
		$t->parse('TPL_TABLE','tpl_table');
		$t->parse('ROW','.table_row');
		$t->clear_dynamic('title_'.$mode);
		$t->clear_dynamic('folder_row');
		$t->clear_dynamic('file_row');
		$t->unsetkey('tpl_table');
	} else {


	}



}

if ($pre['global']['lay']) $t->parse("TPL_LAYERS","tpl_layer"); else
$t->assign("TPL_LAYERS","");

?>
