<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->assign('FORM_ACTION',"index.php?site=$site&action=$action");

$txt_info=new TextField('info','size=25 class=sel style="width:230px"');
$t->assign('TXT_INFO',$txt_info->f());
$t->assign('FOCUS_FIELD','info');

$chk_only_words=new CheckBox("only_words",'class=sel',1);
$t->assign('CHK_ONLY_WORDS',$chk_only_words->f(1));
$chk_use_case=new CheckBox("use_case",'class=sel',1);
$t->assign('CHK_USE_CASE',$chk_use_case->f(1));


$rd_date_typ=new RadioButton('date_typ','','0');
$t->assign('RD_DATE_TYPE0',$rd_date_typ->f('0'));
$t->assign('RD_DATE_TYPE1',$rd_date_typ->f('TimeModify'));
$t->assign('RD_DATE_TYPE2',$rd_date_typ->f('TimeCreate'));
$txt_date_begin=new TextField('date_begin','size=10 class=sel onClick="checkRadio(document.daten.date_typ);"','','','--/--/----');
$txt_date_end=new TextField('date_end','size=10 class=sel onClick="checkRadio(document.daten.date_typ);"','','',date('d/m/Y'));

$link="js_cal.php?date=".time()."";
$t->assign('JS_CAL1',"NewWindow('$link&field=date_begin','Calendar',".$CFG['calwidth'].','.$CFG['calheight'].",0);");
$t->assign('JS_CAL2',"NewWindow('$link&field=date_end','Calendar',".$CFG['calwidth'].','.$CFG['calheight'].",0);");

$t->assign('TXT_DATE_BEGIN',$txt_date_begin->f());
$t->assign('TXT_DATE_END',$txt_date_end->f());

$rd_user_typ=new RadioButton('user_type','','0');
$t->assign('RD_USER_TYPE0',$rd_user_typ->f('0'));
$t->assign('RD_USER_TYPE1',$rd_user_typ->f('UserModify'));
$t->assign('RD_USER_TYPE2',$rd_user_typ->f('UserCreate'));

$users_array=array(0=>'-') + $frm->getFullName();
$sel_user=new SelectField('s_user','class=sel onClick="checkRadio(document.daten.user_type);"',$users_array);
$t->assign('SEL_USER',$sel_user->f());

$obj_type_array[0]='-';
$sel_obj_type=new SelectField('obj_type','class=sel',$obj_type_array);
$t->assign('SEL_OBJ_TYPE',$sel_obj_type->f());

$sel_limit=new SelectField('limit','class=sel',array(50=>50,20=>20,10=>10),20);
$t->assign('SEL_LIMIT',$sel_limit->f());
$date=time();

$qlink='';
$sql_search=array();
$sql_search[]="RootID IN (".implode(',',array_keys($root_obj)).")";
$sql_search[]="Trash=0";
if ($info) {
	$qlink.='&info='.urlencode($info);
	$qlink.='&use_case='.urlencode($use_case);
	$qlink.='&only_words='.urlencode($only_words);
	$fields=array('Link','Text');
	foreach ($CFG['MA_LANG'] as $val) {
		$fields[]="Title_$val";
	}
	$sql_search[]=$db->formatSearch($info,$fields,$use_case,$only_words);
}
if ($date_typ) {
	$qlink.='&date_typ='.urlencode($date_typ);
	if ($b_date=$frm->parseDate($date_begin,0,0,0)) {
		$date_begin=date('d/m/Y',$b_date);
		$qlink.="&date_begin=".urlencode($date_begin);
		$sql_search[]="( ".addslashes($date_typ).">".intval($b_date)." )";
	}
	if ($e_date=$frm->parseDate($date_end,23,59,59)) {
		$date_end=date('d/m/Y',$e_date);
		$qlink.="&date_end=".urlencode($date_end);
		$sql_search[]="( ".addslashes($date_typ)."<".intval($e_date)." )";
	}
}
if ($user_type && $s_user) {
	$qlink.="&user_type=".urlencode($user_type)."&s_user=".urlencode($s_user);
	$sql_search[]="( ".addslashes($user_type)."='".addslashes($s_user)."')";
}


if ($obj_type) {
	$qlink.="&obj_type=".urlencode($obj_type);
	$sql_search[]="DocType=".$db->escape($obj_type);
} else {
	$sql_search[]="DocType IN ('link')";
}



$search_array=$Lmng->searchObj ($rows,$b,$limit,implode(' AND ',$sql_search),'Title_'.$session_lang.' ASC',true);
$num_entrys=count($search_array);
$chk_list=new CheckBox("ListID",'id="ListID"',"","",1);
if (is_array($ListID) && count($ListID) == $num_entrys) {
	$sel_all=true;
}
if ($sel_all) {
	$ListID=array_keys($search_array);
	$t->assign('DISPLAY_ALL','none');
	$t->assign('DISPLAY_NONE','normal');
} else {
	if ($sel_none) {
		$ListID=array();
	}
	$t->assign('DISPLAY_ALL','normal');
	$t->assign('DISPLAY_NONE','none');
}
$list_action=$frm->getObjAction($Lmng->getModul(),'m_'.$mode);
foreach ($list_action as $key=>$val) {
	if (!$val['Hidden'] && $Lmng->isAllowedAction($obj,$val)) {
		$t->assign('SEL_VAL',$key);
		$t->assign('SEL_ITEM',FrameWork::entities($val['Name']));
		$t->parse('ROW','.list_action_val');
	}
}


foreach ($search_array as $list_obj) {
	$t->assign("LIST_CHK",$chk_list->f($list_obj->getID()));
	$t->assign('LIST_OBJ_TITLE',Framework::entities($list_obj->getName()));
	$t->assign('LIST_OBJ_LINK',Framework::entities($list_obj->getMeta('Link')));
	$t->assign('LIST_OBJ_TEXT',nl2br(Framework::entities($list_obj->getMeta('Text'))));
	$t->assign('LIST_OBJ_ID',$list_obj->getID());
	$t->assign("LIST_OBJ_IMG",$list_obj->getImage(0));
	$t->assign("L_LIST_OBJ_IMG","index.php?site=".$list_obj->getSite()."&oid=".$list_obj->getID()."&action=".$list_obj->getAction(1));
	$t->assign("L_LIST_OBJ_ITEM","index.php?site=".$list_obj->getSite()."&oid=".$list_obj->getID()."&action=".$list_obj->getAction(0));

	$t->assign('LIST_OBJ_USER_MODIFY',FrameWork::entities($users_array[$list_obj->getMeta('UserModify')]));
	if ($list_obj->getMeta('TimeModify')) {
		$t->assign('LIST_OBJ_TIME_MODIFY',date('d.m.Y H:i',$list_obj->getMeta('TimeModify')));
	} else {
		$t->assign('LIST_OBJ_TIME_MODIFY','-');
	}
	if ($i%2) {
		$t->assign("ROW_COLOR","#f2f2f2");
	} else {
 		$t->assign("ROW_COLOR",$bgcolor);
	}
 	$t->parse('ROW','.search_row');
  	$i++;
}
$num=$num_entrys;
if ($rows>$limit) {
	$s_limit=10;
	$s_begin=1;
	$s_sites=ceil($rows/$limit);
	$a_site=($b/$limit);
	if ($a_site>=$s_limit) {
		$s_begin=floor($a_site/$s_limit)*$s_limit+1;
		$n_b=($s_begin-2)*$limit;
		$l_sites.="<a href=\"index.php?site=$site&action=$action&b=$n_b".$qlink."\">&lt;&lt;</a> ";
	}
	if (($s_begin+$s_limit)>$s_sites) {
		$len_sites=$s_sites-$s_begin+1;
	} else {
		$len_sites=$s_limit;
	}
	for ($i=$s_begin;$i<($s_begin+$len_sites);$i++) {
		$n_b=($i - 1)*$limit;
		if ($n_b==$b) { $temp_b='<b>'; $temp_e='</b>'; } else{ $temp_b=''; $temp_e=''; }
		$l_sites.="[<a href=\"index.php?site=$site&action=$action&b=$n_b".$qlink."\">".$temp_b.$i.$temp_e."</a>]";
	}
	if ($s_sites>$i) {
		$n_b=($i-1)*$limit;
		$l_sites.=" <a href=\"index.php?site=$site&action=$action&b=$n_b".$qlink."\">&gt;&gt;</a>";
		$t->parse("ROW","more");
	}
	$t->assign("S_SITES",$l_sites);
	$t->assign("S_NUM",($b+1)." - ".($b+$num));
	$t->assign("S_ALL",$rows);
	$t->parse("ROW","search_next");
} else {
	$t->assign("S_ALL",$num);
	$t->parse("ROW","search_one");
}



?>