<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
//debug(date('d.m.y h:i',1289301798));
$t->assign('MOD_TITLE',$frm->getAppName('email'));
if (!$app["email"]) {
	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
} else {
	$T->loadModul('mail');
	$t->setRoot("tpl/$THEME/mail/$session_lang");
	$t->define (array('application' => "header.inc.html"));
	unset($obj);
	unset($ActionError,$vheader);
	$uaccess=array();
	$Mail=& $frm->getStaticModul('mail');


	$uaccess_ids=$Mail->listUserAccess($auth->auth['uid']);
	if ($uaccess_ids) {
		if ($uaccess=$frm->getFullName($uaccess_ids,0,array('','system'))) {
			$uaccess[$auth->auth['uid']]=$REG_USER['lastname'].' '.$REG_USER['firstname'];
			if ($sMACC_ID && isset($uaccess[$sMACC_ID])) {
				$MACC_ID=$sMACC_ID;
				if (!$sess->is_registered('MACC_ID')) $sess->register('MACC_ID');
			}
			foreach($uaccess as $key=>$val) {
				$t->assign('UACCESS_KEY',$key);
				$t->assign('UACCESS_VAL',htmlspecialchars($val));
				if ($MACC_ID==$key || (!$MACC_ID && $key==$auth->auth['uid'])) {
					$t->assign('UACCESS_CHK','selected="selected"');
					if ($key!=$auth->auth['uid']) {
						$t->assign('UACCESS_USER',htmlspecialchars($val));
						$t->parse('ROW','ext_uaccces');
					}
				} else {
					$t->assign('UACCESS_CHK','');
				}
				$t->parse('ROW','.uaccces_row');
			}
			$t->parse('ROW','uaccces');
		}
	} else $MACC_ID=0;

	if ($uaccess[$MACC_ID] && $MACC_ID!=$auth->auth['uid']) {
		$tmp=$frm->read_user($MACC_ID);
		$username=$tmp['username'];
		$password=$tmp['password'];
		$user_id=$MACC_ID;
	} else {
		$username=$auth->auth['uname'];
		$password=$auth->auth['password'];
		$user_id=$auth->auth['uid'];
	}
	$Mail->setUser($user_id);
	$Mail->setUserName($username);
	$Mail->setPassword($password);
	$Mail->open();

	//debug($Mail->listFolders('INBOX',false,true,true,0));

	if(!$Mail->isOpen()) {
		$ActionError['server']=$Mail->getError();
		$t->assign('TPL_CARD','');
		$t->assign('QUOTA','');
	} else {
		$t->assign('CFG_ON','off');
		$t->assign('NEW_ON','off');
		$t->assign('FIL_ON','off');
		$t->assign('SRC_ON','off');
		$t->assign('LOG_ON','off');
		$t->assign('FOL_ON','off');
		if (isset($SESS_MDATA[$site]['L_BACK'])) {
			$H_REFERER=$SESS_MDATA[$site]['L_BACK'];
		} else {
			$H_REFERER[0]="index.php?site=$site";
		}
		if ($show=='compose') $action='n';

		$tmp_prefs=$frm->getPrefs('email');
		$pref_update=false;
		if (!$tmp_prefs['email1']) {
			if (GE_userDomainSuffix) {
				$simple_username=preg_replace('/'.preg_quote('_'.GE_userDomainSuffix,'/').'$/','',$auth->auth['uname']);
			} else {
				$simple_username=$auth->auth['uname'];
			}
			if (GE_DOMAIN && $GLOBALS['CFG']['USER_CLASS']=='ldap_full') {
				$tmp_prefs['email1']=$simple_username.'@'.GE_DOMAIN;
			} else {
				$domain=$Mail->getCfg('cfg/domain');
				if ($domain && strpos($domain,'@')===false) {
					$domain='@'.$domain;
				}
				$tmp_prefs['email1']=$simple_username.$domain;
			}
			$pref_update=true;
		}
		if (!$tmp_prefs['fullname1']) {
			$tmp_prefs['fullname1']=$REG_USER['firstname']." ".$REG_USER['lastname'];
			$pref_update=true;
		}
		if ($pref_update) {
			$frm->insertPrefs('email',$tmp_prefs);
		}
		$Mail->setPrefs($tmp_prefs);
		if (isset($limit)) {
			$Mail->setLimit($limit);
		}
		$root_obj_d=$Mail->getSystemObj('d');
		$root_obj_d->setParentMeta(0,$Mail->getStatus($root_obj_d->getBox()));
		$root_obj[$root_obj_d->getID()]=$root_obj_d;
		$Mail->setRootIDs($root_obj_d->getID(),'d');
		$root_obj_u=$Mail->getSystemObj('u');
		$root_obj_u->setParentMeta(0,$Mail->getStatus($root_obj_u->getBox()));
		$root_obj[$root_obj_u->getID()]=$root_obj_u;
		$Mail->setRootIDs($root_obj_u->getID(),'u');
		$root_obj_s=$Mail->getSystemObj('s');
		if ($Mail->getObj($root_obj_s->getBox())) {
			//debug($root_obj_s->getBox());
			$root_obj_s->setParentMeta(0,$Mail->getStatus($root_obj_s->getBox()));
			$root_obj[$root_obj_s->getID()]=$root_obj_s;
			$Mail->setRootIDs($root_obj_s->getID(),'s');
		}
		$draft_obj=$Mail->getObj($Mail->getDraftID(),false);
		if (!is_object($draft_obj)) {
			if (!($draft_obj=$Mail->getObj($Mail->getDraftID(),true))) {
				$draft_obj=new MObj_fol(array('Box'=>$Mail->getDraftID()));
				$ActionError=$Mail->addFolder($draft_obj->getBox());
			}
			if (!$ActionError) {
				$ActionError=$Mail->subscribeFolder($draft_obj->getBox());
			}
		}
		$sent_obj=$Mail->getObj($Mail->getSentID(),false);
		if (!is_object($sent_obj)) {
			if (!($sent_obj=$Mail->getObj($Mail->getSentID(),true))) {
				$sent_obj=new MObj_fol(array('Box'=>$Mail->getSentID()));
				$ActionError=$Mail->addFolder($sent_obj->getBox());
			}
			if (!$ActionError) {
				$ActionError=$Mail->subscribeFolder($sent_obj->getBox());
			}
		}
		if ($Mail->getReadOnlyID()) {
			$readonly_obj=$Mail->getObj($Mail->getReadOnlyID(),false);
			if (!is_object($readonly_obj)) {
				if (!($readonly_obj=$Mail->getObj($Mail->getReadOnlyID(),true))) {
					$readonly_obj=new MObj_fol(array('Box'=>$Mail->getReadOnlyID()));
					$ActionError=$Mail->addFolder($readonly_obj->getBox());
				}
				if (!$ActionError) {
					$CyrAdm=& $frm->getStaticModul('mail_adm');
					if ($CyrAdm->imap_login()) {
						$aclBox=str_replace('INBOX','user'.$Mail->getCfg('cfg/delim').$Mail->getUserName(),$readonly_obj->getBox());
						$CyrAdm->setacl($aclBox,$Mail->getUserName(),'lrsip');
					}
					$ActionError=$Mail->subscribeFolder($readonly_obj->getBox());
				}

			}


		}
		$trash_obj=$Mail->getObj($Mail->getTrashID(),false);
		if (!is_object($trash_obj)) {
			if (!($trash_obj=$Mail->getObj($Mail->getTrashID(),true))) {
				$trash_obj=new MObj_fol(array('Box'=>$Mail->getTrashID()));
				$ActionError=$Mail->addFolder($trash_obj->getBox());
			}
			if (!$ActionError) {
				$ActionError=$Mail->subscribeFolder($trash_obj->getBox());
			}
		}
		if ($Mail->getCfg('cfg/spam/enable') && $Mail->getSpamID()) {
			$spam_obj=$Mail->getObj($Mail->getSpamID(),false);
			if (!is_object($spam_obj)) {
				if (!($spam_obj=$Mail->getObj($Mail->getSpamID(),true))) {
					$spam_obj=new MObj_fol(array('Box'=>$Mail->getSpamID()));
					$ActionError=$Mail->addFolder($spam_obj->getBox());
				}
				if (!$ActionError) {
					$ActionError=$Mail->subscribeFolder($spam_obj->getBox());
				}
			}
		}
		$autoAbbo=$Mail->getMailAbbo($Mail->getUser(),'');
		//debug($autoAbbo);
		if ($autoAbbo && is_array($autoAbbo)) {
			foreach ($autoAbbo as $val=>$mode) {
				switch ($mode) {
					case 'abbo':
							$Mail->subscribeFolder($val);
							$folders=$Mail->listFolders($val.$Mail->getCfg('cfg/delim').'*',true,false);
							foreach ($folders as $key=>$bval) {
								$Mail->subscribeFolder($bval->getBox());
							}
					break;
					case 'un_abbo':
							$Mail->unsubscribeFolder($val);
							$folders=$Mail->listFolders($val.$Mail->getCfg('cfg/delim').'*',true,false);
							foreach ($folders as $key=>$bval) {
								$Mail->unsubscribeFolder($bval->getBox());
							}
					break;
				}
				$Mail->delteMailAbbo($Mail->getUser(),$val);
			}
		}
		if ($oid) {
			$obj=$Mail->getObj($oid);
			if (!is_object($obj) && $rid=='QUICK') {
					$Mail->unsubscribeFolder($oid);
					$folders=$Mail->listFolders($oid.$Mail->getCfg('cfg/delim').'*',false,false);
					foreach ($folders as $key=>$bval) {
						if (!is_object($Mail->getObj($bval->getBox()))) {
							$Mail->unsubscribeFolder($bval->getBox());
						}
					}
			}
		}
		if (!$rid && is_object($obj)) {
			$rid=$obj->getMeta('RootID');
		}
		if (!is_object($obj) || !$rid || !isset($root_obj[$rid])) {
			$obj=reset($root_obj);
			$rid=$obj->getMeta('RootID');
			if ($obj->getMeta('Box')=='INBOX') $obj->setMeta('RootID','INBOX');
		}

		$rootObj=$root_obj[$rid];
		$Mail->setRootObj($rootObj);
		//$Mail->open($obj->getBox())
		//$qtree=$Mail->listTree();
		$qtree=$Mail->listTree('*',false,false);
		//debug($qtree);


		foreach ($root_obj as $key=>$val) {
			if ($key==$rid && $action!='n' && $action!='f' && $action!='s') {
				$t->assign('M_ON','on');
			} else {
				$t->assign('M_ON','off');
			}
			$t->assign('M_NAME',Framework::entities($val->getName()));
			$t->assign('M_URL',"index.php?site=".$val->getSite()."&rid=".$val->getID()."&oid=".urlencode($val->getBox()));
			$t->parse('ROW','.root_header');
		}
		$qtree[0][$root_obj_u->getID()]=$root_obj_u;
		if (isset($qtree[$root_obj_s->getID()])) $qtree[0][$root_obj_s->getID()]=$root_obj_s;
		$t->assign('T_S_ACTION',"index.php?site=$site&rid=".$root_obj_d->getID());
		if ($pre["global"]['js']) $t->parse("ROW","conf_delete");
		$Mail->setClipboard('mobj',$frm->getClipboard('mobj'));

		if (!$action)  $action=$obj->getAction(0);
		if (($meta_save_x)) {
			if ($new) {
				require ('lib/mail/inc_NewObject.php');
			} else {
				require ('lib/mail/inc_UpdateObject.php');
			}
		}
		if ($obj_action_x && $obj_action_val) {
			require ('lib/mail/inc_ActionObject.php');
		}
		if ($_POST['jsBoxAction']) {
			switch ($_POST['jsBoxActionMode']) {
				case 'delete':
					$ldelete_x=1;
				break;
				case 'move':
					$lmove_x=1;
					$action_oid=$_POST['jsBoxActionID'];
				break;
				case 'copy':
					$lcopy_x=1;
					$action_oid=$_POST['jsBoxActionID'];
				break;
			}
		}
		if ($_POST['hid_FactionID']) $action_oid=substr($_POST['hid_FactionID'],2);
		if (($lcopy_x || $lmove_x || $ldelete_x || $ldeletefinal_x) || ($list_action_x && $list_action_val)) {
			require ('lib/mail/inc_ActionList.php');
		}
		if (($copy_x || $move_x || $delete_x) || ($mail_action_x && $mail_action_val)) {
			require ('lib/mail/inc_MailActionObject.php');
		}

		if ($clearMail) {
			$Mail->deleteEmail();
			$Mail->deleteAttachment();
		}

		if ($action=='b') {
			$t->define (array('tpl_card' => "browse_content.inc.html"));
			require("lib/class_form.inc.php");
			require("mail/browse_list_ajax.php");
			require("mail/browse_content.php");
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=='v') {
			$t->define (array('tpl_card' => "view_content.inc.html"));
			require("lib/class_form.inc.php");
			require("mail/view_content.php");
			$t->parse('TPL_CARD','tpl_card');
		}  elseif ($action=='pv') {
			$t->define (array('tpl_card' => "print_content.inc.html"));
			require("mail/print_content.php");
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=='n') {
			$t->assign('NEW_ON','on');
			$t->define (array('tpl_card' => "new_content.inc.html"));
			require("lib/class_form.inc.php");
			require("mail/new_content.php");
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=='f') {
			$t->assign('FIL_ON','on');
			$t->define (array('tpl_card' => "filter_content.inc.html"));
			require("lib/class_form.inc.php");
			require("mail/filter_content.php");
			require("mail/browse_list_filter.php");
			$t->parse('TPL_CARD','tpl_card');
		} elseif ($action=='l') {
			$t->assign('LOG_ON','on');
			require("lib/mail/class_MailLogGui.php");
			$ContGui=new MailLogGui();
			if ($Gui=$ContGui->process()) {
				$t->assign('TPL_CARD',$Gui->process());
			} else {
				$t->assign('TPL_CARD','');
			}
		} elseif ($action=='o') {
			$t->assign('FOL_ON','on');
			require("lib/mail/class_MailFolderGui.php");
			$ContGui=new MailFolderGui();
			if ($Gui=$ContGui->process()) {
				$t->assign('TPL_CARD',$Gui->process());
			} else {
				$t->assign('TPL_CARD','');
			}
		} elseif ($action=='s') {
			$t->assign('SRC_ON','on');
			$t->define (array('tpl_card' => "search_content.inc.html"));

			require("lib/mail/class_MailSearchGui.php");
			$ContGui=new MailSearchGui();
			$ContGui->setObj($obj);
			$ContGui->setRootObj($root_obj_d);
			$ContGui->setTree($qtree);
			if ($Gui=$ContGui->process()) {
				$t->assign('TPL_CARD',$Gui->process());
			} else {
				$t->assign('TPL_CARD','');
			}
		} else {
			$t->define (array('tpl_card' => "no_perms.inc.html"));
			$t->parse('TPL_CARD','tpl_card');
		}

		if ($Mail->isOpen()) {
			$t->assign('NEW_URL',"index.php?site=$site&action=n&rid=".urlencode($rid)."&oid=".urlencode($rootObj->getBox()).($action=='n'?'&clearMail=1':''));
			$t->parse('ROW','new_header');
			$t->assign('FIL_URL',"index.php?site=$site&action=f&rid=".urlencode($rid)."&oid=".urlencode($rootObj->getBox()));
			$t->parse('ROW','filter_header');
			$t->assign('SRC_URL',"index.php?site=$site&action=s&rid=".urlencode($rid)."&oid=".urlencode($root_obj_d->getBox()));
			$t->parse('ROW','search_header');
			$t->assign('FOL_URL',"index.php?site=$site&action=o");
			$t->parse('ROW','folder_header');
			if ($Mail->getCfg('cfg/all/fwd_intern')) {
				$t->assign('LOG_URL',"index.php?site=$site&action=l");
				$t->parse('ROW','logbook_header');
			}
			$quota=$Mail->getQuota();
		}
		if (isset($quota['usage']) && isset($quota['limit'])) {
			$t->assign('QUOTA',number_format($quota['usage']/1000,1).'Mb / '.number_format($quota['limit']/1000,1).'Mb');
			if ($quota['usage']>($quota['limit']*0.9)) $ActionError['quota']=1;
		} else {
			$t->assign('QUOTA','');
		}
		if ($Mail->getPrefs('fwd')) $ActionError['fwd']=1;
		$SESS_MDATA[$site]['L_BACK']=$H_REFERER;
	}
	if ($ActionError) {
		require('mail/view_error.php');
	}
}
?>