<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define(array('tpl_root' => "browse_list_filter.inc.html"));
$link="index.php?site=$site&action=$action&rid=".urlencode($rid)."&oid=".urlencode($obj->getBox());


if ($Mail->getCfg('cfg/sieve/user')) {
	$filter_list=$sieve->getFilters($sieve_script);
	foreach ($filter_list as $key=>$val) {
		if ($key==$f_id) {
			$t->assign('ROW_COLOR','bgcolor="'.$fg10color.'"');
		} else {
			$t->assign('ROW_COLOR','');
		}
		$t->assign('ACTIV',$val['Activ']);
		$t->assign('L_UP',"$link&show=$show&up=$key&f_id=$f_id");
		$t->assign('L_DOWN',"$link&show=$show&down=$key&f_id=$f_id");
		$t->assign('L_ITEM',"$link&show=filter&f_id=$key");
		$t->assign('ITEM',Framework::entities($val['Name']));
		$t->parse('ROW','.item');
	}
	if ($sieve_script==$s_id && !$f_id) {
		$t->assign('ROW_COLOR','bgcolor="'.$fg10color.'"');
	} else {
		$t->assign('ROW_COLOR','');
	}
	$t->assign('L_NEW',"$link&show=filter&scriptname=".$sieve_script);
	$t->parse('ROW','sieve_root');
}
if ($Mail->getCfg('cfg/filter/user')) {
	$script_list=$sieve->getScripts();
	foreach ($script_list as $script_id=>$sname) {
		$filter_list[$script_id]=$sieve->getFilters($script_id);
		$t->clear_dynamic('item');
		foreach ($filter_list[$script_id] as $key=>$val) {
			if ($key==$f_id) {
				$t->assign('ROW_COLOR','bgcolor="'.$fg10color.'"');
			} else {
				$t->assign('ROW_COLOR','');
			}
			$t->assign('ACTIV',$val[Activ]);
			$t->assign('L_UP',"$link&show=$show&up=$key&f_id=$f_id");
			$t->assign('L_DOWN',"$link&show=$show&down=$key&f_id=$f_id");
			$t->assign('L_ITEM',"$link&show=filter&f_id=$key");
			$t->assign('ITEM',Framework::entities($val['Name']));
			$t->parse('ROW','.item');
		}
		$t->assign('S_NAME',Framework::entities($sname));
		$t->assign('L_NEW',"$link&show=filter&s_id=".$script_id);
		$t->assign('L_EDIT',"$link&show=filter_new&s_id=".$script_id);
		if ($script_id==$s_id && !$f_id) {
			$t->assign('ROW_COLOR','bgcolor="'.$fg10color.'"');
		} else {
			$t->assign('ROW_COLOR','');
		}
		$t->parse('ROW','.s_item');
	}

	$t->assign('S_NEW',"$link&show=filter_new");
	$t->parse('ROW','filter_root');
}
$t->parse ('TPL_ROOT', 'tpl_root');
?>
