<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$Mail->setCfg($GLOBALS['frm']->getCfg($Mail->getModul(),0,$Mail->getCfg('cfg/alias').'/%'));
if ($Mail->getCfg('cfg/alias') && file_exists("lib/mail/classAlias_".$Mail->getCfg('cfg/alias').".php")) {
	require_once("lib/mail/classAlias_".$Mail->getCfg('cfg/alias').".php");
} else {
	require_once("lib/mail/classAlias_mysql.php");
}
$Ali=new Aliases($Mail);
require('lib/mail/classSieve.php');
$sieve=new SieveDB($db);
$sieve->setUid($user_id);
$sieve->setUname($Mail->getUserName());
$sieve->setAliasObj($Ali);

$sieve_script=$Mail->getUserName();
$update_script=false;
if ($up) {
	$tmp_script=$sieve->SwitchEntry($up,'up');
	if ($tmp_script && ($sieve_script==$tmp_script)) $update_script=true;
}
if ($down) {
	$tmp_script=$sieve->SwitchEntry($down,'down');
	if ($tmp_script && ($sieve_script==$tmp_script)) $update_script=true;
}
$script_list=array();
if ($Mail->getCfg('cfg/filter/user')) {
	$script_list=$sieve->getScripts();
}
if (!$Mail->getCfg('cfg/sieve/user') && empty($script_list)) {
	$show='filter_new';
}
if ($filter_action_x && $filter_action_val=='edit') {
	$show='filter_new';
}
if ($filter_action_x && $filter_action_val=='fdelete') {
	$sub_filters=$sieve->getFilters($s_id);
	if (!count($sub_filters)) {
		$sieve->deleteScript($s_id);
		unset($s_id);
	}
}
if ($filter_action_x && $filter_action_val=='rdelete') {
	$tmp_obj=$sieve->readFilter($f_id);
	if ($tmp_obj['ScriptID']==$sieve_script) $update_script=true;
	$sieve->deleteFilter($f_id);
	unset($tmp_obj,$f_id);
}
$parse_action=0;
if ($show=='filter_new') {
	$L_THIS="index.php?site=$site&action=$action&rid=".urlencode($rid)."&oid=".urlencode($obj->getBox());

	if ($save_x) {
		if (!$script_name) $ActionError['fields']['name']=1;
		if (!$ActionError) {
			$ID=$sieve->saveScript($s_id,$script_name,$user_id);
			page_close();
			header("Location:$L_THIS&s_id=$ID");
			exit;
		}

	}
	if ($s_id) {
		$t->assign('SCRIPT_NAME',Framework::entities($script_list[$s_id]));
		if (!$save_x) {
			$script_name=$script_list[$s_id];
		}
		$t->parse('ROW','title_fedit');
	} else {
		$t->parse('ROW','title_fnew');
	}

	if ($ActionError['fields']['name']) {
		$t->assign('C_NAME','error');
	} else $t->assign('C_NAME','desc');
	$t->assign('VAL_NAME',htmlspecialchars($script_name));
	$form_action=$L_THIS."&show=$show";
	if ($s_id) {
		$form_action.="&s_id=$s_id";
		$sub_filters=$sieve->getFilters($s_id);
		if (!count($sub_filters)) {
			//$t->assign('L_DELETE',"index.php?site=$site&show=$show&del_id=$s_id");
			$t->parse('ROW','filter_action_fdelete');
			$parse_action=1;
		}
		$t->assign('L_BREAK',$L_THIS."&s_id=$s_id");
		$t->parse('ROW','break');
	}
	$t->assign('FORM_ACTION',$form_action);
	$t->parse('ROW','update');
	$t->parse('ROW','cont_filter');
} else  {


	$t->assign('FOCUS_FIELD','filter_name');
	if (!isset($s_id)) {
		if ($Mail->getCfg('cfg/sieve/user')) {
			$s_id=$sieve_script;
		} else {
			$s_id=key($script_list);
		}
	}
	if (!$reload && $f_id) {
		$sieve_obj=$sieve->readFilter($f_id);
		extract($sieve_obj);
		$s_id=$ScriptID;

	} elseif (!isset($faction)) $faction['stop']=1;

	if ($s_id==$sieve_script) {
		$userfields=array(
			'normal'=>4,
			'header'=>1,
			'size'=>1,
     	);
		$useraction=array(
			'M'=>true,
			'F'=>true,
			'R'=>true,
			'D'=>true,
		);
	} else {
		$userfields=array(
			'normal'=>4,
			'header'=>1,
			'size'=>1,
			'days'=>1,
			'status'=>1,
     	);
		$useraction=array(
			'M'=>true,
			'D'=>true,
		);
	}




	if ($save_x) {
		if (!$filter_name) $ActionError['fields']['name']=1;
		$av_filters=0;
		if ($faction['match']!='NONE') {
			$id=0;
			foreach ($userfields as $row=>$num) {
				for ($i=0;$i<$num;$i++) {
					if ($row=='size' || $row=='days') {
						$filter[$id]['value']=abs(intval($filter[$id]['value']));
					}
					if ($filter[$id]['test'] && $filter[$id]['test']!='E' && $filter[$id]['test']!='NE') {
						if (empty($filter[$id]['value'])) $ActionError['fields']["filter_$id"]=1;
					} else {
						unset($filter[$id]['value']);
					}
					if ($row=='header' && $filter[$id]['test'] && empty($filter[$id]['value1'])) $ActionError['fields']["filter_$id"]=1;
					if ($filter[$id]['test']) $av_filters++;
					$id++;
				}

			}
			if (!$av_filters) $ActionError['fields']['nofilters']=1;
		} else {
			unset($filter);
		}

		if ($faction['key'] != 'D' && empty($faction['value'])) $ActionError['fields']['action_val']=1;
		elseif ($faction['key'] == 'F' && $Mail->getCfg('cfg/all/check_mail') && !$frm->is_email($faction['value'])) $ActionError['fields']['action_val']=1;

		$require=array();
		if ($faction['key']=='M') {
			$require[]='fileinto';
		} elseif($faction['key']=='R') {
			$require[]='reject';
		}

		if (!$ActionError) {
			if ($f_id) {
				$tmp_obj=$sieve->readFilter($f_id);
				if ($tmp_obj['ScriptID']==$sieve_script) $update_script=true;
				unset($tmp_obj);
			}
			$f_id=$sieve->saveFilter($s_id,$f_id,$filter_name,$filter_activ,$filter,$faction,implode(',',$require));
			if ($s_id==$sieve_script) $update_script=true;
			unset($f_id,$filter_name,$filter_activ,$filter,$faction);
		}
	}



	if ($new_x || $new_action) {
		unset($faction['value']);
	}
	if ($f_id) {
		$t->assign('FILTER_NAME',Framework::entities($filter_name));
		$t->parse('ROW','title_redit');
	} else {
		$t->parse('ROW','title_rnew');
	}

	if ($Mail->getCfg('cfg/sieve/user')) {
		$t->assign('VAL_SCRIPT',$sieve_script);
		if ($s_id==$sieve_script) {
			$t->assign('CHK_SCRIPT','selected');
		} else {
			$t->assign('CHK_SCRIPT','');
		}
		$t->parse('ROW','server_script');
	}
	if ($Mail->getCfg('cfg/filter/user')) {
		$script_list=$sieve->getScripts();
		foreach ($script_list as $script_id=>$sname) {
			if ($s_id==$script_id) {
				$t->assign('CHK_SCRIPT','selected');
			} else {
				$t->assign('CHK_SCRIPT','');
			}
			$t->assign('VAL_SCRIPT',$script_id);
			$t->assign('NAME_SCRIPT',Framework::entities($sname));
			$t->parse('ROW','.filter_script');
		}
	}


	if (!isset($filter)) {
		$filter[0]['key']='From';
		$filter[1]['key']='To';
		$filter[2]['key']='Cc';
		$filter[3]['key']='Subject';
	}

	if ($ActionError['fields']['name']) {
		$t->assign('C_NAME','error');
		if (!$sfocus) {
			$t->assign('FOCUS_FIELD',"filter_name");
			$sfocus=1;
		}
	} else $t->assign('C_NAME','desc');
	$t->assign('VAL_NAME',htmlspecialchars($filter_name));
	$t->parse('ROW','filter_name');


	if ($filter_activ) {
		$t->assign('ACTIV_J','checked');
		$t->assign('ACTIV_N','');
	} else {
		$t->assign('ACTIV_N','checked');
		$t->assign('ACTIV_J','');
	}

	IF ($ActionError['fields']['nofilters']) {
		$t->assign('C_MATCH','error');
		if (!$sfocus) {
			$t->assign('FOCUS_FIELD',"faction[match]");
			$sfocus=1;
		}
	} else $t->assign('C_MATCH','desc');
	$t->assign('MATCH_ALL','');
	$t->assign('MATCH_ONE','');
	$t->assign('MATCH_'.$faction['match'],'selected');


	$t->assign('KEY_FROM','');
	$t->assign('KEY_TO','');
	$t->assign('KEY_CC','');
	$t->assign('KEY_BC','');
	$t->assign('KEY_TC','');
	$t->assign('KEY_SUBJECT','');

	$t->assign('SEL_C','');
	$t->assign('SEL_NC','');
	$t->assign('SEL_I','');
	$t->assign('SEL_NI','');
	$t->assign('SEL_E','');
	$t->assign('SEL_NE','');
	$t->assign('SEL_G','');
	$t->assign('SEL_S','');


	$id=0;$i=0;
	foreach ($userfields as $row=>$num) {
		for ($i=0;$i<$num;$i++) {
			$t->assign('TNUM',$id);
			$t->assign('KEY_'.strtoupper($filter[$id]['key']),'selected');
			$t->assign('SEL_'.$filter[$id][test],'selected');
			$t->assign('VAL_VALUE',htmlspecialchars($filter[$id][value]));
			$t->assign('VAL_VALUE1',htmlspecialchars($filter[$id][value1]));
			IF ($ActionError['fields']["filter_$id"]) {
				$t->assign('C_ROW','error');
				if (!$sfocus) {
					$t->assign('FOCUS_FIELD',"filter[$id][value]");
					$sfocus=1;
				}
			} else $t->assign('C_ROW','desc');
			$t->parse('ROW','.test_'.$row);
			$t->assign('KEY_'.strtoupper($filter[$id]['key']),'');
			$t->assign('SEL_'.$filter[$id]['test'],'');
			$id++;
		}
		if ($i) $t->parse('ROW','view_'.$row);
	}
	if ($i) $t->parse('ROW','filter_match');

	if ($ActionError['fields']['action_val']) {
		$t->assign('C_ACTION','error');
		if (!$sfocus) {
			$t->assign('FOCUS_FIELD',"faction[value]");
			$sfocus=1;
		}
	} else $t->assign('C_ACTION','desc');
	if (!isset($faction['key']) || !isset($useraction[$faction['key']])) $faction['key']=key($useraction);
	foreach ($useraction as $key=>$val) {
		if ($val) {
			if ($faction['key']==$key) $t->assign('ACTION_'.$key,'selected');
			else $t->assign('ACTION_'.$key,'');
			$t->parse('ROW','faction_'.strtolower($key));
		}
	}

	if ($faction['key']=='M' && $useraction['M']) {
		if (is_array($qtree[$root_obj_d->getID()])) {
			foreach ($qtree[$root_obj_d->getID()] as $val) {
				$t->assign('SEL_KEY',$val->getBox());
				if ($faction['value']==$val->getBox())$t->assign('SEL_SELECT','selected="selected"'); else $t->assign('SEL_SELECT','');
				if ($val->getMeta('Type')=='T')	$t->parse('ROW','faction_trash');
				if ($val->getMeta('Type')=='X')	$t->parse('ROW','faction_spam');
			}
		}
		require_once('lib/class_ObjSelect.php');
		$sel_faction=new ObjSelect();
		$sel_faction->setTree($qtree);
		$sel_faction->setFolderPrep('');
		$sel_faction->setDocPrep('');
		$sel_faction->setSelKey('return $obj->getBox();');
		$sel_faction->setIndent('&nbsp;&nbsp;&nbsp;&nbsp;');
		$sel_faction->setSelectedID($faction['value']);
		$t->assign('FACTION_SELECT',$sel_faction->parseSelect(0));
		$t->parse('ROW','action_m');
	} elseif ($faction['key']=='F' && $useraction['F']) {
		$t->assign('VAL_ACTION',htmlspecialchars($faction[value]));
		$t->parse('ROW','action_f');
	} elseif ($faction['key']=='R' && $useraction['R']) {
		$t->assign('VAL_ACTION',htmlspecialchars($faction[value]));
		$t->parse('ROW','action_r');
	}
	if ($faction['key']!='D') {
		if ($faction['keep']) $t->assign('KEEP_CHK','checked'); else $t->assign('KEEP_CHK','');
		$t->parse('ROW','action_keep');
	}

	if ($faction['stop']) $t->assign('STOP_CHK','checked'); else $t->assign('STOP_CHK','');
	$t->parse('ROW','action_stop');

	$form_action="index.php?site=$site&action=$action&rid=".urlencode($rid)."&oid=".urlencode($obj->getBox());
	$form_action.="&show=$show&reload=1";
	if ($f_id) {
		$form_action.="&f_id=$f_id";
		$t->parse('ROW','filter_action_rdelete');
		$parse_action=1;
	} elseif ($s_id!=$sieve_script) {
		$t->parse('ROW','filter_action_edit');
		$sub_filters=$sieve->getFilters($s_id);
		if (!count($sub_filters)) {
			$t->parse('ROW','filter_action_fdelete');
		}
		$parse_action=1;
	}
	$t->assign('FORM_ACTION',$form_action);
	$t->parse('ROW','update');
	$t->parse('ROW','cont_rules');
}
if ($parse_action) {
	$t->parse('ROW','filter_action');
}
if ($Mail->getCfg('cfg/sieve/user') && $update_script) {
	require('lib/mail/classSieveLib.php');
	$sieve_lib=new Sieve($Mail->getCfg('cfg/Server'), $Mail->getCfg('cfg/sieve/port'),$Mail->getUserName(),$Mail->getUserName(),$Mail->getPassword());
	if ($sieve_lib->sieve_login()) {
		$scripttext='';
		$load_script=array();
		if ($Mail->getCfg('cfg/sieve/spam') && $Mail->getCfg('cfg/spam/enable') && $Mail->getSpamID()) {
			$load_script[]='spam';
		}
		if ($Mail->getCfg('cfg/sieve/vacation')) {
			$load_script[]='vacation_1';
			$load_script[]='vacation_2';
		}
		$load_script[]=$sieve_script;
		$scripttext.=$sieve->generateScript($load_script,$user_id,$Mail->getUserName());
		if ($scripttext) {
			//debug($scripttext);
			if ($sieve_lib->sieve_sendscript($sieve_script,$scripttext)) {
				$sieve_lib->sieve_setactivescript($sieve_script);
			} else {
				if(is_array($sieve_lib->error_raw)) {
					$ActionError['server']=implode("\n",$sieve_lib->error_raw);
				} else {
					$ActionError['server']=$sieve_lib->error_raw;
				}
			}
		} else {
			$sieve_lib->sieve_deletescript($sieve_script);
		}
	} else {
		$ActionError['sieve_auth']=1;
	}
}
?>
