<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

$t->assign('MOD_TITLE',$frm->getAppName('portal'));
if (!$app["portal"]) {
	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
} else {
	function daycmp ($a, $b) {
		$d_a=$a['StartDate'];
		$d_b=$b['StartDate'];
		if ($d_a == $d_b) {
			$d_a=$a['EndDate'];
			$d_b=$b['EndDate'];
			return ($d_a<=$d_b)?-1:1;
		} else   return ($d_a < $d_b) ? -1 : 1;
	}
	//$user_id=24;
	$user_id=$auth->auth['uid'];
	$t->setRoot("tpl/$THEME/portal/$session_lang");
	$t->define (array('application' => "portal2.inc.html"));
	$t->assign('ULANG',$session_lang);
	if ($frm->getPrefs('global','js')) $t->parse("ROW","conf_delete");
	$a_groups=$frm->getAllGroups();
	$hidden_app=array();
	$frame_cont=array();
	if ($frm->getPrefs('portal','tdWidth')) {
		$tdWidth=explode(',',$frm->getPrefs('portal','tdWidth'));
	} else {
		$tdWidth=array(25,25,25,25);
	}
	$minSpace=5;
	if ($delAppCol && !$frm->getPrefs('portal','frame_'.($delAppCol))) {
		for ($i=$delAppCol;$i<count($tdWidth);$i++) {
			$frm->insertPrefs('portal',array('frame_'.$i=>$frm->getPrefs('portal','frame_'.($i+1))));
		}
		$frm->insertPrefs('portal',array('frame_'.$i=>''));
		$overWidth=$tdWidth[$delAppCol-1];
		array_splice($tdWidth, $delAppCol-1, 1);
		$tmpWidth=intval($overWidth/count($tdWidth));
		for ($i=0;$i<count($tdWidth);$i++) {
			if ($i==count($tdWidth)-1) {
				$tdWidth[$i]+=$overWidth;
			} else {
				$tdWidth[$i]+=$tmpWidth;
				$overWidth-=$tmpWidth;
			}

		}
		$frm->insertPrefs('portal',array('tdWidth'=>implode(',',$tdWidth)));
		$frm->addOnload('editPortal();');
	}
	if ($addAppCol && (count($tdWidth)<6)) {
		$overWidth=intval(100/(count($tdWidth)+1));
		$tmpWidth=intval($overWidth/count($tdWidth));
		$i=1;
		foreach ($tdWidth as $key=>$val) {
			if (($val-$tmpWidth) > $minSpace) {
				$tdWidth[$key]=$val-$tmpWidth;
			} else {
				$tdWidth[$key]=$minSpace;
				if (count($tdWidth)!=$i) $tmpWidth+=intval(($tmpWidth-($val-$minSpace))/(count($tdWidth)-$i));
			}
			$i++;
		}
		ksort($tdWidth);
		array_splice($tdWidth, $addAppCol,0,array(100-array_sum($tdWidth)));
		for ($i=(count($tdWidth)-1);$i>$addAppCol;$i--) {
			//echo '<br>insert:frame_'.($i+1).'<='.$frm->getPrefs('portal','frame_'.($i));
			$frm->insertPrefs('portal',array('frame_'.($i+1)=>$frm->getPrefs('portal','frame_'.($i))));
		}
		//echo '<br>insert:frame_'.($addAppCol+1).'<=';
		$frm->insertPrefs('portal',array('frame_'.($addAppCol+1)=>''));
		$frm->insertPrefs('portal',array('tdWidth'=>implode(',',$tdWidth)));
		$frm->addOnload('editPortal();');
	}


	$sliderPos=array();
	for ($key=1;$key<count($tdWidth);$key++) {
		if ($key==1) {
			$sliderPos[$key-1]=$tdWidth[$key-1]/100;
		} else {
			$sliderPos[$key-1]=$sliderPos[$key-2]+$tdWidth[$key-1]/100;
		}
	}
	for ($i=0;$i<count($tdWidth);$i++) {
		//echo '<br>frame'.($i+1).':';print_r($frm->getPrefs('portal','frame_'.($i+1)));
		if ($frm->getPrefs('portal','frame_'.($i+1))) {
			$frame_cont[$i+1]=explode(',',$frm->getPrefs('portal','frame_'.($i+1)));
		} else {
			$frame_cont[$i+1]=array();
		}
	}
	//debug($sliderPos);

	if ($app['vbur']) {
		$t->setRoot("tpl/$THEME/portal/$session_lang");
		$t->define (array('tpl_pvbur' => "portal_vbur.inc.html"));
		if ($abwes_x) {
			$frm->insertUserMsg(1,$mbuser,time(),0);
			if ($app['asx'] && $frm->getPrefs('asx','dnd')) {
				$Asx=$frm->getStaticModul('asx');
				$Asx->setDND(true);
			}
			page_close();
			header('Location:locked.php');
			exit;
		}
		require('lib/class_form.inc.php');
		$uptime=time()-600;
		if (!$bgrp || !isset($a_groups[$bgrp])) {
			if ($pre['global']['bgrp']) $bgrp=$pre['global']['bgrp']; else $bgrp=$CFG['GROUP_ALL'];
		}
//
		$busers=$frm->getCachedUserName(array_keys($frm->getApplicationUsers('vbur',$frm->getGroupUsers($bgrp))));
		$c2dial=false;
		if ($frm->getMyApps('asx')) {
			$Asx=$frm->getStaticModul('asx');
			if ($Asx->getCfg('cfg/click2dial/vbur')) {
				$c2dial=$Asx->getPhoneFromIP();
				if ($c2dial) {
					$rows=0;
					$phones=array();
					foreach($Asx->listPhones($rows,array('online'=>1)) as $tmp) {
						$phones[$tmp->getMeta('_FKUserID')]=$tmp->getName();
					}
				}
			}
		}
		if (is_array($busers)) {
			$busers_msg=$frm->listUserMsg(array_keys($busers),0);
			$vbur_cfg=$frm->getCfg('vbur',0,'cfg/%');
			$i=1;
			foreach ($busers as $key=>$val) {
				$msgParams=array(
					'invReset'=>1,
					'invTab'=>'msg',
				);
				if ($app['msg']) {
					$msgParams['msgToAdd']='u_'.$key;
				}
				if ($app['sms'] && $frm->getCachedUser($key,'mobil')) {
					$msgParams['smsToAdd']=$frm->getStaticModul('sms')->formatNumber($frm->getCachedUser($key,'mobil'),$val);
				}
				$t->assign('MSG_PARAMS',htmlspecialchars(json_encode($msgParams)));
				$t->assign('K_BUSER',$key);
				$t->assign('N_BUSER',Framework::entities($val));
				if ($busers_msg[$key]['MsgTime']) $t->assign('T_BUSER',date('H:i',$busers_msg[$key]['MsgTime'])); else $t->assign('T_BUSER','');
				if ($busers_msg[$key]['MsgTime'] && $busers_msg[$key]['Message']) $t->assign('S_BUSER',' - '.$busers_msg[$key]['Message']);
				else $t->assign('S_BUSER',$busers_msg[$key]['Message']);
				if ($busers_msg[$key]['Status']==1) {
					$t->assign('I_BUSER','buser1.gif');
				} elseif($busers_msg[$key]['UpTime']>$uptime) {
					if ($c2dial && (isset($phones[$key]))) {
						//debug($dial2);
						$t->assign('I_DIAL','dial.gif');
						$t->assign('L_DIAL',"javascript:void(sndReq('callto','ajax.php','ajax_modul=asxCall&UserID=".$key."&number=".$phones[$key]."'));");
						$t->parse('ROW','buser_dial');
					}
					if ($frm->isAllowedIpMask($vbur_cfg['cfg/ipmask'],$busers_msg[$key]['IpAdress'])) {
						$t->assign('I_BUSER','buser0.gif');
					} else {
						$t->assign('I_BUSER','buser3.gif');
					}
				} else {
					$t->assign('I_BUSER','buser2.gif');
				}
				if ($i%2) $t->assign('ROW_COLOR','#f2f2f2'); else
				$t->assign('ROW_COLOR',$bgcolor);
				$t->parse('ROW','.buser_row');
				$t->clear_dynamic('buser_dial');
				$i++;
			}
		}
		$app_groups=false;
		$app_users=$frm->getApplicationUsers('vbur');
		if (is_array($app_users)) {
			$app_groups=$frm->getUserGroups(array_keys($app_users));
			if (is_array($app_groups)) {
				foreach ($app_groups as $key=>$val) {
					if (isset($a_groups[$key])) $app_groups[$key]=$a_groups[$key]; else unset($app_groups[$key]);
				}

			}
		}
		if (is_array($app_groups)) {
			natsort($app_groups);
			$sel_group=new SelectField('bgrp','class="sel" style="width:220px;" onchange="document.daten.submit();"',$app_groups);
			$t->assign('F_GROUPS',$sel_group->f());
			$t->assign('MBUSER',htmlspecialchars($mbuser));
			if ($frm->getPrefs('portal','vbur_cont')=='none') {
				$t->assign('DISPLAY_ALL','none');
				$t->assign('DISPLAY_NONE','block');
				$t->assign('DISPLAY_CONT','none');
			} else {
				$t->assign('DISPLAY_ALL','block');
				$t->assign('DISPLAY_NONE','none');
				$t->assign('DISPLAY_CONT','block');
			}

			$t->parse('TEMP','tpl_pvbur');
			$p_content['vbur']=$t->getParsed();
		}
	}



	if ($app['msg']) {
		$T->loadModul('msg');
		$t->setRoot("tpl/$THEME/msg/$session_lang");
		$t->define (array('tpl_pmsg' => "portal_msg.inc.html"));

		/*if (Framework::getParam('n_re_to',0,'G')) {
			$tmp_note=$c_msg->readNote(Framework::getParam('n_re_to',0,'G'));
			$Image=$tmp_note['Image'];
			$defSubject="Re: ".$tmp_note['Subject'];
			$defBody=" \n---- original message ----\n".$tmp_note['Body'];
			$defInvit[]='u_'.$tmp_note['SenderID'];
			$c_msg->markVisited(Framework::getParam('n_re_to',0,'G'));
			$t->assign('FOCUS_FIELD','Body');
			$msg_disp=1;
		}*/
		/*if (Framework::getParam('re_uid',0,'G')) {
			$defInvit[]='u_'.Framework::getParam('re_uid',0,'G');
		}*/

		require_once('lib/msg/ctrl/geMsgCtrlPortal.php');
		$msgGui=new geMsgCtrlPortal();

		$t->assign('TPL_MSG',$msgGui->process());

		if ($frm->getPrefs('portal','msg_cont')=='none') {
			$t->assign('DISPLAY_ALL','none');
			$t->assign('DISPLAY_NONE','block');
			$t->assign('DISPLAY_CONT','none');
		} else {
			$t->assign('DISPLAY_ALL','block');
			$t->assign('DISPLAY_NONE','none');
			$t->assign('DISPLAY_CONT','block');
		}
		$t->parse('TEMP','tpl_pmsg');
		$p_content['msg']=$t->getParsed();


	}

	if ($app['rem']) {
		$T->loadModul('rem');
		$t->setRoot("tpl/$THEME/rem/");
		$t->define (array('tpl_prem' => "portal_rem.inc.html"));

		require_once('lib/rem/ctrl/geRemCtrlPortal.php');
		$remGui=new geRemCtrlPortal();

		$t->assign('TPL_REM',$remGui->process());

		if ($frm->getPrefs('portal','rem_cont')=='none') {
			$t->assign('DISPLAY_ALL','none');
			$t->assign('DISPLAY_NONE','block');
			$t->assign('DISPLAY_CONT','none');
		} else {
			$t->assign('DISPLAY_ALL','block');
			$t->assign('DISPLAY_NONE','none');
			$t->assign('DISPLAY_CONT','block');
		}
		$t->parse('TEMP','tpl_prem');
		$p_content['rem']=$t->getParsed();


	}
	

	if ($app['fmng']) {
		$t->setRoot("tpl/$THEME/fmng/$session_lang");
		$t->define (array('tpl_pfmng' => "portal_fmng.inc.html"));
		require_once('lib/fmng/header.php');
		$search_sql="Trash=0 AND Favorite=1";
		$rows=0;
		$ftree=$Fmng->searchObj($rows,0,0,$search_sql,"DocType DESC,Title_$session_lang ASC",false);
		if ($rows) {
			$i=1;
			foreach ($ftree as $key=>$val) {
				$link="index.php?site=".$val->getSite()."&action=".$val->getAction(0)."&oid=".$key;
				if ($val->getACL(2)) {
					$link_d="index.php?site=".$val->getSite()."&action=".$val->getAction(1)."&oid=".$key;
				} else {
					$link_d="#";
				}
				$t->assign("LIST_IMG",$val->getImage(0));
				$t->assign("L_LIST_IMG",$link_d);
				$t->assign("L_LIST_ITEM",$link);
				$t->assign("LIST_ITEM",FrameWork::entities($val->getName()));
				if ($pre["global"]['lay']) {
					$div_row=0;
					if ($val->getMeta('Text')) {
						$t->assign("DIV_DESC",Framework::entities($val->getMeta('Text')));
						$t->parse("ROW","div_desc");
						$div_row=1;
					}
					if ($div_row) {
						$t->assign('LAY_LINK'," onMouseOver=\"show(event, 'fk_$key'); return true;\" onMouseOut=\"hide('fk_$key'); return true;\"");
						$t->assign("DIV_ID","fk_$key");
						$t->parse("ROW",".div_row");
						$t->clear_dynamic('div_desc');
					} else {
						$t->assign('LAY_LINK','');
					}
				} else {
					$t->assign('LAY_LINK','');
				}
				//if ($i%2) $t->assign('ROW_COLOR','#f2f2f2'); else
				$t->assign('ROW_COLOR',$bgcolor);
				$t->parse('ROW','.hot_obj_row');
				$i++;
			}
		} else {
			$hidden_app['fmng']=true;
			$t->parse('ROW','no_hot_obj');
		}
		if ($frm->getPrefs('portal','fmng_cont')=='none') {
			$t->assign('DISPLAY_ALL','none');
			$t->assign('DISPLAY_NONE','block');
			$t->assign('DISPLAY_CONT','none');
		} else {
			$t->assign('DISPLAY_ALL','block');
			$t->assign('DISPLAY_NONE','none');
			$t->assign('DISPLAY_CONT','block');
		}
		$t->parse('TEMP','tpl_pfmng');
		$p_content['fmng']=$t->getParsed();

	}
	if ($app['lmng']) {
		$t->setRoot("tpl/$THEME/lmng/$session_lang");
		$t->define (array('tpl_plmng' => "portal_lmng.inc.html"));
		require_once('lib/lmng/header.php');
		$search_sql="Trash=0 AND DocType='link' AND Favorite=1 AND FKUserID=".$db->escape($user_id);
		$rows=0;
		$i=1;
		$ftree=$Lmng->searchObj($rows,0,0,$search_sql,'Counter DESC',false);
		if ($rows) {
			foreach ($ftree as $key=>$val) {
				$Name=$val->getName();
				if (strlen($Name)>30) $Name=substr($Name,0,28).'...';
				$t->assign('OBJ_NAME',Framework::entities($Name));
				$t->assign('OBJ_LINK',"index.php?site=".$val->getSite()."&action=".$val->getAction(0)."&oid=".$val->getID());
				if ($pre["global"]['lay']) {
					$div_row=0;
					if ($val->getMeta('Text')) {
						$t->assign("DIV_DESC",Framework::entities($val->getMeta('Text')));
						$t->parse("ROW","div_desc");
						$div_row=1;
					}
					if ($div_row) {
						$t->assign('LAY_LINK'," onMouseOver=\"show(event, 'lk_$key'); return true;\" onMouseOut=\"hide('lk_$key'); return true;\"");
						$t->assign("DIV_ID","lk_$key");
						$t->parse("ROW",".div_row");
						$t->clear_dynamic('div_desc');
					} else {
						$t->assign('LAY_LINK','');
					}
				} else {
					$t->assign('LAY_LINK','');
				}
				//if ($i%2) $t->assign('ROW_COLOR','#f2f2f2'); else
				$t->assign('ROW_COLOR',$bgcolor);
				$t->parse('ROW','.hot_bkm_row');
				$i++;
			}
			$t->parse('TEMP','tpl_plmng');
		} else {
			$t->parse('ROW','no_hot_bkm');
			$hidden_app['lmng']=true;
		}
		if ($frm->getPrefs('portal','lmng_cont')=='none') {
			$t->assign('DISPLAY_ALL','none');
			$t->assign('DISPLAY_NONE','block');
			$t->assign('DISPLAY_CONT','none');
		} else {
			$t->assign('DISPLAY_ALL','block');
			$t->assign('DISPLAY_NONE','none');
			$t->assign('DISPLAY_CONT','block');
		}
		$t->parse('TEMP','tpl_plmng');
		$p_content['lmng']=$t->getParsed();
	}
	if ($app['imng']) {
		$t->setRoot("tpl/$THEME/imng/$session_lang");
		$t->define (array('tpl_pimng' => "portal_imng.inc.html"));
		$Imng=& $frm->getStaticModul('imng');
		$Imng->setPublic(1);

		$search_sql="Trash=0 AND Favorite=1";
		$rows=0;
		$ftree=$Imng->searchObj($rows,0,0,$search_sql,"DocType DESC,Title_$session_lang ASC",false);
		if ($rows) {
			$i=1;
			foreach ($ftree as $key=>$val) {
				$link="index.php?site=".$val->getSite()."&action=".$val->getAction(0)."&oid=".$key;
				if ($val->getACL(2)) {
					$link_d="index.php?site=".$val->getSite()."&action=".$val->getAction(1)."&oid=".$key;
				} else {
					$link_d="#";
				}
				$t->assign("LIST_IMG",$val->getImage(0));
				$t->assign("L_LIST_IMG",$link_d);
				$t->assign("L_LIST_ITEM",$link);
				$t->assign("LIST_ITEM",FrameWork::entities($val->getName()));
				if ($pre["global"]['lay']) {
					$div_row=0;
					if ($val->getMeta('Text')) {
						$t->assign("DIV_DESC",Framework::entities($val->getMeta('Text')));
						$t->parse("ROW","div_desc");
						$div_row=1;
					}
					if ($div_row) {
						$t->assign('LAY_LINK'," onMouseOver=\"show(event, 'ik_$key'); return true;\" onMouseOut=\"hide('ik_$key'); return true;\"");
						$t->assign("DIV_ID","ik_$key");
						$t->parse("ROW",".div_row");
						$t->clear_dynamic('div_desc');
					} else {
						$t->assign('LAY_LINK','');
					}
				} else {
					$t->assign('LAY_LINK','');
				}
				//if ($i%2) $t->assign('ROW_COLOR','#f2f2f2'); else
				$t->assign('ROW_COLOR',$bgcolor);
				$t->parse('ROW','.hot_info_row');
				$i++;
			}
		} else {
			$t->parse('ROW','no_hot_info');
			$hidden_app['imng']=true;
		}
		if ($frm->getPrefs('portal','imng_cont')=='none') {
			$t->assign('DISPLAY_ALL','none');
			$t->assign('DISPLAY_NONE','block');
			$t->assign('DISPLAY_CONT','none');
		} else {
			$t->assign('DISPLAY_ALL','block');
			$t->assign('DISPLAY_NONE','none');
			$t->assign('DISPLAY_CONT','block');
		}
		$t->parse('TEMP','tpl_pimng');
		$p_content['imng']=$t->getParsed();


		$t->setRoot("tpl/$THEME/imng/$session_lang");
		$t->define (array('tpl_pimngf' => "portal_imngf.inc.html"));

		$i=1;

		$escObj=$Imng->listEscalationObj(array());
		if (!empty($escObj)) {
			foreach($escObj as $key=>$val) {
					$t->assign("B_DESC",nl2br(Framework::entities($val->getMeta('Text'))));
					$t->assign("ROW_STYLE","padding:3px;background:#ffe6cc;");
					$t->assign("B_TITLE",Framework::entities($val->getName()));
					$t->assign("B_LINK","index.php?site=".$val->getSite()."&oid=".$val->getID());
					$t->assign('B_IMG',"<img src=\"img/$THEME/".$val->getImage()."\" border=0 hspace=0>");
					$t->parse('ROW','.hot_black_row');
					$i++;
			}
		}


		$time=time();
		$search_sql="Trash=0 AND Portal=1 AND (PortalStart < $time) AND (PortalEnd > $time OR PortalEnd<=0)";
		$search_sql.=" AND (LangID='".$Imng->getLangID()."' OR LangID='00')";
		$order='Title_'.$Imng->getLangID().' asc';
		$rows=0;
		$List=$Imng->searchObj($rows,0,0,$search_sql,$order,false);

		if (!empty($List)) {
			foreach($List as $key=>$val) {
				if (isset($escObj[$key])) continue;
				$t->assign("B_DESC",nl2br(Framework::entities($val->getMeta('Text'))));
				$t->assign("ROW_STYLE","padding:3px;background:#f2f2f2");
				$t->assign("B_TITLE",Framework::entities($val->getName()));
				$t->assign("B_LINK","index.php?site=".$val->getSite()."&oid=".$val->getID());
				$t->assign('B_IMG',"<img src=\"img/$THEME/".$val->getImage()."\" border=0 hspace=0>");
				$t->parse('ROW','.hot_black_row');
				$i++;
			}
		}

		if ($i==1) {
			$hidden_app['imngf']=true;
		}
		if ($frm->getPrefs('portal','imngf_cont')=='none') {
			$t->assign('DISPLAY_ALL','none');
			$t->assign('DISPLAY_NONE','block');
			$t->assign('DISPLAY_CONT','none');
		} else {
			$t->assign('DISPLAY_ALL','block');
			$t->assign('DISPLAY_NONE','none');
			$t->assign('DISPLAY_CONT','block');
		}
		$t->parse('TEMP','tpl_pimngf');
		$p_content['imngf']=$t->getParsed();
	}



	if ($app['email']) {
		$t->setRoot("tpl/$THEME/mail/$session_lang");
		$t->define (array('tpl_pmail' => "portal_mail.inc.html"));
		$Mail=& $frm->getStaticModul('mail');
		$Mail->setUser($user_id);
		$Mail->setUserName($auth->auth['uname']);
		$Mail->setPassword($auth->auth['password']);
		$Mail->open();
		if($Mail->isOpen()) {
			require_once('mail/gui_show_portal.php');
			if ($frm->getPrefs('portal','portal_mail')=='none') {
				$t->assign('DISPLAY_ALL','none');
				$t->assign('DISPLAY_NONE','block');
				$t->assign('DISPLAY_CONT','none');
			} else {
				$t->assign('DISPLAY_ALL','block');
				$t->assign('DISPLAY_NONE','none');
				$t->assign('DISPLAY_CONT','block');
			}
			$t->parse('TEMP','tpl_pmail');
			$p_content['mail']=$t->getParsed();
		}
	}
	if (($app['cal']) || ($app['task'])) {
		if ($app['cal']) {
			$time=time();
			if (!isset($CAL_REFERER)) {
				$sess->register('CAL_REFERER');
			}
			$CAL_REFERER[0]="index.php?site=$site";
			$t->setRoot("tpl/$THEME/cal/$session_lang");
			$t->define (array('tpl_pcal' => "portal_cal.inc.html"));
			$t->assign('CAL_ADD',"index.php?site=cal.php&action=insert&date=$time&view=event&cal_user=".$user_id);
			$cal=& $frm->getStaticModul('cal');
			$cal->setUser($user_id);
			$cal->setGroup(explode(',',$REG_USER['groups']));

			require_once("lib/cal/class_CalListGui.php");
			$listGui=new CalListGui();

			$invit_cal=& $listGui->getInvitEvents();
			$actGui=$listGui->getPortalGui();
			if ($actGui) {
			  $t->assign('CAL_CONT',$actGui);
			} else {
			  $t->assign('CAL_CONT','');
			  $t->parse('ROW','no_aktuell');
			}

			if ($frm->getPrefs('portal','cal_cont')=='none') {
				$t->assign('DISPLAY_ALL','none');
				$t->assign('DISPLAY_NONE','block');
				$t->assign('DISPLAY_CONT','none');
			} else {
				$t->assign('DISPLAY_ALL','block');
				$t->assign('DISPLAY_NONE','none');
				$t->assign('DISPLAY_CONT','block');
			}
			$t->parse('TEMP','tpl_pcal');
			$p_content['cal']=$t->getParsed();
		} else $invit_cal=array();

		if ($app['task']) {
			$GLOBALS['SESS_MDATA']['task.php']['L_BACK']='index.php?site='.$site;
			$t->setRoot("tpl/$THEME/task/$session_lang");
			$t->define (array('tpl_ptask' => "portal_task.inc.html"));
			$Task=& $frm->getStaticModul('task');
			$date=time();
			$i=1;$j=1;
			$ftree=$Task->listTask($rows,$user_id,0,-1,mktime(0,0,0),0,0,0,0,0,0,0,-1,'EndDate ASC,Priority ASC');
			if ($rows) {
				$lastLog=$Task->listLastLog(array_keys($ftree),'log');
				foreach ($ftree as $key=>$val) {
					if ($val['TaskType']=='c') {
						$t->assign('IMG_TEAM',$IMG_DELEG[$val['Status']]);
					} elseif ($val['TaskType']=='p' || $val['TaskType']=='o') {
						$t->assign('IMG_TEAM',$IMG_PERSONAL[$val['Status']]);
					} else {
						$t->assign('IMG_TEAM',$IMG_TEAM[$val['Status']]);
					}
					$link="index.php?site=task.php&action=vo&TaskID=$key";
					$Title=$val['Title'];
					if ($val['Unread']) $t->assign('IMG_NOTE',"<img src=\"img/$THEME/$IMG_MESSAGE\" align=right>");
					else $t->assign('IMG_NOTE','');
					$laylink='';
					if ($val["OwnerID"]==$user_id) {
						$laylink.=' onclick="return goToView(this);" ondblclick="return goToEdit(this,\'action=vo\',\'action=i\');"';
					}
					if ($pre["global"]["lay"]) $laylink.=" onMouseOver=\"show(event, 't"."_$key'); return true;\" onMouseOut=\"hide('t"."_$key'); return true;\"";
					$t->assign('TASK_ITEM',"<a href=\"$link\"$laylink>".Framework::entities($Title)."</a>");

					$t->assign('ROW_COLOR',$bgcolor);

					if ($val['EndDate'] !=$val['StartDate']) {
						$i++;
						if ($val['EndDate']<$date) $t->assign('IMG_PRIO',$IMG_PRIO[$val['Priority']][0]);
						elseif ($val['StartDate']>$date) $t->assign('IMG_PRIO',$IMG_PRIO[$val['Priority']][2]);
						else $t->assign('IMG_PRIO',$IMG_PRIO[$val['Priority']][1]);
						$t->parse('ROW','.task_row');
					} else {
						$j++;
						if ($val['StartDate']>$date) $t->assign('IMG_PRIO',$IMG_PRIO[$val['Priority']][2]);
						else $t->assign('IMG_PRIO',$IMG_PRIO[$val['Priority']][1]);
						$t->parse('ROW','.todo_row');
					}
					if ($pre["global"]["lay"]) {
						$t->assign("DIV_ID","t"."_$key");
						if ($val["StartDate"]==$val["EndDate"]) $t->assign('DIV_DATE',date("d.m.Y ",$val["StartDate"]));
						else $t->assign('DIV_DATE',date("d.m.Y ",$val["StartDate"]).'-'.date("d.m.Y ",$val["EndDate"]));

						$t->assign('DIV_OWNER',FrameWork::entities($frm->getCachedUserName($val['OwnerID'],1,1)));
						$t->parse("ROW","div_task_owner");
						$t->assign('DIV_CAT',FrameWork::entities($val['CatName']));
						$t->parse("ROW","div_task_cat");
						if ($val['Text']) {
							$t->assign("DIV_DESC",Framework::entities($val['Text']));
							$t->parse("ROW","div_task_desc");
						} else $t->clear_dynamic("div_task_desc");
					
						if ($lastLog[$key]) {
							//debug($lastLog[$key]);
							$t->assign("LOG_USER",FrameWork::entities($frm->getCachedUserName($lastLog[$key]['User'],1,1)));
							$t->assign("LOG_DATE",Framework::entities(date('d.m.Y H:i',$lastLog[$key]['Date'])));
							$t->assign("LOG_DESC",Framework::entities($lastLog[$key]['Text']));
							$t->parse("ROW","div_task_log");
						} else $t->clear_dynamic("div_task_log");
				
						$t->parse("ROW",".div_task_row");

						
					}

				}

			}


			$ftree=$Task->listTask($rows,$user_id,0,-1,0,mktime(0,0,0),0,mktime(0,0,0),0,0,mktime(24,0,0),0,-1,'EndDate ASC,Priority ASC');
			if ($rows) {
				$lastLog=$Task->listLastLog(array_keys($ftree),'log');
				foreach ($ftree as $key=>$val) {
					if ($val['TaskType']=='c') {
						$t->assign('IMG_TEAM',$IMG_DELEG[$val['Status']]);
					} elseif ($val['TaskType']=='p' || $val['TaskType']=='o') {
						$t->assign('IMG_TEAM',$IMG_PERSONAL[$val['Status']]);
					} else {
						$t->assign('IMG_TEAM',$IMG_TEAM[$val['Status']]);
					}
					$link="index.php?site=task.php&action=vo&TaskID=$key";
					$Title=$val['Title'];
					if ($val['Unread']) $t->assign('IMG_NOTE',"<img src=\"img/$THEME/$IMG_MESSAGE\" align=right>");
					else $t->assign('IMG_NOTE','');
					if ($pre["global"]["lay"]) $laylink=" onMouseOver=\"show(event, 't"."_$key'); return true;\" onMouseOut=\"hide('t"."_$key'); return true;\"";
					else $laylink="";
					$t->assign('TASK_ITEM',"<a href=\"$link\"$laylink>".Framework::entities($Title)."</a>");
					$t->assign('ROW_COLOR','#dddddd');
					if ($val['EndDate'] !=$val['StartDate']) {
						$i++;
						if ($val['EndDate']<$date) $t->assign('IMG_PRIO',$IMG_PRIO[$val['Priority']][0]);
						elseif ($val['StartDate']>$date) $t->assign('IMG_PRIO',$IMG_PRIO[$val['Priority']][2]);
						else $t->assign('IMG_PRIO',$IMG_PRIO[$val['Priority']][1]);
						$t->parse('ROW','.task_row');
					} else {
						$j++;
						if ($val['StartDate']>$date) $t->assign('IMG_PRIO',$IMG_PRIO[$val['Priority']][2]);
						else $t->assign('IMG_PRIO',$IMG_PRIO[$val['Priority']][1]);
						$t->parse('ROW','.todo_row');
					}
					if ($pre["global"]["lay"]) {
						$t->assign("DIV_ID","t"."_$key");
						if ($val["StartDate"]==$val["EndDate"]) $t->assign('DIV_DATE',date("d.m.Y ",$val["StartDate"]));
						else $t->assign('DIV_DATE',date("d.m.Y ",$val["StartDate"]).'-'.date("d.m.Y ",$val["EndDate"]));

						$t->assign('DIV_OWNER',FrameWork::entities($frm->getCachedUserName($val['OwnerID'],1,1)));
						$t->parse("ROW","div_task_owner");
						$t->assign('DIV_CAT',FrameWork::entities($val['CatName']));
						$t->parse("ROW","div_task_cat");
						if ($val['Text']) {
							$t->assign("DIV_DESC",Framework::entities($val['Text']));
							$t->parse("ROW","div_task_desc");
						} else $t->clear_dynamic("div_task_desc");
					
						if ($lastLog[$key]) {
							//debug($lastLog[$key]);
							$t->assign("LOG_USER",FrameWork::entities($frm->getCachedUserName($lastLog[$key]['User'],1,1)));
							$t->assign("LOG_DATE",Framework::entities(date('d.m.Y H:i',$lastLog[$key]['Date'])));
							$t->assign("LOG_DESC",Framework::entities($lastLog[$key]['Text']));
							$t->parse("ROW","div_task_log");
						} else $t->clear_dynamic("div_task_log");

						$t->parse("ROW",".div_task_row");
					}
				}
			}
			if ($i>1 && $j>1) {
				$t->parse('ROW','task_line');
			}
			if ($i==1 && $j==1) {
				$t->parse('ROW','no_task');
			}
			$t->assign('TASK_ADD',"index.php?site=task.php&action=i");
			if ($frm->getPrefs('portal','task_cont')=='none') {
				$t->assign('DISPLAY_ALL','none');
				$t->assign('DISPLAY_NONE','block');
				$t->assign('DISPLAY_CONT','none');
			} else {
				$t->assign('DISPLAY_ALL','block');
				$t->assign('DISPLAY_NONE','none');
				$t->assign('DISPLAY_CONT','block');
			}
			$t->parse('TEMP','tpl_ptask');
			$p_content['task']=$t->getParsed();
			$invit_task=$Task->listTask($rows,$user_id,'',2,0,0,0,0,0,0,0,0,-1,'EndDate DESC');
		} else $invit_task=array();


		$invitations=array_merge($invit_cal,$invit_task);
		$t->setRoot("tpl/$THEME/portal/$session_lang");
		$t->define (array('tpl_pinvit' => "portal_invit.inc.html"));
		if (count($invitations)) {
			$invitcolor="#ffff00";
			$title='';
			$img="<img src=\"img/$THEME/month_mine.gif\" vspace=7>";
			uasort($invitations,'daycmp');
			foreach ($invitations as $key=>$val) {
				if ($val['EventID']) {
					$link="index.php?site=cal.php&action=view&view=event&date=".$val["StartDate"];
					if ($pre["global"]["lay"]) $laylink=" onMouseOver=\"show(event, 'e_invit"."_".$val[EventID]."'); return true;\" onMouseOut=\"hide('e_invit"."_".$val[EventID]."'); return true;\""; else $laylink="";
					$t->assign('LC_IMG','month_mine.gif');
					$t->assign('LC_COLOR',$cal->getCfg('cfg/icolor'));
					$t->assign('LC_LINK',"$link&event_id=".$val['EventID']."&edate=".$val["StartDate"]);
					$t->assign('LC_LAY',$laylink);
					$title=$cal->formatDate($val["StartDate"],0,$val['TimeMode']).'-';
					if ($val["OwnerID"]!= $user_id) {
						$title.=$frm->getCachedUserName($val['OwnerID'],0,1).' ';
					}
					$title.=Framework::entities($val["Title"]);
					if ($val['Unsecure']) {
						$t->assign('LC_TITLE','<i>'.$title.'</i>');
					} else {
						$t->assign('LC_TITLE',''.$title.'');
					}
					$div_row=0;
					if ($pre["global"]["lay"]) {
						$t->clear_dynamic("div_project");
						$t->clear_dynamic("div_desc");
						$t->clear_dynamic("div_place");
						$t->clear_dynamic("div_user");
						$t->clear_dynamic("div_time");
						$t->assign("DIV_ID","e_invit"."_".$val[EventID]."");
						if ($val['FKProjID'] && $P) {
							$t->assign("DIV_PROJECT",Framework::entities($P->getCachedProjectName($val['FKProjID'])));
							$t->parse("ROW","div_project");
							$div_row=1;
						}
						if ($val['Text']) {
							$t->assign("DIV_DESC",Framework::entities($val['Text']));
							$t->parse("ROW","div_desc");
							$div_row=1;
						}
						if ($val['Place']) {
							$t->assign("DIV_PLACE",Framework::entities($val['Place']));
							$t->parse("ROW","div_place");
							$div_row=1;
						}
						if ($val['TimeMode']!=1) {
							$t->assign("DIV_TIME",date("H:i -",$val["StartDate"]).date(" H:i",$val["EndDate"]));
							$t->parse("ROW","div_time");
							$div_row=1;
						}
						if ($val['InvitUsers'] || $val['InvitGroups']) {
							$iusers='';
							$tmp=explode(',',$val['InvitUsers']);
							foreach ($tmp as $i_uid) {
								if (!$i_uid) continue;
								$iusers.='<br>'.$frm->getCachedUserName($i_uid,0,1);
							}
							$tmp=explode(',',$val['InvitGroups']);
							foreach ($tmp as $i_uid) {
								if (!$i_uid) continue;
								if (!isset($go_groups[$i_uid])) {
									$temp=$frm->getAllGroups($i_uid);
									$go_groups[$i_uid]=$temp[$i_uid];
								}
								$iusers.='<br>'.Framework::entities($go_groups[$i_uid]);
							}
							//
							$t->assign('DIV_USER',$iusers);
							$t->parse('ROW','div_user');
							$div_row=1;
						}

						if ($div_row) $t->parse("ROW",".div_cal_row");
					}
					$t->parse('ROW','.invit_row');
				} else {
					$t->clear_dynamic("div_time");
					$link="index.php?site=task.php&action=vo";
					if ($pre["global"]["lay"]) $laylink=" onMouseOver=\"show(event, 't_invit"."_".$val[ID]."'); return true;\" onMouseOut=\"hide('t_invit"."_".$val[ID]."'); return true;\""; else $laylink="";
					$t->assign('LC_IMG','month_mine.gif');
					$t->assign('LC_COLOR',$CFG['TASK']['INVIT_COLOR']);
					$t->assign('LC_LINK',"$link&TaskID=".$val['ID']);
					$t->assign('LC_LAY',$laylink);
					$title=date("d.m.Y-",$val["StartDate"]);
					$title.=Framework::entities($val["Title"]);
					if ($val['Unsecure']) {
						$t->assign('LC_TITLE','<i>'.$title.'</i>');
					} else {
						$t->assign('LC_TITLE',''.$title.'');
					}
					if ($pre["global"]["lay"]) {
						$t->assign("DIV_ID","t_invit"."_".$val[ID]);
						if ($val["StartDate"]==$val["EndDate"]) $t->assign('DIV_DATE',date("d.m.Y ",$val["StartDate"]));
						else $t->assign('DIV_DATE',date("d.m.Y ",$val["StartDate"]).'-'.date("d.m.Y ",$val["EndDate"]));

						$t->assign('DIV_OWNER',FrameWork::entities($frm->getCachedUserName($val['OwnerID'],1,1)));
						$t->parse("ROW","div_task_owner");
						$t->assign('DIV_CAT',FrameWork::entities($val['CatName']));
						$t->parse("ROW","div_task_cat");
						if ($val['Text']) {
							$t->assign("DIV_DESC",Framework::entities($val['Text']));
							$t->parse("ROW","div_task_desc");
						} else $t->clear_dynamic("div_task_desc");
					
						$t->clear_dynamic("div_task_log");
						
						$t->parse("ROW",".div_task_row");
					}
					$t->parse('ROW','.invit_row');
				}
			}
		} else {
			$hidden_app['invit']=true;
		}
		if ($frm->getPrefs('portal','invit_cont')=='none') {
			$t->assign('DISPLAY_ALL','none');
			$t->assign('DISPLAY_NONE','block');
			$t->assign('DISPLAY_CONT','none');
		} else {
			$t->assign('DISPLAY_ALL','block');
			$t->assign('DISPLAY_NONE','none');
			$t->assign('DISPLAY_CONT','block');
		}
		$t->parse('TEMP','tpl_pinvit');
		$p_content['invit']=$t->getParsed();

	}

	if ($app['prot']) {
		$Prot=$frm->getStaticModul('prot');

		require_once('lib/class_FastTemplateGui.php');
		$protGui=new FastTemplateGui('portal/portal_modul.inc.html');
		$protGui->assign('MODUL','prot');
		$protGui->assign('BG_COLOR','#ddc318');
		$protGui->assign('TITLE',$frm->getAppName('prot'));
		if ($frm->getPrefs('portal','prot_cont')=='none') {
			$protGui->assign('DISPLAY_ALL','none');
			$protGui->assign('DISPLAY_NONE','block');
			$protGui->assign('DISPLAY_CONT','none');
		} else {
			$protGui->assign('DISPLAY_ALL','block');
			$protGui->assign('DISPLAY_NONE','none');
			$protGui->assign('DISPLAY_CONT','block');
		}



		$search=array(
			'protComplete'=>0,
			'UserCreate'=>$Prot->getUser(),
		);
		$rows=0;
		$entries=$Prot->listObj($rows,$search,'TimeCreate DESC');
		if ($rows) {
			$T->loadModul('prot');
			$av_mode=array('I'=>$T->lang('[[Eingehend]]'),'O'=>$T->lang('[[Ausgehend]]'));
			require_once('lib/class_ApplicationListGui.php');
			$tabGui=new ApplicationListGui();
			$tabGui->setBorderColor('#ddc318');
			$tabGui->setHeaderColor('#fff7ce');
			$tabGui->addHeaderCol('protNumber',$T->lang('[[Protokollnummer]]'),'','','',1,'');
			$tabGui->addHeaderCol('TimeCreate',$T->lang('[[Erstellt am]]'),'','','',1,'');
			$tabGui->addHeaderCol('protMode',$T->lang('[[Protokollart]]'),'','','',1,'');
			foreach ($entries as $key=>$val) {
				$tabGui->addRow(($hl?$hl=0:$hl=1),'top');
				$link='index.php?site=prot.php&action=i&oid='.$val->getID();

				$tabGui->addCol('protNumber',$val->getMeta('protNumber'),'',$link,'',1,'');
				$tabGui->addCol('TimeCreate',date('d.m.Y H:i',$val->getMeta('TimeCreate')),'',$link,'',0,'2000');
				$tabGui->addCol('protMode',$av_mode[$val->getMeta('protMode')],'','','',1,'');
			}
			$protGui->assign('CONTENT',$tabGui);
		} else {
			$hidden_app['prot']=true;
		}
		$p_content['prot']=$protGui->process();
	}


	$containment=array();
	$sliders=array();
	for ($i=1;$i<=count($frame_cont);$i++) {
		$t->clear_dynamic('row_tpl_frame');
		$t->assign('FRM_NUM',$i);
		$t->assign('FRM_WIDTH',$tdWidth[$i-1].'%');
		if (is_array($frame_cont[$i])) {
			foreach ($frame_cont[$i] as $frame_app) {
				if ($p_content[$frame_app]) {
					$t->assign('TPL_FRAME',$p_content[$frame_app]);
					$t->assign('FRAME_ROW_ID','frmid_'.$frame_app);
					if ($hidden_app[$frame_app]) {
						$t->assign('SHOW_THIS','display:none;');
					} else {
						$t->assign('SHOW_THIS','');
					}
					$t->parse('ROW','.row_tpl_frame');
					unset($p_content[$frame_app]);
				}
			}
		}
		if ($i==count($frame_cont) && is_array($p_content)) {
			foreach ($p_content as $key=>$val) {
				$t->assign('TPL_FRAME',$val);
				$t->assign('FRAME_ROW_ID','frmid_'.$key);
				if ($hidden_app[$key]) {
					$t->assign('SHOW_THIS','display:none;');
				} else {
					$t->assign('SHOW_THIS','');
				}
				$frame_cont[$i][]=$key;
				$t->parse('ROW','.row_tpl_frame');

			}
			$frm->insertPrefs('portal',array('frame_'.($i)=>implode(',',$frame_cont[$i])));
		} else {
			$sliders[]='track-'.$i;
		}
		$t->parse('ROW','.col_show_width');
		$t->parse('ROW','.col_tpl_frame');
		$containment[]='pl'.$i;
	}
	foreach ($containment as $val) {
		$t->assign('ID',$val);
		$t->assign('CONTAINMENT','"'.implode('","',$containment).'"');
		$t->parse('ROW','.sortable_create');
		$t->parse('ROW','.sortable_destroy');
	}
	foreach ($sliders as $val) {
		$t->assign('ID',$val);
		$t->parse('ROW','.sliders');
	}
	if (!empty($sliderPos) && !empty($sliders)) {
		$sliderVals=array();
		for ((float)$i=0;$i<100;$i+=1) {
			$sliderVals[]=$i/100;
		}
		$t->assign('JS_SLIDER_POS',implode(',',$sliderPos));
		$t->assign('JS_SLIDER_CREATE',"'".implode("','",$sliders)."'");
		$t->assign('JS_SLIDER_VALUES',implode(',',$sliderVals));
		$t->parse('ROW','use_sliders');
	}

	foreach ($hidden_app as $key=>$val) {
		$t->assign('HIDDEN_APP',$key);
		$t->parse('ROW','.hidden_apps');
	}
}

?>
