<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$prefData=$frm->getPrefs($app_name);

$form_action="index.php?site=$site&app_name=$app_name&action=$action";
$t->assign("FORM_ACTION",$form_action);
$parse_card=array();
$cardTitle=array();
$listFields=$Addr->getlistFields();
$selFieldArray=array($T->lang('[[AddrCard_n]]')=>array(-1=>$T->lang('[[Name]]')));
foreach ($Addr->getFields() as $key=>$val) {
	if (!$cardTitle[$val['Card']]) {
		$cardTitle[$val['Card']]=$T->lang('[[AddrCard_'.$val['Card'].']]');
	}
	switch ($val['Typ']) {
		case 'stamm':
		case 'perm':

		break;
		case 'title':
			$cardTitle[$val['Card']]=$val['Title'];
		break;
		default:
			if ($key!='Name') {
				if (in_array($key,$listFields)) {
					$selFieldArray[$cardTitle[$val['Card']]][$key]=$val['Title'];
				} else {
					$avFieldArray[$cardTitle[$val['Card']]][$key]=$val['Title'];
				}
			}
	}
}
$cTitle=$T->lang('[[Internes - Feld]]');
foreach ($Addr->getIntFields() as $key=>$val) {
	if (in_array($key,$listFields)) {
		$selFieldArray[$cTitle][$key]=$T->lang($val['Name']);
	} else {
		$avFieldArray[$cTitle][$key]=$T->lang($val['Name']);
	}
}


require_once('lib/class_FormGui.php');
$formGui=new FormGui();
$formGui->setLabelClass('no','no_error');
$key='avFields';
$formGui->addField($key,'select_grp',$T->lang('[[Alle Felder]]'),'','fields1');
$formGui->setValues($key,$avFieldArray);
$formGui->setAttribs($key,array('multiple'=>'multiple','size'=>20));

$key='selFields';
$formGui->addField($key,'select_grp',$T->lang('[[Angezeigte Felder]]'),'','fields2');
$formGui->setValues($key,$selFieldArray);
$formGui->setAttribs($key,array('multiple'=>'multiple','size'=>20));

$t->assign('SEL_AV_FIELDS',$formGui->process('','fields1'));
$t->assign('SEL_SEL_FIELDS',$formGui->process('','fields2'));

if (!defined('ADDR_MODE') || ADDR_MODE!='ldap') {
	$key='nameMode';
	$formGui->addField($key,'select','',$prefData[$key],'fields_'.$key);
	$formGui->setValues($key,array(
		'fnv'=>$Addr->getFieldData('Firma','Title').', '.$Addr->getFieldData('Nachname','Title').' '.$Addr->getFieldData('Vorname','Title'),
		'fvn'=>$Addr->getFieldData('Firma','Title').', '.$Addr->getFieldData('Vorname','Title').' '.$Addr->getFieldData('Nachname','Title'),
		'nv'=>$Addr->getFieldData('Nachname','Title').' '.$Addr->getFieldData('Vorname','Title'),
		'vn'=>$Addr->getFieldData('Vorname','Title').' '.$Addr->getFieldData('Nachname','Title'),
	));
	$t->assign('SEL_NAME_MODE',$formGui->process('','fields_'.$key));
	$t->parse('ROW','name_mode');
}

$key='limit';
$formGui->addField($key,'select','',$prefData[$key],'fields_'.$key);
$formGui->setValues($key,array(20=>20,50=>50,100=>100,500=>500));
$t->assign("NUM_F",$formGui->process('','fields_'.$key));


$key='exmod';
$formGui->addField($key,'select','',$prefData[$key],'fields_'.$key);
$formGui->setValues($key,array('csv'=>$T->lang('[[CSV - Datei]]'),'xls'=>$T->lang('[[XLS - Datei]]')));
$t->assign("SEL_EXMOD",$formGui->process('','fields_'.$key));

$key='exchar';
$formGui->addField($key,'select','',$prefData[$key]?$prefData[$key]:GE_CHARSET,'fields_'.$key);
$formGui->setValues($key,array('UTF-8'=>$T->lang('[[Unicode (UTF-8)]]'),'ISO-8859-1'=>$T->lang('[[Europaeisch (iso)]]')));
$t->assign("SEL_EXCHAR",$formGui->process('','fields_'.$key));

if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
	$myBooks=$Addr->getMyBooks();
	foreach ($myBooks as $key=>$val) {
		if ($key==$std_view) {
			$t->assign('F_SEL','selected');
		} else {
			$t->assign('F_SEL','');
		}
		$t->assign('F_VAL',$key);
		$t->assign('F_NAME',Framework::entities($val->getName()));
		$t->parse('ROW','.book_row');
	}
	$t->parse('ROW','std_book');
}



$t->assign("USERNAME",$REG_USER[name]);
$t->assign("EMAIL",$REG_USER[email]);
$t->parse("FORM_TPL","form_tpl");
?>