<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
require_once('lib/class_FormGui.php');
$form_action="index.php?site=$site&app_name=$app_name&action=$action";
$t->assign("FORM_ACTION",$form_action);
$Task=$frm->getStaticModul('task');
$T->loadModul('task');
$formGui=new FormGui();

$root['s']=$Task->getSystemObj('s',$frm->getLang(),0,true);
$root['u']=$Task->getSystemObj('u',$frm->getLang(),$frm->getUser(),true);

$DocObj=null;
if ($obj['defCatID']) {
	$DocObj=$Task->getObj($obj['defCatID']);
}
$catTyp_array=array();
if (is_object($root['s'])) {
	$catTyp_array[$root['s']->getID()]=$root['s']->getName();
	if (!$DocObj) $DocObj=$root['s'];
}
if (is_object($root['u'])) {
	$catTyp_array[$root['u']->getID()]=$root['u']->getName();
	if (!$DocObj) $DocObj=$root['u'];
}
$defDocTyp=$DocObj->getMeta('RootID');

$key='CatTyp';
$formGui->addField($key,'radiolist_h',$T->lang('[[Kategorie]]'),$defDocTyp,'fields1');
$formGui->setValues($key,$catTyp_array);
$formGui->setAttribs($key,array('onclick'=>"document.daten.submit();",'onchange'=>"document.daten.submit();"));

$key='defCatID';
$doc_array=$Task->ListSubEntrys($formGui->getFieldVal('CatTyp',1),'','Title_'.$frm->getLang());
$formGui->addField($key,'select','',$obj['defCatID'],'fields1');
$formGui->setValues($key,array(0=>'-') + $frm->extractObjMeta($doc_array,'Title_'.$frm->getLang()));

$key='defPrio';
$priority_array=array(0=>$T->lang('[[HOCH]]'),1=>$T->lang('[[NORMAL]]'),2=>$T->lang('[[NIEDRIG]]'));
$formGui->addField($key,'radiolist_h',$T->lang('[[Prioritaet]]'),isset($obj['defPrio'])?$obj['defPrio']:1,'fields1');
$formGui->setValues($key,$priority_array);

$key='defNotes';
$formGui->addField($key,'check',$T->lang('[[Benachrichtigungsservice]]'),isset($obj['defNotes'])?$obj['defNotes']:0,'fields1');

$t->assign('FORM_CONTENT',$formGui->process());


$t->parse("FORM_TPL","form_tpl");
?>
