<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$l_this="index.php?site=$site&action=$action&oid=$oid";
$t->assign('FORM_ACTION',$l_this);
$t->assign('L_THIS',$l_this);
if ($oid) {
	if ($meta_save_x) {
		$Reg->updateAction($oid,$meta);
		page_close();
		header ("Location:index.php?site=$site&action=$action&oid=$oid");
		exit;
	}
	if ($meta_save_as_x) {
		if ($oid=$Reg->insertAction($meta)) {
			page_close();
			header ("Location:index.php?site=$site&action=$action&oid=$oid");
			exit;
		}
	}
	if ($meta_delete_x) {
		if ($Reg->deleteAction($oid)) {
			page_close();
			header ("Location:index.php?site=$site&action=$action");
			exit;
		}
	}
	if ($sql_export_x) {
		$data=$Reg->getActionData($oid);
		if (!empty($data)) {
			$sql='';
			foreach ($data as $values) {
				$sql.=$Reg->arrayToSql('ObjAction',$values)."\n";
			}
			$t->assign('EXPORT_SQL_DATA',$sql);
			$t->parse('ROW','export_sql_data');
		}
	}
	$t->assign('OBJ_NAME',$tree[$oid]['Name_'.$session_lang]);
	$t->parse('ROW','update');
	$t->parse('ROW','delete');
	$t->parse('ROW','sql_export');
} else {
	if ($meta_export_x) {
		$data=$Reg->getActionData();
		//debug($data);
		if (!empty($data)) {
			page_close();
			$frm->exportCsv($data,',',true,'ObjAction.csv');
		}
	}
	if ($sql_export_x) {
		$data=$Reg->getActionData();
		if (!empty($data)) {
			$sql='';
			foreach ($data as $values) {
				$sql.=$Reg->arrayToSql('ObjAction',$values)."\n";
			}
			$t->assign('EXPORT_SQL_DATA',$sql);
			$t->parse('ROW','export_sql_data');
		}
	}
	if ($meta_save_x) {
		if ($_FILES['csv_file'] && $csv_file && file_exists($csv_file)) {
			$csv_data=$frm->importCsv ($csv_file,',',true);
			if (is_array($csv_data)) {
				foreach ($csv_data as $row) {
					//debug($row);
					$Reg->replaceAction($row);
				}
				page_close();
				header ("Location:index.php?site=$site&action=$action");
				exit;
			}
		} elseif ($meta['Action']) {
			if ($oid=$Reg->insertAction($meta)) {
				page_close();
				header ("Location:index.php?site=$site&action=$action&oid=$oid");
				exit;
			}
		}
	}
	$t->assign('OBJ_NAME','');
	$t->parse('ROW','update');
	$t->parse('ROW','export');
	$t->parse('ROW','upload_box');
	$t->parse('ROW','sql_export');
}

$Field['ACTION']=new TextField('meta[Action]','size="30" class="sel" style="width:300px"','0','%',$tree[$oid]['Action']);
$t->assign('FOCUS_FIELD','meta[Action]');
$Field['NAME_DE']=new TextField('meta[Name_de]','size="30" class="sel" style="width:300px"','0','%',$tree[$oid]['Name_de']);
$Field['NAME_IT']=new TextField('meta[Name_it]','size="30" class="sel" style="width:300px"','0','%',$tree[$oid]['Name_it']);
$Field['NAME_EN']=new TextField('meta[Name_en]','size="30" class="sel" style="width:300px"','0','%',$tree[$oid]['Name_en']);
$Field['NAME_FR']=new TextField('meta[Name_fr]','size="30" class="sel" style="width:300px"','0','%',$tree[$oid]['Name_fr']);
foreach ($Field as $key=>$val) {
	$t->assign($key,$val->f());
}

?>
