<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$l_this="index.php?site=$site&action=$action&oid=$oid";
$t->assign('FORM_ACTION',$l_this);
$t->assign('L_THIS',$l_this);

if ($oid) {
	$oid_ar=explode('/',$oid);
	$modul=$oid_ar[0];
	$mode=$oid_ar[1];
	$action_id=$oid_ar[2];


	$obj=$Reg->getActionObj($modul,$mode,$action_id);
	if ($meta_export_x) {
		$data=$Reg->getActionObjData($modul,$mode,$action_id);
		//debug($data);
		if (!empty($data)) {
			page_close();
			$frm->exportCsv($data,',',true,'ObjActionModul_'.$modul.'.csv');
		}
	}
	if ($sql_export_x) {
		$data=$Reg->getActionObjData($modul,$mode,$action_id);
		if (!empty($data)) {
			$sql='';
			foreach ($data as $values) {
				$sql.=$Reg->arrayToSql('ObjActionModul',$values)."\n";
			}
			$t->assign('EXPORT_SQL_DATA',$sql);
			$t->parse('ROW','export_sql_data');
		}
	}


	if (is_object($obj)) {
		if ($meta_save_x && $meta['Modul'] && $meta['Mode'] && $meta['FKActionID']) {
			if ($Reg->updateActionObj($obj->getMeta('Modul'),$obj->getMeta('Mode'),$obj->getMeta('FKActionID'),$meta)) {
				page_close();
				header ("Location:index.php?site=$site&action=$action&oid=".$meta['Modul'].'/'.$meta['Mode'].'/'.$meta['FKActionID']);
				exit;
			}
		}
		if ($meta_save_as_x && $meta['Modul'] && $meta['Mode'] && $meta['FKActionID']) {
			if ($Reg->insertActionObj($meta)) {
				page_close();
				header ("Location:index.php?site=$site&action=$action&oid=".$meta['Modul'].'/'.$meta['Mode'].'/'.$meta['FKActionID']);
				exit;
			}
		}
	} else {
		if ($meta_save_x && $meta['Modul'] && $meta['Mode'] && $meta['FKActionID']) {
			if ($Reg->insertActionObj($meta)) {
				page_close();
				header ("Location:index.php?site=$site&action=$action&oid=".$meta['Modul'].'/'.$meta['Mode'].'/'.$meta['FKActionID']);
				exit;
			}
		}
		$obj=new ActionObj($oid,array('Modul'=>$modul,'Mode'=>$mode,'FKActionID'=>$action_id));
	}
	if ($meta_delete_x && $modul) {
		if ($Reg->deleteActionObj($modul,$mode,$action_id)) {
			page_close();
			header ("Location:index.php?site=$site&action=$action");
			exit;
		}
	}
	$t->parse('ROW','sql_export');

} else {
	if ($meta_export_x) {
		$data=$Reg->getActionObjData();
		//debug($data);
		if (!empty($data)) {
			page_close();
			$frm->exportCsv($data,',',true,'ObjActionModul_ALL.csv');
		}
	}

	if ($meta_save_x) {
		if ($_FILES['csv_file'] && $csv_file && file_exists($csv_file)) {
			$csv_data=$frm->importCsv ($csv_file,',',true);
			if (is_array($csv_data)) {
				foreach ($csv_data as $row) {
					if (!$parsed[$row['Modul']]) {
						$Reg->deleteActionObj($row['Modul']);
						$parsed[$row['Modul']]=1;
					}
					$Reg->insertActionObj($row);
				}
				page_close();
				header ("Location:index.php?site=$site&action=$action");
				exit;
			}
		} elseif ($meta['Modul'] && $meta['Mode'] && $meta['FKActionID']) {
			if ($Reg->insertActionObj($meta)) {
				page_close();
				header ("Location:index.php?site=$site&action=$action&oid=".$meta['Modul'].'/'.$meta['Mode'].'/'.$meta['FKActionID']);
				exit;
			}
		}
	}
	$obj=new ActionObj();
	$t->parse('ROW','upload_box');
}

if (is_object($obj)) {
	$action_array=$Reg->ListActions($session_lang);

	$Field['FKACTIONID']=new SelectField('meta[FKActionID]','class="sel" style="width:300px"',$action_array,$obj->getMeta('FKActionID'));
	$t->assign('FOCUS_FIELD','meta[FKActionIDl]');

	$Field['MODUL']=new TextField('meta[Modul]','size="30" class="sel" style="width:300px"','0','%',$obj->getMeta('Modul'));
	$Field['MODE']=new TextField('meta[Mode]','size="30" class="sel" style="width:300px"','0','%',$obj->getMeta('Mode'));
	$Field['PERMS']=new TextField('meta[Perms]','size="30" class="sel" style="width:300px"','0','%',$obj->getMeta('Perms'));
	$Field['EXTRA']=new TextField('meta[Extra]','size="30" class="sel" style="width:300px"','0','%',$obj->getMeta('Extra'));

	$Field['SEQUENCE']=new TextField('meta[Sequenze]','size="10" class="sel" style="width:100px"','0','%',$obj->getMeta('Sequenze'));
	$Field['HIDDEN']=new CheckBox('meta[Hidden]','','1',$obj->getMeta('Hidden'));
	$Field['CUSTOM']=new TextField('meta[Custom]','size="30" class="sel" style="width:300px"','0','%',$obj->getMeta('Custom'));
	foreach ($Field as $key=>$val) {
		$t->assign($key,$val->f());
	}
	$t->assign('OBJ_NAME',$obj->getID());

}



$p_update=true;

$t->parse('ROW','export');

if ($p_update) {
	$t->parse('ROW','update');
	$t->parse('ROW','delete');
}

/*
$t->assign('L_BREAK',"#");
$t->parse('ROW','break');
*/
?>
