<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->assign('MOD_TITLE',$frm->getAppName('stel'));
if (!$app["stel"]) {
	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
} else {
	$Stel=& $frm->getStaticModul('stel');
	$T->loadModul('stel');
	require_once('lib/class_form.inc.php');
	$wd=& $frm->getStaticModul('workday');

	$t->setRoot("tpl/$THEME/stel/$session_lang");
	$t->define (array('application' => "header.inc.html"));
	$t->assign('V_ON','off');
	$t->assign('A_ON','off');
	$t->assign('I_ON','off');
	$t->parse('ROW','text_other');
	$text_other=$t->getParsed('text_other');
	$t->clear_dynamic('text_other');

	if (!$action) $action='v';

	if ($action=="v") {
		$t->assign('V_ON','on');
		$t->define (array('tpl_card' => "view.inc.html"));
		require("stel/view.php");
		$t->parse('TPL_CARD','tpl_card');
	}
	if ($Stel->getPerms(2)) {
		if ($action=="i") {
			$t->assign('I_ON','on');
			require("lib/stel/class_stelGui.php");
			$stelGui=new stelGui();
			$contGui=$stelGui->getInsertGui();
			$t->assign('TPL_CARD',$contGui->process());
		}
		$t->parse('ROW','head_i');
	}
	if ($Stel->getPerms(4)) {
		if ($action=="a") {
			if ($print_x) {
				$t->define (array('tpl_card' => "print_auswertung.inc.html"));
				require("stel/print_auswertung.php");
				$t->parse('TPL_CARD','tpl_card');
			} else {
				$t->assign('A_ON','on');
				$t->define (array('tpl_card' => "view_auswertung.inc.html"));
				require("stel/view_auswertung.php");
				$t->parse('TPL_CARD','tpl_card');
			}
		}
		$t->parse('ROW','head_a');
	}
	if ($print_x) {
		$PrintID=$frm->insertPrint('stel','html',$t->getparsed('TPL_CARD'));
		page_close();
		header("Location:print.php?PrintID=$PrintID");
		exit;
	}

	if ($ActionError) {
		$t->unload('tpl_error');
		$t->define (array('tpl_error' => "error.inc.html"));
		foreach ($ActionError as $key=>$val) {
			if ($t->issetkey('error_'.$key)) {
				$t->parse('ROW','error_'.$key);
			}
		}

		$t->parse('TPL_ERROR','.tpl_error');
	}
	if ($E->isError()) {
		$t->assign('TPL_ERROR',$E->process());
	}

}


?>
