<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$lang=strtoupper($session_lang);
$all_perms=$Stel->getAllPerms('l');
if (is_array($all_perms['l'])) {
	$sel_group=key($all_perms['l']);
} else {
	$sel_group=$CFG['GROUP_ALL'];
}
$user_array=array(-1=>$text_other) + $frm->getFullName($frm->getGroupUsers($sel_group));
$cat_array=$Stel->listAllCat($session_lang);
$telUsers=array(-1=>$text_other);

$t->parse('ROW','title_t');
$title['t']=$t->getParsed('title_t');
$t->clear_dynamic('title_t');
$t->parse('ROW','title_c');
$title['c']=$t->getParsed('title_c');
$t->clear_dynamic('title_c');
$t->parse('ROW','title_u');
$title['u']=$t->getParsed('title_u');
$t->clear_dynamic('title_u');

$t->parse('ROW','text_all');
$text_all=$t->getParsed('text_all');
$t->clear_dynamic('text_all');

$t->parse('ROW','text_other');
$text_other=$t->getParsed('text_other');
$t->clear_dynamic('text_other');


if ($sqlBegin) {
	$t->assign('TIME_BEGIN',date('d.m.Y',$sqlBegin));
} else {
	$t->assign('TIME_BEGIN','-');
}
if ($sqlEnd) {
	$t->assign('TIME_END',date('d.m.Y',$sqlEnd-1));
} else {
	$t->assign('TIME_END','-');
}
if ($TelCatID) {
	$t->assign('TEL_CAT',Framework::entities($cat_array[$TelCatID]['Name_'.$session_lang]));
} else {
	$t->assign('TEL_CAT',$text_all);
}

if ($TelUser) {
	$sqlUser=substr($TelUser,1);
	if ($TelUser[0]=='G') {
		$t->assign('TEL_USER',Framework::entities($frm->getCachedGroupName($sqlUser)));
		$sqlUser=$frm->getGroupUsers($sqlUser);
	} else {
		$t->assign('TEL_USER',Framework::entities($user_array[$sqlUser]));
	}
} else {
	$sqlUser=0;
	$t->assign('TEL_USER',$text_all);
}
if ($mode=='d') {
	$ausw=$Stel->listDetails($sqlBegin,$sqlEnd,$TelCatID,$sqlUser,$OrderBy,$b,$limit);
	$j=0;
	foreach ($ausw as $teluid=>$uidval) {
		if (!isset($telUsers[$teluid])) {
			$temp=$frm->getFullName($teluid,0,1);
			$telUsers[$teluid]=$temp[$teluid];
		}
		$t->assign("N_TELUSER",Framework::entities($telUsers[$teluid]));
		$t->clear_dynamic('telcat_row');
		$sum_uid=0;

		foreach ($uidval as $cat_id=>$cat_val) {
			$t->assign("N_TELCAT",Framework::entities($cat_array[$cat_id]['Name_'.$session_lang]));
			$t->clear_dynamic('teltime_row');
			$sum_cat=0;
			foreach ($cat_val as $teltime=>$time_val) {
				$t->assign("N_TELTIME",Framework::entities($teltime));
				$t->clear_dynamic('det_row');
				$sum_date=0;
				foreach ($time_val as $tid=>$det) {
					$t->assign('TEL_TIME',date('H:i',$det['TelTime']));
					$t->assign("TEL_FROM",Framework::entities($det['TelFrom']));
					$t->assign("TEL_DESC",Framework::entities($det['Description']));
					$t->parse('ROW','.det_row');
					$sum_date+=1;
				}
				$t->assign('SUM_TELTIME',intval($sum_date));
				$t->parse('ROW','.teltime_row');
				$sum_cat+=$sum_date;
			}
			$t->assign('SUM_TELCAT',intval($sum_cat));
			$t->parse('ROW','.telcat_row');
			$sum_uid+=$sum_cat;
		}
		$t->assign('SUM_TELUSER',intval($sum_uid));
		$t->parse('ROW','.teluser_row');
	}
	$t->parse('ROW','mode_d');
} else {

	$t->assign('TITLE_1','&nbsp;');
	$t->assign('TITLE_2','&nbsp;');
	$t->assign('TITLE_3','&nbsp;');
	$t->assign('TEXT_1','&nbsp;');
	$t->assign('TEXT_2','&nbsp;');
	$t->assign('TEXT_3','&nbsp;');

	unset($txt_group);
	foreach (array_keys($sqlGroupBy) as $val) {
		$txt_group[]=$title[$val];
	}
	if (is_array($txt_group)) {
		$t->assign('GROUPBY',implode(' > ',$txt_group));
	}
	$rows=0;
	$summe=0;

	$search=array(
		'TimeB'=>$sqlBegin,
		'TimeE'=>$sqlEnd,
		'TelCatID'=>$TelCatID,
		'TelUser'=>$sqlUser,
		'GroupBy'=>$sqlGroupBy,
		'noPerms'=>1,
	);
	$ausw=$Stel->listAuswertung($rows,$summe,$search,$OrderBy,$b,$limit);

	foreach (array_keys($sqlGroupBy) as $key=>$val) {
		$t->assign('TITLE_'.($key+1),$title[$val]);
	}
	$j=0;
	foreach ($ausw as $key=>$val) {
		$i=1;
		foreach ($sqlGroupBy as $field) {
			switch ($field) {
				case 'TelCatID':
					$t->assign("TEXT_$i",Framework::entities($cat_array[$val[$field]]['Name_'.$session_lang]));
				break;
				case 'TelUser':
					if (!isset($telUsers[$val[$field]])) {
						$temp=$frm->getFullName($val[$field],0,1);
						$telUsers[$val[$field]]=$temp[$val[$field]];
					}
					$t->assign("TEXT_$i",Framework::entities($telUsers[$val[$field]]));
				break;
				case 'TelTime':
					$t->assign("TEXT_$i",Framework::entities(date('d.m.Y',$val[$field])));
				break;
			}
			$i++;

		}
		$t->assign('NUM_TEL',intval($val['Num']));

		if ($j) {
			$t->assign('ROW_COLOR',$bgcolor);
			$j=0;
		} else {
			$t->assign('ROW_COLOR','#f2f2f2');
			$j=1;
		}


		$t->parse('ROW','.list_row');
	}
	$t->assign('NUM_TEL_SUM',intval($summe));
	$t->parse('ROW','mode_g');
}

?>