<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array('tpl_entry' => "view_entry.inc.html"));
if ($pre["global"]['lay']) $t->define (array('tpl_layer' => "layers.inc.html"));
if (!$bdate) $bdate=mktime(0,0,0,date('m'),date('d')-3,date('Y'));
if (!$edate) $edate=mktime(23,59,0,date('m',$bdate),date('d',$bdate)+8,date('Y',$bdate));
$bmonth=date('m',$bdate);
$byear=date('Y',$bdate);
$adate=mktime(0,0,0);
$aldate=date('Y-m-d');
$lang=strtoupper($session_lang);
$cat_array=$Stel->listAllCat($session_lang);
$cat=array();
foreach ($cat_array as $key=>$val) {
	$cat[$key]=$val['Name_'.$session_lang];
}
$list=$Stel->listEntries($bdate,$edate);
$ldate=$bdate+3600*12;
for ($i=1;$i<10;$i++) {
	$day=date('Y-m-d',$ldate);
	$sum_dur=0;
	if (is_array($list[$day])) {
		$j=0;
		foreach ($list[$day] as $key=>$val) {
			$t->assign('TELTIME',date('H:i',$val['TelTime']));
			$t->assign('TELFROM',FrameWork::entities($val['TelFrom']));
			if ($j==1) {
				$t->assign('ROW_COLOR','#f2f2f2');
				$j=0;
			} else {
				$t->assign('ROW_COLOR',$bgcolor);
				$j=1;
			}
			if ($Stel->getPerms(2)) {
				$t->assign('L_EDIT',"index.php?site=$site&action=i&ID=$key&bdate=$bdate");
			} else {
				$t->assign('L_EDIT',"#");
			}

			$lay_array=array();
			$lay_array[$T->lang('[[Anruf fuer]]').': ']=Framework::entities($val['TelUser']==-1?$T->lang('[[Andere]]'):$frm->getCachedUserName($val['TelUser']));
			$lay_array[$T->lang('[[Kategorie]]').': ']=Framework::entities($cat[$val['TelCatID']]);
			if ($val['FKProjID'] && is_object($P)) {
				$lay_array[$T->lang('[[Projekt]]').': ']=Framework::entities($P->getCachedProjectName($val['FKProjID']));
			}
			if ($val['Description']) {
				$lay_array[$T->lang('[[Beschreibung]]').':']='<div>'.Framework::entities($val['Description']).'</div>';
			}

			$t->assign('LAY_LINK',' onMouseOver="'.$Y->getFunctionOn('stel_'.$key).'" onMouseOut="'.$Y->getFunctionOff('stel_'.$key).'"');

			$lay_title=date('H:i',$val['TelTime']).' '.FrameWork::entities($val['TelFrom']);
			$Y->addLayer('stel_'.$key,$lay_array,'array',0,$lay_title);

			$t->parse('ROW','.entry');
		}
	}
	if ($day==$aldate) {
		$t->assign('DAY_DATE','<strong>'.strftime('%a %d.%m.%Y',$ldate).'</strong>');
		$t->assign('BORDER_COLOR','#ff0000');
	} else {
		$t->assign('DAY_DATE',strftime('%a %d.%m.%Y',$ldate));
		$t->assign('BORDER_COLOR',$fgcolor);
	}
	if ($Stel->getPerms(2)) {
		$t->assign('L_ADD',"index.php?site=$site&action=i&bdate=$bdate&TelTime=".$ldate);
		$t->parse('ROW','stel_add');
	}
	$t->parse("ENTRY_$i",'tpl_entry');
	$t->clear_dynamic('entry');
	$t->clear_dynamic('stel_add');
	$ldate+=3600*24;
}

$t->define (array('tpl_root' => "view_cal.inc.html"));
$kw_num=strftime("%V",$bdate);
$listbeginn=mktime (0,0,0,$bmonth,1,$byear);
$days=date("t",$listbeginn);
$startday=date("w",$listbeginn)-1;
if ($startday<0) $startday=6;
if (($startday+$days)>35) $cells=42; else $cells=35;
$listend=mktime(0,0,0,$bmonth,1-$startday+$cells,$byear);
if ($listend<$edate) $cells+=7;

$t->assign("PREV_LINK","index.php?site=$site&action=$action&bdate=".mktime(0,0,0,$bmonth-1,1,$byear));
$t->assign("NEXT_LINK","index.php?site=$site&action=$action&bdate=".mktime(0,0,0,$bmonth+1,1,$byear));
$t->assign("SEL_MONTH",Framework::entities(strftime("%B",$listbeginn)." ".strftime("%Y",$listbeginn)));

for($cell=1;$cell<=$cells;$cell++){
	$day=$cell-$startday;
	$celldate=mktime(0,0,0,$bmonth,$day,$byear);

	if ($celldate >= $bdate && $celldate < $edate) {
		$t->assign("CAL_COL_COLOR","bgcolor=\"#e2e2e2\"");
	} else {
		$t->assign("CAL_COL_COLOR","");
	}
	if ($celldate==$adate) {
		$t->assign("CAL_BG"," class=\"calborder\"");
	} else {
		$t->assign("CAL_BG","");
	}

	$t->assign("CAL_DAY_NUM","<a href=\"index.php?site=$site&action=$action&bdate=$celldate\">".date('j',$celldate)."</a>");
	$t->parse("COL",".month_col");
	if ($cell%7==1) {
		$cell_kw=strftime("%V",$celldate);
		if ($cell_kw==$kw_num) {
			$t->assign("KW_BG","$fg20color");
		} else {
			$t->assign("KW_BG","$fg10color");
		}
		$t->assign("KW_NUM","<a href=\"index.php?site=$site&action=$action&bdate=$celldate\">$cell_kw</a>");

	}
	if ($cell%7==0) {
		$t->parse("ROW",".month_row");
		$t->clear_dynamic("month_col");
	}
}
if ($pre["global"]['lay']) $t->parse("TPL_LAYERS","tpl_layer"); else  $t->assign("TPL_LAYERS","");
$t->parse("TPL_ROOT",'tpl_root');
?>