<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->define (array('tpl_root' => "view_cfg_auswertung.inc.html"));
$all_perms=$Stel->getAllPerms('l');
if (is_array($all_perms['l'])) {
	$sel_group=array_keys($all_perms['l']);
} else {
	$sel_group=$CFG['GROUP_ALL'];
}
$user_array=array(-1=>$text_other) + $frm->getFullName($frm->getGroupUsers($sel_group));
$cat_array=$Stel->listAllCat($session_lang);
$group_array=$frm->getAllGroups($sel_group);
$telUsers=array(-1=>$text_other);
$TimeBegin=$frm->parseDate($TimeBegin,0,0,0);
$TimeEnd=$frm->parseDate($TimeEnd,23,59,59);

if ($TimeBegin) {
	$t->assign('F_TIME_BEGIN',date('d/m/Y',$TimeBegin));
} else {
	$t->assign('F_TIME_BEGIN','--/--/----');
}
if ($TimeEnd) {
	$t->assign('F_TIME_END',date('d/m/Y',$TimeEnd));
} else {
	$t->assign('F_TIME_END','--/--/----');
}

$sqlGroupBy=array();
for ($i=1;$i<4;$i++) {
	if ($GroupBy[$i] && !isset($sqlGroupBy[$GroupBy[$i]])) {
		switch ($GroupBy[$i]) {
			case 'c':
				$sqlGroupBy['c']='TelCatID';
			break;
			case 'u':
				$sqlGroupBy['u']='TelUser';
			break;
			case 't':
				$sqlGroupBy['t']='TelTime';
			break;
		}
	} else {

	}
}
$i=0;
unset($GroupBy);
$OrderBy='';
foreach ($sqlGroupBy as $key=>$val) {
	$GroupBy[++$i]=$key;
	if ($OrderBy) $OrderBy.=',';
	$OrderBy.="$val ASC";

}



if ($TelUser) {
	$sqlUser=substr($TelUser,1);
	if ($TelUser[0]=='G') {
		$sqlUser=$frm->getGroupUsers($sqlUser);
	}
} else {
	$sqlUser=0;
}

if ($TimeBegin) {
	$sqlBegin=$TimeBegin;
} else {
	$sqlBegin=0;
}

if ($TimeEnd) {
	$sqlEnd=$TimeEnd;
} else {
	$sqlEnd=0;
}
if ($mode=='d') {
	$t->assign('S_GP_DIS','disabled="disabled"');
	if ($view_x) {
		$OrderBy="TelUser,TelCatID,TelTime";
		$rows=0;
		$b=0;
		$limit=0;
		$summe=0;
		$qlink="mode=$mode&sqlEnd=".$sqlEnd;
		$qlink.="&sqlBegin=".$sqlBegin;
		$qlink.="&TelCatID=".$TelCatID;
		$qlink.="&TelUser=".$TelUser;
		foreach ($sqlGroupBy as $key=>$val) {
			$qlink.="&sqlGroupBy[$key]=".$val;
		}
		$qlink.="&OrderBy=".urlencode($OrderBy);
		$qlink.="&b=".$b;
		$qlink.="&Limit=".$Limit;
		$ausw=$Stel->listDetails($sqlBegin,$sqlEnd,$TelCatID,$sqlUser,$OrderBy,$b,$limit);
		$j=0;
		foreach ($ausw as $teluid=>$uidval) {
			if (!isset($telUsers[$teluid])) {
				$temp=$frm->getFullName($teluid,0,1);
				$telUsers[$teluid]=$temp[$teluid];
			}
			$t->assign("N_TELUSER",Framework::entities($telUsers[$teluid]));
			$t->clear_dynamic('telcat_row');
			$sum_uid=0;

			foreach ($uidval as $cat_id=>$cat_val) {
				$t->assign("N_TELCAT",Framework::entities($cat_array[$cat_id]['Name_'.$session_lang]));
				$t->clear_dynamic('teltime_row');
				$sum_cat=0;
				foreach ($cat_val as $teltime=>$time_val) {
					$t->assign("N_TELTIME",Framework::entities($teltime));
					$t->clear_dynamic('det_row');
					$sum_date=0;
					foreach ($time_val as $tid=>$det) {
						$t->assign('TEL_TIME',date('H:i',$det['TelTime']));
						$t->assign("TEL_FROM",Framework::entities($det['TelFrom']));
						$t->assign("TEL_DESC",Framework::entities($det['Description']));
						$t->parse('ROW','.det_row');
						$sum_date+=1;
					}
					$t->assign('SUM_TELTIME',intval($sum_date));
					$t->parse('ROW','.teltime_row');
					$sum_cat+=$sum_date;
				}
				$t->assign('SUM_TELCAT',intval($sum_cat));
				$t->parse('ROW','.telcat_row');
				$sum_uid+=$sum_cat;
			}
			$t->assign('SUM_TELUSER',intval($sum_uid));
			$t->parse('ROW','.teluser_row');
		}
		$t->assign('L_PRINT',"index.php?site=$site&action=$action&print_x=1&".$qlink);
		$t->parse('ROW','print');
	}
	$t->parse('ROW','mode_d');

} else {
	$t->parse('ROW','title_t');
	$title['t']=$t->getParsed('title_t');
	$t->clear_dynamic('title_t');
	$t->parse('ROW','title_c');
	$title['c']=$t->getParsed('title_c');
	$t->clear_dynamic('title_c');
	$t->parse('ROW','title_u');
	$title['u']=$t->getParsed('title_u');
	$t->clear_dynamic('title_u');

	$t->assign('S_GP_DIS','');
	$t->assign('TITLE_1','&nbsp;');
	$t->assign('TITLE_2','&nbsp;');
	$t->assign('TITLE_3','&nbsp;');
	$t->assign('TEXT_1','&nbsp;');
	$t->assign('TEXT_2','&nbsp;');
	$t->assign('TEXT_3','&nbsp;');
	if ($view_x) {
		$rows=0;
		$b=0;
		$limit=0;
		$summe=0;
		$qlink="mode=$mode&sqlEnd=".$sqlEnd;
		$qlink.="&sqlBegin=".$sqlBegin;
		$qlink.="&TelCatID=".$TelCatID;
		$qlink.="&TelUser=".$TelUser;
		foreach ($sqlGroupBy as $key=>$val) {
			$qlink.="&sqlGroupBy[$key]=".$val;
		}
		$qlink.="&OrderBy=".$OrderBy;
		$qlink.="&b=".$b;
		$qlink.="&Limit=".$Limit;

		$search=array(
			'TimeB'=>$sqlBegin,
			'TimeE'=>$sqlEnd,
			'TelCatID'=>$TelCatID,
			'TelUser'=>$sqlUser,
			'GroupBy'=>$sqlGroupBy,
			'noPerms'=>1,
		);
		$ausw=$Stel->listAuswertung($rows,$summe,$search,$OrderBy,$b,$limit);

		foreach (array_keys($sqlGroupBy) as $key=>$val) {
			$t->assign('TITLE_'.($key+1),$title[$val]);
		}
		$j=0;
		foreach ($ausw as $key=>$val) {
			$i=1;
			foreach ($sqlGroupBy as $field) {
				switch ($field) {
					case 'TelCatID':
						$t->assign("TEXT_$i",Framework::entities($cat_array[$val[$field]]['Name_'.$session_lang]));
					break;
					case 'TelUser':
						if (!isset($telUsers[$val[$field]])) {
							$temp=$frm->getFullName($val[$field],0,1);
							$telUsers[$val[$field]]=$temp[$val[$field]];
						}
						$t->assign("TEXT_$i",Framework::entities($telUsers[$val[$field]]));
					break;
					case 'TelTime':
						$t->assign("TEXT_$i",Framework::entities(date('d.m.Y',$val[$field])));
					break;
				}
				$i++;

			}
			$t->assign('NUM_TEL',intval($val['Num']));

			if ($j) {
				$t->assign('ROW_COLOR',$bgcolor);
				$j=0;
			} else {
				$t->assign('ROW_COLOR','#f2f2f2');
				$j=1;
			}


			$t->parse('ROW','.list_row');
		}
		$t->assign('NUM_TEL_SUM',intval($summe));
		$t->assign('L_PRINT',"index.php?site=$site&action=$action&print_x=1&".$qlink);
		$t->parse('ROW','print');
	} else {
		$t->assign('ROW_COLOR','#f2f2f2');
		$t->assign('NUM_TEL','&nbsp;');
		$t->parse('ROW','list_row');
		$t->assign('NUM_TEL_SUM','0');
	}
	$t->parse('ROW','mode_g');

}

$link="js_cal.php?date=".time();
$t->assign('JS_CAL1',"NewWindow('$link&field=TimeBegin','Calendar',".$CFG['calwidth'].','.$CFG['calheight'].",0);");
$t->assign('JS_CAL2',"NewWindow('$link&field=TimeEnd','Calendar',".$CFG['calwidth'].','.$CFG['calheight'].",0);");



foreach ($cat_array as $key=>$val) {
	$t->assign('K_SEL',$key);
	$t->assign('V_SEL',FrameWork::entities($val['Name_'.$session_lang]));
	if ($key==$TelCatID) {
		$t->assign('S_SEL','selected');
	} else {
		$t->assign('S_SEL','');
	}
	$t->parse('ROW','.telcat');

}
if ($CFG['USER_LIST']) {
	$link="js_user.php?modul=stel&form=daten&field=TelUser&mult=0&prep=U";
	$t->assign('JS_USER',"NewWindow('$link','User',".$CFG['userwidth'].','.$CFG['userheight'].",0)");
} else {
	$t->assign('JS_USER','');
}
foreach ($user_array as $key=>$val) {
	$t->assign('K_USR',$key);
	$t->assign('V_USR',FrameWork::entities($val));
	if ('U'.$key==$TelUser) {
		$t->assign('S_USR','selected');
	} else {
		$t->assign('S_USR','');
	}
	$t->parse('ROW','.teluser');
}
foreach ($group_array as $key=>$val) {
	$t->assign('K_USR',$key);
	$t->assign('V_USR',FrameWork::entities($val));
	if ('G'.$key==$TelUser) {
		$t->assign('S_USR','selected');
	} else {
		$t->assign('S_USR','');
	}
	$t->parse('ROW','.telgroup');
}

for ($i=1;$i<4;$i++) {
	$t->assign("SEL_P_$i",'');
	$t->assign("SEL_C_$i",'');
	$t->assign("SEL_U_$i",'');
	if ($GroupBy[$i]) $t->assign("SEL_".strtoupper($GroupBy[$i])."_$i","selected");
}

if ($mode=='d') {
	$t->assign('S_MODE_D','checked');
	$t->assign('S_MODE_G','');
} else {
	$t->assign('S_MODE_D','');
	$t->assign('S_MODE_G','checked');
}

$t->assign('FORM_ACTION',"index.php?site=$site&action=$action&view_x=1");
$t->parse("TPL_ROOT",'tpl_root');
?>