<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$TaskObj=$Task->readTask($TaskID);
if (!$TaskObj) {
        page_close();
        header("Location:index.php?site=$site&action=b");
        exit;
}
$TaskUserObj=$Task->readTaskUser($TaskID,$user_id);
$TaskUsers=$Task->getTaskUsers($TaskID);
$SortedUsers=$frm->getFullName(array_keys($TaskUsers),0,1);
$t->assign('TASK_USER',Framework::entities($SortedUsers[$user_id]));
$NumInvited=0;
if ($TaskObj["Users"] || $TaskObj["Groups"]) {
	foreach ($TaskUsers as $val) {
		if ($val==5) continue;
		$NumInvited+=1;
	}
}

$t->assign('TASK_TITLE',Framework::entities($TaskObj[Title]));
$t->assign('TASK_TEXT',nl2br(Framework::entities($TaskObj[Text])));
$t->assign('TASK_START',strftime("%A, %d.%m.%Y",$TaskObj[StartDate]));
$t->assign('TIME_CREATE',date('d.m.Y',$TaskObj['TimeCreate']));
$t->assign('TASK_OWNER',$SortedUsers[$TaskObj['OwnerID']]);
$t->parse('ROW','prio_'.$TaskObj['Priority']);
if ($TaskObj['FKProjID'] && $P) {
	$pName=$P->getCachedProjectName($TaskObj['FKProjID']);
	if ($pName) {
		$t->assign("TASK_PROJECT",Framework::entities($pName));
		$t->parse('ROW','task_project');
	}
}

$CatObj=$Task->getObj($TaskObj['FKDocID'],$session_lang,false);
if (is_object($CatObj)) $t->assign('TASK_CAT',Framework::entities($CatObj->getName())); else $t->assign('TASK_CAT','-');

if ($TaskObj['EndDate']!=$TaskObj['StartDate']) {
	$t->assign('TASK_END',strftime("%A, %d.%m.%Y",$TaskObj[EndDate]));
	$t->parse('ROW','task_end');
}
if ($TaskObj['RecType']) {
        if ($TaskObj['RecInt']>1) $t->assign('REC_INT',' '.$TaskObj['RecInt']);
        else $t->assign('REC_INT','');
        $t->parse('ROW','recur_'.$TaskObj['RecType']);
        if ($TaskObj['RecDate']!=-1) {
                $t->assign('REC_END',strftime("%A, %d.%m.%Y",$TaskObj['RecDate']));
                $t->parse('ROW','rec_end');
        }
        $t->parse('ROW','recurence');
}
/*
if ($TaskObj[Alarm]) {
        $t->assign('TASK_ALARM',$TaskObj[Alarm]);
        $t->parse('ROW','y_alarm');
} else {
        $t->parse('ROW','n_alarm');
}

if ($TaskObj[Notes]) {
        $t->parse('ROW','y_notes');
} else {
        $t->parse('ROW','n_notes');
}
*/
if ($TaskObj['DoneOne']) {
        if ($NumInvited>1) $t->parse('ROW','done_one');
} else {
       if ($NumInvited>1) $t->parse('ROW','done_all');
}


if ($TaskUserObj['Done']!=2 && $TaskUserObj['Done']!=3) {
	$log_list=$Task->listLog($TaskID,'log','',$mode);
	foreach ($log_list as $val) {
		$t->assign('LOG_TEXT',nl2br(Framework::entities($val['Text'])));
		$t->assign('LOG_DATE',date('d.m.Y - H:i',$val['Date']));
		$t->assign('LOG_USER',$SortedUsers[$val['User']]);
		$t->parse('ROW','.log_row');

	}
	if (count($log_list)) $t->parse('ROW','.log_book');
}


foreach ($SortedUsers as $key=>$val) {
	$t->clear_dynamic('user_done');
	$t->clear_dynamic('user_wait');
	$t->clear_dynamic('user_log');
	if ($TaskUsers[$key]==5) continue;
	elseif ($TaskUsers[$key]==2) {
		$t->parse('ROW','user_wait');
	} elseif ($TaskUsers[$key]==4) {
		$t->parse('ROW','user_done');
	}
	$log_list=$Task->listLog($TaskID,array('accept','deny','done'),$key,$mode);
	foreach ($log_list as $logval) {
		$t->assign('LOG_TEXT',nl2br(Framework::entities($logval[Text])));
		$t->assign('LOG_DATE',date('d.m.Y',$logval[Date]));
		$t->assign('LOG_TITLE',htmlspecialchars($T->lang('task_action_'.$logval['Type'].'_title')));
		$t->parse('ROW','.user_log');

	}
	$t->assign('LOG_USER',$val);
	$t->parse('ROW','.user_row');

}
$t->parse('TPL_CARD','tpl_card');
$PrintID=$frm->insertPrint('task','html',$t->getparsed('TPL_CARD'));
page_close();
header("Location:print.php?PrintID=$PrintID");
exit;
?>
