<?php
function updateCustom ($VERSION) {
	global $db,$frm;
	$query=array();
	if ($VERSION < 1) {
		$query="REPLACE INTO `application` (`app_id` ,`app_name` ,`app_title` ,`app_title_it` ,`app_title_de` ,`app_title_en` ,`app_title_fr` ,`app_title_es` ,`app_url` ,`app_enabled` ,`app_order` ,`app_parent`) VALUES ('2000', 'custom', 'Intern', 'Interno', 'Intern', 'Intern', 'Intern', 'Intern', 'custom.php', '1', '2000', '');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('160','cus_blz','reha','0','','0','0');";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `customBlzReha` (
			`RehaID` int(11) NOT NULL,
			`FKAddrID` int(11) NOT NULL,
			`FKTyp` int(11) NOT NULL,
			`RehaUser` int(11) NOT NULL,
			`RehaDate` date NOT NULL,
			`RehaHelp` text NOT NULL,
			`RehaDesc` text NOT NULL,
			`RehaTraining` text NOT NULL,
			`RehaOK` tinyint(4) NOT NULL,
			`RehaPlaceKM` int(11) NOT NULL,
			`RehaPlaceStart` varchar(255) NOT NULL,
			`RehaPlaceEnd` varchar(255) NOT NULL,
			`RehaDuration` double NOT NULL,
			`FKCat` int(11) NOT NULL,
			`RehaBill` varchar(255) NOT NULL,
			`TimeCreate` int(11) NOT NULL,
			`TimeModify` int(11) NOT NULL,
			`UserCreate` int(11) NOT NULL,
			`UserModify` int(11) NOT NULL,
			PRIMARY KEY  (`RehaID`),
			KEY `FKAddrID` (`FKAddrID`)
			);";
		$db->query($query);

		$query="REPLACE INTO ObjAction (`ActionID`,`Action`,`Name_de`,`Name_it`,`Name_en`) VALUES ('163','custom_blz_r','------- Reha --------','--- Riabilitazione ---','--- Rehabilitation ---');";
		$db->query($query);
		$query="REPLACE INTO ObjAction (`ActionID`,`Action`,`Name_de`,`Name_it`,`Name_en`) VALUES ('164','custom_blz_r_n','Neue Reha anlegen','Nuova riabilitazione','New rehabilitation');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`,`Custom`) VALUES ('163','addr','addr','0','app_custom','200','0','perms=1&modul=reha');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`,`Custom`) VALUES ('164','addr','addr','0','app_custom','201','0','perms=1&modul=reha&action=n');";
		$db->query($query);

		$query="INSERT INTO `Version` ( `Modul` , `Version` , `UpdateDate` ) VALUES ('cus_blz', '1', '2008-01-10');";
		$db->query($query);

	}
	if ($VERSION < 1.1) {
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`,`Custom`) VALUES ('160','cus_blz','cal','0','','0','0','');";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS customBlzCal (
			CalID int(11) NOT NULL,
			CalTitle varchar(255) NOT NULL,
			CalDateStart datetime NOT NULL,
			CalDateEnd datetime NOT NULL,
			CalPlace varchar(255) NOT NULL,
			CalUser int(11) NOT NULL,
			FKGroup int(11) NOT NULL,
			CalDesc text NOT NULL,
			FKCat int(11) NOT NULL,
			TimeCreate int(11) NOT NULL,
			TimeModify int(11) NOT NULL,
			UserCreate int(11) NOT NULL,
			UserModify int(11) NOT NULL,
			Deleted tinyint(4) NOT NULL,
			PRIMARY KEY  (CalID)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS customBlzCalLog (
			LogID int(11) NOT NULL auto_increment,
			FKCalID int(11) NOT NULL,
			FKUserID int(11) NOT NULL,
			LogDate datetime NOT NULL,
			LogText text NOT NULL,
			LogPrivat int(11) NOT NULL,
			PRIMARY KEY  (LogID),
			KEY FKCalID (FKCalID)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS customBlzCalPart (
			PartID int(11) NOT NULL auto_increment,
			FKCalID int(11) NOT NULL,
			FKAddrID int(11) NOT NULL,
			PRIMARY KEY  (PartID),
			KEY FKCalID (FKCalID),
			KEY FKAddrID (FKAddrID)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS customBlzCalPartLog (
			PartLogID int(11) NOT NULL auto_increment,
			FKCalID int(11) NOT NULL,
			FKAddrID int(11) NOT NULL,
			FKPartTyp int(11) NOT NULL,
			FKUserID int(11) NOT NULL,
			PartDate datetime NOT NULL,
			PartText text NOT NULL,
			PRIMARY KEY  (PartLogID)
		);";
		$db->query($query);

		$query="UPDATE `Version` SET `Version` = '1.1',`UpdateDate`='2008-02-10' WHERE Modul='cus_blz';";
		$db->query($query);
	}
	if ($VERSION < 1.2) {

		$query="REPLACE INTO `Rules` (`RuleID` ,`Name_de` ,`Name_it` ,`Name_en` ,`Name_fr` ,`Name_es` ,`Perms`) VALUES ('110', 'Intern Administrator', 'Amministratore interno', 'Intern administrator', 'Intern administrator', 'Intern administrator', 'custom');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`,`Custom`) VALUES ('160','cus_blz','spd','0','','0','0','');";
		$db->query($query);
		$query="REPLACE INTO ModulCfgKeys (`CfgKey`,`Sequence`,`FKModul`,`Name_de`,`Name_it`,`Name_en`,`Name_fr`,`Name_es`,`FieldTyp`,`Size`,`CfgVal`) VALUES ('cfg/blz/addrSpdcat','10','custom','Adressen Kategorie Spenden','Categorie indirizzi per donazioni','Adressen Kategorie Spenden','','','text','1|30','');";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `customBlzSpd` (
			`ID` int(11) NOT NULL,
			`FKEmpfaengerID` int(11) NOT NULL,
			`FKAddrID` int(11) NOT NULL,
			`FKZweckID` int(11) NOT NULL,
			`Typ` char(1) NOT NULL,
			`Datum` date NOT NULL,
			`Betrag` decimal(10,2) NOT NULL,
			`Art` char(1) NOT NULL,
			`FKKontoID` int(11) NOT NULL,
			`Anmerkung` varchar(255) NOT NULL,
			`Quittung` tinyint(4) NOT NULL,
			`BuchungsArt` char(1) NOT NULL,
			`TimeCreate` int(11) NOT NULL,
			`UserCreate` int(11) NOT NULL,
			`TimeModify` int(11) NOT NULL,
			`UserModify` int(11) NOT NULL,
			PRIMARY KEY  (`ID`),
			KEY `FKAddressID` (`FKAddrID`),
			KEY `FKZweckID` (`FKZweckID`),
			KEY `Datum` (`Datum`),
			KEY `FKKontoID` (`FKKontoID`)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `customBlzSpdEmpfaenger` (
			`ID` int(11) NOT NULL,
			`Title_de` varchar(255) NOT NULL,
			`Title_it` varchar(255) NOT NULL,
			`Quittung_de` text NOT NULL,
			`Quittung_it` text NOT NULL,
			`PermsUsers` varchar(255) NOT NULL,
			`PermsGroup` varchar(255) NOT NULL,
			PRIMARY KEY  (`ID`)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `customBlzSpdKonto` (
			`ID` int(11) NOT NULL,
			`Title` varchar(255) NOT NULL,
			`Bank` varchar(255) NOT NULL,
			`Tel` varchar(255) NOT NULL,
			`Email` varchar(255) NOT NULL,
			`IBAN` varchar(255) NOT NULL,
			`FKEmpfaengerID` int(11) NOT NULL,
			PRIMARY KEY  (`ID`),
			KEY `FKEmpfaengerID` (`FKEmpfaengerID`)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `customBlzSpdZweck` (
			`ID` int(11) NOT NULL,
			`Title` varchar(255) NOT NULL,
			`Text` text NOT NULL,
			`DateB` date NOT NULL,
			`DateE` date NOT NULL,
			`Aktiv` tinyint(4) NOT NULL,
			`crmFieldPate` varchar(255) NOT NULL,
			`FKEmpfaengerID` int(11) NOT NULL,
			PRIMARY KEY  (`ID`),
			KEY `FKEmpfaengerID` (`FKEmpfaengerID`)
		);";
		$db->query($query);

		$query="UPDATE `Version` SET `Version` = '1.2',`UpdateDate`='2008-06-19' WHERE Modul='cus_blz';";
		$db->query($query);
	}

	if ($VERSION < 1.3) {
		if (!colExists('customBlzSpdZweck','crmViewFields')) {
			$query="ALTER TABLE `customBlzSpdZweck` ADD `crmViewFields` BLOB NOT NULL ;";
			$db->query($query);
		}
		$query="UPDATE `Version` SET `Version` = '1.3',`UpdateDate`='2008-07-21' WHERE Modul='cus_blz';";
		$db->query($query);
	}
	if ($VERSION < 1.4) {
		$query="REPLACE INTO ObjAction (`ActionID`,`Action`,`Name_de`,`Name_it`,`Name_en`) VALUES ('172','new','Neuer Versand','Nuova spedizione','New dispatch');";
		$db->query($query);
		$query="REPLACE INTO ObjAction (`ActionID`,`Action`,`Name_de`,`Name_it`,`Name_en`) VALUES ('173','edit','Versand bearbeiten','Modifica spedizione','Edit dispath');";
		$db->query($query);
		$query="REPLACE INTO ObjAction (`ActionID`,`Action`,`Name_de`,`Name_it`,`Name_en`) VALUES ('174','delete','".convertBlob('Versand lschen')."','Cancella spedizione','Delete dispath');";
		$db->query($query);

		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`,`Custom`) VALUES ('172','cus_blz','kas','0','','10','0','');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`,`Custom`) VALUES ('173','cus_blz','kas','0','ID','20','0','');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`,`Custom`) VALUES ('1','cus_blz','kas','0','ID','30','0','');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`,`Custom`) VALUES ('174','cus_blz','kas','0','ID','40','0','');";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `customBlzKas` (
			`ID` int(11) NOT NULL,
			`FKListID` int(11) NOT NULL,
			`Datum` date NOT NULL,
			`SendNumber` int(11) NOT NULL,
			PRIMARY KEY  (`ID`)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `customBlzKasList` (
			`ID` int(11) NOT NULL,
			`Title_de` varchar(255) NOT NULL,
			`Title_it` varchar(255) NOT NULL,
			`PermsUsers` varchar(255) NOT NULL,
			`PermsGroup` varchar(255) NOT NULL,
			`crmFieldNumber` varchar(255) NOT NULL,
			`crmViewFields` blob NOT NULL,
			PRIMARY KEY  (`ID`)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `customBlzKasSend` (
			`FKKasID` int(11) NOT NULL,
			`FKAddrID` int(11) NOT NULL,
			`Retour` tinyint(4) NOT NULL,
			`Anmerkung` varchar(255) NOT NULL,
			PRIMARY KEY  (`FKKasID`,`FKAddrID`)
		);";
		$db->query($query);

		$query="UPDATE `Version` SET `Version` = '1.4',`UpdateDate`='2008-10-20' WHERE Modul='cus_blz';";
		$db->query($query);
	}
	if ($VERSION < 1.5) {
		$query="REPLACE INTO ModulCfgKeys (`CfgKey`,`Sequence`,`FKModul`,`Name_de`,`Name_it`,`Name_en`,`Name_fr`,`Name_es`,`FieldTyp`,`Size`,`CfgVal`) VALUES ('cfg/blz/addrPazcat','20','custom','Adressen Kategorie Patienten','Categorie indirizzi per pazienti','Adressen Kategorie Patienten','','','text','1|30','');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`,`Custom`) VALUES ('160','cus_blz','paz','2','','0','0','');";
		$db->query($query);
		$query="ALTER TABLE `SelectData` CHANGE `Name_de` `Name_de` VARCHAR( 255 ) NOT NULL , CHANGE `Name_it` `Name_it` VARCHAR( 255 ) NOT NULL , CHANGE `Name_en` `Name_en` VARCHAR( 255 ) NOT NULL;";
		$db->query($query);

		if (!colExists('AddrMeta','Gort')) {
			$query="ALTER TABLE `AddrMeta` ADD `Gort` VARCHAR(255) NOT NULL;";
			$db->query($query);
		}
		if (!colExists('AddrMeta','Famstand')) {
			$query="ALTER TABLE `AddrMeta` ADD `Famstand` VARCHAR(255) NOT NULL;";
			$db->query($query);
			$query="REPLACE INTO AddrFields (`FieldTyp`, `FieldID`, `Title_de`, `Title_it`, `Title_en`, `Title_fr`, `Title_es`, `Card`, `Search`, `Typ`, `Value`, `Action`, `Multi`, `Vcard`, `Sequence`, `Users`, `Groups`, `Aktiv`, `F_Unique`, `F_Mode`)
					VALUES ('f', '`Famstand', 'Familienstand', 'Stato civile', 'Marital status', '', '', 'ex', '0', 'text', '', '', '0', '', '357', '', '', '1', '0', '0');";
			$db->query($query);
			$query="REPLACE INTO `AddrSelect` (`SelID` ,`SelType` ,`Name_de` ,`Name_it` ,`Name_en` ,`Name_fr` ,`Name_es` ,`Sequence`) VALUES ('l', 'Famstand', 'Ledig', 'celibe/nubile', 'unmarried', 'unmarried', 'unmarried', '1');";
			$db->query($query);
			$query="REPLACE INTO `AddrSelect` (`SelID` ,`SelType` ,`Name_de` ,`Name_it` ,`Name_en` ,`Name_fr` ,`Name_es` ,`Sequence`) VALUES ('v', 'Famstand', 'Verheirated', 'coniugato/a', 'married', 'married', 'married', '2');";
			$db->query($query);
			$query="REPLACE INTO `AddrSelect` (`SelID` ,`SelType` ,`Name_de` ,`Name_it` ,`Name_en` ,`Name_fr` ,`Name_es` ,`Sequence`) VALUES ('t', 'Famstand', 'In Trennung', 'separato/a', 'separated', 'separated', 'separated', '3');";
			$db->query($query);
			$query="REPLACE INTO `AddrSelect` (`SelID` ,`SelType` ,`Name_de` ,`Name_it` ,`Name_en` ,`Name_fr` ,`Name_es` ,`Sequence`) VALUES ('g', 'Famstand', 'Geschieden', 'divorziato/a', 'divorced', 'divorced', 'divorced', '4');";
			$db->query($query);
			$query="REPLACE INTO `AddrSelect` (`SelID` ,`SelType` ,`Name_de` ,`Name_it` ,`Name_en` ,`Name_fr` ,`Name_es` ,`Sequence`) VALUES ('w', 'Famstand', 'Verwittwet', 'vedovo/a', 'widowed', 'widowed', 'widowed', '5');";
			$db->query($query);
		}

		$query="CREATE TABLE IF NOT EXISTS customBlzPaz (
			ID int(11) NOT NULL,
			PazStruempfe tinyint(4) NOT NULL,
			PazBandagieren tinyint(4) NOT NULL,
			PazDesc text NOT NULL,
			TimeCreate int(11) NOT NULL,
			TimeModify int(11) NOT NULL,
			TimePrint int(11) NOT NULL,
			UserCreate int(11) NOT NULL,
			UserModify int(11) NOT NULL,
			UserPrint int(11) NOT NULL,
			Deleted tinyint(4) NOT NULL,
			PRIMARY KEY  (ID)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS customBlzPazKon (
			ID int(11) NOT NULL,
			FKPatientID int(11) NOT NULL,
			FKAddressID int(11) NOT NULL,
			KontaktTyp int(11) NOT NULL,
			KontaktCat int(11) NOT NULL,
			KontaktPar varchar(255) NOT NULL,
			KontaktDesc text NOT NULL,
			TimeCreate int(11) NOT NULL,
			TimeModify int(11) NOT NULL,
			TimePrint int(11) NOT NULL,
			UserCreate int(11) NOT NULL,
			UserModify int(11) NOT NULL,
			UserPrint int(11) NOT NULL,
			Deleted tinyint(4) NOT NULL,
			PRIMARY KEY  (ID)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS customBlzPazKra (
			ID int(11) NOT NULL,
			FKPatientID int(11) NOT NULL,
			KraHospital int(11) NOT NULL,
			KraHospitalNum varchar(255) NOT NULL,
			KraBeginn date NOT NULL,
			KraEnd date NOT NULL,
			KraWhy varchar(255) NOT NULL,
			KraPar tinyint(4) NOT NULL,
			KraDesc text NOT NULL,
			TimeCreate int(11) NOT NULL,
			TimeModify int(11) NOT NULL,
			TimePrint int(11) NOT NULL,
			UserCreate int(11) NOT NULL,
			UserModify int(11) NOT NULL,
			UserPrint int(11) NOT NULL,
			Deleted tinyint(4) NOT NULL,
			PRIMARY KEY  (ID)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS customBlzPazMed (
			ID int(11) NOT NULL,
			FKPatientID int(11) NOT NULL,
			MedBeginn date NOT NULL,
			MedEnd date NOT NULL,
			MedDesc text NOT NULL,
			TimeCreate int(11) NOT NULL,
			TimeModify int(11) NOT NULL,
			TimePrint int(11) NOT NULL,
			UserCreate int(11) NOT NULL,
			UserModify int(11) NOT NULL,
			UserPrint int(11) NOT NULL,
			Deleted tinyint(4) NOT NULL,
			PRIMARY KEY  (ID)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS customBlzPazOrd (
			ID int(11) NOT NULL,
			FKPatientID int(11) NOT NULL,
			OrdBeginn date NOT NULL,
			OrdEnd date NOT NULL,
			OrdDesc text NOT NULL,
			OrdMed varchar(255) NOT NULL,
			FKVerabreichung int(11) NOT NULL,
			OrdRecTyp char(1) NOT NULL,
			OrdRecNum int(11) NOT NULL,
			OrdRecCfg varchar(255) NOT NULL,
			OrdInjection tinyint(4) NOT NULL,
			OrdInsulin tinyint(4) NOT NULL,
			TimeCreate int(11) NOT NULL,
			TimeModify int(11) NOT NULL,
			TimePrint int(11) NOT NULL,
			UserCreate int(11) NOT NULL,
			UserModify int(11) NOT NULL,
			UserPrint int(11) NOT NULL,
			Deleted tinyint(4) NOT NULL,
			PRIMARY KEY  (ID)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS customBlzPazOrdTimes (
			FKPazOrdID int(11) NOT NULL,
			OrdMedNum int(11) NOT NULL,
			OrdMedTime int(11) NOT NULL,
			OrdMedDesc varchar(255) NOT NULL,
			OrdMedEinheit varchar(255) NOT NULL,
			KEY FKPazOrdID (FKPazOrdID)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS customBlzPazPfa (
			ID int(11) NOT NULL,
			FKPatientID int(11) NOT NULL,
			PfaTyp int(11) NOT NULL,
			PfaDesc text NOT NULL,
			TimeCreate int(11) NOT NULL,
			TimeModify int(11) NOT NULL,
			TimePrint int(11) NOT NULL,
			UserCreate int(11) NOT NULL,
			UserModify int(11) NOT NULL,
			UserPrint int(11) NOT NULL,
			Deleted tinyint(4) NOT NULL,
			PRIMARY KEY  (ID)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS customBlzPazVerabreichung (
			ID int(11) NOT NULL,
			Title varchar(255) NOT NULL,
			TitleShort varchar(255) NOT NULL,
			Einheiten varchar(255) NOT NULL
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS customBlzPazVis (
			ID int(11) NOT NULL,
			FKPatientID int(11) NOT NULL,
			VisDate date NOT NULL,
			VisTyp varchar(255) NOT NULL,
			VisDesc text NOT NULL,
			TimeCreate int(11) NOT NULL,
			TimeModify int(11) NOT NULL,
			TimePrint int(11) NOT NULL,
			UserCreate int(11) NOT NULL,
			UserModify int(11) NOT NULL,
			UserPrint int(11) NOT NULL,
			Deleted tinyint(4) NOT NULL,
			PRIMARY KEY  (ID)
		);";
		$db->query($query);

		$query="UPDATE `Version` SET `Version` = '1.5',`UpdateDate`='2009-11-11' WHERE Modul='cus_blz';";
		$db->query($query);
	}
	if ($VERSION < 1.6) {
		$query="CREATE TABLE IF NOT EXISTS `customBlzPazDia` (
			`ID` int(11) NOT NULL,
			`FKPatientID` int(11) NOT NULL,
			`DiaDate` date NOT NULL,
			`DiaDesc` text NOT NULL,
			`TimeCreate` int(11) NOT NULL,
			`TimeModify` int(11) NOT NULL,
			`TimePrint` int(11) NOT NULL,
			`UserCreate` int(11) NOT NULL,
			`UserModify` int(11) NOT NULL,
			`UserPrint` int(11) NOT NULL,
			`Deleted` tinyint(4) NOT NULL,
			PRIMARY KEY  (`ID`)
		);";
		$db->query($query);
		$query="UPDATE `Version` SET `Version` = '1.6',`UpdateDate`='2009-12-16' WHERE Modul='cus_blz';";
		$db->query($query);
	}
	if ($VERSION < 1.7) {
		$query="ALTER TABLE `customBlzPazOrdTimes` CHANGE `OrdMedNum` `OrdMedNum` FLOAT NOT NULL";
		$db->query($query);
		$query="UPDATE `Version` SET `Version` = '1.7',`UpdateDate`='2009-12-21' WHERE Modul='cus_blz';";
		$db->query($query);
	}
	if ($VERSION < 1.8) {
		if (!colExists('customBlzPazDia','TimePrint')) {
			$query="ALTER TABLE customBlzPazDia  DROP `TimePrint`,  DROP `UserPrint`;";
			$db->query($query);
		}
		if (!colExists('customBlzPazPfa','TimePrint')) {
			$query="ALTER TABLE customBlzPazPfa  DROP `TimePrint`,  DROP `UserPrint`;";
			$db->query($query);
		}
		if (!colExists('customBlzPazKra','TimePrint')) {
			$query="ALTER TABLE customBlzPazKra  DROP `TimePrint`,  DROP `UserPrint`;";
			$db->query($query);
		}
		if (!colExists('customBlzPazVis','TimePrint')) {
			$query="ALTER TABLE customBlzPazVis  DROP `TimePrint`,  DROP `UserPrint`;";
			$db->query($query);
		}
		if (!colExists('customBlzPazMed','TimePrint')) {
			$query="ALTER TABLE customBlzPazMed  DROP `TimePrint`,  DROP `UserPrint`;";
			$db->query($query);
		}
		if (!colExists('customBlzPazOrd','TimePrint')) {
			$query="ALTER TABLE customBlzPazOrd  DROP `TimePrint`,  DROP `UserPrint`;";
			$db->query($query);
		}
		if (!colExists('customBlzPazKon','TimePrint')) {
			$query="ALTER TABLE customBlzPazKon  DROP `TimePrint`,  DROP `UserPrint`;";
			$db->query($query);
		}
		$query="CREATE TABLE IF NOT EXISTS `customBlzPazPrint` (
			`ViewTyp` varchar(10) NOT NULL,
			`FKObjID` int(11) NOT NULL,
			`ViewMd5` varchar(255) NOT NULL,
			`PrintTime` int(11) NOT NULL,
			`PrintUser` int(11) NOT NULL,
			`LastTime` int(11) NOT NULL,
			`LastUser` int(11) NOT NULL,
			PRIMARY KEY  (`ViewTyp`,`FKObjID`)
		) ;";
		$db->query($query);


		$query="UPDATE `Version` SET `Version` = '1.8',`UpdateDate`='2010-01-27' WHERE Modul='cus_blz';";
		$db->query($query);
	}
	if ($VERSION < 1.9) {
		$query="CREATE TABLE IF NOT EXISTS `customBlzPazSch` (
			`ID` int(11) NOT NULL,
			`FKPatientID` int(11) NOT NULL,
			`SchMed` varchar(255) NOT NULL,
			`SchBzB` int(11) NOT NULL,
			`SchBzE` int(11) NOT NULL,
			`SchDesc` varchar(255) NOT NULL,
			`SchTime` varchar(255) NOT NULL,
			`SchTimeA` varchar(255) NOT NULL,
			`SchTimeB` varchar(255) NOT NULL,
			`SchTimeC` varchar(255) NOT NULL,
			`TimeCreate` int(11) NOT NULL,
			`TimeModify` int(11) NOT NULL,
			`UserCreate` int(11) NOT NULL,
			`UserModify` int(11) NOT NULL,
			`Deleted` tinyint(4) NOT NULL,
			PRIMARY KEY  (`ID`)
		) ;";
		$db->query($query);

		$query="UPDATE `Version` SET `Version` = '1.9',`UpdateDate`='2010-02-03' WHERE Modul='cus_blz';";
		$db->query($query);
	}
	if ($VERSION < 2) {
		$query="CREATE TABLE IF NOT EXISTS `customBlzPazAedl` (
			`ID` int(11) NOT NULL,
			`Title` varchar(255) NOT NULL,
			`Description` text NOT NULL,
			`oneLang` tinyint(4) NOT NULL,
			`TimeCreate` int(11) NOT NULL,
			`UserCreate` int(11) NOT NULL,
			`TimeModify` int(11) NOT NULL,
			`UserModify` int(11) NOT NULL,
			`deleted` int(11) NOT NULL,
			PRIMARY KEY  (`ID`)
			) ;";
		$db->query($query);

		$query="REPLACE INTO customBlzPazAedl SELECT SelID,CONCAT('[[Title_',SelID,']]'),CONCAT('[[Descirption_',SelID,']]'),1,0,0,0,0,0 FROM SelectData WHERE SelType='custom_blz_paz_pfa';";
		$db->query($query);
		$query="REPLACE INTO db_sequence SELECT 'customBlzPazAedl',MAX(ID)+1 FROM customBlzPazAedl;";
		$db->query($query);
		$query="REPLACE INTO UserTrans SELECT 'customBlzPazAedl',CONCAT('[[Title_',SelID,']]'),'de',Name_de FROM SelectData WHERE SelType='custom_blz_paz_pfa' AND Name_de!='';";
		$db->query($query);
		$query="REPLACE INTO UserTrans SELECT 'customBlzPazAedl',CONCAT('[[Title_',SelID,']]'),'it',Name_it FROM SelectData WHERE SelType='custom_blz_paz_pfa' AND Name_de!='';";
		$db->query($query);
		$query="REPLACE INTO UserTrans SELECT 'customBlzPazAedl',CONCAT('[[Title_',SelID,']]'),'en',Name_en FROM SelectData WHERE SelType='custom_blz_paz_pfa' AND Name_de!='';";
		$db->query($query);


		$query="CREATE TABLE IF NOT EXISTS `customBlzPazTag` (
			`ID` int(11) NOT NULL,
			`FKPatientID` int(11) NOT NULL,
			`TagDate` datetime NOT NULL,
			`TagUser` int(11) NOT NULL,
			`TagTyp` int(11) NOT NULL,
			`TagDesc` text NOT NULL,
			`TimeCreate` int(11) NOT NULL,
			`TimeModify` int(11) NOT NULL,
			`UserCreate` int(11) NOT NULL,
			`UserModify` int(11) NOT NULL,
			`Deleted` tinyint(4) NOT NULL,
			PRIMARY KEY  (`ID`)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `customBlzPazVit` (
			`ID` int(11) NOT NULL,
			`FKPatientID` int(11) NOT NULL,
			`VitDate` datetime NOT NULL,
			`VitUser` int(11) NOT NULL,
			`VitBz` varchar(255) NOT NULL,
			`VitIn` varchar(255) NOT NULL,
			`VitRr` varchar(255) NOT NULL,
			`VitPu` varchar(255) NOT NULL,
			`VitTe` varchar(255) NOT NULL,
			`VitSp` varchar(255) NOT NULL,
			`VitKg` varchar(255) NOT NULL,
			`TimeCreate` int(11) NOT NULL,
			`TimeModify` int(11) NOT NULL,
			`UserCreate` int(11) NOT NULL,
			`UserModify` int(11) NOT NULL,
			`Deleted` tinyint(4) NOT NULL,
			PRIMARY KEY  (`ID`)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `customBlzPazStu` (
			`ID` int(11) NOT NULL,
			`FKPatientID` int(11) NOT NULL,
			`StuDate` date NOT NULL,
			`StuTime` int(11) NOT NULL,
			`StuUser` int(11) NOT NULL,
			`StuVorher` tinyint(4) NOT NULL,
			`StuPharma` tinyint(4) NOT NULL,
			`StuWas` text NOT NULL,
			`StuWo` text NOT NULL,
			`StuWie` text NOT NULL,
			`StuHergang` text NOT NULL,
			`StuVital` text NOT NULL,
			`StuFolgen` text NOT NULL,
			`StuToDo` text NOT NULL,
			`StuInfoAn` text NOT NULL,
			`StuInfoWann` text NOT NULL,
			`TimeCreate` int(11) NOT NULL,
			`TimeModify` int(11) NOT NULL,
			`UserCreate` int(11) NOT NULL,
			`UserModify` int(11) NOT NULL,
			`Deleted` tinyint(4) NOT NULL,
			PRIMARY KEY  (`ID`)
		);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `customBlzPazBet` (
			`ID` int(11) NOT NULL,
			`FKPatientID` int(11) NOT NULL,
			`BetAedl` int(11) NOT NULL,
			`BetProblem` text NOT NULL,
			`BetZiel` text NOT NULL,
			`BetRessource` text NOT NULL,
			`BetMassnahme` text NOT NULL,
			`TimeCreate` int(11) NOT NULL,
			`TimeModify` int(11) NOT NULL,
			`UserCreate` int(11) NOT NULL,
			`UserModify` int(11) NOT NULL,
			`Deleted` tinyint(4) NOT NULL,
			PRIMARY KEY  (`ID`)
		);";
		$db->query($query);

		if (!colExists('customBlzPaz','PazBetDiagnose')) {
			$query="ALTER TABLE `customBlzPaz` ADD `PazBetDiagnose` TEXT NOT NULL AFTER `PazDesc`;";
			$db->query($query);
		}

		$query="CREATE TABLE IF NOT EXISTS `customBlzPazWun` (
			`ID` int(11) NOT NULL,
			`FKPatientID` int(11) NOT NULL,
			`WunOrt` int(11) NOT NULL,
			`WunArt` int(11) NOT NULL,
			`WunArtDesc` varchar(255) NOT NULL,
			`WunStadium` int(11) NOT NULL,
			`WunDekubitus` int(11) NOT NULL,
			`WunNekrose` int(11) NOT NULL,
			`WunGeruch` int(11) NOT NULL,
			`WunVerlauf` int(11) NOT NULL,
			`WunVerlaufDesc` varchar(255) NOT NULL,
			`WunSekretion` int(11) NOT NULL,
			`WunRaender` int(11) NOT NULL,
			`WunBreite` decimal(10,2) NOT NULL,
			`WunTiefe` decimal(10,2) NOT NULL,
			`WunLaenge` decimal(10,2) NOT NULL,
			`WunPosX` double NOT NULL,
			`WunPosY` double NOT NULL,
			`WunPosImg` varchar(255) NOT NULL,
			`WunPosNum` int(11) NOT NULL,
			`WunNotiz` varchar(255) NOT NULL,
			`WunAktiv` INT NOT NULL,
			`TimeCreate` int(11) NOT NULL,
			`TimeModify` int(11) NOT NULL,
			`UserCreate` int(11) NOT NULL,
			`UserModify` int(11) NOT NULL,
			`Deleted` tinyint(4) NOT NULL,
			PRIMARY KEY  (`ID`)
		)";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `customBlzPazWunDoc` (
			`ID` int(11) NOT NULL,
			`TimeCreate` int(11) NOT NULL,
			`TimeModify` int(11) NOT NULL,
			`UserCreate` int(11) NOT NULL,
			`UserModify` int(11) NOT NULL,
			`FKWunID` int(11) NOT NULL,
			`DocTyp` varchar(32) NOT NULL,
			`DocDate` date NOT NULL,
			`DocDesc1` text NOT NULL,
			`DocDesc2` text NOT NULL,
			`Deleted` tinyint(4) NOT NULL,
			PRIMARY KEY  (`ID`)
		)";
		$db->query($query);

		if (!colExists('customBlzPaz','PazZustand')) {
			$query="ALTER TABLE `customBlzPaz`
				ADD  `PazZustand` int(11) NOT NULL,
				ADD  `PazZustandDesc` varchar(255) NOT NULL,
				ADD  `PazGrunderkrankung` int(11) NOT NULL,
				ADD  `PazGrunderkrankungDesc` varchar(255) NOT NULL,
				ADD  `PazArzneimittel` int(11) NOT NULL,
				ADD  `PazArzneimittelDesc` varchar(255) NOT NULL,
				ADD  `PazBrandenWert` int(11) NOT NULL,
				ADD  `PazBrandenDatum` date NOT NULL
			AFTER `PazBetDiagnose`;";
			$db->query($query);
		}

		$query="UPDATE `Version` SET `Version` = '2.0',`UpdateDate`='2011-03-30' WHERE Modul='cus_blz';";
		$db->query($query);

	}

}
?>