<?php
function updateAddrLdap ($VERSION) {
	global $db,$frm;
	$query=array();
	$db->query("SET NAMES 'utf8'");
	if ($VERSION < 1) {
		$query="CREATE TABLE IF NOT EXISTS `AddrFieldsLdap` (
			`FieldTyp` varchar(8) NOT NULL default '0',
			`FieldID` varchar(32) NOT NULL default '',
			`Title_de` varchar(64) NOT NULL default '',
			`Title_it` varchar(64) NOT NULL default '',
			`Title_en` varchar(64) NOT NULL default '',
			`Title_fr` varchar(64) NOT NULL default '',
			`Title_es` varchar(64) NOT NULL default '',
			`Card` varchar(4) NOT NULL default '0',
			`Search` tinyint(4) NOT NULL default '0',
			`Typ` varchar(8) NOT NULL default '',
			`Value` varchar(255) NOT NULL default '',
			`Action` varchar(16) NOT NULL default '',
			`Multi` tinyint(4) NOT NULL default '0',
			`Vcard` varchar(255) NOT NULL default '',
			`Ldap` varchar(255) NOT NULL,
			`LdapMulti` tinyint(4) NOT NULL,
			`LdapClass` varchar(255) NOT NULL,
			`AllowedChars` varchar(16) NOT NULL,
			`Sequence` int(11) NOT NULL default '0',
			`Users` varchar(255) NOT NULL default '',
			`Groups` varchar(255) NOT NULL default '',
			`Aktiv` tinyint(4) NOT NULL default '1',
			PRIMARY KEY  (`FieldID`)
			) ENGINE=MyISAM";
		$db->query($query);

		$query="REPLACE INTO `AddrFieldsLdap` (`FieldTyp`, `FieldID`, `Title_de`, `Title_it`, `Title_en`, `Title_fr`, `Title_es`, `Card`, `Search`, `Typ`, `Value`, `Action`, `Multi`, `Vcard`, `Ldap`, `LdapMulti`, `LdapClass`, `AllowedChars`, `Sequence`, `Users`, `Groups`, `Aktiv`) VALUES
			('k', 'Iptel', 'Skype', 'Skype', 'Skype', '', '', 'k', 1, 'kont', '', 'skype', 0, '', 'mozillaCustom1', 1, 'mozillaOrgPerson', 'n', 220, '', '', 1),
			('f', 'Firma', 'Firma', 'Ditta', 'Company', '', '', 'n', 1, 'text', '', '', 0, '0:ORG', 'o', 0, 'inetOrgPerson', 'n', 20, '', '', 1),
			('f', 'Nachname', 'Nachname', 'Cognome', 'Lastname', '', '', 'n', 1, 'text', '', '', 0, '0:N:0', 'sn', 0, 'inetOrgPerson', 'n', 30, '', '', 1),
			('f', 'Vorname', 'Vorname', 'Nome', 'Firstname', '', '', 'n', 1, 'text', '', '', 0, '0:N:1', 'givenName', 0, 'inetOrgPerson', 'n', 40, '', '', 1),
			('f', 'Titel', 'Titel', 'Titolo', 'Titel', '', '', 'n', 1, 'text', '', '', 0, '0:N:3|0:TITLE', 'title', 0, 'inetOrgPerson', 'n', 50, '', '', 1),
			('f', 'AStrasse', 'Straße', 'Via/Piazza/Nr.', 'Street/Nr.', '', '', 'ga', 1, 'text', '', '', 1, '1:ADR:2', 'postalAddress', 0, 'inetOrgPerson', 'n', 60, '', '', 1),
			('f', 'AOrt', 'Ort', 'Citt', 'Town', '', '', 'ga', 1, 'text', '', '', 1, '1:ADR:5', 'l', 0, 'inetOrgPerson', 'n', 70, '', '', 1),
			('f', 'APlz', 'PLZ', 'CAP', 'ZIP', '', '', 'ga', 1, 'text', '', '', 1, '1:ADR:3', 'postalCode', 0, 'inetOrgPerson', 'n', 80, '', '', 1),
			('f', 'AProv', 'Provinz', 'Provincia', 'Province', '', '', 'ga', 1, 'text', '', '', 1, '1:ADR:4', 'st', 0, 'inetOrgPerson', 'n', 90, '', '', 1),
			('f', 'ALand', 'Land', 'Stato', 'State', '', '', 'ga', 1, 'text', '', '', 1, '1:ADR:6', 'c', 0, 'inetOrgPerson', 'n', 100, '', '', 1),
			('f', 'PStrasse', 'Straße', 'Via/Piazza/Nr.', 'Street/Nr.', '', '', 'pa', 1, 'text', '', '', 2, '2:ADR:2', 'homePostalAddress', 0, 'inetOrgPerson', 'n', 110, '', '', 1),
			('f', 'POrt', 'Ort', 'Citt', 'Town', '', '', 'pa', 1, 'text', '', '', 2, '2:ADR:5', 'mozillaHomeLocalityName', 0, 'mozillaOrgPerson', 'n', 120, '', '', 1),
			('f', 'PPlz', 'PLZ', 'CAP', 'ZIP', '', '', 'pa', 1, 'text', '', '', 2, '2:ADR:3', 'mozillaHomePostalCode', 0, 'mozillaOrgPerson', 'n', 130, '', '', 1),
			('f', 'PProv', 'Provinz', 'Provincia', 'Province', '', '', 'pa', 1, 'text', '', '', 2, '2:ADR:4', 'mozillaHomeState', 0, 'mozillaOrgPerson', 'n', 140, '', '', 1),
			('f', 'PLand', 'Land', 'Stato', 'State', '', '', 'pa', 1, 'text', '', '', 2, '2:ADR:6', 'mozillaHomeCountryName', 0, 'mozillaOrgPerson', 'n', 150, '', '', 1),
			('k', 'ATel', 'Tel.(Gesch.)', 'Tel.(Ufficio)', 'Tel.(Office)', '', '', 'k', 1, 'kont', '', 'skype', 0, '0:TEL:WORK', 'telephoneNumber', 1, 'inetOrgPerson', 'p', 170, '', '', 1),
			('k', 'PTel', 'Tel.(Priv.)', 'Tel.(Priv.)', 'Tel.(Priv.)', '', '', 'k', 1, 'kont', '', 'skype', 0, '0:TEL:HOME', 'homePhone', 1, 'inetOrgPerson', 'p', 180, '', '', 1),
			('k', 'Fax', 'Fax', 'Fax', 'Fax', '', '', 'k', 1, 'kont', '', 'fax', 0, '0:TEL:FAX', 'facsimileTelephoneNumber', 1, 'inetOrgPerson', 'p', 190, '', '', 1),
			('k', 'Mobil', 'Mobil', 'Cellulare', 'Mobil', '', '', 'k', 1, 'kont', '', 'sms', 0, '0:TEL:CELL', 'mobile', 1, 'inetOrgPerson', 'p', 200, '', '', 1),
			('k', 'Intern', 'Intern', 'Interno', 'Intern', '', '', 'k', 1, 'kont', '', '', 0, '0:TEL:PAGER', 'pager', 1, 'inetOrgPerson', 'p', 210, '', '', 1),
			('k', 'Email', 'E-Mail', 'E-mail', 'E-mail', '', '', 'k', 1, 'kont', '', 'mail', 0, '0:EMAIL', 'mail', 1, 'inetOrgPerson', 'ia5', 160, '', '', 1),
			('k', 'Url', 'Web', 'Web', 'Web', '', '', 'k', 1, 'kont', 'http://', 'web', 0, '0:URL', 'mozillaWorkUrl', 1, 'mozillaOrgPerson', 'p', 230, '', '', 1),
			('f', 'Iva', 'Mwst. Nummer', 'Partita IVA', 'Tax number', '', '', 'gf', 1, 'text', '', '', 0, '', 'mozillaCustom2', 0, 'mozillaOrgPerson', 'n', 240, '', '', 1),
			('f', 'Mwst', 'Steuernummer', 'Codice fiscale', 'Tax number', '', '', 'pf', 1, 'text', '', '', 0, '', 'mozillaCustom3', 0, 'mozillaOrgPerson', 'n', 250, '', '', 1),
			('f', 'Nickname', 'Kurzname', 'Nickname', 'Nickname', '', '', 'ex', 1, 'text', '', '', 0, '0:NICKNAME', 'mozillaNickname', 0, 'mozillaOrgPerson', 'n', 260, '', '', 1),
			('f', 'Lang', 'Sprache', 'Lingua', 'Language', '', '', 'ex', 0, 'select', '', '', 0, '', 'preferredLanguage', 0, 'inetOrgPerson', 'p', 270, '', '', 1),
			('f', 'Notiz', 'Notiz', 'Nota', 'Note', '', '', 'ex', 1, 'area', '', '', 0, '0:NOTE', 'description', 0, 'inetOrgPerson', '', 280, '', '', 1),
			('f', 'StammID', 'Stammadresse', 'Indirizzo base', 'Base adddress', '', '', 'n', 0, 'stamm', '', '', 0, '', 'seeAlso', 0, 'inetOrgPerson', '', 10, '', '', 0),
			('f', 'Name', 'Angezeigter Name', 'Nome visualizzato', 'Display name', 'Display name', 'Display name', 'n', 1, 'dname', '', '', 0, '0:FN', 'displayName', 0, 'inetOrgPerson', 'n', 15, '', '', 1);";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `AddrLogLdap` (
			`LogID` int(11) NOT NULL auto_increment,
			`FKAddressID` varchar(255) NOT NULL default '0',
			`FKUserID` int(11) NOT NULL,
			`Text` text NOT NULL,
			`Type` varchar(8) NOT NULL default '',
			`Date` int(11) NOT NULL default '0',
			PRIMARY KEY  (`LogID`)
			) ENGINE=MyISAM;";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `AddrSearchLdap` (
			`SearchID` int(11) NOT NULL default '0',
			`FKUserID` int(11) NOT NULL default '0',
			`isPrivat` tinyint(4) NOT NULL,
			`Groups` varchar(255) NOT NULL default '',
			`Users` varchar(255) NOT NULL,
			`Title` varchar(255) NOT NULL default '',
			`Sdata` blob NOT NULL,
			`Mlist` tinyint(4) NOT NULL default '0',
			`Flist` tinyint(4) NOT NULL default '0',
			PRIMARY KEY  (`SearchID`)
			) ENGINE=MyISAM;";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `AddrSyncLdap` (
			`FKUserID` int(11) NOT NULL,
			`FKAddressID` varchar(255) NOT NULL,
			`TimeModify` int(11) NOT NULL,
			`LastAnchor` int(11) NOT NULL,
			PRIMARY KEY  (`FKUserID`,`FKAddressID`)
			) ENGINE=MyISAM;";
		$db->query($query);

		$query="CREATE TABLE IF NOT EXISTS `AddrServerMetabase` (
			`ID` int(11) NOT NULL,
			`Title` varchar(255) NOT NULL,
			`Server` varchar(255) NOT NULL,
			`Port` varchar(255) NOT NULL,
			`BaseDN` varchar(255) NOT NULL,
			`LdapVersion` tinyint(4) NOT NULL,
			`Security` tinyint(4) NOT NULL,
			`BindDN` varchar(255) NOT NULL,
			`BindPwd` varchar(255) NOT NULL,
			`PermsUser` varchar(255) NOT NULL,
			`PermsGroup` varchar(255) NOT NULL,
			`isPrivat` tinyint(4) NOT NULL,
			`Sequence` int(11) NOT NULL
			) ENGINE=MyISAM;";
		$db->query($query);

		$query="REPLACE INTO ObjAction (`ActionID`,`Action`,`Name_de`,`Name_it`,`Name_en`) VALUES ('149','new','Neues Adressbuch','Nuovo addressbook','New addressbook');";
		$db->query($query);
		$query="REPLACE INTO ObjAction (`ActionID`,`Action`,`Name_de`,`Name_it`,`Name_en`) VALUES ('150','i_list','Zu Verteiler hinzufügen','Inserire nella liste di distribuzione','Add to distribution list');";
		$db->query($query);
		$query="REPLACE INTO ObjAction (`ActionID`,`Action`,`Name_de`,`Name_it`,`Name_en`) VALUES ('151','d_list','Aus Verteilerliste entfernen','Cancellare dalla lista di distribuzione','Remove from distribution list');";
		$db->query($query);

		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('84','addr','ldap_addr','1','','3','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('5','addr','ldap_addr','2','','4','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('3','addr','ldap_addr','1','a_write','5','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('4','addr','ldap_addr','2','','10','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('1','addr','ldap_addr','1','app_mail|app_msg','19','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('70','addr','ldap_addr','1','app_msg,!user','20','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('71','addr','ldap_addr','1','app_mail','21','1');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('98','addr','ldap_addr','1','app_mail','25','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('74','addr','ldap_fol','2','','2','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('75','addr','ldap_fol','2','!root','4','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('76','addr','ldap_fol','2','!root,!content','10','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('1','addr','ldap_fol','0','','20','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('78','addr','ldap_fol','0','','25','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('79','addr','ldap_fol','0','','40','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('80','addr','ldap_fol_l','0','app_mail,list_perm','2','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('81','addr','ldap_fol_l','2','','3','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('78','addr','ldap_fol_src','0','','25','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('79','addr','ldap_fol_src','0','','40','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('151','addr','ldap_list_l','1','','3','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('150','addr','ldap_list_li','1','','3','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('5','addr','ldap_list_view','1','','3','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('1','addr','ldap_list_view','1','','10','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('4','addr','ldap_list_view','1','','20','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('149','admin','addr_ldap_server','0','','1','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('1','admin','addr_ldap_server','0','ID','10','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('4','admin','addr_ldap_server','0','ID','20','0');";
		$db->query($query);

		$query="REPLACE INTO `Version` (`Version`,`UpdateDate`,`Modul`) VALUES (1.0,'2007-02-28','addr_ldap');";
		$db->query($query);
	}
	if ($VERSION < 1.01) {
		$query="CREATE TABLE IF NOT EXISTS `AddrParentProjectLdap` (
			`FKProjID` int(11) NOT NULL default '0',
			`FKAddressID` varchar(255) NOT NULL default '0',
			PRIMARY KEY  (`FKProjID`,`FKAddressID`)
			) ENGINE=MyISAM;";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('137','addr','ldap_addr','0','app_proj,act_proj,proj','2','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('136','addr','ldap_addr','0','app_proj,act_proj,!proj','2','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('1','addr','ldap_fol_l','0','act_proj','10','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('136','addr','ldap_fol_l','0','act_proj','12','0');";
		$db->query($query);
		$query="REPLACE INTO ObjActionModul (`FKActionID`,`Modul`,`Mode`,`Perms`,`Extra`,`Sequenze`,`Hidden`) VALUES ('137','addr','ldap_fol_l','0','act_proj','13','0');";
		$db->query($query);

		$query="UPDATE `Version` SET `Version` = '1.01',`UpdateDate`='2007-03-20' WHERE Modul='addr_ldap';";
		$db->query($query);
	}
	if ($VERSION < 1.02) {
		$query="REPLACE INTO `UserForm` (`FormID`, `RefID`, `System`, `Name`, `Table`, `FKModul`, `UserCreate`, `TimeCreate`, `UserModify`, `TimeModify`) VALUES(20, 'addrldap', 'addrldap', '[[Adressfelder]]', '', 'addr', 0, 0, 0, 0);";
		$db->query($query);
		if (!colExists('AddrFieldsLdap','AllowedLen')) {
			$query="ALTER TABLE `AddrFieldsLdap` ADD `AllowedLen` INT NOT NULL AFTER `AllowedChars`;";
			$db->query($query);
		}
		if (!colExists('AddrFieldsLdap','Hidden')) {
			$query="ALTER TABLE `AddrFieldsLdap` ADD `Hidden` TINYINT NOT NULL AFTER `AllowedLen`;";
			$db->query($query);
		}
		$query="UPDATE `Version` SET `Version` = '1.02',`UpdateDate`='2009-02-18' WHERE Modul='addr_ldap';";
		$db->query($query);

	}
	if ($VERSION < 1.03) {
		$query="ALTER TABLE `AddrSearchLdap` CHANGE `Sdata` `Sdata` TEXT NOT NULL;";
		$db->query($query);
		$query="UPDATE `Version` SET `Version` = '1.03',`UpdateDate`='2012-03-13' WHERE Modul='addr_ldap';";
		$db->query($query);
	}
}
?>