<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
$t->assign('MOD_TITLE',$frm->getAppName('zef'));
if (!$app["zef"]) {
	$t->setRoot("tpl/$THEME/$session_lang");
	$t->define (array('application' => "no_app.inc.html"));
} else {
	$pre['zef']=$frm->getPrefs('zef');
	$zef=& $frm->getStaticModul('zef');
	$T->loadModul('zef');
	require_once('lib/class_form.inc.php');
	$wd=& $frm->getStaticModul('workday');
	$t->setRoot("tpl/$THEME/zef/$session_lang");
	$t->define (array('application' => "header.inc.html"));
	if ($zef->getPerms(8)) {
		if (!isset($ZEF_USER)) {
			$sess->register('ZEF_USER');
			$ZEF_USER=$auth->auth['uid'];
		}
		$zef_users=$frm->getFullName(array_unique(array_keys($frm->getApplicationUsers('zef'))));
		if ($setZefUser && isset($zef_users[$setZefUser])) {
			$ZEF_USER=$setZefUser;
		}
		$zef->setUser($ZEF_USER);
		if ($ZEF_USER!=$auth->auth['uid']) {
			$zef->setGroup($frm->getUserGroups($ZEF_USER));
		}
		foreach ($zef_users as $key=>$val) {
			$t->assign('K_SET_USR',$key);
			$t->assign('V_SET_USR',Framework::entities($val));
			if ($zef->getUser()==$key) {
				$t->assign('S_SET_USR','selected');
			} else {
				$t->assign('S_SET_USR','');
			}
			$t->parse('ROW','.zef_setuser_row');
		}
		if ($zef->getUser()!=$auth->auth['uid']) {
			$t->assign('EXT_ZEF_USER',Framework::entities($zef_users[$zef->getUser()]));
			$t->parse('ROW','ext_user');
		}
		$t->assign('I_ACTION',"index.php?site=$site&action=$action");
		$t->parse('ROW','zef_setuser');

	}
	$zef_prj=$zef->listAllPrjNames();
	//debug($zef_prj_cont);



	$t->assign('ZE_ON','off');
	$t->assign('PJ_ON','off');
	$t->assign('AU_ON','off');
	$t->assign('PS_ON','off');
	$t->assign('EI_ON','off');
	$t->assign('CS_ON','off');
	$t->assign('AF_ON','off');

	if (!$action) $action='ze';

	if ($action=="ze") {
		$t->assign('ZE_ON','on');
		$CAL_REFERER[0]=$L->getTempLink();
		unset($CAL_REFERER[1]);
		require_once('lib/zef/class_ViewWeekGui.php');
		$weekGui=new ViewWeekGui();
		$guiContent=$weekGui->process();
		$t->assign('TPL_CARD',$guiContent->process());
	}
	if ($zef->getPerms(2)) {
		if ($action=="pj") {
			$t->assign('PJ_ON','on');
			require_once('lib/zef/class_zefProjectGui.php');
			$zefGui=new zefProjectGui();
			$t->assign('TPL_CARD',$zefGui->process());
		}
		$t->parse('ROW','head_pj');
	}
	if ($zef->getCfg('cfg/modul/expenses')) {
		if ($action=="cs") {
			$t->assign('CS_ON','on');
			require_once('lib/zef/class_ViewExpensesGui.php');
			$expGui=new ViewExpensesGui();
			$t->assign('TPL_CARD',$expGui->process());
		}
		$t->parse('ROW','head_cs');
	}
	if ($action=="au") {
		$t->assign('AU_ON','on');
		require_once('lib/zef/class_ViewAuswertungGui.php');
		$auGui=new ViewAuswertungGui();
		$t->assign('TPL_CARD',$auGui->process());
		/*
		if ($print_x) {
			$t->define (array('tpl_card' => "print_auswertung.inc.html"));
			require("zef/print_auswertung.php");
			$t->parse('TPL_CARD','tpl_card');
		} else {
			$t->assign('AU_ON','on');
			$t->define (array('tpl_card' => "view_auswertung.inc.html"));
			require("zef/view_auswertung.php");
			$t->parse('TPL_CARD','tpl_card');
		}*/
	}
	$t->parse('ROW','head_au');
	if ($zef->getCfg('cfg/showPrefenz')) {
		if ($action=="ps") {
			$t->assign('PS_ON','on');
			require_once('lib/zef/class_ViewPresenzGui.php');
			$psGui=new ViewPresenzGui();
			$t->assign('TPL_CARD',$psGui->process());
			/*if ($print_x) {
				$t->define (array('tpl_card' => "print_presenz.inc.html"));
				require("zef/print_presenz.php");
				$t->parse('TPL_CARD','tpl_card');
			} else {
				$t->define (array('tpl_card' => "view_presenz.inc.html"));
				require("zef/view_presenz.php");
				$t->parse('TPL_CARD','tpl_card');
			}*/
		}
		$t->parse('ROW','head_ps');
	}
	if ($action=="ei") {
		$t->assign('EI_ON','on');
		require("lib/zef/class_zefGui.php");
		$zefGui=new zefGui();
		$contGui=$zefGui->getInsertGui();
		$t->assign('TPL_CARD',$contGui->process());
	}
	if ($frm->isRuleUser(array('sysadmin','zef')) && $zef->getCfg('cfg/modul/company')) {
		if ($action=="af") {
			$t->assign('AF_ON','on');
			require_once('lib/zef/class_ViewAufteilungGui.php');
			$afGui=new ViewAufteilungGui();
			$t->assign('TPL_CARD',$afGui->process());
			/*
			if ($print_x) {
				$t->define (array('tpl_card' => "print_auswertung.inc.html"));
				require("zef/print_auswertung.php");
				$t->parse('TPL_CARD','tpl_card');
			} else {
				$t->assign('AU_ON','on');
				$t->define (array('tpl_card' => "view_auswertung.inc.html"));
				require("zef/view_auswertung.php");
				$t->parse('TPL_CARD','tpl_card');
			}*/
		}
		$t->parse('ROW','head_af');
	}

	if ($print_x) {
		$PrintID=$frm->insertPrint('zef','html',$t->getparsed('TPL_CARD'));
		page_close();
		header("Location:print.php?PrintID=$PrintID");
		exit;
	}

	if ($ActionError) {
		$t->unload('tpl_error');
		$t->define (array('tpl_error' => "error.inc.html"));
		foreach ($ActionError as $key=>$val) {
			if ($key=='conf' && is_array($val)) {
				foreach ($val as $errorZef) {
					if (!isset($zef_cat[$errorZef['FKzefCatID']])) {
						$tmp=$zef->readCat($errorZef['FKzefCatID'],strtoupper($session_lang));
						$zef_cat[$errorZef['FKzefCatID']]=$tmp["zefName$lang"];
					}
					if (!isset($zef_prj[$errorZef['FKzefPrjID']])) {
						$tmp=$zef->readPrj($errorZef['FKzefPrjID'],strtoupper($session_lang));
						$zef_prj[$errorZef['FKzefPrjID']]=$tmp["zefName$lang"];
					}
					$t->assign('ZEF_E_PRJ',Framework::entities($zef_prj[$errorZef['FKzefPrjID']]));
					$t->assign('ZEF_E_CAT',Framework::entities($zef_cat[$errorZef['FKzefCatID']]));
					$t->assign('ZEF_E_BEGIN',date('d.m.Y H:i',$db->SqlToDate($errorZef['zefBegin'])));
					$t->assign('ZEF_E_END',date('H:i',$db->SqlToDate($errorZef['zefEnd'])));
					$t->parse('ROW','.error_conf_row');
				}

			}
			if ($t->issetkey('error_'.$key)) {
				$t->parse('ROW','error_'.$key);
			}
		}

		$t->parse('TPL_ERROR','.tpl_error');
	}
	if ($E->isError()) {
		$t->assign('TPL_ERROR',$E->process());
	}
}


?>
