<?php
class GroupeContact {
	public $_deviceProperties;
	public $_syncSettings;
	public $_mapping = array();
	function __construct() {
   		$this->_mapping=array(
			array("body",'Notiz'),
			array("fileas",'Name'),
			array("companyname",'Firma'),
			array("firstname",'Vorname'),
			array("lastname",'Nachname'),
			array("businesscity",'AOrt'),
			array("businesscountry",'AProv'),
			array("businesspostalcode",'APlz'),
			array("businessstate",'ALand'),
			array("businessstreet",'AStrasse'),
			array("businessfaxnumber",array('Fax',0)),
			array("businessphonenumber",array('ATel',0)),
			array("business2phonenumber",array('ATel',1)),
			array("categories",'Categories'),
			array("email1address",array('Email',0)),
			array("email2address",array('Email',1)),
			array("email3address",array('Email',2)),
			array("homephonenumber",array('PTel',0)),
			array("home2phonenumber",array('PTel',1)),
			array("homecity",'POrt'),
			array("homecountry",'PProv'),
			array("homepostalcode",'PPlz'),
			array("homestate",'PLand'),
			array("homestreet",'PStrasse'),
			array("homefaxnumber",array('Fax',1)),
			array("jobtitle",'Beruf'),
			array("title",'Titel'),
			//array("middlename",''),
			array("mobilephonenumber",array('Mobil',0)),
			array("radiophonenumber",array('Mobil',1)),
			array("pagernumber",array('Intern',0)),
			array("carphonenumber",array('Andere',0)),
			array("webpage",array('Url',0)),
		);
		if( Request::GetProtocolVersion() >= 2.5) {
            $this->_mapping+= array(
				array("imaddress",'Iptel'),
				array("governmentid",'Iva'),
				array("customerid",'Mwst'),
 				array("nickname",'Nickname'),
            );
		}
   }
   function setDeviceProperties($val) {
		$this->_deviceProperties=$val;
   }
   function setSyncSettings($val) {
		$this->_syncSettings=$val;
   }
   function groupe2message($groupe, $contentparameters) {
    	debugLog('groupe2contact');
   		$message=new SyncContact();
    	foreach ($this->_mapping as $val) {
    		$msgKey=$val[0];$grpKey=$val[1];
			switch($msgKey) {
				case 'body':
					BackendGroupe::setMessageBody($message,isset($groupe->$grpKey)?$groupe->$grpKey:'',$contentparameters);
				break;
				default:
					if (is_array($grpKey)) {
						if (isset($groupe->{$grpKey[0]})) {
							$tmpData=explode('||',$groupe->{$grpKey[0]});
							$message->$msgKey=isset($tmpData[$grpKey[1]])?$tmpData[$grpKey[1]]:'';
						}
					} else {
						if (isset($groupe->$grpKey)) {
							$message->$msgKey=$groupe->$grpKey;
						}
					}
				break;
			}
    	}
    	//debugLog(print_r($message,1));
   		return $message;
    }
    function message2groupe($message,$groupe) {
    	debugLog('contact2groupe');
    	//$message=(array)$message;
    	//debugLog(print_r($message,1));
     	//debugLog(print_r($groupe,1));
		BackendGroupe::convertMessageBody($message);

    	foreach ($this->_mapping as $val) {
    		$msgKey=$val[0];$grpKey=$val[1];
			switch($msgKey) {
				case 'email1address':
				case 'email2address':
				case 'email3address':
					$regs=array();
					if(isset($message->$msgKey) && preg_match("/.*<(.+)>/", $message->$msgKey, $regs ) ) {
						$message->$msgKey = $regs[1];
					}
				break;
			}
			if (is_array($grpKey)) {
				if (isset($groupe->{$grpKey[0]})) {
					$tmpData=explode('||',$groupe->{$grpKey[0]});
				} else {
					$tmpData=array();
				}
				if(isset($message->$msgKey)) {
					$tmpData[$grpKey[1]]=$message->$msgKey;
				}
				$groupe->{$grpKey[0]}=implode('||',$tmpData);
			} else {
				$groupe->$grpKey=isset($message->$msgKey)?$message->$msgKey:'';
			}
    	}
     	//debugLog(print_r($groupe,1));
    	return $groupe;
    }
}
?>