#!/bin/bash
# This script creates automatically a profile directory (if it not exist already) 
# under the home directory of the current user.
# Put the following entry in the profiles section of smb.conf and change the path
# to your needs.
#   ....
#   [profiles$]
#   ....
#   root preexec = /etc/samba/scripts/make_profiles.sc %U
#   ....

if [ -e /home/$1/.profiles ] ; then
   echo "DIR existiert"
   else
   mkdir /home/$1/.profiles
   chmod 700 /home/$1/.profiles
   chown $1:$1 /home/$1/.profiles
fi